#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 10144
#define LARGE_STATE_COUNT 548
#define SYMBOL_COUNT 317
#define ALIAS_COUNT 9
#define TOKEN_COUNT 92
#define EXTERNAL_TOKEN_COUNT 23
#define FIELD_COUNT 21
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 78

enum ts_symbol_identifiers {
  sym__varid = 1,
  anon_sym_SEMI = 2,
  sym_number = 3,
  sym_char = 4,
  sym_string = 5,
  sym_triple_quote_string = 6,
  sym__integer_literal = 7,
  sym__hex_literal = 8,
  anon_sym_u21d2 = 9,
  anon_sym_EQ_GT = 10,
  anon_sym_u21d0 = 11,
  anon_sym_LT_EQ = 12,
  anon_sym_u2192 = 13,
  anon_sym_DASH_GT = 14,
  anon_sym_u2190 = 15,
  anon_sym_LT_DASH = 16,
  anon_sym_u2237 = 17,
  anon_sym_COLON_COLON = 18,
  anon_sym__ = 19,
  sym_hole = 20,
  sym__immediate_dot = 21,
  sym__immediate_varid = 22,
  sym__operator = 23,
  anon_sym_DASH = 24,
  anon_sym_LPAREN = 25,
  anon_sym_RPAREN = 26,
  sym__conid = 27,
  anon_sym_PIPE = 28,
  anon_sym_LBRACE = 29,
  anon_sym_RBRACE = 30,
  anon_sym_COLON = 31,
  anon_sym_EQ = 32,
  anon_sym_AT = 33,
  anon_sym_forall = 34,
  anon_sym_u2200 = 35,
  anon_sym_DOT = 36,
  anon_sym_nominal = 37,
  anon_sym_representational = 38,
  anon_sym_phantom = 39,
  anon_sym_type = 40,
  anon_sym_role = 41,
  anon_sym_BQUOTE = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_if = 45,
  anon_sym_then = 46,
  anon_sym_else = 47,
  anon_sym_case = 48,
  anon_sym_of = 49,
  anon_sym_let = 50,
  anon_sym_in = 51,
  anon_sym_BSLASH = 52,
  anon_sym_do = 53,
  anon_sym_ado = 54,
  anon_sym_AT2 = 55,
  anon_sym_DOT_DOT = 56,
  anon_sym_class = 57,
  anon_sym_hiding = 58,
  anon_sym_import = 59,
  anon_sym_as = 60,
  anon_sym_module = 61,
  anon_sym_data = 62,
  anon_sym_newtype = 63,
  anon_sym_instance = 64,
  anon_sym_infixl = 65,
  anon_sym_infixr = 66,
  anon_sym_infix = 67,
  anon_sym_foreign = 68,
  anon_sym_derive = 69,
  anon_sym_pattern = 70,
  aux_sym__token1 = 71,
  sym__layout_semicolon = 72,
  sym__layout_start = 73,
  sym__layout_end = 74,
  sym__dot = 75,
  sym__arith_dotdot = 76,
  sym_where = 77,
  sym__splice_dollar = 78,
  sym__varsym = 79,
  sym__consym = 80,
  sym__tyconsym = 81,
  sym_comment = 82,
  sym_cpp = 83,
  sym_comma = 84,
  sym_quasiquote_start = 85,
  sym_quasiquote_bar = 86,
  sym_quasiquote_body = 87,
  sym__strict = 88,
  sym__lazy = 89,
  sym__unboxed_close = 90,
  sym_empty_file = 91,
  sym_purescript = 92,
  sym__topdecl = 93,
  sym_integer = 94,
  sym__numeric = 95,
  sym__literal = 96,
  sym__rcarrow = 97,
  sym__lcarrow = 98,
  sym__arrow = 99,
  sym__larrow = 100,
  sym__colon2 = 101,
  sym_wildcard = 102,
  sym_variable = 103,
  sym__immediate_variable = 104,
  sym_qualified_variable = 105,
  sym_operator = 106,
  sym__minus = 107,
  sym__operator_or_minus = 108,
  sym_qualified_operator = 109,
  sym__q_op = 110,
  sym_constructor = 111,
  sym_qualified_constructor = 112,
  sym_constructor_operator = 113,
  sym_qualified_constructor_operator = 114,
  sym__qcon = 115,
  sym_qualified_type = 116,
  sym__type_operator = 117,
  sym_qualified_type_operator = 118,
  sym__qualified_type_operator = 119,
  sym_type_literal = 120,
  sym_literal = 121,
  sym__name = 122,
  sym__field_name_ty = 123,
  sym_row_field = 124,
  sym__row_variable = 125,
  sym_row_type = 126,
  sym_record_type_literal = 127,
  sym__field_name = 128,
  sym_field_wildcard = 129,
  sym_record_field = 130,
  sym_record_literal = 131,
  sym__record_field_update = 132,
  sym__record_update_lhs = 133,
  sym_record_update = 134,
  sym_type_variable = 135,
  sym__visible_type_variable = 136,
  sym__tyvar_no_annotation = 137,
  sym__tyvar_annotated = 138,
  sym__forall_kw = 139,
  sym_forall = 140,
  sym_type_name = 141,
  sym_type_wildcard = 142,
  sym_type_operator = 143,
  sym__type_qoperator = 144,
  sym_captured_type_operator = 145,
  sym_type_parens = 146,
  sym__type_annotation = 147,
  sym__atype = 148,
  sym_type_apply = 149,
  sym__btype = 150,
  sym_type_infix = 151,
  sym__type = 152,
  sym__simpletype = 153,
  sym__role = 154,
  sym_type_role_declaration = 155,
  sym__type_type_signature = 156,
  sym_decl_type = 157,
  sym_exp_name = 158,
  sym_exp_ticked = 159,
  sym_exp_negation = 160,
  sym_exp_parens = 161,
  sym_exp_type_application = 162,
  sym_exp_array = 163,
  sym_exp_section_left = 164,
  sym_exp_section_right = 165,
  sym__record_access_field = 166,
  sym_record_accessor = 167,
  sym_exp_record_access = 168,
  sym_exp_if = 169,
  sym_pattern_guard = 170,
  sym_guard = 171,
  sym_guards = 172,
  sym_gdpat = 173,
  sym__alt_variants = 174,
  sym_alt = 175,
  sym_alts = 176,
  sym__exp_case_slots = 177,
  sym_exp_case = 178,
  sym__let_decls = 179,
  sym_exp_let_in = 180,
  sym_exp_lambda = 181,
  sym__statement_lexp = 182,
  sym___statement_exp_infix = 183,
  sym__statement_exp_infix = 184,
  sym__statement_exp = 185,
  sym_bind_pattern = 186,
  sym_let = 187,
  sym_statement = 188,
  sym__do_kw = 189,
  sym__do = 190,
  sym_exp_do = 191,
  sym__ado_kw = 192,
  sym__ado = 193,
  sym__ado_in = 194,
  sym_exp_ado = 195,
  sym__do_or_ado_block = 196,
  sym__aexp_projection = 197,
  sym__aexp = 198,
  sym__exp_apply = 199,
  sym__fexp = 200,
  sym__lexp = 201,
  sym_exp_infix = 202,
  sym__exp_infix = 203,
  sym__exp = 204,
  sym_pat_field = 205,
  sym_pat_fields = 206,
  sym_pat_name = 207,
  sym_pat_as = 208,
  sym__pat_constructor = 209,
  sym_pat_record = 210,
  sym_pat_wildcard = 211,
  sym_pat_parens = 212,
  sym_pat_array = 213,
  sym__apat = 214,
  sym_pat_negation = 215,
  sym_pat_apply = 216,
  sym__lpat = 217,
  sym_pat_infix = 218,
  sym__pat = 219,
  sym_pat_typed = 220,
  sym__typed_pat = 221,
  sym__import_name = 222,
  sym_import_con_names = 223,
  sym_import_item = 224,
  sym_class_import = 225,
  sym_type_operator_import = 226,
  sym_type_import = 227,
  sym_var_import = 228,
  sym_import_list = 229,
  sym_decl_import = 230,
  sym__modid = 231,
  aux_sym__qualifying_module = 232,
  sym_qualified_module = 233,
  sym_export_names = 234,
  sym_export = 235,
  sym_exports = 236,
  sym__decl_module = 237,
  sym__data_type_signature = 238,
  sym_decl_data = 239,
  sym_newtype_constructor = 240,
  sym__newtype_type_signature = 241,
  sym_decl_newtype = 242,
  sym_class_name = 243,
  sym_constraint = 244,
  sym_constraints = 245,
  sym__cdecl = 246,
  sym_fundep = 247,
  sym_fundeps = 248,
  sym_class_body = 249,
  sym__class_kind_declaration = 250,
  sym_class_head = 251,
  sym_class_declaration = 252,
  sym__idecl = 253,
  sym_instance_head = 254,
  sym__instance_name = 255,
  sym_class_instance = 256,
  sym__funpat = 257,
  sym__fun_name = 258,
  sym_guard_equation = 259,
  aux_sym__fun_guards = 260,
  sym__funrhs = 261,
  aux_sym__fun_patterns = 262,
  sym__funvar = 263,
  sym__funlhs = 264,
  sym_function = 265,
  sym_operator_declaration = 266,
  sym_signature = 267,
  sym__gendecl = 268,
  sym__decl_fun = 269,
  sym__decl = 270,
  sym_declarations = 271,
  sym_decl_foreign_import = 272,
  sym__decl_foreign = 273,
  sym__newkind_type_signature = 274,
  sym_kind_declaration = 275,
  sym_kind_value_declaration = 276,
  sym_decl_derive = 277,
  sym__pattern_type = 278,
  sym__pattern_equals = 279,
  sym__pattern_decl = 280,
  sym__pattern_arrow = 281,
  sym_decl_pattern = 282,
  aux_sym_purescript_repeat1 = 283,
  aux_sym_row_type_repeat1 = 284,
  aux_sym_record_literal_repeat1 = 285,
  aux_sym__record_field_update_repeat1 = 286,
  aux_sym_record_update_repeat1 = 287,
  aux_sym__quantifiers_repeat1 = 288,
  aux_sym_forall_repeat1 = 289,
  aux_sym_type_apply_repeat1 = 290,
  aux_sym_type_role_declaration_repeat1 = 291,
  aux_sym_exp_array_repeat1 = 292,
  aux_sym_record_accessor_repeat1 = 293,
  aux_sym_guards_repeat1 = 294,
  aux_sym__alt_variants_repeat1 = 295,
  aux_sym_alt_repeat1 = 296,
  aux_sym_alts_repeat1 = 297,
  aux_sym__exp_case_slots_repeat1 = 298,
  aux_sym__let_decls_repeat1 = 299,
  aux_sym_exp_lambda_repeat1 = 300,
  aux_sym_exp_do_repeat1 = 301,
  aux_sym__ado_in_repeat1 = 302,
  aux_sym_pat_fields_repeat1 = 303,
  aux_sym_pat_array_repeat1 = 304,
  aux_sym_import_con_names_repeat1 = 305,
  aux_sym_import_list_repeat1 = 306,
  aux_sym_export_names_repeat1 = 307,
  aux_sym_exports_repeat1 = 308,
  aux_sym_decl_data_repeat1 = 309,
  aux_sym_decl_data_repeat2 = 310,
  aux_sym_constraints_repeat1 = 311,
  aux_sym_fundep_repeat1 = 312,
  aux_sym_fundeps_repeat1 = 313,
  aux_sym_class_body_repeat1 = 314,
  aux_sym_class_instance_repeat1 = 315,
  aux_sym__pattern_arrow_repeat1 = 316,
  alias_sym_exp_apply = 317,
  alias_sym_field_name = 318,
  alias_sym_field_pun = 319,
  alias_sym_field_value = 320,
  alias_sym_instance_name = 321,
  alias_sym_module = 322,
  alias_sym_pat_literal = 323,
  alias_sym_patterns = 324,
  alias_sym_type = 325,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__varid] = "_varid",
  [anon_sym_SEMI] = ";",
  [sym_number] = "number",
  [sym_char] = "char",
  [sym_string] = "string",
  [sym_triple_quote_string] = "triple_quote_string",
  [sym__integer_literal] = "_integer_literal",
  [sym__hex_literal] = "_hex_literal",
  [anon_sym_u21d2] = "\u21d2",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_u21d0] = "\u21d0",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_u2192] = "\u2192",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_u2190] = "\u2190",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_u2237] = "\u2237",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym__] = "_",
  [sym_hole] = "hole",
  [sym__immediate_dot] = "_immediate_dot",
  [sym__immediate_varid] = "variable",
  [sym__operator] = "_operator",
  [anon_sym_DASH] = "-",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [sym__conid] = "_conid",
  [anon_sym_PIPE] = "|",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_AT] = "@",
  [anon_sym_forall] = "forall",
  [anon_sym_u2200] = "\u2200",
  [anon_sym_DOT] = ".",
  [anon_sym_nominal] = "nominal",
  [anon_sym_representational] = "representational",
  [anon_sym_phantom] = "phantom",
  [anon_sym_type] = "type",
  [anon_sym_role] = "role",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_of] = "of",
  [anon_sym_let] = "let",
  [anon_sym_in] = "in",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_do] = "do",
  [anon_sym_ado] = "ado",
  [anon_sym_AT2] = "@",
  [anon_sym_DOT_DOT] = "all_names",
  [anon_sym_class] = "class",
  [anon_sym_hiding] = "hiding",
  [anon_sym_import] = "import",
  [anon_sym_as] = "as",
  [anon_sym_module] = "module",
  [anon_sym_data] = "data",
  [anon_sym_newtype] = "newtype",
  [anon_sym_instance] = "instance",
  [anon_sym_infixl] = "infixl",
  [anon_sym_infixr] = "infixr",
  [anon_sym_infix] = "infix",
  [anon_sym_foreign] = "foreign",
  [anon_sym_derive] = "derive",
  [anon_sym_pattern] = "pattern",
  [aux_sym__token1] = "_token1",
  [sym__layout_semicolon] = "_layout_semicolon",
  [sym__layout_start] = "_layout_start",
  [sym__layout_end] = "_layout_end",
  [sym__dot] = "_dot",
  [sym__arith_dotdot] = "_arith_dotdot",
  [sym_where] = "where",
  [sym__splice_dollar] = "_splice_dollar",
  [sym__varsym] = "_varsym",
  [sym__consym] = "_consym",
  [sym__tyconsym] = "type_operator",
  [sym_comment] = "comment",
  [sym_cpp] = "cpp",
  [sym_comma] = "comma",
  [sym_quasiquote_start] = "quasiquote_start",
  [sym_quasiquote_bar] = "quasiquote_bar",
  [sym_quasiquote_body] = "quasiquote_body",
  [sym__strict] = "_strict",
  [sym__lazy] = "_lazy",
  [sym__unboxed_close] = "_unboxed_close",
  [sym_empty_file] = "empty_file",
  [sym_purescript] = "purescript",
  [sym__topdecl] = "_topdecl",
  [sym_integer] = "integer",
  [sym__numeric] = "_numeric",
  [sym__literal] = "_literal",
  [sym__rcarrow] = "_rcarrow",
  [sym__lcarrow] = "_lcarrow",
  [sym__arrow] = "_arrow",
  [sym__larrow] = "_larrow",
  [sym__colon2] = "_colon2",
  [sym_wildcard] = "wildcard",
  [sym_variable] = "variable",
  [sym__immediate_variable] = "_immediate_variable",
  [sym_qualified_variable] = "qualified_variable",
  [sym_operator] = "operator",
  [sym__minus] = "_minus",
  [sym__operator_or_minus] = "_operator_or_minus",
  [sym_qualified_operator] = "qualified_operator",
  [sym__q_op] = "_q_op",
  [sym_constructor] = "constructor",
  [sym_qualified_constructor] = "qualified_constructor",
  [sym_constructor_operator] = "constructor_operator",
  [sym_qualified_constructor_operator] = "qualified_constructor_operator",
  [sym__qcon] = "_qcon",
  [sym_qualified_type] = "qualified_type",
  [sym__type_operator] = "_type_operator",
  [sym_qualified_type_operator] = "qualified_type_operator",
  [sym__qualified_type_operator] = "_qualified_type_operator",
  [sym_type_literal] = "type_literal",
  [sym_literal] = "exp_literal",
  [sym__name] = "_name",
  [sym__field_name_ty] = "_field_name_ty",
  [sym_row_field] = "row_field",
  [sym__row_variable] = "_row_variable",
  [sym_row_type] = "row_type",
  [sym_record_type_literal] = "record_type_literal",
  [sym__field_name] = "_field_name",
  [sym_field_wildcard] = "field_wildcard",
  [sym_record_field] = "record_field",
  [sym_record_literal] = "record_literal",
  [sym__record_field_update] = "_record_field_update",
  [sym__record_update_lhs] = "_record_update_lhs",
  [sym_record_update] = "record_update",
  [sym_type_variable] = "type_variable",
  [sym__visible_type_variable] = "_visible_type_variable",
  [sym__tyvar_no_annotation] = "_tyvar_no_annotation",
  [sym__tyvar_annotated] = "annotated_type_variable",
  [sym__forall_kw] = "_forall_kw",
  [sym_forall] = "forall",
  [sym_type_name] = "type_name",
  [sym_type_wildcard] = "type_wildcard",
  [sym_type_operator] = "type_operator",
  [sym__type_qoperator] = "_type_qoperator",
  [sym_captured_type_operator] = "captured_type_operator",
  [sym_type_parens] = "type_parens",
  [sym__type_annotation] = "_type_annotation",
  [sym__atype] = "_atype",
  [sym_type_apply] = "type_apply",
  [sym__btype] = "_btype",
  [sym_type_infix] = "type_infix",
  [sym__type] = "_type",
  [sym__simpletype] = "_simpletype",
  [sym__role] = "type_role",
  [sym_type_role_declaration] = "type_role_declaration",
  [sym__type_type_signature] = "type_signature",
  [sym_decl_type] = "type_alias",
  [sym_exp_name] = "exp_name",
  [sym_exp_ticked] = "exp_ticked",
  [sym_exp_negation] = "exp_negation",
  [sym_exp_parens] = "exp_parens",
  [sym_exp_type_application] = "exp_type_application",
  [sym_exp_array] = "exp_array",
  [sym_exp_section_left] = "exp_section_left",
  [sym_exp_section_right] = "exp_section_right",
  [sym__record_access_field] = "_record_access_field",
  [sym_record_accessor] = "record_accessor",
  [sym_exp_record_access] = "exp_record_access",
  [sym_exp_if] = "exp_if",
  [sym_pattern_guard] = "pattern_guard",
  [sym_guard] = "guard",
  [sym_guards] = "guards",
  [sym_gdpat] = "gdpat",
  [sym__alt_variants] = "_alt_variants",
  [sym_alt] = "alt",
  [sym_alts] = "alts",
  [sym__exp_case_slots] = "_exp_case_slots",
  [sym_exp_case] = "exp_case",
  [sym__let_decls] = "declarations",
  [sym_exp_let_in] = "exp_let_in",
  [sym_exp_lambda] = "exp_lambda",
  [sym__statement_lexp] = "_statement_lexp",
  [sym___statement_exp_infix] = "exp_infix",
  [sym__statement_exp_infix] = "_statement_exp_infix",
  [sym__statement_exp] = "_statement_exp",
  [sym_bind_pattern] = "bind_pattern",
  [sym_let] = "let",
  [sym_statement] = "statement",
  [sym__do_kw] = "_do_kw",
  [sym__do] = "_do",
  [sym_exp_do] = "exp_do",
  [sym__ado_kw] = "_ado_kw",
  [sym__ado] = "_ado",
  [sym__ado_in] = "_ado_in",
  [sym_exp_ado] = "exp_ado",
  [sym__do_or_ado_block] = "_do_or_ado_block",
  [sym__aexp_projection] = "_aexp_projection",
  [sym__aexp] = "_aexp",
  [sym__exp_apply] = "_exp_apply",
  [sym__fexp] = "_fexp",
  [sym__lexp] = "_lexp",
  [sym_exp_infix] = "exp_infix",
  [sym__exp_infix] = "_exp_infix",
  [sym__exp] = "_exp",
  [sym_pat_field] = "pat_field",
  [sym_pat_fields] = "pat_fields",
  [sym_pat_name] = "pat_name",
  [sym_pat_as] = "pat_as",
  [sym__pat_constructor] = "_pat_constructor",
  [sym_pat_record] = "pat_record",
  [sym_pat_wildcard] = "pat_wildcard",
  [sym_pat_parens] = "pat_parens",
  [sym_pat_array] = "pat_array",
  [sym__apat] = "_apat",
  [sym_pat_negation] = "pat_negation",
  [sym_pat_apply] = "pat_apply",
  [sym__lpat] = "_lpat",
  [sym_pat_infix] = "pat_infix",
  [sym__pat] = "_pat",
  [sym_pat_typed] = "pat_typed",
  [sym__typed_pat] = "_typed_pat",
  [sym__import_name] = "_import_name",
  [sym_import_con_names] = "import_con_names",
  [sym_import_item] = "import_item",
  [sym_class_import] = "class_import",
  [sym_type_operator_import] = "type_operator_import",
  [sym_type_import] = "type_import",
  [sym_var_import] = "var_import",
  [sym_import_list] = "import_list",
  [sym_decl_import] = "import",
  [sym__modid] = "_modid",
  [aux_sym__qualifying_module] = "_qualifying_module",
  [sym_qualified_module] = "qualified_module",
  [sym_export_names] = "export_names",
  [sym_export] = "export",
  [sym_exports] = "exports",
  [sym__decl_module] = "_decl_module",
  [sym__data_type_signature] = "type_signature",
  [sym_decl_data] = "data",
  [sym_newtype_constructor] = "newtype_constructor",
  [sym__newtype_type_signature] = "type_signature",
  [sym_decl_newtype] = "newtype",
  [sym_class_name] = "class_name",
  [sym_constraint] = "constraint",
  [sym_constraints] = "constraints",
  [sym__cdecl] = "_cdecl",
  [sym_fundep] = "fundep",
  [sym_fundeps] = "fundeps",
  [sym_class_body] = "class_body",
  [sym__class_kind_declaration] = "kind_declaration",
  [sym_class_head] = "class_head",
  [sym_class_declaration] = "class_declaration",
  [sym__idecl] = "_idecl",
  [sym_instance_head] = "instance_head",
  [sym__instance_name] = "_instance_name",
  [sym_class_instance] = "class_instance",
  [sym__funpat] = "function",
  [sym__fun_name] = "_fun_name",
  [sym_guard_equation] = "guard_equation",
  [aux_sym__fun_guards] = "_fun_guards",
  [sym__funrhs] = "_funrhs",
  [aux_sym__fun_patterns] = "_fun_patterns",
  [sym__funvar] = "_funvar",
  [sym__funlhs] = "_funlhs",
  [sym_function] = "function",
  [sym_operator_declaration] = "operator_declaration",
  [sym_signature] = "signature",
  [sym__gendecl] = "_gendecl",
  [sym__decl_fun] = "_decl_fun",
  [sym__decl] = "_decl",
  [sym_declarations] = "declarations",
  [sym_decl_foreign_import] = "foreign_import",
  [sym__decl_foreign] = "_decl_foreign",
  [sym__newkind_type_signature] = "kind_signature",
  [sym_kind_declaration] = "kind_declaration",
  [sym_kind_value_declaration] = "kind_value_declaration",
  [sym_decl_derive] = "derive_declaration",
  [sym__pattern_type] = "signature",
  [sym__pattern_equals] = "equation",
  [sym__pattern_decl] = "_pattern_decl",
  [sym__pattern_arrow] = "equation",
  [sym_decl_pattern] = "pattern_synonym",
  [aux_sym_purescript_repeat1] = "purescript_repeat1",
  [aux_sym_row_type_repeat1] = "row_type_repeat1",
  [aux_sym_record_literal_repeat1] = "record_literal_repeat1",
  [aux_sym__record_field_update_repeat1] = "_record_field_update_repeat1",
  [aux_sym_record_update_repeat1] = "record_update_repeat1",
  [aux_sym__quantifiers_repeat1] = "_quantifiers_repeat1",
  [aux_sym_forall_repeat1] = "forall_repeat1",
  [aux_sym_type_apply_repeat1] = "type_apply_repeat1",
  [aux_sym_type_role_declaration_repeat1] = "type_role_declaration_repeat1",
  [aux_sym_exp_array_repeat1] = "exp_array_repeat1",
  [aux_sym_record_accessor_repeat1] = "record_accessor_repeat1",
  [aux_sym_guards_repeat1] = "guards_repeat1",
  [aux_sym__alt_variants_repeat1] = "_alt_variants_repeat1",
  [aux_sym_alt_repeat1] = "alt_repeat1",
  [aux_sym_alts_repeat1] = "alts_repeat1",
  [aux_sym__exp_case_slots_repeat1] = "_exp_case_slots_repeat1",
  [aux_sym__let_decls_repeat1] = "_let_decls_repeat1",
  [aux_sym_exp_lambda_repeat1] = "exp_lambda_repeat1",
  [aux_sym_exp_do_repeat1] = "exp_do_repeat1",
  [aux_sym__ado_in_repeat1] = "_ado_in_repeat1",
  [aux_sym_pat_fields_repeat1] = "pat_fields_repeat1",
  [aux_sym_pat_array_repeat1] = "pat_array_repeat1",
  [aux_sym_import_con_names_repeat1] = "import_con_names_repeat1",
  [aux_sym_import_list_repeat1] = "import_list_repeat1",
  [aux_sym_export_names_repeat1] = "export_names_repeat1",
  [aux_sym_exports_repeat1] = "exports_repeat1",
  [aux_sym_decl_data_repeat1] = "decl_data_repeat1",
  [aux_sym_decl_data_repeat2] = "decl_data_repeat2",
  [aux_sym_constraints_repeat1] = "constraints_repeat1",
  [aux_sym_fundep_repeat1] = "fundep_repeat1",
  [aux_sym_fundeps_repeat1] = "fundeps_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_class_instance_repeat1] = "class_instance_repeat1",
  [aux_sym__pattern_arrow_repeat1] = "_pattern_arrow_repeat1",
  [alias_sym_exp_apply] = "exp_apply",
  [alias_sym_field_name] = "field_name",
  [alias_sym_field_pun] = "field_pun",
  [alias_sym_field_value] = "field_value",
  [alias_sym_instance_name] = "instance_name",
  [alias_sym_module] = "module",
  [alias_sym_pat_literal] = "pat_literal",
  [alias_sym_patterns] = "patterns",
  [alias_sym_type] = "type",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__varid] = sym__varid,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [sym_number] = sym_number,
  [sym_char] = sym_char,
  [sym_string] = sym_string,
  [sym_triple_quote_string] = sym_triple_quote_string,
  [sym__integer_literal] = sym__integer_literal,
  [sym__hex_literal] = sym__hex_literal,
  [anon_sym_u21d2] = anon_sym_u21d2,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_u21d0] = anon_sym_u21d0,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_u2192] = anon_sym_u2192,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_u2190] = anon_sym_u2190,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_u2237] = anon_sym_u2237,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym__] = anon_sym__,
  [sym_hole] = sym_hole,
  [sym__immediate_dot] = sym__immediate_dot,
  [sym__immediate_varid] = sym_variable,
  [sym__operator] = sym__operator,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [sym__conid] = sym__conid,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_u2200] = anon_sym_u2200,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_nominal] = anon_sym_nominal,
  [anon_sym_representational] = anon_sym_representational,
  [anon_sym_phantom] = anon_sym_phantom,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_role] = anon_sym_role,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_ado] = anon_sym_ado,
  [anon_sym_AT2] = anon_sym_AT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_hiding] = anon_sym_hiding,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_data] = anon_sym_data,
  [anon_sym_newtype] = anon_sym_newtype,
  [anon_sym_instance] = anon_sym_instance,
  [anon_sym_infixl] = anon_sym_infixl,
  [anon_sym_infixr] = anon_sym_infixr,
  [anon_sym_infix] = anon_sym_infix,
  [anon_sym_foreign] = anon_sym_foreign,
  [anon_sym_derive] = anon_sym_derive,
  [anon_sym_pattern] = anon_sym_pattern,
  [aux_sym__token1] = aux_sym__token1,
  [sym__layout_semicolon] = sym__layout_semicolon,
  [sym__layout_start] = sym__layout_start,
  [sym__layout_end] = sym__layout_end,
  [sym__dot] = sym__dot,
  [sym__arith_dotdot] = sym__arith_dotdot,
  [sym_where] = sym_where,
  [sym__splice_dollar] = sym__splice_dollar,
  [sym__varsym] = sym__varsym,
  [sym__consym] = sym__consym,
  [sym__tyconsym] = sym_type_operator,
  [sym_comment] = sym_comment,
  [sym_cpp] = sym_cpp,
  [sym_comma] = sym_comma,
  [sym_quasiquote_start] = sym_quasiquote_start,
  [sym_quasiquote_bar] = sym_quasiquote_bar,
  [sym_quasiquote_body] = sym_quasiquote_body,
  [sym__strict] = sym__strict,
  [sym__lazy] = sym__lazy,
  [sym__unboxed_close] = sym__unboxed_close,
  [sym_empty_file] = sym_empty_file,
  [sym_purescript] = sym_purescript,
  [sym__topdecl] = sym__topdecl,
  [sym_integer] = sym_integer,
  [sym__numeric] = sym__numeric,
  [sym__literal] = sym__literal,
  [sym__rcarrow] = sym__rcarrow,
  [sym__lcarrow] = sym__lcarrow,
  [sym__arrow] = sym__arrow,
  [sym__larrow] = sym__larrow,
  [sym__colon2] = sym__colon2,
  [sym_wildcard] = sym_wildcard,
  [sym_variable] = sym_variable,
  [sym__immediate_variable] = sym__immediate_variable,
  [sym_qualified_variable] = sym_qualified_variable,
  [sym_operator] = sym_operator,
  [sym__minus] = sym__minus,
  [sym__operator_or_minus] = sym__operator_or_minus,
  [sym_qualified_operator] = sym_qualified_operator,
  [sym__q_op] = sym__q_op,
  [sym_constructor] = sym_constructor,
  [sym_qualified_constructor] = sym_qualified_constructor,
  [sym_constructor_operator] = sym_constructor_operator,
  [sym_qualified_constructor_operator] = sym_qualified_constructor_operator,
  [sym__qcon] = sym__qcon,
  [sym_qualified_type] = sym_qualified_type,
  [sym__type_operator] = sym__type_operator,
  [sym_qualified_type_operator] = sym_qualified_type_operator,
  [sym__qualified_type_operator] = sym__qualified_type_operator,
  [sym_type_literal] = sym_type_literal,
  [sym_literal] = sym_literal,
  [sym__name] = sym__name,
  [sym__field_name_ty] = sym__field_name_ty,
  [sym_row_field] = sym_row_field,
  [sym__row_variable] = sym__row_variable,
  [sym_row_type] = sym_row_type,
  [sym_record_type_literal] = sym_record_type_literal,
  [sym__field_name] = sym__field_name,
  [sym_field_wildcard] = sym_field_wildcard,
  [sym_record_field] = sym_record_field,
  [sym_record_literal] = sym_record_literal,
  [sym__record_field_update] = sym__record_field_update,
  [sym__record_update_lhs] = sym__record_update_lhs,
  [sym_record_update] = sym_record_update,
  [sym_type_variable] = sym_type_variable,
  [sym__visible_type_variable] = sym__visible_type_variable,
  [sym__tyvar_no_annotation] = sym__tyvar_no_annotation,
  [sym__tyvar_annotated] = sym__tyvar_annotated,
  [sym__forall_kw] = sym__forall_kw,
  [sym_forall] = sym_forall,
  [sym_type_name] = sym_type_name,
  [sym_type_wildcard] = sym_type_wildcard,
  [sym_type_operator] = sym_type_operator,
  [sym__type_qoperator] = sym__type_qoperator,
  [sym_captured_type_operator] = sym_captured_type_operator,
  [sym_type_parens] = sym_type_parens,
  [sym__type_annotation] = sym__type_annotation,
  [sym__atype] = sym__atype,
  [sym_type_apply] = sym_type_apply,
  [sym__btype] = sym__btype,
  [sym_type_infix] = sym_type_infix,
  [sym__type] = sym__type,
  [sym__simpletype] = sym__simpletype,
  [sym__role] = sym__role,
  [sym_type_role_declaration] = sym_type_role_declaration,
  [sym__type_type_signature] = sym__type_type_signature,
  [sym_decl_type] = sym_decl_type,
  [sym_exp_name] = sym_exp_name,
  [sym_exp_ticked] = sym_exp_ticked,
  [sym_exp_negation] = sym_exp_negation,
  [sym_exp_parens] = sym_exp_parens,
  [sym_exp_type_application] = sym_exp_type_application,
  [sym_exp_array] = sym_exp_array,
  [sym_exp_section_left] = sym_exp_section_left,
  [sym_exp_section_right] = sym_exp_section_right,
  [sym__record_access_field] = sym__record_access_field,
  [sym_record_accessor] = sym_record_accessor,
  [sym_exp_record_access] = sym_exp_record_access,
  [sym_exp_if] = sym_exp_if,
  [sym_pattern_guard] = sym_pattern_guard,
  [sym_guard] = sym_guard,
  [sym_guards] = sym_guards,
  [sym_gdpat] = sym_gdpat,
  [sym__alt_variants] = sym__alt_variants,
  [sym_alt] = sym_alt,
  [sym_alts] = sym_alts,
  [sym__exp_case_slots] = sym__exp_case_slots,
  [sym_exp_case] = sym_exp_case,
  [sym__let_decls] = sym_declarations,
  [sym_exp_let_in] = sym_exp_let_in,
  [sym_exp_lambda] = sym_exp_lambda,
  [sym__statement_lexp] = sym__statement_lexp,
  [sym___statement_exp_infix] = sym_exp_infix,
  [sym__statement_exp_infix] = sym__statement_exp_infix,
  [sym__statement_exp] = sym__statement_exp,
  [sym_bind_pattern] = sym_bind_pattern,
  [sym_let] = sym_let,
  [sym_statement] = sym_statement,
  [sym__do_kw] = sym__do_kw,
  [sym__do] = sym__do,
  [sym_exp_do] = sym_exp_do,
  [sym__ado_kw] = sym__ado_kw,
  [sym__ado] = sym__ado,
  [sym__ado_in] = sym__ado_in,
  [sym_exp_ado] = sym_exp_ado,
  [sym__do_or_ado_block] = sym__do_or_ado_block,
  [sym__aexp_projection] = sym__aexp_projection,
  [sym__aexp] = sym__aexp,
  [sym__exp_apply] = sym__exp_apply,
  [sym__fexp] = sym__fexp,
  [sym__lexp] = sym__lexp,
  [sym_exp_infix] = sym_exp_infix,
  [sym__exp_infix] = sym__exp_infix,
  [sym__exp] = sym__exp,
  [sym_pat_field] = sym_pat_field,
  [sym_pat_fields] = sym_pat_fields,
  [sym_pat_name] = sym_pat_name,
  [sym_pat_as] = sym_pat_as,
  [sym__pat_constructor] = sym__pat_constructor,
  [sym_pat_record] = sym_pat_record,
  [sym_pat_wildcard] = sym_pat_wildcard,
  [sym_pat_parens] = sym_pat_parens,
  [sym_pat_array] = sym_pat_array,
  [sym__apat] = sym__apat,
  [sym_pat_negation] = sym_pat_negation,
  [sym_pat_apply] = sym_pat_apply,
  [sym__lpat] = sym__lpat,
  [sym_pat_infix] = sym_pat_infix,
  [sym__pat] = sym__pat,
  [sym_pat_typed] = sym_pat_typed,
  [sym__typed_pat] = sym__typed_pat,
  [sym__import_name] = sym__import_name,
  [sym_import_con_names] = sym_import_con_names,
  [sym_import_item] = sym_import_item,
  [sym_class_import] = sym_class_import,
  [sym_type_operator_import] = sym_type_operator_import,
  [sym_type_import] = sym_type_import,
  [sym_var_import] = sym_var_import,
  [sym_import_list] = sym_import_list,
  [sym_decl_import] = sym_decl_import,
  [sym__modid] = sym__modid,
  [aux_sym__qualifying_module] = aux_sym__qualifying_module,
  [sym_qualified_module] = sym_qualified_module,
  [sym_export_names] = sym_export_names,
  [sym_export] = sym_export,
  [sym_exports] = sym_exports,
  [sym__decl_module] = sym__decl_module,
  [sym__data_type_signature] = sym__type_type_signature,
  [sym_decl_data] = sym_decl_data,
  [sym_newtype_constructor] = sym_newtype_constructor,
  [sym__newtype_type_signature] = sym__type_type_signature,
  [sym_decl_newtype] = sym_decl_newtype,
  [sym_class_name] = sym_class_name,
  [sym_constraint] = sym_constraint,
  [sym_constraints] = sym_constraints,
  [sym__cdecl] = sym__cdecl,
  [sym_fundep] = sym_fundep,
  [sym_fundeps] = sym_fundeps,
  [sym_class_body] = sym_class_body,
  [sym__class_kind_declaration] = sym_kind_declaration,
  [sym_class_head] = sym_class_head,
  [sym_class_declaration] = sym_class_declaration,
  [sym__idecl] = sym__idecl,
  [sym_instance_head] = sym_instance_head,
  [sym__instance_name] = sym__instance_name,
  [sym_class_instance] = sym_class_instance,
  [sym__funpat] = sym_function,
  [sym__fun_name] = sym__fun_name,
  [sym_guard_equation] = sym_guard_equation,
  [aux_sym__fun_guards] = aux_sym__fun_guards,
  [sym__funrhs] = sym__funrhs,
  [aux_sym__fun_patterns] = aux_sym__fun_patterns,
  [sym__funvar] = sym__funvar,
  [sym__funlhs] = sym__funlhs,
  [sym_function] = sym_function,
  [sym_operator_declaration] = sym_operator_declaration,
  [sym_signature] = sym_signature,
  [sym__gendecl] = sym__gendecl,
  [sym__decl_fun] = sym__decl_fun,
  [sym__decl] = sym__decl,
  [sym_declarations] = sym_declarations,
  [sym_decl_foreign_import] = sym_decl_foreign_import,
  [sym__decl_foreign] = sym__decl_foreign,
  [sym__newkind_type_signature] = sym__newkind_type_signature,
  [sym_kind_declaration] = sym_kind_declaration,
  [sym_kind_value_declaration] = sym_kind_value_declaration,
  [sym_decl_derive] = sym_decl_derive,
  [sym__pattern_type] = sym_signature,
  [sym__pattern_equals] = sym__pattern_equals,
  [sym__pattern_decl] = sym__pattern_decl,
  [sym__pattern_arrow] = sym__pattern_equals,
  [sym_decl_pattern] = sym_decl_pattern,
  [aux_sym_purescript_repeat1] = aux_sym_purescript_repeat1,
  [aux_sym_row_type_repeat1] = aux_sym_row_type_repeat1,
  [aux_sym_record_literal_repeat1] = aux_sym_record_literal_repeat1,
  [aux_sym__record_field_update_repeat1] = aux_sym__record_field_update_repeat1,
  [aux_sym_record_update_repeat1] = aux_sym_record_update_repeat1,
  [aux_sym__quantifiers_repeat1] = aux_sym__quantifiers_repeat1,
  [aux_sym_forall_repeat1] = aux_sym_forall_repeat1,
  [aux_sym_type_apply_repeat1] = aux_sym_type_apply_repeat1,
  [aux_sym_type_role_declaration_repeat1] = aux_sym_type_role_declaration_repeat1,
  [aux_sym_exp_array_repeat1] = aux_sym_exp_array_repeat1,
  [aux_sym_record_accessor_repeat1] = aux_sym_record_accessor_repeat1,
  [aux_sym_guards_repeat1] = aux_sym_guards_repeat1,
  [aux_sym__alt_variants_repeat1] = aux_sym__alt_variants_repeat1,
  [aux_sym_alt_repeat1] = aux_sym_alt_repeat1,
  [aux_sym_alts_repeat1] = aux_sym_alts_repeat1,
  [aux_sym__exp_case_slots_repeat1] = aux_sym__exp_case_slots_repeat1,
  [aux_sym__let_decls_repeat1] = aux_sym__let_decls_repeat1,
  [aux_sym_exp_lambda_repeat1] = aux_sym_exp_lambda_repeat1,
  [aux_sym_exp_do_repeat1] = aux_sym_exp_do_repeat1,
  [aux_sym__ado_in_repeat1] = aux_sym__ado_in_repeat1,
  [aux_sym_pat_fields_repeat1] = aux_sym_pat_fields_repeat1,
  [aux_sym_pat_array_repeat1] = aux_sym_pat_array_repeat1,
  [aux_sym_import_con_names_repeat1] = aux_sym_import_con_names_repeat1,
  [aux_sym_import_list_repeat1] = aux_sym_import_list_repeat1,
  [aux_sym_export_names_repeat1] = aux_sym_export_names_repeat1,
  [aux_sym_exports_repeat1] = aux_sym_exports_repeat1,
  [aux_sym_decl_data_repeat1] = aux_sym_decl_data_repeat1,
  [aux_sym_decl_data_repeat2] = aux_sym_decl_data_repeat2,
  [aux_sym_constraints_repeat1] = aux_sym_constraints_repeat1,
  [aux_sym_fundep_repeat1] = aux_sym_fundep_repeat1,
  [aux_sym_fundeps_repeat1] = aux_sym_fundeps_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_class_instance_repeat1] = aux_sym_class_instance_repeat1,
  [aux_sym__pattern_arrow_repeat1] = aux_sym__pattern_arrow_repeat1,
  [alias_sym_exp_apply] = alias_sym_exp_apply,
  [alias_sym_field_name] = alias_sym_field_name,
  [alias_sym_field_pun] = alias_sym_field_pun,
  [alias_sym_field_value] = alias_sym_field_value,
  [alias_sym_instance_name] = alias_sym_instance_name,
  [alias_sym_module] = alias_sym_module,
  [alias_sym_pat_literal] = alias_sym_pat_literal,
  [alias_sym_patterns] = alias_sym_patterns,
  [alias_sym_type] = alias_sym_type,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__varid] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_triple_quote_string] = {
    .visible = true,
    .named = true,
  },
  [sym__integer_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_literal] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_u21d2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u21d0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2190] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2237] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [sym_hole] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_varid] = {
    .visible = true,
    .named = true,
  },
  [sym__operator] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym__conid] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nominal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_representational] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_phantom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_role] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ado] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hiding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_data] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_newtype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infix] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreign] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_derive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pattern] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__token1] = {
    .visible = false,
    .named = false,
  },
  [sym__layout_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_start] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_end] = {
    .visible = false,
    .named = true,
  },
  [sym__dot] = {
    .visible = false,
    .named = true,
  },
  [sym__arith_dotdot] = {
    .visible = false,
    .named = true,
  },
  [sym_where] = {
    .visible = true,
    .named = true,
  },
  [sym__splice_dollar] = {
    .visible = false,
    .named = true,
  },
  [sym__varsym] = {
    .visible = false,
    .named = true,
  },
  [sym__consym] = {
    .visible = false,
    .named = true,
  },
  [sym__tyconsym] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_cpp] = {
    .visible = true,
    .named = true,
  },
  [sym_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote_start] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote_bar] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote_body] = {
    .visible = true,
    .named = true,
  },
  [sym__strict] = {
    .visible = false,
    .named = true,
  },
  [sym__lazy] = {
    .visible = false,
    .named = true,
  },
  [sym__unboxed_close] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_file] = {
    .visible = true,
    .named = true,
  },
  [sym_purescript] = {
    .visible = true,
    .named = true,
  },
  [sym__topdecl] = {
    .visible = false,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym__numeric] = {
    .visible = false,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym__rcarrow] = {
    .visible = false,
    .named = true,
  },
  [sym__lcarrow] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow] = {
    .visible = false,
    .named = true,
  },
  [sym__larrow] = {
    .visible = false,
    .named = true,
  },
  [sym__colon2] = {
    .visible = false,
    .named = true,
  },
  [sym_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_variable] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__minus] = {
    .visible = false,
    .named = true,
  },
  [sym__operator_or_minus] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__q_op] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_constructor_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__qcon] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym__type_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_type_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__qualified_type_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_type_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym__field_name_ty] = {
    .visible = false,
    .named = true,
  },
  [sym_row_field] = {
    .visible = true,
    .named = true,
  },
  [sym__row_variable] = {
    .visible = false,
    .named = true,
  },
  [sym_row_type] = {
    .visible = true,
    .named = true,
  },
  [sym_record_type_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__field_name] = {
    .visible = false,
    .named = true,
  },
  [sym_field_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_record_field] = {
    .visible = true,
    .named = true,
  },
  [sym_record_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__record_field_update] = {
    .visible = false,
    .named = true,
  },
  [sym__record_update_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_record_update] = {
    .visible = true,
    .named = true,
  },
  [sym_type_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__visible_type_variable] = {
    .visible = false,
    .named = true,
  },
  [sym__tyvar_no_annotation] = {
    .visible = false,
    .named = true,
  },
  [sym__tyvar_annotated] = {
    .visible = true,
    .named = true,
  },
  [sym__forall_kw] = {
    .visible = false,
    .named = true,
  },
  [sym_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_type_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__type_qoperator] = {
    .visible = false,
    .named = true,
  },
  [sym_captured_type_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__type_annotation] = {
    .visible = false,
    .named = true,
  },
  [sym__atype] = {
    .visible = false,
    .named = true,
  },
  [sym_type_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__btype] = {
    .visible = false,
    .named = true,
  },
  [sym_type_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym__simpletype] = {
    .visible = false,
    .named = true,
  },
  [sym__role] = {
    .visible = true,
    .named = true,
  },
  [sym_type_role_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__type_type_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_type] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_name] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_ticked] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_type_application] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_array] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_section_left] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_section_right] = {
    .visible = true,
    .named = true,
  },
  [sym__record_access_field] = {
    .visible = false,
    .named = true,
  },
  [sym_record_accessor] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_record_access] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_if] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_guards] = {
    .visible = true,
    .named = true,
  },
  [sym_gdpat] = {
    .visible = true,
    .named = true,
  },
  [sym__alt_variants] = {
    .visible = false,
    .named = true,
  },
  [sym_alt] = {
    .visible = true,
    .named = true,
  },
  [sym_alts] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_case_slots] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_case] = {
    .visible = true,
    .named = true,
  },
  [sym__let_decls] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_let_in] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_lexp] = {
    .visible = false,
    .named = true,
  },
  [sym___statement_exp_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_exp_infix] = {
    .visible = false,
    .named = true,
  },
  [sym__statement_exp] = {
    .visible = false,
    .named = true,
  },
  [sym_bind_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__do_kw] = {
    .visible = false,
    .named = true,
  },
  [sym__do] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_do] = {
    .visible = true,
    .named = true,
  },
  [sym__ado_kw] = {
    .visible = false,
    .named = true,
  },
  [sym__ado] = {
    .visible = false,
    .named = true,
  },
  [sym__ado_in] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_ado] = {
    .visible = true,
    .named = true,
  },
  [sym__do_or_ado_block] = {
    .visible = false,
    .named = true,
  },
  [sym__aexp_projection] = {
    .visible = false,
    .named = true,
  },
  [sym__aexp] = {
    .visible = false,
    .named = true,
  },
  [sym__exp_apply] = {
    .visible = false,
    .named = true,
  },
  [sym__fexp] = {
    .visible = false,
    .named = true,
  },
  [sym__lexp] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_infix] = {
    .visible = false,
    .named = true,
  },
  [sym__exp] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_field] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_name] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_as] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_constructor] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_record] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_array] = {
    .visible = true,
    .named = true,
  },
  [sym__apat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__lpat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__pat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_typed] = {
    .visible = true,
    .named = true,
  },
  [sym__typed_pat] = {
    .visible = false,
    .named = true,
  },
  [sym__import_name] = {
    .visible = false,
    .named = true,
  },
  [sym_import_con_names] = {
    .visible = true,
    .named = true,
  },
  [sym_import_item] = {
    .visible = true,
    .named = true,
  },
  [sym_class_import] = {
    .visible = true,
    .named = true,
  },
  [sym_type_operator_import] = {
    .visible = true,
    .named = true,
  },
  [sym_type_import] = {
    .visible = true,
    .named = true,
  },
  [sym_var_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_import] = {
    .visible = true,
    .named = true,
  },
  [sym__modid] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__qualifying_module] = {
    .visible = false,
    .named = false,
  },
  [sym_qualified_module] = {
    .visible = true,
    .named = true,
  },
  [sym_export_names] = {
    .visible = true,
    .named = true,
  },
  [sym_export] = {
    .visible = true,
    .named = true,
  },
  [sym_exports] = {
    .visible = true,
    .named = true,
  },
  [sym__decl_module] = {
    .visible = false,
    .named = true,
  },
  [sym__data_type_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_data] = {
    .visible = true,
    .named = true,
  },
  [sym_newtype_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__newtype_type_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_newtype] = {
    .visible = true,
    .named = true,
  },
  [sym_class_name] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_constraints] = {
    .visible = true,
    .named = true,
  },
  [sym__cdecl] = {
    .visible = false,
    .named = true,
  },
  [sym_fundep] = {
    .visible = true,
    .named = true,
  },
  [sym_fundeps] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym__class_kind_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_head] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__idecl] = {
    .visible = false,
    .named = true,
  },
  [sym_instance_head] = {
    .visible = true,
    .named = true,
  },
  [sym__instance_name] = {
    .visible = false,
    .named = true,
  },
  [sym_class_instance] = {
    .visible = true,
    .named = true,
  },
  [sym__funpat] = {
    .visible = true,
    .named = true,
  },
  [sym__fun_name] = {
    .visible = false,
    .named = true,
  },
  [sym_guard_equation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__fun_guards] = {
    .visible = false,
    .named = false,
  },
  [sym__funrhs] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__fun_patterns] = {
    .visible = false,
    .named = false,
  },
  [sym__funvar] = {
    .visible = false,
    .named = true,
  },
  [sym__funlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__gendecl] = {
    .visible = false,
    .named = true,
  },
  [sym__decl_fun] = {
    .visible = false,
    .named = true,
  },
  [sym__decl] = {
    .visible = false,
    .named = true,
  },
  [sym_declarations] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_foreign_import] = {
    .visible = true,
    .named = true,
  },
  [sym__decl_foreign] = {
    .visible = false,
    .named = true,
  },
  [sym__newkind_type_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_kind_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_kind_value_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_derive] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_type] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_equals] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_decl] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_pattern] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_purescript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_row_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__record_field_update_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_update_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__quantifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_forall_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_apply_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_role_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_accessor_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_guards_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__alt_variants_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alt_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alts_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_case_slots_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__let_decls_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_lambda_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_do_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__ado_in_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pat_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pat_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_con_names_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_names_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_data_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_data_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constraints_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fundep_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fundeps_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_instance_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_arrow_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_exp_apply] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_pun] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_value] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_instance_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_module] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pat_literal] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_patterns] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_condition = 1,
  field_else = 2,
  field_exp = 3,
  field_exports = 4,
  field_field = 5,
  field_fields = 6,
  field_if = 7,
  field_import_rename = 8,
  field_imports = 9,
  field_in = 10,
  field_lhs = 11,
  field_module = 12,
  field_name = 13,
  field_pat = 14,
  field_pattern = 15,
  field_patterns = 16,
  field_precedence = 17,
  field_rhs = 18,
  field_role = 19,
  field_then = 20,
  field_var = 21,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_condition] = "condition",
  [field_else] = "else",
  [field_exp] = "exp",
  [field_exports] = "exports",
  [field_field] = "field",
  [field_fields] = "fields",
  [field_if] = "if",
  [field_import_rename] = "import_rename",
  [field_imports] = "imports",
  [field_in] = "in",
  [field_lhs] = "lhs",
  [field_module] = "module",
  [field_name] = "name",
  [field_pat] = "pat",
  [field_pattern] = "pattern",
  [field_patterns] = "patterns",
  [field_precedence] = "precedence",
  [field_rhs] = "rhs",
  [field_role] = "role",
  [field_then] = "then",
  [field_var] = "var",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [6] = {.index = 1, .length = 1},
  [7] = {.index = 2, .length = 2},
  [8] = {.index = 4, .length = 2},
  [9] = {.index = 6, .length = 1},
  [10] = {.index = 7, .length = 2},
  [13] = {.index = 0, .length = 1},
  [15] = {.index = 9, .length = 1},
  [16] = {.index = 10, .length = 1},
  [17] = {.index = 11, .length = 2},
  [18] = {.index = 13, .length = 1},
  [19] = {.index = 14, .length = 2},
  [20] = {.index = 16, .length = 2},
  [21] = {.index = 18, .length = 3},
  [22] = {.index = 21, .length = 3},
  [25] = {.index = 24, .length = 2},
  [26] = {.index = 26, .length = 1},
  [28] = {.index = 27, .length = 2},
  [30] = {.index = 29, .length = 1},
  [31] = {.index = 30, .length = 1},
  [32] = {.index = 31, .length = 1},
  [33] = {.index = 32, .length = 1},
  [35] = {.index = 33, .length = 3},
  [36] = {.index = 36, .length = 2},
  [37] = {.index = 38, .length = 2},
  [38] = {.index = 40, .length = 1},
  [40] = {.index = 41, .length = 1},
  [41] = {.index = 42, .length = 2},
  [42] = {.index = 44, .length = 4},
  [43] = {.index = 48, .length = 4},
  [44] = {.index = 52, .length = 1},
  [45] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 1},
  [48] = {.index = 54, .length = 1},
  [49] = {.index = 55, .length = 2},
  [50] = {.index = 57, .length = 2},
  [51] = {.index = 59, .length = 1},
  [52] = {.index = 60, .length = 5},
  [53] = {.index = 52, .length = 1},
  [56] = {.index = 65, .length = 1},
  [57] = {.index = 66, .length = 2},
  [58] = {.index = 68, .length = 1},
  [59] = {.index = 69, .length = 1},
  [60] = {.index = 70, .length = 2},
  [61] = {.index = 72, .length = 1},
  [62] = {.index = 73, .length = 1},
  [63] = {.index = 74, .length = 3},
  [64] = {.index = 77, .length = 3},
  [65] = {.index = 80, .length = 2},
  [67] = {.index = 82, .length = 3},
  [68] = {.index = 85, .length = 1},
  [69] = {.index = 86, .length = 4},
  [70] = {.index = 90, .length = 2},
  [71] = {.index = 92, .length = 1},
  [72] = {.index = 93, .length = 1},
  [73] = {.index = 94, .length = 3},
  [74] = {.index = 97, .length = 2},
  [76] = {.index = 99, .length = 4},
  [77] = {.index = 103, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_fields, 0},
  [2] =
    {field_exports, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [4] =
    {field_pattern, 0, .inherited = true},
    {field_rhs, 0, .inherited = true},
  [6] =
    {field_name, 0, .inherited = true},
  [7] =
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [9] =
    {field_module, 1},
  [10] =
    {field_name, 1, .inherited = true},
  [11] =
    {field_lhs, 1, .inherited = true},
    {field_rhs, 1, .inherited = true},
  [13] =
    {field_pattern, 0},
  [14] =
    {field_pattern, 0},
    {field_rhs, 1, .inherited = true},
  [16] =
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [18] =
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
    {field_rhs, 1, .inherited = true},
  [21] =
    {field_name, 0},
    {field_name, 1},
    {field_name, 2},
  [24] =
    {field_imports, 2},
    {field_module, 1},
  [26] =
    {field_name, 1},
  [27] =
    {field_pat, 2},
    {field_var, 0},
  [29] =
    {field_rhs, 1},
  [30] =
    {field_name, 2, .inherited = true},
  [31] =
    {field_role, 0},
  [32] =
    {field_role, 3, .inherited = true},
  [33] =
    {field_import_rename, 2},
    {field_import_rename, 3},
    {field_module, 1},
  [36] =
    {field_exports, 2},
    {field_name, 1},
  [38] =
    {field_lhs, 0},
    {field_rhs, 2},
  [40] =
    {field_field, 1, .inherited = true},
  [41] =
    {field_condition, 0},
  [42] =
    {field_role, 0, .inherited = true},
    {field_role, 1, .inherited = true},
  [44] =
    {field_import_rename, 2},
    {field_import_rename, 3},
    {field_import_rename, 4},
    {field_module, 1},
  [48] =
    {field_import_rename, 3},
    {field_import_rename, 4},
    {field_imports, 2},
    {field_module, 1},
  [52] =
    {field_precedence, 1},
  [53] =
    {field_name, 3, .inherited = true},
  [54] =
    {field_field, 1},
  [55] =
    {field_field, 0, .inherited = true},
    {field_field, 1, .inherited = true},
  [57] =
    {field_condition, 0},
    {field_condition, 1, .inherited = true},
  [59] =
    {field_in, 2, .inherited = true},
  [60] =
    {field_import_rename, 3},
    {field_import_rename, 4},
    {field_import_rename, 5},
    {field_imports, 2},
    {field_module, 1},
  [65] =
    {field_condition, 1},
  [66] =
    {field_condition, 0, .inherited = true},
    {field_condition, 1, .inherited = true},
  [68] =
    {field_condition, 1, .inherited = true},
  [69] =
    {field_in, 3, .inherited = true},
  [70] =
    {field_in, 1},
    {field_in, 2},
  [72] =
    {field_in, 4, .inherited = true},
  [73] =
    {field_rhs, 1, .inherited = true},
  [74] =
    {field_lhs, 0},
    {field_rhs, 2},
    {field_rhs, 5, .inherited = true},
  [77] =
    {field_else, 5},
    {field_if, 1},
    {field_then, 3},
  [80] =
    {field_exp, 1, .inherited = true},
    {field_pat, 0},
  [82] =
    {field_in, 1},
    {field_in, 2},
    {field_in, 3},
  [85] =
    {field_in, 5, .inherited = true},
  [86] =
    {field_lhs, 0},
    {field_rhs, 2},
    {field_rhs, 5, .inherited = true},
    {field_rhs, 6, .inherited = true},
  [90] =
    {field_rhs, 0, .inherited = true},
    {field_rhs, 1, .inherited = true},
  [92] =
    {field_pat, 1},
  [93] =
    {field_exp, 1},
  [94] =
    {field_exp, 2, .inherited = true},
    {field_pat, 0},
    {field_pat, 1, .inherited = true},
  [97] =
    {field_pat, 0, .inherited = true},
    {field_pat, 1, .inherited = true},
  [99] =
    {field_in, 1},
    {field_in, 2},
    {field_in, 3},
    {field_in, 4},
  [103] =
    {field_in, 1},
    {field_in, 2},
    {field_in, 3},
    {field_in, 4},
    {field_in, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_pat_wildcard,
  },
  [3] = {
    [0] = alias_sym_module,
  },
  [4] = {
    [0] = sym_pat_name,
  },
  [5] = {
    [0] = alias_sym_pat_literal,
  },
  [11] = {
    [0] = sym_operator,
  },
  [12] = {
    [0] = alias_sym_field_name,
  },
  [13] = {
    [0] = alias_sym_type,
  },
  [14] = {
    [0] = alias_sym_type,
  },
  [20] = {
    [1] = alias_sym_patterns,
  },
  [23] = {
    [1] = alias_sym_type,
  },
  [24] = {
    [1] = sym_class_name,
  },
  [27] = {
    [0] = alias_sym_instance_name,
  },
  [29] = {
    [0] = alias_sym_exp_apply,
  },
  [33] = {
    [2] = alias_sym_type,
  },
  [34] = {
    [1] = sym_type_variable,
  },
  [39] = {
    [0] = alias_sym_field_pun,
  },
  [45] = {
    [2] = alias_sym_type,
  },
  [47] = {
    [2] = alias_sym_instance_name,
  },
  [53] = {
    [3] = alias_sym_type,
  },
  [54] = {
    [3] = alias_sym_instance_name,
  },
  [55] = {
    [2] = alias_sym_field_value,
  },
  [66] = {
    [2] = sym_record_update,
  },
  [75] = {
    [1] = sym_record_update,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_wildcard, 2,
    sym_wildcard,
    sym_pat_wildcard,
  sym_variable, 3,
    sym_variable,
    alias_sym_field_name,
    alias_sym_field_pun,
  sym_constructor, 3,
    sym_constructor,
    alias_sym_module,
    alias_sym_type,
  sym__qcon, 2,
    sym__qcon,
    sym_pat_name,
  sym_literal, 2,
    sym_literal,
    alias_sym_pat_literal,
  sym__record_field_update, 2,
    sym__record_field_update,
    sym_record_update,
  sym_type_variable, 2,
    sym_type_variable,
    alias_sym_field_name,
  sym__exp_apply, 2,
    sym__exp_apply,
    alias_sym_exp_apply,
  sym__exp, 2,
    sym__exp,
    alias_sym_field_value,
  aux_sym__fun_patterns, 2,
    aux_sym__fun_patterns,
    alias_sym_patterns,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 2,
  [10] = 2,
  [11] = 2,
  [12] = 2,
  [13] = 2,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 22,
  [24] = 22,
  [25] = 25,
  [26] = 25,
  [27] = 27,
  [28] = 28,
  [29] = 22,
  [30] = 27,
  [31] = 27,
  [32] = 22,
  [33] = 25,
  [34] = 22,
  [35] = 22,
  [36] = 25,
  [37] = 22,
  [38] = 27,
  [39] = 27,
  [40] = 25,
  [41] = 22,
  [42] = 22,
  [43] = 22,
  [44] = 27,
  [45] = 25,
  [46] = 22,
  [47] = 27,
  [48] = 22,
  [49] = 25,
  [50] = 22,
  [51] = 25,
  [52] = 22,
  [53] = 27,
  [54] = 22,
  [55] = 25,
  [56] = 25,
  [57] = 25,
  [58] = 25,
  [59] = 27,
  [60] = 27,
  [61] = 27,
  [62] = 27,
  [63] = 27,
  [64] = 25,
  [65] = 22,
  [66] = 22,
  [67] = 22,
  [68] = 25,
  [69] = 25,
  [70] = 27,
  [71] = 25,
  [72] = 27,
  [73] = 25,
  [74] = 22,
  [75] = 25,
  [76] = 27,
  [77] = 27,
  [78] = 25,
  [79] = 25,
  [80] = 27,
  [81] = 25,
  [82] = 27,
  [83] = 27,
  [84] = 25,
  [85] = 27,
  [86] = 25,
  [87] = 27,
  [88] = 22,
  [89] = 27,
  [90] = 25,
  [91] = 22,
  [92] = 22,
  [93] = 22,
  [94] = 22,
  [95] = 27,
  [96] = 25,
  [97] = 25,
  [98] = 25,
  [99] = 27,
  [100] = 22,
  [101] = 25,
  [102] = 27,
  [103] = 22,
  [104] = 27,
  [105] = 22,
  [106] = 27,
  [107] = 22,
  [108] = 22,
  [109] = 22,
  [110] = 25,
  [111] = 27,
  [112] = 28,
  [113] = 27,
  [114] = 27,
  [115] = 22,
  [116] = 25,
  [117] = 25,
  [118] = 22,
  [119] = 27,
  [120] = 27,
  [121] = 25,
  [122] = 25,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 123,
  [127] = 123,
  [128] = 124,
  [129] = 123,
  [130] = 125,
  [131] = 125,
  [132] = 125,
  [133] = 124,
  [134] = 124,
  [135] = 123,
  [136] = 125,
  [137] = 124,
  [138] = 124,
  [139] = 124,
  [140] = 124,
  [141] = 123,
  [142] = 123,
  [143] = 125,
  [144] = 124,
  [145] = 124,
  [146] = 125,
  [147] = 125,
  [148] = 125,
  [149] = 123,
  [150] = 124,
  [151] = 124,
  [152] = 124,
  [153] = 124,
  [154] = 124,
  [155] = 125,
  [156] = 125,
  [157] = 123,
  [158] = 123,
  [159] = 123,
  [160] = 125,
  [161] = 125,
  [162] = 123,
  [163] = 123,
  [164] = 123,
  [165] = 123,
  [166] = 123,
  [167] = 125,
  [168] = 125,
  [169] = 123,
  [170] = 124,
  [171] = 125,
  [172] = 124,
  [173] = 123,
  [174] = 123,
  [175] = 125,
  [176] = 125,
  [177] = 124,
  [178] = 123,
  [179] = 123,
  [180] = 124,
  [181] = 125,
  [182] = 123,
  [183] = 125,
  [184] = 123,
  [185] = 125,
  [186] = 124,
  [187] = 124,
  [188] = 125,
  [189] = 124,
  [190] = 124,
  [191] = 125,
  [192] = 123,
  [193] = 124,
  [194] = 125,
  [195] = 125,
  [196] = 125,
  [197] = 123,
  [198] = 124,
  [199] = 123,
  [200] = 125,
  [201] = 123,
  [202] = 124,
  [203] = 125,
  [204] = 124,
  [205] = 123,
  [206] = 125,
  [207] = 125,
  [208] = 124,
  [209] = 123,
  [210] = 123,
  [211] = 124,
  [212] = 123,
  [213] = 123,
  [214] = 124,
  [215] = 124,
  [216] = 125,
  [217] = 125,
  [218] = 125,
  [219] = 123,
  [220] = 124,
  [221] = 124,
  [222] = 222,
  [223] = 222,
  [224] = 224,
  [225] = 225,
  [226] = 225,
  [227] = 225,
  [228] = 225,
  [229] = 225,
  [230] = 225,
  [231] = 225,
  [232] = 225,
  [233] = 225,
  [234] = 225,
  [235] = 225,
  [236] = 225,
  [237] = 237,
  [238] = 238,
  [239] = 238,
  [240] = 237,
  [241] = 241,
  [242] = 241,
  [243] = 241,
  [244] = 241,
  [245] = 241,
  [246] = 241,
  [247] = 241,
  [248] = 241,
  [249] = 241,
  [250] = 241,
  [251] = 241,
  [252] = 241,
  [253] = 241,
  [254] = 241,
  [255] = 241,
  [256] = 241,
  [257] = 241,
  [258] = 241,
  [259] = 241,
  [260] = 241,
  [261] = 241,
  [262] = 241,
  [263] = 241,
  [264] = 241,
  [265] = 241,
  [266] = 241,
  [267] = 241,
  [268] = 241,
  [269] = 241,
  [270] = 241,
  [271] = 241,
  [272] = 241,
  [273] = 241,
  [274] = 274,
  [275] = 274,
  [276] = 276,
  [277] = 276,
  [278] = 276,
  [279] = 274,
  [280] = 276,
  [281] = 276,
  [282] = 276,
  [283] = 274,
  [284] = 274,
  [285] = 274,
  [286] = 286,
  [287] = 286,
  [288] = 288,
  [289] = 289,
  [290] = 288,
  [291] = 291,
  [292] = 274,
  [293] = 286,
  [294] = 289,
  [295] = 295,
  [296] = 291,
  [297] = 286,
  [298] = 289,
  [299] = 288,
  [300] = 274,
  [301] = 288,
  [302] = 291,
  [303] = 286,
  [304] = 289,
  [305] = 276,
  [306] = 295,
  [307] = 286,
  [308] = 289,
  [309] = 291,
  [310] = 295,
  [311] = 295,
  [312] = 286,
  [313] = 291,
  [314] = 291,
  [315] = 289,
  [316] = 288,
  [317] = 295,
  [318] = 289,
  [319] = 288,
  [320] = 291,
  [321] = 295,
  [322] = 291,
  [323] = 288,
  [324] = 288,
  [325] = 295,
  [326] = 291,
  [327] = 291,
  [328] = 286,
  [329] = 288,
  [330] = 295,
  [331] = 291,
  [332] = 276,
  [333] = 295,
  [334] = 295,
  [335] = 335,
  [336] = 295,
  [337] = 276,
  [338] = 289,
  [339] = 288,
  [340] = 289,
  [341] = 288,
  [342] = 274,
  [343] = 288,
  [344] = 286,
  [345] = 288,
  [346] = 291,
  [347] = 289,
  [348] = 289,
  [349] = 289,
  [350] = 288,
  [351] = 295,
  [352] = 289,
  [353] = 288,
  [354] = 289,
  [355] = 289,
  [356] = 288,
  [357] = 289,
  [358] = 291,
  [359] = 291,
  [360] = 288,
  [361] = 291,
  [362] = 291,
  [363] = 295,
  [364] = 288,
  [365] = 291,
  [366] = 288,
  [367] = 291,
  [368] = 288,
  [369] = 289,
  [370] = 289,
  [371] = 274,
  [372] = 295,
  [373] = 289,
  [374] = 291,
  [375] = 289,
  [376] = 289,
  [377] = 289,
  [378] = 289,
  [379] = 288,
  [380] = 295,
  [381] = 286,
  [382] = 288,
  [383] = 291,
  [384] = 291,
  [385] = 291,
  [386] = 291,
  [387] = 295,
  [388] = 286,
  [389] = 291,
  [390] = 286,
  [391] = 295,
  [392] = 291,
  [393] = 295,
  [394] = 295,
  [395] = 288,
  [396] = 295,
  [397] = 291,
  [398] = 289,
  [399] = 295,
  [400] = 295,
  [401] = 276,
  [402] = 286,
  [403] = 288,
  [404] = 295,
  [405] = 286,
  [406] = 291,
  [407] = 286,
  [408] = 295,
  [409] = 289,
  [410] = 295,
  [411] = 291,
  [412] = 288,
  [413] = 288,
  [414] = 289,
  [415] = 288,
  [416] = 289,
  [417] = 291,
  [418] = 295,
  [419] = 289,
  [420] = 291,
  [421] = 288,
  [422] = 291,
  [423] = 295,
  [424] = 295,
  [425] = 289,
  [426] = 291,
  [427] = 295,
  [428] = 288,
  [429] = 291,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 431,
  [435] = 430,
  [436] = 432,
  [437] = 431,
  [438] = 433,
  [439] = 432,
  [440] = 433,
  [441] = 430,
  [442] = 432,
  [443] = 443,
  [444] = 444,
  [445] = 430,
  [446] = 430,
  [447] = 431,
  [448] = 443,
  [449] = 431,
  [450] = 450,
  [451] = 430,
  [452] = 430,
  [453] = 274,
  [454] = 432,
  [455] = 431,
  [456] = 431,
  [457] = 443,
  [458] = 433,
  [459] = 431,
  [460] = 433,
  [461] = 443,
  [462] = 431,
  [463] = 432,
  [464] = 432,
  [465] = 433,
  [466] = 443,
  [467] = 450,
  [468] = 444,
  [469] = 443,
  [470] = 430,
  [471] = 431,
  [472] = 433,
  [473] = 432,
  [474] = 433,
  [475] = 431,
  [476] = 433,
  [477] = 432,
  [478] = 430,
  [479] = 443,
  [480] = 480,
  [481] = 431,
  [482] = 433,
  [483] = 433,
  [484] = 433,
  [485] = 433,
  [486] = 432,
  [487] = 433,
  [488] = 432,
  [489] = 432,
  [490] = 432,
  [491] = 443,
  [492] = 430,
  [493] = 432,
  [494] = 494,
  [495] = 433,
  [496] = 431,
  [497] = 433,
  [498] = 433,
  [499] = 499,
  [500] = 431,
  [501] = 430,
  [502] = 443,
  [503] = 494,
  [504] = 433,
  [505] = 433,
  [506] = 431,
  [507] = 443,
  [508] = 443,
  [509] = 432,
  [510] = 430,
  [511] = 511,
  [512] = 430,
  [513] = 450,
  [514] = 431,
  [515] = 515,
  [516] = 276,
  [517] = 443,
  [518] = 443,
  [519] = 430,
  [520] = 443,
  [521] = 430,
  [522] = 431,
  [523] = 431,
  [524] = 432,
  [525] = 443,
  [526] = 526,
  [527] = 432,
  [528] = 430,
  [529] = 430,
  [530] = 530,
  [531] = 431,
  [532] = 443,
  [533] = 494,
  [534] = 276,
  [535] = 431,
  [536] = 443,
  [537] = 443,
  [538] = 432,
  [539] = 432,
  [540] = 443,
  [541] = 430,
  [542] = 430,
  [543] = 432,
  [544] = 274,
  [545] = 430,
  [546] = 443,
  [547] = 433,
  [548] = 548,
  [549] = 548,
  [550] = 548,
  [551] = 548,
  [552] = 276,
  [553] = 548,
  [554] = 276,
  [555] = 548,
  [556] = 548,
  [557] = 548,
  [558] = 274,
  [559] = 548,
  [560] = 548,
  [561] = 274,
  [562] = 548,
  [563] = 548,
  [564] = 276,
  [565] = 548,
  [566] = 548,
  [567] = 548,
  [568] = 568,
  [569] = 548,
  [570] = 548,
  [571] = 548,
  [572] = 548,
  [573] = 274,
  [574] = 548,
  [575] = 575,
  [576] = 548,
  [577] = 548,
  [578] = 578,
  [579] = 548,
  [580] = 548,
  [581] = 276,
  [582] = 548,
  [583] = 548,
  [584] = 548,
  [585] = 548,
  [586] = 548,
  [587] = 548,
  [588] = 575,
  [589] = 548,
  [590] = 548,
  [591] = 274,
  [592] = 548,
  [593] = 276,
  [594] = 274,
  [595] = 276,
  [596] = 274,
  [597] = 597,
  [598] = 597,
  [599] = 599,
  [600] = 597,
  [601] = 597,
  [602] = 597,
  [603] = 599,
  [604] = 597,
  [605] = 597,
  [606] = 597,
  [607] = 597,
  [608] = 599,
  [609] = 599,
  [610] = 597,
  [611] = 597,
  [612] = 597,
  [613] = 597,
  [614] = 597,
  [615] = 597,
  [616] = 597,
  [617] = 599,
  [618] = 599,
  [619] = 599,
  [620] = 597,
  [621] = 599,
  [622] = 597,
  [623] = 597,
  [624] = 276,
  [625] = 625,
  [626] = 625,
  [627] = 599,
  [628] = 599,
  [629] = 597,
  [630] = 597,
  [631] = 597,
  [632] = 599,
  [633] = 599,
  [634] = 597,
  [635] = 597,
  [636] = 599,
  [637] = 597,
  [638] = 597,
  [639] = 599,
  [640] = 599,
  [641] = 599,
  [642] = 599,
  [643] = 599,
  [644] = 597,
  [645] = 599,
  [646] = 597,
  [647] = 274,
  [648] = 597,
  [649] = 597,
  [650] = 597,
  [651] = 597,
  [652] = 599,
  [653] = 597,
  [654] = 274,
  [655] = 276,
  [656] = 656,
  [657] = 657,
  [658] = 657,
  [659] = 657,
  [660] = 657,
  [661] = 657,
  [662] = 662,
  [663] = 663,
  [664] = 663,
  [665] = 665,
  [666] = 666,
  [667] = 662,
  [668] = 663,
  [669] = 665,
  [670] = 665,
  [671] = 671,
  [672] = 672,
  [673] = 662,
  [674] = 674,
  [675] = 674,
  [676] = 676,
  [677] = 676,
  [678] = 676,
  [679] = 676,
  [680] = 676,
  [681] = 676,
  [682] = 676,
  [683] = 676,
  [684] = 676,
  [685] = 676,
  [686] = 676,
  [687] = 676,
  [688] = 676,
  [689] = 676,
  [690] = 676,
  [691] = 676,
  [692] = 676,
  [693] = 676,
  [694] = 676,
  [695] = 676,
  [696] = 676,
  [697] = 676,
  [698] = 676,
  [699] = 676,
  [700] = 676,
  [701] = 676,
  [702] = 676,
  [703] = 676,
  [704] = 676,
  [705] = 676,
  [706] = 676,
  [707] = 676,
  [708] = 676,
  [709] = 676,
  [710] = 676,
  [711] = 676,
  [712] = 676,
  [713] = 676,
  [714] = 676,
  [715] = 676,
  [716] = 676,
  [717] = 676,
  [718] = 676,
  [719] = 676,
  [720] = 676,
  [721] = 676,
  [722] = 676,
  [723] = 676,
  [724] = 676,
  [725] = 676,
  [726] = 676,
  [727] = 676,
  [728] = 676,
  [729] = 676,
  [730] = 676,
  [731] = 676,
  [732] = 676,
  [733] = 676,
  [734] = 676,
  [735] = 676,
  [736] = 676,
  [737] = 676,
  [738] = 676,
  [739] = 676,
  [740] = 676,
  [741] = 676,
  [742] = 676,
  [743] = 676,
  [744] = 676,
  [745] = 676,
  [746] = 676,
  [747] = 676,
  [748] = 676,
  [749] = 676,
  [750] = 676,
  [751] = 676,
  [752] = 676,
  [753] = 676,
  [754] = 676,
  [755] = 676,
  [756] = 676,
  [757] = 676,
  [758] = 676,
  [759] = 676,
  [760] = 676,
  [761] = 676,
  [762] = 762,
  [763] = 762,
  [764] = 762,
  [765] = 762,
  [766] = 762,
  [767] = 762,
  [768] = 762,
  [769] = 762,
  [770] = 770,
  [771] = 762,
  [772] = 762,
  [773] = 762,
  [774] = 762,
  [775] = 762,
  [776] = 762,
  [777] = 762,
  [778] = 762,
  [779] = 762,
  [780] = 762,
  [781] = 762,
  [782] = 762,
  [783] = 762,
  [784] = 784,
  [785] = 762,
  [786] = 762,
  [787] = 762,
  [788] = 762,
  [789] = 770,
  [790] = 790,
  [791] = 762,
  [792] = 762,
  [793] = 762,
  [794] = 770,
  [795] = 795,
  [796] = 762,
  [797] = 762,
  [798] = 762,
  [799] = 762,
  [800] = 762,
  [801] = 762,
  [802] = 762,
  [803] = 762,
  [804] = 762,
  [805] = 795,
  [806] = 784,
  [807] = 762,
  [808] = 808,
  [809] = 808,
  [810] = 808,
  [811] = 808,
  [812] = 808,
  [813] = 808,
  [814] = 808,
  [815] = 808,
  [816] = 808,
  [817] = 808,
  [818] = 808,
  [819] = 808,
  [820] = 808,
  [821] = 808,
  [822] = 808,
  [823] = 808,
  [824] = 808,
  [825] = 825,
  [826] = 826,
  [827] = 825,
  [828] = 826,
  [829] = 829,
  [830] = 829,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 833,
  [835] = 835,
  [836] = 835,
  [837] = 831,
  [838] = 832,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 829,
  [843] = 829,
  [844] = 844,
  [845] = 829,
  [846] = 841,
  [847] = 844,
  [848] = 829,
  [849] = 839,
  [850] = 840,
  [851] = 851,
  [852] = 851,
  [853] = 851,
  [854] = 851,
  [855] = 851,
  [856] = 851,
  [857] = 851,
  [858] = 851,
  [859] = 851,
  [860] = 851,
  [861] = 851,
  [862] = 851,
  [863] = 851,
  [864] = 851,
  [865] = 851,
  [866] = 851,
  [867] = 851,
  [868] = 868,
  [869] = 851,
  [870] = 851,
  [871] = 851,
  [872] = 851,
  [873] = 851,
  [874] = 851,
  [875] = 851,
  [876] = 851,
  [877] = 851,
  [878] = 868,
  [879] = 879,
  [880] = 880,
  [881] = 881,
  [882] = 881,
  [883] = 880,
  [884] = 884,
  [885] = 829,
  [886] = 880,
  [887] = 887,
  [888] = 829,
  [889] = 880,
  [890] = 890,
  [891] = 880,
  [892] = 890,
  [893] = 881,
  [894] = 881,
  [895] = 880,
  [896] = 879,
  [897] = 879,
  [898] = 887,
  [899] = 881,
  [900] = 884,
  [901] = 881,
  [902] = 902,
  [903] = 903,
  [904] = 890,
  [905] = 879,
  [906] = 881,
  [907] = 880,
  [908] = 908,
  [909] = 909,
  [910] = 879,
  [911] = 879,
  [912] = 881,
  [913] = 879,
  [914] = 881,
  [915] = 915,
  [916] = 916,
  [917] = 879,
  [918] = 881,
  [919] = 880,
  [920] = 880,
  [921] = 881,
  [922] = 881,
  [923] = 879,
  [924] = 924,
  [925] = 925,
  [926] = 925,
  [927] = 879,
  [928] = 880,
  [929] = 924,
  [930] = 879,
  [931] = 879,
  [932] = 880,
  [933] = 880,
  [934] = 879,
  [935] = 880,
  [936] = 881,
  [937] = 880,
  [938] = 881,
  [939] = 902,
  [940] = 880,
  [941] = 881,
  [942] = 942,
  [943] = 879,
  [944] = 829,
  [945] = 908,
  [946] = 879,
  [947] = 947,
  [948] = 948,
  [949] = 949,
  [950] = 949,
  [951] = 915,
  [952] = 948,
  [953] = 909,
  [954] = 903,
  [955] = 955,
  [956] = 903,
  [957] = 957,
  [958] = 909,
  [959] = 915,
  [960] = 947,
  [961] = 903,
  [962] = 909,
  [963] = 909,
  [964] = 903,
  [965] = 909,
  [966] = 903,
  [967] = 957,
  [968] = 949,
  [969] = 955,
  [970] = 970,
  [971] = 957,
  [972] = 947,
  [973] = 948,
  [974] = 955,
  [975] = 915,
  [976] = 915,
  [977] = 915,
  [978] = 978,
  [979] = 955,
  [980] = 948,
  [981] = 909,
  [982] = 915,
  [983] = 957,
  [984] = 947,
  [985] = 948,
  [986] = 986,
  [987] = 903,
  [988] = 955,
  [989] = 955,
  [990] = 949,
  [991] = 986,
  [992] = 955,
  [993] = 949,
  [994] = 986,
  [995] = 986,
  [996] = 996,
  [997] = 949,
  [998] = 998,
  [999] = 999,
  [1000] = 999,
  [1001] = 903,
  [1002] = 903,
  [1003] = 986,
  [1004] = 986,
  [1005] = 986,
  [1006] = 909,
  [1007] = 915,
  [1008] = 915,
  [1009] = 998,
  [1010] = 909,
  [1011] = 986,
  [1012] = 949,
  [1013] = 949,
  [1014] = 957,
  [1015] = 986,
  [1016] = 903,
  [1017] = 986,
  [1018] = 986,
  [1019] = 986,
  [1020] = 948,
  [1021] = 947,
  [1022] = 957,
  [1023] = 955,
  [1024] = 948,
  [1025] = 947,
  [1026] = 957,
  [1027] = 915,
  [1028] = 909,
  [1029] = 947,
  [1030] = 957,
  [1031] = 948,
  [1032] = 947,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1033,
  [1038] = 948,
  [1039] = 1036,
  [1040] = 1036,
  [1041] = 1035,
  [1042] = 1034,
  [1043] = 1036,
  [1044] = 1035,
  [1045] = 1033,
  [1046] = 1034,
  [1047] = 1047,
  [1048] = 1034,
  [1049] = 1034,
  [1050] = 1034,
  [1051] = 949,
  [1052] = 1036,
  [1053] = 1036,
  [1054] = 1033,
  [1055] = 1035,
  [1056] = 1034,
  [1057] = 1035,
  [1058] = 1034,
  [1059] = 1036,
  [1060] = 1036,
  [1061] = 1033,
  [1062] = 1033,
  [1063] = 1036,
  [1064] = 1033,
  [1065] = 1035,
  [1066] = 1034,
  [1067] = 1034,
  [1068] = 1036,
  [1069] = 1035,
  [1070] = 1034,
  [1071] = 1036,
  [1072] = 1036,
  [1073] = 1033,
  [1074] = 1033,
  [1075] = 1035,
  [1076] = 1034,
  [1077] = 1036,
  [1078] = 1036,
  [1079] = 1036,
  [1080] = 1034,
  [1081] = 1036,
  [1082] = 957,
  [1083] = 1036,
  [1084] = 1033,
  [1085] = 1036,
  [1086] = 1034,
  [1087] = 1034,
  [1088] = 1035,
  [1089] = 1035,
  [1090] = 1034,
  [1091] = 1036,
  [1092] = 1033,
  [1093] = 1035,
  [1094] = 1036,
  [1095] = 1034,
  [1096] = 1035,
  [1097] = 1033,
  [1098] = 1034,
  [1099] = 1036,
  [1100] = 1034,
  [1101] = 1035,
  [1102] = 1036,
  [1103] = 1036,
  [1104] = 1036,
  [1105] = 1036,
  [1106] = 1036,
  [1107] = 1034,
  [1108] = 1036,
  [1109] = 1034,
  [1110] = 909,
  [1111] = 947,
  [1112] = 1036,
  [1113] = 1034,
  [1114] = 1035,
  [1115] = 915,
  [1116] = 1036,
  [1117] = 957,
  [1118] = 948,
  [1119] = 1036,
  [1120] = 1033,
  [1121] = 1035,
  [1122] = 1033,
  [1123] = 1036,
  [1124] = 1033,
  [1125] = 1033,
  [1126] = 1126,
  [1127] = 1036,
  [1128] = 1035,
  [1129] = 1035,
  [1130] = 1034,
  [1131] = 1034,
  [1132] = 1036,
  [1133] = 1036,
  [1134] = 1034,
  [1135] = 1135,
  [1136] = 1036,
  [1137] = 1035,
  [1138] = 1036,
  [1139] = 1035,
  [1140] = 1036,
  [1141] = 949,
  [1142] = 1034,
  [1143] = 1033,
  [1144] = 1036,
  [1145] = 915,
  [1146] = 1033,
  [1147] = 909,
  [1148] = 1035,
  [1149] = 1036,
  [1150] = 1033,
  [1151] = 1036,
  [1152] = 1033,
  [1153] = 1036,
  [1154] = 1034,
  [1155] = 1035,
  [1156] = 1034,
  [1157] = 1034,
  [1158] = 1034,
  [1159] = 1135,
  [1160] = 1036,
  [1161] = 1034,
  [1162] = 1034,
  [1163] = 1035,
  [1164] = 1035,
  [1165] = 1035,
  [1166] = 1033,
  [1167] = 1033,
  [1168] = 1035,
  [1169] = 1036,
  [1170] = 1033,
  [1171] = 949,
  [1172] = 1036,
  [1173] = 1035,
  [1174] = 1033,
  [1175] = 1034,
  [1176] = 1035,
  [1177] = 1036,
  [1178] = 1034,
  [1179] = 1035,
  [1180] = 1036,
  [1181] = 1036,
  [1182] = 1034,
  [1183] = 1035,
  [1184] = 1036,
  [1185] = 1036,
  [1186] = 1033,
  [1187] = 1036,
  [1188] = 1036,
  [1189] = 1033,
  [1190] = 1036,
  [1191] = 1033,
  [1192] = 1033,
  [1193] = 1033,
  [1194] = 955,
  [1195] = 1035,
  [1196] = 1036,
  [1197] = 1126,
  [1198] = 955,
  [1199] = 1033,
  [1200] = 947,
  [1201] = 1034,
  [1202] = 1034,
  [1203] = 955,
  [1204] = 1034,
  [1205] = 1036,
  [1206] = 1034,
  [1207] = 1036,
  [1208] = 1036,
  [1209] = 1036,
  [1210] = 1034,
  [1211] = 1034,
  [1212] = 1034,
  [1213] = 1036,
  [1214] = 1034,
  [1215] = 1033,
  [1216] = 1036,
  [1217] = 1034,
  [1218] = 1033,
  [1219] = 1035,
  [1220] = 1036,
  [1221] = 1035,
  [1222] = 1036,
  [1223] = 1033,
  [1224] = 1036,
  [1225] = 947,
  [1226] = 1036,
  [1227] = 957,
  [1228] = 948,
  [1229] = 1036,
  [1230] = 947,
  [1231] = 1034,
  [1232] = 1036,
  [1233] = 1035,
  [1234] = 1033,
  [1235] = 1036,
  [1236] = 1035,
  [1237] = 1033,
  [1238] = 1034,
  [1239] = 1036,
  [1240] = 1036,
  [1241] = 1036,
  [1242] = 1242,
  [1243] = 903,
  [1244] = 1036,
  [1245] = 1033,
  [1246] = 1036,
  [1247] = 1036,
  [1248] = 1036,
  [1249] = 1036,
  [1250] = 903,
  [1251] = 949,
  [1252] = 957,
  [1253] = 1036,
  [1254] = 1036,
  [1255] = 1036,
  [1256] = 1034,
  [1257] = 1033,
  [1258] = 948,
  [1259] = 1035,
  [1260] = 955,
  [1261] = 1034,
  [1262] = 1036,
  [1263] = 1036,
  [1264] = 1033,
  [1265] = 1035,
  [1266] = 1036,
  [1267] = 1036,
  [1268] = 1035,
  [1269] = 1036,
  [1270] = 1035,
  [1271] = 1036,
  [1272] = 1272,
  [1273] = 1272,
  [1274] = 1274,
  [1275] = 1272,
  [1276] = 1272,
  [1277] = 957,
  [1278] = 1272,
  [1279] = 1272,
  [1280] = 1274,
  [1281] = 949,
  [1282] = 1272,
  [1283] = 1272,
  [1284] = 1274,
  [1285] = 947,
  [1286] = 948,
  [1287] = 955,
  [1288] = 1272,
  [1289] = 949,
  [1290] = 1272,
  [1291] = 1272,
  [1292] = 1274,
  [1293] = 1272,
  [1294] = 1272,
  [1295] = 1272,
  [1296] = 947,
  [1297] = 949,
  [1298] = 1274,
  [1299] = 1272,
  [1300] = 1274,
  [1301] = 1272,
  [1302] = 1272,
  [1303] = 948,
  [1304] = 1274,
  [1305] = 1272,
  [1306] = 1272,
  [1307] = 1274,
  [1308] = 1272,
  [1309] = 1272,
  [1310] = 947,
  [1311] = 947,
  [1312] = 948,
  [1313] = 1274,
  [1314] = 1272,
  [1315] = 1272,
  [1316] = 1274,
  [1317] = 1272,
  [1318] = 957,
  [1319] = 1274,
  [1320] = 1272,
  [1321] = 957,
  [1322] = 957,
  [1323] = 1274,
  [1324] = 955,
  [1325] = 1274,
  [1326] = 948,
  [1327] = 1274,
  [1328] = 1272,
  [1329] = 1272,
  [1330] = 1272,
  [1331] = 1272,
  [1332] = 1272,
  [1333] = 1272,
  [1334] = 1272,
  [1335] = 1272,
  [1336] = 1272,
  [1337] = 955,
  [1338] = 1272,
  [1339] = 1272,
  [1340] = 1274,
  [1341] = 1272,
  [1342] = 1272,
  [1343] = 949,
  [1344] = 1272,
  [1345] = 1272,
  [1346] = 957,
  [1347] = 947,
  [1348] = 1274,
  [1349] = 948,
  [1350] = 1274,
  [1351] = 1272,
  [1352] = 1272,
  [1353] = 1272,
  [1354] = 955,
  [1355] = 1274,
  [1356] = 1272,
  [1357] = 949,
  [1358] = 955,
  [1359] = 1274,
  [1360] = 957,
  [1361] = 1274,
  [1362] = 947,
  [1363] = 1272,
  [1364] = 1272,
  [1365] = 948,
  [1366] = 949,
  [1367] = 955,
  [1368] = 1272,
  [1369] = 1272,
  [1370] = 947,
  [1371] = 949,
  [1372] = 957,
  [1373] = 949,
  [1374] = 957,
  [1375] = 957,
  [1376] = 903,
  [1377] = 948,
  [1378] = 955,
  [1379] = 955,
  [1380] = 947,
  [1381] = 948,
  [1382] = 949,
  [1383] = 957,
  [1384] = 957,
  [1385] = 949,
  [1386] = 957,
  [1387] = 1387,
  [1388] = 947,
  [1389] = 955,
  [1390] = 948,
  [1391] = 1391,
  [1392] = 955,
  [1393] = 949,
  [1394] = 948,
  [1395] = 949,
  [1396] = 948,
  [1397] = 955,
  [1398] = 948,
  [1399] = 947,
  [1400] = 947,
  [1401] = 1401,
  [1402] = 949,
  [1403] = 955,
  [1404] = 948,
  [1405] = 947,
  [1406] = 957,
  [1407] = 955,
  [1408] = 947,
  [1409] = 955,
  [1410] = 949,
  [1411] = 957,
  [1412] = 957,
  [1413] = 955,
  [1414] = 955,
  [1415] = 947,
  [1416] = 948,
  [1417] = 955,
  [1418] = 948,
  [1419] = 955,
  [1420] = 957,
  [1421] = 955,
  [1422] = 949,
  [1423] = 949,
  [1424] = 948,
  [1425] = 948,
  [1426] = 949,
  [1427] = 947,
  [1428] = 957,
  [1429] = 957,
  [1430] = 948,
  [1431] = 949,
  [1432] = 947,
  [1433] = 947,
  [1434] = 949,
  [1435] = 948,
  [1436] = 947,
  [1437] = 947,
  [1438] = 957,
  [1439] = 948,
  [1440] = 949,
  [1441] = 955,
  [1442] = 949,
  [1443] = 947,
  [1444] = 957,
  [1445] = 957,
  [1446] = 955,
  [1447] = 947,
  [1448] = 948,
  [1449] = 955,
  [1450] = 957,
  [1451] = 955,
  [1452] = 948,
  [1453] = 948,
  [1454] = 947,
  [1455] = 1455,
  [1456] = 947,
  [1457] = 949,
  [1458] = 1455,
  [1459] = 949,
  [1460] = 1455,
  [1461] = 1455,
  [1462] = 1455,
  [1463] = 948,
  [1464] = 1464,
  [1465] = 949,
  [1466] = 1455,
  [1467] = 1467,
  [1468] = 1455,
  [1469] = 1455,
  [1470] = 1455,
  [1471] = 957,
  [1472] = 948,
  [1473] = 1455,
  [1474] = 1455,
  [1475] = 955,
  [1476] = 947,
  [1477] = 1455,
  [1478] = 1455,
  [1479] = 1467,
  [1480] = 955,
  [1481] = 955,
  [1482] = 947,
  [1483] = 1455,
  [1484] = 1455,
  [1485] = 1455,
  [1486] = 947,
  [1487] = 1455,
  [1488] = 949,
  [1489] = 957,
  [1490] = 957,
  [1491] = 949,
  [1492] = 1492,
  [1493] = 1455,
  [1494] = 957,
  [1495] = 1455,
  [1496] = 948,
  [1497] = 1455,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 947,
  [1501] = 948,
  [1502] = 1502,
  [1503] = 948,
  [1504] = 947,
  [1505] = 1498,
  [1506] = 1506,
  [1507] = 1498,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 955,
  [1513] = 1498,
  [1514] = 1514,
  [1515] = 1498,
  [1516] = 1498,
  [1517] = 1517,
  [1518] = 1498,
  [1519] = 1517,
  [1520] = 1520,
  [1521] = 957,
  [1522] = 949,
  [1523] = 1498,
  [1524] = 955,
  [1525] = 948,
  [1526] = 1526,
  [1527] = 949,
  [1528] = 1528,
  [1529] = 1498,
  [1530] = 947,
  [1531] = 955,
  [1532] = 1528,
  [1533] = 1533,
  [1534] = 1498,
  [1535] = 1535,
  [1536] = 1498,
  [1537] = 1498,
  [1538] = 1526,
  [1539] = 1539,
  [1540] = 957,
  [1541] = 957,
  [1542] = 1542,
  [1543] = 1498,
  [1544] = 1498,
  [1545] = 1509,
  [1546] = 1502,
  [1547] = 1547,
  [1548] = 1499,
  [1549] = 1498,
  [1550] = 1498,
  [1551] = 949,
  [1552] = 1552,
  [1553] = 1498,
  [1554] = 948,
  [1555] = 949,
  [1556] = 1520,
  [1557] = 1498,
  [1558] = 1499,
  [1559] = 1559,
  [1560] = 1498,
  [1561] = 1561,
  [1562] = 1498,
  [1563] = 1499,
  [1564] = 1498,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1567,
  [1568] = 1508,
  [1569] = 949,
  [1570] = 1499,
  [1571] = 1542,
  [1572] = 1499,
  [1573] = 1499,
  [1574] = 1498,
  [1575] = 1552,
  [1576] = 1533,
  [1577] = 1499,
  [1578] = 1547,
  [1579] = 1535,
  [1580] = 1498,
  [1581] = 1581,
  [1582] = 1499,
  [1583] = 955,
  [1584] = 1559,
  [1585] = 949,
  [1586] = 1561,
  [1587] = 1581,
  [1588] = 1520,
  [1589] = 1499,
  [1590] = 1539,
  [1591] = 1510,
  [1592] = 1566,
  [1593] = 1498,
  [1594] = 1506,
  [1595] = 1502,
  [1596] = 1509,
  [1597] = 1514,
  [1598] = 1542,
  [1599] = 1499,
  [1600] = 1565,
  [1601] = 1567,
  [1602] = 957,
  [1603] = 1528,
  [1604] = 1526,
  [1605] = 947,
  [1606] = 1511,
  [1607] = 1498,
  [1608] = 1499,
  [1609] = 1498,
  [1610] = 949,
  [1611] = 949,
  [1612] = 1520,
  [1613] = 957,
  [1614] = 1502,
  [1615] = 1615,
  [1616] = 1509,
  [1617] = 1617,
  [1618] = 1542,
  [1619] = 1619,
  [1620] = 947,
  [1621] = 1621,
  [1622] = 1622,
  [1623] = 948,
  [1624] = 1624,
  [1625] = 1528,
  [1626] = 1526,
  [1627] = 1624,
  [1628] = 957,
  [1629] = 949,
  [1630] = 955,
  [1631] = 1631,
  [1632] = 1622,
  [1633] = 1633,
  [1634] = 1621,
  [1635] = 955,
  [1636] = 1617,
  [1637] = 1615,
  [1638] = 1514,
  [1639] = 1639,
  [1640] = 1467,
  [1641] = 947,
  [1642] = 1642,
  [1643] = 948,
  [1644] = 1644,
  [1645] = 1619,
  [1646] = 1646,
  [1647] = 1633,
  [1648] = 1631,
  [1649] = 1639,
  [1650] = 1514,
  [1651] = 1651,
  [1652] = 957,
  [1653] = 1653,
  [1654] = 1654,
  [1655] = 1631,
  [1656] = 1656,
  [1657] = 1657,
  [1658] = 1658,
  [1659] = 1633,
  [1660] = 947,
  [1661] = 948,
  [1662] = 957,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 947,
  [1666] = 1514,
  [1667] = 948,
  [1668] = 1633,
  [1669] = 1492,
  [1670] = 1631,
  [1671] = 957,
  [1672] = 1651,
  [1673] = 947,
  [1674] = 948,
  [1675] = 1656,
  [1676] = 1658,
  [1677] = 1663,
  [1678] = 955,
  [1679] = 1492,
  [1680] = 1520,
  [1681] = 1664,
  [1682] = 1502,
  [1683] = 1509,
  [1684] = 1542,
  [1685] = 1646,
  [1686] = 1528,
  [1687] = 957,
  [1688] = 1526,
  [1689] = 1467,
  [1690] = 1646,
  [1691] = 947,
  [1692] = 948,
  [1693] = 1520,
  [1694] = 955,
  [1695] = 949,
  [1696] = 1502,
  [1697] = 1509,
  [1698] = 1492,
  [1699] = 1542,
  [1700] = 1528,
  [1701] = 1664,
  [1702] = 1526,
  [1703] = 949,
  [1704] = 1633,
  [1705] = 1619,
  [1706] = 1631,
  [1707] = 949,
  [1708] = 1644,
  [1709] = 1657,
  [1710] = 1654,
  [1711] = 1653,
  [1712] = 1615,
  [1713] = 1642,
  [1714] = 1639,
  [1715] = 955,
  [1716] = 1492,
  [1717] = 1622,
  [1718] = 1624,
  [1719] = 1621,
  [1720] = 955,
  [1721] = 1664,
  [1722] = 1502,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1617,
  [1726] = 1726,
  [1727] = 1467,
  [1728] = 1646,
  [1729] = 1514,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1735,
  [1736] = 1730,
  [1737] = 1646,
  [1738] = 1633,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1631,
  [1744] = 1744,
  [1745] = 1520,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1633,
  [1751] = 1639,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1744,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1502,
  [1762] = 1509,
  [1763] = 1763,
  [1764] = 1542,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1631,
  [1768] = 1768,
  [1769] = 1492,
  [1770] = 1528,
  [1771] = 1526,
  [1772] = 1772,
  [1773] = 1639,
  [1774] = 1774,
  [1775] = 1514,
  [1776] = 1520,
  [1777] = 1777,
  [1778] = 1642,
  [1779] = 1730,
  [1780] = 1502,
  [1781] = 1509,
  [1782] = 1542,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1528,
  [1786] = 1786,
  [1787] = 1526,
  [1788] = 1757,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1639,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1514,
  [1795] = 1664,
  [1796] = 1664,
  [1797] = 1739,
  [1798] = 1615,
  [1799] = 1624,
  [1800] = 1520,
  [1801] = 1801,
  [1802] = 1622,
  [1803] = 1621,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1617,
  [1808] = 1520,
  [1809] = 1615,
  [1810] = 1514,
  [1811] = 1804,
  [1812] = 1646,
  [1813] = 1784,
  [1814] = 1783,
  [1815] = 1806,
  [1816] = 1642,
  [1817] = 1633,
  [1818] = 1502,
  [1819] = 1651,
  [1820] = 1653,
  [1821] = 1654,
  [1822] = 1631,
  [1823] = 1765,
  [1824] = 1509,
  [1825] = 1805,
  [1826] = 1826,
  [1827] = 1656,
  [1828] = 1657,
  [1829] = 1658,
  [1830] = 1723,
  [1831] = 1663,
  [1832] = 1542,
  [1833] = 1753,
  [1834] = 1730,
  [1835] = 1528,
  [1836] = 1836,
  [1837] = 1526,
  [1838] = 1624,
  [1839] = 1752,
  [1840] = 1724,
  [1841] = 1509,
  [1842] = 1622,
  [1843] = 1836,
  [1844] = 1621,
  [1845] = 1619,
  [1846] = 1615,
  [1847] = 1749,
  [1848] = 1772,
  [1849] = 1542,
  [1850] = 1801,
  [1851] = 1826,
  [1852] = 1756,
  [1853] = 1735,
  [1854] = 1651,
  [1855] = 1492,
  [1856] = 1740,
  [1857] = 1656,
  [1858] = 1658,
  [1859] = 1663,
  [1860] = 1792,
  [1861] = 1741,
  [1862] = 1492,
  [1863] = 1789,
  [1864] = 1792,
  [1865] = 1514,
  [1866] = 1793,
  [1867] = 1619,
  [1868] = 1768,
  [1869] = 1653,
  [1870] = 1766,
  [1871] = 1758,
  [1872] = 1742,
  [1873] = 1528,
  [1874] = 1654,
  [1875] = 1793,
  [1876] = 1763,
  [1877] = 1746,
  [1878] = 1747,
  [1879] = 1789,
  [1880] = 1526,
  [1881] = 1763,
  [1882] = 1786,
  [1883] = 1756,
  [1884] = 1748,
  [1885] = 1758,
  [1886] = 1742,
  [1887] = 1734,
  [1888] = 1741,
  [1889] = 1755,
  [1890] = 1740,
  [1891] = 1657,
  [1892] = 1735,
  [1893] = 1756,
  [1894] = 1805,
  [1895] = 1789,
  [1896] = 1806,
  [1897] = 1766,
  [1898] = 1792,
  [1899] = 1734,
  [1900] = 1723,
  [1901] = 1757,
  [1902] = 1786,
  [1903] = 1804,
  [1904] = 1784,
  [1905] = 1774,
  [1906] = 1772,
  [1907] = 1765,
  [1908] = 1777,
  [1909] = 1748,
  [1910] = 1768,
  [1911] = 1783,
  [1912] = 1755,
  [1913] = 1759,
  [1914] = 1730,
  [1915] = 1744,
  [1916] = 1726,
  [1917] = 1792,
  [1918] = 1753,
  [1919] = 1731,
  [1920] = 1732,
  [1921] = 1752,
  [1922] = 1739,
  [1923] = 1789,
  [1924] = 1724,
  [1925] = 1619,
  [1926] = 1756,
  [1927] = 1733,
  [1928] = 1836,
  [1929] = 1790,
  [1930] = 1749,
  [1931] = 1760,
  [1932] = 1777,
  [1933] = 1657,
  [1934] = 1760,
  [1935] = 1733,
  [1936] = 1654,
  [1937] = 1732,
  [1938] = 1731,
  [1939] = 1726,
  [1940] = 1790,
  [1941] = 1801,
  [1942] = 1759,
  [1943] = 1624,
  [1944] = 1826,
  [1945] = 1653,
  [1946] = 1622,
  [1947] = 1621,
  [1948] = 1642,
  [1949] = 1617,
  [1950] = 1742,
  [1951] = 1792,
  [1952] = 1730,
  [1953] = 1639,
  [1954] = 1619,
  [1955] = 1955,
  [1956] = 1741,
  [1957] = 1740,
  [1958] = 1633,
  [1959] = 1735,
  [1960] = 1955,
  [1961] = 1631,
  [1962] = 1730,
  [1963] = 1492,
  [1964] = 1723,
  [1965] = 1633,
  [1966] = 1631,
  [1967] = 1526,
  [1968] = 1528,
  [1969] = 1757,
  [1970] = 1631,
  [1971] = 1633,
  [1972] = 1772,
  [1973] = 1765,
  [1974] = 1759,
  [1975] = 1826,
  [1976] = 1801,
  [1977] = 1749,
  [1978] = 1836,
  [1979] = 1724,
  [1980] = 1542,
  [1981] = 1509,
  [1982] = 1502,
  [1983] = 1726,
  [1984] = 1734,
  [1985] = 1731,
  [1986] = 1732,
  [1987] = 1658,
  [1988] = 1739,
  [1989] = 1752,
  [1990] = 1753,
  [1991] = 1744,
  [1992] = 1733,
  [1993] = 1639,
  [1994] = 1955,
  [1995] = 1520,
  [1996] = 1663,
  [1997] = 1783,
  [1998] = 1784,
  [1999] = 1758,
  [2000] = 1657,
  [2001] = 1748,
  [2002] = 1804,
  [2003] = 1806,
  [2004] = 1805,
  [2005] = 1793,
  [2006] = 1734,
  [2007] = 1748,
  [2008] = 1793,
  [2009] = 1492,
  [2010] = 1656,
  [2011] = 1955,
  [2012] = 1826,
  [2013] = 1955,
  [2014] = 1760,
  [2015] = 1801,
  [2016] = 1749,
  [2017] = 1836,
  [2018] = 1724,
  [2019] = 1730,
  [2020] = 1955,
  [2021] = 1739,
  [2022] = 1752,
  [2023] = 1753,
  [2024] = 1763,
  [2025] = 1654,
  [2026] = 1744,
  [2027] = 1955,
  [2028] = 1653,
  [2029] = 1955,
  [2030] = 1783,
  [2031] = 1644,
  [2032] = 1790,
  [2033] = 1766,
  [2034] = 1784,
  [2035] = 1804,
  [2036] = 1793,
  [2037] = 1768,
  [2038] = 1786,
  [2039] = 1651,
  [2040] = 1955,
  [2041] = 1955,
  [2042] = 1806,
  [2043] = 1805,
  [2044] = 1804,
  [2045] = 1664,
  [2046] = 1826,
  [2047] = 1801,
  [2048] = 1749,
  [2049] = 1955,
  [2050] = 1836,
  [2051] = 1724,
  [2052] = 1739,
  [2053] = 1752,
  [2054] = 1753,
  [2055] = 1744,
  [2056] = 1783,
  [2057] = 1784,
  [2058] = 1806,
  [2059] = 1805,
  [2060] = 1792,
  [2061] = 1789,
  [2062] = 1642,
  [2063] = 1756,
  [2064] = 1663,
  [2065] = 1664,
  [2066] = 1658,
  [2067] = 1657,
  [2068] = 1656,
  [2069] = 1514,
  [2070] = 1955,
  [2071] = 1654,
  [2072] = 1653,
  [2073] = 1651,
  [2074] = 1514,
  [2075] = 1642,
  [2076] = 1734,
  [2077] = 1955,
  [2078] = 1615,
  [2079] = 1528,
  [2080] = 1663,
  [2081] = 1492,
  [2082] = 1658,
  [2083] = 1656,
  [2084] = 1617,
  [2085] = 1621,
  [2086] = 1622,
  [2087] = 1651,
  [2088] = 1492,
  [2089] = 1624,
  [2090] = 1792,
  [2091] = 1786,
  [2092] = 1789,
  [2093] = 1755,
  [2094] = 1615,
  [2095] = 1748,
  [2096] = 1617,
  [2097] = 1756,
  [2098] = 1514,
  [2099] = 1542,
  [2100] = 1526,
  [2101] = 1646,
  [2102] = 1755,
  [2103] = 1955,
  [2104] = 1633,
  [2105] = 1502,
  [2106] = 1768,
  [2107] = 1631,
  [2108] = 1955,
  [2109] = 1615,
  [2110] = 1621,
  [2111] = 1622,
  [2112] = 1624,
  [2113] = 1664,
  [2114] = 1955,
  [2115] = 1492,
  [2116] = 1639,
  [2117] = 1621,
  [2118] = 1664,
  [2119] = 1646,
  [2120] = 1633,
  [2121] = 1766,
  [2122] = 1955,
  [2123] = 1657,
  [2124] = 1742,
  [2125] = 1955,
  [2126] = 1763,
  [2127] = 1654,
  [2128] = 1955,
  [2129] = 1758,
  [2130] = 1955,
  [2131] = 1955,
  [2132] = 1619,
  [2133] = 1653,
  [2134] = 1631,
  [2135] = 1646,
  [2136] = 1741,
  [2137] = 1740,
  [2138] = 1622,
  [2139] = 1509,
  [2140] = 1955,
  [2141] = 1786,
  [2142] = 1735,
  [2143] = 1639,
  [2144] = 1955,
  [2145] = 1723,
  [2146] = 1955,
  [2147] = 1955,
  [2148] = 1955,
  [2149] = 1955,
  [2150] = 1757,
  [2151] = 1642,
  [2152] = 1520,
  [2153] = 1755,
  [2154] = 1955,
  [2155] = 1619,
  [2156] = 1772,
  [2157] = 1514,
  [2158] = 1657,
  [2159] = 1765,
  [2160] = 1955,
  [2161] = 1759,
  [2162] = 1955,
  [2163] = 1654,
  [2164] = 1955,
  [2165] = 1790,
  [2166] = 1955,
  [2167] = 1955,
  [2168] = 1955,
  [2169] = 1955,
  [2170] = 1617,
  [2171] = 1955,
  [2172] = 1726,
  [2173] = 1731,
  [2174] = 1732,
  [2175] = 1955,
  [2176] = 1955,
  [2177] = 1514,
  [2178] = 1955,
  [2179] = 1642,
  [2180] = 1733,
  [2181] = 1955,
  [2182] = 1615,
  [2183] = 1760,
  [2184] = 1955,
  [2185] = 1617,
  [2186] = 1621,
  [2187] = 1955,
  [2188] = 1624,
  [2189] = 1467,
  [2190] = 1644,
  [2191] = 1733,
  [2192] = 1619,
  [2193] = 1732,
  [2194] = 1731,
  [2195] = 1726,
  [2196] = 1622,
  [2197] = 1653,
  [2198] = 1955,
  [2199] = 1646,
  [2200] = 1955,
  [2201] = 1759,
  [2202] = 1772,
  [2203] = 1765,
  [2204] = 1790,
  [2205] = 1624,
  [2206] = 1757,
  [2207] = 1955,
  [2208] = 1955,
  [2209] = 1768,
  [2210] = 1766,
  [2211] = 1742,
  [2212] = 1763,
  [2213] = 1955,
  [2214] = 1760,
  [2215] = 1756,
  [2216] = 1789,
  [2217] = 1758,
  [2218] = 1741,
  [2219] = 1955,
  [2220] = 1740,
  [2221] = 1735,
  [2222] = 1723,
  [2223] = 2223,
  [2224] = 1651,
  [2225] = 2223,
  [2226] = 1658,
  [2227] = 1752,
  [2228] = 1739,
  [2229] = 2223,
  [2230] = 1654,
  [2231] = 1520,
  [2232] = 2223,
  [2233] = 1514,
  [2234] = 1760,
  [2235] = 1653,
  [2236] = 1657,
  [2237] = 1651,
  [2238] = 2223,
  [2239] = 1755,
  [2240] = 1783,
  [2241] = 1502,
  [2242] = 1784,
  [2243] = 1656,
  [2244] = 1509,
  [2245] = 1744,
  [2246] = 2223,
  [2247] = 1542,
  [2248] = 1753,
  [2249] = 1790,
  [2250] = 1526,
  [2251] = 1528,
  [2252] = 1786,
  [2253] = 1733,
  [2254] = 2223,
  [2255] = 1663,
  [2256] = 1528,
  [2257] = 1526,
  [2258] = 1642,
  [2259] = 1664,
  [2260] = 2223,
  [2261] = 1619,
  [2262] = 1792,
  [2263] = 1542,
  [2264] = 1509,
  [2265] = 1746,
  [2266] = 1747,
  [2267] = 1502,
  [2268] = 1789,
  [2269] = 1752,
  [2270] = 1492,
  [2271] = 1804,
  [2272] = 1739,
  [2273] = 1806,
  [2274] = 2223,
  [2275] = 1724,
  [2276] = 1836,
  [2277] = 1733,
  [2278] = 1749,
  [2279] = 1805,
  [2280] = 1756,
  [2281] = 1826,
  [2282] = 1756,
  [2283] = 1792,
  [2284] = 1789,
  [2285] = 1615,
  [2286] = 1801,
  [2287] = 1756,
  [2288] = 1492,
  [2289] = 1826,
  [2290] = 1801,
  [2291] = 1789,
  [2292] = 1774,
  [2293] = 1749,
  [2294] = 1792,
  [2295] = 1777,
  [2296] = 2223,
  [2297] = 1520,
  [2298] = 1732,
  [2299] = 1731,
  [2300] = 1726,
  [2301] = 2223,
  [2302] = 1724,
  [2303] = 1836,
  [2304] = 1749,
  [2305] = 1617,
  [2306] = 1836,
  [2307] = 2223,
  [2308] = 1730,
  [2309] = 1730,
  [2310] = 2223,
  [2311] = 1757,
  [2312] = 2223,
  [2313] = 1766,
  [2314] = 1621,
  [2315] = 1734,
  [2316] = 1759,
  [2317] = 1755,
  [2318] = 2223,
  [2319] = 1724,
  [2320] = 1826,
  [2321] = 1801,
  [2322] = 1765,
  [2323] = 1772,
  [2324] = 1624,
  [2325] = 1748,
  [2326] = 2223,
  [2327] = 1757,
  [2328] = 1801,
  [2329] = 1739,
  [2330] = 1622,
  [2331] = 1760,
  [2332] = 1749,
  [2333] = 1836,
  [2334] = 1826,
  [2335] = 1723,
  [2336] = 1752,
  [2337] = 1735,
  [2338] = 1621,
  [2339] = 1724,
  [2340] = 1753,
  [2341] = 1740,
  [2342] = 1753,
  [2343] = 1617,
  [2344] = 1622,
  [2345] = 1741,
  [2346] = 1805,
  [2347] = 1615,
  [2348] = 1786,
  [2349] = 1758,
  [2350] = 1642,
  [2351] = 1763,
  [2352] = 1734,
  [2353] = 1742,
  [2354] = 1520,
  [2355] = 1739,
  [2356] = 1752,
  [2357] = 1753,
  [2358] = 1653,
  [2359] = 1744,
  [2360] = 1777,
  [2361] = 1639,
  [2362] = 1744,
  [2363] = 1654,
  [2364] = 1766,
  [2365] = 1768,
  [2366] = 1656,
  [2367] = 1657,
  [2368] = 1624,
  [2369] = 1658,
  [2370] = 1663,
  [2371] = 2223,
  [2372] = 1742,
  [2373] = 1631,
  [2374] = 1783,
  [2375] = 1784,
  [2376] = 1633,
  [2377] = 1763,
  [2378] = 1631,
  [2379] = 1744,
  [2380] = 2223,
  [2381] = 1768,
  [2382] = 1755,
  [2383] = 2223,
  [2384] = 1502,
  [2385] = 1758,
  [2386] = 1631,
  [2387] = 1639,
  [2388] = 2223,
  [2389] = 1633,
  [2390] = 2223,
  [2391] = 1509,
  [2392] = 1783,
  [2393] = 2223,
  [2394] = 1793,
  [2395] = 1790,
  [2396] = 1774,
  [2397] = 1542,
  [2398] = 1741,
  [2399] = 1804,
  [2400] = 1748,
  [2401] = 1793,
  [2402] = 1784,
  [2403] = 1664,
  [2404] = 1806,
  [2405] = 1805,
  [2406] = 1756,
  [2407] = 1786,
  [2408] = 1789,
  [2409] = 1783,
  [2410] = 1735,
  [2411] = 2223,
  [2412] = 1792,
  [2413] = 2223,
  [2414] = 1734,
  [2415] = 2223,
  [2416] = 1520,
  [2417] = 1502,
  [2418] = 1804,
  [2419] = 1760,
  [2420] = 1748,
  [2421] = 2223,
  [2422] = 1755,
  [2423] = 1633,
  [2424] = 1806,
  [2425] = 1734,
  [2426] = 2223,
  [2427] = 1509,
  [2428] = 1723,
  [2429] = 1740,
  [2430] = 2430,
  [2431] = 1514,
  [2432] = 1747,
  [2433] = 2223,
  [2434] = 1746,
  [2435] = 1732,
  [2436] = 1619,
  [2437] = 2223,
  [2438] = 1731,
  [2439] = 1733,
  [2440] = 2223,
  [2441] = 1730,
  [2442] = 1732,
  [2443] = 1731,
  [2444] = 1726,
  [2445] = 1617,
  [2446] = 1768,
  [2447] = 1528,
  [2448] = 1766,
  [2449] = 1542,
  [2450] = 1742,
  [2451] = 1804,
  [2452] = 1759,
  [2453] = 1526,
  [2454] = 1763,
  [2455] = 1528,
  [2456] = 1765,
  [2457] = 1772,
  [2458] = 1642,
  [2459] = 1757,
  [2460] = 1758,
  [2461] = 1526,
  [2462] = 1723,
  [2463] = 1735,
  [2464] = 2223,
  [2465] = 1740,
  [2466] = 1741,
  [2467] = 1651,
  [2468] = 1653,
  [2469] = 1758,
  [2470] = 1654,
  [2471] = 1741,
  [2472] = 1492,
  [2473] = 1756,
  [2474] = 1763,
  [2475] = 1656,
  [2476] = 1742,
  [2477] = 1657,
  [2478] = 1766,
  [2479] = 2223,
  [2480] = 1658,
  [2481] = 1768,
  [2482] = 1740,
  [2483] = 1663,
  [2484] = 1735,
  [2485] = 1789,
  [2486] = 1723,
  [2487] = 1757,
  [2488] = 1772,
  [2489] = 1792,
  [2490] = 1765,
  [2491] = 1644,
  [2492] = 1759,
  [2493] = 1646,
  [2494] = 1793,
  [2495] = 1726,
  [2496] = 2223,
  [2497] = 1514,
  [2498] = 1731,
  [2499] = 1732,
  [2500] = 1730,
  [2501] = 1733,
  [2502] = 1646,
  [2503] = 1772,
  [2504] = 1765,
  [2505] = 1790,
  [2506] = 1786,
  [2507] = 2430,
  [2508] = 1759,
  [2509] = 1730,
  [2510] = 1784,
  [2511] = 1805,
  [2512] = 1760,
  [2513] = 1806,
  [2514] = 1793,
  [2515] = 1726,
  [2516] = 1790,
  [2517] = 1748,
  [2518] = 1619,
  [2519] = 1749,
  [2520] = 1726,
  [2521] = 1749,
  [2522] = 1801,
  [2523] = 1756,
  [2524] = 1617,
  [2525] = 1621,
  [2526] = 1622,
  [2527] = 1804,
  [2528] = 1766,
  [2529] = 1664,
  [2530] = 1624,
  [2531] = 1724,
  [2532] = 1619,
  [2533] = 1739,
  [2534] = 1664,
  [2535] = 1760,
  [2536] = 1752,
  [2537] = 1753,
  [2538] = 1502,
  [2539] = 1756,
  [2540] = 1783,
  [2541] = 1492,
  [2542] = 1639,
  [2543] = 1758,
  [2544] = 1633,
  [2545] = 1622,
  [2546] = 1631,
  [2547] = 1654,
  [2548] = 1777,
  [2549] = 1653,
  [2550] = 1784,
  [2551] = 1509,
  [2552] = 1774,
  [2553] = 1514,
  [2554] = 1790,
  [2555] = 1806,
  [2556] = 1663,
  [2557] = 1805,
  [2558] = 1741,
  [2559] = 1520,
  [2560] = 1740,
  [2561] = 1651,
  [2562] = 1742,
  [2563] = 1646,
  [2564] = 1768,
  [2565] = 1763,
  [2566] = 1658,
  [2567] = 1748,
  [2568] = 1734,
  [2569] = 1657,
  [2570] = 1656,
  [2571] = 1654,
  [2572] = 1744,
  [2573] = 1663,
  [2574] = 1723,
  [2575] = 1789,
  [2576] = 1542,
  [2577] = 1757,
  [2578] = 1639,
  [2579] = 1653,
  [2580] = 1664,
  [2581] = 1651,
  [2582] = 1658,
  [2583] = 1514,
  [2584] = 1642,
  [2585] = 1772,
  [2586] = 1646,
  [2587] = 1765,
  [2588] = 1621,
  [2589] = 1619,
  [2590] = 1615,
  [2591] = 1631,
  [2592] = 1621,
  [2593] = 1633,
  [2594] = 1639,
  [2595] = 1514,
  [2596] = 1826,
  [2597] = 1759,
  [2598] = 1656,
  [2599] = 1801,
  [2600] = 1642,
  [2601] = 1646,
  [2602] = 1790,
  [2603] = 1624,
  [2604] = 1654,
  [2605] = 1836,
  [2606] = 1492,
  [2607] = 1657,
  [2608] = 1622,
  [2609] = 1726,
  [2610] = 1492,
  [2611] = 1792,
  [2612] = 1621,
  [2613] = 1624,
  [2614] = 1639,
  [2615] = 1633,
  [2616] = 1731,
  [2617] = 1663,
  [2618] = 1793,
  [2619] = 1724,
  [2620] = 1760,
  [2621] = 1615,
  [2622] = 1654,
  [2623] = 1617,
  [2624] = 1664,
  [2625] = 1732,
  [2626] = 1735,
  [2627] = 1805,
  [2628] = 1651,
  [2629] = 1615,
  [2630] = 1730,
  [2631] = 1806,
  [2632] = 1748,
  [2633] = 1617,
  [2634] = 1786,
  [2635] = 1786,
  [2636] = 1734,
  [2637] = 1514,
  [2638] = 1615,
  [2639] = 1617,
  [2640] = 1804,
  [2641] = 1653,
  [2642] = 1619,
  [2643] = 1642,
  [2644] = 1733,
  [2645] = 1492,
  [2646] = 1528,
  [2647] = 1747,
  [2648] = 1732,
  [2649] = 1746,
  [2650] = 1731,
  [2651] = 1528,
  [2652] = 1792,
  [2653] = 1789,
  [2654] = 1755,
  [2655] = 1526,
  [2656] = 1756,
  [2657] = 1784,
  [2658] = 1658,
  [2659] = 1783,
  [2660] = 1642,
  [2661] = 1657,
  [2662] = 1793,
  [2663] = 1663,
  [2664] = 1658,
  [2665] = 1657,
  [2666] = 1656,
  [2667] = 1656,
  [2668] = 1792,
  [2669] = 1744,
  [2670] = 1646,
  [2671] = 1789,
  [2672] = 1755,
  [2673] = 1624,
  [2674] = 1826,
  [2675] = 1836,
  [2676] = 1730,
  [2677] = 1653,
  [2678] = 1768,
  [2679] = 1631,
  [2680] = 1631,
  [2681] = 1651,
  [2682] = 1766,
  [2683] = 1742,
  [2684] = 1730,
  [2685] = 1763,
  [2686] = 1633,
  [2687] = 1758,
  [2688] = 1619,
  [2689] = 1741,
  [2690] = 1753,
  [2691] = 1644,
  [2692] = 1622,
  [2693] = 1740,
  [2694] = 1735,
  [2695] = 1723,
  [2696] = 1757,
  [2697] = 1752,
  [2698] = 1772,
  [2699] = 1765,
  [2700] = 1759,
  [2701] = 1739,
  [2702] = 1733,
  [2703] = 1651,
  [2704] = 1734,
  [2705] = 1806,
  [2706] = 1763,
  [2707] = 1663,
  [2708] = 1766,
  [2709] = 1792,
  [2710] = 1748,
  [2711] = 1734,
  [2712] = 1772,
  [2713] = 1752,
  [2714] = 1758,
  [2715] = 1639,
  [2716] = 1789,
  [2717] = 1801,
  [2718] = 1768,
  [2719] = 1756,
  [2720] = 1723,
  [2721] = 1765,
  [2722] = 1789,
  [2723] = 1759,
  [2724] = 1766,
  [2725] = 1756,
  [2726] = 1826,
  [2727] = 1801,
  [2728] = 1749,
  [2729] = 1742,
  [2730] = 1792,
  [2731] = 2731,
  [2732] = 1836,
  [2733] = 1774,
  [2734] = 1724,
  [2735] = 1509,
  [2736] = 1502,
  [2737] = 1739,
  [2738] = 1741,
  [2739] = 1733,
  [2740] = 1730,
  [2741] = 2731,
  [2742] = 1742,
  [2743] = 1752,
  [2744] = 1753,
  [2745] = 1744,
  [2746] = 1749,
  [2747] = 1740,
  [2748] = 1806,
  [2749] = 1836,
  [2750] = 1757,
  [2751] = 1793,
  [2752] = 1783,
  [2753] = 1658,
  [2754] = 1520,
  [2755] = 1784,
  [2756] = 1735,
  [2757] = 1724,
  [2758] = 1804,
  [2759] = 1732,
  [2760] = 1757,
  [2761] = 1741,
  [2762] = 1542,
  [2763] = 1786,
  [2764] = 1760,
  [2765] = 1768,
  [2766] = 1758,
  [2767] = 2767,
  [2768] = 1726,
  [2769] = 1792,
  [2770] = 1735,
  [2771] = 1772,
  [2772] = 1763,
  [2773] = 1740,
  [2774] = 1765,
  [2775] = 1733,
  [2776] = 1734,
  [2777] = 1783,
  [2778] = 1731,
  [2779] = 1805,
  [2780] = 1656,
  [2781] = 1723,
  [2782] = 1759,
  [2783] = 1528,
  [2784] = 1526,
  [2785] = 1492,
  [2786] = 1758,
  [2787] = 1726,
  [2788] = 1726,
  [2789] = 1731,
  [2790] = 1646,
  [2791] = 1763,
  [2792] = 1731,
  [2793] = 1793,
  [2794] = 1654,
  [2795] = 1742,
  [2796] = 1759,
  [2797] = 1653,
  [2798] = 1732,
  [2799] = 1748,
  [2800] = 1755,
  [2801] = 1633,
  [2802] = 1805,
  [2803] = 1733,
  [2804] = 1657,
  [2805] = 1747,
  [2806] = 1734,
  [2807] = 1786,
  [2808] = 1746,
  [2809] = 1790,
  [2810] = 1732,
  [2811] = 1514,
  [2812] = 1631,
  [2813] = 1765,
  [2814] = 1739,
  [2815] = 1804,
  [2816] = 1772,
  [2817] = 1642,
  [2818] = 1757,
  [2819] = 1752,
  [2820] = 1784,
  [2821] = 1753,
  [2822] = 1760,
  [2823] = 1755,
  [2824] = 1664,
  [2825] = 1783,
  [2826] = 1615,
  [2827] = 1756,
  [2828] = 1744,
  [2829] = 1753,
  [2830] = 1752,
  [2831] = 1739,
  [2832] = 1724,
  [2833] = 1759,
  [2834] = 1730,
  [2835] = 1805,
  [2836] = 1836,
  [2837] = 1748,
  [2838] = 1806,
  [2839] = 1723,
  [2840] = 1765,
  [2841] = 1790,
  [2842] = 1760,
  [2843] = 1749,
  [2844] = 1735,
  [2845] = 1804,
  [2846] = 1772,
  [2847] = 1801,
  [2848] = 1757,
  [2849] = 1789,
  [2850] = 1792,
  [2851] = 1723,
  [2852] = 1735,
  [2853] = 1740,
  [2854] = 1741,
  [2855] = 1826,
  [2856] = 1755,
  [2857] = 1826,
  [2858] = 1744,
  [2859] = 1801,
  [2860] = 1766,
  [2861] = 1790,
  [2862] = 1748,
  [2863] = 1784,
  [2864] = 1758,
  [2865] = 1617,
  [2866] = 1763,
  [2867] = 1793,
  [2868] = 1742,
  [2869] = 1621,
  [2870] = 1768,
  [2871] = 1622,
  [2872] = 1766,
  [2873] = 1786,
  [2874] = 1790,
  [2875] = 1740,
  [2876] = 1730,
  [2877] = 1826,
  [2878] = 1783,
  [2879] = 1749,
  [2880] = 1760,
  [2881] = 1805,
  [2882] = 1806,
  [2883] = 1741,
  [2884] = 1804,
  [2885] = 1836,
  [2886] = 1724,
  [2887] = 1768,
  [2888] = 1624,
  [2889] = 1730,
  [2890] = 1756,
  [2891] = 1739,
  [2892] = 1789,
  [2893] = 1753,
  [2894] = 1744,
  [2895] = 1755,
  [2896] = 1786,
  [2897] = 1733,
  [2898] = 2767,
  [2899] = 1793,
  [2900] = 1732,
  [2901] = 1731,
  [2902] = 1726,
  [2903] = 1784,
  [2904] = 1826,
  [2905] = 1739,
  [2906] = 1768,
  [2907] = 1766,
  [2908] = 1742,
  [2909] = 1651,
  [2910] = 1763,
  [2911] = 1734,
  [2912] = 1758,
  [2913] = 1741,
  [2914] = 1653,
  [2915] = 1654,
  [2916] = 1740,
  [2917] = 1656,
  [2918] = 1657,
  [2919] = 1735,
  [2920] = 1658,
  [2921] = 1663,
  [2922] = 1723,
  [2923] = 1514,
  [2924] = 1749,
  [2925] = 2925,
  [2926] = 1801,
  [2927] = 1642,
  [2928] = 1748,
  [2929] = 1615,
  [2930] = 1836,
  [2931] = 1724,
  [2932] = 2925,
  [2933] = 1664,
  [2934] = 1757,
  [2935] = 1617,
  [2936] = 1731,
  [2937] = 1772,
  [2938] = 1765,
  [2939] = 1759,
  [2940] = 1621,
  [2941] = 1726,
  [2942] = 1622,
  [2943] = 1732,
  [2944] = 1624,
  [2945] = 1733,
  [2946] = 1752,
  [2947] = 1646,
  [2948] = 1753,
  [2949] = 1744,
  [2950] = 1793,
  [2951] = 1755,
  [2952] = 1760,
  [2953] = 1783,
  [2954] = 1784,
  [2955] = 1804,
  [2956] = 1806,
  [2957] = 1805,
  [2958] = 1786,
  [2959] = 1730,
  [2960] = 1631,
  [2961] = 1633,
  [2962] = 1756,
  [2963] = 1789,
  [2964] = 1619,
  [2965] = 1492,
  [2966] = 1792,
  [2967] = 1639,
  [2968] = 1790,
  [2969] = 1806,
  [2970] = 1772,
  [2971] = 1786,
  [2972] = 1792,
  [2973] = 1826,
  [2974] = 1758,
  [2975] = 1804,
  [2976] = 1801,
  [2977] = 1763,
  [2978] = 1749,
  [2979] = 1742,
  [2980] = 1836,
  [2981] = 1766,
  [2982] = 1793,
  [2983] = 1755,
  [2984] = 1768,
  [2985] = 1724,
  [2986] = 2731,
  [2987] = 1789,
  [2988] = 1723,
  [2989] = 2767,
  [2990] = 1740,
  [2991] = 1756,
  [2992] = 1735,
  [2993] = 1748,
  [2994] = 1757,
  [2995] = 2767,
  [2996] = 1739,
  [2997] = 2731,
  [2998] = 1730,
  [2999] = 2731,
  [3000] = 1790,
  [3001] = 2767,
  [3002] = 1752,
  [3003] = 1765,
  [3004] = 2731,
  [3005] = 1760,
  [3006] = 1805,
  [3007] = 1759,
  [3008] = 1783,
  [3009] = 1753,
  [3010] = 1741,
  [3011] = 1784,
  [3012] = 1733,
  [3013] = 2767,
  [3014] = 1744,
  [3015] = 1732,
  [3016] = 1731,
  [3017] = 1726,
  [3018] = 1734,
  [3019] = 1492,
  [3020] = 1492,
  [3021] = 1664,
  [3022] = 3022,
  [3023] = 3023,
  [3024] = 3024,
  [3025] = 2767,
  [3026] = 1664,
  [3027] = 3024,
  [3028] = 3024,
  [3029] = 2767,
  [3030] = 1646,
  [3031] = 2731,
  [3032] = 1492,
  [3033] = 3033,
  [3034] = 3033,
  [3035] = 3024,
  [3036] = 1646,
  [3037] = 1492,
  [3038] = 3024,
  [3039] = 3039,
  [3040] = 2731,
  [3041] = 3024,
  [3042] = 1646,
  [3043] = 2767,
  [3044] = 1492,
  [3045] = 2731,
  [3046] = 1664,
  [3047] = 3047,
  [3048] = 1664,
  [3049] = 3024,
  [3050] = 3050,
  [3051] = 3024,
  [3052] = 3024,
  [3053] = 1734,
  [3054] = 1801,
  [3055] = 1748,
  [3056] = 1664,
  [3057] = 1664,
  [3058] = 3058,
  [3059] = 1806,
  [3060] = 3060,
  [3061] = 1826,
  [3062] = 1801,
  [3063] = 1793,
  [3064] = 1793,
  [3065] = 1749,
  [3066] = 1646,
  [3067] = 1749,
  [3068] = 1836,
  [3069] = 1734,
  [3070] = 1748,
  [3071] = 1793,
  [3072] = 1836,
  [3073] = 1724,
  [3074] = 1753,
  [3075] = 1739,
  [3076] = 1752,
  [3077] = 1753,
  [3078] = 1734,
  [3079] = 1804,
  [3080] = 1744,
  [3081] = 1783,
  [3082] = 1784,
  [3083] = 1784,
  [3084] = 1783,
  [3085] = 3024,
  [3086] = 3024,
  [3087] = 1748,
  [3088] = 1749,
  [3089] = 1804,
  [3090] = 1752,
  [3091] = 1724,
  [3092] = 1664,
  [3093] = 1492,
  [3094] = 1492,
  [3095] = 1734,
  [3096] = 3096,
  [3097] = 1664,
  [3098] = 3060,
  [3099] = 1646,
  [3100] = 1646,
  [3101] = 3096,
  [3102] = 1744,
  [3103] = 3103,
  [3104] = 1806,
  [3105] = 1744,
  [3106] = 3103,
  [3107] = 1646,
  [3108] = 1826,
  [3109] = 1664,
  [3110] = 1805,
  [3111] = 1753,
  [3112] = 1752,
  [3113] = 1739,
  [3114] = 1739,
  [3115] = 1783,
  [3116] = 1492,
  [3117] = 3024,
  [3118] = 1748,
  [3119] = 1724,
  [3120] = 1836,
  [3121] = 1748,
  [3122] = 1646,
  [3123] = 1793,
  [3124] = 1734,
  [3125] = 1492,
  [3126] = 3103,
  [3127] = 1801,
  [3128] = 1784,
  [3129] = 1492,
  [3130] = 1793,
  [3131] = 1492,
  [3132] = 1804,
  [3133] = 1826,
  [3134] = 1492,
  [3135] = 1664,
  [3136] = 1730,
  [3137] = 1730,
  [3138] = 1730,
  [3139] = 3050,
  [3140] = 1806,
  [3141] = 1805,
  [3142] = 1805,
  [3143] = 1744,
  [3144] = 1749,
  [3145] = 3145,
  [3146] = 1492,
  [3147] = 1752,
  [3148] = 1734,
  [3149] = 1724,
  [3150] = 1836,
  [3151] = 1646,
  [3152] = 3024,
  [3153] = 3024,
  [3154] = 1646,
  [3155] = 1734,
  [3156] = 1753,
  [3157] = 1734,
  [3158] = 1748,
  [3159] = 1749,
  [3160] = 1730,
  [3161] = 1801,
  [3162] = 1633,
  [3163] = 3060,
  [3164] = 3164,
  [3165] = 3165,
  [3166] = 1646,
  [3167] = 1826,
  [3168] = 1748,
  [3169] = 1492,
  [3170] = 1752,
  [3171] = 3165,
  [3172] = 1793,
  [3173] = 1793,
  [3174] = 3024,
  [3175] = 1739,
  [3176] = 1739,
  [3177] = 1730,
  [3178] = 1734,
  [3179] = 1730,
  [3180] = 1793,
  [3181] = 1730,
  [3182] = 1631,
  [3183] = 1492,
  [3184] = 1492,
  [3185] = 1492,
  [3186] = 1724,
  [3187] = 1748,
  [3188] = 1753,
  [3189] = 1664,
  [3190] = 1836,
  [3191] = 1805,
  [3192] = 1806,
  [3193] = 1744,
  [3194] = 1730,
  [3195] = 3195,
  [3196] = 1749,
  [3197] = 1804,
  [3198] = 1801,
  [3199] = 1826,
  [3200] = 1783,
  [3201] = 1664,
  [3202] = 1492,
  [3203] = 1664,
  [3204] = 1784,
  [3205] = 1783,
  [3206] = 1744,
  [3207] = 3145,
  [3208] = 1784,
  [3209] = 1753,
  [3210] = 1752,
  [3211] = 1739,
  [3212] = 1724,
  [3213] = 1836,
  [3214] = 1749,
  [3215] = 3164,
  [3216] = 1801,
  [3217] = 1826,
  [3218] = 1793,
  [3219] = 1804,
  [3220] = 3060,
  [3221] = 1492,
  [3222] = 3222,
  [3223] = 1806,
  [3224] = 1783,
  [3225] = 3024,
  [3226] = 1805,
  [3227] = 3227,
  [3228] = 1784,
  [3229] = 1646,
  [3230] = 3024,
  [3231] = 1805,
  [3232] = 3227,
  [3233] = 1664,
  [3234] = 1734,
  [3235] = 1826,
  [3236] = 3222,
  [3237] = 1801,
  [3238] = 1806,
  [3239] = 3024,
  [3240] = 1748,
  [3241] = 1664,
  [3242] = 1748,
  [3243] = 1749,
  [3244] = 1836,
  [3245] = 1805,
  [3246] = 1724,
  [3247] = 1806,
  [3248] = 1804,
  [3249] = 1793,
  [3250] = 1784,
  [3251] = 1739,
  [3252] = 1783,
  [3253] = 1664,
  [3254] = 1752,
  [3255] = 1804,
  [3256] = 1804,
  [3257] = 1514,
  [3258] = 1753,
  [3259] = 1744,
  [3260] = 3024,
  [3261] = 1805,
  [3262] = 1783,
  [3263] = 3024,
  [3264] = 1744,
  [3265] = 1753,
  [3266] = 1752,
  [3267] = 1806,
  [3268] = 1739,
  [3269] = 1784,
  [3270] = 1724,
  [3271] = 1836,
  [3272] = 1826,
  [3273] = 3227,
  [3274] = 1801,
  [3275] = 1646,
  [3276] = 3058,
  [3277] = 1748,
  [3278] = 1801,
  [3279] = 3024,
  [3280] = 1631,
  [3281] = 3281,
  [3282] = 1646,
  [3283] = 1631,
  [3284] = 3281,
  [3285] = 1783,
  [3286] = 1514,
  [3287] = 3281,
  [3288] = 1633,
  [3289] = 1664,
  [3290] = 3195,
  [3291] = 1734,
  [3292] = 1730,
  [3293] = 1646,
  [3294] = 3024,
  [3295] = 1730,
  [3296] = 1664,
  [3297] = 3297,
  [3298] = 3298,
  [3299] = 1784,
  [3300] = 1633,
  [3301] = 3024,
  [3302] = 3302,
  [3303] = 1631,
  [3304] = 1744,
  [3305] = 1514,
  [3306] = 1492,
  [3307] = 3281,
  [3308] = 1492,
  [3309] = 1826,
  [3310] = 1749,
  [3311] = 1492,
  [3312] = 1753,
  [3313] = 3195,
  [3314] = 3281,
  [3315] = 1804,
  [3316] = 3281,
  [3317] = 1664,
  [3318] = 3281,
  [3319] = 1806,
  [3320] = 3281,
  [3321] = 1752,
  [3322] = 3302,
  [3323] = 1633,
  [3324] = 1805,
  [3325] = 3047,
  [3326] = 3281,
  [3327] = 1793,
  [3328] = 3024,
  [3329] = 3281,
  [3330] = 1734,
  [3331] = 1664,
  [3332] = 1836,
  [3333] = 3058,
  [3334] = 3281,
  [3335] = 3335,
  [3336] = 1748,
  [3337] = 1752,
  [3338] = 1734,
  [3339] = 3339,
  [3340] = 3195,
  [3341] = 1748,
  [3342] = 1514,
  [3343] = 1631,
  [3344] = 1514,
  [3345] = 1724,
  [3346] = 1739,
  [3347] = 1646,
  [3348] = 1793,
  [3349] = 1826,
  [3350] = 1801,
  [3351] = 1793,
  [3352] = 1646,
  [3353] = 1514,
  [3354] = 1749,
  [3355] = 1793,
  [3356] = 1492,
  [3357] = 1724,
  [3358] = 3195,
  [3359] = 1748,
  [3360] = 1836,
  [3361] = 1492,
  [3362] = 1749,
  [3363] = 3363,
  [3364] = 1664,
  [3365] = 3365,
  [3366] = 1734,
  [3367] = 1836,
  [3368] = 1724,
  [3369] = 1492,
  [3370] = 3370,
  [3371] = 1492,
  [3372] = 1739,
  [3373] = 1730,
  [3374] = 1739,
  [3375] = 3195,
  [3376] = 1664,
  [3377] = 1664,
  [3378] = 1752,
  [3379] = 3379,
  [3380] = 3380,
  [3381] = 1492,
  [3382] = 1646,
  [3383] = 1801,
  [3384] = 1753,
  [3385] = 1492,
  [3386] = 3386,
  [3387] = 1744,
  [3388] = 3388,
  [3389] = 1756,
  [3390] = 3390,
  [3391] = 1826,
  [3392] = 1492,
  [3393] = 1783,
  [3394] = 1730,
  [3395] = 1784,
  [3396] = 1804,
  [3397] = 1492,
  [3398] = 3398,
  [3399] = 1730,
  [3400] = 3281,
  [3401] = 1789,
  [3402] = 3402,
  [3403] = 1633,
  [3404] = 1806,
  [3405] = 1492,
  [3406] = 1664,
  [3407] = 1805,
  [3408] = 1806,
  [3409] = 1792,
  [3410] = 1804,
  [3411] = 3164,
  [3412] = 1784,
  [3413] = 1805,
  [3414] = 3164,
  [3415] = 3047,
  [3416] = 1783,
  [3417] = 1744,
  [3418] = 1753,
  [3419] = 1492,
  [3420] = 1752,
  [3421] = 1805,
  [3422] = 1739,
  [3423] = 1806,
  [3424] = 1826,
  [3425] = 1724,
  [3426] = 1836,
  [3427] = 1749,
  [3428] = 1801,
  [3429] = 1804,
  [3430] = 1784,
  [3431] = 1631,
  [3432] = 1783,
  [3433] = 1633,
  [3434] = 1744,
  [3435] = 1753,
  [3436] = 1805,
  [3437] = 1514,
  [3438] = 1789,
  [3439] = 1734,
  [3440] = 1792,
  [3441] = 3402,
  [3442] = 3442,
  [3443] = 3339,
  [3444] = 3222,
  [3445] = 1664,
  [3446] = 3442,
  [3447] = 1749,
  [3448] = 1514,
  [3449] = 1646,
  [3450] = 3165,
  [3451] = 3442,
  [3452] = 1801,
  [3453] = 1730,
  [3454] = 3165,
  [3455] = 3455,
  [3456] = 1826,
  [3457] = 1631,
  [3458] = 1748,
  [3459] = 1804,
  [3460] = 3442,
  [3461] = 1514,
  [3462] = 3402,
  [3463] = 1492,
  [3464] = 1633,
  [3465] = 3222,
  [3466] = 1748,
  [3467] = 1734,
  [3468] = 1793,
  [3469] = 1734,
  [3470] = 3222,
  [3471] = 1806,
  [3472] = 3222,
  [3473] = 1664,
  [3474] = 1753,
  [3475] = 1805,
  [3476] = 1646,
  [3477] = 3442,
  [3478] = 1784,
  [3479] = 1783,
  [3480] = 3335,
  [3481] = 1748,
  [3482] = 3442,
  [3483] = 3442,
  [3484] = 3484,
  [3485] = 3024,
  [3486] = 3442,
  [3487] = 3442,
  [3488] = 3442,
  [3489] = 3442,
  [3490] = 1631,
  [3491] = 1633,
  [3492] = 3298,
  [3493] = 1793,
  [3494] = 1836,
  [3495] = 3484,
  [3496] = 3442,
  [3497] = 1789,
  [3498] = 1792,
  [3499] = 1734,
  [3500] = 3195,
  [3501] = 1631,
  [3502] = 1633,
  [3503] = 1748,
  [3504] = 1631,
  [3505] = 3442,
  [3506] = 3442,
  [3507] = 1734,
  [3508] = 3442,
  [3509] = 1734,
  [3510] = 1836,
  [3511] = 1756,
  [3512] = 3442,
  [3513] = 1793,
  [3514] = 3442,
  [3515] = 1792,
  [3516] = 1748,
  [3517] = 1646,
  [3518] = 3442,
  [3519] = 3442,
  [3520] = 1730,
  [3521] = 3442,
  [3522] = 3442,
  [3523] = 3363,
  [3524] = 3442,
  [3525] = 3525,
  [3526] = 3365,
  [3527] = 3442,
  [3528] = 3379,
  [3529] = 1730,
  [3530] = 3398,
  [3531] = 3388,
  [3532] = 3390,
  [3533] = 3442,
  [3534] = 1664,
  [3535] = 1806,
  [3536] = 1789,
  [3537] = 1804,
  [3538] = 1724,
  [3539] = 1784,
  [3540] = 3380,
  [3541] = 3402,
  [3542] = 3297,
  [3543] = 3386,
  [3544] = 1783,
  [3545] = 1739,
  [3546] = 1744,
  [3547] = 1752,
  [3548] = 1753,
  [3549] = 1744,
  [3550] = 3298,
  [3551] = 3442,
  [3552] = 1730,
  [3553] = 3335,
  [3554] = 3339,
  [3555] = 1793,
  [3556] = 1753,
  [3557] = 3363,
  [3558] = 3365,
  [3559] = 1492,
  [3560] = 1752,
  [3561] = 1826,
  [3562] = 3370,
  [3563] = 3380,
  [3564] = 1792,
  [3565] = 1801,
  [3566] = 1739,
  [3567] = 1749,
  [3568] = 1492,
  [3569] = 1836,
  [3570] = 1724,
  [3571] = 1724,
  [3572] = 3402,
  [3573] = 1514,
  [3574] = 1739,
  [3575] = 1752,
  [3576] = 1836,
  [3577] = 1730,
  [3578] = 1749,
  [3579] = 1801,
  [3580] = 1826,
  [3581] = 3365,
  [3582] = 3165,
  [3583] = 3442,
  [3584] = 1744,
  [3585] = 1492,
  [3586] = 1805,
  [3587] = 1806,
  [3588] = 1804,
  [3589] = 3589,
  [3590] = 1784,
  [3591] = 1783,
  [3592] = 1744,
  [3593] = 1753,
  [3594] = 1492,
  [3595] = 1752,
  [3596] = 3386,
  [3597] = 1739,
  [3598] = 1724,
  [3599] = 1753,
  [3600] = 1492,
  [3601] = 1730,
  [3602] = 3370,
  [3603] = 1749,
  [3604] = 1744,
  [3605] = 1633,
  [3606] = 1801,
  [3607] = 1826,
  [3608] = 1752,
  [3609] = 1793,
  [3610] = 1739,
  [3611] = 1492,
  [3612] = 1789,
  [3613] = 3398,
  [3614] = 1646,
  [3615] = 1664,
  [3616] = 1492,
  [3617] = 1730,
  [3618] = 3379,
  [3619] = 1664,
  [3620] = 3402,
  [3621] = 1646,
  [3622] = 1783,
  [3623] = 1492,
  [3624] = 3398,
  [3625] = 1748,
  [3626] = 1783,
  [3627] = 3195,
  [3628] = 3442,
  [3629] = 1784,
  [3630] = 3386,
  [3631] = 3442,
  [3632] = 3442,
  [3633] = 1784,
  [3634] = 3380,
  [3635] = 3370,
  [3636] = 3442,
  [3637] = 3365,
  [3638] = 3363,
  [3639] = 1730,
  [3640] = 3442,
  [3641] = 3339,
  [3642] = 3335,
  [3643] = 1826,
  [3644] = 3298,
  [3645] = 3379,
  [3646] = 1804,
  [3647] = 1792,
  [3648] = 1646,
  [3649] = 3388,
  [3650] = 1789,
  [3651] = 1801,
  [3652] = 3297,
  [3653] = 1756,
  [3654] = 1749,
  [3655] = 3388,
  [3656] = 1806,
  [3657] = 3390,
  [3658] = 3388,
  [3659] = 3390,
  [3660] = 3379,
  [3661] = 3297,
  [3662] = 3390,
  [3663] = 1804,
  [3664] = 1836,
  [3665] = 1805,
  [3666] = 1724,
  [3667] = 1724,
  [3668] = 1806,
  [3669] = 1805,
  [3670] = 3398,
  [3671] = 1836,
  [3672] = 3298,
  [3673] = 3024,
  [3674] = 1749,
  [3675] = 3165,
  [3676] = 1664,
  [3677] = 3024,
  [3678] = 3195,
  [3679] = 3297,
  [3680] = 1793,
  [3681] = 3335,
  [3682] = 1739,
  [3683] = 1730,
  [3684] = 1826,
  [3685] = 3398,
  [3686] = 1756,
  [3687] = 3024,
  [3688] = 1730,
  [3689] = 3386,
  [3690] = 3024,
  [3691] = 1752,
  [3692] = 1730,
  [3693] = 1753,
  [3694] = 1744,
  [3695] = 3370,
  [3696] = 1783,
  [3697] = 1756,
  [3698] = 1664,
  [3699] = 3380,
  [3700] = 1492,
  [3701] = 1784,
  [3702] = 3379,
  [3703] = 3363,
  [3704] = 3339,
  [3705] = 3388,
  [3706] = 3390,
  [3707] = 3365,
  [3708] = 3442,
  [3709] = 1756,
  [3710] = 3380,
  [3711] = 3370,
  [3712] = 3297,
  [3713] = 3195,
  [3714] = 1805,
  [3715] = 1646,
  [3716] = 1514,
  [3717] = 3386,
  [3718] = 3442,
  [3719] = 3363,
  [3720] = 1801,
  [3721] = 1806,
  [3722] = 3298,
  [3723] = 1804,
  [3724] = 3024,
  [3725] = 3335,
  [3726] = 3339,
  [3727] = 1664,
  [3728] = 1734,
  [3729] = 1730,
  [3730] = 3380,
  [3731] = 3370,
  [3732] = 1784,
  [3733] = 3365,
  [3734] = 3363,
  [3735] = 1748,
  [3736] = 1734,
  [3737] = 3339,
  [3738] = 3335,
  [3739] = 1744,
  [3740] = 3298,
  [3741] = 1492,
  [3742] = 1730,
  [3743] = 1806,
  [3744] = 1805,
  [3745] = 2767,
  [3746] = 1739,
  [3747] = 1752,
  [3748] = 3297,
  [3749] = 2731,
  [3750] = 1784,
  [3751] = 1783,
  [3752] = 3047,
  [3753] = 3390,
  [3754] = 3388,
  [3755] = 1793,
  [3756] = 3379,
  [3757] = 1804,
  [3758] = 1753,
  [3759] = 3759,
  [3760] = 3386,
  [3761] = 3759,
  [3762] = 1724,
  [3763] = 1783,
  [3764] = 1744,
  [3765] = 3765,
  [3766] = 3759,
  [3767] = 3058,
  [3768] = 1753,
  [3769] = 1752,
  [3770] = 1739,
  [3771] = 3379,
  [3772] = 1724,
  [3773] = 3388,
  [3774] = 3390,
  [3775] = 1836,
  [3776] = 3297,
  [3777] = 1749,
  [3778] = 1836,
  [3779] = 1801,
  [3780] = 1646,
  [3781] = 1749,
  [3782] = 1801,
  [3783] = 1826,
  [3784] = 3298,
  [3785] = 1826,
  [3786] = 3335,
  [3787] = 3339,
  [3788] = 3363,
  [3789] = 3365,
  [3790] = 1804,
  [3791] = 3759,
  [3792] = 3370,
  [3793] = 3380,
  [3794] = 3386,
  [3795] = 1756,
  [3796] = 1756,
  [3797] = 1514,
  [3798] = 3398,
  [3799] = 1730,
  [3800] = 2731,
  [3801] = 1793,
  [3802] = 1492,
  [3803] = 3759,
  [3804] = 2767,
  [3805] = 3024,
  [3806] = 1492,
  [3807] = 3047,
  [3808] = 3759,
  [3809] = 1646,
  [3810] = 1730,
  [3811] = 1646,
  [3812] = 1748,
  [3813] = 3759,
  [3814] = 1492,
  [3815] = 3759,
  [3816] = 3759,
  [3817] = 1730,
  [3818] = 1730,
  [3819] = 1492,
  [3820] = 1492,
  [3821] = 1730,
  [3822] = 3759,
  [3823] = 1806,
  [3824] = 1730,
  [3825] = 3759,
  [3826] = 3759,
  [3827] = 3759,
  [3828] = 1805,
  [3829] = 3759,
  [3830] = 3759,
  [3831] = 3759,
  [3832] = 3759,
  [3833] = 1793,
  [3834] = 3759,
  [3835] = 3759,
  [3836] = 1734,
  [3837] = 3759,
  [3838] = 3759,
  [3839] = 3759,
  [3840] = 1646,
  [3841] = 3759,
  [3842] = 1748,
  [3843] = 2731,
  [3844] = 3759,
  [3845] = 3759,
  [3846] = 3195,
  [3847] = 1730,
  [3848] = 3759,
  [3849] = 1734,
  [3850] = 3759,
  [3851] = 3759,
  [3852] = 3759,
  [3853] = 3759,
  [3854] = 3759,
  [3855] = 3759,
  [3856] = 3759,
  [3857] = 2767,
  [3858] = 1492,
  [3859] = 3759,
  [3860] = 1748,
  [3861] = 3765,
  [3862] = 3759,
  [3863] = 3759,
  [3864] = 3759,
  [3865] = 3759,
  [3866] = 3398,
  [3867] = 1756,
  [3868] = 3386,
  [3869] = 3380,
  [3870] = 3370,
  [3871] = 3398,
  [3872] = 3759,
  [3873] = 3365,
  [3874] = 3874,
  [3875] = 3363,
  [3876] = 3339,
  [3877] = 3335,
  [3878] = 3759,
  [3879] = 3298,
  [3880] = 3759,
  [3881] = 3759,
  [3882] = 3297,
  [3883] = 3759,
  [3884] = 3759,
  [3885] = 3759,
  [3886] = 3759,
  [3887] = 3390,
  [3888] = 3388,
  [3889] = 3889,
  [3890] = 3379,
  [3891] = 1631,
  [3892] = 1826,
  [3893] = 1633,
  [3894] = 1801,
  [3895] = 1793,
  [3896] = 3759,
  [3897] = 1749,
  [3898] = 1836,
  [3899] = 1724,
  [3900] = 3759,
  [3901] = 3901,
  [3902] = 3759,
  [3903] = 1739,
  [3904] = 3759,
  [3905] = 1752,
  [3906] = 1514,
  [3907] = 1753,
  [3908] = 3402,
  [3909] = 1744,
  [3910] = 3759,
  [3911] = 1783,
  [3912] = 1749,
  [3913] = 1784,
  [3914] = 3759,
  [3915] = 3889,
  [3916] = 3759,
  [3917] = 1804,
  [3918] = 3759,
  [3919] = 3759,
  [3920] = 3759,
  [3921] = 1806,
  [3922] = 1805,
  [3923] = 1664,
  [3924] = 3759,
  [3925] = 3759,
  [3926] = 3759,
  [3927] = 3759,
  [3928] = 3759,
  [3929] = 3759,
  [3930] = 3759,
  [3931] = 1789,
  [3932] = 3402,
  [3933] = 3759,
  [3934] = 3759,
  [3935] = 1734,
  [3936] = 3759,
  [3937] = 3759,
  [3938] = 3759,
  [3939] = 3759,
  [3940] = 1826,
  [3941] = 1801,
  [3942] = 1792,
  [3943] = 1730,
  [3944] = 1836,
  [3945] = 1724,
  [3946] = 1492,
  [3947] = 3759,
  [3948] = 3759,
  [3949] = 3759,
  [3950] = 3759,
  [3951] = 3759,
  [3952] = 3759,
  [3953] = 3759,
  [3954] = 1739,
  [3955] = 1752,
  [3956] = 1753,
  [3957] = 1744,
  [3958] = 1783,
  [3959] = 1784,
  [3960] = 3759,
  [3961] = 3759,
  [3962] = 1804,
  [3963] = 3759,
  [3964] = 3759,
  [3965] = 1633,
  [3966] = 3759,
  [3967] = 3759,
  [3968] = 1806,
  [3969] = 3402,
  [3970] = 1805,
  [3971] = 1631,
  [3972] = 3759,
  [3973] = 3759,
  [3974] = 3759,
  [3975] = 1734,
  [3976] = 3874,
  [3977] = 3024,
  [3978] = 1789,
  [3979] = 1792,
  [3980] = 1646,
  [3981] = 1744,
  [3982] = 1789,
  [3983] = 1792,
  [3984] = 1664,
  [3985] = 1646,
  [3986] = 1664,
  [3987] = 1826,
  [3988] = 1801,
  [3989] = 1749,
  [3990] = 1836,
  [3991] = 1724,
  [3992] = 1739,
  [3993] = 1752,
  [3994] = 1753,
  [3995] = 1744,
  [3996] = 1783,
  [3997] = 1784,
  [3998] = 1646,
  [3999] = 1492,
  [4000] = 1492,
  [4001] = 1804,
  [4002] = 1806,
  [4003] = 1805,
  [4004] = 1664,
  [4005] = 3195,
  [4006] = 1492,
  [4007] = 1646,
  [4008] = 1805,
  [4009] = 1806,
  [4010] = 1804,
  [4011] = 1784,
  [4012] = 1783,
  [4013] = 1826,
  [4014] = 1753,
  [4015] = 1752,
  [4016] = 1739,
  [4017] = 1724,
  [4018] = 1748,
  [4019] = 1836,
  [4020] = 1749,
  [4021] = 1801,
  [4022] = 1826,
  [4023] = 1664,
  [4024] = 1492,
  [4025] = 1748,
  [4026] = 3386,
  [4027] = 3380,
  [4028] = 3365,
  [4029] = 3363,
  [4030] = 1514,
  [4031] = 1756,
  [4032] = 1805,
  [4033] = 1806,
  [4034] = 1804,
  [4035] = 1784,
  [4036] = 1783,
  [4037] = 3058,
  [4038] = 1744,
  [4039] = 1753,
  [4040] = 3058,
  [4041] = 1752,
  [4042] = 1739,
  [4043] = 1724,
  [4044] = 1836,
  [4045] = 1749,
  [4046] = 3047,
  [4047] = 1801,
  [4048] = 1734,
  [4049] = 3398,
  [4050] = 3370,
  [4051] = 3339,
  [4052] = 1789,
  [4053] = 3402,
  [4054] = 3335,
  [4055] = 3298,
  [4056] = 3297,
  [4057] = 3390,
  [4058] = 1793,
  [4059] = 3388,
  [4060] = 3379,
  [4061] = 1793,
  [4062] = 1730,
  [4063] = 1646,
  [4064] = 1793,
  [4065] = 1664,
  [4066] = 1792,
  [4067] = 1748,
  [4068] = 3765,
  [4069] = 1664,
  [4070] = 1492,
  [4071] = 1836,
  [4072] = 4072,
  [4073] = 3398,
  [4074] = 1793,
  [4075] = 4075,
  [4076] = 3398,
  [4077] = 4075,
  [4078] = 1734,
  [4079] = 4075,
  [4080] = 4075,
  [4081] = 4075,
  [4082] = 4075,
  [4083] = 4075,
  [4084] = 1748,
  [4085] = 1826,
  [4086] = 1801,
  [4087] = 1749,
  [4088] = 1836,
  [4089] = 1724,
  [4090] = 1739,
  [4091] = 1752,
  [4092] = 1753,
  [4093] = 1744,
  [4094] = 1783,
  [4095] = 1784,
  [4096] = 1804,
  [4097] = 1806,
  [4098] = 1805,
  [4099] = 4075,
  [4100] = 4075,
  [4101] = 4075,
  [4102] = 4075,
  [4103] = 4075,
  [4104] = 1492,
  [4105] = 3402,
  [4106] = 1734,
  [4107] = 4075,
  [4108] = 1836,
  [4109] = 3379,
  [4110] = 1748,
  [4111] = 3388,
  [4112] = 3390,
  [4113] = 3297,
  [4114] = 3298,
  [4115] = 3335,
  [4116] = 3339,
  [4117] = 3370,
  [4118] = 1793,
  [4119] = 1826,
  [4120] = 1801,
  [4121] = 1749,
  [4122] = 1724,
  [4123] = 1739,
  [4124] = 1752,
  [4125] = 1753,
  [4126] = 1793,
  [4127] = 1744,
  [4128] = 1734,
  [4129] = 1783,
  [4130] = 4075,
  [4131] = 1784,
  [4132] = 3165,
  [4133] = 1748,
  [4134] = 1748,
  [4135] = 1804,
  [4136] = 1806,
  [4137] = 1805,
  [4138] = 1734,
  [4139] = 4075,
  [4140] = 1793,
  [4141] = 3363,
  [4142] = 3365,
  [4143] = 3380,
  [4144] = 3402,
  [4145] = 3386,
  [4146] = 4146,
  [4147] = 4075,
  [4148] = 4075,
  [4149] = 2731,
  [4150] = 4150,
  [4151] = 4075,
  [4152] = 4075,
  [4153] = 4075,
  [4154] = 4075,
  [4155] = 4075,
  [4156] = 1793,
  [4157] = 1730,
  [4158] = 1826,
  [4159] = 1801,
  [4160] = 1749,
  [4161] = 1836,
  [4162] = 1724,
  [4163] = 1734,
  [4164] = 1739,
  [4165] = 1752,
  [4166] = 1753,
  [4167] = 1744,
  [4168] = 1783,
  [4169] = 1784,
  [4170] = 1804,
  [4171] = 1806,
  [4172] = 1805,
  [4173] = 4075,
  [4174] = 4075,
  [4175] = 1748,
  [4176] = 1805,
  [4177] = 1806,
  [4178] = 1756,
  [4179] = 1748,
  [4180] = 1804,
  [4181] = 1793,
  [4182] = 4075,
  [4183] = 1730,
  [4184] = 1826,
  [4185] = 1801,
  [4186] = 1749,
  [4187] = 1836,
  [4188] = 1724,
  [4189] = 1739,
  [4190] = 1752,
  [4191] = 1753,
  [4192] = 1744,
  [4193] = 1783,
  [4194] = 1784,
  [4195] = 1804,
  [4196] = 1806,
  [4197] = 1805,
  [4198] = 4075,
  [4199] = 4075,
  [4200] = 4075,
  [4201] = 1748,
  [4202] = 4075,
  [4203] = 4203,
  [4204] = 1730,
  [4205] = 4075,
  [4206] = 4075,
  [4207] = 4075,
  [4208] = 1756,
  [4209] = 1734,
  [4210] = 1789,
  [4211] = 3765,
  [4212] = 1792,
  [4213] = 1784,
  [4214] = 1664,
  [4215] = 2767,
  [4216] = 1783,
  [4217] = 3222,
  [4218] = 1793,
  [4219] = 1793,
  [4220] = 1664,
  [4221] = 4221,
  [4222] = 4222,
  [4223] = 1734,
  [4224] = 4221,
  [4225] = 1730,
  [4226] = 1492,
  [4227] = 4203,
  [4228] = 1792,
  [4229] = 1789,
  [4230] = 1748,
  [4231] = 1804,
  [4232] = 1734,
  [4233] = 4075,
  [4234] = 1748,
  [4235] = 1744,
  [4236] = 1646,
  [4237] = 1734,
  [4238] = 1753,
  [4239] = 1752,
  [4240] = 1826,
  [4241] = 1801,
  [4242] = 1739,
  [4243] = 1664,
  [4244] = 3165,
  [4245] = 1749,
  [4246] = 1724,
  [4247] = 4150,
  [4248] = 3165,
  [4249] = 4222,
  [4250] = 3386,
  [4251] = 3380,
  [4252] = 3370,
  [4253] = 3365,
  [4254] = 3363,
  [4255] = 3339,
  [4256] = 1739,
  [4257] = 1730,
  [4258] = 3298,
  [4259] = 1646,
  [4260] = 1752,
  [4261] = 1753,
  [4262] = 1724,
  [4263] = 1836,
  [4264] = 1744,
  [4265] = 1749,
  [4266] = 3297,
  [4267] = 3390,
  [4268] = 3388,
  [4269] = 3379,
  [4270] = 1492,
  [4271] = 3335,
  [4272] = 3765,
  [4273] = 1826,
  [4274] = 3222,
  [4275] = 1783,
  [4276] = 1784,
  [4277] = 1492,
  [4278] = 1730,
  [4279] = 1664,
  [4280] = 1805,
  [4281] = 1806,
  [4282] = 1804,
  [4283] = 1804,
  [4284] = 1492,
  [4285] = 1784,
  [4286] = 1783,
  [4287] = 1806,
  [4288] = 1805,
  [4289] = 1793,
  [4290] = 3765,
  [4291] = 1646,
  [4292] = 1744,
  [4293] = 1753,
  [4294] = 1752,
  [4295] = 1739,
  [4296] = 1724,
  [4297] = 1836,
  [4298] = 1749,
  [4299] = 1801,
  [4300] = 1826,
  [4301] = 1730,
  [4302] = 1730,
  [4303] = 1492,
  [4304] = 1730,
  [4305] = 1730,
  [4306] = 1801,
  [4307] = 2767,
  [4308] = 2731,
  [4309] = 3222,
  [4310] = 1664,
  [4311] = 1805,
  [4312] = 1806,
  [4313] = 1804,
  [4314] = 4146,
  [4315] = 1646,
  [4316] = 2767,
  [4317] = 3060,
  [4318] = 1664,
  [4319] = 1784,
  [4320] = 2731,
  [4321] = 1783,
  [4322] = 1744,
  [4323] = 1753,
  [4324] = 1752,
  [4325] = 1739,
  [4326] = 4326,
  [4327] = 1724,
  [4328] = 1836,
  [4329] = 4329,
  [4330] = 1749,
  [4331] = 1801,
  [4332] = 1826,
  [4333] = 1806,
  [4334] = 1836,
  [4335] = 1748,
  [4336] = 1646,
  [4337] = 1646,
  [4338] = 2767,
  [4339] = 1734,
  [4340] = 3195,
  [4341] = 3765,
  [4342] = 4329,
  [4343] = 1492,
  [4344] = 4344,
  [4345] = 1492,
  [4346] = 1730,
  [4347] = 2731,
  [4348] = 1646,
  [4349] = 3765,
  [4350] = 1646,
  [4351] = 1492,
  [4352] = 1804,
  [4353] = 4326,
  [4354] = 4354,
  [4355] = 1664,
  [4356] = 4356,
  [4357] = 4357,
  [4358] = 4358,
  [4359] = 4329,
  [4360] = 1646,
  [4361] = 1734,
  [4362] = 1748,
  [4363] = 1748,
  [4364] = 4364,
  [4365] = 4365,
  [4366] = 3164,
  [4367] = 1748,
  [4368] = 1730,
  [4369] = 1793,
  [4370] = 1467,
  [4371] = 4329,
  [4372] = 4365,
  [4373] = 3765,
  [4374] = 1734,
  [4375] = 1467,
  [4376] = 4344,
  [4377] = 1748,
  [4378] = 1646,
  [4379] = 1664,
  [4380] = 1793,
  [4381] = 1805,
  [4382] = 1804,
  [4383] = 1784,
  [4384] = 1734,
  [4385] = 1826,
  [4386] = 1783,
  [4387] = 1744,
  [4388] = 1753,
  [4389] = 1734,
  [4390] = 1801,
  [4391] = 1734,
  [4392] = 1752,
  [4393] = 1739,
  [4394] = 1724,
  [4395] = 1836,
  [4396] = 1749,
  [4397] = 1836,
  [4398] = 1492,
  [4399] = 1748,
  [4400] = 1804,
  [4401] = 1724,
  [4402] = 1749,
  [4403] = 1801,
  [4404] = 1826,
  [4405] = 1805,
  [4406] = 1806,
  [4407] = 1793,
  [4408] = 1492,
  [4409] = 1826,
  [4410] = 1801,
  [4411] = 1749,
  [4412] = 1836,
  [4413] = 1724,
  [4414] = 1793,
  [4415] = 1633,
  [4416] = 1739,
  [4417] = 1752,
  [4418] = 1730,
  [4419] = 1753,
  [4420] = 1744,
  [4421] = 1739,
  [4422] = 1783,
  [4423] = 1784,
  [4424] = 1734,
  [4425] = 1793,
  [4426] = 1793,
  [4427] = 1806,
  [4428] = 1805,
  [4429] = 4072,
  [4430] = 1752,
  [4431] = 1753,
  [4432] = 1744,
  [4433] = 4356,
  [4434] = 2731,
  [4435] = 1783,
  [4436] = 1631,
  [4437] = 1784,
  [4438] = 2767,
  [4439] = 1730,
  [4440] = 2731,
  [4441] = 1631,
  [4442] = 3765,
  [4443] = 4329,
  [4444] = 4329,
  [4445] = 1730,
  [4446] = 4354,
  [4447] = 1805,
  [4448] = 1806,
  [4449] = 1748,
  [4450] = 2731,
  [4451] = 1826,
  [4452] = 1784,
  [4453] = 1783,
  [4454] = 1801,
  [4455] = 1749,
  [4456] = 1836,
  [4457] = 1724,
  [4458] = 2767,
  [4459] = 1739,
  [4460] = 1752,
  [4461] = 1744,
  [4462] = 1753,
  [4463] = 1753,
  [4464] = 1744,
  [4465] = 1664,
  [4466] = 1492,
  [4467] = 1783,
  [4468] = 1784,
  [4469] = 1752,
  [4470] = 1804,
  [4471] = 1806,
  [4472] = 1633,
  [4473] = 1805,
  [4474] = 1739,
  [4475] = 3195,
  [4476] = 1749,
  [4477] = 1724,
  [4478] = 1664,
  [4479] = 2767,
  [4480] = 1801,
  [4481] = 1826,
  [4482] = 3363,
  [4483] = 1749,
  [4484] = 4484,
  [4485] = 1793,
  [4486] = 1783,
  [4487] = 1784,
  [4488] = 1646,
  [4489] = 1520,
  [4490] = 1784,
  [4491] = 1664,
  [4492] = 1784,
  [4493] = 1792,
  [4494] = 1502,
  [4495] = 4484,
  [4496] = 4484,
  [4497] = 1826,
  [4498] = 1542,
  [4499] = 1783,
  [4500] = 1783,
  [4501] = 1806,
  [4502] = 1805,
  [4503] = 1492,
  [4504] = 3363,
  [4505] = 3365,
  [4506] = 1734,
  [4507] = 4484,
  [4508] = 3380,
  [4509] = 3402,
  [4510] = 1804,
  [4511] = 3386,
  [4512] = 1793,
  [4513] = 2731,
  [4514] = 4514,
  [4515] = 4484,
  [4516] = 2767,
  [4517] = 1744,
  [4518] = 3365,
  [4519] = 4519,
  [4520] = 4329,
  [4521] = 4484,
  [4522] = 3370,
  [4523] = 1492,
  [4524] = 1542,
  [4525] = 1502,
  [4526] = 4329,
  [4527] = 1744,
  [4528] = 1528,
  [4529] = 1753,
  [4530] = 1752,
  [4531] = 1739,
  [4532] = 1528,
  [4533] = 1526,
  [4534] = 3380,
  [4535] = 3402,
  [4536] = 4536,
  [4537] = 1789,
  [4538] = 3386,
  [4539] = 1520,
  [4540] = 1492,
  [4541] = 1756,
  [4542] = 1748,
  [4543] = 1528,
  [4544] = 1753,
  [4545] = 1526,
  [4546] = 1804,
  [4547] = 1806,
  [4548] = 1526,
  [4549] = 1664,
  [4550] = 1805,
  [4551] = 1752,
  [4552] = 1805,
  [4553] = 1664,
  [4554] = 1806,
  [4555] = 4484,
  [4556] = 4484,
  [4557] = 1734,
  [4558] = 3398,
  [4559] = 1836,
  [4560] = 1730,
  [4561] = 1739,
  [4562] = 1724,
  [4563] = 4563,
  [4564] = 1730,
  [4565] = 3398,
  [4566] = 1836,
  [4567] = 1749,
  [4568] = 1806,
  [4569] = 1748,
  [4570] = 4484,
  [4571] = 1748,
  [4572] = 1730,
  [4573] = 4484,
  [4574] = 1730,
  [4575] = 1542,
  [4576] = 1724,
  [4577] = 1836,
  [4578] = 1749,
  [4579] = 1492,
  [4580] = 4580,
  [4581] = 1793,
  [4582] = 4484,
  [4583] = 1646,
  [4584] = 1730,
  [4585] = 4484,
  [4586] = 1502,
  [4587] = 1801,
  [4588] = 1826,
  [4589] = 1801,
  [4590] = 1749,
  [4591] = 1836,
  [4592] = 1724,
  [4593] = 1646,
  [4594] = 4484,
  [4595] = 1734,
  [4596] = 1739,
  [4597] = 1752,
  [4598] = 1730,
  [4599] = 4514,
  [4600] = 1753,
  [4601] = 1826,
  [4602] = 1744,
  [4603] = 1826,
  [4604] = 1783,
  [4605] = 1801,
  [4606] = 1784,
  [4607] = 4484,
  [4608] = 1801,
  [4609] = 1806,
  [4610] = 1805,
  [4611] = 4611,
  [4612] = 4484,
  [4613] = 4484,
  [4614] = 4329,
  [4615] = 1664,
  [4616] = 1804,
  [4617] = 4484,
  [4618] = 2767,
  [4619] = 1730,
  [4620] = 4611,
  [4621] = 1492,
  [4622] = 1784,
  [4623] = 4484,
  [4624] = 1783,
  [4625] = 1749,
  [4626] = 3370,
  [4627] = 4484,
  [4628] = 4484,
  [4629] = 1520,
  [4630] = 1756,
  [4631] = 3339,
  [4632] = 4329,
  [4633] = 4484,
  [4634] = 3335,
  [4635] = 3298,
  [4636] = 1664,
  [4637] = 1646,
  [4638] = 1789,
  [4639] = 4484,
  [4640] = 4514,
  [4641] = 1664,
  [4642] = 3388,
  [4643] = 4484,
  [4644] = 1744,
  [4645] = 1724,
  [4646] = 1793,
  [4647] = 3765,
  [4648] = 1514,
  [4649] = 4484,
  [4650] = 3297,
  [4651] = 1753,
  [4652] = 3390,
  [4653] = 4484,
  [4654] = 1804,
  [4655] = 4484,
  [4656] = 1646,
  [4657] = 4484,
  [4658] = 3765,
  [4659] = 1826,
  [4660] = 1801,
  [4661] = 1749,
  [4662] = 1836,
  [4663] = 1724,
  [4664] = 3388,
  [4665] = 1752,
  [4666] = 3379,
  [4667] = 1739,
  [4668] = 1752,
  [4669] = 1753,
  [4670] = 1744,
  [4671] = 4519,
  [4672] = 1792,
  [4673] = 1492,
  [4674] = 4484,
  [4675] = 3339,
  [4676] = 1783,
  [4677] = 1730,
  [4678] = 3335,
  [4679] = 1748,
  [4680] = 1784,
  [4681] = 3297,
  [4682] = 1646,
  [4683] = 1805,
  [4684] = 1806,
  [4685] = 1805,
  [4686] = 1804,
  [4687] = 3379,
  [4688] = 1826,
  [4689] = 1739,
  [4690] = 1724,
  [4691] = 1752,
  [4692] = 3390,
  [4693] = 1753,
  [4694] = 4484,
  [4695] = 1744,
  [4696] = 1804,
  [4697] = 1836,
  [4698] = 2731,
  [4699] = 1739,
  [4700] = 4563,
  [4701] = 1801,
  [4702] = 4702,
  [4703] = 4703,
  [4704] = 4484,
  [4705] = 4484,
  [4706] = 3298,
  [4707] = 1514,
  [4708] = 4484,
  [4709] = 4484,
  [4710] = 1734,
  [4711] = 3398,
  [4712] = 1753,
  [4713] = 1639,
  [4714] = 1730,
  [4715] = 1730,
  [4716] = 1619,
  [4717] = 4717,
  [4718] = 1793,
  [4719] = 1621,
  [4720] = 1622,
  [4721] = 1624,
  [4722] = 1793,
  [4723] = 4723,
  [4724] = 3765,
  [4725] = 1514,
  [4726] = 1542,
  [4727] = 1467,
  [4728] = 1502,
  [4729] = 3765,
  [4730] = 1804,
  [4731] = 2767,
  [4732] = 1805,
  [4733] = 2731,
  [4734] = 1509,
  [4735] = 4329,
  [4736] = 4514,
  [4737] = 1724,
  [4738] = 1836,
  [4739] = 3398,
  [4740] = 1749,
  [4741] = 3765,
  [4742] = 2731,
  [4743] = 1734,
  [4744] = 2767,
  [4745] = 1748,
  [4746] = 4746,
  [4747] = 1467,
  [4748] = 1805,
  [4749] = 1528,
  [4750] = 3047,
  [4751] = 4751,
  [4752] = 1806,
  [4753] = 1526,
  [4754] = 1748,
  [4755] = 1748,
  [4756] = 4514,
  [4757] = 1509,
  [4758] = 1520,
  [4759] = 1734,
  [4760] = 3398,
  [4761] = 3765,
  [4762] = 2731,
  [4763] = 1514,
  [4764] = 1784,
  [4765] = 2767,
  [4766] = 1520,
  [4767] = 1783,
  [4768] = 3058,
  [4769] = 3765,
  [4770] = 1805,
  [4771] = 2767,
  [4772] = 1615,
  [4773] = 2731,
  [4774] = 1784,
  [4775] = 4775,
  [4776] = 1624,
  [4777] = 1826,
  [4778] = 1783,
  [4779] = 1806,
  [4780] = 1734,
  [4781] = 1622,
  [4782] = 4775,
  [4783] = 1520,
  [4784] = 1644,
  [4785] = 4329,
  [4786] = 1804,
  [4787] = 1639,
  [4788] = 1801,
  [4789] = 1748,
  [4790] = 1744,
  [4791] = 1753,
  [4792] = 1752,
  [4793] = 1739,
  [4794] = 1502,
  [4795] = 1749,
  [4796] = 1724,
  [4797] = 1836,
  [4798] = 1749,
  [4799] = 1801,
  [4800] = 1826,
  [4801] = 1744,
  [4802] = 1753,
  [4803] = 1752,
  [4804] = 2731,
  [4805] = 1836,
  [4806] = 1621,
  [4807] = 4807,
  [4808] = 1542,
  [4809] = 1801,
  [4810] = 1826,
  [4811] = 4811,
  [4812] = 1730,
  [4813] = 1748,
  [4814] = 4814,
  [4815] = 1739,
  [4816] = 1805,
  [4817] = 1806,
  [4818] = 1724,
  [4819] = 1724,
  [4820] = 1804,
  [4821] = 1502,
  [4822] = 2767,
  [4823] = 3765,
  [4824] = 4811,
  [4825] = 1621,
  [4826] = 1734,
  [4827] = 1793,
  [4828] = 1784,
  [4829] = 2731,
  [4830] = 1783,
  [4831] = 4831,
  [4832] = 1619,
  [4833] = 1520,
  [4834] = 1644,
  [4835] = 1836,
  [4836] = 1622,
  [4837] = 1739,
  [4838] = 1752,
  [4839] = 1753,
  [4840] = 1744,
  [4841] = 1502,
  [4842] = 1744,
  [4843] = 1753,
  [4844] = 1752,
  [4845] = 1739,
  [4846] = 4846,
  [4847] = 4847,
  [4848] = 1749,
  [4849] = 4847,
  [4850] = 4850,
  [4851] = 1730,
  [4852] = 1528,
  [4853] = 4853,
  [4854] = 1624,
  [4855] = 4807,
  [4856] = 1724,
  [4857] = 1836,
  [4858] = 4858,
  [4859] = 1749,
  [4860] = 4850,
  [4861] = 1826,
  [4862] = 1526,
  [4863] = 4863,
  [4864] = 4864,
  [4865] = 1801,
  [4866] = 1826,
  [4867] = 1542,
  [4868] = 4514,
  [4869] = 1615,
  [4870] = 4853,
  [4871] = 4717,
  [4872] = 1806,
  [4873] = 4873,
  [4874] = 1734,
  [4875] = 1615,
  [4876] = 1619,
  [4877] = 1783,
  [4878] = 2731,
  [4879] = 1734,
  [4880] = 1784,
  [4881] = 1739,
  [4882] = 1801,
  [4883] = 1526,
  [4884] = 1752,
  [4885] = 1805,
  [4886] = 1542,
  [4887] = 4887,
  [4888] = 4751,
  [4889] = 1514,
  [4890] = 1744,
  [4891] = 2767,
  [4892] = 1730,
  [4893] = 1793,
  [4894] = 1730,
  [4895] = 1806,
  [4896] = 1509,
  [4897] = 1826,
  [4898] = 1801,
  [4899] = 1749,
  [4900] = 1793,
  [4901] = 3765,
  [4902] = 1793,
  [4903] = 1804,
  [4904] = 1836,
  [4905] = 1804,
  [4906] = 4831,
  [4907] = 4846,
  [4908] = 1526,
  [4909] = 1724,
  [4910] = 2767,
  [4911] = 1748,
  [4912] = 1805,
  [4913] = 1806,
  [4914] = 1528,
  [4915] = 1804,
  [4916] = 1739,
  [4917] = 1639,
  [4918] = 1784,
  [4919] = 1783,
  [4920] = 1784,
  [4921] = 1783,
  [4922] = 1744,
  [4923] = 1753,
  [4924] = 1752,
  [4925] = 1657,
  [4926] = 1542,
  [4927] = 2767,
  [4928] = 4928,
  [4929] = 1528,
  [4930] = 2731,
  [4931] = 1646,
  [4932] = 1502,
  [4933] = 4850,
  [4934] = 1492,
  [4935] = 1520,
  [4936] = 4936,
  [4937] = 1631,
  [4938] = 1492,
  [4939] = 1633,
  [4940] = 1615,
  [4941] = 1619,
  [4942] = 4850,
  [4943] = 1514,
  [4944] = 1492,
  [4945] = 4514,
  [4946] = 1528,
  [4947] = 1520,
  [4948] = 4948,
  [4949] = 1656,
  [4950] = 4850,
  [4951] = 1621,
  [4952] = 1664,
  [4953] = 2731,
  [4954] = 1653,
  [4955] = 1509,
  [4956] = 1639,
  [4957] = 1777,
  [4958] = 1526,
  [4959] = 2731,
  [4960] = 1664,
  [4961] = 1502,
  [4962] = 1642,
  [4963] = 1509,
  [4964] = 1542,
  [4965] = 4948,
  [4966] = 3765,
  [4967] = 1624,
  [4968] = 1619,
  [4969] = 1622,
  [4970] = 1617,
  [4971] = 1621,
  [4972] = 1656,
  [4973] = 3765,
  [4974] = 1633,
  [4975] = 1663,
  [4976] = 2767,
  [4977] = 1651,
  [4978] = 1492,
  [4979] = 1654,
  [4980] = 1631,
  [4981] = 1520,
  [4982] = 1646,
  [4983] = 1651,
  [4984] = 1467,
  [4985] = 1526,
  [4986] = 1663,
  [4987] = 4987,
  [4988] = 4514,
  [4989] = 1646,
  [4990] = 1631,
  [4991] = 1633,
  [4992] = 1642,
  [4993] = 1658,
  [4994] = 1509,
  [4995] = 1502,
  [4996] = 1514,
  [4997] = 1542,
  [4998] = 1790,
  [4999] = 1615,
  [5000] = 1777,
  [5001] = 1622,
  [5002] = 1777,
  [5003] = 1619,
  [5004] = 1624,
  [5005] = 1520,
  [5006] = 2767,
  [5007] = 1619,
  [5008] = 1624,
  [5009] = 1514,
  [5010] = 1639,
  [5011] = 1622,
  [5012] = 1653,
  [5013] = 1502,
  [5014] = 1654,
  [5015] = 1624,
  [5016] = 1790,
  [5017] = 3398,
  [5018] = 1542,
  [5019] = 1622,
  [5020] = 1621,
  [5021] = 1790,
  [5022] = 5022,
  [5023] = 1615,
  [5024] = 1621,
  [5025] = 3765,
  [5026] = 1633,
  [5027] = 4514,
  [5028] = 4987,
  [5029] = 3398,
  [5030] = 1514,
  [5031] = 4514,
  [5032] = 1514,
  [5033] = 2767,
  [5034] = 1664,
  [5035] = 1633,
  [5036] = 1528,
  [5037] = 1631,
  [5038] = 1514,
  [5039] = 1639,
  [5040] = 3398,
  [5041] = 1526,
  [5042] = 1639,
  [5043] = 1658,
  [5044] = 2731,
  [5045] = 5022,
  [5046] = 1509,
  [5047] = 1492,
  [5048] = 1657,
  [5049] = 2731,
  [5050] = 1526,
  [5051] = 3398,
  [5052] = 1615,
  [5053] = 1528,
  [5054] = 2767,
  [5055] = 4928,
  [5056] = 5056,
  [5057] = 3765,
  [5058] = 1631,
  [5059] = 1617,
  [5060] = 1793,
  [5061] = 1646,
  [5062] = 5022,
  [5063] = 1619,
  [5064] = 1657,
  [5065] = 5065,
  [5066] = 1786,
  [5067] = 1528,
  [5068] = 3047,
  [5069] = 1658,
  [5070] = 1514,
  [5071] = 1528,
  [5072] = 1663,
  [5073] = 1653,
  [5074] = 1733,
  [5075] = 1651,
  [5076] = 1654,
  [5077] = 4514,
  [5078] = 5078,
  [5079] = 1644,
  [5080] = 5080,
  [5081] = 1760,
  [5082] = 1786,
  [5083] = 1755,
  [5084] = 5084,
  [5085] = 1656,
  [5086] = 1836,
  [5087] = 5087,
  [5088] = 1730,
  [5089] = 1805,
  [5090] = 1806,
  [5091] = 1804,
  [5092] = 1731,
  [5093] = 1784,
  [5094] = 1783,
  [5095] = 1744,
  [5096] = 1753,
  [5097] = 1752,
  [5098] = 1619,
  [5099] = 1739,
  [5100] = 1724,
  [5101] = 3058,
  [5102] = 1749,
  [5103] = 1801,
  [5104] = 1514,
  [5105] = 1726,
  [5106] = 1617,
  [5107] = 1631,
  [5108] = 1492,
  [5109] = 1633,
  [5110] = 1826,
  [5111] = 5111,
  [5112] = 1759,
  [5113] = 1633,
  [5114] = 1765,
  [5115] = 1631,
  [5116] = 1760,
  [5117] = 5117,
  [5118] = 5118,
  [5119] = 5119,
  [5120] = 5120,
  [5121] = 5121,
  [5122] = 1772,
  [5123] = 1790,
  [5124] = 5124,
  [5125] = 1757,
  [5126] = 1732,
  [5127] = 5127,
  [5128] = 1755,
  [5129] = 1755,
  [5130] = 1622,
  [5131] = 3765,
  [5132] = 1642,
  [5133] = 5133,
  [5134] = 1723,
  [5135] = 5135,
  [5136] = 1735,
  [5137] = 5137,
  [5138] = 1615,
  [5139] = 5139,
  [5140] = 1740,
  [5141] = 3398,
  [5142] = 3047,
  [5143] = 1621,
  [5144] = 1664,
  [5145] = 1651,
  [5146] = 1615,
  [5147] = 1741,
  [5148] = 1624,
  [5149] = 1733,
  [5150] = 5150,
  [5151] = 3398,
  [5152] = 1509,
  [5153] = 1621,
  [5154] = 1622,
  [5155] = 1774,
  [5156] = 1758,
  [5157] = 1730,
  [5158] = 3765,
  [5159] = 1624,
  [5160] = 1747,
  [5161] = 1746,
  [5162] = 1793,
  [5163] = 1826,
  [5164] = 1801,
  [5165] = 1749,
  [5166] = 3765,
  [5167] = 1763,
  [5168] = 1631,
  [5169] = 1742,
  [5170] = 1766,
  [5171] = 4514,
  [5172] = 1633,
  [5173] = 1509,
  [5174] = 5065,
  [5175] = 1639,
  [5176] = 1748,
  [5177] = 5084,
  [5178] = 1774,
  [5179] = 1768,
  [5180] = 3058,
  [5181] = 1747,
  [5182] = 1746,
  [5183] = 5078,
  [5184] = 1732,
  [5185] = 1836,
  [5186] = 1663,
  [5187] = 1724,
  [5188] = 1658,
  [5189] = 1739,
  [5190] = 1752,
  [5191] = 1753,
  [5192] = 1492,
  [5193] = 1664,
  [5194] = 5078,
  [5195] = 5080,
  [5196] = 5084,
  [5197] = 1657,
  [5198] = 1656,
  [5199] = 1514,
  [5200] = 1654,
  [5201] = 1734,
  [5202] = 1653,
  [5203] = 1619,
  [5204] = 5150,
  [5205] = 1744,
  [5206] = 2767,
  [5207] = 1642,
  [5208] = 2731,
  [5209] = 5118,
  [5210] = 5119,
  [5211] = 5121,
  [5212] = 1783,
  [5213] = 1784,
  [5214] = 1756,
  [5215] = 1768,
  [5216] = 1789,
  [5217] = 5217,
  [5218] = 1792,
  [5219] = 1731,
  [5220] = 1617,
  [5221] = 5150,
  [5222] = 2767,
  [5223] = 5127,
  [5224] = 1734,
  [5225] = 5133,
  [5226] = 5135,
  [5227] = 1646,
  [5228] = 2767,
  [5229] = 5137,
  [5230] = 1526,
  [5231] = 5139,
  [5232] = 1726,
  [5233] = 1528,
  [5234] = 5118,
  [5235] = 3398,
  [5236] = 1617,
  [5237] = 5065,
  [5238] = 1730,
  [5239] = 1748,
  [5240] = 1759,
  [5241] = 5080,
  [5242] = 1804,
  [5243] = 3765,
  [5244] = 1806,
  [5245] = 1805,
  [5246] = 5121,
  [5247] = 2731,
  [5248] = 1542,
  [5249] = 5124,
  [5250] = 1502,
  [5251] = 1792,
  [5252] = 1789,
  [5253] = 1756,
  [5254] = 1615,
  [5255] = 3398,
  [5256] = 1520,
  [5257] = 5127,
  [5258] = 5120,
  [5259] = 5117,
  [5260] = 1621,
  [5261] = 1622,
  [5262] = 5133,
  [5263] = 1624,
  [5264] = 1805,
  [5265] = 1509,
  [5266] = 1651,
  [5267] = 1790,
  [5268] = 1656,
  [5269] = 1768,
  [5270] = 1730,
  [5271] = 1658,
  [5272] = 1663,
  [5273] = 1765,
  [5274] = 5135,
  [5275] = 5137,
  [5276] = 1790,
  [5277] = 1772,
  [5278] = 3398,
  [5279] = 5139,
  [5280] = 1642,
  [5281] = 3165,
  [5282] = 5111,
  [5283] = 5124,
  [5284] = 3222,
  [5285] = 2731,
  [5286] = 1492,
  [5287] = 3165,
  [5288] = 2767,
  [5289] = 1619,
  [5290] = 1730,
  [5291] = 5120,
  [5292] = 3222,
  [5293] = 1639,
  [5294] = 1792,
  [5295] = 1646,
  [5296] = 5117,
  [5297] = 1789,
  [5298] = 1756,
  [5299] = 5119,
  [5300] = 1826,
  [5301] = 1760,
  [5302] = 1801,
  [5303] = 1749,
  [5304] = 1646,
  [5305] = 1836,
  [5306] = 1724,
  [5307] = 1739,
  [5308] = 1733,
  [5309] = 1752,
  [5310] = 1753,
  [5311] = 1732,
  [5312] = 1731,
  [5313] = 1726,
  [5314] = 1744,
  [5315] = 1756,
  [5316] = 1783,
  [5317] = 1759,
  [5318] = 1765,
  [5319] = 1784,
  [5320] = 1757,
  [5321] = 1804,
  [5322] = 1756,
  [5323] = 1806,
  [5324] = 1789,
  [5325] = 1642,
  [5326] = 1792,
  [5327] = 1772,
  [5328] = 3765,
  [5329] = 1766,
  [5330] = 1789,
  [5331] = 3058,
  [5332] = 1793,
  [5333] = 1757,
  [5334] = 1657,
  [5335] = 1786,
  [5336] = 1742,
  [5337] = 1723,
  [5338] = 1763,
  [5339] = 1748,
  [5340] = 1723,
  [5341] = 1654,
  [5342] = 1615,
  [5343] = 1621,
  [5344] = 1622,
  [5345] = 1644,
  [5346] = 1624,
  [5347] = 1492,
  [5348] = 1735,
  [5349] = 1740,
  [5350] = 1758,
  [5351] = 1741,
  [5352] = 1664,
  [5353] = 1792,
  [5354] = 1758,
  [5355] = 1639,
  [5356] = 1509,
  [5357] = 1653,
  [5358] = 1763,
  [5359] = 1467,
  [5360] = 1742,
  [5361] = 1790,
  [5362] = 3222,
  [5363] = 1766,
  [5364] = 1741,
  [5365] = 1664,
  [5366] = 1740,
  [5367] = 1639,
  [5368] = 1734,
  [5369] = 3165,
  [5370] = 1617,
  [5371] = 1735,
  [5372] = 1514,
  [5373] = 5111,
  [5374] = 1653,
  [5375] = 1654,
  [5376] = 3047,
  [5377] = 2767,
  [5378] = 1657,
  [5379] = 1631,
  [5380] = 2731,
  [5381] = 1633,
  [5382] = 1514,
  [5383] = 2731,
  [5384] = 1836,
  [5385] = 1723,
  [5386] = 5137,
  [5387] = 1633,
  [5388] = 1657,
  [5389] = 1631,
  [5390] = 1658,
  [5391] = 1826,
  [5392] = 1801,
  [5393] = 1749,
  [5394] = 1836,
  [5395] = 1724,
  [5396] = 1739,
  [5397] = 1752,
  [5398] = 1753,
  [5399] = 1744,
  [5400] = 1783,
  [5401] = 1784,
  [5402] = 1804,
  [5403] = 1806,
  [5404] = 1805,
  [5405] = 5139,
  [5406] = 5406,
  [5407] = 5139,
  [5408] = 1663,
  [5409] = 1656,
  [5410] = 1734,
  [5411] = 5135,
  [5412] = 5133,
  [5413] = 1654,
  [5414] = 1653,
  [5415] = 1748,
  [5416] = 1651,
  [5417] = 5065,
  [5418] = 1793,
  [5419] = 5127,
  [5420] = 1633,
  [5421] = 1642,
  [5422] = 1631,
  [5423] = 5078,
  [5424] = 1760,
  [5425] = 5080,
  [5426] = 5121,
  [5427] = 5119,
  [5428] = 1633,
  [5429] = 5118,
  [5430] = 5406,
  [5431] = 1617,
  [5432] = 1733,
  [5433] = 1732,
  [5434] = 1755,
  [5435] = 1631,
  [5436] = 5080,
  [5437] = 5078,
  [5438] = 1731,
  [5439] = 1726,
  [5440] = 1792,
  [5441] = 1789,
  [5442] = 1756,
  [5443] = 5406,
  [5444] = 1759,
  [5445] = 5118,
  [5446] = 5119,
  [5447] = 5117,
  [5448] = 1793,
  [5449] = 5120,
  [5450] = 1826,
  [5451] = 1801,
  [5452] = 1749,
  [5453] = 1724,
  [5454] = 1786,
  [5455] = 1739,
  [5456] = 1752,
  [5457] = 5121,
  [5458] = 1631,
  [5459] = 5065,
  [5460] = 1633,
  [5461] = 1790,
  [5462] = 1753,
  [5463] = 1744,
  [5464] = 1783,
  [5465] = 1784,
  [5466] = 1528,
  [5467] = 1804,
  [5468] = 1748,
  [5469] = 1806,
  [5470] = 1805,
  [5471] = 5124,
  [5472] = 1765,
  [5473] = 1772,
  [5474] = 1757,
  [5475] = 1723,
  [5476] = 5137,
  [5477] = 1735,
  [5478] = 1514,
  [5479] = 5135,
  [5480] = 5127,
  [5481] = 1740,
  [5482] = 1741,
  [5483] = 1758,
  [5484] = 1734,
  [5485] = 5133,
  [5486] = 1763,
  [5487] = 1742,
  [5488] = 1766,
  [5489] = 5406,
  [5490] = 5133,
  [5491] = 5137,
  [5492] = 1768,
  [5493] = 5139,
  [5494] = 3398,
  [5495] = 5495,
  [5496] = 5496,
  [5497] = 5406,
  [5498] = 5150,
  [5499] = 5117,
  [5500] = 5120,
  [5501] = 1777,
  [5502] = 1664,
  [5503] = 5135,
  [5504] = 3765,
  [5505] = 5124,
  [5506] = 3047,
  [5507] = 1792,
  [5508] = 1789,
  [5509] = 1756,
  [5510] = 1492,
  [5511] = 5406,
  [5512] = 5512,
  [5513] = 1664,
  [5514] = 1768,
  [5515] = 1766,
  [5516] = 1742,
  [5517] = 1763,
  [5518] = 1733,
  [5519] = 1758,
  [5520] = 1741,
  [5521] = 1740,
  [5522] = 1735,
  [5523] = 5523,
  [5524] = 1723,
  [5525] = 1757,
  [5526] = 5406,
  [5527] = 1772,
  [5528] = 1765,
  [5529] = 1759,
  [5530] = 5150,
  [5531] = 5406,
  [5532] = 1726,
  [5533] = 4514,
  [5534] = 1731,
  [5535] = 5406,
  [5536] = 1732,
  [5537] = 3058,
  [5538] = 5084,
  [5539] = 1760,
  [5540] = 5406,
  [5541] = 5541,
  [5542] = 3047,
  [5543] = 5406,
  [5544] = 5406,
  [5545] = 5545,
  [5546] = 5546,
  [5547] = 3165,
  [5548] = 3058,
  [5549] = 2767,
  [5550] = 1730,
  [5551] = 5406,
  [5552] = 5406,
  [5553] = 5084,
  [5554] = 2767,
  [5555] = 2767,
  [5556] = 5556,
  [5557] = 5406,
  [5558] = 5084,
  [5559] = 5127,
  [5560] = 5124,
  [5561] = 1755,
  [5562] = 1646,
  [5563] = 1790,
  [5564] = 1777,
  [5565] = 2731,
  [5566] = 5117,
  [5567] = 5120,
  [5568] = 3222,
  [5569] = 1619,
  [5570] = 1786,
  [5571] = 5124,
  [5572] = 2731,
  [5573] = 5120,
  [5574] = 5117,
  [5575] = 5406,
  [5576] = 5139,
  [5577] = 5137,
  [5578] = 5406,
  [5579] = 5135,
  [5580] = 5133,
  [5581] = 1646,
  [5582] = 5582,
  [5583] = 5121,
  [5584] = 5119,
  [5585] = 5118,
  [5586] = 5150,
  [5587] = 5080,
  [5588] = 5078,
  [5589] = 5084,
  [5590] = 5590,
  [5591] = 5065,
  [5592] = 5087,
  [5593] = 5406,
  [5594] = 3398,
  [5595] = 5406,
  [5596] = 3165,
  [5597] = 5406,
  [5598] = 5406,
  [5599] = 1730,
  [5600] = 1734,
  [5601] = 3222,
  [5602] = 5087,
  [5603] = 2731,
  [5604] = 5604,
  [5605] = 1790,
  [5606] = 1657,
  [5607] = 5406,
  [5608] = 3222,
  [5609] = 1654,
  [5610] = 5406,
  [5611] = 1653,
  [5612] = 5406,
  [5613] = 3047,
  [5614] = 5406,
  [5615] = 5087,
  [5616] = 5406,
  [5617] = 1617,
  [5618] = 1642,
  [5619] = 5406,
  [5620] = 5065,
  [5621] = 1651,
  [5622] = 5087,
  [5623] = 1653,
  [5624] = 4514,
  [5625] = 1654,
  [5626] = 1656,
  [5627] = 1657,
  [5628] = 1658,
  [5629] = 1663,
  [5630] = 5406,
  [5631] = 5406,
  [5632] = 4514,
  [5633] = 1730,
  [5634] = 5406,
  [5635] = 1642,
  [5636] = 5636,
  [5637] = 5406,
  [5638] = 5638,
  [5639] = 1617,
  [5640] = 3058,
  [5641] = 5406,
  [5642] = 2767,
  [5643] = 2731,
  [5644] = 3165,
  [5645] = 3765,
  [5646] = 5087,
  [5647] = 4514,
  [5648] = 3222,
  [5649] = 5406,
  [5650] = 1790,
  [5651] = 3765,
  [5652] = 5078,
  [5653] = 5495,
  [5654] = 1644,
  [5655] = 5406,
  [5656] = 1748,
  [5657] = 5512,
  [5658] = 1664,
  [5659] = 5080,
  [5660] = 5541,
  [5661] = 5661,
  [5662] = 5546,
  [5663] = 5556,
  [5664] = 5406,
  [5665] = 1639,
  [5666] = 5406,
  [5667] = 5150,
  [5668] = 5582,
  [5669] = 3165,
  [5670] = 1756,
  [5671] = 1789,
  [5672] = 5590,
  [5673] = 5406,
  [5674] = 5406,
  [5675] = 1792,
  [5676] = 5406,
  [5677] = 1786,
  [5678] = 1793,
  [5679] = 5118,
  [5680] = 5119,
  [5681] = 5636,
  [5682] = 1755,
  [5683] = 5638,
  [5684] = 5661,
  [5685] = 5685,
  [5686] = 1520,
  [5687] = 1805,
  [5688] = 5127,
  [5689] = 1502,
  [5690] = 1806,
  [5691] = 1804,
  [5692] = 1542,
  [5693] = 5685,
  [5694] = 1784,
  [5695] = 1783,
  [5696] = 5406,
  [5697] = 1528,
  [5698] = 1526,
  [5699] = 1492,
  [5700] = 1744,
  [5701] = 1753,
  [5702] = 1752,
  [5703] = 1514,
  [5704] = 1739,
  [5705] = 1663,
  [5706] = 1658,
  [5707] = 1656,
  [5708] = 1651,
  [5709] = 1509,
  [5710] = 1624,
  [5711] = 1622,
  [5712] = 1826,
  [5713] = 1801,
  [5714] = 1749,
  [5715] = 1836,
  [5716] = 1724,
  [5717] = 1621,
  [5718] = 1724,
  [5719] = 1836,
  [5720] = 1492,
  [5721] = 1739,
  [5722] = 1752,
  [5723] = 1753,
  [5724] = 1744,
  [5725] = 1749,
  [5726] = 1783,
  [5727] = 1784,
  [5728] = 1804,
  [5729] = 1806,
  [5730] = 1805,
  [5731] = 5406,
  [5732] = 1615,
  [5733] = 1801,
  [5734] = 1826,
  [5735] = 1786,
  [5736] = 5121,
  [5737] = 3222,
  [5738] = 3058,
  [5739] = 1492,
  [5740] = 1760,
  [5741] = 1755,
  [5742] = 3165,
  [5743] = 3047,
  [5744] = 1733,
  [5745] = 1732,
  [5746] = 1731,
  [5747] = 1726,
  [5748] = 1766,
  [5749] = 1617,
  [5750] = 1759,
  [5751] = 1765,
  [5752] = 1772,
  [5753] = 1642,
  [5754] = 1757,
  [5755] = 1723,
  [5756] = 1735,
  [5757] = 1740,
  [5758] = 1741,
  [5759] = 1653,
  [5760] = 1758,
  [5761] = 1654,
  [5762] = 1763,
  [5763] = 1657,
  [5764] = 1664,
  [5765] = 1646,
  [5766] = 1766,
  [5767] = 1748,
  [5768] = 1768,
  [5769] = 1631,
  [5770] = 1633,
  [5771] = 1742,
  [5772] = 1760,
  [5773] = 1733,
  [5774] = 1732,
  [5775] = 1731,
  [5776] = 1726,
  [5777] = 1793,
  [5778] = 1759,
  [5779] = 1765,
  [5780] = 1772,
  [5781] = 1646,
  [5782] = 1492,
  [5783] = 1730,
  [5784] = 1757,
  [5785] = 1734,
  [5786] = 1792,
  [5787] = 1789,
  [5788] = 1756,
  [5789] = 1768,
  [5790] = 1742,
  [5791] = 1763,
  [5792] = 1758,
  [5793] = 1741,
  [5794] = 1740,
  [5795] = 1735,
  [5796] = 5796,
  [5797] = 1639,
  [5798] = 1786,
  [5799] = 1789,
  [5800] = 1744,
  [5801] = 1805,
  [5802] = 1806,
  [5803] = 3047,
  [5804] = 1804,
  [5805] = 1826,
  [5806] = 1801,
  [5807] = 1749,
  [5808] = 1836,
  [5809] = 1724,
  [5810] = 1786,
  [5811] = 5796,
  [5812] = 1755,
  [5813] = 1739,
  [5814] = 1619,
  [5815] = 1756,
  [5816] = 1752,
  [5817] = 1792,
  [5818] = 1753,
  [5819] = 1742,
  [5820] = 1789,
  [5821] = 1749,
  [5822] = 1756,
  [5823] = 5796,
  [5824] = 1768,
  [5825] = 1759,
  [5826] = 1731,
  [5827] = 1765,
  [5828] = 1772,
  [5829] = 1726,
  [5830] = 1642,
  [5831] = 1757,
  [5832] = 5796,
  [5833] = 1617,
  [5834] = 1763,
  [5835] = 1783,
  [5836] = 1784,
  [5837] = 1804,
  [5838] = 1806,
  [5839] = 1793,
  [5840] = 5796,
  [5841] = 1805,
  [5842] = 1784,
  [5843] = 1783,
  [5844] = 1748,
  [5845] = 3765,
  [5846] = 5796,
  [5847] = 3058,
  [5848] = 1755,
  [5849] = 1744,
  [5850] = 1753,
  [5851] = 1752,
  [5852] = 1739,
  [5853] = 1758,
  [5854] = 1734,
  [5855] = 1492,
  [5856] = 3047,
  [5857] = 1724,
  [5858] = 1836,
  [5859] = 1801,
  [5860] = 5796,
  [5861] = 1733,
  [5862] = 1826,
  [5863] = 1723,
  [5864] = 5117,
  [5865] = 1735,
  [5866] = 5120,
  [5867] = 1740,
  [5868] = 2767,
  [5869] = 1741,
  [5870] = 1740,
  [5871] = 1792,
  [5872] = 1789,
  [5873] = 1735,
  [5874] = 1723,
  [5875] = 1757,
  [5876] = 2731,
  [5877] = 1826,
  [5878] = 1657,
  [5879] = 1756,
  [5880] = 1741,
  [5881] = 1651,
  [5882] = 1730,
  [5883] = 5124,
  [5884] = 1654,
  [5885] = 1806,
  [5886] = 1653,
  [5887] = 5796,
  [5888] = 1784,
  [5889] = 5796,
  [5890] = 5796,
  [5891] = 1772,
  [5892] = 5892,
  [5893] = 1653,
  [5894] = 1642,
  [5895] = 1758,
  [5896] = 1765,
  [5897] = 5084,
  [5898] = 5796,
  [5899] = 1792,
  [5900] = 1783,
  [5901] = 1789,
  [5902] = 1760,
  [5903] = 5796,
  [5904] = 1617,
  [5905] = 3165,
  [5906] = 1744,
  [5907] = 5796,
  [5908] = 1730,
  [5909] = 1492,
  [5910] = 5796,
  [5911] = 1753,
  [5912] = 5796,
  [5913] = 1752,
  [5914] = 3165,
  [5915] = 1514,
  [5916] = 3165,
  [5917] = 1654,
  [5918] = 3222,
  [5919] = 3165,
  [5920] = 1766,
  [5921] = 1793,
  [5922] = 5796,
  [5923] = 3222,
  [5924] = 3222,
  [5925] = 5796,
  [5926] = 1763,
  [5927] = 1759,
  [5928] = 5150,
  [5929] = 1790,
  [5930] = 1748,
  [5931] = 5796,
  [5932] = 1656,
  [5933] = 5796,
  [5934] = 1726,
  [5935] = 1509,
  [5936] = 5796,
  [5937] = 5796,
  [5938] = 1742,
  [5939] = 5796,
  [5940] = 1624,
  [5941] = 1657,
  [5942] = 1766,
  [5943] = 5796,
  [5944] = 1731,
  [5945] = 1658,
  [5946] = 1732,
  [5947] = 1663,
  [5948] = 1658,
  [5949] = 1656,
  [5950] = 1651,
  [5951] = 5124,
  [5952] = 1622,
  [5953] = 1526,
  [5954] = 5796,
  [5955] = 1733,
  [5956] = 5796,
  [5957] = 5087,
  [5958] = 5796,
  [5959] = 1621,
  [5960] = 1528,
  [5961] = 1756,
  [5962] = 5962,
  [5963] = 1760,
  [5964] = 5796,
  [5965] = 1664,
  [5966] = 1739,
  [5967] = 5150,
  [5968] = 5065,
  [5969] = 1724,
  [5970] = 5970,
  [5971] = 5796,
  [5972] = 1768,
  [5973] = 1836,
  [5974] = 1492,
  [5975] = 1749,
  [5976] = 1756,
  [5977] = 1789,
  [5978] = 5978,
  [5979] = 1792,
  [5980] = 5796,
  [5981] = 1663,
  [5982] = 1801,
  [5983] = 1826,
  [5984] = 1615,
  [5985] = 5796,
  [5986] = 1734,
  [5987] = 5796,
  [5988] = 2767,
  [5989] = 2731,
  [5990] = 5796,
  [5991] = 3222,
  [5992] = 5796,
  [5993] = 1804,
  [5994] = 1644,
  [5995] = 1730,
  [5996] = 5796,
  [5997] = 3765,
  [5998] = 1768,
  [5999] = 5796,
  [6000] = 1805,
  [6001] = 1792,
  [6002] = 1766,
  [6003] = 1806,
  [6004] = 1784,
  [6005] = 3765,
  [6006] = 5120,
  [6007] = 5796,
  [6008] = 1742,
  [6009] = 5796,
  [6010] = 1783,
  [6011] = 3398,
  [6012] = 5117,
  [6013] = 1542,
  [6014] = 5078,
  [6015] = 5796,
  [6016] = 1744,
  [6017] = 1502,
  [6018] = 1763,
  [6019] = 5796,
  [6020] = 5796,
  [6021] = 1753,
  [6022] = 1758,
  [6023] = 3765,
  [6024] = 5796,
  [6025] = 5080,
  [6026] = 5796,
  [6027] = 5084,
  [6028] = 3765,
  [6029] = 1730,
  [6030] = 2731,
  [6031] = 2731,
  [6032] = 2767,
  [6033] = 5796,
  [6034] = 2767,
  [6035] = 5796,
  [6036] = 1748,
  [6037] = 5796,
  [6038] = 1741,
  [6039] = 5119,
  [6040] = 1746,
  [6041] = 5796,
  [6042] = 1747,
  [6043] = 5117,
  [6044] = 5120,
  [6045] = 5796,
  [6046] = 1760,
  [6047] = 1805,
  [6048] = 1646,
  [6049] = 1746,
  [6050] = 1755,
  [6051] = 1732,
  [6052] = 5796,
  [6053] = 1752,
  [6054] = 1747,
  [6055] = 5065,
  [6056] = 4514,
  [6057] = 3058,
  [6058] = 1739,
  [6059] = 5078,
  [6060] = 1520,
  [6061] = 1774,
  [6062] = 5796,
  [6063] = 1774,
  [6064] = 1733,
  [6065] = 5124,
  [6066] = 5080,
  [6067] = 1793,
  [6068] = 1724,
  [6069] = 3047,
  [6070] = 1836,
  [6071] = 1786,
  [6072] = 1749,
  [6073] = 6073,
  [6074] = 1734,
  [6075] = 3058,
  [6076] = 5796,
  [6077] = 5796,
  [6078] = 1748,
  [6079] = 6079,
  [6080] = 5796,
  [6081] = 1740,
  [6082] = 1492,
  [6083] = 5118,
  [6084] = 1492,
  [6085] = 5150,
  [6086] = 5084,
  [6087] = 5796,
  [6088] = 5796,
  [6089] = 5796,
  [6090] = 1777,
  [6091] = 1731,
  [6092] = 5796,
  [6093] = 1734,
  [6094] = 1631,
  [6095] = 5796,
  [6096] = 1726,
  [6097] = 5121,
  [6098] = 5892,
  [6099] = 1793,
  [6100] = 1759,
  [6101] = 1765,
  [6102] = 1772,
  [6103] = 1633,
  [6104] = 1732,
  [6105] = 5796,
  [6106] = 1631,
  [6107] = 5127,
  [6108] = 1735,
  [6109] = 1514,
  [6110] = 5796,
  [6111] = 6073,
  [6112] = 5118,
  [6113] = 5133,
  [6114] = 3765,
  [6115] = 5119,
  [6116] = 1786,
  [6117] = 5796,
  [6118] = 1757,
  [6119] = 5121,
  [6120] = 5796,
  [6121] = 1801,
  [6122] = 1760,
  [6123] = 5135,
  [6124] = 5139,
  [6125] = 2731,
  [6126] = 5796,
  [6127] = 1755,
  [6128] = 2767,
  [6129] = 5119,
  [6130] = 1733,
  [6131] = 5796,
  [6132] = 5137,
  [6133] = 1723,
  [6134] = 5796,
  [6135] = 5796,
  [6136] = 1735,
  [6137] = 1633,
  [6138] = 5796,
  [6139] = 1740,
  [6140] = 2767,
  [6141] = 5796,
  [6142] = 6073,
  [6143] = 2731,
  [6144] = 1741,
  [6145] = 5065,
  [6146] = 5796,
  [6147] = 6147,
  [6148] = 1765,
  [6149] = 5139,
  [6150] = 5078,
  [6151] = 5080,
  [6152] = 5796,
  [6153] = 1731,
  [6154] = 5796,
  [6155] = 1726,
  [6156] = 5084,
  [6157] = 5796,
  [6158] = 5796,
  [6159] = 3195,
  [6160] = 5117,
  [6161] = 1631,
  [6162] = 5120,
  [6163] = 5124,
  [6164] = 5796,
  [6165] = 1759,
  [6166] = 1758,
  [6167] = 3765,
  [6168] = 5124,
  [6169] = 5065,
  [6170] = 1633,
  [6171] = 1763,
  [6172] = 1734,
  [6173] = 5127,
  [6174] = 1804,
  [6175] = 5150,
  [6176] = 1723,
  [6177] = 5796,
  [6178] = 5139,
  [6179] = 5137,
  [6180] = 5796,
  [6181] = 5796,
  [6182] = 1742,
  [6183] = 5118,
  [6184] = 5119,
  [6185] = 5137,
  [6186] = 5121,
  [6187] = 1732,
  [6188] = 5127,
  [6189] = 5133,
  [6190] = 5796,
  [6191] = 5796,
  [6192] = 5135,
  [6193] = 5135,
  [6194] = 5133,
  [6195] = 1772,
  [6196] = 1766,
  [6197] = 5120,
  [6198] = 5137,
  [6199] = 5127,
  [6200] = 1757,
  [6201] = 5121,
  [6202] = 5796,
  [6203] = 1730,
  [6204] = 5139,
  [6205] = 5133,
  [6206] = 5135,
  [6207] = 5796,
  [6208] = 5796,
  [6209] = 1768,
  [6210] = 5118,
  [6211] = 5124,
  [6212] = 5117,
  [6213] = 5796,
  [6214] = 3398,
  [6215] = 5796,
  [6216] = 5120,
  [6217] = 5084,
  [6218] = 5117,
  [6219] = 5078,
  [6220] = 5080,
  [6221] = 1509,
  [6222] = 3195,
  [6223] = 5084,
  [6224] = 3195,
  [6225] = 5119,
  [6226] = 6226,
  [6227] = 3365,
  [6228] = 6228,
  [6229] = 1756,
  [6230] = 6230,
  [6231] = 6231,
  [6232] = 1789,
  [6233] = 3402,
  [6234] = 1792,
  [6235] = 1526,
  [6236] = 6236,
  [6237] = 1528,
  [6238] = 5087,
  [6239] = 6228,
  [6240] = 6240,
  [6241] = 3370,
  [6242] = 5150,
  [6243] = 1514,
  [6244] = 1542,
  [6245] = 3380,
  [6246] = 1502,
  [6247] = 3386,
  [6248] = 1520,
  [6249] = 1756,
  [6250] = 6228,
  [6251] = 5087,
  [6252] = 6226,
  [6253] = 1514,
  [6254] = 1492,
  [6255] = 1748,
  [6256] = 6228,
  [6257] = 1734,
  [6258] = 1792,
  [6259] = 1793,
  [6260] = 3165,
  [6261] = 1730,
  [6262] = 1789,
  [6263] = 1615,
  [6264] = 1792,
  [6265] = 6228,
  [6266] = 3222,
  [6267] = 1646,
  [6268] = 5087,
  [6269] = 1774,
  [6270] = 1631,
  [6271] = 1789,
  [6272] = 1633,
  [6273] = 6273,
  [6274] = 1747,
  [6275] = 1746,
  [6276] = 6226,
  [6277] = 1752,
  [6278] = 1756,
  [6279] = 6279,
  [6280] = 1631,
  [6281] = 1621,
  [6282] = 5065,
  [6283] = 1657,
  [6284] = 1622,
  [6285] = 6228,
  [6286] = 1514,
  [6287] = 5117,
  [6288] = 1805,
  [6289] = 1806,
  [6290] = 1786,
  [6291] = 5078,
  [6292] = 6292,
  [6293] = 6230,
  [6294] = 1624,
  [6295] = 5080,
  [6296] = 3398,
  [6297] = 4514,
  [6298] = 5118,
  [6299] = 6299,
  [6300] = 6228,
  [6301] = 6301,
  [6302] = 1804,
  [6303] = 5121,
  [6304] = 1653,
  [6305] = 3195,
  [6306] = 5127,
  [6307] = 5120,
  [6308] = 5133,
  [6309] = 5135,
  [6310] = 1784,
  [6311] = 1755,
  [6312] = 5137,
  [6313] = 1631,
  [6314] = 6279,
  [6315] = 6301,
  [6316] = 1492,
  [6317] = 6317,
  [6318] = 1514,
  [6319] = 5124,
  [6320] = 1744,
  [6321] = 1642,
  [6322] = 1753,
  [6323] = 1739,
  [6324] = 1783,
  [6325] = 3363,
  [6326] = 3379,
  [6327] = 1724,
  [6328] = 3388,
  [6329] = 1836,
  [6330] = 1749,
  [6331] = 3195,
  [6332] = 3390,
  [6333] = 1801,
  [6334] = 1826,
  [6335] = 1793,
  [6336] = 6273,
  [6337] = 3398,
  [6338] = 5087,
  [6339] = 1748,
  [6340] = 6228,
  [6341] = 1617,
  [6342] = 6342,
  [6343] = 1514,
  [6344] = 5139,
  [6345] = 6279,
  [6346] = 6228,
  [6347] = 1633,
  [6348] = 1734,
  [6349] = 1748,
  [6350] = 3297,
  [6351] = 3298,
  [6352] = 3335,
  [6353] = 3339,
  [6354] = 6228,
  [6355] = 1633,
  [6356] = 1631,
  [6357] = 6240,
  [6358] = 1790,
  [6359] = 1760,
  [6360] = 3398,
  [6361] = 6361,
  [6362] = 1492,
  [6363] = 1654,
  [6364] = 1514,
  [6365] = 1733,
  [6366] = 1732,
  [6367] = 1731,
  [6368] = 1726,
  [6369] = 1664,
  [6370] = 1639,
  [6371] = 1730,
  [6372] = 1759,
  [6373] = 1765,
  [6374] = 1772,
  [6375] = 1757,
  [6376] = 1734,
  [6377] = 6228,
  [6378] = 1723,
  [6379] = 1735,
  [6380] = 1740,
  [6381] = 1741,
  [6382] = 6240,
  [6383] = 1758,
  [6384] = 1763,
  [6385] = 1492,
  [6386] = 1742,
  [6387] = 1766,
  [6388] = 6292,
  [6389] = 1619,
  [6390] = 1768,
  [6391] = 1514,
  [6392] = 1730,
  [6393] = 1663,
  [6394] = 1658,
  [6395] = 1656,
  [6396] = 1651,
  [6397] = 3195,
  [6398] = 1492,
  [6399] = 1492,
  [6400] = 1631,
  [6401] = 6228,
  [6402] = 1633,
  [6403] = 1633,
  [6404] = 1793,
  [6405] = 1631,
  [6406] = 3058,
  [6407] = 1633,
  [6408] = 3047,
  [6409] = 6409,
  [6410] = 3380,
  [6411] = 6411,
  [6412] = 6411,
  [6413] = 1734,
  [6414] = 3047,
  [6415] = 3058,
  [6416] = 1631,
  [6417] = 3402,
  [6418] = 1633,
  [6419] = 3398,
  [6420] = 1792,
  [6421] = 6409,
  [6422] = 1792,
  [6423] = 6423,
  [6424] = 1789,
  [6425] = 3398,
  [6426] = 6423,
  [6427] = 6411,
  [6428] = 3386,
  [6429] = 3047,
  [6430] = 3222,
  [6431] = 1633,
  [6432] = 3380,
  [6433] = 5604,
  [6434] = 1631,
  [6435] = 3165,
  [6436] = 1748,
  [6437] = 6423,
  [6438] = 1792,
  [6439] = 3398,
  [6440] = 3365,
  [6441] = 6411,
  [6442] = 3363,
  [6443] = 6409,
  [6444] = 6411,
  [6445] = 1730,
  [6446] = 6411,
  [6447] = 6409,
  [6448] = 1633,
  [6449] = 6409,
  [6450] = 3165,
  [6451] = 3402,
  [6452] = 1631,
  [6453] = 6409,
  [6454] = 6411,
  [6455] = 6409,
  [6456] = 6456,
  [6457] = 6411,
  [6458] = 3222,
  [6459] = 1492,
  [6460] = 1514,
  [6461] = 6423,
  [6462] = 6409,
  [6463] = 1730,
  [6464] = 1793,
  [6465] = 1746,
  [6466] = 1747,
  [6467] = 6423,
  [6468] = 3222,
  [6469] = 6423,
  [6470] = 1730,
  [6471] = 3386,
  [6472] = 3380,
  [6473] = 6473,
  [6474] = 3165,
  [6475] = 1774,
  [6476] = 3365,
  [6477] = 3363,
  [6478] = 1730,
  [6479] = 3297,
  [6480] = 1756,
  [6481] = 1730,
  [6482] = 6423,
  [6483] = 3398,
  [6484] = 1760,
  [6485] = 6485,
  [6486] = 6486,
  [6487] = 1789,
  [6488] = 6411,
  [6489] = 1646,
  [6490] = 6409,
  [6491] = 6491,
  [6492] = 6423,
  [6493] = 6411,
  [6494] = 1792,
  [6495] = 6409,
  [6496] = 6411,
  [6497] = 6423,
  [6498] = 1752,
  [6499] = 1631,
  [6500] = 6411,
  [6501] = 1492,
  [6502] = 3195,
  [6503] = 1733,
  [6504] = 1756,
  [6505] = 6505,
  [6506] = 5084,
  [6507] = 6423,
  [6508] = 6409,
  [6509] = 3386,
  [6510] = 1793,
  [6511] = 6423,
  [6512] = 3379,
  [6513] = 1748,
  [6514] = 1639,
  [6515] = 3380,
  [6516] = 1732,
  [6517] = 3379,
  [6518] = 1790,
  [6519] = 6411,
  [6520] = 6409,
  [6521] = 3388,
  [6522] = 6411,
  [6523] = 3390,
  [6524] = 3339,
  [6525] = 1731,
  [6526] = 3379,
  [6527] = 6409,
  [6528] = 3388,
  [6529] = 1514,
  [6530] = 1792,
  [6531] = 1726,
  [6532] = 1805,
  [6533] = 6409,
  [6534] = 6409,
  [6535] = 1806,
  [6536] = 6411,
  [6537] = 1789,
  [6538] = 1804,
  [6539] = 6539,
  [6540] = 3388,
  [6541] = 6411,
  [6542] = 3390,
  [6543] = 6409,
  [6544] = 3390,
  [6545] = 1784,
  [6546] = 1663,
  [6547] = 1730,
  [6548] = 6423,
  [6549] = 1783,
  [6550] = 1744,
  [6551] = 6551,
  [6552] = 1753,
  [6553] = 3058,
  [6554] = 3297,
  [6555] = 6423,
  [6556] = 3298,
  [6557] = 6236,
  [6558] = 1633,
  [6559] = 3335,
  [6560] = 3339,
  [6561] = 6411,
  [6562] = 3298,
  [6563] = 1658,
  [6564] = 3335,
  [6565] = 1739,
  [6566] = 1724,
  [6567] = 3370,
  [6568] = 3339,
  [6569] = 3398,
  [6570] = 1836,
  [6571] = 1657,
  [6572] = 1749,
  [6573] = 6423,
  [6574] = 3386,
  [6575] = 1656,
  [6576] = 3402,
  [6577] = 3380,
  [6578] = 1801,
  [6579] = 1756,
  [6580] = 3370,
  [6581] = 6423,
  [6582] = 6411,
  [6583] = 3365,
  [6584] = 6423,
  [6585] = 6411,
  [6586] = 3297,
  [6587] = 3195,
  [6588] = 6423,
  [6589] = 6409,
  [6590] = 1826,
  [6591] = 3363,
  [6592] = 3339,
  [6593] = 6409,
  [6594] = 6409,
  [6595] = 1756,
  [6596] = 1759,
  [6597] = 6409,
  [6598] = 1514,
  [6599] = 3363,
  [6600] = 6411,
  [6601] = 1654,
  [6602] = 5127,
  [6603] = 3335,
  [6604] = 6473,
  [6605] = 3298,
  [6606] = 6409,
  [6607] = 6411,
  [6608] = 6409,
  [6609] = 1765,
  [6610] = 1772,
  [6611] = 3365,
  [6612] = 6409,
  [6613] = 1653,
  [6614] = 6411,
  [6615] = 1492,
  [6616] = 6423,
  [6617] = 6423,
  [6618] = 6618,
  [6619] = 6236,
  [6620] = 1631,
  [6621] = 1651,
  [6622] = 6411,
  [6623] = 6409,
  [6624] = 3298,
  [6625] = 3398,
  [6626] = 6236,
  [6627] = 3195,
  [6628] = 5124,
  [6629] = 3335,
  [6630] = 6409,
  [6631] = 1757,
  [6632] = 3390,
  [6633] = 3388,
  [6634] = 3379,
  [6635] = 6635,
  [6636] = 3386,
  [6637] = 6411,
  [6638] = 1723,
  [6639] = 3370,
  [6640] = 6236,
  [6641] = 6411,
  [6642] = 6411,
  [6643] = 5120,
  [6644] = 1735,
  [6645] = 5117,
  [6646] = 3370,
  [6647] = 3339,
  [6648] = 3402,
  [6649] = 1642,
  [6650] = 6423,
  [6651] = 3335,
  [6652] = 5139,
  [6653] = 6411,
  [6654] = 5137,
  [6655] = 5135,
  [6656] = 1740,
  [6657] = 5133,
  [6658] = 1741,
  [6659] = 6236,
  [6660] = 6423,
  [6661] = 5121,
  [6662] = 1509,
  [6663] = 5119,
  [6664] = 5118,
  [6665] = 5150,
  [6666] = 3165,
  [6667] = 1758,
  [6668] = 5080,
  [6669] = 6423,
  [6670] = 5078,
  [6671] = 1624,
  [6672] = 3365,
  [6673] = 3298,
  [6674] = 6409,
  [6675] = 6409,
  [6676] = 6423,
  [6677] = 1622,
  [6678] = 1621,
  [6679] = 3297,
  [6680] = 1789,
  [6681] = 3363,
  [6682] = 6411,
  [6683] = 5065,
  [6684] = 1615,
  [6685] = 1619,
  [6686] = 6686,
  [6687] = 1792,
  [6688] = 1763,
  [6689] = 6409,
  [6690] = 6409,
  [6691] = 6411,
  [6692] = 6409,
  [6693] = 5604,
  [6694] = 1755,
  [6695] = 3390,
  [6696] = 6456,
  [6697] = 6411,
  [6698] = 6409,
  [6699] = 1492,
  [6700] = 6411,
  [6701] = 1756,
  [6702] = 6486,
  [6703] = 6411,
  [6704] = 6409,
  [6705] = 3388,
  [6706] = 1789,
  [6707] = 3402,
  [6708] = 1786,
  [6709] = 3297,
  [6710] = 3370,
  [6711] = 1789,
  [6712] = 1768,
  [6713] = 6491,
  [6714] = 6411,
  [6715] = 3379,
  [6716] = 6423,
  [6717] = 1617,
  [6718] = 6423,
  [6719] = 1742,
  [6720] = 6409,
  [6721] = 1766,
  [6722] = 1514,
  [6723] = 1664,
  [6724] = 1492,
  [6725] = 1756,
  [6726] = 6423,
  [6727] = 1633,
  [6728] = 3222,
  [6729] = 3195,
  [6730] = 1732,
  [6731] = 1792,
  [6732] = 3365,
  [6733] = 3370,
  [6734] = 3363,
  [6735] = 1514,
  [6736] = 1731,
  [6737] = 3339,
  [6738] = 3165,
  [6739] = 1492,
  [6740] = 3335,
  [6741] = 3298,
  [6742] = 3402,
  [6743] = 3297,
  [6744] = 1733,
  [6745] = 1789,
  [6746] = 1726,
  [6747] = 3390,
  [6748] = 3222,
  [6749] = 3380,
  [6750] = 3386,
  [6751] = 1663,
  [6752] = 1658,
  [6753] = 5133,
  [6754] = 5135,
  [6755] = 6755,
  [6756] = 1657,
  [6757] = 1656,
  [6758] = 3388,
  [6759] = 1654,
  [6760] = 1653,
  [6761] = 1651,
  [6762] = 1759,
  [6763] = 5127,
  [6764] = 3402,
  [6765] = 1642,
  [6766] = 1617,
  [6767] = 1734,
  [6768] = 6768,
  [6769] = 6769,
  [6770] = 6770,
  [6771] = 3380,
  [6772] = 6772,
  [6773] = 6773,
  [6774] = 3165,
  [6775] = 1772,
  [6776] = 6776,
  [6777] = 6777,
  [6778] = 6778,
  [6779] = 1730,
  [6780] = 6778,
  [6781] = 6635,
  [6782] = 5137,
  [6783] = 6777,
  [6784] = 3398,
  [6785] = 1757,
  [6786] = 6635,
  [6787] = 1723,
  [6788] = 1756,
  [6789] = 3370,
  [6790] = 1793,
  [6791] = 3386,
  [6792] = 5604,
  [6793] = 6793,
  [6794] = 1760,
  [6795] = 6795,
  [6796] = 3165,
  [6797] = 6797,
  [6798] = 3380,
  [6799] = 3386,
  [6800] = 3222,
  [6801] = 1790,
  [6802] = 1756,
  [6803] = 1735,
  [6804] = 1740,
  [6805] = 1741,
  [6806] = 5080,
  [6807] = 6807,
  [6808] = 5121,
  [6809] = 1734,
  [6810] = 5119,
  [6811] = 1758,
  [6812] = 3365,
  [6813] = 5118,
  [6814] = 3363,
  [6815] = 1765,
  [6816] = 3165,
  [6817] = 6817,
  [6818] = 1646,
  [6819] = 3398,
  [6820] = 6820,
  [6821] = 6821,
  [6822] = 1756,
  [6823] = 6823,
  [6824] = 3388,
  [6825] = 1664,
  [6826] = 6826,
  [6827] = 1763,
  [6828] = 1631,
  [6829] = 3195,
  [6830] = 3390,
  [6831] = 6236,
  [6832] = 1633,
  [6833] = 1766,
  [6834] = 3379,
  [6835] = 1792,
  [6836] = 1734,
  [6837] = 3402,
  [6838] = 1789,
  [6839] = 1768,
  [6840] = 3379,
  [6841] = 3398,
  [6842] = 5065,
  [6843] = 3363,
  [6844] = 6826,
  [6845] = 6820,
  [6846] = 1756,
  [6847] = 6823,
  [6848] = 3386,
  [6849] = 6821,
  [6850] = 1748,
  [6851] = 1492,
  [6852] = 6817,
  [6853] = 6776,
  [6854] = 6854,
  [6855] = 1730,
  [6856] = 3222,
  [6857] = 3297,
  [6858] = 3380,
  [6859] = 3165,
  [6860] = 1753,
  [6861] = 3370,
  [6862] = 6236,
  [6863] = 3195,
  [6864] = 3365,
  [6865] = 3363,
  [6866] = 6777,
  [6867] = 1805,
  [6868] = 6778,
  [6869] = 1806,
  [6870] = 1804,
  [6871] = 3339,
  [6872] = 3335,
  [6873] = 1786,
  [6874] = 3298,
  [6875] = 1730,
  [6876] = 1784,
  [6877] = 5150,
  [6878] = 1783,
  [6879] = 1514,
  [6880] = 6769,
  [6881] = 6881,
  [6882] = 6793,
  [6883] = 1633,
  [6884] = 3297,
  [6885] = 6885,
  [6886] = 3365,
  [6887] = 1631,
  [6888] = 1742,
  [6889] = 3222,
  [6890] = 3298,
  [6891] = 3379,
  [6892] = 3335,
  [6893] = 3388,
  [6894] = 1789,
  [6895] = 3390,
  [6896] = 1730,
  [6897] = 3339,
  [6898] = 3297,
  [6899] = 1792,
  [6900] = 3298,
  [6901] = 3335,
  [6902] = 6902,
  [6903] = 3339,
  [6904] = 1631,
  [6905] = 1755,
  [6906] = 6236,
  [6907] = 3390,
  [6908] = 1744,
  [6909] = 3370,
  [6910] = 3388,
  [6911] = 3222,
  [6912] = 1492,
  [6913] = 6755,
  [6914] = 1789,
  [6915] = 5078,
  [6916] = 6916,
  [6917] = 1752,
  [6918] = 3379,
  [6919] = 1792,
  [6920] = 6920,
  [6921] = 6236,
  [6922] = 3398,
  [6923] = 1739,
  [6924] = 3402,
  [6925] = 1792,
  [6926] = 3222,
  [6927] = 3165,
  [6928] = 1724,
  [6929] = 1836,
  [6930] = 1730,
  [6931] = 1749,
  [6932] = 1789,
  [6933] = 5139,
  [6934] = 1756,
  [6935] = 1801,
  [6936] = 1826,
  [6937] = 1633,
  [6938] = 6938,
  [6939] = 6939,
  [6940] = 6940,
  [6941] = 6939,
  [6942] = 6940,
  [6943] = 6943,
  [6944] = 6944,
  [6945] = 6940,
  [6946] = 6944,
  [6947] = 6940,
  [6948] = 6948,
  [6949] = 6944,
  [6950] = 6939,
  [6951] = 6940,
  [6952] = 6952,
  [6953] = 6939,
  [6954] = 6939,
  [6955] = 6948,
  [6956] = 6940,
  [6957] = 1730,
  [6958] = 6952,
  [6959] = 6944,
  [6960] = 6948,
  [6961] = 1792,
  [6962] = 1789,
  [6963] = 6948,
  [6964] = 6944,
  [6965] = 6940,
  [6966] = 1734,
  [6967] = 6939,
  [6968] = 6968,
  [6969] = 6968,
  [6970] = 1748,
  [6971] = 6943,
  [6972] = 6948,
  [6973] = 6944,
  [6974] = 6944,
  [6975] = 1793,
  [6976] = 6948,
  [6977] = 1724,
  [6978] = 1804,
  [6979] = 1730,
  [6980] = 1826,
  [6981] = 1730,
  [6982] = 1749,
  [6983] = 6968,
  [6984] = 3058,
  [6985] = 1836,
  [6986] = 6940,
  [6987] = 1739,
  [6988] = 6939,
  [6989] = 6989,
  [6990] = 1752,
  [6991] = 6939,
  [6992] = 6940,
  [6993] = 1753,
  [6994] = 1744,
  [6995] = 6944,
  [6996] = 6948,
  [6997] = 6952,
  [6998] = 1783,
  [6999] = 1784,
  [7000] = 5084,
  [7001] = 6948,
  [7002] = 6944,
  [7003] = 6940,
  [7004] = 6939,
  [7005] = 6939,
  [7006] = 1806,
  [7007] = 6939,
  [7008] = 6940,
  [7009] = 6948,
  [7010] = 6944,
  [7011] = 6948,
  [7012] = 6944,
  [7013] = 1805,
  [7014] = 6943,
  [7015] = 1756,
  [7016] = 6968,
  [7017] = 6939,
  [7018] = 6940,
  [7019] = 6948,
  [7020] = 6944,
  [7021] = 6940,
  [7022] = 6944,
  [7023] = 6948,
  [7024] = 6940,
  [7025] = 6939,
  [7026] = 1792,
  [7027] = 6939,
  [7028] = 6939,
  [7029] = 6940,
  [7030] = 6944,
  [7031] = 6948,
  [7032] = 3339,
  [7033] = 6948,
  [7034] = 6944,
  [7035] = 6952,
  [7036] = 6943,
  [7037] = 6944,
  [7038] = 5084,
  [7039] = 6943,
  [7040] = 6948,
  [7041] = 1789,
  [7042] = 6944,
  [7043] = 7043,
  [7044] = 6948,
  [7045] = 6940,
  [7046] = 6968,
  [7047] = 6939,
  [7048] = 6940,
  [7049] = 6952,
  [7050] = 6939,
  [7051] = 6952,
  [7052] = 3379,
  [7053] = 6939,
  [7054] = 3388,
  [7055] = 6940,
  [7056] = 3390,
  [7057] = 1756,
  [7058] = 6968,
  [7059] = 1801,
  [7060] = 3222,
  [7061] = 6943,
  [7062] = 6944,
  [7063] = 3297,
  [7064] = 7064,
  [7065] = 3298,
  [7066] = 6939,
  [7067] = 6940,
  [7068] = 6944,
  [7069] = 6948,
  [7070] = 1792,
  [7071] = 3335,
  [7072] = 7072,
  [7073] = 6948,
  [7074] = 1789,
  [7075] = 6939,
  [7076] = 3047,
  [7077] = 1756,
  [7078] = 3165,
  [7079] = 5120,
  [7080] = 3398,
  [7081] = 6968,
  [7082] = 7082,
  [7083] = 7082,
  [7084] = 6940,
  [7085] = 6944,
  [7086] = 6948,
  [7087] = 6948,
  [7088] = 6948,
  [7089] = 6944,
  [7090] = 7090,
  [7091] = 6943,
  [7092] = 6944,
  [7093] = 6939,
  [7094] = 6940,
  [7095] = 6944,
  [7096] = 7096,
  [7097] = 3370,
  [7098] = 6952,
  [7099] = 6948,
  [7100] = 6943,
  [7101] = 6940,
  [7102] = 3402,
  [7103] = 3047,
  [7104] = 6939,
  [7105] = 6939,
  [7106] = 6940,
  [7107] = 6944,
  [7108] = 6854,
  [7109] = 6939,
  [7110] = 6948,
  [7111] = 7111,
  [7112] = 6952,
  [7113] = 6968,
  [7114] = 6940,
  [7115] = 6940,
  [7116] = 6952,
  [7117] = 6939,
  [7118] = 6952,
  [7119] = 6939,
  [7120] = 6940,
  [7121] = 7121,
  [7122] = 6943,
  [7123] = 6968,
  [7124] = 6944,
  [7125] = 6968,
  [7126] = 6948,
  [7127] = 7127,
  [7128] = 5124,
  [7129] = 6943,
  [7130] = 6944,
  [7131] = 6948,
  [7132] = 3058,
  [7133] = 7133,
  [7134] = 6948,
  [7135] = 6944,
  [7136] = 6948,
  [7137] = 6944,
  [7138] = 5117,
  [7139] = 6943,
  [7140] = 3222,
  [7141] = 6940,
  [7142] = 5124,
  [7143] = 6939,
  [7144] = 6940,
  [7145] = 6944,
  [7146] = 6948,
  [7147] = 6939,
  [7148] = 6952,
  [7149] = 6943,
  [7150] = 6968,
  [7151] = 6939,
  [7152] = 6940,
  [7153] = 6968,
  [7154] = 5120,
  [7155] = 5117,
  [7156] = 6236,
  [7157] = 6940,
  [7158] = 7158,
  [7159] = 6952,
  [7160] = 6968,
  [7161] = 6944,
  [7162] = 6948,
  [7163] = 6948,
  [7164] = 6952,
  [7165] = 6939,
  [7166] = 6944,
  [7167] = 6939,
  [7168] = 6943,
  [7169] = 6939,
  [7170] = 6940,
  [7171] = 6944,
  [7172] = 6948,
  [7173] = 6940,
  [7174] = 7174,
  [7175] = 5139,
  [7176] = 6948,
  [7177] = 6944,
  [7178] = 6940,
  [7179] = 6943,
  [7180] = 6939,
  [7181] = 6939,
  [7182] = 6940,
  [7183] = 6944,
  [7184] = 6948,
  [7185] = 6939,
  [7186] = 5137,
  [7187] = 7043,
  [7188] = 6943,
  [7189] = 6952,
  [7190] = 6940,
  [7191] = 6944,
  [7192] = 6939,
  [7193] = 6948,
  [7194] = 6940,
  [7195] = 6939,
  [7196] = 6939,
  [7197] = 1766,
  [7198] = 5135,
  [7199] = 5133,
  [7200] = 6968,
  [7201] = 6952,
  [7202] = 6952,
  [7203] = 7203,
  [7204] = 6968,
  [7205] = 6943,
  [7206] = 7158,
  [7207] = 6968,
  [7208] = 5127,
  [7209] = 3398,
  [7210] = 6944,
  [7211] = 6968,
  [7212] = 6948,
  [7213] = 6948,
  [7214] = 1768,
  [7215] = 6952,
  [7216] = 5121,
  [7217] = 1742,
  [7218] = 6939,
  [7219] = 5118,
  [7220] = 6940,
  [7221] = 6944,
  [7222] = 6948,
  [7223] = 3222,
  [7224] = 6948,
  [7225] = 6944,
  [7226] = 6940,
  [7227] = 6943,
  [7228] = 6939,
  [7229] = 6940,
  [7230] = 1763,
  [7231] = 6968,
  [7232] = 5084,
  [7233] = 1758,
  [7234] = 1741,
  [7235] = 1740,
  [7236] = 6940,
  [7237] = 6968,
  [7238] = 6944,
  [7239] = 6948,
  [7240] = 6948,
  [7241] = 6968,
  [7242] = 6943,
  [7243] = 6944,
  [7244] = 6952,
  [7245] = 6943,
  [7246] = 6939,
  [7247] = 6940,
  [7248] = 6944,
  [7249] = 6948,
  [7250] = 6944,
  [7251] = 6948,
  [7252] = 6968,
  [7253] = 1723,
  [7254] = 6952,
  [7255] = 6940,
  [7256] = 1757,
  [7257] = 6939,
  [7258] = 6939,
  [7259] = 6940,
  [7260] = 6944,
  [7261] = 1772,
  [7262] = 5080,
  [7263] = 6948,
  [7264] = 1765,
  [7265] = 6952,
  [7266] = 6952,
  [7267] = 1759,
  [7268] = 3165,
  [7269] = 1726,
  [7270] = 1731,
  [7271] = 5078,
  [7272] = 1732,
  [7273] = 1733,
  [7274] = 1760,
  [7275] = 6968,
  [7276] = 7072,
  [7277] = 5065,
  [7278] = 7111,
  [7279] = 1735,
  [7280] = 7280,
  [7281] = 6944,
  [7282] = 6939,
  [7283] = 6968,
  [7284] = 7064,
  [7285] = 6940,
  [7286] = 6943,
  [7287] = 7287,
  [7288] = 6948,
  [7289] = 6944,
  [7290] = 6939,
  [7291] = 6940,
  [7292] = 6944,
  [7293] = 6948,
  [7294] = 6943,
  [7295] = 6940,
  [7296] = 6944,
  [7297] = 6952,
  [7298] = 6939,
  [7299] = 6940,
  [7300] = 6944,
  [7301] = 6939,
  [7302] = 6948,
  [7303] = 6939,
  [7304] = 7304,
  [7305] = 6940,
  [7306] = 6940,
  [7307] = 3165,
  [7308] = 6939,
  [7309] = 6948,
  [7310] = 6948,
  [7311] = 6948,
  [7312] = 6944,
  [7313] = 6943,
  [7314] = 6944,
  [7315] = 6939,
  [7316] = 6943,
  [7317] = 6940,
  [7318] = 6944,
  [7319] = 6948,
  [7320] = 3386,
  [7321] = 3402,
  [7322] = 3380,
  [7323] = 3365,
  [7324] = 3363,
  [7325] = 6940,
  [7326] = 6940,
  [7327] = 6939,
  [7328] = 6940,
  [7329] = 6939,
  [7330] = 6944,
  [7331] = 6948,
  [7332] = 5150,
  [7333] = 6944,
  [7334] = 3222,
  [7335] = 6939,
  [7336] = 6952,
  [7337] = 7280,
  [7338] = 6939,
  [7339] = 6948,
  [7340] = 7340,
  [7341] = 6940,
  [7342] = 7280,
  [7343] = 6952,
  [7344] = 7280,
  [7345] = 3165,
  [7346] = 6968,
  [7347] = 7347,
  [7348] = 6968,
  [7349] = 6968,
  [7350] = 6948,
  [7351] = 6944,
  [7352] = 6944,
  [7353] = 7121,
  [7354] = 6940,
  [7355] = 6939,
  [7356] = 7127,
  [7357] = 6968,
  [7358] = 6944,
  [7359] = 7280,
  [7360] = 6948,
  [7361] = 6948,
  [7362] = 5124,
  [7363] = 7280,
  [7364] = 6939,
  [7365] = 6952,
  [7366] = 6944,
  [7367] = 6940,
  [7368] = 6944,
  [7369] = 6948,
  [7370] = 6943,
  [7371] = 6939,
  [7372] = 6939,
  [7373] = 6948,
  [7374] = 6940,
  [7375] = 6944,
  [7376] = 6940,
  [7377] = 1786,
  [7378] = 6635,
  [7379] = 6940,
  [7380] = 6948,
  [7381] = 6939,
  [7382] = 6940,
  [7383] = 6944,
  [7384] = 6944,
  [7385] = 6943,
  [7386] = 6948,
  [7387] = 6939,
  [7388] = 7347,
  [7389] = 6940,
  [7390] = 6939,
  [7391] = 6943,
  [7392] = 6943,
  [7393] = 6939,
  [7394] = 6940,
  [7395] = 6940,
  [7396] = 6944,
  [7397] = 6948,
  [7398] = 6939,
  [7399] = 6948,
  [7400] = 6938,
  [7401] = 5119,
  [7402] = 6948,
  [7403] = 6944,
  [7404] = 6948,
  [7405] = 6952,
  [7406] = 6939,
  [7407] = 6940,
  [7408] = 6948,
  [7409] = 6948,
  [7410] = 6944,
  [7411] = 6944,
  [7412] = 6940,
  [7413] = 7133,
  [7414] = 3058,
  [7415] = 6968,
  [7416] = 5120,
  [7417] = 5117,
  [7418] = 3379,
  [7419] = 5117,
  [7420] = 5120,
  [7421] = 6939,
  [7422] = 7422,
  [7423] = 6968,
  [7424] = 3388,
  [7425] = 6948,
  [7426] = 6944,
  [7427] = 6940,
  [7428] = 3390,
  [7429] = 6948,
  [7430] = 6939,
  [7431] = 3297,
  [7432] = 6939,
  [7433] = 3298,
  [7434] = 3335,
  [7435] = 6940,
  [7436] = 6944,
  [7437] = 6948,
  [7438] = 1755,
  [7439] = 5124,
  [7440] = 6968,
  [7441] = 3047,
  [7442] = 3386,
  [7443] = 3380,
  [7444] = 3339,
  [7445] = 3365,
  [7446] = 3370,
  [7447] = 6939,
  [7448] = 6948,
  [7449] = 6940,
  [7450] = 6944,
  [7451] = 6944,
  [7452] = 6948,
  [7453] = 6943,
  [7454] = 3363,
  [7455] = 6948,
  [7456] = 6952,
  [7457] = 6939,
  [7458] = 6944,
  [7459] = 6948,
  [7460] = 6939,
  [7461] = 6940,
  [7462] = 6944,
  [7463] = 6940,
  [7464] = 6948,
  [7465] = 6968,
  [7466] = 6939,
  [7467] = 6944,
  [7468] = 6940,
  [7469] = 6940,
  [7470] = 6939,
  [7471] = 6939,
  [7472] = 6948,
  [7473] = 6952,
  [7474] = 6940,
  [7475] = 6944,
  [7476] = 6952,
  [7477] = 6943,
  [7478] = 6948,
  [7479] = 6944,
  [7480] = 6944,
  [7481] = 6952,
  [7482] = 6948,
  [7483] = 6968,
  [7484] = 6944,
  [7485] = 3058,
  [7486] = 6948,
  [7487] = 6940,
  [7488] = 6939,
  [7489] = 6943,
  [7490] = 7490,
  [7491] = 7491,
  [7492] = 6939,
  [7493] = 7174,
  [7494] = 5604,
  [7495] = 6940,
  [7496] = 6940,
  [7497] = 6943,
  [7498] = 6939,
  [7499] = 6940,
  [7500] = 6944,
  [7501] = 6948,
  [7502] = 6939,
  [7503] = 6948,
  [7504] = 6944,
  [7505] = 6940,
  [7506] = 6939,
  [7507] = 6236,
  [7508] = 6939,
  [7509] = 6952,
  [7510] = 6943,
  [7511] = 7158,
  [7512] = 6944,
  [7513] = 7513,
  [7514] = 6940,
  [7515] = 6944,
  [7516] = 6948,
  [7517] = 6948,
  [7518] = 6968,
  [7519] = 6944,
  [7520] = 5084,
  [7521] = 6943,
  [7522] = 6939,
  [7523] = 6940,
  [7524] = 6944,
  [7525] = 6948,
  [7526] = 6939,
  [7527] = 6301,
  [7528] = 6940,
  [7529] = 6940,
  [7530] = 6939,
  [7531] = 6939,
  [7532] = 6940,
  [7533] = 6944,
  [7534] = 6952,
  [7535] = 6948,
  [7536] = 6952,
  [7537] = 3047,
  [7538] = 7538,
  [7539] = 7539,
  [7540] = 7540,
  [7541] = 7541,
  [7542] = 7542,
  [7543] = 6485,
  [7544] = 7541,
  [7545] = 7545,
  [7546] = 7541,
  [7547] = 7538,
  [7548] = 7548,
  [7549] = 7549,
  [7550] = 7550,
  [7551] = 7551,
  [7552] = 7552,
  [7553] = 7549,
  [7554] = 7552,
  [7555] = 7555,
  [7556] = 7541,
  [7557] = 7549,
  [7558] = 7548,
  [7559] = 7538,
  [7560] = 7560,
  [7561] = 7545,
  [7562] = 3222,
  [7563] = 7563,
  [7564] = 7540,
  [7565] = 7565,
  [7566] = 7566,
  [7567] = 7567,
  [7568] = 7541,
  [7569] = 7541,
  [7570] = 7570,
  [7571] = 7571,
  [7572] = 7541,
  [7573] = 7541,
  [7574] = 7574,
  [7575] = 7541,
  [7576] = 7576,
  [7577] = 7577,
  [7578] = 7578,
  [7579] = 7538,
  [7580] = 6854,
  [7581] = 7581,
  [7582] = 7549,
  [7583] = 7583,
  [7584] = 7584,
  [7585] = 7552,
  [7586] = 7586,
  [7587] = 7540,
  [7588] = 7548,
  [7589] = 7540,
  [7590] = 7590,
  [7591] = 7591,
  [7592] = 7541,
  [7593] = 7545,
  [7594] = 7594,
  [7595] = 7595,
  [7596] = 7596,
  [7597] = 7597,
  [7598] = 7540,
  [7599] = 7545,
  [7600] = 7548,
  [7601] = 7541,
  [7602] = 7602,
  [7603] = 7555,
  [7604] = 7541,
  [7605] = 7552,
  [7606] = 7540,
  [7607] = 7550,
  [7608] = 7608,
  [7609] = 7541,
  [7610] = 7541,
  [7611] = 7545,
  [7612] = 7612,
  [7613] = 7540,
  [7614] = 7548,
  [7615] = 7538,
  [7616] = 7541,
  [7617] = 7538,
  [7618] = 3165,
  [7619] = 7552,
  [7620] = 6854,
  [7621] = 7549,
  [7622] = 7549,
  [7623] = 7541,
  [7624] = 7538,
  [7625] = 7541,
  [7626] = 7550,
  [7627] = 7552,
  [7628] = 7628,
  [7629] = 7629,
  [7630] = 7541,
  [7631] = 7631,
  [7632] = 7555,
  [7633] = 7633,
  [7634] = 7541,
  [7635] = 7635,
  [7636] = 7541,
  [7637] = 7637,
  [7638] = 7638,
  [7639] = 7538,
  [7640] = 7549,
  [7641] = 7548,
  [7642] = 7538,
  [7643] = 7552,
  [7644] = 7644,
  [7645] = 7545,
  [7646] = 7646,
  [7647] = 3222,
  [7648] = 7548,
  [7649] = 3165,
  [7650] = 7545,
  [7651] = 7540,
  [7652] = 7541,
  [7653] = 7541,
  [7654] = 7654,
  [7655] = 7655,
  [7656] = 7541,
  [7657] = 7657,
  [7658] = 7658,
  [7659] = 7635,
  [7660] = 7660,
  [7661] = 7541,
  [7662] = 7662,
  [7663] = 7635,
  [7664] = 7541,
  [7665] = 7665,
  [7666] = 7666,
  [7667] = 7635,
  [7668] = 7668,
  [7669] = 7669,
  [7670] = 7670,
  [7671] = 7540,
  [7672] = 7635,
  [7673] = 7541,
  [7674] = 7541,
  [7675] = 1514,
  [7676] = 7545,
  [7677] = 7541,
  [7678] = 7678,
  [7679] = 7548,
  [7680] = 7635,
  [7681] = 7681,
  [7682] = 7540,
  [7683] = 7541,
  [7684] = 7552,
  [7685] = 7685,
  [7686] = 6854,
  [7687] = 7549,
  [7688] = 7538,
  [7689] = 7538,
  [7690] = 7678,
  [7691] = 7549,
  [7692] = 7550,
  [7693] = 7552,
  [7694] = 7555,
  [7695] = 7695,
  [7696] = 7545,
  [7697] = 7538,
  [7698] = 7549,
  [7699] = 7541,
  [7700] = 7700,
  [7701] = 7548,
  [7702] = 7552,
  [7703] = 7548,
  [7704] = 7555,
  [7705] = 7545,
  [7706] = 7706,
  [7707] = 7628,
  [7708] = 7552,
  [7709] = 7540,
  [7710] = 7548,
  [7711] = 7711,
  [7712] = 7541,
  [7713] = 7550,
  [7714] = 7545,
  [7715] = 7549,
  [7716] = 7541,
  [7717] = 7540,
  [7718] = 7538,
  [7719] = 7545,
  [7720] = 7541,
  [7721] = 7721,
  [7722] = 7635,
  [7723] = 7706,
  [7724] = 7638,
  [7725] = 7545,
  [7726] = 7541,
  [7727] = 7637,
  [7728] = 7728,
  [7729] = 7635,
  [7730] = 7541,
  [7731] = 7612,
  [7732] = 7635,
  [7733] = 7657,
  [7734] = 7646,
  [7735] = 7635,
  [7736] = 7540,
  [7737] = 7737,
  [7738] = 7541,
  [7739] = 7541,
  [7740] = 7608,
  [7741] = 7545,
  [7742] = 7635,
  [7743] = 7548,
  [7744] = 7548,
  [7745] = 7745,
  [7746] = 7655,
  [7747] = 7700,
  [7748] = 7538,
  [7749] = 7552,
  [7750] = 7549,
  [7751] = 7635,
  [7752] = 7549,
  [7753] = 6854,
  [7754] = 7538,
  [7755] = 7681,
  [7756] = 7541,
  [7757] = 7757,
  [7758] = 7758,
  [7759] = 7552,
  [7760] = 3058,
  [7761] = 7761,
  [7762] = 7762,
  [7763] = 7596,
  [7764] = 7541,
  [7765] = 7548,
  [7766] = 7595,
  [7767] = 7541,
  [7768] = 7591,
  [7769] = 7574,
  [7770] = 7541,
  [7771] = 7545,
  [7772] = 7538,
  [7773] = 7540,
  [7774] = 7538,
  [7775] = 7540,
  [7776] = 7541,
  [7777] = 7635,
  [7778] = 7778,
  [7779] = 7779,
  [7780] = 7548,
  [7781] = 7545,
  [7782] = 3047,
  [7783] = 7783,
  [7784] = 7541,
  [7785] = 7540,
  [7786] = 7548,
  [7787] = 7555,
  [7788] = 7552,
  [7789] = 7550,
  [7790] = 7549,
  [7791] = 7549,
  [7792] = 7538,
  [7793] = 7635,
  [7794] = 7541,
  [7795] = 7795,
  [7796] = 7541,
  [7797] = 7541,
  [7798] = 7550,
  [7799] = 7799,
  [7800] = 7800,
  [7801] = 7540,
  [7802] = 7635,
  [7803] = 7803,
  [7804] = 7804,
  [7805] = 7552,
  [7806] = 7545,
  [7807] = 7807,
  [7808] = 7555,
  [7809] = 7548,
  [7810] = 7541,
  [7811] = 7807,
  [7812] = 7812,
  [7813] = 7813,
  [7814] = 7552,
  [7815] = 7762,
  [7816] = 7761,
  [7817] = 7549,
  [7818] = 7700,
  [7819] = 7549,
  [7820] = 7548,
  [7821] = 7545,
  [7822] = 7721,
  [7823] = 7597,
  [7824] = 7550,
  [7825] = 7660,
  [7826] = 7542,
  [7827] = 7635,
  [7828] = 7541,
  [7829] = 7602,
  [7830] = 7629,
  [7831] = 7548,
  [7832] = 7628,
  [7833] = 7545,
  [7834] = 7560,
  [7835] = 7552,
  [7836] = 7555,
  [7837] = 7540,
  [7838] = 7540,
  [7839] = 7681,
  [7840] = 7658,
  [7841] = 7548,
  [7842] = 7549,
  [7843] = 7552,
  [7844] = 7566,
  [7845] = 7545,
  [7846] = 7635,
  [7847] = 7541,
  [7848] = 7540,
  [7849] = 7541,
  [7850] = 7803,
  [7851] = 7567,
  [7852] = 7565,
  [7853] = 7541,
  [7854] = 7583,
  [7855] = 7571,
  [7856] = 7570,
  [7857] = 7658,
  [7858] = 7635,
  [7859] = 7563,
  [7860] = 7860,
  [7861] = 7541,
  [7862] = 7541,
  [7863] = 7540,
  [7864] = 7864,
  [7865] = 7540,
  [7866] = 7658,
  [7867] = 7548,
  [7868] = 7545,
  [7869] = 7545,
  [7870] = 7545,
  [7871] = 7539,
  [7872] = 7799,
  [7873] = 7548,
  [7874] = 7538,
  [7875] = 7565,
  [7876] = 7548,
  [7877] = 7565,
  [7878] = 7552,
  [7879] = 7565,
  [7880] = 7565,
  [7881] = 7549,
  [7882] = 7565,
  [7883] = 7565,
  [7884] = 7541,
  [7885] = 7576,
  [7886] = 7565,
  [7887] = 7555,
  [7888] = 7540,
  [7889] = 7552,
  [7890] = 7541,
  [7891] = 7565,
  [7892] = 7541,
  [7893] = 7550,
  [7894] = 7549,
  [7895] = 7538,
  [7896] = 7555,
  [7897] = 7581,
  [7898] = 7590,
  [7899] = 7565,
  [7900] = 7565,
  [7901] = 7635,
  [7902] = 7565,
  [7903] = 7565,
  [7904] = 7538,
  [7905] = 7541,
  [7906] = 7550,
  [7907] = 7541,
  [7908] = 7565,
  [7909] = 7565,
  [7910] = 7910,
  [7911] = 7541,
  [7912] = 7550,
  [7913] = 7654,
  [7914] = 7665,
  [7915] = 7666,
  [7916] = 7658,
  [7917] = 7565,
  [7918] = 7918,
  [7919] = 7678,
  [7920] = 7552,
  [7921] = 7555,
  [7922] = 7549,
  [7923] = 7548,
  [7924] = 7545,
  [7925] = 7548,
  [7926] = 7926,
  [7927] = 7540,
  [7928] = 7541,
  [7929] = 7540,
  [7930] = 7635,
  [7931] = 7545,
  [7932] = 7711,
  [7933] = 7565,
  [7934] = 7545,
  [7935] = 7565,
  [7936] = 7728,
  [7937] = 7548,
  [7938] = 7745,
  [7939] = 7565,
  [7940] = 7940,
  [7941] = 7941,
  [7942] = 7552,
  [7943] = 7540,
  [7944] = 7944,
  [7945] = 7549,
  [7946] = 7946,
  [7947] = 7681,
  [7948] = 7541,
  [7949] = 7541,
  [7950] = 7658,
  [7951] = 7541,
  [7952] = 7540,
  [7953] = 7953,
  [7954] = 7541,
  [7955] = 7545,
  [7956] = 7668,
  [7957] = 6485,
  [7958] = 7758,
  [7959] = 7548,
  [7960] = 7555,
  [7961] = 7550,
  [7962] = 7549,
  [7963] = 7541,
  [7964] = 7538,
  [7965] = 7541,
  [7966] = 7541,
  [7967] = 7541,
  [7968] = 7541,
  [7969] = 7783,
  [7970] = 7549,
  [7971] = 7541,
  [7972] = 7552,
  [7973] = 7541,
  [7974] = 7813,
  [7975] = 7541,
  [7976] = 7538,
  [7977] = 7548,
  [7978] = 7541,
  [7979] = 7779,
  [7980] = 7545,
  [7981] = 7549,
  [7982] = 7550,
  [7983] = 7540,
  [7984] = 7541,
  [7985] = 7540,
  [7986] = 7552,
  [7987] = 7541,
  [7988] = 7555,
  [7989] = 7548,
  [7990] = 7545,
  [7991] = 7541,
  [7992] = 7545,
  [7993] = 7548,
  [7994] = 7540,
  [7995] = 7541,
  [7996] = 7541,
  [7997] = 7541,
  [7998] = 7552,
  [7999] = 7999,
  [8000] = 7552,
  [8001] = 7549,
  [8002] = 7541,
  [8003] = 7540,
  [8004] = 7538,
  [8005] = 7541,
  [8006] = 7860,
  [8007] = 7541,
  [8008] = 7541,
  [8009] = 7541,
  [8010] = 7541,
  [8011] = 7545,
  [8012] = 7548,
  [8013] = 7555,
  [8014] = 7538,
  [8015] = 7552,
  [8016] = 7550,
  [8017] = 7549,
  [8018] = 7541,
  [8019] = 7549,
  [8020] = 7550,
  [8021] = 7549,
  [8022] = 7538,
  [8023] = 7552,
  [8024] = 7552,
  [8025] = 7555,
  [8026] = 7541,
  [8027] = 7548,
  [8028] = 7545,
  [8029] = 7541,
  [8030] = 7548,
  [8031] = 7545,
  [8032] = 7541,
  [8033] = 7540,
  [8034] = 7541,
  [8035] = 7540,
  [8036] = 8036,
  [8037] = 8037,
  [8038] = 8038,
  [8039] = 8039,
  [8040] = 8040,
  [8041] = 8040,
  [8042] = 1492,
  [8043] = 8036,
  [8044] = 8044,
  [8045] = 8045,
  [8046] = 8046,
  [8047] = 8047,
  [8048] = 8048,
  [8049] = 8049,
  [8050] = 8050,
  [8051] = 8051,
  [8052] = 8052,
  [8053] = 8053,
  [8054] = 8054,
  [8055] = 8055,
  [8056] = 8056,
  [8057] = 8057,
  [8058] = 8058,
  [8059] = 8059,
  [8060] = 8060,
  [8061] = 8061,
  [8062] = 8057,
  [8063] = 8049,
  [8064] = 8064,
  [8065] = 8065,
  [8066] = 8066,
  [8067] = 8037,
  [8068] = 8037,
  [8069] = 8069,
  [8070] = 8037,
  [8071] = 8071,
  [8072] = 8072,
  [8073] = 8037,
  [8074] = 8046,
  [8075] = 3022,
  [8076] = 8076,
  [8077] = 1492,
  [8078] = 8040,
  [8079] = 8052,
  [8080] = 6486,
  [8081] = 8049,
  [8082] = 6854,
  [8083] = 8052,
  [8084] = 8049,
  [8085] = 8047,
  [8086] = 8086,
  [8087] = 8087,
  [8088] = 8054,
  [8089] = 8039,
  [8090] = 8090,
  [8091] = 8054,
  [8092] = 8071,
  [8093] = 8061,
  [8094] = 8038,
  [8095] = 8039,
  [8096] = 8040,
  [8097] = 8097,
  [8098] = 8039,
  [8099] = 8099,
  [8100] = 8100,
  [8101] = 8101,
  [8102] = 8038,
  [8103] = 8047,
  [8104] = 8104,
  [8105] = 8052,
  [8106] = 8106,
  [8107] = 8107,
  [8108] = 8036,
  [8109] = 8109,
  [8110] = 8110,
  [8111] = 8111,
  [8112] = 8049,
  [8113] = 8052,
  [8114] = 8114,
  [8115] = 8049,
  [8116] = 8116,
  [8117] = 8117,
  [8118] = 8036,
  [8119] = 8044,
  [8120] = 8104,
  [8121] = 8038,
  [8122] = 8122,
  [8123] = 8039,
  [8124] = 8124,
  [8125] = 8125,
  [8126] = 8126,
  [8127] = 8038,
  [8128] = 8037,
  [8129] = 8037,
  [8130] = 8044,
  [8131] = 8131,
  [8132] = 8040,
  [8133] = 3022,
  [8134] = 8134,
  [8135] = 8052,
  [8136] = 8136,
  [8137] = 8137,
  [8138] = 8138,
  [8139] = 8052,
  [8140] = 8049,
  [8141] = 8037,
  [8142] = 6473,
  [8143] = 8047,
  [8144] = 8144,
  [8145] = 8047,
  [8146] = 8057,
  [8147] = 8036,
  [8148] = 8148,
  [8149] = 8061,
  [8150] = 8038,
  [8151] = 8039,
  [8152] = 8040,
  [8153] = 8040,
  [8154] = 8039,
  [8155] = 8155,
  [8156] = 8156,
  [8157] = 8157,
  [8158] = 8038,
  [8159] = 8047,
  [8160] = 8160,
  [8161] = 8044,
  [8162] = 8086,
  [8163] = 8071,
  [8164] = 8164,
  [8165] = 8049,
  [8166] = 8052,
  [8167] = 8167,
  [8168] = 8044,
  [8169] = 8036,
  [8170] = 8038,
  [8171] = 6485,
  [8172] = 8172,
  [8173] = 8173,
  [8174] = 8047,
  [8175] = 8057,
  [8176] = 8176,
  [8177] = 8037,
  [8178] = 8178,
  [8179] = 8179,
  [8180] = 8037,
  [8181] = 8134,
  [8182] = 8057,
  [8183] = 8045,
  [8184] = 8131,
  [8185] = 8040,
  [8186] = 8037,
  [8187] = 8061,
  [8188] = 8039,
  [8189] = 8061,
  [8190] = 8052,
  [8191] = 8049,
  [8192] = 8038,
  [8193] = 8193,
  [8194] = 8194,
  [8195] = 8057,
  [8196] = 8038,
  [8197] = 8044,
  [8198] = 8039,
  [8199] = 8049,
  [8200] = 8036,
  [8201] = 8038,
  [8202] = 8039,
  [8203] = 8040,
  [8204] = 8204,
  [8205] = 8052,
  [8206] = 8052,
  [8207] = 8049,
  [8208] = 3058,
  [8209] = 8047,
  [8210] = 8047,
  [8211] = 8211,
  [8212] = 8037,
  [8213] = 8213,
  [8214] = 8040,
  [8215] = 8215,
  [8216] = 8216,
  [8217] = 8217,
  [8218] = 8218,
  [8219] = 8219,
  [8220] = 8057,
  [8221] = 8039,
  [8222] = 8222,
  [8223] = 8061,
  [8224] = 8044,
  [8225] = 8036,
  [8226] = 8064,
  [8227] = 8047,
  [8228] = 8040,
  [8229] = 8229,
  [8230] = 8049,
  [8231] = 8037,
  [8232] = 8047,
  [8233] = 8052,
  [8234] = 8039,
  [8235] = 8038,
  [8236] = 8038,
  [8237] = 8039,
  [8238] = 8049,
  [8239] = 8239,
  [8240] = 8052,
  [8241] = 8052,
  [8242] = 8049,
  [8243] = 8040,
  [8244] = 8037,
  [8245] = 8245,
  [8246] = 8246,
  [8247] = 8247,
  [8248] = 8248,
  [8249] = 8047,
  [8250] = 8057,
  [8251] = 5124,
  [8252] = 8038,
  [8253] = 8039,
  [8254] = 8040,
  [8255] = 8037,
  [8256] = 3047,
  [8257] = 8061,
  [8258] = 8036,
  [8259] = 8219,
  [8260] = 8218,
  [8261] = 8047,
  [8262] = 8057,
  [8263] = 8036,
  [8264] = 8061,
  [8265] = 8036,
  [8266] = 8044,
  [8267] = 8036,
  [8268] = 8268,
  [8269] = 8229,
  [8270] = 8044,
  [8271] = 8061,
  [8272] = 7918,
  [8273] = 8194,
  [8274] = 8057,
  [8275] = 8101,
  [8276] = 8047,
  [8277] = 8160,
  [8278] = 8065,
  [8279] = 8037,
  [8280] = 8040,
  [8281] = 8039,
  [8282] = 8037,
  [8283] = 6456,
  [8284] = 8038,
  [8285] = 8037,
  [8286] = 8044,
  [8287] = 8173,
  [8288] = 8172,
  [8289] = 8164,
  [8290] = 8053,
  [8291] = 8052,
  [8292] = 8052,
  [8293] = 8049,
  [8294] = 8049,
  [8295] = 8178,
  [8296] = 8157,
  [8297] = 8061,
  [8298] = 8044,
  [8299] = 8049,
  [8300] = 8300,
  [8301] = 8038,
  [8302] = 8052,
  [8303] = 8038,
  [8304] = 8039,
  [8305] = 8040,
  [8306] = 8039,
  [8307] = 8052,
  [8308] = 8308,
  [8309] = 8047,
  [8310] = 8040,
  [8311] = 8040,
  [8312] = 8047,
  [8313] = 8061,
  [8314] = 8314,
  [8315] = 8047,
  [8316] = 8316,
  [8317] = 8037,
  [8318] = 8318,
  [8319] = 8319,
  [8320] = 8320,
  [8321] = 8057,
  [8322] = 8322,
  [8323] = 8036,
  [8324] = 8061,
  [8325] = 8044,
  [8326] = 8039,
  [8327] = 8044,
  [8328] = 8061,
  [8329] = 8057,
  [8330] = 8037,
  [8331] = 8122,
  [8332] = 8038,
  [8333] = 8076,
  [8334] = 8047,
  [8335] = 8049,
  [8336] = 8052,
  [8337] = 8052,
  [8338] = 8049,
  [8339] = 8339,
  [8340] = 8037,
  [8341] = 8320,
  [8342] = 8057,
  [8343] = 8057,
  [8344] = 8040,
  [8345] = 8039,
  [8346] = 8038,
  [8347] = 8061,
  [8348] = 8319,
  [8349] = 8308,
  [8350] = 8350,
  [8351] = 8318,
  [8352] = 8052,
  [8353] = 5120,
  [8354] = 8049,
  [8355] = 5117,
  [8356] = 8052,
  [8357] = 8038,
  [8358] = 8039,
  [8359] = 8359,
  [8360] = 8360,
  [8361] = 8052,
  [8362] = 8049,
  [8363] = 8037,
  [8364] = 8040,
  [8365] = 8365,
  [8366] = 8366,
  [8367] = 7804,
  [8368] = 8047,
  [8369] = 6486,
  [8370] = 8229,
  [8371] = 8178,
  [8372] = 8044,
  [8373] = 8090,
  [8374] = 8037,
  [8375] = 8268,
  [8376] = 8316,
  [8377] = 8057,
  [8378] = 8036,
  [8379] = 8061,
  [8380] = 8044,
  [8381] = 8036,
  [8382] = 8382,
  [8383] = 8047,
  [8384] = 8044,
  [8385] = 8061,
  [8386] = 8057,
  [8387] = 8047,
  [8388] = 8036,
  [8389] = 8097,
  [8390] = 8245,
  [8391] = 8040,
  [8392] = 8039,
  [8393] = 8038,
  [8394] = 8052,
  [8395] = 8087,
  [8396] = 8060,
  [8397] = 8099,
  [8398] = 1730,
  [8399] = 8047,
  [8400] = 8100,
  [8401] = 8049,
  [8402] = 8402,
  [8403] = 8040,
  [8404] = 8039,
  [8405] = 8049,
  [8406] = 8038,
  [8407] = 8407,
  [8408] = 8037,
  [8409] = 8038,
  [8410] = 8193,
  [8411] = 8222,
  [8412] = 8039,
  [8413] = 8413,
  [8414] = 8057,
  [8415] = 8219,
  [8416] = 8218,
  [8417] = 8061,
  [8418] = 8217,
  [8419] = 8419,
  [8420] = 8044,
  [8421] = 8049,
  [8422] = 8216,
  [8423] = 8215,
  [8424] = 8036,
  [8425] = 8038,
  [8426] = 8248,
  [8427] = 8039,
  [8428] = 8247,
  [8429] = 8047,
  [8430] = 8040,
  [8431] = 8431,
  [8432] = 8040,
  [8433] = 8052,
  [8434] = 8040,
  [8435] = 7864,
  [8436] = 8039,
  [8437] = 8211,
  [8438] = 8438,
  [8439] = 8047,
  [8440] = 8194,
  [8441] = 8037,
  [8442] = 8101,
  [8443] = 8179,
  [8444] = 8057,
  [8445] = 8036,
  [8446] = 8176,
  [8447] = 8061,
  [8448] = 8044,
  [8449] = 6473,
  [8450] = 8061,
  [8451] = 8044,
  [8452] = 8057,
  [8453] = 8036,
  [8454] = 8037,
  [8455] = 8167,
  [8456] = 8049,
  [8457] = 8052,
  [8458] = 8049,
  [8459] = 8038,
  [8460] = 8460,
  [8461] = 8049,
  [8462] = 8462,
  [8463] = 3022,
  [8464] = 8137,
  [8465] = 8465,
  [8466] = 8213,
  [8467] = 6456,
  [8468] = 8038,
  [8469] = 8047,
  [8470] = 8048,
  [8471] = 8039,
  [8472] = 8052,
  [8473] = 8040,
  [8474] = 8040,
  [8475] = 8039,
  [8476] = 8050,
  [8477] = 8477,
  [8478] = 8038,
  [8479] = 8037,
  [8480] = 8480,
  [8481] = 8047,
  [8482] = 8036,
  [8483] = 8160,
  [8484] = 8157,
  [8485] = 8044,
  [8486] = 8486,
  [8487] = 8061,
  [8488] = 8057,
  [8489] = 8061,
  [8490] = 8051,
  [8491] = 8049,
  [8492] = 8492,
  [8493] = 8052,
  [8494] = 8044,
  [8495] = 8495,
  [8496] = 8057,
  [8497] = 8037,
  [8498] = 8036,
  [8499] = 8499,
  [8500] = 8052,
  [8501] = 8047,
  [8502] = 8125,
  [8503] = 8049,
  [8504] = 8124,
  [8505] = 8122,
  [8506] = 8038,
  [8507] = 8039,
  [8508] = 8117,
  [8509] = 8040,
  [8510] = 8037,
  [8511] = 6854,
  [8512] = 8116,
  [8513] = 8057,
  [8514] = 8514,
  [8515] = 8134,
  [8516] = 8047,
  [8517] = 8052,
  [8518] = 8061,
  [8519] = 8040,
  [8520] = 8047,
  [8521] = 8521,
  [8522] = 8038,
  [8523] = 8039,
  [8524] = 8036,
  [8525] = 8044,
  [8526] = 8039,
  [8527] = 8044,
  [8528] = 8036,
  [8529] = 8529,
  [8530] = 8530,
  [8531] = 8061,
  [8532] = 8114,
  [8533] = 8057,
  [8534] = 8040,
  [8535] = 8037,
  [8536] = 8047,
  [8537] = 8111,
  [8538] = 8038,
  [8539] = 8539,
  [8540] = 8540,
  [8541] = 8541,
  [8542] = 8040,
  [8543] = 8052,
  [8544] = 8106,
  [8545] = 8049,
  [8546] = 8039,
  [8547] = 8110,
  [8548] = 8087,
  [8549] = 8038,
  [8550] = 8072,
  [8551] = 8038,
  [8552] = 8131,
  [8553] = 8039,
  [8554] = 8069,
  [8555] = 8049,
  [8556] = 8052,
  [8557] = 8109,
  [8558] = 8558,
  [8559] = 8037,
  [8560] = 8036,
  [8561] = 8561,
  [8562] = 8040,
  [8563] = 8049,
  [8564] = 8057,
  [8565] = 8061,
  [8566] = 8044,
  [8567] = 8052,
  [8568] = 8568,
  [8569] = 8047,
  [8570] = 8570,
  [8571] = 8066,
  [8572] = 8036,
  [8573] = 8086,
  [8574] = 8156,
  [8575] = 8044,
  [8576] = 8061,
  [8577] = 8036,
  [8578] = 8155,
  [8579] = 8579,
  [8580] = 8057,
  [8581] = 8047,
  [8582] = 8126,
  [8583] = 8583,
  [8584] = 8059,
  [8585] = 8037,
  [8586] = 8060,
  [8587] = 8058,
  [8588] = 8588,
  [8589] = 8056,
  [8590] = 8590,
  [8591] = 8037,
  [8592] = 8055,
  [8593] = 8049,
  [8594] = 8594,
  [8595] = 8057,
  [8596] = 8486,
  [8597] = 8148,
  [8598] = 8438,
  [8599] = 8038,
  [8600] = 8061,
  [8601] = 8419,
  [8602] = 8039,
  [8603] = 8350,
  [8604] = 8144,
  [8605] = 8239,
  [8606] = 8246,
  [8607] = 8044,
  [8608] = 8040,
  [8609] = 8047,
  [8610] = 8040,
  [8611] = 8611,
  [8612] = 8612,
  [8613] = 8613,
  [8614] = 8614,
  [8615] = 8615,
  [8616] = 8616,
  [8617] = 6485,
  [8618] = 8618,
  [8619] = 3058,
  [8620] = 8620,
  [8621] = 8621,
  [8622] = 8614,
  [8623] = 8615,
  [8624] = 8624,
  [8625] = 8625,
  [8626] = 8626,
  [8627] = 8627,
  [8628] = 8628,
  [8629] = 8629,
  [8630] = 8613,
  [8631] = 8631,
  [8632] = 8632,
  [8633] = 3047,
  [8634] = 8634,
  [8635] = 8635,
  [8636] = 8613,
  [8637] = 8613,
  [8638] = 8638,
  [8639] = 8639,
  [8640] = 8640,
  [8641] = 8641,
  [8642] = 8642,
  [8643] = 8643,
  [8644] = 8644,
  [8645] = 8645,
  [8646] = 8646,
  [8647] = 8647,
  [8648] = 8613,
  [8649] = 8649,
  [8650] = 8650,
  [8651] = 8651,
  [8652] = 8652,
  [8653] = 8653,
  [8654] = 8654,
  [8655] = 8613,
  [8656] = 8613,
  [8657] = 8657,
  [8658] = 8613,
  [8659] = 5124,
  [8660] = 8660,
  [8661] = 8661,
  [8662] = 8662,
  [8663] = 8663,
  [8664] = 8664,
  [8665] = 8665,
  [8666] = 8666,
  [8667] = 8667,
  [8668] = 8613,
  [8669] = 8669,
  [8670] = 8670,
  [8671] = 8671,
  [8672] = 8672,
  [8673] = 8673,
  [8674] = 8613,
  [8675] = 8675,
  [8676] = 8676,
  [8677] = 8615,
  [8678] = 8678,
  [8679] = 8679,
  [8680] = 8680,
  [8681] = 8681,
  [8682] = 8682,
  [8683] = 5120,
  [8684] = 8613,
  [8685] = 5117,
  [8686] = 8686,
  [8687] = 8613,
  [8688] = 8688,
  [8689] = 8689,
  [8690] = 8690,
  [8691] = 8691,
  [8692] = 8692,
  [8693] = 8692,
  [8694] = 8692,
  [8695] = 8692,
  [8696] = 8692,
  [8697] = 8697,
  [8698] = 8613,
  [8699] = 8614,
  [8700] = 8692,
  [8701] = 8613,
  [8702] = 8661,
  [8703] = 8662,
  [8704] = 8704,
  [8705] = 8692,
  [8706] = 8706,
  [8707] = 8707,
  [8708] = 8692,
  [8709] = 8673,
  [8710] = 8692,
  [8711] = 8692,
  [8712] = 8675,
  [8713] = 8676,
  [8714] = 8692,
  [8715] = 8690,
  [8716] = 8692,
  [8717] = 8692,
  [8718] = 8692,
  [8719] = 8109,
  [8720] = 8692,
  [8721] = 8692,
  [8722] = 8692,
  [8723] = 8692,
  [8724] = 8692,
  [8725] = 8653,
  [8726] = 8692,
  [8727] = 8613,
  [8728] = 8661,
  [8729] = 8662,
  [8730] = 8618,
  [8731] = 8663,
  [8732] = 8732,
  [8733] = 8672,
  [8734] = 8673,
  [8735] = 8675,
  [8736] = 8676,
  [8737] = 8690,
  [8738] = 8706,
  [8739] = 8621,
  [8740] = 8740,
  [8741] = 8741,
  [8742] = 8742,
  [8743] = 8743,
  [8744] = 8744,
  [8745] = 8745,
  [8746] = 8746,
  [8747] = 8747,
  [8748] = 8748,
  [8749] = 8740,
  [8750] = 8750,
  [8751] = 8744,
  [8752] = 8752,
  [8753] = 8750,
  [8754] = 8754,
  [8755] = 8755,
  [8756] = 8740,
  [8757] = 8757,
  [8758] = 8742,
  [8759] = 8743,
  [8760] = 8748,
  [8761] = 8745,
  [8762] = 8746,
  [8763] = 8746,
  [8764] = 8748,
  [8765] = 8740,
  [8766] = 8745,
  [8767] = 8750,
  [8768] = 8744,
  [8769] = 8752,
  [8770] = 8754,
  [8771] = 8755,
  [8772] = 8772,
  [8773] = 8757,
  [8774] = 8742,
  [8775] = 8743,
  [8776] = 8745,
  [8777] = 8746,
  [8778] = 8778,
  [8779] = 8748,
  [8780] = 8740,
  [8781] = 8743,
  [8782] = 8750,
  [8783] = 8744,
  [8784] = 8752,
  [8785] = 8754,
  [8786] = 8755,
  [8787] = 8757,
  [8788] = 8742,
  [8789] = 8743,
  [8790] = 8742,
  [8791] = 8745,
  [8792] = 8757,
  [8793] = 8746,
  [8794] = 8748,
  [8795] = 8740,
  [8796] = 8750,
  [8797] = 8744,
  [8798] = 8752,
  [8799] = 8754,
  [8800] = 8755,
  [8801] = 8755,
  [8802] = 8757,
  [8803] = 8742,
  [8804] = 8743,
  [8805] = 8754,
  [8806] = 8745,
  [8807] = 8752,
  [8808] = 8744,
  [8809] = 8746,
  [8810] = 8748,
  [8811] = 8740,
  [8812] = 8755,
  [8813] = 8750,
  [8814] = 8744,
  [8815] = 8752,
  [8816] = 8747,
  [8817] = 8754,
  [8818] = 8755,
  [8819] = 8819,
  [8820] = 8757,
  [8821] = 8742,
  [8822] = 8743,
  [8823] = 8750,
  [8824] = 8745,
  [8825] = 8740,
  [8826] = 8748,
  [8827] = 8746,
  [8828] = 8746,
  [8829] = 8748,
  [8830] = 8740,
  [8831] = 8752,
  [8832] = 8750,
  [8833] = 8744,
  [8834] = 8752,
  [8835] = 8755,
  [8836] = 8754,
  [8837] = 8755,
  [8838] = 8745,
  [8839] = 8757,
  [8840] = 8742,
  [8841] = 8743,
  [8842] = 8754,
  [8843] = 8745,
  [8844] = 8754,
  [8845] = 8772,
  [8846] = 8746,
  [8847] = 8752,
  [8848] = 8748,
  [8849] = 8740,
  [8850] = 8744,
  [8851] = 8750,
  [8852] = 8744,
  [8853] = 8752,
  [8854] = 8778,
  [8855] = 8754,
  [8856] = 8755,
  [8857] = 8743,
  [8858] = 8757,
  [8859] = 8742,
  [8860] = 8743,
  [8861] = 8742,
  [8862] = 8745,
  [8863] = 8750,
  [8864] = 8745,
  [8865] = 8746,
  [8866] = 8757,
  [8867] = 8748,
  [8868] = 8740,
  [8869] = 8778,
  [8870] = 8750,
  [8871] = 8744,
  [8872] = 8752,
  [8873] = 8740,
  [8874] = 8754,
  [8875] = 8755,
  [8876] = 8748,
  [8877] = 8757,
  [8878] = 8742,
  [8879] = 8743,
  [8880] = 8755,
  [8881] = 8745,
  [8882] = 8754,
  [8883] = 8752,
  [8884] = 8746,
  [8885] = 8744,
  [8886] = 8748,
  [8887] = 8740,
  [8888] = 8746,
  [8889] = 8750,
  [8890] = 8744,
  [8891] = 8752,
  [8892] = 8819,
  [8893] = 8754,
  [8894] = 8755,
  [8895] = 8747,
  [8896] = 8757,
  [8897] = 8742,
  [8898] = 8743,
  [8899] = 8819,
  [8900] = 8745,
  [8901] = 8750,
  [8902] = 8740,
  [8903] = 8746,
  [8904] = 8748,
  [8905] = 8748,
  [8906] = 8740,
  [8907] = 8746,
  [8908] = 8750,
  [8909] = 8744,
  [8910] = 8752,
  [8911] = 8745,
  [8912] = 8754,
  [8913] = 8755,
  [8914] = 8757,
  [8915] = 8757,
  [8916] = 8742,
  [8917] = 8743,
  [8918] = 8745,
  [8919] = 8745,
  [8920] = 8743,
  [8921] = 8772,
  [8922] = 8746,
  [8923] = 8742,
  [8924] = 8748,
  [8925] = 8740,
  [8926] = 8757,
  [8927] = 8750,
  [8928] = 8744,
  [8929] = 8752,
  [8930] = 8778,
  [8931] = 8754,
  [8932] = 8755,
  [8933] = 8743,
  [8934] = 8757,
  [8935] = 8742,
  [8936] = 8743,
  [8937] = 8742,
  [8938] = 8745,
  [8939] = 8742,
  [8940] = 8757,
  [8941] = 8746,
  [8942] = 8755,
  [8943] = 8748,
  [8944] = 8740,
  [8945] = 8754,
  [8946] = 8750,
  [8947] = 8744,
  [8948] = 8752,
  [8949] = 8752,
  [8950] = 8754,
  [8951] = 8755,
  [8952] = 8744,
  [8953] = 8757,
  [8954] = 8742,
  [8955] = 8743,
  [8956] = 8755,
  [8957] = 8745,
  [8958] = 8754,
  [8959] = 8752,
  [8960] = 8746,
  [8961] = 8744,
  [8962] = 8748,
  [8963] = 8740,
  [8964] = 8750,
  [8965] = 8750,
  [8966] = 8744,
  [8967] = 8752,
  [8968] = 8743,
  [8969] = 8754,
  [8970] = 8755,
  [8971] = 8747,
  [8972] = 8757,
  [8973] = 8742,
  [8974] = 8743,
  [8975] = 8819,
  [8976] = 8745,
  [8977] = 8750,
  [8978] = 8740,
  [8979] = 8746,
  [8980] = 8748,
  [8981] = 8748,
  [8982] = 8740,
  [8983] = 8746,
  [8984] = 8750,
  [8985] = 8744,
  [8986] = 8752,
  [8987] = 8740,
  [8988] = 8754,
  [8989] = 8755,
  [8990] = 8748,
  [8991] = 8757,
  [8992] = 8742,
  [8993] = 8743,
  [8994] = 8752,
  [8995] = 8745,
  [8996] = 8746,
  [8997] = 8745,
  [8998] = 8746,
  [8999] = 8772,
  [9000] = 8748,
  [9001] = 8740,
  [9002] = 8743,
  [9003] = 8750,
  [9004] = 8744,
  [9005] = 8752,
  [9006] = 8742,
  [9007] = 8754,
  [9008] = 8755,
  [9009] = 8778,
  [9010] = 8757,
  [9011] = 8742,
  [9012] = 8743,
  [9013] = 8745,
  [9014] = 8757,
  [9015] = 8742,
  [9016] = 8746,
  [9017] = 8757,
  [9018] = 8748,
  [9019] = 8740,
  [9020] = 8772,
  [9021] = 8750,
  [9022] = 8744,
  [9023] = 8752,
  [9024] = 8755,
  [9025] = 8754,
  [9026] = 8755,
  [9027] = 8754,
  [9028] = 8757,
  [9029] = 8742,
  [9030] = 8740,
  [9031] = 8745,
  [9032] = 8755,
  [9033] = 8754,
  [9034] = 8746,
  [9035] = 8752,
  [9036] = 8748,
  [9037] = 8740,
  [9038] = 8744,
  [9039] = 8750,
  [9040] = 8744,
  [9041] = 8752,
  [9042] = 8744,
  [9043] = 8754,
  [9044] = 8755,
  [9045] = 8750,
  [9046] = 8757,
  [9047] = 8742,
  [9048] = 8747,
  [9049] = 8745,
  [9050] = 8819,
  [9051] = 8750,
  [9052] = 8746,
  [9053] = 8740,
  [9054] = 8748,
  [9055] = 8740,
  [9056] = 8748,
  [9057] = 8750,
  [9058] = 8744,
  [9059] = 8752,
  [9060] = 8746,
  [9061] = 8754,
  [9062] = 8755,
  [9063] = 8745,
  [9064] = 8757,
  [9065] = 8742,
  [9066] = 8740,
  [9067] = 8745,
  [9068] = 8745,
  [9069] = 8748,
  [9070] = 8746,
  [9071] = 8772,
  [9072] = 8748,
  [9073] = 8740,
  [9074] = 8746,
  [9075] = 8750,
  [9076] = 8744,
  [9077] = 8752,
  [9078] = 8745,
  [9079] = 8754,
  [9080] = 8755,
  [9081] = 8778,
  [9082] = 8757,
  [9083] = 8742,
  [9084] = 8743,
  [9085] = 8745,
  [9086] = 8746,
  [9087] = 8742,
  [9088] = 8746,
  [9089] = 8757,
  [9090] = 8748,
  [9091] = 8740,
  [9092] = 8743,
  [9093] = 8750,
  [9094] = 8744,
  [9095] = 8752,
  [9096] = 8742,
  [9097] = 8754,
  [9098] = 8755,
  [9099] = 8757,
  [9100] = 8757,
  [9101] = 8742,
  [9102] = 8748,
  [9103] = 8745,
  [9104] = 8755,
  [9105] = 8755,
  [9106] = 8746,
  [9107] = 8754,
  [9108] = 8748,
  [9109] = 8740,
  [9110] = 8752,
  [9111] = 8750,
  [9112] = 8744,
  [9113] = 8752,
  [9114] = 8744,
  [9115] = 8754,
  [9116] = 8755,
  [9117] = 8754,
  [9118] = 8757,
  [9119] = 8742,
  [9120] = 8743,
  [9121] = 8745,
  [9122] = 8747,
  [9123] = 8819,
  [9124] = 8746,
  [9125] = 8750,
  [9126] = 8748,
  [9127] = 8740,
  [9128] = 8740,
  [9129] = 8750,
  [9130] = 8744,
  [9131] = 8752,
  [9132] = 8748,
  [9133] = 8754,
  [9134] = 8755,
  [9135] = 8746,
  [9136] = 8757,
  [9137] = 8742,
  [9138] = 8740,
  [9139] = 8745,
  [9140] = 8752,
  [9141] = 8744,
  [9142] = 8746,
  [9143] = 8745,
  [9144] = 8748,
  [9145] = 8740,
  [9146] = 8750,
  [9147] = 8750,
  [9148] = 8744,
  [9149] = 8752,
  [9150] = 8772,
  [9151] = 8754,
  [9152] = 8755,
  [9153] = 8750,
  [9154] = 8757,
  [9155] = 8742,
  [9156] = 8740,
  [9157] = 8745,
  [9158] = 8778,
  [9159] = 8743,
  [9160] = 8746,
  [9161] = 8748,
  [9162] = 8748,
  [9163] = 8740,
  [9164] = 8742,
  [9165] = 8750,
  [9166] = 8744,
  [9167] = 8752,
  [9168] = 8757,
  [9169] = 8754,
  [9170] = 8755,
  [9171] = 8819,
  [9172] = 8757,
  [9173] = 8742,
  [9174] = 8746,
  [9175] = 8745,
  [9176] = 8747,
  [9177] = 8745,
  [9178] = 8746,
  [9179] = 8755,
  [9180] = 8748,
  [9181] = 8740,
  [9182] = 8754,
  [9183] = 8750,
  [9184] = 8744,
  [9185] = 8752,
  [9186] = 8752,
  [9187] = 8754,
  [9188] = 8755,
  [9189] = 8744,
  [9190] = 8757,
  [9191] = 8742,
  [9192] = 8743,
  [9193] = 8745,
  [9194] = 8742,
  [9195] = 8757,
  [9196] = 8746,
  [9197] = 8747,
  [9198] = 8748,
  [9199] = 8740,
  [9200] = 8819,
  [9201] = 8750,
  [9202] = 8744,
  [9203] = 8752,
  [9204] = 8750,
  [9205] = 8754,
  [9206] = 8755,
  [9207] = 8740,
  [9208] = 8757,
  [9209] = 8742,
  [9210] = 8748,
  [9211] = 8745,
  [9212] = 8744,
  [9213] = 8746,
  [9214] = 8746,
  [9215] = 8755,
  [9216] = 8748,
  [9217] = 8740,
  [9218] = 8754,
  [9219] = 8750,
  [9220] = 8744,
  [9221] = 8752,
  [9222] = 8745,
  [9223] = 8754,
  [9224] = 8755,
  [9225] = 8752,
  [9226] = 8757,
  [9227] = 8742,
  [9228] = 8772,
  [9229] = 8745,
  [9230] = 8752,
  [9231] = 8744,
  [9232] = 8746,
  [9233] = 8750,
  [9234] = 8748,
  [9235] = 8740,
  [9236] = 8778,
  [9237] = 8750,
  [9238] = 8744,
  [9239] = 8752,
  [9240] = 8757,
  [9241] = 8754,
  [9242] = 8755,
  [9243] = 8754,
  [9244] = 8757,
  [9245] = 8742,
  [9246] = 8742,
  [9247] = 8745,
  [9248] = 9248,
  [9249] = 8752,
  [9250] = 8746,
  [9251] = 8748,
  [9252] = 8748,
  [9253] = 8740,
  [9254] = 8755,
  [9255] = 8750,
  [9256] = 8744,
  [9257] = 8752,
  [9258] = 8746,
  [9259] = 8754,
  [9260] = 8755,
  [9261] = 8745,
  [9262] = 8757,
  [9263] = 8742,
  [9264] = 8755,
  [9265] = 8745,
  [9266] = 8743,
  [9267] = 8754,
  [9268] = 8746,
  [9269] = 8752,
  [9270] = 8748,
  [9271] = 8740,
  [9272] = 8744,
  [9273] = 8750,
  [9274] = 8744,
  [9275] = 8752,
  [9276] = 8742,
  [9277] = 8754,
  [9278] = 8755,
  [9279] = 8757,
  [9280] = 8757,
  [9281] = 8742,
  [9282] = 8747,
  [9283] = 8745,
  [9284] = 8757,
  [9285] = 8819,
  [9286] = 8746,
  [9287] = 8750,
  [9288] = 8748,
  [9289] = 8740,
  [9290] = 8740,
  [9291] = 8750,
  [9292] = 8744,
  [9293] = 8752,
  [9294] = 8748,
  [9295] = 8754,
  [9296] = 8755,
  [9297] = 8746,
  [9298] = 8757,
  [9299] = 8742,
  [9300] = 8755,
  [9301] = 8745,
  [9302] = 8744,
  [9303] = 8754,
  [9304] = 8745,
  [9305] = 8744,
  [9306] = 8745,
  [9307] = 8745,
  [9308] = 8744,
  [9309] = 8742,
  [9310] = 8745,
  [9311] = 8744,
  [9312] = 8772,
  [9313] = 8745,
  [9314] = 8744,
  [9315] = 8752,
  [9316] = 8745,
  [9317] = 8744,
  [9318] = 9318,
  [9319] = 8750,
  [9320] = 9320,
  [9321] = 9321,
  [9322] = 8740,
  [9323] = 9323,
  [9324] = 8748,
  [9325] = 9325,
  [9326] = 8746,
  [9327] = 9327,
  [9328] = 8743,
  [9329] = 8778,
  [9330] = 9330,
  [9331] = 8743,
  [9332] = 9332,
  [9333] = 9333,
  [9334] = 9334,
  [9335] = 8745,
  [9336] = 8778,
  [9337] = 8743,
  [9338] = 9338,
  [9339] = 9339,
  [9340] = 8742,
  [9341] = 9341,
  [9342] = 9342,
  [9343] = 9343,
  [9344] = 8757,
  [9345] = 8742,
  [9346] = 9346,
  [9347] = 9347,
  [9348] = 8757,
  [9349] = 8755,
  [9350] = 8754,
  [9351] = 8752,
  [9352] = 9352,
  [9353] = 8744,
  [9354] = 8750,
  [9355] = 9355,
  [9356] = 8741,
  [9357] = 8772,
  [9358] = 8740,
  [9359] = 9359,
  [9360] = 8748,
  [9361] = 8755,
  [9362] = 8746,
  [9363] = 9363,
  [9364] = 8745,
  [9365] = 8754,
  [9366] = 9366,
  [9367] = 8752,
  [9368] = 8745,
  [9369] = 8744,
  [9370] = 8743,
  [9371] = 8742,
  [9372] = 8757,
  [9373] = 8755,
  [9374] = 8754,
  [9375] = 8746,
  [9376] = 8743,
  [9377] = 8744,
  [9378] = 8750,
  [9379] = 9379,
  [9380] = 8747,
  [9381] = 8748,
  [9382] = 8740,
  [9383] = 8819,
  [9384] = 8750,
  [9385] = 8740,
  [9386] = 8748,
  [9387] = 9323,
  [9388] = 9332,
  [9389] = 9334,
  [9390] = 8748,
  [9391] = 8746,
  [9392] = 9341,
  [9393] = 9342,
  [9394] = 9343,
  [9395] = 8778,
  [9396] = 8740,
  [9397] = 8745,
  [9398] = 8746,
  [9399] = 9352,
  [9400] = 8750,
  [9401] = 9355,
  [9402] = 8741,
  [9403] = 8745,
  [9404] = 8772,
  [9405] = 8819,
  [9406] = 9363,
  [9407] = 8743,
  [9408] = 9366,
  [9409] = 8778,
  [9410] = 8743,
  [9411] = 8742,
  [9412] = 8757,
  [9413] = 8747,
  [9414] = 9414,
  [9415] = 9341,
  [9416] = 9342,
  [9417] = 9343,
  [9418] = 8755,
  [9419] = 8742,
  [9420] = 8754,
  [9421] = 8752,
  [9422] = 9355,
  [9423] = 8741,
  [9424] = 8744,
  [9425] = 9425,
  [9426] = 8757,
  [9427] = 9363,
  [9428] = 8750,
  [9429] = 9366,
  [9430] = 8755,
  [9431] = 8748,
  [9432] = 8746,
  [9433] = 9341,
  [9434] = 9342,
  [9435] = 9343,
  [9436] = 8752,
  [9437] = 8745,
  [9438] = 8754,
  [9439] = 8744,
  [9440] = 9355,
  [9441] = 8757,
  [9442] = 8755,
  [9443] = 8742,
  [9444] = 8755,
  [9445] = 9363,
  [9446] = 8754,
  [9447] = 9366,
  [9448] = 8757,
  [9449] = 8752,
  [9450] = 8755,
  [9451] = 9341,
  [9452] = 9342,
  [9453] = 9343,
  [9454] = 8744,
  [9455] = 8754,
  [9456] = 8752,
  [9457] = 8744,
  [9458] = 9355,
  [9459] = 8741,
  [9460] = 8750,
  [9461] = 8740,
  [9462] = 8747,
  [9463] = 9363,
  [9464] = 8819,
  [9465] = 9366,
  [9466] = 8748,
  [9467] = 8757,
  [9468] = 8750,
  [9469] = 9341,
  [9470] = 9342,
  [9471] = 9343,
  [9472] = 8746,
  [9473] = 8740,
  [9474] = 8748,
  [9475] = 9355,
  [9476] = 8741,
  [9477] = 8746,
  [9478] = 8742,
  [9479] = 8745,
  [9480] = 9363,
  [9481] = 8745,
  [9482] = 9366,
  [9483] = 8743,
  [9484] = 8743,
  [9485] = 9341,
  [9486] = 9342,
  [9487] = 9343,
  [9488] = 8778,
  [9489] = 8772,
  [9490] = 9490,
  [9491] = 9355,
  [9492] = 8741,
  [9493] = 8742,
  [9494] = 8757,
  [9495] = 8755,
  [9496] = 9363,
  [9497] = 8754,
  [9498] = 9366,
  [9499] = 9499,
  [9500] = 8752,
  [9501] = 9341,
  [9502] = 9342,
  [9503] = 9343,
  [9504] = 8743,
  [9505] = 8743,
  [9506] = 8750,
  [9507] = 9355,
  [9508] = 8741,
  [9509] = 8772,
  [9510] = 8740,
  [9511] = 9511,
  [9512] = 9363,
  [9513] = 8742,
  [9514] = 9366,
  [9515] = 8748,
  [9516] = 8746,
  [9517] = 9341,
  [9518] = 9342,
  [9519] = 9343,
  [9520] = 8757,
  [9521] = 8745,
  [9522] = 8745,
  [9523] = 9355,
  [9524] = 8741,
  [9525] = 8743,
  [9526] = 8755,
  [9527] = 8742,
  [9528] = 9363,
  [9529] = 8757,
  [9530] = 9366,
  [9531] = 8746,
  [9532] = 8755,
  [9533] = 9341,
  [9534] = 9342,
  [9535] = 9343,
  [9536] = 8754,
  [9537] = 8755,
  [9538] = 8752,
  [9539] = 9355,
  [9540] = 8741,
  [9541] = 9541,
  [9542] = 8744,
  [9543] = 8754,
  [9544] = 9363,
  [9545] = 8748,
  [9546] = 9366,
  [9547] = 8752,
  [9548] = 8744,
  [9549] = 9341,
  [9550] = 9342,
  [9551] = 9343,
  [9552] = 8750,
  [9553] = 8747,
  [9554] = 8819,
  [9555] = 9355,
  [9556] = 8741,
  [9557] = 8750,
  [9558] = 8740,
  [9559] = 8748,
  [9560] = 9363,
  [9561] = 8746,
  [9562] = 9366,
  [9563] = 8740,
  [9564] = 9341,
  [9565] = 9342,
  [9566] = 9343,
  [9567] = 8740,
  [9568] = 8748,
  [9569] = 9366,
  [9570] = 9355,
  [9571] = 8741,
  [9572] = 8750,
  [9573] = 8746,
  [9574] = 8819,
  [9575] = 9363,
  [9576] = 8745,
  [9577] = 9366,
  [9578] = 8747,
  [9579] = 9341,
  [9580] = 9342,
  [9581] = 9343,
  [9582] = 8745,
  [9583] = 8743,
  [9584] = 8744,
  [9585] = 9355,
  [9586] = 8741,
  [9587] = 8752,
  [9588] = 8772,
  [9589] = 8742,
  [9590] = 9363,
  [9591] = 8757,
  [9592] = 9366,
  [9593] = 8754,
  [9594] = 9341,
  [9595] = 9342,
  [9596] = 9343,
  [9597] = 8755,
  [9598] = 8754,
  [9599] = 8778,
  [9600] = 9355,
  [9601] = 8741,
  [9602] = 8743,
  [9603] = 8744,
  [9604] = 8742,
  [9605] = 9363,
  [9606] = 8757,
  [9607] = 9366,
  [9608] = 9608,
  [9609] = 9341,
  [9610] = 9342,
  [9611] = 9343,
  [9612] = 8752,
  [9613] = 9613,
  [9614] = 8744,
  [9615] = 8741,
  [9616] = 8750,
  [9617] = 9617,
  [9618] = 8740,
  [9619] = 9363,
  [9620] = 8748,
  [9621] = 9366,
  [9622] = 8746,
  [9623] = 9341,
  [9624] = 9342,
  [9625] = 9343,
  [9626] = 9626,
  [9627] = 9627,
  [9628] = 8757,
  [9629] = 8741,
  [9630] = 8742,
  [9631] = 8745,
  [9632] = 8819,
  [9633] = 9363,
  [9634] = 8743,
  [9635] = 9366,
  [9636] = 8754,
  [9637] = 9341,
  [9638] = 9342,
  [9639] = 9343,
  [9640] = 8742,
  [9641] = 8757,
  [9642] = 8755,
  [9643] = 8741,
  [9644] = 8752,
  [9645] = 8754,
  [9646] = 9646,
  [9647] = 9363,
  [9648] = 8744,
  [9649] = 9366,
  [9650] = 8743,
  [9651] = 9341,
  [9652] = 9342,
  [9653] = 9343,
  [9654] = 8752,
  [9655] = 9655,
  [9656] = 8744,
  [9657] = 8741,
  [9658] = 8750,
  [9659] = 8747,
  [9660] = 8778,
  [9661] = 9363,
  [9662] = 8819,
  [9663] = 9366,
  [9664] = 9664,
  [9665] = 9341,
  [9666] = 9342,
  [9667] = 9343,
  [9668] = 8750,
  [9669] = 8742,
  [9670] = 8740,
  [9671] = 8741,
  [9672] = 8748,
  [9673] = 8746,
  [9674] = 8740,
  [9675] = 9363,
  [9676] = 8748,
  [9677] = 9366,
  [9678] = 8757,
  [9679] = 9341,
  [9680] = 9342,
  [9681] = 9343,
  [9682] = 8745,
  [9683] = 8746,
  [9684] = 8772,
  [9685] = 8772,
  [9686] = 8745,
  [9687] = 9363,
  [9688] = 8743,
  [9689] = 9341,
  [9690] = 9342,
  [9691] = 9343,
  [9692] = 8745,
  [9693] = 8778,
  [9694] = 8742,
  [9695] = 8757,
  [9696] = 8754,
  [9697] = 9363,
  [9698] = 8755,
  [9699] = 9341,
  [9700] = 9342,
  [9701] = 9343,
  [9702] = 9363,
  [9703] = 8754,
  [9704] = 8742,
  [9705] = 8746,
  [9706] = 8752,
  [9707] = 9363,
  [9708] = 8744,
  [9709] = 9341,
  [9710] = 9342,
  [9711] = 9343,
  [9712] = 8757,
  [9713] = 8750,
  [9714] = 8748,
  [9715] = 8740,
  [9716] = 8748,
  [9717] = 9363,
  [9718] = 8740,
  [9719] = 9341,
  [9720] = 9342,
  [9721] = 9343,
  [9722] = 8746,
  [9723] = 8750,
  [9724] = 8757,
  [9725] = 8745,
  [9726] = 8747,
  [9727] = 9363,
  [9728] = 9359,
  [9729] = 9341,
  [9730] = 9342,
  [9731] = 9343,
  [9732] = 8755,
  [9733] = 8743,
  [9734] = 8744,
  [9735] = 8742,
  [9736] = 8757,
  [9737] = 9363,
  [9738] = 8752,
  [9739] = 9341,
  [9740] = 9342,
  [9741] = 9343,
  [9742] = 8755,
  [9743] = 8754,
  [9744] = 8754,
  [9745] = 8752,
  [9746] = 8744,
  [9747] = 9363,
  [9748] = 8750,
  [9749] = 9341,
  [9750] = 9342,
  [9751] = 9343,
  [9752] = 8755,
  [9753] = 8740,
  [9754] = 9754,
  [9755] = 8748,
  [9756] = 8755,
  [9757] = 9363,
  [9758] = 8746,
  [9759] = 9341,
  [9760] = 9342,
  [9761] = 9343,
  [9762] = 8741,
  [9763] = 9763,
  [9764] = 9764,
  [9765] = 8752,
  [9766] = 9766,
  [9767] = 9363,
  [9768] = 8752,
  [9769] = 9341,
  [9770] = 9342,
  [9771] = 9343,
  [9772] = 8744,
  [9773] = 8743,
  [9774] = 8742,
  [9775] = 8745,
  [9776] = 8743,
  [9777] = 8743,
  [9778] = 9341,
  [9779] = 9342,
  [9780] = 9343,
  [9781] = 8747,
  [9782] = 8742,
  [9783] = 8757,
  [9784] = 9784,
  [9785] = 9785,
  [9786] = 8819,
  [9787] = 9341,
  [9788] = 9342,
  [9789] = 9343,
  [9790] = 8750,
  [9791] = 8778,
  [9792] = 8740,
  [9793] = 8748,
  [9794] = 8755,
  [9795] = 8746,
  [9796] = 9341,
  [9797] = 9342,
  [9798] = 9343,
  [9799] = 8755,
  [9800] = 8754,
  [9801] = 8752,
  [9802] = 8754,
  [9803] = 8745,
  [9804] = 8752,
  [9805] = 8744,
  [9806] = 8750,
  [9807] = 8740,
  [9808] = 8772,
  [9809] = 8748,
  [9810] = 8772,
  [9811] = 8746,
  [9812] = 8744,
  [9813] = 8778,
  [9814] = 8745,
  [9815] = 8745,
  [9816] = 8746,
  [9817] = 8743,
  [9818] = 8743,
  [9819] = 8748,
  [9820] = 8740,
  [9821] = 9821,
  [9822] = 9822,
  [9823] = 9823,
  [9824] = 8742,
  [9825] = 8742,
  [9826] = 8757,
  [9827] = 8757,
  [9828] = 8750,
  [9829] = 9355,
  [9830] = 8755,
  [9831] = 9831,
  [9832] = 8754,
  [9833] = 8819,
  [9834] = 8752,
  [9835] = 8744,
  [9836] = 8750,
  [9837] = 8747,
  [9838] = 8819,
  [9839] = 9839,
  [9840] = 8747,
  [9841] = 8740,
  [9842] = 8748,
  [9843] = 8746,
  [9844] = 8755,
  [9845] = 8744,
  [9846] = 8754,
  [9847] = 8745,
  [9848] = 8754,
  [9849] = 9849,
  [9850] = 8755,
  [9851] = 8743,
  [9852] = 8742,
  [9853] = 9352,
  [9854] = 9854,
  [9855] = 8757,
  [9856] = 8757,
  [9857] = 8755,
  [9858] = 8744,
  [9859] = 8754,
  [9860] = 8742,
  [9861] = 8752,
  [9862] = 8747,
  [9863] = 9863,
  [9864] = 8819,
  [9865] = 8750,
  [9866] = 8740,
  [9867] = 8744,
  [9868] = 8750,
  [9869] = 8748,
  [9870] = 8740,
  [9871] = 9871,
  [9872] = 8746,
  [9873] = 8748,
  [9874] = 8746,
  [9875] = 8745,
  [9876] = 8743,
  [9877] = 8750,
  [9878] = 8772,
  [9879] = 8778,
  [9880] = 8772,
  [9881] = 8745,
  [9882] = 8778,
  [9883] = 8740,
  [9884] = 8748,
  [9885] = 8743,
  [9886] = 8745,
  [9887] = 8746,
  [9888] = 8752,
  [9889] = 9854,
  [9890] = 8746,
  [9891] = 8742,
  [9892] = 8757,
  [9893] = 8748,
  [9894] = 8740,
  [9895] = 8750,
  [9896] = 8742,
  [9897] = 8757,
  [9898] = 8752,
  [9899] = 8747,
  [9900] = 8755,
  [9901] = 8754,
  [9902] = 8755,
  [9903] = 8752,
  [9904] = 8754,
  [9905] = 8750,
  [9906] = 8744,
  [9907] = 8744,
  [9908] = 8744,
  [9909] = 8752,
  [9910] = 9347,
  [9911] = 9346,
  [9912] = 8747,
  [9913] = 8747,
  [9914] = 9914,
  [9915] = 8819,
  [9916] = 9839,
  [9917] = 8819,
  [9918] = 8754,
  [9919] = 8750,
  [9920] = 8750,
  [9921] = 8755,
  [9922] = 8740,
  [9923] = 8748,
  [9924] = 8740,
  [9925] = 8748,
  [9926] = 8746,
  [9927] = 8746,
  [9928] = 8757,
  [9929] = 8742,
  [9930] = 9343,
  [9931] = 9342,
  [9932] = 8745,
  [9933] = 8745,
  [9934] = 8743,
  [9935] = 8772,
  [9936] = 8743,
  [9937] = 9341,
  [9938] = 8778,
  [9939] = 8772,
  [9940] = 8745,
  [9941] = 8778,
  [9942] = 8743,
  [9943] = 9339,
  [9944] = 8742,
  [9945] = 8757,
  [9946] = 8746,
  [9947] = 8755,
  [9948] = 8742,
  [9949] = 8754,
  [9950] = 8748,
  [9951] = 9338,
  [9952] = 8757,
  [9953] = 8752,
  [9954] = 8744,
  [9955] = 8740,
  [9956] = 8750,
  [9957] = 8747,
  [9958] = 8819,
  [9959] = 8819,
  [9960] = 8750,
  [9961] = 8747,
  [9962] = 8740,
  [9963] = 9334,
  [9964] = 8748,
  [9965] = 8746,
  [9966] = 8755,
  [9967] = 8744,
  [9968] = 8752,
  [9969] = 8754,
  [9970] = 9970,
  [9971] = 8755,
  [9972] = 9972,
  [9973] = 9973,
  [9974] = 8819,
  [9975] = 8754,
  [9976] = 8745,
  [9977] = 8752,
  [9978] = 9333,
  [9979] = 8744,
  [9980] = 8743,
  [9981] = 8757,
  [9982] = 8742,
  [9983] = 8742,
  [9984] = 8757,
  [9985] = 8747,
  [9986] = 8819,
  [9987] = 9839,
  [9988] = 9988,
  [9989] = 8743,
  [9990] = 8778,
  [9991] = 8755,
  [9992] = 8754,
  [9993] = 8752,
  [9994] = 8750,
  [9995] = 9995,
  [9996] = 8745,
  [9997] = 8744,
  [9998] = 8740,
  [9999] = 8748,
  [10000] = 8746,
  [10001] = 8772,
  [10002] = 8747,
  [10003] = 8819,
  [10004] = 8750,
  [10005] = 10005,
  [10006] = 8745,
  [10007] = 8772,
  [10008] = 8740,
  [10009] = 8748,
  [10010] = 8746,
  [10011] = 8746,
  [10012] = 8748,
  [10013] = 8740,
  [10014] = 8745,
  [10015] = 8745,
  [10016] = 10016,
  [10017] = 8754,
  [10018] = 9854,
  [10019] = 9332,
  [10020] = 8743,
  [10021] = 8772,
  [10022] = 8747,
  [10023] = 8744,
  [10024] = 8752,
  [10025] = 8754,
  [10026] = 8755,
  [10027] = 8742,
  [10028] = 8757,
  [10029] = 8757,
  [10030] = 8755,
  [10031] = 9330,
  [10032] = 8778,
  [10033] = 8754,
  [10034] = 8743,
  [10035] = 8748,
  [10036] = 8742,
  [10037] = 8752,
  [10038] = 8744,
  [10039] = 8743,
  [10040] = 9327,
  [10041] = 8747,
  [10042] = 8819,
  [10043] = 8745,
  [10044] = 8742,
  [10045] = 8757,
  [10046] = 8750,
  [10047] = 8740,
  [10048] = 8748,
  [10049] = 8746,
  [10050] = 8746,
  [10051] = 8748,
  [10052] = 8740,
  [10053] = 8745,
  [10054] = 8750,
  [10055] = 8819,
  [10056] = 9325,
  [10057] = 8743,
  [10058] = 8747,
  [10059] = 8744,
  [10060] = 8752,
  [10061] = 8754,
  [10062] = 8755,
  [10063] = 8778,
  [10064] = 8743,
  [10065] = 9323,
  [10066] = 10066,
  [10067] = 8742,
  [10068] = 8755,
  [10069] = 9321,
  [10070] = 8757,
  [10071] = 8819,
  [10072] = 8757,
  [10073] = 9320,
  [10074] = 10074,
  [10075] = 10075,
  [10076] = 10076,
  [10077] = 8754,
  [10078] = 9854,
  [10079] = 8755,
  [10080] = 10080,
  [10081] = 10075,
  [10082] = 10074,
  [10083] = 8752,
  [10084] = 9831,
  [10085] = 8744,
  [10086] = 8754,
  [10087] = 8742,
  [10088] = 8752,
  [10089] = 8744,
  [10090] = 9831,
  [10091] = 8747,
  [10092] = 9831,
  [10093] = 8819,
  [10094] = 9831,
  [10095] = 8747,
  [10096] = 9831,
  [10097] = 8819,
  [10098] = 9831,
  [10099] = 9839,
  [10100] = 9831,
  [10101] = 8750,
  [10102] = 9831,
  [10103] = 6456,
  [10104] = 9831,
  [10105] = 8740,
  [10106] = 9831,
  [10107] = 8750,
  [10108] = 9831,
  [10109] = 8740,
  [10110] = 9831,
  [10111] = 8748,
  [10112] = 9831,
  [10113] = 8746,
  [10114] = 9831,
  [10115] = 8746,
  [10116] = 9831,
  [10117] = 8743,
  [10118] = 9831,
  [10119] = 8745,
  [10120] = 9831,
  [10121] = 8745,
  [10122] = 9831,
  [10123] = 8746,
  [10124] = 9831,
  [10125] = 10080,
  [10126] = 8748,
  [10127] = 8745,
  [10128] = 8743,
  [10129] = 8772,
  [10130] = 10130,
  [10131] = 8740,
  [10132] = 9914,
  [10133] = 8750,
  [10134] = 8819,
  [10135] = 8747,
  [10136] = 8744,
  [10137] = 8752,
  [10138] = 8742,
  [10139] = 9318,
  [10140] = 8778,
  [10141] = 8743,
  [10142] = 9854,
  [10143] = 8757,
};

static inline bool sym_hole_character_set_1(int32_t c) {
  return (c < 6576
    ? (c < 2974
      ? (c < 2208
        ? (c < 1369
          ? (c < 748
            ? (c < 181
              ? (c < '_'
                ? (c < '0'
                  ? c == '\''
                  : (c <= '9' || (c >= 'A' && c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? (c >= 'a' && c <= 'z')
                  : c <= 170)))
              : (c <= 181 || (c < 248
                ? (c < 192
                  ? c == 186
                  : (c <= 214 || (c >= 216 && c <= 246)))
                : (c <= 705 || (c < 736
                  ? (c >= 710 && c <= 721)
                  : c <= 740)))))
            : (c <= 748 || (c < 904
              ? (c < 890
                ? (c < 880
                  ? c == 750
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 902
                  ? c == 895
                  : c <= 902)))
              : (c <= 906 || (c < 1015
                ? (c < 910
                  ? c == 908
                  : (c <= 929 || (c >= 931 && c <= 1013)))
                : (c <= 1153 || (c < 1329
                  ? (c >= 1162 && c <= 1327)
                  : c <= 1366)))))))
          : (c <= 1369 || (c < 1869
            ? (c < 1749
              ? (c < 1568
                ? (c < 1488
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 1514 || (c >= 1519 && c <= 1522)))
                : (c <= 1610 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1791
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1810
                  ? c == 1808
                  : c <= 1839)))))
            : (c <= 1957 || (c < 2084
              ? (c < 2042
                ? (c < 1994
                  ? c == 1969
                  : (c <= 2026 || (c >= 2036 && c <= 2037)))
                : (c <= 2042 || (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : c <= 2074)))
              : (c <= 2084 || (c < 2144
                ? (c < 2112
                  ? c == 2088
                  : c <= 2136)
                : (c <= 2154 || (c < 2185
                  ? (c >= 2160 && c <= 2183)
                  : c <= 2190)))))))))
        : (c <= 2249 || (c < 2674
          ? (c < 2524
            ? (c < 2447
              ? (c < 2392
                ? (c < 2365
                  ? (c >= 2308 && c <= 2361)
                  : (c <= 2365 || c == 2384))
                : (c <= 2401 || (c < 2437
                  ? (c >= 2417 && c <= 2432)
                  : c <= 2444)))
              : (c <= 2448 || (c < 2486
                ? (c < 2474
                  ? (c >= 2451 && c <= 2472)
                  : (c <= 2480 || c == 2482))
                : (c <= 2489 || (c < 2510
                  ? c == 2493
                  : c <= 2510)))))
            : (c <= 2525 || (c < 2602
              ? (c < 2565
                ? (c < 2544
                  ? (c >= 2527 && c <= 2529)
                  : (c <= 2545 || c == 2556))
                : (c <= 2570 || (c < 2579
                  ? (c >= 2575 && c <= 2576)
                  : c <= 2600)))
              : (c <= 2608 || (c < 2616
                ? (c < 2613
                  ? (c >= 2610 && c <= 2611)
                  : c <= 2614)
                : (c <= 2617 || (c < 2654
                  ? (c >= 2649 && c <= 2652)
                  : c <= 2654)))))))
          : (c <= 2676 || (c < 2858
            ? (c < 2749
              ? (c < 2730
                ? (c < 2703
                  ? (c >= 2693 && c <= 2701)
                  : (c <= 2705 || (c >= 2707 && c <= 2728)))
                : (c <= 2736 || (c < 2741
                  ? (c >= 2738 && c <= 2739)
                  : c <= 2745)))
              : (c <= 2749 || (c < 2821
                ? (c < 2784
                  ? c == 2768
                  : (c <= 2785 || c == 2809))
                : (c <= 2828 || (c < 2835
                  ? (c >= 2831 && c <= 2832)
                  : c <= 2856)))))
            : (c <= 2864 || (c < 2947
              ? (c < 2908
                ? (c < 2869
                  ? (c >= 2866 && c <= 2867)
                  : (c <= 2873 || c == 2877))
                : (c <= 2909 || (c < 2929
                  ? (c >= 2911 && c <= 2913)
                  : c <= 2929)))
              : (c <= 2947 || (c < 2962
                ? (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : c <= 2960)
                : (c <= 2965 || (c < 2972
                  ? (c >= 2969 && c <= 2970)
                  : c <= 2972)))))))))))
      : (c <= 2975 || (c < 4096
        ? (c < 3406
          ? (c < 3205
            ? (c < 3090
              ? (c < 3024
                ? (c < 2984
                  ? (c >= 2979 && c <= 2980)
                  : (c <= 2986 || (c >= 2990 && c <= 3001)))
                : (c <= 3024 || (c < 3086
                  ? (c >= 3077 && c <= 3084)
                  : c <= 3088)))
              : (c <= 3112 || (c < 3165
                ? (c < 3133
                  ? (c >= 3114 && c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))
                : (c <= 3165 || (c < 3200
                  ? (c >= 3168 && c <= 3169)
                  : c <= 3200)))))
            : (c <= 3212 || (c < 3296
              ? (c < 3253
                ? (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))
                : (c <= 3257 || (c < 3293
                  ? c == 3261
                  : c <= 3294)))
              : (c <= 3297 || (c < 3342
                ? (c < 3332
                  ? (c >= 3313 && c <= 3314)
                  : c <= 3340)
                : (c <= 3344 || (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)))))))
          : (c <= 3406 || (c < 3718
            ? (c < 3517
              ? (c < 3461
                ? (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : (c <= 3425 || (c >= 3450 && c <= 3455)))
                : (c <= 3478 || (c < 3507
                  ? (c >= 3482 && c <= 3505)
                  : c <= 3515)))
              : (c <= 3517 || (c < 3648
                ? (c < 3585
                  ? (c >= 3520 && c <= 3526)
                  : (c <= 3632 || (c >= 3634 && c <= 3635)))
                : (c <= 3654 || (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : c <= 3716)))))
            : (c <= 3722 || (c < 3782
              ? (c < 3762
                ? (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : (c <= 3749 || (c >= 3751 && c <= 3760)))
                : (c <= 3763 || (c < 3776
                  ? c == 3773
                  : c <= 3780)))
              : (c <= 3782 || (c < 3904
                ? (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)
                : (c <= 3911 || (c < 3976
                  ? (c >= 3913 && c <= 3948)
                  : c <= 3980)))))))))
        : (c <= 4138 || (c < 4882
          ? (c < 4682
            ? (c < 4213
              ? (c < 4193
                ? (c < 4176
                  ? c == 4159
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))
                : (c <= 4193 || (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : c <= 4208)))
              : (c <= 4225 || (c < 4301
                ? (c < 4256
                  ? c == 4238
                  : (c <= 4293 || c == 4295))
                : (c <= 4301 || (c < 4348
                  ? (c >= 4304 && c <= 4346)
                  : c <= 4680)))))
            : (c <= 4685 || (c < 4786
              ? (c < 4704
                ? (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : (c <= 4696 || (c >= 4698 && c <= 4701)))
                : (c <= 4744 || (c < 4752
                  ? (c >= 4746 && c <= 4749)
                  : c <= 4784)))
              : (c <= 4789 || (c < 4802
                ? (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)
                : (c <= 4805 || (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : c <= 4880)))))))
          : (c <= 4885 || (c < 5998
            ? (c < 5761
              ? (c < 5112
                ? (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : (c <= 5007 || (c >= 5024 && c <= 5109)))
                : (c <= 5117 || (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : c <= 5759)))
              : (c <= 5786 || (c < 5919
                ? (c < 5873
                  ? (c >= 5792 && c <= 5866)
                  : (c <= 5880 || (c >= 5888 && c <= 5905)))
                : (c <= 5937 || (c < 5984
                  ? (c >= 5952 && c <= 5969)
                  : c <= 5996)))))
            : (c <= 6000 || (c < 6314
              ? (c < 6176
                ? (c < 6103
                  ? (c >= 6016 && c <= 6067)
                  : (c <= 6103 || c == 6108))
                : (c <= 6264 || (c < 6279
                  ? (c >= 6272 && c <= 6276)
                  : c <= 6312)))
              : (c <= 6314 || (c < 6480
                ? (c < 6400
                  ? (c >= 6320 && c <= 6389)
                  : c <= 6430)
                : (c <= 6509 || (c < 6528
                  ? (c >= 6512 && c <= 6516)
                  : c <= 6571)))))))))))))
    : (c <= 6601 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7357
            ? (c < 7086
              ? (c < 6917
                ? (c < 6688
                  ? (c >= 6656 && c <= 6678)
                  : (c <= 6740 || c == 6823))
                : (c <= 6963 || (c < 7043
                  ? (c >= 6981 && c <= 6988)
                  : c <= 7072)))
              : (c <= 7087 || (c < 7258
                ? (c < 7168
                  ? (c >= 7098 && c <= 7141)
                  : (c <= 7203 || (c >= 7245 && c <= 7247)))
                : (c <= 7293 || (c < 7312
                  ? (c >= 7296 && c <= 7304)
                  : c <= 7354)))))
            : (c <= 7359 || (c < 7960
              ? (c < 7418
                ? (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7680
                  ? (c >= 7424 && c <= 7615)
                  : c <= 7957)))
              : (c <= 7965 || (c < 8025
                ? (c < 8008
                  ? (c >= 7968 && c <= 8005)
                  : (c <= 8013 || (c >= 8016 && c <= 8023)))
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym_hole_character_set_2(int32_t c) {
  return (c < 6320
    ? (c < 2990
      ? (c < 2447
        ? (c < 1749
          ? (c < 904
            ? (c < 186
              ? (c < '_'
                ? (c < '0'
                  ? c == '\''
                  : (c <= '9' || (c >= 'A' && c <= 'Z')))
                : (c <= 'z' || (c < 181
                  ? c == 170
                  : c <= 181)))
              : (c <= 186 || (c < 890
                ? (c < 880
                  ? (c >= 192 && c <= 750)
                  : c <= 887)
                : (c <= 893 || (c < 902
                  ? c == 895
                  : c <= 902)))))
            : (c <= 906 || (c < 1376
              ? (c < 1162
                ? (c < 910
                  ? c == 908
                  : (c <= 929 || (c >= 931 && c <= 1153)))
                : (c <= 1327 || (c < 1369
                  ? (c >= 1329 && c <= 1366)
                  : c <= 1369)))
              : (c <= 1416 || (c < 1568
                ? (c < 1519
                  ? (c >= 1488 && c <= 1514)
                  : c <= 1522)
                : (c <= 1610 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))))))
          : (c <= 1749 || (c < 2084
            ? (c < 1969
              ? (c < 1808
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1791)))
                : (c <= 1808 || (c < 1869
                  ? (c >= 1810 && c <= 1839)
                  : c <= 1957)))
              : (c <= 1969 || (c < 2042
                ? (c < 2036
                  ? (c >= 1994 && c <= 2026)
                  : c <= 2037)
                : (c <= 2042 || (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : c <= 2074)))))
            : (c <= 2084 || (c < 2308
              ? (c < 2144
                ? (c < 2112
                  ? c == 2088
                  : c <= 2136)
                : (c <= 2154 || (c < 2208
                  ? (c >= 2160 && c <= 2190)
                  : c <= 2249)))
              : (c <= 2361 || (c < 2392
                ? (c < 2384
                  ? c == 2365
                  : c <= 2384)
                : (c <= 2401 || (c < 2437
                  ? (c >= 2417 && c <= 2432)
                  : c <= 2444)))))))))
        : (c <= 2448 || (c < 2738
          ? (c < 2579
            ? (c < 2524
              ? (c < 2486
                ? (c < 2474
                  ? (c >= 2451 && c <= 2472)
                  : (c <= 2480 || c == 2482))
                : (c <= 2489 || (c < 2510
                  ? c == 2493
                  : c <= 2510)))
              : (c <= 2525 || (c < 2556
                ? (c < 2544
                  ? (c >= 2527 && c <= 2529)
                  : c <= 2545)
                : (c <= 2556 || (c < 2575
                  ? (c >= 2565 && c <= 2570)
                  : c <= 2576)))))
            : (c <= 2600 || (c < 2654
              ? (c < 2613
                ? (c < 2610
                  ? (c >= 2602 && c <= 2608)
                  : c <= 2611)
                : (c <= 2614 || (c < 2649
                  ? (c >= 2616 && c <= 2617)
                  : c <= 2652)))
              : (c <= 2654 || (c < 2703
                ? (c < 2693
                  ? (c >= 2674 && c <= 2676)
                  : c <= 2701)
                : (c <= 2705 || (c < 2730
                  ? (c >= 2707 && c <= 2728)
                  : c <= 2736)))))))
          : (c <= 2739 || (c < 2908
            ? (c < 2831
              ? (c < 2784
                ? (c < 2749
                  ? (c >= 2741 && c <= 2745)
                  : (c <= 2749 || c == 2768))
                : (c <= 2785 || (c < 2821
                  ? c == 2809
                  : c <= 2828)))
              : (c <= 2832 || (c < 2866
                ? (c < 2858
                  ? (c >= 2835 && c <= 2856)
                  : c <= 2864)
                : (c <= 2867 || (c < 2877
                  ? (c >= 2869 && c <= 2873)
                  : c <= 2877)))))
            : (c <= 2909 || (c < 2962
              ? (c < 2947
                ? (c < 2929
                  ? (c >= 2911 && c <= 2913)
                  : c <= 2929)
                : (c <= 2947 || (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : c <= 2960)))
              : (c <= 2965 || (c < 2974
                ? (c < 2972
                  ? (c >= 2969 && c <= 2970)
                  : c <= 2972)
                : (c <= 2975 || (c < 2984
                  ? (c >= 2979 && c <= 2980)
                  : c <= 2986)))))))))))
      : (c <= 3001 || (c < 3976
        ? (c < 3412
          ? (c < 3218
            ? (c < 3160
              ? (c < 3090
                ? (c < 3077
                  ? c == 3024
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))
                : (c <= 3112 || (c < 3133
                  ? (c >= 3114 && c <= 3129)
                  : c <= 3133)))
              : (c <= 3162 || (c < 3200
                ? (c < 3168
                  ? c == 3165
                  : c <= 3169)
                : (c <= 3200 || (c < 3214
                  ? (c >= 3205 && c <= 3212)
                  : c <= 3216)))))
            : (c <= 3240 || (c < 3313
              ? (c < 3261
                ? (c < 3253
                  ? (c >= 3242 && c <= 3251)
                  : c <= 3257)
                : (c <= 3261 || (c < 3296
                  ? (c >= 3293 && c <= 3294)
                  : c <= 3297)))
              : (c <= 3314 || (c < 3346
                ? (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)
                : (c <= 3386 || (c < 3406
                  ? c == 3389
                  : c <= 3406)))))))
          : (c <= 3414 || (c < 3718
            ? (c < 3520
              ? (c < 3482
                ? (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : (c <= 3455 || (c >= 3461 && c <= 3478)))
                : (c <= 3505 || (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : c <= 3517)))
              : (c <= 3526 || (c < 3648
                ? (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : c <= 3635)
                : (c <= 3654 || (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : c <= 3716)))))
            : (c <= 3722 || (c < 3776
              ? (c < 3751
                ? (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : c <= 3749)
                : (c <= 3760 || (c < 3773
                  ? (c >= 3762 && c <= 3763)
                  : c <= 3773)))
              : (c <= 3780 || (c < 3840
                ? (c < 3804
                  ? c == 3782
                  : c <= 3807)
                : (c <= 3840 || (c < 3913
                  ? (c >= 3904 && c <= 3911)
                  : c <= 3948)))))))))
        : (c <= 3980 || (c < 4802
          ? (c < 4304
            ? (c < 4206
              ? (c < 4186
                ? (c < 4159
                  ? (c >= 4096 && c <= 4138)
                  : (c <= 4159 || (c >= 4176 && c <= 4181)))
                : (c <= 4189 || (c < 4197
                  ? c == 4193
                  : c <= 4198)))
              : (c <= 4208 || (c < 4256
                ? (c < 4238
                  ? (c >= 4213 && c <= 4225)
                  : c <= 4238)
                : (c <= 4293 || (c < 4301
                  ? c == 4295
                  : c <= 4301)))))
            : (c <= 4346 || (c < 4704
              ? (c < 4688
                ? (c < 4682
                  ? (c >= 4348 && c <= 4680)
                  : c <= 4685)
                : (c <= 4694 || (c < 4698
                  ? c == 4696
                  : c <= 4701)))
              : (c <= 4744 || (c < 4786
                ? (c < 4752
                  ? (c >= 4746 && c <= 4749)
                  : c <= 4784)
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)))))))
          : (c <= 4805 || (c < 5888
            ? (c < 5112
              ? (c < 4888
                ? (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : (c <= 4880 || (c >= 4882 && c <= 4885)))
                : (c <= 4954 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : c <= 5109)))
              : (c <= 5117 || (c < 5761
                ? (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : c <= 5759)
                : (c <= 5786 || (c < 5873
                  ? (c >= 5792 && c <= 5866)
                  : c <= 5880)))))
            : (c <= 5905 || (c < 6103
              ? (c < 5984
                ? (c < 5952
                  ? (c >= 5919 && c <= 5937)
                  : c <= 5969)
                : (c <= 5996 || (c < 6016
                  ? (c >= 5998 && c <= 6000)
                  : c <= 6067)))
              : (c <= 6103 || (c < 6272
                ? (c < 6176
                  ? c == 6108
                  : c <= 6264)
                : (c <= 6276 || (c < 6314
                  ? (c >= 6279 && c <= 6312)
                  : c <= 6314)))))))))))))
    : (c <= 6389 || (c < 43396
      ? (c < 11565
        ? (c < 7680
          ? (c < 7098
            ? (c < 6688
              ? (c < 6528
                ? (c < 6480
                  ? (c >= 6400 && c <= 6430)
                  : (c <= 6509 || (c >= 6512 && c <= 6516)))
                : (c <= 6571 || (c < 6656
                  ? (c >= 6576 && c <= 6601)
                  : c <= 6678)))
              : (c <= 6740 || (c < 6981
                ? (c < 6917
                  ? c == 6823
                  : c <= 6963)
                : (c <= 6988 || (c < 7086
                  ? (c >= 7043 && c <= 7072)
                  : c <= 7087)))))
            : (c <= 7141 || (c < 7357
              ? (c < 7258
                ? (c < 7245
                  ? (c >= 7168 && c <= 7203)
                  : c <= 7247)
                : (c <= 7293 || (c < 7312
                  ? (c >= 7296 && c <= 7304)
                  : c <= 7354)))
              : (c <= 7359 || (c < 7413
                ? (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : c <= 7411)
                : (c <= 7414 || (c < 7424
                  ? c == 7418
                  : c <= 7615)))))))
          : (c <= 7957 || (c < 8160
            ? (c < 8029
              ? (c < 8016
                ? (c < 7968
                  ? (c >= 7960 && c <= 7965)
                  : (c <= 8005 || (c >= 8008 && c <= 8013)))
                : (c <= 8023 || (c < 8027
                  ? c == 8025
                  : c <= 8027)))
              : (c <= 8029 || (c < 8118
                ? (c < 8064
                  ? (c >= 8031 && c <= 8061)
                  : c <= 8116)
                : (c <= 8132 || (c < 8150
                  ? (c >= 8134 && c <= 8147)
                  : c <= 8155)))))
            : (c <= 8172 || (c < 8450
              ? (c < 8305
                ? (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : c <= 8188)
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))
              : (c <= 8526 || (c < 11506
                ? (c < 11264
                  ? (c >= 8579 && c <= 8580)
                  : c <= 11502)
                : (c <= 11507 || (c < 11559
                  ? (c >= 11520 && c <= 11557)
                  : c <= 11559)))))))))
        : (c <= 11565 || (c < 19903
          ? (c < 12293
            ? (c < 11704
              ? (c < 11680
                ? (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))
                : (c <= 11686 || (c < 11696
                  ? (c >= 11688 && c <= 11694)
                  : c <= 11702)))
              : (c <= 11710 || (c < 11728
                ? (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : c <= 11726)
                : (c <= 11734 || (c < 11823
                  ? (c >= 11736 && c <= 11742)
                  : c <= 11823)))))
            : (c <= 12294 || (c < 12540
              ? (c < 12353
                ? (c < 12347
                  ? (c >= 12337 && c <= 12341)
                  : c <= 12348)
                : (c <= 12438 || (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : c <= 12538)))
              : (c <= 12543 || (c < 12704
                ? (c < 12593
                  ? (c >= 12549 && c <= 12591)
                  : c <= 12686)
                : (c <= 12735 || (c < 13312
                  ? (c >= 12784 && c <= 12799)
                  : c <= 13312)))))))
          : (c <= 19968 || (c < 42994
            ? (c < 42623
              ? (c < 42512
                ? (c < 42192
                  ? (c >= 40959 && c <= 42124)
                  : (c <= 42237 || (c >= 42240 && c <= 42508)))
                : (c <= 42527 || (c < 42560
                  ? (c >= 42538 && c <= 42539)
                  : c <= 42606)))
              : (c <= 42653 || (c < 42960
                ? (c < 42775
                  ? (c >= 42656 && c <= 42725)
                  : c <= 42954)
                : (c <= 42961 || (c < 42965
                  ? c == 42963
                  : c <= 42969)))))
            : (c <= 43009 || (c < 43250
              ? (c < 43020
                ? (c < 43015
                  ? (c >= 43011 && c <= 43013)
                  : c <= 43018)
                : (c <= 43042 || (c < 43138
                  ? (c >= 43072 && c <= 43123)
                  : c <= 43187)))
              : (c <= 43255 || (c < 43274
                ? (c < 43261
                  ? c == 43259
                  : c <= 43262)
                : (c <= 43301 || (c < 43360
                  ? (c >= 43312 && c <= 43334)
                  : c <= 43388)))))))))))
      : (c <= 43442 || (c < 65482
        ? (c < 44032
          ? (c < 43712
            ? (c < 43588
              ? (c < 43514
                ? (c < 43488
                  ? c == 43471
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))
                : (c <= 43518 || (c < 43584
                  ? (c >= 43520 && c <= 43560)
                  : c <= 43586)))
              : (c <= 43595 || (c < 43697
                ? (c < 43646
                  ? (c >= 43616 && c <= 43642)
                  : c <= 43695)
                : (c <= 43697 || (c < 43705
                  ? (c >= 43701 && c <= 43702)
                  : c <= 43709)))))
            : (c <= 43712 || (c < 43785
              ? (c < 43744
                ? (c < 43739
                  ? c == 43714
                  : c <= 43741)
                : (c <= 43754 || (c < 43777
                  ? (c >= 43762 && c <= 43764)
                  : c <= 43782)))
              : (c <= 43790 || (c < 43816
                ? (c < 43808
                  ? (c >= 43793 && c <= 43798)
                  : c <= 43814)
                : (c <= 43822 || (c < 43888
                  ? (c >= 43824 && c <= 43881)
                  : c <= 44002)))))))
          : (c <= 44032 || (c < 64323
            ? (c < 64275
              ? (c < 63744
                ? (c < 55216
                  ? c == 55203
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64256
                  ? (c >= 64112 && c <= 64217)
                  : c <= 64262)))
              : (c <= 64279 || (c < 64312
                ? (c < 64287
                  ? c == 64285
                  : c <= 64310)
                : (c <= 64316 || (c < 64320
                  ? c == 64318
                  : c <= 64321)))))
            : (c <= 64324 || (c < 65136
              ? (c < 64848
                ? (c < 64467
                  ? (c >= 64326 && c <= 64433)
                  : c <= 64829)
                : (c <= 64911 || (c < 65008
                  ? (c >= 64914 && c <= 64967)
                  : c <= 65019)))
              : (c <= 65140 || (c < 65345
                ? (c < 65313
                  ? (c >= 65142 && c <= 65276)
                  : c <= 65338)
                : (c <= 65370 || (c < 65474
                  ? (c >= 65382 && c <= 65470)
                  : c <= 65479)))))))))
        : (c <= 65487 || (c < 66940
          ? (c < 66349
            ? (c < 65599
              ? (c < 65549
                ? (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : (c <= 65500 || (c >= 65536 && c <= 65547)))
                : (c <= 65574 || (c < 65596
                  ? (c >= 65576 && c <= 65594)
                  : c <= 65597)))
              : (c <= 65613 || (c < 66176
                ? (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)
                : (c <= 66204 || (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : c <= 66335)))))
            : (c <= 66368 || (c < 66560
              ? (c < 66432
                ? (c < 66384
                  ? (c >= 66370 && c <= 66377)
                  : c <= 66421)
                : (c <= 66461 || (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : c <= 66511)))
              : (c <= 66717 || (c < 66816
                ? (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)
                : (c <= 66855 || (c < 66928
                  ? (c >= 66864 && c <= 66915)
                  : c <= 66938)))))))
          : (c <= 66954 || (c < 67584
            ? (c < 67072
              ? (c < 66979
                ? (c < 66964
                  ? (c >= 66956 && c <= 66962)
                  : (c <= 66965 || (c >= 66967 && c <= 66977)))
                : (c <= 66993 || (c < 67003
                  ? (c >= 66995 && c <= 67001)
                  : c <= 67004)))
              : (c <= 67382 || (c < 67456
                ? (c < 67424
                  ? (c >= 67392 && c <= 67413)
                  : c <= 67431)
                : (c <= 67461 || (c < 67506
                  ? (c >= 67463 && c <= 67504)
                  : c <= 67514)))))
            : (c <= 67589 || (c < 67680
              ? (c < 67639
                ? (c < 67594
                  ? c == 67592
                  : c <= 67637)
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym__varid_character_set_1(int32_t c) {
  return (c < 8160
    ? (c < 4349
      ? (c < 661
        ? (c < 445
          ? (c < 223
            ? (c < 181
              ? (c >= 'a' && c <= 'z')
              : c <= 181)
            : (c <= 246 || (c >= 248 && c <= 442)))
          : (c <= 447 || (c < 460
            ? (c < 457
              ? c == 454
              : c <= 457)
            : (c <= 496 || (c >= 499 && c <= 659)))))
        : (c <= 687 || (c < 940
          ? (c < 891
            ? (c < 887
              ? (c >= 881 && c <= 883)
              : c <= 887)
            : (c <= 893 || c == 912))
          : (c <= 1013 || (c < 1376
            ? (c < 1163
              ? (c >= 1016 && c <= 1153)
              : c <= 1327)
            : (c <= 1416 || (c >= 4304 && c <= 4346)))))))
      : (c <= 4351 || (c < 8064
        ? (c < 7545
          ? (c < 7424
            ? (c < 7296
              ? (c >= 5112 && c <= 5117)
              : c <= 7304)
            : (c <= 7467 || (c >= 7531 && c <= 7543)))
          : (c <= 7578 || (c < 8016
            ? (c < 7968
              ? (c >= 7681 && c <= 7957)
              : c <= 8005)
            : (c <= 8023 || (c >= 8032 && c <= 8061)))))
        : (c <= 8071 || (c < 8126
          ? (c < 8112
            ? (c < 8096
              ? (c >= 8080 && c <= 8087)
              : c <= 8103)
            : (c <= 8116 || (c >= 8118 && c <= 8119)))
          : (c <= 8126 || (c < 8144
            ? (c < 8134
              ? (c >= 8130 && c <= 8132)
              : c <= 8135)
            : (c <= 8147 || (c >= 8150 && c <= 8151)))))))))
    : (c <= 8167 || (c < 42865
      ? (c < 11312
        ? (c < 8505
          ? (c < 8458
            ? (c < 8182
              ? (c >= 8178 && c <= 8180)
              : c <= 8183)
            : (c <= 8467 || (c >= 8495 && c <= 8500)))
          : (c <= 8505 || (c < 8526
            ? (c < 8518
              ? (c >= 8508 && c <= 8509)
              : c <= 8521)
            : (c <= 8526 || c == 8580))))
        : (c <= 11387 || (c < 11559
          ? (c < 11507
            ? (c < 11500
              ? (c >= 11393 && c <= 11492)
              : c <= 11502)
            : (c <= 11507 || (c >= 11520 && c <= 11557)))
          : (c <= 11559 || (c < 42625
            ? (c < 42561
              ? c == 11565
              : c <= 42605)
            : (c <= 42651 || (c >= 42787 && c <= 42863)))))))
      : (c <= 42887 || (c < 43888
        ? (c < 42965
          ? (c < 42961
            ? (c < 42897
              ? (c >= 42892 && c <= 42894)
              : c <= 42954)
            : (c <= 42961 || c == 42963))
          : (c <= 42969 || (c < 43824
            ? (c < 43002
              ? c == 42998
              : c <= 43002)
            : (c <= 43866 || (c >= 43872 && c <= 43880)))))
        : (c <= 43967 || (c < 66776
          ? (c < 65345
            ? (c < 64275
              ? (c >= 64256 && c <= 64262)
              : c <= 64279)
            : (c <= 65370 || (c >= 66600 && c <= 66639)))
          : (c <= 66811 || (c < 66995
            ? (c < 66979
              ? (c >= 66967 && c <= 66977)
              : c <= 66993)
            : (c <= 67001 || (c >= 67003 && c <= 67004)))))))))));
}

static inline bool sym__varid_character_set_2(int32_t c) {
  return (c < 8150
    ? (c < 4349
      ? (c < 661
        ? (c < 454
          ? (c < 223
            ? (c < 181
              ? (c >= 'a' && c <= 'z')
              : c <= 181)
            : (c <= 442 || (c >= 445 && c <= 447)))
          : (c <= 454 || (c < 460
            ? c == 457
            : (c <= 496 || (c >= 499 && c <= 659)))))
        : (c <= 687 || (c < 940
          ? (c < 891
            ? (c < 887
              ? (c >= 881 && c <= 883)
              : c <= 887)
            : (c <= 893 || c == 912))
          : (c <= 1153 || (c < 1376
            ? (c >= 1163 && c <= 1327)
            : (c <= 1416 || (c >= 4304 && c <= 4346)))))))
      : (c <= 4351 || (c < 8032
        ? (c < 7545
          ? (c < 7424
            ? (c < 7296
              ? (c >= 5112 && c <= 5117)
              : c <= 7304)
            : (c <= 7467 || (c >= 7531 && c <= 7543)))
          : (c <= 7578 || (c < 7968
            ? (c >= 7681 && c <= 7957)
            : (c <= 8005 || (c >= 8016 && c <= 8023)))))
        : (c <= 8061 || (c < 8118
          ? (c < 8096
            ? (c < 8080
              ? (c >= 8064 && c <= 8071)
              : c <= 8087)
            : (c <= 8103 || (c >= 8112 && c <= 8116)))
          : (c <= 8119 || (c < 8134
            ? (c >= 8126 && c <= 8132)
            : (c <= 8135 || (c >= 8144 && c <= 8147)))))))))
    : (c <= 8151 || (c < 42897
      ? (c < 11507
        ? (c < 8505
          ? (c < 8182
            ? (c < 8178
              ? (c >= 8160 && c <= 8167)
              : c <= 8180)
            : (c <= 8183 || (c >= 8458 && c <= 8500)))
          : (c <= 8526 || (c < 11312
            ? c == 8580
            : (c <= 11387 || (c >= 11393 && c <= 11502)))))
        : (c <= 11507 || (c < 42625
          ? (c < 11565
            ? (c < 11559
              ? (c >= 11520 && c <= 11557)
              : c <= 11559)
            : (c <= 11565 || (c >= 42561 && c <= 42605)))
          : (c <= 42651 || (c < 42865
            ? (c >= 42787 && c <= 42863)
            : (c <= 42887 || (c >= 42892 && c <= 42894)))))))
      : (c <= 42954 || (c < 64256
        ? (c < 43002
          ? (c < 42965
            ? (c < 42963
              ? c == 42961
              : c <= 42963)
            : (c <= 42969 || c == 42998))
          : (c <= 43002 || (c < 43872
            ? (c >= 43824 && c <= 43866)
            : (c <= 43880 || (c >= 43888 && c <= 43967)))))
        : (c <= 64262 || (c < 66967
          ? (c < 66600
            ? (c < 65345
              ? (c >= 64275 && c <= 64279)
              : c <= 65370)
            : (c <= 66639 || (c >= 66776 && c <= 66811)))
          : (c <= 66977 || (c < 66995
            ? (c >= 66979 && c <= 66993)
            : (c <= 67001 || (c >= 67003 && c <= 67004)))))))))));
}

static inline bool sym__varid_character_set_3(int32_t c) {
  return (c < 6576
    ? (c < 2974
      ? (c < 2208
        ? (c < 1369
          ? (c < 748
            ? (c < 181
              ? (c < '_'
                ? (c < '0'
                  ? c == '\''
                  : (c <= '9' || (c >= 'A' && c <= 'Z')))
                : (c <= '_' || (c < 170
                  ? (c >= 'b' && c <= 'z')
                  : c <= 170)))
              : (c <= 181 || (c < 248
                ? (c < 192
                  ? c == 186
                  : (c <= 214 || (c >= 216 && c <= 246)))
                : (c <= 705 || (c < 736
                  ? (c >= 710 && c <= 721)
                  : c <= 740)))))
            : (c <= 748 || (c < 904
              ? (c < 890
                ? (c < 880
                  ? c == 750
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 902
                  ? c == 895
                  : c <= 902)))
              : (c <= 906 || (c < 1015
                ? (c < 910
                  ? c == 908
                  : (c <= 929 || (c >= 931 && c <= 1013)))
                : (c <= 1153 || (c < 1329
                  ? (c >= 1162 && c <= 1327)
                  : c <= 1366)))))))
          : (c <= 1369 || (c < 1869
            ? (c < 1749
              ? (c < 1568
                ? (c < 1488
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 1514 || (c >= 1519 && c <= 1522)))
                : (c <= 1610 || (c < 1649
                  ? (c >= 1646 && c <= 1647)
                  : c <= 1747)))
              : (c <= 1749 || (c < 1791
                ? (c < 1774
                  ? (c >= 1765 && c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1810
                  ? c == 1808
                  : c <= 1839)))))
            : (c <= 1957 || (c < 2084
              ? (c < 2042
                ? (c < 1994
                  ? c == 1969
                  : (c <= 2026 || (c >= 2036 && c <= 2037)))
                : (c <= 2042 || (c < 2074
                  ? (c >= 2048 && c <= 2069)
                  : c <= 2074)))
              : (c <= 2084 || (c < 2144
                ? (c < 2112
                  ? c == 2088
                  : c <= 2136)
                : (c <= 2154 || (c < 2185
                  ? (c >= 2160 && c <= 2183)
                  : c <= 2190)))))))))
        : (c <= 2249 || (c < 2674
          ? (c < 2524
            ? (c < 2447
              ? (c < 2392
                ? (c < 2365
                  ? (c >= 2308 && c <= 2361)
                  : (c <= 2365 || c == 2384))
                : (c <= 2401 || (c < 2437
                  ? (c >= 2417 && c <= 2432)
                  : c <= 2444)))
              : (c <= 2448 || (c < 2486
                ? (c < 2474
                  ? (c >= 2451 && c <= 2472)
                  : (c <= 2480 || c == 2482))
                : (c <= 2489 || (c < 2510
                  ? c == 2493
                  : c <= 2510)))))
            : (c <= 2525 || (c < 2602
              ? (c < 2565
                ? (c < 2544
                  ? (c >= 2527 && c <= 2529)
                  : (c <= 2545 || c == 2556))
                : (c <= 2570 || (c < 2579
                  ? (c >= 2575 && c <= 2576)
                  : c <= 2600)))
              : (c <= 2608 || (c < 2616
                ? (c < 2613
                  ? (c >= 2610 && c <= 2611)
                  : c <= 2614)
                : (c <= 2617 || (c < 2654
                  ? (c >= 2649 && c <= 2652)
                  : c <= 2654)))))))
          : (c <= 2676 || (c < 2858
            ? (c < 2749
              ? (c < 2730
                ? (c < 2703
                  ? (c >= 2693 && c <= 2701)
                  : (c <= 2705 || (c >= 2707 && c <= 2728)))
                : (c <= 2736 || (c < 2741
                  ? (c >= 2738 && c <= 2739)
                  : c <= 2745)))
              : (c <= 2749 || (c < 2821
                ? (c < 2784
                  ? c == 2768
                  : (c <= 2785 || c == 2809))
                : (c <= 2828 || (c < 2835
                  ? (c >= 2831 && c <= 2832)
                  : c <= 2856)))))
            : (c <= 2864 || (c < 2947
              ? (c < 2908
                ? (c < 2869
                  ? (c >= 2866 && c <= 2867)
                  : (c <= 2873 || c == 2877))
                : (c <= 2909 || (c < 2929
                  ? (c >= 2911 && c <= 2913)
                  : c <= 2929)))
              : (c <= 2947 || (c < 2962
                ? (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : c <= 2960)
                : (c <= 2965 || (c < 2972
                  ? (c >= 2969 && c <= 2970)
                  : c <= 2972)))))))))))
      : (c <= 2975 || (c < 4096
        ? (c < 3406
          ? (c < 3205
            ? (c < 3090
              ? (c < 3024
                ? (c < 2984
                  ? (c >= 2979 && c <= 2980)
                  : (c <= 2986 || (c >= 2990 && c <= 3001)))
                : (c <= 3024 || (c < 3086
                  ? (c >= 3077 && c <= 3084)
                  : c <= 3088)))
              : (c <= 3112 || (c < 3165
                ? (c < 3133
                  ? (c >= 3114 && c <= 3129)
                  : (c <= 3133 || (c >= 3160 && c <= 3162)))
                : (c <= 3165 || (c < 3200
                  ? (c >= 3168 && c <= 3169)
                  : c <= 3200)))))
            : (c <= 3212 || (c < 3296
              ? (c < 3253
                ? (c < 3218
                  ? (c >= 3214 && c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))
                : (c <= 3257 || (c < 3293
                  ? c == 3261
                  : c <= 3294)))
              : (c <= 3297 || (c < 3342
                ? (c < 3332
                  ? (c >= 3313 && c <= 3314)
                  : c <= 3340)
                : (c <= 3344 || (c < 3389
                  ? (c >= 3346 && c <= 3386)
                  : c <= 3389)))))))
          : (c <= 3406 || (c < 3718
            ? (c < 3517
              ? (c < 3461
                ? (c < 3423
                  ? (c >= 3412 && c <= 3414)
                  : (c <= 3425 || (c >= 3450 && c <= 3455)))
                : (c <= 3478 || (c < 3507
                  ? (c >= 3482 && c <= 3505)
                  : c <= 3515)))
              : (c <= 3517 || (c < 3648
                ? (c < 3585
                  ? (c >= 3520 && c <= 3526)
                  : (c <= 3632 || (c >= 3634 && c <= 3635)))
                : (c <= 3654 || (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : c <= 3716)))))
            : (c <= 3722 || (c < 3782
              ? (c < 3762
                ? (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : (c <= 3749 || (c >= 3751 && c <= 3760)))
                : (c <= 3763 || (c < 3776
                  ? c == 3773
                  : c <= 3780)))
              : (c <= 3782 || (c < 3904
                ? (c < 3840
                  ? (c >= 3804 && c <= 3807)
                  : c <= 3840)
                : (c <= 3911 || (c < 3976
                  ? (c >= 3913 && c <= 3948)
                  : c <= 3980)))))))))
        : (c <= 4138 || (c < 4882
          ? (c < 4682
            ? (c < 4213
              ? (c < 4193
                ? (c < 4176
                  ? c == 4159
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))
                : (c <= 4193 || (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : c <= 4208)))
              : (c <= 4225 || (c < 4301
                ? (c < 4256
                  ? c == 4238
                  : (c <= 4293 || c == 4295))
                : (c <= 4301 || (c < 4348
                  ? (c >= 4304 && c <= 4346)
                  : c <= 4680)))))
            : (c <= 4685 || (c < 4786
              ? (c < 4704
                ? (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : (c <= 4696 || (c >= 4698 && c <= 4701)))
                : (c <= 4744 || (c < 4752
                  ? (c >= 4746 && c <= 4749)
                  : c <= 4784)))
              : (c <= 4789 || (c < 4802
                ? (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : c <= 4800)
                : (c <= 4805 || (c < 4824
                  ? (c >= 4808 && c <= 4822)
                  : c <= 4880)))))))
          : (c <= 4885 || (c < 5998
            ? (c < 5761
              ? (c < 5112
                ? (c < 4992
                  ? (c >= 4888 && c <= 4954)
                  : (c <= 5007 || (c >= 5024 && c <= 5109)))
                : (c <= 5117 || (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : c <= 5759)))
              : (c <= 5786 || (c < 5919
                ? (c < 5873
                  ? (c >= 5792 && c <= 5866)
                  : (c <= 5880 || (c >= 5888 && c <= 5905)))
                : (c <= 5937 || (c < 5984
                  ? (c >= 5952 && c <= 5969)
                  : c <= 5996)))))
            : (c <= 6000 || (c < 6314
              ? (c < 6176
                ? (c < 6103
                  ? (c >= 6016 && c <= 6067)
                  : (c <= 6103 || c == 6108))
                : (c <= 6264 || (c < 6279
                  ? (c >= 6272 && c <= 6276)
                  : c <= 6312)))
              : (c <= 6314 || (c < 6480
                ? (c < 6400
                  ? (c >= 6320 && c <= 6389)
                  : c <= 6430)
                : (c <= 6509 || (c < 6528
                  ? (c >= 6512 && c <= 6516)
                  : c <= 6571)))))))))))))
    : (c <= 6601 || (c < 43259
      ? (c < 8579
        ? (c < 8031
          ? (c < 7357
            ? (c < 7086
              ? (c < 6917
                ? (c < 6688
                  ? (c >= 6656 && c <= 6678)
                  : (c <= 6740 || c == 6823))
                : (c <= 6963 || (c < 7043
                  ? (c >= 6981 && c <= 6988)
                  : c <= 7072)))
              : (c <= 7087 || (c < 7258
                ? (c < 7168
                  ? (c >= 7098 && c <= 7141)
                  : (c <= 7203 || (c >= 7245 && c <= 7247)))
                : (c <= 7293 || (c < 7312
                  ? (c >= 7296 && c <= 7304)
                  : c <= 7354)))))
            : (c <= 7359 || (c < 7960
              ? (c < 7418
                ? (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7680
                  ? (c >= 7424 && c <= 7615)
                  : c <= 7957)))
              : (c <= 7965 || (c < 8025
                ? (c < 8008
                  ? (c >= 7968 && c <= 8005)
                  : (c <= 8013 || (c >= 8016 && c <= 8023)))
                : (c <= 8025 || (c < 8029
                  ? c == 8027
                  : c <= 8029)))))))
          : (c <= 8061 || (c < 8450
            ? (c < 8150
              ? (c < 8130
                ? (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))
                : (c <= 8132 || (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : c <= 8147)))
              : (c <= 8155 || (c < 8305
                ? (c < 8178
                  ? (c >= 8160 && c <= 8172)
                  : (c <= 8180 || (c >= 8182 && c <= 8188)))
                : (c <= 8305 || (c < 8336
                  ? c == 8319
                  : c <= 8348)))))
            : (c <= 8450 || (c < 8488
              ? (c < 8473
                ? (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))
                : (c <= 8477 || (c < 8486
                  ? c == 8484
                  : c <= 8486)))
              : (c <= 8488 || (c < 8508
                ? (c < 8495
                  ? (c >= 8490 && c <= 8493)
                  : c <= 8505)
                : (c <= 8511 || (c < 8526
                  ? (c >= 8517 && c <= 8521)
                  : c <= 8526)))))))))
        : (c <= 8580 || (c < 12593
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11264 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12347
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12337
                  ? (c >= 12293 && c <= 12294)
                  : c <= 12341)))
              : (c <= 12348 || (c < 12449
                ? (c < 12445
                  ? (c >= 12353 && c <= 12438)
                  : c <= 12447)
                : (c <= 12538 || (c < 12549
                  ? (c >= 12540 && c <= 12543)
                  : c <= 12591)))))))
          : (c <= 12686 || (c < 42775
            ? (c < 42192
              ? (c < 19903
                ? (c < 12784
                  ? (c >= 12704 && c <= 12735)
                  : (c <= 12799 || c == 13312))
                : (c <= 19903 || (c < 40959
                  ? c == 19968
                  : c <= 42124)))
              : (c <= 42237 || (c < 42560
                ? (c < 42512
                  ? (c >= 42240 && c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42656
                  ? (c >= 42623 && c <= 42653)
                  : c <= 42725)))))
            : (c <= 42783 || (c < 43011
              ? (c < 42963
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42954 || (c >= 42960 && c <= 42961)))
                : (c <= 42963 || (c < 42994
                  ? (c >= 42965 && c <= 42969)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66864
          ? (c < 66176
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 66204 || (c < 66464
              ? (c < 66370
                ? (c < 66304
                  ? (c >= 66208 && c <= 66256)
                  : (c <= 66335 || (c >= 66349 && c <= 66368)))
                : (c <= 66377 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66736
                ? (c < 66560
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66717)
                : (c <= 66771 || (c < 66816
                  ? (c >= 66776 && c <= 66811)
                  : c <= 66855)))))))
          : (c <= 66915 || (c < 67506
            ? (c < 66995
              ? (c < 66964
                ? (c < 66940
                  ? (c >= 66928 && c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))
                : (c <= 66965 || (c < 66979
                  ? (c >= 66967 && c <= 66977)
                  : c <= 66993)))
              : (c <= 67001 || (c < 67424
                ? (c < 67072
                  ? (c >= 67003 && c <= 67004)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67463
                  ? (c >= 67456 && c <= 67461)
                  : c <= 67504)))))
            : (c <= 67514 || (c < 67680
              ? (c < 67639
                ? (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : (c <= 67592 || (c >= 67594 && c <= 67637)))
                : (c <= 67640 || (c < 67647
                  ? c == 67644
                  : c <= 67669)))
              : (c <= 67702 || (c < 67828
                ? (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)
                : (c <= 67829 || (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : c <= 67883)))))))))))))));
}

static inline bool sym__immediate_varid_character_set_1(int32_t c) {
  return (c < 7749
    ? (c < 987
      ? (c < 424
        ? (c < 326
          ? (c < 285
            ? (c < 265
              ? (c < 248
                ? (c < 181
                  ? (c < 'a'
                    ? c == '_'
                    : c <= 'z')
                  : (c <= 181 || (c >= 223 && c <= 246)))
                : (c <= 255 || (c < 261
                  ? (c < 259
                    ? c == 257
                    : c <= 259)
                  : (c <= 261 || c == 263))))
              : (c <= 265 || (c < 275
                ? (c < 271
                  ? (c < 269
                    ? c == 267
                    : c <= 269)
                  : (c <= 271 || c == 273))
                : (c <= 275 || (c < 281
                  ? (c < 279
                    ? c == 277
                    : c <= 279)
                  : (c <= 281 || c == 283))))))
            : (c <= 285 || (c < 305
              ? (c < 295
                ? (c < 291
                  ? (c < 289
                    ? c == 287
                    : c <= 289)
                  : (c <= 291 || c == 293))
                : (c <= 295 || (c < 301
                  ? (c < 299
                    ? c == 297
                    : c <= 299)
                  : (c <= 301 || c == 303))))
              : (c <= 305 || (c < 316
                ? (c < 311
                  ? (c < 309
                    ? c == 307
                    : c <= 309)
                  : (c <= 312 || c == 314))
                : (c <= 316 || (c < 322
                  ? (c < 320
                    ? c == 318
                    : c <= 320)
                  : (c <= 322 || c == 324))))))))
          : (c <= 326 || (c < 367
            ? (c < 347
              ? (c < 337
                ? (c < 333
                  ? (c < 331
                    ? (c >= 328 && c <= 329)
                    : c <= 331)
                  : (c <= 333 || c == 335))
                : (c <= 337 || (c < 343
                  ? (c < 341
                    ? c == 339
                    : c <= 341)
                  : (c <= 343 || c == 345))))
              : (c <= 347 || (c < 357
                ? (c < 353
                  ? (c < 351
                    ? c == 349
                    : c <= 351)
                  : (c <= 353 || c == 355))
                : (c <= 357 || (c < 363
                  ? (c < 361
                    ? c == 359
                    : c <= 361)
                  : (c <= 363 || c == 365))))))
            : (c <= 367 || (c < 392
              ? (c < 378
                ? (c < 373
                  ? (c < 371
                    ? c == 369
                    : c <= 371)
                  : (c <= 373 || c == 375))
                : (c <= 378 || (c < 387
                  ? (c < 382
                    ? c == 380
                    : c <= 384)
                  : (c <= 387 || c == 389))))
              : (c <= 392 || (c < 414
                ? (c < 405
                  ? (c < 402
                    ? (c >= 396 && c <= 397)
                    : c <= 402)
                  : (c <= 405 || (c >= 409 && c <= 411)))
                : (c <= 414 || (c < 419
                  ? c == 417
                  : (c <= 419 || c == 421))))))))))
        : (c <= 424 || (c < 523
          ? (c < 481
            ? (c < 460
              ? (c < 438
                ? (c < 432
                  ? (c < 429
                    ? (c >= 426 && c <= 427)
                    : c <= 429)
                  : (c <= 432 || c == 436))
                : (c <= 438 || (c < 454
                  ? (c < 445
                    ? (c >= 441 && c <= 442)
                    : c <= 447)
                  : (c <= 454 || c == 457))))
              : (c <= 460 || (c < 470
                ? (c < 466
                  ? (c < 464
                    ? c == 462
                    : c <= 464)
                  : (c <= 466 || c == 468))
                : (c <= 470 || (c < 476
                  ? (c < 474
                    ? c == 472
                    : c <= 474)
                  : (c <= 477 || c == 479))))))
            : (c <= 481 || (c < 505
              ? (c < 491
                ? (c < 487
                  ? (c < 485
                    ? c == 483
                    : c <= 485)
                  : (c <= 487 || c == 489))
                : (c <= 491 || (c < 499
                  ? (c < 495
                    ? c == 493
                    : c <= 496)
                  : (c <= 499 || c == 501))))
              : (c <= 505 || (c < 515
                ? (c < 511
                  ? (c < 509
                    ? c == 507
                    : c <= 509)
                  : (c <= 511 || c == 513))
                : (c <= 515 || (c < 519
                  ? c == 517
                  : (c <= 519 || c == 521))))))))
          : (c <= 523 || (c < 563
            ? (c < 543
              ? (c < 533
                ? (c < 529
                  ? (c < 527
                    ? c == 525
                    : c <= 527)
                  : (c <= 529 || c == 531))
                : (c <= 533 || (c < 539
                  ? (c < 537
                    ? c == 535
                    : c <= 537)
                  : (c <= 539 || c == 541))))
              : (c <= 543 || (c < 553
                ? (c < 549
                  ? (c < 547
                    ? c == 545
                    : c <= 547)
                  : (c <= 549 || c == 551))
                : (c <= 553 || (c < 559
                  ? (c < 557
                    ? c == 555
                    : c <= 557)
                  : (c <= 559 || c == 561))))))
            : (c <= 569 || (c < 881
              ? (c < 585
                ? (c < 578
                  ? (c < 575
                    ? c == 572
                    : c <= 576)
                  : (c <= 578 || c == 583))
                : (c <= 585 || (c < 591
                  ? (c < 589
                    ? c == 587
                    : c <= 589)
                  : (c <= 659 || (c >= 661 && c <= 687)))))
              : (c <= 881 || (c < 940
                ? (c < 891
                  ? (c < 887
                    ? c == 883
                    : c <= 887)
                  : (c <= 893 || c == 912))
                : (c <= 974 || (c < 981
                  ? (c >= 976 && c <= 977)
                  : (c <= 983 || c == 985))))))))))))
      : (c <= 987 || (c < 1257
        ? (c < 1177
          ? (c < 1131
            ? (c < 1007
              ? (c < 997
                ? (c < 993
                  ? (c < 991
                    ? c == 989
                    : c <= 991)
                  : (c <= 993 || c == 995))
                : (c <= 997 || (c < 1003
                  ? (c < 1001
                    ? c == 999
                    : c <= 1001)
                  : (c <= 1003 || c == 1005))))
              : (c <= 1011 || (c < 1121
                ? (c < 1019
                  ? (c < 1016
                    ? c == 1013
                    : c <= 1016)
                  : (c <= 1020 || (c >= 1072 && c <= 1119)))
                : (c <= 1121 || (c < 1127
                  ? (c < 1125
                    ? c == 1123
                    : c <= 1125)
                  : (c <= 1127 || c == 1129))))))
            : (c <= 1131 || (c < 1151
              ? (c < 1141
                ? (c < 1137
                  ? (c < 1135
                    ? c == 1133
                    : c <= 1135)
                  : (c <= 1137 || c == 1139))
                : (c <= 1141 || (c < 1147
                  ? (c < 1145
                    ? c == 1143
                    : c <= 1145)
                  : (c <= 1147 || c == 1149))))
              : (c <= 1151 || (c < 1169
                ? (c < 1165
                  ? (c < 1163
                    ? c == 1153
                    : c <= 1163)
                  : (c <= 1165 || c == 1167))
                : (c <= 1169 || (c < 1173
                  ? c == 1171
                  : (c <= 1173 || c == 1175))))))))
          : (c <= 1177 || (c < 1218
            ? (c < 1197
              ? (c < 1187
                ? (c < 1183
                  ? (c < 1181
                    ? c == 1179
                    : c <= 1181)
                  : (c <= 1183 || c == 1185))
                : (c <= 1187 || (c < 1193
                  ? (c < 1191
                    ? c == 1189
                    : c <= 1191)
                  : (c <= 1193 || c == 1195))))
              : (c <= 1197 || (c < 1207
                ? (c < 1203
                  ? (c < 1201
                    ? c == 1199
                    : c <= 1201)
                  : (c <= 1203 || c == 1205))
                : (c <= 1207 || (c < 1213
                  ? (c < 1211
                    ? c == 1209
                    : c <= 1211)
                  : (c <= 1213 || c == 1215))))))
            : (c <= 1218 || (c < 1239
              ? (c < 1228
                ? (c < 1224
                  ? (c < 1222
                    ? c == 1220
                    : c <= 1222)
                  : (c <= 1224 || c == 1226))
                : (c <= 1228 || (c < 1235
                  ? (c < 1233
                    ? (c >= 1230 && c <= 1231)
                    : c <= 1233)
                  : (c <= 1235 || c == 1237))))
              : (c <= 1239 || (c < 1249
                ? (c < 1245
                  ? (c < 1243
                    ? c == 1241
                    : c <= 1243)
                  : (c <= 1245 || c == 1247))
                : (c <= 1249 || (c < 1253
                  ? c == 1251
                  : (c <= 1253 || c == 1255))))))))))
        : (c <= 1257 || (c < 5112
          ? (c < 1297
            ? (c < 1277
              ? (c < 1267
                ? (c < 1263
                  ? (c < 1261
                    ? c == 1259
                    : c <= 1261)
                  : (c <= 1263 || c == 1265))
                : (c <= 1267 || (c < 1273
                  ? (c < 1271
                    ? c == 1269
                    : c <= 1271)
                  : (c <= 1273 || c == 1275))))
              : (c <= 1277 || (c < 1287
                ? (c < 1283
                  ? (c < 1281
                    ? c == 1279
                    : c <= 1281)
                  : (c <= 1283 || c == 1285))
                : (c <= 1287 || (c < 1293
                  ? (c < 1291
                    ? c == 1289
                    : c <= 1291)
                  : (c <= 1293 || c == 1295))))))
            : (c <= 1297 || (c < 1317
              ? (c < 1307
                ? (c < 1303
                  ? (c < 1301
                    ? c == 1299
                    : c <= 1301)
                  : (c <= 1303 || c == 1305))
                : (c <= 1307 || (c < 1313
                  ? (c < 1311
                    ? c == 1309
                    : c <= 1311)
                  : (c <= 1313 || c == 1315))))
              : (c <= 1317 || (c < 1327
                ? (c < 1323
                  ? (c < 1321
                    ? c == 1319
                    : c <= 1321)
                  : (c <= 1323 || c == 1325))
                : (c <= 1327 || (c < 4304
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 4346 || (c >= 4349 && c <= 4351)))))))))
          : (c <= 5117 || (c < 7711
            ? (c < 7691
              ? (c < 7681
                ? (c < 7531
                  ? (c < 7424
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7467)
                  : (c <= 7543 || (c >= 7545 && c <= 7578)))
                : (c <= 7681 || (c < 7687
                  ? (c < 7685
                    ? c == 7683
                    : c <= 7685)
                  : (c <= 7687 || c == 7689))))
              : (c <= 7691 || (c < 7701
                ? (c < 7697
                  ? (c < 7695
                    ? c == 7693
                    : c <= 7695)
                  : (c <= 7697 || c == 7699))
                : (c <= 7701 || (c < 7707
                  ? (c < 7705
                    ? c == 7703
                    : c <= 7705)
                  : (c <= 7707 || c == 7709))))))
            : (c <= 7711 || (c < 7731
              ? (c < 7721
                ? (c < 7717
                  ? (c < 7715
                    ? c == 7713
                    : c <= 7715)
                  : (c <= 7717 || c == 7719))
                : (c <= 7721 || (c < 7727
                  ? (c < 7725
                    ? c == 7723
                    : c <= 7725)
                  : (c <= 7727 || c == 7729))))
              : (c <= 7731 || (c < 7741
                ? (c < 7737
                  ? (c < 7735
                    ? c == 7733
                    : c <= 7735)
                  : (c <= 7737 || c == 7739))
                : (c <= 7741 || (c < 7745
                  ? c == 7743
                  : (c <= 7745 || c == 7747))))))))))))))
    : (c <= 7749 || (c < 11447
      ? (c < 7913
        ? (c < 7827
          ? (c < 7789
            ? (c < 7769
              ? (c < 7759
                ? (c < 7755
                  ? (c < 7753
                    ? c == 7751
                    : c <= 7753)
                  : (c <= 7755 || c == 7757))
                : (c <= 7759 || (c < 7765
                  ? (c < 7763
                    ? c == 7761
                    : c <= 7763)
                  : (c <= 7765 || c == 7767))))
              : (c <= 7769 || (c < 7779
                ? (c < 7775
                  ? (c < 7773
                    ? c == 7771
                    : c <= 7773)
                  : (c <= 7775 || c == 7777))
                : (c <= 7779 || (c < 7785
                  ? (c < 7783
                    ? c == 7781
                    : c <= 7783)
                  : (c <= 7785 || c == 7787))))))
            : (c <= 7789 || (c < 7809
              ? (c < 7799
                ? (c < 7795
                  ? (c < 7793
                    ? c == 7791
                    : c <= 7793)
                  : (c <= 7795 || c == 7797))
                : (c <= 7799 || (c < 7805
                  ? (c < 7803
                    ? c == 7801
                    : c <= 7803)
                  : (c <= 7805 || c == 7807))))
              : (c <= 7809 || (c < 7819
                ? (c < 7815
                  ? (c < 7813
                    ? c == 7811
                    : c <= 7813)
                  : (c <= 7815 || c == 7817))
                : (c <= 7819 || (c < 7823
                  ? c == 7821
                  : (c <= 7823 || c == 7825))))))))
          : (c <= 7827 || (c < 7875
            ? (c < 7855
              ? (c < 7845
                ? (c < 7841
                  ? (c < 7839
                    ? (c >= 7829 && c <= 7837)
                    : c <= 7839)
                  : (c <= 7841 || c == 7843))
                : (c <= 7845 || (c < 7851
                  ? (c < 7849
                    ? c == 7847
                    : c <= 7849)
                  : (c <= 7851 || c == 7853))))
              : (c <= 7855 || (c < 7865
                ? (c < 7861
                  ? (c < 7859
                    ? c == 7857
                    : c <= 7859)
                  : (c <= 7861 || c == 7863))
                : (c <= 7865 || (c < 7871
                  ? (c < 7869
                    ? c == 7867
                    : c <= 7869)
                  : (c <= 7871 || c == 7873))))))
            : (c <= 7875 || (c < 7895
              ? (c < 7885
                ? (c < 7881
                  ? (c < 7879
                    ? c == 7877
                    : c <= 7879)
                  : (c <= 7881 || c == 7883))
                : (c <= 7885 || (c < 7891
                  ? (c < 7889
                    ? c == 7887
                    : c <= 7889)
                  : (c <= 7891 || c == 7893))))
              : (c <= 7895 || (c < 7905
                ? (c < 7901
                  ? (c < 7899
                    ? c == 7897
                    : c <= 7899)
                  : (c <= 7901 || c == 7903))
                : (c <= 7905 || (c < 7909
                  ? c == 7907
                  : (c <= 7909 || c == 7911))))))))))
        : (c <= 7913 || (c < 8518
          ? (c < 8080
            ? (c < 7933
              ? (c < 7923
                ? (c < 7919
                  ? (c < 7917
                    ? c == 7915
                    : c <= 7917)
                  : (c <= 7919 || c == 7921))
                : (c <= 7923 || (c < 7929
                  ? (c < 7927
                    ? c == 7925
                    : c <= 7927)
                  : (c <= 7929 || c == 7931))))
              : (c <= 7933 || (c < 8000
                ? (c < 7968
                  ? (c < 7952
                    ? (c >= 7935 && c <= 7943)
                    : c <= 7957)
                  : (c <= 7975 || (c >= 7984 && c <= 7991)))
                : (c <= 8005 || (c < 8048
                  ? (c < 8032
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8039)
                  : (c <= 8061 || (c >= 8064 && c <= 8071)))))))
            : (c <= 8087 || (c < 8178
              ? (c < 8130
                ? (c < 8118
                  ? (c < 8112
                    ? (c >= 8096 && c <= 8103)
                    : c <= 8116)
                  : (c <= 8119 || c == 8126))
                : (c <= 8132 || (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8135)
                    : c <= 8147)
                  : (c <= 8151 || (c >= 8160 && c <= 8167)))))
              : (c <= 8180 || (c < 8495
                ? (c < 8462
                  ? (c < 8458
                    ? (c >= 8182 && c <= 8183)
                    : c <= 8458)
                  : (c <= 8463 || c == 8467))
                : (c <= 8495 || (c < 8505
                  ? c == 8500
                  : (c <= 8505 || (c >= 8508 && c <= 8509)))))))))
          : (c <= 8521 || (c < 11409
            ? (c < 11379
              ? (c < 11365
                ? (c < 11312
                  ? (c < 8580
                    ? c == 8526
                    : c <= 8580)
                  : (c <= 11359 || c == 11361))
                : (c <= 11366 || (c < 11372
                  ? (c < 11370
                    ? c == 11368
                    : c <= 11370)
                  : (c <= 11372 || c == 11377))))
              : (c <= 11380 || (c < 11399
                ? (c < 11395
                  ? (c < 11393
                    ? (c >= 11382 && c <= 11387)
                    : c <= 11393)
                  : (c <= 11395 || c == 11397))
                : (c <= 11399 || (c < 11405
                  ? (c < 11403
                    ? c == 11401
                    : c <= 11403)
                  : (c <= 11405 || c == 11407))))))
            : (c <= 11409 || (c < 11429
              ? (c < 11419
                ? (c < 11415
                  ? (c < 11413
                    ? c == 11411
                    : c <= 11413)
                  : (c <= 11415 || c == 11417))
                : (c <= 11419 || (c < 11425
                  ? (c < 11423
                    ? c == 11421
                    : c <= 11423)
                  : (c <= 11425 || c == 11427))))
              : (c <= 11429 || (c < 11439
                ? (c < 11435
                  ? (c < 11433
                    ? c == 11431
                    : c <= 11433)
                  : (c <= 11435 || c == 11437))
                : (c <= 11439 || (c < 11443
                  ? c == 11441
                  : (c <= 11443 || c == 11445))))))))))))
      : (c <= 11447 || (c < 42813
        ? (c < 42581
          ? (c < 11487
            ? (c < 11467
              ? (c < 11457
                ? (c < 11453
                  ? (c < 11451
                    ? c == 11449
                    : c <= 11451)
                  : (c <= 11453 || c == 11455))
                : (c <= 11457 || (c < 11463
                  ? (c < 11461
                    ? c == 11459
                    : c <= 11461)
                  : (c <= 11463 || c == 11465))))
              : (c <= 11467 || (c < 11477
                ? (c < 11473
                  ? (c < 11471
                    ? c == 11469
                    : c <= 11471)
                  : (c <= 11473 || c == 11475))
                : (c <= 11477 || (c < 11483
                  ? (c < 11481
                    ? c == 11479
                    : c <= 11481)
                  : (c <= 11483 || c == 11485))))))
            : (c <= 11487 || (c < 42563
              ? (c < 11507
                ? (c < 11500
                  ? (c < 11491
                    ? c == 11489
                    : c <= 11492)
                  : (c <= 11500 || c == 11502))
                : (c <= 11507 || (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || c == 42561))))
              : (c <= 42563 || (c < 42573
                ? (c < 42569
                  ? (c < 42567
                    ? c == 42565
                    : c <= 42567)
                  : (c <= 42569 || c == 42571))
                : (c <= 42573 || (c < 42577
                  ? c == 42575
                  : (c <= 42577 || c == 42579))))))))
          : (c <= 42581 || (c < 42639
            ? (c < 42601
              ? (c < 42591
                ? (c < 42587
                  ? (c < 42585
                    ? c == 42583
                    : c <= 42585)
                  : (c <= 42587 || c == 42589))
                : (c <= 42591 || (c < 42597
                  ? (c < 42595
                    ? c == 42593
                    : c <= 42595)
                  : (c <= 42597 || c == 42599))))
              : (c <= 42601 || (c < 42629
                ? (c < 42625
                  ? (c < 42605
                    ? c == 42603
                    : c <= 42605)
                  : (c <= 42625 || c == 42627))
                : (c <= 42629 || (c < 42635
                  ? (c < 42633
                    ? c == 42631
                    : c <= 42633)
                  : (c <= 42635 || c == 42637))))))
            : (c <= 42639 || (c < 42793
              ? (c < 42649
                ? (c < 42645
                  ? (c < 42643
                    ? c == 42641
                    : c <= 42643)
                  : (c <= 42645 || c == 42647))
                : (c <= 42649 || (c < 42789
                  ? (c < 42787
                    ? c == 42651
                    : c <= 42787)
                  : (c <= 42789 || c == 42791))))
              : (c <= 42793 || (c < 42805
                ? (c < 42799
                  ? (c < 42797
                    ? c == 42795
                    : c <= 42797)
                  : (c <= 42801 || c == 42803))
                : (c <= 42805 || (c < 42809
                  ? c == 42807
                  : (c <= 42809 || c == 42811))))))))))
        : (c <= 42813 || (c < 42905
          ? (c < 42853
            ? (c < 42833
              ? (c < 42823
                ? (c < 42819
                  ? (c < 42817
                    ? c == 42815
                    : c <= 42817)
                  : (c <= 42819 || c == 42821))
                : (c <= 42823 || (c < 42829
                  ? (c < 42827
                    ? c == 42825
                    : c <= 42827)
                  : (c <= 42829 || c == 42831))))
              : (c <= 42833 || (c < 42843
                ? (c < 42839
                  ? (c < 42837
                    ? c == 42835
                    : c <= 42837)
                  : (c <= 42839 || c == 42841))
                : (c <= 42843 || (c < 42849
                  ? (c < 42847
                    ? c == 42845
                    : c <= 42847)
                  : (c <= 42849 || c == 42851))))))
            : (c <= 42853 || (c < 42881
              ? (c < 42863
                ? (c < 42859
                  ? (c < 42857
                    ? c == 42855
                    : c <= 42857)
                  : (c <= 42859 || c == 42861))
                : (c <= 42863 || (c < 42876
                  ? (c < 42874
                    ? (c >= 42865 && c <= 42872)
                    : c <= 42874)
                  : (c <= 42876 || c == 42879))))
              : (c <= 42881 || (c < 42894
                ? (c < 42887
                  ? (c < 42885
                    ? c == 42883
                    : c <= 42885)
                  : (c <= 42887 || c == 42892))
                : (c <= 42894 || (c < 42899
                  ? c == 42897
                  : (c <= 42901 || c == 42903))))))))
          : (c <= 42905 || (c < 42961
            ? (c < 42933
              ? (c < 42915
                ? (c < 42911
                  ? (c < 42909
                    ? c == 42907
                    : c <= 42909)
                  : (c <= 42911 || c == 42913))
                : (c <= 42915 || (c < 42921
                  ? (c < 42919
                    ? c == 42917
                    : c <= 42919)
                  : (c <= 42921 || c == 42927))))
              : (c <= 42933 || (c < 42943
                ? (c < 42939
                  ? (c < 42937
                    ? c == 42935
                    : c <= 42937)
                  : (c <= 42939 || c == 42941))
                : (c <= 42943 || (c < 42952
                  ? (c < 42947
                    ? c == 42945
                    : c <= 42947)
                  : (c <= 42952 || c == 42954))))))
            : (c <= 42961 || (c < 64256
              ? (c < 42998
                ? (c < 42967
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42965)
                  : (c <= 42967 || c == 42969))
                : (c <= 42998 || (c < 43872
                  ? (c < 43824
                    ? c == 43002
                    : c <= 43866)
                  : (c <= 43880 || (c >= 43888 && c <= 43967)))))
              : (c <= 64262 || (c < 66967
                ? (c < 66600
                  ? (c < 65345
                    ? (c >= 64275 && c <= 64279)
                    : c <= 65370)
                  : (c <= 66639 || (c >= 66776 && c <= 66811)))
                : (c <= 66977 || (c < 66995
                  ? (c >= 66979 && c <= 66993)
                  : (c <= 67001 || (c >= 67003 && c <= 67004)))))))))))))))));
}

static inline bool sym__operator_character_set_1(int32_t c) {
  return (c < 8485
    ? (c < 3407
      ? (c < 885
        ? (c < 174
          ? (c < '^'
            ? (c < '/'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '>')))
            : (c <= '^' || (c < 168
              ? (c < 162
                ? c == '~'
                : c <= 166)
              : (c <= 169 || c == 172))))
          : (c <= 177 || (c < 706
            ? (c < 215
              ? (c < 184
                ? c == 180
                : c <= 184)
              : (c <= 215 || c == 247))
            : (c <= 709 || (c < 749
              ? (c < 741
                ? (c >= 722 && c <= 735)
                : c <= 747)
              : (c <= 749 || (c >= 751 && c <= 767)))))))
        : (c <= 885 || (c < 1789
          ? (c < 1542
            ? (c < 1154
              ? (c < 1014
                ? (c >= 900 && c <= 901)
                : c <= 1014)
              : (c <= 1154 || (c >= 1421 && c <= 1423)))
            : (c <= 1544 || (c < 1758
              ? (c < 1550
                ? c == 1547
                : c <= 1551)
              : (c <= 1758 || c == 1769))))
          : (c <= 1790 || (c < 2554
            ? (c < 2184
              ? (c < 2046
                ? c == 2038
                : c <= 2047)
              : (c <= 2184 || (c >= 2546 && c <= 2547)))
            : (c <= 2555 || (c < 3059
              ? (c < 2928
                ? c == 2801
                : c <= 2928)
              : (c <= 3066 || c == 3199))))))))
      : (c <= 3407 || (c < 7009
        ? (c < 4030
          ? (c < 3861
            ? (c < 3841
              ? (c < 3647
                ? c == 3449
                : c <= 3647)
              : (c <= 3843 || c == 3859))
            : (c <= 3863 || (c < 3894
              ? (c < 3892
                ? (c >= 3866 && c <= 3871)
                : c <= 3892)
              : (c <= 3894 || c == 3896))))
          : (c <= 4037 || (c < 5008
            ? (c < 4053
              ? (c < 4046
                ? (c >= 4039 && c <= 4044)
                : c <= 4047)
              : (c <= 4056 || (c >= 4254 && c <= 4255)))
            : (c <= 5017 || (c < 6464
              ? (c < 6107
                ? c == 5741
                : c <= 6107)
              : (c <= 6464 || (c >= 6622 && c <= 6655)))))))
        : (c <= 7018 || (c < 8314
          ? (c < 8157
            ? (c < 8127
              ? (c < 8125
                ? (c >= 7028 && c <= 7036)
                : c <= 8125)
              : (c <= 8129 || (c >= 8141 && c <= 8143)))
            : (c <= 8159 || (c < 8260
              ? (c < 8189
                ? (c >= 8173 && c <= 8175)
                : c <= 8190)
              : (c <= 8260 || c == 8274))))
          : (c <= 8316 || (c < 8456
            ? (c < 8448
              ? (c < 8352
                ? (c >= 8330 && c <= 8332)
                : c <= 8384)
              : (c <= 8449 || (c >= 8451 && c <= 8454)))
            : (c <= 8457 || (c < 8470
              ? c == 8468
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_2(int32_t c) {
  return (c < 8485
    ? (c < 3407
      ? (c < 885
        ? (c < 174
          ? (c < '^'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '>')))
            : (c <= '^' || (c < 168
              ? (c < 162
                ? c == '~'
                : c <= 166)
              : (c <= 169 || c == 172))))
          : (c <= 177 || (c < 706
            ? (c < 215
              ? (c < 184
                ? c == 180
                : c <= 184)
              : (c <= 215 || c == 247))
            : (c <= 709 || (c < 749
              ? (c < 741
                ? (c >= 722 && c <= 735)
                : c <= 747)
              : (c <= 749 || (c >= 751 && c <= 767)))))))
        : (c <= 885 || (c < 1789
          ? (c < 1542
            ? (c < 1154
              ? (c < 1014
                ? (c >= 900 && c <= 901)
                : c <= 1014)
              : (c <= 1154 || (c >= 1421 && c <= 1423)))
            : (c <= 1544 || (c < 1758
              ? (c < 1550
                ? c == 1547
                : c <= 1551)
              : (c <= 1758 || c == 1769))))
          : (c <= 1790 || (c < 2554
            ? (c < 2184
              ? (c < 2046
                ? c == 2038
                : c <= 2047)
              : (c <= 2184 || (c >= 2546 && c <= 2547)))
            : (c <= 2555 || (c < 3059
              ? (c < 2928
                ? c == 2801
                : c <= 2928)
              : (c <= 3066 || c == 3199))))))))
      : (c <= 3407 || (c < 7009
        ? (c < 4030
          ? (c < 3861
            ? (c < 3841
              ? (c < 3647
                ? c == 3449
                : c <= 3647)
              : (c <= 3843 || c == 3859))
            : (c <= 3863 || (c < 3894
              ? (c < 3892
                ? (c >= 3866 && c <= 3871)
                : c <= 3892)
              : (c <= 3894 || c == 3896))))
          : (c <= 4037 || (c < 5008
            ? (c < 4053
              ? (c < 4046
                ? (c >= 4039 && c <= 4044)
                : c <= 4047)
              : (c <= 4056 || (c >= 4254 && c <= 4255)))
            : (c <= 5017 || (c < 6464
              ? (c < 6107
                ? c == 5741
                : c <= 6107)
              : (c <= 6464 || (c >= 6622 && c <= 6655)))))))
        : (c <= 7018 || (c < 8314
          ? (c < 8157
            ? (c < 8127
              ? (c < 8125
                ? (c >= 7028 && c <= 7036)
                : c <= 8125)
              : (c <= 8129 || (c >= 8141 && c <= 8143)))
            : (c <= 8159 || (c < 8260
              ? (c < 8189
                ? (c >= 8173 && c <= 8175)
                : c <= 8190)
              : (c <= 8260 || c == 8274))))
          : (c <= 8316 || (c < 8456
            ? (c < 8448
              ? (c < 8352
                ? (c >= 8330 && c <= 8332)
                : c <= 8384)
              : (c <= 8449 || (c >= 8451 && c <= 8454)))
            : (c <= 8457 || (c < 8470
              ? c == 8468
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_3(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '^'
            ? (c < '/'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '>')))
            : (c <= '^' || (c < 162
              ? (c < '~'
                ? c == '|'
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_4(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '^'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '>')))
            : (c <= '^' || (c < 162
              ? (c < '~'
                ? c == '|'
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_5(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '/'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '>' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_6(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '>' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_7(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '^'
            ? (c < ':'
              ? (c < '/'
                ? (c >= '!' && c <= '+')
                : c <= '/')
              : (c <= ':' || (c >= '<' && c <= '>')))
            : (c <= '^' || (c < 162
              ? (c < '~'
                ? c == '|'
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_8(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '^'
            ? (c < ':'
              ? (c < '.'
                ? (c >= '!' && c <= '+')
                : c <= '/')
              : (c <= ':' || (c >= '<' && c <= '>')))
            : (c <= '^' || (c < 162
              ? (c < '~'
                ? c == '|'
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_9(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '>' || (c < '~'
              ? (c < '^'
                ? c == '\\'
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_10(int32_t c) {
  return (c < 8487
    ? (c < 3449
      ? (c < 900
        ? (c < 180
          ? (c < '|'
            ? (c < '<'
              ? (c < '.'
                ? (c >= '!' && c <= '+')
                : c <= '/')
              : (c <= '?' || (c >= '\\' && c <= '`')))
            : (c <= '~' || (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))))
          : (c <= 180 || (c < 722
            ? (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))
            : (c <= 735 || (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))))))
        : (c <= 901 || (c < 2038
          ? (c < 1547
            ? (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))
            : (c <= 1547 || (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))))
          : (c <= 2038 || (c < 2801
            ? (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))
            : (c <= 2801 || (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || c == 3407))))))))
      : (c <= 3449 || (c < 7028
        ? (c < 4039
          ? (c < 3866
            ? (c < 3859
              ? (c < 3841
                ? c == 3647
                : c <= 3843)
              : (c <= 3859 || (c >= 3861 && c <= 3863)))
            : (c <= 3871 || (c < 3896
              ? (c < 3894
                ? c == 3892
                : c <= 3894)
              : (c <= 3896 || (c >= 4030 && c <= 4037)))))
          : (c <= 4044 || (c < 5741
            ? (c < 4254
              ? (c < 4053
                ? (c >= 4046 && c <= 4047)
                : c <= 4056)
              : (c <= 4255 || (c >= 5008 && c <= 5017)))
            : (c <= 5741 || (c < 6622
              ? (c < 6464
                ? c == 6107
                : c <= 6464)
              : (c <= 6655 || (c >= 7009 && c <= 7018)))))))
        : (c <= 7036 || (c < 8330
          ? (c < 8173
            ? (c < 8141
              ? (c < 8127
                ? c == 8125
                : c <= 8129)
              : (c <= 8143 || (c >= 8157 && c <= 8159)))
            : (c <= 8175 || (c < 8274
              ? (c < 8260
                ? (c >= 8189 && c <= 8190)
                : c <= 8260)
              : (c <= 8274 || (c >= 8314 && c <= 8316)))))
          : (c <= 8332 || (c < 8468
            ? (c < 8451
              ? (c < 8448
                ? (c >= 8352 && c <= 8384)
                : c <= 8449)
              : (c <= 8454 || (c >= 8456 && c <= 8457)))
            : (c <= 8468 || (c < 8478
              ? (c >= 8470 && c <= 8472)
              : (c <= 8483 || c == 8485))))))))))
    : (c <= 8487 || (c < 12880
      ? (c < 11126
        ? (c < 9003
          ? (c < 8522
            ? (c < 8506
              ? (c < 8494
                ? c == 8489
                : c <= 8494)
              : (c <= 8507 || (c >= 8512 && c <= 8516)))
            : (c <= 8525 || (c < 8592
              ? (c < 8586
                ? c == 8527
                : c <= 8587)
              : (c <= 8967 || (c >= 8972 && c <= 9000)))))
          : (c <= 9254 || (c < 10183
            ? (c < 9472
              ? (c < 9372
                ? (c >= 9280 && c <= 9290)
                : c <= 9449)
              : (c <= 10087 || (c >= 10132 && c <= 10180)))
            : (c <= 10213 || (c < 10716
              ? (c < 10649
                ? (c >= 10224 && c <= 10626)
                : c <= 10711)
              : (c <= 10747 || (c >= 10750 && c <= 11123)))))))
        : (c <= 11157 || (c < 12320
          ? (c < 11931
            ? (c < 11856
              ? (c < 11493
                ? (c >= 11159 && c <= 11263)
                : c <= 11498)
              : (c <= 11857 || (c >= 11904 && c <= 11929)))
            : (c <= 12019 || (c < 12292
              ? (c < 12272
                ? (c >= 12032 && c <= 12245)
                : c <= 12283)
              : (c <= 12292 || (c >= 12306 && c <= 12307)))))
          : (c <= 12320 || (c < 12694
            ? (c < 12443
              ? (c < 12350
                ? (c >= 12342 && c <= 12343)
                : c <= 12351)
              : (c <= 12444 || (c >= 12688 && c <= 12689)))
            : (c <= 12703 || (c < 12800
              ? (c >= 12736 && c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_11(int32_t c) {
  return (c < 8487
    ? (c < 3449
      ? (c < 900
        ? (c < 180
          ? (c < '|'
            ? (c < '<'
              ? (c < '.'
                ? (c >= '!' && c <= '+')
                : c <= '/')
              : (c <= '@' || (c >= '\\' && c <= '`')))
            : (c <= '~' || (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))))
          : (c <= 180 || (c < 722
            ? (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))
            : (c <= 735 || (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))))))
        : (c <= 901 || (c < 2038
          ? (c < 1547
            ? (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))
            : (c <= 1547 || (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))))
          : (c <= 2038 || (c < 2801
            ? (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))
            : (c <= 2801 || (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || c == 3407))))))))
      : (c <= 3449 || (c < 7028
        ? (c < 4039
          ? (c < 3866
            ? (c < 3859
              ? (c < 3841
                ? c == 3647
                : c <= 3843)
              : (c <= 3859 || (c >= 3861 && c <= 3863)))
            : (c <= 3871 || (c < 3896
              ? (c < 3894
                ? c == 3892
                : c <= 3894)
              : (c <= 3896 || (c >= 4030 && c <= 4037)))))
          : (c <= 4044 || (c < 5741
            ? (c < 4254
              ? (c < 4053
                ? (c >= 4046 && c <= 4047)
                : c <= 4056)
              : (c <= 4255 || (c >= 5008 && c <= 5017)))
            : (c <= 5741 || (c < 6622
              ? (c < 6464
                ? c == 6107
                : c <= 6464)
              : (c <= 6655 || (c >= 7009 && c <= 7018)))))))
        : (c <= 7036 || (c < 8330
          ? (c < 8173
            ? (c < 8141
              ? (c < 8127
                ? c == 8125
                : c <= 8129)
              : (c <= 8143 || (c >= 8157 && c <= 8159)))
            : (c <= 8175 || (c < 8274
              ? (c < 8260
                ? (c >= 8189 && c <= 8190)
                : c <= 8260)
              : (c <= 8274 || (c >= 8314 && c <= 8316)))))
          : (c <= 8332 || (c < 8468
            ? (c < 8451
              ? (c < 8448
                ? (c >= 8352 && c <= 8384)
                : c <= 8449)
              : (c <= 8454 || (c >= 8456 && c <= 8457)))
            : (c <= 8468 || (c < 8478
              ? (c >= 8470 && c <= 8472)
              : (c <= 8483 || c == 8485))))))))))
    : (c <= 8487 || (c < 12880
      ? (c < 11126
        ? (c < 9003
          ? (c < 8522
            ? (c < 8506
              ? (c < 8494
                ? c == 8489
                : c <= 8494)
              : (c <= 8507 || (c >= 8512 && c <= 8516)))
            : (c <= 8525 || (c < 8592
              ? (c < 8586
                ? c == 8527
                : c <= 8587)
              : (c <= 8967 || (c >= 8972 && c <= 9000)))))
          : (c <= 9254 || (c < 10183
            ? (c < 9472
              ? (c < 9372
                ? (c >= 9280 && c <= 9290)
                : c <= 9449)
              : (c <= 10087 || (c >= 10132 && c <= 10180)))
            : (c <= 10213 || (c < 10716
              ? (c < 10649
                ? (c >= 10224 && c <= 10626)
                : c <= 10711)
              : (c <= 10747 || (c >= 10750 && c <= 11123)))))))
        : (c <= 11157 || (c < 12320
          ? (c < 11931
            ? (c < 11856
              ? (c < 11493
                ? (c >= 11159 && c <= 11263)
                : c <= 11498)
              : (c <= 11857 || (c >= 11904 && c <= 11929)))
            : (c <= 12019 || (c < 12292
              ? (c < 12272
                ? (c >= 12032 && c <= 12245)
                : c <= 12283)
              : (c <= 12292 || (c >= 12306 && c <= 12307)))))
          : (c <= 12320 || (c < 12694
            ? (c < 12443
              ? (c < 12350
                ? (c >= 12342 && c <= 12343)
                : c <= 12351)
              : (c <= 12444 || (c >= 12688 && c <= 12689)))
            : (c <= 12703 || (c < 12800
              ? (c >= 12736 && c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_12(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '>')))
            : (c <= '\\' || (c < 162
              ? (c < '~'
                ? c == '^'
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_13(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '=' && c <= '?')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_14(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '=' && c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_15(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '?' || (c < '~'
              ? (c < '^'
                ? c == '\\'
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_16(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '@' || (c < '~'
              ? (c < '^'
                ? c == '\\'
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_17(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '?')))
            : (c <= '\\' || (c < 162
              ? (c < '~'
                ? (c >= '^' && c <= '`')
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_18(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '@')))
            : (c <= '\\' || (c < 162
              ? (c < '~'
                ? (c >= '^' && c <= '`')
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_19(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '>')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_20(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c < '>'
                ? c == ':'
                : c <= '?')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_21(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c < '>'
                ? c == ':'
                : c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_22(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c < '='
                ? c == ':'
                : c <= '?')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_23(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c < '='
                ? c == ':'
                : c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_24(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '\\'
            ? (c < '-'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= ':' && c <= '>')))
            : (c <= '\\' || (c < 162
              ? (c < '~'
                ? (c >= '^' && c <= '`')
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_25(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c < '<'
                ? c == ':'
                : c <= '>')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_26(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '-'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c < '='
                ? c == ':'
                : c <= '>')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_27(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '-'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= ':' && c <= '>')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_28(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '^'
            ? (c < '/'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '=' && c <= '>')))
            : (c <= '^' || (c < 162
              ? (c < '~'
                ? c == '|'
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8593 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_29(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '^'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '=' && c <= '>')))
            : (c <= '^' || (c < 162
              ? (c < '~'
                ? c == '|'
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8593 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_30(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '-'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '>' || (c < '~'
              ? (c < '^'
                ? c == '\\'
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_31(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '-'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c < '<'
                ? c == ':'
                : c <= '>')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_32(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '-'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c < '='
                ? c == ':'
                : c <= '>')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_33(int32_t c) {
  return (c < 8487
    ? (c < 3449
      ? (c < 900
        ? (c < 180
          ? (c < '|'
            ? (c < '<'
              ? (c < '/'
                ? (c >= '!' && c <= '+')
                : c <= '/')
              : (c <= '>' || c == '^'))
            : (c <= '~' || (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))))
          : (c <= 180 || (c < 722
            ? (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))
            : (c <= 735 || (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))))))
        : (c <= 901 || (c < 2038
          ? (c < 1547
            ? (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))
            : (c <= 1547 || (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))))
          : (c <= 2038 || (c < 2801
            ? (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))
            : (c <= 2801 || (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || c == 3407))))))))
      : (c <= 3449 || (c < 7028
        ? (c < 4039
          ? (c < 3866
            ? (c < 3859
              ? (c < 3841
                ? c == 3647
                : c <= 3843)
              : (c <= 3859 || (c >= 3861 && c <= 3863)))
            : (c <= 3871 || (c < 3896
              ? (c < 3894
                ? c == 3892
                : c <= 3894)
              : (c <= 3896 || (c >= 4030 && c <= 4037)))))
          : (c <= 4044 || (c < 5741
            ? (c < 4254
              ? (c < 4053
                ? (c >= 4046 && c <= 4047)
                : c <= 4056)
              : (c <= 4255 || (c >= 5008 && c <= 5017)))
            : (c <= 5741 || (c < 6622
              ? (c < 6464
                ? c == 6107
                : c <= 6464)
              : (c <= 6655 || (c >= 7009 && c <= 7018)))))))
        : (c <= 7036 || (c < 8330
          ? (c < 8173
            ? (c < 8141
              ? (c < 8127
                ? c == 8125
                : c <= 8129)
              : (c <= 8143 || (c >= 8157 && c <= 8159)))
            : (c <= 8175 || (c < 8274
              ? (c < 8260
                ? (c >= 8189 && c <= 8190)
                : c <= 8260)
              : (c <= 8274 || (c >= 8314 && c <= 8316)))))
          : (c <= 8332 || (c < 8468
            ? (c < 8451
              ? (c < 8448
                ? (c >= 8352 && c <= 8384)
                : c <= 8449)
              : (c <= 8454 || (c >= 8456 && c <= 8457)))
            : (c <= 8468 || (c < 8478
              ? (c >= 8470 && c <= 8472)
              : (c <= 8483 || c == 8485))))))))))
    : (c <= 8487 || (c < 12880
      ? (c < 11126
        ? (c < 9003
          ? (c < 8522
            ? (c < 8506
              ? (c < 8494
                ? c == 8489
                : c <= 8494)
              : (c <= 8507 || (c >= 8512 && c <= 8516)))
            : (c <= 8525 || (c < 8592
              ? (c < 8586
                ? c == 8527
                : c <= 8587)
              : (c <= 8967 || (c >= 8972 && c <= 9000)))))
          : (c <= 9254 || (c < 10183
            ? (c < 9472
              ? (c < 9372
                ? (c >= 9280 && c <= 9290)
                : c <= 9449)
              : (c <= 10087 || (c >= 10132 && c <= 10180)))
            : (c <= 10213 || (c < 10716
              ? (c < 10649
                ? (c >= 10224 && c <= 10626)
                : c <= 10711)
              : (c <= 10747 || (c >= 10750 && c <= 11123)))))))
        : (c <= 11157 || (c < 12320
          ? (c < 11931
            ? (c < 11856
              ? (c < 11493
                ? (c >= 11159 && c <= 11263)
                : c <= 11498)
              : (c <= 11857 || (c >= 11904 && c <= 11929)))
            : (c <= 12019 || (c < 12292
              ? (c < 12272
                ? (c >= 12032 && c <= 12245)
                : c <= 12283)
              : (c <= 12292 || (c >= 12306 && c <= 12307)))))
          : (c <= 12320 || (c < 12694
            ? (c < 12443
              ? (c < 12350
                ? (c >= 12342 && c <= 12343)
                : c <= 12351)
              : (c <= 12444 || (c >= 12688 && c <= 12689)))
            : (c <= 12703 || (c < 12800
              ? (c >= 12736 && c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_34(int32_t c) {
  return (c < 8487
    ? (c < 3449
      ? (c < 900
        ? (c < 180
          ? (c < '|'
            ? (c < '<'
              ? (c < '.'
                ? (c >= '!' && c <= '+')
                : c <= '/')
              : (c <= '>' || c == '^'))
            : (c <= '~' || (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))))
          : (c <= 180 || (c < 722
            ? (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))
            : (c <= 735 || (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))))))
        : (c <= 901 || (c < 2038
          ? (c < 1547
            ? (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))
            : (c <= 1547 || (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))))
          : (c <= 2038 || (c < 2801
            ? (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))
            : (c <= 2801 || (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || c == 3407))))))))
      : (c <= 3449 || (c < 7028
        ? (c < 4039
          ? (c < 3866
            ? (c < 3859
              ? (c < 3841
                ? c == 3647
                : c <= 3843)
              : (c <= 3859 || (c >= 3861 && c <= 3863)))
            : (c <= 3871 || (c < 3896
              ? (c < 3894
                ? c == 3892
                : c <= 3894)
              : (c <= 3896 || (c >= 4030 && c <= 4037)))))
          : (c <= 4044 || (c < 5741
            ? (c < 4254
              ? (c < 4053
                ? (c >= 4046 && c <= 4047)
                : c <= 4056)
              : (c <= 4255 || (c >= 5008 && c <= 5017)))
            : (c <= 5741 || (c < 6622
              ? (c < 6464
                ? c == 6107
                : c <= 6464)
              : (c <= 6655 || (c >= 7009 && c <= 7018)))))))
        : (c <= 7036 || (c < 8330
          ? (c < 8173
            ? (c < 8141
              ? (c < 8127
                ? c == 8125
                : c <= 8129)
              : (c <= 8143 || (c >= 8157 && c <= 8159)))
            : (c <= 8175 || (c < 8274
              ? (c < 8260
                ? (c >= 8189 && c <= 8190)
                : c <= 8260)
              : (c <= 8274 || (c >= 8314 && c <= 8316)))))
          : (c <= 8332 || (c < 8468
            ? (c < 8451
              ? (c < 8448
                ? (c >= 8352 && c <= 8384)
                : c <= 8449)
              : (c <= 8454 || (c >= 8456 && c <= 8457)))
            : (c <= 8468 || (c < 8478
              ? (c >= 8470 && c <= 8472)
              : (c <= 8483 || c == 8485))))))))))
    : (c <= 8487 || (c < 12880
      ? (c < 11126
        ? (c < 9003
          ? (c < 8522
            ? (c < 8506
              ? (c < 8494
                ? c == 8489
                : c <= 8494)
              : (c <= 8507 || (c >= 8512 && c <= 8516)))
            : (c <= 8525 || (c < 8592
              ? (c < 8586
                ? c == 8527
                : c <= 8587)
              : (c <= 8967 || (c >= 8972 && c <= 9000)))))
          : (c <= 9254 || (c < 10183
            ? (c < 9472
              ? (c < 9372
                ? (c >= 9280 && c <= 9290)
                : c <= 9449)
              : (c <= 10087 || (c >= 10132 && c <= 10180)))
            : (c <= 10213 || (c < 10716
              ? (c < 10649
                ? (c >= 10224 && c <= 10626)
                : c <= 10711)
              : (c <= 10747 || (c >= 10750 && c <= 11123)))))))
        : (c <= 11157 || (c < 12320
          ? (c < 11931
            ? (c < 11856
              ? (c < 11493
                ? (c >= 11159 && c <= 11263)
                : c <= 11498)
              : (c <= 11857 || (c >= 11904 && c <= 11929)))
            : (c <= 12019 || (c < 12292
              ? (c < 12272
                ? (c >= 12032 && c <= 12245)
                : c <= 12283)
              : (c <= 12292 || (c >= 12306 && c <= 12307)))))
          : (c <= 12320 || (c < 12694
            ? (c < 12443
              ? (c < 12350
                ? (c >= 12342 && c <= 12343)
                : c <= 12351)
              : (c <= 12444 || (c >= 12688 && c <= 12689)))
            : (c <= 12703 || (c < 12800
              ? (c >= 12736 && c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_35(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '='
            ? (c < '/'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '>' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_36(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '='
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '>' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_37(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '>'
            ? (c < '/'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '>' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_38(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '>'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || c == ':'))
            : (c <= '>' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_39(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '>' && c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_40(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '<'
                ? c == '/'
                : c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_41(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '<'
                ? (c >= '.' && c <= '/')
                : c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_42(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '-'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '>')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_43(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? c == '/'
                : c <= ':')))
            : (c <= '@' || (c < '|'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_44(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '|'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_45(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c >= '.' && c <= '/')))
            : (c <= '?' || (c < '|'
              ? (c < '`'
                ? (c >= '\\' && c <= '^')
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_46(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c >= '.' && c <= '/')))
            : (c <= '@' || (c < '|'
              ? (c < '`'
                ? (c >= '\\' && c <= '^')
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_47(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < ':'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c >= '.' && c <= '/')))
            : (c <= ':' || (c < '|'
              ? (c < '\\'
                ? (c >= '<' && c <= '@')
                : c <= '^')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_48(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '<'
                ? (c >= '.' && c <= '/')
                : c <= '?')))
            : (c <= '\\' || (c < '~'
              ? (c < '`'
                ? c == '^'
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_49(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '<'
                ? (c >= '.' && c <= '/')
                : c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '`'
                ? c == '^'
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_50(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '='
                ? c == '/'
                : c <= '?')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_51(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '='
                ? c == '/'
                : c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_52(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '='
                ? (c >= '.' && c <= '/')
                : c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? c == '^'
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_53(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '?' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_54(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_55(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '='
                ? (c >= '.' && c <= '/')
                : c <= '?')))
            : (c <= '\\' || (c < '|'
              ? (c < '`'
                ? c == '^'
                : c <= '`')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_56(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '='
                ? (c >= '.' && c <= '/')
                : c <= '@')))
            : (c <= '\\' || (c < '|'
              ? (c < '`'
                ? c == '^'
                : c <= '`')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_57(int32_t c) {
  return (c < 8470
    ? (c < 2801
      ? (c < 722
        ? (c < '~'
          ? (c < '>'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '?' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '|'))))
          : (c <= '~' || (c < 180
            ? (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))
            : (c <= 180 || (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))))))
        : (c <= 735 || (c < 1547
          ? (c < 900
            ? (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))
            : (c <= 901 || (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))))
          : (c <= 1547 || (c < 2038
            ? (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))
            : (c <= 2038 || (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))))))))
      : (c <= 2801 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || (c < 3449
                ? c == 3407
                : c <= 3449)))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_58(int32_t c) {
  return (c < 8470
    ? (c < 2801
      ? (c < 722
        ? (c < '~'
          ? (c < '>'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '|'))))
          : (c <= '~' || (c < 180
            ? (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))
            : (c <= 180 || (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))))))
        : (c <= 735 || (c < 1547
          ? (c < 900
            ? (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))
            : (c <= 901 || (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))))
          : (c <= 1547 || (c < 2038
            ? (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))
            : (c <= 2038 || (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))))))))
      : (c <= 2801 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || (c < 3449
                ? c == 3407
                : c <= 3449)))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_59(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '='
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? c == '/'
                : c <= ':')))
            : (c <= '?' || (c < '|'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_60(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '='
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? c == '/'
                : c <= ':')))
            : (c <= '@' || (c < '|'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_61(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '='
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '|'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_62(int32_t c) {
  return (c < 8470
    ? (c < 2801
      ? (c < 722
        ? (c < '~'
          ? (c < '='
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '?' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '|'))))
          : (c <= '~' || (c < 180
            ? (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))
            : (c <= 180 || (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))))))
        : (c <= 735 || (c < 1547
          ? (c < 900
            ? (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))
            : (c <= 901 || (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))))
          : (c <= 1547 || (c < 2038
            ? (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))
            : (c <= 2038 || (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))))))))
      : (c <= 2801 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || (c < 3449
                ? c == 3407
                : c <= 3449)))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_63(int32_t c) {
  return (c < 8470
    ? (c < 2801
      ? (c < 722
        ? (c < '~'
          ? (c < '='
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '|'))))
          : (c <= '~' || (c < 180
            ? (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))
            : (c <= 180 || (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))))))
        : (c <= 735 || (c < 1547
          ? (c < 900
            ? (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))
            : (c <= 901 || (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))))
          : (c <= 1547 || (c < 2038
            ? (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))
            : (c <= 2038 || (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))))))))
      : (c <= 2801 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || (c < 3449
                ? c == 3407
                : c <= 3449)))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_64(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || c == '/'))
            : (c <= '?' || (c < 162
              ? (c < '|'
                ? (c >= '\\' && c <= '^')
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_65(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c >= '.' && c <= '/')))
            : (c <= '@' || (c < 162
              ? (c < '|'
                ? (c >= '\\' && c <= '^')
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_66(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '>'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? c == '/'
                : c <= ':')))
            : (c <= '?' || (c < '|'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_67(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '>'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? c == '/'
                : c <= ':')))
            : (c <= '@' || (c < '|'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_68(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '>'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '|'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_69(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || c == '/'))
            : (c <= '@' || (c < '|'
              ? (c < '`'
                ? (c >= '\\' && c <= '^')
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_70(int32_t c) {
  return (c < 8470
    ? (c < 2801
      ? (c < 722
        ? (c < '~'
          ? (c < '='
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? c == '/'
                : c <= ':')))
            : (c <= '@' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '|'))))
          : (c <= '~' || (c < 180
            ? (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))
            : (c <= 180 || (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))))))
        : (c <= 735 || (c < 1547
          ? (c < 900
            ? (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))
            : (c <= 901 || (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))))
          : (c <= 1547 || (c < 2038
            ? (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))
            : (c <= 2038 || (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))))))))
      : (c <= 2801 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || (c < 3449
                ? c == 3407
                : c <= 3449)))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_71(int32_t c) {
  return (c < 8470
    ? (c < 2801
      ? (c < 722
        ? (c < '~'
          ? (c < '='
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '-' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '|'))))
          : (c <= '~' || (c < 180
            ? (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))
            : (c <= 180 || (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))))))
        : (c <= 735 || (c < 1547
          ? (c < 900
            ? (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))
            : (c <= 901 || (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))))
          : (c <= 1547 || (c < 2038
            ? (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))
            : (c <= 2038 || (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))))))))
      : (c <= 2801 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || (c < 3449
                ? c == 3407
                : c <= 3449)))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_72(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '-' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_73(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '='
                ? c == '/'
                : c <= '@')))
            : (c <= '\\' || (c < '|'
              ? (c < '`'
                ? c == '^'
                : c <= '`')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8593
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_74(int32_t c) {
  return (c < 8487
    ? (c < 3449
      ? (c < 900
        ? (c < 180
          ? (c < '|'
            ? (c < ':'
              ? (c < '.'
                ? (c >= '!' && c <= '+')
                : c <= '/')
              : (c <= '>' || (c >= '^' && c <= '`')))
            : (c <= '~' || (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))))
          : (c <= 180 || (c < 722
            ? (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))
            : (c <= 735 || (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))))))
        : (c <= 901 || (c < 2038
          ? (c < 1547
            ? (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))
            : (c <= 1547 || (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))))
          : (c <= 2038 || (c < 2801
            ? (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))
            : (c <= 2801 || (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || c == 3407))))))))
      : (c <= 3449 || (c < 7028
        ? (c < 4039
          ? (c < 3866
            ? (c < 3859
              ? (c < 3841
                ? c == 3647
                : c <= 3843)
              : (c <= 3859 || (c >= 3861 && c <= 3863)))
            : (c <= 3871 || (c < 3896
              ? (c < 3894
                ? c == 3892
                : c <= 3894)
              : (c <= 3896 || (c >= 4030 && c <= 4037)))))
          : (c <= 4044 || (c < 5741
            ? (c < 4254
              ? (c < 4053
                ? (c >= 4046 && c <= 4047)
                : c <= 4056)
              : (c <= 4255 || (c >= 5008 && c <= 5017)))
            : (c <= 5741 || (c < 6622
              ? (c < 6464
                ? c == 6107
                : c <= 6464)
              : (c <= 6655 || (c >= 7009 && c <= 7018)))))))
        : (c <= 7036 || (c < 8330
          ? (c < 8173
            ? (c < 8141
              ? (c < 8127
                ? c == 8125
                : c <= 8129)
              : (c <= 8143 || (c >= 8157 && c <= 8159)))
            : (c <= 8175 || (c < 8274
              ? (c < 8260
                ? (c >= 8189 && c <= 8190)
                : c <= 8260)
              : (c <= 8274 || (c >= 8314 && c <= 8316)))))
          : (c <= 8332 || (c < 8468
            ? (c < 8451
              ? (c < 8448
                ? (c >= 8352 && c <= 8384)
                : c <= 8449)
              : (c <= 8454 || (c >= 8456 && c <= 8457)))
            : (c <= 8468 || (c < 8478
              ? (c >= 8470 && c <= 8472)
              : (c <= 8483 || c == 8485))))))))))
    : (c <= 8487 || (c < 12880
      ? (c < 11126
        ? (c < 9003
          ? (c < 8522
            ? (c < 8506
              ? (c < 8494
                ? c == 8489
                : c <= 8494)
              : (c <= 8507 || (c >= 8512 && c <= 8516)))
            : (c <= 8525 || (c < 8592
              ? (c < 8586
                ? c == 8527
                : c <= 8587)
              : (c <= 8967 || (c >= 8972 && c <= 9000)))))
          : (c <= 9254 || (c < 10183
            ? (c < 9472
              ? (c < 9372
                ? (c >= 9280 && c <= 9290)
                : c <= 9449)
              : (c <= 10087 || (c >= 10132 && c <= 10180)))
            : (c <= 10213 || (c < 10716
              ? (c < 10649
                ? (c >= 10224 && c <= 10626)
                : c <= 10711)
              : (c <= 10747 || (c >= 10750 && c <= 11123)))))))
        : (c <= 11157 || (c < 12320
          ? (c < 11931
            ? (c < 11856
              ? (c < 11493
                ? (c >= 11159 && c <= 11263)
                : c <= 11498)
              : (c <= 11857 || (c >= 11904 && c <= 11929)))
            : (c <= 12019 || (c < 12292
              ? (c < 12272
                ? (c >= 12032 && c <= 12245)
                : c <= 12283)
              : (c <= 12292 || (c >= 12306 && c <= 12307)))))
          : (c <= 12320 || (c < 12694
            ? (c < 12443
              ? (c < 12350
                ? (c >= 12342 && c <= 12343)
                : c <= 12351)
              : (c <= 12444 || (c >= 12688 && c <= 12689)))
            : (c <= 12703 || (c < 12800
              ? (c >= 12736 && c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_75(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= ':' && c <= '?')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_76(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= ':' && c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '|'
                ? (c >= '^' && c <= '`')
                : c <= '|')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_77(int32_t c) {
  return (c < 8485
    ? (c < 3407
      ? (c < 885
        ? (c < 174
          ? (c < '\\'
            ? (c < '.'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= '<' && c <= '>')))
            : (c <= '^' || (c < 168
              ? (c < 162
                ? (c >= '|' && c <= '~')
                : c <= 166)
              : (c <= 169 || c == 172))))
          : (c <= 177 || (c < 706
            ? (c < 215
              ? (c < 184
                ? c == 180
                : c <= 184)
              : (c <= 215 || c == 247))
            : (c <= 709 || (c < 749
              ? (c < 741
                ? (c >= 722 && c <= 735)
                : c <= 747)
              : (c <= 749 || (c >= 751 && c <= 767)))))))
        : (c <= 885 || (c < 1789
          ? (c < 1542
            ? (c < 1154
              ? (c < 1014
                ? (c >= 900 && c <= 901)
                : c <= 1014)
              : (c <= 1154 || (c >= 1421 && c <= 1423)))
            : (c <= 1544 || (c < 1758
              ? (c < 1550
                ? c == 1547
                : c <= 1551)
              : (c <= 1758 || c == 1769))))
          : (c <= 1790 || (c < 2554
            ? (c < 2184
              ? (c < 2046
                ? c == 2038
                : c <= 2047)
              : (c <= 2184 || (c >= 2546 && c <= 2547)))
            : (c <= 2555 || (c < 3059
              ? (c < 2928
                ? c == 2801
                : c <= 2928)
              : (c <= 3066 || c == 3199))))))))
      : (c <= 3407 || (c < 7009
        ? (c < 4030
          ? (c < 3861
            ? (c < 3841
              ? (c < 3647
                ? c == 3449
                : c <= 3647)
              : (c <= 3843 || c == 3859))
            : (c <= 3863 || (c < 3894
              ? (c < 3892
                ? (c >= 3866 && c <= 3871)
                : c <= 3892)
              : (c <= 3894 || c == 3896))))
          : (c <= 4037 || (c < 5008
            ? (c < 4053
              ? (c < 4046
                ? (c >= 4039 && c <= 4044)
                : c <= 4047)
              : (c <= 4056 || (c >= 4254 && c <= 4255)))
            : (c <= 5017 || (c < 6464
              ? (c < 6107
                ? c == 5741
                : c <= 6107)
              : (c <= 6464 || (c >= 6622 && c <= 6655)))))))
        : (c <= 7018 || (c < 8314
          ? (c < 8157
            ? (c < 8127
              ? (c < 8125
                ? (c >= 7028 && c <= 7036)
                : c <= 8125)
              : (c <= 8129 || (c >= 8141 && c <= 8143)))
            : (c <= 8159 || (c < 8260
              ? (c < 8189
                ? (c >= 8173 && c <= 8175)
                : c <= 8190)
              : (c <= 8260 || c == 8274))))
          : (c <= 8316 || (c < 8456
            ? (c < 8448
              ? (c < 8352
                ? (c >= 8330 && c <= 8332)
                : c <= 8384)
              : (c <= 8449 || (c >= 8451 && c <= 8454)))
            : (c <= 8457 || (c < 8470
              ? c == 8468
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_78(int32_t c) {
  return (c < 8485
    ? (c < 3407
      ? (c < 885
        ? (c < 174
          ? (c < '\\'
            ? (c < '-'
              ? (c < '*'
                ? (c >= '!' && c <= '&')
                : c <= '+')
              : (c <= '/' || (c >= ':' && c <= '>')))
            : (c <= '`' || (c < 168
              ? (c < 162
                ? (c >= '|' && c <= '~')
                : c <= 166)
              : (c <= 169 || c == 172))))
          : (c <= 177 || (c < 706
            ? (c < 215
              ? (c < 184
                ? c == 180
                : c <= 184)
              : (c <= 215 || c == 247))
            : (c <= 709 || (c < 749
              ? (c < 741
                ? (c >= 722 && c <= 735)
                : c <= 747)
              : (c <= 749 || (c >= 751 && c <= 767)))))))
        : (c <= 885 || (c < 1789
          ? (c < 1542
            ? (c < 1154
              ? (c < 1014
                ? (c >= 900 && c <= 901)
                : c <= 1014)
              : (c <= 1154 || (c >= 1421 && c <= 1423)))
            : (c <= 1544 || (c < 1758
              ? (c < 1550
                ? c == 1547
                : c <= 1551)
              : (c <= 1758 || c == 1769))))
          : (c <= 1790 || (c < 2554
            ? (c < 2184
              ? (c < 2046
                ? c == 2038
                : c <= 2047)
              : (c <= 2184 || (c >= 2546 && c <= 2547)))
            : (c <= 2555 || (c < 3059
              ? (c < 2928
                ? c == 2801
                : c <= 2928)
              : (c <= 3066 || c == 3199))))))))
      : (c <= 3407 || (c < 7009
        ? (c < 4030
          ? (c < 3861
            ? (c < 3841
              ? (c < 3647
                ? c == 3449
                : c <= 3647)
              : (c <= 3843 || c == 3859))
            : (c <= 3863 || (c < 3894
              ? (c < 3892
                ? (c >= 3866 && c <= 3871)
                : c <= 3892)
              : (c <= 3894 || c == 3896))))
          : (c <= 4037 || (c < 5008
            ? (c < 4053
              ? (c < 4046
                ? (c >= 4039 && c <= 4044)
                : c <= 4047)
              : (c <= 4056 || (c >= 4254 && c <= 4255)))
            : (c <= 5017 || (c < 6464
              ? (c < 6107
                ? c == 5741
                : c <= 6107)
              : (c <= 6464 || (c >= 6622 && c <= 6655)))))))
        : (c <= 7018 || (c < 8314
          ? (c < 8157
            ? (c < 8127
              ? (c < 8125
                ? (c >= 7028 && c <= 7036)
                : c <= 8125)
              : (c <= 8129 || (c >= 8141 && c <= 8143)))
            : (c <= 8159 || (c < 8260
              ? (c < 8189
                ? (c >= 8173 && c <= 8175)
                : c <= 8190)
              : (c <= 8260 || c == 8274))))
          : (c <= 8316 || (c < 8456
            ? (c < 8448
              ? (c < 8352
                ? (c >= 8330 && c <= 8332)
                : c <= 8384)
              : (c <= 8449 || (c >= 8451 && c <= 8454)))
            : (c <= 8457 || (c < 8470
              ? c == 8468
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_79(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c >= '.' && c <= '/')))
            : (c <= '@' || (c < '~'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_80(int32_t c) {
  return (c < 8485
    ? (c < 3199
      ? (c < 751
        ? (c < 172
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || c == '/'))
            : (c <= '@' || (c < 162
              ? (c < '|'
                ? (c >= '\\' && c <= '^')
                : c <= '~')
              : (c <= 166 || (c >= 168 && c <= 169)))))
          : (c <= 172 || (c < 247
            ? (c < 184
              ? (c < 180
                ? (c >= 174 && c <= 177)
                : c <= 180)
              : (c <= 184 || c == 215))
            : (c <= 247 || (c < 741
              ? (c < 722
                ? (c >= 706 && c <= 709)
                : c <= 735)
              : (c <= 747 || c == 749))))))
        : (c <= 767 || (c < 1769
          ? (c < 1421
            ? (c < 1014
              ? (c < 900
                ? c == 885
                : c <= 901)
              : (c <= 1014 || c == 1154))
            : (c <= 1423 || (c < 1550
              ? (c < 1547
                ? (c >= 1542 && c <= 1544)
                : c <= 1547)
              : (c <= 1551 || c == 1758))))
          : (c <= 1769 || (c < 2546
            ? (c < 2046
              ? (c < 2038
                ? (c >= 1789 && c <= 1790)
                : c <= 2038)
              : (c <= 2047 || c == 2184))
            : (c <= 2547 || (c < 2928
              ? (c < 2801
                ? (c >= 2554 && c <= 2555)
                : c <= 2801)
              : (c <= 2928 || (c >= 3059 && c <= 3066)))))))))
      : (c <= 3199 || (c < 6622
        ? (c < 3896
          ? (c < 3859
            ? (c < 3647
              ? (c < 3449
                ? c == 3407
                : c <= 3449)
              : (c <= 3647 || (c >= 3841 && c <= 3843)))
            : (c <= 3859 || (c < 3892
              ? (c < 3866
                ? (c >= 3861 && c <= 3863)
                : c <= 3871)
              : (c <= 3892 || c == 3894))))
          : (c <= 3896 || (c < 4254
            ? (c < 4046
              ? (c < 4039
                ? (c >= 4030 && c <= 4037)
                : c <= 4044)
              : (c <= 4047 || (c >= 4053 && c <= 4056)))
            : (c <= 4255 || (c < 6107
              ? (c < 5741
                ? (c >= 5008 && c <= 5017)
                : c <= 5741)
              : (c <= 6107 || c == 6464))))))
        : (c <= 6655 || (c < 8274
          ? (c < 8141
            ? (c < 8125
              ? (c < 7028
                ? (c >= 7009 && c <= 7018)
                : c <= 7036)
              : (c <= 8125 || (c >= 8127 && c <= 8129)))
            : (c <= 8143 || (c < 8189
              ? (c < 8173
                ? (c >= 8157 && c <= 8159)
                : c <= 8175)
              : (c <= 8190 || c == 8260))))
          : (c <= 8274 || (c < 8451
            ? (c < 8352
              ? (c < 8330
                ? (c >= 8314 && c <= 8316)
                : c <= 8332)
              : (c <= 8384 || (c >= 8448 && c <= 8449)))
            : (c <= 8454 || (c < 8470
              ? (c < 8468
                ? (c >= 8456 && c <= 8457)
                : c <= 8468)
              : (c <= 8472 || (c >= 8478 && c <= 8483)))))))))))
    : (c <= 8485 || (c < 12880
      ? (c < 10750
        ? (c < 8972
          ? (c < 8512
            ? (c < 8494
              ? (c < 8489
                ? c == 8487
                : c <= 8489)
              : (c <= 8494 || (c >= 8506 && c <= 8507)))
            : (c <= 8516 || (c < 8586
              ? (c < 8527
                ? (c >= 8522 && c <= 8525)
                : c <= 8527)
              : (c <= 8587 || (c >= 8592 && c <= 8967)))))
          : (c <= 9000 || (c < 10132
            ? (c < 9372
              ? (c < 9280
                ? (c >= 9003 && c <= 9254)
                : c <= 9290)
              : (c <= 9449 || (c >= 9472 && c <= 10087)))
            : (c <= 10180 || (c < 10649
              ? (c < 10224
                ? (c >= 10183 && c <= 10213)
                : c <= 10626)
              : (c <= 10711 || (c >= 10716 && c <= 10747)))))))
        : (c <= 11123 || (c < 12306
          ? (c < 11904
            ? (c < 11493
              ? (c < 11159
                ? (c >= 11126 && c <= 11157)
                : c <= 11263)
              : (c <= 11498 || (c >= 11856 && c <= 11857)))
            : (c <= 11929 || (c < 12272
              ? (c < 12032
                ? (c >= 11931 && c <= 12019)
                : c <= 12245)
              : (c <= 12283 || c == 12292))))
          : (c <= 12307 || (c < 12688
            ? (c < 12350
              ? (c < 12342
                ? c == 12320
                : c <= 12343)
              : (c <= 12351 || (c >= 12443 && c <= 12444)))
            : (c <= 12689 || (c < 12800
              ? (c < 12736
                ? (c >= 12694 && c <= 12703)
                : c <= 12771)
              : (c <= 12830 || (c >= 12842 && c <= 12871)))))))))
      : (c <= 12880 || (c < 65124
        ? (c < 43062
          ? (c < 42128
            ? (c < 12992
              ? (c < 12938
                ? (c >= 12896 && c <= 12927)
                : c <= 12976)
              : (c <= 13311 || (c >= 19904 && c <= 19967)))
            : (c <= 42182 || (c < 42889
              ? (c < 42784
                ? (c >= 42752 && c <= 42774)
                : c <= 42785)
              : (c <= 42890 || (c >= 43048 && c <= 43051)))))
          : (c <= 43065 || (c < 64434
            ? (c < 43882
              ? (c < 43867
                ? (c >= 43639 && c <= 43641)
                : c <= 43867)
              : (c <= 43883 || c == 64297))
            : (c <= 64450 || (c < 65020
              ? (c < 64975
                ? (c >= 64832 && c <= 64847)
                : c <= 64975)
              : (c <= 65023 || c == 65122))))))
        : (c <= 65126 || (c < 65512
          ? (c < 65342
            ? (c < 65291
              ? (c < 65284
                ? c == 65129
                : c <= 65284)
              : (c <= 65291 || (c >= 65308 && c <= 65310)))
            : (c <= 65342 || (c < 65374
              ? (c < 65372
                ? c == 65344
                : c <= 65372)
              : (c <= 65374 || (c >= 65504 && c <= 65510)))))
          : (c <= 65518 || (c < 65936
            ? (c < 65913
              ? (c < 65847
                ? (c >= 65532 && c <= 65533)
                : c <= 65855)
              : (c <= 65929 || (c >= 65932 && c <= 65934)))
            : (c <= 65948 || (c < 66000
              ? c == 65952
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_81(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= '?')))
            : (c <= '\\' || (c < '|'
              ? (c < '`'
                ? c == '^'
                : c <= '`')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_82(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= '@')))
            : (c <= '\\' || (c < '|'
              ? (c < '`'
                ? c == '^'
                : c <= '`')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_83(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || c == '/'))
            : (c <= '@' || (c < '~'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_84(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '-' && c <= '/')
                : c <= '@')))
            : (c <= '\\' || (c < '~'
              ? (c < '`'
                ? c == '^'
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_85(int32_t c) {
  return (c < 8478
    ? (c < 3059
      ? (c < 749
        ? (c < 168
          ? (c < ':'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c >= '-' && c <= '/')))
            : (c <= '@' || (c < '|'
              ? (c < '`'
                ? (c >= '\\' && c <= '^')
                : c <= '`')
              : (c <= '~' || (c >= 162 && c <= 166)))))
          : (c <= 169 || (c < 215
            ? (c < 180
              ? (c < 174
                ? c == 172
                : c <= 177)
              : (c <= 180 || c == 184))
            : (c <= 215 || (c < 722
              ? (c < 706
                ? c == 247
                : c <= 709)
              : (c <= 735 || (c >= 741 && c <= 747)))))))
        : (c <= 749 || (c < 1758
          ? (c < 1154
            ? (c < 900
              ? (c < 885
                ? (c >= 751 && c <= 767)
                : c <= 885)
              : (c <= 901 || c == 1014))
            : (c <= 1154 || (c < 1547
              ? (c < 1542
                ? (c >= 1421 && c <= 1423)
                : c <= 1544)
              : (c <= 1547 || (c >= 1550 && c <= 1551)))))
          : (c <= 1758 || (c < 2184
            ? (c < 2038
              ? (c < 1789
                ? c == 1769
                : c <= 1790)
              : (c <= 2038 || (c >= 2046 && c <= 2047)))
            : (c <= 2184 || (c < 2801
              ? (c < 2554
                ? (c >= 2546 && c <= 2547)
                : c <= 2555)
              : (c <= 2801 || c == 2928))))))))
      : (c <= 3066 || (c < 6464
        ? (c < 3894
          ? (c < 3841
            ? (c < 3449
              ? (c < 3407
                ? c == 3199
                : c <= 3407)
              : (c <= 3449 || c == 3647))
            : (c <= 3843 || (c < 3866
              ? (c < 3861
                ? c == 3859
                : c <= 3863)
              : (c <= 3871 || c == 3892))))
          : (c <= 3894 || (c < 4053
            ? (c < 4039
              ? (c < 4030
                ? c == 3896
                : c <= 4037)
              : (c <= 4044 || (c >= 4046 && c <= 4047)))
            : (c <= 4056 || (c < 5741
              ? (c < 5008
                ? (c >= 4254 && c <= 4255)
                : c <= 5017)
              : (c <= 5741 || c == 6107))))))
        : (c <= 6464 || (c < 8260
          ? (c < 8127
            ? (c < 7028
              ? (c < 7009
                ? (c >= 6622 && c <= 6655)
                : c <= 7018)
              : (c <= 7036 || c == 8125))
            : (c <= 8129 || (c < 8173
              ? (c < 8157
                ? (c >= 8141 && c <= 8143)
                : c <= 8159)
              : (c <= 8175 || (c >= 8189 && c <= 8190)))))
          : (c <= 8260 || (c < 8448
            ? (c < 8330
              ? (c < 8314
                ? c == 8274
                : c <= 8316)
              : (c <= 8332 || (c >= 8352 && c <= 8384)))
            : (c <= 8449 || (c < 8468
              ? (c < 8456
                ? (c >= 8451 && c <= 8454)
                : c <= 8457)
              : (c <= 8468 || (c >= 8470 && c <= 8472)))))))))))
    : (c <= 8483 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8489
              ? (c < 8487
                ? c == 8485
                : c <= 8487)
              : (c <= 8489 || c == 8494))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_86(int32_t c) {
  return (c < 8470
    ? (c < 2801
      ? (c < 722
        ? (c < '~'
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '-' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '|'))))
          : (c <= '~' || (c < 180
            ? (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))
            : (c <= 180 || (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))))))
        : (c <= 735 || (c < 1547
          ? (c < 900
            ? (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))
            : (c <= 901 || (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))))
          : (c <= 1547 || (c < 2038
            ? (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))
            : (c <= 2038 || (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))))))))
      : (c <= 2801 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || (c < 3449
                ? c == 3407
                : c <= 3449)))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_87(int32_t c) {
  return (c < 8470
    ? (c < 2801
      ? (c < 722
        ? (c < '~'
          ? (c < '<'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < ':'
                ? (c >= '.' && c <= '/')
                : c <= ':')))
            : (c <= '@' || (c < '`'
              ? (c < '^'
                ? c == '\\'
                : c <= '^')
              : (c <= '`' || c == '|'))))
          : (c <= '~' || (c < 180
            ? (c < 172
              ? (c < 168
                ? (c >= 162 && c <= 166)
                : c <= 169)
              : (c <= 172 || (c >= 174 && c <= 177)))
            : (c <= 180 || (c < 247
              ? (c < 215
                ? c == 184
                : c <= 215)
              : (c <= 247 || (c >= 706 && c <= 709)))))))
        : (c <= 735 || (c < 1547
          ? (c < 900
            ? (c < 751
              ? (c < 749
                ? (c >= 741 && c <= 747)
                : c <= 749)
              : (c <= 767 || c == 885))
            : (c <= 901 || (c < 1421
              ? (c < 1154
                ? c == 1014
                : c <= 1154)
              : (c <= 1423 || (c >= 1542 && c <= 1544)))))
          : (c <= 1547 || (c < 2038
            ? (c < 1769
              ? (c < 1758
                ? (c >= 1550 && c <= 1551)
                : c <= 1758)
              : (c <= 1769 || (c >= 1789 && c <= 1790)))
            : (c <= 2038 || (c < 2546
              ? (c < 2184
                ? (c >= 2046 && c <= 2047)
                : c <= 2184)
              : (c <= 2547 || (c >= 2554 && c <= 2555)))))))))
      : (c <= 2801 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3199
              ? (c < 3059
                ? c == 2928
                : c <= 3066)
              : (c <= 3199 || (c < 3449
                ? c == 3407
                : c <= 3449)))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__operator_character_set_88(int32_t c) {
  return (c < 8470
    ? (c < 2928
      ? (c < 741
        ? (c < 162
          ? (c < '\\'
            ? (c < '*'
              ? (c < '#'
                ? c == '!'
                : c <= '&')
              : (c <= '+' || (c < '<'
                ? (c >= '-' && c <= '/')
                : c <= '@')))
            : (c <= '\\' || (c < '|'
              ? (c < '`'
                ? c == '^'
                : c <= '`')
              : (c <= '|' || c == '~'))))
          : (c <= 166 || (c < 184
            ? (c < 174
              ? (c < 172
                ? (c >= 168 && c <= 169)
                : c <= 172)
              : (c <= 177 || c == 180))
            : (c <= 184 || (c < 706
              ? (c < 247
                ? c == 215
                : c <= 247)
              : (c <= 709 || (c >= 722 && c <= 735)))))))
        : (c <= 747 || (c < 1550
          ? (c < 1014
            ? (c < 885
              ? (c < 751
                ? c == 749
                : c <= 767)
              : (c <= 885 || (c >= 900 && c <= 901)))
            : (c <= 1014 || (c < 1542
              ? (c < 1421
                ? c == 1154
                : c <= 1423)
              : (c <= 1544 || c == 1547))))
          : (c <= 1551 || (c < 2046
            ? (c < 1789
              ? (c < 1769
                ? c == 1758
                : c <= 1769)
              : (c <= 1790 || c == 2038))
            : (c <= 2047 || (c < 2554
              ? (c < 2546
                ? c == 2184
                : c <= 2547)
              : (c <= 2555 || c == 2801))))))))
      : (c <= 2928 || (c < 6107
        ? (c < 3892
          ? (c < 3647
            ? (c < 3407
              ? (c < 3199
                ? (c >= 3059 && c <= 3066)
                : c <= 3199)
              : (c <= 3407 || c == 3449))
            : (c <= 3647 || (c < 3861
              ? (c < 3859
                ? (c >= 3841 && c <= 3843)
                : c <= 3859)
              : (c <= 3863 || (c >= 3866 && c <= 3871)))))
          : (c <= 3892 || (c < 4046
            ? (c < 4030
              ? (c < 3896
                ? c == 3894
                : c <= 3896)
              : (c <= 4037 || (c >= 4039 && c <= 4044)))
            : (c <= 4047 || (c < 5008
              ? (c < 4254
                ? (c >= 4053 && c <= 4056)
                : c <= 4255)
              : (c <= 5017 || c == 5741))))))
        : (c <= 6107 || (c < 8189
          ? (c < 8125
            ? (c < 7009
              ? (c < 6622
                ? c == 6464
                : c <= 6655)
              : (c <= 7018 || (c >= 7028 && c <= 7036)))
            : (c <= 8125 || (c < 8157
              ? (c < 8141
                ? (c >= 8127 && c <= 8129)
                : c <= 8143)
              : (c <= 8159 || (c >= 8173 && c <= 8175)))))
          : (c <= 8190 || (c < 8352
            ? (c < 8314
              ? (c < 8274
                ? c == 8260
                : c <= 8274)
              : (c <= 8316 || (c >= 8330 && c <= 8332)))
            : (c <= 8384 || (c < 8456
              ? (c < 8451
                ? (c >= 8448 && c <= 8449)
                : c <= 8454)
              : (c <= 8457 || c == 8468))))))))))
    : (c <= 8472 || (c < 12842
      ? (c < 10716
        ? (c < 8592
          ? (c < 8506
            ? (c < 8487
              ? (c < 8485
                ? (c >= 8478 && c <= 8483)
                : c <= 8485)
              : (c <= 8487 || (c < 8494
                ? c == 8489
                : c <= 8494)))
            : (c <= 8507 || (c < 8527
              ? (c < 8522
                ? (c >= 8512 && c <= 8516)
                : c <= 8525)
              : (c <= 8527 || (c >= 8586 && c <= 8587)))))
          : (c <= 8967 || (c < 9472
            ? (c < 9280
              ? (c < 9003
                ? (c >= 8972 && c <= 9000)
                : c <= 9254)
              : (c <= 9290 || (c >= 9372 && c <= 9449)))
            : (c <= 10087 || (c < 10224
              ? (c < 10183
                ? (c >= 10132 && c <= 10180)
                : c <= 10213)
              : (c <= 10626 || (c >= 10649 && c <= 10711)))))))
        : (c <= 10747 || (c < 12292
          ? (c < 11856
            ? (c < 11159
              ? (c < 11126
                ? (c >= 10750 && c <= 11123)
                : c <= 11157)
              : (c <= 11263 || (c >= 11493 && c <= 11498)))
            : (c <= 11857 || (c < 12032
              ? (c < 11931
                ? (c >= 11904 && c <= 11929)
                : c <= 12019)
              : (c <= 12245 || (c >= 12272 && c <= 12283)))))
          : (c <= 12292 || (c < 12443
            ? (c < 12342
              ? (c < 12320
                ? (c >= 12306 && c <= 12307)
                : c <= 12320)
              : (c <= 12343 || (c >= 12350 && c <= 12351)))
            : (c <= 12444 || (c < 12736
              ? (c < 12694
                ? (c >= 12688 && c <= 12689)
                : c <= 12703)
              : (c <= 12771 || (c >= 12800 && c <= 12830)))))))))
      : (c <= 12871 || (c < 65122
        ? (c < 43048
          ? (c < 19904
            ? (c < 12938
              ? (c < 12896
                ? c == 12880
                : c <= 12927)
              : (c <= 12976 || (c >= 12992 && c <= 13311)))
            : (c <= 19967 || (c < 42784
              ? (c < 42752
                ? (c >= 42128 && c <= 42182)
                : c <= 42774)
              : (c <= 42785 || (c >= 42889 && c <= 42890)))))
          : (c <= 43051 || (c < 64297
            ? (c < 43867
              ? (c < 43639
                ? (c >= 43062 && c <= 43065)
                : c <= 43641)
              : (c <= 43867 || (c >= 43882 && c <= 43883)))
            : (c <= 64297 || (c < 64975
              ? (c < 64832
                ? (c >= 64434 && c <= 64450)
                : c <= 64847)
              : (c <= 64975 || (c >= 65020 && c <= 65023)))))))
        : (c <= 65122 || (c < 65504
          ? (c < 65308
            ? (c < 65284
              ? (c < 65129
                ? (c >= 65124 && c <= 65126)
                : c <= 65129)
              : (c <= 65284 || c == 65291))
            : (c <= 65310 || (c < 65372
              ? (c < 65344
                ? c == 65342
                : c <= 65344)
              : (c <= 65372 || c == 65374))))
          : (c <= 65510 || (c < 65932
            ? (c < 65847
              ? (c < 65532
                ? (c >= 65512 && c <= 65518)
                : c <= 65533)
              : (c <= 65855 || (c >= 65913 && c <= 65929)))
            : (c <= 65934 || (c < 66000
              ? (c < 65952
                ? (c >= 65936 && c <= 65948)
                : c <= 65952)
              : (c <= 66044 || (c >= 67703 && c <= 67704)))))))))))));
}

static inline bool sym__conid_character_set_1(int32_t c) {
  return (c < 7734
    ? (c < 913
      ? (c < 422
        ? (c < 327
          ? (c < 288
            ? (c < 268
              ? (c < 258
                ? (c < 216
                  ? (c < 192
                    ? (c >= 'A' && c <= 'Z')
                    : c <= 214)
                  : (c <= 222 || c == 256))
                : (c <= 258 || (c < 264
                  ? (c < 262
                    ? c == 260
                    : c <= 262)
                  : (c <= 264 || c == 266))))
              : (c <= 268 || (c < 278
                ? (c < 274
                  ? (c < 272
                    ? c == 270
                    : c <= 272)
                  : (c <= 274 || c == 276))
                : (c <= 278 || (c < 284
                  ? (c < 282
                    ? c == 280
                    : c <= 282)
                  : (c <= 284 || c == 286))))))
            : (c <= 288 || (c < 308
              ? (c < 298
                ? (c < 294
                  ? (c < 292
                    ? c == 290
                    : c <= 292)
                  : (c <= 294 || c == 296))
                : (c <= 298 || (c < 304
                  ? (c < 302
                    ? c == 300
                    : c <= 302)
                  : (c <= 304 || c == 306))))
              : (c <= 308 || (c < 319
                ? (c < 315
                  ? (c < 313
                    ? c == 310
                    : c <= 313)
                  : (c <= 315 || c == 317))
                : (c <= 319 || (c < 323
                  ? c == 321
                  : (c <= 323 || c == 325))))))))
          : (c <= 327 || (c < 366
            ? (c < 348
              ? (c < 338
                ? (c < 334
                  ? (c < 332
                    ? c == 330
                    : c <= 332)
                  : (c <= 334 || c == 336))
                : (c <= 338 || (c < 344
                  ? (c < 342
                    ? c == 340
                    : c <= 342)
                  : (c <= 344 || c == 346))))
              : (c <= 348 || (c < 358
                ? (c < 354
                  ? (c < 352
                    ? c == 350
                    : c <= 352)
                  : (c <= 354 || c == 356))
                : (c <= 358 || (c < 362
                  ? c == 360
                  : (c <= 362 || c == 364))))))
            : (c <= 366 || (c < 390
              ? (c < 376
                ? (c < 372
                  ? (c < 370
                    ? c == 368
                    : c <= 370)
                  : (c <= 372 || c == 374))
                : (c <= 377 || (c < 385
                  ? (c < 381
                    ? c == 379
                    : c <= 381)
                  : (c <= 386 || c == 388))))
              : (c <= 391 || (c < 412
                ? (c < 403
                  ? (c < 398
                    ? (c >= 393 && c <= 395)
                    : c <= 401)
                  : (c <= 404 || (c >= 406 && c <= 408)))
                : (c <= 413 || (c < 418
                  ? (c >= 415 && c <= 416)
                  : (c <= 418 || c == 420))))))))))
        : (c <= 423 || (c < 520
          ? (c < 478
            ? (c < 458
              ? (c < 437
                ? (c < 430
                  ? (c < 428
                    ? c == 425
                    : c <= 428)
                  : (c <= 431 || (c >= 433 && c <= 435)))
                : (c <= 437 || (c < 452
                  ? (c < 444
                    ? (c >= 439 && c <= 440)
                    : c <= 444)
                  : (c <= 452 || c == 455))))
              : (c <= 458 || (c < 469
                ? (c < 465
                  ? (c < 463
                    ? c == 461
                    : c <= 463)
                  : (c <= 465 || c == 467))
                : (c <= 469 || (c < 473
                  ? c == 471
                  : (c <= 473 || c == 475))))))
            : (c <= 478 || (c < 500
              ? (c < 488
                ? (c < 484
                  ? (c < 482
                    ? c == 480
                    : c <= 482)
                  : (c <= 484 || c == 486))
                : (c <= 488 || (c < 494
                  ? (c < 492
                    ? c == 490
                    : c <= 492)
                  : (c <= 494 || c == 497))))
              : (c <= 500 || (c < 512
                ? (c < 508
                  ? (c < 506
                    ? (c >= 502 && c <= 504)
                    : c <= 506)
                  : (c <= 508 || c == 510))
                : (c <= 512 || (c < 516
                  ? c == 514
                  : (c <= 516 || c == 518))))))))
          : (c <= 520 || (c < 558
            ? (c < 540
              ? (c < 530
                ? (c < 526
                  ? (c < 524
                    ? c == 522
                    : c <= 524)
                  : (c <= 526 || c == 528))
                : (c <= 530 || (c < 536
                  ? (c < 534
                    ? c == 532
                    : c <= 534)
                  : (c <= 536 || c == 538))))
              : (c <= 540 || (c < 550
                ? (c < 546
                  ? (c < 544
                    ? c == 542
                    : c <= 544)
                  : (c <= 546 || c == 548))
                : (c <= 550 || (c < 554
                  ? c == 552
                  : (c <= 554 || c == 556))))))
            : (c <= 558 || (c < 590
              ? (c < 577
                ? (c < 570
                  ? (c < 562
                    ? c == 560
                    : c <= 562)
                  : (c <= 571 || (c >= 573 && c <= 574)))
                : (c <= 577 || (c < 586
                  ? (c < 584
                    ? (c >= 579 && c <= 582)
                    : c <= 584)
                  : (c <= 586 || c == 588))))
              : (c <= 590 || (c < 902
                ? (c < 886
                  ? (c < 882
                    ? c == 880
                    : c <= 882)
                  : (c <= 886 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 911)))))))))))))
      : (c <= 929 || (c < 1244
        ? (c < 1166
          ? (c < 1120
            ? (c < 996
              ? (c < 986
                ? (c < 978
                  ? (c < 975
                    ? (c >= 931 && c <= 939)
                    : c <= 975)
                  : (c <= 980 || c == 984))
                : (c <= 986 || (c < 992
                  ? (c < 990
                    ? c == 988
                    : c <= 990)
                  : (c <= 992 || c == 994))))
              : (c <= 996 || (c < 1006
                ? (c < 1002
                  ? (c < 1000
                    ? c == 998
                    : c <= 1000)
                  : (c <= 1002 || c == 1004))
                : (c <= 1006 || (c < 1017
                  ? (c < 1015
                    ? c == 1012
                    : c <= 1015)
                  : (c <= 1018 || (c >= 1021 && c <= 1071)))))))
            : (c <= 1120 || (c < 1140
              ? (c < 1130
                ? (c < 1126
                  ? (c < 1124
                    ? c == 1122
                    : c <= 1124)
                  : (c <= 1126 || c == 1128))
                : (c <= 1130 || (c < 1136
                  ? (c < 1134
                    ? c == 1132
                    : c <= 1134)
                  : (c <= 1136 || c == 1138))))
              : (c <= 1140 || (c < 1150
                ? (c < 1146
                  ? (c < 1144
                    ? c == 1142
                    : c <= 1144)
                  : (c <= 1146 || c == 1148))
                : (c <= 1150 || (c < 1162
                  ? c == 1152
                  : (c <= 1162 || c == 1164))))))))
          : (c <= 1166 || (c < 1204
            ? (c < 1186
              ? (c < 1176
                ? (c < 1172
                  ? (c < 1170
                    ? c == 1168
                    : c <= 1170)
                  : (c <= 1172 || c == 1174))
                : (c <= 1176 || (c < 1182
                  ? (c < 1180
                    ? c == 1178
                    : c <= 1180)
                  : (c <= 1182 || c == 1184))))
              : (c <= 1186 || (c < 1196
                ? (c < 1192
                  ? (c < 1190
                    ? c == 1188
                    : c <= 1190)
                  : (c <= 1192 || c == 1194))
                : (c <= 1196 || (c < 1200
                  ? c == 1198
                  : (c <= 1200 || c == 1202))))))
            : (c <= 1204 || (c < 1225
              ? (c < 1214
                ? (c < 1210
                  ? (c < 1208
                    ? c == 1206
                    : c <= 1208)
                  : (c <= 1210 || c == 1212))
                : (c <= 1214 || (c < 1221
                  ? (c < 1219
                    ? (c >= 1216 && c <= 1217)
                    : c <= 1219)
                  : (c <= 1221 || c == 1223))))
              : (c <= 1225 || (c < 1236
                ? (c < 1232
                  ? (c < 1229
                    ? c == 1227
                    : c <= 1229)
                  : (c <= 1232 || c == 1234))
                : (c <= 1236 || (c < 1240
                  ? c == 1238
                  : (c <= 1240 || c == 1242))))))))))
        : (c <= 1244 || (c < 1320
          ? (c < 1282
            ? (c < 1264
              ? (c < 1254
                ? (c < 1250
                  ? (c < 1248
                    ? c == 1246
                    : c <= 1248)
                  : (c <= 1250 || c == 1252))
                : (c <= 1254 || (c < 1260
                  ? (c < 1258
                    ? c == 1256
                    : c <= 1258)
                  : (c <= 1260 || c == 1262))))
              : (c <= 1264 || (c < 1274
                ? (c < 1270
                  ? (c < 1268
                    ? c == 1266
                    : c <= 1268)
                  : (c <= 1270 || c == 1272))
                : (c <= 1274 || (c < 1278
                  ? c == 1276
                  : (c <= 1278 || c == 1280))))))
            : (c <= 1282 || (c < 1302
              ? (c < 1292
                ? (c < 1288
                  ? (c < 1286
                    ? c == 1284
                    : c <= 1286)
                  : (c <= 1288 || c == 1290))
                : (c <= 1292 || (c < 1298
                  ? (c < 1296
                    ? c == 1294
                    : c <= 1296)
                  : (c <= 1298 || c == 1300))))
              : (c <= 1302 || (c < 1312
                ? (c < 1308
                  ? (c < 1306
                    ? c == 1304
                    : c <= 1306)
                  : (c <= 1308 || c == 1310))
                : (c <= 1312 || (c < 1316
                  ? c == 1314
                  : (c <= 1316 || c == 1318))))))))
          : (c <= 1320 || (c < 7696
            ? (c < 7357
              ? (c < 4256
                ? (c < 1326
                  ? (c < 1324
                    ? c == 1322
                    : c <= 1324)
                  : (c <= 1326 || (c >= 1329 && c <= 1366)))
                : (c <= 4293 || (c < 5024
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 5109 || (c >= 7312 && c <= 7354)))))
              : (c <= 7359 || (c < 7688
                ? (c < 7684
                  ? (c < 7682
                    ? c == 7680
                    : c <= 7682)
                  : (c <= 7684 || c == 7686))
                : (c <= 7688 || (c < 7692
                  ? c == 7690
                  : (c <= 7692 || c == 7694))))))
            : (c <= 7696 || (c < 7716
              ? (c < 7706
                ? (c < 7702
                  ? (c < 7700
                    ? c == 7698
                    : c <= 7700)
                  : (c <= 7702 || c == 7704))
                : (c <= 7706 || (c < 7712
                  ? (c < 7710
                    ? c == 7708
                    : c <= 7710)
                  : (c <= 7712 || c == 7714))))
              : (c <= 7716 || (c < 7726
                ? (c < 7722
                  ? (c < 7720
                    ? c == 7718
                    : c <= 7720)
                  : (c <= 7722 || c == 7724))
                : (c <= 7726 || (c < 7730
                  ? c == 7728
                  : (c <= 7730 || c == 7732))))))))))))))
    : (c <= 7734 || (c < 11428
      ? (c < 7896
        ? (c < 7812
          ? (c < 7774
            ? (c < 7754
              ? (c < 7744
                ? (c < 7740
                  ? (c < 7738
                    ? c == 7736
                    : c <= 7738)
                  : (c <= 7740 || c == 7742))
                : (c <= 7744 || (c < 7750
                  ? (c < 7748
                    ? c == 7746
                    : c <= 7748)
                  : (c <= 7750 || c == 7752))))
              : (c <= 7754 || (c < 7764
                ? (c < 7760
                  ? (c < 7758
                    ? c == 7756
                    : c <= 7758)
                  : (c <= 7760 || c == 7762))
                : (c <= 7764 || (c < 7770
                  ? (c < 7768
                    ? c == 7766
                    : c <= 7768)
                  : (c <= 7770 || c == 7772))))))
            : (c <= 7774 || (c < 7794
              ? (c < 7784
                ? (c < 7780
                  ? (c < 7778
                    ? c == 7776
                    : c <= 7778)
                  : (c <= 7780 || c == 7782))
                : (c <= 7784 || (c < 7790
                  ? (c < 7788
                    ? c == 7786
                    : c <= 7788)
                  : (c <= 7790 || c == 7792))))
              : (c <= 7794 || (c < 7804
                ? (c < 7800
                  ? (c < 7798
                    ? c == 7796
                    : c <= 7798)
                  : (c <= 7800 || c == 7802))
                : (c <= 7804 || (c < 7808
                  ? c == 7806
                  : (c <= 7808 || c == 7810))))))))
          : (c <= 7812 || (c < 7858
            ? (c < 7840
              ? (c < 7822
                ? (c < 7818
                  ? (c < 7816
                    ? c == 7814
                    : c <= 7816)
                  : (c <= 7818 || c == 7820))
                : (c <= 7822 || (c < 7828
                  ? (c < 7826
                    ? c == 7824
                    : c <= 7826)
                  : (c <= 7828 || c == 7838))))
              : (c <= 7840 || (c < 7850
                ? (c < 7846
                  ? (c < 7844
                    ? c == 7842
                    : c <= 7844)
                  : (c <= 7846 || c == 7848))
                : (c <= 7850 || (c < 7854
                  ? c == 7852
                  : (c <= 7854 || c == 7856))))))
            : (c <= 7858 || (c < 7878
              ? (c < 7868
                ? (c < 7864
                  ? (c < 7862
                    ? c == 7860
                    : c <= 7862)
                  : (c <= 7864 || c == 7866))
                : (c <= 7868 || (c < 7874
                  ? (c < 7872
                    ? c == 7870
                    : c <= 7872)
                  : (c <= 7874 || c == 7876))))
              : (c <= 7878 || (c < 7888
                ? (c < 7884
                  ? (c < 7882
                    ? c == 7880
                    : c <= 7882)
                  : (c <= 7884 || c == 7886))
                : (c <= 7888 || (c < 7892
                  ? c == 7890
                  : (c <= 7892 || c == 7894))))))))))
        : (c <= 7896 || (c < 8464
          ? (c < 7934
            ? (c < 7916
              ? (c < 7906
                ? (c < 7902
                  ? (c < 7900
                    ? c == 7898
                    : c <= 7900)
                  : (c <= 7902 || c == 7904))
                : (c <= 7906 || (c < 7912
                  ? (c < 7910
                    ? c == 7908
                    : c <= 7910)
                  : (c <= 7912 || c == 7914))))
              : (c <= 7916 || (c < 7926
                ? (c < 7922
                  ? (c < 7920
                    ? c == 7918
                    : c <= 7920)
                  : (c <= 7922 || c == 7924))
                : (c <= 7926 || (c < 7930
                  ? c == 7928
                  : (c <= 7930 || c == 7932))))))
            : (c <= 7934 || (c < 8040
              ? (c < 8008
                ? (c < 7976
                  ? (c < 7960
                    ? (c >= 7944 && c <= 7951)
                    : c <= 7965)
                  : (c <= 7983 || (c >= 7992 && c <= 7999)))
                : (c <= 8013 || (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || c == 8031))))
              : (c <= 8047 || (c < 8184
                ? (c < 8152
                  ? (c < 8136
                    ? (c >= 8120 && c <= 8123)
                    : c <= 8139)
                  : (c <= 8155 || (c >= 8168 && c <= 8172)))
                : (c <= 8187 || (c < 8455
                  ? c == 8450
                  : (c <= 8455 || (c >= 8459 && c <= 8461)))))))))
          : (c <= 8466 || (c < 11381
            ? (c < 8579
              ? (c < 8488
                ? (c < 8484
                  ? (c < 8473
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8510
                  ? (c < 8496
                    ? (c >= 8490 && c <= 8493)
                    : c <= 8499)
                  : (c <= 8511 || c == 8517))))
              : (c <= 8579 || (c < 11369
                ? (c < 11362
                  ? (c < 11360
                    ? (c >= 11264 && c <= 11311)
                    : c <= 11360)
                  : (c <= 11364 || c == 11367))
                : (c <= 11369 || (c < 11373
                  ? c == 11371
                  : (c <= 11376 || c == 11378))))))
            : (c <= 11381 || (c < 11410
              ? (c < 11400
                ? (c < 11396
                  ? (c < 11394
                    ? (c >= 11390 && c <= 11392)
                    : c <= 11394)
                  : (c <= 11396 || c == 11398))
                : (c <= 11400 || (c < 11406
                  ? (c < 11404
                    ? c == 11402
                    : c <= 11404)
                  : (c <= 11406 || c == 11408))))
              : (c <= 11410 || (c < 11420
                ? (c < 11416
                  ? (c < 11414
                    ? c == 11412
                    : c <= 11414)
                  : (c <= 11416 || c == 11418))
                : (c <= 11420 || (c < 11424
                  ? c == 11422
                  : (c <= 11424 || c == 11426))))))))))))
      : (c <= 11428 || (c < 42796
        ? (c < 42568
          ? (c < 11468
            ? (c < 11448
              ? (c < 11438
                ? (c < 11434
                  ? (c < 11432
                    ? c == 11430
                    : c <= 11432)
                  : (c <= 11434 || c == 11436))
                : (c <= 11438 || (c < 11444
                  ? (c < 11442
                    ? c == 11440
                    : c <= 11442)
                  : (c <= 11444 || c == 11446))))
              : (c <= 11448 || (c < 11458
                ? (c < 11454
                  ? (c < 11452
                    ? c == 11450
                    : c <= 11452)
                  : (c <= 11454 || c == 11456))
                : (c <= 11458 || (c < 11464
                  ? (c < 11462
                    ? c == 11460
                    : c <= 11462)
                  : (c <= 11464 || c == 11466))))))
            : (c <= 11468 || (c < 11488
              ? (c < 11478
                ? (c < 11474
                  ? (c < 11472
                    ? c == 11470
                    : c <= 11472)
                  : (c <= 11474 || c == 11476))
                : (c <= 11478 || (c < 11484
                  ? (c < 11482
                    ? c == 11480
                    : c <= 11482)
                  : (c <= 11484 || c == 11486))))
              : (c <= 11488 || (c < 42560
                ? (c < 11501
                  ? (c < 11499
                    ? c == 11490
                    : c <= 11499)
                  : (c <= 11501 || c == 11506))
                : (c <= 42560 || (c < 42564
                  ? c == 42562
                  : (c <= 42564 || c == 42566))))))))
          : (c <= 42568 || (c < 42624
            ? (c < 42588
              ? (c < 42578
                ? (c < 42574
                  ? (c < 42572
                    ? c == 42570
                    : c <= 42572)
                  : (c <= 42574 || c == 42576))
                : (c <= 42578 || (c < 42584
                  ? (c < 42582
                    ? c == 42580
                    : c <= 42582)
                  : (c <= 42584 || c == 42586))))
              : (c <= 42588 || (c < 42598
                ? (c < 42594
                  ? (c < 42592
                    ? c == 42590
                    : c <= 42592)
                  : (c <= 42594 || c == 42596))
                : (c <= 42598 || (c < 42602
                  ? c == 42600
                  : (c <= 42602 || c == 42604))))))
            : (c <= 42624 || (c < 42644
              ? (c < 42634
                ? (c < 42630
                  ? (c < 42628
                    ? c == 42626
                    : c <= 42628)
                  : (c <= 42630 || c == 42632))
                : (c <= 42634 || (c < 42640
                  ? (c < 42638
                    ? c == 42636
                    : c <= 42638)
                  : (c <= 42640 || c == 42642))))
              : (c <= 42644 || (c < 42788
                ? (c < 42650
                  ? (c < 42648
                    ? c == 42646
                    : c <= 42648)
                  : (c <= 42650 || c == 42786))
                : (c <= 42788 || (c < 42792
                  ? c == 42790
                  : (c <= 42792 || c == 42794))))))))))
        : (c <= 42796 || (c < 42884
          ? (c < 42836
            ? (c < 42818
              ? (c < 42808
                ? (c < 42804
                  ? (c < 42802
                    ? c == 42798
                    : c <= 42802)
                  : (c <= 42804 || c == 42806))
                : (c <= 42808 || (c < 42814
                  ? (c < 42812
                    ? c == 42810
                    : c <= 42812)
                  : (c <= 42814 || c == 42816))))
              : (c <= 42818 || (c < 42828
                ? (c < 42824
                  ? (c < 42822
                    ? c == 42820
                    : c <= 42822)
                  : (c <= 42824 || c == 42826))
                : (c <= 42828 || (c < 42832
                  ? c == 42830
                  : (c <= 42832 || c == 42834))))))
            : (c <= 42836 || (c < 42856
              ? (c < 42846
                ? (c < 42842
                  ? (c < 42840
                    ? c == 42838
                    : c <= 42840)
                  : (c <= 42842 || c == 42844))
                : (c <= 42846 || (c < 42852
                  ? (c < 42850
                    ? c == 42848
                    : c <= 42850)
                  : (c <= 42852 || c == 42854))))
              : (c <= 42856 || (c < 42875
                ? (c < 42862
                  ? (c < 42860
                    ? c == 42858
                    : c <= 42860)
                  : (c <= 42862 || c == 42873))
                : (c <= 42875 || (c < 42880
                  ? (c >= 42877 && c <= 42878)
                  : (c <= 42880 || c == 42882))))))))
          : (c <= 42884 || (c < 42936
            ? (c < 42910
              ? (c < 42898
                ? (c < 42893
                  ? (c < 42891
                    ? c == 42886
                    : c <= 42891)
                  : (c <= 42893 || c == 42896))
                : (c <= 42898 || (c < 42906
                  ? (c < 42904
                    ? c == 42902
                    : c <= 42904)
                  : (c <= 42906 || c == 42908))))
              : (c <= 42910 || (c < 42920
                ? (c < 42916
                  ? (c < 42914
                    ? c == 42912
                    : c <= 42914)
                  : (c <= 42916 || c == 42918))
                : (c <= 42920 || (c < 42928
                  ? (c >= 42922 && c <= 42926)
                  : (c <= 42932 || c == 42934))))))
            : (c <= 42936 || (c < 42968
              ? (c < 42946
                ? (c < 42942
                  ? (c < 42940
                    ? c == 42938
                    : c <= 42940)
                  : (c <= 42942 || c == 42944))
                : (c <= 42946 || (c < 42960
                  ? (c < 42953
                    ? (c >= 42948 && c <= 42951)
                    : c <= 42953)
                  : (c <= 42960 || c == 42966))))
              : (c <= 42968 || (c < 66928
                ? (c < 66560
                  ? (c < 65313
                    ? c == 42997
                    : c <= 65338)
                  : (c <= 66599 || (c >= 66736 && c <= 66771)))
                : (c <= 66938 || (c < 66956
                  ? (c >= 66940 && c <= 66954)
                  : (c <= 66962 || (c >= 66964 && c <= 66965)))))))))))))))));
}

static inline bool sym__conid_character_set_2(int32_t c) {
  return (c < 7728
    ? (c < 910
      ? (c < 422
        ? (c < 327
          ? (c < 288
            ? (c < 270
              ? (c < 260
                ? (c < 256
                  ? (c < 192
                    ? (c >= 'A' && c <= 'Z')
                    : c <= 222)
                  : (c <= 256 || c == 258))
                : (c <= 260 || (c < 266
                  ? (c < 264
                    ? c == 262
                    : c <= 264)
                  : (c <= 266 || c == 268))))
              : (c <= 270 || (c < 280
                ? (c < 276
                  ? (c < 274
                    ? c == 272
                    : c <= 274)
                  : (c <= 276 || c == 278))
                : (c <= 280 || (c < 284
                  ? c == 282
                  : (c <= 284 || c == 286))))))
            : (c <= 288 || (c < 308
              ? (c < 298
                ? (c < 294
                  ? (c < 292
                    ? c == 290
                    : c <= 292)
                  : (c <= 294 || c == 296))
                : (c <= 298 || (c < 304
                  ? (c < 302
                    ? c == 300
                    : c <= 302)
                  : (c <= 304 || c == 306))))
              : (c <= 308 || (c < 319
                ? (c < 315
                  ? (c < 313
                    ? c == 310
                    : c <= 313)
                  : (c <= 315 || c == 317))
                : (c <= 319 || (c < 323
                  ? c == 321
                  : (c <= 323 || c == 325))))))))
          : (c <= 327 || (c < 366
            ? (c < 348
              ? (c < 338
                ? (c < 334
                  ? (c < 332
                    ? c == 330
                    : c <= 332)
                  : (c <= 334 || c == 336))
                : (c <= 338 || (c < 344
                  ? (c < 342
                    ? c == 340
                    : c <= 342)
                  : (c <= 344 || c == 346))))
              : (c <= 348 || (c < 358
                ? (c < 354
                  ? (c < 352
                    ? c == 350
                    : c <= 352)
                  : (c <= 354 || c == 356))
                : (c <= 358 || (c < 362
                  ? c == 360
                  : (c <= 362 || c == 364))))))
            : (c <= 366 || (c < 390
              ? (c < 376
                ? (c < 372
                  ? (c < 370
                    ? c == 368
                    : c <= 370)
                  : (c <= 372 || c == 374))
                : (c <= 377 || (c < 385
                  ? (c < 381
                    ? c == 379
                    : c <= 381)
                  : (c <= 386 || c == 388))))
              : (c <= 391 || (c < 412
                ? (c < 403
                  ? (c < 398
                    ? (c >= 393 && c <= 395)
                    : c <= 401)
                  : (c <= 404 || (c >= 406 && c <= 408)))
                : (c <= 413 || (c < 418
                  ? (c >= 415 && c <= 416)
                  : (c <= 418 || c == 420))))))))))
        : (c <= 423 || (c < 520
          ? (c < 478
            ? (c < 458
              ? (c < 437
                ? (c < 430
                  ? (c < 428
                    ? c == 425
                    : c <= 428)
                  : (c <= 431 || (c >= 433 && c <= 435)))
                : (c <= 437 || (c < 452
                  ? (c < 444
                    ? (c >= 439 && c <= 440)
                    : c <= 444)
                  : (c <= 452 || c == 455))))
              : (c <= 458 || (c < 469
                ? (c < 465
                  ? (c < 463
                    ? c == 461
                    : c <= 463)
                  : (c <= 465 || c == 467))
                : (c <= 469 || (c < 473
                  ? c == 471
                  : (c <= 473 || c == 475))))))
            : (c <= 478 || (c < 500
              ? (c < 488
                ? (c < 484
                  ? (c < 482
                    ? c == 480
                    : c <= 482)
                  : (c <= 484 || c == 486))
                : (c <= 488 || (c < 494
                  ? (c < 492
                    ? c == 490
                    : c <= 492)
                  : (c <= 494 || c == 497))))
              : (c <= 500 || (c < 512
                ? (c < 508
                  ? (c < 506
                    ? (c >= 502 && c <= 504)
                    : c <= 506)
                  : (c <= 508 || c == 510))
                : (c <= 512 || (c < 516
                  ? c == 514
                  : (c <= 516 || c == 518))))))))
          : (c <= 520 || (c < 558
            ? (c < 540
              ? (c < 530
                ? (c < 526
                  ? (c < 524
                    ? c == 522
                    : c <= 524)
                  : (c <= 526 || c == 528))
                : (c <= 530 || (c < 536
                  ? (c < 534
                    ? c == 532
                    : c <= 534)
                  : (c <= 536 || c == 538))))
              : (c <= 540 || (c < 550
                ? (c < 546
                  ? (c < 544
                    ? c == 542
                    : c <= 544)
                  : (c <= 546 || c == 548))
                : (c <= 550 || (c < 554
                  ? c == 552
                  : (c <= 554 || c == 556))))))
            : (c <= 558 || (c < 588
              ? (c < 577
                ? (c < 570
                  ? (c < 562
                    ? c == 560
                    : c <= 562)
                  : (c <= 571 || (c >= 573 && c <= 574)))
                : (c <= 577 || (c < 584
                  ? (c >= 579 && c <= 582)
                  : (c <= 584 || c == 586))))
              : (c <= 588 || (c < 895
                ? (c < 882
                  ? (c < 880
                    ? c == 590
                    : c <= 880)
                  : (c <= 882 || c == 886))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : (c <= 906 || c == 908))))))))))))
      : (c <= 911 || (c < 1240
        ? (c < 1162
          ? (c < 1017
            ? (c < 994
              ? (c < 984
                ? (c < 975
                  ? (c < 931
                    ? (c >= 913 && c <= 929)
                    : c <= 939)
                  : (c <= 975 || (c >= 978 && c <= 980)))
                : (c <= 984 || (c < 990
                  ? (c < 988
                    ? c == 986
                    : c <= 988)
                  : (c <= 990 || c == 992))))
              : (c <= 994 || (c < 1004
                ? (c < 1000
                  ? (c < 998
                    ? c == 996
                    : c <= 998)
                  : (c <= 1000 || c == 1002))
                : (c <= 1004 || (c < 1012
                  ? c == 1006
                  : (c <= 1012 || c == 1015))))))
            : (c <= 1018 || (c < 1136
              ? (c < 1126
                ? (c < 1122
                  ? (c < 1120
                    ? (c >= 1021 && c <= 1071)
                    : c <= 1120)
                  : (c <= 1122 || c == 1124))
                : (c <= 1126 || (c < 1132
                  ? (c < 1130
                    ? c == 1128
                    : c <= 1130)
                  : (c <= 1132 || c == 1134))))
              : (c <= 1136 || (c < 1146
                ? (c < 1142
                  ? (c < 1140
                    ? c == 1138
                    : c <= 1140)
                  : (c <= 1142 || c == 1144))
                : (c <= 1146 || (c < 1150
                  ? c == 1148
                  : (c <= 1150 || c == 1152))))))))
          : (c <= 1162 || (c < 1200
            ? (c < 1182
              ? (c < 1172
                ? (c < 1168
                  ? (c < 1166
                    ? c == 1164
                    : c <= 1166)
                  : (c <= 1168 || c == 1170))
                : (c <= 1172 || (c < 1178
                  ? (c < 1176
                    ? c == 1174
                    : c <= 1176)
                  : (c <= 1178 || c == 1180))))
              : (c <= 1182 || (c < 1192
                ? (c < 1188
                  ? (c < 1186
                    ? c == 1184
                    : c <= 1186)
                  : (c <= 1188 || c == 1190))
                : (c <= 1192 || (c < 1196
                  ? c == 1194
                  : (c <= 1196 || c == 1198))))))
            : (c <= 1200 || (c < 1221
              ? (c < 1210
                ? (c < 1206
                  ? (c < 1204
                    ? c == 1202
                    : c <= 1204)
                  : (c <= 1206 || c == 1208))
                : (c <= 1210 || (c < 1216
                  ? (c < 1214
                    ? c == 1212
                    : c <= 1214)
                  : (c <= 1217 || c == 1219))))
              : (c <= 1221 || (c < 1232
                ? (c < 1227
                  ? (c < 1225
                    ? c == 1223
                    : c <= 1225)
                  : (c <= 1227 || c == 1229))
                : (c <= 1232 || (c < 1236
                  ? c == 1234
                  : (c <= 1236 || c == 1238))))))))))
        : (c <= 1240 || (c < 1316
          ? (c < 1278
            ? (c < 1260
              ? (c < 1250
                ? (c < 1246
                  ? (c < 1244
                    ? c == 1242
                    : c <= 1244)
                  : (c <= 1246 || c == 1248))
                : (c <= 1250 || (c < 1256
                  ? (c < 1254
                    ? c == 1252
                    : c <= 1254)
                  : (c <= 1256 || c == 1258))))
              : (c <= 1260 || (c < 1270
                ? (c < 1266
                  ? (c < 1264
                    ? c == 1262
                    : c <= 1264)
                  : (c <= 1266 || c == 1268))
                : (c <= 1270 || (c < 1274
                  ? c == 1272
                  : (c <= 1274 || c == 1276))))))
            : (c <= 1278 || (c < 1298
              ? (c < 1288
                ? (c < 1284
                  ? (c < 1282
                    ? c == 1280
                    : c <= 1282)
                  : (c <= 1284 || c == 1286))
                : (c <= 1288 || (c < 1294
                  ? (c < 1292
                    ? c == 1290
                    : c <= 1292)
                  : (c <= 1294 || c == 1296))))
              : (c <= 1298 || (c < 1308
                ? (c < 1304
                  ? (c < 1302
                    ? c == 1300
                    : c <= 1302)
                  : (c <= 1304 || c == 1306))
                : (c <= 1308 || (c < 1312
                  ? c == 1310
                  : (c <= 1312 || c == 1314))))))))
          : (c <= 1316 || (c < 7692
            ? (c < 5024
              ? (c < 1326
                ? (c < 1322
                  ? (c < 1320
                    ? c == 1318
                    : c <= 1320)
                  : (c <= 1322 || c == 1324))
                : (c <= 1326 || (c < 4295
                  ? (c < 4256
                    ? (c >= 1329 && c <= 1366)
                    : c <= 4293)
                  : (c <= 4295 || c == 4301))))
              : (c <= 5109 || (c < 7684
                ? (c < 7680
                  ? (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)
                  : (c <= 7680 || c == 7682))
                : (c <= 7684 || (c < 7688
                  ? c == 7686
                  : (c <= 7688 || c == 7690))))))
            : (c <= 7692 || (c < 7710
              ? (c < 7702
                ? (c < 7698
                  ? (c < 7696
                    ? c == 7694
                    : c <= 7696)
                  : (c <= 7698 || c == 7700))
                : (c <= 7702 || (c < 7706
                  ? c == 7704
                  : (c <= 7706 || c == 7708))))
              : (c <= 7710 || (c < 7720
                ? (c < 7716
                  ? (c < 7714
                    ? c == 7712
                    : c <= 7714)
                  : (c <= 7716 || c == 7718))
                : (c <= 7720 || (c < 7724
                  ? c == 7722
                  : (c <= 7724 || c == 7726))))))))))))))
    : (c <= 7728 || (c < 11432
      ? (c < 7888
        ? (c < 7804
          ? (c < 7766
            ? (c < 7748
              ? (c < 7738
                ? (c < 7734
                  ? (c < 7732
                    ? c == 7730
                    : c <= 7732)
                  : (c <= 7734 || c == 7736))
                : (c <= 7738 || (c < 7744
                  ? (c < 7742
                    ? c == 7740
                    : c <= 7742)
                  : (c <= 7744 || c == 7746))))
              : (c <= 7748 || (c < 7758
                ? (c < 7754
                  ? (c < 7752
                    ? c == 7750
                    : c <= 7752)
                  : (c <= 7754 || c == 7756))
                : (c <= 7758 || (c < 7762
                  ? c == 7760
                  : (c <= 7762 || c == 7764))))))
            : (c <= 7766 || (c < 7786
              ? (c < 7776
                ? (c < 7772
                  ? (c < 7770
                    ? c == 7768
                    : c <= 7770)
                  : (c <= 7772 || c == 7774))
                : (c <= 7776 || (c < 7782
                  ? (c < 7780
                    ? c == 7778
                    : c <= 7780)
                  : (c <= 7782 || c == 7784))))
              : (c <= 7786 || (c < 7796
                ? (c < 7792
                  ? (c < 7790
                    ? c == 7788
                    : c <= 7790)
                  : (c <= 7792 || c == 7794))
                : (c <= 7796 || (c < 7800
                  ? c == 7798
                  : (c <= 7800 || c == 7802))))))))
          : (c <= 7804 || (c < 7850
            ? (c < 7824
              ? (c < 7814
                ? (c < 7810
                  ? (c < 7808
                    ? c == 7806
                    : c <= 7808)
                  : (c <= 7810 || c == 7812))
                : (c <= 7814 || (c < 7820
                  ? (c < 7818
                    ? c == 7816
                    : c <= 7818)
                  : (c <= 7820 || c == 7822))))
              : (c <= 7824 || (c < 7842
                ? (c < 7838
                  ? (c < 7828
                    ? c == 7826
                    : c <= 7828)
                  : (c <= 7838 || c == 7840))
                : (c <= 7842 || (c < 7846
                  ? c == 7844
                  : (c <= 7846 || c == 7848))))))
            : (c <= 7850 || (c < 7870
              ? (c < 7860
                ? (c < 7856
                  ? (c < 7854
                    ? c == 7852
                    : c <= 7854)
                  : (c <= 7856 || c == 7858))
                : (c <= 7860 || (c < 7866
                  ? (c < 7864
                    ? c == 7862
                    : c <= 7864)
                  : (c <= 7866 || c == 7868))))
              : (c <= 7870 || (c < 7880
                ? (c < 7876
                  ? (c < 7874
                    ? c == 7872
                    : c <= 7874)
                  : (c <= 7876 || c == 7878))
                : (c <= 7880 || (c < 7884
                  ? c == 7882
                  : (c <= 7884 || c == 7886))))))))))
        : (c <= 7888 || (c < 8184
          ? (c < 7926
            ? (c < 7908
              ? (c < 7898
                ? (c < 7894
                  ? (c < 7892
                    ? c == 7890
                    : c <= 7892)
                  : (c <= 7894 || c == 7896))
                : (c <= 7898 || (c < 7904
                  ? (c < 7902
                    ? c == 7900
                    : c <= 7902)
                  : (c <= 7904 || c == 7906))))
              : (c <= 7908 || (c < 7918
                ? (c < 7914
                  ? (c < 7912
                    ? c == 7910
                    : c <= 7912)
                  : (c <= 7914 || c == 7916))
                : (c <= 7918 || (c < 7922
                  ? c == 7920
                  : (c <= 7922 || c == 7924))))))
            : (c <= 7926 || (c < 8025
              ? (c < 7944
                ? (c < 7932
                  ? (c < 7930
                    ? c == 7928
                    : c <= 7930)
                  : (c <= 7932 || c == 7934))
                : (c <= 7951 || (c < 7992
                  ? (c < 7976
                    ? (c >= 7960 && c <= 7965)
                    : c <= 7983)
                  : (c <= 7999 || (c >= 8008 && c <= 8013)))))
              : (c <= 8025 || (c < 8120
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8031 || (c >= 8040 && c <= 8047)))
                : (c <= 8123 || (c < 8152
                  ? (c >= 8136 && c <= 8139)
                  : (c <= 8155 || (c >= 8168 && c <= 8172)))))))))
          : (c <= 8187 || (c < 11396
            ? (c < 11362
              ? (c < 8496
                ? (c < 8464
                  ? (c < 8459
                    ? (c >= 8450 && c <= 8455)
                    : c <= 8461)
                  : (c <= 8466 || (c >= 8469 && c <= 8493)))
                : (c <= 8499 || (c < 11264
                  ? (c < 8579
                    ? (c >= 8510 && c <= 8517)
                    : c <= 8579)
                  : (c <= 11311 || c == 11360))))
              : (c <= 11364 || (c < 11378
                ? (c < 11371
                  ? (c < 11369
                    ? c == 11367
                    : c <= 11369)
                  : (c <= 11371 || (c >= 11373 && c <= 11376)))
                : (c <= 11378 || (c < 11390
                  ? c == 11381
                  : (c <= 11392 || c == 11394))))))
            : (c <= 11396 || (c < 11414
              ? (c < 11406
                ? (c < 11402
                  ? (c < 11400
                    ? c == 11398
                    : c <= 11400)
                  : (c <= 11402 || c == 11404))
                : (c <= 11406 || (c < 11410
                  ? c == 11408
                  : (c <= 11410 || c == 11412))))
              : (c <= 11414 || (c < 11424
                ? (c < 11420
                  ? (c < 11418
                    ? c == 11416
                    : c <= 11418)
                  : (c <= 11420 || c == 11422))
                : (c <= 11424 || (c < 11428
                  ? c == 11426
                  : (c <= 11428 || c == 11430))))))))))))
      : (c <= 11432 || (c < 42798
        ? (c < 42570
          ? (c < 11470
            ? (c < 11452
              ? (c < 11442
                ? (c < 11438
                  ? (c < 11436
                    ? c == 11434
                    : c <= 11436)
                  : (c <= 11438 || c == 11440))
                : (c <= 11442 || (c < 11448
                  ? (c < 11446
                    ? c == 11444
                    : c <= 11446)
                  : (c <= 11448 || c == 11450))))
              : (c <= 11452 || (c < 11462
                ? (c < 11458
                  ? (c < 11456
                    ? c == 11454
                    : c <= 11456)
                  : (c <= 11458 || c == 11460))
                : (c <= 11462 || (c < 11466
                  ? c == 11464
                  : (c <= 11466 || c == 11468))))))
            : (c <= 11470 || (c < 11490
              ? (c < 11480
                ? (c < 11476
                  ? (c < 11474
                    ? c == 11472
                    : c <= 11474)
                  : (c <= 11476 || c == 11478))
                : (c <= 11480 || (c < 11486
                  ? (c < 11484
                    ? c == 11482
                    : c <= 11484)
                  : (c <= 11486 || c == 11488))))
              : (c <= 11490 || (c < 42562
                ? (c < 11506
                  ? (c < 11501
                    ? c == 11499
                    : c <= 11501)
                  : (c <= 11506 || c == 42560))
                : (c <= 42562 || (c < 42566
                  ? c == 42564
                  : (c <= 42566 || c == 42568))))))))
          : (c <= 42570 || (c < 42626
            ? (c < 42590
              ? (c < 42580
                ? (c < 42576
                  ? (c < 42574
                    ? c == 42572
                    : c <= 42574)
                  : (c <= 42576 || c == 42578))
                : (c <= 42580 || (c < 42586
                  ? (c < 42584
                    ? c == 42582
                    : c <= 42584)
                  : (c <= 42586 || c == 42588))))
              : (c <= 42590 || (c < 42600
                ? (c < 42596
                  ? (c < 42594
                    ? c == 42592
                    : c <= 42594)
                  : (c <= 42596 || c == 42598))
                : (c <= 42600 || (c < 42604
                  ? c == 42602
                  : (c <= 42604 || c == 42624))))))
            : (c <= 42626 || (c < 42646
              ? (c < 42636
                ? (c < 42632
                  ? (c < 42630
                    ? c == 42628
                    : c <= 42630)
                  : (c <= 42632 || c == 42634))
                : (c <= 42636 || (c < 42642
                  ? (c < 42640
                    ? c == 42638
                    : c <= 42640)
                  : (c <= 42642 || c == 42644))))
              : (c <= 42646 || (c < 42790
                ? (c < 42786
                  ? (c < 42650
                    ? c == 42648
                    : c <= 42650)
                  : (c <= 42786 || c == 42788))
                : (c <= 42790 || (c < 42794
                  ? c == 42792
                  : (c <= 42794 || c == 42796))))))))))
        : (c <= 42798 || (c < 42886
          ? (c < 42838
            ? (c < 42820
              ? (c < 42810
                ? (c < 42806
                  ? (c < 42804
                    ? c == 42802
                    : c <= 42804)
                  : (c <= 42806 || c == 42808))
                : (c <= 42810 || (c < 42816
                  ? (c < 42814
                    ? c == 42812
                    : c <= 42814)
                  : (c <= 42816 || c == 42818))))
              : (c <= 42820 || (c < 42830
                ? (c < 42826
                  ? (c < 42824
                    ? c == 42822
                    : c <= 42824)
                  : (c <= 42826 || c == 42828))
                : (c <= 42830 || (c < 42834
                  ? c == 42832
                  : (c <= 42834 || c == 42836))))))
            : (c <= 42838 || (c < 42858
              ? (c < 42848
                ? (c < 42844
                  ? (c < 42842
                    ? c == 42840
                    : c <= 42842)
                  : (c <= 42844 || c == 42846))
                : (c <= 42848 || (c < 42854
                  ? (c < 42852
                    ? c == 42850
                    : c <= 42852)
                  : (c <= 42854 || c == 42856))))
              : (c <= 42858 || (c < 42877
                ? (c < 42873
                  ? (c < 42862
                    ? c == 42860
                    : c <= 42862)
                  : (c <= 42873 || c == 42875))
                : (c <= 42878 || (c < 42882
                  ? c == 42880
                  : (c <= 42882 || c == 42884))))))))
          : (c <= 42886 || (c < 42938
            ? (c < 42912
              ? (c < 42902
                ? (c < 42896
                  ? (c < 42893
                    ? c == 42891
                    : c <= 42893)
                  : (c <= 42896 || c == 42898))
                : (c <= 42902 || (c < 42908
                  ? (c < 42906
                    ? c == 42904
                    : c <= 42906)
                  : (c <= 42908 || c == 42910))))
              : (c <= 42912 || (c < 42922
                ? (c < 42918
                  ? (c < 42916
                    ? c == 42914
                    : c <= 42916)
                  : (c <= 42918 || c == 42920))
                : (c <= 42926 || (c < 42934
                  ? (c >= 42928 && c <= 42932)
                  : (c <= 42934 || c == 42936))))))
            : (c <= 42938 || (c < 42968
              ? (c < 42948
                ? (c < 42944
                  ? (c < 42942
                    ? c == 42940
                    : c <= 42942)
                  : (c <= 42944 || c == 42946))
                : (c <= 42951 || (c < 42960
                  ? c == 42953
                  : (c <= 42960 || c == 42966))))
              : (c <= 42968 || (c < 66928
                ? (c < 66560
                  ? (c < 65313
                    ? c == 42997
                    : c <= 65338)
                  : (c <= 66599 || (c >= 66736 && c <= 66771)))
                : (c <= 66938 || (c < 66956
                  ? (c >= 66940 && c <= 66954)
                  : (c <= 66962 || (c >= 66964 && c <= 66965)))))))))))))))));
}

static inline bool sym__conid_character_set_3(int32_t c) {
  return (c < 7728
    ? (c < 910
      ? (c < 420
        ? (c < 325
          ? (c < 286
            ? (c < 268
              ? (c < 258
                ? (c < 192
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 222 || c == 256))
                : (c <= 258 || (c < 264
                  ? (c < 262
                    ? c == 260
                    : c <= 262)
                  : (c <= 264 || c == 266))))
              : (c <= 268 || (c < 278
                ? (c < 274
                  ? (c < 272
                    ? c == 270
                    : c <= 272)
                  : (c <= 274 || c == 276))
                : (c <= 278 || (c < 282
                  ? c == 280
                  : (c <= 282 || c == 284))))))
            : (c <= 286 || (c < 306
              ? (c < 296
                ? (c < 292
                  ? (c < 290
                    ? c == 288
                    : c <= 290)
                  : (c <= 292 || c == 294))
                : (c <= 296 || (c < 302
                  ? (c < 300
                    ? c == 298
                    : c <= 300)
                  : (c <= 302 || c == 304))))
              : (c <= 306 || (c < 317
                ? (c < 313
                  ? (c < 310
                    ? c == 308
                    : c <= 310)
                  : (c <= 313 || c == 315))
                : (c <= 317 || (c < 321
                  ? c == 319
                  : (c <= 321 || c == 323))))))))
          : (c <= 325 || (c < 364
            ? (c < 346
              ? (c < 336
                ? (c < 332
                  ? (c < 330
                    ? c == 327
                    : c <= 330)
                  : (c <= 332 || c == 334))
                : (c <= 336 || (c < 342
                  ? (c < 340
                    ? c == 338
                    : c <= 340)
                  : (c <= 342 || c == 344))))
              : (c <= 346 || (c < 356
                ? (c < 352
                  ? (c < 350
                    ? c == 348
                    : c <= 350)
                  : (c <= 352 || c == 354))
                : (c <= 356 || (c < 360
                  ? c == 358
                  : (c <= 360 || c == 362))))))
            : (c <= 364 || (c < 388
              ? (c < 374
                ? (c < 370
                  ? (c < 368
                    ? c == 366
                    : c <= 368)
                  : (c <= 370 || c == 372))
                : (c <= 374 || (c < 381
                  ? (c < 379
                    ? (c >= 376 && c <= 377)
                    : c <= 379)
                  : (c <= 381 || (c >= 385 && c <= 386)))))
              : (c <= 388 || (c < 406
                ? (c < 398
                  ? (c < 393
                    ? (c >= 390 && c <= 391)
                    : c <= 395)
                  : (c <= 401 || (c >= 403 && c <= 404)))
                : (c <= 408 || (c < 415
                  ? (c >= 412 && c <= 413)
                  : (c <= 416 || c == 418))))))))))
        : (c <= 420 || (c < 518
          ? (c < 475
            ? (c < 455
              ? (c < 433
                ? (c < 428
                  ? (c < 425
                    ? (c >= 422 && c <= 423)
                    : c <= 425)
                  : (c <= 428 || (c >= 430 && c <= 431)))
                : (c <= 435 || (c < 444
                  ? (c < 439
                    ? c == 437
                    : c <= 440)
                  : (c <= 444 || c == 452))))
              : (c <= 455 || (c < 467
                ? (c < 463
                  ? (c < 461
                    ? c == 458
                    : c <= 461)
                  : (c <= 463 || c == 465))
                : (c <= 467 || (c < 471
                  ? c == 469
                  : (c <= 471 || c == 473))))))
            : (c <= 475 || (c < 497
              ? (c < 486
                ? (c < 482
                  ? (c < 480
                    ? c == 478
                    : c <= 480)
                  : (c <= 482 || c == 484))
                : (c <= 486 || (c < 492
                  ? (c < 490
                    ? c == 488
                    : c <= 490)
                  : (c <= 492 || c == 494))))
              : (c <= 497 || (c < 510
                ? (c < 506
                  ? (c < 502
                    ? c == 500
                    : c <= 504)
                  : (c <= 506 || c == 508))
                : (c <= 510 || (c < 514
                  ? c == 512
                  : (c <= 514 || c == 516))))))))
          : (c <= 518 || (c < 556
            ? (c < 538
              ? (c < 528
                ? (c < 524
                  ? (c < 522
                    ? c == 520
                    : c <= 522)
                  : (c <= 524 || c == 526))
                : (c <= 528 || (c < 534
                  ? (c < 532
                    ? c == 530
                    : c <= 532)
                  : (c <= 534 || c == 536))))
              : (c <= 538 || (c < 548
                ? (c < 544
                  ? (c < 542
                    ? c == 540
                    : c <= 542)
                  : (c <= 544 || c == 546))
                : (c <= 548 || (c < 552
                  ? c == 550
                  : (c <= 552 || c == 554))))))
            : (c <= 556 || (c < 588
              ? (c < 573
                ? (c < 562
                  ? (c < 560
                    ? c == 558
                    : c <= 560)
                  : (c <= 562 || (c >= 570 && c <= 571)))
                : (c <= 574 || (c < 584
                  ? (c < 579
                    ? c == 577
                    : c <= 582)
                  : (c <= 584 || c == 586))))
              : (c <= 588 || (c < 895
                ? (c < 882
                  ? (c < 880
                    ? c == 590
                    : c <= 880)
                  : (c <= 882 || c == 886))
                : (c <= 895 || (c < 904
                  ? c == 902
                  : (c <= 906 || c == 908))))))))))))
      : (c <= 911 || (c < 1240
        ? (c < 1162
          ? (c < 1017
            ? (c < 994
              ? (c < 984
                ? (c < 975
                  ? (c < 931
                    ? (c >= 913 && c <= 929)
                    : c <= 939)
                  : (c <= 975 || (c >= 978 && c <= 980)))
                : (c <= 984 || (c < 990
                  ? (c < 988
                    ? c == 986
                    : c <= 988)
                  : (c <= 990 || c == 992))))
              : (c <= 994 || (c < 1004
                ? (c < 1000
                  ? (c < 998
                    ? c == 996
                    : c <= 998)
                  : (c <= 1000 || c == 1002))
                : (c <= 1004 || (c < 1012
                  ? c == 1006
                  : (c <= 1012 || c == 1015))))))
            : (c <= 1018 || (c < 1136
              ? (c < 1126
                ? (c < 1122
                  ? (c < 1120
                    ? (c >= 1021 && c <= 1071)
                    : c <= 1120)
                  : (c <= 1122 || c == 1124))
                : (c <= 1126 || (c < 1132
                  ? (c < 1130
                    ? c == 1128
                    : c <= 1130)
                  : (c <= 1132 || c == 1134))))
              : (c <= 1136 || (c < 1146
                ? (c < 1142
                  ? (c < 1140
                    ? c == 1138
                    : c <= 1140)
                  : (c <= 1142 || c == 1144))
                : (c <= 1146 || (c < 1150
                  ? c == 1148
                  : (c <= 1150 || c == 1152))))))))
          : (c <= 1162 || (c < 1200
            ? (c < 1182
              ? (c < 1172
                ? (c < 1168
                  ? (c < 1166
                    ? c == 1164
                    : c <= 1166)
                  : (c <= 1168 || c == 1170))
                : (c <= 1172 || (c < 1178
                  ? (c < 1176
                    ? c == 1174
                    : c <= 1176)
                  : (c <= 1178 || c == 1180))))
              : (c <= 1182 || (c < 1192
                ? (c < 1188
                  ? (c < 1186
                    ? c == 1184
                    : c <= 1186)
                  : (c <= 1188 || c == 1190))
                : (c <= 1192 || (c < 1196
                  ? c == 1194
                  : (c <= 1196 || c == 1198))))))
            : (c <= 1200 || (c < 1221
              ? (c < 1210
                ? (c < 1206
                  ? (c < 1204
                    ? c == 1202
                    : c <= 1204)
                  : (c <= 1206 || c == 1208))
                : (c <= 1210 || (c < 1216
                  ? (c < 1214
                    ? c == 1212
                    : c <= 1214)
                  : (c <= 1217 || c == 1219))))
              : (c <= 1221 || (c < 1232
                ? (c < 1227
                  ? (c < 1225
                    ? c == 1223
                    : c <= 1225)
                  : (c <= 1227 || c == 1229))
                : (c <= 1232 || (c < 1236
                  ? c == 1234
                  : (c <= 1236 || c == 1238))))))))))
        : (c <= 1240 || (c < 1316
          ? (c < 1278
            ? (c < 1260
              ? (c < 1250
                ? (c < 1246
                  ? (c < 1244
                    ? c == 1242
                    : c <= 1244)
                  : (c <= 1246 || c == 1248))
                : (c <= 1250 || (c < 1256
                  ? (c < 1254
                    ? c == 1252
                    : c <= 1254)
                  : (c <= 1256 || c == 1258))))
              : (c <= 1260 || (c < 1270
                ? (c < 1266
                  ? (c < 1264
                    ? c == 1262
                    : c <= 1264)
                  : (c <= 1266 || c == 1268))
                : (c <= 1270 || (c < 1274
                  ? c == 1272
                  : (c <= 1274 || c == 1276))))))
            : (c <= 1278 || (c < 1298
              ? (c < 1288
                ? (c < 1284
                  ? (c < 1282
                    ? c == 1280
                    : c <= 1282)
                  : (c <= 1284 || c == 1286))
                : (c <= 1288 || (c < 1294
                  ? (c < 1292
                    ? c == 1290
                    : c <= 1292)
                  : (c <= 1294 || c == 1296))))
              : (c <= 1298 || (c < 1308
                ? (c < 1304
                  ? (c < 1302
                    ? c == 1300
                    : c <= 1302)
                  : (c <= 1304 || c == 1306))
                : (c <= 1308 || (c < 1312
                  ? c == 1310
                  : (c <= 1312 || c == 1314))))))))
          : (c <= 1316 || (c < 7692
            ? (c < 5024
              ? (c < 1326
                ? (c < 1322
                  ? (c < 1320
                    ? c == 1318
                    : c <= 1320)
                  : (c <= 1322 || c == 1324))
                : (c <= 1326 || (c < 4295
                  ? (c < 4256
                    ? (c >= 1329 && c <= 1366)
                    : c <= 4293)
                  : (c <= 4295 || c == 4301))))
              : (c <= 5109 || (c < 7684
                ? (c < 7680
                  ? (c < 7357
                    ? (c >= 7312 && c <= 7354)
                    : c <= 7359)
                  : (c <= 7680 || c == 7682))
                : (c <= 7684 || (c < 7688
                  ? c == 7686
                  : (c <= 7688 || c == 7690))))))
            : (c <= 7692 || (c < 7710
              ? (c < 7702
                ? (c < 7698
                  ? (c < 7696
                    ? c == 7694
                    : c <= 7696)
                  : (c <= 7698 || c == 7700))
                : (c <= 7702 || (c < 7706
                  ? c == 7704
                  : (c <= 7706 || c == 7708))))
              : (c <= 7710 || (c < 7720
                ? (c < 7716
                  ? (c < 7714
                    ? c == 7712
                    : c <= 7714)
                  : (c <= 7716 || c == 7718))
                : (c <= 7720 || (c < 7724
                  ? c == 7722
                  : (c <= 7724 || c == 7726))))))))))))))
    : (c <= 7728 || (c < 11432
      ? (c < 7888
        ? (c < 7804
          ? (c < 7766
            ? (c < 7748
              ? (c < 7738
                ? (c < 7734
                  ? (c < 7732
                    ? c == 7730
                    : c <= 7732)
                  : (c <= 7734 || c == 7736))
                : (c <= 7738 || (c < 7744
                  ? (c < 7742
                    ? c == 7740
                    : c <= 7742)
                  : (c <= 7744 || c == 7746))))
              : (c <= 7748 || (c < 7758
                ? (c < 7754
                  ? (c < 7752
                    ? c == 7750
                    : c <= 7752)
                  : (c <= 7754 || c == 7756))
                : (c <= 7758 || (c < 7762
                  ? c == 7760
                  : (c <= 7762 || c == 7764))))))
            : (c <= 7766 || (c < 7786
              ? (c < 7776
                ? (c < 7772
                  ? (c < 7770
                    ? c == 7768
                    : c <= 7770)
                  : (c <= 7772 || c == 7774))
                : (c <= 7776 || (c < 7782
                  ? (c < 7780
                    ? c == 7778
                    : c <= 7780)
                  : (c <= 7782 || c == 7784))))
              : (c <= 7786 || (c < 7796
                ? (c < 7792
                  ? (c < 7790
                    ? c == 7788
                    : c <= 7790)
                  : (c <= 7792 || c == 7794))
                : (c <= 7796 || (c < 7800
                  ? c == 7798
                  : (c <= 7800 || c == 7802))))))))
          : (c <= 7804 || (c < 7850
            ? (c < 7824
              ? (c < 7814
                ? (c < 7810
                  ? (c < 7808
                    ? c == 7806
                    : c <= 7808)
                  : (c <= 7810 || c == 7812))
                : (c <= 7814 || (c < 7820
                  ? (c < 7818
                    ? c == 7816
                    : c <= 7818)
                  : (c <= 7820 || c == 7822))))
              : (c <= 7824 || (c < 7842
                ? (c < 7838
                  ? (c < 7828
                    ? c == 7826
                    : c <= 7828)
                  : (c <= 7838 || c == 7840))
                : (c <= 7842 || (c < 7846
                  ? c == 7844
                  : (c <= 7846 || c == 7848))))))
            : (c <= 7850 || (c < 7870
              ? (c < 7860
                ? (c < 7856
                  ? (c < 7854
                    ? c == 7852
                    : c <= 7854)
                  : (c <= 7856 || c == 7858))
                : (c <= 7860 || (c < 7866
                  ? (c < 7864
                    ? c == 7862
                    : c <= 7864)
                  : (c <= 7866 || c == 7868))))
              : (c <= 7870 || (c < 7880
                ? (c < 7876
                  ? (c < 7874
                    ? c == 7872
                    : c <= 7874)
                  : (c <= 7876 || c == 7878))
                : (c <= 7880 || (c < 7884
                  ? c == 7882
                  : (c <= 7884 || c == 7886))))))))))
        : (c <= 7888 || (c < 8184
          ? (c < 7926
            ? (c < 7908
              ? (c < 7898
                ? (c < 7894
                  ? (c < 7892
                    ? c == 7890
                    : c <= 7892)
                  : (c <= 7894 || c == 7896))
                : (c <= 7898 || (c < 7904
                  ? (c < 7902
                    ? c == 7900
                    : c <= 7902)
                  : (c <= 7904 || c == 7906))))
              : (c <= 7908 || (c < 7918
                ? (c < 7914
                  ? (c < 7912
                    ? c == 7910
                    : c <= 7912)
                  : (c <= 7914 || c == 7916))
                : (c <= 7918 || (c < 7922
                  ? c == 7920
                  : (c <= 7922 || c == 7924))))))
            : (c <= 7926 || (c < 8025
              ? (c < 7944
                ? (c < 7932
                  ? (c < 7930
                    ? c == 7928
                    : c <= 7930)
                  : (c <= 7932 || c == 7934))
                : (c <= 7951 || (c < 7992
                  ? (c < 7976
                    ? (c >= 7960 && c <= 7965)
                    : c <= 7983)
                  : (c <= 7999 || (c >= 8008 && c <= 8013)))))
              : (c <= 8025 || (c < 8120
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8031 || (c >= 8040 && c <= 8047)))
                : (c <= 8123 || (c < 8152
                  ? (c >= 8136 && c <= 8139)
                  : (c <= 8155 || (c >= 8168 && c <= 8172)))))))))
          : (c <= 8187 || (c < 11396
            ? (c < 11362
              ? (c < 8496
                ? (c < 8464
                  ? (c < 8459
                    ? (c >= 8450 && c <= 8455)
                    : c <= 8461)
                  : (c <= 8466 || (c >= 8469 && c <= 8493)))
                : (c <= 8499 || (c < 11264
                  ? (c < 8579
                    ? (c >= 8510 && c <= 8517)
                    : c <= 8579)
                  : (c <= 11311 || c == 11360))))
              : (c <= 11364 || (c < 11378
                ? (c < 11371
                  ? (c < 11369
                    ? c == 11367
                    : c <= 11369)
                  : (c <= 11371 || (c >= 11373 && c <= 11376)))
                : (c <= 11378 || (c < 11390
                  ? c == 11381
                  : (c <= 11392 || c == 11394))))))
            : (c <= 11396 || (c < 11414
              ? (c < 11406
                ? (c < 11402
                  ? (c < 11400
                    ? c == 11398
                    : c <= 11400)
                  : (c <= 11402 || c == 11404))
                : (c <= 11406 || (c < 11410
                  ? c == 11408
                  : (c <= 11410 || c == 11412))))
              : (c <= 11414 || (c < 11424
                ? (c < 11420
                  ? (c < 11418
                    ? c == 11416
                    : c <= 11418)
                  : (c <= 11420 || c == 11422))
                : (c <= 11424 || (c < 11428
                  ? c == 11426
                  : (c <= 11428 || c == 11430))))))))))))
      : (c <= 11432 || (c < 42798
        ? (c < 42570
          ? (c < 11470
            ? (c < 11452
              ? (c < 11442
                ? (c < 11438
                  ? (c < 11436
                    ? c == 11434
                    : c <= 11436)
                  : (c <= 11438 || c == 11440))
                : (c <= 11442 || (c < 11448
                  ? (c < 11446
                    ? c == 11444
                    : c <= 11446)
                  : (c <= 11448 || c == 11450))))
              : (c <= 11452 || (c < 11462
                ? (c < 11458
                  ? (c < 11456
                    ? c == 11454
                    : c <= 11456)
                  : (c <= 11458 || c == 11460))
                : (c <= 11462 || (c < 11466
                  ? c == 11464
                  : (c <= 11466 || c == 11468))))))
            : (c <= 11470 || (c < 11490
              ? (c < 11480
                ? (c < 11476
                  ? (c < 11474
                    ? c == 11472
                    : c <= 11474)
                  : (c <= 11476 || c == 11478))
                : (c <= 11480 || (c < 11486
                  ? (c < 11484
                    ? c == 11482
                    : c <= 11484)
                  : (c <= 11486 || c == 11488))))
              : (c <= 11490 || (c < 42562
                ? (c < 11506
                  ? (c < 11501
                    ? c == 11499
                    : c <= 11501)
                  : (c <= 11506 || c == 42560))
                : (c <= 42562 || (c < 42566
                  ? c == 42564
                  : (c <= 42566 || c == 42568))))))))
          : (c <= 42570 || (c < 42626
            ? (c < 42590
              ? (c < 42580
                ? (c < 42576
                  ? (c < 42574
                    ? c == 42572
                    : c <= 42574)
                  : (c <= 42576 || c == 42578))
                : (c <= 42580 || (c < 42586
                  ? (c < 42584
                    ? c == 42582
                    : c <= 42584)
                  : (c <= 42586 || c == 42588))))
              : (c <= 42590 || (c < 42600
                ? (c < 42596
                  ? (c < 42594
                    ? c == 42592
                    : c <= 42594)
                  : (c <= 42596 || c == 42598))
                : (c <= 42600 || (c < 42604
                  ? c == 42602
                  : (c <= 42604 || c == 42624))))))
            : (c <= 42626 || (c < 42646
              ? (c < 42636
                ? (c < 42632
                  ? (c < 42630
                    ? c == 42628
                    : c <= 42630)
                  : (c <= 42632 || c == 42634))
                : (c <= 42636 || (c < 42642
                  ? (c < 42640
                    ? c == 42638
                    : c <= 42640)
                  : (c <= 42642 || c == 42644))))
              : (c <= 42646 || (c < 42790
                ? (c < 42786
                  ? (c < 42650
                    ? c == 42648
                    : c <= 42650)
                  : (c <= 42786 || c == 42788))
                : (c <= 42790 || (c < 42794
                  ? c == 42792
                  : (c <= 42794 || c == 42796))))))))))
        : (c <= 42798 || (c < 42886
          ? (c < 42838
            ? (c < 42820
              ? (c < 42810
                ? (c < 42806
                  ? (c < 42804
                    ? c == 42802
                    : c <= 42804)
                  : (c <= 42806 || c == 42808))
                : (c <= 42810 || (c < 42816
                  ? (c < 42814
                    ? c == 42812
                    : c <= 42814)
                  : (c <= 42816 || c == 42818))))
              : (c <= 42820 || (c < 42830
                ? (c < 42826
                  ? (c < 42824
                    ? c == 42822
                    : c <= 42824)
                  : (c <= 42826 || c == 42828))
                : (c <= 42830 || (c < 42834
                  ? c == 42832
                  : (c <= 42834 || c == 42836))))))
            : (c <= 42838 || (c < 42858
              ? (c < 42848
                ? (c < 42844
                  ? (c < 42842
                    ? c == 42840
                    : c <= 42842)
                  : (c <= 42844 || c == 42846))
                : (c <= 42848 || (c < 42854
                  ? (c < 42852
                    ? c == 42850
                    : c <= 42852)
                  : (c <= 42854 || c == 42856))))
              : (c <= 42858 || (c < 42877
                ? (c < 42873
                  ? (c < 42862
                    ? c == 42860
                    : c <= 42862)
                  : (c <= 42873 || c == 42875))
                : (c <= 42878 || (c < 42882
                  ? c == 42880
                  : (c <= 42882 || c == 42884))))))))
          : (c <= 42886 || (c < 42938
            ? (c < 42912
              ? (c < 42902
                ? (c < 42896
                  ? (c < 42893
                    ? c == 42891
                    : c <= 42893)
                  : (c <= 42896 || c == 42898))
                : (c <= 42902 || (c < 42908
                  ? (c < 42906
                    ? c == 42904
                    : c <= 42906)
                  : (c <= 42908 || c == 42910))))
              : (c <= 42912 || (c < 42922
                ? (c < 42918
                  ? (c < 42916
                    ? c == 42914
                    : c <= 42916)
                  : (c <= 42918 || c == 42920))
                : (c <= 42926 || (c < 42934
                  ? (c >= 42928 && c <= 42932)
                  : (c <= 42934 || c == 42936))))))
            : (c <= 42938 || (c < 42968
              ? (c < 42948
                ? (c < 42944
                  ? (c < 42942
                    ? c == 42940
                    : c <= 42942)
                  : (c <= 42944 || c == 42946))
                : (c <= 42951 || (c < 42960
                  ? c == 42953
                  : (c <= 42960 || c == 42966))))
              : (c <= 42968 || (c < 66928
                ? (c < 66560
                  ? (c < 65313
                    ? c == 42997
                    : c <= 65338)
                  : (c <= 66599 || (c >= 66736 && c <= 66771)))
                : (c <= 66938 || (c < 66956
                  ? (c >= 66940 && c <= 66954)
                  : (c <= 66962 || (c >= 66964 && c <= 66965)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(180)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(289);
      if (lookahead == '.') ADVANCE(250);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(300);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(140);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(179);
      if (lookahead == '@') ADVANCE(328);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(326);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(314);
      if (lookahead == 'c') ADVANCE(265);
      if (lookahead == 'd') ADVANCE(252);
      if (lookahead == 'e') ADVANCE(264);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == 'n') ADVANCE(255);
      if (lookahead == 'o') ADVANCE(261);
      if (lookahead == 'r') ADVANCE(269);
      if (lookahead == 't') ADVANCE(262);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(295);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8592) ADVANCE(240);
      if (lookahead == 8594) ADVANCE(236);
      if (lookahead == 8656) ADVANCE(232);
      if (lookahead == 8658) ADVANCE(228);
      if (lookahead == 8704) ADVANCE(306);
      if (lookahead == 8759) ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(1)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(288);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(299);
      if (lookahead == '<') ADVANCE(143);
      if (lookahead == '=') ADVANCE(145);
      if (lookahead == '?') ADVANCE(179);
      if (lookahead == '@') ADVANCE(304);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(326);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8656) ADVANCE(232);
      if (lookahead == 8658) ADVANCE(228);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(3)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_1(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(3)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_2(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(5)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_3(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(5)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_4(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(7)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_3(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(7)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_4(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(9)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_3(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 9:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(9)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_4(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 10:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(11)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'o') ADVANCE(261);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_3(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 11:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(11)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'o') ADVANCE(261);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_4(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 12:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(13)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 't') ADVANCE(263);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_3(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 13:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(13)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 't') ADVANCE(263);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_4(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 14:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(15)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'e') ADVANCE(264);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_3(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 15:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(15)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'e') ADVANCE(264);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_4(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 16:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(17)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_5(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 17:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(17)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_6(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 18:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(18)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_6(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 19:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(20)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_7(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 20:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(20)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_8(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 21:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(21)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8704) ADVANCE(307);
      if (sym__operator_character_set_9(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 22:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(23)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_10(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 23:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(23)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_11(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 24:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(24)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_12(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 25:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(26)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_13(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 26:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(26)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_14(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 27:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(28)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_15(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 28:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(28)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_16(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 29:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(30)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_17(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 30:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(30)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_18(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 31:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(31)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_19(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 32:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(33)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_20(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 33:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(33)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_21(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 34:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(34)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_19(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 35:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(36)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_22(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 36:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(36)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_23(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 37:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(38)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (sym__operator_character_set_15(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 38:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(38)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (sym__operator_character_set_16(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 39:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(39)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'o') ADVANCE(261);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_19(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 40:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(40)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_19(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 41:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(41)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (sym__operator_character_set_24(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 42:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(42)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 't') ADVANCE(263);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_19(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 43:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(43)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'e') ADVANCE(264);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_19(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 44:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(44)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_25(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 45:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(45)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '<') ADVANCE(284);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8656) ADVANCE(233);
      if (lookahead == 8704) ADVANCE(307);
      if (sym__operator_character_set_26(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 46:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(46)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_27(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 47:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(47)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_25(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 48:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(48)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_25(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 49:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(51)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_28(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 50:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(51)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_28(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 51:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(51)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_29(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 52:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(54)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_28(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 53:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(54)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_28(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 54:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(54)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_29(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 55:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(55)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (sym__operator_character_set_30(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 56:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(56)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'o') ADVANCE(261);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_31(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 57:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(57)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_32(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 58:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(58)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'c') ADVANCE(265);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_31(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 59:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(59)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 't') ADVANCE(263);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_31(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 60:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(60)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'e') ADVANCE(264);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_31(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 61:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(62)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_33(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 62:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(62)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_34(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 63:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(63)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'd') ADVANCE(252);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_31(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 64:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(64)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'n') ADVANCE(255);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_31(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 65:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(67)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_35(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 66:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(67)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_35(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 67:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(67)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_36(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 68:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(70)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_37(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 69:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(70)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_37(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 70:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(70)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_38(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 71:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(72)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_7(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 72:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(72)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_8(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 73:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(73)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_39(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 74:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(75)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_40(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 75:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(75)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_41(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 76:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(77)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_40(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 77:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(77)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_41(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 78:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(79)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == '=') ADVANCE(301);
      if (lookahead == '@') ADVANCE(328);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(295);
      if (lookahead == 8594) ADVANCE(236);
      if (lookahead == 8759) ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 79:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(79)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == '=') ADVANCE(301);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(295);
      if (lookahead == 8594) ADVANCE(236);
      if (lookahead == 8759) ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 80:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(80)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_42(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 81:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(82)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_43(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 82:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(82)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_44(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 83:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(84)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_43(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 84:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(84)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_44(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 85:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(86)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_45(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 86:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(86)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_46(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 87:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(87)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'o') ADVANCE(157);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (sym__operator_character_set_47(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 88:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(89)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_48(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 89:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(89)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_49(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 90:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(92)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_50(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 91:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(92)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_51(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 92:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(92)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_52(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 93:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(94)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_53(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 94:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(94)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_54(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 95:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(96)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_55(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 96:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(96)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_56(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 97:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(98)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_57(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 98:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(98)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_58(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 99:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(99)
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == ':') ADVANCE(299);
      if (lookahead == '=') ADVANCE(301);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'c') ADVANCE(265);
      if (lookahead == 't') ADVANCE(278);
      if (lookahead == '{') ADVANCE(297);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 100:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(102)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_59(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 101:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(102)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_60(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 102:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(102)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_61(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 103:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(104)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_62(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 104:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(104)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_63(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 105:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(106)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_64(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 106:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(106)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_65(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 107:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(108)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '|') ADVANCE(296);
      if (sym__operator_character_set_53(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 108:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(108)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '|') ADVANCE(296);
      if (sym__operator_character_set_54(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 109:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(109)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_52(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 110:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(112)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_66(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 111:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(112)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_67(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 112:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(112)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_68(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 113:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(114)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(157);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_69(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 114:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(114)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(157);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_46(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 115:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(115)
      if (lookahead == '-') ADVANCE(290);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8594) ADVANCE(237);
      if (sym__operator_character_set_61(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 116:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(117)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 't') ADVANCE(158);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_70(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 117:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(117)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 't') ADVANCE(158);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_63(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 118:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(118)
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_71(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 119:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(119)
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '|') ADVANCE(296);
      if (sym__operator_character_set_72(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 120:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(121)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_73(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 121:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(121)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8592) ADVANCE(241);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_56(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 122:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(122)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(139);
      if (lookahead == 'c') ADVANCE(161);
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == 'n') ADVANCE(151);
      if (lookahead == 't') ADVANCE(159);
      if (lookahead == '|') ADVANCE(295);
      if (lookahead == 8592) ADVANCE(240);
      END_STATE();
    case 123:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(124)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_43(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 124:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(124)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_44(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 125:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(125)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '<') ADVANCE(282);
      if (lookahead == '=') ADVANCE(303);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 8592) ADVANCE(241);
      if (sym__operator_character_set_68(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 126:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(126)
      if (lookahead == '"') ADVANCE(131);
      END_STATE();
    case 127:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(126)
      if (lookahead == '"') ADVANCE(131);
      if (sym__immediate_varid_character_set_1(lookahead)) ADVANCE(281);
      END_STATE();
    case 128:
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(128)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 't') ADVANCE(278);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_31(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 129:
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '"') ADVANCE(219);
      if (lookahead == '\\') ADVANCE(129);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead != 0) ADVANCE(132);
      END_STATE();
    case 130:
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '^') ADVANCE(133);
      if (lookahead != 0) ADVANCE(132);
      END_STATE();
    case 131:
      if (lookahead == '"') ADVANCE(218);
      if (lookahead == '\\') ADVANCE(130);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(132);
      END_STATE();
    case 132:
      if (lookahead == '"') ADVANCE(217);
      if (lookahead == '\\') ADVANCE(130);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(132);
      END_STATE();
    case 133:
      if (lookahead == '"') ADVANCE(219);
      if (lookahead == '\\') ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(132);
      END_STATE();
    case 134:
      if (lookahead == '"') ADVANCE(222);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 135:
      if (lookahead == '"') ADVANCE(134);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 136:
      if (lookahead == '"') ADVANCE(135);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 137:
      if (lookahead == '\'') ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(137);
      END_STATE();
    case 138:
      if (lookahead == '\'') ADVANCE(215);
      END_STATE();
    case 139:
      if (lookahead == '-') ADVANCE(242);
      END_STATE();
    case 140:
      if (lookahead == '-') ADVANCE(242);
      if (lookahead == '=') ADVANCE(234);
      END_STATE();
    case 141:
      if (lookahead == '.') ADVANCE(330);
      END_STATE();
    case 142:
      if (lookahead == ':') ADVANCE(246);
      END_STATE();
    case 143:
      if (lookahead == '=') ADVANCE(234);
      END_STATE();
    case 144:
      if (lookahead == '>') ADVANCE(238);
      END_STATE();
    case 145:
      if (lookahead == '>') ADVANCE(230);
      END_STATE();
    case 146:
      if (lookahead == '\\') ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(138);
      END_STATE();
    case 147:
      if (lookahead == '\\') ADVANCE(132);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(147);
      END_STATE();
    case 148:
      if (lookahead == 'a') ADVANCE(172);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(333);
      END_STATE();
    case 150:
      if (lookahead == 'a') ADVANCE(170);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(173);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(320);
      END_STATE();
    case 153:
      if (lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 155:
      if (lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 156:
      if (lookahead == 'e') ADVANCE(164);
      END_STATE();
    case 157:
      if (lookahead == 'f') ADVANCE(322);
      END_STATE();
    case 158:
      if (lookahead == 'h') ADVANCE(156);
      END_STATE();
    case 159:
      if (lookahead == 'h') ADVANCE(156);
      if (lookahead == 'y') ADVANCE(166);
      END_STATE();
    case 160:
      if (lookahead == 'l') ADVANCE(169);
      END_STATE();
    case 161:
      if (lookahead == 'l') ADVANCE(150);
      END_STATE();
    case 162:
      if (lookahead == 'l') ADVANCE(153);
      END_STATE();
    case 163:
      if (lookahead == 'n') ADVANCE(324);
      END_STATE();
    case 164:
      if (lookahead == 'n') ADVANCE(318);
      END_STATE();
    case 165:
      if (lookahead == 'o') ADVANCE(162);
      END_STATE();
    case 166:
      if (lookahead == 'p') ADVANCE(154);
      END_STATE();
    case 167:
      if (lookahead == 'p') ADVANCE(155);
      END_STATE();
    case 168:
      if (lookahead == 's') ADVANCE(331);
      END_STATE();
    case 169:
      if (lookahead == 's') ADVANCE(152);
      END_STATE();
    case 170:
      if (lookahead == 's') ADVANCE(168);
      END_STATE();
    case 171:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 172:
      if (lookahead == 't') ADVANCE(149);
      END_STATE();
    case 173:
      if (lookahead == 'w') ADVANCE(171);
      END_STATE();
    case 174:
      if (lookahead == 'y') ADVANCE(167);
      END_STATE();
    case 175:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(176);
      if (('1' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(214);
      END_STATE();
    case 176:
      if (('1' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(214);
      END_STATE();
    case 177:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(213);
      END_STATE();
    case 178:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(227);
      END_STATE();
    case 179:
      if (sym_hole_character_set_1(lookahead)) ADVANCE(248);
      END_STATE();
    case 180:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(180)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(289);
      if (lookahead == '.') ADVANCE(309);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(300);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(140);
      if (lookahead == '=') ADVANCE(302);
      if (lookahead == '?') ADVANCE(179);
      if (lookahead == '@') ADVANCE(304);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(326);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(314);
      if (lookahead == 'c') ADVANCE(265);
      if (lookahead == 'd') ADVANCE(252);
      if (lookahead == 'e') ADVANCE(264);
      if (lookahead == 'i') ADVANCE(267);
      if (lookahead == 'n') ADVANCE(255);
      if (lookahead == 'o') ADVANCE(261);
      if (lookahead == 'r') ADVANCE(269);
      if (lookahead == 't') ADVANCE(262);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(295);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8592) ADVANCE(240);
      if (lookahead == 8594) ADVANCE(236);
      if (lookahead == 8656) ADVANCE(232);
      if (lookahead == 8658) ADVANCE(228);
      if (lookahead == 8704) ADVANCE(306);
      if (lookahead == 8759) ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 181:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(182)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(289);
      if (lookahead == '.') ADVANCE(249);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(139);
      if (lookahead == '=') ADVANCE(301);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'c') ADVANCE(265);
      if (lookahead == 'd') ADVANCE(252);
      if (lookahead == 'e') ADVANCE(264);
      if (lookahead == 'n') ADVANCE(255);
      if (lookahead == 't') ADVANCE(278);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(295);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8592) ADVANCE(240);
      if (lookahead == 8594) ADVANCE(236);
      if (lookahead == 8759) ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 182:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(182)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(289);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(139);
      if (lookahead == '=') ADVANCE(301);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == 'c') ADVANCE(265);
      if (lookahead == 'd') ADVANCE(252);
      if (lookahead == 'e') ADVANCE(264);
      if (lookahead == 'n') ADVANCE(255);
      if (lookahead == 't') ADVANCE(278);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(295);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8592) ADVANCE(240);
      if (lookahead == 8594) ADVANCE(236);
      if (lookahead == 8759) ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 183:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(183)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (sym__operator_character_set_74(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 184:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(184)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(289);
      if (lookahead == '.') ADVANCE(308);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '=') ADVANCE(301);
      if (lookahead == '?') ADVANCE(179);
      if (lookahead == '@') ADVANCE(304);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(326);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(295);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8594) ADVANCE(236);
      if (lookahead == 8759) ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 185:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(186)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_1(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 186:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(186)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_2(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 187:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(188)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_33(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 188:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(188)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '\\') ADVANCE(327);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_34(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 189:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(190)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '@') ADVANCE(329);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_75(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 190:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(190)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '\'') ADVANCE(146);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(223);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '[') ADVANCE(316);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (sym__operator_character_set_76(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(224);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 191:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(191)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '.') ADVANCE(141);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(140);
      if (lookahead == '=') ADVANCE(145);
      if (lookahead == '?') ADVANCE(179);
      if (lookahead == '@') ADVANCE(304);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(295);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8592) ADVANCE(240);
      if (lookahead == 8656) ADVANCE(232);
      if (lookahead == 8658) ADVANCE(228);
      if (lookahead == 8704) ADVANCE(306);
      if (lookahead == 8759) ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 192:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(192)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_12(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 193:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(193)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '=') ADVANCE(285);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8658) ADVANCE(229);
      if (lookahead == 8704) ADVANCE(307);
      if (sym__operator_character_set_27(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 194:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(194)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_77(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 195:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(195)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8704) ADVANCE(307);
      if (sym__operator_character_set_27(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 196:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(196)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8704) ADVANCE(307);
      if (sym__operator_character_set_24(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 197:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(197)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == '}') ADVANCE(298);
      if (sym__operator_character_set_24(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 198:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(198)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (sym__operator_character_set_78(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 199:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(199)
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'c') ADVANCE(161);
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == 'n') ADVANCE(151);
      if (lookahead == 'r') ADVANCE(165);
      if (lookahead == 't') ADVANCE(159);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_79(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 200:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(200)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'c') ADVANCE(161);
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == 'n') ADVANCE(151);
      if (lookahead == 'o') ADVANCE(157);
      if (lookahead == 't') ADVANCE(159);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_65(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 201:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(201)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '<') ADVANCE(284);
      if (lookahead == '?') ADVANCE(287);
      if (lookahead == '@') ADVANCE(305);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8656) ADVANCE(233);
      if (lookahead == 8704) ADVANCE(307);
      if (sym__operator_character_set_24(lookahead)) ADVANCE(286);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_2(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(280);
      END_STATE();
    case 202:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(203)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == 'o') ADVANCE(157);
      if (lookahead == 't') ADVANCE(158);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_80(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 203:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(203)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == 'o') ADVANCE(157);
      if (lookahead == 't') ADVANCE(158);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '}') ADVANCE(298);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_65(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 204:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(205)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '@') ADVANCE(329);
      if (sym__operator_character_set_81(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 205:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(205)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ';') ADVANCE(212);
      if (sym__operator_character_set_82(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 206:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(206)
      if (lookahead == '"') ADVANCE(131);
      if (lookahead == '(') ADVANCE(292);
      if (lookahead == '0') ADVANCE(225);
      if (lookahead == ':') ADVANCE(142);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '=') ADVANCE(301);
      if (lookahead == '?') ADVANCE(179);
      if (lookahead == '@') ADVANCE(304);
      if (lookahead == '_') ADVANCE(280);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == 8759) ADVANCE(244);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(226);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(294);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 207:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(208)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == '.') ADVANCE(251);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_83(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 208:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(208)
      if (lookahead == '-') ADVANCE(291);
      if (lookahead == ':') ADVANCE(283);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == '`') ADVANCE(315);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == '{') ADVANCE(297);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == 8759) ADVANCE(245);
      if (sym__operator_character_set_79(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 209:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(209)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == '|') ADVANCE(296);
      if (lookahead == '}') ADVANCE(298);
      if (sym__operator_character_set_84(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 210:
      if (eof) ADVANCE(211);
      if (lookahead == '\n') ADVANCE(337);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(210)
      if (lookahead == ')') ADVANCE(293);
      if (lookahead == ';') ADVANCE(212);
      if (lookahead == ']') ADVANCE(317);
      if (lookahead == 'c') ADVANCE(161);
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'e') ADVANCE(160);
      if (lookahead == 'i') ADVANCE(163);
      if (lookahead == 'n') ADVANCE(151);
      if (lookahead == 'o') ADVANCE(157);
      if (lookahead == 't') ADVANCE(159);
      if (lookahead == '}') ADVANCE(298);
      if (sym__operator_character_set_85(lookahead)) ADVANCE(286);
      if (sym__conid_character_set_3(lookahead)) ADVANCE(294);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'e') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(213);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_number);
      if (('1' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(214);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_char);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '\'') ADVANCE(216);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(137);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(136);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(217);
      if (lookahead == '\\') ADVANCE(130);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(132);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_triple_quote_string);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_triple_quote_string);
      if (lookahead == '"') ADVANCE(220);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_triple_quote_string);
      if (lookahead == '"') ADVANCE(221);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '.') ADVANCE(177);
      if (lookahead == 'e') ADVANCE(175);
      if (lookahead == 'x') ADVANCE(178);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '.') ADVANCE(177);
      if (lookahead == 'e') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(224);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == 'x') ADVANCE(178);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym__integer_literal);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(226);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym__hex_literal);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(227);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_u21d2);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_u21d2);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_u21d0);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_u21d0);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_u2192);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_u2192);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_u2190);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_u2190);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_u2237);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_u2237);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_hole);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(248);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym__immediate_dot);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym__immediate_dot);
      if (lookahead == '.') ADVANCE(330);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym__immediate_dot);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'a') ADVANCE(276);
      if (sym__varid_character_set_3(lookahead)) ADVANCE(280);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'a') ADVANCE(334);
      if (sym__varid_character_set_3(lookahead)) ADVANCE(280);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'a') ADVANCE(274);
      if (sym__varid_character_set_3(lookahead)) ADVANCE(280);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'e') ADVANCE(277);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'e') ADVANCE(321);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'e') ADVANCE(313);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'e') ADVANCE(311);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'e') ADVANCE(336);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'e') ADVANCE(268);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'f') ADVANCE(323);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'h') ADVANCE(260);
      if (lookahead == 'y') ADVANCE(270);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'h') ADVANCE(260);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'l') ADVANCE(273);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'l') ADVANCE(254);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'l') ADVANCE(257);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'n') ADVANCE(325);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'n') ADVANCE(319);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'o') ADVANCE(266);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'p') ADVANCE(258);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'p') ADVANCE(259);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 's') ADVANCE(332);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 's') ADVANCE(256);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 's') ADVANCE(272);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 't') ADVANCE(279);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 't') ADVANCE(253);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'w') ADVANCE(275);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'y') ADVANCE(270);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == 'y') ADVANCE(271);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym__varid);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym__immediate_varid);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(281);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym__operator);
      if (lookahead == '-') ADVANCE(243);
      if (sym__operator_character_set_87(lookahead)) ADVANCE(286);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym__operator);
      if (lookahead == ':') ADVANCE(247);
      if (sym__operator_character_set_88(lookahead)) ADVANCE(286);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym__operator);
      if (lookahead == '=') ADVANCE(235);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym__operator);
      if (lookahead == '>') ADVANCE(231);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym__operator);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym__operator);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      if (sym_hole_character_set_2(lookahead)) ADVANCE(248);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(238);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(239);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym__conid);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(294);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(246);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(230);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_AT);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_u2200);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_u2200);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(330);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_type);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym_role);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_role);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_then);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_else);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_of);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_in);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_AT2);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_AT2);
      if (sym__operator_character_set_86(lookahead)) ADVANCE(286);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_class);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_data);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_data);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_newtype);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_newtype);
      if (sym_hole_character_set_1(lookahead)) ADVANCE(280);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(aux_sym__token1);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(0)
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'a') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'f') ADVANCE(5);
      if (lookahead == 'h') ADVANCE(6);
      if (lookahead == 'i') ADVANCE(7);
      if (lookahead == 'l') ADVANCE(8);
      if (lookahead == 'm') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 'd') ADVANCE(13);
      if (lookahead == 's') ADVANCE(14);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(15);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(16);
      if (lookahead == 'o') ADVANCE(17);
      END_STATE();
    case 5:
      if (lookahead == 'o') ADVANCE(18);
      END_STATE();
    case 6:
      if (lookahead == 'i') ADVANCE(19);
      END_STATE();
    case 7:
      if (lookahead == 'f') ADVANCE(20);
      if (lookahead == 'm') ADVANCE(21);
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(23);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'h') ADVANCE(27);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(28);
      END_STATE();
    case 13:
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 15:
      if (lookahead == 's') ADVANCE(30);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(31);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 18:
      if (lookahead == 'r') ADVANCE(32);
      END_STATE();
    case 19:
      if (lookahead == 'd') ADVANCE(33);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 21:
      if (lookahead == 'p') ADVANCE(34);
      END_STATE();
    case 22:
      if (lookahead == 'f') ADVANCE(35);
      if (lookahead == 's') ADVANCE(36);
      END_STATE();
    case 23:
      if (lookahead == 't') ADVANCE(37);
      END_STATE();
    case 24:
      if (lookahead == 'd') ADVANCE(38);
      END_STATE();
    case 25:
      if (lookahead == 'm') ADVANCE(39);
      END_STATE();
    case 26:
      if (lookahead == 't') ADVANCE(40);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(41);
      END_STATE();
    case 28:
      if (lookahead == 'p') ADVANCE(42);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_ado);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(43);
      END_STATE();
    case 31:
      if (lookahead == 'i') ADVANCE(44);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(45);
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 33:
      if (lookahead == 'i') ADVANCE(47);
      END_STATE();
    case 34:
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(49);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(50);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 38:
      if (lookahead == 'u') ADVANCE(51);
      END_STATE();
    case 39:
      if (lookahead == 'i') ADVANCE(52);
      END_STATE();
    case 40:
      if (lookahead == 't') ADVANCE(53);
      END_STATE();
    case 41:
      if (lookahead == 'n') ADVANCE(54);
      END_STATE();
    case 42:
      if (lookahead == 'r') ADVANCE(55);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 44:
      if (lookahead == 'v') ADVANCE(56);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(57);
      END_STATE();
    case 46:
      if (lookahead == 'i') ADVANCE(58);
      END_STATE();
    case 47:
      if (lookahead == 'n') ADVANCE(59);
      END_STATE();
    case 48:
      if (lookahead == 'r') ADVANCE(60);
      END_STATE();
    case 49:
      if (lookahead == 'x') ADVANCE(61);
      END_STATE();
    case 50:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 51:
      if (lookahead == 'l') ADVANCE(63);
      END_STATE();
    case 52:
      if (lookahead == 'n') ADVANCE(64);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(68);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(69);
      END_STATE();
    case 58:
      if (lookahead == 'g') ADVANCE(70);
      END_STATE();
    case 59:
      if (lookahead == 'g') ADVANCE(71);
      END_STATE();
    case 60:
      if (lookahead == 't') ADVANCE(72);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_infix);
      if (lookahead == 'l') ADVANCE(73);
      if (lookahead == 'r') ADVANCE(74);
      END_STATE();
    case 62:
      if (lookahead == 'n') ADVANCE(75);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(76);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(77);
      END_STATE();
    case 65:
      if (lookahead == 'r') ADVANCE(78);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 67:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_derive);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(81);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_hiding);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_infixl);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_infixr);
      END_STATE();
    case 75:
      if (lookahead == 'c') ADVANCE(82);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 77:
      if (lookahead == 'l') ADVANCE(83);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(84);
      END_STATE();
    case 79:
      if (lookahead == 'm') ADVANCE(85);
      END_STATE();
    case 80:
      if (lookahead == 'e') ADVANCE(86);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_foreign);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_nominal);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_pattern);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_phantom);
      END_STATE();
    case 86:
      if (lookahead == 'n') ADVANCE(88);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_instance);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(89);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(90);
      END_STATE();
    case 90:
      if (lookahead == 't') ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 'i') ADVANCE(92);
      END_STATE();
    case 92:
      if (lookahead == 'o') ADVANCE(93);
      END_STATE();
    case 93:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(95);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_representational);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 181, .external_lex_state = 2},
  [2] = {.lex_state = 183, .external_lex_state = 3},
  [3] = {.lex_state = 183, .external_lex_state = 3},
  [4] = {.lex_state = 183, .external_lex_state = 3},
  [5] = {.lex_state = 183, .external_lex_state = 3},
  [6] = {.lex_state = 183, .external_lex_state = 3},
  [7] = {.lex_state = 183, .external_lex_state = 3},
  [8] = {.lex_state = 183, .external_lex_state = 3},
  [9] = {.lex_state = 183, .external_lex_state = 3},
  [10] = {.lex_state = 183, .external_lex_state = 3},
  [11] = {.lex_state = 183, .external_lex_state = 3},
  [12] = {.lex_state = 183, .external_lex_state = 3},
  [13] = {.lex_state = 183, .external_lex_state = 3},
  [14] = {.lex_state = 181, .external_lex_state = 4},
  [15] = {.lex_state = 181, .external_lex_state = 4},
  [16] = {.lex_state = 181, .external_lex_state = 4},
  [17] = {.lex_state = 181, .external_lex_state = 5},
  [18] = {.lex_state = 181, .external_lex_state = 4},
  [19] = {.lex_state = 181, .external_lex_state = 4},
  [20] = {.lex_state = 181, .external_lex_state = 4},
  [21] = {.lex_state = 181, .external_lex_state = 5},
  [22] = {.lex_state = 1, .external_lex_state = 6},
  [23] = {.lex_state = 1, .external_lex_state = 6},
  [24] = {.lex_state = 1, .external_lex_state = 6},
  [25] = {.lex_state = 1, .external_lex_state = 6},
  [26] = {.lex_state = 1, .external_lex_state = 6},
  [27] = {.lex_state = 1, .external_lex_state = 6},
  [28] = {.lex_state = 181, .external_lex_state = 5},
  [29] = {.lex_state = 1, .external_lex_state = 6},
  [30] = {.lex_state = 1, .external_lex_state = 6},
  [31] = {.lex_state = 1, .external_lex_state = 6},
  [32] = {.lex_state = 1, .external_lex_state = 6},
  [33] = {.lex_state = 1, .external_lex_state = 6},
  [34] = {.lex_state = 1, .external_lex_state = 6},
  [35] = {.lex_state = 1, .external_lex_state = 6},
  [36] = {.lex_state = 1, .external_lex_state = 6},
  [37] = {.lex_state = 1, .external_lex_state = 6},
  [38] = {.lex_state = 1, .external_lex_state = 6},
  [39] = {.lex_state = 1, .external_lex_state = 6},
  [40] = {.lex_state = 1, .external_lex_state = 6},
  [41] = {.lex_state = 1, .external_lex_state = 6},
  [42] = {.lex_state = 1, .external_lex_state = 6},
  [43] = {.lex_state = 1, .external_lex_state = 6},
  [44] = {.lex_state = 1, .external_lex_state = 6},
  [45] = {.lex_state = 1, .external_lex_state = 6},
  [46] = {.lex_state = 1, .external_lex_state = 6},
  [47] = {.lex_state = 1, .external_lex_state = 6},
  [48] = {.lex_state = 1, .external_lex_state = 6},
  [49] = {.lex_state = 1, .external_lex_state = 6},
  [50] = {.lex_state = 1, .external_lex_state = 6},
  [51] = {.lex_state = 1, .external_lex_state = 6},
  [52] = {.lex_state = 1, .external_lex_state = 6},
  [53] = {.lex_state = 1, .external_lex_state = 6},
  [54] = {.lex_state = 1, .external_lex_state = 6},
  [55] = {.lex_state = 1, .external_lex_state = 6},
  [56] = {.lex_state = 1, .external_lex_state = 6},
  [57] = {.lex_state = 1, .external_lex_state = 6},
  [58] = {.lex_state = 1, .external_lex_state = 6},
  [59] = {.lex_state = 1, .external_lex_state = 6},
  [60] = {.lex_state = 1, .external_lex_state = 6},
  [61] = {.lex_state = 1, .external_lex_state = 6},
  [62] = {.lex_state = 1, .external_lex_state = 6},
  [63] = {.lex_state = 1, .external_lex_state = 6},
  [64] = {.lex_state = 1, .external_lex_state = 6},
  [65] = {.lex_state = 1, .external_lex_state = 6},
  [66] = {.lex_state = 1, .external_lex_state = 6},
  [67] = {.lex_state = 1, .external_lex_state = 6},
  [68] = {.lex_state = 1, .external_lex_state = 6},
  [69] = {.lex_state = 1, .external_lex_state = 6},
  [70] = {.lex_state = 1, .external_lex_state = 6},
  [71] = {.lex_state = 1, .external_lex_state = 6},
  [72] = {.lex_state = 1, .external_lex_state = 6},
  [73] = {.lex_state = 1, .external_lex_state = 6},
  [74] = {.lex_state = 1, .external_lex_state = 6},
  [75] = {.lex_state = 1, .external_lex_state = 6},
  [76] = {.lex_state = 1, .external_lex_state = 6},
  [77] = {.lex_state = 1, .external_lex_state = 6},
  [78] = {.lex_state = 1, .external_lex_state = 6},
  [79] = {.lex_state = 1, .external_lex_state = 6},
  [80] = {.lex_state = 1, .external_lex_state = 6},
  [81] = {.lex_state = 1, .external_lex_state = 6},
  [82] = {.lex_state = 1, .external_lex_state = 6},
  [83] = {.lex_state = 1, .external_lex_state = 6},
  [84] = {.lex_state = 1, .external_lex_state = 6},
  [85] = {.lex_state = 1, .external_lex_state = 6},
  [86] = {.lex_state = 1, .external_lex_state = 6},
  [87] = {.lex_state = 1, .external_lex_state = 6},
  [88] = {.lex_state = 1, .external_lex_state = 6},
  [89] = {.lex_state = 1, .external_lex_state = 6},
  [90] = {.lex_state = 1, .external_lex_state = 6},
  [91] = {.lex_state = 1, .external_lex_state = 6},
  [92] = {.lex_state = 1, .external_lex_state = 6},
  [93] = {.lex_state = 1, .external_lex_state = 6},
  [94] = {.lex_state = 1, .external_lex_state = 6},
  [95] = {.lex_state = 1, .external_lex_state = 6},
  [96] = {.lex_state = 1, .external_lex_state = 6},
  [97] = {.lex_state = 1, .external_lex_state = 6},
  [98] = {.lex_state = 1, .external_lex_state = 6},
  [99] = {.lex_state = 1, .external_lex_state = 6},
  [100] = {.lex_state = 1, .external_lex_state = 6},
  [101] = {.lex_state = 1, .external_lex_state = 6},
  [102] = {.lex_state = 1, .external_lex_state = 6},
  [103] = {.lex_state = 1, .external_lex_state = 6},
  [104] = {.lex_state = 1, .external_lex_state = 6},
  [105] = {.lex_state = 1, .external_lex_state = 6},
  [106] = {.lex_state = 1, .external_lex_state = 6},
  [107] = {.lex_state = 1, .external_lex_state = 6},
  [108] = {.lex_state = 1, .external_lex_state = 6},
  [109] = {.lex_state = 1, .external_lex_state = 6},
  [110] = {.lex_state = 1, .external_lex_state = 6},
  [111] = {.lex_state = 1, .external_lex_state = 6},
  [112] = {.lex_state = 181, .external_lex_state = 5},
  [113] = {.lex_state = 1, .external_lex_state = 6},
  [114] = {.lex_state = 1, .external_lex_state = 6},
  [115] = {.lex_state = 1, .external_lex_state = 6},
  [116] = {.lex_state = 1, .external_lex_state = 6},
  [117] = {.lex_state = 1, .external_lex_state = 6},
  [118] = {.lex_state = 1, .external_lex_state = 6},
  [119] = {.lex_state = 1, .external_lex_state = 6},
  [120] = {.lex_state = 1, .external_lex_state = 6},
  [121] = {.lex_state = 1, .external_lex_state = 6},
  [122] = {.lex_state = 1, .external_lex_state = 6},
  [123] = {.lex_state = 184, .external_lex_state = 4},
  [124] = {.lex_state = 184, .external_lex_state = 4},
  [125] = {.lex_state = 184, .external_lex_state = 4},
  [126] = {.lex_state = 184, .external_lex_state = 4},
  [127] = {.lex_state = 184, .external_lex_state = 4},
  [128] = {.lex_state = 184, .external_lex_state = 4},
  [129] = {.lex_state = 184, .external_lex_state = 4},
  [130] = {.lex_state = 184, .external_lex_state = 4},
  [131] = {.lex_state = 184, .external_lex_state = 4},
  [132] = {.lex_state = 184, .external_lex_state = 4},
  [133] = {.lex_state = 184, .external_lex_state = 4},
  [134] = {.lex_state = 184, .external_lex_state = 4},
  [135] = {.lex_state = 184, .external_lex_state = 4},
  [136] = {.lex_state = 184, .external_lex_state = 4},
  [137] = {.lex_state = 184, .external_lex_state = 4},
  [138] = {.lex_state = 184, .external_lex_state = 4},
  [139] = {.lex_state = 184, .external_lex_state = 4},
  [140] = {.lex_state = 184, .external_lex_state = 4},
  [141] = {.lex_state = 184, .external_lex_state = 4},
  [142] = {.lex_state = 184, .external_lex_state = 4},
  [143] = {.lex_state = 184, .external_lex_state = 4},
  [144] = {.lex_state = 184, .external_lex_state = 4},
  [145] = {.lex_state = 184, .external_lex_state = 4},
  [146] = {.lex_state = 184, .external_lex_state = 4},
  [147] = {.lex_state = 184, .external_lex_state = 4},
  [148] = {.lex_state = 184, .external_lex_state = 4},
  [149] = {.lex_state = 184, .external_lex_state = 4},
  [150] = {.lex_state = 184, .external_lex_state = 4},
  [151] = {.lex_state = 184, .external_lex_state = 4},
  [152] = {.lex_state = 184, .external_lex_state = 4},
  [153] = {.lex_state = 184, .external_lex_state = 4},
  [154] = {.lex_state = 184, .external_lex_state = 4},
  [155] = {.lex_state = 184, .external_lex_state = 4},
  [156] = {.lex_state = 184, .external_lex_state = 4},
  [157] = {.lex_state = 184, .external_lex_state = 4},
  [158] = {.lex_state = 184, .external_lex_state = 4},
  [159] = {.lex_state = 184, .external_lex_state = 4},
  [160] = {.lex_state = 184, .external_lex_state = 4},
  [161] = {.lex_state = 184, .external_lex_state = 4},
  [162] = {.lex_state = 184, .external_lex_state = 4},
  [163] = {.lex_state = 184, .external_lex_state = 4},
  [164] = {.lex_state = 184, .external_lex_state = 4},
  [165] = {.lex_state = 184, .external_lex_state = 4},
  [166] = {.lex_state = 184, .external_lex_state = 4},
  [167] = {.lex_state = 184, .external_lex_state = 4},
  [168] = {.lex_state = 184, .external_lex_state = 4},
  [169] = {.lex_state = 184, .external_lex_state = 4},
  [170] = {.lex_state = 184, .external_lex_state = 4},
  [171] = {.lex_state = 184, .external_lex_state = 4},
  [172] = {.lex_state = 184, .external_lex_state = 4},
  [173] = {.lex_state = 184, .external_lex_state = 4},
  [174] = {.lex_state = 184, .external_lex_state = 4},
  [175] = {.lex_state = 184, .external_lex_state = 4},
  [176] = {.lex_state = 184, .external_lex_state = 4},
  [177] = {.lex_state = 184, .external_lex_state = 4},
  [178] = {.lex_state = 184, .external_lex_state = 4},
  [179] = {.lex_state = 184, .external_lex_state = 4},
  [180] = {.lex_state = 184, .external_lex_state = 4},
  [181] = {.lex_state = 184, .external_lex_state = 4},
  [182] = {.lex_state = 184, .external_lex_state = 4},
  [183] = {.lex_state = 184, .external_lex_state = 4},
  [184] = {.lex_state = 184, .external_lex_state = 4},
  [185] = {.lex_state = 184, .external_lex_state = 4},
  [186] = {.lex_state = 184, .external_lex_state = 4},
  [187] = {.lex_state = 184, .external_lex_state = 4},
  [188] = {.lex_state = 184, .external_lex_state = 4},
  [189] = {.lex_state = 184, .external_lex_state = 4},
  [190] = {.lex_state = 184, .external_lex_state = 4},
  [191] = {.lex_state = 184, .external_lex_state = 4},
  [192] = {.lex_state = 184, .external_lex_state = 4},
  [193] = {.lex_state = 184, .external_lex_state = 4},
  [194] = {.lex_state = 184, .external_lex_state = 4},
  [195] = {.lex_state = 184, .external_lex_state = 4},
  [196] = {.lex_state = 184, .external_lex_state = 4},
  [197] = {.lex_state = 184, .external_lex_state = 4},
  [198] = {.lex_state = 184, .external_lex_state = 4},
  [199] = {.lex_state = 184, .external_lex_state = 4},
  [200] = {.lex_state = 184, .external_lex_state = 4},
  [201] = {.lex_state = 184, .external_lex_state = 4},
  [202] = {.lex_state = 184, .external_lex_state = 4},
  [203] = {.lex_state = 184, .external_lex_state = 4},
  [204] = {.lex_state = 184, .external_lex_state = 4},
  [205] = {.lex_state = 184, .external_lex_state = 4},
  [206] = {.lex_state = 184, .external_lex_state = 4},
  [207] = {.lex_state = 184, .external_lex_state = 4},
  [208] = {.lex_state = 184, .external_lex_state = 4},
  [209] = {.lex_state = 184, .external_lex_state = 4},
  [210] = {.lex_state = 184, .external_lex_state = 4},
  [211] = {.lex_state = 184, .external_lex_state = 4},
  [212] = {.lex_state = 184, .external_lex_state = 4},
  [213] = {.lex_state = 184, .external_lex_state = 4},
  [214] = {.lex_state = 184, .external_lex_state = 4},
  [215] = {.lex_state = 184, .external_lex_state = 4},
  [216] = {.lex_state = 184, .external_lex_state = 4},
  [217] = {.lex_state = 184, .external_lex_state = 4},
  [218] = {.lex_state = 184, .external_lex_state = 4},
  [219] = {.lex_state = 184, .external_lex_state = 4},
  [220] = {.lex_state = 184, .external_lex_state = 4},
  [221] = {.lex_state = 184, .external_lex_state = 4},
  [222] = {.lex_state = 184, .external_lex_state = 5},
  [223] = {.lex_state = 184, .external_lex_state = 5},
  [224] = {.lex_state = 184, .external_lex_state = 5},
  [225] = {.lex_state = 184, .external_lex_state = 5},
  [226] = {.lex_state = 184, .external_lex_state = 5},
  [227] = {.lex_state = 184, .external_lex_state = 5},
  [228] = {.lex_state = 184, .external_lex_state = 5},
  [229] = {.lex_state = 184, .external_lex_state = 5},
  [230] = {.lex_state = 184, .external_lex_state = 5},
  [231] = {.lex_state = 184, .external_lex_state = 5},
  [232] = {.lex_state = 184, .external_lex_state = 5},
  [233] = {.lex_state = 184, .external_lex_state = 5},
  [234] = {.lex_state = 184, .external_lex_state = 5},
  [235] = {.lex_state = 184, .external_lex_state = 5},
  [236] = {.lex_state = 184, .external_lex_state = 5},
  [237] = {.lex_state = 184, .external_lex_state = 5},
  [238] = {.lex_state = 184, .external_lex_state = 5},
  [239] = {.lex_state = 184, .external_lex_state = 5},
  [240] = {.lex_state = 184, .external_lex_state = 5},
  [241] = {.lex_state = 183, .external_lex_state = 3},
  [242] = {.lex_state = 183, .external_lex_state = 3},
  [243] = {.lex_state = 183, .external_lex_state = 3},
  [244] = {.lex_state = 183, .external_lex_state = 3},
  [245] = {.lex_state = 183, .external_lex_state = 3},
  [246] = {.lex_state = 183, .external_lex_state = 3},
  [247] = {.lex_state = 183, .external_lex_state = 3},
  [248] = {.lex_state = 183, .external_lex_state = 3},
  [249] = {.lex_state = 183, .external_lex_state = 3},
  [250] = {.lex_state = 183, .external_lex_state = 3},
  [251] = {.lex_state = 183, .external_lex_state = 3},
  [252] = {.lex_state = 183, .external_lex_state = 3},
  [253] = {.lex_state = 183, .external_lex_state = 3},
  [254] = {.lex_state = 183, .external_lex_state = 3},
  [255] = {.lex_state = 183, .external_lex_state = 3},
  [256] = {.lex_state = 183, .external_lex_state = 3},
  [257] = {.lex_state = 183, .external_lex_state = 3},
  [258] = {.lex_state = 183, .external_lex_state = 3},
  [259] = {.lex_state = 183, .external_lex_state = 3},
  [260] = {.lex_state = 183, .external_lex_state = 3},
  [261] = {.lex_state = 183, .external_lex_state = 3},
  [262] = {.lex_state = 183, .external_lex_state = 3},
  [263] = {.lex_state = 183, .external_lex_state = 3},
  [264] = {.lex_state = 183, .external_lex_state = 3},
  [265] = {.lex_state = 183, .external_lex_state = 3},
  [266] = {.lex_state = 183, .external_lex_state = 3},
  [267] = {.lex_state = 183, .external_lex_state = 3},
  [268] = {.lex_state = 183, .external_lex_state = 3},
  [269] = {.lex_state = 183, .external_lex_state = 3},
  [270] = {.lex_state = 183, .external_lex_state = 3},
  [271] = {.lex_state = 183, .external_lex_state = 3},
  [272] = {.lex_state = 183, .external_lex_state = 3},
  [273] = {.lex_state = 183, .external_lex_state = 3},
  [274] = {.lex_state = 186, .external_lex_state = 7},
  [275] = {.lex_state = 3, .external_lex_state = 8},
  [276] = {.lex_state = 186, .external_lex_state = 9},
  [277] = {.lex_state = 3, .external_lex_state = 8},
  [278] = {.lex_state = 186, .external_lex_state = 7},
  [279] = {.lex_state = 186, .external_lex_state = 9},
  [280] = {.lex_state = 188, .external_lex_state = 10},
  [281] = {.lex_state = 188, .external_lex_state = 11},
  [282] = {.lex_state = 5, .external_lex_state = 12},
  [283] = {.lex_state = 188, .external_lex_state = 10},
  [284] = {.lex_state = 5, .external_lex_state = 12},
  [285] = {.lex_state = 188, .external_lex_state = 11},
  [286] = {.lex_state = 184, .external_lex_state = 5},
  [287] = {.lex_state = 184, .external_lex_state = 5},
  [288] = {.lex_state = 184, .external_lex_state = 4},
  [289] = {.lex_state = 184, .external_lex_state = 4},
  [290] = {.lex_state = 184, .external_lex_state = 4},
  [291] = {.lex_state = 184, .external_lex_state = 5},
  [292] = {.lex_state = 7, .external_lex_state = 13},
  [293] = {.lex_state = 184, .external_lex_state = 5},
  [294] = {.lex_state = 184, .external_lex_state = 4},
  [295] = {.lex_state = 184, .external_lex_state = 4},
  [296] = {.lex_state = 184, .external_lex_state = 5},
  [297] = {.lex_state = 184, .external_lex_state = 5},
  [298] = {.lex_state = 184, .external_lex_state = 4},
  [299] = {.lex_state = 184, .external_lex_state = 4},
  [300] = {.lex_state = 188, .external_lex_state = 13},
  [301] = {.lex_state = 184, .external_lex_state = 4},
  [302] = {.lex_state = 184, .external_lex_state = 5},
  [303] = {.lex_state = 184, .external_lex_state = 5},
  [304] = {.lex_state = 184, .external_lex_state = 4},
  [305] = {.lex_state = 5, .external_lex_state = 14},
  [306] = {.lex_state = 184, .external_lex_state = 4},
  [307] = {.lex_state = 184, .external_lex_state = 5},
  [308] = {.lex_state = 184, .external_lex_state = 4},
  [309] = {.lex_state = 184, .external_lex_state = 5},
  [310] = {.lex_state = 184, .external_lex_state = 4},
  [311] = {.lex_state = 184, .external_lex_state = 4},
  [312] = {.lex_state = 184, .external_lex_state = 5},
  [313] = {.lex_state = 184, .external_lex_state = 5},
  [314] = {.lex_state = 184, .external_lex_state = 5},
  [315] = {.lex_state = 184, .external_lex_state = 4},
  [316] = {.lex_state = 184, .external_lex_state = 4},
  [317] = {.lex_state = 184, .external_lex_state = 4},
  [318] = {.lex_state = 184, .external_lex_state = 4},
  [319] = {.lex_state = 184, .external_lex_state = 4},
  [320] = {.lex_state = 184, .external_lex_state = 5},
  [321] = {.lex_state = 184, .external_lex_state = 4},
  [322] = {.lex_state = 184, .external_lex_state = 5},
  [323] = {.lex_state = 184, .external_lex_state = 4},
  [324] = {.lex_state = 184, .external_lex_state = 4},
  [325] = {.lex_state = 184, .external_lex_state = 4},
  [326] = {.lex_state = 184, .external_lex_state = 5},
  [327] = {.lex_state = 184, .external_lex_state = 5},
  [328] = {.lex_state = 184, .external_lex_state = 5},
  [329] = {.lex_state = 184, .external_lex_state = 4},
  [330] = {.lex_state = 184, .external_lex_state = 4},
  [331] = {.lex_state = 184, .external_lex_state = 5},
  [332] = {.lex_state = 7, .external_lex_state = 13},
  [333] = {.lex_state = 184, .external_lex_state = 4},
  [334] = {.lex_state = 184, .external_lex_state = 4},
  [335] = {.lex_state = 184, .external_lex_state = 5},
  [336] = {.lex_state = 184, .external_lex_state = 4},
  [337] = {.lex_state = 188, .external_lex_state = 13},
  [338] = {.lex_state = 184, .external_lex_state = 4},
  [339] = {.lex_state = 184, .external_lex_state = 4},
  [340] = {.lex_state = 184, .external_lex_state = 4},
  [341] = {.lex_state = 184, .external_lex_state = 4},
  [342] = {.lex_state = 5, .external_lex_state = 14},
  [343] = {.lex_state = 184, .external_lex_state = 4},
  [344] = {.lex_state = 184, .external_lex_state = 5},
  [345] = {.lex_state = 184, .external_lex_state = 4},
  [346] = {.lex_state = 184, .external_lex_state = 5},
  [347] = {.lex_state = 184, .external_lex_state = 4},
  [348] = {.lex_state = 184, .external_lex_state = 4},
  [349] = {.lex_state = 184, .external_lex_state = 4},
  [350] = {.lex_state = 184, .external_lex_state = 4},
  [351] = {.lex_state = 184, .external_lex_state = 4},
  [352] = {.lex_state = 184, .external_lex_state = 4},
  [353] = {.lex_state = 184, .external_lex_state = 4},
  [354] = {.lex_state = 184, .external_lex_state = 4},
  [355] = {.lex_state = 184, .external_lex_state = 4},
  [356] = {.lex_state = 184, .external_lex_state = 4},
  [357] = {.lex_state = 184, .external_lex_state = 4},
  [358] = {.lex_state = 184, .external_lex_state = 5},
  [359] = {.lex_state = 184, .external_lex_state = 5},
  [360] = {.lex_state = 184, .external_lex_state = 4},
  [361] = {.lex_state = 184, .external_lex_state = 5},
  [362] = {.lex_state = 184, .external_lex_state = 5},
  [363] = {.lex_state = 184, .external_lex_state = 4},
  [364] = {.lex_state = 184, .external_lex_state = 4},
  [365] = {.lex_state = 184, .external_lex_state = 5},
  [366] = {.lex_state = 184, .external_lex_state = 4},
  [367] = {.lex_state = 184, .external_lex_state = 5},
  [368] = {.lex_state = 184, .external_lex_state = 4},
  [369] = {.lex_state = 184, .external_lex_state = 4},
  [370] = {.lex_state = 184, .external_lex_state = 4},
  [371] = {.lex_state = 188, .external_lex_state = 15},
  [372] = {.lex_state = 184, .external_lex_state = 4},
  [373] = {.lex_state = 184, .external_lex_state = 4},
  [374] = {.lex_state = 184, .external_lex_state = 5},
  [375] = {.lex_state = 184, .external_lex_state = 4},
  [376] = {.lex_state = 184, .external_lex_state = 4},
  [377] = {.lex_state = 184, .external_lex_state = 4},
  [378] = {.lex_state = 184, .external_lex_state = 4},
  [379] = {.lex_state = 184, .external_lex_state = 4},
  [380] = {.lex_state = 184, .external_lex_state = 4},
  [381] = {.lex_state = 184, .external_lex_state = 5},
  [382] = {.lex_state = 184, .external_lex_state = 4},
  [383] = {.lex_state = 184, .external_lex_state = 5},
  [384] = {.lex_state = 184, .external_lex_state = 5},
  [385] = {.lex_state = 184, .external_lex_state = 5},
  [386] = {.lex_state = 184, .external_lex_state = 5},
  [387] = {.lex_state = 184, .external_lex_state = 4},
  [388] = {.lex_state = 184, .external_lex_state = 5},
  [389] = {.lex_state = 184, .external_lex_state = 5},
  [390] = {.lex_state = 184, .external_lex_state = 5},
  [391] = {.lex_state = 184, .external_lex_state = 4},
  [392] = {.lex_state = 184, .external_lex_state = 5},
  [393] = {.lex_state = 184, .external_lex_state = 4},
  [394] = {.lex_state = 184, .external_lex_state = 4},
  [395] = {.lex_state = 184, .external_lex_state = 4},
  [396] = {.lex_state = 184, .external_lex_state = 4},
  [397] = {.lex_state = 184, .external_lex_state = 5},
  [398] = {.lex_state = 184, .external_lex_state = 4},
  [399] = {.lex_state = 184, .external_lex_state = 4},
  [400] = {.lex_state = 184, .external_lex_state = 4},
  [401] = {.lex_state = 188, .external_lex_state = 15},
  [402] = {.lex_state = 184, .external_lex_state = 5},
  [403] = {.lex_state = 184, .external_lex_state = 4},
  [404] = {.lex_state = 184, .external_lex_state = 4},
  [405] = {.lex_state = 184, .external_lex_state = 5},
  [406] = {.lex_state = 184, .external_lex_state = 5},
  [407] = {.lex_state = 184, .external_lex_state = 5},
  [408] = {.lex_state = 184, .external_lex_state = 4},
  [409] = {.lex_state = 184, .external_lex_state = 4},
  [410] = {.lex_state = 184, .external_lex_state = 4},
  [411] = {.lex_state = 184, .external_lex_state = 5},
  [412] = {.lex_state = 184, .external_lex_state = 4},
  [413] = {.lex_state = 184, .external_lex_state = 4},
  [414] = {.lex_state = 184, .external_lex_state = 4},
  [415] = {.lex_state = 184, .external_lex_state = 4},
  [416] = {.lex_state = 184, .external_lex_state = 4},
  [417] = {.lex_state = 184, .external_lex_state = 5},
  [418] = {.lex_state = 184, .external_lex_state = 4},
  [419] = {.lex_state = 184, .external_lex_state = 4},
  [420] = {.lex_state = 184, .external_lex_state = 5},
  [421] = {.lex_state = 184, .external_lex_state = 4},
  [422] = {.lex_state = 184, .external_lex_state = 5},
  [423] = {.lex_state = 184, .external_lex_state = 4},
  [424] = {.lex_state = 184, .external_lex_state = 4},
  [425] = {.lex_state = 184, .external_lex_state = 4},
  [426] = {.lex_state = 184, .external_lex_state = 5},
  [427] = {.lex_state = 184, .external_lex_state = 4},
  [428] = {.lex_state = 184, .external_lex_state = 4},
  [429] = {.lex_state = 184, .external_lex_state = 5},
  [430] = {.lex_state = 184, .external_lex_state = 5},
  [431] = {.lex_state = 184, .external_lex_state = 5},
  [432] = {.lex_state = 184, .external_lex_state = 5},
  [433] = {.lex_state = 184, .external_lex_state = 5},
  [434] = {.lex_state = 184, .external_lex_state = 5},
  [435] = {.lex_state = 184, .external_lex_state = 5},
  [436] = {.lex_state = 184, .external_lex_state = 5},
  [437] = {.lex_state = 184, .external_lex_state = 5},
  [438] = {.lex_state = 184, .external_lex_state = 5},
  [439] = {.lex_state = 184, .external_lex_state = 5},
  [440] = {.lex_state = 184, .external_lex_state = 5},
  [441] = {.lex_state = 184, .external_lex_state = 5},
  [442] = {.lex_state = 184, .external_lex_state = 5},
  [443] = {.lex_state = 184, .external_lex_state = 5},
  [444] = {.lex_state = 184, .external_lex_state = 5},
  [445] = {.lex_state = 184, .external_lex_state = 5},
  [446] = {.lex_state = 184, .external_lex_state = 5},
  [447] = {.lex_state = 184, .external_lex_state = 5},
  [448] = {.lex_state = 184, .external_lex_state = 5},
  [449] = {.lex_state = 184, .external_lex_state = 5},
  [450] = {.lex_state = 184, .external_lex_state = 5},
  [451] = {.lex_state = 184, .external_lex_state = 5},
  [452] = {.lex_state = 184, .external_lex_state = 5},
  [453] = {.lex_state = 9, .external_lex_state = 13},
  [454] = {.lex_state = 184, .external_lex_state = 5},
  [455] = {.lex_state = 184, .external_lex_state = 5},
  [456] = {.lex_state = 184, .external_lex_state = 5},
  [457] = {.lex_state = 184, .external_lex_state = 5},
  [458] = {.lex_state = 184, .external_lex_state = 5},
  [459] = {.lex_state = 184, .external_lex_state = 5},
  [460] = {.lex_state = 184, .external_lex_state = 5},
  [461] = {.lex_state = 184, .external_lex_state = 5},
  [462] = {.lex_state = 184, .external_lex_state = 5},
  [463] = {.lex_state = 184, .external_lex_state = 5},
  [464] = {.lex_state = 184, .external_lex_state = 5},
  [465] = {.lex_state = 184, .external_lex_state = 5},
  [466] = {.lex_state = 184, .external_lex_state = 5},
  [467] = {.lex_state = 184, .external_lex_state = 5},
  [468] = {.lex_state = 184, .external_lex_state = 5},
  [469] = {.lex_state = 184, .external_lex_state = 5},
  [470] = {.lex_state = 184, .external_lex_state = 5},
  [471] = {.lex_state = 184, .external_lex_state = 5},
  [472] = {.lex_state = 184, .external_lex_state = 5},
  [473] = {.lex_state = 184, .external_lex_state = 5},
  [474] = {.lex_state = 184, .external_lex_state = 5},
  [475] = {.lex_state = 184, .external_lex_state = 5},
  [476] = {.lex_state = 184, .external_lex_state = 5},
  [477] = {.lex_state = 184, .external_lex_state = 5},
  [478] = {.lex_state = 184, .external_lex_state = 5},
  [479] = {.lex_state = 184, .external_lex_state = 5},
  [480] = {.lex_state = 184, .external_lex_state = 5},
  [481] = {.lex_state = 184, .external_lex_state = 5},
  [482] = {.lex_state = 184, .external_lex_state = 5},
  [483] = {.lex_state = 184, .external_lex_state = 5},
  [484] = {.lex_state = 184, .external_lex_state = 5},
  [485] = {.lex_state = 184, .external_lex_state = 5},
  [486] = {.lex_state = 184, .external_lex_state = 5},
  [487] = {.lex_state = 184, .external_lex_state = 5},
  [488] = {.lex_state = 184, .external_lex_state = 5},
  [489] = {.lex_state = 184, .external_lex_state = 5},
  [490] = {.lex_state = 184, .external_lex_state = 5},
  [491] = {.lex_state = 184, .external_lex_state = 5},
  [492] = {.lex_state = 184, .external_lex_state = 5},
  [493] = {.lex_state = 184, .external_lex_state = 5},
  [494] = {.lex_state = 184, .external_lex_state = 5},
  [495] = {.lex_state = 184, .external_lex_state = 5},
  [496] = {.lex_state = 184, .external_lex_state = 5},
  [497] = {.lex_state = 184, .external_lex_state = 5},
  [498] = {.lex_state = 184, .external_lex_state = 5},
  [499] = {.lex_state = 184, .external_lex_state = 5},
  [500] = {.lex_state = 184, .external_lex_state = 5},
  [501] = {.lex_state = 184, .external_lex_state = 5},
  [502] = {.lex_state = 184, .external_lex_state = 5},
  [503] = {.lex_state = 184, .external_lex_state = 5},
  [504] = {.lex_state = 184, .external_lex_state = 5},
  [505] = {.lex_state = 184, .external_lex_state = 5},
  [506] = {.lex_state = 184, .external_lex_state = 5},
  [507] = {.lex_state = 184, .external_lex_state = 5},
  [508] = {.lex_state = 184, .external_lex_state = 5},
  [509] = {.lex_state = 184, .external_lex_state = 5},
  [510] = {.lex_state = 184, .external_lex_state = 5},
  [511] = {.lex_state = 184, .external_lex_state = 5},
  [512] = {.lex_state = 184, .external_lex_state = 5},
  [513] = {.lex_state = 184, .external_lex_state = 5},
  [514] = {.lex_state = 184, .external_lex_state = 5},
  [515] = {.lex_state = 184, .external_lex_state = 5},
  [516] = {.lex_state = 9, .external_lex_state = 13},
  [517] = {.lex_state = 184, .external_lex_state = 5},
  [518] = {.lex_state = 184, .external_lex_state = 5},
  [519] = {.lex_state = 184, .external_lex_state = 5},
  [520] = {.lex_state = 184, .external_lex_state = 5},
  [521] = {.lex_state = 184, .external_lex_state = 5},
  [522] = {.lex_state = 184, .external_lex_state = 5},
  [523] = {.lex_state = 184, .external_lex_state = 5},
  [524] = {.lex_state = 184, .external_lex_state = 5},
  [525] = {.lex_state = 184, .external_lex_state = 5},
  [526] = {.lex_state = 184, .external_lex_state = 5},
  [527] = {.lex_state = 184, .external_lex_state = 5},
  [528] = {.lex_state = 184, .external_lex_state = 5},
  [529] = {.lex_state = 184, .external_lex_state = 5},
  [530] = {.lex_state = 184, .external_lex_state = 5},
  [531] = {.lex_state = 184, .external_lex_state = 5},
  [532] = {.lex_state = 184, .external_lex_state = 5},
  [533] = {.lex_state = 184, .external_lex_state = 5},
  [534] = {.lex_state = 11, .external_lex_state = 13},
  [535] = {.lex_state = 184, .external_lex_state = 5},
  [536] = {.lex_state = 184, .external_lex_state = 5},
  [537] = {.lex_state = 184, .external_lex_state = 5},
  [538] = {.lex_state = 184, .external_lex_state = 5},
  [539] = {.lex_state = 184, .external_lex_state = 5},
  [540] = {.lex_state = 184, .external_lex_state = 5},
  [541] = {.lex_state = 184, .external_lex_state = 5},
  [542] = {.lex_state = 184, .external_lex_state = 5},
  [543] = {.lex_state = 184, .external_lex_state = 5},
  [544] = {.lex_state = 11, .external_lex_state = 13},
  [545] = {.lex_state = 184, .external_lex_state = 5},
  [546] = {.lex_state = 184, .external_lex_state = 5},
  [547] = {.lex_state = 184, .external_lex_state = 5},
  [548] = {.lex_state = 184, .external_lex_state = 5},
  [549] = {.lex_state = 184, .external_lex_state = 5},
  [550] = {.lex_state = 184, .external_lex_state = 5},
  [551] = {.lex_state = 184, .external_lex_state = 5},
  [552] = {.lex_state = 13, .external_lex_state = 5},
  [553] = {.lex_state = 184, .external_lex_state = 5},
  [554] = {.lex_state = 15, .external_lex_state = 5},
  [555] = {.lex_state = 184, .external_lex_state = 5},
  [556] = {.lex_state = 184, .external_lex_state = 5},
  [557] = {.lex_state = 184, .external_lex_state = 5},
  [558] = {.lex_state = 13, .external_lex_state = 5},
  [559] = {.lex_state = 184, .external_lex_state = 5},
  [560] = {.lex_state = 184, .external_lex_state = 5},
  [561] = {.lex_state = 17, .external_lex_state = 13},
  [562] = {.lex_state = 184, .external_lex_state = 5},
  [563] = {.lex_state = 184, .external_lex_state = 5},
  [564] = {.lex_state = 188, .external_lex_state = 5},
  [565] = {.lex_state = 184, .external_lex_state = 5},
  [566] = {.lex_state = 184, .external_lex_state = 5},
  [567] = {.lex_state = 184, .external_lex_state = 5},
  [568] = {.lex_state = 184, .external_lex_state = 5},
  [569] = {.lex_state = 184, .external_lex_state = 5},
  [570] = {.lex_state = 184, .external_lex_state = 5},
  [571] = {.lex_state = 184, .external_lex_state = 5},
  [572] = {.lex_state = 184, .external_lex_state = 5},
  [573] = {.lex_state = 15, .external_lex_state = 5},
  [574] = {.lex_state = 184, .external_lex_state = 5},
  [575] = {.lex_state = 184, .external_lex_state = 5},
  [576] = {.lex_state = 184, .external_lex_state = 5},
  [577] = {.lex_state = 184, .external_lex_state = 5},
  [578] = {.lex_state = 184, .external_lex_state = 5},
  [579] = {.lex_state = 184, .external_lex_state = 5},
  [580] = {.lex_state = 184, .external_lex_state = 5},
  [581] = {.lex_state = 17, .external_lex_state = 13},
  [582] = {.lex_state = 184, .external_lex_state = 5},
  [583] = {.lex_state = 184, .external_lex_state = 5},
  [584] = {.lex_state = 184, .external_lex_state = 5},
  [585] = {.lex_state = 184, .external_lex_state = 5},
  [586] = {.lex_state = 184, .external_lex_state = 5},
  [587] = {.lex_state = 184, .external_lex_state = 5},
  [588] = {.lex_state = 184, .external_lex_state = 5},
  [589] = {.lex_state = 184, .external_lex_state = 5},
  [590] = {.lex_state = 184, .external_lex_state = 5},
  [591] = {.lex_state = 188, .external_lex_state = 5},
  [592] = {.lex_state = 184, .external_lex_state = 5},
  [593] = {.lex_state = 18, .external_lex_state = 13},
  [594] = {.lex_state = 18, .external_lex_state = 13},
  [595] = {.lex_state = 188, .external_lex_state = 5},
  [596] = {.lex_state = 188, .external_lex_state = 5},
  [597] = {.lex_state = 184, .external_lex_state = 5},
  [598] = {.lex_state = 184, .external_lex_state = 5},
  [599] = {.lex_state = 184, .external_lex_state = 5},
  [600] = {.lex_state = 184, .external_lex_state = 5},
  [601] = {.lex_state = 184, .external_lex_state = 5},
  [602] = {.lex_state = 184, .external_lex_state = 5},
  [603] = {.lex_state = 184, .external_lex_state = 5},
  [604] = {.lex_state = 184, .external_lex_state = 5},
  [605] = {.lex_state = 184, .external_lex_state = 5},
  [606] = {.lex_state = 184, .external_lex_state = 5},
  [607] = {.lex_state = 184, .external_lex_state = 5},
  [608] = {.lex_state = 184, .external_lex_state = 5},
  [609] = {.lex_state = 184, .external_lex_state = 5},
  [610] = {.lex_state = 184, .external_lex_state = 5},
  [611] = {.lex_state = 184, .external_lex_state = 5},
  [612] = {.lex_state = 184, .external_lex_state = 5},
  [613] = {.lex_state = 184, .external_lex_state = 5},
  [614] = {.lex_state = 184, .external_lex_state = 5},
  [615] = {.lex_state = 184, .external_lex_state = 5},
  [616] = {.lex_state = 184, .external_lex_state = 5},
  [617] = {.lex_state = 184, .external_lex_state = 5},
  [618] = {.lex_state = 184, .external_lex_state = 5},
  [619] = {.lex_state = 184, .external_lex_state = 5},
  [620] = {.lex_state = 184, .external_lex_state = 5},
  [621] = {.lex_state = 184, .external_lex_state = 5},
  [622] = {.lex_state = 184, .external_lex_state = 5},
  [623] = {.lex_state = 184, .external_lex_state = 5},
  [624] = {.lex_state = 20, .external_lex_state = 5},
  [625] = {.lex_state = 184, .external_lex_state = 5},
  [626] = {.lex_state = 184, .external_lex_state = 5},
  [627] = {.lex_state = 184, .external_lex_state = 5},
  [628] = {.lex_state = 184, .external_lex_state = 5},
  [629] = {.lex_state = 184, .external_lex_state = 5},
  [630] = {.lex_state = 184, .external_lex_state = 5},
  [631] = {.lex_state = 184, .external_lex_state = 5},
  [632] = {.lex_state = 184, .external_lex_state = 5},
  [633] = {.lex_state = 184, .external_lex_state = 5},
  [634] = {.lex_state = 184, .external_lex_state = 5},
  [635] = {.lex_state = 184, .external_lex_state = 5},
  [636] = {.lex_state = 184, .external_lex_state = 5},
  [637] = {.lex_state = 184, .external_lex_state = 5},
  [638] = {.lex_state = 184, .external_lex_state = 5},
  [639] = {.lex_state = 184, .external_lex_state = 5},
  [640] = {.lex_state = 184, .external_lex_state = 5},
  [641] = {.lex_state = 184, .external_lex_state = 5},
  [642] = {.lex_state = 184, .external_lex_state = 5},
  [643] = {.lex_state = 184, .external_lex_state = 5},
  [644] = {.lex_state = 184, .external_lex_state = 5},
  [645] = {.lex_state = 184, .external_lex_state = 5},
  [646] = {.lex_state = 184, .external_lex_state = 5},
  [647] = {.lex_state = 20, .external_lex_state = 5},
  [648] = {.lex_state = 184, .external_lex_state = 5},
  [649] = {.lex_state = 184, .external_lex_state = 5},
  [650] = {.lex_state = 184, .external_lex_state = 5},
  [651] = {.lex_state = 184, .external_lex_state = 5},
  [652] = {.lex_state = 184, .external_lex_state = 5},
  [653] = {.lex_state = 184, .external_lex_state = 5},
  [654] = {.lex_state = 20, .external_lex_state = 5},
  [655] = {.lex_state = 20, .external_lex_state = 5},
  [656] = {.lex_state = 184, .external_lex_state = 5},
  [657] = {.lex_state = 184, .external_lex_state = 5},
  [658] = {.lex_state = 184, .external_lex_state = 5},
  [659] = {.lex_state = 184, .external_lex_state = 5},
  [660] = {.lex_state = 184, .external_lex_state = 5},
  [661] = {.lex_state = 184, .external_lex_state = 5},
  [662] = {.lex_state = 184, .external_lex_state = 4},
  [663] = {.lex_state = 184, .external_lex_state = 4},
  [664] = {.lex_state = 184, .external_lex_state = 4},
  [665] = {.lex_state = 184, .external_lex_state = 4},
  [666] = {.lex_state = 1, .external_lex_state = 6},
  [667] = {.lex_state = 184, .external_lex_state = 4},
  [668] = {.lex_state = 184, .external_lex_state = 4},
  [669] = {.lex_state = 184, .external_lex_state = 4},
  [670] = {.lex_state = 184, .external_lex_state = 4},
  [671] = {.lex_state = 1, .external_lex_state = 6},
  [672] = {.lex_state = 1, .external_lex_state = 6},
  [673] = {.lex_state = 184, .external_lex_state = 4},
  [674] = {.lex_state = 184, .external_lex_state = 5},
  [675] = {.lex_state = 184, .external_lex_state = 5},
  [676] = {.lex_state = 21, .external_lex_state = 16},
  [677] = {.lex_state = 21, .external_lex_state = 16},
  [678] = {.lex_state = 21, .external_lex_state = 16},
  [679] = {.lex_state = 21, .external_lex_state = 16},
  [680] = {.lex_state = 21, .external_lex_state = 16},
  [681] = {.lex_state = 21, .external_lex_state = 16},
  [682] = {.lex_state = 21, .external_lex_state = 16},
  [683] = {.lex_state = 21, .external_lex_state = 16},
  [684] = {.lex_state = 21, .external_lex_state = 16},
  [685] = {.lex_state = 21, .external_lex_state = 16},
  [686] = {.lex_state = 21, .external_lex_state = 16},
  [687] = {.lex_state = 21, .external_lex_state = 16},
  [688] = {.lex_state = 21, .external_lex_state = 16},
  [689] = {.lex_state = 21, .external_lex_state = 16},
  [690] = {.lex_state = 21, .external_lex_state = 16},
  [691] = {.lex_state = 21, .external_lex_state = 16},
  [692] = {.lex_state = 21, .external_lex_state = 16},
  [693] = {.lex_state = 21, .external_lex_state = 16},
  [694] = {.lex_state = 21, .external_lex_state = 16},
  [695] = {.lex_state = 21, .external_lex_state = 16},
  [696] = {.lex_state = 21, .external_lex_state = 16},
  [697] = {.lex_state = 21, .external_lex_state = 16},
  [698] = {.lex_state = 21, .external_lex_state = 16},
  [699] = {.lex_state = 21, .external_lex_state = 16},
  [700] = {.lex_state = 21, .external_lex_state = 16},
  [701] = {.lex_state = 21, .external_lex_state = 16},
  [702] = {.lex_state = 21, .external_lex_state = 16},
  [703] = {.lex_state = 21, .external_lex_state = 16},
  [704] = {.lex_state = 21, .external_lex_state = 16},
  [705] = {.lex_state = 21, .external_lex_state = 16},
  [706] = {.lex_state = 21, .external_lex_state = 16},
  [707] = {.lex_state = 21, .external_lex_state = 16},
  [708] = {.lex_state = 21, .external_lex_state = 16},
  [709] = {.lex_state = 21, .external_lex_state = 16},
  [710] = {.lex_state = 21, .external_lex_state = 16},
  [711] = {.lex_state = 21, .external_lex_state = 16},
  [712] = {.lex_state = 21, .external_lex_state = 16},
  [713] = {.lex_state = 21, .external_lex_state = 16},
  [714] = {.lex_state = 21, .external_lex_state = 16},
  [715] = {.lex_state = 21, .external_lex_state = 16},
  [716] = {.lex_state = 21, .external_lex_state = 16},
  [717] = {.lex_state = 21, .external_lex_state = 16},
  [718] = {.lex_state = 21, .external_lex_state = 16},
  [719] = {.lex_state = 21, .external_lex_state = 16},
  [720] = {.lex_state = 21, .external_lex_state = 16},
  [721] = {.lex_state = 21, .external_lex_state = 16},
  [722] = {.lex_state = 21, .external_lex_state = 16},
  [723] = {.lex_state = 21, .external_lex_state = 16},
  [724] = {.lex_state = 21, .external_lex_state = 16},
  [725] = {.lex_state = 21, .external_lex_state = 16},
  [726] = {.lex_state = 21, .external_lex_state = 16},
  [727] = {.lex_state = 21, .external_lex_state = 16},
  [728] = {.lex_state = 21, .external_lex_state = 16},
  [729] = {.lex_state = 21, .external_lex_state = 16},
  [730] = {.lex_state = 21, .external_lex_state = 16},
  [731] = {.lex_state = 21, .external_lex_state = 16},
  [732] = {.lex_state = 21, .external_lex_state = 16},
  [733] = {.lex_state = 21, .external_lex_state = 16},
  [734] = {.lex_state = 21, .external_lex_state = 16},
  [735] = {.lex_state = 21, .external_lex_state = 16},
  [736] = {.lex_state = 21, .external_lex_state = 16},
  [737] = {.lex_state = 21, .external_lex_state = 16},
  [738] = {.lex_state = 21, .external_lex_state = 16},
  [739] = {.lex_state = 21, .external_lex_state = 16},
  [740] = {.lex_state = 21, .external_lex_state = 16},
  [741] = {.lex_state = 21, .external_lex_state = 16},
  [742] = {.lex_state = 21, .external_lex_state = 16},
  [743] = {.lex_state = 21, .external_lex_state = 16},
  [744] = {.lex_state = 21, .external_lex_state = 16},
  [745] = {.lex_state = 21, .external_lex_state = 16},
  [746] = {.lex_state = 21, .external_lex_state = 16},
  [747] = {.lex_state = 21, .external_lex_state = 16},
  [748] = {.lex_state = 21, .external_lex_state = 16},
  [749] = {.lex_state = 21, .external_lex_state = 16},
  [750] = {.lex_state = 21, .external_lex_state = 16},
  [751] = {.lex_state = 21, .external_lex_state = 16},
  [752] = {.lex_state = 21, .external_lex_state = 16},
  [753] = {.lex_state = 21, .external_lex_state = 16},
  [754] = {.lex_state = 21, .external_lex_state = 16},
  [755] = {.lex_state = 21, .external_lex_state = 16},
  [756] = {.lex_state = 21, .external_lex_state = 16},
  [757] = {.lex_state = 21, .external_lex_state = 16},
  [758] = {.lex_state = 21, .external_lex_state = 16},
  [759] = {.lex_state = 21, .external_lex_state = 16},
  [760] = {.lex_state = 21, .external_lex_state = 16},
  [761] = {.lex_state = 21, .external_lex_state = 16},
  [762] = {.lex_state = 190, .external_lex_state = 3},
  [763] = {.lex_state = 190, .external_lex_state = 3},
  [764] = {.lex_state = 190, .external_lex_state = 3},
  [765] = {.lex_state = 190, .external_lex_state = 3},
  [766] = {.lex_state = 190, .external_lex_state = 3},
  [767] = {.lex_state = 190, .external_lex_state = 3},
  [768] = {.lex_state = 190, .external_lex_state = 3},
  [769] = {.lex_state = 190, .external_lex_state = 3},
  [770] = {.lex_state = 190, .external_lex_state = 3},
  [771] = {.lex_state = 190, .external_lex_state = 3},
  [772] = {.lex_state = 190, .external_lex_state = 3},
  [773] = {.lex_state = 190, .external_lex_state = 3},
  [774] = {.lex_state = 190, .external_lex_state = 3},
  [775] = {.lex_state = 190, .external_lex_state = 3},
  [776] = {.lex_state = 190, .external_lex_state = 3},
  [777] = {.lex_state = 190, .external_lex_state = 3},
  [778] = {.lex_state = 190, .external_lex_state = 3},
  [779] = {.lex_state = 190, .external_lex_state = 3},
  [780] = {.lex_state = 190, .external_lex_state = 3},
  [781] = {.lex_state = 190, .external_lex_state = 3},
  [782] = {.lex_state = 190, .external_lex_state = 3},
  [783] = {.lex_state = 190, .external_lex_state = 3},
  [784] = {.lex_state = 191, .external_lex_state = 7},
  [785] = {.lex_state = 190, .external_lex_state = 3},
  [786] = {.lex_state = 190, .external_lex_state = 3},
  [787] = {.lex_state = 190, .external_lex_state = 3},
  [788] = {.lex_state = 190, .external_lex_state = 3},
  [789] = {.lex_state = 190, .external_lex_state = 3},
  [790] = {.lex_state = 184, .external_lex_state = 5},
  [791] = {.lex_state = 190, .external_lex_state = 3},
  [792] = {.lex_state = 190, .external_lex_state = 3},
  [793] = {.lex_state = 190, .external_lex_state = 3},
  [794] = {.lex_state = 190, .external_lex_state = 3},
  [795] = {.lex_state = 190, .external_lex_state = 3},
  [796] = {.lex_state = 190, .external_lex_state = 3},
  [797] = {.lex_state = 190, .external_lex_state = 3},
  [798] = {.lex_state = 190, .external_lex_state = 3},
  [799] = {.lex_state = 190, .external_lex_state = 3},
  [800] = {.lex_state = 190, .external_lex_state = 3},
  [801] = {.lex_state = 190, .external_lex_state = 3},
  [802] = {.lex_state = 190, .external_lex_state = 3},
  [803] = {.lex_state = 190, .external_lex_state = 3},
  [804] = {.lex_state = 190, .external_lex_state = 3},
  [805] = {.lex_state = 190, .external_lex_state = 3},
  [806] = {.lex_state = 191, .external_lex_state = 9},
  [807] = {.lex_state = 190, .external_lex_state = 3},
  [808] = {.lex_state = 184, .external_lex_state = 5},
  [809] = {.lex_state = 184, .external_lex_state = 5},
  [810] = {.lex_state = 184, .external_lex_state = 5},
  [811] = {.lex_state = 184, .external_lex_state = 5},
  [812] = {.lex_state = 184, .external_lex_state = 5},
  [813] = {.lex_state = 184, .external_lex_state = 5},
  [814] = {.lex_state = 184, .external_lex_state = 5},
  [815] = {.lex_state = 184, .external_lex_state = 5},
  [816] = {.lex_state = 184, .external_lex_state = 5},
  [817] = {.lex_state = 184, .external_lex_state = 5},
  [818] = {.lex_state = 184, .external_lex_state = 5},
  [819] = {.lex_state = 184, .external_lex_state = 5},
  [820] = {.lex_state = 184, .external_lex_state = 5},
  [821] = {.lex_state = 184, .external_lex_state = 5},
  [822] = {.lex_state = 184, .external_lex_state = 5},
  [823] = {.lex_state = 184, .external_lex_state = 5},
  [824] = {.lex_state = 184, .external_lex_state = 5},
  [825] = {.lex_state = 191, .external_lex_state = 11},
  [826] = {.lex_state = 191, .external_lex_state = 10},
  [827] = {.lex_state = 191, .external_lex_state = 10},
  [828] = {.lex_state = 191, .external_lex_state = 11},
  [829] = {.lex_state = 191, .external_lex_state = 11},
  [830] = {.lex_state = 191, .external_lex_state = 10},
  [831] = {.lex_state = 191, .external_lex_state = 17},
  [832] = {.lex_state = 191, .external_lex_state = 17},
  [833] = {.lex_state = 191, .external_lex_state = 17},
  [834] = {.lex_state = 191, .external_lex_state = 18},
  [835] = {.lex_state = 191, .external_lex_state = 17},
  [836] = {.lex_state = 191, .external_lex_state = 18},
  [837] = {.lex_state = 191, .external_lex_state = 18},
  [838] = {.lex_state = 191, .external_lex_state = 18},
  [839] = {.lex_state = 191, .external_lex_state = 18},
  [840] = {.lex_state = 191, .external_lex_state = 11},
  [841] = {.lex_state = 191, .external_lex_state = 11},
  [842] = {.lex_state = 191, .external_lex_state = 10},
  [843] = {.lex_state = 191, .external_lex_state = 18},
  [844] = {.lex_state = 191, .external_lex_state = 17},
  [845] = {.lex_state = 191, .external_lex_state = 11},
  [846] = {.lex_state = 191, .external_lex_state = 10},
  [847] = {.lex_state = 191, .external_lex_state = 18},
  [848] = {.lex_state = 191, .external_lex_state = 17},
  [849] = {.lex_state = 191, .external_lex_state = 17},
  [850] = {.lex_state = 191, .external_lex_state = 10},
  [851] = {.lex_state = 184, .external_lex_state = 5},
  [852] = {.lex_state = 184, .external_lex_state = 5},
  [853] = {.lex_state = 184, .external_lex_state = 5},
  [854] = {.lex_state = 184, .external_lex_state = 5},
  [855] = {.lex_state = 184, .external_lex_state = 5},
  [856] = {.lex_state = 184, .external_lex_state = 5},
  [857] = {.lex_state = 184, .external_lex_state = 5},
  [858] = {.lex_state = 184, .external_lex_state = 5},
  [859] = {.lex_state = 184, .external_lex_state = 5},
  [860] = {.lex_state = 184, .external_lex_state = 5},
  [861] = {.lex_state = 184, .external_lex_state = 5},
  [862] = {.lex_state = 184, .external_lex_state = 5},
  [863] = {.lex_state = 184, .external_lex_state = 5},
  [864] = {.lex_state = 184, .external_lex_state = 5},
  [865] = {.lex_state = 184, .external_lex_state = 5},
  [866] = {.lex_state = 184, .external_lex_state = 5},
  [867] = {.lex_state = 184, .external_lex_state = 5},
  [868] = {.lex_state = 184, .external_lex_state = 5},
  [869] = {.lex_state = 184, .external_lex_state = 5},
  [870] = {.lex_state = 184, .external_lex_state = 5},
  [871] = {.lex_state = 184, .external_lex_state = 5},
  [872] = {.lex_state = 184, .external_lex_state = 5},
  [873] = {.lex_state = 184, .external_lex_state = 5},
  [874] = {.lex_state = 184, .external_lex_state = 5},
  [875] = {.lex_state = 184, .external_lex_state = 5},
  [876] = {.lex_state = 184, .external_lex_state = 5},
  [877] = {.lex_state = 184, .external_lex_state = 5},
  [878] = {.lex_state = 184, .external_lex_state = 5},
  [879] = {.lex_state = 184, .external_lex_state = 4},
  [880] = {.lex_state = 184, .external_lex_state = 4},
  [881] = {.lex_state = 184, .external_lex_state = 4},
  [882] = {.lex_state = 184, .external_lex_state = 4},
  [883] = {.lex_state = 184, .external_lex_state = 4},
  [884] = {.lex_state = 184, .external_lex_state = 4},
  [885] = {.lex_state = 191, .external_lex_state = 5},
  [886] = {.lex_state = 184, .external_lex_state = 4},
  [887] = {.lex_state = 184, .external_lex_state = 4},
  [888] = {.lex_state = 191, .external_lex_state = 13},
  [889] = {.lex_state = 184, .external_lex_state = 4},
  [890] = {.lex_state = 191, .external_lex_state = 5},
  [891] = {.lex_state = 184, .external_lex_state = 4},
  [892] = {.lex_state = 191, .external_lex_state = 13},
  [893] = {.lex_state = 184, .external_lex_state = 4},
  [894] = {.lex_state = 184, .external_lex_state = 4},
  [895] = {.lex_state = 184, .external_lex_state = 4},
  [896] = {.lex_state = 184, .external_lex_state = 4},
  [897] = {.lex_state = 184, .external_lex_state = 4},
  [898] = {.lex_state = 184, .external_lex_state = 4},
  [899] = {.lex_state = 184, .external_lex_state = 4},
  [900] = {.lex_state = 184, .external_lex_state = 4},
  [901] = {.lex_state = 184, .external_lex_state = 4},
  [902] = {.lex_state = 191, .external_lex_state = 13},
  [903] = {.lex_state = 23, .external_lex_state = 13},
  [904] = {.lex_state = 191, .external_lex_state = 5},
  [905] = {.lex_state = 184, .external_lex_state = 4},
  [906] = {.lex_state = 184, .external_lex_state = 4},
  [907] = {.lex_state = 184, .external_lex_state = 4},
  [908] = {.lex_state = 184, .external_lex_state = 4},
  [909] = {.lex_state = 23, .external_lex_state = 13},
  [910] = {.lex_state = 184, .external_lex_state = 4},
  [911] = {.lex_state = 184, .external_lex_state = 4},
  [912] = {.lex_state = 184, .external_lex_state = 4},
  [913] = {.lex_state = 184, .external_lex_state = 4},
  [914] = {.lex_state = 184, .external_lex_state = 4},
  [915] = {.lex_state = 23, .external_lex_state = 13},
  [916] = {.lex_state = 184, .external_lex_state = 5},
  [917] = {.lex_state = 184, .external_lex_state = 4},
  [918] = {.lex_state = 184, .external_lex_state = 4},
  [919] = {.lex_state = 184, .external_lex_state = 4},
  [920] = {.lex_state = 184, .external_lex_state = 4},
  [921] = {.lex_state = 184, .external_lex_state = 4},
  [922] = {.lex_state = 184, .external_lex_state = 4},
  [923] = {.lex_state = 184, .external_lex_state = 4},
  [924] = {.lex_state = 184, .external_lex_state = 4},
  [925] = {.lex_state = 184, .external_lex_state = 4},
  [926] = {.lex_state = 184, .external_lex_state = 4},
  [927] = {.lex_state = 184, .external_lex_state = 4},
  [928] = {.lex_state = 184, .external_lex_state = 4},
  [929] = {.lex_state = 184, .external_lex_state = 4},
  [930] = {.lex_state = 184, .external_lex_state = 4},
  [931] = {.lex_state = 184, .external_lex_state = 4},
  [932] = {.lex_state = 184, .external_lex_state = 4},
  [933] = {.lex_state = 184, .external_lex_state = 4},
  [934] = {.lex_state = 184, .external_lex_state = 4},
  [935] = {.lex_state = 184, .external_lex_state = 4},
  [936] = {.lex_state = 184, .external_lex_state = 4},
  [937] = {.lex_state = 184, .external_lex_state = 4},
  [938] = {.lex_state = 184, .external_lex_state = 4},
  [939] = {.lex_state = 191, .external_lex_state = 5},
  [940] = {.lex_state = 184, .external_lex_state = 4},
  [941] = {.lex_state = 184, .external_lex_state = 4},
  [942] = {.lex_state = 184, .external_lex_state = 5},
  [943] = {.lex_state = 184, .external_lex_state = 4},
  [944] = {.lex_state = 191, .external_lex_state = 5},
  [945] = {.lex_state = 184, .external_lex_state = 4},
  [946] = {.lex_state = 184, .external_lex_state = 4},
  [947] = {.lex_state = 24, .external_lex_state = 8},
  [948] = {.lex_state = 192, .external_lex_state = 9},
  [949] = {.lex_state = 24, .external_lex_state = 8},
  [950] = {.lex_state = 192, .external_lex_state = 9},
  [951] = {.lex_state = 26, .external_lex_state = 5},
  [952] = {.lex_state = 24, .external_lex_state = 8},
  [953] = {.lex_state = 26, .external_lex_state = 5},
  [954] = {.lex_state = 190, .external_lex_state = 11},
  [955] = {.lex_state = 24, .external_lex_state = 8},
  [956] = {.lex_state = 190, .external_lex_state = 10},
  [957] = {.lex_state = 192, .external_lex_state = 9},
  [958] = {.lex_state = 190, .external_lex_state = 11},
  [959] = {.lex_state = 190, .external_lex_state = 11},
  [960] = {.lex_state = 192, .external_lex_state = 9},
  [961] = {.lex_state = 28, .external_lex_state = 19},
  [962] = {.lex_state = 28, .external_lex_state = 19},
  [963] = {.lex_state = 30, .external_lex_state = 16},
  [964] = {.lex_state = 30, .external_lex_state = 16},
  [965] = {.lex_state = 190, .external_lex_state = 10},
  [966] = {.lex_state = 26, .external_lex_state = 5},
  [967] = {.lex_state = 24, .external_lex_state = 8},
  [968] = {.lex_state = 192, .external_lex_state = 7},
  [969] = {.lex_state = 192, .external_lex_state = 9},
  [970] = {.lex_state = 184, .external_lex_state = 5},
  [971] = {.lex_state = 192, .external_lex_state = 7},
  [972] = {.lex_state = 192, .external_lex_state = 7},
  [973] = {.lex_state = 192, .external_lex_state = 7},
  [974] = {.lex_state = 192, .external_lex_state = 7},
  [975] = {.lex_state = 190, .external_lex_state = 10},
  [976] = {.lex_state = 28, .external_lex_state = 19},
  [977] = {.lex_state = 30, .external_lex_state = 16},
  [978] = {.lex_state = 184, .external_lex_state = 5},
  [979] = {.lex_state = 31, .external_lex_state = 12},
  [980] = {.lex_state = 193, .external_lex_state = 11},
  [981] = {.lex_state = 190, .external_lex_state = 20},
  [982] = {.lex_state = 190, .external_lex_state = 20},
  [983] = {.lex_state = 194, .external_lex_state = 11},
  [984] = {.lex_state = 194, .external_lex_state = 11},
  [985] = {.lex_state = 194, .external_lex_state = 11},
  [986] = {.lex_state = 184, .external_lex_state = 5},
  [987] = {.lex_state = 190, .external_lex_state = 20},
  [988] = {.lex_state = 193, .external_lex_state = 11},
  [989] = {.lex_state = 193, .external_lex_state = 10},
  [990] = {.lex_state = 193, .external_lex_state = 11},
  [991] = {.lex_state = 184, .external_lex_state = 5},
  [992] = {.lex_state = 194, .external_lex_state = 11},
  [993] = {.lex_state = 194, .external_lex_state = 11},
  [994] = {.lex_state = 184, .external_lex_state = 5},
  [995] = {.lex_state = 184, .external_lex_state = 5},
  [996] = {.lex_state = 184, .external_lex_state = 5},
  [997] = {.lex_state = 193, .external_lex_state = 10},
  [998] = {.lex_state = 184, .external_lex_state = 5},
  [999] = {.lex_state = 184, .external_lex_state = 5},
  [1000] = {.lex_state = 184, .external_lex_state = 5},
  [1001] = {.lex_state = 190, .external_lex_state = 15},
  [1002] = {.lex_state = 33, .external_lex_state = 5},
  [1003] = {.lex_state = 184, .external_lex_state = 5},
  [1004] = {.lex_state = 184, .external_lex_state = 5},
  [1005] = {.lex_state = 184, .external_lex_state = 5},
  [1006] = {.lex_state = 33, .external_lex_state = 5},
  [1007] = {.lex_state = 33, .external_lex_state = 5},
  [1008] = {.lex_state = 23, .external_lex_state = 5},
  [1009] = {.lex_state = 184, .external_lex_state = 5},
  [1010] = {.lex_state = 23, .external_lex_state = 5},
  [1011] = {.lex_state = 184, .external_lex_state = 5},
  [1012] = {.lex_state = 31, .external_lex_state = 12},
  [1013] = {.lex_state = 194, .external_lex_state = 10},
  [1014] = {.lex_state = 193, .external_lex_state = 11},
  [1015] = {.lex_state = 184, .external_lex_state = 5},
  [1016] = {.lex_state = 23, .external_lex_state = 5},
  [1017] = {.lex_state = 184, .external_lex_state = 5},
  [1018] = {.lex_state = 184, .external_lex_state = 5},
  [1019] = {.lex_state = 184, .external_lex_state = 5},
  [1020] = {.lex_state = 31, .external_lex_state = 12},
  [1021] = {.lex_state = 31, .external_lex_state = 12},
  [1022] = {.lex_state = 31, .external_lex_state = 12},
  [1023] = {.lex_state = 194, .external_lex_state = 10},
  [1024] = {.lex_state = 194, .external_lex_state = 10},
  [1025] = {.lex_state = 194, .external_lex_state = 10},
  [1026] = {.lex_state = 194, .external_lex_state = 10},
  [1027] = {.lex_state = 190, .external_lex_state = 15},
  [1028] = {.lex_state = 190, .external_lex_state = 15},
  [1029] = {.lex_state = 193, .external_lex_state = 10},
  [1030] = {.lex_state = 193, .external_lex_state = 10},
  [1031] = {.lex_state = 193, .external_lex_state = 10},
  [1032] = {.lex_state = 193, .external_lex_state = 11},
  [1033] = {.lex_state = 191, .external_lex_state = 5},
  [1034] = {.lex_state = 191, .external_lex_state = 5},
  [1035] = {.lex_state = 191, .external_lex_state = 5},
  [1036] = {.lex_state = 191, .external_lex_state = 5},
  [1037] = {.lex_state = 191, .external_lex_state = 5},
  [1038] = {.lex_state = 34, .external_lex_state = 13},
  [1039] = {.lex_state = 191, .external_lex_state = 5},
  [1040] = {.lex_state = 191, .external_lex_state = 5},
  [1041] = {.lex_state = 191, .external_lex_state = 5},
  [1042] = {.lex_state = 191, .external_lex_state = 5},
  [1043] = {.lex_state = 191, .external_lex_state = 5},
  [1044] = {.lex_state = 191, .external_lex_state = 5},
  [1045] = {.lex_state = 191, .external_lex_state = 5},
  [1046] = {.lex_state = 191, .external_lex_state = 5},
  [1047] = {.lex_state = 191, .external_lex_state = 5},
  [1048] = {.lex_state = 191, .external_lex_state = 5},
  [1049] = {.lex_state = 191, .external_lex_state = 5},
  [1050] = {.lex_state = 191, .external_lex_state = 5},
  [1051] = {.lex_state = 31, .external_lex_state = 14},
  [1052] = {.lex_state = 191, .external_lex_state = 5},
  [1053] = {.lex_state = 191, .external_lex_state = 5},
  [1054] = {.lex_state = 191, .external_lex_state = 5},
  [1055] = {.lex_state = 191, .external_lex_state = 5},
  [1056] = {.lex_state = 191, .external_lex_state = 5},
  [1057] = {.lex_state = 191, .external_lex_state = 5},
  [1058] = {.lex_state = 191, .external_lex_state = 5},
  [1059] = {.lex_state = 191, .external_lex_state = 5},
  [1060] = {.lex_state = 191, .external_lex_state = 5},
  [1061] = {.lex_state = 191, .external_lex_state = 5},
  [1062] = {.lex_state = 191, .external_lex_state = 5},
  [1063] = {.lex_state = 191, .external_lex_state = 5},
  [1064] = {.lex_state = 191, .external_lex_state = 5},
  [1065] = {.lex_state = 191, .external_lex_state = 5},
  [1066] = {.lex_state = 191, .external_lex_state = 5},
  [1067] = {.lex_state = 191, .external_lex_state = 5},
  [1068] = {.lex_state = 191, .external_lex_state = 5},
  [1069] = {.lex_state = 191, .external_lex_state = 5},
  [1070] = {.lex_state = 191, .external_lex_state = 5},
  [1071] = {.lex_state = 191, .external_lex_state = 5},
  [1072] = {.lex_state = 191, .external_lex_state = 5},
  [1073] = {.lex_state = 191, .external_lex_state = 5},
  [1074] = {.lex_state = 191, .external_lex_state = 5},
  [1075] = {.lex_state = 191, .external_lex_state = 5},
  [1076] = {.lex_state = 191, .external_lex_state = 5},
  [1077] = {.lex_state = 191, .external_lex_state = 5},
  [1078] = {.lex_state = 191, .external_lex_state = 5},
  [1079] = {.lex_state = 191, .external_lex_state = 5},
  [1080] = {.lex_state = 191, .external_lex_state = 5},
  [1081] = {.lex_state = 191, .external_lex_state = 5},
  [1082] = {.lex_state = 194, .external_lex_state = 15},
  [1083] = {.lex_state = 191, .external_lex_state = 5},
  [1084] = {.lex_state = 191, .external_lex_state = 5},
  [1085] = {.lex_state = 191, .external_lex_state = 5},
  [1086] = {.lex_state = 191, .external_lex_state = 5},
  [1087] = {.lex_state = 191, .external_lex_state = 5},
  [1088] = {.lex_state = 191, .external_lex_state = 5},
  [1089] = {.lex_state = 191, .external_lex_state = 5},
  [1090] = {.lex_state = 191, .external_lex_state = 5},
  [1091] = {.lex_state = 191, .external_lex_state = 5},
  [1092] = {.lex_state = 191, .external_lex_state = 5},
  [1093] = {.lex_state = 191, .external_lex_state = 5},
  [1094] = {.lex_state = 191, .external_lex_state = 5},
  [1095] = {.lex_state = 191, .external_lex_state = 5},
  [1096] = {.lex_state = 191, .external_lex_state = 5},
  [1097] = {.lex_state = 191, .external_lex_state = 5},
  [1098] = {.lex_state = 191, .external_lex_state = 5},
  [1099] = {.lex_state = 191, .external_lex_state = 5},
  [1100] = {.lex_state = 191, .external_lex_state = 5},
  [1101] = {.lex_state = 191, .external_lex_state = 5},
  [1102] = {.lex_state = 191, .external_lex_state = 5},
  [1103] = {.lex_state = 191, .external_lex_state = 5},
  [1104] = {.lex_state = 191, .external_lex_state = 5},
  [1105] = {.lex_state = 191, .external_lex_state = 5},
  [1106] = {.lex_state = 191, .external_lex_state = 5},
  [1107] = {.lex_state = 191, .external_lex_state = 5},
  [1108] = {.lex_state = 191, .external_lex_state = 5},
  [1109] = {.lex_state = 191, .external_lex_state = 5},
  [1110] = {.lex_state = 36, .external_lex_state = 5},
  [1111] = {.lex_state = 194, .external_lex_state = 15},
  [1112] = {.lex_state = 191, .external_lex_state = 5},
  [1113] = {.lex_state = 191, .external_lex_state = 5},
  [1114] = {.lex_state = 191, .external_lex_state = 5},
  [1115] = {.lex_state = 36, .external_lex_state = 5},
  [1116] = {.lex_state = 191, .external_lex_state = 5},
  [1117] = {.lex_state = 31, .external_lex_state = 14},
  [1118] = {.lex_state = 194, .external_lex_state = 15},
  [1119] = {.lex_state = 191, .external_lex_state = 5},
  [1120] = {.lex_state = 191, .external_lex_state = 5},
  [1121] = {.lex_state = 191, .external_lex_state = 5},
  [1122] = {.lex_state = 191, .external_lex_state = 5},
  [1123] = {.lex_state = 191, .external_lex_state = 5},
  [1124] = {.lex_state = 191, .external_lex_state = 5},
  [1125] = {.lex_state = 191, .external_lex_state = 5},
  [1126] = {.lex_state = 191, .external_lex_state = 5},
  [1127] = {.lex_state = 191, .external_lex_state = 5},
  [1128] = {.lex_state = 191, .external_lex_state = 5},
  [1129] = {.lex_state = 191, .external_lex_state = 5},
  [1130] = {.lex_state = 191, .external_lex_state = 5},
  [1131] = {.lex_state = 191, .external_lex_state = 5},
  [1132] = {.lex_state = 191, .external_lex_state = 5},
  [1133] = {.lex_state = 191, .external_lex_state = 5},
  [1134] = {.lex_state = 191, .external_lex_state = 5},
  [1135] = {.lex_state = 191, .external_lex_state = 5},
  [1136] = {.lex_state = 191, .external_lex_state = 5},
  [1137] = {.lex_state = 191, .external_lex_state = 5},
  [1138] = {.lex_state = 191, .external_lex_state = 5},
  [1139] = {.lex_state = 191, .external_lex_state = 5},
  [1140] = {.lex_state = 191, .external_lex_state = 5},
  [1141] = {.lex_state = 34, .external_lex_state = 13},
  [1142] = {.lex_state = 191, .external_lex_state = 5},
  [1143] = {.lex_state = 191, .external_lex_state = 5},
  [1144] = {.lex_state = 191, .external_lex_state = 5},
  [1145] = {.lex_state = 38, .external_lex_state = 16},
  [1146] = {.lex_state = 191, .external_lex_state = 5},
  [1147] = {.lex_state = 38, .external_lex_state = 16},
  [1148] = {.lex_state = 191, .external_lex_state = 5},
  [1149] = {.lex_state = 191, .external_lex_state = 5},
  [1150] = {.lex_state = 191, .external_lex_state = 5},
  [1151] = {.lex_state = 191, .external_lex_state = 5},
  [1152] = {.lex_state = 191, .external_lex_state = 5},
  [1153] = {.lex_state = 191, .external_lex_state = 5},
  [1154] = {.lex_state = 191, .external_lex_state = 5},
  [1155] = {.lex_state = 191, .external_lex_state = 5},
  [1156] = {.lex_state = 191, .external_lex_state = 5},
  [1157] = {.lex_state = 191, .external_lex_state = 5},
  [1158] = {.lex_state = 191, .external_lex_state = 5},
  [1159] = {.lex_state = 191, .external_lex_state = 5},
  [1160] = {.lex_state = 191, .external_lex_state = 5},
  [1161] = {.lex_state = 191, .external_lex_state = 5},
  [1162] = {.lex_state = 191, .external_lex_state = 5},
  [1163] = {.lex_state = 191, .external_lex_state = 5},
  [1164] = {.lex_state = 191, .external_lex_state = 5},
  [1165] = {.lex_state = 191, .external_lex_state = 5},
  [1166] = {.lex_state = 191, .external_lex_state = 5},
  [1167] = {.lex_state = 191, .external_lex_state = 5},
  [1168] = {.lex_state = 191, .external_lex_state = 5},
  [1169] = {.lex_state = 191, .external_lex_state = 5},
  [1170] = {.lex_state = 191, .external_lex_state = 5},
  [1171] = {.lex_state = 194, .external_lex_state = 15},
  [1172] = {.lex_state = 191, .external_lex_state = 5},
  [1173] = {.lex_state = 191, .external_lex_state = 5},
  [1174] = {.lex_state = 191, .external_lex_state = 5},
  [1175] = {.lex_state = 191, .external_lex_state = 5},
  [1176] = {.lex_state = 191, .external_lex_state = 5},
  [1177] = {.lex_state = 191, .external_lex_state = 5},
  [1178] = {.lex_state = 191, .external_lex_state = 5},
  [1179] = {.lex_state = 191, .external_lex_state = 5},
  [1180] = {.lex_state = 191, .external_lex_state = 5},
  [1181] = {.lex_state = 191, .external_lex_state = 5},
  [1182] = {.lex_state = 191, .external_lex_state = 5},
  [1183] = {.lex_state = 191, .external_lex_state = 5},
  [1184] = {.lex_state = 191, .external_lex_state = 5},
  [1185] = {.lex_state = 191, .external_lex_state = 5},
  [1186] = {.lex_state = 191, .external_lex_state = 5},
  [1187] = {.lex_state = 191, .external_lex_state = 5},
  [1188] = {.lex_state = 191, .external_lex_state = 5},
  [1189] = {.lex_state = 191, .external_lex_state = 5},
  [1190] = {.lex_state = 191, .external_lex_state = 5},
  [1191] = {.lex_state = 191, .external_lex_state = 5},
  [1192] = {.lex_state = 191, .external_lex_state = 5},
  [1193] = {.lex_state = 191, .external_lex_state = 5},
  [1194] = {.lex_state = 194, .external_lex_state = 13},
  [1195] = {.lex_state = 191, .external_lex_state = 5},
  [1196] = {.lex_state = 191, .external_lex_state = 5},
  [1197] = {.lex_state = 191, .external_lex_state = 5},
  [1198] = {.lex_state = 34, .external_lex_state = 13},
  [1199] = {.lex_state = 191, .external_lex_state = 5},
  [1200] = {.lex_state = 31, .external_lex_state = 14},
  [1201] = {.lex_state = 191, .external_lex_state = 5},
  [1202] = {.lex_state = 191, .external_lex_state = 5},
  [1203] = {.lex_state = 194, .external_lex_state = 15},
  [1204] = {.lex_state = 191, .external_lex_state = 5},
  [1205] = {.lex_state = 191, .external_lex_state = 5},
  [1206] = {.lex_state = 191, .external_lex_state = 5},
  [1207] = {.lex_state = 191, .external_lex_state = 5},
  [1208] = {.lex_state = 191, .external_lex_state = 5},
  [1209] = {.lex_state = 191, .external_lex_state = 5},
  [1210] = {.lex_state = 191, .external_lex_state = 5},
  [1211] = {.lex_state = 191, .external_lex_state = 5},
  [1212] = {.lex_state = 191, .external_lex_state = 5},
  [1213] = {.lex_state = 191, .external_lex_state = 5},
  [1214] = {.lex_state = 191, .external_lex_state = 5},
  [1215] = {.lex_state = 191, .external_lex_state = 5},
  [1216] = {.lex_state = 191, .external_lex_state = 5},
  [1217] = {.lex_state = 191, .external_lex_state = 5},
  [1218] = {.lex_state = 191, .external_lex_state = 5},
  [1219] = {.lex_state = 191, .external_lex_state = 5},
  [1220] = {.lex_state = 191, .external_lex_state = 5},
  [1221] = {.lex_state = 191, .external_lex_state = 5},
  [1222] = {.lex_state = 191, .external_lex_state = 5},
  [1223] = {.lex_state = 191, .external_lex_state = 5},
  [1224] = {.lex_state = 191, .external_lex_state = 5},
  [1225] = {.lex_state = 34, .external_lex_state = 13},
  [1226] = {.lex_state = 191, .external_lex_state = 5},
  [1227] = {.lex_state = 34, .external_lex_state = 13},
  [1228] = {.lex_state = 194, .external_lex_state = 13},
  [1229] = {.lex_state = 191, .external_lex_state = 5},
  [1230] = {.lex_state = 194, .external_lex_state = 13},
  [1231] = {.lex_state = 191, .external_lex_state = 5},
  [1232] = {.lex_state = 191, .external_lex_state = 5},
  [1233] = {.lex_state = 191, .external_lex_state = 5},
  [1234] = {.lex_state = 191, .external_lex_state = 5},
  [1235] = {.lex_state = 191, .external_lex_state = 5},
  [1236] = {.lex_state = 191, .external_lex_state = 5},
  [1237] = {.lex_state = 191, .external_lex_state = 5},
  [1238] = {.lex_state = 191, .external_lex_state = 5},
  [1239] = {.lex_state = 191, .external_lex_state = 5},
  [1240] = {.lex_state = 191, .external_lex_state = 5},
  [1241] = {.lex_state = 191, .external_lex_state = 5},
  [1242] = {.lex_state = 191, .external_lex_state = 5},
  [1243] = {.lex_state = 36, .external_lex_state = 5},
  [1244] = {.lex_state = 191, .external_lex_state = 5},
  [1245] = {.lex_state = 191, .external_lex_state = 5},
  [1246] = {.lex_state = 191, .external_lex_state = 5},
  [1247] = {.lex_state = 191, .external_lex_state = 5},
  [1248] = {.lex_state = 191, .external_lex_state = 5},
  [1249] = {.lex_state = 191, .external_lex_state = 5},
  [1250] = {.lex_state = 38, .external_lex_state = 16},
  [1251] = {.lex_state = 194, .external_lex_state = 13},
  [1252] = {.lex_state = 194, .external_lex_state = 13},
  [1253] = {.lex_state = 191, .external_lex_state = 5},
  [1254] = {.lex_state = 191, .external_lex_state = 5},
  [1255] = {.lex_state = 191, .external_lex_state = 5},
  [1256] = {.lex_state = 191, .external_lex_state = 5},
  [1257] = {.lex_state = 191, .external_lex_state = 5},
  [1258] = {.lex_state = 31, .external_lex_state = 14},
  [1259] = {.lex_state = 191, .external_lex_state = 5},
  [1260] = {.lex_state = 31, .external_lex_state = 14},
  [1261] = {.lex_state = 191, .external_lex_state = 5},
  [1262] = {.lex_state = 191, .external_lex_state = 5},
  [1263] = {.lex_state = 191, .external_lex_state = 5},
  [1264] = {.lex_state = 191, .external_lex_state = 5},
  [1265] = {.lex_state = 191, .external_lex_state = 5},
  [1266] = {.lex_state = 191, .external_lex_state = 5},
  [1267] = {.lex_state = 191, .external_lex_state = 5},
  [1268] = {.lex_state = 191, .external_lex_state = 5},
  [1269] = {.lex_state = 191, .external_lex_state = 5},
  [1270] = {.lex_state = 191, .external_lex_state = 5},
  [1271] = {.lex_state = 191, .external_lex_state = 5},
  [1272] = {.lex_state = 191, .external_lex_state = 5},
  [1273] = {.lex_state = 191, .external_lex_state = 5},
  [1274] = {.lex_state = 184, .external_lex_state = 5},
  [1275] = {.lex_state = 191, .external_lex_state = 5},
  [1276] = {.lex_state = 191, .external_lex_state = 5},
  [1277] = {.lex_state = 39, .external_lex_state = 13},
  [1278] = {.lex_state = 191, .external_lex_state = 5},
  [1279] = {.lex_state = 191, .external_lex_state = 5},
  [1280] = {.lex_state = 184, .external_lex_state = 5},
  [1281] = {.lex_state = 39, .external_lex_state = 13},
  [1282] = {.lex_state = 191, .external_lex_state = 5},
  [1283] = {.lex_state = 191, .external_lex_state = 5},
  [1284] = {.lex_state = 184, .external_lex_state = 5},
  [1285] = {.lex_state = 39, .external_lex_state = 13},
  [1286] = {.lex_state = 39, .external_lex_state = 13},
  [1287] = {.lex_state = 39, .external_lex_state = 13},
  [1288] = {.lex_state = 191, .external_lex_state = 5},
  [1289] = {.lex_state = 40, .external_lex_state = 13},
  [1290] = {.lex_state = 191, .external_lex_state = 5},
  [1291] = {.lex_state = 191, .external_lex_state = 5},
  [1292] = {.lex_state = 184, .external_lex_state = 5},
  [1293] = {.lex_state = 191, .external_lex_state = 5},
  [1294] = {.lex_state = 191, .external_lex_state = 5},
  [1295] = {.lex_state = 191, .external_lex_state = 5},
  [1296] = {.lex_state = 195, .external_lex_state = 11},
  [1297] = {.lex_state = 196, .external_lex_state = 18},
  [1298] = {.lex_state = 184, .external_lex_state = 5},
  [1299] = {.lex_state = 191, .external_lex_state = 5},
  [1300] = {.lex_state = 184, .external_lex_state = 5},
  [1301] = {.lex_state = 191, .external_lex_state = 5},
  [1302] = {.lex_state = 191, .external_lex_state = 5},
  [1303] = {.lex_state = 195, .external_lex_state = 10},
  [1304] = {.lex_state = 184, .external_lex_state = 5},
  [1305] = {.lex_state = 191, .external_lex_state = 5},
  [1306] = {.lex_state = 191, .external_lex_state = 5},
  [1307] = {.lex_state = 184, .external_lex_state = 5},
  [1308] = {.lex_state = 191, .external_lex_state = 5},
  [1309] = {.lex_state = 191, .external_lex_state = 5},
  [1310] = {.lex_state = 195, .external_lex_state = 10},
  [1311] = {.lex_state = 196, .external_lex_state = 17},
  [1312] = {.lex_state = 195, .external_lex_state = 11},
  [1313] = {.lex_state = 184, .external_lex_state = 5},
  [1314] = {.lex_state = 191, .external_lex_state = 5},
  [1315] = {.lex_state = 191, .external_lex_state = 5},
  [1316] = {.lex_state = 184, .external_lex_state = 5},
  [1317] = {.lex_state = 191, .external_lex_state = 5},
  [1318] = {.lex_state = 196, .external_lex_state = 17},
  [1319] = {.lex_state = 184, .external_lex_state = 5},
  [1320] = {.lex_state = 191, .external_lex_state = 5},
  [1321] = {.lex_state = 195, .external_lex_state = 10},
  [1322] = {.lex_state = 195, .external_lex_state = 11},
  [1323] = {.lex_state = 184, .external_lex_state = 5},
  [1324] = {.lex_state = 195, .external_lex_state = 10},
  [1325] = {.lex_state = 184, .external_lex_state = 5},
  [1326] = {.lex_state = 196, .external_lex_state = 17},
  [1327] = {.lex_state = 184, .external_lex_state = 5},
  [1328] = {.lex_state = 191, .external_lex_state = 5},
  [1329] = {.lex_state = 191, .external_lex_state = 5},
  [1330] = {.lex_state = 191, .external_lex_state = 5},
  [1331] = {.lex_state = 191, .external_lex_state = 5},
  [1332] = {.lex_state = 191, .external_lex_state = 5},
  [1333] = {.lex_state = 191, .external_lex_state = 5},
  [1334] = {.lex_state = 191, .external_lex_state = 5},
  [1335] = {.lex_state = 191, .external_lex_state = 5},
  [1336] = {.lex_state = 191, .external_lex_state = 5},
  [1337] = {.lex_state = 40, .external_lex_state = 13},
  [1338] = {.lex_state = 191, .external_lex_state = 5},
  [1339] = {.lex_state = 191, .external_lex_state = 5},
  [1340] = {.lex_state = 184, .external_lex_state = 5},
  [1341] = {.lex_state = 191, .external_lex_state = 5},
  [1342] = {.lex_state = 191, .external_lex_state = 5},
  [1343] = {.lex_state = 195, .external_lex_state = 10},
  [1344] = {.lex_state = 191, .external_lex_state = 5},
  [1345] = {.lex_state = 191, .external_lex_state = 5},
  [1346] = {.lex_state = 40, .external_lex_state = 13},
  [1347] = {.lex_state = 40, .external_lex_state = 13},
  [1348] = {.lex_state = 184, .external_lex_state = 5},
  [1349] = {.lex_state = 40, .external_lex_state = 13},
  [1350] = {.lex_state = 184, .external_lex_state = 5},
  [1351] = {.lex_state = 191, .external_lex_state = 5},
  [1352] = {.lex_state = 191, .external_lex_state = 5},
  [1353] = {.lex_state = 191, .external_lex_state = 5},
  [1354] = {.lex_state = 196, .external_lex_state = 17},
  [1355] = {.lex_state = 184, .external_lex_state = 5},
  [1356] = {.lex_state = 191, .external_lex_state = 5},
  [1357] = {.lex_state = 195, .external_lex_state = 11},
  [1358] = {.lex_state = 195, .external_lex_state = 11},
  [1359] = {.lex_state = 184, .external_lex_state = 5},
  [1360] = {.lex_state = 196, .external_lex_state = 18},
  [1361] = {.lex_state = 184, .external_lex_state = 5},
  [1362] = {.lex_state = 196, .external_lex_state = 18},
  [1363] = {.lex_state = 191, .external_lex_state = 5},
  [1364] = {.lex_state = 191, .external_lex_state = 5},
  [1365] = {.lex_state = 196, .external_lex_state = 18},
  [1366] = {.lex_state = 196, .external_lex_state = 17},
  [1367] = {.lex_state = 196, .external_lex_state = 18},
  [1368] = {.lex_state = 191, .external_lex_state = 5},
  [1369] = {.lex_state = 191, .external_lex_state = 5},
  [1370] = {.lex_state = 41, .external_lex_state = 8},
  [1371] = {.lex_state = 42, .external_lex_state = 5},
  [1372] = {.lex_state = 43, .external_lex_state = 5},
  [1373] = {.lex_state = 197, .external_lex_state = 9},
  [1374] = {.lex_state = 197, .external_lex_state = 9},
  [1375] = {.lex_state = 197, .external_lex_state = 7},
  [1376] = {.lex_state = 184, .external_lex_state = 5},
  [1377] = {.lex_state = 41, .external_lex_state = 8},
  [1378] = {.lex_state = 197, .external_lex_state = 9},
  [1379] = {.lex_state = 41, .external_lex_state = 8},
  [1380] = {.lex_state = 197, .external_lex_state = 7},
  [1381] = {.lex_state = 197, .external_lex_state = 7},
  [1382] = {.lex_state = 194, .external_lex_state = 5},
  [1383] = {.lex_state = 42, .external_lex_state = 5},
  [1384] = {.lex_state = 194, .external_lex_state = 5},
  [1385] = {.lex_state = 197, .external_lex_state = 7},
  [1386] = {.lex_state = 41, .external_lex_state = 8},
  [1387] = {.lex_state = 184, .external_lex_state = 16},
  [1388] = {.lex_state = 194, .external_lex_state = 5},
  [1389] = {.lex_state = 197, .external_lex_state = 7},
  [1390] = {.lex_state = 194, .external_lex_state = 5},
  [1391] = {.lex_state = 184, .external_lex_state = 16},
  [1392] = {.lex_state = 43, .external_lex_state = 5},
  [1393] = {.lex_state = 44, .external_lex_state = 13},
  [1394] = {.lex_state = 43, .external_lex_state = 5},
  [1395] = {.lex_state = 43, .external_lex_state = 5},
  [1396] = {.lex_state = 197, .external_lex_state = 9},
  [1397] = {.lex_state = 194, .external_lex_state = 5},
  [1398] = {.lex_state = 42, .external_lex_state = 5},
  [1399] = {.lex_state = 43, .external_lex_state = 5},
  [1400] = {.lex_state = 42, .external_lex_state = 5},
  [1401] = {.lex_state = 184, .external_lex_state = 16},
  [1402] = {.lex_state = 41, .external_lex_state = 8},
  [1403] = {.lex_state = 44, .external_lex_state = 13},
  [1404] = {.lex_state = 44, .external_lex_state = 13},
  [1405] = {.lex_state = 44, .external_lex_state = 13},
  [1406] = {.lex_state = 44, .external_lex_state = 13},
  [1407] = {.lex_state = 42, .external_lex_state = 5},
  [1408] = {.lex_state = 197, .external_lex_state = 9},
  [1409] = {.lex_state = 193, .external_lex_state = 5},
  [1410] = {.lex_state = 195, .external_lex_state = 13},
  [1411] = {.lex_state = 198, .external_lex_state = 10},
  [1412] = {.lex_state = 45, .external_lex_state = 5},
  [1413] = {.lex_state = 198, .external_lex_state = 11},
  [1414] = {.lex_state = 197, .external_lex_state = 19},
  [1415] = {.lex_state = 198, .external_lex_state = 10},
  [1416] = {.lex_state = 198, .external_lex_state = 10},
  [1417] = {.lex_state = 46, .external_lex_state = 12},
  [1418] = {.lex_state = 193, .external_lex_state = 5},
  [1419] = {.lex_state = 45, .external_lex_state = 5},
  [1420] = {.lex_state = 195, .external_lex_state = 13},
  [1421] = {.lex_state = 47, .external_lex_state = 13},
  [1422] = {.lex_state = 47, .external_lex_state = 13},
  [1423] = {.lex_state = 197, .external_lex_state = 19},
  [1424] = {.lex_state = 197, .external_lex_state = 19},
  [1425] = {.lex_state = 198, .external_lex_state = 11},
  [1426] = {.lex_state = 198, .external_lex_state = 11},
  [1427] = {.lex_state = 197, .external_lex_state = 19},
  [1428] = {.lex_state = 197, .external_lex_state = 19},
  [1429] = {.lex_state = 193, .external_lex_state = 5},
  [1430] = {.lex_state = 46, .external_lex_state = 12},
  [1431] = {.lex_state = 46, .external_lex_state = 12},
  [1432] = {.lex_state = 45, .external_lex_state = 5},
  [1433] = {.lex_state = 198, .external_lex_state = 11},
  [1434] = {.lex_state = 45, .external_lex_state = 5},
  [1435] = {.lex_state = 45, .external_lex_state = 5},
  [1436] = {.lex_state = 46, .external_lex_state = 12},
  [1437] = {.lex_state = 195, .external_lex_state = 13},
  [1438] = {.lex_state = 47, .external_lex_state = 13},
  [1439] = {.lex_state = 195, .external_lex_state = 13},
  [1440] = {.lex_state = 198, .external_lex_state = 10},
  [1441] = {.lex_state = 198, .external_lex_state = 10},
  [1442] = {.lex_state = 193, .external_lex_state = 5},
  [1443] = {.lex_state = 193, .external_lex_state = 5},
  [1444] = {.lex_state = 46, .external_lex_state = 12},
  [1445] = {.lex_state = 198, .external_lex_state = 11},
  [1446] = {.lex_state = 195, .external_lex_state = 13},
  [1447] = {.lex_state = 47, .external_lex_state = 13},
  [1448] = {.lex_state = 47, .external_lex_state = 13},
  [1449] = {.lex_state = 46, .external_lex_state = 14},
  [1450] = {.lex_state = 198, .external_lex_state = 15},
  [1451] = {.lex_state = 48, .external_lex_state = 5},
  [1452] = {.lex_state = 198, .external_lex_state = 13},
  [1453] = {.lex_state = 198, .external_lex_state = 20},
  [1454] = {.lex_state = 198, .external_lex_state = 13},
  [1455] = {.lex_state = 183, .external_lex_state = 5},
  [1456] = {.lex_state = 198, .external_lex_state = 20},
  [1457] = {.lex_state = 198, .external_lex_state = 20},
  [1458] = {.lex_state = 183, .external_lex_state = 5},
  [1459] = {.lex_state = 48, .external_lex_state = 5},
  [1460] = {.lex_state = 183, .external_lex_state = 5},
  [1461] = {.lex_state = 183, .external_lex_state = 5},
  [1462] = {.lex_state = 183, .external_lex_state = 5},
  [1463] = {.lex_state = 48, .external_lex_state = 5},
  [1464] = {.lex_state = 183, .external_lex_state = 5},
  [1465] = {.lex_state = 198, .external_lex_state = 13},
  [1466] = {.lex_state = 183, .external_lex_state = 5},
  [1467] = {.lex_state = 50, .external_lex_state = 15},
  [1468] = {.lex_state = 183, .external_lex_state = 5},
  [1469] = {.lex_state = 183, .external_lex_state = 5},
  [1470] = {.lex_state = 183, .external_lex_state = 5},
  [1471] = {.lex_state = 198, .external_lex_state = 13},
  [1472] = {.lex_state = 46, .external_lex_state = 14},
  [1473] = {.lex_state = 183, .external_lex_state = 5},
  [1474] = {.lex_state = 183, .external_lex_state = 5},
  [1475] = {.lex_state = 198, .external_lex_state = 20},
  [1476] = {.lex_state = 46, .external_lex_state = 14},
  [1477] = {.lex_state = 183, .external_lex_state = 5},
  [1478] = {.lex_state = 183, .external_lex_state = 5},
  [1479] = {.lex_state = 53, .external_lex_state = 14},
  [1480] = {.lex_state = 198, .external_lex_state = 13},
  [1481] = {.lex_state = 198, .external_lex_state = 15},
  [1482] = {.lex_state = 198, .external_lex_state = 15},
  [1483] = {.lex_state = 183, .external_lex_state = 5},
  [1484] = {.lex_state = 183, .external_lex_state = 5},
  [1485] = {.lex_state = 183, .external_lex_state = 5},
  [1486] = {.lex_state = 48, .external_lex_state = 5},
  [1487] = {.lex_state = 183, .external_lex_state = 5},
  [1488] = {.lex_state = 198, .external_lex_state = 15},
  [1489] = {.lex_state = 48, .external_lex_state = 5},
  [1490] = {.lex_state = 198, .external_lex_state = 20},
  [1491] = {.lex_state = 46, .external_lex_state = 14},
  [1492] = {.lex_state = 51, .external_lex_state = 21},
  [1493] = {.lex_state = 183, .external_lex_state = 5},
  [1494] = {.lex_state = 46, .external_lex_state = 14},
  [1495] = {.lex_state = 183, .external_lex_state = 5},
  [1496] = {.lex_state = 198, .external_lex_state = 15},
  [1497] = {.lex_state = 183, .external_lex_state = 5},
  [1498] = {.lex_state = 183, .external_lex_state = 5},
  [1499] = {.lex_state = 183, .external_lex_state = 5},
  [1500] = {.lex_state = 198, .external_lex_state = 5},
  [1501] = {.lex_state = 55, .external_lex_state = 16},
  [1502] = {.lex_state = 185, .external_lex_state = 9},
  [1503] = {.lex_state = 198, .external_lex_state = 5},
  [1504] = {.lex_state = 55, .external_lex_state = 16},
  [1505] = {.lex_state = 183, .external_lex_state = 5},
  [1506] = {.lex_state = 191, .external_lex_state = 15},
  [1507] = {.lex_state = 183, .external_lex_state = 5},
  [1508] = {.lex_state = 191, .external_lex_state = 20},
  [1509] = {.lex_state = 185, .external_lex_state = 9},
  [1510] = {.lex_state = 191, .external_lex_state = 15},
  [1511] = {.lex_state = 191, .external_lex_state = 20},
  [1512] = {.lex_state = 56, .external_lex_state = 13},
  [1513] = {.lex_state = 183, .external_lex_state = 5},
  [1514] = {.lex_state = 50, .external_lex_state = 15},
  [1515] = {.lex_state = 183, .external_lex_state = 5},
  [1516] = {.lex_state = 183, .external_lex_state = 5},
  [1517] = {.lex_state = 191, .external_lex_state = 20},
  [1518] = {.lex_state = 183, .external_lex_state = 5},
  [1519] = {.lex_state = 191, .external_lex_state = 15},
  [1520] = {.lex_state = 185, .external_lex_state = 9},
  [1521] = {.lex_state = 198, .external_lex_state = 5},
  [1522] = {.lex_state = 191, .external_lex_state = 15},
  [1523] = {.lex_state = 183, .external_lex_state = 5},
  [1524] = {.lex_state = 57, .external_lex_state = 5},
  [1525] = {.lex_state = 57, .external_lex_state = 5},
  [1526] = {.lex_state = 185, .external_lex_state = 7},
  [1527] = {.lex_state = 55, .external_lex_state = 16},
  [1528] = {.lex_state = 185, .external_lex_state = 7},
  [1529] = {.lex_state = 183, .external_lex_state = 5},
  [1530] = {.lex_state = 57, .external_lex_state = 5},
  [1531] = {.lex_state = 198, .external_lex_state = 5},
  [1532] = {.lex_state = 185, .external_lex_state = 9},
  [1533] = {.lex_state = 191, .external_lex_state = 15},
  [1534] = {.lex_state = 183, .external_lex_state = 5},
  [1535] = {.lex_state = 191, .external_lex_state = 15},
  [1536] = {.lex_state = 183, .external_lex_state = 5},
  [1537] = {.lex_state = 183, .external_lex_state = 5},
  [1538] = {.lex_state = 185, .external_lex_state = 9},
  [1539] = {.lex_state = 191, .external_lex_state = 15},
  [1540] = {.lex_state = 55, .external_lex_state = 16},
  [1541] = {.lex_state = 57, .external_lex_state = 5},
  [1542] = {.lex_state = 185, .external_lex_state = 7},
  [1543] = {.lex_state = 183, .external_lex_state = 5},
  [1544] = {.lex_state = 183, .external_lex_state = 5},
  [1545] = {.lex_state = 185, .external_lex_state = 7},
  [1546] = {.lex_state = 185, .external_lex_state = 7},
  [1547] = {.lex_state = 191, .external_lex_state = 15},
  [1548] = {.lex_state = 183, .external_lex_state = 5},
  [1549] = {.lex_state = 183, .external_lex_state = 5},
  [1550] = {.lex_state = 183, .external_lex_state = 5},
  [1551] = {.lex_state = 56, .external_lex_state = 13},
  [1552] = {.lex_state = 191, .external_lex_state = 20},
  [1553] = {.lex_state = 183, .external_lex_state = 5},
  [1554] = {.lex_state = 56, .external_lex_state = 13},
  [1555] = {.lex_state = 57, .external_lex_state = 5},
  [1556] = {.lex_state = 185, .external_lex_state = 7},
  [1557] = {.lex_state = 183, .external_lex_state = 5},
  [1558] = {.lex_state = 183, .external_lex_state = 5},
  [1559] = {.lex_state = 191, .external_lex_state = 15},
  [1560] = {.lex_state = 183, .external_lex_state = 5},
  [1561] = {.lex_state = 191, .external_lex_state = 15},
  [1562] = {.lex_state = 183, .external_lex_state = 5},
  [1563] = {.lex_state = 183, .external_lex_state = 5},
  [1564] = {.lex_state = 183, .external_lex_state = 5},
  [1565] = {.lex_state = 191, .external_lex_state = 15},
  [1566] = {.lex_state = 191, .external_lex_state = 15},
  [1567] = {.lex_state = 191, .external_lex_state = 15},
  [1568] = {.lex_state = 191, .external_lex_state = 15},
  [1569] = {.lex_state = 191, .external_lex_state = 20},
  [1570] = {.lex_state = 183, .external_lex_state = 5},
  [1571] = {.lex_state = 185, .external_lex_state = 9},
  [1572] = {.lex_state = 183, .external_lex_state = 5},
  [1573] = {.lex_state = 183, .external_lex_state = 5},
  [1574] = {.lex_state = 183, .external_lex_state = 5},
  [1575] = {.lex_state = 191, .external_lex_state = 15},
  [1576] = {.lex_state = 191, .external_lex_state = 20},
  [1577] = {.lex_state = 183, .external_lex_state = 5},
  [1578] = {.lex_state = 191, .external_lex_state = 20},
  [1579] = {.lex_state = 191, .external_lex_state = 20},
  [1580] = {.lex_state = 183, .external_lex_state = 5},
  [1581] = {.lex_state = 191, .external_lex_state = 15},
  [1582] = {.lex_state = 183, .external_lex_state = 5},
  [1583] = {.lex_state = 55, .external_lex_state = 16},
  [1584] = {.lex_state = 191, .external_lex_state = 20},
  [1585] = {.lex_state = 198, .external_lex_state = 5},
  [1586] = {.lex_state = 191, .external_lex_state = 20},
  [1587] = {.lex_state = 191, .external_lex_state = 20},
  [1588] = {.lex_state = 2, .external_lex_state = 8},
  [1589] = {.lex_state = 183, .external_lex_state = 5},
  [1590] = {.lex_state = 191, .external_lex_state = 20},
  [1591] = {.lex_state = 191, .external_lex_state = 20},
  [1592] = {.lex_state = 191, .external_lex_state = 20},
  [1593] = {.lex_state = 183, .external_lex_state = 5},
  [1594] = {.lex_state = 191, .external_lex_state = 20},
  [1595] = {.lex_state = 2, .external_lex_state = 8},
  [1596] = {.lex_state = 2, .external_lex_state = 8},
  [1597] = {.lex_state = 53, .external_lex_state = 14},
  [1598] = {.lex_state = 2, .external_lex_state = 8},
  [1599] = {.lex_state = 183, .external_lex_state = 5},
  [1600] = {.lex_state = 191, .external_lex_state = 20},
  [1601] = {.lex_state = 191, .external_lex_state = 20},
  [1602] = {.lex_state = 56, .external_lex_state = 13},
  [1603] = {.lex_state = 2, .external_lex_state = 8},
  [1604] = {.lex_state = 2, .external_lex_state = 8},
  [1605] = {.lex_state = 56, .external_lex_state = 13},
  [1606] = {.lex_state = 191, .external_lex_state = 15},
  [1607] = {.lex_state = 183, .external_lex_state = 5},
  [1608] = {.lex_state = 183, .external_lex_state = 5},
  [1609] = {.lex_state = 183, .external_lex_state = 5},
  [1610] = {.lex_state = 58, .external_lex_state = 5},
  [1611] = {.lex_state = 59, .external_lex_state = 5},
  [1612] = {.lex_state = 4, .external_lex_state = 12},
  [1613] = {.lex_state = 58, .external_lex_state = 5},
  [1614] = {.lex_state = 4, .external_lex_state = 12},
  [1615] = {.lex_state = 2, .external_lex_state = 8},
  [1616] = {.lex_state = 4, .external_lex_state = 12},
  [1617] = {.lex_state = 3, .external_lex_state = 22},
  [1618] = {.lex_state = 4, .external_lex_state = 12},
  [1619] = {.lex_state = 2, .external_lex_state = 8},
  [1620] = {.lex_state = 58, .external_lex_state = 5},
  [1621] = {.lex_state = 2, .external_lex_state = 8},
  [1622] = {.lex_state = 2, .external_lex_state = 8},
  [1623] = {.lex_state = 58, .external_lex_state = 5},
  [1624] = {.lex_state = 2, .external_lex_state = 8},
  [1625] = {.lex_state = 4, .external_lex_state = 12},
  [1626] = {.lex_state = 4, .external_lex_state = 12},
  [1627] = {.lex_state = 185, .external_lex_state = 9},
  [1628] = {.lex_state = 128, .external_lex_state = 5},
  [1629] = {.lex_state = 60, .external_lex_state = 5},
  [1630] = {.lex_state = 60, .external_lex_state = 5},
  [1631] = {.lex_state = 186, .external_lex_state = 23},
  [1632] = {.lex_state = 185, .external_lex_state = 9},
  [1633] = {.lex_state = 186, .external_lex_state = 23},
  [1634] = {.lex_state = 185, .external_lex_state = 9},
  [1635] = {.lex_state = 128, .external_lex_state = 5},
  [1636] = {.lex_state = 186, .external_lex_state = 7},
  [1637] = {.lex_state = 185, .external_lex_state = 9},
  [1638] = {.lex_state = 185, .external_lex_state = 9},
  [1639] = {.lex_state = 185, .external_lex_state = 9},
  [1640] = {.lex_state = 61, .external_lex_state = 13},
  [1641] = {.lex_state = 128, .external_lex_state = 5},
  [1642] = {.lex_state = 186, .external_lex_state = 7},
  [1643] = {.lex_state = 128, .external_lex_state = 5},
  [1644] = {.lex_state = 52, .external_lex_state = 14},
  [1645] = {.lex_state = 185, .external_lex_state = 9},
  [1646] = {.lex_state = 3, .external_lex_state = 24},
  [1647] = {.lex_state = 51, .external_lex_state = 21},
  [1648] = {.lex_state = 51, .external_lex_state = 21},
  [1649] = {.lex_state = 185, .external_lex_state = 7},
  [1650] = {.lex_state = 2, .external_lex_state = 8},
  [1651] = {.lex_state = 186, .external_lex_state = 7},
  [1652] = {.lex_state = 59, .external_lex_state = 5},
  [1653] = {.lex_state = 186, .external_lex_state = 7},
  [1654] = {.lex_state = 186, .external_lex_state = 7},
  [1655] = {.lex_state = 54, .external_lex_state = 25},
  [1656] = {.lex_state = 186, .external_lex_state = 7},
  [1657] = {.lex_state = 186, .external_lex_state = 7},
  [1658] = {.lex_state = 186, .external_lex_state = 7},
  [1659] = {.lex_state = 54, .external_lex_state = 25},
  [1660] = {.lex_state = 59, .external_lex_state = 5},
  [1661] = {.lex_state = 59, .external_lex_state = 5},
  [1662] = {.lex_state = 60, .external_lex_state = 5},
  [1663] = {.lex_state = 186, .external_lex_state = 7},
  [1664] = {.lex_state = 186, .external_lex_state = 26},
  [1665] = {.lex_state = 60, .external_lex_state = 5},
  [1666] = {.lex_state = 185, .external_lex_state = 7},
  [1667] = {.lex_state = 60, .external_lex_state = 5},
  [1668] = {.lex_state = 3, .external_lex_state = 24},
  [1669] = {.lex_state = 3, .external_lex_state = 24},
  [1670] = {.lex_state = 3, .external_lex_state = 24},
  [1671] = {.lex_state = 63, .external_lex_state = 5},
  [1672] = {.lex_state = 3, .external_lex_state = 22},
  [1673] = {.lex_state = 63, .external_lex_state = 5},
  [1674] = {.lex_state = 63, .external_lex_state = 5},
  [1675] = {.lex_state = 3, .external_lex_state = 22},
  [1676] = {.lex_state = 3, .external_lex_state = 22},
  [1677] = {.lex_state = 3, .external_lex_state = 22},
  [1678] = {.lex_state = 58, .external_lex_state = 5},
  [1679] = {.lex_state = 186, .external_lex_state = 26},
  [1680] = {.lex_state = 187, .external_lex_state = 10},
  [1681] = {.lex_state = 186, .external_lex_state = 23},
  [1682] = {.lex_state = 187, .external_lex_state = 10},
  [1683] = {.lex_state = 187, .external_lex_state = 10},
  [1684] = {.lex_state = 187, .external_lex_state = 10},
  [1685] = {.lex_state = 186, .external_lex_state = 23},
  [1686] = {.lex_state = 187, .external_lex_state = 10},
  [1687] = {.lex_state = 64, .external_lex_state = 5},
  [1688] = {.lex_state = 187, .external_lex_state = 10},
  [1689] = {.lex_state = 66, .external_lex_state = 13},
  [1690] = {.lex_state = 186, .external_lex_state = 26},
  [1691] = {.lex_state = 64, .external_lex_state = 5},
  [1692] = {.lex_state = 64, .external_lex_state = 5},
  [1693] = {.lex_state = 187, .external_lex_state = 11},
  [1694] = {.lex_state = 63, .external_lex_state = 5},
  [1695] = {.lex_state = 63, .external_lex_state = 5},
  [1696] = {.lex_state = 187, .external_lex_state = 11},
  [1697] = {.lex_state = 187, .external_lex_state = 11},
  [1698] = {.lex_state = 54, .external_lex_state = 25},
  [1699] = {.lex_state = 187, .external_lex_state = 11},
  [1700] = {.lex_state = 187, .external_lex_state = 11},
  [1701] = {.lex_state = 3, .external_lex_state = 24},
  [1702] = {.lex_state = 187, .external_lex_state = 11},
  [1703] = {.lex_state = 128, .external_lex_state = 5},
  [1704] = {.lex_state = 186, .external_lex_state = 26},
  [1705] = {.lex_state = 185, .external_lex_state = 7},
  [1706] = {.lex_state = 186, .external_lex_state = 26},
  [1707] = {.lex_state = 64, .external_lex_state = 5},
  [1708] = {.lex_state = 49, .external_lex_state = 15},
  [1709] = {.lex_state = 3, .external_lex_state = 22},
  [1710] = {.lex_state = 3, .external_lex_state = 22},
  [1711] = {.lex_state = 3, .external_lex_state = 22},
  [1712] = {.lex_state = 185, .external_lex_state = 7},
  [1713] = {.lex_state = 3, .external_lex_state = 22},
  [1714] = {.lex_state = 2, .external_lex_state = 8},
  [1715] = {.lex_state = 64, .external_lex_state = 5},
  [1716] = {.lex_state = 186, .external_lex_state = 23},
  [1717] = {.lex_state = 185, .external_lex_state = 7},
  [1718] = {.lex_state = 185, .external_lex_state = 7},
  [1719] = {.lex_state = 185, .external_lex_state = 7},
  [1720] = {.lex_state = 59, .external_lex_state = 5},
  [1721] = {.lex_state = 5, .external_lex_state = 27},
  [1722] = {.lex_state = 187, .external_lex_state = 13},
  [1723] = {.lex_state = 3, .external_lex_state = 8},
  [1724] = {.lex_state = 186, .external_lex_state = 9},
  [1725] = {.lex_state = 186, .external_lex_state = 7},
  [1726] = {.lex_state = 186, .external_lex_state = 7},
  [1727] = {.lex_state = 69, .external_lex_state = 13},
  [1728] = {.lex_state = 5, .external_lex_state = 27},
  [1729] = {.lex_state = 187, .external_lex_state = 10},
  [1730] = {.lex_state = 54, .external_lex_state = 14},
  [1731] = {.lex_state = 186, .external_lex_state = 7},
  [1732] = {.lex_state = 186, .external_lex_state = 7},
  [1733] = {.lex_state = 186, .external_lex_state = 7},
  [1734] = {.lex_state = 3, .external_lex_state = 8},
  [1735] = {.lex_state = 3, .external_lex_state = 8},
  [1736] = {.lex_state = 51, .external_lex_state = 15},
  [1737] = {.lex_state = 188, .external_lex_state = 28},
  [1738] = {.lex_state = 5, .external_lex_state = 27},
  [1739] = {.lex_state = 186, .external_lex_state = 9},
  [1740] = {.lex_state = 3, .external_lex_state = 8},
  [1741] = {.lex_state = 3, .external_lex_state = 8},
  [1742] = {.lex_state = 3, .external_lex_state = 8},
  [1743] = {.lex_state = 5, .external_lex_state = 27},
  [1744] = {.lex_state = 186, .external_lex_state = 7},
  [1745] = {.lex_state = 4, .external_lex_state = 14},
  [1746] = {.lex_state = 51, .external_lex_state = 15},
  [1747] = {.lex_state = 51, .external_lex_state = 15},
  [1748] = {.lex_state = 3, .external_lex_state = 8},
  [1749] = {.lex_state = 186, .external_lex_state = 9},
  [1750] = {.lex_state = 188, .external_lex_state = 28},
  [1751] = {.lex_state = 187, .external_lex_state = 11},
  [1752] = {.lex_state = 186, .external_lex_state = 9},
  [1753] = {.lex_state = 186, .external_lex_state = 9},
  [1754] = {.lex_state = 186, .external_lex_state = 9},
  [1755] = {.lex_state = 3, .external_lex_state = 8},
  [1756] = {.lex_state = 186, .external_lex_state = 7},
  [1757] = {.lex_state = 3, .external_lex_state = 8},
  [1758] = {.lex_state = 3, .external_lex_state = 8},
  [1759] = {.lex_state = 186, .external_lex_state = 7},
  [1760] = {.lex_state = 186, .external_lex_state = 7},
  [1761] = {.lex_state = 4, .external_lex_state = 14},
  [1762] = {.lex_state = 4, .external_lex_state = 14},
  [1763] = {.lex_state = 3, .external_lex_state = 8},
  [1764] = {.lex_state = 4, .external_lex_state = 14},
  [1765] = {.lex_state = 186, .external_lex_state = 7},
  [1766] = {.lex_state = 3, .external_lex_state = 8},
  [1767] = {.lex_state = 188, .external_lex_state = 28},
  [1768] = {.lex_state = 3, .external_lex_state = 8},
  [1769] = {.lex_state = 188, .external_lex_state = 28},
  [1770] = {.lex_state = 4, .external_lex_state = 14},
  [1771] = {.lex_state = 4, .external_lex_state = 14},
  [1772] = {.lex_state = 186, .external_lex_state = 7},
  [1773] = {.lex_state = 187, .external_lex_state = 10},
  [1774] = {.lex_state = 51, .external_lex_state = 15},
  [1775] = {.lex_state = 187, .external_lex_state = 11},
  [1776] = {.lex_state = 187, .external_lex_state = 15},
  [1777] = {.lex_state = 187, .external_lex_state = 15},
  [1778] = {.lex_state = 186, .external_lex_state = 7},
  [1779] = {.lex_state = 186, .external_lex_state = 9},
  [1780] = {.lex_state = 187, .external_lex_state = 15},
  [1781] = {.lex_state = 187, .external_lex_state = 15},
  [1782] = {.lex_state = 187, .external_lex_state = 15},
  [1783] = {.lex_state = 186, .external_lex_state = 9},
  [1784] = {.lex_state = 186, .external_lex_state = 9},
  [1785] = {.lex_state = 187, .external_lex_state = 15},
  [1786] = {.lex_state = 3, .external_lex_state = 8},
  [1787] = {.lex_state = 187, .external_lex_state = 15},
  [1788] = {.lex_state = 186, .external_lex_state = 7},
  [1789] = {.lex_state = 186, .external_lex_state = 7},
  [1790] = {.lex_state = 186, .external_lex_state = 7},
  [1791] = {.lex_state = 4, .external_lex_state = 12},
  [1792] = {.lex_state = 186, .external_lex_state = 7},
  [1793] = {.lex_state = 3, .external_lex_state = 8},
  [1794] = {.lex_state = 4, .external_lex_state = 12},
  [1795] = {.lex_state = 188, .external_lex_state = 28},
  [1796] = {.lex_state = 188, .external_lex_state = 29},
  [1797] = {.lex_state = 186, .external_lex_state = 7},
  [1798] = {.lex_state = 4, .external_lex_state = 12},
  [1799] = {.lex_state = 187, .external_lex_state = 11},
  [1800] = {.lex_state = 187, .external_lex_state = 13},
  [1801] = {.lex_state = 186, .external_lex_state = 9},
  [1802] = {.lex_state = 187, .external_lex_state = 11},
  [1803] = {.lex_state = 187, .external_lex_state = 11},
  [1804] = {.lex_state = 186, .external_lex_state = 9},
  [1805] = {.lex_state = 186, .external_lex_state = 7},
  [1806] = {.lex_state = 186, .external_lex_state = 7},
  [1807] = {.lex_state = 188, .external_lex_state = 10},
  [1808] = {.lex_state = 6, .external_lex_state = 13},
  [1809] = {.lex_state = 187, .external_lex_state = 11},
  [1810] = {.lex_state = 61, .external_lex_state = 13},
  [1811] = {.lex_state = 186, .external_lex_state = 7},
  [1812] = {.lex_state = 188, .external_lex_state = 29},
  [1813] = {.lex_state = 186, .external_lex_state = 7},
  [1814] = {.lex_state = 186, .external_lex_state = 7},
  [1815] = {.lex_state = 186, .external_lex_state = 9},
  [1816] = {.lex_state = 188, .external_lex_state = 10},
  [1817] = {.lex_state = 188, .external_lex_state = 29},
  [1818] = {.lex_state = 6, .external_lex_state = 13},
  [1819] = {.lex_state = 188, .external_lex_state = 10},
  [1820] = {.lex_state = 188, .external_lex_state = 10},
  [1821] = {.lex_state = 188, .external_lex_state = 10},
  [1822] = {.lex_state = 188, .external_lex_state = 29},
  [1823] = {.lex_state = 3, .external_lex_state = 8},
  [1824] = {.lex_state = 6, .external_lex_state = 13},
  [1825] = {.lex_state = 186, .external_lex_state = 9},
  [1826] = {.lex_state = 186, .external_lex_state = 9},
  [1827] = {.lex_state = 188, .external_lex_state = 10},
  [1828] = {.lex_state = 188, .external_lex_state = 10},
  [1829] = {.lex_state = 188, .external_lex_state = 10},
  [1830] = {.lex_state = 186, .external_lex_state = 7},
  [1831] = {.lex_state = 188, .external_lex_state = 10},
  [1832] = {.lex_state = 6, .external_lex_state = 13},
  [1833] = {.lex_state = 186, .external_lex_state = 7},
  [1834] = {.lex_state = 186, .external_lex_state = 7},
  [1835] = {.lex_state = 6, .external_lex_state = 13},
  [1836] = {.lex_state = 186, .external_lex_state = 9},
  [1837] = {.lex_state = 6, .external_lex_state = 13},
  [1838] = {.lex_state = 187, .external_lex_state = 10},
  [1839] = {.lex_state = 186, .external_lex_state = 7},
  [1840] = {.lex_state = 186, .external_lex_state = 7},
  [1841] = {.lex_state = 187, .external_lex_state = 13},
  [1842] = {.lex_state = 187, .external_lex_state = 10},
  [1843] = {.lex_state = 186, .external_lex_state = 7},
  [1844] = {.lex_state = 187, .external_lex_state = 10},
  [1845] = {.lex_state = 187, .external_lex_state = 11},
  [1846] = {.lex_state = 187, .external_lex_state = 10},
  [1847] = {.lex_state = 186, .external_lex_state = 7},
  [1848] = {.lex_state = 3, .external_lex_state = 8},
  [1849] = {.lex_state = 187, .external_lex_state = 13},
  [1850] = {.lex_state = 186, .external_lex_state = 7},
  [1851] = {.lex_state = 186, .external_lex_state = 7},
  [1852] = {.lex_state = 3, .external_lex_state = 8},
  [1853] = {.lex_state = 186, .external_lex_state = 7},
  [1854] = {.lex_state = 5, .external_lex_state = 30},
  [1855] = {.lex_state = 5, .external_lex_state = 27},
  [1856] = {.lex_state = 186, .external_lex_state = 7},
  [1857] = {.lex_state = 5, .external_lex_state = 30},
  [1858] = {.lex_state = 5, .external_lex_state = 30},
  [1859] = {.lex_state = 5, .external_lex_state = 30},
  [1860] = {.lex_state = 54, .external_lex_state = 14},
  [1861] = {.lex_state = 186, .external_lex_state = 7},
  [1862] = {.lex_state = 188, .external_lex_state = 29},
  [1863] = {.lex_state = 3, .external_lex_state = 8},
  [1864] = {.lex_state = 3, .external_lex_state = 8},
  [1865] = {.lex_state = 66, .external_lex_state = 13},
  [1866] = {.lex_state = 186, .external_lex_state = 7},
  [1867] = {.lex_state = 4, .external_lex_state = 12},
  [1868] = {.lex_state = 186, .external_lex_state = 9},
  [1869] = {.lex_state = 186, .external_lex_state = 7},
  [1870] = {.lex_state = 186, .external_lex_state = 9},
  [1871] = {.lex_state = 186, .external_lex_state = 7},
  [1872] = {.lex_state = 186, .external_lex_state = 9},
  [1873] = {.lex_state = 187, .external_lex_state = 13},
  [1874] = {.lex_state = 186, .external_lex_state = 7},
  [1875] = {.lex_state = 186, .external_lex_state = 9},
  [1876] = {.lex_state = 186, .external_lex_state = 9},
  [1877] = {.lex_state = 54, .external_lex_state = 14},
  [1878] = {.lex_state = 54, .external_lex_state = 14},
  [1879] = {.lex_state = 54, .external_lex_state = 14},
  [1880] = {.lex_state = 187, .external_lex_state = 13},
  [1881] = {.lex_state = 186, .external_lex_state = 7},
  [1882] = {.lex_state = 186, .external_lex_state = 9},
  [1883] = {.lex_state = 54, .external_lex_state = 14},
  [1884] = {.lex_state = 186, .external_lex_state = 7},
  [1885] = {.lex_state = 186, .external_lex_state = 9},
  [1886] = {.lex_state = 186, .external_lex_state = 7},
  [1887] = {.lex_state = 186, .external_lex_state = 7},
  [1888] = {.lex_state = 186, .external_lex_state = 9},
  [1889] = {.lex_state = 186, .external_lex_state = 7},
  [1890] = {.lex_state = 186, .external_lex_state = 9},
  [1891] = {.lex_state = 186, .external_lex_state = 7},
  [1892] = {.lex_state = 186, .external_lex_state = 9},
  [1893] = {.lex_state = 51, .external_lex_state = 15},
  [1894] = {.lex_state = 3, .external_lex_state = 8},
  [1895] = {.lex_state = 51, .external_lex_state = 15},
  [1896] = {.lex_state = 3, .external_lex_state = 8},
  [1897] = {.lex_state = 186, .external_lex_state = 7},
  [1898] = {.lex_state = 51, .external_lex_state = 15},
  [1899] = {.lex_state = 186, .external_lex_state = 9},
  [1900] = {.lex_state = 186, .external_lex_state = 9},
  [1901] = {.lex_state = 186, .external_lex_state = 9},
  [1902] = {.lex_state = 186, .external_lex_state = 7},
  [1903] = {.lex_state = 3, .external_lex_state = 8},
  [1904] = {.lex_state = 3, .external_lex_state = 8},
  [1905] = {.lex_state = 54, .external_lex_state = 14},
  [1906] = {.lex_state = 186, .external_lex_state = 9},
  [1907] = {.lex_state = 186, .external_lex_state = 9},
  [1908] = {.lex_state = 4, .external_lex_state = 14},
  [1909] = {.lex_state = 186, .external_lex_state = 9},
  [1910] = {.lex_state = 186, .external_lex_state = 7},
  [1911] = {.lex_state = 3, .external_lex_state = 8},
  [1912] = {.lex_state = 186, .external_lex_state = 9},
  [1913] = {.lex_state = 186, .external_lex_state = 9},
  [1914] = {.lex_state = 3, .external_lex_state = 8},
  [1915] = {.lex_state = 3, .external_lex_state = 8},
  [1916] = {.lex_state = 186, .external_lex_state = 9},
  [1917] = {.lex_state = 186, .external_lex_state = 9},
  [1918] = {.lex_state = 3, .external_lex_state = 8},
  [1919] = {.lex_state = 186, .external_lex_state = 9},
  [1920] = {.lex_state = 186, .external_lex_state = 9},
  [1921] = {.lex_state = 3, .external_lex_state = 8},
  [1922] = {.lex_state = 3, .external_lex_state = 8},
  [1923] = {.lex_state = 186, .external_lex_state = 9},
  [1924] = {.lex_state = 3, .external_lex_state = 8},
  [1925] = {.lex_state = 187, .external_lex_state = 10},
  [1926] = {.lex_state = 186, .external_lex_state = 9},
  [1927] = {.lex_state = 186, .external_lex_state = 9},
  [1928] = {.lex_state = 3, .external_lex_state = 8},
  [1929] = {.lex_state = 3, .external_lex_state = 8},
  [1930] = {.lex_state = 3, .external_lex_state = 8},
  [1931] = {.lex_state = 186, .external_lex_state = 9},
  [1932] = {.lex_state = 187, .external_lex_state = 13},
  [1933] = {.lex_state = 5, .external_lex_state = 30},
  [1934] = {.lex_state = 3, .external_lex_state = 8},
  [1935] = {.lex_state = 3, .external_lex_state = 8},
  [1936] = {.lex_state = 5, .external_lex_state = 30},
  [1937] = {.lex_state = 3, .external_lex_state = 8},
  [1938] = {.lex_state = 3, .external_lex_state = 8},
  [1939] = {.lex_state = 3, .external_lex_state = 8},
  [1940] = {.lex_state = 186, .external_lex_state = 9},
  [1941] = {.lex_state = 3, .external_lex_state = 8},
  [1942] = {.lex_state = 3, .external_lex_state = 8},
  [1943] = {.lex_state = 4, .external_lex_state = 12},
  [1944] = {.lex_state = 3, .external_lex_state = 8},
  [1945] = {.lex_state = 5, .external_lex_state = 30},
  [1946] = {.lex_state = 4, .external_lex_state = 12},
  [1947] = {.lex_state = 4, .external_lex_state = 12},
  [1948] = {.lex_state = 5, .external_lex_state = 30},
  [1949] = {.lex_state = 5, .external_lex_state = 30},
  [1950] = {.lex_state = 5, .external_lex_state = 12},
  [1951] = {.lex_state = 188, .external_lex_state = 11},
  [1952] = {.lex_state = 188, .external_lex_state = 10},
  [1953] = {.lex_state = 4, .external_lex_state = 14},
  [1954] = {.lex_state = 6, .external_lex_state = 13},
  [1955] = {.lex_state = 191, .external_lex_state = 5},
  [1956] = {.lex_state = 5, .external_lex_state = 12},
  [1957] = {.lex_state = 5, .external_lex_state = 12},
  [1958] = {.lex_state = 188, .external_lex_state = 31},
  [1959] = {.lex_state = 5, .external_lex_state = 12},
  [1960] = {.lex_state = 191, .external_lex_state = 5},
  [1961] = {.lex_state = 188, .external_lex_state = 31},
  [1962] = {.lex_state = 188, .external_lex_state = 11},
  [1963] = {.lex_state = 188, .external_lex_state = 21},
  [1964] = {.lex_state = 5, .external_lex_state = 12},
  [1965] = {.lex_state = 67, .external_lex_state = 31},
  [1966] = {.lex_state = 67, .external_lex_state = 31},
  [1967] = {.lex_state = 8, .external_lex_state = 13},
  [1968] = {.lex_state = 8, .external_lex_state = 13},
  [1969] = {.lex_state = 5, .external_lex_state = 12},
  [1970] = {.lex_state = 7, .external_lex_state = 31},
  [1971] = {.lex_state = 7, .external_lex_state = 31},
  [1972] = {.lex_state = 5, .external_lex_state = 12},
  [1973] = {.lex_state = 5, .external_lex_state = 12},
  [1974] = {.lex_state = 5, .external_lex_state = 12},
  [1975] = {.lex_state = 188, .external_lex_state = 11},
  [1976] = {.lex_state = 188, .external_lex_state = 11},
  [1977] = {.lex_state = 188, .external_lex_state = 11},
  [1978] = {.lex_state = 188, .external_lex_state = 11},
  [1979] = {.lex_state = 188, .external_lex_state = 11},
  [1980] = {.lex_state = 8, .external_lex_state = 13},
  [1981] = {.lex_state = 8, .external_lex_state = 13},
  [1982] = {.lex_state = 8, .external_lex_state = 13},
  [1983] = {.lex_state = 5, .external_lex_state = 12},
  [1984] = {.lex_state = 5, .external_lex_state = 12},
  [1985] = {.lex_state = 5, .external_lex_state = 12},
  [1986] = {.lex_state = 5, .external_lex_state = 12},
  [1987] = {.lex_state = 188, .external_lex_state = 32},
  [1988] = {.lex_state = 188, .external_lex_state = 11},
  [1989] = {.lex_state = 188, .external_lex_state = 11},
  [1990] = {.lex_state = 188, .external_lex_state = 11},
  [1991] = {.lex_state = 188, .external_lex_state = 11},
  [1992] = {.lex_state = 5, .external_lex_state = 12},
  [1993] = {.lex_state = 187, .external_lex_state = 15},
  [1994] = {.lex_state = 191, .external_lex_state = 5},
  [1995] = {.lex_state = 8, .external_lex_state = 13},
  [1996] = {.lex_state = 188, .external_lex_state = 32},
  [1997] = {.lex_state = 188, .external_lex_state = 11},
  [1998] = {.lex_state = 188, .external_lex_state = 11},
  [1999] = {.lex_state = 5, .external_lex_state = 12},
  [2000] = {.lex_state = 188, .external_lex_state = 32},
  [2001] = {.lex_state = 5, .external_lex_state = 12},
  [2002] = {.lex_state = 188, .external_lex_state = 11},
  [2003] = {.lex_state = 188, .external_lex_state = 11},
  [2004] = {.lex_state = 188, .external_lex_state = 11},
  [2005] = {.lex_state = 5, .external_lex_state = 12},
  [2006] = {.lex_state = 188, .external_lex_state = 10},
  [2007] = {.lex_state = 188, .external_lex_state = 10},
  [2008] = {.lex_state = 188, .external_lex_state = 10},
  [2009] = {.lex_state = 5, .external_lex_state = 25},
  [2010] = {.lex_state = 188, .external_lex_state = 32},
  [2011] = {.lex_state = 191, .external_lex_state = 5},
  [2012] = {.lex_state = 5, .external_lex_state = 12},
  [2013] = {.lex_state = 191, .external_lex_state = 5},
  [2014] = {.lex_state = 5, .external_lex_state = 12},
  [2015] = {.lex_state = 5, .external_lex_state = 12},
  [2016] = {.lex_state = 5, .external_lex_state = 12},
  [2017] = {.lex_state = 5, .external_lex_state = 12},
  [2018] = {.lex_state = 5, .external_lex_state = 12},
  [2019] = {.lex_state = 5, .external_lex_state = 12},
  [2020] = {.lex_state = 191, .external_lex_state = 5},
  [2021] = {.lex_state = 5, .external_lex_state = 12},
  [2022] = {.lex_state = 5, .external_lex_state = 12},
  [2023] = {.lex_state = 5, .external_lex_state = 12},
  [2024] = {.lex_state = 5, .external_lex_state = 12},
  [2025] = {.lex_state = 188, .external_lex_state = 32},
  [2026] = {.lex_state = 5, .external_lex_state = 12},
  [2027] = {.lex_state = 191, .external_lex_state = 5},
  [2028] = {.lex_state = 188, .external_lex_state = 32},
  [2029] = {.lex_state = 191, .external_lex_state = 5},
  [2030] = {.lex_state = 5, .external_lex_state = 12},
  [2031] = {.lex_state = 187, .external_lex_state = 13},
  [2032] = {.lex_state = 5, .external_lex_state = 12},
  [2033] = {.lex_state = 5, .external_lex_state = 12},
  [2034] = {.lex_state = 5, .external_lex_state = 12},
  [2035] = {.lex_state = 5, .external_lex_state = 12},
  [2036] = {.lex_state = 188, .external_lex_state = 11},
  [2037] = {.lex_state = 5, .external_lex_state = 12},
  [2038] = {.lex_state = 188, .external_lex_state = 11},
  [2039] = {.lex_state = 188, .external_lex_state = 32},
  [2040] = {.lex_state = 191, .external_lex_state = 5},
  [2041] = {.lex_state = 191, .external_lex_state = 5},
  [2042] = {.lex_state = 5, .external_lex_state = 12},
  [2043] = {.lex_state = 5, .external_lex_state = 12},
  [2044] = {.lex_state = 188, .external_lex_state = 10},
  [2045] = {.lex_state = 7, .external_lex_state = 31},
  [2046] = {.lex_state = 188, .external_lex_state = 10},
  [2047] = {.lex_state = 188, .external_lex_state = 10},
  [2048] = {.lex_state = 188, .external_lex_state = 10},
  [2049] = {.lex_state = 191, .external_lex_state = 5},
  [2050] = {.lex_state = 188, .external_lex_state = 10},
  [2051] = {.lex_state = 188, .external_lex_state = 10},
  [2052] = {.lex_state = 188, .external_lex_state = 10},
  [2053] = {.lex_state = 188, .external_lex_state = 10},
  [2054] = {.lex_state = 188, .external_lex_state = 10},
  [2055] = {.lex_state = 188, .external_lex_state = 10},
  [2056] = {.lex_state = 188, .external_lex_state = 10},
  [2057] = {.lex_state = 188, .external_lex_state = 10},
  [2058] = {.lex_state = 188, .external_lex_state = 10},
  [2059] = {.lex_state = 188, .external_lex_state = 10},
  [2060] = {.lex_state = 5, .external_lex_state = 12},
  [2061] = {.lex_state = 5, .external_lex_state = 12},
  [2062] = {.lex_state = 188, .external_lex_state = 32},
  [2063] = {.lex_state = 5, .external_lex_state = 12},
  [2064] = {.lex_state = 5, .external_lex_state = 33},
  [2065] = {.lex_state = 188, .external_lex_state = 31},
  [2066] = {.lex_state = 5, .external_lex_state = 33},
  [2067] = {.lex_state = 5, .external_lex_state = 33},
  [2068] = {.lex_state = 5, .external_lex_state = 33},
  [2069] = {.lex_state = 4, .external_lex_state = 14},
  [2070] = {.lex_state = 191, .external_lex_state = 5},
  [2071] = {.lex_state = 5, .external_lex_state = 33},
  [2072] = {.lex_state = 5, .external_lex_state = 33},
  [2073] = {.lex_state = 5, .external_lex_state = 33},
  [2074] = {.lex_state = 6, .external_lex_state = 13},
  [2075] = {.lex_state = 5, .external_lex_state = 33},
  [2076] = {.lex_state = 188, .external_lex_state = 11},
  [2077] = {.lex_state = 191, .external_lex_state = 5},
  [2078] = {.lex_state = 4, .external_lex_state = 14},
  [2079] = {.lex_state = 10, .external_lex_state = 13},
  [2080] = {.lex_state = 7, .external_lex_state = 32},
  [2081] = {.lex_state = 7, .external_lex_state = 31},
  [2082] = {.lex_state = 7, .external_lex_state = 32},
  [2083] = {.lex_state = 7, .external_lex_state = 32},
  [2084] = {.lex_state = 5, .external_lex_state = 33},
  [2085] = {.lex_state = 4, .external_lex_state = 14},
  [2086] = {.lex_state = 4, .external_lex_state = 14},
  [2087] = {.lex_state = 7, .external_lex_state = 32},
  [2088] = {.lex_state = 67, .external_lex_state = 31},
  [2089] = {.lex_state = 4, .external_lex_state = 14},
  [2090] = {.lex_state = 188, .external_lex_state = 10},
  [2091] = {.lex_state = 188, .external_lex_state = 10},
  [2092] = {.lex_state = 188, .external_lex_state = 10},
  [2093] = {.lex_state = 188, .external_lex_state = 11},
  [2094] = {.lex_state = 187, .external_lex_state = 13},
  [2095] = {.lex_state = 188, .external_lex_state = 11},
  [2096] = {.lex_state = 188, .external_lex_state = 32},
  [2097] = {.lex_state = 188, .external_lex_state = 10},
  [2098] = {.lex_state = 187, .external_lex_state = 15},
  [2099] = {.lex_state = 10, .external_lex_state = 13},
  [2100] = {.lex_state = 10, .external_lex_state = 13},
  [2101] = {.lex_state = 7, .external_lex_state = 31},
  [2102] = {.lex_state = 188, .external_lex_state = 10},
  [2103] = {.lex_state = 191, .external_lex_state = 5},
  [2104] = {.lex_state = 5, .external_lex_state = 25},
  [2105] = {.lex_state = 10, .external_lex_state = 13},
  [2106] = {.lex_state = 188, .external_lex_state = 10},
  [2107] = {.lex_state = 5, .external_lex_state = 25},
  [2108] = {.lex_state = 191, .external_lex_state = 5},
  [2109] = {.lex_state = 187, .external_lex_state = 15},
  [2110] = {.lex_state = 187, .external_lex_state = 15},
  [2111] = {.lex_state = 187, .external_lex_state = 15},
  [2112] = {.lex_state = 187, .external_lex_state = 15},
  [2113] = {.lex_state = 5, .external_lex_state = 25},
  [2114] = {.lex_state = 191, .external_lex_state = 5},
  [2115] = {.lex_state = 188, .external_lex_state = 31},
  [2116] = {.lex_state = 187, .external_lex_state = 13},
  [2117] = {.lex_state = 187, .external_lex_state = 13},
  [2118] = {.lex_state = 188, .external_lex_state = 21},
  [2119] = {.lex_state = 188, .external_lex_state = 21},
  [2120] = {.lex_state = 188, .external_lex_state = 21},
  [2121] = {.lex_state = 188, .external_lex_state = 10},
  [2122] = {.lex_state = 191, .external_lex_state = 5},
  [2123] = {.lex_state = 188, .external_lex_state = 10},
  [2124] = {.lex_state = 188, .external_lex_state = 10},
  [2125] = {.lex_state = 191, .external_lex_state = 5},
  [2126] = {.lex_state = 188, .external_lex_state = 10},
  [2127] = {.lex_state = 188, .external_lex_state = 10},
  [2128] = {.lex_state = 191, .external_lex_state = 5},
  [2129] = {.lex_state = 188, .external_lex_state = 10},
  [2130] = {.lex_state = 191, .external_lex_state = 5},
  [2131] = {.lex_state = 191, .external_lex_state = 5},
  [2132] = {.lex_state = 187, .external_lex_state = 13},
  [2133] = {.lex_state = 188, .external_lex_state = 10},
  [2134] = {.lex_state = 188, .external_lex_state = 21},
  [2135] = {.lex_state = 188, .external_lex_state = 31},
  [2136] = {.lex_state = 188, .external_lex_state = 10},
  [2137] = {.lex_state = 188, .external_lex_state = 10},
  [2138] = {.lex_state = 187, .external_lex_state = 13},
  [2139] = {.lex_state = 10, .external_lex_state = 13},
  [2140] = {.lex_state = 191, .external_lex_state = 5},
  [2141] = {.lex_state = 5, .external_lex_state = 12},
  [2142] = {.lex_state = 188, .external_lex_state = 10},
  [2143] = {.lex_state = 6, .external_lex_state = 13},
  [2144] = {.lex_state = 191, .external_lex_state = 5},
  [2145] = {.lex_state = 188, .external_lex_state = 10},
  [2146] = {.lex_state = 191, .external_lex_state = 5},
  [2147] = {.lex_state = 191, .external_lex_state = 5},
  [2148] = {.lex_state = 191, .external_lex_state = 5},
  [2149] = {.lex_state = 191, .external_lex_state = 5},
  [2150] = {.lex_state = 188, .external_lex_state = 10},
  [2151] = {.lex_state = 188, .external_lex_state = 10},
  [2152] = {.lex_state = 10, .external_lex_state = 13},
  [2153] = {.lex_state = 5, .external_lex_state = 12},
  [2154] = {.lex_state = 191, .external_lex_state = 5},
  [2155] = {.lex_state = 187, .external_lex_state = 15},
  [2156] = {.lex_state = 188, .external_lex_state = 10},
  [2157] = {.lex_state = 69, .external_lex_state = 13},
  [2158] = {.lex_state = 7, .external_lex_state = 32},
  [2159] = {.lex_state = 188, .external_lex_state = 10},
  [2160] = {.lex_state = 191, .external_lex_state = 5},
  [2161] = {.lex_state = 188, .external_lex_state = 10},
  [2162] = {.lex_state = 191, .external_lex_state = 5},
  [2163] = {.lex_state = 7, .external_lex_state = 32},
  [2164] = {.lex_state = 191, .external_lex_state = 5},
  [2165] = {.lex_state = 188, .external_lex_state = 11},
  [2166] = {.lex_state = 191, .external_lex_state = 5},
  [2167] = {.lex_state = 191, .external_lex_state = 5},
  [2168] = {.lex_state = 191, .external_lex_state = 5},
  [2169] = {.lex_state = 191, .external_lex_state = 5},
  [2170] = {.lex_state = 188, .external_lex_state = 10},
  [2171] = {.lex_state = 191, .external_lex_state = 5},
  [2172] = {.lex_state = 188, .external_lex_state = 10},
  [2173] = {.lex_state = 188, .external_lex_state = 10},
  [2174] = {.lex_state = 188, .external_lex_state = 10},
  [2175] = {.lex_state = 191, .external_lex_state = 5},
  [2176] = {.lex_state = 191, .external_lex_state = 5},
  [2177] = {.lex_state = 187, .external_lex_state = 13},
  [2178] = {.lex_state = 191, .external_lex_state = 5},
  [2179] = {.lex_state = 7, .external_lex_state = 32},
  [2180] = {.lex_state = 188, .external_lex_state = 10},
  [2181] = {.lex_state = 191, .external_lex_state = 5},
  [2182] = {.lex_state = 6, .external_lex_state = 13},
  [2183] = {.lex_state = 188, .external_lex_state = 11},
  [2184] = {.lex_state = 191, .external_lex_state = 5},
  [2185] = {.lex_state = 7, .external_lex_state = 32},
  [2186] = {.lex_state = 6, .external_lex_state = 13},
  [2187] = {.lex_state = 191, .external_lex_state = 5},
  [2188] = {.lex_state = 187, .external_lex_state = 13},
  [2189] = {.lex_state = 61, .external_lex_state = 5},
  [2190] = {.lex_state = 65, .external_lex_state = 13},
  [2191] = {.lex_state = 188, .external_lex_state = 11},
  [2192] = {.lex_state = 4, .external_lex_state = 14},
  [2193] = {.lex_state = 188, .external_lex_state = 11},
  [2194] = {.lex_state = 188, .external_lex_state = 11},
  [2195] = {.lex_state = 188, .external_lex_state = 11},
  [2196] = {.lex_state = 6, .external_lex_state = 13},
  [2197] = {.lex_state = 7, .external_lex_state = 32},
  [2198] = {.lex_state = 191, .external_lex_state = 5},
  [2199] = {.lex_state = 5, .external_lex_state = 25},
  [2200] = {.lex_state = 191, .external_lex_state = 5},
  [2201] = {.lex_state = 188, .external_lex_state = 11},
  [2202] = {.lex_state = 188, .external_lex_state = 11},
  [2203] = {.lex_state = 188, .external_lex_state = 11},
  [2204] = {.lex_state = 188, .external_lex_state = 10},
  [2205] = {.lex_state = 6, .external_lex_state = 13},
  [2206] = {.lex_state = 188, .external_lex_state = 11},
  [2207] = {.lex_state = 191, .external_lex_state = 5},
  [2208] = {.lex_state = 191, .external_lex_state = 5},
  [2209] = {.lex_state = 188, .external_lex_state = 11},
  [2210] = {.lex_state = 188, .external_lex_state = 11},
  [2211] = {.lex_state = 188, .external_lex_state = 11},
  [2212] = {.lex_state = 188, .external_lex_state = 11},
  [2213] = {.lex_state = 191, .external_lex_state = 5},
  [2214] = {.lex_state = 188, .external_lex_state = 10},
  [2215] = {.lex_state = 188, .external_lex_state = 11},
  [2216] = {.lex_state = 188, .external_lex_state = 11},
  [2217] = {.lex_state = 188, .external_lex_state = 11},
  [2218] = {.lex_state = 188, .external_lex_state = 11},
  [2219] = {.lex_state = 191, .external_lex_state = 5},
  [2220] = {.lex_state = 188, .external_lex_state = 11},
  [2221] = {.lex_state = 188, .external_lex_state = 11},
  [2222] = {.lex_state = 188, .external_lex_state = 11},
  [2223] = {.lex_state = 191, .external_lex_state = 5},
  [2224] = {.lex_state = 9, .external_lex_state = 32},
  [2225] = {.lex_state = 191, .external_lex_state = 5},
  [2226] = {.lex_state = 11, .external_lex_state = 32},
  [2227] = {.lex_state = 7, .external_lex_state = 13},
  [2228] = {.lex_state = 7, .external_lex_state = 13},
  [2229] = {.lex_state = 191, .external_lex_state = 5},
  [2230] = {.lex_state = 11, .external_lex_state = 32},
  [2231] = {.lex_state = 14, .external_lex_state = 5},
  [2232] = {.lex_state = 191, .external_lex_state = 5},
  [2233] = {.lex_state = 61, .external_lex_state = 5},
  [2234] = {.lex_state = 7, .external_lex_state = 13},
  [2235] = {.lex_state = 11, .external_lex_state = 32},
  [2236] = {.lex_state = 11, .external_lex_state = 32},
  [2237] = {.lex_state = 11, .external_lex_state = 32},
  [2238] = {.lex_state = 191, .external_lex_state = 5},
  [2239] = {.lex_state = 5, .external_lex_state = 14},
  [2240] = {.lex_state = 5, .external_lex_state = 14},
  [2241] = {.lex_state = 14, .external_lex_state = 5},
  [2242] = {.lex_state = 5, .external_lex_state = 14},
  [2243] = {.lex_state = 11, .external_lex_state = 32},
  [2244] = {.lex_state = 14, .external_lex_state = 5},
  [2245] = {.lex_state = 5, .external_lex_state = 14},
  [2246] = {.lex_state = 191, .external_lex_state = 5},
  [2247] = {.lex_state = 14, .external_lex_state = 5},
  [2248] = {.lex_state = 5, .external_lex_state = 14},
  [2249] = {.lex_state = 7, .external_lex_state = 13},
  [2250] = {.lex_state = 12, .external_lex_state = 5},
  [2251] = {.lex_state = 12, .external_lex_state = 5},
  [2252] = {.lex_state = 5, .external_lex_state = 14},
  [2253] = {.lex_state = 188, .external_lex_state = 13},
  [2254] = {.lex_state = 191, .external_lex_state = 5},
  [2255] = {.lex_state = 11, .external_lex_state = 32},
  [2256] = {.lex_state = 14, .external_lex_state = 5},
  [2257] = {.lex_state = 14, .external_lex_state = 5},
  [2258] = {.lex_state = 11, .external_lex_state = 32},
  [2259] = {.lex_state = 11, .external_lex_state = 31},
  [2260] = {.lex_state = 191, .external_lex_state = 5},
  [2261] = {.lex_state = 10, .external_lex_state = 13},
  [2262] = {.lex_state = 188, .external_lex_state = 13},
  [2263] = {.lex_state = 12, .external_lex_state = 5},
  [2264] = {.lex_state = 12, .external_lex_state = 5},
  [2265] = {.lex_state = 67, .external_lex_state = 13},
  [2266] = {.lex_state = 67, .external_lex_state = 13},
  [2267] = {.lex_state = 12, .external_lex_state = 5},
  [2268] = {.lex_state = 188, .external_lex_state = 13},
  [2269] = {.lex_state = 5, .external_lex_state = 14},
  [2270] = {.lex_state = 9, .external_lex_state = 31},
  [2271] = {.lex_state = 5, .external_lex_state = 14},
  [2272] = {.lex_state = 5, .external_lex_state = 14},
  [2273] = {.lex_state = 5, .external_lex_state = 14},
  [2274] = {.lex_state = 191, .external_lex_state = 5},
  [2275] = {.lex_state = 7, .external_lex_state = 13},
  [2276] = {.lex_state = 7, .external_lex_state = 13},
  [2277] = {.lex_state = 7, .external_lex_state = 13},
  [2278] = {.lex_state = 7, .external_lex_state = 13},
  [2279] = {.lex_state = 5, .external_lex_state = 14},
  [2280] = {.lex_state = 188, .external_lex_state = 13},
  [2281] = {.lex_state = 188, .external_lex_state = 15},
  [2282] = {.lex_state = 7, .external_lex_state = 13},
  [2283] = {.lex_state = 67, .external_lex_state = 13},
  [2284] = {.lex_state = 67, .external_lex_state = 13},
  [2285] = {.lex_state = 10, .external_lex_state = 13},
  [2286] = {.lex_state = 7, .external_lex_state = 13},
  [2287] = {.lex_state = 67, .external_lex_state = 13},
  [2288] = {.lex_state = 70, .external_lex_state = 31},
  [2289] = {.lex_state = 7, .external_lex_state = 13},
  [2290] = {.lex_state = 188, .external_lex_state = 15},
  [2291] = {.lex_state = 7, .external_lex_state = 13},
  [2292] = {.lex_state = 67, .external_lex_state = 13},
  [2293] = {.lex_state = 188, .external_lex_state = 15},
  [2294] = {.lex_state = 7, .external_lex_state = 13},
  [2295] = {.lex_state = 16, .external_lex_state = 13},
  [2296] = {.lex_state = 191, .external_lex_state = 5},
  [2297] = {.lex_state = 12, .external_lex_state = 5},
  [2298] = {.lex_state = 7, .external_lex_state = 13},
  [2299] = {.lex_state = 7, .external_lex_state = 13},
  [2300] = {.lex_state = 7, .external_lex_state = 13},
  [2301] = {.lex_state = 191, .external_lex_state = 5},
  [2302] = {.lex_state = 5, .external_lex_state = 14},
  [2303] = {.lex_state = 5, .external_lex_state = 14},
  [2304] = {.lex_state = 5, .external_lex_state = 14},
  [2305] = {.lex_state = 11, .external_lex_state = 32},
  [2306] = {.lex_state = 188, .external_lex_state = 15},
  [2307] = {.lex_state = 191, .external_lex_state = 5},
  [2308] = {.lex_state = 5, .external_lex_state = 14},
  [2309] = {.lex_state = 188, .external_lex_state = 15},
  [2310] = {.lex_state = 191, .external_lex_state = 5},
  [2311] = {.lex_state = 188, .external_lex_state = 13},
  [2312] = {.lex_state = 191, .external_lex_state = 5},
  [2313] = {.lex_state = 188, .external_lex_state = 13},
  [2314] = {.lex_state = 10, .external_lex_state = 13},
  [2315] = {.lex_state = 188, .external_lex_state = 13},
  [2316] = {.lex_state = 7, .external_lex_state = 13},
  [2317] = {.lex_state = 188, .external_lex_state = 15},
  [2318] = {.lex_state = 191, .external_lex_state = 5},
  [2319] = {.lex_state = 188, .external_lex_state = 15},
  [2320] = {.lex_state = 188, .external_lex_state = 13},
  [2321] = {.lex_state = 188, .external_lex_state = 13},
  [2322] = {.lex_state = 7, .external_lex_state = 13},
  [2323] = {.lex_state = 7, .external_lex_state = 13},
  [2324] = {.lex_state = 8, .external_lex_state = 13},
  [2325] = {.lex_state = 7, .external_lex_state = 13},
  [2326] = {.lex_state = 191, .external_lex_state = 5},
  [2327] = {.lex_state = 7, .external_lex_state = 13},
  [2328] = {.lex_state = 5, .external_lex_state = 14},
  [2329] = {.lex_state = 188, .external_lex_state = 15},
  [2330] = {.lex_state = 8, .external_lex_state = 13},
  [2331] = {.lex_state = 188, .external_lex_state = 13},
  [2332] = {.lex_state = 188, .external_lex_state = 13},
  [2333] = {.lex_state = 188, .external_lex_state = 13},
  [2334] = {.lex_state = 5, .external_lex_state = 14},
  [2335] = {.lex_state = 7, .external_lex_state = 13},
  [2336] = {.lex_state = 188, .external_lex_state = 15},
  [2337] = {.lex_state = 7, .external_lex_state = 13},
  [2338] = {.lex_state = 8, .external_lex_state = 13},
  [2339] = {.lex_state = 188, .external_lex_state = 13},
  [2340] = {.lex_state = 188, .external_lex_state = 15},
  [2341] = {.lex_state = 7, .external_lex_state = 13},
  [2342] = {.lex_state = 7, .external_lex_state = 13},
  [2343] = {.lex_state = 9, .external_lex_state = 32},
  [2344] = {.lex_state = 10, .external_lex_state = 13},
  [2345] = {.lex_state = 7, .external_lex_state = 13},
  [2346] = {.lex_state = 188, .external_lex_state = 15},
  [2347] = {.lex_state = 8, .external_lex_state = 13},
  [2348] = {.lex_state = 188, .external_lex_state = 15},
  [2349] = {.lex_state = 7, .external_lex_state = 13},
  [2350] = {.lex_state = 9, .external_lex_state = 32},
  [2351] = {.lex_state = 7, .external_lex_state = 13},
  [2352] = {.lex_state = 7, .external_lex_state = 13},
  [2353] = {.lex_state = 7, .external_lex_state = 13},
  [2354] = {.lex_state = 187, .external_lex_state = 5},
  [2355] = {.lex_state = 188, .external_lex_state = 13},
  [2356] = {.lex_state = 188, .external_lex_state = 13},
  [2357] = {.lex_state = 188, .external_lex_state = 13},
  [2358] = {.lex_state = 9, .external_lex_state = 32},
  [2359] = {.lex_state = 188, .external_lex_state = 13},
  [2360] = {.lex_state = 187, .external_lex_state = 5},
  [2361] = {.lex_state = 10, .external_lex_state = 13},
  [2362] = {.lex_state = 7, .external_lex_state = 13},
  [2363] = {.lex_state = 9, .external_lex_state = 32},
  [2364] = {.lex_state = 7, .external_lex_state = 13},
  [2365] = {.lex_state = 7, .external_lex_state = 13},
  [2366] = {.lex_state = 9, .external_lex_state = 32},
  [2367] = {.lex_state = 9, .external_lex_state = 32},
  [2368] = {.lex_state = 10, .external_lex_state = 13},
  [2369] = {.lex_state = 9, .external_lex_state = 32},
  [2370] = {.lex_state = 9, .external_lex_state = 32},
  [2371] = {.lex_state = 191, .external_lex_state = 5},
  [2372] = {.lex_state = 188, .external_lex_state = 13},
  [2373] = {.lex_state = 11, .external_lex_state = 31},
  [2374] = {.lex_state = 188, .external_lex_state = 13},
  [2375] = {.lex_state = 188, .external_lex_state = 13},
  [2376] = {.lex_state = 11, .external_lex_state = 31},
  [2377] = {.lex_state = 188, .external_lex_state = 13},
  [2378] = {.lex_state = 70, .external_lex_state = 31},
  [2379] = {.lex_state = 188, .external_lex_state = 15},
  [2380] = {.lex_state = 191, .external_lex_state = 5},
  [2381] = {.lex_state = 188, .external_lex_state = 13},
  [2382] = {.lex_state = 7, .external_lex_state = 13},
  [2383] = {.lex_state = 191, .external_lex_state = 5},
  [2384] = {.lex_state = 187, .external_lex_state = 5},
  [2385] = {.lex_state = 188, .external_lex_state = 13},
  [2386] = {.lex_state = 9, .external_lex_state = 31},
  [2387] = {.lex_state = 8, .external_lex_state = 13},
  [2388] = {.lex_state = 191, .external_lex_state = 5},
  [2389] = {.lex_state = 9, .external_lex_state = 31},
  [2390] = {.lex_state = 191, .external_lex_state = 5},
  [2391] = {.lex_state = 187, .external_lex_state = 5},
  [2392] = {.lex_state = 188, .external_lex_state = 15},
  [2393] = {.lex_state = 191, .external_lex_state = 5},
  [2394] = {.lex_state = 188, .external_lex_state = 15},
  [2395] = {.lex_state = 188, .external_lex_state = 15},
  [2396] = {.lex_state = 188, .external_lex_state = 13},
  [2397] = {.lex_state = 187, .external_lex_state = 5},
  [2398] = {.lex_state = 188, .external_lex_state = 13},
  [2399] = {.lex_state = 188, .external_lex_state = 13},
  [2400] = {.lex_state = 188, .external_lex_state = 15},
  [2401] = {.lex_state = 5, .external_lex_state = 14},
  [2402] = {.lex_state = 188, .external_lex_state = 15},
  [2403] = {.lex_state = 9, .external_lex_state = 31},
  [2404] = {.lex_state = 188, .external_lex_state = 13},
  [2405] = {.lex_state = 188, .external_lex_state = 13},
  [2406] = {.lex_state = 188, .external_lex_state = 15},
  [2407] = {.lex_state = 7, .external_lex_state = 13},
  [2408] = {.lex_state = 188, .external_lex_state = 15},
  [2409] = {.lex_state = 7, .external_lex_state = 13},
  [2410] = {.lex_state = 188, .external_lex_state = 13},
  [2411] = {.lex_state = 191, .external_lex_state = 5},
  [2412] = {.lex_state = 188, .external_lex_state = 15},
  [2413] = {.lex_state = 191, .external_lex_state = 5},
  [2414] = {.lex_state = 188, .external_lex_state = 15},
  [2415] = {.lex_state = 191, .external_lex_state = 5},
  [2416] = {.lex_state = 16, .external_lex_state = 13},
  [2417] = {.lex_state = 16, .external_lex_state = 13},
  [2418] = {.lex_state = 188, .external_lex_state = 15},
  [2419] = {.lex_state = 188, .external_lex_state = 15},
  [2420] = {.lex_state = 5, .external_lex_state = 14},
  [2421] = {.lex_state = 191, .external_lex_state = 5},
  [2422] = {.lex_state = 188, .external_lex_state = 13},
  [2423] = {.lex_state = 70, .external_lex_state = 31},
  [2424] = {.lex_state = 188, .external_lex_state = 15},
  [2425] = {.lex_state = 5, .external_lex_state = 14},
  [2426] = {.lex_state = 191, .external_lex_state = 5},
  [2427] = {.lex_state = 16, .external_lex_state = 13},
  [2428] = {.lex_state = 188, .external_lex_state = 13},
  [2429] = {.lex_state = 188, .external_lex_state = 13},
  [2430] = {.lex_state = 191, .external_lex_state = 5},
  [2431] = {.lex_state = 10, .external_lex_state = 13},
  [2432] = {.lex_state = 188, .external_lex_state = 13},
  [2433] = {.lex_state = 191, .external_lex_state = 5},
  [2434] = {.lex_state = 188, .external_lex_state = 13},
  [2435] = {.lex_state = 188, .external_lex_state = 13},
  [2436] = {.lex_state = 187, .external_lex_state = 5},
  [2437] = {.lex_state = 191, .external_lex_state = 5},
  [2438] = {.lex_state = 188, .external_lex_state = 13},
  [2439] = {.lex_state = 188, .external_lex_state = 15},
  [2440] = {.lex_state = 191, .external_lex_state = 5},
  [2441] = {.lex_state = 188, .external_lex_state = 13},
  [2442] = {.lex_state = 188, .external_lex_state = 15},
  [2443] = {.lex_state = 188, .external_lex_state = 15},
  [2444] = {.lex_state = 188, .external_lex_state = 15},
  [2445] = {.lex_state = 188, .external_lex_state = 15},
  [2446] = {.lex_state = 5, .external_lex_state = 14},
  [2447] = {.lex_state = 187, .external_lex_state = 5},
  [2448] = {.lex_state = 5, .external_lex_state = 14},
  [2449] = {.lex_state = 16, .external_lex_state = 13},
  [2450] = {.lex_state = 5, .external_lex_state = 14},
  [2451] = {.lex_state = 7, .external_lex_state = 13},
  [2452] = {.lex_state = 188, .external_lex_state = 15},
  [2453] = {.lex_state = 187, .external_lex_state = 5},
  [2454] = {.lex_state = 5, .external_lex_state = 14},
  [2455] = {.lex_state = 16, .external_lex_state = 13},
  [2456] = {.lex_state = 188, .external_lex_state = 15},
  [2457] = {.lex_state = 188, .external_lex_state = 15},
  [2458] = {.lex_state = 188, .external_lex_state = 15},
  [2459] = {.lex_state = 188, .external_lex_state = 15},
  [2460] = {.lex_state = 5, .external_lex_state = 14},
  [2461] = {.lex_state = 16, .external_lex_state = 13},
  [2462] = {.lex_state = 188, .external_lex_state = 15},
  [2463] = {.lex_state = 188, .external_lex_state = 15},
  [2464] = {.lex_state = 191, .external_lex_state = 5},
  [2465] = {.lex_state = 188, .external_lex_state = 15},
  [2466] = {.lex_state = 188, .external_lex_state = 15},
  [2467] = {.lex_state = 188, .external_lex_state = 15},
  [2468] = {.lex_state = 188, .external_lex_state = 15},
  [2469] = {.lex_state = 188, .external_lex_state = 15},
  [2470] = {.lex_state = 188, .external_lex_state = 15},
  [2471] = {.lex_state = 5, .external_lex_state = 14},
  [2472] = {.lex_state = 11, .external_lex_state = 31},
  [2473] = {.lex_state = 5, .external_lex_state = 14},
  [2474] = {.lex_state = 188, .external_lex_state = 15},
  [2475] = {.lex_state = 188, .external_lex_state = 15},
  [2476] = {.lex_state = 188, .external_lex_state = 15},
  [2477] = {.lex_state = 188, .external_lex_state = 15},
  [2478] = {.lex_state = 188, .external_lex_state = 15},
  [2479] = {.lex_state = 191, .external_lex_state = 5},
  [2480] = {.lex_state = 188, .external_lex_state = 15},
  [2481] = {.lex_state = 188, .external_lex_state = 15},
  [2482] = {.lex_state = 5, .external_lex_state = 14},
  [2483] = {.lex_state = 188, .external_lex_state = 15},
  [2484] = {.lex_state = 5, .external_lex_state = 14},
  [2485] = {.lex_state = 5, .external_lex_state = 14},
  [2486] = {.lex_state = 5, .external_lex_state = 14},
  [2487] = {.lex_state = 5, .external_lex_state = 14},
  [2488] = {.lex_state = 5, .external_lex_state = 14},
  [2489] = {.lex_state = 5, .external_lex_state = 14},
  [2490] = {.lex_state = 5, .external_lex_state = 14},
  [2491] = {.lex_state = 68, .external_lex_state = 13},
  [2492] = {.lex_state = 5, .external_lex_state = 14},
  [2493] = {.lex_state = 11, .external_lex_state = 31},
  [2494] = {.lex_state = 188, .external_lex_state = 13},
  [2495] = {.lex_state = 5, .external_lex_state = 14},
  [2496] = {.lex_state = 191, .external_lex_state = 5},
  [2497] = {.lex_state = 8, .external_lex_state = 13},
  [2498] = {.lex_state = 5, .external_lex_state = 14},
  [2499] = {.lex_state = 5, .external_lex_state = 14},
  [2500] = {.lex_state = 7, .external_lex_state = 13},
  [2501] = {.lex_state = 5, .external_lex_state = 14},
  [2502] = {.lex_state = 9, .external_lex_state = 31},
  [2503] = {.lex_state = 188, .external_lex_state = 13},
  [2504] = {.lex_state = 188, .external_lex_state = 13},
  [2505] = {.lex_state = 188, .external_lex_state = 13},
  [2506] = {.lex_state = 188, .external_lex_state = 13},
  [2507] = {.lex_state = 191, .external_lex_state = 5},
  [2508] = {.lex_state = 188, .external_lex_state = 13},
  [2509] = {.lex_state = 67, .external_lex_state = 13},
  [2510] = {.lex_state = 7, .external_lex_state = 13},
  [2511] = {.lex_state = 7, .external_lex_state = 13},
  [2512] = {.lex_state = 5, .external_lex_state = 14},
  [2513] = {.lex_state = 7, .external_lex_state = 13},
  [2514] = {.lex_state = 7, .external_lex_state = 13},
  [2515] = {.lex_state = 188, .external_lex_state = 13},
  [2516] = {.lex_state = 5, .external_lex_state = 14},
  [2517] = {.lex_state = 188, .external_lex_state = 13},
  [2518] = {.lex_state = 8, .external_lex_state = 13},
  [2519] = {.lex_state = 11, .external_lex_state = 13},
  [2520] = {.lex_state = 9, .external_lex_state = 13},
  [2521] = {.lex_state = 9, .external_lex_state = 13},
  [2522] = {.lex_state = 9, .external_lex_state = 13},
  [2523] = {.lex_state = 11, .external_lex_state = 13},
  [2524] = {.lex_state = 15, .external_lex_state = 4},
  [2525] = {.lex_state = 14, .external_lex_state = 5},
  [2526] = {.lex_state = 14, .external_lex_state = 5},
  [2527] = {.lex_state = 9, .external_lex_state = 13},
  [2528] = {.lex_state = 11, .external_lex_state = 13},
  [2529] = {.lex_state = 17, .external_lex_state = 31},
  [2530] = {.lex_state = 14, .external_lex_state = 5},
  [2531] = {.lex_state = 9, .external_lex_state = 13},
  [2532] = {.lex_state = 16, .external_lex_state = 13},
  [2533] = {.lex_state = 9, .external_lex_state = 13},
  [2534] = {.lex_state = 13, .external_lex_state = 34},
  [2535] = {.lex_state = 11, .external_lex_state = 13},
  [2536] = {.lex_state = 9, .external_lex_state = 13},
  [2537] = {.lex_state = 9, .external_lex_state = 13},
  [2538] = {.lex_state = 71, .external_lex_state = 13},
  [2539] = {.lex_state = 70, .external_lex_state = 13},
  [2540] = {.lex_state = 9, .external_lex_state = 13},
  [2541] = {.lex_state = 17, .external_lex_state = 31},
  [2542] = {.lex_state = 14, .external_lex_state = 5},
  [2543] = {.lex_state = 11, .external_lex_state = 13},
  [2544] = {.lex_state = 17, .external_lex_state = 31},
  [2545] = {.lex_state = 16, .external_lex_state = 13},
  [2546] = {.lex_state = 17, .external_lex_state = 31},
  [2547] = {.lex_state = 13, .external_lex_state = 4},
  [2548] = {.lex_state = 71, .external_lex_state = 13},
  [2549] = {.lex_state = 188, .external_lex_state = 4},
  [2550] = {.lex_state = 9, .external_lex_state = 13},
  [2551] = {.lex_state = 71, .external_lex_state = 13},
  [2552] = {.lex_state = 70, .external_lex_state = 13},
  [2553] = {.lex_state = 187, .external_lex_state = 5},
  [2554] = {.lex_state = 11, .external_lex_state = 13},
  [2555] = {.lex_state = 9, .external_lex_state = 13},
  [2556] = {.lex_state = 15, .external_lex_state = 4},
  [2557] = {.lex_state = 9, .external_lex_state = 13},
  [2558] = {.lex_state = 11, .external_lex_state = 13},
  [2559] = {.lex_state = 71, .external_lex_state = 13},
  [2560] = {.lex_state = 11, .external_lex_state = 13},
  [2561] = {.lex_state = 188, .external_lex_state = 4},
  [2562] = {.lex_state = 11, .external_lex_state = 13},
  [2563] = {.lex_state = 188, .external_lex_state = 34},
  [2564] = {.lex_state = 11, .external_lex_state = 13},
  [2565] = {.lex_state = 11, .external_lex_state = 13},
  [2566] = {.lex_state = 15, .external_lex_state = 4},
  [2567] = {.lex_state = 11, .external_lex_state = 13},
  [2568] = {.lex_state = 11, .external_lex_state = 13},
  [2569] = {.lex_state = 15, .external_lex_state = 4},
  [2570] = {.lex_state = 15, .external_lex_state = 4},
  [2571] = {.lex_state = 15, .external_lex_state = 4},
  [2572] = {.lex_state = 9, .external_lex_state = 13},
  [2573] = {.lex_state = 17, .external_lex_state = 32},
  [2574] = {.lex_state = 11, .external_lex_state = 13},
  [2575] = {.lex_state = 70, .external_lex_state = 13},
  [2576] = {.lex_state = 71, .external_lex_state = 13},
  [2577] = {.lex_state = 11, .external_lex_state = 13},
  [2578] = {.lex_state = 16, .external_lex_state = 13},
  [2579] = {.lex_state = 15, .external_lex_state = 4},
  [2580] = {.lex_state = 15, .external_lex_state = 34},
  [2581] = {.lex_state = 15, .external_lex_state = 4},
  [2582] = {.lex_state = 17, .external_lex_state = 32},
  [2583] = {.lex_state = 14, .external_lex_state = 5},
  [2584] = {.lex_state = 15, .external_lex_state = 4},
  [2585] = {.lex_state = 11, .external_lex_state = 13},
  [2586] = {.lex_state = 13, .external_lex_state = 34},
  [2587] = {.lex_state = 11, .external_lex_state = 13},
  [2588] = {.lex_state = 187, .external_lex_state = 5},
  [2589] = {.lex_state = 12, .external_lex_state = 5},
  [2590] = {.lex_state = 14, .external_lex_state = 5},
  [2591] = {.lex_state = 13, .external_lex_state = 34},
  [2592] = {.lex_state = 16, .external_lex_state = 13},
  [2593] = {.lex_state = 13, .external_lex_state = 34},
  [2594] = {.lex_state = 187, .external_lex_state = 5},
  [2595] = {.lex_state = 12, .external_lex_state = 5},
  [2596] = {.lex_state = 11, .external_lex_state = 13},
  [2597] = {.lex_state = 11, .external_lex_state = 13},
  [2598] = {.lex_state = 17, .external_lex_state = 32},
  [2599] = {.lex_state = 11, .external_lex_state = 13},
  [2600] = {.lex_state = 188, .external_lex_state = 4},
  [2601] = {.lex_state = 15, .external_lex_state = 34},
  [2602] = {.lex_state = 9, .external_lex_state = 13},
  [2603] = {.lex_state = 12, .external_lex_state = 5},
  [2604] = {.lex_state = 188, .external_lex_state = 4},
  [2605] = {.lex_state = 11, .external_lex_state = 13},
  [2606] = {.lex_state = 15, .external_lex_state = 34},
  [2607] = {.lex_state = 17, .external_lex_state = 32},
  [2608] = {.lex_state = 12, .external_lex_state = 5},
  [2609] = {.lex_state = 11, .external_lex_state = 13},
  [2610] = {.lex_state = 13, .external_lex_state = 34},
  [2611] = {.lex_state = 70, .external_lex_state = 13},
  [2612] = {.lex_state = 12, .external_lex_state = 5},
  [2613] = {.lex_state = 16, .external_lex_state = 13},
  [2614] = {.lex_state = 12, .external_lex_state = 5},
  [2615] = {.lex_state = 15, .external_lex_state = 34},
  [2616] = {.lex_state = 11, .external_lex_state = 13},
  [2617] = {.lex_state = 188, .external_lex_state = 4},
  [2618] = {.lex_state = 9, .external_lex_state = 13},
  [2619] = {.lex_state = 11, .external_lex_state = 13},
  [2620] = {.lex_state = 9, .external_lex_state = 13},
  [2621] = {.lex_state = 187, .external_lex_state = 5},
  [2622] = {.lex_state = 17, .external_lex_state = 32},
  [2623] = {.lex_state = 13, .external_lex_state = 4},
  [2624] = {.lex_state = 188, .external_lex_state = 34},
  [2625] = {.lex_state = 11, .external_lex_state = 13},
  [2626] = {.lex_state = 11, .external_lex_state = 13},
  [2627] = {.lex_state = 11, .external_lex_state = 13},
  [2628] = {.lex_state = 17, .external_lex_state = 32},
  [2629] = {.lex_state = 12, .external_lex_state = 5},
  [2630] = {.lex_state = 9, .external_lex_state = 13},
  [2631] = {.lex_state = 11, .external_lex_state = 13},
  [2632] = {.lex_state = 9, .external_lex_state = 13},
  [2633] = {.lex_state = 17, .external_lex_state = 32},
  [2634] = {.lex_state = 9, .external_lex_state = 13},
  [2635] = {.lex_state = 11, .external_lex_state = 13},
  [2636] = {.lex_state = 9, .external_lex_state = 13},
  [2637] = {.lex_state = 16, .external_lex_state = 13},
  [2638] = {.lex_state = 16, .external_lex_state = 13},
  [2639] = {.lex_state = 188, .external_lex_state = 4},
  [2640] = {.lex_state = 11, .external_lex_state = 13},
  [2641] = {.lex_state = 17, .external_lex_state = 32},
  [2642] = {.lex_state = 71, .external_lex_state = 13},
  [2643] = {.lex_state = 13, .external_lex_state = 4},
  [2644] = {.lex_state = 9, .external_lex_state = 13},
  [2645] = {.lex_state = 188, .external_lex_state = 34},
  [2646] = {.lex_state = 187, .external_lex_state = 5},
  [2647] = {.lex_state = 70, .external_lex_state = 13},
  [2648] = {.lex_state = 9, .external_lex_state = 13},
  [2649] = {.lex_state = 70, .external_lex_state = 13},
  [2650] = {.lex_state = 9, .external_lex_state = 13},
  [2651] = {.lex_state = 71, .external_lex_state = 13},
  [2652] = {.lex_state = 9, .external_lex_state = 13},
  [2653] = {.lex_state = 9, .external_lex_state = 13},
  [2654] = {.lex_state = 9, .external_lex_state = 13},
  [2655] = {.lex_state = 71, .external_lex_state = 13},
  [2656] = {.lex_state = 9, .external_lex_state = 13},
  [2657] = {.lex_state = 11, .external_lex_state = 13},
  [2658] = {.lex_state = 188, .external_lex_state = 4},
  [2659] = {.lex_state = 11, .external_lex_state = 13},
  [2660] = {.lex_state = 17, .external_lex_state = 32},
  [2661] = {.lex_state = 188, .external_lex_state = 4},
  [2662] = {.lex_state = 11, .external_lex_state = 13},
  [2663] = {.lex_state = 13, .external_lex_state = 4},
  [2664] = {.lex_state = 13, .external_lex_state = 4},
  [2665] = {.lex_state = 13, .external_lex_state = 4},
  [2666] = {.lex_state = 188, .external_lex_state = 4},
  [2667] = {.lex_state = 13, .external_lex_state = 4},
  [2668] = {.lex_state = 11, .external_lex_state = 13},
  [2669] = {.lex_state = 11, .external_lex_state = 13},
  [2670] = {.lex_state = 17, .external_lex_state = 31},
  [2671] = {.lex_state = 11, .external_lex_state = 13},
  [2672] = {.lex_state = 11, .external_lex_state = 13},
  [2673] = {.lex_state = 187, .external_lex_state = 5},
  [2674] = {.lex_state = 9, .external_lex_state = 13},
  [2675] = {.lex_state = 9, .external_lex_state = 13},
  [2676] = {.lex_state = 70, .external_lex_state = 13},
  [2677] = {.lex_state = 13, .external_lex_state = 4},
  [2678] = {.lex_state = 9, .external_lex_state = 13},
  [2679] = {.lex_state = 15, .external_lex_state = 34},
  [2680] = {.lex_state = 188, .external_lex_state = 34},
  [2681] = {.lex_state = 13, .external_lex_state = 4},
  [2682] = {.lex_state = 9, .external_lex_state = 13},
  [2683] = {.lex_state = 9, .external_lex_state = 13},
  [2684] = {.lex_state = 11, .external_lex_state = 13},
  [2685] = {.lex_state = 9, .external_lex_state = 13},
  [2686] = {.lex_state = 188, .external_lex_state = 34},
  [2687] = {.lex_state = 9, .external_lex_state = 13},
  [2688] = {.lex_state = 14, .external_lex_state = 5},
  [2689] = {.lex_state = 9, .external_lex_state = 13},
  [2690] = {.lex_state = 11, .external_lex_state = 13},
  [2691] = {.lex_state = 187, .external_lex_state = 5},
  [2692] = {.lex_state = 187, .external_lex_state = 5},
  [2693] = {.lex_state = 9, .external_lex_state = 13},
  [2694] = {.lex_state = 9, .external_lex_state = 13},
  [2695] = {.lex_state = 9, .external_lex_state = 13},
  [2696] = {.lex_state = 9, .external_lex_state = 13},
  [2697] = {.lex_state = 11, .external_lex_state = 13},
  [2698] = {.lex_state = 9, .external_lex_state = 13},
  [2699] = {.lex_state = 9, .external_lex_state = 13},
  [2700] = {.lex_state = 9, .external_lex_state = 13},
  [2701] = {.lex_state = 11, .external_lex_state = 13},
  [2702] = {.lex_state = 11, .external_lex_state = 13},
  [2703] = {.lex_state = 18, .external_lex_state = 32},
  [2704] = {.lex_state = 188, .external_lex_state = 5},
  [2705] = {.lex_state = 17, .external_lex_state = 13},
  [2706] = {.lex_state = 13, .external_lex_state = 5},
  [2707] = {.lex_state = 18, .external_lex_state = 32},
  [2708] = {.lex_state = 188, .external_lex_state = 5},
  [2709] = {.lex_state = 15, .external_lex_state = 5},
  [2710] = {.lex_state = 17, .external_lex_state = 13},
  [2711] = {.lex_state = 17, .external_lex_state = 13},
  [2712] = {.lex_state = 17, .external_lex_state = 13},
  [2713] = {.lex_state = 188, .external_lex_state = 5},
  [2714] = {.lex_state = 13, .external_lex_state = 5},
  [2715] = {.lex_state = 71, .external_lex_state = 13},
  [2716] = {.lex_state = 15, .external_lex_state = 5},
  [2717] = {.lex_state = 13, .external_lex_state = 5},
  [2718] = {.lex_state = 13, .external_lex_state = 5},
  [2719] = {.lex_state = 188, .external_lex_state = 5},
  [2720] = {.lex_state = 17, .external_lex_state = 13},
  [2721] = {.lex_state = 17, .external_lex_state = 13},
  [2722] = {.lex_state = 188, .external_lex_state = 5},
  [2723] = {.lex_state = 17, .external_lex_state = 13},
  [2724] = {.lex_state = 13, .external_lex_state = 5},
  [2725] = {.lex_state = 15, .external_lex_state = 5},
  [2726] = {.lex_state = 17, .external_lex_state = 13},
  [2727] = {.lex_state = 17, .external_lex_state = 13},
  [2728] = {.lex_state = 17, .external_lex_state = 13},
  [2729] = {.lex_state = 188, .external_lex_state = 5},
  [2730] = {.lex_state = 188, .external_lex_state = 5},
  [2731] = {.lex_state = 193, .external_lex_state = 11},
  [2732] = {.lex_state = 17, .external_lex_state = 13},
  [2733] = {.lex_state = 188, .external_lex_state = 5},
  [2734] = {.lex_state = 17, .external_lex_state = 13},
  [2735] = {.lex_state = 19, .external_lex_state = 5},
  [2736] = {.lex_state = 19, .external_lex_state = 5},
  [2737] = {.lex_state = 17, .external_lex_state = 13},
  [2738] = {.lex_state = 13, .external_lex_state = 5},
  [2739] = {.lex_state = 188, .external_lex_state = 5},
  [2740] = {.lex_state = 15, .external_lex_state = 5},
  [2741] = {.lex_state = 193, .external_lex_state = 10},
  [2742] = {.lex_state = 13, .external_lex_state = 5},
  [2743] = {.lex_state = 17, .external_lex_state = 13},
  [2744] = {.lex_state = 17, .external_lex_state = 13},
  [2745] = {.lex_state = 17, .external_lex_state = 13},
  [2746] = {.lex_state = 13, .external_lex_state = 5},
  [2747] = {.lex_state = 13, .external_lex_state = 5},
  [2748] = {.lex_state = 15, .external_lex_state = 5},
  [2749] = {.lex_state = 13, .external_lex_state = 5},
  [2750] = {.lex_state = 17, .external_lex_state = 13},
  [2751] = {.lex_state = 13, .external_lex_state = 5},
  [2752] = {.lex_state = 17, .external_lex_state = 13},
  [2753] = {.lex_state = 18, .external_lex_state = 32},
  [2754] = {.lex_state = 19, .external_lex_state = 5},
  [2755] = {.lex_state = 17, .external_lex_state = 13},
  [2756] = {.lex_state = 13, .external_lex_state = 5},
  [2757] = {.lex_state = 13, .external_lex_state = 5},
  [2758] = {.lex_state = 17, .external_lex_state = 13},
  [2759] = {.lex_state = 188, .external_lex_state = 5},
  [2760] = {.lex_state = 13, .external_lex_state = 5},
  [2761] = {.lex_state = 17, .external_lex_state = 13},
  [2762] = {.lex_state = 19, .external_lex_state = 5},
  [2763] = {.lex_state = 13, .external_lex_state = 5},
  [2764] = {.lex_state = 188, .external_lex_state = 5},
  [2765] = {.lex_state = 188, .external_lex_state = 5},
  [2766] = {.lex_state = 188, .external_lex_state = 5},
  [2767] = {.lex_state = 193, .external_lex_state = 11},
  [2768] = {.lex_state = 188, .external_lex_state = 5},
  [2769] = {.lex_state = 17, .external_lex_state = 13},
  [2770] = {.lex_state = 17, .external_lex_state = 13},
  [2771] = {.lex_state = 13, .external_lex_state = 5},
  [2772] = {.lex_state = 188, .external_lex_state = 5},
  [2773] = {.lex_state = 17, .external_lex_state = 13},
  [2774] = {.lex_state = 13, .external_lex_state = 5},
  [2775] = {.lex_state = 17, .external_lex_state = 13},
  [2776] = {.lex_state = 13, .external_lex_state = 5},
  [2777] = {.lex_state = 188, .external_lex_state = 5},
  [2778] = {.lex_state = 188, .external_lex_state = 5},
  [2779] = {.lex_state = 17, .external_lex_state = 13},
  [2780] = {.lex_state = 18, .external_lex_state = 32},
  [2781] = {.lex_state = 13, .external_lex_state = 5},
  [2782] = {.lex_state = 13, .external_lex_state = 5},
  [2783] = {.lex_state = 19, .external_lex_state = 5},
  [2784] = {.lex_state = 19, .external_lex_state = 5},
  [2785] = {.lex_state = 18, .external_lex_state = 31},
  [2786] = {.lex_state = 17, .external_lex_state = 13},
  [2787] = {.lex_state = 17, .external_lex_state = 13},
  [2788] = {.lex_state = 13, .external_lex_state = 5},
  [2789] = {.lex_state = 17, .external_lex_state = 13},
  [2790] = {.lex_state = 18, .external_lex_state = 31},
  [2791] = {.lex_state = 17, .external_lex_state = 13},
  [2792] = {.lex_state = 13, .external_lex_state = 5},
  [2793] = {.lex_state = 188, .external_lex_state = 5},
  [2794] = {.lex_state = 18, .external_lex_state = 32},
  [2795] = {.lex_state = 17, .external_lex_state = 13},
  [2796] = {.lex_state = 188, .external_lex_state = 5},
  [2797] = {.lex_state = 18, .external_lex_state = 32},
  [2798] = {.lex_state = 13, .external_lex_state = 5},
  [2799] = {.lex_state = 13, .external_lex_state = 5},
  [2800] = {.lex_state = 13, .external_lex_state = 5},
  [2801] = {.lex_state = 18, .external_lex_state = 31},
  [2802] = {.lex_state = 15, .external_lex_state = 5},
  [2803] = {.lex_state = 13, .external_lex_state = 5},
  [2804] = {.lex_state = 18, .external_lex_state = 32},
  [2805] = {.lex_state = 188, .external_lex_state = 5},
  [2806] = {.lex_state = 15, .external_lex_state = 5},
  [2807] = {.lex_state = 15, .external_lex_state = 5},
  [2808] = {.lex_state = 188, .external_lex_state = 5},
  [2809] = {.lex_state = 188, .external_lex_state = 5},
  [2810] = {.lex_state = 17, .external_lex_state = 13},
  [2811] = {.lex_state = 71, .external_lex_state = 13},
  [2812] = {.lex_state = 18, .external_lex_state = 31},
  [2813] = {.lex_state = 188, .external_lex_state = 5},
  [2814] = {.lex_state = 13, .external_lex_state = 5},
  [2815] = {.lex_state = 15, .external_lex_state = 5},
  [2816] = {.lex_state = 188, .external_lex_state = 5},
  [2817] = {.lex_state = 18, .external_lex_state = 32},
  [2818] = {.lex_state = 188, .external_lex_state = 5},
  [2819] = {.lex_state = 13, .external_lex_state = 5},
  [2820] = {.lex_state = 15, .external_lex_state = 5},
  [2821] = {.lex_state = 13, .external_lex_state = 5},
  [2822] = {.lex_state = 17, .external_lex_state = 13},
  [2823] = {.lex_state = 188, .external_lex_state = 5},
  [2824] = {.lex_state = 18, .external_lex_state = 31},
  [2825] = {.lex_state = 15, .external_lex_state = 5},
  [2826] = {.lex_state = 71, .external_lex_state = 13},
  [2827] = {.lex_state = 13, .external_lex_state = 5},
  [2828] = {.lex_state = 15, .external_lex_state = 5},
  [2829] = {.lex_state = 15, .external_lex_state = 5},
  [2830] = {.lex_state = 15, .external_lex_state = 5},
  [2831] = {.lex_state = 15, .external_lex_state = 5},
  [2832] = {.lex_state = 15, .external_lex_state = 5},
  [2833] = {.lex_state = 15, .external_lex_state = 5},
  [2834] = {.lex_state = 13, .external_lex_state = 5},
  [2835] = {.lex_state = 13, .external_lex_state = 5},
  [2836] = {.lex_state = 15, .external_lex_state = 5},
  [2837] = {.lex_state = 15, .external_lex_state = 5},
  [2838] = {.lex_state = 13, .external_lex_state = 5},
  [2839] = {.lex_state = 188, .external_lex_state = 5},
  [2840] = {.lex_state = 15, .external_lex_state = 5},
  [2841] = {.lex_state = 17, .external_lex_state = 13},
  [2842] = {.lex_state = 13, .external_lex_state = 5},
  [2843] = {.lex_state = 15, .external_lex_state = 5},
  [2844] = {.lex_state = 188, .external_lex_state = 5},
  [2845] = {.lex_state = 13, .external_lex_state = 5},
  [2846] = {.lex_state = 15, .external_lex_state = 5},
  [2847] = {.lex_state = 15, .external_lex_state = 5},
  [2848] = {.lex_state = 15, .external_lex_state = 5},
  [2849] = {.lex_state = 13, .external_lex_state = 5},
  [2850] = {.lex_state = 13, .external_lex_state = 5},
  [2851] = {.lex_state = 15, .external_lex_state = 5},
  [2852] = {.lex_state = 15, .external_lex_state = 5},
  [2853] = {.lex_state = 15, .external_lex_state = 5},
  [2854] = {.lex_state = 15, .external_lex_state = 5},
  [2855] = {.lex_state = 15, .external_lex_state = 5},
  [2856] = {.lex_state = 17, .external_lex_state = 13},
  [2857] = {.lex_state = 188, .external_lex_state = 5},
  [2858] = {.lex_state = 13, .external_lex_state = 5},
  [2859] = {.lex_state = 188, .external_lex_state = 5},
  [2860] = {.lex_state = 17, .external_lex_state = 13},
  [2861] = {.lex_state = 15, .external_lex_state = 5},
  [2862] = {.lex_state = 188, .external_lex_state = 5},
  [2863] = {.lex_state = 13, .external_lex_state = 5},
  [2864] = {.lex_state = 15, .external_lex_state = 5},
  [2865] = {.lex_state = 18, .external_lex_state = 32},
  [2866] = {.lex_state = 15, .external_lex_state = 5},
  [2867] = {.lex_state = 15, .external_lex_state = 5},
  [2868] = {.lex_state = 15, .external_lex_state = 5},
  [2869] = {.lex_state = 71, .external_lex_state = 13},
  [2870] = {.lex_state = 17, .external_lex_state = 13},
  [2871] = {.lex_state = 71, .external_lex_state = 13},
  [2872] = {.lex_state = 15, .external_lex_state = 5},
  [2873] = {.lex_state = 188, .external_lex_state = 5},
  [2874] = {.lex_state = 13, .external_lex_state = 5},
  [2875] = {.lex_state = 188, .external_lex_state = 5},
  [2876] = {.lex_state = 188, .external_lex_state = 5},
  [2877] = {.lex_state = 13, .external_lex_state = 5},
  [2878] = {.lex_state = 13, .external_lex_state = 5},
  [2879] = {.lex_state = 188, .external_lex_state = 5},
  [2880] = {.lex_state = 15, .external_lex_state = 5},
  [2881] = {.lex_state = 188, .external_lex_state = 5},
  [2882] = {.lex_state = 188, .external_lex_state = 5},
  [2883] = {.lex_state = 188, .external_lex_state = 5},
  [2884] = {.lex_state = 188, .external_lex_state = 5},
  [2885] = {.lex_state = 188, .external_lex_state = 5},
  [2886] = {.lex_state = 188, .external_lex_state = 5},
  [2887] = {.lex_state = 15, .external_lex_state = 5},
  [2888] = {.lex_state = 71, .external_lex_state = 13},
  [2889] = {.lex_state = 17, .external_lex_state = 13},
  [2890] = {.lex_state = 17, .external_lex_state = 13},
  [2891] = {.lex_state = 188, .external_lex_state = 5},
  [2892] = {.lex_state = 17, .external_lex_state = 13},
  [2893] = {.lex_state = 188, .external_lex_state = 5},
  [2894] = {.lex_state = 188, .external_lex_state = 5},
  [2895] = {.lex_state = 15, .external_lex_state = 5},
  [2896] = {.lex_state = 17, .external_lex_state = 13},
  [2897] = {.lex_state = 15, .external_lex_state = 5},
  [2898] = {.lex_state = 193, .external_lex_state = 10},
  [2899] = {.lex_state = 17, .external_lex_state = 13},
  [2900] = {.lex_state = 15, .external_lex_state = 5},
  [2901] = {.lex_state = 15, .external_lex_state = 5},
  [2902] = {.lex_state = 15, .external_lex_state = 5},
  [2903] = {.lex_state = 188, .external_lex_state = 5},
  [2904] = {.lex_state = 18, .external_lex_state = 13},
  [2905] = {.lex_state = 18, .external_lex_state = 13},
  [2906] = {.lex_state = 18, .external_lex_state = 13},
  [2907] = {.lex_state = 18, .external_lex_state = 13},
  [2908] = {.lex_state = 18, .external_lex_state = 13},
  [2909] = {.lex_state = 20, .external_lex_state = 4},
  [2910] = {.lex_state = 18, .external_lex_state = 13},
  [2911] = {.lex_state = 18, .external_lex_state = 13},
  [2912] = {.lex_state = 18, .external_lex_state = 13},
  [2913] = {.lex_state = 18, .external_lex_state = 13},
  [2914] = {.lex_state = 20, .external_lex_state = 4},
  [2915] = {.lex_state = 20, .external_lex_state = 4},
  [2916] = {.lex_state = 18, .external_lex_state = 13},
  [2917] = {.lex_state = 20, .external_lex_state = 4},
  [2918] = {.lex_state = 20, .external_lex_state = 4},
  [2919] = {.lex_state = 18, .external_lex_state = 13},
  [2920] = {.lex_state = 20, .external_lex_state = 4},
  [2921] = {.lex_state = 20, .external_lex_state = 4},
  [2922] = {.lex_state = 18, .external_lex_state = 13},
  [2923] = {.lex_state = 19, .external_lex_state = 5},
  [2924] = {.lex_state = 18, .external_lex_state = 13},
  [2925] = {.lex_state = 191, .external_lex_state = 26},
  [2926] = {.lex_state = 18, .external_lex_state = 13},
  [2927] = {.lex_state = 20, .external_lex_state = 4},
  [2928] = {.lex_state = 18, .external_lex_state = 13},
  [2929] = {.lex_state = 19, .external_lex_state = 5},
  [2930] = {.lex_state = 18, .external_lex_state = 13},
  [2931] = {.lex_state = 18, .external_lex_state = 13},
  [2932] = {.lex_state = 191, .external_lex_state = 23},
  [2933] = {.lex_state = 20, .external_lex_state = 34},
  [2934] = {.lex_state = 18, .external_lex_state = 13},
  [2935] = {.lex_state = 20, .external_lex_state = 4},
  [2936] = {.lex_state = 18, .external_lex_state = 13},
  [2937] = {.lex_state = 18, .external_lex_state = 13},
  [2938] = {.lex_state = 18, .external_lex_state = 13},
  [2939] = {.lex_state = 18, .external_lex_state = 13},
  [2940] = {.lex_state = 19, .external_lex_state = 5},
  [2941] = {.lex_state = 18, .external_lex_state = 13},
  [2942] = {.lex_state = 19, .external_lex_state = 5},
  [2943] = {.lex_state = 18, .external_lex_state = 13},
  [2944] = {.lex_state = 19, .external_lex_state = 5},
  [2945] = {.lex_state = 18, .external_lex_state = 13},
  [2946] = {.lex_state = 18, .external_lex_state = 13},
  [2947] = {.lex_state = 20, .external_lex_state = 34},
  [2948] = {.lex_state = 18, .external_lex_state = 13},
  [2949] = {.lex_state = 18, .external_lex_state = 13},
  [2950] = {.lex_state = 18, .external_lex_state = 13},
  [2951] = {.lex_state = 18, .external_lex_state = 13},
  [2952] = {.lex_state = 18, .external_lex_state = 13},
  [2953] = {.lex_state = 18, .external_lex_state = 13},
  [2954] = {.lex_state = 18, .external_lex_state = 13},
  [2955] = {.lex_state = 18, .external_lex_state = 13},
  [2956] = {.lex_state = 18, .external_lex_state = 13},
  [2957] = {.lex_state = 18, .external_lex_state = 13},
  [2958] = {.lex_state = 18, .external_lex_state = 13},
  [2959] = {.lex_state = 18, .external_lex_state = 13},
  [2960] = {.lex_state = 20, .external_lex_state = 34},
  [2961] = {.lex_state = 20, .external_lex_state = 34},
  [2962] = {.lex_state = 18, .external_lex_state = 13},
  [2963] = {.lex_state = 18, .external_lex_state = 13},
  [2964] = {.lex_state = 19, .external_lex_state = 5},
  [2965] = {.lex_state = 20, .external_lex_state = 34},
  [2966] = {.lex_state = 18, .external_lex_state = 13},
  [2967] = {.lex_state = 19, .external_lex_state = 5},
  [2968] = {.lex_state = 18, .external_lex_state = 13},
  [2969] = {.lex_state = 20, .external_lex_state = 5},
  [2970] = {.lex_state = 20, .external_lex_state = 5},
  [2971] = {.lex_state = 20, .external_lex_state = 5},
  [2972] = {.lex_state = 20, .external_lex_state = 5},
  [2973] = {.lex_state = 20, .external_lex_state = 5},
  [2974] = {.lex_state = 20, .external_lex_state = 5},
  [2975] = {.lex_state = 20, .external_lex_state = 5},
  [2976] = {.lex_state = 20, .external_lex_state = 5},
  [2977] = {.lex_state = 20, .external_lex_state = 5},
  [2978] = {.lex_state = 20, .external_lex_state = 5},
  [2979] = {.lex_state = 20, .external_lex_state = 5},
  [2980] = {.lex_state = 20, .external_lex_state = 5},
  [2981] = {.lex_state = 20, .external_lex_state = 5},
  [2982] = {.lex_state = 20, .external_lex_state = 5},
  [2983] = {.lex_state = 20, .external_lex_state = 5},
  [2984] = {.lex_state = 20, .external_lex_state = 5},
  [2985] = {.lex_state = 20, .external_lex_state = 5},
  [2986] = {.lex_state = 196, .external_lex_state = 18},
  [2987] = {.lex_state = 20, .external_lex_state = 5},
  [2988] = {.lex_state = 20, .external_lex_state = 5},
  [2989] = {.lex_state = 195, .external_lex_state = 10},
  [2990] = {.lex_state = 20, .external_lex_state = 5},
  [2991] = {.lex_state = 20, .external_lex_state = 5},
  [2992] = {.lex_state = 20, .external_lex_state = 5},
  [2993] = {.lex_state = 20, .external_lex_state = 5},
  [2994] = {.lex_state = 20, .external_lex_state = 5},
  [2995] = {.lex_state = 195, .external_lex_state = 11},
  [2996] = {.lex_state = 20, .external_lex_state = 5},
  [2997] = {.lex_state = 195, .external_lex_state = 11},
  [2998] = {.lex_state = 20, .external_lex_state = 5},
  [2999] = {.lex_state = 195, .external_lex_state = 10},
  [3000] = {.lex_state = 20, .external_lex_state = 5},
  [3001] = {.lex_state = 196, .external_lex_state = 17},
  [3002] = {.lex_state = 20, .external_lex_state = 5},
  [3003] = {.lex_state = 20, .external_lex_state = 5},
  [3004] = {.lex_state = 196, .external_lex_state = 17},
  [3005] = {.lex_state = 20, .external_lex_state = 5},
  [3006] = {.lex_state = 20, .external_lex_state = 5},
  [3007] = {.lex_state = 20, .external_lex_state = 5},
  [3008] = {.lex_state = 20, .external_lex_state = 5},
  [3009] = {.lex_state = 20, .external_lex_state = 5},
  [3010] = {.lex_state = 20, .external_lex_state = 5},
  [3011] = {.lex_state = 20, .external_lex_state = 5},
  [3012] = {.lex_state = 20, .external_lex_state = 5},
  [3013] = {.lex_state = 196, .external_lex_state = 18},
  [3014] = {.lex_state = 20, .external_lex_state = 5},
  [3015] = {.lex_state = 20, .external_lex_state = 5},
  [3016] = {.lex_state = 20, .external_lex_state = 5},
  [3017] = {.lex_state = 20, .external_lex_state = 5},
  [3018] = {.lex_state = 20, .external_lex_state = 5},
  [3019] = {.lex_state = 191, .external_lex_state = 26},
  [3020] = {.lex_state = 191, .external_lex_state = 23},
  [3021] = {.lex_state = 192, .external_lex_state = 23},
  [3022] = {.lex_state = 184, .external_lex_state = 5},
  [3023] = {.lex_state = 184, .external_lex_state = 5},
  [3024] = {.lex_state = 199, .external_lex_state = 8},
  [3025] = {.lex_state = 195, .external_lex_state = 13},
  [3026] = {.lex_state = 192, .external_lex_state = 26},
  [3027] = {.lex_state = 199, .external_lex_state = 9},
  [3028] = {.lex_state = 199, .external_lex_state = 7},
  [3029] = {.lex_state = 45, .external_lex_state = 5},
  [3030] = {.lex_state = 192, .external_lex_state = 26},
  [3031] = {.lex_state = 193, .external_lex_state = 5},
  [3032] = {.lex_state = 24, .external_lex_state = 24},
  [3033] = {.lex_state = 73, .external_lex_state = 34},
  [3034] = {.lex_state = 73, .external_lex_state = 34},
  [3035] = {.lex_state = 199, .external_lex_state = 7},
  [3036] = {.lex_state = 192, .external_lex_state = 23},
  [3037] = {.lex_state = 192, .external_lex_state = 26},
  [3038] = {.lex_state = 199, .external_lex_state = 8},
  [3039] = {.lex_state = 184, .external_lex_state = 5},
  [3040] = {.lex_state = 45, .external_lex_state = 5},
  [3041] = {.lex_state = 199, .external_lex_state = 9},
  [3042] = {.lex_state = 24, .external_lex_state = 24},
  [3043] = {.lex_state = 193, .external_lex_state = 5},
  [3044] = {.lex_state = 192, .external_lex_state = 23},
  [3045] = {.lex_state = 195, .external_lex_state = 13},
  [3046] = {.lex_state = 24, .external_lex_state = 24},
  [3047] = {.lex_state = 191, .external_lex_state = 5},
  [3048] = {.lex_state = 191, .external_lex_state = 26},
  [3049] = {.lex_state = 200, .external_lex_state = 11},
  [3050] = {.lex_state = 73, .external_lex_state = 5},
  [3051] = {.lex_state = 200, .external_lex_state = 10},
  [3052] = {.lex_state = 200, .external_lex_state = 12},
  [3053] = {.lex_state = 192, .external_lex_state = 9},
  [3054] = {.lex_state = 192, .external_lex_state = 7},
  [3055] = {.lex_state = 192, .external_lex_state = 9},
  [3056] = {.lex_state = 31, .external_lex_state = 27},
  [3057] = {.lex_state = 194, .external_lex_state = 28},
  [3058] = {.lex_state = 191, .external_lex_state = 5},
  [3059] = {.lex_state = 192, .external_lex_state = 9},
  [3060] = {.lex_state = 191, .external_lex_state = 23},
  [3061] = {.lex_state = 24, .external_lex_state = 8},
  [3062] = {.lex_state = 24, .external_lex_state = 8},
  [3063] = {.lex_state = 201, .external_lex_state = 9},
  [3064] = {.lex_state = 24, .external_lex_state = 8},
  [3065] = {.lex_state = 192, .external_lex_state = 7},
  [3066] = {.lex_state = 194, .external_lex_state = 28},
  [3067] = {.lex_state = 24, .external_lex_state = 8},
  [3068] = {.lex_state = 24, .external_lex_state = 8},
  [3069] = {.lex_state = 192, .external_lex_state = 7},
  [3070] = {.lex_state = 24, .external_lex_state = 8},
  [3071] = {.lex_state = 192, .external_lex_state = 9},
  [3072] = {.lex_state = 192, .external_lex_state = 7},
  [3073] = {.lex_state = 24, .external_lex_state = 8},
  [3074] = {.lex_state = 192, .external_lex_state = 7},
  [3075] = {.lex_state = 24, .external_lex_state = 8},
  [3076] = {.lex_state = 24, .external_lex_state = 8},
  [3077] = {.lex_state = 24, .external_lex_state = 8},
  [3078] = {.lex_state = 24, .external_lex_state = 8},
  [3079] = {.lex_state = 192, .external_lex_state = 9},
  [3080] = {.lex_state = 24, .external_lex_state = 8},
  [3081] = {.lex_state = 24, .external_lex_state = 8},
  [3082] = {.lex_state = 24, .external_lex_state = 8},
  [3083] = {.lex_state = 192, .external_lex_state = 9},
  [3084] = {.lex_state = 192, .external_lex_state = 9},
  [3085] = {.lex_state = 200, .external_lex_state = 11},
  [3086] = {.lex_state = 200, .external_lex_state = 12},
  [3087] = {.lex_state = 201, .external_lex_state = 9},
  [3088] = {.lex_state = 192, .external_lex_state = 9},
  [3089] = {.lex_state = 24, .external_lex_state = 8},
  [3090] = {.lex_state = 192, .external_lex_state = 7},
  [3091] = {.lex_state = 192, .external_lex_state = 7},
  [3092] = {.lex_state = 193, .external_lex_state = 28},
  [3093] = {.lex_state = 23, .external_lex_state = 31},
  [3094] = {.lex_state = 191, .external_lex_state = 35},
  [3095] = {.lex_state = 201, .external_lex_state = 7},
  [3096] = {.lex_state = 201, .external_lex_state = 7},
  [3097] = {.lex_state = 193, .external_lex_state = 29},
  [3098] = {.lex_state = 191, .external_lex_state = 26},
  [3099] = {.lex_state = 194, .external_lex_state = 29},
  [3100] = {.lex_state = 31, .external_lex_state = 27},
  [3101] = {.lex_state = 201, .external_lex_state = 9},
  [3102] = {.lex_state = 192, .external_lex_state = 9},
  [3103] = {.lex_state = 29, .external_lex_state = 16},
  [3104] = {.lex_state = 24, .external_lex_state = 8},
  [3105] = {.lex_state = 192, .external_lex_state = 7},
  [3106] = {.lex_state = 29, .external_lex_state = 16},
  [3107] = {.lex_state = 193, .external_lex_state = 29},
  [3108] = {.lex_state = 192, .external_lex_state = 7},
  [3109] = {.lex_state = 191, .external_lex_state = 23},
  [3110] = {.lex_state = 24, .external_lex_state = 8},
  [3111] = {.lex_state = 192, .external_lex_state = 9},
  [3112] = {.lex_state = 192, .external_lex_state = 9},
  [3113] = {.lex_state = 192, .external_lex_state = 9},
  [3114] = {.lex_state = 192, .external_lex_state = 7},
  [3115] = {.lex_state = 192, .external_lex_state = 7},
  [3116] = {.lex_state = 194, .external_lex_state = 29},
  [3117] = {.lex_state = 200, .external_lex_state = 10},
  [3118] = {.lex_state = 201, .external_lex_state = 7},
  [3119] = {.lex_state = 192, .external_lex_state = 9},
  [3120] = {.lex_state = 192, .external_lex_state = 9},
  [3121] = {.lex_state = 192, .external_lex_state = 7},
  [3122] = {.lex_state = 193, .external_lex_state = 28},
  [3123] = {.lex_state = 201, .external_lex_state = 7},
  [3124] = {.lex_state = 201, .external_lex_state = 9},
  [3125] = {.lex_state = 193, .external_lex_state = 28},
  [3126] = {.lex_state = 29, .external_lex_state = 16},
  [3127] = {.lex_state = 192, .external_lex_state = 9},
  [3128] = {.lex_state = 192, .external_lex_state = 7},
  [3129] = {.lex_state = 193, .external_lex_state = 29},
  [3130] = {.lex_state = 192, .external_lex_state = 7},
  [3131] = {.lex_state = 31, .external_lex_state = 27},
  [3132] = {.lex_state = 192, .external_lex_state = 7},
  [3133] = {.lex_state = 192, .external_lex_state = 9},
  [3134] = {.lex_state = 194, .external_lex_state = 28},
  [3135] = {.lex_state = 194, .external_lex_state = 29},
  [3136] = {.lex_state = 24, .external_lex_state = 8},
  [3137] = {.lex_state = 192, .external_lex_state = 7},
  [3138] = {.lex_state = 192, .external_lex_state = 9},
  [3139] = {.lex_state = 73, .external_lex_state = 5},
  [3140] = {.lex_state = 192, .external_lex_state = 7},
  [3141] = {.lex_state = 192, .external_lex_state = 7},
  [3142] = {.lex_state = 192, .external_lex_state = 9},
  [3143] = {.lex_state = 193, .external_lex_state = 10},
  [3144] = {.lex_state = 194, .external_lex_state = 11},
  [3145] = {.lex_state = 200, .external_lex_state = 14},
  [3146] = {.lex_state = 191, .external_lex_state = 29},
  [3147] = {.lex_state = 193, .external_lex_state = 11},
  [3148] = {.lex_state = 193, .external_lex_state = 10},
  [3149] = {.lex_state = 193, .external_lex_state = 11},
  [3150] = {.lex_state = 193, .external_lex_state = 11},
  [3151] = {.lex_state = 194, .external_lex_state = 31},
  [3152] = {.lex_state = 200, .external_lex_state = 15},
  [3153] = {.lex_state = 200, .external_lex_state = 14},
  [3154] = {.lex_state = 194, .external_lex_state = 21},
  [3155] = {.lex_state = 194, .external_lex_state = 11},
  [3156] = {.lex_state = 193, .external_lex_state = 10},
  [3157] = {.lex_state = 193, .external_lex_state = 11},
  [3158] = {.lex_state = 194, .external_lex_state = 10},
  [3159] = {.lex_state = 193, .external_lex_state = 11},
  [3160] = {.lex_state = 193, .external_lex_state = 10},
  [3161] = {.lex_state = 193, .external_lex_state = 11},
  [3162] = {.lex_state = 23, .external_lex_state = 31},
  [3163] = {.lex_state = 191, .external_lex_state = 28},
  [3164] = {.lex_state = 191, .external_lex_state = 7},
  [3165] = {.lex_state = 193, .external_lex_state = 10},
  [3166] = {.lex_state = 31, .external_lex_state = 25},
  [3167] = {.lex_state = 193, .external_lex_state = 11},
  [3168] = {.lex_state = 194, .external_lex_state = 11},
  [3169] = {.lex_state = 194, .external_lex_state = 31},
  [3170] = {.lex_state = 193, .external_lex_state = 10},
  [3171] = {.lex_state = 193, .external_lex_state = 11},
  [3172] = {.lex_state = 194, .external_lex_state = 10},
  [3173] = {.lex_state = 31, .external_lex_state = 12},
  [3174] = {.lex_state = 200, .external_lex_state = 15},
  [3175] = {.lex_state = 193, .external_lex_state = 10},
  [3176] = {.lex_state = 193, .external_lex_state = 11},
  [3177] = {.lex_state = 194, .external_lex_state = 10},
  [3178] = {.lex_state = 31, .external_lex_state = 12},
  [3179] = {.lex_state = 193, .external_lex_state = 11},
  [3180] = {.lex_state = 194, .external_lex_state = 11},
  [3181] = {.lex_state = 31, .external_lex_state = 12},
  [3182] = {.lex_state = 23, .external_lex_state = 31},
  [3183] = {.lex_state = 194, .external_lex_state = 21},
  [3184] = {.lex_state = 31, .external_lex_state = 25},
  [3185] = {.lex_state = 73, .external_lex_state = 34},
  [3186] = {.lex_state = 193, .external_lex_state = 10},
  [3187] = {.lex_state = 193, .external_lex_state = 10},
  [3188] = {.lex_state = 193, .external_lex_state = 11},
  [3189] = {.lex_state = 31, .external_lex_state = 25},
  [3190] = {.lex_state = 193, .external_lex_state = 10},
  [3191] = {.lex_state = 194, .external_lex_state = 10},
  [3192] = {.lex_state = 194, .external_lex_state = 10},
  [3193] = {.lex_state = 193, .external_lex_state = 11},
  [3194] = {.lex_state = 194, .external_lex_state = 11},
  [3195] = {.lex_state = 22, .external_lex_state = 13},
  [3196] = {.lex_state = 193, .external_lex_state = 10},
  [3197] = {.lex_state = 194, .external_lex_state = 10},
  [3198] = {.lex_state = 193, .external_lex_state = 10},
  [3199] = {.lex_state = 193, .external_lex_state = 10},
  [3200] = {.lex_state = 193, .external_lex_state = 10},
  [3201] = {.lex_state = 194, .external_lex_state = 31},
  [3202] = {.lex_state = 34, .external_lex_state = 31},
  [3203] = {.lex_state = 34, .external_lex_state = 31},
  [3204] = {.lex_state = 194, .external_lex_state = 10},
  [3205] = {.lex_state = 194, .external_lex_state = 10},
  [3206] = {.lex_state = 194, .external_lex_state = 10},
  [3207] = {.lex_state = 200, .external_lex_state = 15},
  [3208] = {.lex_state = 193, .external_lex_state = 10},
  [3209] = {.lex_state = 194, .external_lex_state = 10},
  [3210] = {.lex_state = 194, .external_lex_state = 10},
  [3211] = {.lex_state = 194, .external_lex_state = 10},
  [3212] = {.lex_state = 194, .external_lex_state = 10},
  [3213] = {.lex_state = 194, .external_lex_state = 10},
  [3214] = {.lex_state = 194, .external_lex_state = 10},
  [3215] = {.lex_state = 191, .external_lex_state = 9},
  [3216] = {.lex_state = 194, .external_lex_state = 10},
  [3217] = {.lex_state = 194, .external_lex_state = 10},
  [3218] = {.lex_state = 193, .external_lex_state = 10},
  [3219] = {.lex_state = 193, .external_lex_state = 10},
  [3220] = {.lex_state = 191, .external_lex_state = 29},
  [3221] = {.lex_state = 191, .external_lex_state = 28},
  [3222] = {.lex_state = 193, .external_lex_state = 11},
  [3223] = {.lex_state = 193, .external_lex_state = 10},
  [3224] = {.lex_state = 193, .external_lex_state = 11},
  [3225] = {.lex_state = 200, .external_lex_state = 14},
  [3226] = {.lex_state = 193, .external_lex_state = 10},
  [3227] = {.lex_state = 30, .external_lex_state = 16},
  [3228] = {.lex_state = 193, .external_lex_state = 11},
  [3229] = {.lex_state = 34, .external_lex_state = 31},
  [3230] = {.lex_state = 200, .external_lex_state = 13},
  [3231] = {.lex_state = 31, .external_lex_state = 12},
  [3232] = {.lex_state = 30, .external_lex_state = 16},
  [3233] = {.lex_state = 191, .external_lex_state = 28},
  [3234] = {.lex_state = 194, .external_lex_state = 10},
  [3235] = {.lex_state = 31, .external_lex_state = 12},
  [3236] = {.lex_state = 193, .external_lex_state = 10},
  [3237] = {.lex_state = 31, .external_lex_state = 12},
  [3238] = {.lex_state = 31, .external_lex_state = 12},
  [3239] = {.lex_state = 200, .external_lex_state = 13},
  [3240] = {.lex_state = 31, .external_lex_state = 12},
  [3241] = {.lex_state = 194, .external_lex_state = 21},
  [3242] = {.lex_state = 193, .external_lex_state = 11},
  [3243] = {.lex_state = 31, .external_lex_state = 12},
  [3244] = {.lex_state = 31, .external_lex_state = 12},
  [3245] = {.lex_state = 194, .external_lex_state = 11},
  [3246] = {.lex_state = 31, .external_lex_state = 12},
  [3247] = {.lex_state = 194, .external_lex_state = 11},
  [3248] = {.lex_state = 194, .external_lex_state = 11},
  [3249] = {.lex_state = 193, .external_lex_state = 11},
  [3250] = {.lex_state = 194, .external_lex_state = 11},
  [3251] = {.lex_state = 31, .external_lex_state = 12},
  [3252] = {.lex_state = 194, .external_lex_state = 11},
  [3253] = {.lex_state = 191, .external_lex_state = 29},
  [3254] = {.lex_state = 31, .external_lex_state = 12},
  [3255] = {.lex_state = 193, .external_lex_state = 11},
  [3256] = {.lex_state = 31, .external_lex_state = 12},
  [3257] = {.lex_state = 22, .external_lex_state = 13},
  [3258] = {.lex_state = 31, .external_lex_state = 12},
  [3259] = {.lex_state = 31, .external_lex_state = 12},
  [3260] = {.lex_state = 75, .external_lex_state = 13},
  [3261] = {.lex_state = 193, .external_lex_state = 11},
  [3262] = {.lex_state = 31, .external_lex_state = 12},
  [3263] = {.lex_state = 75, .external_lex_state = 13},
  [3264] = {.lex_state = 194, .external_lex_state = 11},
  [3265] = {.lex_state = 194, .external_lex_state = 11},
  [3266] = {.lex_state = 194, .external_lex_state = 11},
  [3267] = {.lex_state = 193, .external_lex_state = 11},
  [3268] = {.lex_state = 194, .external_lex_state = 11},
  [3269] = {.lex_state = 31, .external_lex_state = 12},
  [3270] = {.lex_state = 194, .external_lex_state = 11},
  [3271] = {.lex_state = 194, .external_lex_state = 11},
  [3272] = {.lex_state = 194, .external_lex_state = 11},
  [3273] = {.lex_state = 30, .external_lex_state = 16},
  [3274] = {.lex_state = 194, .external_lex_state = 11},
  [3275] = {.lex_state = 39, .external_lex_state = 31},
  [3276] = {.lex_state = 191, .external_lex_state = 10},
  [3277] = {.lex_state = 31, .external_lex_state = 14},
  [3278] = {.lex_state = 31, .external_lex_state = 14},
  [3279] = {.lex_state = 77, .external_lex_state = 13},
  [3280] = {.lex_state = 30, .external_lex_state = 36},
  [3281] = {.lex_state = 202, .external_lex_state = 5},
  [3282] = {.lex_state = 196, .external_lex_state = 37},
  [3283] = {.lex_state = 26, .external_lex_state = 34},
  [3284] = {.lex_state = 202, .external_lex_state = 5},
  [3285] = {.lex_state = 34, .external_lex_state = 13},
  [3286] = {.lex_state = 29, .external_lex_state = 16},
  [3287] = {.lex_state = 202, .external_lex_state = 5},
  [3288] = {.lex_state = 26, .external_lex_state = 34},
  [3289] = {.lex_state = 195, .external_lex_state = 29},
  [3290] = {.lex_state = 29, .external_lex_state = 16},
  [3291] = {.lex_state = 31, .external_lex_state = 14},
  [3292] = {.lex_state = 194, .external_lex_state = 13},
  [3293] = {.lex_state = 40, .external_lex_state = 31},
  [3294] = {.lex_state = 200, .external_lex_state = 13},
  [3295] = {.lex_state = 23, .external_lex_state = 13},
  [3296] = {.lex_state = 40, .external_lex_state = 31},
  [3297] = {.lex_state = 23, .external_lex_state = 13},
  [3298] = {.lex_state = 23, .external_lex_state = 13},
  [3299] = {.lex_state = 34, .external_lex_state = 13},
  [3300] = {.lex_state = 190, .external_lex_state = 28},
  [3301] = {.lex_state = 77, .external_lex_state = 13},
  [3302] = {.lex_state = 191, .external_lex_state = 21},
  [3303] = {.lex_state = 190, .external_lex_state = 28},
  [3304] = {.lex_state = 34, .external_lex_state = 13},
  [3305] = {.lex_state = 189, .external_lex_state = 11},
  [3306] = {.lex_state = 30, .external_lex_state = 36},
  [3307] = {.lex_state = 202, .external_lex_state = 5},
  [3308] = {.lex_state = 195, .external_lex_state = 28},
  [3309] = {.lex_state = 31, .external_lex_state = 14},
  [3310] = {.lex_state = 31, .external_lex_state = 14},
  [3311] = {.lex_state = 191, .external_lex_state = 21},
  [3312] = {.lex_state = 34, .external_lex_state = 13},
  [3313] = {.lex_state = 27, .external_lex_state = 19},
  [3314] = {.lex_state = 202, .external_lex_state = 5},
  [3315] = {.lex_state = 34, .external_lex_state = 13},
  [3316] = {.lex_state = 202, .external_lex_state = 5},
  [3317] = {.lex_state = 39, .external_lex_state = 31},
  [3318] = {.lex_state = 202, .external_lex_state = 5},
  [3319] = {.lex_state = 34, .external_lex_state = 13},
  [3320] = {.lex_state = 202, .external_lex_state = 5},
  [3321] = {.lex_state = 34, .external_lex_state = 13},
  [3322] = {.lex_state = 191, .external_lex_state = 35},
  [3323] = {.lex_state = 30, .external_lex_state = 36},
  [3324] = {.lex_state = 34, .external_lex_state = 13},
  [3325] = {.lex_state = 191, .external_lex_state = 10},
  [3326] = {.lex_state = 202, .external_lex_state = 5},
  [3327] = {.lex_state = 194, .external_lex_state = 13},
  [3328] = {.lex_state = 200, .external_lex_state = 13},
  [3329] = {.lex_state = 202, .external_lex_state = 5},
  [3330] = {.lex_state = 194, .external_lex_state = 15},
  [3331] = {.lex_state = 195, .external_lex_state = 28},
  [3332] = {.lex_state = 31, .external_lex_state = 14},
  [3333] = {.lex_state = 191, .external_lex_state = 11},
  [3334] = {.lex_state = 202, .external_lex_state = 5},
  [3335] = {.lex_state = 23, .external_lex_state = 13},
  [3336] = {.lex_state = 194, .external_lex_state = 13},
  [3337] = {.lex_state = 194, .external_lex_state = 13},
  [3338] = {.lex_state = 34, .external_lex_state = 13},
  [3339] = {.lex_state = 23, .external_lex_state = 13},
  [3340] = {.lex_state = 25, .external_lex_state = 5},
  [3341] = {.lex_state = 34, .external_lex_state = 13},
  [3342] = {.lex_state = 27, .external_lex_state = 19},
  [3343] = {.lex_state = 190, .external_lex_state = 29},
  [3344] = {.lex_state = 25, .external_lex_state = 5},
  [3345] = {.lex_state = 31, .external_lex_state = 14},
  [3346] = {.lex_state = 34, .external_lex_state = 13},
  [3347] = {.lex_state = 196, .external_lex_state = 38},
  [3348] = {.lex_state = 31, .external_lex_state = 14},
  [3349] = {.lex_state = 194, .external_lex_state = 13},
  [3350] = {.lex_state = 194, .external_lex_state = 13},
  [3351] = {.lex_state = 194, .external_lex_state = 15},
  [3352] = {.lex_state = 195, .external_lex_state = 29},
  [3353] = {.lex_state = 189, .external_lex_state = 10},
  [3354] = {.lex_state = 194, .external_lex_state = 13},
  [3355] = {.lex_state = 34, .external_lex_state = 13},
  [3356] = {.lex_state = 190, .external_lex_state = 29},
  [3357] = {.lex_state = 34, .external_lex_state = 13},
  [3358] = {.lex_state = 189, .external_lex_state = 10},
  [3359] = {.lex_state = 194, .external_lex_state = 15},
  [3360] = {.lex_state = 34, .external_lex_state = 13},
  [3361] = {.lex_state = 190, .external_lex_state = 28},
  [3362] = {.lex_state = 34, .external_lex_state = 13},
  [3363] = {.lex_state = 23, .external_lex_state = 13},
  [3364] = {.lex_state = 191, .external_lex_state = 21},
  [3365] = {.lex_state = 23, .external_lex_state = 13},
  [3366] = {.lex_state = 194, .external_lex_state = 13},
  [3367] = {.lex_state = 194, .external_lex_state = 13},
  [3368] = {.lex_state = 194, .external_lex_state = 13},
  [3369] = {.lex_state = 26, .external_lex_state = 34},
  [3370] = {.lex_state = 23, .external_lex_state = 13},
  [3371] = {.lex_state = 40, .external_lex_state = 31},
  [3372] = {.lex_state = 194, .external_lex_state = 13},
  [3373] = {.lex_state = 34, .external_lex_state = 13},
  [3374] = {.lex_state = 31, .external_lex_state = 14},
  [3375] = {.lex_state = 189, .external_lex_state = 11},
  [3376] = {.lex_state = 191, .external_lex_state = 35},
  [3377] = {.lex_state = 196, .external_lex_state = 38},
  [3378] = {.lex_state = 31, .external_lex_state = 14},
  [3379] = {.lex_state = 23, .external_lex_state = 13},
  [3380] = {.lex_state = 23, .external_lex_state = 13},
  [3381] = {.lex_state = 28, .external_lex_state = 39},
  [3382] = {.lex_state = 195, .external_lex_state = 28},
  [3383] = {.lex_state = 34, .external_lex_state = 13},
  [3384] = {.lex_state = 31, .external_lex_state = 14},
  [3385] = {.lex_state = 196, .external_lex_state = 38},
  [3386] = {.lex_state = 23, .external_lex_state = 13},
  [3387] = {.lex_state = 31, .external_lex_state = 14},
  [3388] = {.lex_state = 23, .external_lex_state = 13},
  [3389] = {.lex_state = 23, .external_lex_state = 13},
  [3390] = {.lex_state = 23, .external_lex_state = 13},
  [3391] = {.lex_state = 34, .external_lex_state = 13},
  [3392] = {.lex_state = 23, .external_lex_state = 34},
  [3393] = {.lex_state = 31, .external_lex_state = 14},
  [3394] = {.lex_state = 31, .external_lex_state = 14},
  [3395] = {.lex_state = 31, .external_lex_state = 14},
  [3396] = {.lex_state = 31, .external_lex_state = 14},
  [3397] = {.lex_state = 39, .external_lex_state = 31},
  [3398] = {.lex_state = 23, .external_lex_state = 13},
  [3399] = {.lex_state = 194, .external_lex_state = 15},
  [3400] = {.lex_state = 202, .external_lex_state = 5},
  [3401] = {.lex_state = 23, .external_lex_state = 13},
  [3402] = {.lex_state = 23, .external_lex_state = 13},
  [3403] = {.lex_state = 190, .external_lex_state = 29},
  [3404] = {.lex_state = 31, .external_lex_state = 14},
  [3405] = {.lex_state = 195, .external_lex_state = 29},
  [3406] = {.lex_state = 196, .external_lex_state = 37},
  [3407] = {.lex_state = 194, .external_lex_state = 15},
  [3408] = {.lex_state = 194, .external_lex_state = 15},
  [3409] = {.lex_state = 23, .external_lex_state = 13},
  [3410] = {.lex_state = 194, .external_lex_state = 15},
  [3411] = {.lex_state = 191, .external_lex_state = 10},
  [3412] = {.lex_state = 194, .external_lex_state = 15},
  [3413] = {.lex_state = 31, .external_lex_state = 14},
  [3414] = {.lex_state = 191, .external_lex_state = 11},
  [3415] = {.lex_state = 191, .external_lex_state = 11},
  [3416] = {.lex_state = 194, .external_lex_state = 15},
  [3417] = {.lex_state = 194, .external_lex_state = 15},
  [3418] = {.lex_state = 194, .external_lex_state = 15},
  [3419] = {.lex_state = 196, .external_lex_state = 37},
  [3420] = {.lex_state = 194, .external_lex_state = 15},
  [3421] = {.lex_state = 194, .external_lex_state = 13},
  [3422] = {.lex_state = 194, .external_lex_state = 15},
  [3423] = {.lex_state = 194, .external_lex_state = 13},
  [3424] = {.lex_state = 194, .external_lex_state = 15},
  [3425] = {.lex_state = 194, .external_lex_state = 15},
  [3426] = {.lex_state = 194, .external_lex_state = 15},
  [3427] = {.lex_state = 194, .external_lex_state = 15},
  [3428] = {.lex_state = 194, .external_lex_state = 15},
  [3429] = {.lex_state = 194, .external_lex_state = 13},
  [3430] = {.lex_state = 194, .external_lex_state = 13},
  [3431] = {.lex_state = 28, .external_lex_state = 39},
  [3432] = {.lex_state = 194, .external_lex_state = 13},
  [3433] = {.lex_state = 28, .external_lex_state = 39},
  [3434] = {.lex_state = 194, .external_lex_state = 13},
  [3435] = {.lex_state = 194, .external_lex_state = 13},
  [3436] = {.lex_state = 196, .external_lex_state = 18},
  [3437] = {.lex_state = 78, .external_lex_state = 5},
  [3438] = {.lex_state = 28, .external_lex_state = 19},
  [3439] = {.lex_state = 195, .external_lex_state = 11},
  [3440] = {.lex_state = 28, .external_lex_state = 19},
  [3441] = {.lex_state = 190, .external_lex_state = 10},
  [3442] = {.lex_state = 200, .external_lex_state = 5},
  [3443] = {.lex_state = 30, .external_lex_state = 16},
  [3444] = {.lex_state = 195, .external_lex_state = 11},
  [3445] = {.lex_state = 197, .external_lex_state = 26},
  [3446] = {.lex_state = 200, .external_lex_state = 5},
  [3447] = {.lex_state = 40, .external_lex_state = 13},
  [3448] = {.lex_state = 189, .external_lex_state = 20},
  [3449] = {.lex_state = 44, .external_lex_state = 31},
  [3450] = {.lex_state = 195, .external_lex_state = 11},
  [3451] = {.lex_state = 200, .external_lex_state = 5},
  [3452] = {.lex_state = 40, .external_lex_state = 13},
  [3453] = {.lex_state = 28, .external_lex_state = 19},
  [3454] = {.lex_state = 196, .external_lex_state = 17},
  [3455] = {.lex_state = 205, .external_lex_state = 40},
  [3456] = {.lex_state = 40, .external_lex_state = 13},
  [3457] = {.lex_state = 23, .external_lex_state = 34},
  [3458] = {.lex_state = 40, .external_lex_state = 13},
  [3459] = {.lex_state = 195, .external_lex_state = 11},
  [3460] = {.lex_state = 200, .external_lex_state = 5},
  [3461] = {.lex_state = 32, .external_lex_state = 5},
  [3462] = {.lex_state = 190, .external_lex_state = 11},
  [3463] = {.lex_state = 197, .external_lex_state = 23},
  [3464] = {.lex_state = 23, .external_lex_state = 34},
  [3465] = {.lex_state = 196, .external_lex_state = 18},
  [3466] = {.lex_state = 195, .external_lex_state = 11},
  [3467] = {.lex_state = 40, .external_lex_state = 13},
  [3468] = {.lex_state = 40, .external_lex_state = 13},
  [3469] = {.lex_state = 195, .external_lex_state = 10},
  [3470] = {.lex_state = 196, .external_lex_state = 17},
  [3471] = {.lex_state = 195, .external_lex_state = 11},
  [3472] = {.lex_state = 195, .external_lex_state = 10},
  [3473] = {.lex_state = 194, .external_lex_state = 34},
  [3474] = {.lex_state = 196, .external_lex_state = 17},
  [3475] = {.lex_state = 195, .external_lex_state = 11},
  [3476] = {.lex_state = 41, .external_lex_state = 24},
  [3477] = {.lex_state = 200, .external_lex_state = 5},
  [3478] = {.lex_state = 195, .external_lex_state = 11},
  [3479] = {.lex_state = 195, .external_lex_state = 11},
  [3480] = {.lex_state = 30, .external_lex_state = 16},
  [3481] = {.lex_state = 195, .external_lex_state = 10},
  [3482] = {.lex_state = 200, .external_lex_state = 5},
  [3483] = {.lex_state = 200, .external_lex_state = 5},
  [3484] = {.lex_state = 191, .external_lex_state = 20},
  [3485] = {.lex_state = 200, .external_lex_state = 5},
  [3486] = {.lex_state = 200, .external_lex_state = 5},
  [3487] = {.lex_state = 200, .external_lex_state = 5},
  [3488] = {.lex_state = 200, .external_lex_state = 5},
  [3489] = {.lex_state = 200, .external_lex_state = 5},
  [3490] = {.lex_state = 190, .external_lex_state = 21},
  [3491] = {.lex_state = 190, .external_lex_state = 21},
  [3492] = {.lex_state = 30, .external_lex_state = 16},
  [3493] = {.lex_state = 195, .external_lex_state = 11},
  [3494] = {.lex_state = 195, .external_lex_state = 10},
  [3495] = {.lex_state = 191, .external_lex_state = 15},
  [3496] = {.lex_state = 200, .external_lex_state = 5},
  [3497] = {.lex_state = 190, .external_lex_state = 10},
  [3498] = {.lex_state = 190, .external_lex_state = 10},
  [3499] = {.lex_state = 196, .external_lex_state = 18},
  [3500] = {.lex_state = 32, .external_lex_state = 5},
  [3501] = {.lex_state = 190, .external_lex_state = 35},
  [3502] = {.lex_state = 190, .external_lex_state = 35},
  [3503] = {.lex_state = 196, .external_lex_state = 17},
  [3504] = {.lex_state = 33, .external_lex_state = 34},
  [3505] = {.lex_state = 200, .external_lex_state = 5},
  [3506] = {.lex_state = 200, .external_lex_state = 5},
  [3507] = {.lex_state = 39, .external_lex_state = 13},
  [3508] = {.lex_state = 200, .external_lex_state = 5},
  [3509] = {.lex_state = 196, .external_lex_state = 17},
  [3510] = {.lex_state = 40, .external_lex_state = 13},
  [3511] = {.lex_state = 28, .external_lex_state = 19},
  [3512] = {.lex_state = 200, .external_lex_state = 5},
  [3513] = {.lex_state = 195, .external_lex_state = 10},
  [3514] = {.lex_state = 200, .external_lex_state = 5},
  [3515] = {.lex_state = 30, .external_lex_state = 16},
  [3516] = {.lex_state = 39, .external_lex_state = 13},
  [3517] = {.lex_state = 197, .external_lex_state = 26},
  [3518] = {.lex_state = 200, .external_lex_state = 5},
  [3519] = {.lex_state = 200, .external_lex_state = 5},
  [3520] = {.lex_state = 190, .external_lex_state = 11},
  [3521] = {.lex_state = 200, .external_lex_state = 5},
  [3522] = {.lex_state = 200, .external_lex_state = 5},
  [3523] = {.lex_state = 26, .external_lex_state = 5},
  [3524] = {.lex_state = 200, .external_lex_state = 5},
  [3525] = {.lex_state = 184, .external_lex_state = 16},
  [3526] = {.lex_state = 26, .external_lex_state = 5},
  [3527] = {.lex_state = 200, .external_lex_state = 5},
  [3528] = {.lex_state = 190, .external_lex_state = 10},
  [3529] = {.lex_state = 30, .external_lex_state = 16},
  [3530] = {.lex_state = 26, .external_lex_state = 5},
  [3531] = {.lex_state = 190, .external_lex_state = 10},
  [3532] = {.lex_state = 190, .external_lex_state = 10},
  [3533] = {.lex_state = 200, .external_lex_state = 5},
  [3534] = {.lex_state = 197, .external_lex_state = 23},
  [3535] = {.lex_state = 196, .external_lex_state = 18},
  [3536] = {.lex_state = 190, .external_lex_state = 11},
  [3537] = {.lex_state = 196, .external_lex_state = 18},
  [3538] = {.lex_state = 40, .external_lex_state = 13},
  [3539] = {.lex_state = 196, .external_lex_state = 18},
  [3540] = {.lex_state = 26, .external_lex_state = 5},
  [3541] = {.lex_state = 26, .external_lex_state = 5},
  [3542] = {.lex_state = 190, .external_lex_state = 10},
  [3543] = {.lex_state = 26, .external_lex_state = 5},
  [3544] = {.lex_state = 196, .external_lex_state = 18},
  [3545] = {.lex_state = 40, .external_lex_state = 13},
  [3546] = {.lex_state = 196, .external_lex_state = 18},
  [3547] = {.lex_state = 40, .external_lex_state = 13},
  [3548] = {.lex_state = 40, .external_lex_state = 13},
  [3549] = {.lex_state = 40, .external_lex_state = 13},
  [3550] = {.lex_state = 190, .external_lex_state = 10},
  [3551] = {.lex_state = 200, .external_lex_state = 5},
  [3552] = {.lex_state = 195, .external_lex_state = 11},
  [3553] = {.lex_state = 190, .external_lex_state = 10},
  [3554] = {.lex_state = 190, .external_lex_state = 10},
  [3555] = {.lex_state = 196, .external_lex_state = 17},
  [3556] = {.lex_state = 196, .external_lex_state = 18},
  [3557] = {.lex_state = 190, .external_lex_state = 10},
  [3558] = {.lex_state = 190, .external_lex_state = 10},
  [3559] = {.lex_state = 190, .external_lex_state = 35},
  [3560] = {.lex_state = 196, .external_lex_state = 18},
  [3561] = {.lex_state = 196, .external_lex_state = 17},
  [3562] = {.lex_state = 190, .external_lex_state = 10},
  [3563] = {.lex_state = 190, .external_lex_state = 10},
  [3564] = {.lex_state = 190, .external_lex_state = 11},
  [3565] = {.lex_state = 196, .external_lex_state = 17},
  [3566] = {.lex_state = 196, .external_lex_state = 18},
  [3567] = {.lex_state = 196, .external_lex_state = 17},
  [3568] = {.lex_state = 44, .external_lex_state = 31},
  [3569] = {.lex_state = 196, .external_lex_state = 17},
  [3570] = {.lex_state = 196, .external_lex_state = 17},
  [3571] = {.lex_state = 196, .external_lex_state = 18},
  [3572] = {.lex_state = 30, .external_lex_state = 16},
  [3573] = {.lex_state = 189, .external_lex_state = 15},
  [3574] = {.lex_state = 196, .external_lex_state = 17},
  [3575] = {.lex_state = 196, .external_lex_state = 17},
  [3576] = {.lex_state = 196, .external_lex_state = 18},
  [3577] = {.lex_state = 196, .external_lex_state = 17},
  [3578] = {.lex_state = 196, .external_lex_state = 18},
  [3579] = {.lex_state = 196, .external_lex_state = 18},
  [3580] = {.lex_state = 196, .external_lex_state = 18},
  [3581] = {.lex_state = 30, .external_lex_state = 16},
  [3582] = {.lex_state = 195, .external_lex_state = 10},
  [3583] = {.lex_state = 200, .external_lex_state = 5},
  [3584] = {.lex_state = 195, .external_lex_state = 11},
  [3585] = {.lex_state = 43, .external_lex_state = 34},
  [3586] = {.lex_state = 195, .external_lex_state = 10},
  [3587] = {.lex_state = 195, .external_lex_state = 10},
  [3588] = {.lex_state = 195, .external_lex_state = 10},
  [3589] = {.lex_state = 184, .external_lex_state = 16},
  [3590] = {.lex_state = 195, .external_lex_state = 10},
  [3591] = {.lex_state = 195, .external_lex_state = 10},
  [3592] = {.lex_state = 195, .external_lex_state = 10},
  [3593] = {.lex_state = 195, .external_lex_state = 10},
  [3594] = {.lex_state = 41, .external_lex_state = 24},
  [3595] = {.lex_state = 195, .external_lex_state = 10},
  [3596] = {.lex_state = 190, .external_lex_state = 10},
  [3597] = {.lex_state = 195, .external_lex_state = 10},
  [3598] = {.lex_state = 195, .external_lex_state = 10},
  [3599] = {.lex_state = 195, .external_lex_state = 11},
  [3600] = {.lex_state = 197, .external_lex_state = 26},
  [3601] = {.lex_state = 40, .external_lex_state = 13},
  [3602] = {.lex_state = 26, .external_lex_state = 5},
  [3603] = {.lex_state = 195, .external_lex_state = 10},
  [3604] = {.lex_state = 196, .external_lex_state = 17},
  [3605] = {.lex_state = 33, .external_lex_state = 34},
  [3606] = {.lex_state = 195, .external_lex_state = 10},
  [3607] = {.lex_state = 195, .external_lex_state = 10},
  [3608] = {.lex_state = 195, .external_lex_state = 11},
  [3609] = {.lex_state = 39, .external_lex_state = 13},
  [3610] = {.lex_state = 195, .external_lex_state = 11},
  [3611] = {.lex_state = 42, .external_lex_state = 34},
  [3612] = {.lex_state = 30, .external_lex_state = 16},
  [3613] = {.lex_state = 28, .external_lex_state = 19},
  [3614] = {.lex_state = 194, .external_lex_state = 34},
  [3615] = {.lex_state = 43, .external_lex_state = 34},
  [3616] = {.lex_state = 194, .external_lex_state = 34},
  [3617] = {.lex_state = 26, .external_lex_state = 5},
  [3618] = {.lex_state = 30, .external_lex_state = 16},
  [3619] = {.lex_state = 45, .external_lex_state = 34},
  [3620] = {.lex_state = 28, .external_lex_state = 19},
  [3621] = {.lex_state = 43, .external_lex_state = 34},
  [3622] = {.lex_state = 40, .external_lex_state = 13},
  [3623] = {.lex_state = 33, .external_lex_state = 34},
  [3624] = {.lex_state = 190, .external_lex_state = 11},
  [3625] = {.lex_state = 196, .external_lex_state = 18},
  [3626] = {.lex_state = 196, .external_lex_state = 17},
  [3627] = {.lex_state = 189, .external_lex_state = 20},
  [3628] = {.lex_state = 200, .external_lex_state = 5},
  [3629] = {.lex_state = 196, .external_lex_state = 17},
  [3630] = {.lex_state = 28, .external_lex_state = 19},
  [3631] = {.lex_state = 200, .external_lex_state = 5},
  [3632] = {.lex_state = 200, .external_lex_state = 5},
  [3633] = {.lex_state = 40, .external_lex_state = 13},
  [3634] = {.lex_state = 28, .external_lex_state = 19},
  [3635] = {.lex_state = 28, .external_lex_state = 19},
  [3636] = {.lex_state = 200, .external_lex_state = 5},
  [3637] = {.lex_state = 28, .external_lex_state = 19},
  [3638] = {.lex_state = 28, .external_lex_state = 19},
  [3639] = {.lex_state = 39, .external_lex_state = 13},
  [3640] = {.lex_state = 200, .external_lex_state = 5},
  [3641] = {.lex_state = 28, .external_lex_state = 19},
  [3642] = {.lex_state = 28, .external_lex_state = 19},
  [3643] = {.lex_state = 39, .external_lex_state = 13},
  [3644] = {.lex_state = 28, .external_lex_state = 19},
  [3645] = {.lex_state = 190, .external_lex_state = 11},
  [3646] = {.lex_state = 40, .external_lex_state = 13},
  [3647] = {.lex_state = 26, .external_lex_state = 5},
  [3648] = {.lex_state = 42, .external_lex_state = 34},
  [3649] = {.lex_state = 30, .external_lex_state = 16},
  [3650] = {.lex_state = 26, .external_lex_state = 5},
  [3651] = {.lex_state = 39, .external_lex_state = 13},
  [3652] = {.lex_state = 28, .external_lex_state = 19},
  [3653] = {.lex_state = 26, .external_lex_state = 5},
  [3654] = {.lex_state = 39, .external_lex_state = 13},
  [3655] = {.lex_state = 190, .external_lex_state = 11},
  [3656] = {.lex_state = 40, .external_lex_state = 13},
  [3657] = {.lex_state = 28, .external_lex_state = 19},
  [3658] = {.lex_state = 28, .external_lex_state = 19},
  [3659] = {.lex_state = 190, .external_lex_state = 11},
  [3660] = {.lex_state = 28, .external_lex_state = 19},
  [3661] = {.lex_state = 190, .external_lex_state = 11},
  [3662] = {.lex_state = 30, .external_lex_state = 16},
  [3663] = {.lex_state = 196, .external_lex_state = 17},
  [3664] = {.lex_state = 39, .external_lex_state = 13},
  [3665] = {.lex_state = 40, .external_lex_state = 13},
  [3666] = {.lex_state = 39, .external_lex_state = 13},
  [3667] = {.lex_state = 195, .external_lex_state = 11},
  [3668] = {.lex_state = 196, .external_lex_state = 17},
  [3669] = {.lex_state = 196, .external_lex_state = 17},
  [3670] = {.lex_state = 30, .external_lex_state = 16},
  [3671] = {.lex_state = 195, .external_lex_state = 11},
  [3672] = {.lex_state = 190, .external_lex_state = 11},
  [3673] = {.lex_state = 200, .external_lex_state = 5},
  [3674] = {.lex_state = 195, .external_lex_state = 11},
  [3675] = {.lex_state = 196, .external_lex_state = 18},
  [3676] = {.lex_state = 41, .external_lex_state = 24},
  [3677] = {.lex_state = 200, .external_lex_state = 5},
  [3678] = {.lex_state = 22, .external_lex_state = 5},
  [3679] = {.lex_state = 30, .external_lex_state = 16},
  [3680] = {.lex_state = 196, .external_lex_state = 18},
  [3681] = {.lex_state = 190, .external_lex_state = 11},
  [3682] = {.lex_state = 39, .external_lex_state = 13},
  [3683] = {.lex_state = 190, .external_lex_state = 10},
  [3684] = {.lex_state = 195, .external_lex_state = 11},
  [3685] = {.lex_state = 190, .external_lex_state = 10},
  [3686] = {.lex_state = 30, .external_lex_state = 16},
  [3687] = {.lex_state = 200, .external_lex_state = 5},
  [3688] = {.lex_state = 195, .external_lex_state = 10},
  [3689] = {.lex_state = 30, .external_lex_state = 16},
  [3690] = {.lex_state = 200, .external_lex_state = 5},
  [3691] = {.lex_state = 39, .external_lex_state = 13},
  [3692] = {.lex_state = 196, .external_lex_state = 18},
  [3693] = {.lex_state = 39, .external_lex_state = 13},
  [3694] = {.lex_state = 39, .external_lex_state = 13},
  [3695] = {.lex_state = 30, .external_lex_state = 16},
  [3696] = {.lex_state = 39, .external_lex_state = 13},
  [3697] = {.lex_state = 190, .external_lex_state = 10},
  [3698] = {.lex_state = 44, .external_lex_state = 31},
  [3699] = {.lex_state = 30, .external_lex_state = 16},
  [3700] = {.lex_state = 190, .external_lex_state = 21},
  [3701] = {.lex_state = 39, .external_lex_state = 13},
  [3702] = {.lex_state = 26, .external_lex_state = 5},
  [3703] = {.lex_state = 190, .external_lex_state = 11},
  [3704] = {.lex_state = 190, .external_lex_state = 11},
  [3705] = {.lex_state = 26, .external_lex_state = 5},
  [3706] = {.lex_state = 26, .external_lex_state = 5},
  [3707] = {.lex_state = 190, .external_lex_state = 11},
  [3708] = {.lex_state = 200, .external_lex_state = 5},
  [3709] = {.lex_state = 190, .external_lex_state = 11},
  [3710] = {.lex_state = 190, .external_lex_state = 11},
  [3711] = {.lex_state = 190, .external_lex_state = 11},
  [3712] = {.lex_state = 26, .external_lex_state = 5},
  [3713] = {.lex_state = 189, .external_lex_state = 15},
  [3714] = {.lex_state = 39, .external_lex_state = 13},
  [3715] = {.lex_state = 197, .external_lex_state = 23},
  [3716] = {.lex_state = 22, .external_lex_state = 5},
  [3717] = {.lex_state = 190, .external_lex_state = 11},
  [3718] = {.lex_state = 200, .external_lex_state = 5},
  [3719] = {.lex_state = 30, .external_lex_state = 16},
  [3720] = {.lex_state = 195, .external_lex_state = 11},
  [3721] = {.lex_state = 39, .external_lex_state = 13},
  [3722] = {.lex_state = 26, .external_lex_state = 5},
  [3723] = {.lex_state = 39, .external_lex_state = 13},
  [3724] = {.lex_state = 200, .external_lex_state = 5},
  [3725] = {.lex_state = 26, .external_lex_state = 5},
  [3726] = {.lex_state = 26, .external_lex_state = 5},
  [3727] = {.lex_state = 42, .external_lex_state = 34},
  [3728] = {.lex_state = 42, .external_lex_state = 5},
  [3729] = {.lex_state = 190, .external_lex_state = 15},
  [3730] = {.lex_state = 190, .external_lex_state = 15},
  [3731] = {.lex_state = 190, .external_lex_state = 15},
  [3732] = {.lex_state = 197, .external_lex_state = 9},
  [3733] = {.lex_state = 190, .external_lex_state = 15},
  [3734] = {.lex_state = 190, .external_lex_state = 15},
  [3735] = {.lex_state = 44, .external_lex_state = 13},
  [3736] = {.lex_state = 44, .external_lex_state = 13},
  [3737] = {.lex_state = 190, .external_lex_state = 15},
  [3738] = {.lex_state = 190, .external_lex_state = 15},
  [3739] = {.lex_state = 197, .external_lex_state = 9},
  [3740] = {.lex_state = 190, .external_lex_state = 15},
  [3741] = {.lex_state = 191, .external_lex_state = 18},
  [3742] = {.lex_state = 23, .external_lex_state = 5},
  [3743] = {.lex_state = 197, .external_lex_state = 9},
  [3744] = {.lex_state = 197, .external_lex_state = 9},
  [3745] = {.lex_state = 199, .external_lex_state = 7},
  [3746] = {.lex_state = 197, .external_lex_state = 9},
  [3747] = {.lex_state = 197, .external_lex_state = 9},
  [3748] = {.lex_state = 190, .external_lex_state = 15},
  [3749] = {.lex_state = 199, .external_lex_state = 7},
  [3750] = {.lex_state = 43, .external_lex_state = 5},
  [3751] = {.lex_state = 197, .external_lex_state = 9},
  [3752] = {.lex_state = 191, .external_lex_state = 17},
  [3753] = {.lex_state = 190, .external_lex_state = 15},
  [3754] = {.lex_state = 190, .external_lex_state = 15},
  [3755] = {.lex_state = 44, .external_lex_state = 13},
  [3756] = {.lex_state = 190, .external_lex_state = 15},
  [3757] = {.lex_state = 197, .external_lex_state = 9},
  [3758] = {.lex_state = 197, .external_lex_state = 9},
  [3759] = {.lex_state = 80, .external_lex_state = 5},
  [3760] = {.lex_state = 190, .external_lex_state = 15},
  [3761] = {.lex_state = 80, .external_lex_state = 5},
  [3762] = {.lex_state = 197, .external_lex_state = 9},
  [3763] = {.lex_state = 43, .external_lex_state = 5},
  [3764] = {.lex_state = 43, .external_lex_state = 5},
  [3765] = {.lex_state = 199, .external_lex_state = 7},
  [3766] = {.lex_state = 80, .external_lex_state = 5},
  [3767] = {.lex_state = 191, .external_lex_state = 17},
  [3768] = {.lex_state = 43, .external_lex_state = 5},
  [3769] = {.lex_state = 43, .external_lex_state = 5},
  [3770] = {.lex_state = 43, .external_lex_state = 5},
  [3771] = {.lex_state = 23, .external_lex_state = 5},
  [3772] = {.lex_state = 43, .external_lex_state = 5},
  [3773] = {.lex_state = 23, .external_lex_state = 5},
  [3774] = {.lex_state = 23, .external_lex_state = 5},
  [3775] = {.lex_state = 197, .external_lex_state = 9},
  [3776] = {.lex_state = 23, .external_lex_state = 5},
  [3777] = {.lex_state = 197, .external_lex_state = 9},
  [3778] = {.lex_state = 43, .external_lex_state = 5},
  [3779] = {.lex_state = 197, .external_lex_state = 9},
  [3780] = {.lex_state = 198, .external_lex_state = 31},
  [3781] = {.lex_state = 43, .external_lex_state = 5},
  [3782] = {.lex_state = 43, .external_lex_state = 5},
  [3783] = {.lex_state = 43, .external_lex_state = 5},
  [3784] = {.lex_state = 23, .external_lex_state = 5},
  [3785] = {.lex_state = 197, .external_lex_state = 9},
  [3786] = {.lex_state = 23, .external_lex_state = 5},
  [3787] = {.lex_state = 23, .external_lex_state = 5},
  [3788] = {.lex_state = 23, .external_lex_state = 5},
  [3789] = {.lex_state = 23, .external_lex_state = 5},
  [3790] = {.lex_state = 43, .external_lex_state = 5},
  [3791] = {.lex_state = 80, .external_lex_state = 5},
  [3792] = {.lex_state = 23, .external_lex_state = 5},
  [3793] = {.lex_state = 23, .external_lex_state = 5},
  [3794] = {.lex_state = 23, .external_lex_state = 5},
  [3795] = {.lex_state = 23, .external_lex_state = 5},
  [3796] = {.lex_state = 190, .external_lex_state = 20},
  [3797] = {.lex_state = 78, .external_lex_state = 16},
  [3798] = {.lex_state = 23, .external_lex_state = 5},
  [3799] = {.lex_state = 194, .external_lex_state = 5},
  [3800] = {.lex_state = 199, .external_lex_state = 8},
  [3801] = {.lex_state = 41, .external_lex_state = 8},
  [3802] = {.lex_state = 38, .external_lex_state = 36},
  [3803] = {.lex_state = 80, .external_lex_state = 5},
  [3804] = {.lex_state = 199, .external_lex_state = 8},
  [3805] = {.lex_state = 200, .external_lex_state = 5},
  [3806] = {.lex_state = 47, .external_lex_state = 31},
  [3807] = {.lex_state = 191, .external_lex_state = 13},
  [3808] = {.lex_state = 80, .external_lex_state = 5},
  [3809] = {.lex_state = 195, .external_lex_state = 31},
  [3810] = {.lex_state = 42, .external_lex_state = 5},
  [3811] = {.lex_state = 198, .external_lex_state = 29},
  [3812] = {.lex_state = 41, .external_lex_state = 8},
  [3813] = {.lex_state = 80, .external_lex_state = 5},
  [3814] = {.lex_state = 198, .external_lex_state = 28},
  [3815] = {.lex_state = 80, .external_lex_state = 5},
  [3816] = {.lex_state = 80, .external_lex_state = 5},
  [3817] = {.lex_state = 197, .external_lex_state = 7},
  [3818] = {.lex_state = 41, .external_lex_state = 8},
  [3819] = {.lex_state = 46, .external_lex_state = 27},
  [3820] = {.lex_state = 195, .external_lex_state = 31},
  [3821] = {.lex_state = 43, .external_lex_state = 5},
  [3822] = {.lex_state = 80, .external_lex_state = 5},
  [3823] = {.lex_state = 43, .external_lex_state = 5},
  [3824] = {.lex_state = 44, .external_lex_state = 13},
  [3825] = {.lex_state = 80, .external_lex_state = 5},
  [3826] = {.lex_state = 80, .external_lex_state = 5},
  [3827] = {.lex_state = 80, .external_lex_state = 5},
  [3828] = {.lex_state = 43, .external_lex_state = 5},
  [3829] = {.lex_state = 80, .external_lex_state = 5},
  [3830] = {.lex_state = 80, .external_lex_state = 5},
  [3831] = {.lex_state = 80, .external_lex_state = 5},
  [3832] = {.lex_state = 80, .external_lex_state = 5},
  [3833] = {.lex_state = 197, .external_lex_state = 9},
  [3834] = {.lex_state = 80, .external_lex_state = 5},
  [3835] = {.lex_state = 80, .external_lex_state = 5},
  [3836] = {.lex_state = 197, .external_lex_state = 7},
  [3837] = {.lex_state = 80, .external_lex_state = 5},
  [3838] = {.lex_state = 80, .external_lex_state = 5},
  [3839] = {.lex_state = 80, .external_lex_state = 5},
  [3840] = {.lex_state = 197, .external_lex_state = 39},
  [3841] = {.lex_state = 80, .external_lex_state = 5},
  [3842] = {.lex_state = 197, .external_lex_state = 9},
  [3843] = {.lex_state = 199, .external_lex_state = 9},
  [3844] = {.lex_state = 80, .external_lex_state = 5},
  [3845] = {.lex_state = 80, .external_lex_state = 5},
  [3846] = {.lex_state = 37, .external_lex_state = 16},
  [3847] = {.lex_state = 190, .external_lex_state = 20},
  [3848] = {.lex_state = 80, .external_lex_state = 5},
  [3849] = {.lex_state = 197, .external_lex_state = 9},
  [3850] = {.lex_state = 80, .external_lex_state = 5},
  [3851] = {.lex_state = 80, .external_lex_state = 5},
  [3852] = {.lex_state = 80, .external_lex_state = 5},
  [3853] = {.lex_state = 80, .external_lex_state = 5},
  [3854] = {.lex_state = 80, .external_lex_state = 5},
  [3855] = {.lex_state = 80, .external_lex_state = 5},
  [3856] = {.lex_state = 80, .external_lex_state = 5},
  [3857] = {.lex_state = 199, .external_lex_state = 9},
  [3858] = {.lex_state = 36, .external_lex_state = 34},
  [3859] = {.lex_state = 80, .external_lex_state = 5},
  [3860] = {.lex_state = 197, .external_lex_state = 7},
  [3861] = {.lex_state = 199, .external_lex_state = 8},
  [3862] = {.lex_state = 80, .external_lex_state = 5},
  [3863] = {.lex_state = 80, .external_lex_state = 5},
  [3864] = {.lex_state = 80, .external_lex_state = 5},
  [3865] = {.lex_state = 80, .external_lex_state = 5},
  [3866] = {.lex_state = 33, .external_lex_state = 5},
  [3867] = {.lex_state = 33, .external_lex_state = 5},
  [3868] = {.lex_state = 33, .external_lex_state = 5},
  [3869] = {.lex_state = 33, .external_lex_state = 5},
  [3870] = {.lex_state = 33, .external_lex_state = 5},
  [3871] = {.lex_state = 190, .external_lex_state = 15},
  [3872] = {.lex_state = 80, .external_lex_state = 5},
  [3873] = {.lex_state = 33, .external_lex_state = 5},
  [3874] = {.lex_state = 191, .external_lex_state = 15},
  [3875] = {.lex_state = 33, .external_lex_state = 5},
  [3876] = {.lex_state = 33, .external_lex_state = 5},
  [3877] = {.lex_state = 33, .external_lex_state = 5},
  [3878] = {.lex_state = 80, .external_lex_state = 5},
  [3879] = {.lex_state = 33, .external_lex_state = 5},
  [3880] = {.lex_state = 80, .external_lex_state = 5},
  [3881] = {.lex_state = 80, .external_lex_state = 5},
  [3882] = {.lex_state = 33, .external_lex_state = 5},
  [3883] = {.lex_state = 80, .external_lex_state = 5},
  [3884] = {.lex_state = 80, .external_lex_state = 5},
  [3885] = {.lex_state = 80, .external_lex_state = 5},
  [3886] = {.lex_state = 80, .external_lex_state = 5},
  [3887] = {.lex_state = 33, .external_lex_state = 5},
  [3888] = {.lex_state = 33, .external_lex_state = 5},
  [3889] = {.lex_state = 191, .external_lex_state = 15},
  [3890] = {.lex_state = 33, .external_lex_state = 5},
  [3891] = {.lex_state = 38, .external_lex_state = 36},
  [3892] = {.lex_state = 44, .external_lex_state = 13},
  [3893] = {.lex_state = 38, .external_lex_state = 36},
  [3894] = {.lex_state = 44, .external_lex_state = 13},
  [3895] = {.lex_state = 197, .external_lex_state = 7},
  [3896] = {.lex_state = 80, .external_lex_state = 5},
  [3897] = {.lex_state = 44, .external_lex_state = 13},
  [3898] = {.lex_state = 44, .external_lex_state = 13},
  [3899] = {.lex_state = 44, .external_lex_state = 13},
  [3900] = {.lex_state = 80, .external_lex_state = 5},
  [3901] = {.lex_state = 190, .external_lex_state = 3},
  [3902] = {.lex_state = 80, .external_lex_state = 5},
  [3903] = {.lex_state = 44, .external_lex_state = 13},
  [3904] = {.lex_state = 80, .external_lex_state = 5},
  [3905] = {.lex_state = 44, .external_lex_state = 13},
  [3906] = {.lex_state = 35, .external_lex_state = 5},
  [3907] = {.lex_state = 44, .external_lex_state = 13},
  [3908] = {.lex_state = 190, .external_lex_state = 20},
  [3909] = {.lex_state = 44, .external_lex_state = 13},
  [3910] = {.lex_state = 80, .external_lex_state = 5},
  [3911] = {.lex_state = 44, .external_lex_state = 13},
  [3912] = {.lex_state = 41, .external_lex_state = 8},
  [3913] = {.lex_state = 44, .external_lex_state = 13},
  [3914] = {.lex_state = 80, .external_lex_state = 5},
  [3915] = {.lex_state = 191, .external_lex_state = 20},
  [3916] = {.lex_state = 80, .external_lex_state = 5},
  [3917] = {.lex_state = 44, .external_lex_state = 13},
  [3918] = {.lex_state = 80, .external_lex_state = 5},
  [3919] = {.lex_state = 80, .external_lex_state = 5},
  [3920] = {.lex_state = 80, .external_lex_state = 5},
  [3921] = {.lex_state = 44, .external_lex_state = 13},
  [3922] = {.lex_state = 44, .external_lex_state = 13},
  [3923] = {.lex_state = 198, .external_lex_state = 29},
  [3924] = {.lex_state = 80, .external_lex_state = 5},
  [3925] = {.lex_state = 80, .external_lex_state = 5},
  [3926] = {.lex_state = 80, .external_lex_state = 5},
  [3927] = {.lex_state = 80, .external_lex_state = 5},
  [3928] = {.lex_state = 80, .external_lex_state = 5},
  [3929] = {.lex_state = 80, .external_lex_state = 5},
  [3930] = {.lex_state = 80, .external_lex_state = 5},
  [3931] = {.lex_state = 23, .external_lex_state = 5},
  [3932] = {.lex_state = 23, .external_lex_state = 5},
  [3933] = {.lex_state = 80, .external_lex_state = 5},
  [3934] = {.lex_state = 80, .external_lex_state = 5},
  [3935] = {.lex_state = 43, .external_lex_state = 5},
  [3936] = {.lex_state = 80, .external_lex_state = 5},
  [3937] = {.lex_state = 80, .external_lex_state = 5},
  [3938] = {.lex_state = 80, .external_lex_state = 5},
  [3939] = {.lex_state = 80, .external_lex_state = 5},
  [3940] = {.lex_state = 41, .external_lex_state = 8},
  [3941] = {.lex_state = 41, .external_lex_state = 8},
  [3942] = {.lex_state = 23, .external_lex_state = 5},
  [3943] = {.lex_state = 33, .external_lex_state = 5},
  [3944] = {.lex_state = 41, .external_lex_state = 8},
  [3945] = {.lex_state = 41, .external_lex_state = 8},
  [3946] = {.lex_state = 193, .external_lex_state = 34},
  [3947] = {.lex_state = 80, .external_lex_state = 5},
  [3948] = {.lex_state = 80, .external_lex_state = 5},
  [3949] = {.lex_state = 80, .external_lex_state = 5},
  [3950] = {.lex_state = 80, .external_lex_state = 5},
  [3951] = {.lex_state = 80, .external_lex_state = 5},
  [3952] = {.lex_state = 80, .external_lex_state = 5},
  [3953] = {.lex_state = 80, .external_lex_state = 5},
  [3954] = {.lex_state = 41, .external_lex_state = 8},
  [3955] = {.lex_state = 41, .external_lex_state = 8},
  [3956] = {.lex_state = 41, .external_lex_state = 8},
  [3957] = {.lex_state = 41, .external_lex_state = 8},
  [3958] = {.lex_state = 41, .external_lex_state = 8},
  [3959] = {.lex_state = 41, .external_lex_state = 8},
  [3960] = {.lex_state = 80, .external_lex_state = 5},
  [3961] = {.lex_state = 80, .external_lex_state = 5},
  [3962] = {.lex_state = 41, .external_lex_state = 8},
  [3963] = {.lex_state = 80, .external_lex_state = 5},
  [3964] = {.lex_state = 80, .external_lex_state = 5},
  [3965] = {.lex_state = 36, .external_lex_state = 34},
  [3966] = {.lex_state = 80, .external_lex_state = 5},
  [3967] = {.lex_state = 80, .external_lex_state = 5},
  [3968] = {.lex_state = 41, .external_lex_state = 8},
  [3969] = {.lex_state = 190, .external_lex_state = 15},
  [3970] = {.lex_state = 41, .external_lex_state = 8},
  [3971] = {.lex_state = 36, .external_lex_state = 34},
  [3972] = {.lex_state = 80, .external_lex_state = 5},
  [3973] = {.lex_state = 80, .external_lex_state = 5},
  [3974] = {.lex_state = 80, .external_lex_state = 5},
  [3975] = {.lex_state = 41, .external_lex_state = 8},
  [3976] = {.lex_state = 191, .external_lex_state = 20},
  [3977] = {.lex_state = 200, .external_lex_state = 5},
  [3978] = {.lex_state = 190, .external_lex_state = 15},
  [3979] = {.lex_state = 190, .external_lex_state = 15},
  [3980] = {.lex_state = 47, .external_lex_state = 31},
  [3981] = {.lex_state = 194, .external_lex_state = 5},
  [3982] = {.lex_state = 190, .external_lex_state = 20},
  [3983] = {.lex_state = 190, .external_lex_state = 20},
  [3984] = {.lex_state = 195, .external_lex_state = 31},
  [3985] = {.lex_state = 45, .external_lex_state = 34},
  [3986] = {.lex_state = 46, .external_lex_state = 27},
  [3987] = {.lex_state = 197, .external_lex_state = 7},
  [3988] = {.lex_state = 197, .external_lex_state = 7},
  [3989] = {.lex_state = 197, .external_lex_state = 7},
  [3990] = {.lex_state = 197, .external_lex_state = 7},
  [3991] = {.lex_state = 197, .external_lex_state = 7},
  [3992] = {.lex_state = 197, .external_lex_state = 7},
  [3993] = {.lex_state = 197, .external_lex_state = 7},
  [3994] = {.lex_state = 197, .external_lex_state = 7},
  [3995] = {.lex_state = 197, .external_lex_state = 7},
  [3996] = {.lex_state = 197, .external_lex_state = 7},
  [3997] = {.lex_state = 197, .external_lex_state = 7},
  [3998] = {.lex_state = 198, .external_lex_state = 28},
  [3999] = {.lex_state = 198, .external_lex_state = 29},
  [4000] = {.lex_state = 206, .external_lex_state = 5},
  [4001] = {.lex_state = 197, .external_lex_state = 7},
  [4002] = {.lex_state = 197, .external_lex_state = 7},
  [4003] = {.lex_state = 197, .external_lex_state = 7},
  [4004] = {.lex_state = 47, .external_lex_state = 31},
  [4005] = {.lex_state = 35, .external_lex_state = 5},
  [4006] = {.lex_state = 197, .external_lex_state = 39},
  [4007] = {.lex_state = 193, .external_lex_state = 34},
  [4008] = {.lex_state = 194, .external_lex_state = 5},
  [4009] = {.lex_state = 194, .external_lex_state = 5},
  [4010] = {.lex_state = 194, .external_lex_state = 5},
  [4011] = {.lex_state = 194, .external_lex_state = 5},
  [4012] = {.lex_state = 194, .external_lex_state = 5},
  [4013] = {.lex_state = 42, .external_lex_state = 5},
  [4014] = {.lex_state = 194, .external_lex_state = 5},
  [4015] = {.lex_state = 194, .external_lex_state = 5},
  [4016] = {.lex_state = 194, .external_lex_state = 5},
  [4017] = {.lex_state = 194, .external_lex_state = 5},
  [4018] = {.lex_state = 43, .external_lex_state = 5},
  [4019] = {.lex_state = 194, .external_lex_state = 5},
  [4020] = {.lex_state = 194, .external_lex_state = 5},
  [4021] = {.lex_state = 194, .external_lex_state = 5},
  [4022] = {.lex_state = 194, .external_lex_state = 5},
  [4023] = {.lex_state = 198, .external_lex_state = 28},
  [4024] = {.lex_state = 191, .external_lex_state = 17},
  [4025] = {.lex_state = 42, .external_lex_state = 5},
  [4026] = {.lex_state = 190, .external_lex_state = 20},
  [4027] = {.lex_state = 190, .external_lex_state = 20},
  [4028] = {.lex_state = 190, .external_lex_state = 20},
  [4029] = {.lex_state = 190, .external_lex_state = 20},
  [4030] = {.lex_state = 37, .external_lex_state = 16},
  [4031] = {.lex_state = 190, .external_lex_state = 15},
  [4032] = {.lex_state = 42, .external_lex_state = 5},
  [4033] = {.lex_state = 42, .external_lex_state = 5},
  [4034] = {.lex_state = 42, .external_lex_state = 5},
  [4035] = {.lex_state = 42, .external_lex_state = 5},
  [4036] = {.lex_state = 42, .external_lex_state = 5},
  [4037] = {.lex_state = 191, .external_lex_state = 18},
  [4038] = {.lex_state = 42, .external_lex_state = 5},
  [4039] = {.lex_state = 42, .external_lex_state = 5},
  [4040] = {.lex_state = 191, .external_lex_state = 13},
  [4041] = {.lex_state = 42, .external_lex_state = 5},
  [4042] = {.lex_state = 42, .external_lex_state = 5},
  [4043] = {.lex_state = 42, .external_lex_state = 5},
  [4044] = {.lex_state = 42, .external_lex_state = 5},
  [4045] = {.lex_state = 42, .external_lex_state = 5},
  [4046] = {.lex_state = 191, .external_lex_state = 18},
  [4047] = {.lex_state = 42, .external_lex_state = 5},
  [4048] = {.lex_state = 194, .external_lex_state = 5},
  [4049] = {.lex_state = 190, .external_lex_state = 20},
  [4050] = {.lex_state = 190, .external_lex_state = 20},
  [4051] = {.lex_state = 190, .external_lex_state = 20},
  [4052] = {.lex_state = 33, .external_lex_state = 5},
  [4053] = {.lex_state = 33, .external_lex_state = 5},
  [4054] = {.lex_state = 190, .external_lex_state = 20},
  [4055] = {.lex_state = 190, .external_lex_state = 20},
  [4056] = {.lex_state = 190, .external_lex_state = 20},
  [4057] = {.lex_state = 190, .external_lex_state = 20},
  [4058] = {.lex_state = 43, .external_lex_state = 5},
  [4059] = {.lex_state = 190, .external_lex_state = 20},
  [4060] = {.lex_state = 190, .external_lex_state = 20},
  [4061] = {.lex_state = 42, .external_lex_state = 5},
  [4062] = {.lex_state = 197, .external_lex_state = 9},
  [4063] = {.lex_state = 46, .external_lex_state = 27},
  [4064] = {.lex_state = 194, .external_lex_state = 5},
  [4065] = {.lex_state = 197, .external_lex_state = 39},
  [4066] = {.lex_state = 33, .external_lex_state = 5},
  [4067] = {.lex_state = 194, .external_lex_state = 5},
  [4068] = {.lex_state = 199, .external_lex_state = 9},
  [4069] = {.lex_state = 193, .external_lex_state = 34},
  [4070] = {.lex_state = 45, .external_lex_state = 34},
  [4071] = {.lex_state = 195, .external_lex_state = 13},
  [4072] = {.lex_state = 82, .external_lex_state = 13},
  [4073] = {.lex_state = 36, .external_lex_state = 5},
  [4074] = {.lex_state = 193, .external_lex_state = 5},
  [4075] = {.lex_state = 83, .external_lex_state = 5},
  [4076] = {.lex_state = 38, .external_lex_state = 16},
  [4077] = {.lex_state = 83, .external_lex_state = 5},
  [4078] = {.lex_state = 193, .external_lex_state = 5},
  [4079] = {.lex_state = 83, .external_lex_state = 5},
  [4080] = {.lex_state = 83, .external_lex_state = 5},
  [4081] = {.lex_state = 83, .external_lex_state = 5},
  [4082] = {.lex_state = 83, .external_lex_state = 5},
  [4083] = {.lex_state = 83, .external_lex_state = 5},
  [4084] = {.lex_state = 193, .external_lex_state = 5},
  [4085] = {.lex_state = 46, .external_lex_state = 12},
  [4086] = {.lex_state = 46, .external_lex_state = 12},
  [4087] = {.lex_state = 46, .external_lex_state = 12},
  [4088] = {.lex_state = 46, .external_lex_state = 12},
  [4089] = {.lex_state = 46, .external_lex_state = 12},
  [4090] = {.lex_state = 46, .external_lex_state = 12},
  [4091] = {.lex_state = 46, .external_lex_state = 12},
  [4092] = {.lex_state = 46, .external_lex_state = 12},
  [4093] = {.lex_state = 46, .external_lex_state = 12},
  [4094] = {.lex_state = 46, .external_lex_state = 12},
  [4095] = {.lex_state = 46, .external_lex_state = 12},
  [4096] = {.lex_state = 46, .external_lex_state = 12},
  [4097] = {.lex_state = 46, .external_lex_state = 12},
  [4098] = {.lex_state = 46, .external_lex_state = 12},
  [4099] = {.lex_state = 83, .external_lex_state = 5},
  [4100] = {.lex_state = 83, .external_lex_state = 5},
  [4101] = {.lex_state = 83, .external_lex_state = 5},
  [4102] = {.lex_state = 83, .external_lex_state = 5},
  [4103] = {.lex_state = 83, .external_lex_state = 5},
  [4104] = {.lex_state = 191, .external_lex_state = 31},
  [4105] = {.lex_state = 38, .external_lex_state = 16},
  [4106] = {.lex_state = 198, .external_lex_state = 10},
  [4107] = {.lex_state = 83, .external_lex_state = 5},
  [4108] = {.lex_state = 193, .external_lex_state = 5},
  [4109] = {.lex_state = 36, .external_lex_state = 5},
  [4110] = {.lex_state = 198, .external_lex_state = 10},
  [4111] = {.lex_state = 36, .external_lex_state = 5},
  [4112] = {.lex_state = 36, .external_lex_state = 5},
  [4113] = {.lex_state = 36, .external_lex_state = 5},
  [4114] = {.lex_state = 36, .external_lex_state = 5},
  [4115] = {.lex_state = 36, .external_lex_state = 5},
  [4116] = {.lex_state = 36, .external_lex_state = 5},
  [4117] = {.lex_state = 36, .external_lex_state = 5},
  [4118] = {.lex_state = 198, .external_lex_state = 10},
  [4119] = {.lex_state = 193, .external_lex_state = 5},
  [4120] = {.lex_state = 193, .external_lex_state = 5},
  [4121] = {.lex_state = 193, .external_lex_state = 5},
  [4122] = {.lex_state = 193, .external_lex_state = 5},
  [4123] = {.lex_state = 193, .external_lex_state = 5},
  [4124] = {.lex_state = 193, .external_lex_state = 5},
  [4125] = {.lex_state = 193, .external_lex_state = 5},
  [4126] = {.lex_state = 197, .external_lex_state = 19},
  [4127] = {.lex_state = 193, .external_lex_state = 5},
  [4128] = {.lex_state = 47, .external_lex_state = 13},
  [4129] = {.lex_state = 193, .external_lex_state = 5},
  [4130] = {.lex_state = 83, .external_lex_state = 5},
  [4131] = {.lex_state = 193, .external_lex_state = 5},
  [4132] = {.lex_state = 195, .external_lex_state = 13},
  [4133] = {.lex_state = 45, .external_lex_state = 5},
  [4134] = {.lex_state = 47, .external_lex_state = 13},
  [4135] = {.lex_state = 193, .external_lex_state = 5},
  [4136] = {.lex_state = 193, .external_lex_state = 5},
  [4137] = {.lex_state = 193, .external_lex_state = 5},
  [4138] = {.lex_state = 45, .external_lex_state = 5},
  [4139] = {.lex_state = 83, .external_lex_state = 5},
  [4140] = {.lex_state = 47, .external_lex_state = 13},
  [4141] = {.lex_state = 36, .external_lex_state = 5},
  [4142] = {.lex_state = 36, .external_lex_state = 5},
  [4143] = {.lex_state = 36, .external_lex_state = 5},
  [4144] = {.lex_state = 36, .external_lex_state = 5},
  [4145] = {.lex_state = 36, .external_lex_state = 5},
  [4146] = {.lex_state = 184, .external_lex_state = 20},
  [4147] = {.lex_state = 83, .external_lex_state = 5},
  [4148] = {.lex_state = 83, .external_lex_state = 5},
  [4149] = {.lex_state = 200, .external_lex_state = 11},
  [4150] = {.lex_state = 184, .external_lex_state = 5},
  [4151] = {.lex_state = 83, .external_lex_state = 5},
  [4152] = {.lex_state = 83, .external_lex_state = 5},
  [4153] = {.lex_state = 83, .external_lex_state = 5},
  [4154] = {.lex_state = 83, .external_lex_state = 5},
  [4155] = {.lex_state = 83, .external_lex_state = 5},
  [4156] = {.lex_state = 45, .external_lex_state = 5},
  [4157] = {.lex_state = 195, .external_lex_state = 13},
  [4158] = {.lex_state = 198, .external_lex_state = 10},
  [4159] = {.lex_state = 198, .external_lex_state = 10},
  [4160] = {.lex_state = 198, .external_lex_state = 10},
  [4161] = {.lex_state = 198, .external_lex_state = 10},
  [4162] = {.lex_state = 198, .external_lex_state = 10},
  [4163] = {.lex_state = 197, .external_lex_state = 19},
  [4164] = {.lex_state = 198, .external_lex_state = 10},
  [4165] = {.lex_state = 198, .external_lex_state = 10},
  [4166] = {.lex_state = 198, .external_lex_state = 10},
  [4167] = {.lex_state = 198, .external_lex_state = 10},
  [4168] = {.lex_state = 198, .external_lex_state = 10},
  [4169] = {.lex_state = 198, .external_lex_state = 10},
  [4170] = {.lex_state = 198, .external_lex_state = 10},
  [4171] = {.lex_state = 198, .external_lex_state = 10},
  [4172] = {.lex_state = 198, .external_lex_state = 10},
  [4173] = {.lex_state = 83, .external_lex_state = 5},
  [4174] = {.lex_state = 83, .external_lex_state = 5},
  [4175] = {.lex_state = 197, .external_lex_state = 19},
  [4176] = {.lex_state = 45, .external_lex_state = 5},
  [4177] = {.lex_state = 45, .external_lex_state = 5},
  [4178] = {.lex_state = 38, .external_lex_state = 16},
  [4179] = {.lex_state = 198, .external_lex_state = 11},
  [4180] = {.lex_state = 45, .external_lex_state = 5},
  [4181] = {.lex_state = 46, .external_lex_state = 12},
  [4182] = {.lex_state = 83, .external_lex_state = 5},
  [4183] = {.lex_state = 197, .external_lex_state = 19},
  [4184] = {.lex_state = 47, .external_lex_state = 13},
  [4185] = {.lex_state = 47, .external_lex_state = 13},
  [4186] = {.lex_state = 47, .external_lex_state = 13},
  [4187] = {.lex_state = 47, .external_lex_state = 13},
  [4188] = {.lex_state = 47, .external_lex_state = 13},
  [4189] = {.lex_state = 47, .external_lex_state = 13},
  [4190] = {.lex_state = 47, .external_lex_state = 13},
  [4191] = {.lex_state = 47, .external_lex_state = 13},
  [4192] = {.lex_state = 47, .external_lex_state = 13},
  [4193] = {.lex_state = 47, .external_lex_state = 13},
  [4194] = {.lex_state = 47, .external_lex_state = 13},
  [4195] = {.lex_state = 47, .external_lex_state = 13},
  [4196] = {.lex_state = 47, .external_lex_state = 13},
  [4197] = {.lex_state = 47, .external_lex_state = 13},
  [4198] = {.lex_state = 83, .external_lex_state = 5},
  [4199] = {.lex_state = 83, .external_lex_state = 5},
  [4200] = {.lex_state = 83, .external_lex_state = 5},
  [4201] = {.lex_state = 46, .external_lex_state = 12},
  [4202] = {.lex_state = 83, .external_lex_state = 5},
  [4203] = {.lex_state = 184, .external_lex_state = 5},
  [4204] = {.lex_state = 198, .external_lex_state = 11},
  [4205] = {.lex_state = 83, .external_lex_state = 5},
  [4206] = {.lex_state = 83, .external_lex_state = 5},
  [4207] = {.lex_state = 83, .external_lex_state = 5},
  [4208] = {.lex_state = 36, .external_lex_state = 5},
  [4209] = {.lex_state = 46, .external_lex_state = 12},
  [4210] = {.lex_state = 36, .external_lex_state = 5},
  [4211] = {.lex_state = 200, .external_lex_state = 11},
  [4212] = {.lex_state = 36, .external_lex_state = 5},
  [4213] = {.lex_state = 45, .external_lex_state = 5},
  [4214] = {.lex_state = 198, .external_lex_state = 31},
  [4215] = {.lex_state = 200, .external_lex_state = 11},
  [4216] = {.lex_state = 45, .external_lex_state = 5},
  [4217] = {.lex_state = 45, .external_lex_state = 5},
  [4218] = {.lex_state = 195, .external_lex_state = 13},
  [4219] = {.lex_state = 198, .external_lex_state = 13},
  [4220] = {.lex_state = 46, .external_lex_state = 25},
  [4221] = {.lex_state = 184, .external_lex_state = 5},
  [4222] = {.lex_state = 184, .external_lex_state = 5},
  [4223] = {.lex_state = 195, .external_lex_state = 13},
  [4224] = {.lex_state = 184, .external_lex_state = 5},
  [4225] = {.lex_state = 45, .external_lex_state = 5},
  [4226] = {.lex_state = 198, .external_lex_state = 21},
  [4227] = {.lex_state = 184, .external_lex_state = 5},
  [4228] = {.lex_state = 38, .external_lex_state = 16},
  [4229] = {.lex_state = 38, .external_lex_state = 16},
  [4230] = {.lex_state = 198, .external_lex_state = 13},
  [4231] = {.lex_state = 195, .external_lex_state = 13},
  [4232] = {.lex_state = 198, .external_lex_state = 13},
  [4233] = {.lex_state = 83, .external_lex_state = 5},
  [4234] = {.lex_state = 195, .external_lex_state = 13},
  [4235] = {.lex_state = 45, .external_lex_state = 5},
  [4236] = {.lex_state = 48, .external_lex_state = 34},
  [4237] = {.lex_state = 198, .external_lex_state = 11},
  [4238] = {.lex_state = 45, .external_lex_state = 5},
  [4239] = {.lex_state = 45, .external_lex_state = 5},
  [4240] = {.lex_state = 195, .external_lex_state = 13},
  [4241] = {.lex_state = 195, .external_lex_state = 13},
  [4242] = {.lex_state = 45, .external_lex_state = 5},
  [4243] = {.lex_state = 198, .external_lex_state = 21},
  [4244] = {.lex_state = 45, .external_lex_state = 5},
  [4245] = {.lex_state = 195, .external_lex_state = 13},
  [4246] = {.lex_state = 195, .external_lex_state = 13},
  [4247] = {.lex_state = 184, .external_lex_state = 5},
  [4248] = {.lex_state = 193, .external_lex_state = 5},
  [4249] = {.lex_state = 184, .external_lex_state = 5},
  [4250] = {.lex_state = 38, .external_lex_state = 16},
  [4251] = {.lex_state = 38, .external_lex_state = 16},
  [4252] = {.lex_state = 38, .external_lex_state = 16},
  [4253] = {.lex_state = 38, .external_lex_state = 16},
  [4254] = {.lex_state = 38, .external_lex_state = 16},
  [4255] = {.lex_state = 38, .external_lex_state = 16},
  [4256] = {.lex_state = 195, .external_lex_state = 13},
  [4257] = {.lex_state = 38, .external_lex_state = 16},
  [4258] = {.lex_state = 38, .external_lex_state = 16},
  [4259] = {.lex_state = 46, .external_lex_state = 25},
  [4260] = {.lex_state = 195, .external_lex_state = 13},
  [4261] = {.lex_state = 195, .external_lex_state = 13},
  [4262] = {.lex_state = 45, .external_lex_state = 5},
  [4263] = {.lex_state = 45, .external_lex_state = 5},
  [4264] = {.lex_state = 195, .external_lex_state = 13},
  [4265] = {.lex_state = 45, .external_lex_state = 5},
  [4266] = {.lex_state = 38, .external_lex_state = 16},
  [4267] = {.lex_state = 38, .external_lex_state = 16},
  [4268] = {.lex_state = 38, .external_lex_state = 16},
  [4269] = {.lex_state = 38, .external_lex_state = 16},
  [4270] = {.lex_state = 198, .external_lex_state = 35},
  [4271] = {.lex_state = 38, .external_lex_state = 16},
  [4272] = {.lex_state = 200, .external_lex_state = 10},
  [4273] = {.lex_state = 45, .external_lex_state = 5},
  [4274] = {.lex_state = 193, .external_lex_state = 5},
  [4275] = {.lex_state = 195, .external_lex_state = 13},
  [4276] = {.lex_state = 195, .external_lex_state = 13},
  [4277] = {.lex_state = 48, .external_lex_state = 34},
  [4278] = {.lex_state = 46, .external_lex_state = 12},
  [4279] = {.lex_state = 48, .external_lex_state = 34},
  [4280] = {.lex_state = 198, .external_lex_state = 11},
  [4281] = {.lex_state = 198, .external_lex_state = 11},
  [4282] = {.lex_state = 198, .external_lex_state = 11},
  [4283] = {.lex_state = 198, .external_lex_state = 13},
  [4284] = {.lex_state = 46, .external_lex_state = 25},
  [4285] = {.lex_state = 198, .external_lex_state = 11},
  [4286] = {.lex_state = 198, .external_lex_state = 11},
  [4287] = {.lex_state = 195, .external_lex_state = 13},
  [4288] = {.lex_state = 195, .external_lex_state = 13},
  [4289] = {.lex_state = 198, .external_lex_state = 11},
  [4290] = {.lex_state = 200, .external_lex_state = 12},
  [4291] = {.lex_state = 198, .external_lex_state = 21},
  [4292] = {.lex_state = 198, .external_lex_state = 11},
  [4293] = {.lex_state = 198, .external_lex_state = 11},
  [4294] = {.lex_state = 198, .external_lex_state = 11},
  [4295] = {.lex_state = 198, .external_lex_state = 11},
  [4296] = {.lex_state = 198, .external_lex_state = 11},
  [4297] = {.lex_state = 198, .external_lex_state = 11},
  [4298] = {.lex_state = 198, .external_lex_state = 11},
  [4299] = {.lex_state = 198, .external_lex_state = 11},
  [4300] = {.lex_state = 198, .external_lex_state = 11},
  [4301] = {.lex_state = 198, .external_lex_state = 10},
  [4302] = {.lex_state = 193, .external_lex_state = 5},
  [4303] = {.lex_state = 198, .external_lex_state = 31},
  [4304] = {.lex_state = 47, .external_lex_state = 13},
  [4305] = {.lex_state = 36, .external_lex_state = 5},
  [4306] = {.lex_state = 45, .external_lex_state = 5},
  [4307] = {.lex_state = 200, .external_lex_state = 12},
  [4308] = {.lex_state = 200, .external_lex_state = 12},
  [4309] = {.lex_state = 195, .external_lex_state = 13},
  [4310] = {.lex_state = 198, .external_lex_state = 35},
  [4311] = {.lex_state = 197, .external_lex_state = 19},
  [4312] = {.lex_state = 197, .external_lex_state = 19},
  [4313] = {.lex_state = 197, .external_lex_state = 19},
  [4314] = {.lex_state = 184, .external_lex_state = 15},
  [4315] = {.lex_state = 198, .external_lex_state = 35},
  [4316] = {.lex_state = 200, .external_lex_state = 10},
  [4317] = {.lex_state = 191, .external_lex_state = 31},
  [4318] = {.lex_state = 191, .external_lex_state = 31},
  [4319] = {.lex_state = 197, .external_lex_state = 19},
  [4320] = {.lex_state = 200, .external_lex_state = 10},
  [4321] = {.lex_state = 197, .external_lex_state = 19},
  [4322] = {.lex_state = 197, .external_lex_state = 19},
  [4323] = {.lex_state = 197, .external_lex_state = 19},
  [4324] = {.lex_state = 197, .external_lex_state = 19},
  [4325] = {.lex_state = 197, .external_lex_state = 19},
  [4326] = {.lex_state = 82, .external_lex_state = 13},
  [4327] = {.lex_state = 197, .external_lex_state = 19},
  [4328] = {.lex_state = 197, .external_lex_state = 19},
  [4329] = {.lex_state = 86, .external_lex_state = 13},
  [4330] = {.lex_state = 197, .external_lex_state = 19},
  [4331] = {.lex_state = 197, .external_lex_state = 19},
  [4332] = {.lex_state = 197, .external_lex_state = 19},
  [4333] = {.lex_state = 48, .external_lex_state = 5},
  [4334] = {.lex_state = 198, .external_lex_state = 13},
  [4335] = {.lex_state = 80, .external_lex_state = 5},
  [4336] = {.lex_state = 191, .external_lex_state = 35},
  [4337] = {.lex_state = 198, .external_lex_state = 34},
  [4338] = {.lex_state = 200, .external_lex_state = 14},
  [4339] = {.lex_state = 80, .external_lex_state = 5},
  [4340] = {.lex_state = 78, .external_lex_state = 5},
  [4341] = {.lex_state = 200, .external_lex_state = 14},
  [4342] = {.lex_state = 205, .external_lex_state = 10},
  [4343] = {.lex_state = 57, .external_lex_state = 34},
  [4344] = {.lex_state = 191, .external_lex_state = 5},
  [4345] = {.lex_state = 184, .external_lex_state = 36},
  [4346] = {.lex_state = 46, .external_lex_state = 14},
  [4347] = {.lex_state = 200, .external_lex_state = 14},
  [4348] = {.lex_state = 56, .external_lex_state = 31},
  [4349] = {.lex_state = 75, .external_lex_state = 13},
  [4350] = {.lex_state = 55, .external_lex_state = 36},
  [4351] = {.lex_state = 55, .external_lex_state = 36},
  [4352] = {.lex_state = 198, .external_lex_state = 20},
  [4353] = {.lex_state = 87, .external_lex_state = 13},
  [4354] = {.lex_state = 183, .external_lex_state = 4},
  [4355] = {.lex_state = 57, .external_lex_state = 34},
  [4356] = {.lex_state = 183, .external_lex_state = 4},
  [4357] = {.lex_state = 80, .external_lex_state = 5},
  [4358] = {.lex_state = 80, .external_lex_state = 5},
  [4359] = {.lex_state = 89, .external_lex_state = 16},
  [4360] = {.lex_state = 191, .external_lex_state = 21},
  [4361] = {.lex_state = 46, .external_lex_state = 14},
  [4362] = {.lex_state = 48, .external_lex_state = 5},
  [4363] = {.lex_state = 198, .external_lex_state = 20},
  [4364] = {.lex_state = 191, .external_lex_state = 5},
  [4365] = {.lex_state = 183, .external_lex_state = 4},
  [4366] = {.lex_state = 191, .external_lex_state = 13},
  [4367] = {.lex_state = 46, .external_lex_state = 14},
  [4368] = {.lex_state = 198, .external_lex_state = 20},
  [4369] = {.lex_state = 46, .external_lex_state = 14},
  [4370] = {.lex_state = 90, .external_lex_state = 14},
  [4371] = {.lex_state = 94, .external_lex_state = 19},
  [4372] = {.lex_state = 183, .external_lex_state = 4},
  [4373] = {.lex_state = 200, .external_lex_state = 15},
  [4374] = {.lex_state = 206, .external_lex_state = 15},
  [4375] = {.lex_state = 90, .external_lex_state = 15},
  [4376] = {.lex_state = 191, .external_lex_state = 5},
  [4377] = {.lex_state = 206, .external_lex_state = 15},
  [4378] = {.lex_state = 57, .external_lex_state = 34},
  [4379] = {.lex_state = 198, .external_lex_state = 34},
  [4380] = {.lex_state = 206, .external_lex_state = 15},
  [4381] = {.lex_state = 48, .external_lex_state = 5},
  [4382] = {.lex_state = 48, .external_lex_state = 5},
  [4383] = {.lex_state = 48, .external_lex_state = 5},
  [4384] = {.lex_state = 206, .external_lex_state = 20},
  [4385] = {.lex_state = 198, .external_lex_state = 20},
  [4386] = {.lex_state = 48, .external_lex_state = 5},
  [4387] = {.lex_state = 48, .external_lex_state = 5},
  [4388] = {.lex_state = 48, .external_lex_state = 5},
  [4389] = {.lex_state = 198, .external_lex_state = 20},
  [4390] = {.lex_state = 198, .external_lex_state = 20},
  [4391] = {.lex_state = 198, .external_lex_state = 15},
  [4392] = {.lex_state = 48, .external_lex_state = 5},
  [4393] = {.lex_state = 48, .external_lex_state = 5},
  [4394] = {.lex_state = 48, .external_lex_state = 5},
  [4395] = {.lex_state = 48, .external_lex_state = 5},
  [4396] = {.lex_state = 198, .external_lex_state = 20},
  [4397] = {.lex_state = 198, .external_lex_state = 20},
  [4398] = {.lex_state = 198, .external_lex_state = 34},
  [4399] = {.lex_state = 198, .external_lex_state = 15},
  [4400] = {.lex_state = 46, .external_lex_state = 14},
  [4401] = {.lex_state = 198, .external_lex_state = 20},
  [4402] = {.lex_state = 48, .external_lex_state = 5},
  [4403] = {.lex_state = 48, .external_lex_state = 5},
  [4404] = {.lex_state = 48, .external_lex_state = 5},
  [4405] = {.lex_state = 198, .external_lex_state = 20},
  [4406] = {.lex_state = 198, .external_lex_state = 20},
  [4407] = {.lex_state = 206, .external_lex_state = 20},
  [4408] = {.lex_state = 184, .external_lex_state = 34},
  [4409] = {.lex_state = 46, .external_lex_state = 14},
  [4410] = {.lex_state = 46, .external_lex_state = 14},
  [4411] = {.lex_state = 46, .external_lex_state = 14},
  [4412] = {.lex_state = 46, .external_lex_state = 14},
  [4413] = {.lex_state = 46, .external_lex_state = 14},
  [4414] = {.lex_state = 198, .external_lex_state = 15},
  [4415] = {.lex_state = 184, .external_lex_state = 34},
  [4416] = {.lex_state = 46, .external_lex_state = 14},
  [4417] = {.lex_state = 46, .external_lex_state = 14},
  [4418] = {.lex_state = 198, .external_lex_state = 15},
  [4419] = {.lex_state = 46, .external_lex_state = 14},
  [4420] = {.lex_state = 46, .external_lex_state = 14},
  [4421] = {.lex_state = 198, .external_lex_state = 20},
  [4422] = {.lex_state = 46, .external_lex_state = 14},
  [4423] = {.lex_state = 46, .external_lex_state = 14},
  [4424] = {.lex_state = 48, .external_lex_state = 5},
  [4425] = {.lex_state = 48, .external_lex_state = 5},
  [4426] = {.lex_state = 198, .external_lex_state = 20},
  [4427] = {.lex_state = 46, .external_lex_state = 14},
  [4428] = {.lex_state = 46, .external_lex_state = 14},
  [4429] = {.lex_state = 87, .external_lex_state = 13},
  [4430] = {.lex_state = 198, .external_lex_state = 20},
  [4431] = {.lex_state = 198, .external_lex_state = 20},
  [4432] = {.lex_state = 198, .external_lex_state = 20},
  [4433] = {.lex_state = 183, .external_lex_state = 4},
  [4434] = {.lex_state = 200, .external_lex_state = 15},
  [4435] = {.lex_state = 198, .external_lex_state = 20},
  [4436] = {.lex_state = 184, .external_lex_state = 34},
  [4437] = {.lex_state = 198, .external_lex_state = 20},
  [4438] = {.lex_state = 75, .external_lex_state = 13},
  [4439] = {.lex_state = 198, .external_lex_state = 13},
  [4440] = {.lex_state = 75, .external_lex_state = 13},
  [4441] = {.lex_state = 184, .external_lex_state = 36},
  [4442] = {.lex_state = 200, .external_lex_state = 13},
  [4443] = {.lex_state = 96, .external_lex_state = 5},
  [4444] = {.lex_state = 205, .external_lex_state = 11},
  [4445] = {.lex_state = 48, .external_lex_state = 5},
  [4446] = {.lex_state = 183, .external_lex_state = 4},
  [4447] = {.lex_state = 198, .external_lex_state = 13},
  [4448] = {.lex_state = 198, .external_lex_state = 13},
  [4449] = {.lex_state = 206, .external_lex_state = 20},
  [4450] = {.lex_state = 200, .external_lex_state = 13},
  [4451] = {.lex_state = 198, .external_lex_state = 15},
  [4452] = {.lex_state = 198, .external_lex_state = 13},
  [4453] = {.lex_state = 198, .external_lex_state = 13},
  [4454] = {.lex_state = 198, .external_lex_state = 15},
  [4455] = {.lex_state = 198, .external_lex_state = 15},
  [4456] = {.lex_state = 198, .external_lex_state = 15},
  [4457] = {.lex_state = 198, .external_lex_state = 15},
  [4458] = {.lex_state = 200, .external_lex_state = 13},
  [4459] = {.lex_state = 198, .external_lex_state = 15},
  [4460] = {.lex_state = 198, .external_lex_state = 15},
  [4461] = {.lex_state = 198, .external_lex_state = 13},
  [4462] = {.lex_state = 198, .external_lex_state = 13},
  [4463] = {.lex_state = 198, .external_lex_state = 15},
  [4464] = {.lex_state = 198, .external_lex_state = 15},
  [4465] = {.lex_state = 55, .external_lex_state = 36},
  [4466] = {.lex_state = 56, .external_lex_state = 31},
  [4467] = {.lex_state = 198, .external_lex_state = 15},
  [4468] = {.lex_state = 198, .external_lex_state = 15},
  [4469] = {.lex_state = 198, .external_lex_state = 13},
  [4470] = {.lex_state = 198, .external_lex_state = 15},
  [4471] = {.lex_state = 198, .external_lex_state = 15},
  [4472] = {.lex_state = 184, .external_lex_state = 36},
  [4473] = {.lex_state = 198, .external_lex_state = 15},
  [4474] = {.lex_state = 198, .external_lex_state = 13},
  [4475] = {.lex_state = 78, .external_lex_state = 16},
  [4476] = {.lex_state = 198, .external_lex_state = 13},
  [4477] = {.lex_state = 198, .external_lex_state = 13},
  [4478] = {.lex_state = 56, .external_lex_state = 31},
  [4479] = {.lex_state = 200, .external_lex_state = 15},
  [4480] = {.lex_state = 198, .external_lex_state = 13},
  [4481] = {.lex_state = 198, .external_lex_state = 13},
  [4482] = {.lex_state = 184, .external_lex_state = 16},
  [4483] = {.lex_state = 55, .external_lex_state = 16},
  [4484] = {.lex_state = 84, .external_lex_state = 5},
  [4485] = {.lex_state = 55, .external_lex_state = 16},
  [4486] = {.lex_state = 191, .external_lex_state = 20},
  [4487] = {.lex_state = 191, .external_lex_state = 20},
  [4488] = {.lex_state = 128, .external_lex_state = 34},
  [4489] = {.lex_state = 207, .external_lex_state = 9},
  [4490] = {.lex_state = 198, .external_lex_state = 5},
  [4491] = {.lex_state = 60, .external_lex_state = 34},
  [4492] = {.lex_state = 56, .external_lex_state = 13},
  [4493] = {.lex_state = 184, .external_lex_state = 16},
  [4494] = {.lex_state = 207, .external_lex_state = 9},
  [4495] = {.lex_state = 84, .external_lex_state = 5},
  [4496] = {.lex_state = 84, .external_lex_state = 5},
  [4497] = {.lex_state = 55, .external_lex_state = 16},
  [4498] = {.lex_state = 207, .external_lex_state = 9},
  [4499] = {.lex_state = 56, .external_lex_state = 13},
  [4500] = {.lex_state = 198, .external_lex_state = 5},
  [4501] = {.lex_state = 191, .external_lex_state = 20},
  [4502] = {.lex_state = 191, .external_lex_state = 20},
  [4503] = {.lex_state = 59, .external_lex_state = 34},
  [4504] = {.lex_state = 184, .external_lex_state = 5},
  [4505] = {.lex_state = 184, .external_lex_state = 5},
  [4506] = {.lex_state = 56, .external_lex_state = 13},
  [4507] = {.lex_state = 84, .external_lex_state = 5},
  [4508] = {.lex_state = 184, .external_lex_state = 5},
  [4509] = {.lex_state = 184, .external_lex_state = 5},
  [4510] = {.lex_state = 191, .external_lex_state = 20},
  [4511] = {.lex_state = 184, .external_lex_state = 5},
  [4512] = {.lex_state = 198, .external_lex_state = 5},
  [4513] = {.lex_state = 200, .external_lex_state = 13},
  [4514] = {.lex_state = 207, .external_lex_state = 7},
  [4515] = {.lex_state = 84, .external_lex_state = 5},
  [4516] = {.lex_state = 200, .external_lex_state = 13},
  [4517] = {.lex_state = 191, .external_lex_state = 20},
  [4518] = {.lex_state = 184, .external_lex_state = 16},
  [4519] = {.lex_state = 184, .external_lex_state = 9},
  [4520] = {.lex_state = 205, .external_lex_state = 20},
  [4521] = {.lex_state = 84, .external_lex_state = 5},
  [4522] = {.lex_state = 184, .external_lex_state = 16},
  [4523] = {.lex_state = 60, .external_lex_state = 34},
  [4524] = {.lex_state = 207, .external_lex_state = 8},
  [4525] = {.lex_state = 207, .external_lex_state = 8},
  [4526] = {.lex_state = 98, .external_lex_state = 5},
  [4527] = {.lex_state = 56, .external_lex_state = 13},
  [4528] = {.lex_state = 207, .external_lex_state = 9},
  [4529] = {.lex_state = 56, .external_lex_state = 13},
  [4530] = {.lex_state = 56, .external_lex_state = 13},
  [4531] = {.lex_state = 56, .external_lex_state = 13},
  [4532] = {.lex_state = 207, .external_lex_state = 7},
  [4533] = {.lex_state = 207, .external_lex_state = 7},
  [4534] = {.lex_state = 184, .external_lex_state = 16},
  [4535] = {.lex_state = 184, .external_lex_state = 16},
  [4536] = {.lex_state = 183, .external_lex_state = 5},
  [4537] = {.lex_state = 184, .external_lex_state = 16},
  [4538] = {.lex_state = 184, .external_lex_state = 16},
  [4539] = {.lex_state = 207, .external_lex_state = 8},
  [4540] = {.lex_state = 58, .external_lex_state = 34},
  [4541] = {.lex_state = 184, .external_lex_state = 16},
  [4542] = {.lex_state = 56, .external_lex_state = 13},
  [4543] = {.lex_state = 207, .external_lex_state = 8},
  [4544] = {.lex_state = 191, .external_lex_state = 20},
  [4545] = {.lex_state = 207, .external_lex_state = 8},
  [4546] = {.lex_state = 56, .external_lex_state = 13},
  [4547] = {.lex_state = 56, .external_lex_state = 13},
  [4548] = {.lex_state = 207, .external_lex_state = 9},
  [4549] = {.lex_state = 64, .external_lex_state = 34},
  [4550] = {.lex_state = 56, .external_lex_state = 13},
  [4551] = {.lex_state = 191, .external_lex_state = 20},
  [4552] = {.lex_state = 55, .external_lex_state = 16},
  [4553] = {.lex_state = 59, .external_lex_state = 34},
  [4554] = {.lex_state = 55, .external_lex_state = 16},
  [4555] = {.lex_state = 84, .external_lex_state = 5},
  [4556] = {.lex_state = 84, .external_lex_state = 5},
  [4557] = {.lex_state = 57, .external_lex_state = 5},
  [4558] = {.lex_state = 184, .external_lex_state = 16},
  [4559] = {.lex_state = 198, .external_lex_state = 5},
  [4560] = {.lex_state = 56, .external_lex_state = 13},
  [4561] = {.lex_state = 191, .external_lex_state = 20},
  [4562] = {.lex_state = 56, .external_lex_state = 13},
  [4563] = {.lex_state = 184, .external_lex_state = 7},
  [4564] = {.lex_state = 184, .external_lex_state = 5},
  [4565] = {.lex_state = 184, .external_lex_state = 5},
  [4566] = {.lex_state = 56, .external_lex_state = 13},
  [4567] = {.lex_state = 56, .external_lex_state = 13},
  [4568] = {.lex_state = 198, .external_lex_state = 5},
  [4569] = {.lex_state = 57, .external_lex_state = 5},
  [4570] = {.lex_state = 84, .external_lex_state = 5},
  [4571] = {.lex_state = 198, .external_lex_state = 5},
  [4572] = {.lex_state = 191, .external_lex_state = 15},
  [4573] = {.lex_state = 84, .external_lex_state = 5},
  [4574] = {.lex_state = 198, .external_lex_state = 5},
  [4575] = {.lex_state = 207, .external_lex_state = 7},
  [4576] = {.lex_state = 191, .external_lex_state = 20},
  [4577] = {.lex_state = 191, .external_lex_state = 20},
  [4578] = {.lex_state = 191, .external_lex_state = 20},
  [4579] = {.lex_state = 128, .external_lex_state = 34},
  [4580] = {.lex_state = 184, .external_lex_state = 16},
  [4581] = {.lex_state = 57, .external_lex_state = 5},
  [4582] = {.lex_state = 84, .external_lex_state = 5},
  [4583] = {.lex_state = 60, .external_lex_state = 34},
  [4584] = {.lex_state = 191, .external_lex_state = 20},
  [4585] = {.lex_state = 84, .external_lex_state = 5},
  [4586] = {.lex_state = 207, .external_lex_state = 7},
  [4587] = {.lex_state = 191, .external_lex_state = 20},
  [4588] = {.lex_state = 191, .external_lex_state = 15},
  [4589] = {.lex_state = 191, .external_lex_state = 15},
  [4590] = {.lex_state = 191, .external_lex_state = 15},
  [4591] = {.lex_state = 191, .external_lex_state = 15},
  [4592] = {.lex_state = 191, .external_lex_state = 15},
  [4593] = {.lex_state = 64, .external_lex_state = 34},
  [4594] = {.lex_state = 84, .external_lex_state = 5},
  [4595] = {.lex_state = 198, .external_lex_state = 5},
  [4596] = {.lex_state = 191, .external_lex_state = 15},
  [4597] = {.lex_state = 191, .external_lex_state = 15},
  [4598] = {.lex_state = 184, .external_lex_state = 16},
  [4599] = {.lex_state = 207, .external_lex_state = 9},
  [4600] = {.lex_state = 191, .external_lex_state = 15},
  [4601] = {.lex_state = 198, .external_lex_state = 5},
  [4602] = {.lex_state = 191, .external_lex_state = 15},
  [4603] = {.lex_state = 191, .external_lex_state = 20},
  [4604] = {.lex_state = 191, .external_lex_state = 15},
  [4605] = {.lex_state = 198, .external_lex_state = 5},
  [4606] = {.lex_state = 191, .external_lex_state = 15},
  [4607] = {.lex_state = 84, .external_lex_state = 5},
  [4608] = {.lex_state = 56, .external_lex_state = 13},
  [4609] = {.lex_state = 191, .external_lex_state = 15},
  [4610] = {.lex_state = 191, .external_lex_state = 15},
  [4611] = {.lex_state = 184, .external_lex_state = 7},
  [4612] = {.lex_state = 84, .external_lex_state = 5},
  [4613] = {.lex_state = 84, .external_lex_state = 5},
  [4614] = {.lex_state = 205, .external_lex_state = 15},
  [4615] = {.lex_state = 63, .external_lex_state = 34},
  [4616] = {.lex_state = 191, .external_lex_state = 15},
  [4617] = {.lex_state = 84, .external_lex_state = 5},
  [4618] = {.lex_state = 77, .external_lex_state = 13},
  [4619] = {.lex_state = 55, .external_lex_state = 16},
  [4620] = {.lex_state = 184, .external_lex_state = 9},
  [4621] = {.lex_state = 63, .external_lex_state = 34},
  [4622] = {.lex_state = 55, .external_lex_state = 16},
  [4623] = {.lex_state = 84, .external_lex_state = 5},
  [4624] = {.lex_state = 55, .external_lex_state = 16},
  [4625] = {.lex_state = 198, .external_lex_state = 5},
  [4626] = {.lex_state = 184, .external_lex_state = 5},
  [4627] = {.lex_state = 84, .external_lex_state = 5},
  [4628] = {.lex_state = 84, .external_lex_state = 5},
  [4629] = {.lex_state = 207, .external_lex_state = 7},
  [4630] = {.lex_state = 184, .external_lex_state = 5},
  [4631] = {.lex_state = 184, .external_lex_state = 5},
  [4632] = {.lex_state = 86, .external_lex_state = 5},
  [4633] = {.lex_state = 84, .external_lex_state = 5},
  [4634] = {.lex_state = 184, .external_lex_state = 5},
  [4635] = {.lex_state = 184, .external_lex_state = 5},
  [4636] = {.lex_state = 58, .external_lex_state = 34},
  [4637] = {.lex_state = 63, .external_lex_state = 34},
  [4638] = {.lex_state = 184, .external_lex_state = 5},
  [4639] = {.lex_state = 84, .external_lex_state = 5},
  [4640] = {.lex_state = 207, .external_lex_state = 8},
  [4641] = {.lex_state = 128, .external_lex_state = 34},
  [4642] = {.lex_state = 184, .external_lex_state = 16},
  [4643] = {.lex_state = 84, .external_lex_state = 5},
  [4644] = {.lex_state = 55, .external_lex_state = 16},
  [4645] = {.lex_state = 198, .external_lex_state = 5},
  [4646] = {.lex_state = 56, .external_lex_state = 13},
  [4647] = {.lex_state = 200, .external_lex_state = 13},
  [4648] = {.lex_state = 90, .external_lex_state = 14},
  [4649] = {.lex_state = 84, .external_lex_state = 5},
  [4650] = {.lex_state = 184, .external_lex_state = 5},
  [4651] = {.lex_state = 55, .external_lex_state = 16},
  [4652] = {.lex_state = 184, .external_lex_state = 5},
  [4653] = {.lex_state = 84, .external_lex_state = 5},
  [4654] = {.lex_state = 57, .external_lex_state = 5},
  [4655] = {.lex_state = 84, .external_lex_state = 5},
  [4656] = {.lex_state = 59, .external_lex_state = 34},
  [4657] = {.lex_state = 84, .external_lex_state = 5},
  [4658] = {.lex_state = 77, .external_lex_state = 13},
  [4659] = {.lex_state = 57, .external_lex_state = 5},
  [4660] = {.lex_state = 57, .external_lex_state = 5},
  [4661] = {.lex_state = 57, .external_lex_state = 5},
  [4662] = {.lex_state = 57, .external_lex_state = 5},
  [4663] = {.lex_state = 57, .external_lex_state = 5},
  [4664] = {.lex_state = 184, .external_lex_state = 5},
  [4665] = {.lex_state = 55, .external_lex_state = 16},
  [4666] = {.lex_state = 184, .external_lex_state = 16},
  [4667] = {.lex_state = 57, .external_lex_state = 5},
  [4668] = {.lex_state = 57, .external_lex_state = 5},
  [4669] = {.lex_state = 57, .external_lex_state = 5},
  [4670] = {.lex_state = 57, .external_lex_state = 5},
  [4671] = {.lex_state = 184, .external_lex_state = 7},
  [4672] = {.lex_state = 184, .external_lex_state = 5},
  [4673] = {.lex_state = 64, .external_lex_state = 34},
  [4674] = {.lex_state = 84, .external_lex_state = 5},
  [4675] = {.lex_state = 184, .external_lex_state = 16},
  [4676] = {.lex_state = 57, .external_lex_state = 5},
  [4677] = {.lex_state = 57, .external_lex_state = 5},
  [4678] = {.lex_state = 184, .external_lex_state = 16},
  [4679] = {.lex_state = 55, .external_lex_state = 16},
  [4680] = {.lex_state = 57, .external_lex_state = 5},
  [4681] = {.lex_state = 184, .external_lex_state = 16},
  [4682] = {.lex_state = 58, .external_lex_state = 34},
  [4683] = {.lex_state = 198, .external_lex_state = 5},
  [4684] = {.lex_state = 57, .external_lex_state = 5},
  [4685] = {.lex_state = 57, .external_lex_state = 5},
  [4686] = {.lex_state = 198, .external_lex_state = 5},
  [4687] = {.lex_state = 184, .external_lex_state = 5},
  [4688] = {.lex_state = 56, .external_lex_state = 13},
  [4689] = {.lex_state = 55, .external_lex_state = 16},
  [4690] = {.lex_state = 55, .external_lex_state = 16},
  [4691] = {.lex_state = 198, .external_lex_state = 5},
  [4692] = {.lex_state = 184, .external_lex_state = 16},
  [4693] = {.lex_state = 198, .external_lex_state = 5},
  [4694] = {.lex_state = 84, .external_lex_state = 5},
  [4695] = {.lex_state = 198, .external_lex_state = 5},
  [4696] = {.lex_state = 55, .external_lex_state = 16},
  [4697] = {.lex_state = 55, .external_lex_state = 16},
  [4698] = {.lex_state = 77, .external_lex_state = 13},
  [4699] = {.lex_state = 198, .external_lex_state = 5},
  [4700] = {.lex_state = 184, .external_lex_state = 9},
  [4701] = {.lex_state = 55, .external_lex_state = 16},
  [4702] = {.lex_state = 191, .external_lex_state = 5},
  [4703] = {.lex_state = 198, .external_lex_state = 5},
  [4704] = {.lex_state = 84, .external_lex_state = 5},
  [4705] = {.lex_state = 84, .external_lex_state = 5},
  [4706] = {.lex_state = 184, .external_lex_state = 16},
  [4707] = {.lex_state = 90, .external_lex_state = 15},
  [4708] = {.lex_state = 84, .external_lex_state = 5},
  [4709] = {.lex_state = 84, .external_lex_state = 5},
  [4710] = {.lex_state = 55, .external_lex_state = 16},
  [4711] = {.lex_state = 207, .external_lex_state = 8},
  [4712] = {.lex_state = 59, .external_lex_state = 5},
  [4713] = {.lex_state = 207, .external_lex_state = 9},
  [4714] = {.lex_state = 59, .external_lex_state = 5},
  [4715] = {.lex_state = 64, .external_lex_state = 5},
  [4716] = {.lex_state = 207, .external_lex_state = 9},
  [4717] = {.lex_state = 99, .external_lex_state = 5},
  [4718] = {.lex_state = 128, .external_lex_state = 5},
  [4719] = {.lex_state = 207, .external_lex_state = 9},
  [4720] = {.lex_state = 207, .external_lex_state = 9},
  [4721] = {.lex_state = 207, .external_lex_state = 9},
  [4722] = {.lex_state = 60, .external_lex_state = 5},
  [4723] = {.lex_state = 191, .external_lex_state = 5},
  [4724] = {.lex_state = 82, .external_lex_state = 13},
  [4725] = {.lex_state = 207, .external_lex_state = 8},
  [4726] = {.lex_state = 202, .external_lex_state = 12},
  [4727] = {.lex_state = 100, .external_lex_state = 13},
  [4728] = {.lex_state = 202, .external_lex_state = 12},
  [4729] = {.lex_state = 200, .external_lex_state = 5},
  [4730] = {.lex_state = 64, .external_lex_state = 5},
  [4731] = {.lex_state = 209, .external_lex_state = 7},
  [4732] = {.lex_state = 128, .external_lex_state = 5},
  [4733] = {.lex_state = 200, .external_lex_state = 5},
  [4734] = {.lex_state = 207, .external_lex_state = 9},
  [4735] = {.lex_state = 104, .external_lex_state = 5},
  [4736] = {.lex_state = 202, .external_lex_state = 11},
  [4737] = {.lex_state = 59, .external_lex_state = 5},
  [4738] = {.lex_state = 59, .external_lex_state = 5},
  [4739] = {.lex_state = 207, .external_lex_state = 7},
  [4740] = {.lex_state = 59, .external_lex_state = 5},
  [4741] = {.lex_state = 200, .external_lex_state = 5},
  [4742] = {.lex_state = 209, .external_lex_state = 7},
  [4743] = {.lex_state = 64, .external_lex_state = 5},
  [4744] = {.lex_state = 200, .external_lex_state = 5},
  [4745] = {.lex_state = 59, .external_lex_state = 5},
  [4746] = {.lex_state = 184, .external_lex_state = 5},
  [4747] = {.lex_state = 105, .external_lex_state = 13},
  [4748] = {.lex_state = 58, .external_lex_state = 5},
  [4749] = {.lex_state = 202, .external_lex_state = 12},
  [4750] = {.lex_state = 200, .external_lex_state = 5},
  [4751] = {.lex_state = 184, .external_lex_state = 5},
  [4752] = {.lex_state = 58, .external_lex_state = 5},
  [4753] = {.lex_state = 202, .external_lex_state = 12},
  [4754] = {.lex_state = 63, .external_lex_state = 5},
  [4755] = {.lex_state = 128, .external_lex_state = 5},
  [4756] = {.lex_state = 202, .external_lex_state = 12},
  [4757] = {.lex_state = 207, .external_lex_state = 8},
  [4758] = {.lex_state = 202, .external_lex_state = 10},
  [4759] = {.lex_state = 128, .external_lex_state = 5},
  [4760] = {.lex_state = 207, .external_lex_state = 9},
  [4761] = {.lex_state = 200, .external_lex_state = 5},
  [4762] = {.lex_state = 200, .external_lex_state = 5},
  [4763] = {.lex_state = 207, .external_lex_state = 7},
  [4764] = {.lex_state = 128, .external_lex_state = 5},
  [4765] = {.lex_state = 200, .external_lex_state = 5},
  [4766] = {.lex_state = 202, .external_lex_state = 11},
  [4767] = {.lex_state = 128, .external_lex_state = 5},
  [4768] = {.lex_state = 200, .external_lex_state = 5},
  [4769] = {.lex_state = 209, .external_lex_state = 9},
  [4770] = {.lex_state = 59, .external_lex_state = 5},
  [4771] = {.lex_state = 200, .external_lex_state = 5},
  [4772] = {.lex_state = 207, .external_lex_state = 9},
  [4773] = {.lex_state = 209, .external_lex_state = 8},
  [4774] = {.lex_state = 58, .external_lex_state = 5},
  [4775] = {.lex_state = 99, .external_lex_state = 5},
  [4776] = {.lex_state = 207, .external_lex_state = 8},
  [4777] = {.lex_state = 64, .external_lex_state = 5},
  [4778] = {.lex_state = 58, .external_lex_state = 5},
  [4779] = {.lex_state = 59, .external_lex_state = 5},
  [4780] = {.lex_state = 59, .external_lex_state = 5},
  [4781] = {.lex_state = 207, .external_lex_state = 8},
  [4782] = {.lex_state = 99, .external_lex_state = 5},
  [4783] = {.lex_state = 202, .external_lex_state = 12},
  [4784] = {.lex_state = 91, .external_lex_state = 15},
  [4785] = {.lex_state = 108, .external_lex_state = 16},
  [4786] = {.lex_state = 59, .external_lex_state = 5},
  [4787] = {.lex_state = 207, .external_lex_state = 7},
  [4788] = {.lex_state = 64, .external_lex_state = 5},
  [4789] = {.lex_state = 64, .external_lex_state = 5},
  [4790] = {.lex_state = 58, .external_lex_state = 5},
  [4791] = {.lex_state = 58, .external_lex_state = 5},
  [4792] = {.lex_state = 58, .external_lex_state = 5},
  [4793] = {.lex_state = 58, .external_lex_state = 5},
  [4794] = {.lex_state = 202, .external_lex_state = 10},
  [4795] = {.lex_state = 64, .external_lex_state = 5},
  [4796] = {.lex_state = 58, .external_lex_state = 5},
  [4797] = {.lex_state = 58, .external_lex_state = 5},
  [4798] = {.lex_state = 58, .external_lex_state = 5},
  [4799] = {.lex_state = 58, .external_lex_state = 5},
  [4800] = {.lex_state = 58, .external_lex_state = 5},
  [4801] = {.lex_state = 128, .external_lex_state = 5},
  [4802] = {.lex_state = 128, .external_lex_state = 5},
  [4803] = {.lex_state = 128, .external_lex_state = 5},
  [4804] = {.lex_state = 209, .external_lex_state = 9},
  [4805] = {.lex_state = 64, .external_lex_state = 5},
  [4806] = {.lex_state = 207, .external_lex_state = 8},
  [4807] = {.lex_state = 99, .external_lex_state = 5},
  [4808] = {.lex_state = 202, .external_lex_state = 10},
  [4809] = {.lex_state = 59, .external_lex_state = 5},
  [4810] = {.lex_state = 59, .external_lex_state = 5},
  [4811] = {.lex_state = 184, .external_lex_state = 5},
  [4812] = {.lex_state = 63, .external_lex_state = 5},
  [4813] = {.lex_state = 60, .external_lex_state = 5},
  [4814] = {.lex_state = 84, .external_lex_state = 5},
  [4815] = {.lex_state = 128, .external_lex_state = 5},
  [4816] = {.lex_state = 63, .external_lex_state = 5},
  [4817] = {.lex_state = 63, .external_lex_state = 5},
  [4818] = {.lex_state = 64, .external_lex_state = 5},
  [4819] = {.lex_state = 128, .external_lex_state = 5},
  [4820] = {.lex_state = 58, .external_lex_state = 5},
  [4821] = {.lex_state = 202, .external_lex_state = 11},
  [4822] = {.lex_state = 209, .external_lex_state = 8},
  [4823] = {.lex_state = 209, .external_lex_state = 7},
  [4824] = {.lex_state = 184, .external_lex_state = 5},
  [4825] = {.lex_state = 207, .external_lex_state = 7},
  [4826] = {.lex_state = 63, .external_lex_state = 5},
  [4827] = {.lex_state = 58, .external_lex_state = 5},
  [4828] = {.lex_state = 63, .external_lex_state = 5},
  [4829] = {.lex_state = 200, .external_lex_state = 5},
  [4830] = {.lex_state = 63, .external_lex_state = 5},
  [4831] = {.lex_state = 99, .external_lex_state = 5},
  [4832] = {.lex_state = 207, .external_lex_state = 8},
  [4833] = {.lex_state = 202, .external_lex_state = 13},
  [4834] = {.lex_state = 91, .external_lex_state = 14},
  [4835] = {.lex_state = 128, .external_lex_state = 5},
  [4836] = {.lex_state = 207, .external_lex_state = 7},
  [4837] = {.lex_state = 64, .external_lex_state = 5},
  [4838] = {.lex_state = 64, .external_lex_state = 5},
  [4839] = {.lex_state = 64, .external_lex_state = 5},
  [4840] = {.lex_state = 64, .external_lex_state = 5},
  [4841] = {.lex_state = 202, .external_lex_state = 13},
  [4842] = {.lex_state = 63, .external_lex_state = 5},
  [4843] = {.lex_state = 63, .external_lex_state = 5},
  [4844] = {.lex_state = 63, .external_lex_state = 5},
  [4845] = {.lex_state = 63, .external_lex_state = 5},
  [4846] = {.lex_state = 184, .external_lex_state = 5},
  [4847] = {.lex_state = 184, .external_lex_state = 5},
  [4848] = {.lex_state = 128, .external_lex_state = 5},
  [4849] = {.lex_state = 184, .external_lex_state = 5},
  [4850] = {.lex_state = 184, .external_lex_state = 7},
  [4851] = {.lex_state = 58, .external_lex_state = 5},
  [4852] = {.lex_state = 202, .external_lex_state = 10},
  [4853] = {.lex_state = 99, .external_lex_state = 5},
  [4854] = {.lex_state = 207, .external_lex_state = 7},
  [4855] = {.lex_state = 99, .external_lex_state = 5},
  [4856] = {.lex_state = 63, .external_lex_state = 5},
  [4857] = {.lex_state = 63, .external_lex_state = 5},
  [4858] = {.lex_state = 184, .external_lex_state = 5},
  [4859] = {.lex_state = 63, .external_lex_state = 5},
  [4860] = {.lex_state = 184, .external_lex_state = 9},
  [4861] = {.lex_state = 128, .external_lex_state = 5},
  [4862] = {.lex_state = 202, .external_lex_state = 10},
  [4863] = {.lex_state = 184, .external_lex_state = 5},
  [4864] = {.lex_state = 191, .external_lex_state = 5},
  [4865] = {.lex_state = 63, .external_lex_state = 5},
  [4866] = {.lex_state = 63, .external_lex_state = 5},
  [4867] = {.lex_state = 202, .external_lex_state = 11},
  [4868] = {.lex_state = 202, .external_lex_state = 10},
  [4869] = {.lex_state = 207, .external_lex_state = 8},
  [4870] = {.lex_state = 99, .external_lex_state = 5},
  [4871] = {.lex_state = 99, .external_lex_state = 5},
  [4872] = {.lex_state = 128, .external_lex_state = 5},
  [4873] = {.lex_state = 99, .external_lex_state = 5},
  [4874] = {.lex_state = 60, .external_lex_state = 5},
  [4875] = {.lex_state = 207, .external_lex_state = 7},
  [4876] = {.lex_state = 207, .external_lex_state = 7},
  [4877] = {.lex_state = 59, .external_lex_state = 5},
  [4878] = {.lex_state = 82, .external_lex_state = 13},
  [4879] = {.lex_state = 58, .external_lex_state = 5},
  [4880] = {.lex_state = 59, .external_lex_state = 5},
  [4881] = {.lex_state = 59, .external_lex_state = 5},
  [4882] = {.lex_state = 128, .external_lex_state = 5},
  [4883] = {.lex_state = 202, .external_lex_state = 11},
  [4884] = {.lex_state = 59, .external_lex_state = 5},
  [4885] = {.lex_state = 64, .external_lex_state = 5},
  [4886] = {.lex_state = 202, .external_lex_state = 13},
  [4887] = {.lex_state = 99, .external_lex_state = 5},
  [4888] = {.lex_state = 184, .external_lex_state = 5},
  [4889] = {.lex_state = 207, .external_lex_state = 9},
  [4890] = {.lex_state = 59, .external_lex_state = 5},
  [4891] = {.lex_state = 209, .external_lex_state = 9},
  [4892] = {.lex_state = 128, .external_lex_state = 5},
  [4893] = {.lex_state = 64, .external_lex_state = 5},
  [4894] = {.lex_state = 60, .external_lex_state = 5},
  [4895] = {.lex_state = 64, .external_lex_state = 5},
  [4896] = {.lex_state = 207, .external_lex_state = 7},
  [4897] = {.lex_state = 60, .external_lex_state = 5},
  [4898] = {.lex_state = 60, .external_lex_state = 5},
  [4899] = {.lex_state = 60, .external_lex_state = 5},
  [4900] = {.lex_state = 63, .external_lex_state = 5},
  [4901] = {.lex_state = 209, .external_lex_state = 8},
  [4902] = {.lex_state = 59, .external_lex_state = 5},
  [4903] = {.lex_state = 63, .external_lex_state = 5},
  [4904] = {.lex_state = 60, .external_lex_state = 5},
  [4905] = {.lex_state = 128, .external_lex_state = 5},
  [4906] = {.lex_state = 99, .external_lex_state = 5},
  [4907] = {.lex_state = 184, .external_lex_state = 5},
  [4908] = {.lex_state = 202, .external_lex_state = 13},
  [4909] = {.lex_state = 60, .external_lex_state = 5},
  [4910] = {.lex_state = 82, .external_lex_state = 13},
  [4911] = {.lex_state = 58, .external_lex_state = 5},
  [4912] = {.lex_state = 60, .external_lex_state = 5},
  [4913] = {.lex_state = 60, .external_lex_state = 5},
  [4914] = {.lex_state = 202, .external_lex_state = 11},
  [4915] = {.lex_state = 60, .external_lex_state = 5},
  [4916] = {.lex_state = 60, .external_lex_state = 5},
  [4917] = {.lex_state = 207, .external_lex_state = 8},
  [4918] = {.lex_state = 60, .external_lex_state = 5},
  [4919] = {.lex_state = 60, .external_lex_state = 5},
  [4920] = {.lex_state = 64, .external_lex_state = 5},
  [4921] = {.lex_state = 64, .external_lex_state = 5},
  [4922] = {.lex_state = 60, .external_lex_state = 5},
  [4923] = {.lex_state = 60, .external_lex_state = 5},
  [4924] = {.lex_state = 60, .external_lex_state = 5},
  [4925] = {.lex_state = 199, .external_lex_state = 22},
  [4926] = {.lex_state = 202, .external_lex_state = 15},
  [4927] = {.lex_state = 209, .external_lex_state = 19},
  [4928] = {.lex_state = 183, .external_lex_state = 5},
  [4929] = {.lex_state = 202, .external_lex_state = 13},
  [4930] = {.lex_state = 210, .external_lex_state = 11},
  [4931] = {.lex_state = 199, .external_lex_state = 26},
  [4932] = {.lex_state = 202, .external_lex_state = 15},
  [4933] = {.lex_state = 184, .external_lex_state = 5},
  [4934] = {.lex_state = 199, .external_lex_state = 24},
  [4935] = {.lex_state = 202, .external_lex_state = 15},
  [4936] = {.lex_state = 99, .external_lex_state = 5},
  [4937] = {.lex_state = 109, .external_lex_state = 25},
  [4938] = {.lex_state = 199, .external_lex_state = 26},
  [4939] = {.lex_state = 109, .external_lex_state = 25},
  [4940] = {.lex_state = 202, .external_lex_state = 12},
  [4941] = {.lex_state = 202, .external_lex_state = 12},
  [4942] = {.lex_state = 184, .external_lex_state = 15},
  [4943] = {.lex_state = 202, .external_lex_state = 10},
  [4944] = {.lex_state = 199, .external_lex_state = 23},
  [4945] = {.lex_state = 202, .external_lex_state = 15},
  [4946] = {.lex_state = 202, .external_lex_state = 15},
  [4947] = {.lex_state = 202, .external_lex_state = 5},
  [4948] = {.lex_state = 184, .external_lex_state = 5},
  [4949] = {.lex_state = 199, .external_lex_state = 7},
  [4950] = {.lex_state = 184, .external_lex_state = 20},
  [4951] = {.lex_state = 202, .external_lex_state = 12},
  [4952] = {.lex_state = 199, .external_lex_state = 26},
  [4953] = {.lex_state = 210, .external_lex_state = 12},
  [4954] = {.lex_state = 199, .external_lex_state = 22},
  [4955] = {.lex_state = 202, .external_lex_state = 11},
  [4956] = {.lex_state = 202, .external_lex_state = 13},
  [4957] = {.lex_state = 202, .external_lex_state = 14},
  [4958] = {.lex_state = 202, .external_lex_state = 15},
  [4959] = {.lex_state = 87, .external_lex_state = 13},
  [4960] = {.lex_state = 199, .external_lex_state = 24},
  [4961] = {.lex_state = 202, .external_lex_state = 5},
  [4962] = {.lex_state = 199, .external_lex_state = 7},
  [4963] = {.lex_state = 202, .external_lex_state = 13},
  [4964] = {.lex_state = 202, .external_lex_state = 5},
  [4965] = {.lex_state = 184, .external_lex_state = 5},
  [4966] = {.lex_state = 210, .external_lex_state = 11},
  [4967] = {.lex_state = 202, .external_lex_state = 13},
  [4968] = {.lex_state = 202, .external_lex_state = 11},
  [4969] = {.lex_state = 202, .external_lex_state = 13},
  [4970] = {.lex_state = 199, .external_lex_state = 22},
  [4971] = {.lex_state = 202, .external_lex_state = 13},
  [4972] = {.lex_state = 199, .external_lex_state = 22},
  [4973] = {.lex_state = 87, .external_lex_state = 13},
  [4974] = {.lex_state = 199, .external_lex_state = 24},
  [4975] = {.lex_state = 199, .external_lex_state = 7},
  [4976] = {.lex_state = 210, .external_lex_state = 12},
  [4977] = {.lex_state = 199, .external_lex_state = 7},
  [4978] = {.lex_state = 109, .external_lex_state = 21},
  [4979] = {.lex_state = 199, .external_lex_state = 22},
  [4980] = {.lex_state = 199, .external_lex_state = 24},
  [4981] = {.lex_state = 202, .external_lex_state = 14},
  [4982] = {.lex_state = 199, .external_lex_state = 23},
  [4983] = {.lex_state = 199, .external_lex_state = 22},
  [4984] = {.lex_state = 110, .external_lex_state = 13},
  [4985] = {.lex_state = 202, .external_lex_state = 5},
  [4986] = {.lex_state = 199, .external_lex_state = 22},
  [4987] = {.lex_state = 183, .external_lex_state = 5},
  [4988] = {.lex_state = 202, .external_lex_state = 13},
  [4989] = {.lex_state = 199, .external_lex_state = 24},
  [4990] = {.lex_state = 199, .external_lex_state = 23},
  [4991] = {.lex_state = 199, .external_lex_state = 23},
  [4992] = {.lex_state = 199, .external_lex_state = 22},
  [4993] = {.lex_state = 199, .external_lex_state = 22},
  [4994] = {.lex_state = 202, .external_lex_state = 10},
  [4995] = {.lex_state = 202, .external_lex_state = 14},
  [4996] = {.lex_state = 100, .external_lex_state = 13},
  [4997] = {.lex_state = 202, .external_lex_state = 14},
  [4998] = {.lex_state = 199, .external_lex_state = 8},
  [4999] = {.lex_state = 202, .external_lex_state = 13},
  [5000] = {.lex_state = 202, .external_lex_state = 13},
  [5001] = {.lex_state = 202, .external_lex_state = 11},
  [5002] = {.lex_state = 202, .external_lex_state = 15},
  [5003] = {.lex_state = 202, .external_lex_state = 13},
  [5004] = {.lex_state = 202, .external_lex_state = 12},
  [5005] = {.lex_state = 74, .external_lex_state = 13},
  [5006] = {.lex_state = 210, .external_lex_state = 10},
  [5007] = {.lex_state = 202, .external_lex_state = 10},
  [5008] = {.lex_state = 202, .external_lex_state = 11},
  [5009] = {.lex_state = 105, .external_lex_state = 13},
  [5010] = {.lex_state = 202, .external_lex_state = 10},
  [5011] = {.lex_state = 202, .external_lex_state = 12},
  [5012] = {.lex_state = 199, .external_lex_state = 7},
  [5013] = {.lex_state = 74, .external_lex_state = 13},
  [5014] = {.lex_state = 199, .external_lex_state = 7},
  [5015] = {.lex_state = 202, .external_lex_state = 10},
  [5016] = {.lex_state = 199, .external_lex_state = 7},
  [5017] = {.lex_state = 202, .external_lex_state = 10},
  [5018] = {.lex_state = 74, .external_lex_state = 13},
  [5019] = {.lex_state = 202, .external_lex_state = 10},
  [5020] = {.lex_state = 202, .external_lex_state = 10},
  [5021] = {.lex_state = 199, .external_lex_state = 9},
  [5022] = {.lex_state = 184, .external_lex_state = 15},
  [5023] = {.lex_state = 202, .external_lex_state = 10},
  [5024] = {.lex_state = 202, .external_lex_state = 11},
  [5025] = {.lex_state = 210, .external_lex_state = 12},
  [5026] = {.lex_state = 199, .external_lex_state = 26},
  [5027] = {.lex_state = 74, .external_lex_state = 13},
  [5028] = {.lex_state = 183, .external_lex_state = 5},
  [5029] = {.lex_state = 202, .external_lex_state = 11},
  [5030] = {.lex_state = 202, .external_lex_state = 11},
  [5031] = {.lex_state = 202, .external_lex_state = 14},
  [5032] = {.lex_state = 202, .external_lex_state = 12},
  [5033] = {.lex_state = 87, .external_lex_state = 13},
  [5034] = {.lex_state = 199, .external_lex_state = 23},
  [5035] = {.lex_state = 109, .external_lex_state = 21},
  [5036] = {.lex_state = 202, .external_lex_state = 14},
  [5037] = {.lex_state = 109, .external_lex_state = 21},
  [5038] = {.lex_state = 202, .external_lex_state = 13},
  [5039] = {.lex_state = 202, .external_lex_state = 12},
  [5040] = {.lex_state = 202, .external_lex_state = 13},
  [5041] = {.lex_state = 202, .external_lex_state = 14},
  [5042] = {.lex_state = 202, .external_lex_state = 11},
  [5043] = {.lex_state = 199, .external_lex_state = 7},
  [5044] = {.lex_state = 209, .external_lex_state = 19},
  [5045] = {.lex_state = 184, .external_lex_state = 20},
  [5046] = {.lex_state = 202, .external_lex_state = 12},
  [5047] = {.lex_state = 109, .external_lex_state = 25},
  [5048] = {.lex_state = 199, .external_lex_state = 7},
  [5049] = {.lex_state = 210, .external_lex_state = 10},
  [5050] = {.lex_state = 74, .external_lex_state = 13},
  [5051] = {.lex_state = 202, .external_lex_state = 12},
  [5052] = {.lex_state = 202, .external_lex_state = 11},
  [5053] = {.lex_state = 74, .external_lex_state = 13},
  [5054] = {.lex_state = 210, .external_lex_state = 11},
  [5055] = {.lex_state = 183, .external_lex_state = 5},
  [5056] = {.lex_state = 205, .external_lex_state = 3},
  [5057] = {.lex_state = 210, .external_lex_state = 10},
  [5058] = {.lex_state = 199, .external_lex_state = 26},
  [5059] = {.lex_state = 199, .external_lex_state = 7},
  [5060] = {.lex_state = 199, .external_lex_state = 9},
  [5061] = {.lex_state = 200, .external_lex_state = 28},
  [5062] = {.lex_state = 184, .external_lex_state = 5},
  [5063] = {.lex_state = 202, .external_lex_state = 5},
  [5064] = {.lex_state = 200, .external_lex_state = 32},
  [5065] = {.lex_state = 199, .external_lex_state = 7},
  [5066] = {.lex_state = 199, .external_lex_state = 9},
  [5067] = {.lex_state = 202, .external_lex_state = 5},
  [5068] = {.lex_state = 199, .external_lex_state = 7},
  [5069] = {.lex_state = 200, .external_lex_state = 32},
  [5070] = {.lex_state = 202, .external_lex_state = 15},
  [5071] = {.lex_state = 202, .external_lex_state = 13},
  [5072] = {.lex_state = 200, .external_lex_state = 32},
  [5073] = {.lex_state = 200, .external_lex_state = 32},
  [5074] = {.lex_state = 199, .external_lex_state = 8},
  [5075] = {.lex_state = 200, .external_lex_state = 32},
  [5076] = {.lex_state = 200, .external_lex_state = 32},
  [5077] = {.lex_state = 202, .external_lex_state = 13},
  [5078] = {.lex_state = 199, .external_lex_state = 7},
  [5079] = {.lex_state = 101, .external_lex_state = 13},
  [5080] = {.lex_state = 199, .external_lex_state = 7},
  [5081] = {.lex_state = 199, .external_lex_state = 8},
  [5082] = {.lex_state = 199, .external_lex_state = 7},
  [5083] = {.lex_state = 199, .external_lex_state = 9},
  [5084] = {.lex_state = 199, .external_lex_state = 7},
  [5085] = {.lex_state = 200, .external_lex_state = 32},
  [5086] = {.lex_state = 199, .external_lex_state = 8},
  [5087] = {.lex_state = 113, .external_lex_state = 13},
  [5088] = {.lex_state = 199, .external_lex_state = 9},
  [5089] = {.lex_state = 199, .external_lex_state = 8},
  [5090] = {.lex_state = 199, .external_lex_state = 8},
  [5091] = {.lex_state = 199, .external_lex_state = 8},
  [5092] = {.lex_state = 199, .external_lex_state = 8},
  [5093] = {.lex_state = 199, .external_lex_state = 8},
  [5094] = {.lex_state = 199, .external_lex_state = 8},
  [5095] = {.lex_state = 199, .external_lex_state = 8},
  [5096] = {.lex_state = 199, .external_lex_state = 8},
  [5097] = {.lex_state = 199, .external_lex_state = 8},
  [5098] = {.lex_state = 74, .external_lex_state = 13},
  [5099] = {.lex_state = 199, .external_lex_state = 8},
  [5100] = {.lex_state = 199, .external_lex_state = 8},
  [5101] = {.lex_state = 199, .external_lex_state = 7},
  [5102] = {.lex_state = 199, .external_lex_state = 8},
  [5103] = {.lex_state = 199, .external_lex_state = 8},
  [5104] = {.lex_state = 202, .external_lex_state = 14},
  [5105] = {.lex_state = 199, .external_lex_state = 8},
  [5106] = {.lex_state = 200, .external_lex_state = 32},
  [5107] = {.lex_state = 200, .external_lex_state = 27},
  [5108] = {.lex_state = 200, .external_lex_state = 31},
  [5109] = {.lex_state = 200, .external_lex_state = 27},
  [5110] = {.lex_state = 199, .external_lex_state = 8},
  [5111] = {.lex_state = 184, .external_lex_state = 5},
  [5112] = {.lex_state = 199, .external_lex_state = 8},
  [5113] = {.lex_state = 200, .external_lex_state = 28},
  [5114] = {.lex_state = 199, .external_lex_state = 8},
  [5115] = {.lex_state = 200, .external_lex_state = 28},
  [5116] = {.lex_state = 199, .external_lex_state = 7},
  [5117] = {.lex_state = 199, .external_lex_state = 9},
  [5118] = {.lex_state = 199, .external_lex_state = 7},
  [5119] = {.lex_state = 199, .external_lex_state = 7},
  [5120] = {.lex_state = 199, .external_lex_state = 9},
  [5121] = {.lex_state = 199, .external_lex_state = 7},
  [5122] = {.lex_state = 199, .external_lex_state = 8},
  [5123] = {.lex_state = 200, .external_lex_state = 13},
  [5124] = {.lex_state = 199, .external_lex_state = 9},
  [5125] = {.lex_state = 199, .external_lex_state = 8},
  [5126] = {.lex_state = 199, .external_lex_state = 8},
  [5127] = {.lex_state = 199, .external_lex_state = 7},
  [5128] = {.lex_state = 199, .external_lex_state = 8},
  [5129] = {.lex_state = 199, .external_lex_state = 7},
  [5130] = {.lex_state = 202, .external_lex_state = 5},
  [5131] = {.lex_state = 84, .external_lex_state = 5},
  [5132] = {.lex_state = 200, .external_lex_state = 32},
  [5133] = {.lex_state = 199, .external_lex_state = 7},
  [5134] = {.lex_state = 199, .external_lex_state = 8},
  [5135] = {.lex_state = 199, .external_lex_state = 7},
  [5136] = {.lex_state = 199, .external_lex_state = 8},
  [5137] = {.lex_state = 199, .external_lex_state = 7},
  [5138] = {.lex_state = 202, .external_lex_state = 5},
  [5139] = {.lex_state = 199, .external_lex_state = 7},
  [5140] = {.lex_state = 199, .external_lex_state = 8},
  [5141] = {.lex_state = 202, .external_lex_state = 5},
  [5142] = {.lex_state = 199, .external_lex_state = 8},
  [5143] = {.lex_state = 202, .external_lex_state = 5},
  [5144] = {.lex_state = 200, .external_lex_state = 27},
  [5145] = {.lex_state = 200, .external_lex_state = 10},
  [5146] = {.lex_state = 202, .external_lex_state = 14},
  [5147] = {.lex_state = 199, .external_lex_state = 8},
  [5148] = {.lex_state = 202, .external_lex_state = 5},
  [5149] = {.lex_state = 199, .external_lex_state = 7},
  [5150] = {.lex_state = 199, .external_lex_state = 7},
  [5151] = {.lex_state = 74, .external_lex_state = 13},
  [5152] = {.lex_state = 202, .external_lex_state = 5},
  [5153] = {.lex_state = 202, .external_lex_state = 14},
  [5154] = {.lex_state = 202, .external_lex_state = 14},
  [5155] = {.lex_state = 109, .external_lex_state = 14},
  [5156] = {.lex_state = 199, .external_lex_state = 8},
  [5157] = {.lex_state = 109, .external_lex_state = 15},
  [5158] = {.lex_state = 210, .external_lex_state = 13},
  [5159] = {.lex_state = 202, .external_lex_state = 14},
  [5160] = {.lex_state = 109, .external_lex_state = 14},
  [5161] = {.lex_state = 109, .external_lex_state = 14},
  [5162] = {.lex_state = 199, .external_lex_state = 7},
  [5163] = {.lex_state = 199, .external_lex_state = 7},
  [5164] = {.lex_state = 199, .external_lex_state = 7},
  [5165] = {.lex_state = 199, .external_lex_state = 7},
  [5166] = {.lex_state = 210, .external_lex_state = 20},
  [5167] = {.lex_state = 199, .external_lex_state = 8},
  [5168] = {.lex_state = 200, .external_lex_state = 29},
  [5169] = {.lex_state = 199, .external_lex_state = 8},
  [5170] = {.lex_state = 199, .external_lex_state = 8},
  [5171] = {.lex_state = 76, .external_lex_state = 13},
  [5172] = {.lex_state = 200, .external_lex_state = 29},
  [5173] = {.lex_state = 202, .external_lex_state = 14},
  [5174] = {.lex_state = 199, .external_lex_state = 8},
  [5175] = {.lex_state = 202, .external_lex_state = 5},
  [5176] = {.lex_state = 199, .external_lex_state = 7},
  [5177] = {.lex_state = 199, .external_lex_state = 9},
  [5178] = {.lex_state = 109, .external_lex_state = 15},
  [5179] = {.lex_state = 199, .external_lex_state = 8},
  [5180] = {.lex_state = 199, .external_lex_state = 8},
  [5181] = {.lex_state = 109, .external_lex_state = 15},
  [5182] = {.lex_state = 109, .external_lex_state = 15},
  [5183] = {.lex_state = 199, .external_lex_state = 9},
  [5184] = {.lex_state = 199, .external_lex_state = 7},
  [5185] = {.lex_state = 199, .external_lex_state = 7},
  [5186] = {.lex_state = 200, .external_lex_state = 10},
  [5187] = {.lex_state = 199, .external_lex_state = 7},
  [5188] = {.lex_state = 200, .external_lex_state = 10},
  [5189] = {.lex_state = 199, .external_lex_state = 7},
  [5190] = {.lex_state = 199, .external_lex_state = 7},
  [5191] = {.lex_state = 199, .external_lex_state = 7},
  [5192] = {.lex_state = 200, .external_lex_state = 29},
  [5193] = {.lex_state = 200, .external_lex_state = 28},
  [5194] = {.lex_state = 199, .external_lex_state = 8},
  [5195] = {.lex_state = 199, .external_lex_state = 8},
  [5196] = {.lex_state = 199, .external_lex_state = 8},
  [5197] = {.lex_state = 200, .external_lex_state = 10},
  [5198] = {.lex_state = 200, .external_lex_state = 10},
  [5199] = {.lex_state = 74, .external_lex_state = 13},
  [5200] = {.lex_state = 200, .external_lex_state = 10},
  [5201] = {.lex_state = 199, .external_lex_state = 7},
  [5202] = {.lex_state = 200, .external_lex_state = 10},
  [5203] = {.lex_state = 202, .external_lex_state = 15},
  [5204] = {.lex_state = 199, .external_lex_state = 8},
  [5205] = {.lex_state = 199, .external_lex_state = 7},
  [5206] = {.lex_state = 210, .external_lex_state = 13},
  [5207] = {.lex_state = 200, .external_lex_state = 10},
  [5208] = {.lex_state = 84, .external_lex_state = 5},
  [5209] = {.lex_state = 199, .external_lex_state = 8},
  [5210] = {.lex_state = 199, .external_lex_state = 8},
  [5211] = {.lex_state = 199, .external_lex_state = 8},
  [5212] = {.lex_state = 199, .external_lex_state = 7},
  [5213] = {.lex_state = 199, .external_lex_state = 7},
  [5214] = {.lex_state = 199, .external_lex_state = 7},
  [5215] = {.lex_state = 199, .external_lex_state = 9},
  [5216] = {.lex_state = 199, .external_lex_state = 7},
  [5217] = {.lex_state = 205, .external_lex_state = 5},
  [5218] = {.lex_state = 199, .external_lex_state = 7},
  [5219] = {.lex_state = 199, .external_lex_state = 7},
  [5220] = {.lex_state = 200, .external_lex_state = 10},
  [5221] = {.lex_state = 199, .external_lex_state = 9},
  [5222] = {.lex_state = 84, .external_lex_state = 5},
  [5223] = {.lex_state = 199, .external_lex_state = 8},
  [5224] = {.lex_state = 199, .external_lex_state = 9},
  [5225] = {.lex_state = 199, .external_lex_state = 8},
  [5226] = {.lex_state = 199, .external_lex_state = 8},
  [5227] = {.lex_state = 200, .external_lex_state = 29},
  [5228] = {.lex_state = 210, .external_lex_state = 20},
  [5229] = {.lex_state = 199, .external_lex_state = 8},
  [5230] = {.lex_state = 76, .external_lex_state = 13},
  [5231] = {.lex_state = 199, .external_lex_state = 8},
  [5232] = {.lex_state = 199, .external_lex_state = 7},
  [5233] = {.lex_state = 76, .external_lex_state = 13},
  [5234] = {.lex_state = 199, .external_lex_state = 9},
  [5235] = {.lex_state = 113, .external_lex_state = 13},
  [5236] = {.lex_state = 199, .external_lex_state = 7},
  [5237] = {.lex_state = 199, .external_lex_state = 9},
  [5238] = {.lex_state = 109, .external_lex_state = 14},
  [5239] = {.lex_state = 199, .external_lex_state = 9},
  [5240] = {.lex_state = 199, .external_lex_state = 7},
  [5241] = {.lex_state = 199, .external_lex_state = 9},
  [5242] = {.lex_state = 199, .external_lex_state = 7},
  [5243] = {.lex_state = 210, .external_lex_state = 14},
  [5244] = {.lex_state = 199, .external_lex_state = 7},
  [5245] = {.lex_state = 199, .external_lex_state = 7},
  [5246] = {.lex_state = 199, .external_lex_state = 9},
  [5247] = {.lex_state = 210, .external_lex_state = 15},
  [5248] = {.lex_state = 76, .external_lex_state = 13},
  [5249] = {.lex_state = 199, .external_lex_state = 7},
  [5250] = {.lex_state = 76, .external_lex_state = 13},
  [5251] = {.lex_state = 109, .external_lex_state = 14},
  [5252] = {.lex_state = 109, .external_lex_state = 14},
  [5253] = {.lex_state = 109, .external_lex_state = 14},
  [5254] = {.lex_state = 202, .external_lex_state = 15},
  [5255] = {.lex_state = 202, .external_lex_state = 14},
  [5256] = {.lex_state = 76, .external_lex_state = 13},
  [5257] = {.lex_state = 199, .external_lex_state = 9},
  [5258] = {.lex_state = 199, .external_lex_state = 7},
  [5259] = {.lex_state = 199, .external_lex_state = 7},
  [5260] = {.lex_state = 202, .external_lex_state = 15},
  [5261] = {.lex_state = 202, .external_lex_state = 15},
  [5262] = {.lex_state = 199, .external_lex_state = 9},
  [5263] = {.lex_state = 202, .external_lex_state = 15},
  [5264] = {.lex_state = 199, .external_lex_state = 9},
  [5265] = {.lex_state = 202, .external_lex_state = 15},
  [5266] = {.lex_state = 200, .external_lex_state = 30},
  [5267] = {.lex_state = 200, .external_lex_state = 11},
  [5268] = {.lex_state = 200, .external_lex_state = 30},
  [5269] = {.lex_state = 199, .external_lex_state = 7},
  [5270] = {.lex_state = 199, .external_lex_state = 8},
  [5271] = {.lex_state = 200, .external_lex_state = 30},
  [5272] = {.lex_state = 200, .external_lex_state = 30},
  [5273] = {.lex_state = 199, .external_lex_state = 7},
  [5274] = {.lex_state = 199, .external_lex_state = 9},
  [5275] = {.lex_state = 199, .external_lex_state = 9},
  [5276] = {.lex_state = 200, .external_lex_state = 10},
  [5277] = {.lex_state = 199, .external_lex_state = 7},
  [5278] = {.lex_state = 202, .external_lex_state = 15},
  [5279] = {.lex_state = 199, .external_lex_state = 9},
  [5280] = {.lex_state = 199, .external_lex_state = 7},
  [5281] = {.lex_state = 199, .external_lex_state = 8},
  [5282] = {.lex_state = 184, .external_lex_state = 15},
  [5283] = {.lex_state = 199, .external_lex_state = 8},
  [5284] = {.lex_state = 199, .external_lex_state = 8},
  [5285] = {.lex_state = 210, .external_lex_state = 20},
  [5286] = {.lex_state = 200, .external_lex_state = 27},
  [5287] = {.lex_state = 199, .external_lex_state = 7},
  [5288] = {.lex_state = 210, .external_lex_state = 15},
  [5289] = {.lex_state = 202, .external_lex_state = 14},
  [5290] = {.lex_state = 199, .external_lex_state = 7},
  [5291] = {.lex_state = 199, .external_lex_state = 8},
  [5292] = {.lex_state = 199, .external_lex_state = 7},
  [5293] = {.lex_state = 202, .external_lex_state = 14},
  [5294] = {.lex_state = 109, .external_lex_state = 15},
  [5295] = {.lex_state = 200, .external_lex_state = 31},
  [5296] = {.lex_state = 199, .external_lex_state = 8},
  [5297] = {.lex_state = 109, .external_lex_state = 15},
  [5298] = {.lex_state = 109, .external_lex_state = 15},
  [5299] = {.lex_state = 199, .external_lex_state = 9},
  [5300] = {.lex_state = 199, .external_lex_state = 9},
  [5301] = {.lex_state = 199, .external_lex_state = 9},
  [5302] = {.lex_state = 199, .external_lex_state = 9},
  [5303] = {.lex_state = 199, .external_lex_state = 9},
  [5304] = {.lex_state = 200, .external_lex_state = 27},
  [5305] = {.lex_state = 199, .external_lex_state = 9},
  [5306] = {.lex_state = 199, .external_lex_state = 9},
  [5307] = {.lex_state = 199, .external_lex_state = 9},
  [5308] = {.lex_state = 199, .external_lex_state = 9},
  [5309] = {.lex_state = 199, .external_lex_state = 9},
  [5310] = {.lex_state = 199, .external_lex_state = 9},
  [5311] = {.lex_state = 199, .external_lex_state = 9},
  [5312] = {.lex_state = 199, .external_lex_state = 9},
  [5313] = {.lex_state = 199, .external_lex_state = 9},
  [5314] = {.lex_state = 199, .external_lex_state = 9},
  [5315] = {.lex_state = 199, .external_lex_state = 9},
  [5316] = {.lex_state = 199, .external_lex_state = 9},
  [5317] = {.lex_state = 199, .external_lex_state = 9},
  [5318] = {.lex_state = 199, .external_lex_state = 9},
  [5319] = {.lex_state = 199, .external_lex_state = 9},
  [5320] = {.lex_state = 199, .external_lex_state = 7},
  [5321] = {.lex_state = 199, .external_lex_state = 9},
  [5322] = {.lex_state = 199, .external_lex_state = 8},
  [5323] = {.lex_state = 199, .external_lex_state = 9},
  [5324] = {.lex_state = 199, .external_lex_state = 8},
  [5325] = {.lex_state = 200, .external_lex_state = 30},
  [5326] = {.lex_state = 199, .external_lex_state = 8},
  [5327] = {.lex_state = 199, .external_lex_state = 9},
  [5328] = {.lex_state = 210, .external_lex_state = 15},
  [5329] = {.lex_state = 199, .external_lex_state = 7},
  [5330] = {.lex_state = 199, .external_lex_state = 9},
  [5331] = {.lex_state = 199, .external_lex_state = 9},
  [5332] = {.lex_state = 199, .external_lex_state = 8},
  [5333] = {.lex_state = 199, .external_lex_state = 9},
  [5334] = {.lex_state = 199, .external_lex_state = 7},
  [5335] = {.lex_state = 199, .external_lex_state = 8},
  [5336] = {.lex_state = 199, .external_lex_state = 7},
  [5337] = {.lex_state = 199, .external_lex_state = 7},
  [5338] = {.lex_state = 199, .external_lex_state = 7},
  [5339] = {.lex_state = 199, .external_lex_state = 8},
  [5340] = {.lex_state = 199, .external_lex_state = 9},
  [5341] = {.lex_state = 199, .external_lex_state = 7},
  [5342] = {.lex_state = 74, .external_lex_state = 13},
  [5343] = {.lex_state = 74, .external_lex_state = 13},
  [5344] = {.lex_state = 74, .external_lex_state = 13},
  [5345] = {.lex_state = 202, .external_lex_state = 13},
  [5346] = {.lex_state = 74, .external_lex_state = 13},
  [5347] = {.lex_state = 200, .external_lex_state = 28},
  [5348] = {.lex_state = 199, .external_lex_state = 9},
  [5349] = {.lex_state = 199, .external_lex_state = 9},
  [5350] = {.lex_state = 199, .external_lex_state = 7},
  [5351] = {.lex_state = 199, .external_lex_state = 9},
  [5352] = {.lex_state = 200, .external_lex_state = 29},
  [5353] = {.lex_state = 199, .external_lex_state = 9},
  [5354] = {.lex_state = 199, .external_lex_state = 9},
  [5355] = {.lex_state = 74, .external_lex_state = 13},
  [5356] = {.lex_state = 74, .external_lex_state = 13},
  [5357] = {.lex_state = 199, .external_lex_state = 7},
  [5358] = {.lex_state = 199, .external_lex_state = 9},
  [5359] = {.lex_state = 105, .external_lex_state = 5},
  [5360] = {.lex_state = 199, .external_lex_state = 9},
  [5361] = {.lex_state = 200, .external_lex_state = 12},
  [5362] = {.lex_state = 199, .external_lex_state = 9},
  [5363] = {.lex_state = 199, .external_lex_state = 9},
  [5364] = {.lex_state = 199, .external_lex_state = 7},
  [5365] = {.lex_state = 200, .external_lex_state = 31},
  [5366] = {.lex_state = 199, .external_lex_state = 7},
  [5367] = {.lex_state = 202, .external_lex_state = 15},
  [5368] = {.lex_state = 199, .external_lex_state = 8},
  [5369] = {.lex_state = 199, .external_lex_state = 9},
  [5370] = {.lex_state = 200, .external_lex_state = 30},
  [5371] = {.lex_state = 199, .external_lex_state = 7},
  [5372] = {.lex_state = 202, .external_lex_state = 5},
  [5373] = {.lex_state = 184, .external_lex_state = 20},
  [5374] = {.lex_state = 200, .external_lex_state = 30},
  [5375] = {.lex_state = 200, .external_lex_state = 30},
  [5376] = {.lex_state = 199, .external_lex_state = 9},
  [5377] = {.lex_state = 210, .external_lex_state = 14},
  [5378] = {.lex_state = 200, .external_lex_state = 30},
  [5379] = {.lex_state = 200, .external_lex_state = 31},
  [5380] = {.lex_state = 210, .external_lex_state = 14},
  [5381] = {.lex_state = 200, .external_lex_state = 31},
  [5382] = {.lex_state = 110, .external_lex_state = 13},
  [5383] = {.lex_state = 210, .external_lex_state = 13},
  [5384] = {.lex_state = 200, .external_lex_state = 10},
  [5385] = {.lex_state = 200, .external_lex_state = 12},
  [5386] = {.lex_state = 200, .external_lex_state = 10},
  [5387] = {.lex_state = 115, .external_lex_state = 31},
  [5388] = {.lex_state = 200, .external_lex_state = 4},
  [5389] = {.lex_state = 115, .external_lex_state = 31},
  [5390] = {.lex_state = 200, .external_lex_state = 4},
  [5391] = {.lex_state = 200, .external_lex_state = 12},
  [5392] = {.lex_state = 200, .external_lex_state = 12},
  [5393] = {.lex_state = 200, .external_lex_state = 12},
  [5394] = {.lex_state = 200, .external_lex_state = 12},
  [5395] = {.lex_state = 200, .external_lex_state = 12},
  [5396] = {.lex_state = 200, .external_lex_state = 12},
  [5397] = {.lex_state = 200, .external_lex_state = 12},
  [5398] = {.lex_state = 200, .external_lex_state = 12},
  [5399] = {.lex_state = 200, .external_lex_state = 12},
  [5400] = {.lex_state = 200, .external_lex_state = 12},
  [5401] = {.lex_state = 200, .external_lex_state = 12},
  [5402] = {.lex_state = 200, .external_lex_state = 12},
  [5403] = {.lex_state = 200, .external_lex_state = 12},
  [5404] = {.lex_state = 200, .external_lex_state = 12},
  [5405] = {.lex_state = 200, .external_lex_state = 11},
  [5406] = {.lex_state = 183, .external_lex_state = 5},
  [5407] = {.lex_state = 200, .external_lex_state = 10},
  [5408] = {.lex_state = 200, .external_lex_state = 4},
  [5409] = {.lex_state = 200, .external_lex_state = 4},
  [5410] = {.lex_state = 200, .external_lex_state = 10},
  [5411] = {.lex_state = 200, .external_lex_state = 10},
  [5412] = {.lex_state = 200, .external_lex_state = 10},
  [5413] = {.lex_state = 200, .external_lex_state = 4},
  [5414] = {.lex_state = 200, .external_lex_state = 4},
  [5415] = {.lex_state = 200, .external_lex_state = 10},
  [5416] = {.lex_state = 200, .external_lex_state = 4},
  [5417] = {.lex_state = 200, .external_lex_state = 12},
  [5418] = {.lex_state = 200, .external_lex_state = 10},
  [5419] = {.lex_state = 200, .external_lex_state = 10},
  [5420] = {.lex_state = 200, .external_lex_state = 25},
  [5421] = {.lex_state = 200, .external_lex_state = 4},
  [5422] = {.lex_state = 200, .external_lex_state = 25},
  [5423] = {.lex_state = 200, .external_lex_state = 12},
  [5424] = {.lex_state = 200, .external_lex_state = 13},
  [5425] = {.lex_state = 200, .external_lex_state = 12},
  [5426] = {.lex_state = 200, .external_lex_state = 10},
  [5427] = {.lex_state = 200, .external_lex_state = 10},
  [5428] = {.lex_state = 200, .external_lex_state = 21},
  [5429] = {.lex_state = 200, .external_lex_state = 10},
  [5430] = {.lex_state = 183, .external_lex_state = 5},
  [5431] = {.lex_state = 200, .external_lex_state = 4},
  [5432] = {.lex_state = 200, .external_lex_state = 13},
  [5433] = {.lex_state = 200, .external_lex_state = 13},
  [5434] = {.lex_state = 200, .external_lex_state = 13},
  [5435] = {.lex_state = 200, .external_lex_state = 21},
  [5436] = {.lex_state = 200, .external_lex_state = 10},
  [5437] = {.lex_state = 200, .external_lex_state = 10},
  [5438] = {.lex_state = 200, .external_lex_state = 13},
  [5439] = {.lex_state = 200, .external_lex_state = 13},
  [5440] = {.lex_state = 200, .external_lex_state = 12},
  [5441] = {.lex_state = 200, .external_lex_state = 12},
  [5442] = {.lex_state = 200, .external_lex_state = 12},
  [5443] = {.lex_state = 183, .external_lex_state = 5},
  [5444] = {.lex_state = 200, .external_lex_state = 13},
  [5445] = {.lex_state = 200, .external_lex_state = 12},
  [5446] = {.lex_state = 200, .external_lex_state = 12},
  [5447] = {.lex_state = 200, .external_lex_state = 12},
  [5448] = {.lex_state = 200, .external_lex_state = 12},
  [5449] = {.lex_state = 200, .external_lex_state = 12},
  [5450] = {.lex_state = 200, .external_lex_state = 10},
  [5451] = {.lex_state = 200, .external_lex_state = 10},
  [5452] = {.lex_state = 200, .external_lex_state = 10},
  [5453] = {.lex_state = 200, .external_lex_state = 10},
  [5454] = {.lex_state = 200, .external_lex_state = 13},
  [5455] = {.lex_state = 200, .external_lex_state = 10},
  [5456] = {.lex_state = 200, .external_lex_state = 10},
  [5457] = {.lex_state = 200, .external_lex_state = 12},
  [5458] = {.lex_state = 75, .external_lex_state = 31},
  [5459] = {.lex_state = 200, .external_lex_state = 10},
  [5460] = {.lex_state = 75, .external_lex_state = 31},
  [5461] = {.lex_state = 200, .external_lex_state = 5},
  [5462] = {.lex_state = 200, .external_lex_state = 10},
  [5463] = {.lex_state = 200, .external_lex_state = 10},
  [5464] = {.lex_state = 200, .external_lex_state = 10},
  [5465] = {.lex_state = 200, .external_lex_state = 10},
  [5466] = {.lex_state = 202, .external_lex_state = 5},
  [5467] = {.lex_state = 200, .external_lex_state = 10},
  [5468] = {.lex_state = 200, .external_lex_state = 12},
  [5469] = {.lex_state = 200, .external_lex_state = 10},
  [5470] = {.lex_state = 200, .external_lex_state = 10},
  [5471] = {.lex_state = 200, .external_lex_state = 12},
  [5472] = {.lex_state = 200, .external_lex_state = 13},
  [5473] = {.lex_state = 200, .external_lex_state = 13},
  [5474] = {.lex_state = 200, .external_lex_state = 13},
  [5475] = {.lex_state = 200, .external_lex_state = 13},
  [5476] = {.lex_state = 200, .external_lex_state = 11},
  [5477] = {.lex_state = 200, .external_lex_state = 13},
  [5478] = {.lex_state = 76, .external_lex_state = 13},
  [5479] = {.lex_state = 200, .external_lex_state = 11},
  [5480] = {.lex_state = 200, .external_lex_state = 12},
  [5481] = {.lex_state = 200, .external_lex_state = 13},
  [5482] = {.lex_state = 200, .external_lex_state = 13},
  [5483] = {.lex_state = 200, .external_lex_state = 13},
  [5484] = {.lex_state = 200, .external_lex_state = 12},
  [5485] = {.lex_state = 200, .external_lex_state = 12},
  [5486] = {.lex_state = 200, .external_lex_state = 13},
  [5487] = {.lex_state = 200, .external_lex_state = 13},
  [5488] = {.lex_state = 200, .external_lex_state = 13},
  [5489] = {.lex_state = 183, .external_lex_state = 5},
  [5490] = {.lex_state = 200, .external_lex_state = 11},
  [5491] = {.lex_state = 200, .external_lex_state = 12},
  [5492] = {.lex_state = 200, .external_lex_state = 13},
  [5493] = {.lex_state = 200, .external_lex_state = 12},
  [5494] = {.lex_state = 116, .external_lex_state = 5},
  [5495] = {.lex_state = 183, .external_lex_state = 4},
  [5496] = {.lex_state = 0, .external_lex_state = 19},
  [5497] = {.lex_state = 183, .external_lex_state = 5},
  [5498] = {.lex_state = 200, .external_lex_state = 12},
  [5499] = {.lex_state = 200, .external_lex_state = 10},
  [5500] = {.lex_state = 200, .external_lex_state = 10},
  [5501] = {.lex_state = 81, .external_lex_state = 13},
  [5502] = {.lex_state = 200, .external_lex_state = 25},
  [5503] = {.lex_state = 200, .external_lex_state = 12},
  [5504] = {.lex_state = 118, .external_lex_state = 5},
  [5505] = {.lex_state = 200, .external_lex_state = 10},
  [5506] = {.lex_state = 200, .external_lex_state = 11},
  [5507] = {.lex_state = 200, .external_lex_state = 10},
  [5508] = {.lex_state = 200, .external_lex_state = 10},
  [5509] = {.lex_state = 200, .external_lex_state = 10},
  [5510] = {.lex_state = 200, .external_lex_state = 34},
  [5511] = {.lex_state = 183, .external_lex_state = 5},
  [5512] = {.lex_state = 183, .external_lex_state = 4},
  [5513] = {.lex_state = 200, .external_lex_state = 21},
  [5514] = {.lex_state = 200, .external_lex_state = 11},
  [5515] = {.lex_state = 200, .external_lex_state = 11},
  [5516] = {.lex_state = 200, .external_lex_state = 11},
  [5517] = {.lex_state = 200, .external_lex_state = 11},
  [5518] = {.lex_state = 200, .external_lex_state = 11},
  [5519] = {.lex_state = 200, .external_lex_state = 11},
  [5520] = {.lex_state = 200, .external_lex_state = 11},
  [5521] = {.lex_state = 200, .external_lex_state = 11},
  [5522] = {.lex_state = 200, .external_lex_state = 11},
  [5523] = {.lex_state = 0, .external_lex_state = 19},
  [5524] = {.lex_state = 200, .external_lex_state = 11},
  [5525] = {.lex_state = 200, .external_lex_state = 11},
  [5526] = {.lex_state = 183, .external_lex_state = 5},
  [5527] = {.lex_state = 200, .external_lex_state = 11},
  [5528] = {.lex_state = 200, .external_lex_state = 11},
  [5529] = {.lex_state = 200, .external_lex_state = 11},
  [5530] = {.lex_state = 200, .external_lex_state = 10},
  [5531] = {.lex_state = 183, .external_lex_state = 5},
  [5532] = {.lex_state = 200, .external_lex_state = 11},
  [5533] = {.lex_state = 81, .external_lex_state = 13},
  [5534] = {.lex_state = 200, .external_lex_state = 11},
  [5535] = {.lex_state = 183, .external_lex_state = 5},
  [5536] = {.lex_state = 200, .external_lex_state = 11},
  [5537] = {.lex_state = 200, .external_lex_state = 11},
  [5538] = {.lex_state = 200, .external_lex_state = 13},
  [5539] = {.lex_state = 200, .external_lex_state = 11},
  [5540] = {.lex_state = 183, .external_lex_state = 5},
  [5541] = {.lex_state = 183, .external_lex_state = 4},
  [5542] = {.lex_state = 200, .external_lex_state = 12},
  [5543] = {.lex_state = 183, .external_lex_state = 5},
  [5544] = {.lex_state = 183, .external_lex_state = 5},
  [5545] = {.lex_state = 113, .external_lex_state = 13},
  [5546] = {.lex_state = 183, .external_lex_state = 4},
  [5547] = {.lex_state = 210, .external_lex_state = 5},
  [5548] = {.lex_state = 200, .external_lex_state = 12},
  [5549] = {.lex_state = 210, .external_lex_state = 5},
  [5550] = {.lex_state = 200, .external_lex_state = 13},
  [5551] = {.lex_state = 183, .external_lex_state = 5},
  [5552] = {.lex_state = 183, .external_lex_state = 5},
  [5553] = {.lex_state = 200, .external_lex_state = 12},
  [5554] = {.lex_state = 118, .external_lex_state = 5},
  [5555] = {.lex_state = 119, .external_lex_state = 16},
  [5556] = {.lex_state = 183, .external_lex_state = 4},
  [5557] = {.lex_state = 183, .external_lex_state = 5},
  [5558] = {.lex_state = 200, .external_lex_state = 10},
  [5559] = {.lex_state = 200, .external_lex_state = 13},
  [5560] = {.lex_state = 200, .external_lex_state = 13},
  [5561] = {.lex_state = 200, .external_lex_state = 11},
  [5562] = {.lex_state = 200, .external_lex_state = 25},
  [5563] = {.lex_state = 200, .external_lex_state = 15},
  [5564] = {.lex_state = 202, .external_lex_state = 5},
  [5565] = {.lex_state = 118, .external_lex_state = 5},
  [5566] = {.lex_state = 200, .external_lex_state = 11},
  [5567] = {.lex_state = 200, .external_lex_state = 11},
  [5568] = {.lex_state = 210, .external_lex_state = 5},
  [5569] = {.lex_state = 76, .external_lex_state = 13},
  [5570] = {.lex_state = 200, .external_lex_state = 11},
  [5571] = {.lex_state = 200, .external_lex_state = 11},
  [5572] = {.lex_state = 210, .external_lex_state = 5},
  [5573] = {.lex_state = 200, .external_lex_state = 13},
  [5574] = {.lex_state = 200, .external_lex_state = 13},
  [5575] = {.lex_state = 183, .external_lex_state = 5},
  [5576] = {.lex_state = 200, .external_lex_state = 13},
  [5577] = {.lex_state = 200, .external_lex_state = 13},
  [5578] = {.lex_state = 183, .external_lex_state = 5},
  [5579] = {.lex_state = 200, .external_lex_state = 13},
  [5580] = {.lex_state = 200, .external_lex_state = 13},
  [5581] = {.lex_state = 200, .external_lex_state = 21},
  [5582] = {.lex_state = 183, .external_lex_state = 4},
  [5583] = {.lex_state = 200, .external_lex_state = 13},
  [5584] = {.lex_state = 200, .external_lex_state = 13},
  [5585] = {.lex_state = 200, .external_lex_state = 13},
  [5586] = {.lex_state = 200, .external_lex_state = 13},
  [5587] = {.lex_state = 200, .external_lex_state = 13},
  [5588] = {.lex_state = 200, .external_lex_state = 13},
  [5589] = {.lex_state = 200, .external_lex_state = 11},
  [5590] = {.lex_state = 183, .external_lex_state = 4},
  [5591] = {.lex_state = 200, .external_lex_state = 13},
  [5592] = {.lex_state = 120, .external_lex_state = 5},
  [5593] = {.lex_state = 183, .external_lex_state = 5},
  [5594] = {.lex_state = 76, .external_lex_state = 13},
  [5595] = {.lex_state = 183, .external_lex_state = 5},
  [5596] = {.lex_state = 200, .external_lex_state = 12},
  [5597] = {.lex_state = 183, .external_lex_state = 5},
  [5598] = {.lex_state = 183, .external_lex_state = 5},
  [5599] = {.lex_state = 200, .external_lex_state = 11},
  [5600] = {.lex_state = 200, .external_lex_state = 13},
  [5601] = {.lex_state = 200, .external_lex_state = 12},
  [5602] = {.lex_state = 120, .external_lex_state = 5},
  [5603] = {.lex_state = 119, .external_lex_state = 16},
  [5604] = {.lex_state = 190, .external_lex_state = 3},
  [5605] = {.lex_state = 200, .external_lex_state = 14},
  [5606] = {.lex_state = 75, .external_lex_state = 32},
  [5607] = {.lex_state = 183, .external_lex_state = 5},
  [5608] = {.lex_state = 200, .external_lex_state = 11},
  [5609] = {.lex_state = 75, .external_lex_state = 32},
  [5610] = {.lex_state = 183, .external_lex_state = 5},
  [5611] = {.lex_state = 75, .external_lex_state = 32},
  [5612] = {.lex_state = 183, .external_lex_state = 5},
  [5613] = {.lex_state = 200, .external_lex_state = 10},
  [5614] = {.lex_state = 183, .external_lex_state = 5},
  [5615] = {.lex_state = 113, .external_lex_state = 13},
  [5616] = {.lex_state = 183, .external_lex_state = 5},
  [5617] = {.lex_state = 200, .external_lex_state = 33},
  [5618] = {.lex_state = 200, .external_lex_state = 33},
  [5619] = {.lex_state = 183, .external_lex_state = 5},
  [5620] = {.lex_state = 200, .external_lex_state = 11},
  [5621] = {.lex_state = 200, .external_lex_state = 33},
  [5622] = {.lex_state = 120, .external_lex_state = 5},
  [5623] = {.lex_state = 200, .external_lex_state = 33},
  [5624] = {.lex_state = 202, .external_lex_state = 5},
  [5625] = {.lex_state = 200, .external_lex_state = 33},
  [5626] = {.lex_state = 200, .external_lex_state = 33},
  [5627] = {.lex_state = 200, .external_lex_state = 33},
  [5628] = {.lex_state = 200, .external_lex_state = 33},
  [5629] = {.lex_state = 200, .external_lex_state = 33},
  [5630] = {.lex_state = 183, .external_lex_state = 5},
  [5631] = {.lex_state = 183, .external_lex_state = 5},
  [5632] = {.lex_state = 202, .external_lex_state = 5},
  [5633] = {.lex_state = 200, .external_lex_state = 10},
  [5634] = {.lex_state = 183, .external_lex_state = 5},
  [5635] = {.lex_state = 75, .external_lex_state = 32},
  [5636] = {.lex_state = 199, .external_lex_state = 5},
  [5637] = {.lex_state = 183, .external_lex_state = 5},
  [5638] = {.lex_state = 199, .external_lex_state = 5},
  [5639] = {.lex_state = 75, .external_lex_state = 32},
  [5640] = {.lex_state = 200, .external_lex_state = 10},
  [5641] = {.lex_state = 183, .external_lex_state = 5},
  [5642] = {.lex_state = 210, .external_lex_state = 13},
  [5643] = {.lex_state = 210, .external_lex_state = 13},
  [5644] = {.lex_state = 200, .external_lex_state = 10},
  [5645] = {.lex_state = 210, .external_lex_state = 13},
  [5646] = {.lex_state = 120, .external_lex_state = 5},
  [5647] = {.lex_state = 202, .external_lex_state = 5},
  [5648] = {.lex_state = 200, .external_lex_state = 10},
  [5649] = {.lex_state = 183, .external_lex_state = 5},
  [5650] = {.lex_state = 75, .external_lex_state = 13},
  [5651] = {.lex_state = 119, .external_lex_state = 16},
  [5652] = {.lex_state = 200, .external_lex_state = 11},
  [5653] = {.lex_state = 183, .external_lex_state = 4},
  [5654] = {.lex_state = 111, .external_lex_state = 13},
  [5655] = {.lex_state = 183, .external_lex_state = 5},
  [5656] = {.lex_state = 200, .external_lex_state = 13},
  [5657] = {.lex_state = 183, .external_lex_state = 4},
  [5658] = {.lex_state = 200, .external_lex_state = 34},
  [5659] = {.lex_state = 200, .external_lex_state = 11},
  [5660] = {.lex_state = 183, .external_lex_state = 4},
  [5661] = {.lex_state = 199, .external_lex_state = 5},
  [5662] = {.lex_state = 183, .external_lex_state = 4},
  [5663] = {.lex_state = 183, .external_lex_state = 4},
  [5664] = {.lex_state = 183, .external_lex_state = 5},
  [5665] = {.lex_state = 76, .external_lex_state = 13},
  [5666] = {.lex_state = 183, .external_lex_state = 5},
  [5667] = {.lex_state = 200, .external_lex_state = 11},
  [5668] = {.lex_state = 183, .external_lex_state = 4},
  [5669] = {.lex_state = 200, .external_lex_state = 11},
  [5670] = {.lex_state = 200, .external_lex_state = 11},
  [5671] = {.lex_state = 200, .external_lex_state = 11},
  [5672] = {.lex_state = 183, .external_lex_state = 4},
  [5673] = {.lex_state = 183, .external_lex_state = 5},
  [5674] = {.lex_state = 183, .external_lex_state = 5},
  [5675] = {.lex_state = 200, .external_lex_state = 11},
  [5676] = {.lex_state = 183, .external_lex_state = 5},
  [5677] = {.lex_state = 200, .external_lex_state = 10},
  [5678] = {.lex_state = 200, .external_lex_state = 13},
  [5679] = {.lex_state = 200, .external_lex_state = 11},
  [5680] = {.lex_state = 200, .external_lex_state = 11},
  [5681] = {.lex_state = 199, .external_lex_state = 5},
  [5682] = {.lex_state = 200, .external_lex_state = 10},
  [5683] = {.lex_state = 199, .external_lex_state = 5},
  [5684] = {.lex_state = 199, .external_lex_state = 5},
  [5685] = {.lex_state = 199, .external_lex_state = 5},
  [5686] = {.lex_state = 81, .external_lex_state = 13},
  [5687] = {.lex_state = 200, .external_lex_state = 11},
  [5688] = {.lex_state = 200, .external_lex_state = 11},
  [5689] = {.lex_state = 81, .external_lex_state = 13},
  [5690] = {.lex_state = 200, .external_lex_state = 11},
  [5691] = {.lex_state = 200, .external_lex_state = 11},
  [5692] = {.lex_state = 81, .external_lex_state = 13},
  [5693] = {.lex_state = 199, .external_lex_state = 5},
  [5694] = {.lex_state = 200, .external_lex_state = 11},
  [5695] = {.lex_state = 200, .external_lex_state = 11},
  [5696] = {.lex_state = 183, .external_lex_state = 5},
  [5697] = {.lex_state = 81, .external_lex_state = 13},
  [5698] = {.lex_state = 81, .external_lex_state = 13},
  [5699] = {.lex_state = 75, .external_lex_state = 31},
  [5700] = {.lex_state = 200, .external_lex_state = 11},
  [5701] = {.lex_state = 200, .external_lex_state = 11},
  [5702] = {.lex_state = 200, .external_lex_state = 11},
  [5703] = {.lex_state = 105, .external_lex_state = 5},
  [5704] = {.lex_state = 200, .external_lex_state = 11},
  [5705] = {.lex_state = 75, .external_lex_state = 32},
  [5706] = {.lex_state = 75, .external_lex_state = 32},
  [5707] = {.lex_state = 75, .external_lex_state = 32},
  [5708] = {.lex_state = 75, .external_lex_state = 32},
  [5709] = {.lex_state = 76, .external_lex_state = 13},
  [5710] = {.lex_state = 76, .external_lex_state = 13},
  [5711] = {.lex_state = 76, .external_lex_state = 13},
  [5712] = {.lex_state = 200, .external_lex_state = 13},
  [5713] = {.lex_state = 200, .external_lex_state = 13},
  [5714] = {.lex_state = 200, .external_lex_state = 13},
  [5715] = {.lex_state = 200, .external_lex_state = 13},
  [5716] = {.lex_state = 200, .external_lex_state = 13},
  [5717] = {.lex_state = 76, .external_lex_state = 13},
  [5718] = {.lex_state = 200, .external_lex_state = 11},
  [5719] = {.lex_state = 200, .external_lex_state = 11},
  [5720] = {.lex_state = 115, .external_lex_state = 31},
  [5721] = {.lex_state = 200, .external_lex_state = 13},
  [5722] = {.lex_state = 200, .external_lex_state = 13},
  [5723] = {.lex_state = 200, .external_lex_state = 13},
  [5724] = {.lex_state = 200, .external_lex_state = 13},
  [5725] = {.lex_state = 200, .external_lex_state = 11},
  [5726] = {.lex_state = 200, .external_lex_state = 13},
  [5727] = {.lex_state = 200, .external_lex_state = 13},
  [5728] = {.lex_state = 200, .external_lex_state = 13},
  [5729] = {.lex_state = 200, .external_lex_state = 13},
  [5730] = {.lex_state = 200, .external_lex_state = 13},
  [5731] = {.lex_state = 183, .external_lex_state = 5},
  [5732] = {.lex_state = 76, .external_lex_state = 13},
  [5733] = {.lex_state = 200, .external_lex_state = 11},
  [5734] = {.lex_state = 200, .external_lex_state = 11},
  [5735] = {.lex_state = 200, .external_lex_state = 12},
  [5736] = {.lex_state = 200, .external_lex_state = 11},
  [5737] = {.lex_state = 200, .external_lex_state = 13},
  [5738] = {.lex_state = 200, .external_lex_state = 13},
  [5739] = {.lex_state = 200, .external_lex_state = 21},
  [5740] = {.lex_state = 200, .external_lex_state = 10},
  [5741] = {.lex_state = 200, .external_lex_state = 12},
  [5742] = {.lex_state = 200, .external_lex_state = 13},
  [5743] = {.lex_state = 200, .external_lex_state = 13},
  [5744] = {.lex_state = 200, .external_lex_state = 10},
  [5745] = {.lex_state = 200, .external_lex_state = 10},
  [5746] = {.lex_state = 200, .external_lex_state = 10},
  [5747] = {.lex_state = 200, .external_lex_state = 10},
  [5748] = {.lex_state = 200, .external_lex_state = 12},
  [5749] = {.lex_state = 200, .external_lex_state = 10},
  [5750] = {.lex_state = 200, .external_lex_state = 10},
  [5751] = {.lex_state = 200, .external_lex_state = 10},
  [5752] = {.lex_state = 200, .external_lex_state = 10},
  [5753] = {.lex_state = 200, .external_lex_state = 10},
  [5754] = {.lex_state = 200, .external_lex_state = 10},
  [5755] = {.lex_state = 200, .external_lex_state = 10},
  [5756] = {.lex_state = 200, .external_lex_state = 10},
  [5757] = {.lex_state = 200, .external_lex_state = 10},
  [5758] = {.lex_state = 200, .external_lex_state = 10},
  [5759] = {.lex_state = 200, .external_lex_state = 10},
  [5760] = {.lex_state = 200, .external_lex_state = 10},
  [5761] = {.lex_state = 200, .external_lex_state = 10},
  [5762] = {.lex_state = 200, .external_lex_state = 10},
  [5763] = {.lex_state = 200, .external_lex_state = 10},
  [5764] = {.lex_state = 75, .external_lex_state = 31},
  [5765] = {.lex_state = 75, .external_lex_state = 31},
  [5766] = {.lex_state = 200, .external_lex_state = 10},
  [5767] = {.lex_state = 200, .external_lex_state = 11},
  [5768] = {.lex_state = 200, .external_lex_state = 10},
  [5769] = {.lex_state = 200, .external_lex_state = 34},
  [5770] = {.lex_state = 200, .external_lex_state = 34},
  [5771] = {.lex_state = 200, .external_lex_state = 10},
  [5772] = {.lex_state = 200, .external_lex_state = 12},
  [5773] = {.lex_state = 200, .external_lex_state = 12},
  [5774] = {.lex_state = 200, .external_lex_state = 12},
  [5775] = {.lex_state = 200, .external_lex_state = 12},
  [5776] = {.lex_state = 200, .external_lex_state = 12},
  [5777] = {.lex_state = 200, .external_lex_state = 11},
  [5778] = {.lex_state = 200, .external_lex_state = 12},
  [5779] = {.lex_state = 200, .external_lex_state = 12},
  [5780] = {.lex_state = 200, .external_lex_state = 12},
  [5781] = {.lex_state = 200, .external_lex_state = 34},
  [5782] = {.lex_state = 200, .external_lex_state = 25},
  [5783] = {.lex_state = 200, .external_lex_state = 12},
  [5784] = {.lex_state = 200, .external_lex_state = 12},
  [5785] = {.lex_state = 200, .external_lex_state = 11},
  [5786] = {.lex_state = 200, .external_lex_state = 13},
  [5787] = {.lex_state = 200, .external_lex_state = 13},
  [5788] = {.lex_state = 200, .external_lex_state = 13},
  [5789] = {.lex_state = 200, .external_lex_state = 12},
  [5790] = {.lex_state = 200, .external_lex_state = 12},
  [5791] = {.lex_state = 200, .external_lex_state = 12},
  [5792] = {.lex_state = 200, .external_lex_state = 12},
  [5793] = {.lex_state = 200, .external_lex_state = 12},
  [5794] = {.lex_state = 200, .external_lex_state = 12},
  [5795] = {.lex_state = 200, .external_lex_state = 12},
  [5796] = {.lex_state = 184, .external_lex_state = 16},
  [5797] = {.lex_state = 81, .external_lex_state = 13},
  [5798] = {.lex_state = 200, .external_lex_state = 15},
  [5799] = {.lex_state = 115, .external_lex_state = 13},
  [5800] = {.lex_state = 75, .external_lex_state = 13},
  [5801] = {.lex_state = 200, .external_lex_state = 5},
  [5802] = {.lex_state = 200, .external_lex_state = 5},
  [5803] = {.lex_state = 200, .external_lex_state = 15},
  [5804] = {.lex_state = 200, .external_lex_state = 5},
  [5805] = {.lex_state = 75, .external_lex_state = 13},
  [5806] = {.lex_state = 75, .external_lex_state = 13},
  [5807] = {.lex_state = 75, .external_lex_state = 13},
  [5808] = {.lex_state = 75, .external_lex_state = 13},
  [5809] = {.lex_state = 75, .external_lex_state = 13},
  [5810] = {.lex_state = 200, .external_lex_state = 14},
  [5811] = {.lex_state = 184, .external_lex_state = 16},
  [5812] = {.lex_state = 200, .external_lex_state = 15},
  [5813] = {.lex_state = 75, .external_lex_state = 13},
  [5814] = {.lex_state = 81, .external_lex_state = 13},
  [5815] = {.lex_state = 115, .external_lex_state = 13},
  [5816] = {.lex_state = 75, .external_lex_state = 13},
  [5817] = {.lex_state = 200, .external_lex_state = 5},
  [5818] = {.lex_state = 75, .external_lex_state = 13},
  [5819] = {.lex_state = 200, .external_lex_state = 5},
  [5820] = {.lex_state = 200, .external_lex_state = 5},
  [5821] = {.lex_state = 200, .external_lex_state = 5},
  [5822] = {.lex_state = 200, .external_lex_state = 5},
  [5823] = {.lex_state = 184, .external_lex_state = 16},
  [5824] = {.lex_state = 200, .external_lex_state = 5},
  [5825] = {.lex_state = 200, .external_lex_state = 15},
  [5826] = {.lex_state = 200, .external_lex_state = 15},
  [5827] = {.lex_state = 200, .external_lex_state = 15},
  [5828] = {.lex_state = 200, .external_lex_state = 15},
  [5829] = {.lex_state = 200, .external_lex_state = 15},
  [5830] = {.lex_state = 200, .external_lex_state = 15},
  [5831] = {.lex_state = 200, .external_lex_state = 15},
  [5832] = {.lex_state = 184, .external_lex_state = 16},
  [5833] = {.lex_state = 200, .external_lex_state = 15},
  [5834] = {.lex_state = 200, .external_lex_state = 5},
  [5835] = {.lex_state = 75, .external_lex_state = 13},
  [5836] = {.lex_state = 75, .external_lex_state = 13},
  [5837] = {.lex_state = 75, .external_lex_state = 13},
  [5838] = {.lex_state = 75, .external_lex_state = 13},
  [5839] = {.lex_state = 75, .external_lex_state = 13},
  [5840] = {.lex_state = 184, .external_lex_state = 16},
  [5841] = {.lex_state = 75, .external_lex_state = 13},
  [5842] = {.lex_state = 200, .external_lex_state = 5},
  [5843] = {.lex_state = 200, .external_lex_state = 5},
  [5844] = {.lex_state = 75, .external_lex_state = 13},
  [5845] = {.lex_state = 210, .external_lex_state = 5},
  [5846] = {.lex_state = 184, .external_lex_state = 16},
  [5847] = {.lex_state = 75, .external_lex_state = 13},
  [5848] = {.lex_state = 200, .external_lex_state = 14},
  [5849] = {.lex_state = 200, .external_lex_state = 5},
  [5850] = {.lex_state = 200, .external_lex_state = 5},
  [5851] = {.lex_state = 200, .external_lex_state = 5},
  [5852] = {.lex_state = 200, .external_lex_state = 5},
  [5853] = {.lex_state = 200, .external_lex_state = 5},
  [5854] = {.lex_state = 75, .external_lex_state = 13},
  [5855] = {.lex_state = 184, .external_lex_state = 15},
  [5856] = {.lex_state = 75, .external_lex_state = 13},
  [5857] = {.lex_state = 200, .external_lex_state = 5},
  [5858] = {.lex_state = 200, .external_lex_state = 5},
  [5859] = {.lex_state = 200, .external_lex_state = 5},
  [5860] = {.lex_state = 184, .external_lex_state = 16},
  [5861] = {.lex_state = 200, .external_lex_state = 15},
  [5862] = {.lex_state = 200, .external_lex_state = 5},
  [5863] = {.lex_state = 200, .external_lex_state = 15},
  [5864] = {.lex_state = 87, .external_lex_state = 13},
  [5865] = {.lex_state = 200, .external_lex_state = 15},
  [5866] = {.lex_state = 87, .external_lex_state = 13},
  [5867] = {.lex_state = 200, .external_lex_state = 15},
  [5868] = {.lex_state = 210, .external_lex_state = 5},
  [5869] = {.lex_state = 200, .external_lex_state = 5},
  [5870] = {.lex_state = 200, .external_lex_state = 5},
  [5871] = {.lex_state = 200, .external_lex_state = 14},
  [5872] = {.lex_state = 200, .external_lex_state = 14},
  [5873] = {.lex_state = 200, .external_lex_state = 5},
  [5874] = {.lex_state = 200, .external_lex_state = 5},
  [5875] = {.lex_state = 200, .external_lex_state = 5},
  [5876] = {.lex_state = 210, .external_lex_state = 5},
  [5877] = {.lex_state = 200, .external_lex_state = 14},
  [5878] = {.lex_state = 77, .external_lex_state = 32},
  [5879] = {.lex_state = 200, .external_lex_state = 14},
  [5880] = {.lex_state = 200, .external_lex_state = 15},
  [5881] = {.lex_state = 200, .external_lex_state = 15},
  [5882] = {.lex_state = 115, .external_lex_state = 13},
  [5883] = {.lex_state = 87, .external_lex_state = 13},
  [5884] = {.lex_state = 77, .external_lex_state = 32},
  [5885] = {.lex_state = 200, .external_lex_state = 15},
  [5886] = {.lex_state = 77, .external_lex_state = 32},
  [5887] = {.lex_state = 184, .external_lex_state = 16},
  [5888] = {.lex_state = 200, .external_lex_state = 15},
  [5889] = {.lex_state = 184, .external_lex_state = 16},
  [5890] = {.lex_state = 184, .external_lex_state = 16},
  [5891] = {.lex_state = 200, .external_lex_state = 5},
  [5892] = {.lex_state = 200, .external_lex_state = 14},
  [5893] = {.lex_state = 200, .external_lex_state = 15},
  [5894] = {.lex_state = 77, .external_lex_state = 32},
  [5895] = {.lex_state = 200, .external_lex_state = 15},
  [5896] = {.lex_state = 200, .external_lex_state = 5},
  [5897] = {.lex_state = 75, .external_lex_state = 13},
  [5898] = {.lex_state = 184, .external_lex_state = 16},
  [5899] = {.lex_state = 200, .external_lex_state = 15},
  [5900] = {.lex_state = 200, .external_lex_state = 15},
  [5901] = {.lex_state = 200, .external_lex_state = 15},
  [5902] = {.lex_state = 200, .external_lex_state = 15},
  [5903] = {.lex_state = 184, .external_lex_state = 16},
  [5904] = {.lex_state = 77, .external_lex_state = 32},
  [5905] = {.lex_state = 75, .external_lex_state = 13},
  [5906] = {.lex_state = 200, .external_lex_state = 15},
  [5907] = {.lex_state = 184, .external_lex_state = 16},
  [5908] = {.lex_state = 75, .external_lex_state = 13},
  [5909] = {.lex_state = 77, .external_lex_state = 31},
  [5910] = {.lex_state = 184, .external_lex_state = 16},
  [5911] = {.lex_state = 200, .external_lex_state = 15},
  [5912] = {.lex_state = 184, .external_lex_state = 16},
  [5913] = {.lex_state = 200, .external_lex_state = 15},
  [5914] = {.lex_state = 200, .external_lex_state = 5},
  [5915] = {.lex_state = 85, .external_lex_state = 13},
  [5916] = {.lex_state = 200, .external_lex_state = 15},
  [5917] = {.lex_state = 200, .external_lex_state = 15},
  [5918] = {.lex_state = 200, .external_lex_state = 14},
  [5919] = {.lex_state = 200, .external_lex_state = 14},
  [5920] = {.lex_state = 200, .external_lex_state = 5},
  [5921] = {.lex_state = 200, .external_lex_state = 5},
  [5922] = {.lex_state = 184, .external_lex_state = 16},
  [5923] = {.lex_state = 200, .external_lex_state = 15},
  [5924] = {.lex_state = 200, .external_lex_state = 5},
  [5925] = {.lex_state = 184, .external_lex_state = 16},
  [5926] = {.lex_state = 200, .external_lex_state = 15},
  [5927] = {.lex_state = 200, .external_lex_state = 5},
  [5928] = {.lex_state = 200, .external_lex_state = 15},
  [5929] = {.lex_state = 77, .external_lex_state = 13},
  [5930] = {.lex_state = 200, .external_lex_state = 5},
  [5931] = {.lex_state = 184, .external_lex_state = 16},
  [5932] = {.lex_state = 200, .external_lex_state = 15},
  [5933] = {.lex_state = 184, .external_lex_state = 16},
  [5934] = {.lex_state = 200, .external_lex_state = 5},
  [5935] = {.lex_state = 81, .external_lex_state = 13},
  [5936] = {.lex_state = 184, .external_lex_state = 16},
  [5937] = {.lex_state = 184, .external_lex_state = 16},
  [5938] = {.lex_state = 200, .external_lex_state = 15},
  [5939] = {.lex_state = 184, .external_lex_state = 16},
  [5940] = {.lex_state = 81, .external_lex_state = 13},
  [5941] = {.lex_state = 200, .external_lex_state = 15},
  [5942] = {.lex_state = 200, .external_lex_state = 15},
  [5943] = {.lex_state = 184, .external_lex_state = 16},
  [5944] = {.lex_state = 200, .external_lex_state = 5},
  [5945] = {.lex_state = 200, .external_lex_state = 15},
  [5946] = {.lex_state = 200, .external_lex_state = 5},
  [5947] = {.lex_state = 77, .external_lex_state = 32},
  [5948] = {.lex_state = 77, .external_lex_state = 32},
  [5949] = {.lex_state = 77, .external_lex_state = 32},
  [5950] = {.lex_state = 77, .external_lex_state = 32},
  [5951] = {.lex_state = 122, .external_lex_state = 5},
  [5952] = {.lex_state = 81, .external_lex_state = 13},
  [5953] = {.lex_state = 123, .external_lex_state = 13},
  [5954] = {.lex_state = 184, .external_lex_state = 16},
  [5955] = {.lex_state = 200, .external_lex_state = 5},
  [5956] = {.lex_state = 184, .external_lex_state = 16},
  [5957] = {.lex_state = 113, .external_lex_state = 5},
  [5958] = {.lex_state = 184, .external_lex_state = 16},
  [5959] = {.lex_state = 81, .external_lex_state = 13},
  [5960] = {.lex_state = 123, .external_lex_state = 13},
  [5961] = {.lex_state = 200, .external_lex_state = 15},
  [5962] = {.lex_state = 190, .external_lex_state = 40},
  [5963] = {.lex_state = 200, .external_lex_state = 5},
  [5964] = {.lex_state = 184, .external_lex_state = 16},
  [5965] = {.lex_state = 77, .external_lex_state = 31},
  [5966] = {.lex_state = 200, .external_lex_state = 15},
  [5967] = {.lex_state = 200, .external_lex_state = 14},
  [5968] = {.lex_state = 200, .external_lex_state = 5},
  [5969] = {.lex_state = 200, .external_lex_state = 15},
  [5970] = {.lex_state = 184, .external_lex_state = 5},
  [5971] = {.lex_state = 184, .external_lex_state = 16},
  [5972] = {.lex_state = 200, .external_lex_state = 15},
  [5973] = {.lex_state = 200, .external_lex_state = 15},
  [5974] = {.lex_state = 125, .external_lex_state = 31},
  [5975] = {.lex_state = 200, .external_lex_state = 15},
  [5976] = {.lex_state = 75, .external_lex_state = 13},
  [5977] = {.lex_state = 75, .external_lex_state = 13},
  [5978] = {.lex_state = 205, .external_lex_state = 5},
  [5979] = {.lex_state = 75, .external_lex_state = 13},
  [5980] = {.lex_state = 184, .external_lex_state = 16},
  [5981] = {.lex_state = 200, .external_lex_state = 15},
  [5982] = {.lex_state = 200, .external_lex_state = 15},
  [5983] = {.lex_state = 200, .external_lex_state = 15},
  [5984] = {.lex_state = 81, .external_lex_state = 13},
  [5985] = {.lex_state = 184, .external_lex_state = 16},
  [5986] = {.lex_state = 200, .external_lex_state = 14},
  [5987] = {.lex_state = 184, .external_lex_state = 16},
  [5988] = {.lex_state = 210, .external_lex_state = 5},
  [5989] = {.lex_state = 210, .external_lex_state = 5},
  [5990] = {.lex_state = 184, .external_lex_state = 16},
  [5991] = {.lex_state = 75, .external_lex_state = 13},
  [5992] = {.lex_state = 184, .external_lex_state = 16},
  [5993] = {.lex_state = 200, .external_lex_state = 15},
  [5994] = {.lex_state = 202, .external_lex_state = 5},
  [5995] = {.lex_state = 200, .external_lex_state = 5},
  [5996] = {.lex_state = 184, .external_lex_state = 16},
  [5997] = {.lex_state = 210, .external_lex_state = 5},
  [5998] = {.lex_state = 75, .external_lex_state = 13},
  [5999] = {.lex_state = 184, .external_lex_state = 16},
  [6000] = {.lex_state = 200, .external_lex_state = 14},
  [6001] = {.lex_state = 115, .external_lex_state = 13},
  [6002] = {.lex_state = 75, .external_lex_state = 13},
  [6003] = {.lex_state = 200, .external_lex_state = 14},
  [6004] = {.lex_state = 200, .external_lex_state = 14},
  [6005] = {.lex_state = 210, .external_lex_state = 5},
  [6006] = {.lex_state = 122, .external_lex_state = 5},
  [6007] = {.lex_state = 184, .external_lex_state = 16},
  [6008] = {.lex_state = 75, .external_lex_state = 13},
  [6009] = {.lex_state = 184, .external_lex_state = 16},
  [6010] = {.lex_state = 200, .external_lex_state = 14},
  [6011] = {.lex_state = 120, .external_lex_state = 5},
  [6012] = {.lex_state = 122, .external_lex_state = 5},
  [6013] = {.lex_state = 123, .external_lex_state = 13},
  [6014] = {.lex_state = 200, .external_lex_state = 5},
  [6015] = {.lex_state = 184, .external_lex_state = 16},
  [6016] = {.lex_state = 200, .external_lex_state = 14},
  [6017] = {.lex_state = 123, .external_lex_state = 13},
  [6018] = {.lex_state = 75, .external_lex_state = 13},
  [6019] = {.lex_state = 184, .external_lex_state = 16},
  [6020] = {.lex_state = 184, .external_lex_state = 16},
  [6021] = {.lex_state = 200, .external_lex_state = 14},
  [6022] = {.lex_state = 75, .external_lex_state = 13},
  [6023] = {.lex_state = 210, .external_lex_state = 5},
  [6024] = {.lex_state = 184, .external_lex_state = 16},
  [6025] = {.lex_state = 200, .external_lex_state = 5},
  [6026] = {.lex_state = 184, .external_lex_state = 16},
  [6027] = {.lex_state = 87, .external_lex_state = 13},
  [6028] = {.lex_state = 210, .external_lex_state = 5},
  [6029] = {.lex_state = 200, .external_lex_state = 14},
  [6030] = {.lex_state = 210, .external_lex_state = 5},
  [6031] = {.lex_state = 210, .external_lex_state = 5},
  [6032] = {.lex_state = 210, .external_lex_state = 5},
  [6033] = {.lex_state = 184, .external_lex_state = 16},
  [6034] = {.lex_state = 210, .external_lex_state = 5},
  [6035] = {.lex_state = 184, .external_lex_state = 16},
  [6036] = {.lex_state = 200, .external_lex_state = 14},
  [6037] = {.lex_state = 184, .external_lex_state = 16},
  [6038] = {.lex_state = 75, .external_lex_state = 13},
  [6039] = {.lex_state = 200, .external_lex_state = 14},
  [6040] = {.lex_state = 115, .external_lex_state = 13},
  [6041] = {.lex_state = 184, .external_lex_state = 16},
  [6042] = {.lex_state = 115, .external_lex_state = 13},
  [6043] = {.lex_state = 75, .external_lex_state = 13},
  [6044] = {.lex_state = 75, .external_lex_state = 13},
  [6045] = {.lex_state = 184, .external_lex_state = 16},
  [6046] = {.lex_state = 200, .external_lex_state = 14},
  [6047] = {.lex_state = 200, .external_lex_state = 15},
  [6048] = {.lex_state = 77, .external_lex_state = 31},
  [6049] = {.lex_state = 200, .external_lex_state = 13},
  [6050] = {.lex_state = 200, .external_lex_state = 5},
  [6051] = {.lex_state = 75, .external_lex_state = 13},
  [6052] = {.lex_state = 184, .external_lex_state = 16},
  [6053] = {.lex_state = 200, .external_lex_state = 14},
  [6054] = {.lex_state = 200, .external_lex_state = 13},
  [6055] = {.lex_state = 200, .external_lex_state = 15},
  [6056] = {.lex_state = 123, .external_lex_state = 13},
  [6057] = {.lex_state = 200, .external_lex_state = 15},
  [6058] = {.lex_state = 200, .external_lex_state = 14},
  [6059] = {.lex_state = 200, .external_lex_state = 15},
  [6060] = {.lex_state = 123, .external_lex_state = 13},
  [6061] = {.lex_state = 200, .external_lex_state = 13},
  [6062] = {.lex_state = 184, .external_lex_state = 16},
  [6063] = {.lex_state = 115, .external_lex_state = 13},
  [6064] = {.lex_state = 200, .external_lex_state = 14},
  [6065] = {.lex_state = 75, .external_lex_state = 13},
  [6066] = {.lex_state = 200, .external_lex_state = 15},
  [6067] = {.lex_state = 200, .external_lex_state = 14},
  [6068] = {.lex_state = 200, .external_lex_state = 14},
  [6069] = {.lex_state = 200, .external_lex_state = 14},
  [6070] = {.lex_state = 200, .external_lex_state = 14},
  [6071] = {.lex_state = 200, .external_lex_state = 5},
  [6072] = {.lex_state = 200, .external_lex_state = 14},
  [6073] = {.lex_state = 128, .external_lex_state = 5},
  [6074] = {.lex_state = 200, .external_lex_state = 15},
  [6075] = {.lex_state = 200, .external_lex_state = 14},
  [6076] = {.lex_state = 184, .external_lex_state = 16},
  [6077] = {.lex_state = 184, .external_lex_state = 16},
  [6078] = {.lex_state = 200, .external_lex_state = 15},
  [6079] = {.lex_state = 183, .external_lex_state = 5},
  [6080] = {.lex_state = 184, .external_lex_state = 16},
  [6081] = {.lex_state = 75, .external_lex_state = 13},
  [6082] = {.lex_state = 86, .external_lex_state = 31},
  [6083] = {.lex_state = 200, .external_lex_state = 15},
  [6084] = {.lex_state = 184, .external_lex_state = 20},
  [6085] = {.lex_state = 200, .external_lex_state = 5},
  [6086] = {.lex_state = 200, .external_lex_state = 5},
  [6087] = {.lex_state = 184, .external_lex_state = 16},
  [6088] = {.lex_state = 184, .external_lex_state = 16},
  [6089] = {.lex_state = 184, .external_lex_state = 16},
  [6090] = {.lex_state = 123, .external_lex_state = 13},
  [6091] = {.lex_state = 200, .external_lex_state = 14},
  [6092] = {.lex_state = 184, .external_lex_state = 16},
  [6093] = {.lex_state = 200, .external_lex_state = 5},
  [6094] = {.lex_state = 125, .external_lex_state = 31},
  [6095] = {.lex_state = 184, .external_lex_state = 16},
  [6096] = {.lex_state = 200, .external_lex_state = 14},
  [6097] = {.lex_state = 200, .external_lex_state = 15},
  [6098] = {.lex_state = 200, .external_lex_state = 15},
  [6099] = {.lex_state = 200, .external_lex_state = 15},
  [6100] = {.lex_state = 200, .external_lex_state = 14},
  [6101] = {.lex_state = 200, .external_lex_state = 14},
  [6102] = {.lex_state = 200, .external_lex_state = 14},
  [6103] = {.lex_state = 77, .external_lex_state = 31},
  [6104] = {.lex_state = 200, .external_lex_state = 15},
  [6105] = {.lex_state = 184, .external_lex_state = 16},
  [6106] = {.lex_state = 77, .external_lex_state = 31},
  [6107] = {.lex_state = 200, .external_lex_state = 15},
  [6108] = {.lex_state = 75, .external_lex_state = 13},
  [6109] = {.lex_state = 81, .external_lex_state = 13},
  [6110] = {.lex_state = 184, .external_lex_state = 16},
  [6111] = {.lex_state = 128, .external_lex_state = 5},
  [6112] = {.lex_state = 200, .external_lex_state = 5},
  [6113] = {.lex_state = 200, .external_lex_state = 15},
  [6114] = {.lex_state = 210, .external_lex_state = 5},
  [6115] = {.lex_state = 200, .external_lex_state = 5},
  [6116] = {.lex_state = 75, .external_lex_state = 13},
  [6117] = {.lex_state = 184, .external_lex_state = 16},
  [6118] = {.lex_state = 200, .external_lex_state = 14},
  [6119] = {.lex_state = 200, .external_lex_state = 5},
  [6120] = {.lex_state = 184, .external_lex_state = 16},
  [6121] = {.lex_state = 200, .external_lex_state = 14},
  [6122] = {.lex_state = 75, .external_lex_state = 13},
  [6123] = {.lex_state = 200, .external_lex_state = 15},
  [6124] = {.lex_state = 200, .external_lex_state = 5},
  [6125] = {.lex_state = 210, .external_lex_state = 5},
  [6126] = {.lex_state = 184, .external_lex_state = 16},
  [6127] = {.lex_state = 75, .external_lex_state = 13},
  [6128] = {.lex_state = 210, .external_lex_state = 5},
  [6129] = {.lex_state = 200, .external_lex_state = 15},
  [6130] = {.lex_state = 75, .external_lex_state = 13},
  [6131] = {.lex_state = 184, .external_lex_state = 16},
  [6132] = {.lex_state = 200, .external_lex_state = 15},
  [6133] = {.lex_state = 200, .external_lex_state = 14},
  [6134] = {.lex_state = 184, .external_lex_state = 16},
  [6135] = {.lex_state = 184, .external_lex_state = 16},
  [6136] = {.lex_state = 200, .external_lex_state = 14},
  [6137] = {.lex_state = 125, .external_lex_state = 31},
  [6138] = {.lex_state = 184, .external_lex_state = 16},
  [6139] = {.lex_state = 200, .external_lex_state = 14},
  [6140] = {.lex_state = 210, .external_lex_state = 5},
  [6141] = {.lex_state = 184, .external_lex_state = 16},
  [6142] = {.lex_state = 128, .external_lex_state = 5},
  [6143] = {.lex_state = 210, .external_lex_state = 5},
  [6144] = {.lex_state = 200, .external_lex_state = 14},
  [6145] = {.lex_state = 75, .external_lex_state = 13},
  [6146] = {.lex_state = 184, .external_lex_state = 16},
  [6147] = {.lex_state = 205, .external_lex_state = 5},
  [6148] = {.lex_state = 75, .external_lex_state = 13},
  [6149] = {.lex_state = 200, .external_lex_state = 15},
  [6150] = {.lex_state = 75, .external_lex_state = 13},
  [6151] = {.lex_state = 75, .external_lex_state = 13},
  [6152] = {.lex_state = 184, .external_lex_state = 16},
  [6153] = {.lex_state = 75, .external_lex_state = 13},
  [6154] = {.lex_state = 184, .external_lex_state = 16},
  [6155] = {.lex_state = 75, .external_lex_state = 13},
  [6156] = {.lex_state = 200, .external_lex_state = 14},
  [6157] = {.lex_state = 184, .external_lex_state = 16},
  [6158] = {.lex_state = 184, .external_lex_state = 16},
  [6159] = {.lex_state = 85, .external_lex_state = 13},
  [6160] = {.lex_state = 200, .external_lex_state = 14},
  [6161] = {.lex_state = 86, .external_lex_state = 31},
  [6162] = {.lex_state = 200, .external_lex_state = 14},
  [6163] = {.lex_state = 200, .external_lex_state = 14},
  [6164] = {.lex_state = 184, .external_lex_state = 16},
  [6165] = {.lex_state = 75, .external_lex_state = 13},
  [6166] = {.lex_state = 200, .external_lex_state = 14},
  [6167] = {.lex_state = 210, .external_lex_state = 5},
  [6168] = {.lex_state = 200, .external_lex_state = 15},
  [6169] = {.lex_state = 200, .external_lex_state = 14},
  [6170] = {.lex_state = 86, .external_lex_state = 31},
  [6171] = {.lex_state = 200, .external_lex_state = 14},
  [6172] = {.lex_state = 184, .external_lex_state = 5},
  [6173] = {.lex_state = 200, .external_lex_state = 5},
  [6174] = {.lex_state = 200, .external_lex_state = 14},
  [6175] = {.lex_state = 75, .external_lex_state = 13},
  [6176] = {.lex_state = 75, .external_lex_state = 13},
  [6177] = {.lex_state = 184, .external_lex_state = 16},
  [6178] = {.lex_state = 200, .external_lex_state = 14},
  [6179] = {.lex_state = 200, .external_lex_state = 14},
  [6180] = {.lex_state = 184, .external_lex_state = 16},
  [6181] = {.lex_state = 184, .external_lex_state = 16},
  [6182] = {.lex_state = 200, .external_lex_state = 14},
  [6183] = {.lex_state = 75, .external_lex_state = 13},
  [6184] = {.lex_state = 75, .external_lex_state = 13},
  [6185] = {.lex_state = 200, .external_lex_state = 5},
  [6186] = {.lex_state = 75, .external_lex_state = 13},
  [6187] = {.lex_state = 200, .external_lex_state = 14},
  [6188] = {.lex_state = 75, .external_lex_state = 13},
  [6189] = {.lex_state = 75, .external_lex_state = 13},
  [6190] = {.lex_state = 184, .external_lex_state = 16},
  [6191] = {.lex_state = 184, .external_lex_state = 16},
  [6192] = {.lex_state = 75, .external_lex_state = 13},
  [6193] = {.lex_state = 200, .external_lex_state = 14},
  [6194] = {.lex_state = 200, .external_lex_state = 14},
  [6195] = {.lex_state = 75, .external_lex_state = 13},
  [6196] = {.lex_state = 200, .external_lex_state = 14},
  [6197] = {.lex_state = 200, .external_lex_state = 15},
  [6198] = {.lex_state = 75, .external_lex_state = 13},
  [6199] = {.lex_state = 200, .external_lex_state = 14},
  [6200] = {.lex_state = 75, .external_lex_state = 13},
  [6201] = {.lex_state = 200, .external_lex_state = 14},
  [6202] = {.lex_state = 184, .external_lex_state = 16},
  [6203] = {.lex_state = 200, .external_lex_state = 15},
  [6204] = {.lex_state = 75, .external_lex_state = 13},
  [6205] = {.lex_state = 200, .external_lex_state = 5},
  [6206] = {.lex_state = 200, .external_lex_state = 5},
  [6207] = {.lex_state = 184, .external_lex_state = 16},
  [6208] = {.lex_state = 184, .external_lex_state = 16},
  [6209] = {.lex_state = 200, .external_lex_state = 14},
  [6210] = {.lex_state = 200, .external_lex_state = 14},
  [6211] = {.lex_state = 200, .external_lex_state = 5},
  [6212] = {.lex_state = 200, .external_lex_state = 15},
  [6213] = {.lex_state = 184, .external_lex_state = 16},
  [6214] = {.lex_state = 81, .external_lex_state = 13},
  [6215] = {.lex_state = 184, .external_lex_state = 16},
  [6216] = {.lex_state = 200, .external_lex_state = 5},
  [6217] = {.lex_state = 200, .external_lex_state = 15},
  [6218] = {.lex_state = 200, .external_lex_state = 5},
  [6219] = {.lex_state = 200, .external_lex_state = 14},
  [6220] = {.lex_state = 200, .external_lex_state = 14},
  [6221] = {.lex_state = 123, .external_lex_state = 13},
  [6222] = {.lex_state = 204, .external_lex_state = 10},
  [6223] = {.lex_state = 77, .external_lex_state = 13},
  [6224] = {.lex_state = 95, .external_lex_state = 5},
  [6225] = {.lex_state = 77, .external_lex_state = 13},
  [6226] = {.lex_state = 183, .external_lex_state = 5},
  [6227] = {.lex_state = 86, .external_lex_state = 13},
  [6228] = {.lex_state = 183, .external_lex_state = 5},
  [6229] = {.lex_state = 77, .external_lex_state = 13},
  [6230] = {.lex_state = 183, .external_lex_state = 15},
  [6231] = {.lex_state = 184, .external_lex_state = 5},
  [6232] = {.lex_state = 86, .external_lex_state = 13},
  [6233] = {.lex_state = 86, .external_lex_state = 13},
  [6234] = {.lex_state = 86, .external_lex_state = 13},
  [6235] = {.lex_state = 83, .external_lex_state = 5},
  [6236] = {.lex_state = 86, .external_lex_state = 13},
  [6237] = {.lex_state = 83, .external_lex_state = 5},
  [6238] = {.lex_state = 116, .external_lex_state = 5},
  [6239] = {.lex_state = 183, .external_lex_state = 5},
  [6240] = {.lex_state = 0, .external_lex_state = 9},
  [6241] = {.lex_state = 86, .external_lex_state = 13},
  [6242] = {.lex_state = 77, .external_lex_state = 13},
  [6243] = {.lex_state = 204, .external_lex_state = 11},
  [6244] = {.lex_state = 83, .external_lex_state = 5},
  [6245] = {.lex_state = 86, .external_lex_state = 13},
  [6246] = {.lex_state = 83, .external_lex_state = 5},
  [6247] = {.lex_state = 86, .external_lex_state = 13},
  [6248] = {.lex_state = 83, .external_lex_state = 5},
  [6249] = {.lex_state = 86, .external_lex_state = 13},
  [6250] = {.lex_state = 183, .external_lex_state = 5},
  [6251] = {.lex_state = 116, .external_lex_state = 5},
  [6252] = {.lex_state = 183, .external_lex_state = 5},
  [6253] = {.lex_state = 22, .external_lex_state = 5},
  [6254] = {.lex_state = 205, .external_lex_state = 29},
  [6255] = {.lex_state = 184, .external_lex_state = 9},
  [6256] = {.lex_state = 183, .external_lex_state = 5},
  [6257] = {.lex_state = 184, .external_lex_state = 9},
  [6258] = {.lex_state = 125, .external_lex_state = 13},
  [6259] = {.lex_state = 184, .external_lex_state = 9},
  [6260] = {.lex_state = 77, .external_lex_state = 13},
  [6261] = {.lex_state = 77, .external_lex_state = 13},
  [6262] = {.lex_state = 77, .external_lex_state = 13},
  [6263] = {.lex_state = 123, .external_lex_state = 13},
  [6264] = {.lex_state = 77, .external_lex_state = 13},
  [6265] = {.lex_state = 183, .external_lex_state = 5},
  [6266] = {.lex_state = 77, .external_lex_state = 13},
  [6267] = {.lex_state = 82, .external_lex_state = 31},
  [6268] = {.lex_state = 116, .external_lex_state = 5},
  [6269] = {.lex_state = 125, .external_lex_state = 13},
  [6270] = {.lex_state = 96, .external_lex_state = 34},
  [6271] = {.lex_state = 125, .external_lex_state = 13},
  [6272] = {.lex_state = 96, .external_lex_state = 34},
  [6273] = {.lex_state = 183, .external_lex_state = 41},
  [6274] = {.lex_state = 125, .external_lex_state = 13},
  [6275] = {.lex_state = 125, .external_lex_state = 13},
  [6276] = {.lex_state = 183, .external_lex_state = 5},
  [6277] = {.lex_state = 77, .external_lex_state = 13},
  [6278] = {.lex_state = 125, .external_lex_state = 13},
  [6279] = {.lex_state = 0, .external_lex_state = 9},
  [6280] = {.lex_state = 89, .external_lex_state = 36},
  [6281] = {.lex_state = 123, .external_lex_state = 13},
  [6282] = {.lex_state = 77, .external_lex_state = 13},
  [6283] = {.lex_state = 82, .external_lex_state = 32},
  [6284] = {.lex_state = 123, .external_lex_state = 13},
  [6285] = {.lex_state = 183, .external_lex_state = 5},
  [6286] = {.lex_state = 93, .external_lex_state = 19},
  [6287] = {.lex_state = 77, .external_lex_state = 13},
  [6288] = {.lex_state = 77, .external_lex_state = 13},
  [6289] = {.lex_state = 77, .external_lex_state = 13},
  [6290] = {.lex_state = 77, .external_lex_state = 13},
  [6291] = {.lex_state = 77, .external_lex_state = 13},
  [6292] = {.lex_state = 183, .external_lex_state = 15},
  [6293] = {.lex_state = 183, .external_lex_state = 20},
  [6294] = {.lex_state = 123, .external_lex_state = 13},
  [6295] = {.lex_state = 77, .external_lex_state = 13},
  [6296] = {.lex_state = 113, .external_lex_state = 5},
  [6297] = {.lex_state = 83, .external_lex_state = 5},
  [6298] = {.lex_state = 77, .external_lex_state = 13},
  [6299] = {.lex_state = 0, .external_lex_state = 7},
  [6300] = {.lex_state = 183, .external_lex_state = 5},
  [6301] = {.lex_state = 183, .external_lex_state = 42},
  [6302] = {.lex_state = 77, .external_lex_state = 13},
  [6303] = {.lex_state = 77, .external_lex_state = 13},
  [6304] = {.lex_state = 82, .external_lex_state = 32},
  [6305] = {.lex_state = 88, .external_lex_state = 16},
  [6306] = {.lex_state = 77, .external_lex_state = 13},
  [6307] = {.lex_state = 77, .external_lex_state = 13},
  [6308] = {.lex_state = 77, .external_lex_state = 13},
  [6309] = {.lex_state = 77, .external_lex_state = 13},
  [6310] = {.lex_state = 77, .external_lex_state = 13},
  [6311] = {.lex_state = 77, .external_lex_state = 13},
  [6312] = {.lex_state = 77, .external_lex_state = 13},
  [6313] = {.lex_state = 94, .external_lex_state = 39},
  [6314] = {.lex_state = 0, .external_lex_state = 7},
  [6315] = {.lex_state = 183, .external_lex_state = 41},
  [6316] = {.lex_state = 89, .external_lex_state = 36},
  [6317] = {.lex_state = 0, .external_lex_state = 7},
  [6318] = {.lex_state = 88, .external_lex_state = 16},
  [6319] = {.lex_state = 77, .external_lex_state = 13},
  [6320] = {.lex_state = 77, .external_lex_state = 13},
  [6321] = {.lex_state = 82, .external_lex_state = 32},
  [6322] = {.lex_state = 77, .external_lex_state = 13},
  [6323] = {.lex_state = 77, .external_lex_state = 13},
  [6324] = {.lex_state = 77, .external_lex_state = 13},
  [6325] = {.lex_state = 86, .external_lex_state = 13},
  [6326] = {.lex_state = 86, .external_lex_state = 13},
  [6327] = {.lex_state = 77, .external_lex_state = 13},
  [6328] = {.lex_state = 86, .external_lex_state = 13},
  [6329] = {.lex_state = 77, .external_lex_state = 13},
  [6330] = {.lex_state = 77, .external_lex_state = 13},
  [6331] = {.lex_state = 93, .external_lex_state = 19},
  [6332] = {.lex_state = 86, .external_lex_state = 13},
  [6333] = {.lex_state = 77, .external_lex_state = 13},
  [6334] = {.lex_state = 77, .external_lex_state = 13},
  [6335] = {.lex_state = 184, .external_lex_state = 7},
  [6336] = {.lex_state = 183, .external_lex_state = 42},
  [6337] = {.lex_state = 86, .external_lex_state = 13},
  [6338] = {.lex_state = 116, .external_lex_state = 5},
  [6339] = {.lex_state = 184, .external_lex_state = 7},
  [6340] = {.lex_state = 183, .external_lex_state = 5},
  [6341] = {.lex_state = 82, .external_lex_state = 32},
  [6342] = {.lex_state = 191, .external_lex_state = 5},
  [6343] = {.lex_state = 95, .external_lex_state = 5},
  [6344] = {.lex_state = 77, .external_lex_state = 13},
  [6345] = {.lex_state = 122, .external_lex_state = 8},
  [6346] = {.lex_state = 183, .external_lex_state = 5},
  [6347] = {.lex_state = 94, .external_lex_state = 39},
  [6348] = {.lex_state = 184, .external_lex_state = 7},
  [6349] = {.lex_state = 77, .external_lex_state = 13},
  [6350] = {.lex_state = 86, .external_lex_state = 13},
  [6351] = {.lex_state = 86, .external_lex_state = 13},
  [6352] = {.lex_state = 86, .external_lex_state = 13},
  [6353] = {.lex_state = 86, .external_lex_state = 13},
  [6354] = {.lex_state = 183, .external_lex_state = 5},
  [6355] = {.lex_state = 82, .external_lex_state = 31},
  [6356] = {.lex_state = 82, .external_lex_state = 31},
  [6357] = {.lex_state = 122, .external_lex_state = 8},
  [6358] = {.lex_state = 82, .external_lex_state = 13},
  [6359] = {.lex_state = 77, .external_lex_state = 13},
  [6360] = {.lex_state = 123, .external_lex_state = 13},
  [6361] = {.lex_state = 191, .external_lex_state = 5},
  [6362] = {.lex_state = 82, .external_lex_state = 31},
  [6363] = {.lex_state = 82, .external_lex_state = 32},
  [6364] = {.lex_state = 123, .external_lex_state = 13},
  [6365] = {.lex_state = 77, .external_lex_state = 13},
  [6366] = {.lex_state = 77, .external_lex_state = 13},
  [6367] = {.lex_state = 77, .external_lex_state = 13},
  [6368] = {.lex_state = 77, .external_lex_state = 13},
  [6369] = {.lex_state = 82, .external_lex_state = 31},
  [6370] = {.lex_state = 123, .external_lex_state = 13},
  [6371] = {.lex_state = 86, .external_lex_state = 13},
  [6372] = {.lex_state = 77, .external_lex_state = 13},
  [6373] = {.lex_state = 77, .external_lex_state = 13},
  [6374] = {.lex_state = 77, .external_lex_state = 13},
  [6375] = {.lex_state = 77, .external_lex_state = 13},
  [6376] = {.lex_state = 77, .external_lex_state = 13},
  [6377] = {.lex_state = 183, .external_lex_state = 5},
  [6378] = {.lex_state = 77, .external_lex_state = 13},
  [6379] = {.lex_state = 77, .external_lex_state = 13},
  [6380] = {.lex_state = 77, .external_lex_state = 13},
  [6381] = {.lex_state = 77, .external_lex_state = 13},
  [6382] = {.lex_state = 0, .external_lex_state = 7},
  [6383] = {.lex_state = 77, .external_lex_state = 13},
  [6384] = {.lex_state = 77, .external_lex_state = 13},
  [6385] = {.lex_state = 205, .external_lex_state = 28},
  [6386] = {.lex_state = 77, .external_lex_state = 13},
  [6387] = {.lex_state = 77, .external_lex_state = 13},
  [6388] = {.lex_state = 183, .external_lex_state = 20},
  [6389] = {.lex_state = 123, .external_lex_state = 13},
  [6390] = {.lex_state = 77, .external_lex_state = 13},
  [6391] = {.lex_state = 204, .external_lex_state = 10},
  [6392] = {.lex_state = 125, .external_lex_state = 13},
  [6393] = {.lex_state = 82, .external_lex_state = 32},
  [6394] = {.lex_state = 82, .external_lex_state = 32},
  [6395] = {.lex_state = 82, .external_lex_state = 32},
  [6396] = {.lex_state = 82, .external_lex_state = 32},
  [6397] = {.lex_state = 204, .external_lex_state = 11},
  [6398] = {.lex_state = 94, .external_lex_state = 39},
  [6399] = {.lex_state = 96, .external_lex_state = 34},
  [6400] = {.lex_state = 205, .external_lex_state = 29},
  [6401] = {.lex_state = 183, .external_lex_state = 5},
  [6402] = {.lex_state = 89, .external_lex_state = 36},
  [6403] = {.lex_state = 205, .external_lex_state = 29},
  [6404] = {.lex_state = 77, .external_lex_state = 13},
  [6405] = {.lex_state = 205, .external_lex_state = 28},
  [6406] = {.lex_state = 77, .external_lex_state = 13},
  [6407] = {.lex_state = 205, .external_lex_state = 28},
  [6408] = {.lex_state = 77, .external_lex_state = 13},
  [6409] = {.lex_state = 183, .external_lex_state = 5},
  [6410] = {.lex_state = 205, .external_lex_state = 10},
  [6411] = {.lex_state = 183, .external_lex_state = 5},
  [6412] = {.lex_state = 183, .external_lex_state = 5},
  [6413] = {.lex_state = 82, .external_lex_state = 13},
  [6414] = {.lex_state = 82, .external_lex_state = 13},
  [6415] = {.lex_state = 82, .external_lex_state = 13},
  [6416] = {.lex_state = 87, .external_lex_state = 31},
  [6417] = {.lex_state = 205, .external_lex_state = 10},
  [6418] = {.lex_state = 87, .external_lex_state = 31},
  [6419] = {.lex_state = 96, .external_lex_state = 5},
  [6420] = {.lex_state = 205, .external_lex_state = 10},
  [6421] = {.lex_state = 183, .external_lex_state = 5},
  [6422] = {.lex_state = 205, .external_lex_state = 11},
  [6423] = {.lex_state = 183, .external_lex_state = 5},
  [6424] = {.lex_state = 205, .external_lex_state = 11},
  [6425] = {.lex_state = 94, .external_lex_state = 19},
  [6426] = {.lex_state = 183, .external_lex_state = 5},
  [6427] = {.lex_state = 183, .external_lex_state = 5},
  [6428] = {.lex_state = 205, .external_lex_state = 11},
  [6429] = {.lex_state = 87, .external_lex_state = 13},
  [6430] = {.lex_state = 209, .external_lex_state = 7},
  [6431] = {.lex_state = 205, .external_lex_state = 21},
  [6432] = {.lex_state = 205, .external_lex_state = 11},
  [6433] = {.lex_state = 205, .external_lex_state = 3},
  [6434] = {.lex_state = 205, .external_lex_state = 21},
  [6435] = {.lex_state = 209, .external_lex_state = 7},
  [6436] = {.lex_state = 82, .external_lex_state = 13},
  [6437] = {.lex_state = 183, .external_lex_state = 5},
  [6438] = {.lex_state = 89, .external_lex_state = 16},
  [6439] = {.lex_state = 205, .external_lex_state = 10},
  [6440] = {.lex_state = 205, .external_lex_state = 11},
  [6441] = {.lex_state = 183, .external_lex_state = 5},
  [6442] = {.lex_state = 205, .external_lex_state = 11},
  [6443] = {.lex_state = 183, .external_lex_state = 5},
  [6444] = {.lex_state = 183, .external_lex_state = 5},
  [6445] = {.lex_state = 89, .external_lex_state = 16},
  [6446] = {.lex_state = 183, .external_lex_state = 5},
  [6447] = {.lex_state = 183, .external_lex_state = 5},
  [6448] = {.lex_state = 205, .external_lex_state = 35},
  [6449] = {.lex_state = 183, .external_lex_state = 5},
  [6450] = {.lex_state = 82, .external_lex_state = 13},
  [6451] = {.lex_state = 94, .external_lex_state = 19},
  [6452] = {.lex_state = 205, .external_lex_state = 35},
  [6453] = {.lex_state = 183, .external_lex_state = 5},
  [6454] = {.lex_state = 183, .external_lex_state = 5},
  [6455] = {.lex_state = 183, .external_lex_state = 5},
  [6456] = {.lex_state = 183, .external_lex_state = 21},
  [6457] = {.lex_state = 183, .external_lex_state = 5},
  [6458] = {.lex_state = 82, .external_lex_state = 13},
  [6459] = {.lex_state = 205, .external_lex_state = 21},
  [6460] = {.lex_state = 204, .external_lex_state = 15},
  [6461] = {.lex_state = 183, .external_lex_state = 5},
  [6462] = {.lex_state = 183, .external_lex_state = 5},
  [6463] = {.lex_state = 82, .external_lex_state = 13},
  [6464] = {.lex_state = 82, .external_lex_state = 13},
  [6465] = {.lex_state = 200, .external_lex_state = 5},
  [6466] = {.lex_state = 200, .external_lex_state = 5},
  [6467] = {.lex_state = 183, .external_lex_state = 5},
  [6468] = {.lex_state = 209, .external_lex_state = 8},
  [6469] = {.lex_state = 183, .external_lex_state = 5},
  [6470] = {.lex_state = 96, .external_lex_state = 5},
  [6471] = {.lex_state = 94, .external_lex_state = 19},
  [6472] = {.lex_state = 94, .external_lex_state = 19},
  [6473] = {.lex_state = 183, .external_lex_state = 21},
  [6474] = {.lex_state = 209, .external_lex_state = 8},
  [6475] = {.lex_state = 200, .external_lex_state = 5},
  [6476] = {.lex_state = 94, .external_lex_state = 19},
  [6477] = {.lex_state = 94, .external_lex_state = 19},
  [6478] = {.lex_state = 205, .external_lex_state = 10},
  [6479] = {.lex_state = 205, .external_lex_state = 10},
  [6480] = {.lex_state = 82, .external_lex_state = 13},
  [6481] = {.lex_state = 205, .external_lex_state = 11},
  [6482] = {.lex_state = 183, .external_lex_state = 5},
  [6483] = {.lex_state = 89, .external_lex_state = 16},
  [6484] = {.lex_state = 82, .external_lex_state = 13},
  [6485] = {.lex_state = 190, .external_lex_state = 3},
  [6486] = {.lex_state = 183, .external_lex_state = 21},
  [6487] = {.lex_state = 82, .external_lex_state = 13},
  [6488] = {.lex_state = 183, .external_lex_state = 5},
  [6489] = {.lex_state = 87, .external_lex_state = 31},
  [6490] = {.lex_state = 183, .external_lex_state = 5},
  [6491] = {.lex_state = 183, .external_lex_state = 15},
  [6492] = {.lex_state = 183, .external_lex_state = 5},
  [6493] = {.lex_state = 183, .external_lex_state = 5},
  [6494] = {.lex_state = 82, .external_lex_state = 13},
  [6495] = {.lex_state = 183, .external_lex_state = 5},
  [6496] = {.lex_state = 183, .external_lex_state = 5},
  [6497] = {.lex_state = 183, .external_lex_state = 5},
  [6498] = {.lex_state = 82, .external_lex_state = 13},
  [6499] = {.lex_state = 86, .external_lex_state = 34},
  [6500] = {.lex_state = 183, .external_lex_state = 5},
  [6501] = {.lex_state = 98, .external_lex_state = 34},
  [6502] = {.lex_state = 97, .external_lex_state = 5},
  [6503] = {.lex_state = 82, .external_lex_state = 13},
  [6504] = {.lex_state = 89, .external_lex_state = 16},
  [6505] = {.lex_state = 199, .external_lex_state = 5},
  [6506] = {.lex_state = 82, .external_lex_state = 13},
  [6507] = {.lex_state = 183, .external_lex_state = 5},
  [6508] = {.lex_state = 183, .external_lex_state = 5},
  [6509] = {.lex_state = 89, .external_lex_state = 16},
  [6510] = {.lex_state = 184, .external_lex_state = 5},
  [6511] = {.lex_state = 183, .external_lex_state = 5},
  [6512] = {.lex_state = 89, .external_lex_state = 16},
  [6513] = {.lex_state = 184, .external_lex_state = 5},
  [6514] = {.lex_state = 83, .external_lex_state = 5},
  [6515] = {.lex_state = 89, .external_lex_state = 16},
  [6516] = {.lex_state = 82, .external_lex_state = 13},
  [6517] = {.lex_state = 205, .external_lex_state = 10},
  [6518] = {.lex_state = 87, .external_lex_state = 13},
  [6519] = {.lex_state = 183, .external_lex_state = 5},
  [6520] = {.lex_state = 183, .external_lex_state = 5},
  [6521] = {.lex_state = 89, .external_lex_state = 16},
  [6522] = {.lex_state = 183, .external_lex_state = 5},
  [6523] = {.lex_state = 89, .external_lex_state = 16},
  [6524] = {.lex_state = 89, .external_lex_state = 16},
  [6525] = {.lex_state = 82, .external_lex_state = 13},
  [6526] = {.lex_state = 96, .external_lex_state = 5},
  [6527] = {.lex_state = 183, .external_lex_state = 5},
  [6528] = {.lex_state = 96, .external_lex_state = 5},
  [6529] = {.lex_state = 97, .external_lex_state = 5},
  [6530] = {.lex_state = 94, .external_lex_state = 19},
  [6531] = {.lex_state = 82, .external_lex_state = 13},
  [6532] = {.lex_state = 82, .external_lex_state = 13},
  [6533] = {.lex_state = 183, .external_lex_state = 5},
  [6534] = {.lex_state = 183, .external_lex_state = 5},
  [6535] = {.lex_state = 82, .external_lex_state = 13},
  [6536] = {.lex_state = 183, .external_lex_state = 5},
  [6537] = {.lex_state = 94, .external_lex_state = 19},
  [6538] = {.lex_state = 82, .external_lex_state = 13},
  [6539] = {.lex_state = 190, .external_lex_state = 3},
  [6540] = {.lex_state = 205, .external_lex_state = 10},
  [6541] = {.lex_state = 183, .external_lex_state = 5},
  [6542] = {.lex_state = 96, .external_lex_state = 5},
  [6543] = {.lex_state = 183, .external_lex_state = 5},
  [6544] = {.lex_state = 205, .external_lex_state = 10},
  [6545] = {.lex_state = 82, .external_lex_state = 13},
  [6546] = {.lex_state = 87, .external_lex_state = 32},
  [6547] = {.lex_state = 94, .external_lex_state = 19},
  [6548] = {.lex_state = 183, .external_lex_state = 5},
  [6549] = {.lex_state = 82, .external_lex_state = 13},
  [6550] = {.lex_state = 82, .external_lex_state = 13},
  [6551] = {.lex_state = 190, .external_lex_state = 3},
  [6552] = {.lex_state = 82, .external_lex_state = 13},
  [6553] = {.lex_state = 87, .external_lex_state = 13},
  [6554] = {.lex_state = 96, .external_lex_state = 5},
  [6555] = {.lex_state = 183, .external_lex_state = 5},
  [6556] = {.lex_state = 205, .external_lex_state = 10},
  [6557] = {.lex_state = 205, .external_lex_state = 11},
  [6558] = {.lex_state = 86, .external_lex_state = 34},
  [6559] = {.lex_state = 205, .external_lex_state = 10},
  [6560] = {.lex_state = 96, .external_lex_state = 5},
  [6561] = {.lex_state = 183, .external_lex_state = 5},
  [6562] = {.lex_state = 96, .external_lex_state = 5},
  [6563] = {.lex_state = 87, .external_lex_state = 32},
  [6564] = {.lex_state = 96, .external_lex_state = 5},
  [6565] = {.lex_state = 82, .external_lex_state = 13},
  [6566] = {.lex_state = 82, .external_lex_state = 13},
  [6567] = {.lex_state = 96, .external_lex_state = 5},
  [6568] = {.lex_state = 205, .external_lex_state = 10},
  [6569] = {.lex_state = 83, .external_lex_state = 5},
  [6570] = {.lex_state = 82, .external_lex_state = 13},
  [6571] = {.lex_state = 87, .external_lex_state = 32},
  [6572] = {.lex_state = 82, .external_lex_state = 13},
  [6573] = {.lex_state = 183, .external_lex_state = 5},
  [6574] = {.lex_state = 96, .external_lex_state = 5},
  [6575] = {.lex_state = 87, .external_lex_state = 32},
  [6576] = {.lex_state = 96, .external_lex_state = 5},
  [6577] = {.lex_state = 96, .external_lex_state = 5},
  [6578] = {.lex_state = 82, .external_lex_state = 13},
  [6579] = {.lex_state = 94, .external_lex_state = 19},
  [6580] = {.lex_state = 94, .external_lex_state = 19},
  [6581] = {.lex_state = 183, .external_lex_state = 5},
  [6582] = {.lex_state = 183, .external_lex_state = 5},
  [6583] = {.lex_state = 96, .external_lex_state = 5},
  [6584] = {.lex_state = 183, .external_lex_state = 5},
  [6585] = {.lex_state = 183, .external_lex_state = 5},
  [6586] = {.lex_state = 89, .external_lex_state = 16},
  [6587] = {.lex_state = 85, .external_lex_state = 5},
  [6588] = {.lex_state = 183, .external_lex_state = 5},
  [6589] = {.lex_state = 183, .external_lex_state = 5},
  [6590] = {.lex_state = 82, .external_lex_state = 13},
  [6591] = {.lex_state = 96, .external_lex_state = 5},
  [6592] = {.lex_state = 94, .external_lex_state = 19},
  [6593] = {.lex_state = 183, .external_lex_state = 5},
  [6594] = {.lex_state = 183, .external_lex_state = 5},
  [6595] = {.lex_state = 205, .external_lex_state = 10},
  [6596] = {.lex_state = 82, .external_lex_state = 13},
  [6597] = {.lex_state = 183, .external_lex_state = 5},
  [6598] = {.lex_state = 83, .external_lex_state = 5},
  [6599] = {.lex_state = 205, .external_lex_state = 10},
  [6600] = {.lex_state = 183, .external_lex_state = 5},
  [6601] = {.lex_state = 87, .external_lex_state = 32},
  [6602] = {.lex_state = 82, .external_lex_state = 13},
  [6603] = {.lex_state = 94, .external_lex_state = 19},
  [6604] = {.lex_state = 183, .external_lex_state = 35},
  [6605] = {.lex_state = 94, .external_lex_state = 19},
  [6606] = {.lex_state = 183, .external_lex_state = 5},
  [6607] = {.lex_state = 183, .external_lex_state = 5},
  [6608] = {.lex_state = 183, .external_lex_state = 5},
  [6609] = {.lex_state = 82, .external_lex_state = 13},
  [6610] = {.lex_state = 82, .external_lex_state = 13},
  [6611] = {.lex_state = 205, .external_lex_state = 10},
  [6612] = {.lex_state = 183, .external_lex_state = 5},
  [6613] = {.lex_state = 87, .external_lex_state = 32},
  [6614] = {.lex_state = 183, .external_lex_state = 5},
  [6615] = {.lex_state = 205, .external_lex_state = 35},
  [6616] = {.lex_state = 183, .external_lex_state = 5},
  [6617] = {.lex_state = 183, .external_lex_state = 5},
  [6618] = {.lex_state = 183, .external_lex_state = 5},
  [6619] = {.lex_state = 94, .external_lex_state = 19},
  [6620] = {.lex_state = 98, .external_lex_state = 34},
  [6621] = {.lex_state = 87, .external_lex_state = 32},
  [6622] = {.lex_state = 183, .external_lex_state = 5},
  [6623] = {.lex_state = 183, .external_lex_state = 5},
  [6624] = {.lex_state = 89, .external_lex_state = 16},
  [6625] = {.lex_state = 205, .external_lex_state = 11},
  [6626] = {.lex_state = 96, .external_lex_state = 5},
  [6627] = {.lex_state = 204, .external_lex_state = 20},
  [6628] = {.lex_state = 82, .external_lex_state = 13},
  [6629] = {.lex_state = 89, .external_lex_state = 16},
  [6630] = {.lex_state = 183, .external_lex_state = 5},
  [6631] = {.lex_state = 82, .external_lex_state = 13},
  [6632] = {.lex_state = 94, .external_lex_state = 19},
  [6633] = {.lex_state = 94, .external_lex_state = 19},
  [6634] = {.lex_state = 94, .external_lex_state = 19},
  [6635] = {.lex_state = 181, .external_lex_state = 13},
  [6636] = {.lex_state = 205, .external_lex_state = 10},
  [6637] = {.lex_state = 183, .external_lex_state = 5},
  [6638] = {.lex_state = 82, .external_lex_state = 13},
  [6639] = {.lex_state = 205, .external_lex_state = 11},
  [6640] = {.lex_state = 205, .external_lex_state = 10},
  [6641] = {.lex_state = 183, .external_lex_state = 5},
  [6642] = {.lex_state = 183, .external_lex_state = 5},
  [6643] = {.lex_state = 82, .external_lex_state = 13},
  [6644] = {.lex_state = 82, .external_lex_state = 13},
  [6645] = {.lex_state = 82, .external_lex_state = 13},
  [6646] = {.lex_state = 89, .external_lex_state = 16},
  [6647] = {.lex_state = 205, .external_lex_state = 11},
  [6648] = {.lex_state = 205, .external_lex_state = 11},
  [6649] = {.lex_state = 87, .external_lex_state = 32},
  [6650] = {.lex_state = 183, .external_lex_state = 5},
  [6651] = {.lex_state = 205, .external_lex_state = 11},
  [6652] = {.lex_state = 82, .external_lex_state = 13},
  [6653] = {.lex_state = 183, .external_lex_state = 5},
  [6654] = {.lex_state = 82, .external_lex_state = 13},
  [6655] = {.lex_state = 82, .external_lex_state = 13},
  [6656] = {.lex_state = 82, .external_lex_state = 13},
  [6657] = {.lex_state = 82, .external_lex_state = 13},
  [6658] = {.lex_state = 82, .external_lex_state = 13},
  [6659] = {.lex_state = 89, .external_lex_state = 16},
  [6660] = {.lex_state = 183, .external_lex_state = 5},
  [6661] = {.lex_state = 82, .external_lex_state = 13},
  [6662] = {.lex_state = 83, .external_lex_state = 5},
  [6663] = {.lex_state = 82, .external_lex_state = 13},
  [6664] = {.lex_state = 82, .external_lex_state = 13},
  [6665] = {.lex_state = 82, .external_lex_state = 13},
  [6666] = {.lex_state = 209, .external_lex_state = 9},
  [6667] = {.lex_state = 82, .external_lex_state = 13},
  [6668] = {.lex_state = 82, .external_lex_state = 13},
  [6669] = {.lex_state = 183, .external_lex_state = 5},
  [6670] = {.lex_state = 82, .external_lex_state = 13},
  [6671] = {.lex_state = 83, .external_lex_state = 5},
  [6672] = {.lex_state = 89, .external_lex_state = 16},
  [6673] = {.lex_state = 205, .external_lex_state = 11},
  [6674] = {.lex_state = 183, .external_lex_state = 5},
  [6675] = {.lex_state = 183, .external_lex_state = 5},
  [6676] = {.lex_state = 183, .external_lex_state = 5},
  [6677] = {.lex_state = 83, .external_lex_state = 5},
  [6678] = {.lex_state = 83, .external_lex_state = 5},
  [6679] = {.lex_state = 205, .external_lex_state = 11},
  [6680] = {.lex_state = 205, .external_lex_state = 10},
  [6681] = {.lex_state = 89, .external_lex_state = 16},
  [6682] = {.lex_state = 183, .external_lex_state = 5},
  [6683] = {.lex_state = 82, .external_lex_state = 13},
  [6684] = {.lex_state = 83, .external_lex_state = 5},
  [6685] = {.lex_state = 83, .external_lex_state = 5},
  [6686] = {.lex_state = 199, .external_lex_state = 5},
  [6687] = {.lex_state = 96, .external_lex_state = 5},
  [6688] = {.lex_state = 82, .external_lex_state = 13},
  [6689] = {.lex_state = 183, .external_lex_state = 5},
  [6690] = {.lex_state = 183, .external_lex_state = 5},
  [6691] = {.lex_state = 183, .external_lex_state = 5},
  [6692] = {.lex_state = 183, .external_lex_state = 5},
  [6693] = {.lex_state = 183, .external_lex_state = 5},
  [6694] = {.lex_state = 82, .external_lex_state = 13},
  [6695] = {.lex_state = 205, .external_lex_state = 11},
  [6696] = {.lex_state = 183, .external_lex_state = 35},
  [6697] = {.lex_state = 183, .external_lex_state = 5},
  [6698] = {.lex_state = 183, .external_lex_state = 5},
  [6699] = {.lex_state = 87, .external_lex_state = 31},
  [6700] = {.lex_state = 183, .external_lex_state = 5},
  [6701] = {.lex_state = 96, .external_lex_state = 5},
  [6702] = {.lex_state = 183, .external_lex_state = 35},
  [6703] = {.lex_state = 183, .external_lex_state = 5},
  [6704] = {.lex_state = 183, .external_lex_state = 5},
  [6705] = {.lex_state = 205, .external_lex_state = 11},
  [6706] = {.lex_state = 96, .external_lex_state = 5},
  [6707] = {.lex_state = 89, .external_lex_state = 16},
  [6708] = {.lex_state = 82, .external_lex_state = 13},
  [6709] = {.lex_state = 94, .external_lex_state = 19},
  [6710] = {.lex_state = 205, .external_lex_state = 10},
  [6711] = {.lex_state = 89, .external_lex_state = 16},
  [6712] = {.lex_state = 82, .external_lex_state = 13},
  [6713] = {.lex_state = 183, .external_lex_state = 20},
  [6714] = {.lex_state = 183, .external_lex_state = 5},
  [6715] = {.lex_state = 205, .external_lex_state = 11},
  [6716] = {.lex_state = 183, .external_lex_state = 5},
  [6717] = {.lex_state = 87, .external_lex_state = 32},
  [6718] = {.lex_state = 183, .external_lex_state = 5},
  [6719] = {.lex_state = 82, .external_lex_state = 13},
  [6720] = {.lex_state = 183, .external_lex_state = 5},
  [6721] = {.lex_state = 82, .external_lex_state = 13},
  [6722] = {.lex_state = 204, .external_lex_state = 20},
  [6723] = {.lex_state = 87, .external_lex_state = 31},
  [6724] = {.lex_state = 86, .external_lex_state = 34},
  [6725] = {.lex_state = 205, .external_lex_state = 11},
  [6726] = {.lex_state = 183, .external_lex_state = 5},
  [6727] = {.lex_state = 98, .external_lex_state = 34},
  [6728] = {.lex_state = 209, .external_lex_state = 9},
  [6729] = {.lex_state = 204, .external_lex_state = 15},
  [6730] = {.lex_state = 87, .external_lex_state = 13},
  [6731] = {.lex_state = 98, .external_lex_state = 5},
  [6732] = {.lex_state = 205, .external_lex_state = 15},
  [6733] = {.lex_state = 205, .external_lex_state = 15},
  [6734] = {.lex_state = 205, .external_lex_state = 15},
  [6735] = {.lex_state = 107, .external_lex_state = 16},
  [6736] = {.lex_state = 87, .external_lex_state = 13},
  [6737] = {.lex_state = 205, .external_lex_state = 15},
  [6738] = {.lex_state = 210, .external_lex_state = 11},
  [6739] = {.lex_state = 84, .external_lex_state = 34},
  [6740] = {.lex_state = 205, .external_lex_state = 15},
  [6741] = {.lex_state = 205, .external_lex_state = 15},
  [6742] = {.lex_state = 98, .external_lex_state = 5},
  [6743] = {.lex_state = 205, .external_lex_state = 15},
  [6744] = {.lex_state = 87, .external_lex_state = 13},
  [6745] = {.lex_state = 98, .external_lex_state = 5},
  [6746] = {.lex_state = 87, .external_lex_state = 13},
  [6747] = {.lex_state = 205, .external_lex_state = 15},
  [6748] = {.lex_state = 209, .external_lex_state = 19},
  [6749] = {.lex_state = 205, .external_lex_state = 15},
  [6750] = {.lex_state = 205, .external_lex_state = 15},
  [6751] = {.lex_state = 84, .external_lex_state = 4},
  [6752] = {.lex_state = 84, .external_lex_state = 4},
  [6753] = {.lex_state = 87, .external_lex_state = 13},
  [6754] = {.lex_state = 87, .external_lex_state = 13},
  [6755] = {.lex_state = 0, .external_lex_state = 42},
  [6756] = {.lex_state = 84, .external_lex_state = 4},
  [6757] = {.lex_state = 84, .external_lex_state = 4},
  [6758] = {.lex_state = 205, .external_lex_state = 15},
  [6759] = {.lex_state = 84, .external_lex_state = 4},
  [6760] = {.lex_state = 84, .external_lex_state = 4},
  [6761] = {.lex_state = 84, .external_lex_state = 4},
  [6762] = {.lex_state = 87, .external_lex_state = 13},
  [6763] = {.lex_state = 87, .external_lex_state = 13},
  [6764] = {.lex_state = 205, .external_lex_state = 20},
  [6765] = {.lex_state = 84, .external_lex_state = 4},
  [6766] = {.lex_state = 84, .external_lex_state = 4},
  [6767] = {.lex_state = 183, .external_lex_state = 41},
  [6768] = {.lex_state = 181, .external_lex_state = 16},
  [6769] = {.lex_state = 0, .external_lex_state = 42},
  [6770] = {.lex_state = 183, .external_lex_state = 5},
  [6771] = {.lex_state = 86, .external_lex_state = 5},
  [6772] = {.lex_state = 183, .external_lex_state = 5},
  [6773] = {.lex_state = 199, .external_lex_state = 3},
  [6774] = {.lex_state = 87, .external_lex_state = 13},
  [6775] = {.lex_state = 87, .external_lex_state = 13},
  [6776] = {.lex_state = 183, .external_lex_state = 15},
  [6777] = {.lex_state = 181, .external_lex_state = 16},
  [6778] = {.lex_state = 181, .external_lex_state = 16},
  [6779] = {.lex_state = 87, .external_lex_state = 13},
  [6780] = {.lex_state = 181, .external_lex_state = 16},
  [6781] = {.lex_state = 181, .external_lex_state = 16},
  [6782] = {.lex_state = 87, .external_lex_state = 13},
  [6783] = {.lex_state = 181, .external_lex_state = 16},
  [6784] = {.lex_state = 205, .external_lex_state = 15},
  [6785] = {.lex_state = 87, .external_lex_state = 13},
  [6786] = {.lex_state = 181, .external_lex_state = 5},
  [6787] = {.lex_state = 87, .external_lex_state = 13},
  [6788] = {.lex_state = 86, .external_lex_state = 5},
  [6789] = {.lex_state = 86, .external_lex_state = 5},
  [6790] = {.lex_state = 87, .external_lex_state = 13},
  [6791] = {.lex_state = 205, .external_lex_state = 20},
  [6792] = {.lex_state = 205, .external_lex_state = 5},
  [6793] = {.lex_state = 184, .external_lex_state = 5},
  [6794] = {.lex_state = 87, .external_lex_state = 13},
  [6795] = {.lex_state = 183, .external_lex_state = 5},
  [6796] = {.lex_state = 210, .external_lex_state = 13},
  [6797] = {.lex_state = 183, .external_lex_state = 5},
  [6798] = {.lex_state = 205, .external_lex_state = 20},
  [6799] = {.lex_state = 86, .external_lex_state = 5},
  [6800] = {.lex_state = 210, .external_lex_state = 10},
  [6801] = {.lex_state = 84, .external_lex_state = 5},
  [6802] = {.lex_state = 205, .external_lex_state = 20},
  [6803] = {.lex_state = 87, .external_lex_state = 13},
  [6804] = {.lex_state = 87, .external_lex_state = 13},
  [6805] = {.lex_state = 87, .external_lex_state = 13},
  [6806] = {.lex_state = 87, .external_lex_state = 13},
  [6807] = {.lex_state = 183, .external_lex_state = 5},
  [6808] = {.lex_state = 87, .external_lex_state = 13},
  [6809] = {.lex_state = 183, .external_lex_state = 42},
  [6810] = {.lex_state = 87, .external_lex_state = 13},
  [6811] = {.lex_state = 87, .external_lex_state = 13},
  [6812] = {.lex_state = 205, .external_lex_state = 20},
  [6813] = {.lex_state = 87, .external_lex_state = 13},
  [6814] = {.lex_state = 205, .external_lex_state = 20},
  [6815] = {.lex_state = 87, .external_lex_state = 13},
  [6816] = {.lex_state = 209, .external_lex_state = 19},
  [6817] = {.lex_state = 199, .external_lex_state = 5},
  [6818] = {.lex_state = 84, .external_lex_state = 34},
  [6819] = {.lex_state = 86, .external_lex_state = 5},
  [6820] = {.lex_state = 199, .external_lex_state = 5},
  [6821] = {.lex_state = 183, .external_lex_state = 15},
  [6822] = {.lex_state = 205, .external_lex_state = 15},
  [6823] = {.lex_state = 0, .external_lex_state = 42},
  [6824] = {.lex_state = 86, .external_lex_state = 5},
  [6825] = {.lex_state = 84, .external_lex_state = 34},
  [6826] = {.lex_state = 183, .external_lex_state = 5},
  [6827] = {.lex_state = 87, .external_lex_state = 13},
  [6828] = {.lex_state = 108, .external_lex_state = 36},
  [6829] = {.lex_state = 103, .external_lex_state = 5},
  [6830] = {.lex_state = 86, .external_lex_state = 5},
  [6831] = {.lex_state = 86, .external_lex_state = 5},
  [6832] = {.lex_state = 108, .external_lex_state = 36},
  [6833] = {.lex_state = 87, .external_lex_state = 13},
  [6834] = {.lex_state = 86, .external_lex_state = 5},
  [6835] = {.lex_state = 86, .external_lex_state = 5},
  [6836] = {.lex_state = 87, .external_lex_state = 13},
  [6837] = {.lex_state = 86, .external_lex_state = 5},
  [6838] = {.lex_state = 86, .external_lex_state = 5},
  [6839] = {.lex_state = 87, .external_lex_state = 13},
  [6840] = {.lex_state = 205, .external_lex_state = 15},
  [6841] = {.lex_state = 98, .external_lex_state = 5},
  [6842] = {.lex_state = 87, .external_lex_state = 13},
  [6843] = {.lex_state = 86, .external_lex_state = 5},
  [6844] = {.lex_state = 183, .external_lex_state = 5},
  [6845] = {.lex_state = 199, .external_lex_state = 5},
  [6846] = {.lex_state = 98, .external_lex_state = 5},
  [6847] = {.lex_state = 0, .external_lex_state = 41},
  [6848] = {.lex_state = 98, .external_lex_state = 5},
  [6849] = {.lex_state = 183, .external_lex_state = 20},
  [6850] = {.lex_state = 87, .external_lex_state = 13},
  [6851] = {.lex_state = 104, .external_lex_state = 34},
  [6852] = {.lex_state = 199, .external_lex_state = 5},
  [6853] = {.lex_state = 183, .external_lex_state = 20},
  [6854] = {.lex_state = 181, .external_lex_state = 5},
  [6855] = {.lex_state = 86, .external_lex_state = 5},
  [6856] = {.lex_state = 210, .external_lex_state = 13},
  [6857] = {.lex_state = 86, .external_lex_state = 5},
  [6858] = {.lex_state = 98, .external_lex_state = 5},
  [6859] = {.lex_state = 210, .external_lex_state = 10},
  [6860] = {.lex_state = 87, .external_lex_state = 13},
  [6861] = {.lex_state = 98, .external_lex_state = 5},
  [6862] = {.lex_state = 205, .external_lex_state = 20},
  [6863] = {.lex_state = 107, .external_lex_state = 16},
  [6864] = {.lex_state = 98, .external_lex_state = 5},
  [6865] = {.lex_state = 98, .external_lex_state = 5},
  [6866] = {.lex_state = 181, .external_lex_state = 16},
  [6867] = {.lex_state = 87, .external_lex_state = 13},
  [6868] = {.lex_state = 181, .external_lex_state = 16},
  [6869] = {.lex_state = 87, .external_lex_state = 13},
  [6870] = {.lex_state = 87, .external_lex_state = 13},
  [6871] = {.lex_state = 98, .external_lex_state = 5},
  [6872] = {.lex_state = 98, .external_lex_state = 5},
  [6873] = {.lex_state = 87, .external_lex_state = 13},
  [6874] = {.lex_state = 98, .external_lex_state = 5},
  [6875] = {.lex_state = 205, .external_lex_state = 15},
  [6876] = {.lex_state = 87, .external_lex_state = 13},
  [6877] = {.lex_state = 87, .external_lex_state = 13},
  [6878] = {.lex_state = 87, .external_lex_state = 13},
  [6879] = {.lex_state = 103, .external_lex_state = 5},
  [6880] = {.lex_state = 0, .external_lex_state = 41},
  [6881] = {.lex_state = 183, .external_lex_state = 5},
  [6882] = {.lex_state = 184, .external_lex_state = 5},
  [6883] = {.lex_state = 104, .external_lex_state = 34},
  [6884] = {.lex_state = 98, .external_lex_state = 5},
  [6885] = {.lex_state = 210, .external_lex_state = 5},
  [6886] = {.lex_state = 86, .external_lex_state = 5},
  [6887] = {.lex_state = 104, .external_lex_state = 34},
  [6888] = {.lex_state = 87, .external_lex_state = 13},
  [6889] = {.lex_state = 210, .external_lex_state = 11},
  [6890] = {.lex_state = 86, .external_lex_state = 5},
  [6891] = {.lex_state = 205, .external_lex_state = 20},
  [6892] = {.lex_state = 86, .external_lex_state = 5},
  [6893] = {.lex_state = 205, .external_lex_state = 20},
  [6894] = {.lex_state = 205, .external_lex_state = 20},
  [6895] = {.lex_state = 205, .external_lex_state = 20},
  [6896] = {.lex_state = 98, .external_lex_state = 5},
  [6897] = {.lex_state = 86, .external_lex_state = 5},
  [6898] = {.lex_state = 205, .external_lex_state = 20},
  [6899] = {.lex_state = 205, .external_lex_state = 20},
  [6900] = {.lex_state = 205, .external_lex_state = 20},
  [6901] = {.lex_state = 205, .external_lex_state = 20},
  [6902] = {.lex_state = 199, .external_lex_state = 5},
  [6903] = {.lex_state = 205, .external_lex_state = 20},
  [6904] = {.lex_state = 84, .external_lex_state = 34},
  [6905] = {.lex_state = 87, .external_lex_state = 13},
  [6906] = {.lex_state = 205, .external_lex_state = 15},
  [6907] = {.lex_state = 98, .external_lex_state = 5},
  [6908] = {.lex_state = 87, .external_lex_state = 13},
  [6909] = {.lex_state = 205, .external_lex_state = 20},
  [6910] = {.lex_state = 98, .external_lex_state = 5},
  [6911] = {.lex_state = 87, .external_lex_state = 13},
  [6912] = {.lex_state = 108, .external_lex_state = 36},
  [6913] = {.lex_state = 0, .external_lex_state = 41},
  [6914] = {.lex_state = 205, .external_lex_state = 15},
  [6915] = {.lex_state = 87, .external_lex_state = 13},
  [6916] = {.lex_state = 183, .external_lex_state = 5},
  [6917] = {.lex_state = 87, .external_lex_state = 13},
  [6918] = {.lex_state = 98, .external_lex_state = 5},
  [6919] = {.lex_state = 205, .external_lex_state = 15},
  [6920] = {.lex_state = 10, .external_lex_state = 13},
  [6921] = {.lex_state = 98, .external_lex_state = 5},
  [6922] = {.lex_state = 205, .external_lex_state = 20},
  [6923] = {.lex_state = 87, .external_lex_state = 13},
  [6924] = {.lex_state = 205, .external_lex_state = 15},
  [6925] = {.lex_state = 87, .external_lex_state = 13},
  [6926] = {.lex_state = 210, .external_lex_state = 12},
  [6927] = {.lex_state = 210, .external_lex_state = 12},
  [6928] = {.lex_state = 87, .external_lex_state = 13},
  [6929] = {.lex_state = 87, .external_lex_state = 13},
  [6930] = {.lex_state = 205, .external_lex_state = 20},
  [6931] = {.lex_state = 87, .external_lex_state = 13},
  [6932] = {.lex_state = 87, .external_lex_state = 13},
  [6933] = {.lex_state = 87, .external_lex_state = 13},
  [6934] = {.lex_state = 87, .external_lex_state = 13},
  [6935] = {.lex_state = 87, .external_lex_state = 13},
  [6936] = {.lex_state = 87, .external_lex_state = 13},
  [6937] = {.lex_state = 84, .external_lex_state = 34},
  [6938] = {.lex_state = 0, .external_lex_state = 11},
  [6939] = {.lex_state = 0, .external_lex_state = 19},
  [6940] = {.lex_state = 0, .external_lex_state = 19},
  [6941] = {.lex_state = 0, .external_lex_state = 19},
  [6942] = {.lex_state = 0, .external_lex_state = 19},
  [6943] = {.lex_state = 127, .external_lex_state = 5},
  [6944] = {.lex_state = 0, .external_lex_state = 19},
  [6945] = {.lex_state = 0, .external_lex_state = 19},
  [6946] = {.lex_state = 0, .external_lex_state = 19},
  [6947] = {.lex_state = 0, .external_lex_state = 19},
  [6948] = {.lex_state = 0, .external_lex_state = 19},
  [6949] = {.lex_state = 0, .external_lex_state = 19},
  [6950] = {.lex_state = 0, .external_lex_state = 19},
  [6951] = {.lex_state = 0, .external_lex_state = 19},
  [6952] = {.lex_state = 199, .external_lex_state = 14},
  [6953] = {.lex_state = 0, .external_lex_state = 19},
  [6954] = {.lex_state = 0, .external_lex_state = 19},
  [6955] = {.lex_state = 0, .external_lex_state = 19},
  [6956] = {.lex_state = 0, .external_lex_state = 19},
  [6957] = {.lex_state = 108, .external_lex_state = 16},
  [6958] = {.lex_state = 199, .external_lex_state = 14},
  [6959] = {.lex_state = 0, .external_lex_state = 19},
  [6960] = {.lex_state = 0, .external_lex_state = 19},
  [6961] = {.lex_state = 108, .external_lex_state = 16},
  [6962] = {.lex_state = 108, .external_lex_state = 16},
  [6963] = {.lex_state = 0, .external_lex_state = 19},
  [6964] = {.lex_state = 0, .external_lex_state = 19},
  [6965] = {.lex_state = 0, .external_lex_state = 19},
  [6966] = {.lex_state = 84, .external_lex_state = 5},
  [6967] = {.lex_state = 0, .external_lex_state = 19},
  [6968] = {.lex_state = 199, .external_lex_state = 14},
  [6969] = {.lex_state = 199, .external_lex_state = 14},
  [6970] = {.lex_state = 84, .external_lex_state = 5},
  [6971] = {.lex_state = 127, .external_lex_state = 5},
  [6972] = {.lex_state = 0, .external_lex_state = 19},
  [6973] = {.lex_state = 0, .external_lex_state = 19},
  [6974] = {.lex_state = 0, .external_lex_state = 19},
  [6975] = {.lex_state = 84, .external_lex_state = 5},
  [6976] = {.lex_state = 0, .external_lex_state = 19},
  [6977] = {.lex_state = 84, .external_lex_state = 5},
  [6978] = {.lex_state = 84, .external_lex_state = 5},
  [6979] = {.lex_state = 104, .external_lex_state = 5},
  [6980] = {.lex_state = 84, .external_lex_state = 5},
  [6981] = {.lex_state = 84, .external_lex_state = 5},
  [6982] = {.lex_state = 84, .external_lex_state = 5},
  [6983] = {.lex_state = 199, .external_lex_state = 14},
  [6984] = {.lex_state = 0, .external_lex_state = 9},
  [6985] = {.lex_state = 84, .external_lex_state = 5},
  [6986] = {.lex_state = 0, .external_lex_state = 19},
  [6987] = {.lex_state = 84, .external_lex_state = 5},
  [6988] = {.lex_state = 0, .external_lex_state = 19},
  [6989] = {.lex_state = 0, .external_lex_state = 7},
  [6990] = {.lex_state = 84, .external_lex_state = 5},
  [6991] = {.lex_state = 0, .external_lex_state = 19},
  [6992] = {.lex_state = 0, .external_lex_state = 19},
  [6993] = {.lex_state = 84, .external_lex_state = 5},
  [6994] = {.lex_state = 84, .external_lex_state = 5},
  [6995] = {.lex_state = 0, .external_lex_state = 19},
  [6996] = {.lex_state = 0, .external_lex_state = 19},
  [6997] = {.lex_state = 199, .external_lex_state = 14},
  [6998] = {.lex_state = 84, .external_lex_state = 5},
  [6999] = {.lex_state = 84, .external_lex_state = 5},
  [7000] = {.lex_state = 122, .external_lex_state = 8},
  [7001] = {.lex_state = 0, .external_lex_state = 19},
  [7002] = {.lex_state = 0, .external_lex_state = 19},
  [7003] = {.lex_state = 0, .external_lex_state = 19},
  [7004] = {.lex_state = 0, .external_lex_state = 19},
  [7005] = {.lex_state = 0, .external_lex_state = 19},
  [7006] = {.lex_state = 84, .external_lex_state = 5},
  [7007] = {.lex_state = 0, .external_lex_state = 19},
  [7008] = {.lex_state = 0, .external_lex_state = 19},
  [7009] = {.lex_state = 0, .external_lex_state = 19},
  [7010] = {.lex_state = 0, .external_lex_state = 19},
  [7011] = {.lex_state = 0, .external_lex_state = 19},
  [7012] = {.lex_state = 0, .external_lex_state = 19},
  [7013] = {.lex_state = 84, .external_lex_state = 5},
  [7014] = {.lex_state = 127, .external_lex_state = 5},
  [7015] = {.lex_state = 108, .external_lex_state = 16},
  [7016] = {.lex_state = 199, .external_lex_state = 14},
  [7017] = {.lex_state = 0, .external_lex_state = 19},
  [7018] = {.lex_state = 0, .external_lex_state = 19},
  [7019] = {.lex_state = 0, .external_lex_state = 19},
  [7020] = {.lex_state = 0, .external_lex_state = 19},
  [7021] = {.lex_state = 0, .external_lex_state = 19},
  [7022] = {.lex_state = 0, .external_lex_state = 19},
  [7023] = {.lex_state = 0, .external_lex_state = 19},
  [7024] = {.lex_state = 0, .external_lex_state = 19},
  [7025] = {.lex_state = 0, .external_lex_state = 19},
  [7026] = {.lex_state = 84, .external_lex_state = 5},
  [7027] = {.lex_state = 0, .external_lex_state = 19},
  [7028] = {.lex_state = 0, .external_lex_state = 19},
  [7029] = {.lex_state = 0, .external_lex_state = 19},
  [7030] = {.lex_state = 0, .external_lex_state = 19},
  [7031] = {.lex_state = 0, .external_lex_state = 19},
  [7032] = {.lex_state = 104, .external_lex_state = 5},
  [7033] = {.lex_state = 0, .external_lex_state = 19},
  [7034] = {.lex_state = 0, .external_lex_state = 19},
  [7035] = {.lex_state = 199, .external_lex_state = 14},
  [7036] = {.lex_state = 127, .external_lex_state = 5},
  [7037] = {.lex_state = 0, .external_lex_state = 19},
  [7038] = {.lex_state = 0, .external_lex_state = 7},
  [7039] = {.lex_state = 127, .external_lex_state = 5},
  [7040] = {.lex_state = 0, .external_lex_state = 19},
  [7041] = {.lex_state = 84, .external_lex_state = 5},
  [7042] = {.lex_state = 0, .external_lex_state = 19},
  [7043] = {.lex_state = 0, .external_lex_state = 18},
  [7044] = {.lex_state = 0, .external_lex_state = 19},
  [7045] = {.lex_state = 0, .external_lex_state = 19},
  [7046] = {.lex_state = 199, .external_lex_state = 14},
  [7047] = {.lex_state = 0, .external_lex_state = 19},
  [7048] = {.lex_state = 0, .external_lex_state = 19},
  [7049] = {.lex_state = 199, .external_lex_state = 14},
  [7050] = {.lex_state = 0, .external_lex_state = 19},
  [7051] = {.lex_state = 199, .external_lex_state = 14},
  [7052] = {.lex_state = 104, .external_lex_state = 5},
  [7053] = {.lex_state = 0, .external_lex_state = 19},
  [7054] = {.lex_state = 104, .external_lex_state = 5},
  [7055] = {.lex_state = 0, .external_lex_state = 19},
  [7056] = {.lex_state = 104, .external_lex_state = 5},
  [7057] = {.lex_state = 84, .external_lex_state = 5},
  [7058] = {.lex_state = 199, .external_lex_state = 14},
  [7059] = {.lex_state = 84, .external_lex_state = 5},
  [7060] = {.lex_state = 84, .external_lex_state = 5},
  [7061] = {.lex_state = 127, .external_lex_state = 5},
  [7062] = {.lex_state = 0, .external_lex_state = 19},
  [7063] = {.lex_state = 104, .external_lex_state = 5},
  [7064] = {.lex_state = 0, .external_lex_state = 18},
  [7065] = {.lex_state = 104, .external_lex_state = 5},
  [7066] = {.lex_state = 0, .external_lex_state = 19},
  [7067] = {.lex_state = 0, .external_lex_state = 19},
  [7068] = {.lex_state = 0, .external_lex_state = 19},
  [7069] = {.lex_state = 0, .external_lex_state = 19},
  [7070] = {.lex_state = 104, .external_lex_state = 5},
  [7071] = {.lex_state = 104, .external_lex_state = 5},
  [7072] = {.lex_state = 63, .external_lex_state = 5},
  [7073] = {.lex_state = 0, .external_lex_state = 19},
  [7074] = {.lex_state = 104, .external_lex_state = 5},
  [7075] = {.lex_state = 0, .external_lex_state = 19},
  [7076] = {.lex_state = 0, .external_lex_state = 9},
  [7077] = {.lex_state = 104, .external_lex_state = 5},
  [7078] = {.lex_state = 84, .external_lex_state = 5},
  [7079] = {.lex_state = 0, .external_lex_state = 7},
  [7080] = {.lex_state = 108, .external_lex_state = 16},
  [7081] = {.lex_state = 199, .external_lex_state = 14},
  [7082] = {.lex_state = 199, .external_lex_state = 5},
  [7083] = {.lex_state = 199, .external_lex_state = 5},
  [7084] = {.lex_state = 0, .external_lex_state = 19},
  [7085] = {.lex_state = 0, .external_lex_state = 19},
  [7086] = {.lex_state = 0, .external_lex_state = 19},
  [7087] = {.lex_state = 0, .external_lex_state = 19},
  [7088] = {.lex_state = 0, .external_lex_state = 19},
  [7089] = {.lex_state = 0, .external_lex_state = 19},
  [7090] = {.lex_state = 0, .external_lex_state = 19},
  [7091] = {.lex_state = 127, .external_lex_state = 5},
  [7092] = {.lex_state = 0, .external_lex_state = 19},
  [7093] = {.lex_state = 0, .external_lex_state = 19},
  [7094] = {.lex_state = 0, .external_lex_state = 19},
  [7095] = {.lex_state = 0, .external_lex_state = 19},
  [7096] = {.lex_state = 199, .external_lex_state = 5},
  [7097] = {.lex_state = 104, .external_lex_state = 5},
  [7098] = {.lex_state = 199, .external_lex_state = 14},
  [7099] = {.lex_state = 0, .external_lex_state = 19},
  [7100] = {.lex_state = 127, .external_lex_state = 5},
  [7101] = {.lex_state = 0, .external_lex_state = 19},
  [7102] = {.lex_state = 108, .external_lex_state = 16},
  [7103] = {.lex_state = 84, .external_lex_state = 5},
  [7104] = {.lex_state = 0, .external_lex_state = 19},
  [7105] = {.lex_state = 0, .external_lex_state = 19},
  [7106] = {.lex_state = 0, .external_lex_state = 19},
  [7107] = {.lex_state = 0, .external_lex_state = 19},
  [7108] = {.lex_state = 181, .external_lex_state = 13},
  [7109] = {.lex_state = 0, .external_lex_state = 19},
  [7110] = {.lex_state = 0, .external_lex_state = 19},
  [7111] = {.lex_state = 183, .external_lex_state = 5},
  [7112] = {.lex_state = 199, .external_lex_state = 14},
  [7113] = {.lex_state = 199, .external_lex_state = 14},
  [7114] = {.lex_state = 0, .external_lex_state = 19},
  [7115] = {.lex_state = 0, .external_lex_state = 19},
  [7116] = {.lex_state = 199, .external_lex_state = 14},
  [7117] = {.lex_state = 0, .external_lex_state = 19},
  [7118] = {.lex_state = 199, .external_lex_state = 14},
  [7119] = {.lex_state = 0, .external_lex_state = 19},
  [7120] = {.lex_state = 0, .external_lex_state = 19},
  [7121] = {.lex_state = 0, .external_lex_state = 18},
  [7122] = {.lex_state = 127, .external_lex_state = 5},
  [7123] = {.lex_state = 199, .external_lex_state = 14},
  [7124] = {.lex_state = 0, .external_lex_state = 19},
  [7125] = {.lex_state = 199, .external_lex_state = 14},
  [7126] = {.lex_state = 0, .external_lex_state = 19},
  [7127] = {.lex_state = 0, .external_lex_state = 18},
  [7128] = {.lex_state = 0, .external_lex_state = 7},
  [7129] = {.lex_state = 127, .external_lex_state = 5},
  [7130] = {.lex_state = 0, .external_lex_state = 19},
  [7131] = {.lex_state = 0, .external_lex_state = 19},
  [7132] = {.lex_state = 84, .external_lex_state = 5},
  [7133] = {.lex_state = 0, .external_lex_state = 42},
  [7134] = {.lex_state = 0, .external_lex_state = 19},
  [7135] = {.lex_state = 0, .external_lex_state = 19},
  [7136] = {.lex_state = 0, .external_lex_state = 19},
  [7137] = {.lex_state = 0, .external_lex_state = 19},
  [7138] = {.lex_state = 0, .external_lex_state = 7},
  [7139] = {.lex_state = 127, .external_lex_state = 5},
  [7140] = {.lex_state = 210, .external_lex_state = 20},
  [7141] = {.lex_state = 0, .external_lex_state = 19},
  [7142] = {.lex_state = 122, .external_lex_state = 8},
  [7143] = {.lex_state = 0, .external_lex_state = 19},
  [7144] = {.lex_state = 0, .external_lex_state = 19},
  [7145] = {.lex_state = 0, .external_lex_state = 19},
  [7146] = {.lex_state = 0, .external_lex_state = 19},
  [7147] = {.lex_state = 0, .external_lex_state = 19},
  [7148] = {.lex_state = 199, .external_lex_state = 14},
  [7149] = {.lex_state = 127, .external_lex_state = 5},
  [7150] = {.lex_state = 199, .external_lex_state = 14},
  [7151] = {.lex_state = 0, .external_lex_state = 19},
  [7152] = {.lex_state = 0, .external_lex_state = 19},
  [7153] = {.lex_state = 199, .external_lex_state = 14},
  [7154] = {.lex_state = 122, .external_lex_state = 8},
  [7155] = {.lex_state = 122, .external_lex_state = 8},
  [7156] = {.lex_state = 108, .external_lex_state = 16},
  [7157] = {.lex_state = 0, .external_lex_state = 19},
  [7158] = {.lex_state = 122, .external_lex_state = 8},
  [7159] = {.lex_state = 199, .external_lex_state = 14},
  [7160] = {.lex_state = 199, .external_lex_state = 14},
  [7161] = {.lex_state = 0, .external_lex_state = 19},
  [7162] = {.lex_state = 0, .external_lex_state = 19},
  [7163] = {.lex_state = 0, .external_lex_state = 19},
  [7164] = {.lex_state = 199, .external_lex_state = 14},
  [7165] = {.lex_state = 0, .external_lex_state = 19},
  [7166] = {.lex_state = 0, .external_lex_state = 19},
  [7167] = {.lex_state = 0, .external_lex_state = 19},
  [7168] = {.lex_state = 127, .external_lex_state = 5},
  [7169] = {.lex_state = 0, .external_lex_state = 19},
  [7170] = {.lex_state = 0, .external_lex_state = 19},
  [7171] = {.lex_state = 0, .external_lex_state = 19},
  [7172] = {.lex_state = 0, .external_lex_state = 19},
  [7173] = {.lex_state = 0, .external_lex_state = 19},
  [7174] = {.lex_state = 0, .external_lex_state = 18},
  [7175] = {.lex_state = 84, .external_lex_state = 5},
  [7176] = {.lex_state = 0, .external_lex_state = 19},
  [7177] = {.lex_state = 0, .external_lex_state = 19},
  [7178] = {.lex_state = 0, .external_lex_state = 19},
  [7179] = {.lex_state = 127, .external_lex_state = 5},
  [7180] = {.lex_state = 0, .external_lex_state = 19},
  [7181] = {.lex_state = 0, .external_lex_state = 19},
  [7182] = {.lex_state = 0, .external_lex_state = 19},
  [7183] = {.lex_state = 0, .external_lex_state = 19},
  [7184] = {.lex_state = 0, .external_lex_state = 19},
  [7185] = {.lex_state = 0, .external_lex_state = 19},
  [7186] = {.lex_state = 84, .external_lex_state = 5},
  [7187] = {.lex_state = 0, .external_lex_state = 17},
  [7188] = {.lex_state = 127, .external_lex_state = 5},
  [7189] = {.lex_state = 199, .external_lex_state = 14},
  [7190] = {.lex_state = 0, .external_lex_state = 19},
  [7191] = {.lex_state = 0, .external_lex_state = 19},
  [7192] = {.lex_state = 0, .external_lex_state = 19},
  [7193] = {.lex_state = 0, .external_lex_state = 19},
  [7194] = {.lex_state = 0, .external_lex_state = 19},
  [7195] = {.lex_state = 0, .external_lex_state = 19},
  [7196] = {.lex_state = 0, .external_lex_state = 19},
  [7197] = {.lex_state = 84, .external_lex_state = 5},
  [7198] = {.lex_state = 84, .external_lex_state = 5},
  [7199] = {.lex_state = 84, .external_lex_state = 5},
  [7200] = {.lex_state = 199, .external_lex_state = 14},
  [7201] = {.lex_state = 199, .external_lex_state = 14},
  [7202] = {.lex_state = 199, .external_lex_state = 14},
  [7203] = {.lex_state = 181, .external_lex_state = 13},
  [7204] = {.lex_state = 199, .external_lex_state = 14},
  [7205] = {.lex_state = 127, .external_lex_state = 5},
  [7206] = {.lex_state = 0, .external_lex_state = 7},
  [7207] = {.lex_state = 199, .external_lex_state = 14},
  [7208] = {.lex_state = 84, .external_lex_state = 5},
  [7209] = {.lex_state = 104, .external_lex_state = 5},
  [7210] = {.lex_state = 0, .external_lex_state = 19},
  [7211] = {.lex_state = 199, .external_lex_state = 14},
  [7212] = {.lex_state = 0, .external_lex_state = 19},
  [7213] = {.lex_state = 0, .external_lex_state = 19},
  [7214] = {.lex_state = 84, .external_lex_state = 5},
  [7215] = {.lex_state = 199, .external_lex_state = 14},
  [7216] = {.lex_state = 84, .external_lex_state = 5},
  [7217] = {.lex_state = 84, .external_lex_state = 5},
  [7218] = {.lex_state = 0, .external_lex_state = 19},
  [7219] = {.lex_state = 84, .external_lex_state = 5},
  [7220] = {.lex_state = 0, .external_lex_state = 19},
  [7221] = {.lex_state = 0, .external_lex_state = 19},
  [7222] = {.lex_state = 0, .external_lex_state = 19},
  [7223] = {.lex_state = 210, .external_lex_state = 15},
  [7224] = {.lex_state = 0, .external_lex_state = 19},
  [7225] = {.lex_state = 0, .external_lex_state = 19},
  [7226] = {.lex_state = 0, .external_lex_state = 19},
  [7227] = {.lex_state = 127, .external_lex_state = 5},
  [7228] = {.lex_state = 0, .external_lex_state = 19},
  [7229] = {.lex_state = 0, .external_lex_state = 19},
  [7230] = {.lex_state = 84, .external_lex_state = 5},
  [7231] = {.lex_state = 199, .external_lex_state = 14},
  [7232] = {.lex_state = 84, .external_lex_state = 5},
  [7233] = {.lex_state = 84, .external_lex_state = 5},
  [7234] = {.lex_state = 84, .external_lex_state = 5},
  [7235] = {.lex_state = 84, .external_lex_state = 5},
  [7236] = {.lex_state = 0, .external_lex_state = 19},
  [7237] = {.lex_state = 199, .external_lex_state = 14},
  [7238] = {.lex_state = 0, .external_lex_state = 19},
  [7239] = {.lex_state = 0, .external_lex_state = 19},
  [7240] = {.lex_state = 0, .external_lex_state = 19},
  [7241] = {.lex_state = 199, .external_lex_state = 14},
  [7242] = {.lex_state = 127, .external_lex_state = 5},
  [7243] = {.lex_state = 0, .external_lex_state = 19},
  [7244] = {.lex_state = 199, .external_lex_state = 14},
  [7245] = {.lex_state = 127, .external_lex_state = 5},
  [7246] = {.lex_state = 0, .external_lex_state = 19},
  [7247] = {.lex_state = 0, .external_lex_state = 19},
  [7248] = {.lex_state = 0, .external_lex_state = 19},
  [7249] = {.lex_state = 0, .external_lex_state = 19},
  [7250] = {.lex_state = 0, .external_lex_state = 19},
  [7251] = {.lex_state = 0, .external_lex_state = 19},
  [7252] = {.lex_state = 199, .external_lex_state = 14},
  [7253] = {.lex_state = 84, .external_lex_state = 5},
  [7254] = {.lex_state = 199, .external_lex_state = 14},
  [7255] = {.lex_state = 0, .external_lex_state = 19},
  [7256] = {.lex_state = 84, .external_lex_state = 5},
  [7257] = {.lex_state = 0, .external_lex_state = 19},
  [7258] = {.lex_state = 0, .external_lex_state = 19},
  [7259] = {.lex_state = 0, .external_lex_state = 19},
  [7260] = {.lex_state = 0, .external_lex_state = 19},
  [7261] = {.lex_state = 84, .external_lex_state = 5},
  [7262] = {.lex_state = 84, .external_lex_state = 5},
  [7263] = {.lex_state = 0, .external_lex_state = 19},
  [7264] = {.lex_state = 84, .external_lex_state = 5},
  [7265] = {.lex_state = 199, .external_lex_state = 14},
  [7266] = {.lex_state = 199, .external_lex_state = 14},
  [7267] = {.lex_state = 84, .external_lex_state = 5},
  [7268] = {.lex_state = 210, .external_lex_state = 15},
  [7269] = {.lex_state = 84, .external_lex_state = 5},
  [7270] = {.lex_state = 84, .external_lex_state = 5},
  [7271] = {.lex_state = 84, .external_lex_state = 5},
  [7272] = {.lex_state = 84, .external_lex_state = 5},
  [7273] = {.lex_state = 84, .external_lex_state = 5},
  [7274] = {.lex_state = 84, .external_lex_state = 5},
  [7275] = {.lex_state = 199, .external_lex_state = 14},
  [7276] = {.lex_state = 63, .external_lex_state = 5},
  [7277] = {.lex_state = 84, .external_lex_state = 5},
  [7278] = {.lex_state = 183, .external_lex_state = 5},
  [7279] = {.lex_state = 84, .external_lex_state = 5},
  [7280] = {.lex_state = 184, .external_lex_state = 5},
  [7281] = {.lex_state = 0, .external_lex_state = 19},
  [7282] = {.lex_state = 0, .external_lex_state = 19},
  [7283] = {.lex_state = 199, .external_lex_state = 14},
  [7284] = {.lex_state = 0, .external_lex_state = 17},
  [7285] = {.lex_state = 0, .external_lex_state = 19},
  [7286] = {.lex_state = 127, .external_lex_state = 5},
  [7287] = {.lex_state = 181, .external_lex_state = 13},
  [7288] = {.lex_state = 0, .external_lex_state = 19},
  [7289] = {.lex_state = 0, .external_lex_state = 19},
  [7290] = {.lex_state = 0, .external_lex_state = 19},
  [7291] = {.lex_state = 0, .external_lex_state = 19},
  [7292] = {.lex_state = 0, .external_lex_state = 19},
  [7293] = {.lex_state = 0, .external_lex_state = 19},
  [7294] = {.lex_state = 127, .external_lex_state = 5},
  [7295] = {.lex_state = 0, .external_lex_state = 19},
  [7296] = {.lex_state = 0, .external_lex_state = 19},
  [7297] = {.lex_state = 199, .external_lex_state = 14},
  [7298] = {.lex_state = 0, .external_lex_state = 19},
  [7299] = {.lex_state = 0, .external_lex_state = 19},
  [7300] = {.lex_state = 0, .external_lex_state = 19},
  [7301] = {.lex_state = 0, .external_lex_state = 19},
  [7302] = {.lex_state = 0, .external_lex_state = 19},
  [7303] = {.lex_state = 0, .external_lex_state = 19},
  [7304] = {.lex_state = 10, .external_lex_state = 13},
  [7305] = {.lex_state = 0, .external_lex_state = 19},
  [7306] = {.lex_state = 0, .external_lex_state = 19},
  [7307] = {.lex_state = 210, .external_lex_state = 20},
  [7308] = {.lex_state = 0, .external_lex_state = 19},
  [7309] = {.lex_state = 0, .external_lex_state = 19},
  [7310] = {.lex_state = 0, .external_lex_state = 19},
  [7311] = {.lex_state = 0, .external_lex_state = 19},
  [7312] = {.lex_state = 0, .external_lex_state = 19},
  [7313] = {.lex_state = 127, .external_lex_state = 5},
  [7314] = {.lex_state = 0, .external_lex_state = 19},
  [7315] = {.lex_state = 0, .external_lex_state = 19},
  [7316] = {.lex_state = 127, .external_lex_state = 5},
  [7317] = {.lex_state = 0, .external_lex_state = 19},
  [7318] = {.lex_state = 0, .external_lex_state = 19},
  [7319] = {.lex_state = 0, .external_lex_state = 19},
  [7320] = {.lex_state = 104, .external_lex_state = 5},
  [7321] = {.lex_state = 104, .external_lex_state = 5},
  [7322] = {.lex_state = 104, .external_lex_state = 5},
  [7323] = {.lex_state = 104, .external_lex_state = 5},
  [7324] = {.lex_state = 104, .external_lex_state = 5},
  [7325] = {.lex_state = 0, .external_lex_state = 19},
  [7326] = {.lex_state = 0, .external_lex_state = 19},
  [7327] = {.lex_state = 0, .external_lex_state = 19},
  [7328] = {.lex_state = 0, .external_lex_state = 19},
  [7329] = {.lex_state = 0, .external_lex_state = 19},
  [7330] = {.lex_state = 0, .external_lex_state = 19},
  [7331] = {.lex_state = 0, .external_lex_state = 19},
  [7332] = {.lex_state = 84, .external_lex_state = 5},
  [7333] = {.lex_state = 0, .external_lex_state = 19},
  [7334] = {.lex_state = 210, .external_lex_state = 14},
  [7335] = {.lex_state = 0, .external_lex_state = 19},
  [7336] = {.lex_state = 199, .external_lex_state = 14},
  [7337] = {.lex_state = 184, .external_lex_state = 5},
  [7338] = {.lex_state = 0, .external_lex_state = 19},
  [7339] = {.lex_state = 0, .external_lex_state = 19},
  [7340] = {.lex_state = 190, .external_lex_state = 5},
  [7341] = {.lex_state = 0, .external_lex_state = 19},
  [7342] = {.lex_state = 184, .external_lex_state = 5},
  [7343] = {.lex_state = 199, .external_lex_state = 14},
  [7344] = {.lex_state = 184, .external_lex_state = 5},
  [7345] = {.lex_state = 210, .external_lex_state = 14},
  [7346] = {.lex_state = 199, .external_lex_state = 14},
  [7347] = {.lex_state = 0, .external_lex_state = 10},
  [7348] = {.lex_state = 199, .external_lex_state = 14},
  [7349] = {.lex_state = 199, .external_lex_state = 14},
  [7350] = {.lex_state = 0, .external_lex_state = 19},
  [7351] = {.lex_state = 0, .external_lex_state = 19},
  [7352] = {.lex_state = 0, .external_lex_state = 19},
  [7353] = {.lex_state = 0, .external_lex_state = 17},
  [7354] = {.lex_state = 0, .external_lex_state = 19},
  [7355] = {.lex_state = 0, .external_lex_state = 19},
  [7356] = {.lex_state = 0, .external_lex_state = 17},
  [7357] = {.lex_state = 199, .external_lex_state = 14},
  [7358] = {.lex_state = 0, .external_lex_state = 19},
  [7359] = {.lex_state = 184, .external_lex_state = 5},
  [7360] = {.lex_state = 0, .external_lex_state = 19},
  [7361] = {.lex_state = 0, .external_lex_state = 19},
  [7362] = {.lex_state = 84, .external_lex_state = 5},
  [7363] = {.lex_state = 184, .external_lex_state = 5},
  [7364] = {.lex_state = 0, .external_lex_state = 19},
  [7365] = {.lex_state = 199, .external_lex_state = 14},
  [7366] = {.lex_state = 0, .external_lex_state = 19},
  [7367] = {.lex_state = 0, .external_lex_state = 19},
  [7368] = {.lex_state = 0, .external_lex_state = 19},
  [7369] = {.lex_state = 0, .external_lex_state = 19},
  [7370] = {.lex_state = 127, .external_lex_state = 5},
  [7371] = {.lex_state = 0, .external_lex_state = 19},
  [7372] = {.lex_state = 0, .external_lex_state = 19},
  [7373] = {.lex_state = 0, .external_lex_state = 19},
  [7374] = {.lex_state = 0, .external_lex_state = 19},
  [7375] = {.lex_state = 0, .external_lex_state = 19},
  [7376] = {.lex_state = 0, .external_lex_state = 19},
  [7377] = {.lex_state = 84, .external_lex_state = 5},
  [7378] = {.lex_state = 181, .external_lex_state = 5},
  [7379] = {.lex_state = 0, .external_lex_state = 19},
  [7380] = {.lex_state = 0, .external_lex_state = 19},
  [7381] = {.lex_state = 0, .external_lex_state = 19},
  [7382] = {.lex_state = 0, .external_lex_state = 19},
  [7383] = {.lex_state = 0, .external_lex_state = 19},
  [7384] = {.lex_state = 0, .external_lex_state = 19},
  [7385] = {.lex_state = 127, .external_lex_state = 5},
  [7386] = {.lex_state = 0, .external_lex_state = 19},
  [7387] = {.lex_state = 0, .external_lex_state = 19},
  [7388] = {.lex_state = 0, .external_lex_state = 11},
  [7389] = {.lex_state = 0, .external_lex_state = 19},
  [7390] = {.lex_state = 0, .external_lex_state = 19},
  [7391] = {.lex_state = 127, .external_lex_state = 5},
  [7392] = {.lex_state = 127, .external_lex_state = 5},
  [7393] = {.lex_state = 0, .external_lex_state = 19},
  [7394] = {.lex_state = 0, .external_lex_state = 19},
  [7395] = {.lex_state = 0, .external_lex_state = 19},
  [7396] = {.lex_state = 0, .external_lex_state = 19},
  [7397] = {.lex_state = 0, .external_lex_state = 19},
  [7398] = {.lex_state = 0, .external_lex_state = 19},
  [7399] = {.lex_state = 0, .external_lex_state = 19},
  [7400] = {.lex_state = 0, .external_lex_state = 10},
  [7401] = {.lex_state = 84, .external_lex_state = 5},
  [7402] = {.lex_state = 0, .external_lex_state = 19},
  [7403] = {.lex_state = 0, .external_lex_state = 19},
  [7404] = {.lex_state = 0, .external_lex_state = 19},
  [7405] = {.lex_state = 199, .external_lex_state = 14},
  [7406] = {.lex_state = 0, .external_lex_state = 19},
  [7407] = {.lex_state = 0, .external_lex_state = 19},
  [7408] = {.lex_state = 0, .external_lex_state = 19},
  [7409] = {.lex_state = 0, .external_lex_state = 19},
  [7410] = {.lex_state = 0, .external_lex_state = 19},
  [7411] = {.lex_state = 0, .external_lex_state = 19},
  [7412] = {.lex_state = 0, .external_lex_state = 19},
  [7413] = {.lex_state = 0, .external_lex_state = 41},
  [7414] = {.lex_state = 122, .external_lex_state = 8},
  [7415] = {.lex_state = 199, .external_lex_state = 14},
  [7416] = {.lex_state = 84, .external_lex_state = 5},
  [7417] = {.lex_state = 84, .external_lex_state = 5},
  [7418] = {.lex_state = 108, .external_lex_state = 16},
  [7419] = {.lex_state = 0, .external_lex_state = 9},
  [7420] = {.lex_state = 0, .external_lex_state = 9},
  [7421] = {.lex_state = 0, .external_lex_state = 19},
  [7422] = {.lex_state = 0, .external_lex_state = 19},
  [7423] = {.lex_state = 199, .external_lex_state = 14},
  [7424] = {.lex_state = 108, .external_lex_state = 16},
  [7425] = {.lex_state = 0, .external_lex_state = 19},
  [7426] = {.lex_state = 0, .external_lex_state = 19},
  [7427] = {.lex_state = 0, .external_lex_state = 19},
  [7428] = {.lex_state = 108, .external_lex_state = 16},
  [7429] = {.lex_state = 0, .external_lex_state = 19},
  [7430] = {.lex_state = 0, .external_lex_state = 19},
  [7431] = {.lex_state = 108, .external_lex_state = 16},
  [7432] = {.lex_state = 0, .external_lex_state = 19},
  [7433] = {.lex_state = 108, .external_lex_state = 16},
  [7434] = {.lex_state = 108, .external_lex_state = 16},
  [7435] = {.lex_state = 0, .external_lex_state = 19},
  [7436] = {.lex_state = 0, .external_lex_state = 19},
  [7437] = {.lex_state = 0, .external_lex_state = 19},
  [7438] = {.lex_state = 84, .external_lex_state = 5},
  [7439] = {.lex_state = 0, .external_lex_state = 9},
  [7440] = {.lex_state = 199, .external_lex_state = 14},
  [7441] = {.lex_state = 0, .external_lex_state = 7},
  [7442] = {.lex_state = 108, .external_lex_state = 16},
  [7443] = {.lex_state = 108, .external_lex_state = 16},
  [7444] = {.lex_state = 108, .external_lex_state = 16},
  [7445] = {.lex_state = 108, .external_lex_state = 16},
  [7446] = {.lex_state = 108, .external_lex_state = 16},
  [7447] = {.lex_state = 0, .external_lex_state = 19},
  [7448] = {.lex_state = 0, .external_lex_state = 19},
  [7449] = {.lex_state = 0, .external_lex_state = 19},
  [7450] = {.lex_state = 0, .external_lex_state = 19},
  [7451] = {.lex_state = 0, .external_lex_state = 19},
  [7452] = {.lex_state = 0, .external_lex_state = 19},
  [7453] = {.lex_state = 127, .external_lex_state = 5},
  [7454] = {.lex_state = 108, .external_lex_state = 16},
  [7455] = {.lex_state = 0, .external_lex_state = 19},
  [7456] = {.lex_state = 199, .external_lex_state = 14},
  [7457] = {.lex_state = 0, .external_lex_state = 19},
  [7458] = {.lex_state = 0, .external_lex_state = 19},
  [7459] = {.lex_state = 0, .external_lex_state = 19},
  [7460] = {.lex_state = 0, .external_lex_state = 19},
  [7461] = {.lex_state = 0, .external_lex_state = 19},
  [7462] = {.lex_state = 0, .external_lex_state = 19},
  [7463] = {.lex_state = 0, .external_lex_state = 19},
  [7464] = {.lex_state = 0, .external_lex_state = 19},
  [7465] = {.lex_state = 199, .external_lex_state = 14},
  [7466] = {.lex_state = 0, .external_lex_state = 19},
  [7467] = {.lex_state = 0, .external_lex_state = 19},
  [7468] = {.lex_state = 0, .external_lex_state = 19},
  [7469] = {.lex_state = 0, .external_lex_state = 19},
  [7470] = {.lex_state = 0, .external_lex_state = 19},
  [7471] = {.lex_state = 0, .external_lex_state = 19},
  [7472] = {.lex_state = 0, .external_lex_state = 19},
  [7473] = {.lex_state = 199, .external_lex_state = 14},
  [7474] = {.lex_state = 0, .external_lex_state = 19},
  [7475] = {.lex_state = 0, .external_lex_state = 19},
  [7476] = {.lex_state = 199, .external_lex_state = 14},
  [7477] = {.lex_state = 127, .external_lex_state = 5},
  [7478] = {.lex_state = 0, .external_lex_state = 19},
  [7479] = {.lex_state = 0, .external_lex_state = 19},
  [7480] = {.lex_state = 0, .external_lex_state = 19},
  [7481] = {.lex_state = 199, .external_lex_state = 14},
  [7482] = {.lex_state = 0, .external_lex_state = 19},
  [7483] = {.lex_state = 199, .external_lex_state = 14},
  [7484] = {.lex_state = 0, .external_lex_state = 19},
  [7485] = {.lex_state = 0, .external_lex_state = 7},
  [7486] = {.lex_state = 0, .external_lex_state = 19},
  [7487] = {.lex_state = 0, .external_lex_state = 19},
  [7488] = {.lex_state = 0, .external_lex_state = 19},
  [7489] = {.lex_state = 127, .external_lex_state = 5},
  [7490] = {.lex_state = 199, .external_lex_state = 5},
  [7491] = {.lex_state = 0, .external_lex_state = 31},
  [7492] = {.lex_state = 0, .external_lex_state = 19},
  [7493] = {.lex_state = 0, .external_lex_state = 17},
  [7494] = {.lex_state = 210, .external_lex_state = 5},
  [7495] = {.lex_state = 0, .external_lex_state = 19},
  [7496] = {.lex_state = 0, .external_lex_state = 19},
  [7497] = {.lex_state = 127, .external_lex_state = 5},
  [7498] = {.lex_state = 0, .external_lex_state = 19},
  [7499] = {.lex_state = 0, .external_lex_state = 19},
  [7500] = {.lex_state = 0, .external_lex_state = 19},
  [7501] = {.lex_state = 0, .external_lex_state = 19},
  [7502] = {.lex_state = 0, .external_lex_state = 19},
  [7503] = {.lex_state = 0, .external_lex_state = 19},
  [7504] = {.lex_state = 0, .external_lex_state = 19},
  [7505] = {.lex_state = 0, .external_lex_state = 19},
  [7506] = {.lex_state = 0, .external_lex_state = 19},
  [7507] = {.lex_state = 104, .external_lex_state = 5},
  [7508] = {.lex_state = 0, .external_lex_state = 19},
  [7509] = {.lex_state = 199, .external_lex_state = 14},
  [7510] = {.lex_state = 127, .external_lex_state = 5},
  [7511] = {.lex_state = 0, .external_lex_state = 9},
  [7512] = {.lex_state = 0, .external_lex_state = 19},
  [7513] = {.lex_state = 190, .external_lex_state = 5},
  [7514] = {.lex_state = 0, .external_lex_state = 19},
  [7515] = {.lex_state = 0, .external_lex_state = 19},
  [7516] = {.lex_state = 0, .external_lex_state = 19},
  [7517] = {.lex_state = 0, .external_lex_state = 19},
  [7518] = {.lex_state = 199, .external_lex_state = 14},
  [7519] = {.lex_state = 0, .external_lex_state = 19},
  [7520] = {.lex_state = 0, .external_lex_state = 9},
  [7521] = {.lex_state = 127, .external_lex_state = 5},
  [7522] = {.lex_state = 0, .external_lex_state = 19},
  [7523] = {.lex_state = 0, .external_lex_state = 19},
  [7524] = {.lex_state = 0, .external_lex_state = 19},
  [7525] = {.lex_state = 0, .external_lex_state = 19},
  [7526] = {.lex_state = 0, .external_lex_state = 19},
  [7527] = {.lex_state = 184, .external_lex_state = 5},
  [7528] = {.lex_state = 0, .external_lex_state = 19},
  [7529] = {.lex_state = 0, .external_lex_state = 19},
  [7530] = {.lex_state = 0, .external_lex_state = 19},
  [7531] = {.lex_state = 0, .external_lex_state = 19},
  [7532] = {.lex_state = 0, .external_lex_state = 19},
  [7533] = {.lex_state = 0, .external_lex_state = 19},
  [7534] = {.lex_state = 199, .external_lex_state = 14},
  [7535] = {.lex_state = 0, .external_lex_state = 19},
  [7536] = {.lex_state = 199, .external_lex_state = 14},
  [7537] = {.lex_state = 122, .external_lex_state = 8},
  [7538] = {.lex_state = 199, .external_lex_state = 5},
  [7539] = {.lex_state = 183, .external_lex_state = 5},
  [7540] = {.lex_state = 0, .external_lex_state = 15},
  [7541] = {.lex_state = 199, .external_lex_state = 5},
  [7542] = {.lex_state = 0, .external_lex_state = 43},
  [7543] = {.lex_state = 205, .external_lex_state = 3},
  [7544] = {.lex_state = 199, .external_lex_state = 5},
  [7545] = {.lex_state = 181, .external_lex_state = 5},
  [7546] = {.lex_state = 199, .external_lex_state = 5},
  [7547] = {.lex_state = 199, .external_lex_state = 5},
  [7548] = {.lex_state = 0, .external_lex_state = 15},
  [7549] = {.lex_state = 0, .external_lex_state = 15},
  [7550] = {.lex_state = 0, .external_lex_state = 15},
  [7551] = {.lex_state = 1, .external_lex_state = 5},
  [7552] = {.lex_state = 0, .external_lex_state = 15},
  [7553] = {.lex_state = 0, .external_lex_state = 15},
  [7554] = {.lex_state = 0, .external_lex_state = 15},
  [7555] = {.lex_state = 0, .external_lex_state = 15},
  [7556] = {.lex_state = 199, .external_lex_state = 5},
  [7557] = {.lex_state = 0, .external_lex_state = 15},
  [7558] = {.lex_state = 0, .external_lex_state = 15},
  [7559] = {.lex_state = 199, .external_lex_state = 5},
  [7560] = {.lex_state = 0, .external_lex_state = 11},
  [7561] = {.lex_state = 181, .external_lex_state = 5},
  [7562] = {.lex_state = 119, .external_lex_state = 16},
  [7563] = {.lex_state = 0, .external_lex_state = 15},
  [7564] = {.lex_state = 0, .external_lex_state = 15},
  [7565] = {.lex_state = 202, .external_lex_state = 5},
  [7566] = {.lex_state = 183, .external_lex_state = 20},
  [7567] = {.lex_state = 0, .external_lex_state = 35},
  [7568] = {.lex_state = 199, .external_lex_state = 5},
  [7569] = {.lex_state = 199, .external_lex_state = 5},
  [7570] = {.lex_state = 0, .external_lex_state = 35},
  [7571] = {.lex_state = 199, .external_lex_state = 5},
  [7572] = {.lex_state = 199, .external_lex_state = 5},
  [7573] = {.lex_state = 199, .external_lex_state = 5},
  [7574] = {.lex_state = 0, .external_lex_state = 11},
  [7575] = {.lex_state = 199, .external_lex_state = 5},
  [7576] = {.lex_state = 181, .external_lex_state = 5},
  [7577] = {.lex_state = 0, .external_lex_state = 13},
  [7578] = {.lex_state = 0, .external_lex_state = 15},
  [7579] = {.lex_state = 199, .external_lex_state = 5},
  [7580] = {.lex_state = 0, .external_lex_state = 11},
  [7581] = {.lex_state = 199, .external_lex_state = 5},
  [7582] = {.lex_state = 0, .external_lex_state = 15},
  [7583] = {.lex_state = 0, .external_lex_state = 15},
  [7584] = {.lex_state = 199, .external_lex_state = 14},
  [7585] = {.lex_state = 0, .external_lex_state = 15},
  [7586] = {.lex_state = 181, .external_lex_state = 13},
  [7587] = {.lex_state = 0, .external_lex_state = 15},
  [7588] = {.lex_state = 0, .external_lex_state = 15},
  [7589] = {.lex_state = 0, .external_lex_state = 15},
  [7590] = {.lex_state = 199, .external_lex_state = 5},
  [7591] = {.lex_state = 0, .external_lex_state = 35},
  [7592] = {.lex_state = 199, .external_lex_state = 5},
  [7593] = {.lex_state = 181, .external_lex_state = 5},
  [7594] = {.lex_state = 0, .external_lex_state = 13},
  [7595] = {.lex_state = 183, .external_lex_state = 20},
  [7596] = {.lex_state = 0, .external_lex_state = 11},
  [7597] = {.lex_state = 0, .external_lex_state = 10},
  [7598] = {.lex_state = 0, .external_lex_state = 15},
  [7599] = {.lex_state = 181, .external_lex_state = 5},
  [7600] = {.lex_state = 0, .external_lex_state = 15},
  [7601] = {.lex_state = 199, .external_lex_state = 5},
  [7602] = {.lex_state = 181, .external_lex_state = 15},
  [7603] = {.lex_state = 0, .external_lex_state = 15},
  [7604] = {.lex_state = 199, .external_lex_state = 5},
  [7605] = {.lex_state = 0, .external_lex_state = 15},
  [7606] = {.lex_state = 0, .external_lex_state = 15},
  [7607] = {.lex_state = 0, .external_lex_state = 15},
  [7608] = {.lex_state = 0, .external_lex_state = 10},
  [7609] = {.lex_state = 199, .external_lex_state = 5},
  [7610] = {.lex_state = 199, .external_lex_state = 5},
  [7611] = {.lex_state = 181, .external_lex_state = 5},
  [7612] = {.lex_state = 0, .external_lex_state = 44},
  [7613] = {.lex_state = 0, .external_lex_state = 15},
  [7614] = {.lex_state = 0, .external_lex_state = 15},
  [7615] = {.lex_state = 199, .external_lex_state = 5},
  [7616] = {.lex_state = 199, .external_lex_state = 5},
  [7617] = {.lex_state = 199, .external_lex_state = 5},
  [7618] = {.lex_state = 118, .external_lex_state = 5},
  [7619] = {.lex_state = 0, .external_lex_state = 15},
  [7620] = {.lex_state = 0, .external_lex_state = 19},
  [7621] = {.lex_state = 0, .external_lex_state = 15},
  [7622] = {.lex_state = 0, .external_lex_state = 15},
  [7623] = {.lex_state = 199, .external_lex_state = 5},
  [7624] = {.lex_state = 199, .external_lex_state = 5},
  [7625] = {.lex_state = 199, .external_lex_state = 5},
  [7626] = {.lex_state = 0, .external_lex_state = 15},
  [7627] = {.lex_state = 0, .external_lex_state = 15},
  [7628] = {.lex_state = 0, .external_lex_state = 15},
  [7629] = {.lex_state = 0, .external_lex_state = 15},
  [7630] = {.lex_state = 199, .external_lex_state = 5},
  [7631] = {.lex_state = 0, .external_lex_state = 19},
  [7632] = {.lex_state = 0, .external_lex_state = 15},
  [7633] = {.lex_state = 0, .external_lex_state = 19},
  [7634] = {.lex_state = 199, .external_lex_state = 5},
  [7635] = {.lex_state = 202, .external_lex_state = 5},
  [7636] = {.lex_state = 199, .external_lex_state = 5},
  [7637] = {.lex_state = 183, .external_lex_state = 15},
  [7638] = {.lex_state = 0, .external_lex_state = 44},
  [7639] = {.lex_state = 199, .external_lex_state = 5},
  [7640] = {.lex_state = 0, .external_lex_state = 15},
  [7641] = {.lex_state = 0, .external_lex_state = 15},
  [7642] = {.lex_state = 199, .external_lex_state = 5},
  [7643] = {.lex_state = 0, .external_lex_state = 15},
  [7644] = {.lex_state = 1, .external_lex_state = 5},
  [7645] = {.lex_state = 181, .external_lex_state = 5},
  [7646] = {.lex_state = 0, .external_lex_state = 11},
  [7647] = {.lex_state = 118, .external_lex_state = 5},
  [7648] = {.lex_state = 0, .external_lex_state = 15},
  [7649] = {.lex_state = 119, .external_lex_state = 16},
  [7650] = {.lex_state = 181, .external_lex_state = 5},
  [7651] = {.lex_state = 0, .external_lex_state = 15},
  [7652] = {.lex_state = 199, .external_lex_state = 5},
  [7653] = {.lex_state = 199, .external_lex_state = 5},
  [7654] = {.lex_state = 0, .external_lex_state = 11},
  [7655] = {.lex_state = 0, .external_lex_state = 10},
  [7656] = {.lex_state = 199, .external_lex_state = 5},
  [7657] = {.lex_state = 0, .external_lex_state = 43},
  [7658] = {.lex_state = 181, .external_lex_state = 5},
  [7659] = {.lex_state = 202, .external_lex_state = 5},
  [7660] = {.lex_state = 0, .external_lex_state = 15},
  [7661] = {.lex_state = 199, .external_lex_state = 5},
  [7662] = {.lex_state = 0, .external_lex_state = 13},
  [7663] = {.lex_state = 202, .external_lex_state = 5},
  [7664] = {.lex_state = 199, .external_lex_state = 5},
  [7665] = {.lex_state = 183, .external_lex_state = 20},
  [7666] = {.lex_state = 0, .external_lex_state = 35},
  [7667] = {.lex_state = 202, .external_lex_state = 5},
  [7668] = {.lex_state = 199, .external_lex_state = 5},
  [7669] = {.lex_state = 0, .external_lex_state = 15},
  [7670] = {.lex_state = 0, .external_lex_state = 13},
  [7671] = {.lex_state = 0, .external_lex_state = 15},
  [7672] = {.lex_state = 202, .external_lex_state = 5},
  [7673] = {.lex_state = 199, .external_lex_state = 5},
  [7674] = {.lex_state = 199, .external_lex_state = 5},
  [7675] = {.lex_state = 1, .external_lex_state = 13},
  [7676] = {.lex_state = 181, .external_lex_state = 5},
  [7677] = {.lex_state = 199, .external_lex_state = 5},
  [7678] = {.lex_state = 0, .external_lex_state = 11},
  [7679] = {.lex_state = 0, .external_lex_state = 15},
  [7680] = {.lex_state = 202, .external_lex_state = 5},
  [7681] = {.lex_state = 199, .external_lex_state = 5},
  [7682] = {.lex_state = 0, .external_lex_state = 15},
  [7683] = {.lex_state = 199, .external_lex_state = 5},
  [7684] = {.lex_state = 0, .external_lex_state = 15},
  [7685] = {.lex_state = 181, .external_lex_state = 13},
  [7686] = {.lex_state = 181, .external_lex_state = 16},
  [7687] = {.lex_state = 0, .external_lex_state = 15},
  [7688] = {.lex_state = 199, .external_lex_state = 5},
  [7689] = {.lex_state = 199, .external_lex_state = 5},
  [7690] = {.lex_state = 0, .external_lex_state = 10},
  [7691] = {.lex_state = 0, .external_lex_state = 15},
  [7692] = {.lex_state = 0, .external_lex_state = 15},
  [7693] = {.lex_state = 0, .external_lex_state = 15},
  [7694] = {.lex_state = 0, .external_lex_state = 15},
  [7695] = {.lex_state = 0, .external_lex_state = 15},
  [7696] = {.lex_state = 181, .external_lex_state = 5},
  [7697] = {.lex_state = 199, .external_lex_state = 5},
  [7698] = {.lex_state = 0, .external_lex_state = 15},
  [7699] = {.lex_state = 199, .external_lex_state = 5},
  [7700] = {.lex_state = 0, .external_lex_state = 15},
  [7701] = {.lex_state = 0, .external_lex_state = 15},
  [7702] = {.lex_state = 0, .external_lex_state = 15},
  [7703] = {.lex_state = 0, .external_lex_state = 15},
  [7704] = {.lex_state = 0, .external_lex_state = 15},
  [7705] = {.lex_state = 181, .external_lex_state = 5},
  [7706] = {.lex_state = 0, .external_lex_state = 20},
  [7707] = {.lex_state = 0, .external_lex_state = 15},
  [7708] = {.lex_state = 0, .external_lex_state = 15},
  [7709] = {.lex_state = 0, .external_lex_state = 15},
  [7710] = {.lex_state = 0, .external_lex_state = 15},
  [7711] = {.lex_state = 181, .external_lex_state = 5},
  [7712] = {.lex_state = 199, .external_lex_state = 5},
  [7713] = {.lex_state = 0, .external_lex_state = 15},
  [7714] = {.lex_state = 181, .external_lex_state = 5},
  [7715] = {.lex_state = 0, .external_lex_state = 15},
  [7716] = {.lex_state = 199, .external_lex_state = 5},
  [7717] = {.lex_state = 0, .external_lex_state = 15},
  [7718] = {.lex_state = 199, .external_lex_state = 5},
  [7719] = {.lex_state = 181, .external_lex_state = 5},
  [7720] = {.lex_state = 199, .external_lex_state = 5},
  [7721] = {.lex_state = 0, .external_lex_state = 15},
  [7722] = {.lex_state = 202, .external_lex_state = 5},
  [7723] = {.lex_state = 0, .external_lex_state = 15},
  [7724] = {.lex_state = 0, .external_lex_state = 43},
  [7725] = {.lex_state = 181, .external_lex_state = 5},
  [7726] = {.lex_state = 199, .external_lex_state = 5},
  [7727] = {.lex_state = 183, .external_lex_state = 20},
  [7728] = {.lex_state = 199, .external_lex_state = 5},
  [7729] = {.lex_state = 202, .external_lex_state = 5},
  [7730] = {.lex_state = 199, .external_lex_state = 5},
  [7731] = {.lex_state = 0, .external_lex_state = 43},
  [7732] = {.lex_state = 202, .external_lex_state = 5},
  [7733] = {.lex_state = 0, .external_lex_state = 44},
  [7734] = {.lex_state = 0, .external_lex_state = 10},
  [7735] = {.lex_state = 202, .external_lex_state = 5},
  [7736] = {.lex_state = 0, .external_lex_state = 15},
  [7737] = {.lex_state = 199, .external_lex_state = 14},
  [7738] = {.lex_state = 199, .external_lex_state = 5},
  [7739] = {.lex_state = 199, .external_lex_state = 5},
  [7740] = {.lex_state = 0, .external_lex_state = 11},
  [7741] = {.lex_state = 181, .external_lex_state = 5},
  [7742] = {.lex_state = 202, .external_lex_state = 5},
  [7743] = {.lex_state = 0, .external_lex_state = 15},
  [7744] = {.lex_state = 0, .external_lex_state = 15},
  [7745] = {.lex_state = 183, .external_lex_state = 5},
  [7746] = {.lex_state = 0, .external_lex_state = 11},
  [7747] = {.lex_state = 0, .external_lex_state = 15},
  [7748] = {.lex_state = 199, .external_lex_state = 5},
  [7749] = {.lex_state = 0, .external_lex_state = 15},
  [7750] = {.lex_state = 0, .external_lex_state = 15},
  [7751] = {.lex_state = 202, .external_lex_state = 5},
  [7752] = {.lex_state = 0, .external_lex_state = 15},
  [7753] = {.lex_state = 0, .external_lex_state = 10},
  [7754] = {.lex_state = 199, .external_lex_state = 5},
  [7755] = {.lex_state = 199, .external_lex_state = 5},
  [7756] = {.lex_state = 199, .external_lex_state = 5},
  [7757] = {.lex_state = 0, .external_lex_state = 20},
  [7758] = {.lex_state = 181, .external_lex_state = 5},
  [7759] = {.lex_state = 0, .external_lex_state = 15},
  [7760] = {.lex_state = 0, .external_lex_state = 19},
  [7761] = {.lex_state = 0, .external_lex_state = 15},
  [7762] = {.lex_state = 0, .external_lex_state = 15},
  [7763] = {.lex_state = 0, .external_lex_state = 10},
  [7764] = {.lex_state = 199, .external_lex_state = 5},
  [7765] = {.lex_state = 0, .external_lex_state = 15},
  [7766] = {.lex_state = 183, .external_lex_state = 15},
  [7767] = {.lex_state = 199, .external_lex_state = 5},
  [7768] = {.lex_state = 0, .external_lex_state = 21},
  [7769] = {.lex_state = 0, .external_lex_state = 10},
  [7770] = {.lex_state = 199, .external_lex_state = 5},
  [7771] = {.lex_state = 181, .external_lex_state = 5},
  [7772] = {.lex_state = 199, .external_lex_state = 5},
  [7773] = {.lex_state = 0, .external_lex_state = 15},
  [7774] = {.lex_state = 199, .external_lex_state = 5},
  [7775] = {.lex_state = 0, .external_lex_state = 15},
  [7776] = {.lex_state = 199, .external_lex_state = 5},
  [7777] = {.lex_state = 202, .external_lex_state = 5},
  [7778] = {.lex_state = 1, .external_lex_state = 5},
  [7779] = {.lex_state = 0, .external_lex_state = 15},
  [7780] = {.lex_state = 0, .external_lex_state = 15},
  [7781] = {.lex_state = 181, .external_lex_state = 5},
  [7782] = {.lex_state = 0, .external_lex_state = 19},
  [7783] = {.lex_state = 183, .external_lex_state = 20},
  [7784] = {.lex_state = 199, .external_lex_state = 5},
  [7785] = {.lex_state = 0, .external_lex_state = 15},
  [7786] = {.lex_state = 0, .external_lex_state = 15},
  [7787] = {.lex_state = 0, .external_lex_state = 15},
  [7788] = {.lex_state = 0, .external_lex_state = 15},
  [7789] = {.lex_state = 0, .external_lex_state = 15},
  [7790] = {.lex_state = 0, .external_lex_state = 15},
  [7791] = {.lex_state = 0, .external_lex_state = 15},
  [7792] = {.lex_state = 199, .external_lex_state = 5},
  [7793] = {.lex_state = 202, .external_lex_state = 5},
  [7794] = {.lex_state = 199, .external_lex_state = 5},
  [7795] = {.lex_state = 0, .external_lex_state = 15},
  [7796] = {.lex_state = 199, .external_lex_state = 5},
  [7797] = {.lex_state = 199, .external_lex_state = 5},
  [7798] = {.lex_state = 0, .external_lex_state = 15},
  [7799] = {.lex_state = 0, .external_lex_state = 15},
  [7800] = {.lex_state = 0, .external_lex_state = 15},
  [7801] = {.lex_state = 0, .external_lex_state = 15},
  [7802] = {.lex_state = 202, .external_lex_state = 5},
  [7803] = {.lex_state = 0, .external_lex_state = 15},
  [7804] = {.lex_state = 0, .external_lex_state = 13},
  [7805] = {.lex_state = 0, .external_lex_state = 15},
  [7806] = {.lex_state = 181, .external_lex_state = 5},
  [7807] = {.lex_state = 0, .external_lex_state = 15},
  [7808] = {.lex_state = 0, .external_lex_state = 15},
  [7809] = {.lex_state = 0, .external_lex_state = 15},
  [7810] = {.lex_state = 199, .external_lex_state = 5},
  [7811] = {.lex_state = 0, .external_lex_state = 15},
  [7812] = {.lex_state = 0, .external_lex_state = 15},
  [7813] = {.lex_state = 199, .external_lex_state = 14},
  [7814] = {.lex_state = 0, .external_lex_state = 15},
  [7815] = {.lex_state = 0, .external_lex_state = 15},
  [7816] = {.lex_state = 0, .external_lex_state = 15},
  [7817] = {.lex_state = 0, .external_lex_state = 15},
  [7818] = {.lex_state = 0, .external_lex_state = 15},
  [7819] = {.lex_state = 0, .external_lex_state = 15},
  [7820] = {.lex_state = 0, .external_lex_state = 15},
  [7821] = {.lex_state = 181, .external_lex_state = 5},
  [7822] = {.lex_state = 0, .external_lex_state = 15},
  [7823] = {.lex_state = 0, .external_lex_state = 11},
  [7824] = {.lex_state = 0, .external_lex_state = 15},
  [7825] = {.lex_state = 0, .external_lex_state = 15},
  [7826] = {.lex_state = 0, .external_lex_state = 44},
  [7827] = {.lex_state = 202, .external_lex_state = 5},
  [7828] = {.lex_state = 199, .external_lex_state = 5},
  [7829] = {.lex_state = 181, .external_lex_state = 20},
  [7830] = {.lex_state = 0, .external_lex_state = 15},
  [7831] = {.lex_state = 0, .external_lex_state = 15},
  [7832] = {.lex_state = 0, .external_lex_state = 15},
  [7833] = {.lex_state = 181, .external_lex_state = 5},
  [7834] = {.lex_state = 0, .external_lex_state = 10},
  [7835] = {.lex_state = 0, .external_lex_state = 15},
  [7836] = {.lex_state = 0, .external_lex_state = 15},
  [7837] = {.lex_state = 0, .external_lex_state = 15},
  [7838] = {.lex_state = 0, .external_lex_state = 15},
  [7839] = {.lex_state = 199, .external_lex_state = 5},
  [7840] = {.lex_state = 181, .external_lex_state = 5},
  [7841] = {.lex_state = 0, .external_lex_state = 15},
  [7842] = {.lex_state = 0, .external_lex_state = 15},
  [7843] = {.lex_state = 0, .external_lex_state = 15},
  [7844] = {.lex_state = 183, .external_lex_state = 15},
  [7845] = {.lex_state = 181, .external_lex_state = 5},
  [7846] = {.lex_state = 202, .external_lex_state = 5},
  [7847] = {.lex_state = 199, .external_lex_state = 5},
  [7848] = {.lex_state = 0, .external_lex_state = 15},
  [7849] = {.lex_state = 199, .external_lex_state = 5},
  [7850] = {.lex_state = 0, .external_lex_state = 15},
  [7851] = {.lex_state = 0, .external_lex_state = 21},
  [7852] = {.lex_state = 202, .external_lex_state = 5},
  [7853] = {.lex_state = 199, .external_lex_state = 5},
  [7854] = {.lex_state = 0, .external_lex_state = 15},
  [7855] = {.lex_state = 199, .external_lex_state = 5},
  [7856] = {.lex_state = 0, .external_lex_state = 21},
  [7857] = {.lex_state = 181, .external_lex_state = 5},
  [7858] = {.lex_state = 202, .external_lex_state = 5},
  [7859] = {.lex_state = 0, .external_lex_state = 15},
  [7860] = {.lex_state = 183, .external_lex_state = 20},
  [7861] = {.lex_state = 199, .external_lex_state = 5},
  [7862] = {.lex_state = 199, .external_lex_state = 5},
  [7863] = {.lex_state = 0, .external_lex_state = 15},
  [7864] = {.lex_state = 0, .external_lex_state = 13},
  [7865] = {.lex_state = 0, .external_lex_state = 15},
  [7866] = {.lex_state = 181, .external_lex_state = 5},
  [7867] = {.lex_state = 0, .external_lex_state = 15},
  [7868] = {.lex_state = 181, .external_lex_state = 5},
  [7869] = {.lex_state = 181, .external_lex_state = 5},
  [7870] = {.lex_state = 181, .external_lex_state = 5},
  [7871] = {.lex_state = 183, .external_lex_state = 5},
  [7872] = {.lex_state = 0, .external_lex_state = 15},
  [7873] = {.lex_state = 0, .external_lex_state = 15},
  [7874] = {.lex_state = 199, .external_lex_state = 5},
  [7875] = {.lex_state = 202, .external_lex_state = 5},
  [7876] = {.lex_state = 0, .external_lex_state = 15},
  [7877] = {.lex_state = 202, .external_lex_state = 5},
  [7878] = {.lex_state = 0, .external_lex_state = 15},
  [7879] = {.lex_state = 202, .external_lex_state = 5},
  [7880] = {.lex_state = 202, .external_lex_state = 5},
  [7881] = {.lex_state = 0, .external_lex_state = 15},
  [7882] = {.lex_state = 202, .external_lex_state = 5},
  [7883] = {.lex_state = 202, .external_lex_state = 5},
  [7884] = {.lex_state = 199, .external_lex_state = 5},
  [7885] = {.lex_state = 181, .external_lex_state = 5},
  [7886] = {.lex_state = 202, .external_lex_state = 5},
  [7887] = {.lex_state = 0, .external_lex_state = 15},
  [7888] = {.lex_state = 0, .external_lex_state = 15},
  [7889] = {.lex_state = 0, .external_lex_state = 15},
  [7890] = {.lex_state = 199, .external_lex_state = 5},
  [7891] = {.lex_state = 202, .external_lex_state = 5},
  [7892] = {.lex_state = 199, .external_lex_state = 5},
  [7893] = {.lex_state = 0, .external_lex_state = 15},
  [7894] = {.lex_state = 0, .external_lex_state = 15},
  [7895] = {.lex_state = 199, .external_lex_state = 5},
  [7896] = {.lex_state = 0, .external_lex_state = 15},
  [7897] = {.lex_state = 199, .external_lex_state = 5},
  [7898] = {.lex_state = 199, .external_lex_state = 5},
  [7899] = {.lex_state = 202, .external_lex_state = 5},
  [7900] = {.lex_state = 202, .external_lex_state = 5},
  [7901] = {.lex_state = 202, .external_lex_state = 5},
  [7902] = {.lex_state = 202, .external_lex_state = 5},
  [7903] = {.lex_state = 202, .external_lex_state = 5},
  [7904] = {.lex_state = 199, .external_lex_state = 5},
  [7905] = {.lex_state = 199, .external_lex_state = 5},
  [7906] = {.lex_state = 0, .external_lex_state = 15},
  [7907] = {.lex_state = 199, .external_lex_state = 5},
  [7908] = {.lex_state = 202, .external_lex_state = 5},
  [7909] = {.lex_state = 202, .external_lex_state = 5},
  [7910] = {.lex_state = 0, .external_lex_state = 10},
  [7911] = {.lex_state = 199, .external_lex_state = 5},
  [7912] = {.lex_state = 0, .external_lex_state = 15},
  [7913] = {.lex_state = 0, .external_lex_state = 10},
  [7914] = {.lex_state = 183, .external_lex_state = 15},
  [7915] = {.lex_state = 0, .external_lex_state = 21},
  [7916] = {.lex_state = 181, .external_lex_state = 5},
  [7917] = {.lex_state = 202, .external_lex_state = 5},
  [7918] = {.lex_state = 0, .external_lex_state = 13},
  [7919] = {.lex_state = 199, .external_lex_state = 12},
  [7920] = {.lex_state = 0, .external_lex_state = 15},
  [7921] = {.lex_state = 0, .external_lex_state = 15},
  [7922] = {.lex_state = 0, .external_lex_state = 15},
  [7923] = {.lex_state = 0, .external_lex_state = 15},
  [7924] = {.lex_state = 181, .external_lex_state = 5},
  [7925] = {.lex_state = 0, .external_lex_state = 15},
  [7926] = {.lex_state = 0, .external_lex_state = 15},
  [7927] = {.lex_state = 0, .external_lex_state = 15},
  [7928] = {.lex_state = 199, .external_lex_state = 5},
  [7929] = {.lex_state = 0, .external_lex_state = 15},
  [7930] = {.lex_state = 202, .external_lex_state = 5},
  [7931] = {.lex_state = 181, .external_lex_state = 5},
  [7932] = {.lex_state = 181, .external_lex_state = 5},
  [7933] = {.lex_state = 202, .external_lex_state = 5},
  [7934] = {.lex_state = 181, .external_lex_state = 5},
  [7935] = {.lex_state = 202, .external_lex_state = 5},
  [7936] = {.lex_state = 199, .external_lex_state = 5},
  [7937] = {.lex_state = 0, .external_lex_state = 15},
  [7938] = {.lex_state = 183, .external_lex_state = 5},
  [7939] = {.lex_state = 202, .external_lex_state = 5},
  [7940] = {.lex_state = 0, .external_lex_state = 15},
  [7941] = {.lex_state = 0, .external_lex_state = 19},
  [7942] = {.lex_state = 0, .external_lex_state = 15},
  [7943] = {.lex_state = 0, .external_lex_state = 15},
  [7944] = {.lex_state = 0, .external_lex_state = 20},
  [7945] = {.lex_state = 0, .external_lex_state = 15},
  [7946] = {.lex_state = 0, .external_lex_state = 10},
  [7947] = {.lex_state = 199, .external_lex_state = 5},
  [7948] = {.lex_state = 199, .external_lex_state = 5},
  [7949] = {.lex_state = 199, .external_lex_state = 5},
  [7950] = {.lex_state = 181, .external_lex_state = 5},
  [7951] = {.lex_state = 199, .external_lex_state = 5},
  [7952] = {.lex_state = 0, .external_lex_state = 15},
  [7953] = {.lex_state = 0, .external_lex_state = 10},
  [7954] = {.lex_state = 199, .external_lex_state = 5},
  [7955] = {.lex_state = 181, .external_lex_state = 5},
  [7956] = {.lex_state = 199, .external_lex_state = 5},
  [7957] = {.lex_state = 183, .external_lex_state = 5},
  [7958] = {.lex_state = 181, .external_lex_state = 5},
  [7959] = {.lex_state = 0, .external_lex_state = 15},
  [7960] = {.lex_state = 0, .external_lex_state = 15},
  [7961] = {.lex_state = 0, .external_lex_state = 15},
  [7962] = {.lex_state = 0, .external_lex_state = 15},
  [7963] = {.lex_state = 199, .external_lex_state = 5},
  [7964] = {.lex_state = 199, .external_lex_state = 5},
  [7965] = {.lex_state = 199, .external_lex_state = 5},
  [7966] = {.lex_state = 199, .external_lex_state = 5},
  [7967] = {.lex_state = 199, .external_lex_state = 5},
  [7968] = {.lex_state = 199, .external_lex_state = 5},
  [7969] = {.lex_state = 183, .external_lex_state = 15},
  [7970] = {.lex_state = 0, .external_lex_state = 15},
  [7971] = {.lex_state = 199, .external_lex_state = 5},
  [7972] = {.lex_state = 0, .external_lex_state = 15},
  [7973] = {.lex_state = 199, .external_lex_state = 5},
  [7974] = {.lex_state = 0, .external_lex_state = 15},
  [7975] = {.lex_state = 199, .external_lex_state = 5},
  [7976] = {.lex_state = 199, .external_lex_state = 5},
  [7977] = {.lex_state = 0, .external_lex_state = 15},
  [7978] = {.lex_state = 199, .external_lex_state = 5},
  [7979] = {.lex_state = 199, .external_lex_state = 14},
  [7980] = {.lex_state = 181, .external_lex_state = 5},
  [7981] = {.lex_state = 0, .external_lex_state = 15},
  [7982] = {.lex_state = 0, .external_lex_state = 15},
  [7983] = {.lex_state = 0, .external_lex_state = 15},
  [7984] = {.lex_state = 199, .external_lex_state = 5},
  [7985] = {.lex_state = 0, .external_lex_state = 15},
  [7986] = {.lex_state = 0, .external_lex_state = 15},
  [7987] = {.lex_state = 199, .external_lex_state = 5},
  [7988] = {.lex_state = 0, .external_lex_state = 15},
  [7989] = {.lex_state = 0, .external_lex_state = 15},
  [7990] = {.lex_state = 181, .external_lex_state = 5},
  [7991] = {.lex_state = 199, .external_lex_state = 5},
  [7992] = {.lex_state = 181, .external_lex_state = 5},
  [7993] = {.lex_state = 0, .external_lex_state = 15},
  [7994] = {.lex_state = 0, .external_lex_state = 15},
  [7995] = {.lex_state = 199, .external_lex_state = 5},
  [7996] = {.lex_state = 199, .external_lex_state = 5},
  [7997] = {.lex_state = 199, .external_lex_state = 5},
  [7998] = {.lex_state = 0, .external_lex_state = 15},
  [7999] = {.lex_state = 0, .external_lex_state = 15},
  [8000] = {.lex_state = 0, .external_lex_state = 15},
  [8001] = {.lex_state = 0, .external_lex_state = 15},
  [8002] = {.lex_state = 199, .external_lex_state = 5},
  [8003] = {.lex_state = 0, .external_lex_state = 15},
  [8004] = {.lex_state = 199, .external_lex_state = 5},
  [8005] = {.lex_state = 199, .external_lex_state = 5},
  [8006] = {.lex_state = 183, .external_lex_state = 15},
  [8007] = {.lex_state = 199, .external_lex_state = 5},
  [8008] = {.lex_state = 199, .external_lex_state = 5},
  [8009] = {.lex_state = 199, .external_lex_state = 5},
  [8010] = {.lex_state = 199, .external_lex_state = 5},
  [8011] = {.lex_state = 181, .external_lex_state = 5},
  [8012] = {.lex_state = 0, .external_lex_state = 15},
  [8013] = {.lex_state = 0, .external_lex_state = 15},
  [8014] = {.lex_state = 199, .external_lex_state = 5},
  [8015] = {.lex_state = 0, .external_lex_state = 15},
  [8016] = {.lex_state = 0, .external_lex_state = 15},
  [8017] = {.lex_state = 0, .external_lex_state = 15},
  [8018] = {.lex_state = 199, .external_lex_state = 5},
  [8019] = {.lex_state = 0, .external_lex_state = 15},
  [8020] = {.lex_state = 0, .external_lex_state = 15},
  [8021] = {.lex_state = 0, .external_lex_state = 15},
  [8022] = {.lex_state = 199, .external_lex_state = 5},
  [8023] = {.lex_state = 0, .external_lex_state = 15},
  [8024] = {.lex_state = 0, .external_lex_state = 15},
  [8025] = {.lex_state = 0, .external_lex_state = 15},
  [8026] = {.lex_state = 199, .external_lex_state = 5},
  [8027] = {.lex_state = 0, .external_lex_state = 15},
  [8028] = {.lex_state = 181, .external_lex_state = 5},
  [8029] = {.lex_state = 199, .external_lex_state = 5},
  [8030] = {.lex_state = 0, .external_lex_state = 15},
  [8031] = {.lex_state = 181, .external_lex_state = 5},
  [8032] = {.lex_state = 199, .external_lex_state = 5},
  [8033] = {.lex_state = 0, .external_lex_state = 15},
  [8034] = {.lex_state = 199, .external_lex_state = 5},
  [8035] = {.lex_state = 0, .external_lex_state = 15},
  [8036] = {.lex_state = 0, .external_lex_state = 13},
  [8037] = {.lex_state = 181, .external_lex_state = 5},
  [8038] = {.lex_state = 0, .external_lex_state = 13},
  [8039] = {.lex_state = 0, .external_lex_state = 13},
  [8040] = {.lex_state = 0, .external_lex_state = 13},
  [8041] = {.lex_state = 0, .external_lex_state = 13},
  [8042] = {.lex_state = 0, .external_lex_state = 13},
  [8043] = {.lex_state = 0, .external_lex_state = 13},
  [8044] = {.lex_state = 0, .external_lex_state = 13},
  [8045] = {.lex_state = 199, .external_lex_state = 5},
  [8046] = {.lex_state = 199, .external_lex_state = 5},
  [8047] = {.lex_state = 0, .external_lex_state = 13},
  [8048] = {.lex_state = 0, .external_lex_state = 15},
  [8049] = {.lex_state = 0, .external_lex_state = 13},
  [8050] = {.lex_state = 0, .external_lex_state = 15},
  [8051] = {.lex_state = 0, .external_lex_state = 15},
  [8052] = {.lex_state = 0, .external_lex_state = 13},
  [8053] = {.lex_state = 199, .external_lex_state = 5},
  [8054] = {.lex_state = 21, .external_lex_state = 5},
  [8055] = {.lex_state = 0, .external_lex_state = 15},
  [8056] = {.lex_state = 0, .external_lex_state = 15},
  [8057] = {.lex_state = 0, .external_lex_state = 13},
  [8058] = {.lex_state = 0, .external_lex_state = 15},
  [8059] = {.lex_state = 0, .external_lex_state = 15},
  [8060] = {.lex_state = 0, .external_lex_state = 15},
  [8061] = {.lex_state = 0, .external_lex_state = 13},
  [8062] = {.lex_state = 0, .external_lex_state = 13},
  [8063] = {.lex_state = 0, .external_lex_state = 13},
  [8064] = {.lex_state = 199, .external_lex_state = 5},
  [8065] = {.lex_state = 0, .external_lex_state = 5},
  [8066] = {.lex_state = 0, .external_lex_state = 15},
  [8067] = {.lex_state = 181, .external_lex_state = 5},
  [8068] = {.lex_state = 181, .external_lex_state = 5},
  [8069] = {.lex_state = 0, .external_lex_state = 15},
  [8070] = {.lex_state = 181, .external_lex_state = 5},
  [8071] = {.lex_state = 199, .external_lex_state = 14},
  [8072] = {.lex_state = 0, .external_lex_state = 15},
  [8073] = {.lex_state = 181, .external_lex_state = 5},
  [8074] = {.lex_state = 199, .external_lex_state = 5},
  [8075] = {.lex_state = 0, .external_lex_state = 15},
  [8076] = {.lex_state = 0, .external_lex_state = 13},
  [8077] = {.lex_state = 0, .external_lex_state = 45},
  [8078] = {.lex_state = 0, .external_lex_state = 13},
  [8079] = {.lex_state = 0, .external_lex_state = 13},
  [8080] = {.lex_state = 0, .external_lex_state = 31},
  [8081] = {.lex_state = 0, .external_lex_state = 13},
  [8082] = {.lex_state = 0, .external_lex_state = 15},
  [8083] = {.lex_state = 0, .external_lex_state = 13},
  [8084] = {.lex_state = 0, .external_lex_state = 13},
  [8085] = {.lex_state = 0, .external_lex_state = 13},
  [8086] = {.lex_state = 199, .external_lex_state = 14},
  [8087] = {.lex_state = 0, .external_lex_state = 15},
  [8088] = {.lex_state = 21, .external_lex_state = 5},
  [8089] = {.lex_state = 0, .external_lex_state = 13},
  [8090] = {.lex_state = 199, .external_lex_state = 5},
  [8091] = {.lex_state = 21, .external_lex_state = 5},
  [8092] = {.lex_state = 0, .external_lex_state = 20},
  [8093] = {.lex_state = 0, .external_lex_state = 13},
  [8094] = {.lex_state = 0, .external_lex_state = 13},
  [8095] = {.lex_state = 0, .external_lex_state = 13},
  [8096] = {.lex_state = 0, .external_lex_state = 13},
  [8097] = {.lex_state = 183, .external_lex_state = 5},
  [8098] = {.lex_state = 0, .external_lex_state = 13},
  [8099] = {.lex_state = 0, .external_lex_state = 13},
  [8100] = {.lex_state = 0, .external_lex_state = 13},
  [8101] = {.lex_state = 0, .external_lex_state = 15},
  [8102] = {.lex_state = 0, .external_lex_state = 13},
  [8103] = {.lex_state = 0, .external_lex_state = 13},
  [8104] = {.lex_state = 1, .external_lex_state = 13},
  [8105] = {.lex_state = 0, .external_lex_state = 13},
  [8106] = {.lex_state = 199, .external_lex_state = 14},
  [8107] = {.lex_state = 1, .external_lex_state = 13},
  [8108] = {.lex_state = 0, .external_lex_state = 13},
  [8109] = {.lex_state = 0, .external_lex_state = 13},
  [8110] = {.lex_state = 199, .external_lex_state = 14},
  [8111] = {.lex_state = 0, .external_lex_state = 15},
  [8112] = {.lex_state = 0, .external_lex_state = 13},
  [8113] = {.lex_state = 0, .external_lex_state = 13},
  [8114] = {.lex_state = 0, .external_lex_state = 15},
  [8115] = {.lex_state = 0, .external_lex_state = 13},
  [8116] = {.lex_state = 0, .external_lex_state = 15},
  [8117] = {.lex_state = 0, .external_lex_state = 15},
  [8118] = {.lex_state = 0, .external_lex_state = 13},
  [8119] = {.lex_state = 0, .external_lex_state = 13},
  [8120] = {.lex_state = 99, .external_lex_state = 5},
  [8121] = {.lex_state = 0, .external_lex_state = 13},
  [8122] = {.lex_state = 0, .external_lex_state = 15},
  [8123] = {.lex_state = 0, .external_lex_state = 13},
  [8124] = {.lex_state = 199, .external_lex_state = 14},
  [8125] = {.lex_state = 199, .external_lex_state = 14},
  [8126] = {.lex_state = 0, .external_lex_state = 5},
  [8127] = {.lex_state = 0, .external_lex_state = 13},
  [8128] = {.lex_state = 181, .external_lex_state = 5},
  [8129] = {.lex_state = 181, .external_lex_state = 5},
  [8130] = {.lex_state = 0, .external_lex_state = 13},
  [8131] = {.lex_state = 199, .external_lex_state = 14},
  [8132] = {.lex_state = 0, .external_lex_state = 13},
  [8133] = {.lex_state = 0, .external_lex_state = 20},
  [8134] = {.lex_state = 199, .external_lex_state = 14},
  [8135] = {.lex_state = 0, .external_lex_state = 13},
  [8136] = {.lex_state = 0, .external_lex_state = 46},
  [8137] = {.lex_state = 0, .external_lex_state = 13},
  [8138] = {.lex_state = 181, .external_lex_state = 5},
  [8139] = {.lex_state = 0, .external_lex_state = 13},
  [8140] = {.lex_state = 0, .external_lex_state = 13},
  [8141] = {.lex_state = 181, .external_lex_state = 5},
  [8142] = {.lex_state = 0, .external_lex_state = 31},
  [8143] = {.lex_state = 0, .external_lex_state = 13},
  [8144] = {.lex_state = 1, .external_lex_state = 5},
  [8145] = {.lex_state = 0, .external_lex_state = 13},
  [8146] = {.lex_state = 0, .external_lex_state = 13},
  [8147] = {.lex_state = 0, .external_lex_state = 13},
  [8148] = {.lex_state = 0, .external_lex_state = 20},
  [8149] = {.lex_state = 0, .external_lex_state = 13},
  [8150] = {.lex_state = 0, .external_lex_state = 13},
  [8151] = {.lex_state = 0, .external_lex_state = 13},
  [8152] = {.lex_state = 0, .external_lex_state = 13},
  [8153] = {.lex_state = 0, .external_lex_state = 13},
  [8154] = {.lex_state = 0, .external_lex_state = 13},
  [8155] = {.lex_state = 0, .external_lex_state = 20},
  [8156] = {.lex_state = 0, .external_lex_state = 20},
  [8157] = {.lex_state = 0, .external_lex_state = 15},
  [8158] = {.lex_state = 0, .external_lex_state = 13},
  [8159] = {.lex_state = 0, .external_lex_state = 13},
  [8160] = {.lex_state = 0, .external_lex_state = 15},
  [8161] = {.lex_state = 0, .external_lex_state = 13},
  [8162] = {.lex_state = 0, .external_lex_state = 20},
  [8163] = {.lex_state = 0, .external_lex_state = 15},
  [8164] = {.lex_state = 199, .external_lex_state = 5},
  [8165] = {.lex_state = 0, .external_lex_state = 13},
  [8166] = {.lex_state = 0, .external_lex_state = 13},
  [8167] = {.lex_state = 0, .external_lex_state = 15},
  [8168] = {.lex_state = 0, .external_lex_state = 13},
  [8169] = {.lex_state = 0, .external_lex_state = 13},
  [8170] = {.lex_state = 0, .external_lex_state = 13},
  [8171] = {.lex_state = 205, .external_lex_state = 5},
  [8172] = {.lex_state = 199, .external_lex_state = 5},
  [8173] = {.lex_state = 199, .external_lex_state = 5},
  [8174] = {.lex_state = 0, .external_lex_state = 13},
  [8175] = {.lex_state = 0, .external_lex_state = 13},
  [8176] = {.lex_state = 0, .external_lex_state = 15},
  [8177] = {.lex_state = 181, .external_lex_state = 5},
  [8178] = {.lex_state = 199, .external_lex_state = 14},
  [8179] = {.lex_state = 0, .external_lex_state = 15},
  [8180] = {.lex_state = 181, .external_lex_state = 5},
  [8181] = {.lex_state = 0, .external_lex_state = 20},
  [8182] = {.lex_state = 0, .external_lex_state = 13},
  [8183] = {.lex_state = 199, .external_lex_state = 5},
  [8184] = {.lex_state = 0, .external_lex_state = 20},
  [8185] = {.lex_state = 0, .external_lex_state = 13},
  [8186] = {.lex_state = 181, .external_lex_state = 5},
  [8187] = {.lex_state = 0, .external_lex_state = 13},
  [8188] = {.lex_state = 0, .external_lex_state = 13},
  [8189] = {.lex_state = 0, .external_lex_state = 13},
  [8190] = {.lex_state = 0, .external_lex_state = 13},
  [8191] = {.lex_state = 0, .external_lex_state = 13},
  [8192] = {.lex_state = 0, .external_lex_state = 13},
  [8193] = {.lex_state = 0, .external_lex_state = 15},
  [8194] = {.lex_state = 0, .external_lex_state = 15},
  [8195] = {.lex_state = 0, .external_lex_state = 13},
  [8196] = {.lex_state = 0, .external_lex_state = 13},
  [8197] = {.lex_state = 0, .external_lex_state = 13},
  [8198] = {.lex_state = 0, .external_lex_state = 13},
  [8199] = {.lex_state = 0, .external_lex_state = 13},
  [8200] = {.lex_state = 0, .external_lex_state = 13},
  [8201] = {.lex_state = 0, .external_lex_state = 13},
  [8202] = {.lex_state = 0, .external_lex_state = 13},
  [8203] = {.lex_state = 0, .external_lex_state = 13},
  [8204] = {.lex_state = 0, .external_lex_state = 13},
  [8205] = {.lex_state = 0, .external_lex_state = 13},
  [8206] = {.lex_state = 0, .external_lex_state = 13},
  [8207] = {.lex_state = 0, .external_lex_state = 13},
  [8208] = {.lex_state = 0, .external_lex_state = 20},
  [8209] = {.lex_state = 0, .external_lex_state = 13},
  [8210] = {.lex_state = 0, .external_lex_state = 13},
  [8211] = {.lex_state = 199, .external_lex_state = 14},
  [8212] = {.lex_state = 181, .external_lex_state = 5},
  [8213] = {.lex_state = 0, .external_lex_state = 20},
  [8214] = {.lex_state = 0, .external_lex_state = 13},
  [8215] = {.lex_state = 0, .external_lex_state = 15},
  [8216] = {.lex_state = 0, .external_lex_state = 15},
  [8217] = {.lex_state = 0, .external_lex_state = 15},
  [8218] = {.lex_state = 0, .external_lex_state = 15},
  [8219] = {.lex_state = 0, .external_lex_state = 15},
  [8220] = {.lex_state = 0, .external_lex_state = 13},
  [8221] = {.lex_state = 0, .external_lex_state = 13},
  [8222] = {.lex_state = 0, .external_lex_state = 15},
  [8223] = {.lex_state = 0, .external_lex_state = 13},
  [8224] = {.lex_state = 0, .external_lex_state = 13},
  [8225] = {.lex_state = 0, .external_lex_state = 13},
  [8226] = {.lex_state = 199, .external_lex_state = 5},
  [8227] = {.lex_state = 0, .external_lex_state = 13},
  [8228] = {.lex_state = 0, .external_lex_state = 13},
  [8229] = {.lex_state = 199, .external_lex_state = 14},
  [8230] = {.lex_state = 0, .external_lex_state = 13},
  [8231] = {.lex_state = 181, .external_lex_state = 5},
  [8232] = {.lex_state = 0, .external_lex_state = 13},
  [8233] = {.lex_state = 0, .external_lex_state = 13},
  [8234] = {.lex_state = 0, .external_lex_state = 13},
  [8235] = {.lex_state = 0, .external_lex_state = 13},
  [8236] = {.lex_state = 0, .external_lex_state = 13},
  [8237] = {.lex_state = 0, .external_lex_state = 13},
  [8238] = {.lex_state = 0, .external_lex_state = 13},
  [8239] = {.lex_state = 199, .external_lex_state = 5},
  [8240] = {.lex_state = 0, .external_lex_state = 13},
  [8241] = {.lex_state = 0, .external_lex_state = 13},
  [8242] = {.lex_state = 0, .external_lex_state = 13},
  [8243] = {.lex_state = 0, .external_lex_state = 13},
  [8244] = {.lex_state = 181, .external_lex_state = 5},
  [8245] = {.lex_state = 0, .external_lex_state = 15},
  [8246] = {.lex_state = 1, .external_lex_state = 5},
  [8247] = {.lex_state = 0, .external_lex_state = 20},
  [8248] = {.lex_state = 0, .external_lex_state = 20},
  [8249] = {.lex_state = 0, .external_lex_state = 13},
  [8250] = {.lex_state = 0, .external_lex_state = 13},
  [8251] = {.lex_state = 0, .external_lex_state = 20},
  [8252] = {.lex_state = 0, .external_lex_state = 13},
  [8253] = {.lex_state = 0, .external_lex_state = 13},
  [8254] = {.lex_state = 0, .external_lex_state = 13},
  [8255] = {.lex_state = 181, .external_lex_state = 5},
  [8256] = {.lex_state = 0, .external_lex_state = 20},
  [8257] = {.lex_state = 0, .external_lex_state = 13},
  [8258] = {.lex_state = 0, .external_lex_state = 13},
  [8259] = {.lex_state = 199, .external_lex_state = 14},
  [8260] = {.lex_state = 199, .external_lex_state = 14},
  [8261] = {.lex_state = 0, .external_lex_state = 13},
  [8262] = {.lex_state = 0, .external_lex_state = 13},
  [8263] = {.lex_state = 0, .external_lex_state = 13},
  [8264] = {.lex_state = 0, .external_lex_state = 13},
  [8265] = {.lex_state = 0, .external_lex_state = 13},
  [8266] = {.lex_state = 0, .external_lex_state = 13},
  [8267] = {.lex_state = 0, .external_lex_state = 13},
  [8268] = {.lex_state = 0, .external_lex_state = 15},
  [8269] = {.lex_state = 0, .external_lex_state = 15},
  [8270] = {.lex_state = 0, .external_lex_state = 13},
  [8271] = {.lex_state = 0, .external_lex_state = 13},
  [8272] = {.lex_state = 181, .external_lex_state = 13},
  [8273] = {.lex_state = 199, .external_lex_state = 14},
  [8274] = {.lex_state = 0, .external_lex_state = 13},
  [8275] = {.lex_state = 199, .external_lex_state = 14},
  [8276] = {.lex_state = 0, .external_lex_state = 13},
  [8277] = {.lex_state = 199, .external_lex_state = 14},
  [8278] = {.lex_state = 0, .external_lex_state = 5},
  [8279] = {.lex_state = 181, .external_lex_state = 5},
  [8280] = {.lex_state = 0, .external_lex_state = 13},
  [8281] = {.lex_state = 0, .external_lex_state = 13},
  [8282] = {.lex_state = 181, .external_lex_state = 5},
  [8283] = {.lex_state = 0, .external_lex_state = 45},
  [8284] = {.lex_state = 0, .external_lex_state = 13},
  [8285] = {.lex_state = 181, .external_lex_state = 5},
  [8286] = {.lex_state = 0, .external_lex_state = 13},
  [8287] = {.lex_state = 199, .external_lex_state = 5},
  [8288] = {.lex_state = 199, .external_lex_state = 5},
  [8289] = {.lex_state = 199, .external_lex_state = 5},
  [8290] = {.lex_state = 199, .external_lex_state = 5},
  [8291] = {.lex_state = 0, .external_lex_state = 13},
  [8292] = {.lex_state = 0, .external_lex_state = 13},
  [8293] = {.lex_state = 0, .external_lex_state = 13},
  [8294] = {.lex_state = 0, .external_lex_state = 13},
  [8295] = {.lex_state = 0, .external_lex_state = 20},
  [8296] = {.lex_state = 199, .external_lex_state = 14},
  [8297] = {.lex_state = 0, .external_lex_state = 13},
  [8298] = {.lex_state = 0, .external_lex_state = 13},
  [8299] = {.lex_state = 0, .external_lex_state = 13},
  [8300] = {.lex_state = 0, .external_lex_state = 13},
  [8301] = {.lex_state = 0, .external_lex_state = 13},
  [8302] = {.lex_state = 0, .external_lex_state = 13},
  [8303] = {.lex_state = 0, .external_lex_state = 13},
  [8304] = {.lex_state = 0, .external_lex_state = 13},
  [8305] = {.lex_state = 0, .external_lex_state = 13},
  [8306] = {.lex_state = 0, .external_lex_state = 13},
  [8307] = {.lex_state = 0, .external_lex_state = 13},
  [8308] = {.lex_state = 0, .external_lex_state = 20},
  [8309] = {.lex_state = 0, .external_lex_state = 13},
  [8310] = {.lex_state = 0, .external_lex_state = 13},
  [8311] = {.lex_state = 0, .external_lex_state = 13},
  [8312] = {.lex_state = 0, .external_lex_state = 13},
  [8313] = {.lex_state = 0, .external_lex_state = 13},
  [8314] = {.lex_state = 0, .external_lex_state = 13},
  [8315] = {.lex_state = 0, .external_lex_state = 13},
  [8316] = {.lex_state = 0, .external_lex_state = 20},
  [8317] = {.lex_state = 181, .external_lex_state = 5},
  [8318] = {.lex_state = 0, .external_lex_state = 15},
  [8319] = {.lex_state = 0, .external_lex_state = 15},
  [8320] = {.lex_state = 0, .external_lex_state = 15},
  [8321] = {.lex_state = 0, .external_lex_state = 13},
  [8322] = {.lex_state = 181, .external_lex_state = 5},
  [8323] = {.lex_state = 0, .external_lex_state = 13},
  [8324] = {.lex_state = 0, .external_lex_state = 13},
  [8325] = {.lex_state = 0, .external_lex_state = 13},
  [8326] = {.lex_state = 0, .external_lex_state = 13},
  [8327] = {.lex_state = 0, .external_lex_state = 13},
  [8328] = {.lex_state = 0, .external_lex_state = 13},
  [8329] = {.lex_state = 0, .external_lex_state = 13},
  [8330] = {.lex_state = 181, .external_lex_state = 5},
  [8331] = {.lex_state = 199, .external_lex_state = 14},
  [8332] = {.lex_state = 0, .external_lex_state = 13},
  [8333] = {.lex_state = 0, .external_lex_state = 13},
  [8334] = {.lex_state = 0, .external_lex_state = 13},
  [8335] = {.lex_state = 0, .external_lex_state = 13},
  [8336] = {.lex_state = 0, .external_lex_state = 13},
  [8337] = {.lex_state = 0, .external_lex_state = 13},
  [8338] = {.lex_state = 0, .external_lex_state = 13},
  [8339] = {.lex_state = 0, .external_lex_state = 13},
  [8340] = {.lex_state = 181, .external_lex_state = 5},
  [8341] = {.lex_state = 0, .external_lex_state = 20},
  [8342] = {.lex_state = 0, .external_lex_state = 13},
  [8343] = {.lex_state = 0, .external_lex_state = 13},
  [8344] = {.lex_state = 0, .external_lex_state = 13},
  [8345] = {.lex_state = 0, .external_lex_state = 13},
  [8346] = {.lex_state = 0, .external_lex_state = 13},
  [8347] = {.lex_state = 0, .external_lex_state = 13},
  [8348] = {.lex_state = 0, .external_lex_state = 20},
  [8349] = {.lex_state = 0, .external_lex_state = 15},
  [8350] = {.lex_state = 1, .external_lex_state = 5},
  [8351] = {.lex_state = 0, .external_lex_state = 20},
  [8352] = {.lex_state = 0, .external_lex_state = 13},
  [8353] = {.lex_state = 0, .external_lex_state = 20},
  [8354] = {.lex_state = 0, .external_lex_state = 13},
  [8355] = {.lex_state = 0, .external_lex_state = 20},
  [8356] = {.lex_state = 0, .external_lex_state = 13},
  [8357] = {.lex_state = 0, .external_lex_state = 13},
  [8358] = {.lex_state = 0, .external_lex_state = 13},
  [8359] = {.lex_state = 1, .external_lex_state = 13},
  [8360] = {.lex_state = 1, .external_lex_state = 13},
  [8361] = {.lex_state = 0, .external_lex_state = 13},
  [8362] = {.lex_state = 0, .external_lex_state = 13},
  [8363] = {.lex_state = 181, .external_lex_state = 5},
  [8364] = {.lex_state = 0, .external_lex_state = 13},
  [8365] = {.lex_state = 0, .external_lex_state = 13},
  [8366] = {.lex_state = 0, .external_lex_state = 13},
  [8367] = {.lex_state = 181, .external_lex_state = 13},
  [8368] = {.lex_state = 0, .external_lex_state = 13},
  [8369] = {.lex_state = 0, .external_lex_state = 45},
  [8370] = {.lex_state = 0, .external_lex_state = 20},
  [8371] = {.lex_state = 0, .external_lex_state = 15},
  [8372] = {.lex_state = 0, .external_lex_state = 13},
  [8373] = {.lex_state = 199, .external_lex_state = 5},
  [8374] = {.lex_state = 181, .external_lex_state = 5},
  [8375] = {.lex_state = 0, .external_lex_state = 20},
  [8376] = {.lex_state = 0, .external_lex_state = 15},
  [8377] = {.lex_state = 0, .external_lex_state = 13},
  [8378] = {.lex_state = 0, .external_lex_state = 13},
  [8379] = {.lex_state = 0, .external_lex_state = 13},
  [8380] = {.lex_state = 0, .external_lex_state = 13},
  [8381] = {.lex_state = 0, .external_lex_state = 13},
  [8382] = {.lex_state = 0, .external_lex_state = 13},
  [8383] = {.lex_state = 0, .external_lex_state = 13},
  [8384] = {.lex_state = 0, .external_lex_state = 13},
  [8385] = {.lex_state = 0, .external_lex_state = 13},
  [8386] = {.lex_state = 0, .external_lex_state = 13},
  [8387] = {.lex_state = 0, .external_lex_state = 13},
  [8388] = {.lex_state = 0, .external_lex_state = 13},
  [8389] = {.lex_state = 183, .external_lex_state = 5},
  [8390] = {.lex_state = 0, .external_lex_state = 20},
  [8391] = {.lex_state = 0, .external_lex_state = 13},
  [8392] = {.lex_state = 0, .external_lex_state = 13},
  [8393] = {.lex_state = 0, .external_lex_state = 13},
  [8394] = {.lex_state = 0, .external_lex_state = 13},
  [8395] = {.lex_state = 199, .external_lex_state = 14},
  [8396] = {.lex_state = 199, .external_lex_state = 14},
  [8397] = {.lex_state = 0, .external_lex_state = 13},
  [8398] = {.lex_state = 128, .external_lex_state = 5},
  [8399] = {.lex_state = 0, .external_lex_state = 13},
  [8400] = {.lex_state = 0, .external_lex_state = 13},
  [8401] = {.lex_state = 0, .external_lex_state = 13},
  [8402] = {.lex_state = 0, .external_lex_state = 15},
  [8403] = {.lex_state = 0, .external_lex_state = 13},
  [8404] = {.lex_state = 0, .external_lex_state = 13},
  [8405] = {.lex_state = 0, .external_lex_state = 13},
  [8406] = {.lex_state = 0, .external_lex_state = 13},
  [8407] = {.lex_state = 0, .external_lex_state = 13},
  [8408] = {.lex_state = 181, .external_lex_state = 5},
  [8409] = {.lex_state = 0, .external_lex_state = 13},
  [8410] = {.lex_state = 0, .external_lex_state = 20},
  [8411] = {.lex_state = 0, .external_lex_state = 20},
  [8412] = {.lex_state = 0, .external_lex_state = 13},
  [8413] = {.lex_state = 0, .external_lex_state = 15},
  [8414] = {.lex_state = 0, .external_lex_state = 13},
  [8415] = {.lex_state = 0, .external_lex_state = 20},
  [8416] = {.lex_state = 0, .external_lex_state = 20},
  [8417] = {.lex_state = 0, .external_lex_state = 13},
  [8418] = {.lex_state = 0, .external_lex_state = 20},
  [8419] = {.lex_state = 1, .external_lex_state = 5},
  [8420] = {.lex_state = 0, .external_lex_state = 13},
  [8421] = {.lex_state = 0, .external_lex_state = 13},
  [8422] = {.lex_state = 0, .external_lex_state = 20},
  [8423] = {.lex_state = 0, .external_lex_state = 20},
  [8424] = {.lex_state = 0, .external_lex_state = 13},
  [8425] = {.lex_state = 0, .external_lex_state = 13},
  [8426] = {.lex_state = 0, .external_lex_state = 15},
  [8427] = {.lex_state = 0, .external_lex_state = 13},
  [8428] = {.lex_state = 0, .external_lex_state = 15},
  [8429] = {.lex_state = 0, .external_lex_state = 13},
  [8430] = {.lex_state = 0, .external_lex_state = 13},
  [8431] = {.lex_state = 0, .external_lex_state = 13},
  [8432] = {.lex_state = 0, .external_lex_state = 13},
  [8433] = {.lex_state = 0, .external_lex_state = 13},
  [8434] = {.lex_state = 0, .external_lex_state = 13},
  [8435] = {.lex_state = 181, .external_lex_state = 13},
  [8436] = {.lex_state = 0, .external_lex_state = 13},
  [8437] = {.lex_state = 0, .external_lex_state = 15},
  [8438] = {.lex_state = 0, .external_lex_state = 5},
  [8439] = {.lex_state = 0, .external_lex_state = 13},
  [8440] = {.lex_state = 0, .external_lex_state = 20},
  [8441] = {.lex_state = 181, .external_lex_state = 5},
  [8442] = {.lex_state = 0, .external_lex_state = 20},
  [8443] = {.lex_state = 0, .external_lex_state = 20},
  [8444] = {.lex_state = 0, .external_lex_state = 13},
  [8445] = {.lex_state = 0, .external_lex_state = 13},
  [8446] = {.lex_state = 0, .external_lex_state = 20},
  [8447] = {.lex_state = 0, .external_lex_state = 13},
  [8448] = {.lex_state = 0, .external_lex_state = 13},
  [8449] = {.lex_state = 0, .external_lex_state = 45},
  [8450] = {.lex_state = 0, .external_lex_state = 13},
  [8451] = {.lex_state = 0, .external_lex_state = 13},
  [8452] = {.lex_state = 0, .external_lex_state = 13},
  [8453] = {.lex_state = 0, .external_lex_state = 13},
  [8454] = {.lex_state = 181, .external_lex_state = 5},
  [8455] = {.lex_state = 0, .external_lex_state = 20},
  [8456] = {.lex_state = 0, .external_lex_state = 13},
  [8457] = {.lex_state = 0, .external_lex_state = 13},
  [8458] = {.lex_state = 0, .external_lex_state = 13},
  [8459] = {.lex_state = 0, .external_lex_state = 13},
  [8460] = {.lex_state = 0, .external_lex_state = 13},
  [8461] = {.lex_state = 0, .external_lex_state = 13},
  [8462] = {.lex_state = 0, .external_lex_state = 13},
  [8463] = {.lex_state = 199, .external_lex_state = 14},
  [8464] = {.lex_state = 0, .external_lex_state = 13},
  [8465] = {.lex_state = 0, .external_lex_state = 13},
  [8466] = {.lex_state = 0, .external_lex_state = 15},
  [8467] = {.lex_state = 0, .external_lex_state = 31},
  [8468] = {.lex_state = 0, .external_lex_state = 13},
  [8469] = {.lex_state = 0, .external_lex_state = 13},
  [8470] = {.lex_state = 0, .external_lex_state = 20},
  [8471] = {.lex_state = 0, .external_lex_state = 13},
  [8472] = {.lex_state = 0, .external_lex_state = 13},
  [8473] = {.lex_state = 0, .external_lex_state = 13},
  [8474] = {.lex_state = 0, .external_lex_state = 13},
  [8475] = {.lex_state = 0, .external_lex_state = 13},
  [8476] = {.lex_state = 0, .external_lex_state = 20},
  [8477] = {.lex_state = 0, .external_lex_state = 13},
  [8478] = {.lex_state = 0, .external_lex_state = 13},
  [8479] = {.lex_state = 181, .external_lex_state = 5},
  [8480] = {.lex_state = 0, .external_lex_state = 13},
  [8481] = {.lex_state = 0, .external_lex_state = 13},
  [8482] = {.lex_state = 0, .external_lex_state = 13},
  [8483] = {.lex_state = 0, .external_lex_state = 20},
  [8484] = {.lex_state = 0, .external_lex_state = 20},
  [8485] = {.lex_state = 0, .external_lex_state = 13},
  [8486] = {.lex_state = 1, .external_lex_state = 5},
  [8487] = {.lex_state = 0, .external_lex_state = 13},
  [8488] = {.lex_state = 0, .external_lex_state = 13},
  [8489] = {.lex_state = 0, .external_lex_state = 13},
  [8490] = {.lex_state = 0, .external_lex_state = 20},
  [8491] = {.lex_state = 0, .external_lex_state = 13},
  [8492] = {.lex_state = 0, .external_lex_state = 13},
  [8493] = {.lex_state = 0, .external_lex_state = 13},
  [8494] = {.lex_state = 0, .external_lex_state = 13},
  [8495] = {.lex_state = 0, .external_lex_state = 13},
  [8496] = {.lex_state = 0, .external_lex_state = 13},
  [8497] = {.lex_state = 181, .external_lex_state = 5},
  [8498] = {.lex_state = 0, .external_lex_state = 13},
  [8499] = {.lex_state = 0, .external_lex_state = 13},
  [8500] = {.lex_state = 0, .external_lex_state = 13},
  [8501] = {.lex_state = 0, .external_lex_state = 13},
  [8502] = {.lex_state = 0, .external_lex_state = 15},
  [8503] = {.lex_state = 0, .external_lex_state = 13},
  [8504] = {.lex_state = 0, .external_lex_state = 15},
  [8505] = {.lex_state = 0, .external_lex_state = 20},
  [8506] = {.lex_state = 0, .external_lex_state = 13},
  [8507] = {.lex_state = 0, .external_lex_state = 13},
  [8508] = {.lex_state = 0, .external_lex_state = 20},
  [8509] = {.lex_state = 0, .external_lex_state = 13},
  [8510] = {.lex_state = 181, .external_lex_state = 5},
  [8511] = {.lex_state = 0, .external_lex_state = 20},
  [8512] = {.lex_state = 0, .external_lex_state = 20},
  [8513] = {.lex_state = 0, .external_lex_state = 13},
  [8514] = {.lex_state = 0, .external_lex_state = 15},
  [8515] = {.lex_state = 0, .external_lex_state = 15},
  [8516] = {.lex_state = 0, .external_lex_state = 13},
  [8517] = {.lex_state = 0, .external_lex_state = 13},
  [8518] = {.lex_state = 0, .external_lex_state = 13},
  [8519] = {.lex_state = 0, .external_lex_state = 13},
  [8520] = {.lex_state = 0, .external_lex_state = 13},
  [8521] = {.lex_state = 0, .external_lex_state = 13},
  [8522] = {.lex_state = 0, .external_lex_state = 13},
  [8523] = {.lex_state = 0, .external_lex_state = 13},
  [8524] = {.lex_state = 0, .external_lex_state = 13},
  [8525] = {.lex_state = 0, .external_lex_state = 13},
  [8526] = {.lex_state = 0, .external_lex_state = 13},
  [8527] = {.lex_state = 0, .external_lex_state = 13},
  [8528] = {.lex_state = 0, .external_lex_state = 13},
  [8529] = {.lex_state = 0, .external_lex_state = 13},
  [8530] = {.lex_state = 0, .external_lex_state = 15},
  [8531] = {.lex_state = 0, .external_lex_state = 13},
  [8532] = {.lex_state = 0, .external_lex_state = 20},
  [8533] = {.lex_state = 0, .external_lex_state = 13},
  [8534] = {.lex_state = 0, .external_lex_state = 13},
  [8535] = {.lex_state = 181, .external_lex_state = 5},
  [8536] = {.lex_state = 0, .external_lex_state = 13},
  [8537] = {.lex_state = 199, .external_lex_state = 14},
  [8538] = {.lex_state = 0, .external_lex_state = 13},
  [8539] = {.lex_state = 0, .external_lex_state = 13},
  [8540] = {.lex_state = 0, .external_lex_state = 15},
  [8541] = {.lex_state = 0, .external_lex_state = 13},
  [8542] = {.lex_state = 0, .external_lex_state = 13},
  [8543] = {.lex_state = 0, .external_lex_state = 13},
  [8544] = {.lex_state = 0, .external_lex_state = 15},
  [8545] = {.lex_state = 0, .external_lex_state = 13},
  [8546] = {.lex_state = 0, .external_lex_state = 13},
  [8547] = {.lex_state = 0, .external_lex_state = 15},
  [8548] = {.lex_state = 0, .external_lex_state = 20},
  [8549] = {.lex_state = 0, .external_lex_state = 13},
  [8550] = {.lex_state = 0, .external_lex_state = 20},
  [8551] = {.lex_state = 0, .external_lex_state = 13},
  [8552] = {.lex_state = 0, .external_lex_state = 15},
  [8553] = {.lex_state = 0, .external_lex_state = 13},
  [8554] = {.lex_state = 0, .external_lex_state = 20},
  [8555] = {.lex_state = 0, .external_lex_state = 13},
  [8556] = {.lex_state = 0, .external_lex_state = 13},
  [8557] = {.lex_state = 0, .external_lex_state = 5},
  [8558] = {.lex_state = 0, .external_lex_state = 13},
  [8559] = {.lex_state = 181, .external_lex_state = 5},
  [8560] = {.lex_state = 0, .external_lex_state = 13},
  [8561] = {.lex_state = 0, .external_lex_state = 13},
  [8562] = {.lex_state = 0, .external_lex_state = 13},
  [8563] = {.lex_state = 0, .external_lex_state = 13},
  [8564] = {.lex_state = 0, .external_lex_state = 13},
  [8565] = {.lex_state = 0, .external_lex_state = 13},
  [8566] = {.lex_state = 0, .external_lex_state = 13},
  [8567] = {.lex_state = 0, .external_lex_state = 13},
  [8568] = {.lex_state = 0, .external_lex_state = 13},
  [8569] = {.lex_state = 0, .external_lex_state = 13},
  [8570] = {.lex_state = 0, .external_lex_state = 15},
  [8571] = {.lex_state = 0, .external_lex_state = 20},
  [8572] = {.lex_state = 0, .external_lex_state = 13},
  [8573] = {.lex_state = 0, .external_lex_state = 15},
  [8574] = {.lex_state = 0, .external_lex_state = 15},
  [8575] = {.lex_state = 0, .external_lex_state = 13},
  [8576] = {.lex_state = 0, .external_lex_state = 13},
  [8577] = {.lex_state = 0, .external_lex_state = 13},
  [8578] = {.lex_state = 0, .external_lex_state = 15},
  [8579] = {.lex_state = 0, .external_lex_state = 5},
  [8580] = {.lex_state = 0, .external_lex_state = 13},
  [8581] = {.lex_state = 0, .external_lex_state = 13},
  [8582] = {.lex_state = 0, .external_lex_state = 5},
  [8583] = {.lex_state = 0, .external_lex_state = 13},
  [8584] = {.lex_state = 0, .external_lex_state = 20},
  [8585] = {.lex_state = 181, .external_lex_state = 5},
  [8586] = {.lex_state = 0, .external_lex_state = 20},
  [8587] = {.lex_state = 0, .external_lex_state = 20},
  [8588] = {.lex_state = 0, .external_lex_state = 15},
  [8589] = {.lex_state = 0, .external_lex_state = 20},
  [8590] = {.lex_state = 0, .external_lex_state = 15},
  [8591] = {.lex_state = 181, .external_lex_state = 5},
  [8592] = {.lex_state = 0, .external_lex_state = 20},
  [8593] = {.lex_state = 0, .external_lex_state = 13},
  [8594] = {.lex_state = 0, .external_lex_state = 15},
  [8595] = {.lex_state = 0, .external_lex_state = 13},
  [8596] = {.lex_state = 1, .external_lex_state = 5},
  [8597] = {.lex_state = 0, .external_lex_state = 15},
  [8598] = {.lex_state = 0, .external_lex_state = 5},
  [8599] = {.lex_state = 0, .external_lex_state = 13},
  [8600] = {.lex_state = 0, .external_lex_state = 13},
  [8601] = {.lex_state = 1, .external_lex_state = 5},
  [8602] = {.lex_state = 0, .external_lex_state = 13},
  [8603] = {.lex_state = 1, .external_lex_state = 5},
  [8604] = {.lex_state = 1, .external_lex_state = 5},
  [8605] = {.lex_state = 199, .external_lex_state = 5},
  [8606] = {.lex_state = 1, .external_lex_state = 5},
  [8607] = {.lex_state = 0, .external_lex_state = 13},
  [8608] = {.lex_state = 0, .external_lex_state = 13},
  [8609] = {.lex_state = 0, .external_lex_state = 13},
  [8610] = {.lex_state = 0, .external_lex_state = 13},
  [8611] = {.lex_state = 0, .external_lex_state = 13},
  [8612] = {.lex_state = 0, .external_lex_state = 47},
  [8613] = {.lex_state = 0, .external_lex_state = 47},
  [8614] = {.lex_state = 183, .external_lex_state = 34},
  [8615] = {.lex_state = 183, .external_lex_state = 34},
  [8616] = {.lex_state = 0, .external_lex_state = 13},
  [8617] = {.lex_state = 210, .external_lex_state = 5},
  [8618] = {.lex_state = 199, .external_lex_state = 5},
  [8619] = {.lex_state = 181, .external_lex_state = 16},
  [8620] = {.lex_state = 0, .external_lex_state = 13},
  [8621] = {.lex_state = 64, .external_lex_state = 5},
  [8622] = {.lex_state = 183, .external_lex_state = 34},
  [8623] = {.lex_state = 183, .external_lex_state = 34},
  [8624] = {.lex_state = 0, .external_lex_state = 13},
  [8625] = {.lex_state = 0, .external_lex_state = 13},
  [8626] = {.lex_state = 0, .external_lex_state = 13},
  [8627] = {.lex_state = 0, .external_lex_state = 13},
  [8628] = {.lex_state = 0, .external_lex_state = 13},
  [8629] = {.lex_state = 0, .external_lex_state = 13},
  [8630] = {.lex_state = 0, .external_lex_state = 47},
  [8631] = {.lex_state = 0, .external_lex_state = 13},
  [8632] = {.lex_state = 0, .external_lex_state = 13},
  [8633] = {.lex_state = 181, .external_lex_state = 16},
  [8634] = {.lex_state = 0, .external_lex_state = 13},
  [8635] = {.lex_state = 0, .external_lex_state = 13},
  [8636] = {.lex_state = 0, .external_lex_state = 47},
  [8637] = {.lex_state = 0, .external_lex_state = 47},
  [8638] = {.lex_state = 0, .external_lex_state = 13},
  [8639] = {.lex_state = 0, .external_lex_state = 13},
  [8640] = {.lex_state = 0, .external_lex_state = 13},
  [8641] = {.lex_state = 0, .external_lex_state = 13},
  [8642] = {.lex_state = 0, .external_lex_state = 13},
  [8643] = {.lex_state = 0, .external_lex_state = 13},
  [8644] = {.lex_state = 0, .external_lex_state = 13},
  [8645] = {.lex_state = 0, .external_lex_state = 13},
  [8646] = {.lex_state = 0, .external_lex_state = 13},
  [8647] = {.lex_state = 0, .external_lex_state = 13},
  [8648] = {.lex_state = 0, .external_lex_state = 47},
  [8649] = {.lex_state = 0, .external_lex_state = 13},
  [8650] = {.lex_state = 0, .external_lex_state = 13},
  [8651] = {.lex_state = 0, .external_lex_state = 13},
  [8652] = {.lex_state = 0, .external_lex_state = 13},
  [8653] = {.lex_state = 0, .external_lex_state = 47},
  [8654] = {.lex_state = 181, .external_lex_state = 5},
  [8655] = {.lex_state = 0, .external_lex_state = 47},
  [8656] = {.lex_state = 0, .external_lex_state = 47},
  [8657] = {.lex_state = 0, .external_lex_state = 13},
  [8658] = {.lex_state = 0, .external_lex_state = 47},
  [8659] = {.lex_state = 181, .external_lex_state = 16},
  [8660] = {.lex_state = 181, .external_lex_state = 5},
  [8661] = {.lex_state = 210, .external_lex_state = 5},
  [8662] = {.lex_state = 210, .external_lex_state = 5},
  [8663] = {.lex_state = 199, .external_lex_state = 5},
  [8664] = {.lex_state = 0, .external_lex_state = 13},
  [8665] = {.lex_state = 0, .external_lex_state = 13},
  [8666] = {.lex_state = 0, .external_lex_state = 13},
  [8667] = {.lex_state = 0, .external_lex_state = 13},
  [8668] = {.lex_state = 0, .external_lex_state = 47},
  [8669] = {.lex_state = 210, .external_lex_state = 5},
  [8670] = {.lex_state = 0, .external_lex_state = 5},
  [8671] = {.lex_state = 0, .external_lex_state = 13},
  [8672] = {.lex_state = 199, .external_lex_state = 5},
  [8673] = {.lex_state = 0, .external_lex_state = 47},
  [8674] = {.lex_state = 0, .external_lex_state = 47},
  [8675] = {.lex_state = 210, .external_lex_state = 5},
  [8676] = {.lex_state = 210, .external_lex_state = 5},
  [8677] = {.lex_state = 183, .external_lex_state = 34},
  [8678] = {.lex_state = 0, .external_lex_state = 47},
  [8679] = {.lex_state = 0, .external_lex_state = 13},
  [8680] = {.lex_state = 0, .external_lex_state = 13},
  [8681] = {.lex_state = 0, .external_lex_state = 13},
  [8682] = {.lex_state = 181, .external_lex_state = 5},
  [8683] = {.lex_state = 181, .external_lex_state = 16},
  [8684] = {.lex_state = 0, .external_lex_state = 47},
  [8685] = {.lex_state = 181, .external_lex_state = 16},
  [8686] = {.lex_state = 0, .external_lex_state = 13},
  [8687] = {.lex_state = 0, .external_lex_state = 47},
  [8688] = {.lex_state = 0, .external_lex_state = 13},
  [8689] = {.lex_state = 0, .external_lex_state = 13},
  [8690] = {.lex_state = 0, .external_lex_state = 47},
  [8691] = {.lex_state = 0, .external_lex_state = 47},
  [8692] = {.lex_state = 0, .external_lex_state = 47},
  [8693] = {.lex_state = 0, .external_lex_state = 47},
  [8694] = {.lex_state = 0, .external_lex_state = 47},
  [8695] = {.lex_state = 0, .external_lex_state = 47},
  [8696] = {.lex_state = 0, .external_lex_state = 47},
  [8697] = {.lex_state = 181, .external_lex_state = 5},
  [8698] = {.lex_state = 0, .external_lex_state = 47},
  [8699] = {.lex_state = 183, .external_lex_state = 34},
  [8700] = {.lex_state = 0, .external_lex_state = 47},
  [8701] = {.lex_state = 0, .external_lex_state = 47},
  [8702] = {.lex_state = 210, .external_lex_state = 5},
  [8703] = {.lex_state = 210, .external_lex_state = 5},
  [8704] = {.lex_state = 199, .external_lex_state = 5},
  [8705] = {.lex_state = 0, .external_lex_state = 47},
  [8706] = {.lex_state = 199, .external_lex_state = 5},
  [8707] = {.lex_state = 0, .external_lex_state = 47},
  [8708] = {.lex_state = 0, .external_lex_state = 47},
  [8709] = {.lex_state = 0, .external_lex_state = 47},
  [8710] = {.lex_state = 0, .external_lex_state = 47},
  [8711] = {.lex_state = 0, .external_lex_state = 47},
  [8712] = {.lex_state = 210, .external_lex_state = 5},
  [8713] = {.lex_state = 210, .external_lex_state = 5},
  [8714] = {.lex_state = 0, .external_lex_state = 47},
  [8715] = {.lex_state = 0, .external_lex_state = 47},
  [8716] = {.lex_state = 0, .external_lex_state = 47},
  [8717] = {.lex_state = 0, .external_lex_state = 47},
  [8718] = {.lex_state = 0, .external_lex_state = 47},
  [8719] = {.lex_state = 181, .external_lex_state = 16},
  [8720] = {.lex_state = 0, .external_lex_state = 47},
  [8721] = {.lex_state = 0, .external_lex_state = 47},
  [8722] = {.lex_state = 0, .external_lex_state = 47},
  [8723] = {.lex_state = 0, .external_lex_state = 47},
  [8724] = {.lex_state = 0, .external_lex_state = 47},
  [8725] = {.lex_state = 0, .external_lex_state = 47},
  [8726] = {.lex_state = 0, .external_lex_state = 47},
  [8727] = {.lex_state = 0, .external_lex_state = 47},
  [8728] = {.lex_state = 210, .external_lex_state = 5},
  [8729] = {.lex_state = 210, .external_lex_state = 5},
  [8730] = {.lex_state = 199, .external_lex_state = 5},
  [8731] = {.lex_state = 199, .external_lex_state = 5},
  [8732] = {.lex_state = 181, .external_lex_state = 16},
  [8733] = {.lex_state = 199, .external_lex_state = 5},
  [8734] = {.lex_state = 0, .external_lex_state = 47},
  [8735] = {.lex_state = 210, .external_lex_state = 5},
  [8736] = {.lex_state = 210, .external_lex_state = 5},
  [8737] = {.lex_state = 0, .external_lex_state = 47},
  [8738] = {.lex_state = 199, .external_lex_state = 5},
  [8739] = {.lex_state = 64, .external_lex_state = 5},
  [8740] = {.lex_state = 0, .external_lex_state = 5},
  [8741] = {.lex_state = 199, .external_lex_state = 6},
  [8742] = {.lex_state = 0, .external_lex_state = 5},
  [8743] = {.lex_state = 0, .external_lex_state = 5},
  [8744] = {.lex_state = 0, .external_lex_state = 5},
  [8745] = {.lex_state = 127, .external_lex_state = 5},
  [8746] = {.lex_state = 0, .external_lex_state = 5},
  [8747] = {.lex_state = 0, .external_lex_state = 5},
  [8748] = {.lex_state = 0, .external_lex_state = 5},
  [8749] = {.lex_state = 0, .external_lex_state = 5},
  [8750] = {.lex_state = 0, .external_lex_state = 5},
  [8751] = {.lex_state = 0, .external_lex_state = 5},
  [8752] = {.lex_state = 0, .external_lex_state = 5},
  [8753] = {.lex_state = 0, .external_lex_state = 5},
  [8754] = {.lex_state = 0, .external_lex_state = 5},
  [8755] = {.lex_state = 0, .external_lex_state = 5},
  [8756] = {.lex_state = 0, .external_lex_state = 5},
  [8757] = {.lex_state = 0, .external_lex_state = 5},
  [8758] = {.lex_state = 0, .external_lex_state = 5},
  [8759] = {.lex_state = 0, .external_lex_state = 5},
  [8760] = {.lex_state = 0, .external_lex_state = 5},
  [8761] = {.lex_state = 127, .external_lex_state = 5},
  [8762] = {.lex_state = 0, .external_lex_state = 5},
  [8763] = {.lex_state = 0, .external_lex_state = 5},
  [8764] = {.lex_state = 0, .external_lex_state = 5},
  [8765] = {.lex_state = 0, .external_lex_state = 5},
  [8766] = {.lex_state = 127, .external_lex_state = 5},
  [8767] = {.lex_state = 0, .external_lex_state = 5},
  [8768] = {.lex_state = 0, .external_lex_state = 5},
  [8769] = {.lex_state = 0, .external_lex_state = 5},
  [8770] = {.lex_state = 0, .external_lex_state = 5},
  [8771] = {.lex_state = 0, .external_lex_state = 5},
  [8772] = {.lex_state = 0, .external_lex_state = 5},
  [8773] = {.lex_state = 0, .external_lex_state = 5},
  [8774] = {.lex_state = 0, .external_lex_state = 5},
  [8775] = {.lex_state = 0, .external_lex_state = 5},
  [8776] = {.lex_state = 127, .external_lex_state = 5},
  [8777] = {.lex_state = 0, .external_lex_state = 5},
  [8778] = {.lex_state = 0, .external_lex_state = 5},
  [8779] = {.lex_state = 0, .external_lex_state = 5},
  [8780] = {.lex_state = 0, .external_lex_state = 5},
  [8781] = {.lex_state = 0, .external_lex_state = 5},
  [8782] = {.lex_state = 0, .external_lex_state = 5},
  [8783] = {.lex_state = 0, .external_lex_state = 5},
  [8784] = {.lex_state = 0, .external_lex_state = 5},
  [8785] = {.lex_state = 0, .external_lex_state = 5},
  [8786] = {.lex_state = 0, .external_lex_state = 5},
  [8787] = {.lex_state = 0, .external_lex_state = 5},
  [8788] = {.lex_state = 0, .external_lex_state = 5},
  [8789] = {.lex_state = 0, .external_lex_state = 5},
  [8790] = {.lex_state = 0, .external_lex_state = 5},
  [8791] = {.lex_state = 127, .external_lex_state = 5},
  [8792] = {.lex_state = 0, .external_lex_state = 5},
  [8793] = {.lex_state = 0, .external_lex_state = 5},
  [8794] = {.lex_state = 0, .external_lex_state = 5},
  [8795] = {.lex_state = 0, .external_lex_state = 5},
  [8796] = {.lex_state = 0, .external_lex_state = 5},
  [8797] = {.lex_state = 0, .external_lex_state = 5},
  [8798] = {.lex_state = 0, .external_lex_state = 5},
  [8799] = {.lex_state = 0, .external_lex_state = 5},
  [8800] = {.lex_state = 0, .external_lex_state = 5},
  [8801] = {.lex_state = 0, .external_lex_state = 5},
  [8802] = {.lex_state = 0, .external_lex_state = 5},
  [8803] = {.lex_state = 0, .external_lex_state = 5},
  [8804] = {.lex_state = 0, .external_lex_state = 5},
  [8805] = {.lex_state = 0, .external_lex_state = 5},
  [8806] = {.lex_state = 127, .external_lex_state = 5},
  [8807] = {.lex_state = 0, .external_lex_state = 5},
  [8808] = {.lex_state = 0, .external_lex_state = 5},
  [8809] = {.lex_state = 0, .external_lex_state = 5},
  [8810] = {.lex_state = 0, .external_lex_state = 5},
  [8811] = {.lex_state = 0, .external_lex_state = 5},
  [8812] = {.lex_state = 0, .external_lex_state = 5},
  [8813] = {.lex_state = 0, .external_lex_state = 5},
  [8814] = {.lex_state = 0, .external_lex_state = 5},
  [8815] = {.lex_state = 0, .external_lex_state = 5},
  [8816] = {.lex_state = 0, .external_lex_state = 5},
  [8817] = {.lex_state = 0, .external_lex_state = 5},
  [8818] = {.lex_state = 0, .external_lex_state = 5},
  [8819] = {.lex_state = 0, .external_lex_state = 5},
  [8820] = {.lex_state = 0, .external_lex_state = 5},
  [8821] = {.lex_state = 0, .external_lex_state = 5},
  [8822] = {.lex_state = 0, .external_lex_state = 5},
  [8823] = {.lex_state = 0, .external_lex_state = 5},
  [8824] = {.lex_state = 127, .external_lex_state = 5},
  [8825] = {.lex_state = 0, .external_lex_state = 5},
  [8826] = {.lex_state = 0, .external_lex_state = 5},
  [8827] = {.lex_state = 0, .external_lex_state = 5},
  [8828] = {.lex_state = 0, .external_lex_state = 5},
  [8829] = {.lex_state = 0, .external_lex_state = 5},
  [8830] = {.lex_state = 0, .external_lex_state = 5},
  [8831] = {.lex_state = 0, .external_lex_state = 5},
  [8832] = {.lex_state = 0, .external_lex_state = 5},
  [8833] = {.lex_state = 0, .external_lex_state = 5},
  [8834] = {.lex_state = 0, .external_lex_state = 5},
  [8835] = {.lex_state = 0, .external_lex_state = 5},
  [8836] = {.lex_state = 0, .external_lex_state = 5},
  [8837] = {.lex_state = 0, .external_lex_state = 5},
  [8838] = {.lex_state = 127, .external_lex_state = 5},
  [8839] = {.lex_state = 0, .external_lex_state = 5},
  [8840] = {.lex_state = 0, .external_lex_state = 5},
  [8841] = {.lex_state = 0, .external_lex_state = 5},
  [8842] = {.lex_state = 0, .external_lex_state = 5},
  [8843] = {.lex_state = 127, .external_lex_state = 5},
  [8844] = {.lex_state = 0, .external_lex_state = 5},
  [8845] = {.lex_state = 0, .external_lex_state = 5},
  [8846] = {.lex_state = 0, .external_lex_state = 5},
  [8847] = {.lex_state = 0, .external_lex_state = 5},
  [8848] = {.lex_state = 0, .external_lex_state = 5},
  [8849] = {.lex_state = 0, .external_lex_state = 5},
  [8850] = {.lex_state = 0, .external_lex_state = 5},
  [8851] = {.lex_state = 0, .external_lex_state = 5},
  [8852] = {.lex_state = 0, .external_lex_state = 5},
  [8853] = {.lex_state = 0, .external_lex_state = 5},
  [8854] = {.lex_state = 0, .external_lex_state = 5},
  [8855] = {.lex_state = 0, .external_lex_state = 5},
  [8856] = {.lex_state = 0, .external_lex_state = 5},
  [8857] = {.lex_state = 0, .external_lex_state = 5},
  [8858] = {.lex_state = 0, .external_lex_state = 5},
  [8859] = {.lex_state = 0, .external_lex_state = 5},
  [8860] = {.lex_state = 0, .external_lex_state = 5},
  [8861] = {.lex_state = 0, .external_lex_state = 5},
  [8862] = {.lex_state = 127, .external_lex_state = 5},
  [8863] = {.lex_state = 0, .external_lex_state = 5},
  [8864] = {.lex_state = 127, .external_lex_state = 5},
  [8865] = {.lex_state = 0, .external_lex_state = 5},
  [8866] = {.lex_state = 0, .external_lex_state = 5},
  [8867] = {.lex_state = 0, .external_lex_state = 5},
  [8868] = {.lex_state = 0, .external_lex_state = 5},
  [8869] = {.lex_state = 0, .external_lex_state = 5},
  [8870] = {.lex_state = 0, .external_lex_state = 5},
  [8871] = {.lex_state = 0, .external_lex_state = 5},
  [8872] = {.lex_state = 0, .external_lex_state = 5},
  [8873] = {.lex_state = 0, .external_lex_state = 5},
  [8874] = {.lex_state = 0, .external_lex_state = 5},
  [8875] = {.lex_state = 0, .external_lex_state = 5},
  [8876] = {.lex_state = 0, .external_lex_state = 5},
  [8877] = {.lex_state = 0, .external_lex_state = 5},
  [8878] = {.lex_state = 0, .external_lex_state = 5},
  [8879] = {.lex_state = 0, .external_lex_state = 5},
  [8880] = {.lex_state = 0, .external_lex_state = 5},
  [8881] = {.lex_state = 127, .external_lex_state = 5},
  [8882] = {.lex_state = 0, .external_lex_state = 5},
  [8883] = {.lex_state = 0, .external_lex_state = 5},
  [8884] = {.lex_state = 0, .external_lex_state = 5},
  [8885] = {.lex_state = 0, .external_lex_state = 5},
  [8886] = {.lex_state = 0, .external_lex_state = 5},
  [8887] = {.lex_state = 0, .external_lex_state = 5},
  [8888] = {.lex_state = 0, .external_lex_state = 5},
  [8889] = {.lex_state = 0, .external_lex_state = 5},
  [8890] = {.lex_state = 0, .external_lex_state = 5},
  [8891] = {.lex_state = 0, .external_lex_state = 5},
  [8892] = {.lex_state = 0, .external_lex_state = 5},
  [8893] = {.lex_state = 0, .external_lex_state = 5},
  [8894] = {.lex_state = 0, .external_lex_state = 5},
  [8895] = {.lex_state = 0, .external_lex_state = 5},
  [8896] = {.lex_state = 0, .external_lex_state = 5},
  [8897] = {.lex_state = 0, .external_lex_state = 5},
  [8898] = {.lex_state = 0, .external_lex_state = 5},
  [8899] = {.lex_state = 0, .external_lex_state = 5},
  [8900] = {.lex_state = 127, .external_lex_state = 5},
  [8901] = {.lex_state = 0, .external_lex_state = 5},
  [8902] = {.lex_state = 0, .external_lex_state = 5},
  [8903] = {.lex_state = 0, .external_lex_state = 5},
  [8904] = {.lex_state = 0, .external_lex_state = 5},
  [8905] = {.lex_state = 0, .external_lex_state = 5},
  [8906] = {.lex_state = 0, .external_lex_state = 5},
  [8907] = {.lex_state = 0, .external_lex_state = 5},
  [8908] = {.lex_state = 0, .external_lex_state = 5},
  [8909] = {.lex_state = 0, .external_lex_state = 5},
  [8910] = {.lex_state = 0, .external_lex_state = 5},
  [8911] = {.lex_state = 127, .external_lex_state = 5},
  [8912] = {.lex_state = 0, .external_lex_state = 5},
  [8913] = {.lex_state = 0, .external_lex_state = 5},
  [8914] = {.lex_state = 0, .external_lex_state = 5},
  [8915] = {.lex_state = 0, .external_lex_state = 5},
  [8916] = {.lex_state = 0, .external_lex_state = 5},
  [8917] = {.lex_state = 0, .external_lex_state = 5},
  [8918] = {.lex_state = 127, .external_lex_state = 5},
  [8919] = {.lex_state = 127, .external_lex_state = 5},
  [8920] = {.lex_state = 0, .external_lex_state = 5},
  [8921] = {.lex_state = 0, .external_lex_state = 5},
  [8922] = {.lex_state = 0, .external_lex_state = 5},
  [8923] = {.lex_state = 0, .external_lex_state = 5},
  [8924] = {.lex_state = 0, .external_lex_state = 5},
  [8925] = {.lex_state = 0, .external_lex_state = 5},
  [8926] = {.lex_state = 0, .external_lex_state = 5},
  [8927] = {.lex_state = 0, .external_lex_state = 5},
  [8928] = {.lex_state = 0, .external_lex_state = 5},
  [8929] = {.lex_state = 0, .external_lex_state = 5},
  [8930] = {.lex_state = 0, .external_lex_state = 5},
  [8931] = {.lex_state = 0, .external_lex_state = 5},
  [8932] = {.lex_state = 0, .external_lex_state = 5},
  [8933] = {.lex_state = 0, .external_lex_state = 5},
  [8934] = {.lex_state = 0, .external_lex_state = 5},
  [8935] = {.lex_state = 0, .external_lex_state = 5},
  [8936] = {.lex_state = 0, .external_lex_state = 5},
  [8937] = {.lex_state = 0, .external_lex_state = 5},
  [8938] = {.lex_state = 127, .external_lex_state = 5},
  [8939] = {.lex_state = 0, .external_lex_state = 5},
  [8940] = {.lex_state = 0, .external_lex_state = 5},
  [8941] = {.lex_state = 0, .external_lex_state = 5},
  [8942] = {.lex_state = 0, .external_lex_state = 5},
  [8943] = {.lex_state = 0, .external_lex_state = 5},
  [8944] = {.lex_state = 0, .external_lex_state = 5},
  [8945] = {.lex_state = 0, .external_lex_state = 5},
  [8946] = {.lex_state = 0, .external_lex_state = 5},
  [8947] = {.lex_state = 0, .external_lex_state = 5},
  [8948] = {.lex_state = 0, .external_lex_state = 5},
  [8949] = {.lex_state = 0, .external_lex_state = 5},
  [8950] = {.lex_state = 0, .external_lex_state = 5},
  [8951] = {.lex_state = 0, .external_lex_state = 5},
  [8952] = {.lex_state = 0, .external_lex_state = 5},
  [8953] = {.lex_state = 0, .external_lex_state = 5},
  [8954] = {.lex_state = 0, .external_lex_state = 5},
  [8955] = {.lex_state = 0, .external_lex_state = 5},
  [8956] = {.lex_state = 0, .external_lex_state = 5},
  [8957] = {.lex_state = 127, .external_lex_state = 5},
  [8958] = {.lex_state = 0, .external_lex_state = 5},
  [8959] = {.lex_state = 0, .external_lex_state = 5},
  [8960] = {.lex_state = 0, .external_lex_state = 5},
  [8961] = {.lex_state = 0, .external_lex_state = 5},
  [8962] = {.lex_state = 0, .external_lex_state = 5},
  [8963] = {.lex_state = 0, .external_lex_state = 5},
  [8964] = {.lex_state = 0, .external_lex_state = 5},
  [8965] = {.lex_state = 0, .external_lex_state = 5},
  [8966] = {.lex_state = 0, .external_lex_state = 5},
  [8967] = {.lex_state = 0, .external_lex_state = 5},
  [8968] = {.lex_state = 0, .external_lex_state = 5},
  [8969] = {.lex_state = 0, .external_lex_state = 5},
  [8970] = {.lex_state = 0, .external_lex_state = 5},
  [8971] = {.lex_state = 0, .external_lex_state = 5},
  [8972] = {.lex_state = 0, .external_lex_state = 5},
  [8973] = {.lex_state = 0, .external_lex_state = 5},
  [8974] = {.lex_state = 0, .external_lex_state = 5},
  [8975] = {.lex_state = 0, .external_lex_state = 5},
  [8976] = {.lex_state = 127, .external_lex_state = 5},
  [8977] = {.lex_state = 0, .external_lex_state = 5},
  [8978] = {.lex_state = 0, .external_lex_state = 5},
  [8979] = {.lex_state = 0, .external_lex_state = 5},
  [8980] = {.lex_state = 0, .external_lex_state = 5},
  [8981] = {.lex_state = 0, .external_lex_state = 5},
  [8982] = {.lex_state = 0, .external_lex_state = 5},
  [8983] = {.lex_state = 0, .external_lex_state = 5},
  [8984] = {.lex_state = 0, .external_lex_state = 5},
  [8985] = {.lex_state = 0, .external_lex_state = 5},
  [8986] = {.lex_state = 0, .external_lex_state = 5},
  [8987] = {.lex_state = 0, .external_lex_state = 5},
  [8988] = {.lex_state = 0, .external_lex_state = 5},
  [8989] = {.lex_state = 0, .external_lex_state = 5},
  [8990] = {.lex_state = 0, .external_lex_state = 5},
  [8991] = {.lex_state = 0, .external_lex_state = 5},
  [8992] = {.lex_state = 0, .external_lex_state = 5},
  [8993] = {.lex_state = 0, .external_lex_state = 5},
  [8994] = {.lex_state = 0, .external_lex_state = 5},
  [8995] = {.lex_state = 127, .external_lex_state = 5},
  [8996] = {.lex_state = 0, .external_lex_state = 5},
  [8997] = {.lex_state = 127, .external_lex_state = 5},
  [8998] = {.lex_state = 0, .external_lex_state = 5},
  [8999] = {.lex_state = 0, .external_lex_state = 5},
  [9000] = {.lex_state = 0, .external_lex_state = 5},
  [9001] = {.lex_state = 0, .external_lex_state = 5},
  [9002] = {.lex_state = 0, .external_lex_state = 5},
  [9003] = {.lex_state = 0, .external_lex_state = 5},
  [9004] = {.lex_state = 0, .external_lex_state = 5},
  [9005] = {.lex_state = 0, .external_lex_state = 5},
  [9006] = {.lex_state = 0, .external_lex_state = 5},
  [9007] = {.lex_state = 0, .external_lex_state = 5},
  [9008] = {.lex_state = 0, .external_lex_state = 5},
  [9009] = {.lex_state = 0, .external_lex_state = 5},
  [9010] = {.lex_state = 0, .external_lex_state = 5},
  [9011] = {.lex_state = 0, .external_lex_state = 5},
  [9012] = {.lex_state = 0, .external_lex_state = 5},
  [9013] = {.lex_state = 127, .external_lex_state = 5},
  [9014] = {.lex_state = 0, .external_lex_state = 5},
  [9015] = {.lex_state = 0, .external_lex_state = 5},
  [9016] = {.lex_state = 0, .external_lex_state = 5},
  [9017] = {.lex_state = 0, .external_lex_state = 5},
  [9018] = {.lex_state = 0, .external_lex_state = 5},
  [9019] = {.lex_state = 0, .external_lex_state = 5},
  [9020] = {.lex_state = 0, .external_lex_state = 5},
  [9021] = {.lex_state = 0, .external_lex_state = 5},
  [9022] = {.lex_state = 0, .external_lex_state = 5},
  [9023] = {.lex_state = 0, .external_lex_state = 5},
  [9024] = {.lex_state = 0, .external_lex_state = 5},
  [9025] = {.lex_state = 0, .external_lex_state = 5},
  [9026] = {.lex_state = 0, .external_lex_state = 5},
  [9027] = {.lex_state = 0, .external_lex_state = 5},
  [9028] = {.lex_state = 0, .external_lex_state = 5},
  [9029] = {.lex_state = 0, .external_lex_state = 5},
  [9030] = {.lex_state = 0, .external_lex_state = 5},
  [9031] = {.lex_state = 127, .external_lex_state = 5},
  [9032] = {.lex_state = 0, .external_lex_state = 5},
  [9033] = {.lex_state = 0, .external_lex_state = 5},
  [9034] = {.lex_state = 0, .external_lex_state = 5},
  [9035] = {.lex_state = 0, .external_lex_state = 5},
  [9036] = {.lex_state = 0, .external_lex_state = 5},
  [9037] = {.lex_state = 0, .external_lex_state = 5},
  [9038] = {.lex_state = 0, .external_lex_state = 5},
  [9039] = {.lex_state = 0, .external_lex_state = 5},
  [9040] = {.lex_state = 0, .external_lex_state = 5},
  [9041] = {.lex_state = 0, .external_lex_state = 5},
  [9042] = {.lex_state = 0, .external_lex_state = 5},
  [9043] = {.lex_state = 0, .external_lex_state = 5},
  [9044] = {.lex_state = 0, .external_lex_state = 5},
  [9045] = {.lex_state = 0, .external_lex_state = 5},
  [9046] = {.lex_state = 0, .external_lex_state = 5},
  [9047] = {.lex_state = 0, .external_lex_state = 5},
  [9048] = {.lex_state = 0, .external_lex_state = 5},
  [9049] = {.lex_state = 127, .external_lex_state = 5},
  [9050] = {.lex_state = 0, .external_lex_state = 5},
  [9051] = {.lex_state = 0, .external_lex_state = 5},
  [9052] = {.lex_state = 0, .external_lex_state = 5},
  [9053] = {.lex_state = 0, .external_lex_state = 5},
  [9054] = {.lex_state = 0, .external_lex_state = 5},
  [9055] = {.lex_state = 0, .external_lex_state = 5},
  [9056] = {.lex_state = 0, .external_lex_state = 5},
  [9057] = {.lex_state = 0, .external_lex_state = 5},
  [9058] = {.lex_state = 0, .external_lex_state = 5},
  [9059] = {.lex_state = 0, .external_lex_state = 5},
  [9060] = {.lex_state = 0, .external_lex_state = 5},
  [9061] = {.lex_state = 0, .external_lex_state = 5},
  [9062] = {.lex_state = 0, .external_lex_state = 5},
  [9063] = {.lex_state = 127, .external_lex_state = 5},
  [9064] = {.lex_state = 0, .external_lex_state = 5},
  [9065] = {.lex_state = 0, .external_lex_state = 5},
  [9066] = {.lex_state = 0, .external_lex_state = 5},
  [9067] = {.lex_state = 127, .external_lex_state = 5},
  [9068] = {.lex_state = 127, .external_lex_state = 5},
  [9069] = {.lex_state = 0, .external_lex_state = 5},
  [9070] = {.lex_state = 0, .external_lex_state = 5},
  [9071] = {.lex_state = 0, .external_lex_state = 5},
  [9072] = {.lex_state = 0, .external_lex_state = 5},
  [9073] = {.lex_state = 0, .external_lex_state = 5},
  [9074] = {.lex_state = 0, .external_lex_state = 5},
  [9075] = {.lex_state = 0, .external_lex_state = 5},
  [9076] = {.lex_state = 0, .external_lex_state = 5},
  [9077] = {.lex_state = 0, .external_lex_state = 5},
  [9078] = {.lex_state = 127, .external_lex_state = 5},
  [9079] = {.lex_state = 0, .external_lex_state = 5},
  [9080] = {.lex_state = 0, .external_lex_state = 5},
  [9081] = {.lex_state = 0, .external_lex_state = 5},
  [9082] = {.lex_state = 0, .external_lex_state = 5},
  [9083] = {.lex_state = 0, .external_lex_state = 5},
  [9084] = {.lex_state = 0, .external_lex_state = 5},
  [9085] = {.lex_state = 127, .external_lex_state = 5},
  [9086] = {.lex_state = 0, .external_lex_state = 5},
  [9087] = {.lex_state = 0, .external_lex_state = 5},
  [9088] = {.lex_state = 0, .external_lex_state = 5},
  [9089] = {.lex_state = 0, .external_lex_state = 5},
  [9090] = {.lex_state = 0, .external_lex_state = 5},
  [9091] = {.lex_state = 0, .external_lex_state = 5},
  [9092] = {.lex_state = 0, .external_lex_state = 5},
  [9093] = {.lex_state = 0, .external_lex_state = 5},
  [9094] = {.lex_state = 0, .external_lex_state = 5},
  [9095] = {.lex_state = 0, .external_lex_state = 5},
  [9096] = {.lex_state = 0, .external_lex_state = 5},
  [9097] = {.lex_state = 0, .external_lex_state = 5},
  [9098] = {.lex_state = 0, .external_lex_state = 5},
  [9099] = {.lex_state = 0, .external_lex_state = 5},
  [9100] = {.lex_state = 0, .external_lex_state = 5},
  [9101] = {.lex_state = 0, .external_lex_state = 5},
  [9102] = {.lex_state = 0, .external_lex_state = 5},
  [9103] = {.lex_state = 127, .external_lex_state = 5},
  [9104] = {.lex_state = 0, .external_lex_state = 5},
  [9105] = {.lex_state = 0, .external_lex_state = 5},
  [9106] = {.lex_state = 0, .external_lex_state = 5},
  [9107] = {.lex_state = 0, .external_lex_state = 5},
  [9108] = {.lex_state = 0, .external_lex_state = 5},
  [9109] = {.lex_state = 0, .external_lex_state = 5},
  [9110] = {.lex_state = 0, .external_lex_state = 5},
  [9111] = {.lex_state = 0, .external_lex_state = 5},
  [9112] = {.lex_state = 0, .external_lex_state = 5},
  [9113] = {.lex_state = 0, .external_lex_state = 5},
  [9114] = {.lex_state = 0, .external_lex_state = 5},
  [9115] = {.lex_state = 0, .external_lex_state = 5},
  [9116] = {.lex_state = 0, .external_lex_state = 5},
  [9117] = {.lex_state = 0, .external_lex_state = 5},
  [9118] = {.lex_state = 0, .external_lex_state = 5},
  [9119] = {.lex_state = 0, .external_lex_state = 5},
  [9120] = {.lex_state = 0, .external_lex_state = 5},
  [9121] = {.lex_state = 127, .external_lex_state = 5},
  [9122] = {.lex_state = 0, .external_lex_state = 5},
  [9123] = {.lex_state = 0, .external_lex_state = 5},
  [9124] = {.lex_state = 0, .external_lex_state = 5},
  [9125] = {.lex_state = 0, .external_lex_state = 5},
  [9126] = {.lex_state = 0, .external_lex_state = 5},
  [9127] = {.lex_state = 0, .external_lex_state = 5},
  [9128] = {.lex_state = 0, .external_lex_state = 5},
  [9129] = {.lex_state = 0, .external_lex_state = 5},
  [9130] = {.lex_state = 0, .external_lex_state = 5},
  [9131] = {.lex_state = 0, .external_lex_state = 5},
  [9132] = {.lex_state = 0, .external_lex_state = 5},
  [9133] = {.lex_state = 0, .external_lex_state = 5},
  [9134] = {.lex_state = 0, .external_lex_state = 5},
  [9135] = {.lex_state = 0, .external_lex_state = 5},
  [9136] = {.lex_state = 0, .external_lex_state = 5},
  [9137] = {.lex_state = 0, .external_lex_state = 5},
  [9138] = {.lex_state = 0, .external_lex_state = 5},
  [9139] = {.lex_state = 127, .external_lex_state = 5},
  [9140] = {.lex_state = 0, .external_lex_state = 5},
  [9141] = {.lex_state = 0, .external_lex_state = 5},
  [9142] = {.lex_state = 0, .external_lex_state = 5},
  [9143] = {.lex_state = 127, .external_lex_state = 5},
  [9144] = {.lex_state = 0, .external_lex_state = 5},
  [9145] = {.lex_state = 0, .external_lex_state = 5},
  [9146] = {.lex_state = 0, .external_lex_state = 5},
  [9147] = {.lex_state = 0, .external_lex_state = 5},
  [9148] = {.lex_state = 0, .external_lex_state = 5},
  [9149] = {.lex_state = 0, .external_lex_state = 5},
  [9150] = {.lex_state = 0, .external_lex_state = 5},
  [9151] = {.lex_state = 0, .external_lex_state = 5},
  [9152] = {.lex_state = 0, .external_lex_state = 5},
  [9153] = {.lex_state = 0, .external_lex_state = 5},
  [9154] = {.lex_state = 0, .external_lex_state = 5},
  [9155] = {.lex_state = 0, .external_lex_state = 5},
  [9156] = {.lex_state = 0, .external_lex_state = 5},
  [9157] = {.lex_state = 127, .external_lex_state = 5},
  [9158] = {.lex_state = 0, .external_lex_state = 5},
  [9159] = {.lex_state = 0, .external_lex_state = 5},
  [9160] = {.lex_state = 0, .external_lex_state = 5},
  [9161] = {.lex_state = 0, .external_lex_state = 5},
  [9162] = {.lex_state = 0, .external_lex_state = 5},
  [9163] = {.lex_state = 0, .external_lex_state = 5},
  [9164] = {.lex_state = 0, .external_lex_state = 5},
  [9165] = {.lex_state = 0, .external_lex_state = 5},
  [9166] = {.lex_state = 0, .external_lex_state = 5},
  [9167] = {.lex_state = 0, .external_lex_state = 5},
  [9168] = {.lex_state = 0, .external_lex_state = 5},
  [9169] = {.lex_state = 0, .external_lex_state = 5},
  [9170] = {.lex_state = 0, .external_lex_state = 5},
  [9171] = {.lex_state = 0, .external_lex_state = 5},
  [9172] = {.lex_state = 0, .external_lex_state = 5},
  [9173] = {.lex_state = 0, .external_lex_state = 5},
  [9174] = {.lex_state = 0, .external_lex_state = 5},
  [9175] = {.lex_state = 127, .external_lex_state = 5},
  [9176] = {.lex_state = 0, .external_lex_state = 5},
  [9177] = {.lex_state = 127, .external_lex_state = 5},
  [9178] = {.lex_state = 0, .external_lex_state = 5},
  [9179] = {.lex_state = 0, .external_lex_state = 5},
  [9180] = {.lex_state = 0, .external_lex_state = 5},
  [9181] = {.lex_state = 0, .external_lex_state = 5},
  [9182] = {.lex_state = 0, .external_lex_state = 5},
  [9183] = {.lex_state = 0, .external_lex_state = 5},
  [9184] = {.lex_state = 0, .external_lex_state = 5},
  [9185] = {.lex_state = 0, .external_lex_state = 5},
  [9186] = {.lex_state = 0, .external_lex_state = 5},
  [9187] = {.lex_state = 0, .external_lex_state = 5},
  [9188] = {.lex_state = 0, .external_lex_state = 5},
  [9189] = {.lex_state = 0, .external_lex_state = 5},
  [9190] = {.lex_state = 0, .external_lex_state = 5},
  [9191] = {.lex_state = 0, .external_lex_state = 5},
  [9192] = {.lex_state = 0, .external_lex_state = 5},
  [9193] = {.lex_state = 127, .external_lex_state = 5},
  [9194] = {.lex_state = 0, .external_lex_state = 5},
  [9195] = {.lex_state = 0, .external_lex_state = 5},
  [9196] = {.lex_state = 0, .external_lex_state = 5},
  [9197] = {.lex_state = 0, .external_lex_state = 5},
  [9198] = {.lex_state = 0, .external_lex_state = 5},
  [9199] = {.lex_state = 0, .external_lex_state = 5},
  [9200] = {.lex_state = 0, .external_lex_state = 5},
  [9201] = {.lex_state = 0, .external_lex_state = 5},
  [9202] = {.lex_state = 0, .external_lex_state = 5},
  [9203] = {.lex_state = 0, .external_lex_state = 5},
  [9204] = {.lex_state = 0, .external_lex_state = 5},
  [9205] = {.lex_state = 0, .external_lex_state = 5},
  [9206] = {.lex_state = 0, .external_lex_state = 5},
  [9207] = {.lex_state = 0, .external_lex_state = 5},
  [9208] = {.lex_state = 0, .external_lex_state = 5},
  [9209] = {.lex_state = 0, .external_lex_state = 5},
  [9210] = {.lex_state = 0, .external_lex_state = 5},
  [9211] = {.lex_state = 127, .external_lex_state = 5},
  [9212] = {.lex_state = 0, .external_lex_state = 5},
  [9213] = {.lex_state = 0, .external_lex_state = 5},
  [9214] = {.lex_state = 0, .external_lex_state = 5},
  [9215] = {.lex_state = 0, .external_lex_state = 5},
  [9216] = {.lex_state = 0, .external_lex_state = 5},
  [9217] = {.lex_state = 0, .external_lex_state = 5},
  [9218] = {.lex_state = 0, .external_lex_state = 5},
  [9219] = {.lex_state = 0, .external_lex_state = 5},
  [9220] = {.lex_state = 0, .external_lex_state = 5},
  [9221] = {.lex_state = 0, .external_lex_state = 5},
  [9222] = {.lex_state = 127, .external_lex_state = 5},
  [9223] = {.lex_state = 0, .external_lex_state = 5},
  [9224] = {.lex_state = 0, .external_lex_state = 5},
  [9225] = {.lex_state = 0, .external_lex_state = 5},
  [9226] = {.lex_state = 0, .external_lex_state = 5},
  [9227] = {.lex_state = 0, .external_lex_state = 5},
  [9228] = {.lex_state = 0, .external_lex_state = 5},
  [9229] = {.lex_state = 127, .external_lex_state = 5},
  [9230] = {.lex_state = 0, .external_lex_state = 5},
  [9231] = {.lex_state = 0, .external_lex_state = 5},
  [9232] = {.lex_state = 0, .external_lex_state = 5},
  [9233] = {.lex_state = 0, .external_lex_state = 5},
  [9234] = {.lex_state = 0, .external_lex_state = 5},
  [9235] = {.lex_state = 0, .external_lex_state = 5},
  [9236] = {.lex_state = 0, .external_lex_state = 5},
  [9237] = {.lex_state = 0, .external_lex_state = 5},
  [9238] = {.lex_state = 0, .external_lex_state = 5},
  [9239] = {.lex_state = 0, .external_lex_state = 5},
  [9240] = {.lex_state = 0, .external_lex_state = 5},
  [9241] = {.lex_state = 0, .external_lex_state = 5},
  [9242] = {.lex_state = 0, .external_lex_state = 5},
  [9243] = {.lex_state = 0, .external_lex_state = 5},
  [9244] = {.lex_state = 0, .external_lex_state = 5},
  [9245] = {.lex_state = 0, .external_lex_state = 5},
  [9246] = {.lex_state = 0, .external_lex_state = 5},
  [9247] = {.lex_state = 127, .external_lex_state = 5},
  [9248] = {.lex_state = 0, .external_lex_state = 5},
  [9249] = {.lex_state = 0, .external_lex_state = 5},
  [9250] = {.lex_state = 0, .external_lex_state = 5},
  [9251] = {.lex_state = 0, .external_lex_state = 5},
  [9252] = {.lex_state = 0, .external_lex_state = 5},
  [9253] = {.lex_state = 0, .external_lex_state = 5},
  [9254] = {.lex_state = 0, .external_lex_state = 5},
  [9255] = {.lex_state = 0, .external_lex_state = 5},
  [9256] = {.lex_state = 0, .external_lex_state = 5},
  [9257] = {.lex_state = 0, .external_lex_state = 5},
  [9258] = {.lex_state = 0, .external_lex_state = 5},
  [9259] = {.lex_state = 0, .external_lex_state = 5},
  [9260] = {.lex_state = 0, .external_lex_state = 5},
  [9261] = {.lex_state = 127, .external_lex_state = 5},
  [9262] = {.lex_state = 0, .external_lex_state = 5},
  [9263] = {.lex_state = 0, .external_lex_state = 5},
  [9264] = {.lex_state = 0, .external_lex_state = 5},
  [9265] = {.lex_state = 127, .external_lex_state = 5},
  [9266] = {.lex_state = 0, .external_lex_state = 5},
  [9267] = {.lex_state = 0, .external_lex_state = 5},
  [9268] = {.lex_state = 0, .external_lex_state = 5},
  [9269] = {.lex_state = 0, .external_lex_state = 5},
  [9270] = {.lex_state = 0, .external_lex_state = 5},
  [9271] = {.lex_state = 0, .external_lex_state = 5},
  [9272] = {.lex_state = 0, .external_lex_state = 5},
  [9273] = {.lex_state = 0, .external_lex_state = 5},
  [9274] = {.lex_state = 0, .external_lex_state = 5},
  [9275] = {.lex_state = 0, .external_lex_state = 5},
  [9276] = {.lex_state = 0, .external_lex_state = 5},
  [9277] = {.lex_state = 0, .external_lex_state = 5},
  [9278] = {.lex_state = 0, .external_lex_state = 5},
  [9279] = {.lex_state = 0, .external_lex_state = 5},
  [9280] = {.lex_state = 0, .external_lex_state = 5},
  [9281] = {.lex_state = 0, .external_lex_state = 5},
  [9282] = {.lex_state = 0, .external_lex_state = 5},
  [9283] = {.lex_state = 127, .external_lex_state = 5},
  [9284] = {.lex_state = 0, .external_lex_state = 5},
  [9285] = {.lex_state = 0, .external_lex_state = 5},
  [9286] = {.lex_state = 0, .external_lex_state = 5},
  [9287] = {.lex_state = 0, .external_lex_state = 5},
  [9288] = {.lex_state = 0, .external_lex_state = 5},
  [9289] = {.lex_state = 0, .external_lex_state = 5},
  [9290] = {.lex_state = 0, .external_lex_state = 5},
  [9291] = {.lex_state = 0, .external_lex_state = 5},
  [9292] = {.lex_state = 0, .external_lex_state = 5},
  [9293] = {.lex_state = 0, .external_lex_state = 5},
  [9294] = {.lex_state = 0, .external_lex_state = 5},
  [9295] = {.lex_state = 0, .external_lex_state = 5},
  [9296] = {.lex_state = 0, .external_lex_state = 5},
  [9297] = {.lex_state = 0, .external_lex_state = 5},
  [9298] = {.lex_state = 0, .external_lex_state = 5},
  [9299] = {.lex_state = 0, .external_lex_state = 5},
  [9300] = {.lex_state = 0, .external_lex_state = 5},
  [9301] = {.lex_state = 127, .external_lex_state = 5},
  [9302] = {.lex_state = 0, .external_lex_state = 5},
  [9303] = {.lex_state = 0, .external_lex_state = 5},
  [9304] = {.lex_state = 127, .external_lex_state = 5},
  [9305] = {.lex_state = 0, .external_lex_state = 5},
  [9306] = {.lex_state = 127, .external_lex_state = 5},
  [9307] = {.lex_state = 127, .external_lex_state = 5},
  [9308] = {.lex_state = 0, .external_lex_state = 5},
  [9309] = {.lex_state = 0, .external_lex_state = 5},
  [9310] = {.lex_state = 127, .external_lex_state = 5},
  [9311] = {.lex_state = 0, .external_lex_state = 5},
  [9312] = {.lex_state = 0, .external_lex_state = 5},
  [9313] = {.lex_state = 127, .external_lex_state = 5},
  [9314] = {.lex_state = 0, .external_lex_state = 5},
  [9315] = {.lex_state = 0, .external_lex_state = 5},
  [9316] = {.lex_state = 127, .external_lex_state = 5},
  [9317] = {.lex_state = 0, .external_lex_state = 5},
  [9318] = {.lex_state = 183, .external_lex_state = 5},
  [9319] = {.lex_state = 0, .external_lex_state = 5},
  [9320] = {.lex_state = 199, .external_lex_state = 5},
  [9321] = {.lex_state = 199, .external_lex_state = 5},
  [9322] = {.lex_state = 0, .external_lex_state = 5},
  [9323] = {.lex_state = 0, .external_lex_state = 5},
  [9324] = {.lex_state = 0, .external_lex_state = 5},
  [9325] = {.lex_state = 181, .external_lex_state = 5},
  [9326] = {.lex_state = 0, .external_lex_state = 5},
  [9327] = {.lex_state = 181, .external_lex_state = 5},
  [9328] = {.lex_state = 0, .external_lex_state = 5},
  [9329] = {.lex_state = 0, .external_lex_state = 5},
  [9330] = {.lex_state = 183, .external_lex_state = 5},
  [9331] = {.lex_state = 0, .external_lex_state = 5},
  [9332] = {.lex_state = 181, .external_lex_state = 5},
  [9333] = {.lex_state = 0, .external_lex_state = 5},
  [9334] = {.lex_state = 183, .external_lex_state = 5},
  [9335] = {.lex_state = 127, .external_lex_state = 5},
  [9336] = {.lex_state = 0, .external_lex_state = 5},
  [9337] = {.lex_state = 0, .external_lex_state = 5},
  [9338] = {.lex_state = 0, .external_lex_state = 5},
  [9339] = {.lex_state = 181, .external_lex_state = 5},
  [9340] = {.lex_state = 0, .external_lex_state = 5},
  [9341] = {.lex_state = 0, .external_lex_state = 5},
  [9342] = {.lex_state = 0, .external_lex_state = 47},
  [9343] = {.lex_state = 0, .external_lex_state = 47},
  [9344] = {.lex_state = 0, .external_lex_state = 5},
  [9345] = {.lex_state = 0, .external_lex_state = 5},
  [9346] = {.lex_state = 181, .external_lex_state = 5},
  [9347] = {.lex_state = 181, .external_lex_state = 5},
  [9348] = {.lex_state = 0, .external_lex_state = 5},
  [9349] = {.lex_state = 0, .external_lex_state = 5},
  [9350] = {.lex_state = 0, .external_lex_state = 5},
  [9351] = {.lex_state = 0, .external_lex_state = 5},
  [9352] = {.lex_state = 183, .external_lex_state = 5},
  [9353] = {.lex_state = 0, .external_lex_state = 5},
  [9354] = {.lex_state = 0, .external_lex_state = 5},
  [9355] = {.lex_state = 0, .external_lex_state = 5},
  [9356] = {.lex_state = 199, .external_lex_state = 6},
  [9357] = {.lex_state = 0, .external_lex_state = 5},
  [9358] = {.lex_state = 0, .external_lex_state = 5},
  [9359] = {.lex_state = 0, .external_lex_state = 47},
  [9360] = {.lex_state = 0, .external_lex_state = 5},
  [9361] = {.lex_state = 0, .external_lex_state = 5},
  [9362] = {.lex_state = 0, .external_lex_state = 5},
  [9363] = {.lex_state = 0, .external_lex_state = 47},
  [9364] = {.lex_state = 127, .external_lex_state = 5},
  [9365] = {.lex_state = 0, .external_lex_state = 5},
  [9366] = {.lex_state = 199, .external_lex_state = 5},
  [9367] = {.lex_state = 0, .external_lex_state = 5},
  [9368] = {.lex_state = 127, .external_lex_state = 5},
  [9369] = {.lex_state = 0, .external_lex_state = 5},
  [9370] = {.lex_state = 0, .external_lex_state = 5},
  [9371] = {.lex_state = 0, .external_lex_state = 5},
  [9372] = {.lex_state = 0, .external_lex_state = 5},
  [9373] = {.lex_state = 0, .external_lex_state = 5},
  [9374] = {.lex_state = 0, .external_lex_state = 5},
  [9375] = {.lex_state = 0, .external_lex_state = 5},
  [9376] = {.lex_state = 0, .external_lex_state = 5},
  [9377] = {.lex_state = 0, .external_lex_state = 5},
  [9378] = {.lex_state = 0, .external_lex_state = 5},
  [9379] = {.lex_state = 0, .external_lex_state = 5},
  [9380] = {.lex_state = 0, .external_lex_state = 5},
  [9381] = {.lex_state = 0, .external_lex_state = 5},
  [9382] = {.lex_state = 0, .external_lex_state = 5},
  [9383] = {.lex_state = 0, .external_lex_state = 5},
  [9384] = {.lex_state = 0, .external_lex_state = 5},
  [9385] = {.lex_state = 0, .external_lex_state = 5},
  [9386] = {.lex_state = 0, .external_lex_state = 5},
  [9387] = {.lex_state = 0, .external_lex_state = 5},
  [9388] = {.lex_state = 181, .external_lex_state = 5},
  [9389] = {.lex_state = 183, .external_lex_state = 5},
  [9390] = {.lex_state = 0, .external_lex_state = 5},
  [9391] = {.lex_state = 0, .external_lex_state = 5},
  [9392] = {.lex_state = 0, .external_lex_state = 5},
  [9393] = {.lex_state = 0, .external_lex_state = 47},
  [9394] = {.lex_state = 0, .external_lex_state = 47},
  [9395] = {.lex_state = 0, .external_lex_state = 5},
  [9396] = {.lex_state = 0, .external_lex_state = 5},
  [9397] = {.lex_state = 127, .external_lex_state = 5},
  [9398] = {.lex_state = 0, .external_lex_state = 5},
  [9399] = {.lex_state = 183, .external_lex_state = 5},
  [9400] = {.lex_state = 0, .external_lex_state = 5},
  [9401] = {.lex_state = 0, .external_lex_state = 5},
  [9402] = {.lex_state = 199, .external_lex_state = 6},
  [9403] = {.lex_state = 127, .external_lex_state = 5},
  [9404] = {.lex_state = 0, .external_lex_state = 5},
  [9405] = {.lex_state = 0, .external_lex_state = 5},
  [9406] = {.lex_state = 0, .external_lex_state = 47},
  [9407] = {.lex_state = 0, .external_lex_state = 5},
  [9408] = {.lex_state = 199, .external_lex_state = 5},
  [9409] = {.lex_state = 0, .external_lex_state = 5},
  [9410] = {.lex_state = 0, .external_lex_state = 5},
  [9411] = {.lex_state = 0, .external_lex_state = 5},
  [9412] = {.lex_state = 0, .external_lex_state = 5},
  [9413] = {.lex_state = 0, .external_lex_state = 5},
  [9414] = {.lex_state = 0, .external_lex_state = 5},
  [9415] = {.lex_state = 0, .external_lex_state = 5},
  [9416] = {.lex_state = 0, .external_lex_state = 47},
  [9417] = {.lex_state = 0, .external_lex_state = 47},
  [9418] = {.lex_state = 0, .external_lex_state = 5},
  [9419] = {.lex_state = 0, .external_lex_state = 5},
  [9420] = {.lex_state = 0, .external_lex_state = 5},
  [9421] = {.lex_state = 0, .external_lex_state = 5},
  [9422] = {.lex_state = 0, .external_lex_state = 5},
  [9423] = {.lex_state = 199, .external_lex_state = 6},
  [9424] = {.lex_state = 0, .external_lex_state = 5},
  [9425] = {.lex_state = 0, .external_lex_state = 5},
  [9426] = {.lex_state = 0, .external_lex_state = 5},
  [9427] = {.lex_state = 0, .external_lex_state = 47},
  [9428] = {.lex_state = 0, .external_lex_state = 5},
  [9429] = {.lex_state = 199, .external_lex_state = 5},
  [9430] = {.lex_state = 0, .external_lex_state = 5},
  [9431] = {.lex_state = 0, .external_lex_state = 5},
  [9432] = {.lex_state = 0, .external_lex_state = 5},
  [9433] = {.lex_state = 0, .external_lex_state = 5},
  [9434] = {.lex_state = 0, .external_lex_state = 47},
  [9435] = {.lex_state = 0, .external_lex_state = 47},
  [9436] = {.lex_state = 0, .external_lex_state = 5},
  [9437] = {.lex_state = 127, .external_lex_state = 5},
  [9438] = {.lex_state = 0, .external_lex_state = 5},
  [9439] = {.lex_state = 0, .external_lex_state = 5},
  [9440] = {.lex_state = 0, .external_lex_state = 5},
  [9441] = {.lex_state = 0, .external_lex_state = 5},
  [9442] = {.lex_state = 0, .external_lex_state = 5},
  [9443] = {.lex_state = 0, .external_lex_state = 5},
  [9444] = {.lex_state = 0, .external_lex_state = 5},
  [9445] = {.lex_state = 0, .external_lex_state = 47},
  [9446] = {.lex_state = 0, .external_lex_state = 5},
  [9447] = {.lex_state = 199, .external_lex_state = 5},
  [9448] = {.lex_state = 0, .external_lex_state = 5},
  [9449] = {.lex_state = 0, .external_lex_state = 5},
  [9450] = {.lex_state = 0, .external_lex_state = 5},
  [9451] = {.lex_state = 0, .external_lex_state = 5},
  [9452] = {.lex_state = 0, .external_lex_state = 47},
  [9453] = {.lex_state = 0, .external_lex_state = 47},
  [9454] = {.lex_state = 0, .external_lex_state = 5},
  [9455] = {.lex_state = 0, .external_lex_state = 5},
  [9456] = {.lex_state = 0, .external_lex_state = 5},
  [9457] = {.lex_state = 0, .external_lex_state = 5},
  [9458] = {.lex_state = 0, .external_lex_state = 5},
  [9459] = {.lex_state = 199, .external_lex_state = 6},
  [9460] = {.lex_state = 0, .external_lex_state = 5},
  [9461] = {.lex_state = 0, .external_lex_state = 5},
  [9462] = {.lex_state = 0, .external_lex_state = 5},
  [9463] = {.lex_state = 0, .external_lex_state = 47},
  [9464] = {.lex_state = 0, .external_lex_state = 5},
  [9465] = {.lex_state = 199, .external_lex_state = 5},
  [9466] = {.lex_state = 0, .external_lex_state = 5},
  [9467] = {.lex_state = 0, .external_lex_state = 5},
  [9468] = {.lex_state = 0, .external_lex_state = 5},
  [9469] = {.lex_state = 0, .external_lex_state = 5},
  [9470] = {.lex_state = 0, .external_lex_state = 47},
  [9471] = {.lex_state = 0, .external_lex_state = 47},
  [9472] = {.lex_state = 0, .external_lex_state = 5},
  [9473] = {.lex_state = 0, .external_lex_state = 5},
  [9474] = {.lex_state = 0, .external_lex_state = 5},
  [9475] = {.lex_state = 0, .external_lex_state = 5},
  [9476] = {.lex_state = 199, .external_lex_state = 6},
  [9477] = {.lex_state = 0, .external_lex_state = 5},
  [9478] = {.lex_state = 0, .external_lex_state = 5},
  [9479] = {.lex_state = 127, .external_lex_state = 5},
  [9480] = {.lex_state = 0, .external_lex_state = 47},
  [9481] = {.lex_state = 127, .external_lex_state = 5},
  [9482] = {.lex_state = 199, .external_lex_state = 5},
  [9483] = {.lex_state = 0, .external_lex_state = 5},
  [9484] = {.lex_state = 0, .external_lex_state = 5},
  [9485] = {.lex_state = 0, .external_lex_state = 5},
  [9486] = {.lex_state = 0, .external_lex_state = 47},
  [9487] = {.lex_state = 0, .external_lex_state = 47},
  [9488] = {.lex_state = 0, .external_lex_state = 5},
  [9489] = {.lex_state = 0, .external_lex_state = 5},
  [9490] = {.lex_state = 0, .external_lex_state = 5},
  [9491] = {.lex_state = 0, .external_lex_state = 5},
  [9492] = {.lex_state = 199, .external_lex_state = 6},
  [9493] = {.lex_state = 0, .external_lex_state = 5},
  [9494] = {.lex_state = 0, .external_lex_state = 5},
  [9495] = {.lex_state = 0, .external_lex_state = 5},
  [9496] = {.lex_state = 0, .external_lex_state = 47},
  [9497] = {.lex_state = 0, .external_lex_state = 5},
  [9498] = {.lex_state = 199, .external_lex_state = 5},
  [9499] = {.lex_state = 0, .external_lex_state = 5},
  [9500] = {.lex_state = 0, .external_lex_state = 5},
  [9501] = {.lex_state = 0, .external_lex_state = 5},
  [9502] = {.lex_state = 0, .external_lex_state = 47},
  [9503] = {.lex_state = 0, .external_lex_state = 47},
  [9504] = {.lex_state = 0, .external_lex_state = 5},
  [9505] = {.lex_state = 0, .external_lex_state = 5},
  [9506] = {.lex_state = 0, .external_lex_state = 5},
  [9507] = {.lex_state = 0, .external_lex_state = 5},
  [9508] = {.lex_state = 199, .external_lex_state = 6},
  [9509] = {.lex_state = 0, .external_lex_state = 5},
  [9510] = {.lex_state = 0, .external_lex_state = 5},
  [9511] = {.lex_state = 0, .external_lex_state = 5},
  [9512] = {.lex_state = 0, .external_lex_state = 47},
  [9513] = {.lex_state = 0, .external_lex_state = 5},
  [9514] = {.lex_state = 199, .external_lex_state = 5},
  [9515] = {.lex_state = 0, .external_lex_state = 5},
  [9516] = {.lex_state = 0, .external_lex_state = 5},
  [9517] = {.lex_state = 0, .external_lex_state = 5},
  [9518] = {.lex_state = 0, .external_lex_state = 47},
  [9519] = {.lex_state = 0, .external_lex_state = 47},
  [9520] = {.lex_state = 0, .external_lex_state = 5},
  [9521] = {.lex_state = 127, .external_lex_state = 5},
  [9522] = {.lex_state = 127, .external_lex_state = 5},
  [9523] = {.lex_state = 0, .external_lex_state = 5},
  [9524] = {.lex_state = 199, .external_lex_state = 6},
  [9525] = {.lex_state = 0, .external_lex_state = 5},
  [9526] = {.lex_state = 0, .external_lex_state = 5},
  [9527] = {.lex_state = 0, .external_lex_state = 5},
  [9528] = {.lex_state = 0, .external_lex_state = 47},
  [9529] = {.lex_state = 0, .external_lex_state = 5},
  [9530] = {.lex_state = 199, .external_lex_state = 5},
  [9531] = {.lex_state = 0, .external_lex_state = 5},
  [9532] = {.lex_state = 0, .external_lex_state = 5},
  [9533] = {.lex_state = 0, .external_lex_state = 5},
  [9534] = {.lex_state = 0, .external_lex_state = 47},
  [9535] = {.lex_state = 0, .external_lex_state = 47},
  [9536] = {.lex_state = 0, .external_lex_state = 5},
  [9537] = {.lex_state = 0, .external_lex_state = 5},
  [9538] = {.lex_state = 0, .external_lex_state = 5},
  [9539] = {.lex_state = 0, .external_lex_state = 5},
  [9540] = {.lex_state = 199, .external_lex_state = 6},
  [9541] = {.lex_state = 0, .external_lex_state = 5},
  [9542] = {.lex_state = 0, .external_lex_state = 5},
  [9543] = {.lex_state = 0, .external_lex_state = 5},
  [9544] = {.lex_state = 0, .external_lex_state = 47},
  [9545] = {.lex_state = 0, .external_lex_state = 5},
  [9546] = {.lex_state = 199, .external_lex_state = 5},
  [9547] = {.lex_state = 0, .external_lex_state = 5},
  [9548] = {.lex_state = 0, .external_lex_state = 5},
  [9549] = {.lex_state = 0, .external_lex_state = 5},
  [9550] = {.lex_state = 0, .external_lex_state = 47},
  [9551] = {.lex_state = 0, .external_lex_state = 47},
  [9552] = {.lex_state = 0, .external_lex_state = 5},
  [9553] = {.lex_state = 0, .external_lex_state = 5},
  [9554] = {.lex_state = 0, .external_lex_state = 5},
  [9555] = {.lex_state = 0, .external_lex_state = 5},
  [9556] = {.lex_state = 199, .external_lex_state = 6},
  [9557] = {.lex_state = 0, .external_lex_state = 5},
  [9558] = {.lex_state = 0, .external_lex_state = 5},
  [9559] = {.lex_state = 0, .external_lex_state = 5},
  [9560] = {.lex_state = 0, .external_lex_state = 47},
  [9561] = {.lex_state = 0, .external_lex_state = 5},
  [9562] = {.lex_state = 199, .external_lex_state = 5},
  [9563] = {.lex_state = 0, .external_lex_state = 5},
  [9564] = {.lex_state = 0, .external_lex_state = 5},
  [9565] = {.lex_state = 0, .external_lex_state = 47},
  [9566] = {.lex_state = 0, .external_lex_state = 47},
  [9567] = {.lex_state = 0, .external_lex_state = 5},
  [9568] = {.lex_state = 0, .external_lex_state = 5},
  [9569] = {.lex_state = 199, .external_lex_state = 5},
  [9570] = {.lex_state = 0, .external_lex_state = 5},
  [9571] = {.lex_state = 199, .external_lex_state = 6},
  [9572] = {.lex_state = 0, .external_lex_state = 5},
  [9573] = {.lex_state = 0, .external_lex_state = 5},
  [9574] = {.lex_state = 0, .external_lex_state = 5},
  [9575] = {.lex_state = 0, .external_lex_state = 47},
  [9576] = {.lex_state = 127, .external_lex_state = 5},
  [9577] = {.lex_state = 199, .external_lex_state = 5},
  [9578] = {.lex_state = 0, .external_lex_state = 5},
  [9579] = {.lex_state = 0, .external_lex_state = 5},
  [9580] = {.lex_state = 0, .external_lex_state = 47},
  [9581] = {.lex_state = 0, .external_lex_state = 47},
  [9582] = {.lex_state = 127, .external_lex_state = 5},
  [9583] = {.lex_state = 0, .external_lex_state = 5},
  [9584] = {.lex_state = 0, .external_lex_state = 5},
  [9585] = {.lex_state = 0, .external_lex_state = 5},
  [9586] = {.lex_state = 199, .external_lex_state = 6},
  [9587] = {.lex_state = 0, .external_lex_state = 5},
  [9588] = {.lex_state = 0, .external_lex_state = 5},
  [9589] = {.lex_state = 0, .external_lex_state = 5},
  [9590] = {.lex_state = 0, .external_lex_state = 47},
  [9591] = {.lex_state = 0, .external_lex_state = 5},
  [9592] = {.lex_state = 199, .external_lex_state = 5},
  [9593] = {.lex_state = 0, .external_lex_state = 5},
  [9594] = {.lex_state = 0, .external_lex_state = 5},
  [9595] = {.lex_state = 0, .external_lex_state = 47},
  [9596] = {.lex_state = 0, .external_lex_state = 47},
  [9597] = {.lex_state = 0, .external_lex_state = 5},
  [9598] = {.lex_state = 0, .external_lex_state = 5},
  [9599] = {.lex_state = 0, .external_lex_state = 5},
  [9600] = {.lex_state = 0, .external_lex_state = 5},
  [9601] = {.lex_state = 199, .external_lex_state = 6},
  [9602] = {.lex_state = 0, .external_lex_state = 5},
  [9603] = {.lex_state = 0, .external_lex_state = 5},
  [9604] = {.lex_state = 0, .external_lex_state = 5},
  [9605] = {.lex_state = 0, .external_lex_state = 47},
  [9606] = {.lex_state = 0, .external_lex_state = 5},
  [9607] = {.lex_state = 199, .external_lex_state = 5},
  [9608] = {.lex_state = 0, .external_lex_state = 5},
  [9609] = {.lex_state = 0, .external_lex_state = 5},
  [9610] = {.lex_state = 0, .external_lex_state = 47},
  [9611] = {.lex_state = 0, .external_lex_state = 47},
  [9612] = {.lex_state = 0, .external_lex_state = 5},
  [9613] = {.lex_state = 0, .external_lex_state = 46},
  [9614] = {.lex_state = 0, .external_lex_state = 5},
  [9615] = {.lex_state = 199, .external_lex_state = 6},
  [9616] = {.lex_state = 0, .external_lex_state = 5},
  [9617] = {.lex_state = 0, .external_lex_state = 5},
  [9618] = {.lex_state = 0, .external_lex_state = 5},
  [9619] = {.lex_state = 0, .external_lex_state = 47},
  [9620] = {.lex_state = 0, .external_lex_state = 5},
  [9621] = {.lex_state = 199, .external_lex_state = 5},
  [9622] = {.lex_state = 0, .external_lex_state = 5},
  [9623] = {.lex_state = 0, .external_lex_state = 5},
  [9624] = {.lex_state = 0, .external_lex_state = 47},
  [9625] = {.lex_state = 0, .external_lex_state = 47},
  [9626] = {.lex_state = 0, .external_lex_state = 5},
  [9627] = {.lex_state = 0, .external_lex_state = 5},
  [9628] = {.lex_state = 0, .external_lex_state = 5},
  [9629] = {.lex_state = 199, .external_lex_state = 6},
  [9630] = {.lex_state = 0, .external_lex_state = 5},
  [9631] = {.lex_state = 127, .external_lex_state = 5},
  [9632] = {.lex_state = 0, .external_lex_state = 5},
  [9633] = {.lex_state = 0, .external_lex_state = 47},
  [9634] = {.lex_state = 0, .external_lex_state = 5},
  [9635] = {.lex_state = 199, .external_lex_state = 5},
  [9636] = {.lex_state = 0, .external_lex_state = 5},
  [9637] = {.lex_state = 0, .external_lex_state = 5},
  [9638] = {.lex_state = 0, .external_lex_state = 47},
  [9639] = {.lex_state = 0, .external_lex_state = 47},
  [9640] = {.lex_state = 0, .external_lex_state = 5},
  [9641] = {.lex_state = 0, .external_lex_state = 5},
  [9642] = {.lex_state = 0, .external_lex_state = 5},
  [9643] = {.lex_state = 199, .external_lex_state = 6},
  [9644] = {.lex_state = 0, .external_lex_state = 5},
  [9645] = {.lex_state = 0, .external_lex_state = 5},
  [9646] = {.lex_state = 0, .external_lex_state = 5},
  [9647] = {.lex_state = 0, .external_lex_state = 47},
  [9648] = {.lex_state = 0, .external_lex_state = 5},
  [9649] = {.lex_state = 199, .external_lex_state = 5},
  [9650] = {.lex_state = 0, .external_lex_state = 5},
  [9651] = {.lex_state = 0, .external_lex_state = 5},
  [9652] = {.lex_state = 0, .external_lex_state = 47},
  [9653] = {.lex_state = 0, .external_lex_state = 47},
  [9654] = {.lex_state = 0, .external_lex_state = 5},
  [9655] = {.lex_state = 0, .external_lex_state = 5},
  [9656] = {.lex_state = 0, .external_lex_state = 5},
  [9657] = {.lex_state = 199, .external_lex_state = 6},
  [9658] = {.lex_state = 0, .external_lex_state = 5},
  [9659] = {.lex_state = 0, .external_lex_state = 5},
  [9660] = {.lex_state = 0, .external_lex_state = 5},
  [9661] = {.lex_state = 0, .external_lex_state = 47},
  [9662] = {.lex_state = 0, .external_lex_state = 5},
  [9663] = {.lex_state = 199, .external_lex_state = 5},
  [9664] = {.lex_state = 0, .external_lex_state = 5},
  [9665] = {.lex_state = 0, .external_lex_state = 5},
  [9666] = {.lex_state = 0, .external_lex_state = 47},
  [9667] = {.lex_state = 0, .external_lex_state = 47},
  [9668] = {.lex_state = 0, .external_lex_state = 5},
  [9669] = {.lex_state = 0, .external_lex_state = 5},
  [9670] = {.lex_state = 0, .external_lex_state = 5},
  [9671] = {.lex_state = 199, .external_lex_state = 6},
  [9672] = {.lex_state = 0, .external_lex_state = 5},
  [9673] = {.lex_state = 0, .external_lex_state = 5},
  [9674] = {.lex_state = 0, .external_lex_state = 5},
  [9675] = {.lex_state = 0, .external_lex_state = 47},
  [9676] = {.lex_state = 0, .external_lex_state = 5},
  [9677] = {.lex_state = 199, .external_lex_state = 5},
  [9678] = {.lex_state = 0, .external_lex_state = 5},
  [9679] = {.lex_state = 0, .external_lex_state = 5},
  [9680] = {.lex_state = 0, .external_lex_state = 47},
  [9681] = {.lex_state = 0, .external_lex_state = 47},
  [9682] = {.lex_state = 127, .external_lex_state = 5},
  [9683] = {.lex_state = 0, .external_lex_state = 5},
  [9684] = {.lex_state = 0, .external_lex_state = 5},
  [9685] = {.lex_state = 0, .external_lex_state = 5},
  [9686] = {.lex_state = 127, .external_lex_state = 5},
  [9687] = {.lex_state = 0, .external_lex_state = 47},
  [9688] = {.lex_state = 0, .external_lex_state = 5},
  [9689] = {.lex_state = 0, .external_lex_state = 5},
  [9690] = {.lex_state = 0, .external_lex_state = 47},
  [9691] = {.lex_state = 0, .external_lex_state = 47},
  [9692] = {.lex_state = 127, .external_lex_state = 5},
  [9693] = {.lex_state = 0, .external_lex_state = 5},
  [9694] = {.lex_state = 0, .external_lex_state = 5},
  [9695] = {.lex_state = 0, .external_lex_state = 5},
  [9696] = {.lex_state = 0, .external_lex_state = 5},
  [9697] = {.lex_state = 0, .external_lex_state = 47},
  [9698] = {.lex_state = 0, .external_lex_state = 5},
  [9699] = {.lex_state = 0, .external_lex_state = 5},
  [9700] = {.lex_state = 0, .external_lex_state = 47},
  [9701] = {.lex_state = 0, .external_lex_state = 47},
  [9702] = {.lex_state = 0, .external_lex_state = 47},
  [9703] = {.lex_state = 0, .external_lex_state = 5},
  [9704] = {.lex_state = 0, .external_lex_state = 5},
  [9705] = {.lex_state = 0, .external_lex_state = 5},
  [9706] = {.lex_state = 0, .external_lex_state = 5},
  [9707] = {.lex_state = 0, .external_lex_state = 47},
  [9708] = {.lex_state = 0, .external_lex_state = 5},
  [9709] = {.lex_state = 0, .external_lex_state = 5},
  [9710] = {.lex_state = 0, .external_lex_state = 47},
  [9711] = {.lex_state = 0, .external_lex_state = 47},
  [9712] = {.lex_state = 0, .external_lex_state = 5},
  [9713] = {.lex_state = 0, .external_lex_state = 5},
  [9714] = {.lex_state = 0, .external_lex_state = 5},
  [9715] = {.lex_state = 0, .external_lex_state = 5},
  [9716] = {.lex_state = 0, .external_lex_state = 5},
  [9717] = {.lex_state = 0, .external_lex_state = 47},
  [9718] = {.lex_state = 0, .external_lex_state = 5},
  [9719] = {.lex_state = 0, .external_lex_state = 5},
  [9720] = {.lex_state = 0, .external_lex_state = 47},
  [9721] = {.lex_state = 0, .external_lex_state = 47},
  [9722] = {.lex_state = 0, .external_lex_state = 5},
  [9723] = {.lex_state = 0, .external_lex_state = 5},
  [9724] = {.lex_state = 0, .external_lex_state = 5},
  [9725] = {.lex_state = 127, .external_lex_state = 5},
  [9726] = {.lex_state = 0, .external_lex_state = 5},
  [9727] = {.lex_state = 0, .external_lex_state = 47},
  [9728] = {.lex_state = 0, .external_lex_state = 47},
  [9729] = {.lex_state = 0, .external_lex_state = 5},
  [9730] = {.lex_state = 0, .external_lex_state = 47},
  [9731] = {.lex_state = 0, .external_lex_state = 47},
  [9732] = {.lex_state = 0, .external_lex_state = 5},
  [9733] = {.lex_state = 0, .external_lex_state = 5},
  [9734] = {.lex_state = 0, .external_lex_state = 5},
  [9735] = {.lex_state = 0, .external_lex_state = 5},
  [9736] = {.lex_state = 0, .external_lex_state = 5},
  [9737] = {.lex_state = 0, .external_lex_state = 47},
  [9738] = {.lex_state = 0, .external_lex_state = 5},
  [9739] = {.lex_state = 0, .external_lex_state = 5},
  [9740] = {.lex_state = 0, .external_lex_state = 47},
  [9741] = {.lex_state = 0, .external_lex_state = 47},
  [9742] = {.lex_state = 0, .external_lex_state = 5},
  [9743] = {.lex_state = 0, .external_lex_state = 5},
  [9744] = {.lex_state = 0, .external_lex_state = 5},
  [9745] = {.lex_state = 0, .external_lex_state = 5},
  [9746] = {.lex_state = 0, .external_lex_state = 5},
  [9747] = {.lex_state = 0, .external_lex_state = 47},
  [9748] = {.lex_state = 0, .external_lex_state = 5},
  [9749] = {.lex_state = 0, .external_lex_state = 5},
  [9750] = {.lex_state = 0, .external_lex_state = 47},
  [9751] = {.lex_state = 0, .external_lex_state = 47},
  [9752] = {.lex_state = 0, .external_lex_state = 5},
  [9753] = {.lex_state = 0, .external_lex_state = 5},
  [9754] = {.lex_state = 0, .external_lex_state = 46},
  [9755] = {.lex_state = 0, .external_lex_state = 5},
  [9756] = {.lex_state = 0, .external_lex_state = 5},
  [9757] = {.lex_state = 0, .external_lex_state = 47},
  [9758] = {.lex_state = 0, .external_lex_state = 5},
  [9759] = {.lex_state = 0, .external_lex_state = 5},
  [9760] = {.lex_state = 0, .external_lex_state = 47},
  [9761] = {.lex_state = 0, .external_lex_state = 47},
  [9762] = {.lex_state = 199, .external_lex_state = 6},
  [9763] = {.lex_state = 0, .external_lex_state = 5},
  [9764] = {.lex_state = 0, .external_lex_state = 5},
  [9765] = {.lex_state = 0, .external_lex_state = 5},
  [9766] = {.lex_state = 0, .external_lex_state = 5},
  [9767] = {.lex_state = 0, .external_lex_state = 47},
  [9768] = {.lex_state = 0, .external_lex_state = 5},
  [9769] = {.lex_state = 0, .external_lex_state = 5},
  [9770] = {.lex_state = 0, .external_lex_state = 47},
  [9771] = {.lex_state = 0, .external_lex_state = 47},
  [9772] = {.lex_state = 0, .external_lex_state = 5},
  [9773] = {.lex_state = 0, .external_lex_state = 5},
  [9774] = {.lex_state = 0, .external_lex_state = 5},
  [9775] = {.lex_state = 127, .external_lex_state = 5},
  [9776] = {.lex_state = 0, .external_lex_state = 5},
  [9777] = {.lex_state = 0, .external_lex_state = 5},
  [9778] = {.lex_state = 0, .external_lex_state = 5},
  [9779] = {.lex_state = 0, .external_lex_state = 47},
  [9780] = {.lex_state = 0, .external_lex_state = 47},
  [9781] = {.lex_state = 0, .external_lex_state = 5},
  [9782] = {.lex_state = 0, .external_lex_state = 5},
  [9783] = {.lex_state = 0, .external_lex_state = 5},
  [9784] = {.lex_state = 0, .external_lex_state = 5},
  [9785] = {.lex_state = 0, .external_lex_state = 5},
  [9786] = {.lex_state = 0, .external_lex_state = 5},
  [9787] = {.lex_state = 0, .external_lex_state = 5},
  [9788] = {.lex_state = 0, .external_lex_state = 47},
  [9789] = {.lex_state = 0, .external_lex_state = 47},
  [9790] = {.lex_state = 0, .external_lex_state = 5},
  [9791] = {.lex_state = 0, .external_lex_state = 5},
  [9792] = {.lex_state = 0, .external_lex_state = 5},
  [9793] = {.lex_state = 0, .external_lex_state = 5},
  [9794] = {.lex_state = 0, .external_lex_state = 5},
  [9795] = {.lex_state = 0, .external_lex_state = 5},
  [9796] = {.lex_state = 0, .external_lex_state = 5},
  [9797] = {.lex_state = 0, .external_lex_state = 47},
  [9798] = {.lex_state = 0, .external_lex_state = 47},
  [9799] = {.lex_state = 0, .external_lex_state = 5},
  [9800] = {.lex_state = 0, .external_lex_state = 5},
  [9801] = {.lex_state = 0, .external_lex_state = 5},
  [9802] = {.lex_state = 0, .external_lex_state = 5},
  [9803] = {.lex_state = 127, .external_lex_state = 5},
  [9804] = {.lex_state = 0, .external_lex_state = 5},
  [9805] = {.lex_state = 0, .external_lex_state = 5},
  [9806] = {.lex_state = 0, .external_lex_state = 5},
  [9807] = {.lex_state = 0, .external_lex_state = 5},
  [9808] = {.lex_state = 0, .external_lex_state = 5},
  [9809] = {.lex_state = 0, .external_lex_state = 5},
  [9810] = {.lex_state = 0, .external_lex_state = 5},
  [9811] = {.lex_state = 0, .external_lex_state = 5},
  [9812] = {.lex_state = 0, .external_lex_state = 5},
  [9813] = {.lex_state = 0, .external_lex_state = 5},
  [9814] = {.lex_state = 127, .external_lex_state = 5},
  [9815] = {.lex_state = 127, .external_lex_state = 5},
  [9816] = {.lex_state = 0, .external_lex_state = 5},
  [9817] = {.lex_state = 0, .external_lex_state = 5},
  [9818] = {.lex_state = 0, .external_lex_state = 5},
  [9819] = {.lex_state = 0, .external_lex_state = 5},
  [9820] = {.lex_state = 0, .external_lex_state = 5},
  [9821] = {.lex_state = 1, .external_lex_state = 5},
  [9822] = {.lex_state = 0, .external_lex_state = 47},
  [9823] = {.lex_state = 0, .external_lex_state = 47},
  [9824] = {.lex_state = 0, .external_lex_state = 5},
  [9825] = {.lex_state = 0, .external_lex_state = 5},
  [9826] = {.lex_state = 0, .external_lex_state = 5},
  [9827] = {.lex_state = 0, .external_lex_state = 5},
  [9828] = {.lex_state = 0, .external_lex_state = 5},
  [9829] = {.lex_state = 0, .external_lex_state = 5},
  [9830] = {.lex_state = 0, .external_lex_state = 5},
  [9831] = {.lex_state = 199, .external_lex_state = 5},
  [9832] = {.lex_state = 0, .external_lex_state = 5},
  [9833] = {.lex_state = 0, .external_lex_state = 5},
  [9834] = {.lex_state = 0, .external_lex_state = 5},
  [9835] = {.lex_state = 0, .external_lex_state = 5},
  [9836] = {.lex_state = 0, .external_lex_state = 5},
  [9837] = {.lex_state = 0, .external_lex_state = 5},
  [9838] = {.lex_state = 0, .external_lex_state = 5},
  [9839] = {.lex_state = 0, .external_lex_state = 5},
  [9840] = {.lex_state = 0, .external_lex_state = 5},
  [9841] = {.lex_state = 0, .external_lex_state = 5},
  [9842] = {.lex_state = 0, .external_lex_state = 5},
  [9843] = {.lex_state = 0, .external_lex_state = 5},
  [9844] = {.lex_state = 0, .external_lex_state = 5},
  [9845] = {.lex_state = 0, .external_lex_state = 5},
  [9846] = {.lex_state = 0, .external_lex_state = 5},
  [9847] = {.lex_state = 127, .external_lex_state = 5},
  [9848] = {.lex_state = 0, .external_lex_state = 5},
  [9849] = {.lex_state = 0, .external_lex_state = 5},
  [9850] = {.lex_state = 0, .external_lex_state = 5},
  [9851] = {.lex_state = 0, .external_lex_state = 5},
  [9852] = {.lex_state = 0, .external_lex_state = 5},
  [9853] = {.lex_state = 183, .external_lex_state = 5},
  [9854] = {.lex_state = 0, .external_lex_state = 34},
  [9855] = {.lex_state = 0, .external_lex_state = 5},
  [9856] = {.lex_state = 0, .external_lex_state = 5},
  [9857] = {.lex_state = 0, .external_lex_state = 5},
  [9858] = {.lex_state = 0, .external_lex_state = 5},
  [9859] = {.lex_state = 0, .external_lex_state = 5},
  [9860] = {.lex_state = 0, .external_lex_state = 5},
  [9861] = {.lex_state = 0, .external_lex_state = 5},
  [9862] = {.lex_state = 0, .external_lex_state = 5},
  [9863] = {.lex_state = 0, .external_lex_state = 5},
  [9864] = {.lex_state = 0, .external_lex_state = 5},
  [9865] = {.lex_state = 0, .external_lex_state = 5},
  [9866] = {.lex_state = 0, .external_lex_state = 5},
  [9867] = {.lex_state = 0, .external_lex_state = 5},
  [9868] = {.lex_state = 0, .external_lex_state = 5},
  [9869] = {.lex_state = 0, .external_lex_state = 5},
  [9870] = {.lex_state = 0, .external_lex_state = 5},
  [9871] = {.lex_state = 0, .external_lex_state = 5},
  [9872] = {.lex_state = 0, .external_lex_state = 5},
  [9873] = {.lex_state = 0, .external_lex_state = 5},
  [9874] = {.lex_state = 0, .external_lex_state = 5},
  [9875] = {.lex_state = 127, .external_lex_state = 5},
  [9876] = {.lex_state = 0, .external_lex_state = 5},
  [9877] = {.lex_state = 0, .external_lex_state = 5},
  [9878] = {.lex_state = 0, .external_lex_state = 5},
  [9879] = {.lex_state = 0, .external_lex_state = 5},
  [9880] = {.lex_state = 0, .external_lex_state = 5},
  [9881] = {.lex_state = 127, .external_lex_state = 5},
  [9882] = {.lex_state = 0, .external_lex_state = 5},
  [9883] = {.lex_state = 0, .external_lex_state = 5},
  [9884] = {.lex_state = 0, .external_lex_state = 5},
  [9885] = {.lex_state = 0, .external_lex_state = 5},
  [9886] = {.lex_state = 127, .external_lex_state = 5},
  [9887] = {.lex_state = 0, .external_lex_state = 5},
  [9888] = {.lex_state = 0, .external_lex_state = 5},
  [9889] = {.lex_state = 0, .external_lex_state = 34},
  [9890] = {.lex_state = 0, .external_lex_state = 5},
  [9891] = {.lex_state = 0, .external_lex_state = 5},
  [9892] = {.lex_state = 0, .external_lex_state = 5},
  [9893] = {.lex_state = 0, .external_lex_state = 5},
  [9894] = {.lex_state = 0, .external_lex_state = 5},
  [9895] = {.lex_state = 0, .external_lex_state = 5},
  [9896] = {.lex_state = 0, .external_lex_state = 5},
  [9897] = {.lex_state = 0, .external_lex_state = 5},
  [9898] = {.lex_state = 0, .external_lex_state = 5},
  [9899] = {.lex_state = 0, .external_lex_state = 5},
  [9900] = {.lex_state = 0, .external_lex_state = 5},
  [9901] = {.lex_state = 0, .external_lex_state = 5},
  [9902] = {.lex_state = 0, .external_lex_state = 5},
  [9903] = {.lex_state = 0, .external_lex_state = 5},
  [9904] = {.lex_state = 0, .external_lex_state = 5},
  [9905] = {.lex_state = 0, .external_lex_state = 5},
  [9906] = {.lex_state = 0, .external_lex_state = 5},
  [9907] = {.lex_state = 0, .external_lex_state = 5},
  [9908] = {.lex_state = 0, .external_lex_state = 5},
  [9909] = {.lex_state = 0, .external_lex_state = 5},
  [9910] = {.lex_state = 181, .external_lex_state = 5},
  [9911] = {.lex_state = 181, .external_lex_state = 5},
  [9912] = {.lex_state = 0, .external_lex_state = 5},
  [9913] = {.lex_state = 0, .external_lex_state = 5},
  [9914] = {.lex_state = 183, .external_lex_state = 5},
  [9915] = {.lex_state = 0, .external_lex_state = 5},
  [9916] = {.lex_state = 0, .external_lex_state = 5},
  [9917] = {.lex_state = 0, .external_lex_state = 5},
  [9918] = {.lex_state = 0, .external_lex_state = 5},
  [9919] = {.lex_state = 0, .external_lex_state = 5},
  [9920] = {.lex_state = 0, .external_lex_state = 5},
  [9921] = {.lex_state = 0, .external_lex_state = 5},
  [9922] = {.lex_state = 0, .external_lex_state = 5},
  [9923] = {.lex_state = 0, .external_lex_state = 5},
  [9924] = {.lex_state = 0, .external_lex_state = 5},
  [9925] = {.lex_state = 0, .external_lex_state = 5},
  [9926] = {.lex_state = 0, .external_lex_state = 5},
  [9927] = {.lex_state = 0, .external_lex_state = 5},
  [9928] = {.lex_state = 0, .external_lex_state = 5},
  [9929] = {.lex_state = 0, .external_lex_state = 5},
  [9930] = {.lex_state = 0, .external_lex_state = 47},
  [9931] = {.lex_state = 0, .external_lex_state = 47},
  [9932] = {.lex_state = 127, .external_lex_state = 5},
  [9933] = {.lex_state = 127, .external_lex_state = 5},
  [9934] = {.lex_state = 0, .external_lex_state = 5},
  [9935] = {.lex_state = 0, .external_lex_state = 5},
  [9936] = {.lex_state = 0, .external_lex_state = 5},
  [9937] = {.lex_state = 0, .external_lex_state = 5},
  [9938] = {.lex_state = 0, .external_lex_state = 5},
  [9939] = {.lex_state = 0, .external_lex_state = 5},
  [9940] = {.lex_state = 127, .external_lex_state = 5},
  [9941] = {.lex_state = 0, .external_lex_state = 5},
  [9942] = {.lex_state = 0, .external_lex_state = 5},
  [9943] = {.lex_state = 181, .external_lex_state = 5},
  [9944] = {.lex_state = 0, .external_lex_state = 5},
  [9945] = {.lex_state = 0, .external_lex_state = 5},
  [9946] = {.lex_state = 0, .external_lex_state = 5},
  [9947] = {.lex_state = 0, .external_lex_state = 5},
  [9948] = {.lex_state = 0, .external_lex_state = 5},
  [9949] = {.lex_state = 0, .external_lex_state = 5},
  [9950] = {.lex_state = 0, .external_lex_state = 5},
  [9951] = {.lex_state = 0, .external_lex_state = 5},
  [9952] = {.lex_state = 0, .external_lex_state = 5},
  [9953] = {.lex_state = 0, .external_lex_state = 5},
  [9954] = {.lex_state = 0, .external_lex_state = 5},
  [9955] = {.lex_state = 0, .external_lex_state = 5},
  [9956] = {.lex_state = 0, .external_lex_state = 5},
  [9957] = {.lex_state = 0, .external_lex_state = 5},
  [9958] = {.lex_state = 0, .external_lex_state = 5},
  [9959] = {.lex_state = 0, .external_lex_state = 5},
  [9960] = {.lex_state = 0, .external_lex_state = 5},
  [9961] = {.lex_state = 0, .external_lex_state = 5},
  [9962] = {.lex_state = 0, .external_lex_state = 5},
  [9963] = {.lex_state = 183, .external_lex_state = 5},
  [9964] = {.lex_state = 0, .external_lex_state = 5},
  [9965] = {.lex_state = 0, .external_lex_state = 5},
  [9966] = {.lex_state = 0, .external_lex_state = 5},
  [9967] = {.lex_state = 0, .external_lex_state = 5},
  [9968] = {.lex_state = 0, .external_lex_state = 5},
  [9969] = {.lex_state = 0, .external_lex_state = 5},
  [9970] = {.lex_state = 199, .external_lex_state = 5},
  [9971] = {.lex_state = 0, .external_lex_state = 5},
  [9972] = {.lex_state = 199, .external_lex_state = 5},
  [9973] = {.lex_state = 0, .external_lex_state = 46},
  [9974] = {.lex_state = 0, .external_lex_state = 5},
  [9975] = {.lex_state = 0, .external_lex_state = 5},
  [9976] = {.lex_state = 127, .external_lex_state = 5},
  [9977] = {.lex_state = 0, .external_lex_state = 5},
  [9978] = {.lex_state = 0, .external_lex_state = 5},
  [9979] = {.lex_state = 0, .external_lex_state = 5},
  [9980] = {.lex_state = 0, .external_lex_state = 5},
  [9981] = {.lex_state = 0, .external_lex_state = 5},
  [9982] = {.lex_state = 0, .external_lex_state = 5},
  [9983] = {.lex_state = 0, .external_lex_state = 5},
  [9984] = {.lex_state = 0, .external_lex_state = 5},
  [9985] = {.lex_state = 0, .external_lex_state = 5},
  [9986] = {.lex_state = 0, .external_lex_state = 5},
  [9987] = {.lex_state = 0, .external_lex_state = 5},
  [9988] = {.lex_state = 199, .external_lex_state = 5},
  [9989] = {.lex_state = 0, .external_lex_state = 5},
  [9990] = {.lex_state = 0, .external_lex_state = 5},
  [9991] = {.lex_state = 0, .external_lex_state = 5},
  [9992] = {.lex_state = 0, .external_lex_state = 5},
  [9993] = {.lex_state = 0, .external_lex_state = 5},
  [9994] = {.lex_state = 0, .external_lex_state = 5},
  [9995] = {.lex_state = 199, .external_lex_state = 5},
  [9996] = {.lex_state = 127, .external_lex_state = 5},
  [9997] = {.lex_state = 0, .external_lex_state = 5},
  [9998] = {.lex_state = 0, .external_lex_state = 5},
  [9999] = {.lex_state = 0, .external_lex_state = 5},
  [10000] = {.lex_state = 0, .external_lex_state = 5},
  [10001] = {.lex_state = 0, .external_lex_state = 5},
  [10002] = {.lex_state = 0, .external_lex_state = 5},
  [10003] = {.lex_state = 0, .external_lex_state = 5},
  [10004] = {.lex_state = 0, .external_lex_state = 5},
  [10005] = {.lex_state = 0, .external_lex_state = 5},
  [10006] = {.lex_state = 127, .external_lex_state = 5},
  [10007] = {.lex_state = 0, .external_lex_state = 5},
  [10008] = {.lex_state = 0, .external_lex_state = 5},
  [10009] = {.lex_state = 0, .external_lex_state = 5},
  [10010] = {.lex_state = 0, .external_lex_state = 5},
  [10011] = {.lex_state = 0, .external_lex_state = 5},
  [10012] = {.lex_state = 0, .external_lex_state = 5},
  [10013] = {.lex_state = 0, .external_lex_state = 5},
  [10014] = {.lex_state = 127, .external_lex_state = 5},
  [10015] = {.lex_state = 127, .external_lex_state = 5},
  [10016] = {.lex_state = 0, .external_lex_state = 5},
  [10017] = {.lex_state = 0, .external_lex_state = 5},
  [10018] = {.lex_state = 0, .external_lex_state = 34},
  [10019] = {.lex_state = 181, .external_lex_state = 5},
  [10020] = {.lex_state = 0, .external_lex_state = 5},
  [10021] = {.lex_state = 0, .external_lex_state = 5},
  [10022] = {.lex_state = 0, .external_lex_state = 5},
  [10023] = {.lex_state = 0, .external_lex_state = 5},
  [10024] = {.lex_state = 0, .external_lex_state = 5},
  [10025] = {.lex_state = 0, .external_lex_state = 5},
  [10026] = {.lex_state = 0, .external_lex_state = 5},
  [10027] = {.lex_state = 0, .external_lex_state = 5},
  [10028] = {.lex_state = 0, .external_lex_state = 5},
  [10029] = {.lex_state = 0, .external_lex_state = 5},
  [10030] = {.lex_state = 0, .external_lex_state = 5},
  [10031] = {.lex_state = 183, .external_lex_state = 5},
  [10032] = {.lex_state = 0, .external_lex_state = 5},
  [10033] = {.lex_state = 0, .external_lex_state = 5},
  [10034] = {.lex_state = 0, .external_lex_state = 5},
  [10035] = {.lex_state = 0, .external_lex_state = 5},
  [10036] = {.lex_state = 0, .external_lex_state = 5},
  [10037] = {.lex_state = 0, .external_lex_state = 5},
  [10038] = {.lex_state = 0, .external_lex_state = 5},
  [10039] = {.lex_state = 0, .external_lex_state = 5},
  [10040] = {.lex_state = 181, .external_lex_state = 5},
  [10041] = {.lex_state = 0, .external_lex_state = 5},
  [10042] = {.lex_state = 0, .external_lex_state = 5},
  [10043] = {.lex_state = 127, .external_lex_state = 5},
  [10044] = {.lex_state = 0, .external_lex_state = 5},
  [10045] = {.lex_state = 0, .external_lex_state = 5},
  [10046] = {.lex_state = 0, .external_lex_state = 5},
  [10047] = {.lex_state = 0, .external_lex_state = 5},
  [10048] = {.lex_state = 0, .external_lex_state = 5},
  [10049] = {.lex_state = 0, .external_lex_state = 5},
  [10050] = {.lex_state = 0, .external_lex_state = 5},
  [10051] = {.lex_state = 0, .external_lex_state = 5},
  [10052] = {.lex_state = 0, .external_lex_state = 5},
  [10053] = {.lex_state = 127, .external_lex_state = 5},
  [10054] = {.lex_state = 0, .external_lex_state = 5},
  [10055] = {.lex_state = 0, .external_lex_state = 5},
  [10056] = {.lex_state = 181, .external_lex_state = 5},
  [10057] = {.lex_state = 0, .external_lex_state = 5},
  [10058] = {.lex_state = 0, .external_lex_state = 5},
  [10059] = {.lex_state = 0, .external_lex_state = 5},
  [10060] = {.lex_state = 0, .external_lex_state = 5},
  [10061] = {.lex_state = 0, .external_lex_state = 5},
  [10062] = {.lex_state = 0, .external_lex_state = 5},
  [10063] = {.lex_state = 0, .external_lex_state = 5},
  [10064] = {.lex_state = 0, .external_lex_state = 5},
  [10065] = {.lex_state = 0, .external_lex_state = 5},
  [10066] = {.lex_state = 0, .external_lex_state = 5},
  [10067] = {.lex_state = 0, .external_lex_state = 5},
  [10068] = {.lex_state = 0, .external_lex_state = 5},
  [10069] = {.lex_state = 199, .external_lex_state = 5},
  [10070] = {.lex_state = 0, .external_lex_state = 5},
  [10071] = {.lex_state = 0, .external_lex_state = 5},
  [10072] = {.lex_state = 0, .external_lex_state = 5},
  [10073] = {.lex_state = 199, .external_lex_state = 5},
  [10074] = {.lex_state = 199, .external_lex_state = 5},
  [10075] = {.lex_state = 199, .external_lex_state = 5},
  [10076] = {.lex_state = 0, .external_lex_state = 5},
  [10077] = {.lex_state = 0, .external_lex_state = 5},
  [10078] = {.lex_state = 0, .external_lex_state = 34},
  [10079] = {.lex_state = 0, .external_lex_state = 5},
  [10080] = {.lex_state = 199, .external_lex_state = 5},
  [10081] = {.lex_state = 199, .external_lex_state = 5},
  [10082] = {.lex_state = 199, .external_lex_state = 5},
  [10083] = {.lex_state = 0, .external_lex_state = 5},
  [10084] = {.lex_state = 199, .external_lex_state = 5},
  [10085] = {.lex_state = 0, .external_lex_state = 5},
  [10086] = {.lex_state = 0, .external_lex_state = 5},
  [10087] = {.lex_state = 0, .external_lex_state = 5},
  [10088] = {.lex_state = 0, .external_lex_state = 5},
  [10089] = {.lex_state = 0, .external_lex_state = 5},
  [10090] = {.lex_state = 199, .external_lex_state = 5},
  [10091] = {.lex_state = 0, .external_lex_state = 5},
  [10092] = {.lex_state = 199, .external_lex_state = 5},
  [10093] = {.lex_state = 0, .external_lex_state = 5},
  [10094] = {.lex_state = 199, .external_lex_state = 5},
  [10095] = {.lex_state = 0, .external_lex_state = 5},
  [10096] = {.lex_state = 199, .external_lex_state = 5},
  [10097] = {.lex_state = 0, .external_lex_state = 5},
  [10098] = {.lex_state = 199, .external_lex_state = 5},
  [10099] = {.lex_state = 0, .external_lex_state = 5},
  [10100] = {.lex_state = 199, .external_lex_state = 5},
  [10101] = {.lex_state = 0, .external_lex_state = 5},
  [10102] = {.lex_state = 199, .external_lex_state = 5},
  [10103] = {.lex_state = 0, .external_lex_state = 34},
  [10104] = {.lex_state = 199, .external_lex_state = 5},
  [10105] = {.lex_state = 0, .external_lex_state = 5},
  [10106] = {.lex_state = 199, .external_lex_state = 5},
  [10107] = {.lex_state = 0, .external_lex_state = 5},
  [10108] = {.lex_state = 199, .external_lex_state = 5},
  [10109] = {.lex_state = 0, .external_lex_state = 5},
  [10110] = {.lex_state = 199, .external_lex_state = 5},
  [10111] = {.lex_state = 0, .external_lex_state = 5},
  [10112] = {.lex_state = 199, .external_lex_state = 5},
  [10113] = {.lex_state = 0, .external_lex_state = 5},
  [10114] = {.lex_state = 199, .external_lex_state = 5},
  [10115] = {.lex_state = 0, .external_lex_state = 5},
  [10116] = {.lex_state = 199, .external_lex_state = 5},
  [10117] = {.lex_state = 0, .external_lex_state = 5},
  [10118] = {.lex_state = 199, .external_lex_state = 5},
  [10119] = {.lex_state = 127, .external_lex_state = 5},
  [10120] = {.lex_state = 199, .external_lex_state = 5},
  [10121] = {.lex_state = 127, .external_lex_state = 5},
  [10122] = {.lex_state = 199, .external_lex_state = 5},
  [10123] = {.lex_state = 0, .external_lex_state = 5},
  [10124] = {.lex_state = 199, .external_lex_state = 5},
  [10125] = {.lex_state = 199, .external_lex_state = 5},
  [10126] = {.lex_state = 0, .external_lex_state = 5},
  [10127] = {.lex_state = 127, .external_lex_state = 5},
  [10128] = {.lex_state = 0, .external_lex_state = 5},
  [10129] = {.lex_state = 0, .external_lex_state = 5},
  [10130] = {.lex_state = 0, .external_lex_state = 5},
  [10131] = {.lex_state = 0, .external_lex_state = 5},
  [10132] = {.lex_state = 183, .external_lex_state = 5},
  [10133] = {.lex_state = 0, .external_lex_state = 5},
  [10134] = {.lex_state = 0, .external_lex_state = 5},
  [10135] = {.lex_state = 0, .external_lex_state = 5},
  [10136] = {.lex_state = 0, .external_lex_state = 5},
  [10137] = {.lex_state = 0, .external_lex_state = 5},
  [10138] = {.lex_state = 0, .external_lex_state = 5},
  [10139] = {.lex_state = 183, .external_lex_state = 5},
  [10140] = {.lex_state = 0, .external_lex_state = 5},
  [10141] = {.lex_state = 0, .external_lex_state = 5},
  [10142] = {.lex_state = 0, .external_lex_state = 34},
  [10143] = {.lex_state = 0, .external_lex_state = 5},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__varid] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_char] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_triple_quote_string] = ACTIONS(1),
    [sym__integer_literal] = ACTIONS(1),
    [sym__hex_literal] = ACTIONS(1),
    [anon_sym_u21d2] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_u21d0] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_u2192] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_u2190] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_u2237] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [sym_hole] = ACTIONS(1),
    [sym__immediate_dot] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym__conid] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_u2200] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_nominal] = ACTIONS(1),
    [anon_sym_representational] = ACTIONS(1),
    [anon_sym_phantom] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_role] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_ado] = ACTIONS(1),
    [anon_sym_AT2] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_hiding] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_data] = ACTIONS(1),
    [anon_sym_newtype] = ACTIONS(1),
    [anon_sym_instance] = ACTIONS(1),
    [anon_sym_infixl] = ACTIONS(1),
    [anon_sym_infixr] = ACTIONS(1),
    [anon_sym_infix] = ACTIONS(1),
    [anon_sym_foreign] = ACTIONS(1),
    [anon_sym_derive] = ACTIONS(1),
    [anon_sym_pattern] = ACTIONS(1),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1),
    [sym__layout_start] = ACTIONS(1),
    [sym__layout_end] = ACTIONS(1),
    [sym__dot] = ACTIONS(1),
    [sym__arith_dotdot] = ACTIONS(1),
    [sym_where] = ACTIONS(1),
    [sym__splice_dollar] = ACTIONS(1),
    [sym__varsym] = ACTIONS(1),
    [sym__consym] = ACTIONS(1),
    [sym__tyconsym] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1),
    [sym_quasiquote_start] = ACTIONS(1),
    [sym_quasiquote_bar] = ACTIONS(1),
    [sym_quasiquote_body] = ACTIONS(1),
    [sym__strict] = ACTIONS(1),
    [sym__lazy] = ACTIONS(1),
    [sym__unboxed_close] = ACTIONS(1),
    [sym_empty_file] = ACTIONS(1),
  },
  [1] = {
    [sym_purescript] = STATE(10130),
    [sym__topdecl] = STATE(7944),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3106),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(7944),
    [sym__type_type_signature] = STATE(10125),
    [sym_decl_type] = STATE(7944),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6780),
    [sym__typed_pat] = STATE(6780),
    [sym_decl_import] = STATE(7944),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__decl_module] = STATE(10076),
    [sym__data_type_signature] = STATE(10075),
    [sym_decl_data] = STATE(7944),
    [sym__newtype_type_signature] = STATE(10074),
    [sym_decl_newtype] = STATE(7944),
    [sym__class_kind_declaration] = STATE(10073),
    [sym_class_declaration] = STATE(7944),
    [sym_class_instance] = STATE(7944),
    [sym__funpat] = STATE(8092),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6777),
    [sym_function] = STATE(7944),
    [sym_operator_declaration] = STATE(7944),
    [sym_signature] = STATE(7944),
    [sym__gendecl] = STATE(7944),
    [sym__decl_fun] = STATE(7944),
    [sym__decl] = STATE(7944),
    [sym_decl_foreign_import] = STATE(7944),
    [sym__decl_foreign] = STATE(7944),
    [sym__newkind_type_signature] = STATE(10069),
    [sym_kind_declaration] = STATE(7944),
    [sym_kind_value_declaration] = STATE(7944),
    [sym_decl_derive] = STATE(7944),
    [sym_decl_pattern] = STATE(7944),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(29),
    [anon_sym_class] = ACTIONS(31),
    [anon_sym_import] = ACTIONS(33),
    [anon_sym_module] = ACTIONS(35),
    [anon_sym_data] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(39),
    [anon_sym_instance] = ACTIONS(41),
    [anon_sym_infixl] = ACTIONS(43),
    [anon_sym_infixr] = ACTIONS(43),
    [anon_sym_infix] = ACTIONS(43),
    [anon_sym_foreign] = ACTIONS(45),
    [anon_sym_derive] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_empty_file] = ACTIONS(51),
  },
  [2] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3318),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9987),
    [sym__minus] = STATE(9987),
    [sym__operator_or_minus] = STATE(9987),
    [sym_qualified_operator] = STATE(9285),
    [sym__q_op] = STATE(9285),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(10039),
    [sym_qualified_constructor_operator] = STATE(10039),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3508),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3508),
    [sym_exp_case] = STATE(3508),
    [sym_exp_let_in] = STATE(3508),
    [sym_exp_lambda] = STATE(3508),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3508),
    [sym__lexp] = STATE(3508),
    [sym_exp_infix] = STATE(3508),
    [sym__exp_infix] = STATE(3508),
    [sym__exp] = STATE(9282),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(10032),
    [sym__typed_pat] = STATE(10032),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [3] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3316),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9916),
    [sym__minus] = STATE(9916),
    [sym__operator_or_minus] = STATE(9916),
    [sym_qualified_operator] = STATE(9200),
    [sym__q_op] = STATE(9200),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(10128),
    [sym_qualified_constructor_operator] = STATE(10128),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3518),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3518),
    [sym_exp_case] = STATE(3518),
    [sym_exp_let_in] = STATE(3518),
    [sym_exp_lambda] = STATE(3518),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3518),
    [sym__lexp] = STATE(3518),
    [sym_exp_infix] = STATE(3518),
    [sym__exp_infix] = STATE(3518),
    [sym__exp] = STATE(9197),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(8854),
    [sym__typed_pat] = STATE(8854),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [4] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3307),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9916),
    [sym__minus] = STATE(9916),
    [sym__operator_or_minus] = STATE(9916),
    [sym_qualified_operator] = STATE(9123),
    [sym__q_op] = STATE(9123),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(10057),
    [sym_qualified_constructor_operator] = STATE(10057),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3519),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3519),
    [sym_exp_case] = STATE(3519),
    [sym_exp_let_in] = STATE(3519),
    [sym_exp_lambda] = STATE(3519),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3519),
    [sym__lexp] = STATE(3519),
    [sym_exp_infix] = STATE(3519),
    [sym__exp_infix] = STATE(3519),
    [sym__exp] = STATE(9122),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(8854),
    [sym__typed_pat] = STATE(8854),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [5] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3326),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9987),
    [sym__minus] = STATE(9987),
    [sym__operator_or_minus] = STATE(9987),
    [sym_qualified_operator] = STATE(9864),
    [sym__q_op] = STATE(9864),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8933),
    [sym_qualified_constructor_operator] = STATE(8933),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3486),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3486),
    [sym_exp_case] = STATE(3486),
    [sym_exp_let_in] = STATE(3486),
    [sym_exp_lambda] = STATE(3486),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3486),
    [sym__lexp] = STATE(3486),
    [sym_exp_infix] = STATE(3486),
    [sym__exp_infix] = STATE(3486),
    [sym__exp] = STATE(9862),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(10032),
    [sym__typed_pat] = STATE(10032),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [6] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3334),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9839),
    [sym__minus] = STATE(9839),
    [sym__operator_or_minus] = STATE(9839),
    [sym_qualified_operator] = STATE(9986),
    [sym__q_op] = STATE(9986),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9084),
    [sym_qualified_constructor_operator] = STATE(9084),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3482),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3482),
    [sym_exp_case] = STATE(3482),
    [sym_exp_let_in] = STATE(3482),
    [sym_exp_lambda] = STATE(3482),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3482),
    [sym__lexp] = STATE(3482),
    [sym_exp_infix] = STATE(3482),
    [sym__exp_infix] = STATE(3482),
    [sym__exp] = STATE(9985),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(9409),
    [sym__typed_pat] = STATE(9409),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [7] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3281),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9916),
    [sym__minus] = STATE(9916),
    [sym__operator_or_minus] = STATE(9916),
    [sym_qualified_operator] = STATE(8892),
    [sym__q_op] = STATE(8892),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9851),
    [sym_qualified_constructor_operator] = STATE(9851),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3533),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3533),
    [sym_exp_case] = STATE(3533),
    [sym_exp_let_in] = STATE(3533),
    [sym_exp_lambda] = STATE(3533),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3533),
    [sym__lexp] = STATE(3533),
    [sym_exp_infix] = STATE(3533),
    [sym__exp_infix] = STATE(3533),
    [sym__exp] = STATE(8747),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(8854),
    [sym__typed_pat] = STATE(8854),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [8] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3284),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9916),
    [sym__minus] = STATE(9916),
    [sym__operator_or_minus] = STATE(9916),
    [sym_qualified_operator] = STATE(9171),
    [sym__q_op] = STATE(9171),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9733),
    [sym_qualified_constructor_operator] = STATE(9733),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3583),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3583),
    [sym_exp_case] = STATE(3583),
    [sym_exp_let_in] = STATE(3583),
    [sym_exp_lambda] = STATE(3583),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3583),
    [sym__lexp] = STATE(3583),
    [sym_exp_infix] = STATE(3583),
    [sym__exp_infix] = STATE(3583),
    [sym__exp] = STATE(9176),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(8854),
    [sym__typed_pat] = STATE(8854),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [9] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3287),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9839),
    [sym__minus] = STATE(9839),
    [sym__operator_or_minus] = STATE(9839),
    [sym_qualified_operator] = STATE(10093),
    [sym__q_op] = STATE(10093),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8879),
    [sym_qualified_constructor_operator] = STATE(8879),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3442),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3442),
    [sym_exp_case] = STATE(3442),
    [sym_exp_let_in] = STATE(3442),
    [sym_exp_lambda] = STATE(3442),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3442),
    [sym__lexp] = STATE(3442),
    [sym_exp_infix] = STATE(3442),
    [sym__exp_infix] = STATE(3442),
    [sym__exp] = STATE(10091),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(9409),
    [sym__typed_pat] = STATE(9409),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [10] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3320),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(10099),
    [sym__minus] = STATE(10099),
    [sym__operator_or_minus] = STATE(10099),
    [sym_qualified_operator] = STATE(9383),
    [sym__q_op] = STATE(9383),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9989),
    [sym_qualified_constructor_operator] = STATE(9989),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3506),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3506),
    [sym_exp_case] = STATE(3506),
    [sym_exp_let_in] = STATE(3506),
    [sym_exp_lambda] = STATE(3506),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3506),
    [sym__lexp] = STATE(3506),
    [sym_exp_infix] = STATE(3506),
    [sym__exp_infix] = STATE(3506),
    [sym__exp] = STATE(9380),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(10140),
    [sym__typed_pat] = STATE(10140),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [11] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3329),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(10099),
    [sym__minus] = STATE(10099),
    [sym__operator_or_minus] = STATE(10099),
    [sym_qualified_operator] = STATE(9915),
    [sym__q_op] = STATE(9915),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9012),
    [sym_qualified_constructor_operator] = STATE(9012),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3483),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3483),
    [sym_exp_case] = STATE(3483),
    [sym_exp_let_in] = STATE(3483),
    [sym_exp_lambda] = STATE(3483),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3483),
    [sym__lexp] = STATE(3483),
    [sym_exp_infix] = STATE(3483),
    [sym__exp_infix] = STATE(3483),
    [sym__exp] = STATE(9912),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(10140),
    [sym__typed_pat] = STATE(10140),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [12] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3400),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9839),
    [sym__minus] = STATE(9839),
    [sym__operator_or_minus] = STATE(9839),
    [sym_qualified_operator] = STATE(9838),
    [sym__q_op] = STATE(9838),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9410),
    [sym_qualified_constructor_operator] = STATE(9410),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3451),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3451),
    [sym_exp_case] = STATE(3451),
    [sym_exp_let_in] = STATE(3451),
    [sym_exp_lambda] = STATE(3451),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3451),
    [sym__lexp] = STATE(3451),
    [sym_exp_infix] = STATE(3451),
    [sym__exp_infix] = STATE(3451),
    [sym__exp] = STATE(9837),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(9409),
    [sym__typed_pat] = STATE(9409),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [13] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(3314),
    [sym_variable] = STATE(2189),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9839),
    [sym__minus] = STATE(9839),
    [sym__operator_or_minus] = STATE(9839),
    [sym_qualified_operator] = STATE(10003),
    [sym__q_op] = STATE(10003),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8917),
    [sym_qualified_constructor_operator] = STATE(8917),
    [sym__qcon] = STATE(2808),
    [sym_literal] = STATE(2805),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3514),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3514),
    [sym_exp_case] = STATE(3514),
    [sym_exp_let_in] = STATE(3514),
    [sym_exp_lambda] = STATE(3514),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3514),
    [sym__lexp] = STATE(3514),
    [sym_exp_infix] = STATE(3514),
    [sym__exp_infix] = STATE(3514),
    [sym__exp] = STATE(10002),
    [sym_pat_fields] = STATE(6789),
    [sym_pat_name] = STATE(4632),
    [sym_pat_as] = STATE(4632),
    [sym__pat_constructor] = STATE(1008),
    [sym_pat_record] = STATE(4632),
    [sym_pat_wildcard] = STATE(4632),
    [sym_pat_parens] = STATE(4632),
    [sym_pat_array] = STATE(4632),
    [sym__apat] = STATE(4632),
    [sym_pat_negation] = STATE(4632),
    [sym_pat_apply] = STATE(4632),
    [sym__lpat] = STATE(4632),
    [sym_pat_infix] = STATE(7378),
    [sym__pat] = STATE(7378),
    [sym_pat_typed] = STATE(9409),
    [sym__typed_pat] = STATE(9409),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(53),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(69),
    [anon_sym_LPAREN] = ACTIONS(71),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(75),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(79),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [14] = {
    [sym__topdecl] = STATE(8426),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3126),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(8426),
    [sym__type_type_signature] = STATE(10080),
    [sym_decl_type] = STATE(8426),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6868),
    [sym__typed_pat] = STATE(6868),
    [sym_decl_import] = STATE(8426),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10081),
    [sym_decl_data] = STATE(8426),
    [sym__newtype_type_signature] = STATE(10082),
    [sym_decl_newtype] = STATE(8426),
    [sym__class_kind_declaration] = STATE(9320),
    [sym_class_declaration] = STATE(8426),
    [sym_class_instance] = STATE(8426),
    [sym__funpat] = STATE(8163),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6866),
    [sym_function] = STATE(8426),
    [sym_operator_declaration] = STATE(8426),
    [sym_signature] = STATE(8426),
    [sym__gendecl] = STATE(8426),
    [sym__decl_fun] = STATE(8426),
    [sym__decl] = STATE(8426),
    [sym_decl_foreign_import] = STATE(8426),
    [sym__decl_foreign] = STATE(8426),
    [sym__newkind_type_signature] = STATE(9321),
    [sym_kind_declaration] = STATE(8426),
    [sym_kind_value_declaration] = STATE(8426),
    [sym_decl_derive] = STATE(8426),
    [sym_decl_pattern] = STATE(8426),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(95),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(99),
    [anon_sym_class] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_data] = ACTIONS(105),
    [anon_sym_newtype] = ACTIONS(107),
    [anon_sym_instance] = ACTIONS(109),
    [anon_sym_infixl] = ACTIONS(111),
    [anon_sym_infixr] = ACTIONS(111),
    [anon_sym_infix] = ACTIONS(111),
    [anon_sym_foreign] = ACTIONS(113),
    [anon_sym_derive] = ACTIONS(115),
    [anon_sym_pattern] = ACTIONS(117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(119),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [15] = {
    [sym__topdecl] = STATE(7695),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3126),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(7695),
    [sym__type_type_signature] = STATE(10080),
    [sym_decl_type] = STATE(7695),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6868),
    [sym__typed_pat] = STATE(6868),
    [sym_decl_import] = STATE(7695),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10081),
    [sym_decl_data] = STATE(7695),
    [sym__newtype_type_signature] = STATE(10082),
    [sym_decl_newtype] = STATE(7695),
    [sym__class_kind_declaration] = STATE(9320),
    [sym_class_declaration] = STATE(7695),
    [sym_class_instance] = STATE(7695),
    [sym__funpat] = STATE(8163),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6866),
    [sym_function] = STATE(7695),
    [sym_operator_declaration] = STATE(7695),
    [sym_signature] = STATE(7695),
    [sym__gendecl] = STATE(7695),
    [sym__decl_fun] = STATE(7695),
    [sym__decl] = STATE(7695),
    [sym_decl_foreign_import] = STATE(7695),
    [sym__decl_foreign] = STATE(7695),
    [sym__newkind_type_signature] = STATE(9321),
    [sym_kind_declaration] = STATE(7695),
    [sym_kind_value_declaration] = STATE(7695),
    [sym_decl_derive] = STATE(7695),
    [sym_decl_pattern] = STATE(7695),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(95),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(99),
    [anon_sym_class] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_data] = ACTIONS(105),
    [anon_sym_newtype] = ACTIONS(107),
    [anon_sym_instance] = ACTIONS(109),
    [anon_sym_infixl] = ACTIONS(111),
    [anon_sym_infixr] = ACTIONS(111),
    [anon_sym_infix] = ACTIONS(111),
    [anon_sym_foreign] = ACTIONS(113),
    [anon_sym_derive] = ACTIONS(115),
    [anon_sym_pattern] = ACTIONS(117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [16] = {
    [sym__topdecl] = STATE(8426),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3126),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(8426),
    [sym__type_type_signature] = STATE(10080),
    [sym_decl_type] = STATE(8426),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6868),
    [sym__typed_pat] = STATE(6868),
    [sym_decl_import] = STATE(8426),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10081),
    [sym_decl_data] = STATE(8426),
    [sym__newtype_type_signature] = STATE(10082),
    [sym_decl_newtype] = STATE(8426),
    [sym__class_kind_declaration] = STATE(9320),
    [sym_class_declaration] = STATE(8426),
    [sym_class_instance] = STATE(8426),
    [sym__funpat] = STATE(8163),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6866),
    [sym_function] = STATE(8426),
    [sym_operator_declaration] = STATE(8426),
    [sym_signature] = STATE(8426),
    [sym__gendecl] = STATE(8426),
    [sym__decl_fun] = STATE(8426),
    [sym__decl] = STATE(8426),
    [sym_decl_foreign_import] = STATE(8426),
    [sym__decl_foreign] = STATE(8426),
    [sym__newkind_type_signature] = STATE(9321),
    [sym_kind_declaration] = STATE(8426),
    [sym_kind_value_declaration] = STATE(8426),
    [sym_decl_derive] = STATE(8426),
    [sym_decl_pattern] = STATE(8426),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(95),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(99),
    [anon_sym_class] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_data] = ACTIONS(105),
    [anon_sym_newtype] = ACTIONS(107),
    [anon_sym_instance] = ACTIONS(109),
    [anon_sym_infixl] = ACTIONS(111),
    [anon_sym_infixr] = ACTIONS(111),
    [anon_sym_infix] = ACTIONS(111),
    [anon_sym_foreign] = ACTIONS(113),
    [anon_sym_derive] = ACTIONS(115),
    [anon_sym_pattern] = ACTIONS(117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [17] = {
    [sym__topdecl] = STATE(8248),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3106),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(8248),
    [sym__type_type_signature] = STATE(10125),
    [sym_decl_type] = STATE(8248),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6780),
    [sym__typed_pat] = STATE(6780),
    [sym_decl_import] = STATE(8248),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10075),
    [sym_decl_data] = STATE(8248),
    [sym__newtype_type_signature] = STATE(10074),
    [sym_decl_newtype] = STATE(8248),
    [sym__class_kind_declaration] = STATE(10073),
    [sym_class_declaration] = STATE(8248),
    [sym_class_instance] = STATE(8248),
    [sym__funpat] = STATE(8092),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6777),
    [sym_function] = STATE(8248),
    [sym_operator_declaration] = STATE(8248),
    [sym_signature] = STATE(8248),
    [sym__gendecl] = STATE(8248),
    [sym__decl_fun] = STATE(8248),
    [sym__decl] = STATE(8248),
    [sym_decl_foreign_import] = STATE(8248),
    [sym__decl_foreign] = STATE(8248),
    [sym__newkind_type_signature] = STATE(10069),
    [sym_kind_declaration] = STATE(8248),
    [sym_kind_value_declaration] = STATE(8248),
    [sym_decl_derive] = STATE(8248),
    [sym_decl_pattern] = STATE(8248),
    [ts_builtin_sym_end] = ACTIONS(125),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(29),
    [anon_sym_class] = ACTIONS(31),
    [anon_sym_import] = ACTIONS(33),
    [anon_sym_data] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(39),
    [anon_sym_instance] = ACTIONS(41),
    [anon_sym_infixl] = ACTIONS(43),
    [anon_sym_infixr] = ACTIONS(43),
    [anon_sym_infix] = ACTIONS(43),
    [anon_sym_foreign] = ACTIONS(45),
    [anon_sym_derive] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [18] = {
    [sym__topdecl] = STATE(8426),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3126),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(8426),
    [sym__type_type_signature] = STATE(10080),
    [sym_decl_type] = STATE(8426),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6868),
    [sym__typed_pat] = STATE(6868),
    [sym_decl_import] = STATE(8426),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10081),
    [sym_decl_data] = STATE(8426),
    [sym__newtype_type_signature] = STATE(10082),
    [sym_decl_newtype] = STATE(8426),
    [sym__class_kind_declaration] = STATE(9320),
    [sym_class_declaration] = STATE(8426),
    [sym_class_instance] = STATE(8426),
    [sym__funpat] = STATE(8163),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6866),
    [sym_function] = STATE(8426),
    [sym_operator_declaration] = STATE(8426),
    [sym_signature] = STATE(8426),
    [sym__gendecl] = STATE(8426),
    [sym__decl_fun] = STATE(8426),
    [sym__decl] = STATE(8426),
    [sym_decl_foreign_import] = STATE(8426),
    [sym__decl_foreign] = STATE(8426),
    [sym__newkind_type_signature] = STATE(9321),
    [sym_kind_declaration] = STATE(8426),
    [sym_kind_value_declaration] = STATE(8426),
    [sym_decl_derive] = STATE(8426),
    [sym_decl_pattern] = STATE(8426),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(95),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(99),
    [anon_sym_class] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_data] = ACTIONS(105),
    [anon_sym_newtype] = ACTIONS(107),
    [anon_sym_instance] = ACTIONS(109),
    [anon_sym_infixl] = ACTIONS(111),
    [anon_sym_infixr] = ACTIONS(111),
    [anon_sym_infix] = ACTIONS(111),
    [anon_sym_foreign] = ACTIONS(113),
    [anon_sym_derive] = ACTIONS(115),
    [anon_sym_pattern] = ACTIONS(117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [19] = {
    [sym__topdecl] = STATE(8426),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3126),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(8426),
    [sym__type_type_signature] = STATE(10080),
    [sym_decl_type] = STATE(8426),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6868),
    [sym__typed_pat] = STATE(6868),
    [sym_decl_import] = STATE(8426),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10081),
    [sym_decl_data] = STATE(8426),
    [sym__newtype_type_signature] = STATE(10082),
    [sym_decl_newtype] = STATE(8426),
    [sym__class_kind_declaration] = STATE(9320),
    [sym_class_declaration] = STATE(8426),
    [sym_class_instance] = STATE(8426),
    [sym__funpat] = STATE(8163),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6866),
    [sym_function] = STATE(8426),
    [sym_operator_declaration] = STATE(8426),
    [sym_signature] = STATE(8426),
    [sym__gendecl] = STATE(8426),
    [sym__decl_fun] = STATE(8426),
    [sym__decl] = STATE(8426),
    [sym_decl_foreign_import] = STATE(8426),
    [sym__decl_foreign] = STATE(8426),
    [sym__newkind_type_signature] = STATE(9321),
    [sym_kind_declaration] = STATE(8426),
    [sym_kind_value_declaration] = STATE(8426),
    [sym_decl_derive] = STATE(8426),
    [sym_decl_pattern] = STATE(8426),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(95),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(99),
    [anon_sym_class] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_data] = ACTIONS(105),
    [anon_sym_newtype] = ACTIONS(107),
    [anon_sym_instance] = ACTIONS(109),
    [anon_sym_infixl] = ACTIONS(111),
    [anon_sym_infixr] = ACTIONS(111),
    [anon_sym_infix] = ACTIONS(111),
    [anon_sym_foreign] = ACTIONS(113),
    [anon_sym_derive] = ACTIONS(115),
    [anon_sym_pattern] = ACTIONS(117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [20] = {
    [sym__topdecl] = STATE(7578),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3126),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(7578),
    [sym__type_type_signature] = STATE(10080),
    [sym_decl_type] = STATE(7578),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6868),
    [sym__typed_pat] = STATE(6868),
    [sym_decl_import] = STATE(7578),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10081),
    [sym_decl_data] = STATE(7578),
    [sym__newtype_type_signature] = STATE(10082),
    [sym_decl_newtype] = STATE(7578),
    [sym__class_kind_declaration] = STATE(9320),
    [sym_class_declaration] = STATE(7578),
    [sym_class_instance] = STATE(7578),
    [sym__funpat] = STATE(8163),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6866),
    [sym_function] = STATE(7578),
    [sym_operator_declaration] = STATE(7578),
    [sym_signature] = STATE(7578),
    [sym__gendecl] = STATE(7578),
    [sym__decl_fun] = STATE(7578),
    [sym__decl] = STATE(7578),
    [sym_decl_foreign_import] = STATE(7578),
    [sym__decl_foreign] = STATE(7578),
    [sym__newkind_type_signature] = STATE(9321),
    [sym_kind_declaration] = STATE(7578),
    [sym_kind_value_declaration] = STATE(7578),
    [sym_decl_derive] = STATE(7578),
    [sym_decl_pattern] = STATE(7578),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(95),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(99),
    [anon_sym_class] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_data] = ACTIONS(105),
    [anon_sym_newtype] = ACTIONS(107),
    [anon_sym_instance] = ACTIONS(109),
    [anon_sym_infixl] = ACTIONS(111),
    [anon_sym_infixr] = ACTIONS(111),
    [anon_sym_infix] = ACTIONS(111),
    [anon_sym_foreign] = ACTIONS(113),
    [anon_sym_derive] = ACTIONS(115),
    [anon_sym_pattern] = ACTIONS(117),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [21] = {
    [sym__topdecl] = STATE(8248),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3106),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(8248),
    [sym__type_type_signature] = STATE(10125),
    [sym_decl_type] = STATE(8248),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6780),
    [sym__typed_pat] = STATE(6780),
    [sym_decl_import] = STATE(8248),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10075),
    [sym_decl_data] = STATE(8248),
    [sym__newtype_type_signature] = STATE(10074),
    [sym_decl_newtype] = STATE(8248),
    [sym__class_kind_declaration] = STATE(10073),
    [sym_class_declaration] = STATE(8248),
    [sym_class_instance] = STATE(8248),
    [sym__funpat] = STATE(8092),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6777),
    [sym_function] = STATE(8248),
    [sym_operator_declaration] = STATE(8248),
    [sym_signature] = STATE(8248),
    [sym__gendecl] = STATE(8248),
    [sym__decl_fun] = STATE(8248),
    [sym__decl] = STATE(8248),
    [sym_decl_foreign_import] = STATE(8248),
    [sym__decl_foreign] = STATE(8248),
    [sym__newkind_type_signature] = STATE(10069),
    [sym_kind_declaration] = STATE(8248),
    [sym_kind_value_declaration] = STATE(8248),
    [sym_decl_derive] = STATE(8248),
    [sym_decl_pattern] = STATE(8248),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(29),
    [anon_sym_class] = ACTIONS(31),
    [anon_sym_import] = ACTIONS(33),
    [anon_sym_data] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(39),
    [anon_sym_instance] = ACTIONS(41),
    [anon_sym_infixl] = ACTIONS(43),
    [anon_sym_infixr] = ACTIONS(43),
    [anon_sym_infix] = ACTIONS(43),
    [anon_sym_foreign] = ACTIONS(45),
    [anon_sym_derive] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [22] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2158),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [23] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(6283),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(175),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [24] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2804),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(177),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [25] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7456),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2170),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [26] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7112),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2935),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [27] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2914),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [28] = {
    [sym__topdecl] = STATE(8426),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3126),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(8426),
    [sym__type_type_signature] = STATE(10080),
    [sym_decl_type] = STATE(8426),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6868),
    [sym__typed_pat] = STATE(6868),
    [sym_decl_import] = STATE(8426),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10081),
    [sym_decl_data] = STATE(8426),
    [sym__newtype_type_signature] = STATE(10082),
    [sym_decl_newtype] = STATE(8426),
    [sym__class_kind_declaration] = STATE(9320),
    [sym_class_declaration] = STATE(8426),
    [sym_class_instance] = STATE(8426),
    [sym__funpat] = STATE(8163),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6866),
    [sym_function] = STATE(8426),
    [sym_operator_declaration] = STATE(8426),
    [sym_signature] = STATE(8426),
    [sym__gendecl] = STATE(8426),
    [sym__decl_fun] = STATE(8426),
    [sym__decl] = STATE(8426),
    [sym_decl_foreign_import] = STATE(8426),
    [sym__decl_foreign] = STATE(8426),
    [sym__newkind_type_signature] = STATE(9321),
    [sym_kind_declaration] = STATE(8426),
    [sym_kind_value_declaration] = STATE(8426),
    [sym_decl_derive] = STATE(8426),
    [sym_decl_pattern] = STATE(8426),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(95),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(99),
    [anon_sym_class] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(103),
    [anon_sym_data] = ACTIONS(105),
    [anon_sym_newtype] = ACTIONS(107),
    [anon_sym_instance] = ACTIONS(109),
    [anon_sym_infixl] = ACTIONS(111),
    [anon_sym_infixr] = ACTIONS(111),
    [anon_sym_infix] = ACTIONS(111),
    [anon_sym_foreign] = ACTIONS(113),
    [anon_sym_derive] = ACTIONS(115),
    [anon_sym_pattern] = ACTIONS(117),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [29] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(6571),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(183),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [30] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2235),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [31] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1945),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(187),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [32] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2918),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(181),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [33] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7365),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1949),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(187),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [34] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5941),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(189),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [35] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2236),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [36] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7098),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5431),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(191),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [37] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1933),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(187),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [38] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5893),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(189),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [39] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5414),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(191),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [40] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7297),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5904),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [41] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5388),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(191),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [42] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1657),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [43] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5606),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(197),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [44] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5886),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [45] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7405),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5833),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(189),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [46] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(6756),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(199),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [47] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5611),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(197),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [48] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5878),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(193),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [49] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7244),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5639),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(197),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [50] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2000),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(201),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [51] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7215),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5749),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [52] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2367),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [53] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5759),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [54] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5763),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [55] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7481),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2623),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(207),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [56] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7534),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2639),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(209),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [57] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(6997),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5106),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(211),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [58] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7266),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2305),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [59] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2358),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [60] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2468),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(213),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [61] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2028),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(201),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [62] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(6760),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(199),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [63] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2197),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [64] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7159),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1725),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [65] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2067),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [66] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2123),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [67] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1828),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [68] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7201),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2185),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(167),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [69] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7509),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2096),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(201),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [70] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1869),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [71] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7336),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2343),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(205),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [72] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2072),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [73] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7343),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(6717),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(183),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [74] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1891),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [75] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7189),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5059),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [76] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(6304),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(175),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [77] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1820),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [78] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7035),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2084),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(215),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [79] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7116),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5370),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(219),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [80] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2133),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [81] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7473),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5617),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [82] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2677),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(207),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [83] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5012),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [84] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7164),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1636),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [85] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5073),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(211),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [86] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7148),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(6341),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(175),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [87] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5374),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(219),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [88] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2665),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(207),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [89] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5623),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [90] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7254),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5220),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [91] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5378),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(219),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [92] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5064),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(211),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [93] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(4925),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(223),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [94] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5048),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [95] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(4954),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(223),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [96] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7202),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1807),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(179),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [97] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7118),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(4970),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(223),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [98] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7049),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1617),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(225),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [99] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1653),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(195),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [100] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2569),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(227),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [101] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7536),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(6766),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(199),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [102] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2797),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(177),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [103] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5627),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(221),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [104] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1711),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(225),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [105] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(1709),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(225),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [106] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2549),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(209),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [107] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2607),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [108] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2477),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(213),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [109] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5197),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [110] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7476),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2865),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(177),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [111] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2579),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(227),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [112] = {
    [sym__topdecl] = STATE(8248),
    [sym_integer] = STATE(6504),
    [sym__numeric] = STATE(6504),
    [sym__literal] = STATE(6504),
    [sym_wildcard] = STATE(6509),
    [sym_variable] = STATE(3106),
    [sym_constructor] = STATE(3280),
    [sym_qualified_constructor] = STATE(3612),
    [sym__qcon] = STATE(3572),
    [sym_literal] = STATE(6515),
    [sym_type_role_declaration] = STATE(8248),
    [sym__type_type_signature] = STATE(10125),
    [sym_decl_type] = STATE(8248),
    [sym_pat_fields] = STATE(6646),
    [sym_pat_name] = STATE(4359),
    [sym_pat_as] = STATE(4359),
    [sym__pat_constructor] = STATE(977),
    [sym_pat_record] = STATE(4359),
    [sym_pat_wildcard] = STATE(4359),
    [sym_pat_parens] = STATE(4359),
    [sym_pat_array] = STATE(4359),
    [sym__apat] = STATE(4359),
    [sym_pat_negation] = STATE(4359),
    [sym_pat_apply] = STATE(4359),
    [sym__lpat] = STATE(4359),
    [sym_pat_infix] = STATE(6781),
    [sym__pat] = STATE(6781),
    [sym_pat_typed] = STATE(6780),
    [sym__typed_pat] = STATE(6780),
    [sym_decl_import] = STATE(8248),
    [sym__modid] = STATE(10078),
    [aux_sym__qualifying_module] = STATE(7874),
    [sym__data_type_signature] = STATE(10075),
    [sym_decl_data] = STATE(8248),
    [sym__newtype_type_signature] = STATE(10074),
    [sym_decl_newtype] = STATE(8248),
    [sym__class_kind_declaration] = STATE(10073),
    [sym_class_declaration] = STATE(8248),
    [sym_class_instance] = STATE(8248),
    [sym__funpat] = STATE(8092),
    [sym__fun_name] = STATE(1391),
    [sym__funvar] = STATE(8732),
    [sym__funlhs] = STATE(6777),
    [sym_function] = STATE(8248),
    [sym_operator_declaration] = STATE(8248),
    [sym_signature] = STATE(8248),
    [sym__gendecl] = STATE(8248),
    [sym__decl_fun] = STATE(8248),
    [sym__decl] = STATE(8248),
    [sym_decl_foreign_import] = STATE(8248),
    [sym__decl_foreign] = STATE(8248),
    [sym__newkind_type_signature] = STATE(10069),
    [sym_kind_declaration] = STATE(8248),
    [sym_kind_value_declaration] = STATE(8248),
    [sym_decl_derive] = STATE(8248),
    [sym_decl_pattern] = STATE(8248),
    [sym__varid] = ACTIONS(5),
    [sym_number] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(9),
    [sym_triple_quote_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(13),
    [anon_sym__] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym__conid] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(23),
    [anon_sym_type] = ACTIONS(25),
    [anon_sym_LBRACK] = ACTIONS(27),
    [anon_sym_else] = ACTIONS(29),
    [anon_sym_class] = ACTIONS(31),
    [anon_sym_import] = ACTIONS(33),
    [anon_sym_data] = ACTIONS(37),
    [anon_sym_newtype] = ACTIONS(39),
    [anon_sym_instance] = ACTIONS(41),
    [anon_sym_infixl] = ACTIONS(43),
    [anon_sym_infixr] = ACTIONS(43),
    [anon_sym_infix] = ACTIONS(43),
    [anon_sym_foreign] = ACTIONS(45),
    [anon_sym_derive] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [113] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(6613),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(183),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [114] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2641),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [115] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2661),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(209),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [116] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7051),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2633),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(229),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [117] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(6958),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2445),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(213),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [118] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5334),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [119] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5202),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(203),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [120] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5357),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [121] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(6952),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(5236),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(217),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [122] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(7265),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym__ado_in] = STATE(2524),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_in] = ACTIONS(227),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [123] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [124] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [125] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8033),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [126] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(273),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [127] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [128] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(277),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [129] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(279),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [130] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7983),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [131] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7773),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [132] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8035),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(285),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [133] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [134] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [135] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [136] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7589),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(293),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [137] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(295),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [138] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [139] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(299),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [140] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [141] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(303),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [142] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(305),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [143] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7540),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(307),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [144] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(309),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [145] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [146] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7985),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [147] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7927),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [148] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7838),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(317),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [149] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(319),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [150] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [151] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [152] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [153] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [154] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(329),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [155] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7888),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(331),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [156] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7775),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [157] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(335),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [158] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [159] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [160] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7994),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [161] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7863),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(343),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [162] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [163] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(347),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [164] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(349),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [165] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(351),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [166] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [167] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7929),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [168] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7598),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [169] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(359),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [170] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [171] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7848),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(363),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [172] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [173] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(367),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [174] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [175] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7717),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [176] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7564),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [177] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [178] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [179] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [180] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(381),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [181] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7837),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [182] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(385),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [183] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7865),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [184] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [185] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7682),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [186] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(393),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [187] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [188] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7651),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(397),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [189] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [190] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [191] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7587),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [192] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [193] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [194] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7801),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [195] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8003),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [196] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7785),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [197] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(415),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [198] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(417),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [199] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(419),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [200] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7613),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(421),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [201] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(423),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [202] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [203] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7736),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(427),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [204] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [205] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [206] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7952),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [207] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7671),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(435),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [208] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [209] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [210] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [211] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(443),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [212] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [213] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(447),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [214] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [215] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(451),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [216] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7606),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [217] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7709),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(455),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [218] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(7943),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [219] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [220] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [221] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(463),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [222] = {
    [sym_integer] = STATE(1893),
    [sym__numeric] = STATE(1893),
    [sym__literal] = STATE(1893),
    [sym_wildcard] = STATE(5592),
    [sym_variable] = STATE(1467),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(1648),
    [sym_qualified_constructor] = STATE(1895),
    [sym__qcon] = STATE(1746),
    [sym_literal] = STATE(1747),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3207),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3207),
    [sym_exp_case] = STATE(3207),
    [sym_exp_lambda] = STATE(3207),
    [sym__statement_lexp] = STATE(3207),
    [sym___statement_exp_infix] = STATE(3207),
    [sym__statement_exp_infix] = STATE(3207),
    [sym__statement_exp] = STATE(8437),
    [sym_bind_pattern] = STATE(8437),
    [sym_let] = STATE(8437),
    [sym_statement] = STATE(8544),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3207),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8438),
    [sym__typed_pat] = STATE(8438),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5430),
    [sym__varid] = ACTIONS(231),
    [sym_number] = ACTIONS(233),
    [sym_char] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_triple_quote_string] = ACTIONS(233),
    [sym__integer_literal] = ACTIONS(237),
    [sym__hex_literal] = ACTIONS(239),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(243),
    [anon_sym_LPAREN] = ACTIONS(245),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(249),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [223] = {
    [sym_integer] = STATE(1883),
    [sym__numeric] = STATE(1883),
    [sym__literal] = STATE(1883),
    [sym_wildcard] = STATE(5646),
    [sym_variable] = STATE(1479),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(1655),
    [sym_qualified_constructor] = STATE(1879),
    [sym__qcon] = STATE(1877),
    [sym_literal] = STATE(1878),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3145),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3145),
    [sym_exp_case] = STATE(3145),
    [sym_exp_lambda] = STATE(3145),
    [sym__statement_lexp] = STATE(3145),
    [sym___statement_exp_infix] = STATE(3145),
    [sym__statement_exp_infix] = STATE(3145),
    [sym__statement_exp] = STATE(8211),
    [sym_bind_pattern] = STATE(8211),
    [sym_let] = STATE(8211),
    [sym_statement] = STATE(8106),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3145),
    [sym_pat_fields] = STATE(6567),
    [sym_pat_name] = STATE(4443),
    [sym_pat_as] = STATE(4443),
    [sym__pat_constructor] = STATE(951),
    [sym_pat_record] = STATE(4443),
    [sym_pat_wildcard] = STATE(4443),
    [sym_pat_parens] = STATE(4443),
    [sym_pat_array] = STATE(4443),
    [sym__apat] = STATE(4443),
    [sym_pat_negation] = STATE(4443),
    [sym_pat_apply] = STATE(4443),
    [sym__lpat] = STATE(4443),
    [sym_pat_infix] = STATE(6786),
    [sym__pat] = STATE(6786),
    [sym_pat_typed] = STATE(8598),
    [sym__typed_pat] = STATE(8598),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5489),
    [sym__varid] = ACTIONS(135),
    [sym_number] = ACTIONS(137),
    [sym_char] = ACTIONS(137),
    [sym_string] = ACTIONS(139),
    [sym_triple_quote_string] = ACTIONS(137),
    [sym__integer_literal] = ACTIONS(141),
    [sym__hex_literal] = ACTIONS(143),
    [anon_sym__] = ACTIONS(145),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [sym__conid] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(165),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [224] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5545),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_field_wildcard] = STATE(8645),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8644),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8689),
    [sym__typed_pat] = STATE(8689),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [225] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8405),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8168),
    [sym__typed_pat] = STATE(8168),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [226] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8115),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8168),
    [sym__typed_pat] = STATE(8168),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(505),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [227] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8207),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8575),
    [sym__typed_pat] = STATE(8575),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(507),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [228] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8555),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8161),
    [sym__typed_pat] = STATE(8161),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(509),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [229] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8294),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8044),
    [sym__typed_pat] = STATE(8044),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(511),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [230] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8593),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8044),
    [sym__typed_pat] = STATE(8044),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [231] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8084),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8575),
    [sym__typed_pat] = STATE(8575),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(515),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [232] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8338),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8161),
    [sym__typed_pat] = STATE(8161),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(517),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [233] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8456),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8168),
    [sym__typed_pat] = STATE(8168),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(519),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [234] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8191),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8575),
    [sym__typed_pat] = STATE(8575),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(521),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [235] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8461),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8168),
    [sym__typed_pat] = STATE(8168),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(523),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [236] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(5615),
    [sym_variable] = STATE(1640),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2434),
    [sym_literal] = STATE(2432),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8362),
    [sym_pat_fields] = STATE(6241),
    [sym_pat_name] = STATE(4329),
    [sym_pat_as] = STATE(4329),
    [sym__pat_constructor] = STATE(915),
    [sym_pat_record] = STATE(4329),
    [sym_pat_wildcard] = STATE(4329),
    [sym_pat_parens] = STATE(4329),
    [sym_pat_array] = STATE(4329),
    [sym__apat] = STATE(4329),
    [sym_pat_negation] = STATE(4329),
    [sym_pat_apply] = STATE(4329),
    [sym__lpat] = STATE(4329),
    [sym_pat_infix] = STATE(6635),
    [sym__pat] = STATE(6635),
    [sym_pat_typed] = STATE(8575),
    [sym__typed_pat] = STATE(8575),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(465),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(481),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [237] = {
    [sym_integer] = STATE(2287),
    [sym__numeric] = STATE(2287),
    [sym__literal] = STATE(2287),
    [sym_wildcard] = STATE(6238),
    [sym_variable] = STATE(1689),
    [sym_qualified_variable] = STATE(2455),
    [sym_constructor] = STATE(1966),
    [sym_qualified_constructor] = STATE(2284),
    [sym__qcon] = STATE(2265),
    [sym_literal] = STATE(2266),
    [sym_record_literal] = STATE(2461),
    [sym__record_update_lhs] = STATE(9759),
    [sym_record_update] = STATE(581),
    [sym_exp_name] = STATE(581),
    [sym_exp_negation] = STATE(4326),
    [sym_exp_parens] = STATE(2461),
    [sym_exp_type_application] = STATE(581),
    [sym_exp_array] = STATE(581),
    [sym_exp_section_left] = STATE(581),
    [sym_exp_section_right] = STATE(581),
    [sym_record_accessor] = STATE(581),
    [sym_exp_record_access] = STATE(2841),
    [sym_exp_if] = STATE(4326),
    [sym_pattern_guard] = STATE(7685),
    [sym_guard] = STATE(7586),
    [sym_exp_case] = STATE(4326),
    [sym_exp_let_in] = STATE(4326),
    [sym_exp_lambda] = STATE(4326),
    [sym__do] = STATE(9760),
    [sym_exp_do] = STATE(581),
    [sym__ado] = STATE(9761),
    [sym_exp_ado] = STATE(581),
    [sym__do_or_ado_block] = STATE(581),
    [sym__aexp_projection] = STATE(581),
    [sym__aexp] = STATE(581),
    [sym__exp_apply] = STATE(6683),
    [sym__fexp] = STATE(4326),
    [sym__lexp] = STATE(4326),
    [sym_exp_infix] = STATE(4326),
    [sym__exp_infix] = STATE(4326),
    [sym_pat_fields] = STATE(7097),
    [sym_pat_name] = STATE(4735),
    [sym_pat_as] = STATE(4735),
    [sym__pat_constructor] = STATE(1115),
    [sym_pat_record] = STATE(4735),
    [sym_pat_wildcard] = STATE(4735),
    [sym_pat_parens] = STATE(4735),
    [sym_pat_array] = STATE(4735),
    [sym__apat] = STATE(4735),
    [sym_pat_negation] = STATE(4735),
    [sym_pat_apply] = STATE(4735),
    [sym__lpat] = STATE(4735),
    [sym_pat_infix] = STATE(8065),
    [sym__pat] = STATE(8065),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5634),
    [sym__varid] = ACTIONS(527),
    [sym_number] = ACTIONS(529),
    [sym_char] = ACTIONS(529),
    [sym_string] = ACTIONS(531),
    [sym_triple_quote_string] = ACTIONS(529),
    [sym__integer_literal] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(535),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(539),
    [anon_sym_DASH] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(543),
    [sym__conid] = ACTIONS(545),
    [anon_sym_LBRACE] = ACTIONS(547),
    [anon_sym_AT] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_case] = ACTIONS(555),
    [anon_sym_let] = ACTIONS(557),
    [anon_sym_BSLASH] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(561),
    [anon_sym_ado] = ACTIONS(563),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [238] = {
    [sym_integer] = STATE(2539),
    [sym__numeric] = STATE(2539),
    [sym__literal] = STATE(2539),
    [sym_wildcard] = STATE(6251),
    [sym_variable] = STATE(1727),
    [sym_qualified_variable] = STATE(2651),
    [sym_constructor] = STATE(2378),
    [sym_qualified_constructor] = STATE(2575),
    [sym__qcon] = STATE(2649),
    [sym_literal] = STATE(2647),
    [sym_record_literal] = STATE(2655),
    [sym__record_update_lhs] = STATE(9937),
    [sym_record_update] = STATE(593),
    [sym_exp_name] = STATE(593),
    [sym_exp_negation] = STATE(4353),
    [sym_exp_parens] = STATE(2655),
    [sym_exp_type_application] = STATE(593),
    [sym_exp_array] = STATE(593),
    [sym_exp_section_left] = STATE(593),
    [sym_exp_section_right] = STATE(593),
    [sym_record_accessor] = STATE(593),
    [sym_exp_record_access] = STATE(2968),
    [sym_exp_if] = STATE(4353),
    [sym_pattern_guard] = STATE(7685),
    [sym_guard] = STATE(8272),
    [sym_exp_case] = STATE(4353),
    [sym_exp_let_in] = STATE(4353),
    [sym_exp_lambda] = STATE(4353),
    [sym__do] = STATE(9931),
    [sym_exp_do] = STATE(593),
    [sym__ado] = STATE(9930),
    [sym_exp_ado] = STATE(593),
    [sym__do_or_ado_block] = STATE(593),
    [sym__aexp_projection] = STATE(593),
    [sym__aexp] = STATE(593),
    [sym__exp_apply] = STATE(6842),
    [sym__fexp] = STATE(4353),
    [sym__lexp] = STATE(4353),
    [sym_exp_infix] = STATE(4353),
    [sym__exp_infix] = STATE(4353),
    [sym_pat_fields] = STATE(7097),
    [sym_pat_name] = STATE(4735),
    [sym_pat_as] = STATE(4735),
    [sym__pat_constructor] = STATE(1115),
    [sym_pat_record] = STATE(4735),
    [sym_pat_wildcard] = STATE(4735),
    [sym_pat_parens] = STATE(4735),
    [sym_pat_array] = STATE(4735),
    [sym__apat] = STATE(4735),
    [sym_pat_negation] = STATE(4735),
    [sym_pat_apply] = STATE(4735),
    [sym__lpat] = STATE(4735),
    [sym_pat_infix] = STATE(8278),
    [sym__pat] = STATE(8278),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5619),
    [sym__varid] = ACTIONS(565),
    [sym_number] = ACTIONS(567),
    [sym_char] = ACTIONS(567),
    [sym_string] = ACTIONS(569),
    [sym_triple_quote_string] = ACTIONS(567),
    [sym__integer_literal] = ACTIONS(571),
    [sym__hex_literal] = ACTIONS(573),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_LPAREN] = ACTIONS(579),
    [sym__conid] = ACTIONS(581),
    [anon_sym_LBRACE] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_LBRACK] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(589),
    [anon_sym_case] = ACTIONS(591),
    [anon_sym_let] = ACTIONS(593),
    [anon_sym_BSLASH] = ACTIONS(595),
    [anon_sym_do] = ACTIONS(597),
    [anon_sym_ado] = ACTIONS(599),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [239] = {
    [sym_integer] = STATE(2287),
    [sym__numeric] = STATE(2287),
    [sym__literal] = STATE(2287),
    [sym_wildcard] = STATE(6238),
    [sym_variable] = STATE(1689),
    [sym_qualified_variable] = STATE(2455),
    [sym_constructor] = STATE(1966),
    [sym_qualified_constructor] = STATE(2284),
    [sym__qcon] = STATE(2265),
    [sym_literal] = STATE(2266),
    [sym_record_literal] = STATE(2461),
    [sym__record_update_lhs] = STATE(9759),
    [sym_record_update] = STATE(581),
    [sym_exp_name] = STATE(581),
    [sym_exp_negation] = STATE(4326),
    [sym_exp_parens] = STATE(2461),
    [sym_exp_type_application] = STATE(581),
    [sym_exp_array] = STATE(581),
    [sym_exp_section_left] = STATE(581),
    [sym_exp_section_right] = STATE(581),
    [sym_record_accessor] = STATE(581),
    [sym_exp_record_access] = STATE(2841),
    [sym_exp_if] = STATE(4326),
    [sym_pattern_guard] = STATE(7685),
    [sym_guard] = STATE(7918),
    [sym_exp_case] = STATE(4326),
    [sym_exp_let_in] = STATE(4326),
    [sym_exp_lambda] = STATE(4326),
    [sym__do] = STATE(9760),
    [sym_exp_do] = STATE(581),
    [sym__ado] = STATE(9761),
    [sym_exp_ado] = STATE(581),
    [sym__do_or_ado_block] = STATE(581),
    [sym__aexp_projection] = STATE(581),
    [sym__aexp] = STATE(581),
    [sym__exp_apply] = STATE(6683),
    [sym__fexp] = STATE(4326),
    [sym__lexp] = STATE(4326),
    [sym_exp_infix] = STATE(4326),
    [sym__exp_infix] = STATE(4326),
    [sym_pat_fields] = STATE(7097),
    [sym_pat_name] = STATE(4735),
    [sym_pat_as] = STATE(4735),
    [sym__pat_constructor] = STATE(1115),
    [sym_pat_record] = STATE(4735),
    [sym_pat_wildcard] = STATE(4735),
    [sym_pat_parens] = STATE(4735),
    [sym_pat_array] = STATE(4735),
    [sym__apat] = STATE(4735),
    [sym_pat_negation] = STATE(4735),
    [sym_pat_apply] = STATE(4735),
    [sym__lpat] = STATE(4735),
    [sym_pat_infix] = STATE(8065),
    [sym__pat] = STATE(8065),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5634),
    [sym__varid] = ACTIONS(527),
    [sym_number] = ACTIONS(529),
    [sym_char] = ACTIONS(529),
    [sym_string] = ACTIONS(531),
    [sym_triple_quote_string] = ACTIONS(529),
    [sym__integer_literal] = ACTIONS(533),
    [sym__hex_literal] = ACTIONS(535),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(539),
    [anon_sym_DASH] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(543),
    [sym__conid] = ACTIONS(545),
    [anon_sym_LBRACE] = ACTIONS(547),
    [anon_sym_AT] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_if] = ACTIONS(553),
    [anon_sym_case] = ACTIONS(555),
    [anon_sym_let] = ACTIONS(557),
    [anon_sym_BSLASH] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(561),
    [anon_sym_ado] = ACTIONS(563),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [240] = {
    [sym_integer] = STATE(2539),
    [sym__numeric] = STATE(2539),
    [sym__literal] = STATE(2539),
    [sym_wildcard] = STATE(6251),
    [sym_variable] = STATE(1727),
    [sym_qualified_variable] = STATE(2651),
    [sym_constructor] = STATE(2378),
    [sym_qualified_constructor] = STATE(2575),
    [sym__qcon] = STATE(2649),
    [sym_literal] = STATE(2647),
    [sym_record_literal] = STATE(2655),
    [sym__record_update_lhs] = STATE(9937),
    [sym_record_update] = STATE(593),
    [sym_exp_name] = STATE(593),
    [sym_exp_negation] = STATE(4353),
    [sym_exp_parens] = STATE(2655),
    [sym_exp_type_application] = STATE(593),
    [sym_exp_array] = STATE(593),
    [sym_exp_section_left] = STATE(593),
    [sym_exp_section_right] = STATE(593),
    [sym_record_accessor] = STATE(593),
    [sym_exp_record_access] = STATE(2968),
    [sym_exp_if] = STATE(4353),
    [sym_pattern_guard] = STATE(7685),
    [sym_guard] = STATE(7586),
    [sym_exp_case] = STATE(4353),
    [sym_exp_let_in] = STATE(4353),
    [sym_exp_lambda] = STATE(4353),
    [sym__do] = STATE(9931),
    [sym_exp_do] = STATE(593),
    [sym__ado] = STATE(9930),
    [sym_exp_ado] = STATE(593),
    [sym__do_or_ado_block] = STATE(593),
    [sym__aexp_projection] = STATE(593),
    [sym__aexp] = STATE(593),
    [sym__exp_apply] = STATE(6842),
    [sym__fexp] = STATE(4353),
    [sym__lexp] = STATE(4353),
    [sym_exp_infix] = STATE(4353),
    [sym__exp_infix] = STATE(4353),
    [sym_pat_fields] = STATE(7097),
    [sym_pat_name] = STATE(4735),
    [sym_pat_as] = STATE(4735),
    [sym__pat_constructor] = STATE(1115),
    [sym_pat_record] = STATE(4735),
    [sym_pat_wildcard] = STATE(4735),
    [sym_pat_parens] = STATE(4735),
    [sym_pat_array] = STATE(4735),
    [sym__apat] = STATE(4735),
    [sym_pat_negation] = STATE(4735),
    [sym_pat_apply] = STATE(4735),
    [sym__lpat] = STATE(4735),
    [sym_pat_infix] = STATE(8278),
    [sym__pat] = STATE(8278),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5619),
    [sym__varid] = ACTIONS(565),
    [sym_number] = ACTIONS(567),
    [sym_char] = ACTIONS(567),
    [sym_string] = ACTIONS(569),
    [sym_triple_quote_string] = ACTIONS(567),
    [sym__integer_literal] = ACTIONS(571),
    [sym__hex_literal] = ACTIONS(573),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(575),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_LPAREN] = ACTIONS(579),
    [sym__conid] = ACTIONS(581),
    [anon_sym_LBRACE] = ACTIONS(583),
    [anon_sym_AT] = ACTIONS(585),
    [anon_sym_LBRACK] = ACTIONS(587),
    [anon_sym_if] = ACTIONS(589),
    [anon_sym_case] = ACTIONS(591),
    [anon_sym_let] = ACTIONS(593),
    [anon_sym_BSLASH] = ACTIONS(595),
    [anon_sym_do] = ACTIONS(597),
    [anon_sym_ado] = ACTIONS(599),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [241] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4102),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9959),
    [sym__minus] = STATE(9959),
    [sym__operator_or_minus] = STATE(9959),
    [sym_qualified_operator] = STATE(9959),
    [sym__q_op] = STATE(9959),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9192),
    [sym_qualified_constructor_operator] = STATE(9192),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3631),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3631),
    [sym_exp_case] = STATE(3631),
    [sym_exp_let_in] = STATE(3631),
    [sym_exp_lambda] = STATE(3631),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3631),
    [sym__lexp] = STATE(3631),
    [sym_exp_infix] = STATE(3631),
    [sym__exp_infix] = STATE(3631),
    [sym__exp] = STATE(9961),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [242] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4202),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9554),
    [sym__minus] = STATE(9554),
    [sym__operator_or_minus] = STATE(9554),
    [sym_qualified_operator] = STATE(9554),
    [sym__q_op] = STATE(9554),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9650),
    [sym_qualified_constructor_operator] = STATE(9650),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3496),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3496),
    [sym_exp_case] = STATE(3496),
    [sym_exp_let_in] = STATE(3496),
    [sym_exp_lambda] = STATE(3496),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3496),
    [sym__lexp] = STATE(3496),
    [sym_exp_infix] = STATE(3496),
    [sym__exp_infix] = STATE(3496),
    [sym__exp] = STATE(9553),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [243] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4082),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(10134),
    [sym__minus] = STATE(10134),
    [sym__operator_or_minus] = STATE(10134),
    [sym_qualified_operator] = STATE(10134),
    [sym__q_op] = STATE(10134),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8822),
    [sym_qualified_constructor_operator] = STATE(8822),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3446),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3446),
    [sym_exp_case] = STATE(3446),
    [sym_exp_let_in] = STATE(3446),
    [sym_exp_lambda] = STATE(3446),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3446),
    [sym__lexp] = STATE(3446),
    [sym_exp_infix] = STATE(3446),
    [sym__exp_infix] = STATE(3446),
    [sym__exp] = STATE(10135),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [244] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4174),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9383),
    [sym__minus] = STATE(9383),
    [sym__operator_or_minus] = STATE(9383),
    [sym_qualified_operator] = STATE(9383),
    [sym__q_op] = STATE(9383),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9989),
    [sym_qualified_constructor_operator] = STATE(9989),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3506),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3506),
    [sym_exp_case] = STATE(3506),
    [sym_exp_let_in] = STATE(3506),
    [sym_exp_lambda] = STATE(3506),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3506),
    [sym__lexp] = STATE(3506),
    [sym_exp_infix] = STATE(3506),
    [sym__exp_infix] = STATE(3506),
    [sym__exp] = STATE(9380),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [245] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4173),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9285),
    [sym__minus] = STATE(9285),
    [sym__operator_or_minus] = STATE(9285),
    [sym_qualified_operator] = STATE(9285),
    [sym__q_op] = STATE(9285),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(10039),
    [sym_qualified_constructor_operator] = STATE(10039),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3508),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3508),
    [sym_exp_case] = STATE(3508),
    [sym_exp_let_in] = STATE(3508),
    [sym_exp_lambda] = STATE(3508),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3508),
    [sym__lexp] = STATE(3508),
    [sym_exp_infix] = STATE(3508),
    [sym__exp_infix] = STATE(3508),
    [sym__exp] = STATE(9282),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [246] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4199),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9050),
    [sym__minus] = STATE(9050),
    [sym__operator_or_minus] = STATE(9050),
    [sym_qualified_operator] = STATE(9050),
    [sym__q_op] = STATE(9050),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(10020),
    [sym_qualified_constructor_operator] = STATE(10020),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3521),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3521),
    [sym_exp_case] = STATE(3521),
    [sym_exp_let_in] = STATE(3521),
    [sym_exp_lambda] = STATE(3521),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3521),
    [sym__lexp] = STATE(3521),
    [sym_exp_infix] = STATE(3521),
    [sym__exp_infix] = STATE(3521),
    [sym__exp] = STATE(9048),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [247] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4147),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9405),
    [sym__minus] = STATE(9405),
    [sym__operator_or_minus] = STATE(9405),
    [sym_qualified_operator] = STATE(9405),
    [sym__q_op] = STATE(9405),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9504),
    [sym_qualified_constructor_operator] = STATE(9504),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3640),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3640),
    [sym_exp_case] = STATE(3640),
    [sym_exp_let_in] = STATE(3640),
    [sym_exp_lambda] = STATE(3640),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3640),
    [sym__lexp] = STATE(3640),
    [sym_exp_infix] = STATE(3640),
    [sym__exp_infix] = STATE(3640),
    [sym__exp] = STATE(9413),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [248] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4083),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9171),
    [sym__minus] = STATE(9171),
    [sym__operator_or_minus] = STATE(9171),
    [sym_qualified_operator] = STATE(9171),
    [sym__q_op] = STATE(9171),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8804),
    [sym_qualified_constructor_operator] = STATE(8804),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3583),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3583),
    [sym_exp_case] = STATE(3583),
    [sym_exp_let_in] = STATE(3583),
    [sym_exp_lambda] = STATE(3583),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3583),
    [sym__lexp] = STATE(3583),
    [sym_exp_infix] = STATE(3583),
    [sym__exp_infix] = STATE(3583),
    [sym__exp] = STATE(9176),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [249] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4205),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9838),
    [sym__minus] = STATE(9838),
    [sym__operator_or_minus] = STATE(9838),
    [sym_qualified_operator] = STATE(9838),
    [sym__q_op] = STATE(9838),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9328),
    [sym_qualified_constructor_operator] = STATE(9328),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3451),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3451),
    [sym_exp_case] = STATE(3451),
    [sym_exp_let_in] = STATE(3451),
    [sym_exp_lambda] = STATE(3451),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3451),
    [sym__lexp] = STATE(3451),
    [sym_exp_infix] = STATE(3451),
    [sym__exp_infix] = STATE(3451),
    [sym__exp] = STATE(9837),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [250] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4233),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(10097),
    [sym__minus] = STATE(10097),
    [sym__operator_or_minus] = STATE(10097),
    [sym_qualified_operator] = STATE(10097),
    [sym__q_op] = STATE(10097),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9331),
    [sym_qualified_constructor_operator] = STATE(9331),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3477),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3477),
    [sym_exp_case] = STATE(3477),
    [sym_exp_let_in] = STATE(3477),
    [sym_exp_lambda] = STATE(3477),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3477),
    [sym__lexp] = STATE(3477),
    [sym_exp_infix] = STATE(3477),
    [sym__exp_infix] = STATE(3477),
    [sym__exp] = STATE(10095),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [251] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4099),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(8892),
    [sym__minus] = STATE(8892),
    [sym__operator_or_minus] = STATE(8892),
    [sym_qualified_operator] = STATE(8892),
    [sym__q_op] = STATE(8892),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8789),
    [sym_qualified_constructor_operator] = STATE(8789),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3533),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3533),
    [sym_exp_case] = STATE(3533),
    [sym_exp_let_in] = STATE(3533),
    [sym_exp_lambda] = STATE(3533),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3533),
    [sym__lexp] = STATE(3533),
    [sym_exp_infix] = STATE(3533),
    [sym__exp_infix] = STATE(3533),
    [sym__exp] = STATE(8747),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [252] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4198),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9864),
    [sym__minus] = STATE(9864),
    [sym__operator_or_minus] = STATE(9864),
    [sym_qualified_operator] = STATE(9864),
    [sym__q_op] = STATE(9864),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8933),
    [sym_qualified_constructor_operator] = STATE(8933),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3486),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3486),
    [sym_exp_case] = STATE(3486),
    [sym_exp_let_in] = STATE(3486),
    [sym_exp_lambda] = STATE(3486),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3486),
    [sym__lexp] = STATE(3486),
    [sym_exp_infix] = STATE(3486),
    [sym__exp_infix] = STATE(3486),
    [sym__exp] = STATE(9862),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [253] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4130),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9574),
    [sym__minus] = STATE(9574),
    [sym__operator_or_minus] = STATE(9574),
    [sym_qualified_operator] = STATE(9574),
    [sym__q_op] = STATE(9574),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9525),
    [sym_qualified_constructor_operator] = STATE(9525),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3708),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3708),
    [sym_exp_case] = STATE(3708),
    [sym_exp_let_in] = STATE(3708),
    [sym_exp_lambda] = STATE(3708),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3708),
    [sym__lexp] = STATE(3708),
    [sym_exp_infix] = STATE(3708),
    [sym__exp_infix] = STATE(3708),
    [sym__exp] = STATE(9578),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [254] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4148),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9123),
    [sym__minus] = STATE(9123),
    [sym__operator_or_minus] = STATE(9123),
    [sym_qualified_operator] = STATE(9123),
    [sym__q_op] = STATE(9123),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9688),
    [sym_qualified_constructor_operator] = STATE(9688),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3519),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3519),
    [sym_exp_case] = STATE(3519),
    [sym_exp_let_in] = STATE(3519),
    [sym_exp_lambda] = STATE(3519),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3519),
    [sym__lexp] = STATE(3519),
    [sym_exp_infix] = STATE(3519),
    [sym__exp_infix] = STATE(3519),
    [sym__exp] = STATE(9122),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [255] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4200),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9915),
    [sym__minus] = STATE(9915),
    [sym__operator_or_minus] = STATE(9915),
    [sym_qualified_operator] = STATE(9915),
    [sym__q_op] = STATE(9915),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9012),
    [sym_qualified_constructor_operator] = STATE(9012),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3483),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3483),
    [sym_exp_case] = STATE(3483),
    [sym_exp_let_in] = STATE(3483),
    [sym_exp_lambda] = STATE(3483),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3483),
    [sym__lexp] = STATE(3483),
    [sym_exp_infix] = STATE(3483),
    [sym__exp_infix] = STATE(3483),
    [sym__exp] = STATE(9912),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [256] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4154),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(8899),
    [sym__minus] = STATE(8899),
    [sym__operator_or_minus] = STATE(8899),
    [sym_qualified_operator] = STATE(8899),
    [sym__q_op] = STATE(8899),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9936),
    [sym_qualified_constructor_operator] = STATE(9936),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3524),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3524),
    [sym_exp_case] = STATE(3524),
    [sym_exp_let_in] = STATE(3524),
    [sym_exp_lambda] = STATE(3524),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3524),
    [sym__lexp] = STATE(3524),
    [sym_exp_infix] = STATE(3524),
    [sym__exp_infix] = STATE(3524),
    [sym__exp] = STATE(8895),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [257] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4152),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9632),
    [sym__minus] = STATE(9632),
    [sym__operator_or_minus] = STATE(9632),
    [sym_qualified_operator] = STATE(9632),
    [sym__q_op] = STATE(9632),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9407),
    [sym_qualified_constructor_operator] = STATE(9407),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3718),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3718),
    [sym_exp_case] = STATE(3718),
    [sym_exp_let_in] = STATE(3718),
    [sym_exp_lambda] = STATE(3718),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3718),
    [sym__lexp] = STATE(3718),
    [sym_exp_infix] = STATE(3718),
    [sym__exp_infix] = STATE(3718),
    [sym__exp] = STATE(9726),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [258] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4155),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(8975),
    [sym__minus] = STATE(8975),
    [sym__operator_or_minus] = STATE(8975),
    [sym_qualified_operator] = STATE(8975),
    [sym__q_op] = STATE(8975),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9980),
    [sym_qualified_constructor_operator] = STATE(9980),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3512),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3512),
    [sym_exp_case] = STATE(3512),
    [sym_exp_let_in] = STATE(3512),
    [sym_exp_lambda] = STATE(3512),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3512),
    [sym__lexp] = STATE(3512),
    [sym_exp_infix] = STATE(3512),
    [sym__exp_infix] = STATE(3512),
    [sym__exp] = STATE(8971),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [259] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4100),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(10055),
    [sym__minus] = STATE(10055),
    [sym__operator_or_minus] = STATE(10055),
    [sym_qualified_operator] = STATE(10055),
    [sym__q_op] = STATE(10055),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8775),
    [sym_qualified_constructor_operator] = STATE(8775),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3460),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3460),
    [sym_exp_case] = STATE(3460),
    [sym_exp_let_in] = STATE(3460),
    [sym_exp_lambda] = STATE(3460),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3460),
    [sym__lexp] = STATE(3460),
    [sym_exp_infix] = STATE(3460),
    [sym__exp_infix] = STATE(3460),
    [sym__exp] = STATE(10058),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [260] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4101),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(10071),
    [sym__minus] = STATE(10071),
    [sym__operator_or_minus] = STATE(10071),
    [sym_qualified_operator] = STATE(10071),
    [sym__q_op] = STATE(10071),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8759),
    [sym_qualified_constructor_operator] = STATE(8759),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3628),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3628),
    [sym_exp_case] = STATE(3628),
    [sym_exp_let_in] = STATE(3628),
    [sym_exp_lambda] = STATE(3628),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3628),
    [sym__lexp] = STATE(3628),
    [sym_exp_infix] = STATE(3628),
    [sym__exp_infix] = STATE(3628),
    [sym__exp] = STATE(10022),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [261] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4153),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(8819),
    [sym__minus] = STATE(8819),
    [sym__operator_or_minus] = STATE(8819),
    [sym_qualified_operator] = STATE(8819),
    [sym__q_op] = STATE(8819),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9773),
    [sym_qualified_constructor_operator] = STATE(9773),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3527),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3527),
    [sym_exp_case] = STATE(3527),
    [sym_exp_let_in] = STATE(3527),
    [sym_exp_lambda] = STATE(3527),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3527),
    [sym__lexp] = STATE(3527),
    [sym_exp_infix] = STATE(3527),
    [sym__exp_infix] = STATE(3527),
    [sym__exp] = STATE(8816),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [262] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4080),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(10093),
    [sym__minus] = STATE(10093),
    [sym__operator_or_minus] = STATE(10093),
    [sym_qualified_operator] = STATE(10093),
    [sym__q_op] = STATE(10093),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8936),
    [sym_qualified_constructor_operator] = STATE(8936),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3442),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3442),
    [sym_exp_case] = STATE(3442),
    [sym_exp_let_in] = STATE(3442),
    [sym_exp_lambda] = STATE(3442),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3442),
    [sym__lexp] = STATE(3442),
    [sym_exp_infix] = STATE(3442),
    [sym__exp_infix] = STATE(3442),
    [sym__exp] = STATE(10091),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [263] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4081),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(10042),
    [sym__minus] = STATE(10042),
    [sym__operator_or_minus] = STATE(10042),
    [sym_qualified_operator] = STATE(10042),
    [sym__q_op] = STATE(10042),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8898),
    [sym_qualified_constructor_operator] = STATE(8898),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3488),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3488),
    [sym_exp_case] = STATE(3488),
    [sym_exp_let_in] = STATE(3488),
    [sym_exp_lambda] = STATE(3488),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3488),
    [sym__lexp] = STATE(3488),
    [sym_exp_infix] = STATE(3488),
    [sym__exp_infix] = STATE(3488),
    [sym__exp] = STATE(10041),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [264] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4075),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9917),
    [sym__minus] = STATE(9917),
    [sym__operator_or_minus] = STATE(9917),
    [sym_qualified_operator] = STATE(9917),
    [sym__q_op] = STATE(9917),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8993),
    [sym_qualified_constructor_operator] = STATE(8993),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3551),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3551),
    [sym_exp_case] = STATE(3551),
    [sym_exp_let_in] = STATE(3551),
    [sym_exp_lambda] = STATE(3551),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3551),
    [sym__lexp] = STATE(3551),
    [sym_exp_infix] = STATE(3551),
    [sym__exp_infix] = STATE(3551),
    [sym__exp] = STATE(9913),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [265] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4079),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9958),
    [sym__minus] = STATE(9958),
    [sym__operator_or_minus] = STATE(9958),
    [sym_qualified_operator] = STATE(9958),
    [sym__q_op] = STATE(9958),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8955),
    [sym_qualified_constructor_operator] = STATE(8955),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3522),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3522),
    [sym_exp_case] = STATE(3522),
    [sym_exp_let_in] = STATE(3522),
    [sym_exp_lambda] = STATE(3522),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3522),
    [sym__lexp] = STATE(3522),
    [sym_exp_infix] = STATE(3522),
    [sym__exp_infix] = STATE(3522),
    [sym__exp] = STATE(9957),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [266] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4103),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9974),
    [sym__minus] = STATE(9974),
    [sym__operator_or_minus] = STATE(9974),
    [sym_qualified_operator] = STATE(9974),
    [sym__q_op] = STATE(9974),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9266),
    [sym_qualified_constructor_operator] = STATE(9266),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3632),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3632),
    [sym_exp_case] = STATE(3632),
    [sym_exp_let_in] = STATE(3632),
    [sym_exp_lambda] = STATE(3632),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3632),
    [sym__lexp] = STATE(3632),
    [sym_exp_infix] = STATE(3632),
    [sym__exp_infix] = STATE(3632),
    [sym__exp] = STATE(9899),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [267] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4139),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9986),
    [sym__minus] = STATE(9986),
    [sym__operator_or_minus] = STATE(9986),
    [sym_qualified_operator] = STATE(9986),
    [sym__q_op] = STATE(9986),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9583),
    [sym_qualified_constructor_operator] = STATE(9583),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3482),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3482),
    [sym_exp_case] = STATE(3482),
    [sym_exp_let_in] = STATE(3482),
    [sym_exp_lambda] = STATE(3482),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3482),
    [sym__lexp] = STATE(3482),
    [sym_exp_infix] = STATE(3482),
    [sym__exp_infix] = STATE(3482),
    [sym__exp] = STATE(9985),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [268] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4206),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9662),
    [sym__minus] = STATE(9662),
    [sym__operator_or_minus] = STATE(9662),
    [sym_qualified_operator] = STATE(9662),
    [sym__q_op] = STATE(9662),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8781),
    [sym_qualified_constructor_operator] = STATE(8781),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3489),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3489),
    [sym_exp_case] = STATE(3489),
    [sym_exp_let_in] = STATE(3489),
    [sym_exp_lambda] = STATE(3489),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3489),
    [sym__lexp] = STATE(3489),
    [sym_exp_infix] = STATE(3489),
    [sym__exp_infix] = STATE(3489),
    [sym__exp] = STATE(9659),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [269] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4107),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9833),
    [sym__minus] = STATE(9833),
    [sym__operator_or_minus] = STATE(9833),
    [sym_qualified_operator] = STATE(9833),
    [sym__q_op] = STATE(9833),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9370),
    [sym_qualified_constructor_operator] = STATE(9370),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3636),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3636),
    [sym_exp_case] = STATE(3636),
    [sym_exp_let_in] = STATE(3636),
    [sym_exp_lambda] = STATE(3636),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3636),
    [sym__lexp] = STATE(3636),
    [sym_exp_infix] = STATE(3636),
    [sym__exp_infix] = STATE(3636),
    [sym__exp] = STATE(9840),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [270] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4151),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9200),
    [sym__minus] = STATE(9200),
    [sym__operator_or_minus] = STATE(9200),
    [sym_qualified_operator] = STATE(9200),
    [sym__q_op] = STATE(9200),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9817),
    [sym_qualified_constructor_operator] = STATE(9817),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3518),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3518),
    [sym_exp_case] = STATE(3518),
    [sym_exp_let_in] = STATE(3518),
    [sym_exp_lambda] = STATE(3518),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3518),
    [sym__lexp] = STATE(3518),
    [sym_exp_infix] = STATE(3518),
    [sym__exp_infix] = STATE(3518),
    [sym__exp] = STATE(9197),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [271] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4077),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(10003),
    [sym__minus] = STATE(10003),
    [sym__operator_or_minus] = STATE(10003),
    [sym_qualified_operator] = STATE(10003),
    [sym__q_op] = STATE(10003),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8974),
    [sym_qualified_constructor_operator] = STATE(8974),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3514),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3514),
    [sym_exp_case] = STATE(3514),
    [sym_exp_let_in] = STATE(3514),
    [sym_exp_lambda] = STATE(3514),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3514),
    [sym__lexp] = STATE(3514),
    [sym_exp_infix] = STATE(3514),
    [sym__exp_infix] = STATE(3514),
    [sym__exp] = STATE(10002),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [272] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4182),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9464),
    [sym__minus] = STATE(9464),
    [sym__operator_or_minus] = STATE(9464),
    [sym_qualified_operator] = STATE(9464),
    [sym__q_op] = STATE(9464),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(9777),
    [sym_qualified_constructor_operator] = STATE(9777),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3505),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3505),
    [sym_exp_case] = STATE(3505),
    [sym_exp_let_in] = STATE(3505),
    [sym_exp_lambda] = STATE(3505),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3505),
    [sym__lexp] = STATE(3505),
    [sym_exp_infix] = STATE(3505),
    [sym__exp_infix] = STATE(3505),
    [sym__exp] = STATE(9462),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [273] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(4207),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_operator] = STATE(9786),
    [sym__minus] = STATE(9786),
    [sym__operator_or_minus] = STATE(9786),
    [sym_qualified_operator] = STATE(9786),
    [sym__q_op] = STATE(9786),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym_constructor_operator] = STATE(8857),
    [sym_qualified_constructor_operator] = STATE(8857),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3487),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3487),
    [sym_exp_case] = STATE(3487),
    [sym_exp_let_in] = STATE(3487),
    [sym_exp_lambda] = STATE(3487),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3487),
    [sym__lexp] = STATE(3487),
    [sym_exp_infix] = STATE(3487),
    [sym__exp_infix] = STATE(3487),
    [sym__exp] = STATE(9781),
    [sym__modid] = STATE(9854),
    [aux_sym__qualifying_module] = STATE(3901),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [sym__operator] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(605),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(77),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym__consym] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [274] = {
    [sym_integer] = STATE(1756),
    [sym__numeric] = STATE(1756),
    [sym__literal] = STATE(1756),
    [sym_wildcard] = STATE(8374),
    [sym_variable] = STATE(1528),
    [sym_qualified_variable] = STATE(1528),
    [sym_constructor] = STATE(1706),
    [sym_qualified_constructor] = STATE(1789),
    [sym__qcon] = STATE(1902),
    [sym_literal] = STATE(274),
    [sym_record_literal] = STATE(1526),
    [sym__record_update_lhs] = STATE(9719),
    [sym_record_update] = STATE(274),
    [sym_exp_name] = STATE(274),
    [sym_exp_parens] = STATE(1526),
    [sym_exp_type_application] = STATE(274),
    [sym_exp_array] = STATE(274),
    [sym_exp_section_left] = STATE(274),
    [sym_exp_section_right] = STATE(274),
    [sym_record_accessor] = STATE(274),
    [sym_exp_record_access] = STATE(1790),
    [sym_exp_if] = STATE(5080),
    [sym_exp_case] = STATE(5080),
    [sym_exp_let_in] = STATE(5080),
    [sym_exp_lambda] = STATE(5080),
    [sym__do] = STATE(9720),
    [sym_exp_do] = STATE(274),
    [sym__ado] = STATE(9721),
    [sym_exp_ado] = STATE(274),
    [sym__do_or_ado_block] = STATE(274),
    [sym__aexp_projection] = STATE(274),
    [sym__aexp] = STATE(274),
    [sym__exp_apply] = STATE(5080),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5540),
    [sym__varid] = ACTIONS(613),
    [anon_sym_SEMI] = ACTIONS(615),
    [sym_number] = ACTIONS(617),
    [sym_char] = ACTIONS(617),
    [sym_string] = ACTIONS(619),
    [sym_triple_quote_string] = ACTIONS(617),
    [sym__integer_literal] = ACTIONS(621),
    [sym__hex_literal] = ACTIONS(623),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(627),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(629),
    [sym__conid] = ACTIONS(631),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_let] = ACTIONS(644),
    [anon_sym_BSLASH] = ACTIONS(646),
    [anon_sym_do] = ACTIONS(648),
    [anon_sym_ado] = ACTIONS(650),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(615),
    [sym__layout_end] = ACTIONS(615),
    [sym_where] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [275] = {
    [sym_integer] = STATE(1852),
    [sym__numeric] = STATE(1852),
    [sym__literal] = STATE(1852),
    [sym_wildcard] = STATE(8255),
    [sym_variable] = STATE(1603),
    [sym_qualified_variable] = STATE(1603),
    [sym_constructor] = STATE(1670),
    [sym_qualified_constructor] = STATE(1863),
    [sym__qcon] = STATE(1786),
    [sym_literal] = STATE(275),
    [sym_record_literal] = STATE(1604),
    [sym__record_update_lhs] = STATE(9739),
    [sym_record_update] = STATE(275),
    [sym_exp_name] = STATE(275),
    [sym_exp_parens] = STATE(1604),
    [sym_exp_type_application] = STATE(275),
    [sym_exp_array] = STATE(275),
    [sym_exp_section_left] = STATE(275),
    [sym_exp_section_right] = STATE(275),
    [sym_record_accessor] = STATE(275),
    [sym_exp_record_access] = STATE(1929),
    [sym_exp_if] = STATE(5195),
    [sym_exp_case] = STATE(5195),
    [sym_exp_let_in] = STATE(5195),
    [sym_exp_lambda] = STATE(5195),
    [sym__do] = STATE(9740),
    [sym_exp_do] = STATE(275),
    [sym__ado] = STATE(9741),
    [sym_exp_ado] = STATE(275),
    [sym__do_or_ado_block] = STATE(275),
    [sym__aexp_projection] = STATE(275),
    [sym__aexp] = STATE(275),
    [sym__exp_apply] = STATE(5195),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5673),
    [sym__varid] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(615),
    [sym_number] = ACTIONS(654),
    [sym_char] = ACTIONS(654),
    [sym_string] = ACTIONS(656),
    [sym_triple_quote_string] = ACTIONS(654),
    [sym__integer_literal] = ACTIONS(658),
    [sym__hex_literal] = ACTIONS(660),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(662),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(664),
    [sym__conid] = ACTIONS(666),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(671),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_case] = ACTIONS(677),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_in] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(681),
    [anon_sym_do] = ACTIONS(683),
    [anon_sym_ado] = ACTIONS(685),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(615),
    [sym_where] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [276] = {
    [sym_integer] = STATE(1926),
    [sym__numeric] = STATE(1926),
    [sym__literal] = STATE(1926),
    [sym_wildcard] = STATE(8330),
    [sym_variable] = STATE(1532),
    [sym_qualified_variable] = STATE(1532),
    [sym_constructor] = STATE(1631),
    [sym_qualified_constructor] = STATE(1923),
    [sym__qcon] = STATE(1882),
    [sym_literal] = STATE(279),
    [sym_record_literal] = STATE(1538),
    [sym__record_update_lhs] = STATE(9501),
    [sym_record_update] = STATE(279),
    [sym_exp_name] = STATE(279),
    [sym_exp_parens] = STATE(1538),
    [sym_exp_type_application] = STATE(279),
    [sym_exp_array] = STATE(279),
    [sym_exp_section_left] = STATE(279),
    [sym_exp_section_right] = STATE(279),
    [sym_record_accessor] = STATE(279),
    [sym_exp_record_access] = STATE(1940),
    [sym_exp_if] = STATE(5241),
    [sym_exp_case] = STATE(5241),
    [sym_exp_let_in] = STATE(5241),
    [sym_exp_lambda] = STATE(5241),
    [sym__do] = STATE(9502),
    [sym_exp_do] = STATE(279),
    [sym__ado] = STATE(9503),
    [sym_exp_ado] = STATE(279),
    [sym__do_or_ado_block] = STATE(279),
    [sym__aexp_projection] = STATE(279),
    [sym__aexp] = STATE(279),
    [sym__exp_apply] = STATE(5241),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5526),
    [ts_builtin_sym_end] = ACTIONS(687),
    [sym__varid] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_number] = ACTIONS(692),
    [sym_char] = ACTIONS(692),
    [sym_string] = ACTIONS(694),
    [sym_triple_quote_string] = ACTIONS(692),
    [sym__integer_literal] = ACTIONS(696),
    [sym__hex_literal] = ACTIONS(698),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(703),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym__conid] = ACTIONS(707),
    [anon_sym_PIPE] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_AT] = ACTIONS(713),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_let] = ACTIONS(721),
    [anon_sym_BSLASH] = ACTIONS(723),
    [anon_sym_do] = ACTIONS(725),
    [anon_sym_ado] = ACTIONS(727),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(687),
    [sym_where] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [277] = {
    [sym_integer] = STATE(1852),
    [sym__numeric] = STATE(1852),
    [sym__literal] = STATE(1852),
    [sym_wildcard] = STATE(8255),
    [sym_variable] = STATE(1603),
    [sym_qualified_variable] = STATE(1603),
    [sym_constructor] = STATE(1670),
    [sym_qualified_constructor] = STATE(1863),
    [sym__qcon] = STATE(1786),
    [sym_literal] = STATE(275),
    [sym_record_literal] = STATE(1604),
    [sym__record_update_lhs] = STATE(9739),
    [sym_record_update] = STATE(275),
    [sym_exp_name] = STATE(275),
    [sym_exp_parens] = STATE(1604),
    [sym_exp_type_application] = STATE(275),
    [sym_exp_array] = STATE(275),
    [sym_exp_section_left] = STATE(275),
    [sym_exp_section_right] = STATE(275),
    [sym_record_accessor] = STATE(275),
    [sym_exp_record_access] = STATE(1929),
    [sym_exp_if] = STATE(5195),
    [sym_exp_case] = STATE(5195),
    [sym_exp_let_in] = STATE(5195),
    [sym_exp_lambda] = STATE(5195),
    [sym__do] = STATE(9740),
    [sym_exp_do] = STATE(275),
    [sym__ado] = STATE(9741),
    [sym_exp_ado] = STATE(275),
    [sym__do_or_ado_block] = STATE(275),
    [sym__aexp_projection] = STATE(275),
    [sym__aexp] = STATE(275),
    [sym__exp_apply] = STATE(5195),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5673),
    [sym__varid] = ACTIONS(652),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_number] = ACTIONS(654),
    [sym_char] = ACTIONS(654),
    [sym_string] = ACTIONS(656),
    [sym_triple_quote_string] = ACTIONS(654),
    [sym__integer_literal] = ACTIONS(658),
    [sym__hex_literal] = ACTIONS(660),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(662),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(664),
    [sym__conid] = ACTIONS(729),
    [anon_sym_PIPE] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(671),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_case] = ACTIONS(677),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_in] = ACTIONS(700),
    [anon_sym_BSLASH] = ACTIONS(681),
    [anon_sym_do] = ACTIONS(683),
    [anon_sym_ado] = ACTIONS(685),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(687),
    [sym_where] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [278] = {
    [sym_integer] = STATE(1756),
    [sym__numeric] = STATE(1756),
    [sym__literal] = STATE(1756),
    [sym_wildcard] = STATE(8374),
    [sym_variable] = STATE(1528),
    [sym_qualified_variable] = STATE(1528),
    [sym_constructor] = STATE(1706),
    [sym_qualified_constructor] = STATE(1789),
    [sym__qcon] = STATE(1902),
    [sym_literal] = STATE(274),
    [sym_record_literal] = STATE(1526),
    [sym__record_update_lhs] = STATE(9719),
    [sym_record_update] = STATE(274),
    [sym_exp_name] = STATE(274),
    [sym_exp_parens] = STATE(1526),
    [sym_exp_type_application] = STATE(274),
    [sym_exp_array] = STATE(274),
    [sym_exp_section_left] = STATE(274),
    [sym_exp_section_right] = STATE(274),
    [sym_record_accessor] = STATE(274),
    [sym_exp_record_access] = STATE(1790),
    [sym_exp_if] = STATE(5080),
    [sym_exp_case] = STATE(5080),
    [sym_exp_let_in] = STATE(5080),
    [sym_exp_lambda] = STATE(5080),
    [sym__do] = STATE(9720),
    [sym_exp_do] = STATE(274),
    [sym__ado] = STATE(9721),
    [sym_exp_ado] = STATE(274),
    [sym__do_or_ado_block] = STATE(274),
    [sym__aexp_projection] = STATE(274),
    [sym__aexp] = STATE(274),
    [sym__exp_apply] = STATE(5080),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5540),
    [sym__varid] = ACTIONS(613),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_number] = ACTIONS(617),
    [sym_char] = ACTIONS(617),
    [sym_string] = ACTIONS(619),
    [sym_triple_quote_string] = ACTIONS(617),
    [sym__integer_literal] = ACTIONS(621),
    [sym__hex_literal] = ACTIONS(623),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(627),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(629),
    [sym__conid] = ACTIONS(733),
    [anon_sym_PIPE] = ACTIONS(700),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(636),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_let] = ACTIONS(644),
    [anon_sym_BSLASH] = ACTIONS(646),
    [anon_sym_do] = ACTIONS(648),
    [anon_sym_ado] = ACTIONS(650),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(687),
    [sym__layout_end] = ACTIONS(687),
    [sym_where] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [279] = {
    [sym_integer] = STATE(1926),
    [sym__numeric] = STATE(1926),
    [sym__literal] = STATE(1926),
    [sym_wildcard] = STATE(8330),
    [sym_variable] = STATE(1532),
    [sym_qualified_variable] = STATE(1532),
    [sym_constructor] = STATE(1631),
    [sym_qualified_constructor] = STATE(1923),
    [sym__qcon] = STATE(1882),
    [sym_literal] = STATE(279),
    [sym_record_literal] = STATE(1538),
    [sym__record_update_lhs] = STATE(9501),
    [sym_record_update] = STATE(279),
    [sym_exp_name] = STATE(279),
    [sym_exp_parens] = STATE(1538),
    [sym_exp_type_application] = STATE(279),
    [sym_exp_array] = STATE(279),
    [sym_exp_section_left] = STATE(279),
    [sym_exp_section_right] = STATE(279),
    [sym_record_accessor] = STATE(279),
    [sym_exp_record_access] = STATE(1940),
    [sym_exp_if] = STATE(5241),
    [sym_exp_case] = STATE(5241),
    [sym_exp_let_in] = STATE(5241),
    [sym_exp_lambda] = STATE(5241),
    [sym__do] = STATE(9502),
    [sym_exp_do] = STATE(279),
    [sym__ado] = STATE(9503),
    [sym_exp_ado] = STATE(279),
    [sym__do_or_ado_block] = STATE(279),
    [sym__aexp_projection] = STATE(279),
    [sym__aexp] = STATE(279),
    [sym__exp_apply] = STATE(5241),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5526),
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym__varid] = ACTIONS(690),
    [anon_sym_SEMI] = ACTIONS(615),
    [sym_number] = ACTIONS(692),
    [sym_char] = ACTIONS(692),
    [sym_string] = ACTIONS(694),
    [sym_triple_quote_string] = ACTIONS(692),
    [sym__integer_literal] = ACTIONS(696),
    [sym__hex_literal] = ACTIONS(698),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(703),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym__conid] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(625),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_AT] = ACTIONS(713),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_let] = ACTIONS(721),
    [anon_sym_BSLASH] = ACTIONS(723),
    [anon_sym_do] = ACTIONS(725),
    [anon_sym_ado] = ACTIONS(727),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(615),
    [sym_where] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [280] = {
    [sym_integer] = STATE(2097),
    [sym__numeric] = STATE(2097),
    [sym__literal] = STATE(2097),
    [sym_wildcard] = STATE(8070),
    [sym_variable] = STATE(1686),
    [sym_qualified_variable] = STATE(1686),
    [sym_constructor] = STATE(1767),
    [sym_qualified_constructor] = STATE(2092),
    [sym__qcon] = STATE(2091),
    [sym_literal] = STATE(283),
    [sym_record_literal] = STATE(1688),
    [sym__record_update_lhs] = STATE(9679),
    [sym_record_update] = STATE(283),
    [sym_exp_name] = STATE(283),
    [sym_exp_parens] = STATE(1688),
    [sym_exp_type_application] = STATE(283),
    [sym_exp_array] = STATE(283),
    [sym_exp_section_left] = STATE(283),
    [sym_exp_section_right] = STATE(283),
    [sym_record_accessor] = STATE(283),
    [sym_exp_record_access] = STATE(2204),
    [sym_exp_if] = STATE(5436),
    [sym_exp_case] = STATE(5436),
    [sym_exp_let_in] = STATE(5436),
    [sym_exp_lambda] = STATE(5436),
    [sym__do] = STATE(9680),
    [sym_exp_do] = STATE(283),
    [sym__ado] = STATE(9681),
    [sym_exp_ado] = STATE(283),
    [sym__do_or_ado_block] = STATE(283),
    [sym__aexp_projection] = STATE(283),
    [sym__aexp] = STATE(283),
    [sym__exp_apply] = STATE(5436),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5664),
    [sym__varid] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_number] = ACTIONS(742),
    [sym_char] = ACTIONS(742),
    [sym_string] = ACTIONS(744),
    [sym_triple_quote_string] = ACTIONS(742),
    [sym__integer_literal] = ACTIONS(746),
    [sym__hex_literal] = ACTIONS(748),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(750),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(752),
    [sym__conid] = ACTIONS(754),
    [anon_sym_LBRACE] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(764),
    [anon_sym_case] = ACTIONS(766),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_BSLASH] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_ado] = ACTIONS(774),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(687),
    [sym__layout_end] = ACTIONS(687),
    [sym_where] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [281] = {
    [sym_integer] = STATE(2215),
    [sym__numeric] = STATE(2215),
    [sym__literal] = STATE(2215),
    [sym_wildcard] = STATE(8285),
    [sym_variable] = STATE(1700),
    [sym_qualified_variable] = STATE(1700),
    [sym_constructor] = STATE(1822),
    [sym_qualified_constructor] = STATE(2216),
    [sym__qcon] = STATE(2038),
    [sym_literal] = STATE(285),
    [sym_record_literal] = STATE(1702),
    [sym__record_update_lhs] = STATE(9341),
    [sym_record_update] = STATE(285),
    [sym_exp_name] = STATE(285),
    [sym_exp_parens] = STATE(1702),
    [sym_exp_type_application] = STATE(285),
    [sym_exp_array] = STATE(285),
    [sym_exp_section_left] = STATE(285),
    [sym_exp_section_right] = STATE(285),
    [sym_record_accessor] = STATE(285),
    [sym_exp_record_access] = STATE(2165),
    [sym_exp_if] = STATE(5659),
    [sym_exp_case] = STATE(5659),
    [sym_exp_let_in] = STATE(5659),
    [sym_exp_lambda] = STATE(5659),
    [sym__do] = STATE(9342),
    [sym_exp_do] = STATE(285),
    [sym__ado] = STATE(9343),
    [sym_exp_ado] = STATE(285),
    [sym__do_or_ado_block] = STATE(285),
    [sym__aexp_projection] = STATE(285),
    [sym__aexp] = STATE(285),
    [sym__exp_apply] = STATE(5659),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5676),
    [ts_builtin_sym_end] = ACTIONS(687),
    [sym__varid] = ACTIONS(776),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_number] = ACTIONS(778),
    [sym_char] = ACTIONS(778),
    [sym_string] = ACTIONS(780),
    [sym_triple_quote_string] = ACTIONS(778),
    [sym__integer_literal] = ACTIONS(782),
    [sym__hex_literal] = ACTIONS(784),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(786),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(788),
    [sym__conid] = ACTIONS(790),
    [anon_sym_LBRACE] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(796),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(800),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_let] = ACTIONS(804),
    [anon_sym_BSLASH] = ACTIONS(806),
    [anon_sym_do] = ACTIONS(808),
    [anon_sym_ado] = ACTIONS(810),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(687),
    [sym_where] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [282] = {
    [sym_integer] = STATE(2063),
    [sym__numeric] = STATE(2063),
    [sym__literal] = STATE(2063),
    [sym_wildcard] = STATE(8591),
    [sym_variable] = STATE(1625),
    [sym_qualified_variable] = STATE(1625),
    [sym_constructor] = STATE(1743),
    [sym_qualified_constructor] = STATE(2061),
    [sym__qcon] = STATE(2141),
    [sym_literal] = STATE(284),
    [sym_record_literal] = STATE(1626),
    [sym__record_update_lhs] = STATE(9689),
    [sym_record_update] = STATE(284),
    [sym_exp_name] = STATE(284),
    [sym_exp_parens] = STATE(1626),
    [sym_exp_type_application] = STATE(284),
    [sym_exp_array] = STATE(284),
    [sym_exp_section_left] = STATE(284),
    [sym_exp_section_right] = STATE(284),
    [sym_record_accessor] = STATE(284),
    [sym_exp_record_access] = STATE(2032),
    [sym_exp_if] = STATE(5425),
    [sym_exp_case] = STATE(5425),
    [sym_exp_let_in] = STATE(5425),
    [sym_exp_lambda] = STATE(5425),
    [sym__do] = STATE(9690),
    [sym_exp_do] = STATE(284),
    [sym__ado] = STATE(9691),
    [sym_exp_ado] = STATE(284),
    [sym__do_or_ado_block] = STATE(284),
    [sym__aexp_projection] = STATE(284),
    [sym__aexp] = STATE(284),
    [sym__exp_apply] = STATE(5425),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5674),
    [sym__varid] = ACTIONS(812),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_number] = ACTIONS(814),
    [sym_char] = ACTIONS(814),
    [sym_string] = ACTIONS(816),
    [sym_triple_quote_string] = ACTIONS(814),
    [sym__integer_literal] = ACTIONS(818),
    [sym__hex_literal] = ACTIONS(820),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(822),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(824),
    [sym__conid] = ACTIONS(826),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(832),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_case] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(700),
    [anon_sym_BSLASH] = ACTIONS(842),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_ado] = ACTIONS(846),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(687),
    [sym_where] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [283] = {
    [sym_integer] = STATE(2097),
    [sym__numeric] = STATE(2097),
    [sym__literal] = STATE(2097),
    [sym_wildcard] = STATE(8070),
    [sym_variable] = STATE(1686),
    [sym_qualified_variable] = STATE(1686),
    [sym_constructor] = STATE(1767),
    [sym_qualified_constructor] = STATE(2092),
    [sym__qcon] = STATE(2091),
    [sym_literal] = STATE(283),
    [sym_record_literal] = STATE(1688),
    [sym__record_update_lhs] = STATE(9679),
    [sym_record_update] = STATE(283),
    [sym_exp_name] = STATE(283),
    [sym_exp_parens] = STATE(1688),
    [sym_exp_type_application] = STATE(283),
    [sym_exp_array] = STATE(283),
    [sym_exp_section_left] = STATE(283),
    [sym_exp_section_right] = STATE(283),
    [sym_record_accessor] = STATE(283),
    [sym_exp_record_access] = STATE(2204),
    [sym_exp_if] = STATE(5436),
    [sym_exp_case] = STATE(5436),
    [sym_exp_let_in] = STATE(5436),
    [sym_exp_lambda] = STATE(5436),
    [sym__do] = STATE(9680),
    [sym_exp_do] = STATE(283),
    [sym__ado] = STATE(9681),
    [sym_exp_ado] = STATE(283),
    [sym__do_or_ado_block] = STATE(283),
    [sym__aexp_projection] = STATE(283),
    [sym__aexp] = STATE(283),
    [sym__exp_apply] = STATE(5436),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5664),
    [sym__varid] = ACTIONS(740),
    [anon_sym_SEMI] = ACTIONS(615),
    [sym_number] = ACTIONS(742),
    [sym_char] = ACTIONS(742),
    [sym_string] = ACTIONS(744),
    [sym_triple_quote_string] = ACTIONS(742),
    [sym__integer_literal] = ACTIONS(746),
    [sym__hex_literal] = ACTIONS(748),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(750),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(752),
    [sym__conid] = ACTIONS(848),
    [anon_sym_LBRACE] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(760),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(764),
    [anon_sym_case] = ACTIONS(766),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_BSLASH] = ACTIONS(770),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_ado] = ACTIONS(774),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(615),
    [sym__layout_end] = ACTIONS(615),
    [sym_where] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [284] = {
    [sym_integer] = STATE(2063),
    [sym__numeric] = STATE(2063),
    [sym__literal] = STATE(2063),
    [sym_wildcard] = STATE(8591),
    [sym_variable] = STATE(1625),
    [sym_qualified_variable] = STATE(1625),
    [sym_constructor] = STATE(1743),
    [sym_qualified_constructor] = STATE(2061),
    [sym__qcon] = STATE(2141),
    [sym_literal] = STATE(284),
    [sym_record_literal] = STATE(1626),
    [sym__record_update_lhs] = STATE(9689),
    [sym_record_update] = STATE(284),
    [sym_exp_name] = STATE(284),
    [sym_exp_parens] = STATE(1626),
    [sym_exp_type_application] = STATE(284),
    [sym_exp_array] = STATE(284),
    [sym_exp_section_left] = STATE(284),
    [sym_exp_section_right] = STATE(284),
    [sym_record_accessor] = STATE(284),
    [sym_exp_record_access] = STATE(2032),
    [sym_exp_if] = STATE(5425),
    [sym_exp_case] = STATE(5425),
    [sym_exp_let_in] = STATE(5425),
    [sym_exp_lambda] = STATE(5425),
    [sym__do] = STATE(9690),
    [sym_exp_do] = STATE(284),
    [sym__ado] = STATE(9691),
    [sym_exp_ado] = STATE(284),
    [sym__do_or_ado_block] = STATE(284),
    [sym__aexp_projection] = STATE(284),
    [sym__aexp] = STATE(284),
    [sym__exp_apply] = STATE(5425),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5674),
    [sym__varid] = ACTIONS(812),
    [anon_sym_SEMI] = ACTIONS(615),
    [sym_number] = ACTIONS(814),
    [sym_char] = ACTIONS(814),
    [sym_string] = ACTIONS(816),
    [sym_triple_quote_string] = ACTIONS(814),
    [sym__integer_literal] = ACTIONS(818),
    [sym__hex_literal] = ACTIONS(820),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(822),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(824),
    [sym__conid] = ACTIONS(851),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(832),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_case] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_in] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(842),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_ado] = ACTIONS(846),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(615),
    [sym_where] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [285] = {
    [sym_integer] = STATE(2215),
    [sym__numeric] = STATE(2215),
    [sym__literal] = STATE(2215),
    [sym_wildcard] = STATE(8285),
    [sym_variable] = STATE(1700),
    [sym_qualified_variable] = STATE(1700),
    [sym_constructor] = STATE(1822),
    [sym_qualified_constructor] = STATE(2216),
    [sym__qcon] = STATE(2038),
    [sym_literal] = STATE(285),
    [sym_record_literal] = STATE(1702),
    [sym__record_update_lhs] = STATE(9341),
    [sym_record_update] = STATE(285),
    [sym_exp_name] = STATE(285),
    [sym_exp_parens] = STATE(1702),
    [sym_exp_type_application] = STATE(285),
    [sym_exp_array] = STATE(285),
    [sym_exp_section_left] = STATE(285),
    [sym_exp_section_right] = STATE(285),
    [sym_record_accessor] = STATE(285),
    [sym_exp_record_access] = STATE(2165),
    [sym_exp_if] = STATE(5659),
    [sym_exp_case] = STATE(5659),
    [sym_exp_let_in] = STATE(5659),
    [sym_exp_lambda] = STATE(5659),
    [sym__do] = STATE(9342),
    [sym_exp_do] = STATE(285),
    [sym__ado] = STATE(9343),
    [sym_exp_ado] = STATE(285),
    [sym__do_or_ado_block] = STATE(285),
    [sym__aexp_projection] = STATE(285),
    [sym__aexp] = STATE(285),
    [sym__exp_apply] = STATE(5659),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5676),
    [ts_builtin_sym_end] = ACTIONS(615),
    [sym__varid] = ACTIONS(776),
    [anon_sym_SEMI] = ACTIONS(615),
    [sym_number] = ACTIONS(778),
    [sym_char] = ACTIONS(778),
    [sym_string] = ACTIONS(780),
    [sym_triple_quote_string] = ACTIONS(778),
    [sym__integer_literal] = ACTIONS(782),
    [sym__hex_literal] = ACTIONS(784),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(786),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(788),
    [sym__conid] = ACTIONS(854),
    [anon_sym_LBRACE] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(796),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(800),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_let] = ACTIONS(804),
    [anon_sym_BSLASH] = ACTIONS(806),
    [anon_sym_do] = ACTIONS(808),
    [anon_sym_ado] = ACTIONS(810),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(615),
    [sym_where] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [286] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9507),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [287] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9539),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [288] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(913),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [289] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [290] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(917),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [291] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8165),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(929),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [292] = {
    [sym_integer] = STATE(2282),
    [sym__numeric] = STATE(2282),
    [sym__literal] = STATE(2282),
    [sym_wildcard] = STATE(8180),
    [sym_variable] = STATE(1835),
    [sym_qualified_variable] = STATE(1835),
    [sym_constructor] = STATE(1970),
    [sym_qualified_constructor] = STATE(2291),
    [sym__qcon] = STATE(2407),
    [sym_literal] = STATE(292),
    [sym_record_literal] = STATE(1837),
    [sym__record_update_lhs] = STATE(9787),
    [sym_record_update] = STATE(292),
    [sym_exp_name] = STATE(292),
    [sym_exp_parens] = STATE(1837),
    [sym_exp_type_application] = STATE(292),
    [sym_exp_array] = STATE(292),
    [sym_exp_section_left] = STATE(292),
    [sym_exp_section_right] = STATE(292),
    [sym_record_accessor] = STATE(292),
    [sym_exp_record_access] = STATE(2249),
    [sym_exp_if] = STATE(6151),
    [sym_exp_case] = STATE(6151),
    [sym_exp_let_in] = STATE(6151),
    [sym_exp_lambda] = STATE(6151),
    [sym__do] = STATE(9788),
    [sym_exp_do] = STATE(292),
    [sym__ado] = STATE(9789),
    [sym_exp_ado] = STATE(292),
    [sym__do_or_ado_block] = STATE(292),
    [sym__aexp_projection] = STATE(292),
    [sym__aexp] = STATE(292),
    [sym__exp_apply] = STATE(6151),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5607),
    [sym__varid] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_char] = ACTIONS(933),
    [sym_string] = ACTIONS(935),
    [sym_triple_quote_string] = ACTIONS(933),
    [sym__integer_literal] = ACTIONS(937),
    [sym__hex_literal] = ACTIONS(939),
    [anon_sym_u2192] = ACTIONS(625),
    [anon_sym_DASH_GT] = ACTIONS(625),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(941),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(943),
    [sym__conid] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BSLASH] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_ado] = ACTIONS(964),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(615),
  },
  [293] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9440),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [294] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [295] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7814),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(968),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [296] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8294),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [297] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9458),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [298] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(972),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [299] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(974),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [300] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(300),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(300),
    [sym_exp_name] = STATE(300),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(300),
    [sym_exp_array] = STATE(300),
    [sym_exp_section_left] = STATE(300),
    [sym_exp_section_right] = STATE(300),
    [sym_record_accessor] = STATE(300),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(5587),
    [sym_exp_case] = STATE(5587),
    [sym_exp_let_in] = STATE(5587),
    [sym_exp_lambda] = STATE(5587),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(300),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(300),
    [sym__do_or_ado_block] = STATE(300),
    [sym__aexp_projection] = STATE(300),
    [sym__aexp] = STATE(300),
    [sym__exp_apply] = STATE(5587),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(976),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(615),
  },
  [301] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [302] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8112),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [303] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9555),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [304] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [305] = {
    [sym_integer] = STATE(2473),
    [sym__numeric] = STATE(2473),
    [sym__literal] = STATE(2473),
    [sym_wildcard] = STATE(8244),
    [sym_variable] = STATE(1770),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(2107),
    [sym_qualified_constructor] = STATE(2485),
    [sym__qcon] = STATE(2252),
    [sym_literal] = STATE(342),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(342),
    [sym_exp_name] = STATE(342),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(342),
    [sym_exp_array] = STATE(342),
    [sym_exp_section_left] = STATE(342),
    [sym_exp_section_right] = STATE(342),
    [sym_record_accessor] = STATE(342),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(6220),
    [sym_exp_case] = STATE(6220),
    [sym_exp_let_in] = STATE(6220),
    [sym_exp_lambda] = STATE(6220),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(342),
    [sym__ado] = STATE(9566),
    [sym_exp_ado] = STATE(342),
    [sym__do_or_ado_block] = STATE(342),
    [sym__aexp_projection] = STATE(342),
    [sym__aexp] = STATE(342),
    [sym__exp_apply] = STATE(6220),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5610),
    [sym__varid] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_number] = ACTIONS(991),
    [sym_char] = ACTIONS(991),
    [sym_string] = ACTIONS(993),
    [sym_triple_quote_string] = ACTIONS(991),
    [sym__integer_literal] = ACTIONS(995),
    [sym__hex_literal] = ACTIONS(997),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(147),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(999),
    [sym__conid] = ACTIONS(1001),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_in] = ACTIONS(700),
    [anon_sym_BSLASH] = ACTIONS(1013),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [306] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7552),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1015),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [307] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9475),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [308] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1017),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [309] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8458),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1019),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [310] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7878),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [311] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7554),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1023),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [312] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9491),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [313] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8461),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [314] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8503),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1027),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [315] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [316] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [317] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7986),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1033),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [318] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1035),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [319] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [320] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8555),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1039),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [321] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7708),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1041),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [322] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8115),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1043),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [323] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1045),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [324] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1047),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [325] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8000),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1049),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [326] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8545),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1051),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [327] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8593),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1053),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [328] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9422),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [329] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [330] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7835),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [331] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8199),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1059),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [332] = {
    [sym_integer] = STATE(2282),
    [sym__numeric] = STATE(2282),
    [sym__literal] = STATE(2282),
    [sym_wildcard] = STATE(8180),
    [sym_variable] = STATE(1835),
    [sym_qualified_variable] = STATE(1835),
    [sym_constructor] = STATE(1970),
    [sym_qualified_constructor] = STATE(2291),
    [sym__qcon] = STATE(2407),
    [sym_literal] = STATE(292),
    [sym_record_literal] = STATE(1837),
    [sym__record_update_lhs] = STATE(9787),
    [sym_record_update] = STATE(292),
    [sym_exp_name] = STATE(292),
    [sym_exp_parens] = STATE(1837),
    [sym_exp_type_application] = STATE(292),
    [sym_exp_array] = STATE(292),
    [sym_exp_section_left] = STATE(292),
    [sym_exp_section_right] = STATE(292),
    [sym_record_accessor] = STATE(292),
    [sym_exp_record_access] = STATE(2249),
    [sym_exp_if] = STATE(6151),
    [sym_exp_case] = STATE(6151),
    [sym_exp_let_in] = STATE(6151),
    [sym_exp_lambda] = STATE(6151),
    [sym__do] = STATE(9788),
    [sym_exp_do] = STATE(292),
    [sym__ado] = STATE(9789),
    [sym_exp_ado] = STATE(292),
    [sym__do_or_ado_block] = STATE(292),
    [sym__aexp_projection] = STATE(292),
    [sym__aexp] = STATE(292),
    [sym__exp_apply] = STATE(6151),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5607),
    [sym__varid] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_char] = ACTIONS(933),
    [sym_string] = ACTIONS(935),
    [sym_triple_quote_string] = ACTIONS(933),
    [sym__integer_literal] = ACTIONS(937),
    [sym__hex_literal] = ACTIONS(939),
    [anon_sym_u2192] = ACTIONS(700),
    [anon_sym_DASH_GT] = ACTIONS(700),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(941),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(943),
    [sym__conid] = ACTIONS(1061),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(950),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BSLASH] = ACTIONS(960),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_ado] = ACTIONS(964),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(687),
  },
  [333] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7605),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1065),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [334] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7942),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [335] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(7287),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_field_wildcard] = STATE(8645),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8644),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [336] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7749),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [337] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(300),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(300),
    [sym_exp_name] = STATE(300),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(300),
    [sym_exp_array] = STATE(300),
    [sym_exp_section_left] = STATE(300),
    [sym_exp_section_right] = STATE(300),
    [sym_record_accessor] = STATE(300),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(5587),
    [sym_exp_case] = STATE(5587),
    [sym_exp_let_in] = STATE(5587),
    [sym_exp_lambda] = STATE(5587),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(300),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(300),
    [sym__do_or_ado_block] = STATE(300),
    [sym__aexp_projection] = STATE(300),
    [sym__aexp] = STATE(300),
    [sym__exp_apply] = STATE(5587),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(1071),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_RBRACE] = ACTIONS(687),
    [anon_sym_AT] = ACTIONS(979),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(687),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(981),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(687),
  },
  [338] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [339] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [340] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1079),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [341] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [342] = {
    [sym_integer] = STATE(2473),
    [sym__numeric] = STATE(2473),
    [sym__literal] = STATE(2473),
    [sym_wildcard] = STATE(8244),
    [sym_variable] = STATE(1770),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(2107),
    [sym_qualified_constructor] = STATE(2485),
    [sym__qcon] = STATE(2252),
    [sym_literal] = STATE(342),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(342),
    [sym_exp_name] = STATE(342),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(342),
    [sym_exp_array] = STATE(342),
    [sym_exp_section_left] = STATE(342),
    [sym_exp_section_right] = STATE(342),
    [sym_record_accessor] = STATE(342),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(6220),
    [sym_exp_case] = STATE(6220),
    [sym_exp_let_in] = STATE(6220),
    [sym_exp_lambda] = STATE(6220),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(342),
    [sym__ado] = STATE(9566),
    [sym_exp_ado] = STATE(342),
    [sym__do_or_ado_block] = STATE(342),
    [sym__aexp_projection] = STATE(342),
    [sym__aexp] = STATE(342),
    [sym__exp_apply] = STATE(6220),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5610),
    [sym__varid] = ACTIONS(989),
    [anon_sym_SEMI] = ACTIONS(615),
    [sym_number] = ACTIONS(991),
    [sym_char] = ACTIONS(991),
    [sym_string] = ACTIONS(993),
    [sym_triple_quote_string] = ACTIONS(991),
    [sym__integer_literal] = ACTIONS(995),
    [sym__hex_literal] = ACTIONS(997),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(147),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(999),
    [sym__conid] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(1007),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_in] = ACTIONS(625),
    [anon_sym_BSLASH] = ACTIONS(1013),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [343] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1086),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [344] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9523),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [345] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1088),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [346] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8456),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1090),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [347] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1092),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [348] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1094),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [349] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [350] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1098),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [351] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7998),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [352] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1102),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [353] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [354] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1106),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [355] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [356] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1110),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [357] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1112),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [358] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8421),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1114),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [359] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8230),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1116),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [360] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [361] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8207),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1120),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [362] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8335),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1122),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [363] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8024),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [364] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1126),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [365] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8049),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1128),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [366] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1130),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [367] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8405),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1132),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [368] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1134),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [369] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1136),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [370] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [371] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(371),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(371),
    [sym_exp_name] = STATE(371),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(371),
    [sym_exp_array] = STATE(371),
    [sym_exp_section_left] = STATE(371),
    [sym_exp_section_right] = STATE(371),
    [sym_record_accessor] = STATE(371),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(6066),
    [sym_exp_case] = STATE(6066),
    [sym_exp_let_in] = STATE(6066),
    [sym_exp_lambda] = STATE(6066),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(371),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(371),
    [sym__do_or_ado_block] = STATE(371),
    [sym__aexp_projection] = STATE(371),
    [sym__aexp] = STATE(371),
    [sym__exp_apply] = STATE(6066),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [anon_sym_SEMI] = ACTIONS(615),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(1140),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(1143),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(1145),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(615),
    [sym__layout_end] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [372] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8023),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1147),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [373] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [374] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8293),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [375] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [376] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [377] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [378] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [379] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [380] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7684),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [381] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9570),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [382] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [383] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8238),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1167),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [384] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8299),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1169),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [385] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8081),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1171),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [386] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8140),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1173),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [387] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7788),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [388] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9355),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [389] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8362),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1177),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [390] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9585),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [391] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7972),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [392] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8063),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1181),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [393] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7759),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1183),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [394] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7702),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [395] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [396] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7843),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [397] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8338),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [398] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [399] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7693),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [400] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7619),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1197),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [401] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(371),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(371),
    [sym_exp_name] = STATE(371),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(371),
    [sym_exp_array] = STATE(371),
    [sym_exp_section_left] = STATE(371),
    [sym_exp_section_right] = STATE(371),
    [sym_record_accessor] = STATE(371),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(6066),
    [sym_exp_case] = STATE(6066),
    [sym_exp_let_in] = STATE(6066),
    [sym_exp_lambda] = STATE(6066),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(371),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(371),
    [sym__do_or_ado_block] = STATE(371),
    [sym__aexp_projection] = STATE(371),
    [sym__aexp] = STATE(371),
    [sym__exp_apply] = STATE(6066),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(1199),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(1143),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(1145),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(687),
    [sym__layout_end] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [402] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9401),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [403] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1203),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [404] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7643),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [405] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9829),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [406] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8191),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1207),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [407] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(6920),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym__exp_case_slots] = STATE(9600),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8365),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [408] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7889),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [409] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1211),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [410] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7627),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [411] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8563),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1215),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [412] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [413] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [414] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [415] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [416] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [417] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8084),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [418] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7920),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [419] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1231),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [420] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8242),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1233),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [421] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [422] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8401),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1237),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [423] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7585),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [424] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8015),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [425] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1243),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [426] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8354),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1245),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [427] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(7805),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1247),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [428] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [429] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8491),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(1251),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [430] = {
    [sym_integer] = STATE(2473),
    [sym__numeric] = STATE(2473),
    [sym__literal] = STATE(2473),
    [sym_wildcard] = STATE(8244),
    [sym_variable] = STATE(1770),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(2107),
    [sym_qualified_constructor] = STATE(2485),
    [sym__qcon] = STATE(2252),
    [sym_literal] = STATE(305),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3153),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3153),
    [sym_exp_case] = STATE(3153),
    [sym_exp_let_in] = STATE(3153),
    [sym_exp_lambda] = STATE(3153),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3153),
    [sym__lexp] = STATE(3153),
    [sym_exp_infix] = STATE(3153),
    [sym__exp_infix] = STATE(3153),
    [sym__exp] = STATE(6201),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5610),
    [sym__varid] = ACTIONS(989),
    [sym_number] = ACTIONS(991),
    [sym_char] = ACTIONS(991),
    [sym_string] = ACTIONS(993),
    [sym_triple_quote_string] = ACTIONS(991),
    [sym__integer_literal] = ACTIONS(995),
    [sym__hex_literal] = ACTIONS(997),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(999),
    [sym__conid] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [431] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7846),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9447),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [432] = {
    [sym_integer] = STATE(2473),
    [sym__numeric] = STATE(2473),
    [sym__literal] = STATE(2473),
    [sym_wildcard] = STATE(5031),
    [sym_variable] = STATE(1770),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(2107),
    [sym_qualified_constructor] = STATE(2485),
    [sym__qcon] = STATE(2252),
    [sym_literal] = STATE(305),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3153),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3153),
    [sym_exp_case] = STATE(3153),
    [sym_exp_let_in] = STATE(3153),
    [sym_exp_lambda] = STATE(3153),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3153),
    [sym__lexp] = STATE(3153),
    [sym_exp_infix] = STATE(3153),
    [sym__exp_infix] = STATE(3153),
    [sym__exp] = STATE(6194),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5610),
    [sym__varid] = ACTIONS(989),
    [sym_number] = ACTIONS(991),
    [sym_char] = ACTIONS(991),
    [sym_string] = ACTIONS(993),
    [sym_triple_quote_string] = ACTIONS(991),
    [sym__integer_literal] = ACTIONS(995),
    [sym__hex_literal] = ACTIONS(997),
    [anon_sym__] = ACTIONS(1291),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(999),
    [sym__conid] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [433] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7935),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10122),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [434] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7901),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9408),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [435] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3152),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3152),
    [sym_exp_case] = STATE(3152),
    [sym_exp_let_in] = STATE(3152),
    [sym_exp_lambda] = STATE(3152),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3152),
    [sym__lexp] = STATE(3152),
    [sym_exp_infix] = STATE(3152),
    [sym__exp_infix] = STATE(3152),
    [sym__exp] = STATE(6097),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [436] = {
    [sym_integer] = STATE(2656),
    [sym__numeric] = STATE(2656),
    [sym__literal] = STATE(2656),
    [sym_wildcard] = STATE(6056),
    [sym_variable] = STATE(1968),
    [sym_qualified_variable] = STATE(1968),
    [sym_constructor] = STATE(2386),
    [sym_qualified_constructor] = STATE(2653),
    [sym__qcon] = STATE(2634),
    [sym_literal] = STATE(516),
    [sym_record_literal] = STATE(1967),
    [sym__record_update_lhs] = STATE(9623),
    [sym_record_update] = STATE(516),
    [sym_exp_name] = STATE(516),
    [sym_exp_negation] = STATE(3279),
    [sym_exp_parens] = STATE(1967),
    [sym_exp_type_application] = STATE(516),
    [sym_exp_array] = STATE(516),
    [sym_exp_section_left] = STATE(516),
    [sym_exp_section_right] = STATE(516),
    [sym_record_accessor] = STATE(516),
    [sym_exp_record_access] = STATE(2602),
    [sym_exp_if] = STATE(3279),
    [sym_exp_case] = STATE(3279),
    [sym_exp_let_in] = STATE(3279),
    [sym_exp_lambda] = STATE(3279),
    [sym__do] = STATE(9624),
    [sym_exp_do] = STATE(516),
    [sym__ado] = STATE(9625),
    [sym_exp_ado] = STATE(516),
    [sym__do_or_ado_block] = STATE(516),
    [sym__aexp_projection] = STATE(516),
    [sym__aexp] = STATE(516),
    [sym__exp_apply] = STATE(6282),
    [sym__fexp] = STATE(3279),
    [sym__lexp] = STATE(3279),
    [sym_exp_infix] = STATE(3279),
    [sym__exp_infix] = STATE(3279),
    [sym__exp] = STATE(6753),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5551),
    [sym__varid] = ACTIONS(1325),
    [sym_number] = ACTIONS(1327),
    [sym_char] = ACTIONS(1327),
    [sym_string] = ACTIONS(1329),
    [sym_triple_quote_string] = ACTIONS(1327),
    [sym__integer_literal] = ACTIONS(1331),
    [sym__hex_literal] = ACTIONS(1333),
    [anon_sym__] = ACTIONS(1335),
    [sym_hole] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [sym__conid] = ACTIONS(1343),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_BSLASH] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_ado] = ACTIONS(1361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [437] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7667),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9635),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [438] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7933),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10120),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [439] = {
    [sym_integer] = STATE(2097),
    [sym__numeric] = STATE(2097),
    [sym__literal] = STATE(2097),
    [sym_wildcard] = STATE(4868),
    [sym_variable] = STATE(1686),
    [sym_qualified_variable] = STATE(1686),
    [sym_constructor] = STATE(1767),
    [sym_qualified_constructor] = STATE(2092),
    [sym__qcon] = STATE(2091),
    [sym_literal] = STATE(280),
    [sym_record_literal] = STATE(1688),
    [sym__record_update_lhs] = STATE(9679),
    [sym_record_update] = STATE(280),
    [sym_exp_name] = STATE(280),
    [sym_exp_negation] = STATE(3051),
    [sym_exp_parens] = STATE(1688),
    [sym_exp_type_application] = STATE(280),
    [sym_exp_array] = STATE(280),
    [sym_exp_section_left] = STATE(280),
    [sym_exp_section_right] = STATE(280),
    [sym_record_accessor] = STATE(280),
    [sym_exp_record_access] = STATE(2204),
    [sym_exp_if] = STATE(3051),
    [sym_exp_case] = STATE(3051),
    [sym_exp_let_in] = STATE(3051),
    [sym_exp_lambda] = STATE(3051),
    [sym__do] = STATE(9680),
    [sym_exp_do] = STATE(280),
    [sym__ado] = STATE(9681),
    [sym_exp_ado] = STATE(280),
    [sym__do_or_ado_block] = STATE(280),
    [sym__aexp_projection] = STATE(280),
    [sym__aexp] = STATE(280),
    [sym__exp_apply] = STATE(5459),
    [sym__fexp] = STATE(3051),
    [sym__lexp] = STATE(3051),
    [sym_exp_infix] = STATE(3051),
    [sym__exp_infix] = STATE(3051),
    [sym__exp] = STATE(5412),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5664),
    [sym__varid] = ACTIONS(740),
    [sym_number] = ACTIONS(742),
    [sym_char] = ACTIONS(742),
    [sym_string] = ACTIONS(744),
    [sym_triple_quote_string] = ACTIONS(742),
    [sym__integer_literal] = ACTIONS(746),
    [sym__hex_literal] = ACTIONS(748),
    [anon_sym__] = ACTIONS(1363),
    [sym_hole] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(752),
    [sym__conid] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(764),
    [anon_sym_case] = ACTIONS(766),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_BSLASH] = ACTIONS(1371),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_ado] = ACTIONS(774),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [440] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7565),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(9831),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [441] = {
    [sym_integer] = STATE(2282),
    [sym__numeric] = STATE(2282),
    [sym__literal] = STATE(2282),
    [sym_wildcard] = STATE(8180),
    [sym_variable] = STATE(1835),
    [sym_qualified_variable] = STATE(1835),
    [sym_constructor] = STATE(1970),
    [sym_qualified_constructor] = STATE(2291),
    [sym__qcon] = STATE(2407),
    [sym_literal] = STATE(332),
    [sym_record_literal] = STATE(1837),
    [sym__record_update_lhs] = STATE(9787),
    [sym_record_update] = STATE(332),
    [sym_exp_name] = STATE(332),
    [sym_exp_negation] = STATE(3260),
    [sym_exp_parens] = STATE(1837),
    [sym_exp_type_application] = STATE(332),
    [sym_exp_array] = STATE(332),
    [sym_exp_section_left] = STATE(332),
    [sym_exp_section_right] = STATE(332),
    [sym_record_accessor] = STATE(332),
    [sym_exp_record_access] = STATE(2249),
    [sym_exp_if] = STATE(3260),
    [sym_exp_case] = STATE(3260),
    [sym_exp_let_in] = STATE(3260),
    [sym_exp_lambda] = STATE(3260),
    [sym__do] = STATE(9788),
    [sym_exp_do] = STATE(332),
    [sym__ado] = STATE(9789),
    [sym_exp_ado] = STATE(332),
    [sym__do_or_ado_block] = STATE(332),
    [sym__aexp_projection] = STATE(332),
    [sym__aexp] = STATE(332),
    [sym__exp_apply] = STATE(6145),
    [sym__fexp] = STATE(3260),
    [sym__lexp] = STATE(3260),
    [sym_exp_infix] = STATE(3260),
    [sym__exp_infix] = STATE(3260),
    [sym__exp] = STATE(6661),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5607),
    [sym__varid] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_char] = ACTIONS(933),
    [sym_string] = ACTIONS(935),
    [sym_triple_quote_string] = ACTIONS(933),
    [sym__integer_literal] = ACTIONS(937),
    [sym__hex_literal] = ACTIONS(939),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(943),
    [sym__conid] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_ado] = ACTIONS(964),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [442] = {
    [sym_integer] = STATE(2282),
    [sym__numeric] = STATE(2282),
    [sym__literal] = STATE(2282),
    [sym_wildcard] = STATE(5533),
    [sym_variable] = STATE(1835),
    [sym_qualified_variable] = STATE(1835),
    [sym_constructor] = STATE(1970),
    [sym_qualified_constructor] = STATE(2291),
    [sym__qcon] = STATE(2407),
    [sym_literal] = STATE(332),
    [sym_record_literal] = STATE(1837),
    [sym__record_update_lhs] = STATE(9787),
    [sym_record_update] = STATE(332),
    [sym_exp_name] = STATE(332),
    [sym_exp_negation] = STATE(3260),
    [sym_exp_parens] = STATE(1837),
    [sym_exp_type_application] = STATE(332),
    [sym_exp_array] = STATE(332),
    [sym_exp_section_left] = STATE(332),
    [sym_exp_section_right] = STATE(332),
    [sym_record_accessor] = STATE(332),
    [sym_exp_record_access] = STATE(2249),
    [sym_exp_if] = STATE(3260),
    [sym_exp_case] = STATE(3260),
    [sym_exp_let_in] = STATE(3260),
    [sym_exp_lambda] = STATE(3260),
    [sym__do] = STATE(9788),
    [sym_exp_do] = STATE(332),
    [sym__ado] = STATE(9789),
    [sym_exp_ado] = STATE(332),
    [sym__do_or_ado_block] = STATE(332),
    [sym__aexp_projection] = STATE(332),
    [sym__aexp] = STATE(332),
    [sym__exp_apply] = STATE(6145),
    [sym__fexp] = STATE(3260),
    [sym__lexp] = STATE(3260),
    [sym_exp_infix] = STATE(3260),
    [sym__exp_infix] = STATE(3260),
    [sym__exp] = STATE(6657),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5607),
    [sym__varid] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_char] = ACTIONS(933),
    [sym_string] = ACTIONS(935),
    [sym_triple_quote_string] = ACTIONS(933),
    [sym__integer_literal] = ACTIONS(937),
    [sym__hex_literal] = ACTIONS(939),
    [anon_sym__] = ACTIONS(1381),
    [sym_hole] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(943),
    [sym__conid] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_ado] = ACTIONS(964),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [443] = {
    [sym_integer] = STATE(2282),
    [sym__numeric] = STATE(2282),
    [sym__literal] = STATE(2282),
    [sym_wildcard] = STATE(8180),
    [sym_variable] = STATE(1835),
    [sym_qualified_variable] = STATE(1835),
    [sym_constructor] = STATE(1970),
    [sym_qualified_constructor] = STATE(2291),
    [sym__qcon] = STATE(2407),
    [sym_literal] = STATE(332),
    [sym_record_literal] = STATE(1837),
    [sym__record_update_lhs] = STATE(9787),
    [sym_record_update] = STATE(332),
    [sym_exp_name] = STATE(332),
    [sym_exp_negation] = STATE(3260),
    [sym_exp_parens] = STATE(1837),
    [sym_exp_type_application] = STATE(332),
    [sym_exp_array] = STATE(332),
    [sym_exp_section_left] = STATE(332),
    [sym_exp_section_right] = STATE(332),
    [sym_record_accessor] = STATE(332),
    [sym_exp_record_access] = STATE(2249),
    [sym_exp_if] = STATE(3260),
    [sym_exp_case] = STATE(3260),
    [sym_exp_let_in] = STATE(3260),
    [sym_exp_lambda] = STATE(3260),
    [sym__do] = STATE(9788),
    [sym_exp_do] = STATE(332),
    [sym__ado] = STATE(9789),
    [sym_exp_ado] = STATE(332),
    [sym__do_or_ado_block] = STATE(332),
    [sym__aexp_projection] = STATE(332),
    [sym__aexp] = STATE(332),
    [sym__exp_apply] = STATE(6145),
    [sym__fexp] = STATE(3260),
    [sym__lexp] = STATE(3260),
    [sym_exp_infix] = STATE(3260),
    [sym__exp_infix] = STATE(3260),
    [sym__exp] = STATE(6663),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5607),
    [sym__varid] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_char] = ACTIONS(933),
    [sym_string] = ACTIONS(935),
    [sym_triple_quote_string] = ACTIONS(933),
    [sym__integer_literal] = ACTIONS(937),
    [sym__hex_literal] = ACTIONS(939),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(943),
    [sym__conid] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_ado] = ACTIONS(964),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [444] = {
    [sym_integer] = STATE(2473),
    [sym__numeric] = STATE(2473),
    [sym__literal] = STATE(2473),
    [sym_wildcard] = STATE(8244),
    [sym_variable] = STATE(1770),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(2107),
    [sym_qualified_constructor] = STATE(2485),
    [sym__qcon] = STATE(2252),
    [sym_literal] = STATE(305),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3225),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3225),
    [sym_exp_case] = STATE(3225),
    [sym_exp_let_in] = STATE(3225),
    [sym_exp_lambda] = STATE(3225),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3225),
    [sym__lexp] = STATE(3225),
    [sym_exp_infix] = STATE(3225),
    [sym__exp_infix] = STATE(3225),
    [sym__exp] = STATE(8110),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5610),
    [sym__varid] = ACTIONS(989),
    [sym_number] = ACTIONS(991),
    [sym_char] = ACTIONS(991),
    [sym_string] = ACTIONS(993),
    [sym_triple_quote_string] = ACTIONS(991),
    [sym__integer_literal] = ACTIONS(995),
    [sym__hex_literal] = ACTIONS(997),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(999),
    [sym__conid] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [445] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3230),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3230),
    [sym_exp_case] = STATE(3230),
    [sym_exp_let_in] = STATE(3230),
    [sym_exp_lambda] = STATE(3230),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3230),
    [sym__lexp] = STATE(3230),
    [sym_exp_infix] = STATE(3230),
    [sym__exp_infix] = STATE(3230),
    [sym__exp] = STATE(5583),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [446] = {
    [sym_integer] = STATE(2215),
    [sym__numeric] = STATE(2215),
    [sym__literal] = STATE(2215),
    [sym_wildcard] = STATE(8285),
    [sym_variable] = STATE(1700),
    [sym_qualified_variable] = STATE(1700),
    [sym_constructor] = STATE(1822),
    [sym_qualified_constructor] = STATE(2216),
    [sym__qcon] = STATE(2038),
    [sym_literal] = STATE(281),
    [sym_record_literal] = STATE(1702),
    [sym__record_update_lhs] = STATE(9341),
    [sym_record_update] = STATE(281),
    [sym_exp_name] = STATE(281),
    [sym_exp_negation] = STATE(3049),
    [sym_exp_parens] = STATE(1702),
    [sym_exp_type_application] = STATE(281),
    [sym_exp_array] = STATE(281),
    [sym_exp_section_left] = STATE(281),
    [sym_exp_section_right] = STATE(281),
    [sym_record_accessor] = STATE(281),
    [sym_exp_record_access] = STATE(2165),
    [sym_exp_if] = STATE(3049),
    [sym_exp_case] = STATE(3049),
    [sym_exp_let_in] = STATE(3049),
    [sym_exp_lambda] = STATE(3049),
    [sym__do] = STATE(9342),
    [sym_exp_do] = STATE(281),
    [sym__ado] = STATE(9343),
    [sym_exp_ado] = STATE(281),
    [sym__do_or_ado_block] = STATE(281),
    [sym__aexp_projection] = STATE(281),
    [sym__aexp] = STATE(281),
    [sym__exp_apply] = STATE(5620),
    [sym__fexp] = STATE(3049),
    [sym__lexp] = STATE(3049),
    [sym_exp_infix] = STATE(3049),
    [sym__exp_infix] = STATE(3049),
    [sym__exp] = STATE(5736),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5676),
    [sym__varid] = ACTIONS(776),
    [sym_number] = ACTIONS(778),
    [sym_char] = ACTIONS(778),
    [sym_string] = ACTIONS(780),
    [sym_triple_quote_string] = ACTIONS(778),
    [sym__integer_literal] = ACTIONS(782),
    [sym__hex_literal] = ACTIONS(784),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(788),
    [sym__conid] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(800),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_let] = ACTIONS(804),
    [anon_sym_BSLASH] = ACTIONS(1389),
    [anon_sym_do] = ACTIONS(808),
    [anon_sym_ado] = ACTIONS(810),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [447] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7663),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9649),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [448] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(8037),
    [sym_variable] = STATE(2646),
    [sym_qualified_variable] = STATE(2646),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(595),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(595),
    [sym_exp_name] = STATE(595),
    [sym_exp_negation] = STATE(3977),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(595),
    [sym_exp_array] = STATE(595),
    [sym_exp_section_left] = STATE(595),
    [sym_exp_section_right] = STATE(595),
    [sym_record_accessor] = STATE(595),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3977),
    [sym_exp_case] = STATE(3977),
    [sym_exp_let_in] = STATE(3977),
    [sym_exp_lambda] = STATE(3977),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(595),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(595),
    [sym__do_or_ado_block] = STATE(595),
    [sym__aexp_projection] = STATE(595),
    [sym__aexp] = STATE(595),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3977),
    [sym__lexp] = STATE(3977),
    [sym_exp_infix] = STATE(3977),
    [sym__exp_infix] = STATE(3977),
    [sym__exp] = STATE(7401),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_BSLASH] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [449] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7680),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9607),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [450] = {
    [sym_integer] = STATE(1756),
    [sym__numeric] = STATE(1756),
    [sym__literal] = STATE(1756),
    [sym_wildcard] = STATE(8374),
    [sym_variable] = STATE(1528),
    [sym_qualified_variable] = STATE(1528),
    [sym_constructor] = STATE(1706),
    [sym_qualified_constructor] = STATE(1789),
    [sym__qcon] = STATE(1902),
    [sym_literal] = STATE(278),
    [sym_record_literal] = STATE(1526),
    [sym__record_update_lhs] = STATE(9719),
    [sym_record_update] = STATE(278),
    [sym_exp_name] = STATE(278),
    [sym_exp_negation] = STATE(3028),
    [sym_exp_parens] = STATE(1526),
    [sym_exp_type_application] = STATE(278),
    [sym_exp_array] = STATE(278),
    [sym_exp_section_left] = STATE(278),
    [sym_exp_section_right] = STATE(278),
    [sym_record_accessor] = STATE(278),
    [sym_exp_record_access] = STATE(1790),
    [sym_exp_if] = STATE(3028),
    [sym_exp_case] = STATE(3028),
    [sym_exp_let_in] = STATE(3028),
    [sym_exp_lambda] = STATE(3028),
    [sym__do] = STATE(9720),
    [sym_exp_do] = STATE(278),
    [sym__ado] = STATE(9721),
    [sym_exp_ado] = STATE(278),
    [sym__do_or_ado_block] = STATE(278),
    [sym__aexp_projection] = STATE(278),
    [sym__aexp] = STATE(278),
    [sym__exp_apply] = STATE(5065),
    [sym__fexp] = STATE(3028),
    [sym__lexp] = STATE(3028),
    [sym_exp_infix] = STATE(3028),
    [sym__exp_infix] = STATE(3028),
    [sym__exp] = STATE(7206),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5540),
    [sym__varid] = ACTIONS(613),
    [sym_number] = ACTIONS(617),
    [sym_char] = ACTIONS(617),
    [sym_string] = ACTIONS(619),
    [sym_triple_quote_string] = ACTIONS(617),
    [sym__integer_literal] = ACTIONS(621),
    [sym__hex_literal] = ACTIONS(623),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(629),
    [sym__conid] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_let] = ACTIONS(644),
    [anon_sym_BSLASH] = ACTIONS(1405),
    [anon_sym_do] = ACTIONS(648),
    [anon_sym_ado] = ACTIONS(650),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [451] = {
    [sym_integer] = STATE(2097),
    [sym__numeric] = STATE(2097),
    [sym__literal] = STATE(2097),
    [sym_wildcard] = STATE(8070),
    [sym_variable] = STATE(1686),
    [sym_qualified_variable] = STATE(1686),
    [sym_constructor] = STATE(1767),
    [sym_qualified_constructor] = STATE(2092),
    [sym__qcon] = STATE(2091),
    [sym_literal] = STATE(280),
    [sym_record_literal] = STATE(1688),
    [sym__record_update_lhs] = STATE(9679),
    [sym_record_update] = STATE(280),
    [sym_exp_name] = STATE(280),
    [sym_exp_negation] = STATE(3051),
    [sym_exp_parens] = STATE(1688),
    [sym_exp_type_application] = STATE(280),
    [sym_exp_array] = STATE(280),
    [sym_exp_section_left] = STATE(280),
    [sym_exp_section_right] = STATE(280),
    [sym_record_accessor] = STATE(280),
    [sym_exp_record_access] = STATE(2204),
    [sym_exp_if] = STATE(3051),
    [sym_exp_case] = STATE(3051),
    [sym_exp_let_in] = STATE(3051),
    [sym_exp_lambda] = STATE(3051),
    [sym__do] = STATE(9680),
    [sym_exp_do] = STATE(280),
    [sym__ado] = STATE(9681),
    [sym_exp_ado] = STATE(280),
    [sym__do_or_ado_block] = STATE(280),
    [sym__aexp_projection] = STATE(280),
    [sym__aexp] = STATE(280),
    [sym__exp_apply] = STATE(5459),
    [sym__fexp] = STATE(3051),
    [sym__lexp] = STATE(3051),
    [sym_exp_infix] = STATE(3051),
    [sym__exp_infix] = STATE(3051),
    [sym__exp] = STATE(5426),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5664),
    [sym__varid] = ACTIONS(740),
    [sym_number] = ACTIONS(742),
    [sym_char] = ACTIONS(742),
    [sym_string] = ACTIONS(744),
    [sym_triple_quote_string] = ACTIONS(742),
    [sym__integer_literal] = ACTIONS(746),
    [sym__hex_literal] = ACTIONS(748),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(752),
    [sym__conid] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(764),
    [anon_sym_case] = ACTIONS(766),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_BSLASH] = ACTIONS(1371),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_ado] = ACTIONS(774),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [452] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(8037),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3687),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3687),
    [sym_exp_case] = STATE(3687),
    [sym_exp_let_in] = STATE(3687),
    [sym_exp_lambda] = STATE(3687),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3687),
    [sym__lexp] = STATE(3687),
    [sym_exp_infix] = STATE(3687),
    [sym__exp_infix] = STATE(3687),
    [sym__exp] = STATE(6119),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [453] = {
    [sym_integer] = STATE(2656),
    [sym__numeric] = STATE(2656),
    [sym__literal] = STATE(2656),
    [sym_wildcard] = STATE(8408),
    [sym_variable] = STATE(1968),
    [sym_qualified_variable] = STATE(1968),
    [sym_constructor] = STATE(2386),
    [sym_qualified_constructor] = STATE(2653),
    [sym__qcon] = STATE(2634),
    [sym_literal] = STATE(453),
    [sym_record_literal] = STATE(1967),
    [sym__record_update_lhs] = STATE(9623),
    [sym_record_update] = STATE(453),
    [sym_exp_name] = STATE(453),
    [sym_exp_parens] = STATE(1967),
    [sym_exp_type_application] = STATE(453),
    [sym_exp_array] = STATE(453),
    [sym_exp_section_left] = STATE(453),
    [sym_exp_section_right] = STATE(453),
    [sym_record_accessor] = STATE(453),
    [sym_exp_record_access] = STATE(2602),
    [sym_exp_if] = STATE(6295),
    [sym_exp_case] = STATE(6295),
    [sym_exp_let_in] = STATE(6295),
    [sym_exp_lambda] = STATE(6295),
    [sym__do] = STATE(9624),
    [sym_exp_do] = STATE(453),
    [sym__ado] = STATE(9625),
    [sym_exp_ado] = STATE(453),
    [sym__do_or_ado_block] = STATE(453),
    [sym__aexp_projection] = STATE(453),
    [sym__aexp] = STATE(453),
    [sym__exp_apply] = STATE(6295),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5551),
    [sym__varid] = ACTIONS(1325),
    [sym_number] = ACTIONS(1327),
    [sym_char] = ACTIONS(1327),
    [sym_string] = ACTIONS(1329),
    [sym_triple_quote_string] = ACTIONS(1327),
    [sym__integer_literal] = ACTIONS(1331),
    [sym__hex_literal] = ACTIONS(1333),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1337),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [sym__conid] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_EQ] = ACTIONS(625),
    [anon_sym_AT] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_BSLASH] = ACTIONS(1416),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_ado] = ACTIONS(1361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(615),
  },
  [454] = {
    [sym_integer] = STATE(1926),
    [sym__numeric] = STATE(1926),
    [sym__literal] = STATE(1926),
    [sym_wildcard] = STATE(4599),
    [sym_variable] = STATE(1532),
    [sym_qualified_variable] = STATE(1532),
    [sym_constructor] = STATE(1631),
    [sym_qualified_constructor] = STATE(1923),
    [sym__qcon] = STATE(1882),
    [sym_literal] = STATE(276),
    [sym_record_literal] = STATE(1538),
    [sym__record_update_lhs] = STATE(9501),
    [sym_record_update] = STATE(276),
    [sym_exp_name] = STATE(276),
    [sym_exp_negation] = STATE(3041),
    [sym_exp_parens] = STATE(1538),
    [sym_exp_type_application] = STATE(276),
    [sym_exp_array] = STATE(276),
    [sym_exp_section_left] = STATE(276),
    [sym_exp_section_right] = STATE(276),
    [sym_record_accessor] = STATE(276),
    [sym_exp_record_access] = STATE(1940),
    [sym_exp_if] = STATE(3041),
    [sym_exp_case] = STATE(3041),
    [sym_exp_let_in] = STATE(3041),
    [sym_exp_lambda] = STATE(3041),
    [sym__do] = STATE(9502),
    [sym_exp_do] = STATE(276),
    [sym__ado] = STATE(9503),
    [sym_exp_ado] = STATE(276),
    [sym__do_or_ado_block] = STATE(276),
    [sym__aexp_projection] = STATE(276),
    [sym__aexp] = STATE(276),
    [sym__exp_apply] = STATE(5237),
    [sym__fexp] = STATE(3041),
    [sym__lexp] = STATE(3041),
    [sym_exp_infix] = STATE(3041),
    [sym__exp_infix] = STATE(3041),
    [sym__exp] = STATE(5262),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5526),
    [sym__varid] = ACTIONS(690),
    [sym_number] = ACTIONS(692),
    [sym_char] = ACTIONS(692),
    [sym_string] = ACTIONS(694),
    [sym_triple_quote_string] = ACTIONS(692),
    [sym__integer_literal] = ACTIONS(696),
    [sym__hex_literal] = ACTIONS(698),
    [anon_sym__] = ACTIONS(1418),
    [sym_hole] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym__conid] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_AT] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_let] = ACTIONS(721),
    [anon_sym_BSLASH] = ACTIONS(1426),
    [anon_sym_do] = ACTIONS(725),
    [anon_sym_ado] = ACTIONS(727),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [455] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7672),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9621),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [456] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7659),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9663),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [457] = {
    [sym_integer] = STATE(2097),
    [sym__numeric] = STATE(2097),
    [sym__literal] = STATE(2097),
    [sym_wildcard] = STATE(8070),
    [sym_variable] = STATE(1686),
    [sym_qualified_variable] = STATE(1686),
    [sym_constructor] = STATE(1767),
    [sym_qualified_constructor] = STATE(2092),
    [sym__qcon] = STATE(2091),
    [sym_literal] = STATE(280),
    [sym_record_literal] = STATE(1688),
    [sym__record_update_lhs] = STATE(9679),
    [sym_record_update] = STATE(280),
    [sym_exp_name] = STATE(280),
    [sym_exp_negation] = STATE(3051),
    [sym_exp_parens] = STATE(1688),
    [sym_exp_type_application] = STATE(280),
    [sym_exp_array] = STATE(280),
    [sym_exp_section_left] = STATE(280),
    [sym_exp_section_right] = STATE(280),
    [sym_record_accessor] = STATE(280),
    [sym_exp_record_access] = STATE(2204),
    [sym_exp_if] = STATE(3051),
    [sym_exp_case] = STATE(3051),
    [sym_exp_let_in] = STATE(3051),
    [sym_exp_lambda] = STATE(3051),
    [sym__do] = STATE(9680),
    [sym_exp_do] = STATE(280),
    [sym__ado] = STATE(9681),
    [sym_exp_ado] = STATE(280),
    [sym__do_or_ado_block] = STATE(280),
    [sym__aexp_projection] = STATE(280),
    [sym__aexp] = STATE(280),
    [sym__exp_apply] = STATE(5459),
    [sym__fexp] = STATE(3051),
    [sym__lexp] = STATE(3051),
    [sym_exp_infix] = STATE(3051),
    [sym__exp_infix] = STATE(3051),
    [sym__exp] = STATE(5427),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5664),
    [sym__varid] = ACTIONS(740),
    [sym_number] = ACTIONS(742),
    [sym_char] = ACTIONS(742),
    [sym_string] = ACTIONS(744),
    [sym_triple_quote_string] = ACTIONS(742),
    [sym__integer_literal] = ACTIONS(746),
    [sym__hex_literal] = ACTIONS(748),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(752),
    [sym__conid] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(764),
    [anon_sym_case] = ACTIONS(766),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_BSLASH] = ACTIONS(1371),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_ado] = ACTIONS(774),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [458] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7917),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10118),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [459] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7930),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9366),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [460] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7909),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10116),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [461] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3230),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3230),
    [sym_exp_case] = STATE(3230),
    [sym_exp_let_in] = STATE(3230),
    [sym_exp_lambda] = STATE(3230),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3230),
    [sym__lexp] = STATE(3230),
    [sym_exp_infix] = STATE(3230),
    [sym__exp_infix] = STATE(3230),
    [sym__exp] = STATE(5584),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [462] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7751),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9530),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [463] = {
    [sym_integer] = STATE(2215),
    [sym__numeric] = STATE(2215),
    [sym__literal] = STATE(2215),
    [sym_wildcard] = STATE(4736),
    [sym_variable] = STATE(1700),
    [sym_qualified_variable] = STATE(1700),
    [sym_constructor] = STATE(1822),
    [sym_qualified_constructor] = STATE(2216),
    [sym__qcon] = STATE(2038),
    [sym_literal] = STATE(281),
    [sym_record_literal] = STATE(1702),
    [sym__record_update_lhs] = STATE(9341),
    [sym_record_update] = STATE(281),
    [sym_exp_name] = STATE(281),
    [sym_exp_negation] = STATE(3049),
    [sym_exp_parens] = STATE(1702),
    [sym_exp_type_application] = STATE(281),
    [sym_exp_array] = STATE(281),
    [sym_exp_section_left] = STATE(281),
    [sym_exp_section_right] = STATE(281),
    [sym_record_accessor] = STATE(281),
    [sym_exp_record_access] = STATE(2165),
    [sym_exp_if] = STATE(3049),
    [sym_exp_case] = STATE(3049),
    [sym_exp_let_in] = STATE(3049),
    [sym_exp_lambda] = STATE(3049),
    [sym__do] = STATE(9342),
    [sym_exp_do] = STATE(281),
    [sym__ado] = STATE(9343),
    [sym_exp_ado] = STATE(281),
    [sym__do_or_ado_block] = STATE(281),
    [sym__aexp_projection] = STATE(281),
    [sym__aexp] = STATE(281),
    [sym__exp_apply] = STATE(5620),
    [sym__fexp] = STATE(3049),
    [sym__lexp] = STATE(3049),
    [sym_exp_infix] = STATE(3049),
    [sym__exp_infix] = STATE(3049),
    [sym__exp] = STATE(5490),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5676),
    [sym__varid] = ACTIONS(776),
    [sym_number] = ACTIONS(778),
    [sym_char] = ACTIONS(778),
    [sym_string] = ACTIONS(780),
    [sym_triple_quote_string] = ACTIONS(778),
    [sym__integer_literal] = ACTIONS(782),
    [sym__hex_literal] = ACTIONS(784),
    [anon_sym__] = ACTIONS(1428),
    [sym_hole] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(788),
    [sym__conid] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(800),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_let] = ACTIONS(804),
    [anon_sym_BSLASH] = ACTIONS(1389),
    [anon_sym_do] = ACTIONS(808),
    [anon_sym_ado] = ACTIONS(810),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [464] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(5632),
    [sym_variable] = STATE(2646),
    [sym_qualified_variable] = STATE(2646),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(595),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(595),
    [sym_exp_name] = STATE(595),
    [sym_exp_negation] = STATE(3805),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(595),
    [sym_exp_array] = STATE(595),
    [sym_exp_section_left] = STATE(595),
    [sym_exp_section_right] = STATE(595),
    [sym_record_accessor] = STATE(595),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3805),
    [sym_exp_case] = STATE(3805),
    [sym_exp_let_in] = STATE(3805),
    [sym_exp_lambda] = STATE(3805),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(595),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(595),
    [sym__do_or_ado_block] = STATE(595),
    [sym__aexp_projection] = STATE(595),
    [sym__aexp] = STATE(595),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3805),
    [sym__lexp] = STATE(3805),
    [sym_exp_infix] = STATE(3805),
    [sym__exp_infix] = STATE(3805),
    [sym__exp] = STATE(6205),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_BSLASH] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [465] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7908),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10114),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [466] = {
    [sym_integer] = STATE(2215),
    [sym__numeric] = STATE(2215),
    [sym__literal] = STATE(2215),
    [sym_wildcard] = STATE(8285),
    [sym_variable] = STATE(1700),
    [sym_qualified_variable] = STATE(1700),
    [sym_constructor] = STATE(1822),
    [sym_qualified_constructor] = STATE(2216),
    [sym__qcon] = STATE(2038),
    [sym_literal] = STATE(281),
    [sym_record_literal] = STATE(1702),
    [sym__record_update_lhs] = STATE(9341),
    [sym_record_update] = STATE(281),
    [sym_exp_name] = STATE(281),
    [sym_exp_negation] = STATE(3049),
    [sym_exp_parens] = STATE(1702),
    [sym_exp_type_application] = STATE(281),
    [sym_exp_array] = STATE(281),
    [sym_exp_section_left] = STATE(281),
    [sym_exp_section_right] = STATE(281),
    [sym_record_accessor] = STATE(281),
    [sym_exp_record_access] = STATE(2165),
    [sym_exp_if] = STATE(3049),
    [sym_exp_case] = STATE(3049),
    [sym_exp_let_in] = STATE(3049),
    [sym_exp_lambda] = STATE(3049),
    [sym__do] = STATE(9342),
    [sym_exp_do] = STATE(281),
    [sym__ado] = STATE(9343),
    [sym_exp_ado] = STATE(281),
    [sym__do_or_ado_block] = STATE(281),
    [sym__aexp_projection] = STATE(281),
    [sym__aexp] = STATE(281),
    [sym__exp_apply] = STATE(5620),
    [sym__fexp] = STATE(3049),
    [sym__lexp] = STATE(3049),
    [sym_exp_infix] = STATE(3049),
    [sym__exp_infix] = STATE(3049),
    [sym__exp] = STATE(5680),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5676),
    [sym__varid] = ACTIONS(776),
    [sym_number] = ACTIONS(778),
    [sym_char] = ACTIONS(778),
    [sym_string] = ACTIONS(780),
    [sym_triple_quote_string] = ACTIONS(778),
    [sym__integer_literal] = ACTIONS(782),
    [sym__hex_literal] = ACTIONS(784),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(788),
    [sym__conid] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(800),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_let] = ACTIONS(804),
    [anon_sym_BSLASH] = ACTIONS(1389),
    [anon_sym_do] = ACTIONS(808),
    [anon_sym_ado] = ACTIONS(810),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [467] = {
    [sym_integer] = STATE(1926),
    [sym__numeric] = STATE(1926),
    [sym__literal] = STATE(1926),
    [sym_wildcard] = STATE(8330),
    [sym_variable] = STATE(1532),
    [sym_qualified_variable] = STATE(1532),
    [sym_constructor] = STATE(1631),
    [sym_qualified_constructor] = STATE(1923),
    [sym__qcon] = STATE(1882),
    [sym_literal] = STATE(276),
    [sym_record_literal] = STATE(1538),
    [sym__record_update_lhs] = STATE(9501),
    [sym_record_update] = STATE(276),
    [sym_exp_name] = STATE(276),
    [sym_exp_negation] = STATE(3027),
    [sym_exp_parens] = STATE(1538),
    [sym_exp_type_application] = STATE(276),
    [sym_exp_array] = STATE(276),
    [sym_exp_section_left] = STATE(276),
    [sym_exp_section_right] = STATE(276),
    [sym_record_accessor] = STATE(276),
    [sym_exp_record_access] = STATE(1940),
    [sym_exp_if] = STATE(3027),
    [sym_exp_case] = STATE(3027),
    [sym_exp_let_in] = STATE(3027),
    [sym_exp_lambda] = STATE(3027),
    [sym__do] = STATE(9502),
    [sym_exp_do] = STATE(276),
    [sym__ado] = STATE(9503),
    [sym_exp_ado] = STATE(276),
    [sym__do_or_ado_block] = STATE(276),
    [sym__aexp_projection] = STATE(276),
    [sym__aexp] = STATE(276),
    [sym__exp_apply] = STATE(5237),
    [sym__fexp] = STATE(3027),
    [sym__lexp] = STATE(3027),
    [sym_exp_infix] = STATE(3027),
    [sym__exp_infix] = STATE(3027),
    [sym__exp] = STATE(7511),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5526),
    [sym__varid] = ACTIONS(690),
    [sym_number] = ACTIONS(692),
    [sym_char] = ACTIONS(692),
    [sym_string] = ACTIONS(694),
    [sym_triple_quote_string] = ACTIONS(692),
    [sym__integer_literal] = ACTIONS(696),
    [sym__hex_literal] = ACTIONS(698),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym__conid] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_AT] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_let] = ACTIONS(721),
    [anon_sym_BSLASH] = ACTIONS(1426),
    [anon_sym_do] = ACTIONS(725),
    [anon_sym_ado] = ACTIONS(727),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [468] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8547),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [469] = {
    [sym_integer] = STATE(1852),
    [sym__numeric] = STATE(1852),
    [sym__literal] = STATE(1852),
    [sym_wildcard] = STATE(8255),
    [sym_variable] = STATE(1603),
    [sym_qualified_variable] = STATE(1603),
    [sym_constructor] = STATE(1670),
    [sym_qualified_constructor] = STATE(1863),
    [sym__qcon] = STATE(1786),
    [sym_literal] = STATE(277),
    [sym_record_literal] = STATE(1604),
    [sym__record_update_lhs] = STATE(9739),
    [sym_record_update] = STATE(277),
    [sym_exp_name] = STATE(277),
    [sym_exp_negation] = STATE(3038),
    [sym_exp_parens] = STATE(1604),
    [sym_exp_type_application] = STATE(277),
    [sym_exp_array] = STATE(277),
    [sym_exp_section_left] = STATE(277),
    [sym_exp_section_right] = STATE(277),
    [sym_record_accessor] = STATE(277),
    [sym_exp_record_access] = STATE(1929),
    [sym_exp_if] = STATE(3038),
    [sym_exp_case] = STATE(3038),
    [sym_exp_let_in] = STATE(3038),
    [sym_exp_lambda] = STATE(3038),
    [sym__do] = STATE(9740),
    [sym_exp_do] = STATE(277),
    [sym__ado] = STATE(9741),
    [sym_exp_ado] = STATE(277),
    [sym__do_or_ado_block] = STATE(277),
    [sym__aexp_projection] = STATE(277),
    [sym__aexp] = STATE(277),
    [sym__exp_apply] = STATE(5174),
    [sym__fexp] = STATE(3038),
    [sym__lexp] = STATE(3038),
    [sym_exp_infix] = STATE(3038),
    [sym__exp_infix] = STATE(3038),
    [sym__exp] = STATE(5210),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5673),
    [sym__varid] = ACTIONS(652),
    [sym_number] = ACTIONS(654),
    [sym_char] = ACTIONS(654),
    [sym_string] = ACTIONS(656),
    [sym_triple_quote_string] = ACTIONS(654),
    [sym__integer_literal] = ACTIONS(658),
    [sym__hex_literal] = ACTIONS(660),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(664),
    [sym__conid] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_case] = ACTIONS(677),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_BSLASH] = ACTIONS(1436),
    [anon_sym_do] = ACTIONS(683),
    [anon_sym_ado] = ACTIONS(685),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [470] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(8037),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3690),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3690),
    [sym_exp_case] = STATE(3690),
    [sym_exp_let_in] = STATE(3690),
    [sym_exp_lambda] = STATE(3690),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3690),
    [sym__lexp] = STATE(3690),
    [sym_exp_infix] = STATE(3690),
    [sym__exp_infix] = STATE(3690),
    [sym__exp] = STATE(7216),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [471] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7635),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9677),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [472] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7852),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10112),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [473] = {
    [sym_integer] = STATE(2282),
    [sym__numeric] = STATE(2282),
    [sym__literal] = STATE(2282),
    [sym_wildcard] = STATE(5027),
    [sym_variable] = STATE(1835),
    [sym_qualified_variable] = STATE(1835),
    [sym_constructor] = STATE(1970),
    [sym_qualified_constructor] = STATE(2291),
    [sym__qcon] = STATE(2407),
    [sym_literal] = STATE(332),
    [sym_record_literal] = STATE(1837),
    [sym__record_update_lhs] = STATE(9787),
    [sym_record_update] = STATE(332),
    [sym_exp_name] = STATE(332),
    [sym_exp_negation] = STATE(3263),
    [sym_exp_parens] = STATE(1837),
    [sym_exp_type_application] = STATE(332),
    [sym_exp_array] = STATE(332),
    [sym_exp_section_left] = STATE(332),
    [sym_exp_section_right] = STATE(332),
    [sym_record_accessor] = STATE(332),
    [sym_exp_record_access] = STATE(2249),
    [sym_exp_if] = STATE(3263),
    [sym_exp_case] = STATE(3263),
    [sym_exp_let_in] = STATE(3263),
    [sym_exp_lambda] = STATE(3263),
    [sym__do] = STATE(9788),
    [sym_exp_do] = STATE(332),
    [sym__ado] = STATE(9789),
    [sym_exp_ado] = STATE(332),
    [sym__do_or_ado_block] = STATE(332),
    [sym__aexp_projection] = STATE(332),
    [sym__aexp] = STATE(332),
    [sym__exp_apply] = STATE(6145),
    [sym__fexp] = STATE(3263),
    [sym__lexp] = STATE(3263),
    [sym_exp_infix] = STATE(3263),
    [sym__exp_infix] = STATE(3263),
    [sym__exp] = STATE(6189),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5607),
    [sym__varid] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_char] = ACTIONS(933),
    [sym_string] = ACTIONS(935),
    [sym_triple_quote_string] = ACTIONS(933),
    [sym__integer_literal] = ACTIONS(937),
    [sym__hex_literal] = ACTIONS(939),
    [anon_sym__] = ACTIONS(1438),
    [sym_hole] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(943),
    [sym__conid] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_ado] = ACTIONS(964),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [474] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7903),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10110),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [475] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7722),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9592),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [476] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7902),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10108),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [477] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(4988),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3230),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3230),
    [sym_exp_case] = STATE(3230),
    [sym_exp_let_in] = STATE(3230),
    [sym_exp_lambda] = STATE(3230),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3230),
    [sym__lexp] = STATE(3230),
    [sym_exp_infix] = STATE(3230),
    [sym__exp_infix] = STATE(3230),
    [sym__exp] = STATE(5580),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(1440),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [478] = {
    [sym_integer] = STATE(1852),
    [sym__numeric] = STATE(1852),
    [sym__literal] = STATE(1852),
    [sym_wildcard] = STATE(8255),
    [sym_variable] = STATE(1603),
    [sym_qualified_variable] = STATE(1603),
    [sym_constructor] = STATE(1670),
    [sym_qualified_constructor] = STATE(1863),
    [sym__qcon] = STATE(1786),
    [sym_literal] = STATE(277),
    [sym_record_literal] = STATE(1604),
    [sym__record_update_lhs] = STATE(9739),
    [sym_record_update] = STATE(277),
    [sym_exp_name] = STATE(277),
    [sym_exp_negation] = STATE(3038),
    [sym_exp_parens] = STATE(1604),
    [sym_exp_type_application] = STATE(277),
    [sym_exp_array] = STATE(277),
    [sym_exp_section_left] = STATE(277),
    [sym_exp_section_right] = STATE(277),
    [sym_record_accessor] = STATE(277),
    [sym_exp_record_access] = STATE(1929),
    [sym_exp_if] = STATE(3038),
    [sym_exp_case] = STATE(3038),
    [sym_exp_let_in] = STATE(3038),
    [sym_exp_lambda] = STATE(3038),
    [sym__do] = STATE(9740),
    [sym_exp_do] = STATE(277),
    [sym__ado] = STATE(9741),
    [sym_exp_ado] = STATE(277),
    [sym__do_or_ado_block] = STATE(277),
    [sym__aexp_projection] = STATE(277),
    [sym__aexp] = STATE(277),
    [sym__exp_apply] = STATE(5174),
    [sym__fexp] = STATE(3038),
    [sym__lexp] = STATE(3038),
    [sym_exp_infix] = STATE(3038),
    [sym__exp_infix] = STATE(3038),
    [sym__exp] = STATE(5211),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5673),
    [sym__varid] = ACTIONS(652),
    [sym_number] = ACTIONS(654),
    [sym_char] = ACTIONS(654),
    [sym_string] = ACTIONS(656),
    [sym_triple_quote_string] = ACTIONS(654),
    [sym__integer_literal] = ACTIONS(658),
    [sym__hex_literal] = ACTIONS(660),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(664),
    [sym__conid] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_case] = ACTIONS(677),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_BSLASH] = ACTIONS(1436),
    [anon_sym_do] = ACTIONS(683),
    [anon_sym_ado] = ACTIONS(685),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [479] = {
    [sym_integer] = STATE(2656),
    [sym__numeric] = STATE(2656),
    [sym__literal] = STATE(2656),
    [sym_wildcard] = STATE(8408),
    [sym_variable] = STATE(1968),
    [sym_qualified_variable] = STATE(1968),
    [sym_constructor] = STATE(2386),
    [sym_qualified_constructor] = STATE(2653),
    [sym__qcon] = STATE(2634),
    [sym_literal] = STATE(516),
    [sym_record_literal] = STATE(1967),
    [sym__record_update_lhs] = STATE(9623),
    [sym_record_update] = STATE(516),
    [sym_exp_name] = STATE(516),
    [sym_exp_negation] = STATE(3301),
    [sym_exp_parens] = STATE(1967),
    [sym_exp_type_application] = STATE(516),
    [sym_exp_array] = STATE(516),
    [sym_exp_section_left] = STATE(516),
    [sym_exp_section_right] = STATE(516),
    [sym_record_accessor] = STATE(516),
    [sym_exp_record_access] = STATE(2602),
    [sym_exp_if] = STATE(3301),
    [sym_exp_case] = STATE(3301),
    [sym_exp_let_in] = STATE(3301),
    [sym_exp_lambda] = STATE(3301),
    [sym__do] = STATE(9624),
    [sym_exp_do] = STATE(516),
    [sym__ado] = STATE(9625),
    [sym_exp_ado] = STATE(516),
    [sym__do_or_ado_block] = STATE(516),
    [sym__aexp_projection] = STATE(516),
    [sym__aexp] = STATE(516),
    [sym__exp_apply] = STATE(6282),
    [sym__fexp] = STATE(3301),
    [sym__lexp] = STATE(3301),
    [sym_exp_infix] = STATE(3301),
    [sym__exp_infix] = STATE(3301),
    [sym__exp] = STATE(6225),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5551),
    [sym__varid] = ACTIONS(1325),
    [sym_number] = ACTIONS(1327),
    [sym_char] = ACTIONS(1327),
    [sym_string] = ACTIONS(1329),
    [sym_triple_quote_string] = ACTIONS(1327),
    [sym__integer_literal] = ACTIONS(1331),
    [sym__hex_literal] = ACTIONS(1333),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [sym__conid] = ACTIONS(1343),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_BSLASH] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_ado] = ACTIONS(1361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [480] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(7203),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8632),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [481] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7858),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9429),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [482] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7900),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10106),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [483] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7899),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10104),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [484] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7891),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10102),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [485] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7886),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10100),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [486] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(6297),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3690),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3690),
    [sym_exp_case] = STATE(3690),
    [sym_exp_let_in] = STATE(3690),
    [sym_exp_lambda] = STATE(3690),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3690),
    [sym__lexp] = STATE(3690),
    [sym_exp_infix] = STATE(3690),
    [sym__exp_infix] = STATE(3690),
    [sym__exp] = STATE(7199),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [487] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7883),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10098),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [488] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(5647),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3677),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3677),
    [sym_exp_case] = STATE(3677),
    [sym_exp_let_in] = STATE(3677),
    [sym_exp_lambda] = STATE(3677),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3677),
    [sym__lexp] = STATE(3677),
    [sym_exp_infix] = STATE(3677),
    [sym__exp_infix] = STATE(3677),
    [sym__exp] = STATE(6205),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [489] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(5632),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3687),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3687),
    [sym_exp_case] = STATE(3687),
    [sym_exp_let_in] = STATE(3687),
    [sym_exp_lambda] = STATE(3687),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3687),
    [sym__lexp] = STATE(3687),
    [sym_exp_infix] = STATE(3687),
    [sym__exp_infix] = STATE(3687),
    [sym__exp] = STATE(6205),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [490] = {
    [sym_integer] = STATE(1756),
    [sym__numeric] = STATE(1756),
    [sym__literal] = STATE(1756),
    [sym_wildcard] = STATE(4514),
    [sym_variable] = STATE(1528),
    [sym_qualified_variable] = STATE(1528),
    [sym_constructor] = STATE(1706),
    [sym_qualified_constructor] = STATE(1789),
    [sym__qcon] = STATE(1902),
    [sym_literal] = STATE(278),
    [sym_record_literal] = STATE(1526),
    [sym__record_update_lhs] = STATE(9719),
    [sym_record_update] = STATE(278),
    [sym_exp_name] = STATE(278),
    [sym_exp_negation] = STATE(3035),
    [sym_exp_parens] = STATE(1526),
    [sym_exp_type_application] = STATE(278),
    [sym_exp_array] = STATE(278),
    [sym_exp_section_left] = STATE(278),
    [sym_exp_section_right] = STATE(278),
    [sym_record_accessor] = STATE(278),
    [sym_exp_record_access] = STATE(1790),
    [sym_exp_if] = STATE(3035),
    [sym_exp_case] = STATE(3035),
    [sym_exp_let_in] = STATE(3035),
    [sym_exp_lambda] = STATE(3035),
    [sym__do] = STATE(9720),
    [sym_exp_do] = STATE(278),
    [sym__ado] = STATE(9721),
    [sym_exp_ado] = STATE(278),
    [sym__do_or_ado_block] = STATE(278),
    [sym__aexp_projection] = STATE(278),
    [sym__aexp] = STATE(278),
    [sym__exp_apply] = STATE(5065),
    [sym__fexp] = STATE(3035),
    [sym__lexp] = STATE(3035),
    [sym_exp_infix] = STATE(3035),
    [sym__exp_infix] = STATE(3035),
    [sym__exp] = STATE(5133),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5540),
    [sym__varid] = ACTIONS(613),
    [sym_number] = ACTIONS(617),
    [sym_char] = ACTIONS(617),
    [sym_string] = ACTIONS(619),
    [sym_triple_quote_string] = ACTIONS(617),
    [sym__integer_literal] = ACTIONS(621),
    [sym__hex_literal] = ACTIONS(623),
    [anon_sym__] = ACTIONS(1442),
    [sym_hole] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(629),
    [sym__conid] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_let] = ACTIONS(644),
    [anon_sym_BSLASH] = ACTIONS(1405),
    [anon_sym_do] = ACTIONS(648),
    [anon_sym_ado] = ACTIONS(650),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [491] = {
    [sym_integer] = STATE(1926),
    [sym__numeric] = STATE(1926),
    [sym__literal] = STATE(1926),
    [sym_wildcard] = STATE(8330),
    [sym_variable] = STATE(1532),
    [sym_qualified_variable] = STATE(1532),
    [sym_constructor] = STATE(1631),
    [sym_qualified_constructor] = STATE(1923),
    [sym__qcon] = STATE(1882),
    [sym_literal] = STATE(276),
    [sym_record_literal] = STATE(1538),
    [sym__record_update_lhs] = STATE(9501),
    [sym_record_update] = STATE(276),
    [sym_exp_name] = STATE(276),
    [sym_exp_negation] = STATE(3041),
    [sym_exp_parens] = STATE(1538),
    [sym_exp_type_application] = STATE(276),
    [sym_exp_array] = STATE(276),
    [sym_exp_section_left] = STATE(276),
    [sym_exp_section_right] = STATE(276),
    [sym_record_accessor] = STATE(276),
    [sym_exp_record_access] = STATE(1940),
    [sym_exp_if] = STATE(3041),
    [sym_exp_case] = STATE(3041),
    [sym_exp_let_in] = STATE(3041),
    [sym_exp_lambda] = STATE(3041),
    [sym__do] = STATE(9502),
    [sym_exp_do] = STATE(276),
    [sym__ado] = STATE(9503),
    [sym_exp_ado] = STATE(276),
    [sym__do_or_ado_block] = STATE(276),
    [sym__aexp_projection] = STATE(276),
    [sym__aexp] = STATE(276),
    [sym__exp_apply] = STATE(5237),
    [sym__fexp] = STATE(3041),
    [sym__lexp] = STATE(3041),
    [sym_exp_infix] = STATE(3041),
    [sym__exp_infix] = STATE(3041),
    [sym__exp] = STATE(5299),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5526),
    [sym__varid] = ACTIONS(690),
    [sym_number] = ACTIONS(692),
    [sym_char] = ACTIONS(692),
    [sym_string] = ACTIONS(694),
    [sym_triple_quote_string] = ACTIONS(692),
    [sym__integer_literal] = ACTIONS(696),
    [sym__hex_literal] = ACTIONS(698),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym__conid] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_AT] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_let] = ACTIONS(721),
    [anon_sym_BSLASH] = ACTIONS(1426),
    [anon_sym_do] = ACTIONS(725),
    [anon_sym_ado] = ACTIONS(727),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [492] = {
    [sym_integer] = STATE(1926),
    [sym__numeric] = STATE(1926),
    [sym__literal] = STATE(1926),
    [sym_wildcard] = STATE(8330),
    [sym_variable] = STATE(1532),
    [sym_qualified_variable] = STATE(1532),
    [sym_constructor] = STATE(1631),
    [sym_qualified_constructor] = STATE(1923),
    [sym__qcon] = STATE(1882),
    [sym_literal] = STATE(276),
    [sym_record_literal] = STATE(1538),
    [sym__record_update_lhs] = STATE(9501),
    [sym_record_update] = STATE(276),
    [sym_exp_name] = STATE(276),
    [sym_exp_negation] = STATE(3041),
    [sym_exp_parens] = STATE(1538),
    [sym_exp_type_application] = STATE(276),
    [sym_exp_array] = STATE(276),
    [sym_exp_section_left] = STATE(276),
    [sym_exp_section_right] = STATE(276),
    [sym_record_accessor] = STATE(276),
    [sym_exp_record_access] = STATE(1940),
    [sym_exp_if] = STATE(3041),
    [sym_exp_case] = STATE(3041),
    [sym_exp_let_in] = STATE(3041),
    [sym_exp_lambda] = STATE(3041),
    [sym__do] = STATE(9502),
    [sym_exp_do] = STATE(276),
    [sym__ado] = STATE(9503),
    [sym_exp_ado] = STATE(276),
    [sym__do_or_ado_block] = STATE(276),
    [sym__aexp_projection] = STATE(276),
    [sym__aexp] = STATE(276),
    [sym__exp_apply] = STATE(5237),
    [sym__fexp] = STATE(3041),
    [sym__lexp] = STATE(3041),
    [sym_exp_infix] = STATE(3041),
    [sym__exp_infix] = STATE(3041),
    [sym__exp] = STATE(5246),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5526),
    [sym__varid] = ACTIONS(690),
    [sym_number] = ACTIONS(692),
    [sym_char] = ACTIONS(692),
    [sym_string] = ACTIONS(694),
    [sym_triple_quote_string] = ACTIONS(692),
    [sym__integer_literal] = ACTIONS(696),
    [sym__hex_literal] = ACTIONS(698),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(703),
    [anon_sym_DASH] = ACTIONS(1420),
    [anon_sym_LPAREN] = ACTIONS(705),
    [sym__conid] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_AT] = ACTIONS(1424),
    [anon_sym_LBRACK] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(719),
    [anon_sym_let] = ACTIONS(721),
    [anon_sym_BSLASH] = ACTIONS(1426),
    [anon_sym_do] = ACTIONS(725),
    [anon_sym_ado] = ACTIONS(727),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [493] = {
    [sym_integer] = STATE(1852),
    [sym__numeric] = STATE(1852),
    [sym__literal] = STATE(1852),
    [sym_wildcard] = STATE(4640),
    [sym_variable] = STATE(1603),
    [sym_qualified_variable] = STATE(1603),
    [sym_constructor] = STATE(1670),
    [sym_qualified_constructor] = STATE(1863),
    [sym__qcon] = STATE(1786),
    [sym_literal] = STATE(277),
    [sym_record_literal] = STATE(1604),
    [sym__record_update_lhs] = STATE(9739),
    [sym_record_update] = STATE(277),
    [sym_exp_name] = STATE(277),
    [sym_exp_negation] = STATE(3038),
    [sym_exp_parens] = STATE(1604),
    [sym_exp_type_application] = STATE(277),
    [sym_exp_array] = STATE(277),
    [sym_exp_section_left] = STATE(277),
    [sym_exp_section_right] = STATE(277),
    [sym_record_accessor] = STATE(277),
    [sym_exp_record_access] = STATE(1929),
    [sym_exp_if] = STATE(3038),
    [sym_exp_case] = STATE(3038),
    [sym_exp_let_in] = STATE(3038),
    [sym_exp_lambda] = STATE(3038),
    [sym__do] = STATE(9740),
    [sym_exp_do] = STATE(277),
    [sym__ado] = STATE(9741),
    [sym_exp_ado] = STATE(277),
    [sym__do_or_ado_block] = STATE(277),
    [sym__aexp_projection] = STATE(277),
    [sym__aexp] = STATE(277),
    [sym__exp_apply] = STATE(5174),
    [sym__fexp] = STATE(3038),
    [sym__lexp] = STATE(3038),
    [sym_exp_infix] = STATE(3038),
    [sym__exp_infix] = STATE(3038),
    [sym__exp] = STATE(5225),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5673),
    [sym__varid] = ACTIONS(652),
    [sym_number] = ACTIONS(654),
    [sym_char] = ACTIONS(654),
    [sym_string] = ACTIONS(656),
    [sym_triple_quote_string] = ACTIONS(654),
    [sym__integer_literal] = ACTIONS(658),
    [sym__hex_literal] = ACTIONS(660),
    [anon_sym__] = ACTIONS(1444),
    [sym_hole] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(664),
    [sym__conid] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_case] = ACTIONS(677),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_BSLASH] = ACTIONS(1436),
    [anon_sym_do] = ACTIONS(683),
    [anon_sym_ado] = ACTIONS(685),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [494] = {
    [sym_integer] = STATE(2215),
    [sym__numeric] = STATE(2215),
    [sym__literal] = STATE(2215),
    [sym_wildcard] = STATE(8285),
    [sym_variable] = STATE(1700),
    [sym_qualified_variable] = STATE(1700),
    [sym_constructor] = STATE(1822),
    [sym_qualified_constructor] = STATE(2216),
    [sym__qcon] = STATE(2038),
    [sym_literal] = STATE(281),
    [sym_record_literal] = STATE(1702),
    [sym__record_update_lhs] = STATE(9341),
    [sym_record_update] = STATE(281),
    [sym_exp_name] = STATE(281),
    [sym_exp_negation] = STATE(3085),
    [sym_exp_parens] = STATE(1702),
    [sym_exp_type_application] = STATE(281),
    [sym_exp_array] = STATE(281),
    [sym_exp_section_left] = STATE(281),
    [sym_exp_section_right] = STATE(281),
    [sym_record_accessor] = STATE(281),
    [sym_exp_record_access] = STATE(2165),
    [sym_exp_if] = STATE(3085),
    [sym_exp_case] = STATE(3085),
    [sym_exp_let_in] = STATE(3085),
    [sym_exp_lambda] = STATE(3085),
    [sym__do] = STATE(9342),
    [sym_exp_do] = STATE(281),
    [sym__ado] = STATE(9343),
    [sym_exp_ado] = STATE(281),
    [sym__do_or_ado_block] = STATE(281),
    [sym__aexp_projection] = STATE(281),
    [sym__aexp] = STATE(281),
    [sym__exp_apply] = STATE(5620),
    [sym__fexp] = STATE(3085),
    [sym__lexp] = STATE(3085),
    [sym_exp_infix] = STATE(3085),
    [sym__exp_infix] = STATE(3085),
    [sym__exp] = STATE(7678),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5676),
    [sym__varid] = ACTIONS(776),
    [sym_number] = ACTIONS(778),
    [sym_char] = ACTIONS(778),
    [sym_string] = ACTIONS(780),
    [sym_triple_quote_string] = ACTIONS(778),
    [sym__integer_literal] = ACTIONS(782),
    [sym__hex_literal] = ACTIONS(784),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(786),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(788),
    [sym__conid] = ACTIONS(1385),
    [anon_sym_LBRACE] = ACTIONS(794),
    [anon_sym_AT] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(798),
    [anon_sym_if] = ACTIONS(800),
    [anon_sym_case] = ACTIONS(802),
    [anon_sym_let] = ACTIONS(804),
    [anon_sym_BSLASH] = ACTIONS(1389),
    [anon_sym_do] = ACTIONS(808),
    [anon_sym_ado] = ACTIONS(810),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [495] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7882),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10096),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [496] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7729),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9577),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [497] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7880),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10094),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [498] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7879),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10092),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [499] = {
    [sym_integer] = STATE(2097),
    [sym__numeric] = STATE(2097),
    [sym__literal] = STATE(2097),
    [sym_wildcard] = STATE(8070),
    [sym_variable] = STATE(1686),
    [sym_qualified_variable] = STATE(1686),
    [sym_constructor] = STATE(1767),
    [sym_qualified_constructor] = STATE(2092),
    [sym__qcon] = STATE(2091),
    [sym_literal] = STATE(280),
    [sym_record_literal] = STATE(1688),
    [sym__record_update_lhs] = STATE(9679),
    [sym_record_update] = STATE(280),
    [sym_exp_name] = STATE(280),
    [sym_exp_negation] = STATE(3117),
    [sym_exp_parens] = STATE(1688),
    [sym_exp_type_application] = STATE(280),
    [sym_exp_array] = STATE(280),
    [sym_exp_section_left] = STATE(280),
    [sym_exp_section_right] = STATE(280),
    [sym_record_accessor] = STATE(280),
    [sym_exp_record_access] = STATE(2204),
    [sym_exp_if] = STATE(3117),
    [sym_exp_case] = STATE(3117),
    [sym_exp_let_in] = STATE(3117),
    [sym_exp_lambda] = STATE(3117),
    [sym__do] = STATE(9680),
    [sym_exp_do] = STATE(280),
    [sym__ado] = STATE(9681),
    [sym_exp_ado] = STATE(280),
    [sym__do_or_ado_block] = STATE(280),
    [sym__aexp_projection] = STATE(280),
    [sym__aexp] = STATE(280),
    [sym__exp_apply] = STATE(5459),
    [sym__fexp] = STATE(3117),
    [sym__lexp] = STATE(3117),
    [sym_exp_infix] = STATE(3117),
    [sym__exp_infix] = STATE(3117),
    [sym__exp] = STATE(7946),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5664),
    [sym__varid] = ACTIONS(740),
    [sym_number] = ACTIONS(742),
    [sym_char] = ACTIONS(742),
    [sym_string] = ACTIONS(744),
    [sym_triple_quote_string] = ACTIONS(742),
    [sym__integer_literal] = ACTIONS(746),
    [sym__hex_literal] = ACTIONS(748),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(752),
    [sym__conid] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(764),
    [anon_sym_case] = ACTIONS(766),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_BSLASH] = ACTIONS(1371),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_ado] = ACTIONS(774),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [500] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7827),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9465),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [501] = {
    [sym_integer] = STATE(1756),
    [sym__numeric] = STATE(1756),
    [sym__literal] = STATE(1756),
    [sym_wildcard] = STATE(8374),
    [sym_variable] = STATE(1528),
    [sym_qualified_variable] = STATE(1528),
    [sym_constructor] = STATE(1706),
    [sym_qualified_constructor] = STATE(1789),
    [sym__qcon] = STATE(1902),
    [sym_literal] = STATE(278),
    [sym_record_literal] = STATE(1526),
    [sym__record_update_lhs] = STATE(9719),
    [sym_record_update] = STATE(278),
    [sym_exp_name] = STATE(278),
    [sym_exp_negation] = STATE(3035),
    [sym_exp_parens] = STATE(1526),
    [sym_exp_type_application] = STATE(278),
    [sym_exp_array] = STATE(278),
    [sym_exp_section_left] = STATE(278),
    [sym_exp_section_right] = STATE(278),
    [sym_record_accessor] = STATE(278),
    [sym_exp_record_access] = STATE(1790),
    [sym_exp_if] = STATE(3035),
    [sym_exp_case] = STATE(3035),
    [sym_exp_let_in] = STATE(3035),
    [sym_exp_lambda] = STATE(3035),
    [sym__do] = STATE(9720),
    [sym_exp_do] = STATE(278),
    [sym__ado] = STATE(9721),
    [sym_exp_ado] = STATE(278),
    [sym__do_or_ado_block] = STATE(278),
    [sym__aexp_projection] = STATE(278),
    [sym__aexp] = STATE(278),
    [sym__exp_apply] = STATE(5065),
    [sym__fexp] = STATE(3035),
    [sym__lexp] = STATE(3035),
    [sym_exp_infix] = STATE(3035),
    [sym__exp_infix] = STATE(3035),
    [sym__exp] = STATE(5121),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5540),
    [sym__varid] = ACTIONS(613),
    [sym_number] = ACTIONS(617),
    [sym_char] = ACTIONS(617),
    [sym_string] = ACTIONS(619),
    [sym_triple_quote_string] = ACTIONS(617),
    [sym__integer_literal] = ACTIONS(621),
    [sym__hex_literal] = ACTIONS(623),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(629),
    [sym__conid] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_let] = ACTIONS(644),
    [anon_sym_BSLASH] = ACTIONS(1405),
    [anon_sym_do] = ACTIONS(648),
    [anon_sym_ado] = ACTIONS(650),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [502] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3152),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3152),
    [sym_exp_case] = STATE(3152),
    [sym_exp_let_in] = STATE(3152),
    [sym_exp_lambda] = STATE(3152),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3152),
    [sym__lexp] = STATE(3152),
    [sym_exp_infix] = STATE(3152),
    [sym__exp_infix] = STATE(3152),
    [sym__exp] = STATE(6129),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [503] = {
    [sym_integer] = STATE(2097),
    [sym__numeric] = STATE(2097),
    [sym__literal] = STATE(2097),
    [sym_wildcard] = STATE(8070),
    [sym_variable] = STATE(1686),
    [sym_qualified_variable] = STATE(1686),
    [sym_constructor] = STATE(1767),
    [sym_qualified_constructor] = STATE(2092),
    [sym__qcon] = STATE(2091),
    [sym_literal] = STATE(280),
    [sym_record_literal] = STATE(1688),
    [sym__record_update_lhs] = STATE(9679),
    [sym_record_update] = STATE(280),
    [sym_exp_name] = STATE(280),
    [sym_exp_negation] = STATE(3117),
    [sym_exp_parens] = STATE(1688),
    [sym_exp_type_application] = STATE(280),
    [sym_exp_array] = STATE(280),
    [sym_exp_section_left] = STATE(280),
    [sym_exp_section_right] = STATE(280),
    [sym_record_accessor] = STATE(280),
    [sym_exp_record_access] = STATE(2204),
    [sym_exp_if] = STATE(3117),
    [sym_exp_case] = STATE(3117),
    [sym_exp_let_in] = STATE(3117),
    [sym_exp_lambda] = STATE(3117),
    [sym__do] = STATE(9680),
    [sym_exp_do] = STATE(280),
    [sym__ado] = STATE(9681),
    [sym_exp_ado] = STATE(280),
    [sym__do_or_ado_block] = STATE(280),
    [sym__aexp_projection] = STATE(280),
    [sym__aexp] = STATE(280),
    [sym__exp_apply] = STATE(5459),
    [sym__fexp] = STATE(3117),
    [sym__lexp] = STATE(3117),
    [sym_exp_infix] = STATE(3117),
    [sym__exp_infix] = STATE(3117),
    [sym__exp] = STATE(7690),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5664),
    [sym__varid] = ACTIONS(740),
    [sym_number] = ACTIONS(742),
    [sym_char] = ACTIONS(742),
    [sym_string] = ACTIONS(744),
    [sym_triple_quote_string] = ACTIONS(742),
    [sym__integer_literal] = ACTIONS(746),
    [sym__hex_literal] = ACTIONS(748),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(750),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(752),
    [sym__conid] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(758),
    [anon_sym_AT] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(762),
    [anon_sym_if] = ACTIONS(764),
    [anon_sym_case] = ACTIONS(766),
    [anon_sym_let] = ACTIONS(768),
    [anon_sym_BSLASH] = ACTIONS(1371),
    [anon_sym_do] = ACTIONS(772),
    [anon_sym_ado] = ACTIONS(774),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [504] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7877),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10090),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [505] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7875),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10084),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [506] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7735),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9562),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [507] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(8037),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3687),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3687),
    [sym_exp_case] = STATE(3687),
    [sym_exp_let_in] = STATE(3687),
    [sym_exp_lambda] = STATE(3687),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3687),
    [sym__lexp] = STATE(3687),
    [sym_exp_infix] = STATE(3687),
    [sym__exp_infix] = STATE(3687),
    [sym__exp] = STATE(6115),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [508] = {
    [sym_integer] = STATE(1756),
    [sym__numeric] = STATE(1756),
    [sym__literal] = STATE(1756),
    [sym_wildcard] = STATE(8374),
    [sym_variable] = STATE(1528),
    [sym_qualified_variable] = STATE(1528),
    [sym_constructor] = STATE(1706),
    [sym_qualified_constructor] = STATE(1789),
    [sym__qcon] = STATE(1902),
    [sym_literal] = STATE(278),
    [sym_record_literal] = STATE(1526),
    [sym__record_update_lhs] = STATE(9719),
    [sym_record_update] = STATE(278),
    [sym_exp_name] = STATE(278),
    [sym_exp_negation] = STATE(3035),
    [sym_exp_parens] = STATE(1526),
    [sym_exp_type_application] = STATE(278),
    [sym_exp_array] = STATE(278),
    [sym_exp_section_left] = STATE(278),
    [sym_exp_section_right] = STATE(278),
    [sym_record_accessor] = STATE(278),
    [sym_exp_record_access] = STATE(1790),
    [sym_exp_if] = STATE(3035),
    [sym_exp_case] = STATE(3035),
    [sym_exp_let_in] = STATE(3035),
    [sym_exp_lambda] = STATE(3035),
    [sym__do] = STATE(9720),
    [sym_exp_do] = STATE(278),
    [sym__ado] = STATE(9721),
    [sym_exp_ado] = STATE(278),
    [sym__do_or_ado_block] = STATE(278),
    [sym__aexp_projection] = STATE(278),
    [sym__aexp] = STATE(278),
    [sym__exp_apply] = STATE(5065),
    [sym__fexp] = STATE(3035),
    [sym__lexp] = STATE(3035),
    [sym_exp_infix] = STATE(3035),
    [sym__exp_infix] = STATE(3035),
    [sym__exp] = STATE(5119),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5540),
    [sym__varid] = ACTIONS(613),
    [sym_number] = ACTIONS(617),
    [sym_char] = ACTIONS(617),
    [sym_string] = ACTIONS(619),
    [sym_triple_quote_string] = ACTIONS(617),
    [sym__integer_literal] = ACTIONS(621),
    [sym__hex_literal] = ACTIONS(623),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(629),
    [sym__conid] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_let] = ACTIONS(644),
    [anon_sym_BSLASH] = ACTIONS(1405),
    [anon_sym_do] = ACTIONS(648),
    [anon_sym_ado] = ACTIONS(650),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [509] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(4945),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3152),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3152),
    [sym_exp_case] = STATE(3152),
    [sym_exp_let_in] = STATE(3152),
    [sym_exp_lambda] = STATE(3152),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3152),
    [sym__lexp] = STATE(3152),
    [sym_exp_infix] = STATE(3152),
    [sym__exp_infix] = STATE(3152),
    [sym__exp] = STATE(6113),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(1446),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [510] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(8363),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3673),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3673),
    [sym_exp_case] = STATE(3673),
    [sym_exp_let_in] = STATE(3673),
    [sym_exp_lambda] = STATE(3673),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3673),
    [sym__lexp] = STATE(3673),
    [sym_exp_infix] = STATE(3673),
    [sym__exp_infix] = STATE(3673),
    [sym__exp] = STATE(6119),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [511] = {
    [sym_integer] = STATE(2280),
    [sym__numeric] = STATE(2280),
    [sym__literal] = STATE(2280),
    [sym_wildcard] = STATE(8279),
    [sym_variable] = STATE(1873),
    [sym_qualified_variable] = STATE(1873),
    [sym_constructor] = STATE(1961),
    [sym_qualified_constructor] = STATE(2268),
    [sym__qcon] = STATE(2506),
    [sym_literal] = STATE(337),
    [sym_record_literal] = STATE(1880),
    [sym__record_update_lhs] = STATE(9433),
    [sym_record_update] = STATE(337),
    [sym_exp_name] = STATE(337),
    [sym_exp_negation] = STATE(3239),
    [sym_exp_parens] = STATE(1880),
    [sym_exp_type_application] = STATE(337),
    [sym_exp_array] = STATE(337),
    [sym_exp_section_left] = STATE(337),
    [sym_exp_section_right] = STATE(337),
    [sym_record_accessor] = STATE(337),
    [sym_exp_record_access] = STATE(2505),
    [sym_exp_if] = STATE(3239),
    [sym_exp_case] = STATE(3239),
    [sym_exp_let_in] = STATE(3239),
    [sym_exp_lambda] = STATE(3239),
    [sym__do] = STATE(9434),
    [sym_exp_do] = STATE(337),
    [sym__ado] = STATE(9435),
    [sym_exp_ado] = STATE(337),
    [sym__do_or_ado_block] = STATE(337),
    [sym__aexp_projection] = STATE(337),
    [sym__aexp] = STATE(337),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3239),
    [sym__lexp] = STATE(3239),
    [sym_exp_infix] = STATE(3239),
    [sym__exp_infix] = STATE(3239),
    [sym__exp] = STATE(8642),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5616),
    [sym__varid] = ACTIONS(919),
    [sym_number] = ACTIONS(467),
    [sym_char] = ACTIONS(467),
    [sym_string] = ACTIONS(469),
    [sym_triple_quote_string] = ACTIONS(467),
    [sym__integer_literal] = ACTIONS(471),
    [sym__hex_literal] = ACTIONS(473),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(477),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_LPAREN] = ACTIONS(923),
    [sym__conid] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_BSLASH] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(499),
    [anon_sym_ado] = ACTIONS(501),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [512] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(8497),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3677),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3677),
    [sym_exp_case] = STATE(3677),
    [sym_exp_let_in] = STATE(3677),
    [sym_exp_lambda] = STATE(3677),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3677),
    [sym__lexp] = STATE(3677),
    [sym_exp_infix] = STATE(3677),
    [sym__exp_infix] = STATE(3677),
    [sym__exp] = STATE(6119),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [513] = {
    [sym_integer] = STATE(1852),
    [sym__numeric] = STATE(1852),
    [sym__literal] = STATE(1852),
    [sym_wildcard] = STATE(8255),
    [sym_variable] = STATE(1603),
    [sym_qualified_variable] = STATE(1603),
    [sym_constructor] = STATE(1670),
    [sym_qualified_constructor] = STATE(1863),
    [sym__qcon] = STATE(1786),
    [sym_literal] = STATE(277),
    [sym_record_literal] = STATE(1604),
    [sym__record_update_lhs] = STATE(9739),
    [sym_record_update] = STATE(277),
    [sym_exp_name] = STATE(277),
    [sym_exp_negation] = STATE(3024),
    [sym_exp_parens] = STATE(1604),
    [sym_exp_type_application] = STATE(277),
    [sym_exp_array] = STATE(277),
    [sym_exp_section_left] = STATE(277),
    [sym_exp_section_right] = STATE(277),
    [sym_record_accessor] = STATE(277),
    [sym_exp_record_access] = STATE(1929),
    [sym_exp_if] = STATE(3024),
    [sym_exp_case] = STATE(3024),
    [sym_exp_let_in] = STATE(3024),
    [sym_exp_lambda] = STATE(3024),
    [sym__do] = STATE(9740),
    [sym_exp_do] = STATE(277),
    [sym__ado] = STATE(9741),
    [sym_exp_ado] = STATE(277),
    [sym__do_or_ado_block] = STATE(277),
    [sym__aexp_projection] = STATE(277),
    [sym__aexp] = STATE(277),
    [sym__exp_apply] = STATE(5174),
    [sym__fexp] = STATE(3024),
    [sym__lexp] = STATE(3024),
    [sym_exp_infix] = STATE(3024),
    [sym__exp_infix] = STATE(3024),
    [sym__exp] = STATE(7158),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5673),
    [sym__varid] = ACTIONS(652),
    [sym_number] = ACTIONS(654),
    [sym_char] = ACTIONS(654),
    [sym_string] = ACTIONS(656),
    [sym_triple_quote_string] = ACTIONS(654),
    [sym__integer_literal] = ACTIONS(658),
    [sym__hex_literal] = ACTIONS(660),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(1430),
    [anon_sym_LPAREN] = ACTIONS(664),
    [sym__conid] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(1434),
    [anon_sym_LBRACK] = ACTIONS(673),
    [anon_sym_if] = ACTIONS(675),
    [anon_sym_case] = ACTIONS(677),
    [anon_sym_let] = ACTIONS(679),
    [anon_sym_BSLASH] = ACTIONS(1436),
    [anon_sym_do] = ACTIONS(683),
    [anon_sym_ado] = ACTIONS(685),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [514] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7732),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9569),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [515] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(7304),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3294),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3294),
    [sym_exp_case] = STATE(3294),
    [sym_exp_let_in] = STATE(3294),
    [sym_exp_lambda] = STATE(3294),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3294),
    [sym__lexp] = STATE(3294),
    [sym_exp_infix] = STATE(3294),
    [sym__exp_infix] = STATE(3294),
    [sym__exp] = STATE(8641),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(475),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [516] = {
    [sym_integer] = STATE(2656),
    [sym__numeric] = STATE(2656),
    [sym__literal] = STATE(2656),
    [sym_wildcard] = STATE(8408),
    [sym_variable] = STATE(1968),
    [sym_qualified_variable] = STATE(1968),
    [sym_constructor] = STATE(2386),
    [sym_qualified_constructor] = STATE(2653),
    [sym__qcon] = STATE(2634),
    [sym_literal] = STATE(453),
    [sym_record_literal] = STATE(1967),
    [sym__record_update_lhs] = STATE(9623),
    [sym_record_update] = STATE(453),
    [sym_exp_name] = STATE(453),
    [sym_exp_parens] = STATE(1967),
    [sym_exp_type_application] = STATE(453),
    [sym_exp_array] = STATE(453),
    [sym_exp_section_left] = STATE(453),
    [sym_exp_section_right] = STATE(453),
    [sym_record_accessor] = STATE(453),
    [sym_exp_record_access] = STATE(2602),
    [sym_exp_if] = STATE(6295),
    [sym_exp_case] = STATE(6295),
    [sym_exp_let_in] = STATE(6295),
    [sym_exp_lambda] = STATE(6295),
    [sym__do] = STATE(9624),
    [sym_exp_do] = STATE(453),
    [sym__ado] = STATE(9625),
    [sym_exp_ado] = STATE(453),
    [sym__do_or_ado_block] = STATE(453),
    [sym__aexp_projection] = STATE(453),
    [sym__aexp] = STATE(453),
    [sym__exp_apply] = STATE(6295),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5551),
    [sym__varid] = ACTIONS(1325),
    [sym_number] = ACTIONS(1327),
    [sym_char] = ACTIONS(1327),
    [sym_string] = ACTIONS(1329),
    [sym_triple_quote_string] = ACTIONS(1327),
    [sym__integer_literal] = ACTIONS(1331),
    [sym__hex_literal] = ACTIONS(1333),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1337),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [sym__conid] = ACTIONS(1448),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_EQ] = ACTIONS(700),
    [anon_sym_AT] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_BSLASH] = ACTIONS(1416),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_ado] = ACTIONS(1361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(687),
  },
  [517] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(8497),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3677),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3677),
    [sym_exp_case] = STATE(3677),
    [sym_exp_let_in] = STATE(3677),
    [sym_exp_lambda] = STATE(3677),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3677),
    [sym__lexp] = STATE(3677),
    [sym_exp_infix] = STATE(3677),
    [sym__exp_infix] = STATE(3677),
    [sym__exp] = STATE(6115),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [518] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(8585),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3328),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3328),
    [sym_exp_case] = STATE(3328),
    [sym_exp_let_in] = STATE(3328),
    [sym_exp_lambda] = STATE(3328),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3328),
    [sym__lexp] = STATE(3328),
    [sym_exp_infix] = STATE(3328),
    [sym__exp_infix] = STATE(3328),
    [sym__exp] = STATE(5584),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [519] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(8585),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3328),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3328),
    [sym_exp_case] = STATE(3328),
    [sym_exp_let_in] = STATE(3328),
    [sym_exp_lambda] = STATE(3328),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3328),
    [sym__lexp] = STATE(3328),
    [sym_exp_infix] = STATE(3328),
    [sym__exp_infix] = STATE(3328),
    [sym__exp] = STATE(5583),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [520] = {
    [sym_integer] = STATE(2656),
    [sym__numeric] = STATE(2656),
    [sym__literal] = STATE(2656),
    [sym_wildcard] = STATE(8408),
    [sym_variable] = STATE(1968),
    [sym_qualified_variable] = STATE(1968),
    [sym_constructor] = STATE(2386),
    [sym_qualified_constructor] = STATE(2653),
    [sym__qcon] = STATE(2634),
    [sym_literal] = STATE(516),
    [sym_record_literal] = STATE(1967),
    [sym__record_update_lhs] = STATE(9623),
    [sym_record_update] = STATE(516),
    [sym_exp_name] = STATE(516),
    [sym_exp_negation] = STATE(3279),
    [sym_exp_parens] = STATE(1967),
    [sym_exp_type_application] = STATE(516),
    [sym_exp_array] = STATE(516),
    [sym_exp_section_left] = STATE(516),
    [sym_exp_section_right] = STATE(516),
    [sym_record_accessor] = STATE(516),
    [sym_exp_record_access] = STATE(2602),
    [sym_exp_if] = STATE(3279),
    [sym_exp_case] = STATE(3279),
    [sym_exp_let_in] = STATE(3279),
    [sym_exp_lambda] = STATE(3279),
    [sym__do] = STATE(9624),
    [sym_exp_do] = STATE(516),
    [sym__ado] = STATE(9625),
    [sym_exp_ado] = STATE(516),
    [sym__do_or_ado_block] = STATE(516),
    [sym__aexp_projection] = STATE(516),
    [sym__aexp] = STATE(516),
    [sym__exp_apply] = STATE(6282),
    [sym__fexp] = STATE(3279),
    [sym__lexp] = STATE(3279),
    [sym_exp_infix] = STATE(3279),
    [sym__exp_infix] = STATE(3279),
    [sym__exp] = STATE(6810),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5551),
    [sym__varid] = ACTIONS(1325),
    [sym_number] = ACTIONS(1327),
    [sym_char] = ACTIONS(1327),
    [sym_string] = ACTIONS(1329),
    [sym_triple_quote_string] = ACTIONS(1327),
    [sym__integer_literal] = ACTIONS(1331),
    [sym__hex_literal] = ACTIONS(1333),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [sym__conid] = ACTIONS(1343),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_BSLASH] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_ado] = ACTIONS(1361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [521] = {
    [sym_integer] = STATE(2656),
    [sym__numeric] = STATE(2656),
    [sym__literal] = STATE(2656),
    [sym_wildcard] = STATE(8408),
    [sym_variable] = STATE(1968),
    [sym_qualified_variable] = STATE(1968),
    [sym_constructor] = STATE(2386),
    [sym_qualified_constructor] = STATE(2653),
    [sym__qcon] = STATE(2634),
    [sym_literal] = STATE(516),
    [sym_record_literal] = STATE(1967),
    [sym__record_update_lhs] = STATE(9623),
    [sym_record_update] = STATE(516),
    [sym_exp_name] = STATE(516),
    [sym_exp_negation] = STATE(3279),
    [sym_exp_parens] = STATE(1967),
    [sym_exp_type_application] = STATE(516),
    [sym_exp_array] = STATE(516),
    [sym_exp_section_left] = STATE(516),
    [sym_exp_section_right] = STATE(516),
    [sym_record_accessor] = STATE(516),
    [sym_exp_record_access] = STATE(2602),
    [sym_exp_if] = STATE(3279),
    [sym_exp_case] = STATE(3279),
    [sym_exp_let_in] = STATE(3279),
    [sym_exp_lambda] = STATE(3279),
    [sym__do] = STATE(9624),
    [sym_exp_do] = STATE(516),
    [sym__ado] = STATE(9625),
    [sym_exp_ado] = STATE(516),
    [sym__do_or_ado_block] = STATE(516),
    [sym__aexp_projection] = STATE(516),
    [sym__aexp] = STATE(516),
    [sym__exp_apply] = STATE(6282),
    [sym__fexp] = STATE(3279),
    [sym__lexp] = STATE(3279),
    [sym_exp_infix] = STATE(3279),
    [sym__exp_infix] = STATE(3279),
    [sym__exp] = STATE(6808),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5551),
    [sym__varid] = ACTIONS(1325),
    [sym_number] = ACTIONS(1327),
    [sym_char] = ACTIONS(1327),
    [sym_string] = ACTIONS(1329),
    [sym_triple_quote_string] = ACTIONS(1327),
    [sym__integer_literal] = ACTIONS(1331),
    [sym__hex_literal] = ACTIONS(1333),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [sym__conid] = ACTIONS(1343),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_BSLASH] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_ado] = ACTIONS(1361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [522] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7742),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9546),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [523] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7802),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9482),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [524] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(5624),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3673),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3673),
    [sym_exp_case] = STATE(3673),
    [sym_exp_let_in] = STATE(3673),
    [sym_exp_lambda] = STATE(3673),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3673),
    [sym__lexp] = STATE(3673),
    [sym_exp_infix] = STATE(3673),
    [sym__exp_infix] = STATE(3673),
    [sym__exp] = STATE(6205),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(63),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [525] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(8037),
    [sym_variable] = STATE(2646),
    [sym_qualified_variable] = STATE(2646),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(595),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(595),
    [sym_exp_name] = STATE(595),
    [sym_exp_negation] = STATE(3805),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(595),
    [sym_exp_array] = STATE(595),
    [sym_exp_section_left] = STATE(595),
    [sym_exp_section_right] = STATE(595),
    [sym_record_accessor] = STATE(595),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3805),
    [sym_exp_case] = STATE(3805),
    [sym_exp_let_in] = STATE(3805),
    [sym_exp_lambda] = STATE(3805),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(595),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(595),
    [sym__do_or_ado_block] = STATE(595),
    [sym__aexp_projection] = STATE(595),
    [sym__aexp] = STATE(595),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3805),
    [sym__lexp] = STATE(3805),
    [sym_exp_infix] = STATE(3805),
    [sym__exp_infix] = STATE(3805),
    [sym__exp] = STATE(6115),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_BSLASH] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [526] = {
    [sym_integer] = STATE(1756),
    [sym__numeric] = STATE(1756),
    [sym__literal] = STATE(1756),
    [sym_wildcard] = STATE(8374),
    [sym_variable] = STATE(1528),
    [sym_qualified_variable] = STATE(1528),
    [sym_constructor] = STATE(1706),
    [sym_qualified_constructor] = STATE(1789),
    [sym__qcon] = STATE(1902),
    [sym_literal] = STATE(278),
    [sym_record_literal] = STATE(1526),
    [sym__record_update_lhs] = STATE(9719),
    [sym_record_update] = STATE(278),
    [sym_exp_name] = STATE(278),
    [sym_exp_negation] = STATE(3028),
    [sym_exp_parens] = STATE(1526),
    [sym_exp_type_application] = STATE(278),
    [sym_exp_array] = STATE(278),
    [sym_exp_section_left] = STATE(278),
    [sym_exp_section_right] = STATE(278),
    [sym_record_accessor] = STATE(278),
    [sym_exp_record_access] = STATE(1790),
    [sym_exp_if] = STATE(3028),
    [sym_exp_case] = STATE(3028),
    [sym_exp_let_in] = STATE(3028),
    [sym_exp_lambda] = STATE(3028),
    [sym__do] = STATE(9720),
    [sym_exp_do] = STATE(278),
    [sym__ado] = STATE(9721),
    [sym_exp_ado] = STATE(278),
    [sym__do_or_ado_block] = STATE(278),
    [sym__aexp_projection] = STATE(278),
    [sym__aexp] = STATE(278),
    [sym__exp_apply] = STATE(5065),
    [sym__fexp] = STATE(3028),
    [sym__lexp] = STATE(3028),
    [sym_exp_infix] = STATE(3028),
    [sym__exp_infix] = STATE(3028),
    [sym__exp] = STATE(6989),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5540),
    [sym__varid] = ACTIONS(613),
    [sym_number] = ACTIONS(617),
    [sym_char] = ACTIONS(617),
    [sym_string] = ACTIONS(619),
    [sym_triple_quote_string] = ACTIONS(617),
    [sym__integer_literal] = ACTIONS(621),
    [sym__hex_literal] = ACTIONS(623),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(627),
    [anon_sym_DASH] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(629),
    [sym__conid] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(638),
    [anon_sym_if] = ACTIONS(640),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_let] = ACTIONS(644),
    [anon_sym_BSLASH] = ACTIONS(1405),
    [anon_sym_do] = ACTIONS(648),
    [anon_sym_ado] = ACTIONS(650),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [527] = {
    [sym_integer] = STATE(2656),
    [sym__numeric] = STATE(2656),
    [sym__literal] = STATE(2656),
    [sym_wildcard] = STATE(5171),
    [sym_variable] = STATE(1968),
    [sym_qualified_variable] = STATE(1968),
    [sym_constructor] = STATE(2386),
    [sym_qualified_constructor] = STATE(2653),
    [sym__qcon] = STATE(2634),
    [sym_literal] = STATE(516),
    [sym_record_literal] = STATE(1967),
    [sym__record_update_lhs] = STATE(9623),
    [sym_record_update] = STATE(516),
    [sym_exp_name] = STATE(516),
    [sym_exp_negation] = STATE(3301),
    [sym_exp_parens] = STATE(1967),
    [sym_exp_type_application] = STATE(516),
    [sym_exp_array] = STATE(516),
    [sym_exp_section_left] = STATE(516),
    [sym_exp_section_right] = STATE(516),
    [sym_record_accessor] = STATE(516),
    [sym_exp_record_access] = STATE(2602),
    [sym_exp_if] = STATE(3301),
    [sym_exp_case] = STATE(3301),
    [sym_exp_let_in] = STATE(3301),
    [sym_exp_lambda] = STATE(3301),
    [sym__do] = STATE(9624),
    [sym_exp_do] = STATE(516),
    [sym__ado] = STATE(9625),
    [sym_exp_ado] = STATE(516),
    [sym__do_or_ado_block] = STATE(516),
    [sym__aexp_projection] = STATE(516),
    [sym__aexp] = STATE(516),
    [sym__exp_apply] = STATE(6282),
    [sym__fexp] = STATE(3301),
    [sym__lexp] = STATE(3301),
    [sym_exp_infix] = STATE(3301),
    [sym__exp_infix] = STATE(3301),
    [sym__exp] = STATE(6308),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5551),
    [sym__varid] = ACTIONS(1325),
    [sym_number] = ACTIONS(1327),
    [sym_char] = ACTIONS(1327),
    [sym_string] = ACTIONS(1329),
    [sym_triple_quote_string] = ACTIONS(1327),
    [sym__integer_literal] = ACTIONS(1331),
    [sym__hex_literal] = ACTIONS(1333),
    [anon_sym__] = ACTIONS(1452),
    [sym_hole] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [sym__conid] = ACTIONS(1343),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_BSLASH] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_ado] = ACTIONS(1361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [528] = {
    [sym_integer] = STATE(2282),
    [sym__numeric] = STATE(2282),
    [sym__literal] = STATE(2282),
    [sym_wildcard] = STATE(8180),
    [sym_variable] = STATE(1835),
    [sym_qualified_variable] = STATE(1835),
    [sym_constructor] = STATE(1970),
    [sym_qualified_constructor] = STATE(2291),
    [sym__qcon] = STATE(2407),
    [sym_literal] = STATE(332),
    [sym_record_literal] = STATE(1837),
    [sym__record_update_lhs] = STATE(9787),
    [sym_record_update] = STATE(332),
    [sym_exp_name] = STATE(332),
    [sym_exp_negation] = STATE(3263),
    [sym_exp_parens] = STATE(1837),
    [sym_exp_type_application] = STATE(332),
    [sym_exp_array] = STATE(332),
    [sym_exp_section_left] = STATE(332),
    [sym_exp_section_right] = STATE(332),
    [sym_record_accessor] = STATE(332),
    [sym_exp_record_access] = STATE(2249),
    [sym_exp_if] = STATE(3263),
    [sym_exp_case] = STATE(3263),
    [sym_exp_let_in] = STATE(3263),
    [sym_exp_lambda] = STATE(3263),
    [sym__do] = STATE(9788),
    [sym_exp_do] = STATE(332),
    [sym__ado] = STATE(9789),
    [sym_exp_ado] = STATE(332),
    [sym__do_or_ado_block] = STATE(332),
    [sym__aexp_projection] = STATE(332),
    [sym__aexp] = STATE(332),
    [sym__exp_apply] = STATE(6145),
    [sym__fexp] = STATE(3263),
    [sym__lexp] = STATE(3263),
    [sym_exp_infix] = STATE(3263),
    [sym__exp_infix] = STATE(3263),
    [sym__exp] = STATE(6186),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5607),
    [sym__varid] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_char] = ACTIONS(933),
    [sym_string] = ACTIONS(935),
    [sym_triple_quote_string] = ACTIONS(933),
    [sym__integer_literal] = ACTIONS(937),
    [sym__hex_literal] = ACTIONS(939),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(943),
    [sym__conid] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_ado] = ACTIONS(964),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [529] = {
    [sym_integer] = STATE(2656),
    [sym__numeric] = STATE(2656),
    [sym__literal] = STATE(2656),
    [sym_wildcard] = STATE(8408),
    [sym_variable] = STATE(1968),
    [sym_qualified_variable] = STATE(1968),
    [sym_constructor] = STATE(2386),
    [sym_qualified_constructor] = STATE(2653),
    [sym__qcon] = STATE(2634),
    [sym_literal] = STATE(516),
    [sym_record_literal] = STATE(1967),
    [sym__record_update_lhs] = STATE(9623),
    [sym_record_update] = STATE(516),
    [sym_exp_name] = STATE(516),
    [sym_exp_negation] = STATE(3301),
    [sym_exp_parens] = STATE(1967),
    [sym_exp_type_application] = STATE(516),
    [sym_exp_array] = STATE(516),
    [sym_exp_section_left] = STATE(516),
    [sym_exp_section_right] = STATE(516),
    [sym_record_accessor] = STATE(516),
    [sym_exp_record_access] = STATE(2602),
    [sym_exp_if] = STATE(3301),
    [sym_exp_case] = STATE(3301),
    [sym_exp_let_in] = STATE(3301),
    [sym_exp_lambda] = STATE(3301),
    [sym__do] = STATE(9624),
    [sym_exp_do] = STATE(516),
    [sym__ado] = STATE(9625),
    [sym_exp_ado] = STATE(516),
    [sym__do_or_ado_block] = STATE(516),
    [sym__aexp_projection] = STATE(516),
    [sym__aexp] = STATE(516),
    [sym__exp_apply] = STATE(6282),
    [sym__fexp] = STATE(3301),
    [sym__lexp] = STATE(3301),
    [sym_exp_infix] = STATE(3301),
    [sym__exp_infix] = STATE(3301),
    [sym__exp] = STATE(6303),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5551),
    [sym__varid] = ACTIONS(1325),
    [sym_number] = ACTIONS(1327),
    [sym_char] = ACTIONS(1327),
    [sym_string] = ACTIONS(1329),
    [sym_triple_quote_string] = ACTIONS(1327),
    [sym__integer_literal] = ACTIONS(1331),
    [sym__hex_literal] = ACTIONS(1333),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [sym__conid] = ACTIONS(1343),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_AT] = ACTIONS(1347),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_case] = ACTIONS(1353),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_BSLASH] = ACTIONS(1357),
    [anon_sym_do] = ACTIONS(1359),
    [anon_sym_ado] = ACTIONS(1361),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [530] = {
    [sym_integer] = STATE(2406),
    [sym__numeric] = STATE(2406),
    [sym__literal] = STATE(2406),
    [sym_wildcard] = STATE(8340),
    [sym_variable] = STATE(1785),
    [sym_qualified_variable] = STATE(1785),
    [sym_constructor] = STATE(2134),
    [sym_qualified_constructor] = STATE(2408),
    [sym__qcon] = STATE(2348),
    [sym_literal] = STATE(401),
    [sym_record_literal] = STATE(1787),
    [sym__record_update_lhs] = STATE(9549),
    [sym_record_update] = STATE(401),
    [sym_exp_name] = STATE(401),
    [sym_exp_negation] = STATE(3174),
    [sym_exp_parens] = STATE(1787),
    [sym_exp_type_application] = STATE(401),
    [sym_exp_array] = STATE(401),
    [sym_exp_section_left] = STATE(401),
    [sym_exp_section_right] = STATE(401),
    [sym_record_accessor] = STATE(401),
    [sym_exp_record_access] = STATE(2395),
    [sym_exp_if] = STATE(3174),
    [sym_exp_case] = STATE(3174),
    [sym_exp_let_in] = STATE(3174),
    [sym_exp_lambda] = STATE(3174),
    [sym__do] = STATE(9550),
    [sym_exp_do] = STATE(401),
    [sym__ado] = STATE(9551),
    [sym_exp_ado] = STATE(401),
    [sym__do_or_ado_block] = STATE(401),
    [sym__aexp_projection] = STATE(401),
    [sym__aexp] = STATE(401),
    [sym__exp_apply] = STATE(6055),
    [sym__fexp] = STATE(3174),
    [sym__lexp] = STATE(3174),
    [sym_exp_infix] = STATE(3174),
    [sym__exp_infix] = STATE(3174),
    [sym__exp] = STATE(8540),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5575),
    [sym__varid] = ACTIONS(891),
    [sym_number] = ACTIONS(893),
    [sym_char] = ACTIONS(893),
    [sym_string] = ACTIONS(895),
    [sym_triple_quote_string] = ACTIONS(893),
    [sym__integer_literal] = ACTIONS(897),
    [sym__hex_literal] = ACTIONS(899),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(241),
    [anon_sym_DASH] = ACTIONS(901),
    [anon_sym_LPAREN] = ACTIONS(903),
    [sym__conid] = ACTIONS(905),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_case] = ACTIONS(257),
    [anon_sym_let] = ACTIONS(911),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_do] = ACTIONS(263),
    [anon_sym_ado] = ACTIONS(265),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [531] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7793),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9498),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [532] = {
    [sym_integer] = STATE(2473),
    [sym__numeric] = STATE(2473),
    [sym__literal] = STATE(2473),
    [sym_wildcard] = STATE(8244),
    [sym_variable] = STATE(1770),
    [sym_qualified_variable] = STATE(1770),
    [sym_constructor] = STATE(2107),
    [sym_qualified_constructor] = STATE(2485),
    [sym__qcon] = STATE(2252),
    [sym_literal] = STATE(305),
    [sym_record_literal] = STATE(1771),
    [sym__record_update_lhs] = STATE(9564),
    [sym_record_update] = STATE(305),
    [sym_exp_name] = STATE(305),
    [sym_exp_negation] = STATE(3153),
    [sym_exp_parens] = STATE(1771),
    [sym_exp_type_application] = STATE(305),
    [sym_exp_array] = STATE(305),
    [sym_exp_section_left] = STATE(305),
    [sym_exp_section_right] = STATE(305),
    [sym_record_accessor] = STATE(305),
    [sym_exp_record_access] = STATE(2516),
    [sym_exp_if] = STATE(3153),
    [sym_exp_case] = STATE(3153),
    [sym_exp_let_in] = STATE(3153),
    [sym_exp_lambda] = STATE(3153),
    [sym__do] = STATE(9565),
    [sym_exp_do] = STATE(305),
    [sym__ado] = STATE(9566),
    [sym_exp_ado] = STATE(305),
    [sym__do_or_ado_block] = STATE(305),
    [sym__aexp_projection] = STATE(305),
    [sym__aexp] = STATE(305),
    [sym__exp_apply] = STATE(6169),
    [sym__fexp] = STATE(3153),
    [sym__lexp] = STATE(3153),
    [sym_exp_infix] = STATE(3153),
    [sym__exp_infix] = STATE(3153),
    [sym__exp] = STATE(6039),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5610),
    [sym__varid] = ACTIONS(989),
    [sym_number] = ACTIONS(991),
    [sym_char] = ACTIONS(991),
    [sym_string] = ACTIONS(993),
    [sym_triple_quote_string] = ACTIONS(991),
    [sym__integer_literal] = ACTIONS(995),
    [sym__hex_literal] = ACTIONS(997),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(147),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(999),
    [sym__conid] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_case] = ACTIONS(163),
    [anon_sym_let] = ACTIONS(1011),
    [anon_sym_BSLASH] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_ado] = ACTIONS(173),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [533] = {
    [sym_integer] = STATE(2063),
    [sym__numeric] = STATE(2063),
    [sym__literal] = STATE(2063),
    [sym_wildcard] = STATE(8591),
    [sym_variable] = STATE(1625),
    [sym_qualified_variable] = STATE(1625),
    [sym_constructor] = STATE(1743),
    [sym_qualified_constructor] = STATE(2061),
    [sym__qcon] = STATE(2141),
    [sym_literal] = STATE(282),
    [sym_record_literal] = STATE(1626),
    [sym__record_update_lhs] = STATE(9689),
    [sym_record_update] = STATE(282),
    [sym_exp_name] = STATE(282),
    [sym_exp_negation] = STATE(3086),
    [sym_exp_parens] = STATE(1626),
    [sym_exp_type_application] = STATE(282),
    [sym_exp_array] = STATE(282),
    [sym_exp_section_left] = STATE(282),
    [sym_exp_section_right] = STATE(282),
    [sym_record_accessor] = STATE(282),
    [sym_exp_record_access] = STATE(2032),
    [sym_exp_if] = STATE(3086),
    [sym_exp_case] = STATE(3086),
    [sym_exp_let_in] = STATE(3086),
    [sym_exp_lambda] = STATE(3086),
    [sym__do] = STATE(9690),
    [sym_exp_do] = STATE(282),
    [sym__ado] = STATE(9691),
    [sym_exp_ado] = STATE(282),
    [sym__do_or_ado_block] = STATE(282),
    [sym__aexp_projection] = STATE(282),
    [sym__aexp] = STATE(282),
    [sym__exp_apply] = STATE(5417),
    [sym__fexp] = STATE(3086),
    [sym__lexp] = STATE(3086),
    [sym_exp_infix] = STATE(3086),
    [sym__exp_infix] = STATE(3086),
    [sym__exp] = STATE(7919),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5674),
    [sym__varid] = ACTIONS(812),
    [sym_number] = ACTIONS(814),
    [sym_char] = ACTIONS(814),
    [sym_string] = ACTIONS(816),
    [sym_triple_quote_string] = ACTIONS(814),
    [sym__integer_literal] = ACTIONS(818),
    [sym__hex_literal] = ACTIONS(820),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(824),
    [sym__conid] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_case] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_BSLASH] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_ado] = ACTIONS(846),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [534] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(8585),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(544),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(544),
    [sym_exp_name] = STATE(544),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(544),
    [sym_exp_array] = STATE(544),
    [sym_exp_section_left] = STATE(544),
    [sym_exp_section_right] = STATE(544),
    [sym_record_accessor] = STATE(544),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(5587),
    [sym_exp_case] = STATE(5587),
    [sym_exp_let_in] = STATE(5587),
    [sym_exp_lambda] = STATE(5587),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(544),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(544),
    [sym__do_or_ado_block] = STATE(544),
    [sym__aexp_projection] = STATE(544),
    [sym__aexp] = STATE(544),
    [sym__exp_apply] = STATE(5587),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym_u2237] = ACTIONS(700),
    [anon_sym_COLON_COLON] = ACTIONS(700),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(867),
    [sym__operator] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(1466),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_of] = ACTIONS(700),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(687),
  },
  [535] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(7777),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3724),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3724),
    [sym_exp_case] = STATE(3724),
    [sym_exp_let_in] = STATE(3724),
    [sym_exp_lambda] = STATE(3724),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3724),
    [sym__lexp] = STATE(3724),
    [sym_exp_infix] = STATE(3724),
    [sym__exp_infix] = STATE(3724),
    [sym__exp] = STATE(9514),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [536] = {
    [sym_integer] = STATE(2282),
    [sym__numeric] = STATE(2282),
    [sym__literal] = STATE(2282),
    [sym_wildcard] = STATE(8180),
    [sym_variable] = STATE(1835),
    [sym_qualified_variable] = STATE(1835),
    [sym_constructor] = STATE(1970),
    [sym_qualified_constructor] = STATE(2291),
    [sym__qcon] = STATE(2407),
    [sym_literal] = STATE(332),
    [sym_record_literal] = STATE(1837),
    [sym__record_update_lhs] = STATE(9787),
    [sym_record_update] = STATE(332),
    [sym_exp_name] = STATE(332),
    [sym_exp_negation] = STATE(3263),
    [sym_exp_parens] = STATE(1837),
    [sym_exp_type_application] = STATE(332),
    [sym_exp_array] = STATE(332),
    [sym_exp_section_left] = STATE(332),
    [sym_exp_section_right] = STATE(332),
    [sym_record_accessor] = STATE(332),
    [sym_exp_record_access] = STATE(2249),
    [sym_exp_if] = STATE(3263),
    [sym_exp_case] = STATE(3263),
    [sym_exp_let_in] = STATE(3263),
    [sym_exp_lambda] = STATE(3263),
    [sym__do] = STATE(9788),
    [sym_exp_do] = STATE(332),
    [sym__ado] = STATE(9789),
    [sym_exp_ado] = STATE(332),
    [sym__do_or_ado_block] = STATE(332),
    [sym__aexp_projection] = STATE(332),
    [sym__aexp] = STATE(332),
    [sym__exp_apply] = STATE(6145),
    [sym__fexp] = STATE(3263),
    [sym__lexp] = STATE(3263),
    [sym_exp_infix] = STATE(3263),
    [sym__exp_infix] = STATE(3263),
    [sym__exp] = STATE(6184),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5607),
    [sym__varid] = ACTIONS(931),
    [sym_number] = ACTIONS(933),
    [sym_char] = ACTIONS(933),
    [sym_string] = ACTIONS(935),
    [sym_triple_quote_string] = ACTIONS(933),
    [sym__integer_literal] = ACTIONS(937),
    [sym__hex_literal] = ACTIONS(939),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(943),
    [sym__conid] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(948),
    [anon_sym_AT] = ACTIONS(1377),
    [anon_sym_LBRACK] = ACTIONS(952),
    [anon_sym_if] = ACTIONS(954),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(958),
    [anon_sym_BSLASH] = ACTIONS(1379),
    [anon_sym_do] = ACTIONS(962),
    [anon_sym_ado] = ACTIONS(964),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [537] = {
    [sym_integer] = STATE(2725),
    [sym__numeric] = STATE(2725),
    [sym__literal] = STATE(2725),
    [sym_wildcard] = STATE(8363),
    [sym_variable] = STATE(2256),
    [sym_qualified_variable] = STATE(2256),
    [sym_constructor] = STATE(2679),
    [sym_qualified_constructor] = STATE(2716),
    [sym__qcon] = STATE(2807),
    [sym_literal] = STATE(554),
    [sym_record_literal] = STATE(2257),
    [sym__record_update_lhs] = STATE(9609),
    [sym_record_update] = STATE(554),
    [sym_exp_name] = STATE(554),
    [sym_exp_negation] = STATE(3673),
    [sym_exp_parens] = STATE(2257),
    [sym_exp_type_application] = STATE(554),
    [sym_exp_array] = STATE(554),
    [sym_exp_section_left] = STATE(554),
    [sym_exp_section_right] = STATE(554),
    [sym_record_accessor] = STATE(554),
    [sym_exp_record_access] = STATE(2861),
    [sym_exp_if] = STATE(3673),
    [sym_exp_case] = STATE(3673),
    [sym_exp_let_in] = STATE(3673),
    [sym_exp_lambda] = STATE(3673),
    [sym__do] = STATE(9610),
    [sym_exp_do] = STATE(554),
    [sym__ado] = STATE(9611),
    [sym_exp_ado] = STATE(554),
    [sym__do_or_ado_block] = STATE(554),
    [sym__aexp_projection] = STATE(554),
    [sym__aexp] = STATE(554),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3673),
    [sym__lexp] = STATE(3673),
    [sym_exp_infix] = STATE(3673),
    [sym__exp_infix] = STATE(3673),
    [sym__exp] = STATE(6115),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5544),
    [sym__varid] = ACTIONS(1257),
    [sym_number] = ACTIONS(1259),
    [sym_char] = ACTIONS(1259),
    [sym_string] = ACTIONS(1261),
    [sym_triple_quote_string] = ACTIONS(1259),
    [sym__integer_literal] = ACTIONS(1263),
    [sym__hex_literal] = ACTIONS(1265),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1267),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1271),
    [sym__conid] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1275),
    [anon_sym_AT] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1281),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1283),
    [anon_sym_BSLASH] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1287),
    [anon_sym_ado] = ACTIONS(1289),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [538] = {
    [sym_integer] = STATE(2063),
    [sym__numeric] = STATE(2063),
    [sym__literal] = STATE(2063),
    [sym_wildcard] = STATE(4756),
    [sym_variable] = STATE(1625),
    [sym_qualified_variable] = STATE(1625),
    [sym_constructor] = STATE(1743),
    [sym_qualified_constructor] = STATE(2061),
    [sym__qcon] = STATE(2141),
    [sym_literal] = STATE(282),
    [sym_record_literal] = STATE(1626),
    [sym__record_update_lhs] = STATE(9689),
    [sym_record_update] = STATE(282),
    [sym_exp_name] = STATE(282),
    [sym_exp_negation] = STATE(3052),
    [sym_exp_parens] = STATE(1626),
    [sym_exp_type_application] = STATE(282),
    [sym_exp_array] = STATE(282),
    [sym_exp_section_left] = STATE(282),
    [sym_exp_section_right] = STATE(282),
    [sym_record_accessor] = STATE(282),
    [sym_exp_record_access] = STATE(2032),
    [sym_exp_if] = STATE(3052),
    [sym_exp_case] = STATE(3052),
    [sym_exp_let_in] = STATE(3052),
    [sym_exp_lambda] = STATE(3052),
    [sym__do] = STATE(9690),
    [sym_exp_do] = STATE(282),
    [sym__ado] = STATE(9691),
    [sym_exp_ado] = STATE(282),
    [sym__do_or_ado_block] = STATE(282),
    [sym__aexp_projection] = STATE(282),
    [sym__aexp] = STATE(282),
    [sym__exp_apply] = STATE(5417),
    [sym__fexp] = STATE(3052),
    [sym__lexp] = STATE(3052),
    [sym_exp_infix] = STATE(3052),
    [sym__exp_infix] = STATE(3052),
    [sym__exp] = STATE(5485),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5674),
    [sym__varid] = ACTIONS(812),
    [sym_number] = ACTIONS(814),
    [sym_char] = ACTIONS(814),
    [sym_string] = ACTIONS(816),
    [sym_triple_quote_string] = ACTIONS(814),
    [sym__integer_literal] = ACTIONS(818),
    [sym__hex_literal] = ACTIONS(820),
    [anon_sym__] = ACTIONS(1470),
    [sym_hole] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(824),
    [sym__conid] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_case] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_BSLASH] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_ado] = ACTIONS(846),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [539] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(5077),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(534),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(534),
    [sym_exp_name] = STATE(534),
    [sym_exp_negation] = STATE(3328),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(534),
    [sym_exp_array] = STATE(534),
    [sym_exp_section_left] = STATE(534),
    [sym_exp_section_right] = STATE(534),
    [sym_record_accessor] = STATE(534),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(3328),
    [sym_exp_case] = STATE(3328),
    [sym_exp_let_in] = STATE(3328),
    [sym_exp_lambda] = STATE(3328),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(534),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(534),
    [sym__do_or_ado_block] = STATE(534),
    [sym__aexp_projection] = STATE(534),
    [sym__aexp] = STATE(534),
    [sym__exp_apply] = STATE(5591),
    [sym__fexp] = STATE(3328),
    [sym__lexp] = STATE(3328),
    [sym_exp_infix] = STATE(3328),
    [sym__exp_infix] = STATE(3328),
    [sym__exp] = STATE(5580),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym__] = ACTIONS(1440),
    [sym_hole] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(873),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(885),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [540] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(8037),
    [sym_variable] = STATE(2447),
    [sym_qualified_variable] = STATE(2447),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(564),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(564),
    [sym_exp_name] = STATE(564),
    [sym_exp_negation] = STATE(3690),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(564),
    [sym_exp_array] = STATE(564),
    [sym_exp_section_left] = STATE(564),
    [sym_exp_section_right] = STATE(564),
    [sym_record_accessor] = STATE(564),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3690),
    [sym_exp_case] = STATE(3690),
    [sym_exp_let_in] = STATE(3690),
    [sym_exp_lambda] = STATE(3690),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(564),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(564),
    [sym__do_or_ado_block] = STATE(564),
    [sym__aexp_projection] = STATE(564),
    [sym__aexp] = STATE(564),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3690),
    [sym__lexp] = STATE(3690),
    [sym_exp_infix] = STATE(3690),
    [sym__exp_infix] = STATE(3690),
    [sym__exp] = STATE(7401),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(85),
    [anon_sym_BSLASH] = ACTIONS(1409),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [541] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(8037),
    [sym_variable] = STATE(2646),
    [sym_qualified_variable] = STATE(2646),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(595),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(595),
    [sym_exp_name] = STATE(595),
    [sym_exp_negation] = STATE(3805),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(595),
    [sym_exp_array] = STATE(595),
    [sym_exp_section_left] = STATE(595),
    [sym_exp_section_right] = STATE(595),
    [sym_record_accessor] = STATE(595),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3805),
    [sym_exp_case] = STATE(3805),
    [sym_exp_let_in] = STATE(3805),
    [sym_exp_lambda] = STATE(3805),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(595),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(595),
    [sym__do_or_ado_block] = STATE(595),
    [sym__aexp_projection] = STATE(595),
    [sym__aexp] = STATE(595),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3805),
    [sym__lexp] = STATE(3805),
    [sym_exp_infix] = STATE(3805),
    [sym__exp_infix] = STATE(3805),
    [sym__exp] = STATE(6119),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_BSLASH] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [542] = {
    [sym_integer] = STATE(2063),
    [sym__numeric] = STATE(2063),
    [sym__literal] = STATE(2063),
    [sym_wildcard] = STATE(8591),
    [sym_variable] = STATE(1625),
    [sym_qualified_variable] = STATE(1625),
    [sym_constructor] = STATE(1743),
    [sym_qualified_constructor] = STATE(2061),
    [sym__qcon] = STATE(2141),
    [sym_literal] = STATE(282),
    [sym_record_literal] = STATE(1626),
    [sym__record_update_lhs] = STATE(9689),
    [sym_record_update] = STATE(282),
    [sym_exp_name] = STATE(282),
    [sym_exp_negation] = STATE(3052),
    [sym_exp_parens] = STATE(1626),
    [sym_exp_type_application] = STATE(282),
    [sym_exp_array] = STATE(282),
    [sym_exp_section_left] = STATE(282),
    [sym_exp_section_right] = STATE(282),
    [sym_record_accessor] = STATE(282),
    [sym_exp_record_access] = STATE(2032),
    [sym_exp_if] = STATE(3052),
    [sym_exp_case] = STATE(3052),
    [sym_exp_let_in] = STATE(3052),
    [sym_exp_lambda] = STATE(3052),
    [sym__do] = STATE(9690),
    [sym_exp_do] = STATE(282),
    [sym__ado] = STATE(9691),
    [sym_exp_ado] = STATE(282),
    [sym__do_or_ado_block] = STATE(282),
    [sym__aexp_projection] = STATE(282),
    [sym__aexp] = STATE(282),
    [sym__exp_apply] = STATE(5417),
    [sym__fexp] = STATE(3052),
    [sym__lexp] = STATE(3052),
    [sym_exp_infix] = STATE(3052),
    [sym__exp_infix] = STATE(3052),
    [sym__exp] = STATE(5457),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5674),
    [sym__varid] = ACTIONS(812),
    [sym_number] = ACTIONS(814),
    [sym_char] = ACTIONS(814),
    [sym_string] = ACTIONS(816),
    [sym_triple_quote_string] = ACTIONS(814),
    [sym__integer_literal] = ACTIONS(818),
    [sym__hex_literal] = ACTIONS(820),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(824),
    [sym__conid] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_case] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_BSLASH] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_ado] = ACTIONS(846),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [543] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(6297),
    [sym_variable] = STATE(2646),
    [sym_qualified_variable] = STATE(2646),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(595),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(595),
    [sym_exp_name] = STATE(595),
    [sym_exp_negation] = STATE(3977),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(595),
    [sym_exp_array] = STATE(595),
    [sym_exp_section_left] = STATE(595),
    [sym_exp_section_right] = STATE(595),
    [sym_record_accessor] = STATE(595),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3977),
    [sym_exp_case] = STATE(3977),
    [sym_exp_let_in] = STATE(3977),
    [sym_exp_lambda] = STATE(3977),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(595),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(595),
    [sym__do_or_ado_block] = STATE(595),
    [sym__aexp_projection] = STATE(595),
    [sym__aexp] = STATE(595),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3977),
    [sym__lexp] = STATE(3977),
    [sym_exp_infix] = STATE(3977),
    [sym__exp_infix] = STATE(3977),
    [sym__exp] = STATE(7199),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(603),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_BSLASH] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [544] = {
    [sym_integer] = STATE(2523),
    [sym__numeric] = STATE(2523),
    [sym__literal] = STATE(2523),
    [sym_wildcard] = STATE(8585),
    [sym_variable] = STATE(2079),
    [sym_qualified_variable] = STATE(2079),
    [sym_constructor] = STATE(2373),
    [sym_qualified_constructor] = STATE(2671),
    [sym__qcon] = STATE(2635),
    [sym_literal] = STATE(544),
    [sym_record_literal] = STATE(2100),
    [sym__record_update_lhs] = STATE(9469),
    [sym_record_update] = STATE(544),
    [sym_exp_name] = STATE(544),
    [sym_exp_parens] = STATE(2100),
    [sym_exp_type_application] = STATE(544),
    [sym_exp_array] = STATE(544),
    [sym_exp_section_left] = STATE(544),
    [sym_exp_section_right] = STATE(544),
    [sym_record_accessor] = STATE(544),
    [sym_exp_record_access] = STATE(2554),
    [sym_exp_if] = STATE(5587),
    [sym_exp_case] = STATE(5587),
    [sym_exp_let_in] = STATE(5587),
    [sym_exp_lambda] = STATE(5587),
    [sym__do] = STATE(9470),
    [sym_exp_do] = STATE(544),
    [sym__ado] = STATE(9471),
    [sym_exp_ado] = STATE(544),
    [sym__do_or_ado_block] = STATE(544),
    [sym__aexp_projection] = STATE(544),
    [sym__aexp] = STATE(544),
    [sym__exp_apply] = STATE(5587),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5578),
    [sym__varid] = ACTIONS(857),
    [sym_number] = ACTIONS(859),
    [sym_char] = ACTIONS(859),
    [sym_string] = ACTIONS(861),
    [sym_triple_quote_string] = ACTIONS(859),
    [sym__integer_literal] = ACTIONS(863),
    [sym__hex_literal] = ACTIONS(865),
    [anon_sym_u2237] = ACTIONS(625),
    [anon_sym_COLON_COLON] = ACTIONS(625),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(867),
    [sym__operator] = ACTIONS(625),
    [anon_sym_DASH] = ACTIONS(625),
    [anon_sym_LPAREN] = ACTIONS(871),
    [sym__conid] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_AT] = ACTIONS(1466),
    [anon_sym_BQUOTE] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(879),
    [anon_sym_if] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_of] = ACTIONS(625),
    [anon_sym_let] = ACTIONS(883),
    [anon_sym_BSLASH] = ACTIONS(1468),
    [anon_sym_do] = ACTIONS(887),
    [anon_sym_ado] = ACTIONS(889),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(615),
  },
  [545] = {
    [sym_integer] = STATE(2719),
    [sym__numeric] = STATE(2719),
    [sym__literal] = STATE(2719),
    [sym_wildcard] = STATE(8037),
    [sym_variable] = STATE(2646),
    [sym_qualified_variable] = STATE(2646),
    [sym_constructor] = STATE(2680),
    [sym_qualified_constructor] = STATE(2722),
    [sym__qcon] = STATE(2873),
    [sym_literal] = STATE(595),
    [sym_record_literal] = STATE(2453),
    [sym__record_update_lhs] = STATE(9415),
    [sym_record_update] = STATE(595),
    [sym_exp_name] = STATE(595),
    [sym_exp_negation] = STATE(3977),
    [sym_exp_parens] = STATE(2453),
    [sym_exp_type_application] = STATE(595),
    [sym_exp_array] = STATE(595),
    [sym_exp_section_left] = STATE(595),
    [sym_exp_section_right] = STATE(595),
    [sym_record_accessor] = STATE(595),
    [sym_exp_record_access] = STATE(2809),
    [sym_exp_if] = STATE(3977),
    [sym_exp_case] = STATE(3977),
    [sym_exp_let_in] = STATE(3977),
    [sym_exp_lambda] = STATE(3977),
    [sym__do] = STATE(9416),
    [sym_exp_do] = STATE(595),
    [sym__ado] = STATE(9417),
    [sym_exp_ado] = STATE(595),
    [sym__do_or_ado_block] = STATE(595),
    [sym__aexp_projection] = STATE(595),
    [sym__aexp] = STATE(595),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3977),
    [sym__lexp] = STATE(3977),
    [sym_exp_infix] = STATE(3977),
    [sym__exp_infix] = STATE(3977),
    [sym__exp] = STATE(7216),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5443),
    [sym__varid] = ACTIONS(601),
    [sym_number] = ACTIONS(55),
    [sym_char] = ACTIONS(55),
    [sym_string] = ACTIONS(57),
    [sym_triple_quote_string] = ACTIONS(55),
    [sym__integer_literal] = ACTIONS(59),
    [sym__hex_literal] = ACTIONS(61),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(65),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(607),
    [sym__conid] = ACTIONS(73),
    [anon_sym_LBRACE] = ACTIONS(609),
    [anon_sym_AT] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(611),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1395),
    [anon_sym_BSLASH] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_ado] = ACTIONS(91),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [546] = {
    [sym_integer] = STATE(2063),
    [sym__numeric] = STATE(2063),
    [sym__literal] = STATE(2063),
    [sym_wildcard] = STATE(8591),
    [sym_variable] = STATE(1625),
    [sym_qualified_variable] = STATE(1625),
    [sym_constructor] = STATE(1743),
    [sym_qualified_constructor] = STATE(2061),
    [sym__qcon] = STATE(2141),
    [sym_literal] = STATE(282),
    [sym_record_literal] = STATE(1626),
    [sym__record_update_lhs] = STATE(9689),
    [sym_record_update] = STATE(282),
    [sym_exp_name] = STATE(282),
    [sym_exp_negation] = STATE(3052),
    [sym_exp_parens] = STATE(1626),
    [sym_exp_type_application] = STATE(282),
    [sym_exp_array] = STATE(282),
    [sym_exp_section_left] = STATE(282),
    [sym_exp_section_right] = STATE(282),
    [sym_record_accessor] = STATE(282),
    [sym_exp_record_access] = STATE(2032),
    [sym_exp_if] = STATE(3052),
    [sym_exp_case] = STATE(3052),
    [sym_exp_let_in] = STATE(3052),
    [sym_exp_lambda] = STATE(3052),
    [sym__do] = STATE(9690),
    [sym_exp_do] = STATE(282),
    [sym__ado] = STATE(9691),
    [sym_exp_ado] = STATE(282),
    [sym__do_or_ado_block] = STATE(282),
    [sym__aexp_projection] = STATE(282),
    [sym__aexp] = STATE(282),
    [sym__exp_apply] = STATE(5417),
    [sym__fexp] = STATE(3052),
    [sym__lexp] = STATE(3052),
    [sym_exp_infix] = STATE(3052),
    [sym__exp_infix] = STATE(3052),
    [sym__exp] = STATE(5446),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5674),
    [sym__varid] = ACTIONS(812),
    [sym_number] = ACTIONS(814),
    [sym_char] = ACTIONS(814),
    [sym_string] = ACTIONS(816),
    [sym_triple_quote_string] = ACTIONS(814),
    [sym__integer_literal] = ACTIONS(818),
    [sym__hex_literal] = ACTIONS(820),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(822),
    [anon_sym_DASH] = ACTIONS(1454),
    [anon_sym_LPAREN] = ACTIONS(824),
    [sym__conid] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(830),
    [anon_sym_AT] = ACTIONS(1458),
    [anon_sym_LBRACK] = ACTIONS(834),
    [anon_sym_if] = ACTIONS(836),
    [anon_sym_case] = ACTIONS(838),
    [anon_sym_let] = ACTIONS(840),
    [anon_sym_BSLASH] = ACTIONS(1460),
    [anon_sym_do] = ACTIONS(844),
    [anon_sym_ado] = ACTIONS(846),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
  [547] = {
    [sym_integer] = STATE(2827),
    [sym__numeric] = STATE(2827),
    [sym__literal] = STATE(2827),
    [sym_wildcard] = STATE(7939),
    [sym_variable] = STATE(2251),
    [sym_qualified_variable] = STATE(2251),
    [sym_constructor] = STATE(2591),
    [sym_qualified_constructor] = STATE(2849),
    [sym__qcon] = STATE(2763),
    [sym_literal] = STATE(552),
    [sym_record_literal] = STATE(2250),
    [sym__record_update_lhs] = STATE(9451),
    [sym_record_update] = STATE(552),
    [sym_exp_name] = STATE(552),
    [sym_exp_negation] = STATE(3485),
    [sym_exp_parens] = STATE(2250),
    [sym_exp_type_application] = STATE(552),
    [sym_exp_array] = STATE(552),
    [sym_exp_section_left] = STATE(552),
    [sym_exp_section_right] = STATE(552),
    [sym_record_accessor] = STATE(552),
    [sym_exp_record_access] = STATE(2874),
    [sym_exp_if] = STATE(3485),
    [sym_exp_case] = STATE(3485),
    [sym_exp_let_in] = STATE(3485),
    [sym_exp_lambda] = STATE(3485),
    [sym__do] = STATE(9452),
    [sym_exp_do] = STATE(552),
    [sym__ado] = STATE(9453),
    [sym_exp_ado] = STATE(552),
    [sym__do_or_ado_block] = STATE(552),
    [sym__aexp_projection] = STATE(552),
    [sym__aexp] = STATE(552),
    [sym__exp_apply] = STATE(5968),
    [sym__fexp] = STATE(3485),
    [sym__lexp] = STATE(3485),
    [sym_exp_infix] = STATE(3485),
    [sym__exp_infix] = STATE(3485),
    [sym__exp] = STATE(10124),
    [sym__modid] = STATE(10018),
    [aux_sym__qualifying_module] = STATE(5597),
    [sym__varid] = ACTIONS(1293),
    [sym_number] = ACTIONS(1295),
    [sym_char] = ACTIONS(1295),
    [sym_string] = ACTIONS(1297),
    [sym_triple_quote_string] = ACTIONS(1295),
    [sym__integer_literal] = ACTIONS(1299),
    [sym__hex_literal] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(537),
    [sym_hole] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1269),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [sym__conid] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AT] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(1313),
    [anon_sym_if] = ACTIONS(1315),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_let] = ACTIONS(1317),
    [anon_sym_BSLASH] = ACTIONS(1319),
    [anon_sym_do] = ACTIONS(1321),
    [anon_sym_ado] = ACTIONS(1323),
    [aux_sym__token1] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4694), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [137] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4613), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [274] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4585), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [411] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4655), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [548] = 35,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1293), 1,
      sym__varid,
    ACTIONS(1297), 1,
      sym_string,
    ACTIONS(1299), 1,
      sym__integer_literal,
    ACTIONS(1301), 1,
      sym__hex_literal,
    ACTIONS(1303), 1,
      sym_hole,
    ACTIONS(1305), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      anon_sym_LBRACE,
    ACTIONS(1313), 1,
      anon_sym_LBRACK,
    ACTIONS(1315), 1,
      anon_sym_if,
    ACTIONS(1317), 1,
      anon_sym_let,
    ACTIONS(1321), 1,
      anon_sym_do,
    ACTIONS(1323), 1,
      anon_sym_ado,
    ACTIONS(1511), 1,
      sym__conid,
    ACTIONS(1515), 1,
      anon_sym_AT,
    ACTIONS(1517), 1,
      anon_sym_BSLASH,
    STATE(2591), 1,
      sym_constructor,
    STATE(2763), 1,
      sym__qcon,
    STATE(2849), 1,
      sym_qualified_constructor,
    STATE(2874), 1,
      sym_exp_record_access,
    STATE(5597), 1,
      aux_sym__qualifying_module,
    STATE(8497), 1,
      sym_wildcard,
    STATE(9451), 1,
      sym__record_update_lhs,
    STATE(9452), 1,
      sym__do,
    STATE(9453), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2250), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(2251), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1295), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2827), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6025), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    ACTIONS(700), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_then,
    STATE(558), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [683] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4704), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [820] = 35,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1257), 1,
      sym__varid,
    ACTIONS(1261), 1,
      sym_string,
    ACTIONS(1263), 1,
      sym__integer_literal,
    ACTIONS(1265), 1,
      sym__hex_literal,
    ACTIONS(1267), 1,
      sym_hole,
    ACTIONS(1271), 1,
      anon_sym_LPAREN,
    ACTIONS(1275), 1,
      anon_sym_LBRACE,
    ACTIONS(1279), 1,
      anon_sym_LBRACK,
    ACTIONS(1281), 1,
      anon_sym_if,
    ACTIONS(1283), 1,
      anon_sym_let,
    ACTIONS(1287), 1,
      anon_sym_do,
    ACTIONS(1289), 1,
      anon_sym_ado,
    ACTIONS(1519), 1,
      sym__conid,
    ACTIONS(1523), 1,
      anon_sym_AT,
    ACTIONS(1525), 1,
      anon_sym_BSLASH,
    STATE(2679), 1,
      sym_constructor,
    STATE(2716), 1,
      sym_qualified_constructor,
    STATE(2807), 1,
      sym__qcon,
    STATE(2861), 1,
      sym_exp_record_access,
    STATE(5544), 1,
      aux_sym__qualifying_module,
    STATE(8363), 1,
      sym_wildcard,
    STATE(9609), 1,
      sym__record_update_lhs,
    STATE(9610), 1,
      sym__do,
    STATE(9611), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2256), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2257), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1259), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2725), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6025), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    ACTIONS(700), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_else,
    STATE(573), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [955] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4709), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [1092] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4594), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [1229] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4496), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [1366] = 35,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1293), 1,
      sym__varid,
    ACTIONS(1297), 1,
      sym_string,
    ACTIONS(1299), 1,
      sym__integer_literal,
    ACTIONS(1301), 1,
      sym__hex_literal,
    ACTIONS(1303), 1,
      sym_hole,
    ACTIONS(1305), 1,
      anon_sym_LPAREN,
    ACTIONS(1309), 1,
      anon_sym_LBRACE,
    ACTIONS(1313), 1,
      anon_sym_LBRACK,
    ACTIONS(1315), 1,
      anon_sym_if,
    ACTIONS(1317), 1,
      anon_sym_let,
    ACTIONS(1321), 1,
      anon_sym_do,
    ACTIONS(1323), 1,
      anon_sym_ado,
    ACTIONS(1515), 1,
      anon_sym_AT,
    ACTIONS(1517), 1,
      anon_sym_BSLASH,
    ACTIONS(1527), 1,
      sym__conid,
    STATE(2591), 1,
      sym_constructor,
    STATE(2763), 1,
      sym__qcon,
    STATE(2849), 1,
      sym_qualified_constructor,
    STATE(2874), 1,
      sym_exp_record_access,
    STATE(5597), 1,
      aux_sym__qualifying_module,
    STATE(8497), 1,
      sym_wildcard,
    STATE(9451), 1,
      sym__record_update_lhs,
    STATE(9452), 1,
      sym__do,
    STATE(9453), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2250), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(2251), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1295), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2827), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6025), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    ACTIONS(625), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_then,
    STATE(558), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [1501] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4556), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [1638] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4708), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [1775] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(539), 1,
      sym_hole,
    ACTIONS(553), 1,
      anon_sym_if,
    ACTIONS(555), 1,
      anon_sym_case,
    ACTIONS(557), 1,
      anon_sym_let,
    ACTIONS(561), 1,
      anon_sym_do,
    ACTIONS(563), 1,
      anon_sym_ado,
    ACTIONS(615), 1,
      sym_comma,
    ACTIONS(1530), 1,
      sym__varid,
    ACTIONS(1534), 1,
      sym_string,
    ACTIONS(1536), 1,
      sym__integer_literal,
    ACTIONS(1538), 1,
      sym__hex_literal,
    ACTIONS(1540), 1,
      anon_sym_LPAREN,
    ACTIONS(1542), 1,
      sym__conid,
    ACTIONS(1545), 1,
      anon_sym_LBRACE,
    ACTIONS(1547), 1,
      anon_sym_AT,
    ACTIONS(1549), 1,
      anon_sym_LBRACK,
    ACTIONS(1551), 1,
      anon_sym_BSLASH,
    STATE(2546), 1,
      sym_constructor,
    STATE(2841), 1,
      sym_exp_record_access,
    STATE(2892), 1,
      sym_qualified_constructor,
    STATE(2896), 1,
      sym__qcon,
    STATE(5612), 1,
      aux_sym__qualifying_module,
    STATE(8129), 1,
      sym_wildcard,
    STATE(9759), 1,
      sym__record_update_lhs,
    STATE(9760), 1,
      sym__do,
    STATE(9761), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2455), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2461), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1532), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2890), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(625), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(6668), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(561), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [1912] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4515), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [2049] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4657), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [2186] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(77), 1,
      anon_sym_AT,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(87), 1,
      anon_sym_BSLASH,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(687), 1,
      anon_sym_RPAREN,
    ACTIONS(1553), 1,
      sym__conid,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(8037), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(700), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(6025), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(591), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [2323] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4521), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [2460] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4607), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [2597] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4705), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [2734] = 36,
    ACTIONS(1557), 1,
      sym__varid,
    ACTIONS(1563), 1,
      sym_string,
    ACTIONS(1566), 1,
      sym__integer_literal,
    ACTIONS(1569), 1,
      sym__hex_literal,
    ACTIONS(1572), 1,
      anon_sym__,
    ACTIONS(1575), 1,
      sym_hole,
    ACTIONS(1578), 1,
      anon_sym_DASH,
    ACTIONS(1581), 1,
      anon_sym_LPAREN,
    ACTIONS(1584), 1,
      sym__conid,
    ACTIONS(1587), 1,
      anon_sym_LBRACE,
    ACTIONS(1590), 1,
      anon_sym_AT,
    ACTIONS(1593), 1,
      anon_sym_LBRACK,
    ACTIONS(1596), 1,
      anon_sym_if,
    ACTIONS(1599), 1,
      anon_sym_case,
    ACTIONS(1602), 1,
      anon_sym_let,
    ACTIONS(1605), 1,
      anon_sym_BSLASH,
    ACTIONS(1608), 1,
      anon_sym_do,
    ACTIONS(1611), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1560), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4814), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(655), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [2871] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4507), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [3008] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4643), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [3145] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4570), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [3282] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4495), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [3419] = 35,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1257), 1,
      sym__varid,
    ACTIONS(1261), 1,
      sym_string,
    ACTIONS(1263), 1,
      sym__integer_literal,
    ACTIONS(1265), 1,
      sym__hex_literal,
    ACTIONS(1267), 1,
      sym_hole,
    ACTIONS(1271), 1,
      anon_sym_LPAREN,
    ACTIONS(1275), 1,
      anon_sym_LBRACE,
    ACTIONS(1279), 1,
      anon_sym_LBRACK,
    ACTIONS(1281), 1,
      anon_sym_if,
    ACTIONS(1283), 1,
      anon_sym_let,
    ACTIONS(1287), 1,
      anon_sym_do,
    ACTIONS(1289), 1,
      anon_sym_ado,
    ACTIONS(1523), 1,
      anon_sym_AT,
    ACTIONS(1525), 1,
      anon_sym_BSLASH,
    ACTIONS(1614), 1,
      sym__conid,
    STATE(2679), 1,
      sym_constructor,
    STATE(2716), 1,
      sym_qualified_constructor,
    STATE(2807), 1,
      sym__qcon,
    STATE(2861), 1,
      sym_exp_record_access,
    STATE(5544), 1,
      aux_sym__qualifying_module,
    STATE(8363), 1,
      sym_wildcard,
    STATE(9609), 1,
      sym__record_update_lhs,
    STATE(9610), 1,
      sym__do,
    STATE(9611), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2256), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2257), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1259), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2725), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6025), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    ACTIONS(625), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_else,
    STATE(573), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [3554] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4582), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [3691] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(575), 1,
      sym_hole,
    ACTIONS(585), 1,
      anon_sym_AT,
    ACTIONS(589), 1,
      anon_sym_if,
    ACTIONS(591), 1,
      anon_sym_case,
    ACTIONS(593), 1,
      anon_sym_let,
    ACTIONS(595), 1,
      anon_sym_BSLASH,
    ACTIONS(597), 1,
      anon_sym_do,
    ACTIONS(599), 1,
      anon_sym_ado,
    ACTIONS(1617), 1,
      sym__varid,
    ACTIONS(1621), 1,
      sym_string,
    ACTIONS(1623), 1,
      sym__integer_literal,
    ACTIONS(1625), 1,
      sym__hex_literal,
    ACTIONS(1627), 1,
      anon_sym_DASH,
    ACTIONS(1629), 1,
      anon_sym_LPAREN,
    ACTIONS(1631), 1,
      sym__conid,
    ACTIONS(1633), 1,
      anon_sym_LBRACE,
    ACTIONS(1635), 1,
      anon_sym_LBRACK,
    STATE(2812), 1,
      sym_constructor,
    STATE(2958), 1,
      sym__qcon,
    STATE(2963), 1,
      sym_qualified_constructor,
    STATE(2968), 1,
      sym_exp_record_access,
    STATE(5552), 1,
      aux_sym__qualifying_module,
    STATE(6842), 1,
      sym__exp_apply,
    STATE(8068), 1,
      sym_wildcard,
    STATE(9930), 1,
      sym__ado,
    STATE(9931), 1,
      sym__do,
    STATE(9937), 1,
      sym__record_update_lhs,
    STATE(10018), 1,
      sym__modid,
    STATE(2651), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2655), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1619), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2962), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4429), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(593), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [3828] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4633), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [3965] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4617), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [4102] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    ACTIONS(1637), 1,
      anon_sym_if,
    ACTIONS(1639), 1,
      anon_sym_let,
    ACTIONS(1641), 1,
      anon_sym_BSLASH,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4814), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(655), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [4239] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4555), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [4376] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4612), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [4513] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(539), 1,
      sym_hole,
    ACTIONS(553), 1,
      anon_sym_if,
    ACTIONS(555), 1,
      anon_sym_case,
    ACTIONS(557), 1,
      anon_sym_let,
    ACTIONS(561), 1,
      anon_sym_do,
    ACTIONS(563), 1,
      anon_sym_ado,
    ACTIONS(687), 1,
      sym_comma,
    ACTIONS(1530), 1,
      sym__varid,
    ACTIONS(1534), 1,
      sym_string,
    ACTIONS(1536), 1,
      sym__integer_literal,
    ACTIONS(1538), 1,
      sym__hex_literal,
    ACTIONS(1540), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_LBRACE,
    ACTIONS(1547), 1,
      anon_sym_AT,
    ACTIONS(1549), 1,
      anon_sym_LBRACK,
    ACTIONS(1551), 1,
      anon_sym_BSLASH,
    ACTIONS(1643), 1,
      sym__conid,
    STATE(2546), 1,
      sym_constructor,
    STATE(2841), 1,
      sym_exp_record_access,
    STATE(2892), 1,
      sym_qualified_constructor,
    STATE(2896), 1,
      sym__qcon,
    STATE(5612), 1,
      aux_sym__qualifying_module,
    STATE(8129), 1,
      sym_wildcard,
    STATE(9759), 1,
      sym__record_update_lhs,
    STATE(9760), 1,
      sym__do,
    STATE(9761), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2455), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2461), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1532), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2890), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(700), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(6668), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(561), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [4650] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4628), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [4787] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4674), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [4924] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4653), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [5061] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4649), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [5198] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4623), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [5335] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4484), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [5472] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(539), 1,
      sym_hole,
    ACTIONS(549), 1,
      anon_sym_AT,
    ACTIONS(553), 1,
      anon_sym_if,
    ACTIONS(555), 1,
      anon_sym_case,
    ACTIONS(557), 1,
      anon_sym_let,
    ACTIONS(559), 1,
      anon_sym_BSLASH,
    ACTIONS(561), 1,
      anon_sym_do,
    ACTIONS(563), 1,
      anon_sym_ado,
    ACTIONS(1530), 1,
      sym__varid,
    ACTIONS(1534), 1,
      sym_string,
    ACTIONS(1536), 1,
      sym__integer_literal,
    ACTIONS(1538), 1,
      sym__hex_literal,
    ACTIONS(1540), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_LBRACE,
    ACTIONS(1549), 1,
      anon_sym_LBRACK,
    ACTIONS(1647), 1,
      anon_sym_DASH,
    ACTIONS(1649), 1,
      sym__conid,
    STATE(2546), 1,
      sym_constructor,
    STATE(2841), 1,
      sym_exp_record_access,
    STATE(2892), 1,
      sym_qualified_constructor,
    STATE(2896), 1,
      sym__qcon,
    STATE(5612), 1,
      aux_sym__qualifying_module,
    STATE(6683), 1,
      sym__exp_apply,
    STATE(8129), 1,
      sym_wildcard,
    STATE(9759), 1,
      sym__record_update_lhs,
    STATE(9760), 1,
      sym__do,
    STATE(9761), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2455), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2461), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1532), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2890), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4072), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(581), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [5609] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4627), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [5746] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4639), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [5883] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(77), 1,
      anon_sym_AT,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(87), 1,
      anon_sym_BSLASH,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(615), 1,
      anon_sym_RPAREN,
    ACTIONS(1651), 1,
      sym__conid,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(8037), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(625), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(6025), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(591), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [6020] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4573), 9,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
      sym_exp_infix,
      sym__exp_infix,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [6157] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(575), 1,
      sym_hole,
    ACTIONS(589), 1,
      anon_sym_if,
    ACTIONS(591), 1,
      anon_sym_case,
    ACTIONS(593), 1,
      anon_sym_let,
    ACTIONS(597), 1,
      anon_sym_do,
    ACTIONS(599), 1,
      anon_sym_ado,
    ACTIONS(687), 1,
      sym_comma,
    ACTIONS(1617), 1,
      sym__varid,
    ACTIONS(1621), 1,
      sym_string,
    ACTIONS(1623), 1,
      sym__integer_literal,
    ACTIONS(1625), 1,
      sym__hex_literal,
    ACTIONS(1629), 1,
      anon_sym_LPAREN,
    ACTIONS(1633), 1,
      anon_sym_LBRACE,
    ACTIONS(1635), 1,
      anon_sym_LBRACK,
    ACTIONS(1654), 1,
      sym__conid,
    ACTIONS(1658), 1,
      anon_sym_AT,
    ACTIONS(1660), 1,
      anon_sym_BSLASH,
    STATE(2812), 1,
      sym_constructor,
    STATE(2958), 1,
      sym__qcon,
    STATE(2963), 1,
      sym_qualified_constructor,
    STATE(2968), 1,
      sym_exp_record_access,
    STATE(5552), 1,
      aux_sym__qualifying_module,
    STATE(8068), 1,
      sym_wildcard,
    STATE(9930), 1,
      sym__ado,
    STATE(9931), 1,
      sym__do,
    STATE(9937), 1,
      sym__record_update_lhs,
    STATE(10018), 1,
      sym__modid,
    STATE(2651), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2655), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1619), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2962), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(700), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(6806), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(594), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [6293] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(575), 1,
      sym_hole,
    ACTIONS(589), 1,
      anon_sym_if,
    ACTIONS(591), 1,
      anon_sym_case,
    ACTIONS(593), 1,
      anon_sym_let,
    ACTIONS(597), 1,
      anon_sym_do,
    ACTIONS(599), 1,
      anon_sym_ado,
    ACTIONS(615), 1,
      sym_comma,
    ACTIONS(1617), 1,
      sym__varid,
    ACTIONS(1621), 1,
      sym_string,
    ACTIONS(1623), 1,
      sym__integer_literal,
    ACTIONS(1625), 1,
      sym__hex_literal,
    ACTIONS(1629), 1,
      anon_sym_LPAREN,
    ACTIONS(1633), 1,
      anon_sym_LBRACE,
    ACTIONS(1635), 1,
      anon_sym_LBRACK,
    ACTIONS(1658), 1,
      anon_sym_AT,
    ACTIONS(1660), 1,
      anon_sym_BSLASH,
    ACTIONS(1662), 1,
      sym__conid,
    STATE(2812), 1,
      sym_constructor,
    STATE(2958), 1,
      sym__qcon,
    STATE(2963), 1,
      sym_qualified_constructor,
    STATE(2968), 1,
      sym_exp_record_access,
    STATE(5552), 1,
      aux_sym__qualifying_module,
    STATE(8068), 1,
      sym_wildcard,
    STATE(9930), 1,
      sym__ado,
    STATE(9931), 1,
      sym__do,
    STATE(9937), 1,
      sym__record_update_lhs,
    STATE(10018), 1,
      sym__modid,
    STATE(2651), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2655), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1619), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2962), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(625), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(6806), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(594), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [6429] = 35,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(77), 1,
      anon_sym_AT,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1393), 1,
      anon_sym_if,
    ACTIONS(1395), 1,
      anon_sym_let,
    ACTIONS(1553), 1,
      sym__conid,
    ACTIONS(1665), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(8037), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(2646), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(700), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(6025), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(596), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [6563] = 35,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(77), 1,
      anon_sym_AT,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1393), 1,
      anon_sym_if,
    ACTIONS(1395), 1,
      anon_sym_let,
    ACTIONS(1651), 1,
      sym__conid,
    ACTIONS(1665), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(8037), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(2646), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(625), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(6025), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(596), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [6697] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7741), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [6832] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7868), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [6967] = 36,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1257), 1,
      sym__varid,
    ACTIONS(1261), 1,
      sym_string,
    ACTIONS(1263), 1,
      sym__integer_literal,
    ACTIONS(1265), 1,
      sym__hex_literal,
    ACTIONS(1267), 1,
      sym_hole,
    ACTIONS(1269), 1,
      anon_sym_DASH,
    ACTIONS(1271), 1,
      anon_sym_LPAREN,
    ACTIONS(1273), 1,
      sym__conid,
    ACTIONS(1275), 1,
      anon_sym_LBRACE,
    ACTIONS(1277), 1,
      anon_sym_AT,
    ACTIONS(1279), 1,
      anon_sym_LBRACK,
    ACTIONS(1281), 1,
      anon_sym_if,
    ACTIONS(1283), 1,
      anon_sym_let,
    ACTIONS(1285), 1,
      anon_sym_BSLASH,
    ACTIONS(1287), 1,
      anon_sym_do,
    ACTIONS(1289), 1,
      anon_sym_ado,
    STATE(2679), 1,
      sym_constructor,
    STATE(2716), 1,
      sym_qualified_constructor,
    STATE(2807), 1,
      sym__qcon,
    STATE(2861), 1,
      sym_exp_record_access,
    STATE(5544), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(8363), 1,
      sym_wildcard,
    STATE(9609), 1,
      sym__record_update_lhs,
    STATE(9610), 1,
      sym__do,
    STATE(9611), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2256), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2257), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1259), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2725), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(554), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [7102] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7845), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [7237] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7725), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [7372] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7545), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [7507] = 36,
    ACTIONS(469), 1,
      sym_string,
    ACTIONS(471), 1,
      sym__integer_literal,
    ACTIONS(473), 1,
      sym__hex_literal,
    ACTIONS(477), 1,
      sym_hole,
    ACTIONS(483), 1,
      sym__conid,
    ACTIONS(487), 1,
      anon_sym_AT,
    ACTIONS(491), 1,
      anon_sym_if,
    ACTIONS(493), 1,
      anon_sym_case,
    ACTIONS(495), 1,
      anon_sym_let,
    ACTIONS(497), 1,
      anon_sym_BSLASH,
    ACTIONS(499), 1,
      anon_sym_do,
    ACTIONS(501), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(919), 1,
      sym__varid,
    ACTIONS(921), 1,
      anon_sym_DASH,
    ACTIONS(923), 1,
      anon_sym_LPAREN,
    ACTIONS(925), 1,
      anon_sym_LBRACE,
    ACTIONS(927), 1,
      anon_sym_LBRACK,
    STATE(1961), 1,
      sym_constructor,
    STATE(2268), 1,
      sym_qualified_constructor,
    STATE(2505), 1,
      sym_exp_record_access,
    STATE(2506), 1,
      sym__qcon,
    STATE(5591), 1,
      sym__exp_apply,
    STATE(5616), 1,
      aux_sym__qualifying_module,
    STATE(8279), 1,
      sym_wildcard,
    STATE(9433), 1,
      sym__record_update_lhs,
    STATE(9434), 1,
      sym__do,
    STATE(9435), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1873), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1880), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(467), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2280), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5586), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(337), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [7642] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7599), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [7777] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7931), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [7912] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7870), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [8047] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7705), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [8182] = 36,
    ACTIONS(493), 1,
      anon_sym_case,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(857), 1,
      sym__varid,
    ACTIONS(861), 1,
      sym_string,
    ACTIONS(863), 1,
      sym__integer_literal,
    ACTIONS(865), 1,
      sym__hex_literal,
    ACTIONS(867), 1,
      sym_hole,
    ACTIONS(869), 1,
      anon_sym_DASH,
    ACTIONS(871), 1,
      anon_sym_LPAREN,
    ACTIONS(873), 1,
      sym__conid,
    ACTIONS(875), 1,
      anon_sym_LBRACE,
    ACTIONS(877), 1,
      anon_sym_AT,
    ACTIONS(879), 1,
      anon_sym_LBRACK,
    ACTIONS(881), 1,
      anon_sym_if,
    ACTIONS(883), 1,
      anon_sym_let,
    ACTIONS(885), 1,
      anon_sym_BSLASH,
    ACTIONS(887), 1,
      anon_sym_do,
    ACTIONS(889), 1,
      anon_sym_ado,
    STATE(2373), 1,
      sym_constructor,
    STATE(2554), 1,
      sym_exp_record_access,
    STATE(2635), 1,
      sym__qcon,
    STATE(2671), 1,
      sym_qualified_constructor,
    STATE(5578), 1,
      aux_sym__qualifying_module,
    STATE(5591), 1,
      sym__exp_apply,
    STATE(8585), 1,
      sym_wildcard,
    STATE(9469), 1,
      sym__record_update_lhs,
    STATE(9470), 1,
      sym__do,
    STATE(9471), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2079), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2100), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(859), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2523), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5586), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(534), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [8317] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(776), 1,
      sym__varid,
    ACTIONS(780), 1,
      sym_string,
    ACTIONS(782), 1,
      sym__integer_literal,
    ACTIONS(784), 1,
      sym__hex_literal,
    ACTIONS(786), 1,
      sym_hole,
    ACTIONS(788), 1,
      anon_sym_LPAREN,
    ACTIONS(794), 1,
      anon_sym_LBRACE,
    ACTIONS(798), 1,
      anon_sym_LBRACK,
    ACTIONS(800), 1,
      anon_sym_if,
    ACTIONS(802), 1,
      anon_sym_case,
    ACTIONS(804), 1,
      anon_sym_let,
    ACTIONS(808), 1,
      anon_sym_do,
    ACTIONS(810), 1,
      anon_sym_ado,
    ACTIONS(1383), 1,
      anon_sym_DASH,
    ACTIONS(1385), 1,
      sym__conid,
    ACTIONS(1387), 1,
      anon_sym_AT,
    ACTIONS(1389), 1,
      anon_sym_BSLASH,
    STATE(1822), 1,
      sym_constructor,
    STATE(2038), 1,
      sym__qcon,
    STATE(2165), 1,
      sym_exp_record_access,
    STATE(2216), 1,
      sym_qualified_constructor,
    STATE(5620), 1,
      sym__exp_apply,
    STATE(5676), 1,
      aux_sym__qualifying_module,
    STATE(8285), 1,
      sym_wildcard,
    STATE(9341), 1,
      sym__record_update_lhs,
    STATE(9342), 1,
      sym__do,
    STATE(9343), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1700), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1702), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(778), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2215), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5667), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(281), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [8452] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7934), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [8587] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7645), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [8722] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7676), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [8857] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7833), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [8992] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7771), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [9127] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7992), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [9262] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7611), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [9397] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(652), 1,
      sym__varid,
    ACTIONS(656), 1,
      sym_string,
    ACTIONS(658), 1,
      sym__integer_literal,
    ACTIONS(660), 1,
      sym__hex_literal,
    ACTIONS(662), 1,
      sym_hole,
    ACTIONS(664), 1,
      anon_sym_LPAREN,
    ACTIONS(669), 1,
      anon_sym_LBRACE,
    ACTIONS(673), 1,
      anon_sym_LBRACK,
    ACTIONS(675), 1,
      anon_sym_if,
    ACTIONS(677), 1,
      anon_sym_case,
    ACTIONS(679), 1,
      anon_sym_let,
    ACTIONS(683), 1,
      anon_sym_do,
    ACTIONS(685), 1,
      anon_sym_ado,
    ACTIONS(1430), 1,
      anon_sym_DASH,
    ACTIONS(1432), 1,
      sym__conid,
    ACTIONS(1434), 1,
      anon_sym_AT,
    ACTIONS(1436), 1,
      anon_sym_BSLASH,
    STATE(1670), 1,
      sym_constructor,
    STATE(1786), 1,
      sym__qcon,
    STATE(1863), 1,
      sym_qualified_constructor,
    STATE(1929), 1,
      sym_exp_record_access,
    STATE(5174), 1,
      sym__exp_apply,
    STATE(5673), 1,
      aux_sym__qualifying_module,
    STATE(8255), 1,
      sym_wildcard,
    STATE(9739), 1,
      sym__record_update_lhs,
    STATE(9740), 1,
      sym__do,
    STATE(9741), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1603), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1604), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(654), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(1852), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5204), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(277), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [9532] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(812), 1,
      sym__varid,
    ACTIONS(816), 1,
      sym_string,
    ACTIONS(818), 1,
      sym__integer_literal,
    ACTIONS(820), 1,
      sym__hex_literal,
    ACTIONS(822), 1,
      sym_hole,
    ACTIONS(824), 1,
      anon_sym_LPAREN,
    ACTIONS(830), 1,
      anon_sym_LBRACE,
    ACTIONS(834), 1,
      anon_sym_LBRACK,
    ACTIONS(836), 1,
      anon_sym_if,
    ACTIONS(838), 1,
      anon_sym_case,
    ACTIONS(840), 1,
      anon_sym_let,
    ACTIONS(844), 1,
      anon_sym_do,
    ACTIONS(846), 1,
      anon_sym_ado,
    ACTIONS(1454), 1,
      anon_sym_DASH,
    ACTIONS(1456), 1,
      sym__conid,
    ACTIONS(1458), 1,
      anon_sym_AT,
    ACTIONS(1460), 1,
      anon_sym_BSLASH,
    STATE(1743), 1,
      sym_constructor,
    STATE(2032), 1,
      sym_exp_record_access,
    STATE(2061), 1,
      sym_qualified_constructor,
    STATE(2141), 1,
      sym__qcon,
    STATE(5417), 1,
      sym__exp_apply,
    STATE(5674), 1,
      aux_sym__qualifying_module,
    STATE(8591), 1,
      sym_wildcard,
    STATE(9689), 1,
      sym__record_update_lhs,
    STATE(9690), 1,
      sym__do,
    STATE(9691), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1625), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1626), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(814), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2063), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5498), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(282), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [9667] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(931), 1,
      sym__varid,
    ACTIONS(935), 1,
      sym_string,
    ACTIONS(937), 1,
      sym__integer_literal,
    ACTIONS(939), 1,
      sym__hex_literal,
    ACTIONS(941), 1,
      sym_hole,
    ACTIONS(943), 1,
      anon_sym_LPAREN,
    ACTIONS(948), 1,
      anon_sym_LBRACE,
    ACTIONS(952), 1,
      anon_sym_LBRACK,
    ACTIONS(954), 1,
      anon_sym_if,
    ACTIONS(956), 1,
      anon_sym_case,
    ACTIONS(958), 1,
      anon_sym_let,
    ACTIONS(962), 1,
      anon_sym_do,
    ACTIONS(964), 1,
      anon_sym_ado,
    ACTIONS(1373), 1,
      anon_sym_DASH,
    ACTIONS(1375), 1,
      sym__conid,
    ACTIONS(1377), 1,
      anon_sym_AT,
    ACTIONS(1379), 1,
      anon_sym_BSLASH,
    STATE(1970), 1,
      sym_constructor,
    STATE(2249), 1,
      sym_exp_record_access,
    STATE(2291), 1,
      sym_qualified_constructor,
    STATE(2407), 1,
      sym__qcon,
    STATE(5607), 1,
      aux_sym__qualifying_module,
    STATE(6145), 1,
      sym__exp_apply,
    STATE(8180), 1,
      sym_wildcard,
    STATE(9787), 1,
      sym__record_update_lhs,
    STATE(9788), 1,
      sym__do,
    STATE(9789), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1835), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1837), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(933), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2282), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6175), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(332), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [9802] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7696), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [9937] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(613), 1,
      sym__varid,
    ACTIONS(619), 1,
      sym_string,
    ACTIONS(621), 1,
      sym__integer_literal,
    ACTIONS(623), 1,
      sym__hex_literal,
    ACTIONS(627), 1,
      sym_hole,
    ACTIONS(629), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(638), 1,
      anon_sym_LBRACK,
    ACTIONS(640), 1,
      anon_sym_if,
    ACTIONS(642), 1,
      anon_sym_case,
    ACTIONS(644), 1,
      anon_sym_let,
    ACTIONS(648), 1,
      anon_sym_do,
    ACTIONS(650), 1,
      anon_sym_ado,
    ACTIONS(1399), 1,
      anon_sym_DASH,
    ACTIONS(1401), 1,
      sym__conid,
    ACTIONS(1403), 1,
      anon_sym_AT,
    ACTIONS(1405), 1,
      anon_sym_BSLASH,
    STATE(1706), 1,
      sym_constructor,
    STATE(1789), 1,
      sym_qualified_constructor,
    STATE(1790), 1,
      sym_exp_record_access,
    STATE(1902), 1,
      sym__qcon,
    STATE(5065), 1,
      sym__exp_apply,
    STATE(5540), 1,
      aux_sym__qualifying_module,
    STATE(8374), 1,
      sym_wildcard,
    STATE(9719), 1,
      sym__record_update_lhs,
    STATE(9720), 1,
      sym__do,
    STATE(9721), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1526), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(1528), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(617), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(1756), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5150), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(278), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [10072] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7561), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [10207] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(8031), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [10342] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(687), 1,
      anon_sym_RPAREN,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    ACTIONS(1667), 1,
      sym__conid,
    ACTIONS(1671), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_BSLASH,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(700), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7262), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(647), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [10477] = 36,
    ACTIONS(241), 1,
      sym_hole,
    ACTIONS(251), 1,
      anon_sym_AT,
    ACTIONS(255), 1,
      anon_sym_if,
    ACTIONS(257), 1,
      anon_sym_case,
    ACTIONS(261), 1,
      anon_sym_BSLASH,
    ACTIONS(263), 1,
      anon_sym_do,
    ACTIONS(265), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(891), 1,
      sym__varid,
    ACTIONS(895), 1,
      sym_string,
    ACTIONS(897), 1,
      sym__integer_literal,
    ACTIONS(899), 1,
      sym__hex_literal,
    ACTIONS(901), 1,
      anon_sym_DASH,
    ACTIONS(903), 1,
      anon_sym_LPAREN,
    ACTIONS(905), 1,
      sym__conid,
    ACTIONS(907), 1,
      anon_sym_LBRACE,
    ACTIONS(909), 1,
      anon_sym_LBRACK,
    ACTIONS(911), 1,
      anon_sym_let,
    STATE(2134), 1,
      sym_constructor,
    STATE(2348), 1,
      sym__qcon,
    STATE(2395), 1,
      sym_exp_record_access,
    STATE(2408), 1,
      sym_qualified_constructor,
    STATE(5575), 1,
      aux_sym__qualifying_module,
    STATE(6055), 1,
      sym__exp_apply,
    STATE(8340), 1,
      sym_wildcard,
    STATE(9549), 1,
      sym__record_update_lhs,
    STATE(9550), 1,
      sym__do,
    STATE(9551), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1785), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1787), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(893), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2406), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6098), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(401), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [10612] = 36,
    ACTIONS(147), 1,
      sym_hole,
    ACTIONS(157), 1,
      anon_sym_AT,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_case,
    ACTIONS(169), 1,
      anon_sym_BSLASH,
    ACTIONS(171), 1,
      anon_sym_do,
    ACTIONS(173), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(989), 1,
      sym__varid,
    ACTIONS(993), 1,
      sym_string,
    ACTIONS(995), 1,
      sym__integer_literal,
    ACTIONS(997), 1,
      sym__hex_literal,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1005), 1,
      anon_sym_LBRACE,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(1011), 1,
      anon_sym_let,
    ACTIONS(1253), 1,
      anon_sym_DASH,
    ACTIONS(1255), 1,
      sym__conid,
    STATE(2107), 1,
      sym_constructor,
    STATE(2252), 1,
      sym__qcon,
    STATE(2485), 1,
      sym_qualified_constructor,
    STATE(2516), 1,
      sym_exp_record_access,
    STATE(5610), 1,
      aux_sym__qualifying_module,
    STATE(6169), 1,
      sym__exp_apply,
    STATE(8244), 1,
      sym_wildcard,
    STATE(9564), 1,
      sym__record_update_lhs,
    STATE(9565), 1,
      sym__do,
    STATE(9566), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1770), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1771), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(991), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2473), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5892), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(305), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [10747] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(575), 1,
      sym_hole,
    ACTIONS(585), 1,
      anon_sym_AT,
    ACTIONS(589), 1,
      anon_sym_if,
    ACTIONS(591), 1,
      anon_sym_case,
    ACTIONS(593), 1,
      anon_sym_let,
    ACTIONS(595), 1,
      anon_sym_BSLASH,
    ACTIONS(597), 1,
      anon_sym_do,
    ACTIONS(599), 1,
      anon_sym_ado,
    ACTIONS(1617), 1,
      sym__varid,
    ACTIONS(1621), 1,
      sym_string,
    ACTIONS(1623), 1,
      sym__integer_literal,
    ACTIONS(1625), 1,
      sym__hex_literal,
    ACTIONS(1627), 1,
      anon_sym_DASH,
    ACTIONS(1629), 1,
      anon_sym_LPAREN,
    ACTIONS(1631), 1,
      sym__conid,
    ACTIONS(1633), 1,
      anon_sym_LBRACE,
    ACTIONS(1635), 1,
      anon_sym_LBRACK,
    STATE(2812), 1,
      sym_constructor,
    STATE(2958), 1,
      sym__qcon,
    STATE(2963), 1,
      sym_qualified_constructor,
    STATE(2968), 1,
      sym_exp_record_access,
    STATE(5552), 1,
      aux_sym__qualifying_module,
    STATE(6842), 1,
      sym__exp_apply,
    STATE(8068), 1,
      sym_wildcard,
    STATE(9930), 1,
      sym__ado,
    STATE(9931), 1,
      sym__do,
    STATE(9937), 1,
      sym__record_update_lhs,
    STATE(10018), 1,
      sym__modid,
    STATE(2651), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2655), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1619), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2962), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6877), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(593), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [10882] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(539), 1,
      sym_hole,
    ACTIONS(549), 1,
      anon_sym_AT,
    ACTIONS(553), 1,
      anon_sym_if,
    ACTIONS(555), 1,
      anon_sym_case,
    ACTIONS(557), 1,
      anon_sym_let,
    ACTIONS(559), 1,
      anon_sym_BSLASH,
    ACTIONS(561), 1,
      anon_sym_do,
    ACTIONS(563), 1,
      anon_sym_ado,
    ACTIONS(1530), 1,
      sym__varid,
    ACTIONS(1534), 1,
      sym_string,
    ACTIONS(1536), 1,
      sym__integer_literal,
    ACTIONS(1538), 1,
      sym__hex_literal,
    ACTIONS(1540), 1,
      anon_sym_LPAREN,
    ACTIONS(1545), 1,
      anon_sym_LBRACE,
    ACTIONS(1549), 1,
      anon_sym_LBRACK,
    ACTIONS(1647), 1,
      anon_sym_DASH,
    ACTIONS(1649), 1,
      sym__conid,
    STATE(2546), 1,
      sym_constructor,
    STATE(2841), 1,
      sym_exp_record_access,
    STATE(2892), 1,
      sym_qualified_constructor,
    STATE(2896), 1,
      sym__qcon,
    STATE(5612), 1,
      aux_sym__qualifying_module,
    STATE(6683), 1,
      sym__exp_apply,
    STATE(8129), 1,
      sym_wildcard,
    STATE(9759), 1,
      sym__record_update_lhs,
    STATE(9760), 1,
      sym__do,
    STATE(9761), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2455), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2461), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1532), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2890), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6665), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(581), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [11017] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7714), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [11152] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7990), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [11287] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7821), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [11422] = 36,
    ACTIONS(147), 1,
      sym_hole,
    ACTIONS(157), 1,
      anon_sym_AT,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_case,
    ACTIONS(169), 1,
      anon_sym_BSLASH,
    ACTIONS(171), 1,
      anon_sym_do,
    ACTIONS(173), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(989), 1,
      sym__varid,
    ACTIONS(993), 1,
      sym_string,
    ACTIONS(995), 1,
      sym__integer_literal,
    ACTIONS(997), 1,
      sym__hex_literal,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1005), 1,
      anon_sym_LBRACE,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(1011), 1,
      anon_sym_let,
    ACTIONS(1253), 1,
      anon_sym_DASH,
    ACTIONS(1255), 1,
      sym__conid,
    STATE(2107), 1,
      sym_constructor,
    STATE(2252), 1,
      sym__qcon,
    STATE(2485), 1,
      sym_qualified_constructor,
    STATE(2516), 1,
      sym_exp_record_access,
    STATE(5610), 1,
      aux_sym__qualifying_module,
    STATE(6169), 1,
      sym__exp_apply,
    STATE(8244), 1,
      sym_wildcard,
    STATE(9564), 1,
      sym__record_update_lhs,
    STATE(9565), 1,
      sym__do,
    STATE(9566), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1770), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1771), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(991), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2473), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5967), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(305), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [11557] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1325), 1,
      sym__varid,
    ACTIONS(1329), 1,
      sym_string,
    ACTIONS(1331), 1,
      sym__integer_literal,
    ACTIONS(1333), 1,
      sym__hex_literal,
    ACTIONS(1337), 1,
      sym_hole,
    ACTIONS(1339), 1,
      anon_sym_DASH,
    ACTIONS(1341), 1,
      anon_sym_LPAREN,
    ACTIONS(1343), 1,
      sym__conid,
    ACTIONS(1345), 1,
      anon_sym_LBRACE,
    ACTIONS(1347), 1,
      anon_sym_AT,
    ACTIONS(1349), 1,
      anon_sym_LBRACK,
    ACTIONS(1351), 1,
      anon_sym_if,
    ACTIONS(1353), 1,
      anon_sym_case,
    ACTIONS(1355), 1,
      anon_sym_let,
    ACTIONS(1357), 1,
      anon_sym_BSLASH,
    ACTIONS(1359), 1,
      anon_sym_do,
    ACTIONS(1361), 1,
      anon_sym_ado,
    STATE(2386), 1,
      sym_constructor,
    STATE(2602), 1,
      sym_exp_record_access,
    STATE(2634), 1,
      sym__qcon,
    STATE(2653), 1,
      sym_qualified_constructor,
    STATE(5551), 1,
      aux_sym__qualifying_module,
    STATE(6282), 1,
      sym__exp_apply,
    STATE(8408), 1,
      sym_wildcard,
    STATE(9623), 1,
      sym__record_update_lhs,
    STATE(9624), 1,
      sym__do,
    STATE(9625), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1967), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(1968), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1327), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2656), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6242), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(516), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [11692] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7806), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [11827] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7719), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [11962] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1505), 1,
      anon_sym_BSLASH,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7332), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(624), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [12097] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(8011), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [12232] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(8028), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [12367] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1269), 1,
      anon_sym_DASH,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1393), 1,
      anon_sym_if,
    ACTIONS(1395), 1,
      anon_sym_let,
    ACTIONS(1397), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(8037), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(2646), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(595), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [12502] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(8037), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [12637] = 36,
    ACTIONS(241), 1,
      sym_hole,
    ACTIONS(251), 1,
      anon_sym_AT,
    ACTIONS(255), 1,
      anon_sym_if,
    ACTIONS(257), 1,
      anon_sym_case,
    ACTIONS(261), 1,
      anon_sym_BSLASH,
    ACTIONS(263), 1,
      anon_sym_do,
    ACTIONS(265), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(891), 1,
      sym__varid,
    ACTIONS(895), 1,
      sym_string,
    ACTIONS(897), 1,
      sym__integer_literal,
    ACTIONS(899), 1,
      sym__hex_literal,
    ACTIONS(901), 1,
      anon_sym_DASH,
    ACTIONS(903), 1,
      anon_sym_LPAREN,
    ACTIONS(905), 1,
      sym__conid,
    ACTIONS(907), 1,
      anon_sym_LBRACE,
    ACTIONS(909), 1,
      anon_sym_LBRACK,
    ACTIONS(911), 1,
      anon_sym_let,
    STATE(2134), 1,
      sym_constructor,
    STATE(2348), 1,
      sym__qcon,
    STATE(2395), 1,
      sym_exp_record_access,
    STATE(2408), 1,
      sym_qualified_constructor,
    STATE(5575), 1,
      aux_sym__qualifying_module,
    STATE(6055), 1,
      sym__exp_apply,
    STATE(8340), 1,
      sym_wildcard,
    STATE(9549), 1,
      sym__record_update_lhs,
    STATE(9550), 1,
      sym__do,
    STATE(9551), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1785), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1787), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(893), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2406), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5928), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(401), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [12772] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(690), 1,
      sym__varid,
    ACTIONS(694), 1,
      sym_string,
    ACTIONS(696), 1,
      sym__integer_literal,
    ACTIONS(698), 1,
      sym__hex_literal,
    ACTIONS(703), 1,
      sym_hole,
    ACTIONS(705), 1,
      anon_sym_LPAREN,
    ACTIONS(711), 1,
      anon_sym_LBRACE,
    ACTIONS(715), 1,
      anon_sym_LBRACK,
    ACTIONS(717), 1,
      anon_sym_if,
    ACTIONS(719), 1,
      anon_sym_case,
    ACTIONS(721), 1,
      anon_sym_let,
    ACTIONS(725), 1,
      anon_sym_do,
    ACTIONS(727), 1,
      anon_sym_ado,
    ACTIONS(1420), 1,
      anon_sym_DASH,
    ACTIONS(1422), 1,
      sym__conid,
    ACTIONS(1424), 1,
      anon_sym_AT,
    ACTIONS(1426), 1,
      anon_sym_BSLASH,
    STATE(1631), 1,
      sym_constructor,
    STATE(1882), 1,
      sym__qcon,
    STATE(1923), 1,
      sym_qualified_constructor,
    STATE(1940), 1,
      sym_exp_record_access,
    STATE(5237), 1,
      sym__exp_apply,
    STATE(5526), 1,
      aux_sym__qualifying_module,
    STATE(8330), 1,
      sym_wildcard,
    STATE(9501), 1,
      sym__record_update_lhs,
    STATE(9502), 1,
      sym__do,
    STATE(9503), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1532), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1538), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(692), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(1926), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5221), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(276), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [12907] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(740), 1,
      sym__varid,
    ACTIONS(744), 1,
      sym_string,
    ACTIONS(746), 1,
      sym__integer_literal,
    ACTIONS(748), 1,
      sym__hex_literal,
    ACTIONS(750), 1,
      sym_hole,
    ACTIONS(752), 1,
      anon_sym_LPAREN,
    ACTIONS(758), 1,
      anon_sym_LBRACE,
    ACTIONS(762), 1,
      anon_sym_LBRACK,
    ACTIONS(764), 1,
      anon_sym_if,
    ACTIONS(766), 1,
      anon_sym_case,
    ACTIONS(768), 1,
      anon_sym_let,
    ACTIONS(772), 1,
      anon_sym_do,
    ACTIONS(774), 1,
      anon_sym_ado,
    ACTIONS(1365), 1,
      anon_sym_DASH,
    ACTIONS(1367), 1,
      sym__conid,
    ACTIONS(1369), 1,
      anon_sym_AT,
    ACTIONS(1371), 1,
      anon_sym_BSLASH,
    STATE(1767), 1,
      sym_constructor,
    STATE(2091), 1,
      sym__qcon,
    STATE(2092), 1,
      sym_qualified_constructor,
    STATE(2204), 1,
      sym_exp_record_access,
    STATE(5459), 1,
      sym__exp_apply,
    STATE(5664), 1,
      aux_sym__qualifying_module,
    STATE(8070), 1,
      sym_wildcard,
    STATE(9679), 1,
      sym__record_update_lhs,
    STATE(9680), 1,
      sym__do,
    STATE(9681), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(1686), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(1688), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(742), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2097), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5530), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(280), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [13042] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7980), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [13177] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1487), 1,
      anon_sym_DASH,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1495), 1,
      anon_sym_AT,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    ACTIONS(1637), 1,
      anon_sym_if,
    ACTIONS(1639), 1,
      anon_sym_let,
    ACTIONS(1641), 1,
      anon_sym_BSLASH,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(7277), 1,
      sym__exp_apply,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7332), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(655), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [13312] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7650), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [13447] = 36,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(615), 1,
      anon_sym_RPAREN,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_if,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1503), 1,
      anon_sym_let,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    ACTIONS(1671), 1,
      anon_sym_AT,
    ACTIONS(1673), 1,
      anon_sym_BSLASH,
    ACTIONS(1675), 1,
      sym__conid,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(625), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7262), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(647), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [13582] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7593), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [13717] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7869), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [13852] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7781), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [13987] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7955), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [14122] = 36,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1269), 1,
      anon_sym_DASH,
    ACTIONS(1293), 1,
      sym__varid,
    ACTIONS(1297), 1,
      sym_string,
    ACTIONS(1299), 1,
      sym__integer_literal,
    ACTIONS(1301), 1,
      sym__hex_literal,
    ACTIONS(1303), 1,
      sym_hole,
    ACTIONS(1305), 1,
      anon_sym_LPAREN,
    ACTIONS(1307), 1,
      sym__conid,
    ACTIONS(1309), 1,
      anon_sym_LBRACE,
    ACTIONS(1311), 1,
      anon_sym_AT,
    ACTIONS(1313), 1,
      anon_sym_LBRACK,
    ACTIONS(1315), 1,
      anon_sym_if,
    ACTIONS(1317), 1,
      anon_sym_let,
    ACTIONS(1319), 1,
      anon_sym_BSLASH,
    ACTIONS(1321), 1,
      anon_sym_do,
    ACTIONS(1323), 1,
      anon_sym_ado,
    STATE(2591), 1,
      sym_constructor,
    STATE(2763), 1,
      sym__qcon,
    STATE(2849), 1,
      sym_qualified_constructor,
    STATE(2874), 1,
      sym_exp_record_access,
    STATE(5597), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(8497), 1,
      sym_wildcard,
    STATE(9451), 1,
      sym__record_update_lhs,
    STATE(9452), 1,
      sym__do,
    STATE(9453), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2250), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(2251), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1295), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2827), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(552), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [14257] = 36,
    ACTIONS(57), 1,
      sym_string,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(65), 1,
      sym_hole,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(81), 1,
      anon_sym_if,
    ACTIONS(83), 1,
      anon_sym_case,
    ACTIONS(85), 1,
      anon_sym_let,
    ACTIONS(89), 1,
      anon_sym_do,
    ACTIONS(91), 1,
      anon_sym_ado,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(607), 1,
      anon_sym_LPAREN,
    ACTIONS(609), 1,
      anon_sym_LBRACE,
    ACTIONS(611), 1,
      anon_sym_LBRACK,
    ACTIONS(1391), 1,
      anon_sym_AT,
    ACTIONS(1407), 1,
      anon_sym_DASH,
    ACTIONS(1409), 1,
      anon_sym_BSLASH,
    STATE(2680), 1,
      sym_constructor,
    STATE(2722), 1,
      sym_qualified_constructor,
    STATE(2809), 1,
      sym_exp_record_access,
    STATE(2873), 1,
      sym__qcon,
    STATE(5443), 1,
      aux_sym__qualifying_module,
    STATE(5968), 1,
      sym__exp_apply,
    STATE(7924), 1,
      sym_wildcard,
    STATE(9415), 1,
      sym__record_update_lhs,
    STATE(9416), 1,
      sym__do,
    STATE(9417), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2447), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2453), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(55), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2719), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6085), 7,
      sym_exp_negation,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__fexp,
      sym__lexp,
    STATE(564), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [14392] = 35,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    ACTIONS(1637), 1,
      anon_sym_if,
    ACTIONS(1639), 1,
      anon_sym_let,
    ACTIONS(1671), 1,
      anon_sym_AT,
    ACTIONS(1675), 1,
      sym__conid,
    ACTIONS(1678), 1,
      anon_sym_BSLASH,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(625), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7262), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(654), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [14524] = 35,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1479), 1,
      sym_string,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1485), 1,
      sym_hole,
    ACTIONS(1489), 1,
      anon_sym_LPAREN,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1501), 1,
      anon_sym_case,
    ACTIONS(1507), 1,
      anon_sym_do,
    ACTIONS(1509), 1,
      anon_sym_ado,
    ACTIONS(1637), 1,
      anon_sym_if,
    ACTIONS(1639), 1,
      anon_sym_let,
    ACTIONS(1667), 1,
      sym__conid,
    ACTIONS(1671), 1,
      anon_sym_AT,
    ACTIONS(1678), 1,
      anon_sym_BSLASH,
    STATE(2960), 1,
      sym_constructor,
    STATE(2971), 1,
      sym__qcon,
    STATE(2987), 1,
      sym_qualified_constructor,
    STATE(3000), 1,
      sym_exp_record_access,
    STATE(5511), 1,
      aux_sym__qualifying_module,
    STATE(8559), 1,
      sym_wildcard,
    STATE(9579), 1,
      sym__record_update_lhs,
    STATE(9580), 1,
      sym__do,
    STATE(9581), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(2783), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(2784), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(700), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1477), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(2991), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7262), 5,
      sym_exp_if,
      sym_exp_case,
      sym_exp_let_in,
      sym_exp_lambda,
      sym__exp_apply,
    STATE(654), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [14656] = 34,
    ACTIONS(1680), 1,
      sym__varid,
    ACTIONS(1684), 1,
      sym_string,
    ACTIONS(1686), 1,
      sym__integer_literal,
    ACTIONS(1688), 1,
      sym__hex_literal,
    ACTIONS(1690), 1,
      anon_sym__,
    ACTIONS(1692), 1,
      sym_hole,
    ACTIONS(1694), 1,
      anon_sym_LPAREN,
    ACTIONS(1696), 1,
      anon_sym_RPAREN,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(1700), 1,
      anon_sym_LBRACE,
    ACTIONS(1702), 1,
      anon_sym_AT,
    ACTIONS(1704), 1,
      anon_sym_LBRACK,
    ACTIONS(1706), 1,
      anon_sym_do,
    ACTIONS(1708), 1,
      anon_sym_ado,
    STATE(5359), 1,
      sym_variable,
    STATE(5461), 1,
      sym_exp_record_access,
    STATE(5466), 1,
      sym_qualified_variable,
    STATE(5497), 1,
      aux_sym__qualifying_module,
    STATE(5769), 1,
      sym_constructor,
    STATE(5820), 1,
      sym_qualified_constructor,
    STATE(5957), 1,
      sym_wildcard,
    STATE(6465), 1,
      sym__qcon,
    STATE(6466), 1,
      sym_literal,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(9517), 1,
      sym__record_update_lhs,
    STATE(9518), 1,
      sym__do,
    STATE(9519), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4985), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1682), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5822), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6831), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
    STATE(6014), 12,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [14784] = 33,
    ACTIONS(145), 1,
      anon_sym__,
    ACTIONS(1710), 1,
      sym__varid,
    ACTIONS(1714), 1,
      sym_string,
    ACTIONS(1716), 1,
      sym__integer_literal,
    ACTIONS(1718), 1,
      sym__hex_literal,
    ACTIONS(1720), 1,
      sym_hole,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1724), 1,
      sym__conid,
    ACTIONS(1726), 1,
      anon_sym_LBRACE,
    ACTIONS(1728), 1,
      anon_sym_AT,
    ACTIONS(1730), 1,
      anon_sym_LBRACK,
    ACTIONS(1732), 1,
      anon_sym_do,
    ACTIONS(1734), 1,
      anon_sym_ado,
    STATE(4375), 1,
      sym_variable,
    STATE(4946), 1,
      sym_qualified_variable,
    STATE(5037), 1,
      sym_constructor,
    STATE(5181), 1,
      sym_literal,
    STATE(5182), 1,
      sym__qcon,
    STATE(5297), 1,
      sym_qualified_constructor,
    STATE(5557), 1,
      aux_sym__qualifying_module,
    STATE(5563), 1,
      sym_exp_record_access,
    STATE(5622), 1,
      sym_wildcard,
    STATE(6567), 1,
      sym_pat_fields,
    STATE(9637), 1,
      sym__record_update_lhs,
    STATE(9638), 1,
      sym__do,
    STATE(9639), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4958), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1712), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5298), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6626), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
    STATE(6059), 12,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [14909] = 33,
    ACTIONS(145), 1,
      anon_sym__,
    ACTIONS(1736), 1,
      sym__varid,
    ACTIONS(1740), 1,
      sym_string,
    ACTIONS(1742), 1,
      sym__integer_literal,
    ACTIONS(1744), 1,
      sym__hex_literal,
    ACTIONS(1746), 1,
      sym_hole,
    ACTIONS(1748), 1,
      anon_sym_LPAREN,
    ACTIONS(1750), 1,
      sym__conid,
    ACTIONS(1752), 1,
      anon_sym_LBRACE,
    ACTIONS(1754), 1,
      anon_sym_AT,
    ACTIONS(1756), 1,
      anon_sym_LBRACK,
    ACTIONS(1758), 1,
      anon_sym_do,
    ACTIONS(1760), 1,
      anon_sym_ado,
    STATE(4370), 1,
      sym_variable,
    STATE(4937), 1,
      sym_constructor,
    STATE(5036), 1,
      sym_qualified_variable,
    STATE(5160), 1,
      sym_literal,
    STATE(5161), 1,
      sym__qcon,
    STATE(5252), 1,
      sym_qualified_constructor,
    STATE(5593), 1,
      aux_sym__qualifying_module,
    STATE(5602), 1,
      sym_wildcard,
    STATE(5605), 1,
      sym_exp_record_access,
    STATE(6567), 1,
      sym_pat_fields,
    STATE(9651), 1,
      sym__record_update_lhs,
    STATE(9652), 1,
      sym__do,
    STATE(9653), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(5041), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1738), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5253), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6626), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
    STATE(6219), 12,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [15034] = 33,
    ACTIONS(475), 1,
      anon_sym__,
    ACTIONS(1762), 1,
      sym__varid,
    ACTIONS(1766), 1,
      sym_string,
    ACTIONS(1768), 1,
      sym__integer_literal,
    ACTIONS(1770), 1,
      sym__hex_literal,
    ACTIONS(1772), 1,
      sym_hole,
    ACTIONS(1774), 1,
      anon_sym_LPAREN,
    ACTIONS(1776), 1,
      sym__conid,
    ACTIONS(1778), 1,
      anon_sym_LBRACE,
    ACTIONS(1780), 1,
      anon_sym_AT,
    ACTIONS(1782), 1,
      anon_sym_LBRACK,
    ACTIONS(1784), 1,
      anon_sym_do,
    ACTIONS(1786), 1,
      anon_sym_ado,
    STATE(4747), 1,
      sym_variable,
    STATE(4929), 1,
      sym_qualified_variable,
    STATE(5087), 1,
      sym_wildcard,
    STATE(5123), 1,
      sym_exp_record_access,
    STATE(5379), 1,
      sym_constructor,
    STATE(5406), 1,
      aux_sym__qualifying_module,
    STATE(5787), 1,
      sym_qualified_constructor,
    STATE(6049), 1,
      sym__qcon,
    STATE(6054), 1,
      sym_literal,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(9533), 1,
      sym__record_update_lhs,
    STATE(9534), 1,
      sym__do,
    STATE(9535), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4908), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1764), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6236), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
    STATE(5588), 12,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [15159] = 33,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1788), 1,
      sym__varid,
    ACTIONS(1792), 1,
      sym_string,
    ACTIONS(1794), 1,
      sym__integer_literal,
    ACTIONS(1796), 1,
      sym__hex_literal,
    ACTIONS(1798), 1,
      sym_hole,
    ACTIONS(1800), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      sym__conid,
    ACTIONS(1804), 1,
      anon_sym_LBRACE,
    ACTIONS(1806), 1,
      anon_sym_AT,
    ACTIONS(1808), 1,
      anon_sym_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_do,
    ACTIONS(1812), 1,
      anon_sym_ado,
    STATE(4727), 1,
      sym_variable,
    STATE(5389), 1,
      sym_constructor,
    STATE(5614), 1,
      aux_sym__qualifying_module,
    STATE(5697), 1,
      sym_qualified_variable,
    STATE(5799), 1,
      sym_qualified_constructor,
    STATE(6040), 1,
      sym__qcon,
    STATE(6042), 1,
      sym_literal,
    STATE(6268), 1,
      sym_wildcard,
    STATE(6358), 1,
      sym_exp_record_access,
    STATE(7097), 1,
      sym_pat_fields,
    STATE(9778), 1,
      sym__record_update_lhs,
    STATE(9779), 1,
      sym__do,
    STATE(9780), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(5698), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1790), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5815), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7507), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
    STATE(6670), 12,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [15284] = 33,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1814), 1,
      sym__varid,
    ACTIONS(1818), 1,
      sym_string,
    ACTIONS(1820), 1,
      sym__integer_literal,
    ACTIONS(1822), 1,
      sym__hex_literal,
    ACTIONS(1824), 1,
      sym_hole,
    ACTIONS(1826), 1,
      anon_sym_LPAREN,
    ACTIONS(1828), 1,
      sym__conid,
    ACTIONS(1830), 1,
      anon_sym_LBRACE,
    ACTIONS(1832), 1,
      anon_sym_AT,
    ACTIONS(1834), 1,
      anon_sym_LBRACK,
    ACTIONS(1836), 1,
      anon_sym_do,
    ACTIONS(1838), 1,
      anon_sym_ado,
    STATE(4984), 1,
      sym_variable,
    STATE(5637), 1,
      aux_sym__qualifying_module,
    STATE(5960), 1,
      sym_qualified_variable,
    STATE(6094), 1,
      sym_constructor,
    STATE(6271), 1,
      sym_qualified_constructor,
    STATE(6274), 1,
      sym_literal,
    STATE(6275), 1,
      sym__qcon,
    STATE(6338), 1,
      sym_wildcard,
    STATE(6518), 1,
      sym_exp_record_access,
    STATE(7097), 1,
      sym_pat_fields,
    STATE(9392), 1,
      sym__record_update_lhs,
    STATE(9393), 1,
      sym__do,
    STATE(9394), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(5953), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1816), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6278), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7507), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
    STATE(6915), 12,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [15409] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(1840), 1,
      sym__layout_end,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8111), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [15533] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(1842), 1,
      sym__layout_end,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8111), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [15657] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(1844), 1,
      sym__layout_end,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8111), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [15781] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(1846), 1,
      sym__layout_end,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7628), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [15905] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(1848), 1,
      anon_sym_LPAREN,
    ACTIONS(1850), 1,
      anon_sym_in,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3103), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6783), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8071), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6778), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(1852), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8537), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [16029] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(1854), 1,
      sym__layout_end,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8111), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [16153] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(1856), 1,
      sym__layout_end,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8111), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [16277] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(1858), 1,
      sym__layout_end,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7832), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [16401] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(1860), 1,
      sym__layout_end,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7707), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [16525] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(1848), 1,
      anon_sym_LPAREN,
    ACTIONS(1862), 1,
      anon_sym_in,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3103), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6783), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8071), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6778), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(1852), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7584), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [16649] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(1848), 1,
      anon_sym_LPAREN,
    ACTIONS(1864), 1,
      anon_sym_in,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3103), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6783), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8071), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6778), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(1852), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8537), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [16773] = 33,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    ACTIONS(1866), 1,
      sym__layout_end,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8111), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [16897] = 32,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(95), 1,
      anon_sym_LPAREN,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3126), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6866), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8163), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    STATE(6868), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8111), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [17018] = 32,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(1848), 1,
      anon_sym_LPAREN,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3103), 1,
      sym_variable,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6783), 1,
      sym__funlhs,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(8071), 1,
      sym__funpat,
    STATE(8732), 1,
      sym__funvar,
    STATE(10078), 1,
      sym__modid,
    STATE(6778), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(6781), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(1852), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8537), 6,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
      sym__decl_fun,
      sym__decl,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [17139] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1886), 1,
      anon_sym_RPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    STATE(1269), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7212), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9198), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3966), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9199), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9196), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [17260] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1898), 1,
      anon_sym_RPAREN,
    STATE(1149), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7397), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8876), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3918), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8873), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8888), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [17381] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1900), 1,
      anon_sym_RPAREN,
    STATE(1177), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7331), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8794), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3925), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8795), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8793), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [17502] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1902), 1,
      anon_sym_RPAREN,
    STATE(1180), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7319), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8810), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3926), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8811), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8809), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [17623] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1904), 1,
      anon_sym_RPAREN,
    STATE(1181), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7309), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8829), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3927), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8830), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8827), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [17744] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1906), 1,
      anon_sym_RPAREN,
    STATE(1184), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7293), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8848), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3928), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8849), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8846), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [17865] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1908), 1,
      anon_sym_RPAREN,
    STATE(1185), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7263), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8867), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3929), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8868), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8865), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [17986] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1910), 1,
      anon_sym_RPAREN,
    STATE(1187), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7249), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8886), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3930), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8887), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8884), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [18107] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1912), 1,
      anon_sym_RPAREN,
    STATE(1036), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7224), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9925), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3862), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9924), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9927), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [18228] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1914), 1,
      anon_sym_RPAREN,
    STATE(1240), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7448), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9102), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3837), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9030), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9086), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [18349] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1916), 1,
      anon_sym_RPAREN,
    STATE(1190), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7239), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8905), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3933), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8906), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8903), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [18470] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1918), 1,
      anon_sym_RPAREN,
    STATE(1138), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7176), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9964), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3859), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9962), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9965), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [18591] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1920), 1,
      anon_sym_RPAREN,
    STATE(1127), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7360), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9923), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3791), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9922), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9926), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [18712] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1922), 1,
      anon_sym_RPAREN,
    STATE(1196), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7222), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8924), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3934), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8925), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8922), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [18833] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1924), 1,
      anon_sym_RPAREN,
    STATE(1207), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7184), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8943), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3936), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8944), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8941), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [18954] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1926), 1,
      anon_sym_RPAREN,
    STATE(1209), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7172), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8962), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3937), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8963), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8960), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [19075] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1928), 1,
      anon_sym_RPAREN,
    STATE(1235), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7380), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8760), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3835), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8756), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8762), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [19196] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1930), 1,
      anon_sym_RPAREN,
    STATE(1213), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7162), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8981), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3883), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8982), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8979), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [19317] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1932), 1,
      anon_sym_RPAREN,
    STATE(1220), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7146), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9000), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3939), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9001), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8998), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [19438] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1934), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7110), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9018), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3947), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9019), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9016), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [19559] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      anon_sym_RPAREN,
    STATE(1099), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7099), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9036), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3949), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9037), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9034), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [19680] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1938), 1,
      anon_sym_RPAREN,
    STATE(1226), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7087), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9054), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3950), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9055), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9052), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [19801] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1940), 1,
      anon_sym_RPAREN,
    STATE(1239), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7069), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9072), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3951), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9073), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9070), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [19922] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1942), 1,
      anon_sym_RPAREN,
    STATE(1039), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7302), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9559), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3813), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9558), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9561), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [20043] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1944), 1,
      anon_sym_RPAREN,
    STATE(1241), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7033), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9090), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3952), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9091), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9088), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [20164] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1946), 1,
      anon_sym_RPAREN,
    STATE(1247), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7136), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(10009), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3856), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(10008), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(10010), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [20285] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1948), 1,
      anon_sym_RPAREN,
    STATE(1246), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7023), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9108), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3953), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9109), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9106), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [20406] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1950), 1,
      anon_sym_RPAREN,
    STATE(1248), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7011), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9126), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3960), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9127), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9124), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [20527] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1952), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6996), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9144), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3961), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9145), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9142), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [20648] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1954), 1,
      anon_sym_RPAREN,
    STATE(1068), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7408), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9672), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3808), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9670), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9673), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [20769] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1956), 1,
      anon_sym_RPAREN,
    STATE(1255), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6960), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9162), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3963), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9163), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9160), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [20890] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1958), 1,
      anon_sym_RPAREN,
    STATE(1267), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6948), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9180), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3964), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9181), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9178), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [21011] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1960), 1,
      anon_sym_RPAREN,
    STATE(1271), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6963), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9216), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3967), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9217), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9214), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [21132] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1962), 1,
      anon_sym_RPAREN,
    STATE(1169), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7369), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8764), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3920), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8765), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8763), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [21253] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1964), 1,
      anon_sym_RPAREN,
    STATE(1208), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7311), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8826), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3834), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8825), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8828), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [21374] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1966), 1,
      anon_sym_RPAREN,
    STATE(1249), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6972), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9234), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3938), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9235), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9232), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [21495] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1968), 1,
      anon_sym_RPAREN,
    STATE(1229), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7455), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9884), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3822), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9883), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9887), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [21616] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1970), 1,
      anon_sym_RPAREN,
    STATE(1262), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7001), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9252), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3972), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9253), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9250), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [21737] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1972), 1,
      anon_sym_RPAREN,
    STATE(1266), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7019), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9270), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3973), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9271), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9268), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [21858] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1974), 1,
      anon_sym_RPAREN,
    STATE(1172), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7361), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8779), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3924), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8780), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8777), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [21979] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1976), 1,
      anon_sym_RPAREN,
    STATE(1263), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7040), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9288), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3974), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9289), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9286), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [22100] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1978), 1,
      anon_sym_RPAREN,
    STATE(1151), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7386), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8748), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3919), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8749), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8746), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [22221] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1980), 1,
      anon_sym_RPAREN,
    STATE(1244), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7088), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(10048), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3855), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(10047), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(10049), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [22342] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1982), 1,
      anon_sym_RPAREN,
    STATE(1078), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7399), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9793), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3803), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9792), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9795), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [22463] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1984), 1,
      anon_sym_RPAREN,
    STATE(1040), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7044), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9294), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3826), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9290), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9297), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [22584] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1986), 1,
      anon_sym_RPAREN,
    STATE(1144), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7409), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9714), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3841), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9718), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9705), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [22705] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1988), 1,
      anon_sym_RPAREN,
    STATE(1043), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7339), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9819), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3844), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9820), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9816), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [22826] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1990), 1,
      anon_sym_RPAREN,
    STATE(1052), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7288), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9873), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3863), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9870), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9874), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [22947] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1992), 1,
      anon_sym_RPAREN,
    STATE(1140), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7402), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9999), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3827), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9998), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(10000), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [23068] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1994), 1,
      anon_sym_RPAREN,
    STATE(1132), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7086), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9056), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3830), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9053), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9060), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [23189] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1996), 1,
      anon_sym_RPAREN,
    STATE(1094), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6955), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9210), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3827), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9207), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9213), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [23310] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1998), 1,
      anon_sym_RPAREN,
    STATE(1059), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7310), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9842), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3864), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9841), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9843), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [23431] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2000), 1,
      anon_sym_RPAREN,
    STATE(1205), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7031), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(10078), 1,
      sym__modid,
    STATE(10111), 1,
      sym__row_variable,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3854), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(10105), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(10115), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [23552] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1968), 1,
      anon_sym_RPAREN,
    STATE(1229), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7455), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9884), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3872), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9883), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9887), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [23673] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2002), 1,
      anon_sym_RPAREN,
    STATE(1136), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7429), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8990), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3916), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8987), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8996), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [23794] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2004), 1,
      anon_sym_RPAREN,
    STATE(1232), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7516), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9381), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3838), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9396), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9375), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [23915] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2006), 1,
      anon_sym_RPAREN,
    STATE(1133), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7437), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9069), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3914), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9066), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9074), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [24036] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2008), 1,
      anon_sym_RPAREN,
    STATE(1123), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7452), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9161), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3839), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9156), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9174), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [24157] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2010), 1,
      anon_sym_RPAREN,
    STATE(1160), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7240), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8904), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3832), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8902), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8907), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [24278] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_RPAREN,
    STATE(1063), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7350), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9809), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3845), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9807), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9811), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [24399] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2014), 1,
      anon_sym_RPAREN,
    STATE(1091), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6976), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(10078), 1,
      sym__modid,
    STATE(10126), 1,
      sym__row_variable,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3853), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(10131), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(10123), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [24520] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2016), 1,
      anon_sym_RPAREN,
    STATE(1119), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7464), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9251), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3910), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9138), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9258), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [24641] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2018), 1,
      anon_sym_RPAREN,
    STATE(1106), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7073), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(10051), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3852), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(10052), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(10050), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [24762] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2020), 1,
      anon_sym_RPAREN,
    STATE(1116), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7478), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9324), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3904), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9322), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9326), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [24883] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2022), 1,
      anon_sym_RPAREN,
    STATE(1071), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7373), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9755), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3878), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9753), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9758), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [25004] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2024), 1,
      anon_sym_RPAREN,
    STATE(1105), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7009), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9132), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3829), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9128), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9135), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [25125] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2026), 1,
      anon_sym_RPAREN,
    STATE(1077), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7404), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9716), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3880), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9715), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9722), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [25246] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2028), 1,
      anon_sym_RPAREN,
    STATE(1188), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7486), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9545), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3815), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9563), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9531), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [25367] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2030), 1,
      anon_sym_RPAREN,
    STATE(1112), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7503), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9360), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3902), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9358), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9362), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [25488] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2032), 1,
      anon_sym_RPAREN,
    STATE(1103), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7472), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9869), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3766), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9866), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9872), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [25609] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2034), 1,
      anon_sym_RPAREN,
    STATE(1108), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7517), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9390), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3900), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9382), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9398), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [25730] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1992), 1,
      anon_sym_RPAREN,
    STATE(1140), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7402), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9999), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3761), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9998), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(10000), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [25851] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2036), 1,
      anon_sym_RPAREN,
    STATE(1060), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7131), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(10012), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3851), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(10013), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(10011), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [25972] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(1968), 1,
      anon_sym_RPAREN,
    STATE(1229), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7455), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9884), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3948), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9883), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9887), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [26093] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2038), 1,
      anon_sym_RPAREN,
    STATE(1079), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7425), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9676), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3881), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9674), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9683), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [26214] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2040), 1,
      anon_sym_RPAREN,
    STATE(1104), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7525), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9431), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3896), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8740), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9432), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [26335] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2042), 1,
      anon_sym_RPAREN,
    STATE(1072), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7126), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9386), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3825), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9385), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9391), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [26456] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2044), 1,
      anon_sym_RPAREN,
    STATE(1081), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7459), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9620), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3865), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9618), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9622), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [26577] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2046), 1,
      anon_sym_RPAREN,
    STATE(1153), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7163), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8980), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3831), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8978), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8983), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [26698] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2048), 1,
      anon_sym_RPAREN,
    STATE(1216), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7193), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9950), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3850), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9955), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9946), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [26819] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2050), 1,
      anon_sym_RPAREN,
    STATE(1083), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7482), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9568), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3884), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9567), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9573), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [26940] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2052), 1,
      anon_sym_RPAREN,
    STATE(1085), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7501), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9515), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3885), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9510), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9516), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [27061] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2054), 1,
      anon_sym_RPAREN,
    STATE(1102), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7535), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9466), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3886), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9461), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9472), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [27182] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2056), 1,
      anon_sym_RPAREN,
    STATE(1053), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7213), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9474), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3816), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9473), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9477), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [27303] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2058), 1,
      anon_sym_RPAREN,
    STATE(1254), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7251), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(9893), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3848), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(9894), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9890), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [27424] = 34,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1868), 1,
      sym__varid,
    ACTIONS(1870), 1,
      sym_string,
    ACTIONS(1872), 1,
      sym_triple_quote_string,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1890), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1894), 1,
      anon_sym_AT,
    ACTIONS(2060), 1,
      anon_sym_RPAREN,
    STATE(1224), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4358), 1,
      sym_type_variable,
    STATE(4683), 1,
      sym_integer,
    STATE(5978), 1,
      aux_sym__qualifying_module,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7134), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(10035), 1,
      sym__row_variable,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(1896), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3759), 2,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
    STATE(4686), 2,
      sym_qualified_type,
      sym__tyvar_annotated,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(10109), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(10113), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [27545] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9409), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9484), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8921), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [27656] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9092), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9938), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9939), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [27767] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8968), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9158), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9228), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [27878] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9236), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9934), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9312), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [27989] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9092), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9488), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9509), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [28100] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8854), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9776), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9357), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [28211] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8854), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9337), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9357), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [28322] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9159), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9236), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9312), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [28433] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(10063), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(10064), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(10065), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [28544] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9505), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9941), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9935), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [28655] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8930), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9159), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8999), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [28766] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9336), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9376), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9020), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [28877] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9602), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(10032), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(10021), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [28988] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9002), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9660), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9685), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [29099] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9409), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(10117), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8921), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [29210] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8869), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(8920), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8772), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [29321] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9882), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(10064), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9878), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [29432] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9395), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9885), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9489), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [29543] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9081), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9484), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9150), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [29654] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(10063), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(10141), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(10007), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [29765] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8869), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9483), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8772), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [29876] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9120), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9329), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9404), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [29987] = 31,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2084), 1,
      sym__varid,
    ACTIONS(2088), 1,
      sym_string,
    ACTIONS(2090), 1,
      sym_triple_quote_string,
    ACTIONS(2092), 1,
      sym__integer_literal,
    ACTIONS(2094), 1,
      sym__hex_literal,
    ACTIONS(2098), 1,
      anon_sym__,
    ACTIONS(2100), 1,
      sym_hole,
    ACTIONS(2102), 1,
      anon_sym_LPAREN,
    ACTIONS(2104), 1,
      sym__conid,
    ACTIONS(2106), 1,
      anon_sym_PIPE,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2110), 1,
      anon_sym_AT,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    STATE(1282), 1,
      sym_forall,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(4180), 1,
      sym_qualified_type,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4671), 1,
      aux_sym__quantifiers_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7608), 1,
      sym_fundeps,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2096), 2,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
    STATE(3040), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(890), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2086), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3096), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1412), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [30100] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8778), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9776), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(8845), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [30211] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9813), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9818), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9808), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [30322] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9483), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9791), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9810), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [30433] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9329), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9876), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9404), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [30544] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(10063), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(10064), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9387), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [30655] = 30,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1684), 1,
      sym_string,
    ACTIONS(1686), 1,
      sym__integer_literal,
    ACTIONS(1688), 1,
      sym__hex_literal,
    ACTIONS(1692), 1,
      sym_hole,
    ACTIONS(1696), 1,
      anon_sym_RPAREN,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(1702), 1,
      anon_sym_AT,
    ACTIONS(1706), 1,
      anon_sym_do,
    ACTIONS(1708), 1,
      anon_sym_ado,
    ACTIONS(2114), 1,
      sym__varid,
    ACTIONS(2116), 1,
      anon_sym_LPAREN,
    ACTIONS(2118), 1,
      anon_sym_LBRACE,
    ACTIONS(2120), 1,
      anon_sym_LBRACK,
    STATE(5461), 1,
      sym_exp_record_access,
    STATE(5497), 1,
      aux_sym__qualifying_module,
    STATE(5769), 1,
      sym_constructor,
    STATE(5820), 1,
      sym_qualified_constructor,
    STATE(6071), 1,
      sym__qcon,
    STATE(8454), 1,
      sym_wildcard,
    STATE(9517), 1,
      sym__record_update_lhs,
    STATE(9518), 1,
      sym__do,
    STATE(9519), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4985), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(5466), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1682), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5822), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6014), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [30766] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9002), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9990), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(10001), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [30877] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9885), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9941), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9935), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [30988] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8860), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9660), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9685), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [31099] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(10063), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(10064), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9323), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [31210] = 31,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(9885), 1,
      sym_qualified_constructor_operator,
    STATE(9951), 1,
      sym_constructor_operator,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9941), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9935), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [31323] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(10034), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(10140), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(10129), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [31434] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9942), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(10032), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(10021), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [31545] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8743), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9336), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9020), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [31656] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9009), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9120), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9071), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [31767] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9634), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(10140), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(10129), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [31878] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8841), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9488), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9509), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [31989] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(10063), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(10064), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(10007), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [32100] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9693), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(10034), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9684), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [32211] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9376), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(9879), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9880), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [32322] = 31,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(9338), 1,
      sym_constructor_operator,
    STATE(9885), 1,
      sym_qualified_constructor_operator,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9941), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9935), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [32435] = 31,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2088), 1,
      sym_string,
    ACTIONS(2090), 1,
      sym_triple_quote_string,
    ACTIONS(2092), 1,
      sym__integer_literal,
    ACTIONS(2094), 1,
      sym__hex_literal,
    ACTIONS(2098), 1,
      anon_sym__,
    ACTIONS(2100), 1,
      sym_hole,
    ACTIONS(2104), 1,
      sym__conid,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2122), 1,
      sym__varid,
    ACTIONS(2124), 1,
      anon_sym_LPAREN,
    ACTIONS(2126), 1,
      anon_sym_PIPE,
    ACTIONS(2128), 1,
      anon_sym_AT,
    STATE(1282), 1,
      sym_forall,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(4180), 1,
      sym_qualified_type,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4519), 1,
      aux_sym__quantifiers_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(7740), 1,
      sym_fundeps,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2096), 2,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
    STATE(3040), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(890), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2086), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3101), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1412), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [32548] = 30,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2074), 1,
      anon_sym_DASH,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6773), 1,
      aux_sym__qualifying_module,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(10142), 1,
      sym__modid,
    STATE(7378), 2,
      sym_pat_infix,
      sym__pat,
    STATE(9599), 2,
      sym_pat_typed,
      sym__typed_pat,
    STATE(9942), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(9588), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [32659] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1746), 1,
      sym_hole,
    ACTIONS(1754), 1,
      anon_sym_AT,
    ACTIONS(1758), 1,
      anon_sym_do,
    ACTIONS(1760), 1,
      anon_sym_ado,
    ACTIONS(2130), 1,
      sym__varid,
    ACTIONS(2134), 1,
      sym_string,
    ACTIONS(2136), 1,
      sym__integer_literal,
    ACTIONS(2138), 1,
      sym__hex_literal,
    ACTIONS(2140), 1,
      anon_sym_LPAREN,
    ACTIONS(2142), 1,
      sym__conid,
    ACTIONS(2144), 1,
      anon_sym_LBRACE,
    ACTIONS(2146), 1,
      anon_sym_LBRACK,
    STATE(5422), 1,
      sym_constructor,
    STATE(5605), 1,
      sym_exp_record_access,
    STATE(5655), 1,
      aux_sym__qualifying_module,
    STATE(5810), 1,
      sym__qcon,
    STATE(5872), 1,
      sym_qualified_constructor,
    STATE(8128), 1,
      sym_wildcard,
    STATE(9651), 1,
      sym__record_update_lhs,
    STATE(9652), 1,
      sym__do,
    STATE(9653), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(5036), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(5041), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2132), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5879), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6219), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [32767] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(2148), 1,
      sym__varid,
    ACTIONS(2152), 1,
      sym_string,
    ACTIONS(2154), 1,
      sym__integer_literal,
    ACTIONS(2156), 1,
      sym__hex_literal,
    ACTIONS(2158), 1,
      sym_hole,
    ACTIONS(2160), 1,
      anon_sym_LPAREN,
    ACTIONS(2162), 1,
      sym__conid,
    ACTIONS(2164), 1,
      anon_sym_LBRACE,
    ACTIONS(2166), 1,
      anon_sym_AT,
    ACTIONS(2168), 1,
      anon_sym_LBRACK,
    ACTIONS(2170), 1,
      anon_sym_do,
    ACTIONS(2172), 1,
      anon_sym_ado,
    STATE(4990), 1,
      sym_constructor,
    STATE(5021), 1,
      sym_exp_record_access,
    STATE(5066), 1,
      sym__qcon,
    STATE(5330), 1,
      sym_qualified_constructor,
    STATE(5535), 1,
      aux_sym__qualifying_module,
    STATE(8479), 1,
      sym_wildcard,
    STATE(9594), 1,
      sym__record_update_lhs,
    STATE(9595), 1,
      sym__do,
    STATE(9596), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4528), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(4548), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2150), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5315), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5183), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [32875] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1824), 1,
      sym_hole,
    ACTIONS(1832), 1,
      anon_sym_AT,
    ACTIONS(1836), 1,
      anon_sym_do,
    ACTIONS(1838), 1,
      anon_sym_ado,
    ACTIONS(2174), 1,
      sym__varid,
    ACTIONS(2178), 1,
      sym_string,
    ACTIONS(2180), 1,
      sym__integer_literal,
    ACTIONS(2182), 1,
      sym__hex_literal,
    ACTIONS(2184), 1,
      anon_sym_LPAREN,
    ACTIONS(2186), 1,
      sym__conid,
    ACTIONS(2188), 1,
      anon_sym_LBRACE,
    ACTIONS(2190), 1,
      anon_sym_LBRACK,
    STATE(5649), 1,
      aux_sym__qualifying_module,
    STATE(6416), 1,
      sym_constructor,
    STATE(6518), 1,
      sym_exp_record_access,
    STATE(6873), 1,
      sym__qcon,
    STATE(6932), 1,
      sym_qualified_constructor,
    STATE(8141), 1,
      sym_wildcard,
    STATE(9392), 1,
      sym__record_update_lhs,
    STATE(9393), 1,
      sym__do,
    STATE(9394), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(5953), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(5960), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2176), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6934), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6915), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [32983] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(2192), 1,
      sym__varid,
    ACTIONS(2196), 1,
      sym_string,
    ACTIONS(2198), 1,
      sym__integer_literal,
    ACTIONS(2200), 1,
      sym__hex_literal,
    ACTIONS(2202), 1,
      sym_hole,
    ACTIONS(2204), 1,
      anon_sym_LPAREN,
    ACTIONS(2206), 1,
      sym__conid,
    ACTIONS(2208), 1,
      anon_sym_LBRACE,
    ACTIONS(2210), 1,
      anon_sym_AT,
    ACTIONS(2212), 1,
      anon_sym_LBRACK,
    ACTIONS(2214), 1,
      anon_sym_do,
    ACTIONS(2216), 1,
      anon_sym_ado,
    STATE(5115), 1,
      sym_constructor,
    STATE(5276), 1,
      sym_exp_record_access,
    STATE(5508), 1,
      sym_qualified_constructor,
    STATE(5531), 1,
      aux_sym__qualifying_module,
    STATE(5677), 1,
      sym__qcon,
    STATE(8441), 1,
      sym_wildcard,
    STATE(9709), 1,
      sym__record_update_lhs,
    STATE(9710), 1,
      sym__do,
    STATE(9711), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4852), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(4862), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2194), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5509), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5437), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [33091] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(2218), 1,
      sym__varid,
    ACTIONS(2222), 1,
      sym_string,
    ACTIONS(2224), 1,
      sym__integer_literal,
    ACTIONS(2226), 1,
      sym__hex_literal,
    ACTIONS(2228), 1,
      sym_hole,
    ACTIONS(2230), 1,
      anon_sym_LPAREN,
    ACTIONS(2232), 1,
      sym__conid,
    ACTIONS(2234), 1,
      anon_sym_LBRACE,
    ACTIONS(2236), 1,
      anon_sym_AT,
    ACTIONS(2238), 1,
      anon_sym_LBRACK,
    ACTIONS(2240), 1,
      anon_sym_do,
    ACTIONS(2242), 1,
      anon_sym_ado,
    STATE(5016), 1,
      sym_exp_record_access,
    STATE(5058), 1,
      sym_constructor,
    STATE(5082), 1,
      sym__qcon,
    STATE(5216), 1,
      sym_qualified_constructor,
    STATE(5641), 1,
      aux_sym__qualifying_module,
    STATE(8067), 1,
      sym_wildcard,
    STATE(9749), 1,
      sym__record_update_lhs,
    STATE(9750), 1,
      sym__do,
    STATE(9751), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4532), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(4533), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2220), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5214), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5078), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [33199] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(2244), 1,
      sym__varid,
    ACTIONS(2248), 1,
      sym_string,
    ACTIONS(2250), 1,
      sym__integer_literal,
    ACTIONS(2252), 1,
      sym__hex_literal,
    ACTIONS(2254), 1,
      sym_hole,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2258), 1,
      sym__conid,
    ACTIONS(2260), 1,
      anon_sym_LBRACE,
    ACTIONS(2262), 1,
      anon_sym_AT,
    ACTIONS(2264), 1,
      anon_sym_LBRACK,
    ACTIONS(2266), 1,
      anon_sym_do,
    ACTIONS(2268), 1,
      anon_sym_ado,
    STATE(5631), 1,
      aux_sym__qualifying_module,
    STATE(6801), 1,
      sym_exp_record_access,
    STATE(6904), 1,
      sym_constructor,
    STATE(7041), 1,
      sym_qualified_constructor,
    STATE(7377), 1,
      sym__qcon,
    STATE(8212), 1,
      sym_wildcard,
    STATE(9665), 1,
      sym__record_update_lhs,
    STATE(9666), 1,
      sym__do,
    STATE(9667), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(6235), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(6237), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2246), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7057), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7271), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [33307] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1720), 1,
      sym_hole,
    ACTIONS(1728), 1,
      anon_sym_AT,
    ACTIONS(1732), 1,
      anon_sym_do,
    ACTIONS(1734), 1,
      anon_sym_ado,
    ACTIONS(2270), 1,
      sym__varid,
    ACTIONS(2274), 1,
      sym_string,
    ACTIONS(2276), 1,
      sym__integer_literal,
    ACTIONS(2278), 1,
      sym__hex_literal,
    ACTIONS(2280), 1,
      anon_sym_LPAREN,
    ACTIONS(2282), 1,
      sym__conid,
    ACTIONS(2284), 1,
      anon_sym_LBRACE,
    ACTIONS(2286), 1,
      anon_sym_LBRACK,
    STATE(5435), 1,
      sym_constructor,
    STATE(5563), 1,
      sym_exp_record_access,
    STATE(5666), 1,
      aux_sym__qualifying_module,
    STATE(5798), 1,
      sym__qcon,
    STATE(5901), 1,
      sym_qualified_constructor,
    STATE(8177), 1,
      sym_wildcard,
    STATE(9637), 1,
      sym__record_update_lhs,
    STATE(9638), 1,
      sym__do,
    STATE(9639), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4946), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(4958), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2272), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5961), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6059), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [33415] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1766), 1,
      sym_string,
    ACTIONS(1768), 1,
      sym__integer_literal,
    ACTIONS(1770), 1,
      sym__hex_literal,
    ACTIONS(1772), 1,
      sym_hole,
    ACTIONS(1776), 1,
      sym__conid,
    ACTIONS(1780), 1,
      anon_sym_AT,
    ACTIONS(1784), 1,
      anon_sym_do,
    ACTIONS(1786), 1,
      anon_sym_ado,
    ACTIONS(2288), 1,
      sym__varid,
    ACTIONS(2290), 1,
      anon_sym_LPAREN,
    ACTIONS(2292), 1,
      anon_sym_LBRACE,
    ACTIONS(2294), 1,
      anon_sym_LBRACK,
    STATE(5123), 1,
      sym_exp_record_access,
    STATE(5379), 1,
      sym_constructor,
    STATE(5406), 1,
      aux_sym__qualifying_module,
    STATE(5454), 1,
      sym__qcon,
    STATE(5787), 1,
      sym_qualified_constructor,
    STATE(8535), 1,
      sym_wildcard,
    STATE(9533), 1,
      sym__record_update_lhs,
    STATE(9534), 1,
      sym__do,
    STATE(9535), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4908), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(4929), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1764), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5588), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [33523] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1766), 1,
      sym_string,
    ACTIONS(1768), 1,
      sym__integer_literal,
    ACTIONS(1770), 1,
      sym__hex_literal,
    ACTIONS(1772), 1,
      sym_hole,
    ACTIONS(1776), 1,
      sym__conid,
    ACTIONS(1780), 1,
      anon_sym_AT,
    ACTIONS(1784), 1,
      anon_sym_do,
    ACTIONS(1786), 1,
      anon_sym_ado,
    ACTIONS(2288), 1,
      sym__varid,
    ACTIONS(2290), 1,
      anon_sym_LPAREN,
    ACTIONS(2292), 1,
      anon_sym_LBRACE,
    ACTIONS(2294), 1,
      anon_sym_LBRACK,
    STATE(5123), 1,
      sym_exp_record_access,
    STATE(5379), 1,
      sym_constructor,
    STATE(5406), 1,
      aux_sym__qualifying_module,
    STATE(5454), 1,
      sym__qcon,
    STATE(5787), 1,
      sym_qualified_constructor,
    STATE(8535), 1,
      sym_wildcard,
    STATE(9533), 1,
      sym__record_update_lhs,
    STATE(9534), 1,
      sym__do,
    STATE(9535), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4908), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(5071), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1764), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5588), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [33631] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(2296), 1,
      sym__varid,
    ACTIONS(2300), 1,
      sym_string,
    ACTIONS(2302), 1,
      sym__integer_literal,
    ACTIONS(2304), 1,
      sym__hex_literal,
    ACTIONS(2306), 1,
      sym_hole,
    ACTIONS(2308), 1,
      anon_sym_LPAREN,
    ACTIONS(2310), 1,
      sym__conid,
    ACTIONS(2312), 1,
      anon_sym_LBRACE,
    ACTIONS(2314), 1,
      anon_sym_AT,
    ACTIONS(2316), 1,
      anon_sym_LBRACK,
    ACTIONS(2318), 1,
      anon_sym_do,
    ACTIONS(2320), 1,
      anon_sym_ado,
    STATE(5168), 1,
      sym_constructor,
    STATE(5267), 1,
      sym_exp_record_access,
    STATE(5543), 1,
      aux_sym__qualifying_module,
    STATE(5570), 1,
      sym__qcon,
    STATE(5671), 1,
      sym_qualified_constructor,
    STATE(8186), 1,
      sym_wildcard,
    STATE(9485), 1,
      sym__record_update_lhs,
    STATE(9486), 1,
      sym__do,
    STATE(9487), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4883), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(4914), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2298), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5670), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5652), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [33739] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1684), 1,
      sym_string,
    ACTIONS(1686), 1,
      sym__integer_literal,
    ACTIONS(1688), 1,
      sym__hex_literal,
    ACTIONS(1692), 1,
      sym_hole,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(1702), 1,
      anon_sym_AT,
    ACTIONS(1706), 1,
      anon_sym_do,
    ACTIONS(1708), 1,
      anon_sym_ado,
    ACTIONS(2114), 1,
      sym__varid,
    ACTIONS(2116), 1,
      anon_sym_LPAREN,
    ACTIONS(2118), 1,
      anon_sym_LBRACE,
    ACTIONS(2120), 1,
      anon_sym_LBRACK,
    STATE(5461), 1,
      sym_exp_record_access,
    STATE(5497), 1,
      aux_sym__qualifying_module,
    STATE(5769), 1,
      sym_constructor,
    STATE(5820), 1,
      sym_qualified_constructor,
    STATE(6071), 1,
      sym__qcon,
    STATE(8454), 1,
      sym_wildcard,
    STATE(9517), 1,
      sym__record_update_lhs,
    STATE(9518), 1,
      sym__do,
    STATE(9519), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4985), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(5466), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1682), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5822), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6014), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [33847] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(2322), 1,
      sym__varid,
    ACTIONS(2326), 1,
      sym_string,
    ACTIONS(2328), 1,
      sym__integer_literal,
    ACTIONS(2330), 1,
      sym__hex_literal,
    ACTIONS(2332), 1,
      sym_hole,
    ACTIONS(2334), 1,
      anon_sym_LPAREN,
    ACTIONS(2336), 1,
      sym__conid,
    ACTIONS(2338), 1,
      anon_sym_LBRACE,
    ACTIONS(2340), 1,
      anon_sym_AT,
    ACTIONS(2342), 1,
      anon_sym_LBRACK,
    ACTIONS(2344), 1,
      anon_sym_do,
    ACTIONS(2346), 1,
      anon_sym_ado,
    STATE(5107), 1,
      sym_constructor,
    STATE(5361), 1,
      sym_exp_record_access,
    STATE(5441), 1,
      sym_qualified_constructor,
    STATE(5731), 1,
      aux_sym__qualifying_module,
    STATE(5735), 1,
      sym__qcon,
    STATE(8317), 1,
      sym_wildcard,
    STATE(9729), 1,
      sym__record_update_lhs,
    STATE(9730), 1,
      sym__do,
    STATE(9731), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4749), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(4753), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2324), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5442), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5423), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [33955] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(2348), 1,
      sym__varid,
    ACTIONS(2352), 1,
      sym_string,
    ACTIONS(2354), 1,
      sym__integer_literal,
    ACTIONS(2356), 1,
      sym__hex_literal,
    ACTIONS(2358), 1,
      sym_hole,
    ACTIONS(2360), 1,
      anon_sym_LPAREN,
    ACTIONS(2362), 1,
      sym__conid,
    ACTIONS(2364), 1,
      anon_sym_LBRACE,
    ACTIONS(2366), 1,
      anon_sym_AT,
    ACTIONS(2368), 1,
      anon_sym_LBRACK,
    ACTIONS(2370), 1,
      anon_sym_do,
    ACTIONS(2372), 1,
      anon_sym_ado,
    STATE(4980), 1,
      sym_constructor,
    STATE(4998), 1,
      sym_exp_record_access,
    STATE(5324), 1,
      sym_qualified_constructor,
    STATE(5335), 1,
      sym__qcon,
    STATE(5630), 1,
      aux_sym__qualifying_module,
    STATE(8073), 1,
      sym_wildcard,
    STATE(9769), 1,
      sym__record_update_lhs,
    STATE(9770), 1,
      sym__do,
    STATE(9771), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4543), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(4545), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2350), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5322), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(5194), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [34063] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1684), 1,
      sym_string,
    ACTIONS(1686), 1,
      sym__integer_literal,
    ACTIONS(1688), 1,
      sym__hex_literal,
    ACTIONS(1692), 1,
      sym_hole,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(1702), 1,
      anon_sym_AT,
    ACTIONS(1706), 1,
      anon_sym_do,
    ACTIONS(1708), 1,
      anon_sym_ado,
    ACTIONS(2114), 1,
      sym__varid,
    ACTIONS(2116), 1,
      anon_sym_LPAREN,
    ACTIONS(2118), 1,
      anon_sym_LBRACE,
    ACTIONS(2120), 1,
      anon_sym_LBRACK,
    STATE(5461), 1,
      sym_exp_record_access,
    STATE(5497), 1,
      aux_sym__qualifying_module,
    STATE(5769), 1,
      sym_constructor,
    STATE(5820), 1,
      sym_qualified_constructor,
    STATE(6071), 1,
      sym__qcon,
    STATE(8454), 1,
      sym_wildcard,
    STATE(9517), 1,
      sym__record_update_lhs,
    STATE(9518), 1,
      sym__do,
    STATE(9519), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(4985), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(5067), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(1682), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5822), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6014), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [34171] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(1798), 1,
      sym_hole,
    ACTIONS(1806), 1,
      anon_sym_AT,
    ACTIONS(1810), 1,
      anon_sym_do,
    ACTIONS(1812), 1,
      anon_sym_ado,
    ACTIONS(2374), 1,
      sym__varid,
    ACTIONS(2378), 1,
      sym_string,
    ACTIONS(2380), 1,
      sym__integer_literal,
    ACTIONS(2382), 1,
      sym__hex_literal,
    ACTIONS(2384), 1,
      anon_sym_LPAREN,
    ACTIONS(2386), 1,
      sym__conid,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2390), 1,
      anon_sym_LBRACK,
    STATE(5598), 1,
      aux_sym__qualifying_module,
    STATE(6356), 1,
      sym_constructor,
    STATE(6358), 1,
      sym_exp_record_access,
    STATE(6487), 1,
      sym_qualified_constructor,
    STATE(6708), 1,
      sym__qcon,
    STATE(8231), 1,
      sym_wildcard,
    STATE(9778), 1,
      sym__record_update_lhs,
    STATE(9779), 1,
      sym__do,
    STATE(9780), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(5697), 2,
      sym_variable,
      sym_qualified_variable,
    STATE(5698), 2,
      sym_record_literal,
      sym_exp_parens,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2376), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6480), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6670), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [34279] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(2392), 1,
      sym__varid,
    ACTIONS(2396), 1,
      sym_string,
    ACTIONS(2398), 1,
      sym__integer_literal,
    ACTIONS(2400), 1,
      sym__hex_literal,
    ACTIONS(2402), 1,
      sym_hole,
    ACTIONS(2404), 1,
      anon_sym_LPAREN,
    ACTIONS(2406), 1,
      sym__conid,
    ACTIONS(2408), 1,
      anon_sym_LBRACE,
    ACTIONS(2410), 1,
      anon_sym_AT,
    ACTIONS(2412), 1,
      anon_sym_LBRACK,
    ACTIONS(2414), 1,
      anon_sym_do,
    ACTIONS(2416), 1,
      anon_sym_ado,
    STATE(5458), 1,
      sym_constructor,
    STATE(5595), 1,
      aux_sym__qualifying_module,
    STATE(5650), 1,
      sym_exp_record_access,
    STATE(5977), 1,
      sym_qualified_constructor,
    STATE(6116), 1,
      sym__qcon,
    STATE(8282), 1,
      sym_wildcard,
    STATE(9796), 1,
      sym__record_update_lhs,
    STATE(9797), 1,
      sym__do,
    STATE(9798), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(5050), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(5053), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2394), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(5976), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6150), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [34387] = 29,
    ACTIONS(537), 1,
      anon_sym__,
    ACTIONS(2418), 1,
      sym__varid,
    ACTIONS(2422), 1,
      sym_string,
    ACTIONS(2424), 1,
      sym__integer_literal,
    ACTIONS(2426), 1,
      sym__hex_literal,
    ACTIONS(2428), 1,
      sym_hole,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    ACTIONS(2432), 1,
      sym__conid,
    ACTIONS(2434), 1,
      anon_sym_LBRACE,
    ACTIONS(2436), 1,
      anon_sym_AT,
    ACTIONS(2438), 1,
      anon_sym_LBRACK,
    ACTIONS(2440), 1,
      anon_sym_do,
    ACTIONS(2442), 1,
      anon_sym_ado,
    STATE(5696), 1,
      aux_sym__qualifying_module,
    STATE(5929), 1,
      sym_exp_record_access,
    STATE(6106), 1,
      sym_constructor,
    STATE(6262), 1,
      sym_qualified_constructor,
    STATE(6290), 1,
      sym__qcon,
    STATE(8510), 1,
      sym_wildcard,
    STATE(9699), 1,
      sym__record_update_lhs,
    STATE(9700), 1,
      sym__do,
    STATE(9701), 1,
      sym__ado,
    STATE(10018), 1,
      sym__modid,
    STATE(5230), 2,
      sym_record_literal,
      sym_exp_parens,
    STATE(5233), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2420), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6229), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6291), 13,
      sym_literal,
      sym_record_update,
      sym_exp_name,
      sym_exp_type_application,
      sym_exp_array,
      sym_exp_section_left,
      sym_exp_section_right,
      sym_record_accessor,
      sym_exp_do,
      sym_exp_ado,
      sym__do_or_ado_block,
      sym__aexp_projection,
      sym__aexp,
  [34495] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2446), 1,
      sym__varid,
    ACTIONS(2448), 1,
      sym_string,
    ACTIONS(2450), 1,
      sym_triple_quote_string,
    ACTIONS(2452), 1,
      sym__integer_literal,
    ACTIONS(2454), 1,
      sym__hex_literal,
    ACTIONS(2456), 1,
      anon_sym__,
    ACTIONS(2458), 1,
      sym_hole,
    ACTIONS(2460), 1,
      anon_sym_LPAREN,
    ACTIONS(2462), 1,
      sym__conid,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_AT,
    STATE(1332), 1,
      sym_forall,
    STATE(3107), 1,
      sym_constructor,
    STATE(3261), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2096), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(2731), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(828), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2444), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1014), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [34597] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2468), 1,
      sym__varid,
    ACTIONS(2472), 1,
      sym_string,
    ACTIONS(2474), 1,
      sym_triple_quote_string,
    ACTIONS(2476), 1,
      sym__integer_literal,
    ACTIONS(2478), 1,
      sym__hex_literal,
    ACTIONS(2482), 1,
      anon_sym__,
    ACTIONS(2484), 1,
      sym_hole,
    ACTIONS(2486), 1,
      anon_sym_LPAREN,
    ACTIONS(2488), 1,
      sym__conid,
    ACTIONS(2490), 1,
      anon_sym_LBRACE,
    ACTIONS(2492), 1,
      anon_sym_AT,
    STATE(1341), 1,
      sym_forall,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2480), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(2741), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(830), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2470), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1030), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [34699] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2468), 1,
      sym__varid,
    ACTIONS(2472), 1,
      sym_string,
    ACTIONS(2474), 1,
      sym_triple_quote_string,
    ACTIONS(2476), 1,
      sym__integer_literal,
    ACTIONS(2478), 1,
      sym__hex_literal,
    ACTIONS(2482), 1,
      anon_sym__,
    ACTIONS(2484), 1,
      sym_hole,
    ACTIONS(2486), 1,
      anon_sym_LPAREN,
    ACTIONS(2488), 1,
      sym__conid,
    ACTIONS(2490), 1,
      anon_sym_LBRACE,
    ACTIONS(2492), 1,
      anon_sym_AT,
    STATE(1341), 1,
      sym_forall,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2096), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(2741), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(826), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2444), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1030), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [34801] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2446), 1,
      sym__varid,
    ACTIONS(2448), 1,
      sym_string,
    ACTIONS(2450), 1,
      sym_triple_quote_string,
    ACTIONS(2452), 1,
      sym__integer_literal,
    ACTIONS(2454), 1,
      sym__hex_literal,
    ACTIONS(2456), 1,
      anon_sym__,
    ACTIONS(2458), 1,
      sym_hole,
    ACTIONS(2460), 1,
      anon_sym_LPAREN,
    ACTIONS(2462), 1,
      sym__conid,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_AT,
    STATE(1332), 1,
      sym_forall,
    STATE(3107), 1,
      sym_constructor,
    STATE(3261), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2480), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(2731), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(829), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2470), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1014), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [34903] = 26,
    ACTIONS(2496), 1,
      sym__varid,
    ACTIONS(2499), 1,
      sym_string,
    ACTIONS(2502), 1,
      sym_triple_quote_string,
    ACTIONS(2505), 1,
      sym__integer_literal,
    ACTIONS(2508), 1,
      sym__hex_literal,
    ACTIONS(2511), 1,
      anon_sym__,
    ACTIONS(2514), 1,
      sym_hole,
    ACTIONS(2517), 1,
      anon_sym_LPAREN,
    ACTIONS(2520), 1,
      sym__conid,
    ACTIONS(2523), 1,
      anon_sym_LBRACE,
    ACTIONS(2526), 1,
      anon_sym_AT,
    ACTIONS(2529), 1,
      anon_sym_forall,
    ACTIONS(2532), 1,
      anon_sym_u2200,
    STATE(1332), 1,
      sym_forall,
    STATE(3107), 1,
      sym_constructor,
    STATE(3261), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2731), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(829), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(2494), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(1014), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35003] = 26,
    ACTIONS(2529), 1,
      anon_sym_forall,
    ACTIONS(2532), 1,
      anon_sym_u2200,
    ACTIONS(2535), 1,
      sym__varid,
    ACTIONS(2538), 1,
      sym_string,
    ACTIONS(2541), 1,
      sym_triple_quote_string,
    ACTIONS(2544), 1,
      sym__integer_literal,
    ACTIONS(2547), 1,
      sym__hex_literal,
    ACTIONS(2550), 1,
      anon_sym__,
    ACTIONS(2553), 1,
      sym_hole,
    ACTIONS(2556), 1,
      anon_sym_LPAREN,
    ACTIONS(2559), 1,
      sym__conid,
    ACTIONS(2562), 1,
      anon_sym_LBRACE,
    ACTIONS(2565), 1,
      anon_sym_AT,
    STATE(1341), 1,
      sym_forall,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2741), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(830), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(2494), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(1030), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35103] = 28,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2570), 1,
      sym__varid,
    ACTIONS(2572), 1,
      sym_string,
    ACTIONS(2574), 1,
      sym_triple_quote_string,
    ACTIONS(2576), 1,
      sym__integer_literal,
    ACTIONS(2578), 1,
      sym__hex_literal,
    ACTIONS(2580), 1,
      anon_sym__,
    ACTIONS(2582), 1,
      sym_hole,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      sym__conid,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
    ACTIONS(2592), 1,
      anon_sym_AT,
    STATE(1320), 1,
      sym_forall,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7284), 1,
      aux_sym_decl_data_repeat2,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3004), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2568), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(835), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1318), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35206] = 28,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2570), 1,
      sym__varid,
    ACTIONS(2572), 1,
      sym_string,
    ACTIONS(2574), 1,
      sym_triple_quote_string,
    ACTIONS(2576), 1,
      sym__integer_literal,
    ACTIONS(2578), 1,
      sym__hex_literal,
    ACTIONS(2580), 1,
      anon_sym__,
    ACTIONS(2582), 1,
      sym_hole,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      sym__conid,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
    ACTIONS(2592), 1,
      anon_sym_AT,
    STATE(1320), 1,
      sym_forall,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7493), 1,
      aux_sym_decl_data_repeat2,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3004), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2594), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(833), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1318), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35309] = 28,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2570), 1,
      sym__varid,
    ACTIONS(2572), 1,
      sym_string,
    ACTIONS(2574), 1,
      sym_triple_quote_string,
    ACTIONS(2576), 1,
      sym__integer_literal,
    ACTIONS(2578), 1,
      sym__hex_literal,
    ACTIONS(2580), 1,
      anon_sym__,
    ACTIONS(2582), 1,
      sym_hole,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      sym__conid,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
    ACTIONS(2592), 1,
      anon_sym_AT,
    STATE(1320), 1,
      sym_forall,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7356), 1,
      aux_sym_decl_data_repeat2,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3004), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2596), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(848), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1318), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35412] = 28,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2598), 1,
      sym__varid,
    ACTIONS(2600), 1,
      sym_string,
    ACTIONS(2602), 1,
      sym_triple_quote_string,
    ACTIONS(2604), 1,
      sym__integer_literal,
    ACTIONS(2606), 1,
      sym__hex_literal,
    ACTIONS(2608), 1,
      anon_sym__,
    ACTIONS(2610), 1,
      sym_hole,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym__conid,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    ACTIONS(2618), 1,
      anon_sym_LBRACE,
    ACTIONS(2620), 1,
      anon_sym_AT,
    STATE(1364), 1,
      sym_forall,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7127), 1,
      aux_sym_decl_data_repeat2,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2986), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2596), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(843), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1360), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35515] = 28,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2570), 1,
      sym__varid,
    ACTIONS(2572), 1,
      sym_string,
    ACTIONS(2574), 1,
      sym_triple_quote_string,
    ACTIONS(2576), 1,
      sym__integer_literal,
    ACTIONS(2578), 1,
      sym__hex_literal,
    ACTIONS(2580), 1,
      anon_sym__,
    ACTIONS(2582), 1,
      sym_hole,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      sym__conid,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
    ACTIONS(2592), 1,
      anon_sym_AT,
    STATE(1320), 1,
      sym_forall,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7187), 1,
      aux_sym_decl_data_repeat2,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3004), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2622), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(848), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1318), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35618] = 28,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2598), 1,
      sym__varid,
    ACTIONS(2600), 1,
      sym_string,
    ACTIONS(2602), 1,
      sym_triple_quote_string,
    ACTIONS(2604), 1,
      sym__integer_literal,
    ACTIONS(2606), 1,
      sym__hex_literal,
    ACTIONS(2608), 1,
      anon_sym__,
    ACTIONS(2610), 1,
      sym_hole,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym__conid,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    ACTIONS(2618), 1,
      anon_sym_LBRACE,
    ACTIONS(2620), 1,
      anon_sym_AT,
    STATE(1364), 1,
      sym_forall,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7043), 1,
      aux_sym_decl_data_repeat2,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2986), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2622), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(843), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1360), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35721] = 28,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2598), 1,
      sym__varid,
    ACTIONS(2600), 1,
      sym_string,
    ACTIONS(2602), 1,
      sym_triple_quote_string,
    ACTIONS(2604), 1,
      sym__integer_literal,
    ACTIONS(2606), 1,
      sym__hex_literal,
    ACTIONS(2608), 1,
      anon_sym__,
    ACTIONS(2610), 1,
      sym_hole,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym__conid,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    ACTIONS(2618), 1,
      anon_sym_LBRACE,
    ACTIONS(2620), 1,
      anon_sym_AT,
    STATE(1364), 1,
      sym_forall,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7064), 1,
      aux_sym_decl_data_repeat2,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2986), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2568), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(836), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1360), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35824] = 28,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2598), 1,
      sym__varid,
    ACTIONS(2600), 1,
      sym_string,
    ACTIONS(2602), 1,
      sym_triple_quote_string,
    ACTIONS(2604), 1,
      sym__integer_literal,
    ACTIONS(2606), 1,
      sym__hex_literal,
    ACTIONS(2608), 1,
      anon_sym__,
    ACTIONS(2610), 1,
      sym_hole,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym__conid,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    ACTIONS(2618), 1,
      anon_sym_LBRACE,
    ACTIONS(2620), 1,
      anon_sym_AT,
    STATE(1364), 1,
      sym_forall,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7174), 1,
      aux_sym_decl_data_repeat2,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2986), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2594), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(834), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1360), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [35927] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2598), 1,
      sym__varid,
    ACTIONS(2600), 1,
      sym_string,
    ACTIONS(2602), 1,
      sym_triple_quote_string,
    ACTIONS(2604), 1,
      sym__integer_literal,
    ACTIONS(2606), 1,
      sym__hex_literal,
    ACTIONS(2608), 1,
      anon_sym__,
    ACTIONS(2610), 1,
      sym_hole,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym__conid,
    ACTIONS(2618), 1,
      anon_sym_LBRACE,
    ACTIONS(2620), 1,
      anon_sym_AT,
    STATE(1364), 1,
      sym_forall,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2986), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(847), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2624), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1360), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36025] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2628), 1,
      sym__varid,
    ACTIONS(2630), 1,
      sym_string,
    ACTIONS(2632), 1,
      sym_triple_quote_string,
    ACTIONS(2634), 1,
      sym__integer_literal,
    ACTIONS(2636), 1,
      sym__hex_literal,
    ACTIONS(2638), 1,
      anon_sym__,
    ACTIONS(2640), 1,
      sym_hole,
    ACTIONS(2642), 1,
      anon_sym_LPAREN,
    ACTIONS(2644), 1,
      sym__conid,
    ACTIONS(2646), 1,
      anon_sym_LBRACE,
    ACTIONS(2648), 1,
      anon_sym_AT,
    STATE(1352), 1,
      sym_forall,
    STATE(3352), 1,
      sym_constructor,
    STATE(3475), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2997), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(841), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2626), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1322), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36123] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2628), 1,
      sym__varid,
    ACTIONS(2630), 1,
      sym_string,
    ACTIONS(2632), 1,
      sym_triple_quote_string,
    ACTIONS(2634), 1,
      sym__integer_literal,
    ACTIONS(2636), 1,
      sym__hex_literal,
    ACTIONS(2638), 1,
      anon_sym__,
    ACTIONS(2640), 1,
      sym_hole,
    ACTIONS(2642), 1,
      anon_sym_LPAREN,
    ACTIONS(2644), 1,
      sym__conid,
    ACTIONS(2646), 1,
      anon_sym_LBRACE,
    ACTIONS(2648), 1,
      anon_sym_AT,
    STATE(1352), 1,
      sym_forall,
    STATE(3352), 1,
      sym_constructor,
    STATE(3475), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2997), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(845), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2650), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1322), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36221] = 26,
    ACTIONS(2529), 1,
      anon_sym_forall,
    ACTIONS(2532), 1,
      anon_sym_u2200,
    ACTIONS(2652), 1,
      sym__varid,
    ACTIONS(2655), 1,
      sym_string,
    ACTIONS(2658), 1,
      sym_triple_quote_string,
    ACTIONS(2661), 1,
      sym__integer_literal,
    ACTIONS(2664), 1,
      sym__hex_literal,
    ACTIONS(2667), 1,
      anon_sym__,
    ACTIONS(2670), 1,
      sym_hole,
    ACTIONS(2673), 1,
      anon_sym_LPAREN,
    ACTIONS(2676), 1,
      sym__conid,
    ACTIONS(2679), 1,
      anon_sym_LBRACE,
    ACTIONS(2682), 1,
      anon_sym_AT,
    STATE(1309), 1,
      sym_forall,
    STATE(3382), 1,
      sym_constructor,
    STATE(3586), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2999), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(842), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2494), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1321), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36319] = 26,
    ACTIONS(2529), 1,
      anon_sym_forall,
    ACTIONS(2532), 1,
      anon_sym_u2200,
    ACTIONS(2685), 1,
      sym__varid,
    ACTIONS(2688), 1,
      sym_string,
    ACTIONS(2691), 1,
      sym_triple_quote_string,
    ACTIONS(2694), 1,
      sym__integer_literal,
    ACTIONS(2697), 1,
      sym__hex_literal,
    ACTIONS(2700), 1,
      anon_sym__,
    ACTIONS(2703), 1,
      sym_hole,
    ACTIONS(2706), 1,
      anon_sym_LPAREN,
    ACTIONS(2709), 1,
      sym__conid,
    ACTIONS(2712), 1,
      anon_sym_LBRACE,
    ACTIONS(2715), 1,
      anon_sym_AT,
    STATE(1364), 1,
      sym_forall,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2986), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(843), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2494), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1360), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36417] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2570), 1,
      sym__varid,
    ACTIONS(2572), 1,
      sym_string,
    ACTIONS(2574), 1,
      sym_triple_quote_string,
    ACTIONS(2576), 1,
      sym__integer_literal,
    ACTIONS(2578), 1,
      sym__hex_literal,
    ACTIONS(2580), 1,
      anon_sym__,
    ACTIONS(2582), 1,
      sym_hole,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      sym__conid,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
    ACTIONS(2592), 1,
      anon_sym_AT,
    STATE(1320), 1,
      sym_forall,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3004), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(848), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2718), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1318), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36515] = 26,
    ACTIONS(2529), 1,
      anon_sym_forall,
    ACTIONS(2532), 1,
      anon_sym_u2200,
    ACTIONS(2720), 1,
      sym__varid,
    ACTIONS(2723), 1,
      sym_string,
    ACTIONS(2726), 1,
      sym_triple_quote_string,
    ACTIONS(2729), 1,
      sym__integer_literal,
    ACTIONS(2732), 1,
      sym__hex_literal,
    ACTIONS(2735), 1,
      anon_sym__,
    ACTIONS(2738), 1,
      sym_hole,
    ACTIONS(2741), 1,
      anon_sym_LPAREN,
    ACTIONS(2744), 1,
      sym__conid,
    ACTIONS(2747), 1,
      anon_sym_LBRACE,
    ACTIONS(2750), 1,
      anon_sym_AT,
    STATE(1352), 1,
      sym_forall,
    STATE(3352), 1,
      sym_constructor,
    STATE(3475), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2997), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(845), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2494), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1322), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36613] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2753), 1,
      sym__varid,
    ACTIONS(2755), 1,
      sym_string,
    ACTIONS(2757), 1,
      sym_triple_quote_string,
    ACTIONS(2759), 1,
      sym__integer_literal,
    ACTIONS(2761), 1,
      sym__hex_literal,
    ACTIONS(2763), 1,
      anon_sym__,
    ACTIONS(2765), 1,
      sym_hole,
    ACTIONS(2767), 1,
      anon_sym_LPAREN,
    ACTIONS(2769), 1,
      sym__conid,
    ACTIONS(2771), 1,
      anon_sym_LBRACE,
    ACTIONS(2773), 1,
      anon_sym_AT,
    STATE(1309), 1,
      sym_forall,
    STATE(3382), 1,
      sym_constructor,
    STATE(3586), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2999), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(842), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2650), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1321), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36711] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2598), 1,
      sym__varid,
    ACTIONS(2600), 1,
      sym_string,
    ACTIONS(2602), 1,
      sym_triple_quote_string,
    ACTIONS(2604), 1,
      sym__integer_literal,
    ACTIONS(2606), 1,
      sym__hex_literal,
    ACTIONS(2608), 1,
      anon_sym__,
    ACTIONS(2610), 1,
      sym_hole,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym__conid,
    ACTIONS(2618), 1,
      anon_sym_LBRACE,
    ACTIONS(2620), 1,
      anon_sym_AT,
    STATE(1364), 1,
      sym_forall,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2986), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(843), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2718), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1360), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36809] = 26,
    ACTIONS(2529), 1,
      anon_sym_forall,
    ACTIONS(2532), 1,
      anon_sym_u2200,
    ACTIONS(2775), 1,
      sym__varid,
    ACTIONS(2778), 1,
      sym_string,
    ACTIONS(2781), 1,
      sym_triple_quote_string,
    ACTIONS(2784), 1,
      sym__integer_literal,
    ACTIONS(2787), 1,
      sym__hex_literal,
    ACTIONS(2790), 1,
      anon_sym__,
    ACTIONS(2793), 1,
      sym_hole,
    ACTIONS(2796), 1,
      anon_sym_LPAREN,
    ACTIONS(2799), 1,
      sym__conid,
    ACTIONS(2802), 1,
      anon_sym_LBRACE,
    ACTIONS(2805), 1,
      anon_sym_AT,
    STATE(1320), 1,
      sym_forall,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3004), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(848), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2494), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1318), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [36907] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2570), 1,
      sym__varid,
    ACTIONS(2572), 1,
      sym_string,
    ACTIONS(2574), 1,
      sym_triple_quote_string,
    ACTIONS(2576), 1,
      sym__integer_literal,
    ACTIONS(2578), 1,
      sym__hex_literal,
    ACTIONS(2580), 1,
      anon_sym__,
    ACTIONS(2582), 1,
      sym_hole,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      sym__conid,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
    ACTIONS(2592), 1,
      anon_sym_AT,
    STATE(1320), 1,
      sym_forall,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3004), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(844), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2624), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1318), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [37005] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2753), 1,
      sym__varid,
    ACTIONS(2755), 1,
      sym_string,
    ACTIONS(2757), 1,
      sym_triple_quote_string,
    ACTIONS(2759), 1,
      sym__integer_literal,
    ACTIONS(2761), 1,
      sym__hex_literal,
    ACTIONS(2763), 1,
      anon_sym__,
    ACTIONS(2765), 1,
      sym_hole,
    ACTIONS(2767), 1,
      anon_sym_LPAREN,
    ACTIONS(2769), 1,
      sym__conid,
    ACTIONS(2771), 1,
      anon_sym_LBRACE,
    ACTIONS(2773), 1,
      anon_sym_AT,
    STATE(1309), 1,
      sym_forall,
    STATE(3382), 1,
      sym_constructor,
    STATE(3586), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2999), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(846), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    ACTIONS(2626), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1321), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [37103] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2830), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8327), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [37202] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2832), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8168), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [37301] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2834), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8298), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [37400] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2836), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8197), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [37499] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2838), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8130), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [37598] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2840), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8384), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [37697] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2842), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8119), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [37796] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2844), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8380), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [37895] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2846), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8494), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [37994] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2848), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8485), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38093] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2850), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8286), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38192] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2852), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8607), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38291] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2854), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8420), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38390] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2856), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8448), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38489] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2858), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8266), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38588] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2860), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8044), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38687] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2862), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8224), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38786] = 28,
    ACTIONS(2864), 1,
      sym__varid,
    ACTIONS(2868), 1,
      sym_string,
    ACTIONS(2870), 1,
      sym__integer_literal,
    ACTIONS(2872), 1,
      sym__hex_literal,
    ACTIONS(2874), 1,
      anon_sym__,
    ACTIONS(2876), 1,
      anon_sym_DASH,
    ACTIONS(2878), 1,
      anon_sym_LPAREN,
    ACTIONS(2880), 1,
      sym__conid,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    STATE(1007), 1,
      sym__pat_constructor,
    STATE(3033), 1,
      sym_constructor,
    STATE(4052), 1,
      sym_qualified_constructor,
    STATE(4053), 1,
      sym__qcon,
    STATE(6502), 1,
      sym_variable,
    STATE(6848), 1,
      sym_wildcard,
    STATE(6858), 1,
      sym_literal,
    STATE(6861), 1,
      sym_pat_fields,
    STATE(7774), 1,
      aux_sym__qualifying_module,
    STATE(8574), 1,
      sym__pattern_arrow,
    STATE(8578), 1,
      sym__pattern_equals,
    STATE(8597), 1,
      sym__pattern_type,
    STATE(10078), 1,
      sym__modid,
    STATE(7958), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2866), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6846), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4526), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38887] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2886), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8575), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [38986] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2888), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8270), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39085] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2890), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8451), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39184] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2892), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8566), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39283] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2894), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8325), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39382] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2896), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8527), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39481] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2898), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8372), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39580] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2900), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8525), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39679] = 27,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(2902), 1,
      anon_sym_RBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8161), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39778] = 28,
    ACTIONS(2864), 1,
      sym__varid,
    ACTIONS(2868), 1,
      sym_string,
    ACTIONS(2870), 1,
      sym__integer_literal,
    ACTIONS(2872), 1,
      sym__hex_literal,
    ACTIONS(2874), 1,
      anon_sym__,
    ACTIONS(2876), 1,
      anon_sym_DASH,
    ACTIONS(2880), 1,
      sym__conid,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    ACTIONS(2904), 1,
      anon_sym_LPAREN,
    STATE(1007), 1,
      sym__pat_constructor,
    STATE(3034), 1,
      sym_constructor,
    STATE(4052), 1,
      sym_qualified_constructor,
    STATE(4053), 1,
      sym__qcon,
    STATE(6502), 1,
      sym_variable,
    STATE(6848), 1,
      sym_wildcard,
    STATE(6858), 1,
      sym_literal,
    STATE(6861), 1,
      sym_pat_fields,
    STATE(7774), 1,
      aux_sym__qualifying_module,
    STATE(8148), 1,
      sym__pattern_type,
    STATE(8155), 1,
      sym__pattern_equals,
    STATE(8156), 1,
      sym__pattern_arrow,
    STATE(10078), 1,
      sym__modid,
    STATE(7758), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2866), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6846), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4526), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39879] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(2928), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [39977] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(2930), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7694), 1,
      sym_alt,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [40075] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(2932), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [40173] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(2934), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [40271] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(2936), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7555), 1,
      sym_alt,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [40369] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(2960), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(8588), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [40467] = 26,
    ACTIONS(2529), 1,
      anon_sym_forall,
    ACTIONS(2532), 1,
      anon_sym_u2200,
    ACTIONS(2962), 1,
      sym__varid,
    ACTIONS(2965), 1,
      sym_string,
    ACTIONS(2968), 1,
      sym_triple_quote_string,
    ACTIONS(2971), 1,
      sym__integer_literal,
    ACTIONS(2974), 1,
      sym__hex_literal,
    ACTIONS(2977), 1,
      anon_sym__,
    ACTIONS(2980), 1,
      sym_hole,
    ACTIONS(2983), 1,
      anon_sym_LPAREN,
    ACTIONS(2986), 1,
      sym__conid,
    ACTIONS(2989), 1,
      anon_sym_LBRACE,
    ACTIONS(2992), 1,
      anon_sym_AT,
    STATE(1282), 1,
      sym_forall,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2494), 2,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
    STATE(3040), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(885), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1412), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [40563] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(2995), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7603), 1,
      sym_alt,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [40661] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(2997), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(8590), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [40759] = 26,
    ACTIONS(2529), 1,
      anon_sym_forall,
    ACTIONS(2532), 1,
      anon_sym_u2200,
    ACTIONS(2999), 1,
      sym__varid,
    ACTIONS(3002), 1,
      sym_string,
    ACTIONS(3005), 1,
      sym_triple_quote_string,
    ACTIONS(3008), 1,
      sym__integer_literal,
    ACTIONS(3011), 1,
      sym__hex_literal,
    ACTIONS(3014), 1,
      anon_sym__,
    ACTIONS(3017), 1,
      sym_hole,
    ACTIONS(3020), 1,
      anon_sym_LPAREN,
    ACTIONS(3023), 1,
      sym__conid,
    ACTIONS(3026), 1,
      anon_sym_LBRACE,
    ACTIONS(3029), 1,
      anon_sym_AT,
    STATE(1330), 1,
      sym_forall,
    STATE(3809), 1,
      sym_constructor,
    STATE(4288), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2494), 2,
      sym_comma,
      anon_sym_RPAREN,
    STATE(3045), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(888), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1420), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [40855] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3032), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(7960), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [40953] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2088), 1,
      sym_string,
    ACTIONS(2090), 1,
      sym_triple_quote_string,
    ACTIONS(2092), 1,
      sym__integer_literal,
    ACTIONS(2094), 1,
      sym__hex_literal,
    ACTIONS(2098), 1,
      anon_sym__,
    ACTIONS(2100), 1,
      sym_hole,
    ACTIONS(2104), 1,
      sym__conid,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3034), 1,
      sym__varid,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3038), 1,
      anon_sym_AT,
    STATE(1282), 1,
      sym_forall,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2480), 2,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
    STATE(3040), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(885), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1412), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [41049] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3040), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(7988), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [41147] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3042), 1,
      sym__varid,
    ACTIONS(3044), 1,
      sym_string,
    ACTIONS(3046), 1,
      sym_triple_quote_string,
    ACTIONS(3048), 1,
      sym__integer_literal,
    ACTIONS(3050), 1,
      sym__hex_literal,
    ACTIONS(3052), 1,
      anon_sym__,
    ACTIONS(3054), 1,
      sym_hole,
    ACTIONS(3056), 1,
      anon_sym_LPAREN,
    ACTIONS(3058), 1,
      sym__conid,
    ACTIONS(3060), 1,
      anon_sym_LBRACE,
    ACTIONS(3062), 1,
      anon_sym_AT,
    STATE(1330), 1,
      sym_forall,
    STATE(3809), 1,
      sym_constructor,
    STATE(4288), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2480), 2,
      sym_comma,
      anon_sym_RPAREN,
    STATE(3045), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(888), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1420), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [41243] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3064), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [41341] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3066), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [41439] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3068), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(7836), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [41537] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3070), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [41635] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3072), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [41733] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(3074), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(8590), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [41831] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3076), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [41929] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(3078), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(8588), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [42027] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3080), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [42125] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3042), 1,
      sym__varid,
    ACTIONS(3044), 1,
      sym_string,
    ACTIONS(3046), 1,
      sym_triple_quote_string,
    ACTIONS(3048), 1,
      sym__integer_literal,
    ACTIONS(3050), 1,
      sym__hex_literal,
    ACTIONS(3052), 1,
      anon_sym__,
    ACTIONS(3054), 1,
      sym_hole,
    ACTIONS(3056), 1,
      anon_sym_LPAREN,
    ACTIONS(3058), 1,
      sym__conid,
    ACTIONS(3060), 1,
      anon_sym_LBRACE,
    ACTIONS(3062), 1,
      anon_sym_AT,
    STATE(1330), 1,
      sym_forall,
    STATE(3809), 1,
      sym_constructor,
    STATE(4288), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2096), 2,
      sym_comma,
      anon_sym_RPAREN,
    STATE(3045), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(892), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1420), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [42221] = 24,
    ACTIONS(3082), 1,
      sym__varid,
    ACTIONS(3088), 1,
      sym_string,
    ACTIONS(3091), 1,
      sym__integer_literal,
    ACTIONS(3094), 1,
      sym__hex_literal,
    ACTIONS(3099), 1,
      anon_sym__,
    ACTIONS(3102), 1,
      anon_sym_LPAREN,
    ACTIONS(3105), 1,
      sym__conid,
    ACTIONS(3108), 1,
      anon_sym_LBRACE,
    ACTIONS(3113), 1,
      anon_sym_LBRACK,
    STATE(3182), 1,
      sym_constructor,
    STATE(3195), 1,
      sym_variable,
    STATE(3370), 1,
      sym_pat_fields,
    STATE(3380), 1,
      sym_literal,
    STATE(3386), 1,
      sym_wildcard,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3085), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(3111), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(3389), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3097), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    STATE(903), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [42313] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3116), 1,
      sym__varid,
    ACTIONS(3118), 1,
      sym_string,
    ACTIONS(3120), 1,
      sym_triple_quote_string,
    ACTIONS(3122), 1,
      sym__integer_literal,
    ACTIONS(3124), 1,
      sym__hex_literal,
    ACTIONS(3126), 1,
      anon_sym__,
    ACTIONS(3128), 1,
      sym_hole,
    ACTIONS(3130), 1,
      anon_sym_LPAREN,
    ACTIONS(3132), 1,
      sym__conid,
    ACTIONS(3134), 1,
      anon_sym_LBRACE,
    ACTIONS(3136), 1,
      anon_sym_AT,
    STATE(1308), 1,
      sym_forall,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2480), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(3031), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(944), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1429), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [42409] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3138), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [42507] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3140), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [42605] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3142), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(7921), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [42703] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(3144), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(7807), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [42801] = 24,
    ACTIONS(3146), 1,
      sym__varid,
    ACTIONS(3150), 1,
      sym_string,
    ACTIONS(3152), 1,
      sym__integer_literal,
    ACTIONS(3154), 1,
      sym__hex_literal,
    ACTIONS(3158), 1,
      anon_sym__,
    ACTIONS(3160), 1,
      anon_sym_LPAREN,
    ACTIONS(3162), 1,
      sym__conid,
    ACTIONS(3165), 1,
      anon_sym_LBRACE,
    ACTIONS(3169), 1,
      anon_sym_LBRACK,
    STATE(3182), 1,
      sym_constructor,
    STATE(3195), 1,
      sym_variable,
    STATE(3370), 1,
      sym_pat_fields,
    STATE(3380), 1,
      sym_literal,
    STATE(3386), 1,
      sym_wildcard,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3148), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(3167), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(3389), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3156), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    STATE(903), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [42893] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3171), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [42991] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3173), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [43089] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3175), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [43187] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3177), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [43285] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3179), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [43383] = 24,
    ACTIONS(3146), 1,
      sym__varid,
    ACTIONS(3150), 1,
      sym_string,
    ACTIONS(3152), 1,
      sym__integer_literal,
    ACTIONS(3154), 1,
      sym__hex_literal,
    ACTIONS(3158), 1,
      anon_sym__,
    ACTIONS(3160), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_LBRACE,
    ACTIONS(3169), 1,
      anon_sym_LBRACK,
    ACTIONS(3183), 1,
      sym__conid,
    STATE(3182), 1,
      sym_constructor,
    STATE(3195), 1,
      sym_variable,
    STATE(3370), 1,
      sym_pat_fields,
    STATE(3380), 1,
      sym_literal,
    STATE(3386), 1,
      sym_wildcard,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3148), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    ACTIONS(3186), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(3389), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3181), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    STATE(909), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [43475] = 26,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8686), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [43571] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3188), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [43669] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3190), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [43767] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3192), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8025), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [43865] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3194), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(7887), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [43963] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3196), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44061] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3198), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44159] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3200), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44257] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(3202), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(8590), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44355] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(3204), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(8588), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44453] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(3206), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(8588), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44551] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3208), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44649] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3210), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(7787), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44747] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(3212), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(8590), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44845] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3214), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [44943] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3216), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [45041] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3218), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8013), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [45139] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3220), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7704), 1,
      sym_alt,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [45237] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3222), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [45335] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3224), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(7896), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [45433] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3226), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [45531] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3228), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7632), 1,
      sym_alt,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [45629] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3230), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [45727] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3116), 1,
      sym__varid,
    ACTIONS(3118), 1,
      sym_string,
    ACTIONS(3120), 1,
      sym_triple_quote_string,
    ACTIONS(3122), 1,
      sym__integer_literal,
    ACTIONS(3124), 1,
      sym__hex_literal,
    ACTIONS(3126), 1,
      anon_sym__,
    ACTIONS(3128), 1,
      sym_hole,
    ACTIONS(3130), 1,
      anon_sym_LPAREN,
    ACTIONS(3132), 1,
      sym__conid,
    ACTIONS(3134), 1,
      anon_sym_LBRACE,
    ACTIONS(3136), 1,
      anon_sym_AT,
    STATE(1308), 1,
      sym_forall,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2096), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(3031), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(904), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1429), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [45823] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3232), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(7808), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [45921] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3234), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [46019] = 26,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6635), 2,
      sym_pat_infix,
      sym__pat,
    STATE(8689), 2,
      sym_pat_typed,
      sym__typed_pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [46115] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3236), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [46213] = 26,
    ACTIONS(2529), 1,
      anon_sym_forall,
    ACTIONS(2532), 1,
      anon_sym_u2200,
    ACTIONS(3238), 1,
      sym__varid,
    ACTIONS(3241), 1,
      sym_string,
    ACTIONS(3244), 1,
      sym_triple_quote_string,
    ACTIONS(3247), 1,
      sym__integer_literal,
    ACTIONS(3250), 1,
      sym__hex_literal,
    ACTIONS(3253), 1,
      anon_sym__,
    ACTIONS(3256), 1,
      sym_hole,
    ACTIONS(3259), 1,
      anon_sym_LPAREN,
    ACTIONS(3262), 1,
      sym__conid,
    ACTIONS(3265), 1,
      anon_sym_LBRACE,
    ACTIONS(3268), 1,
      anon_sym_AT,
    STATE(1308), 1,
      sym_forall,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(2494), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    STATE(3031), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(944), 3,
      sym_type_infix,
      sym__type,
      aux_sym_decl_data_repeat1,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1429), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [46309] = 27,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(3271), 1,
      sym__layout_end,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(7811), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [46407] = 27,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      sym__layout_end,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [46505] = 20,
    ACTIONS(3275), 1,
      sym__varid,
    ACTIONS(3280), 1,
      sym_string,
    ACTIONS(3282), 1,
      sym_triple_quote_string,
    ACTIONS(3284), 1,
      sym__integer_literal,
    ACTIONS(3286), 1,
      sym__hex_literal,
    ACTIONS(3291), 1,
      anon_sym__,
    ACTIONS(3293), 1,
      sym_hole,
    ACTIONS(3295), 1,
      anon_sym_LPAREN,
    ACTIONS(3297), 1,
      sym__conid,
    ACTIONS(3301), 1,
      anon_sym_LBRACE,
    ACTIONS(3303), 1,
      anon_sym_AT,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(952), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [46588] = 20,
    ACTIONS(3307), 1,
      sym__varid,
    ACTIONS(3309), 1,
      sym_string,
    ACTIONS(3311), 1,
      sym_triple_quote_string,
    ACTIONS(3313), 1,
      sym__integer_literal,
    ACTIONS(3315), 1,
      sym__hex_literal,
    ACTIONS(3319), 1,
      anon_sym__,
    ACTIONS(3321), 1,
      sym_hole,
    ACTIONS(3323), 1,
      anon_sym_LPAREN,
    ACTIONS(3325), 1,
      sym__conid,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(3330), 1,
      anon_sym_AT,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(950), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [46671] = 20,
    ACTIONS(3332), 1,
      sym__varid,
    ACTIONS(3337), 1,
      sym_string,
    ACTIONS(3340), 1,
      sym_triple_quote_string,
    ACTIONS(3343), 1,
      sym__integer_literal,
    ACTIONS(3346), 1,
      sym__hex_literal,
    ACTIONS(3351), 1,
      anon_sym__,
    ACTIONS(3354), 1,
      sym_hole,
    ACTIONS(3357), 1,
      anon_sym_LPAREN,
    ACTIONS(3360), 1,
      sym__conid,
    ACTIONS(3363), 1,
      anon_sym_LBRACE,
    ACTIONS(3366), 1,
      anon_sym_AT,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(949), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [46754] = 20,
    ACTIONS(3369), 1,
      sym__varid,
    ACTIONS(3372), 1,
      sym_string,
    ACTIONS(3375), 1,
      sym_triple_quote_string,
    ACTIONS(3378), 1,
      sym__integer_literal,
    ACTIONS(3381), 1,
      sym__hex_literal,
    ACTIONS(3384), 1,
      anon_sym__,
    ACTIONS(3387), 1,
      sym_hole,
    ACTIONS(3390), 1,
      anon_sym_LPAREN,
    ACTIONS(3393), 1,
      sym__conid,
    ACTIONS(3396), 1,
      anon_sym_LBRACE,
    ACTIONS(3399), 1,
      anon_sym_AT,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(950), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [46837] = 23,
    ACTIONS(3402), 1,
      sym__varid,
    ACTIONS(3406), 1,
      sym_string,
    ACTIONS(3408), 1,
      sym__integer_literal,
    ACTIONS(3410), 1,
      sym__hex_literal,
    ACTIONS(3412), 1,
      anon_sym__,
    ACTIONS(3414), 1,
      anon_sym_LPAREN,
    ACTIONS(3416), 1,
      sym__conid,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    ACTIONS(3421), 1,
      anon_sym_LBRACK,
    STATE(3283), 1,
      sym_constructor,
    STATE(3340), 1,
      sym_variable,
    STATE(3540), 1,
      sym_literal,
    STATE(3541), 1,
      sym__qcon,
    STATE(3543), 1,
      sym_wildcard,
    STATE(3602), 1,
      sym_pat_fields,
    STATE(3650), 1,
      sym_qualified_constructor,
    STATE(7904), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3404), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3653), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3181), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    STATE(953), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [46926] = 20,
    ACTIONS(3275), 1,
      sym__varid,
    ACTIONS(3280), 1,
      sym_string,
    ACTIONS(3282), 1,
      sym_triple_quote_string,
    ACTIONS(3284), 1,
      sym__integer_literal,
    ACTIONS(3286), 1,
      sym__hex_literal,
    ACTIONS(3291), 1,
      anon_sym__,
    ACTIONS(3295), 1,
      anon_sym_LPAREN,
    ACTIONS(3301), 1,
      anon_sym_LBRACE,
    ACTIONS(3303), 1,
      anon_sym_AT,
    ACTIONS(3423), 1,
      sym_hole,
    ACTIONS(3425), 1,
      sym__conid,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(949), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [47009] = 23,
    ACTIONS(3402), 1,
      sym__varid,
    ACTIONS(3406), 1,
      sym_string,
    ACTIONS(3408), 1,
      sym__integer_literal,
    ACTIONS(3410), 1,
      sym__hex_literal,
    ACTIONS(3412), 1,
      anon_sym__,
    ACTIONS(3414), 1,
      anon_sym_LPAREN,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    ACTIONS(3421), 1,
      anon_sym_LBRACK,
    ACTIONS(3428), 1,
      sym__conid,
    STATE(3283), 1,
      sym_constructor,
    STATE(3340), 1,
      sym_variable,
    STATE(3540), 1,
      sym_literal,
    STATE(3541), 1,
      sym__qcon,
    STATE(3543), 1,
      sym_wildcard,
    STATE(3602), 1,
      sym_pat_fields,
    STATE(3650), 1,
      sym_qualified_constructor,
    STATE(7904), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3404), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3653), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3156), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    STATE(966), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [47098] = 24,
    ACTIONS(3431), 1,
      sym__varid,
    ACTIONS(3437), 1,
      sym_string,
    ACTIONS(3440), 1,
      sym__integer_literal,
    ACTIONS(3443), 1,
      sym__hex_literal,
    ACTIONS(3446), 1,
      anon_sym__,
    ACTIONS(3449), 1,
      anon_sym_LPAREN,
    ACTIONS(3452), 1,
      sym__conid,
    ACTIONS(3455), 1,
      anon_sym_LBRACE,
    ACTIONS(3458), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_constructor,
    STATE(3375), 1,
      sym_variable,
    STATE(3462), 1,
      sym__qcon,
    STATE(3536), 1,
      sym_qualified_constructor,
    STATE(3710), 1,
      sym_literal,
    STATE(3711), 1,
      sym_pat_fields,
    STATE(3717), 1,
      sym_wildcard,
    STATE(7792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3097), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3434), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3709), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3111), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(954), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [47189] = 20,
    ACTIONS(3275), 1,
      sym__varid,
    ACTIONS(3280), 1,
      sym_string,
    ACTIONS(3282), 1,
      sym_triple_quote_string,
    ACTIONS(3284), 1,
      sym__integer_literal,
    ACTIONS(3286), 1,
      sym__hex_literal,
    ACTIONS(3291), 1,
      anon_sym__,
    ACTIONS(3293), 1,
      sym_hole,
    ACTIONS(3295), 1,
      anon_sym_LPAREN,
    ACTIONS(3301), 1,
      anon_sym_LBRACE,
    ACTIONS(3303), 1,
      anon_sym_AT,
    ACTIONS(3465), 1,
      sym__conid,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(952), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [47272] = 24,
    ACTIONS(3468), 1,
      sym__varid,
    ACTIONS(3474), 1,
      sym_string,
    ACTIONS(3477), 1,
      sym__integer_literal,
    ACTIONS(3480), 1,
      sym__hex_literal,
    ACTIONS(3483), 1,
      anon_sym__,
    ACTIONS(3486), 1,
      anon_sym_LPAREN,
    ACTIONS(3489), 1,
      sym__conid,
    ACTIONS(3492), 1,
      anon_sym_LBRACE,
    ACTIONS(3495), 1,
      anon_sym_LBRACK,
    STATE(3303), 1,
      sym_constructor,
    STATE(3358), 1,
      sym_variable,
    STATE(3441), 1,
      sym__qcon,
    STATE(3497), 1,
      sym_qualified_constructor,
    STATE(3562), 1,
      sym_pat_fields,
    STATE(3563), 1,
      sym_literal,
    STATE(3596), 1,
      sym_wildcard,
    STATE(7579), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3097), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3471), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3697), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3111), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(956), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [47363] = 20,
    ACTIONS(3307), 1,
      sym__varid,
    ACTIONS(3309), 1,
      sym_string,
    ACTIONS(3311), 1,
      sym_triple_quote_string,
    ACTIONS(3313), 1,
      sym__integer_literal,
    ACTIONS(3315), 1,
      sym__hex_literal,
    ACTIONS(3319), 1,
      anon_sym__,
    ACTIONS(3323), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(3330), 1,
      anon_sym_AT,
    ACTIONS(3502), 1,
      sym_hole,
    ACTIONS(3504), 1,
      sym__conid,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(948), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [47446] = 24,
    ACTIONS(3507), 1,
      sym__varid,
    ACTIONS(3511), 1,
      sym_string,
    ACTIONS(3513), 1,
      sym__integer_literal,
    ACTIONS(3515), 1,
      sym__hex_literal,
    ACTIONS(3517), 1,
      anon_sym__,
    ACTIONS(3519), 1,
      anon_sym_LPAREN,
    ACTIONS(3521), 1,
      sym__conid,
    ACTIONS(3524), 1,
      anon_sym_LBRACE,
    ACTIONS(3526), 1,
      anon_sym_LBRACK,
    STATE(3343), 1,
      sym_constructor,
    STATE(3375), 1,
      sym_variable,
    STATE(3462), 1,
      sym__qcon,
    STATE(3536), 1,
      sym_qualified_constructor,
    STATE(3710), 1,
      sym_literal,
    STATE(3711), 1,
      sym_pat_fields,
    STATE(3717), 1,
      sym_wildcard,
    STATE(7792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3156), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3509), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3709), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3167), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(954), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [47537] = 24,
    ACTIONS(3507), 1,
      sym__varid,
    ACTIONS(3511), 1,
      sym_string,
    ACTIONS(3513), 1,
      sym__integer_literal,
    ACTIONS(3515), 1,
      sym__hex_literal,
    ACTIONS(3517), 1,
      anon_sym__,
    ACTIONS(3519), 1,
      anon_sym_LPAREN,
    ACTIONS(3524), 1,
      anon_sym_LBRACE,
    ACTIONS(3526), 1,
      anon_sym_LBRACK,
    ACTIONS(3528), 1,
      sym__conid,
    STATE(3343), 1,
      sym_constructor,
    STATE(3375), 1,
      sym_variable,
    STATE(3462), 1,
      sym__qcon,
    STATE(3536), 1,
      sym_qualified_constructor,
    STATE(3710), 1,
      sym_literal,
    STATE(3711), 1,
      sym_pat_fields,
    STATE(3717), 1,
      sym_wildcard,
    STATE(7792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3181), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3509), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3709), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3186), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(958), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [47628] = 20,
    ACTIONS(3307), 1,
      sym__varid,
    ACTIONS(3309), 1,
      sym_string,
    ACTIONS(3311), 1,
      sym_triple_quote_string,
    ACTIONS(3313), 1,
      sym__integer_literal,
    ACTIONS(3315), 1,
      sym__hex_literal,
    ACTIONS(3319), 1,
      anon_sym__,
    ACTIONS(3323), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(3330), 1,
      anon_sym_AT,
    ACTIONS(3502), 1,
      sym_hole,
    ACTIONS(3531), 1,
      sym__conid,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(948), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [47711] = 24,
    ACTIONS(3111), 1,
      sym_comma,
    ACTIONS(3535), 1,
      sym__varid,
    ACTIONS(3541), 1,
      sym_string,
    ACTIONS(3544), 1,
      sym__integer_literal,
    ACTIONS(3547), 1,
      sym__hex_literal,
    ACTIONS(3550), 1,
      anon_sym__,
    ACTIONS(3553), 1,
      anon_sym_LPAREN,
    ACTIONS(3556), 1,
      sym__conid,
    ACTIONS(3559), 1,
      anon_sym_LBRACE,
    ACTIONS(3562), 1,
      anon_sym_LBRACK,
    STATE(3313), 1,
      sym_variable,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(3630), 1,
      sym_wildcard,
    STATE(3634), 1,
      sym_literal,
    STATE(3635), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3538), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3511), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3097), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
    STATE(961), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [47802] = 24,
    ACTIONS(3167), 1,
      sym_comma,
    ACTIONS(3565), 1,
      sym__varid,
    ACTIONS(3569), 1,
      sym_string,
    ACTIONS(3571), 1,
      sym__integer_literal,
    ACTIONS(3573), 1,
      sym__hex_literal,
    ACTIONS(3575), 1,
      anon_sym__,
    ACTIONS(3577), 1,
      anon_sym_LPAREN,
    ACTIONS(3579), 1,
      sym__conid,
    ACTIONS(3582), 1,
      anon_sym_LBRACE,
    ACTIONS(3584), 1,
      anon_sym_LBRACK,
    STATE(3313), 1,
      sym_variable,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(3630), 1,
      sym_wildcard,
    STATE(3634), 1,
      sym_literal,
    STATE(3635), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3567), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3511), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3156), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
    STATE(961), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [47893] = 23,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(3588), 1,
      sym_string,
    ACTIONS(3590), 1,
      sym__integer_literal,
    ACTIONS(3592), 1,
      sym__hex_literal,
    ACTIONS(3594), 1,
      anon_sym__,
    ACTIONS(3596), 1,
      anon_sym_LPAREN,
    ACTIONS(3598), 1,
      sym__conid,
    ACTIONS(3601), 1,
      anon_sym_LBRACE,
    ACTIONS(3603), 1,
      anon_sym_LBRACK,
    STATE(3280), 1,
      sym_constructor,
    STATE(3290), 1,
      sym_variable,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(3689), 1,
      sym_wildcard,
    STATE(3695), 1,
      sym_pat_fields,
    STATE(3699), 1,
      sym_literal,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3586), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3686), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3156), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(964), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [47982] = 23,
    ACTIONS(3605), 1,
      sym__varid,
    ACTIONS(3611), 1,
      sym_string,
    ACTIONS(3614), 1,
      sym__integer_literal,
    ACTIONS(3617), 1,
      sym__hex_literal,
    ACTIONS(3620), 1,
      anon_sym__,
    ACTIONS(3623), 1,
      anon_sym_LPAREN,
    ACTIONS(3626), 1,
      sym__conid,
    ACTIONS(3629), 1,
      anon_sym_LBRACE,
    ACTIONS(3632), 1,
      anon_sym_LBRACK,
    STATE(3280), 1,
      sym_constructor,
    STATE(3290), 1,
      sym_variable,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(3689), 1,
      sym_wildcard,
    STATE(3695), 1,
      sym_pat_fields,
    STATE(3699), 1,
      sym_literal,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3608), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3686), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3097), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(964), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [48071] = 24,
    ACTIONS(3635), 1,
      sym__varid,
    ACTIONS(3639), 1,
      sym_string,
    ACTIONS(3641), 1,
      sym__integer_literal,
    ACTIONS(3643), 1,
      sym__hex_literal,
    ACTIONS(3645), 1,
      anon_sym__,
    ACTIONS(3647), 1,
      anon_sym_LPAREN,
    ACTIONS(3649), 1,
      sym__conid,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      anon_sym_LBRACK,
    STATE(3303), 1,
      sym_constructor,
    STATE(3358), 1,
      sym_variable,
    STATE(3441), 1,
      sym__qcon,
    STATE(3497), 1,
      sym_qualified_constructor,
    STATE(3562), 1,
      sym_pat_fields,
    STATE(3563), 1,
      sym_literal,
    STATE(3596), 1,
      sym_wildcard,
    STATE(7579), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3156), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3637), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3697), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3167), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(956), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [48162] = 23,
    ACTIONS(3656), 1,
      sym__varid,
    ACTIONS(3662), 1,
      sym_string,
    ACTIONS(3665), 1,
      sym__integer_literal,
    ACTIONS(3668), 1,
      sym__hex_literal,
    ACTIONS(3671), 1,
      anon_sym__,
    ACTIONS(3674), 1,
      anon_sym_LPAREN,
    ACTIONS(3677), 1,
      sym__conid,
    ACTIONS(3680), 1,
      anon_sym_LBRACE,
    ACTIONS(3683), 1,
      anon_sym_LBRACK,
    STATE(3283), 1,
      sym_constructor,
    STATE(3340), 1,
      sym_variable,
    STATE(3540), 1,
      sym_literal,
    STATE(3541), 1,
      sym__qcon,
    STATE(3543), 1,
      sym_wildcard,
    STATE(3602), 1,
      sym_pat_fields,
    STATE(3650), 1,
      sym_qualified_constructor,
    STATE(7904), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3659), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3653), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3097), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    STATE(966), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [48251] = 20,
    ACTIONS(3275), 1,
      sym__varid,
    ACTIONS(3280), 1,
      sym_string,
    ACTIONS(3282), 1,
      sym_triple_quote_string,
    ACTIONS(3284), 1,
      sym__integer_literal,
    ACTIONS(3286), 1,
      sym__hex_literal,
    ACTIONS(3291), 1,
      anon_sym__,
    ACTIONS(3293), 1,
      sym_hole,
    ACTIONS(3295), 1,
      anon_sym_LPAREN,
    ACTIONS(3301), 1,
      anon_sym_LBRACE,
    ACTIONS(3303), 1,
      anon_sym_AT,
    ACTIONS(3686), 1,
      sym__conid,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(952), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [48334] = 20,
    ACTIONS(3689), 1,
      sym__varid,
    ACTIONS(3692), 1,
      sym_string,
    ACTIONS(3695), 1,
      sym_triple_quote_string,
    ACTIONS(3698), 1,
      sym__integer_literal,
    ACTIONS(3701), 1,
      sym__hex_literal,
    ACTIONS(3704), 1,
      anon_sym__,
    ACTIONS(3707), 1,
      sym_hole,
    ACTIONS(3710), 1,
      anon_sym_LPAREN,
    ACTIONS(3713), 1,
      sym__conid,
    ACTIONS(3716), 1,
      anon_sym_LBRACE,
    ACTIONS(3719), 1,
      anon_sym_AT,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(968), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [48417] = 20,
    ACTIONS(3307), 1,
      sym__varid,
    ACTIONS(3309), 1,
      sym_string,
    ACTIONS(3311), 1,
      sym_triple_quote_string,
    ACTIONS(3313), 1,
      sym__integer_literal,
    ACTIONS(3315), 1,
      sym__hex_literal,
    ACTIONS(3319), 1,
      anon_sym__,
    ACTIONS(3323), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(3330), 1,
      anon_sym_AT,
    ACTIONS(3502), 1,
      sym_hole,
    ACTIONS(3722), 1,
      sym__conid,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(948), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [48500] = 26,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(8588), 1,
      sym__pattern_decl,
    STATE(10078), 1,
      sym__modid,
    STATE(6768), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [48595] = 20,
    ACTIONS(3725), 1,
      sym__varid,
    ACTIONS(3727), 1,
      sym_string,
    ACTIONS(3729), 1,
      sym_triple_quote_string,
    ACTIONS(3731), 1,
      sym__integer_literal,
    ACTIONS(3733), 1,
      sym__hex_literal,
    ACTIONS(3735), 1,
      anon_sym__,
    ACTIONS(3737), 1,
      sym_hole,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
    ACTIONS(3741), 1,
      sym__conid,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(3746), 1,
      anon_sym_AT,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(973), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [48678] = 20,
    ACTIONS(3725), 1,
      sym__varid,
    ACTIONS(3727), 1,
      sym_string,
    ACTIONS(3729), 1,
      sym_triple_quote_string,
    ACTIONS(3731), 1,
      sym__integer_literal,
    ACTIONS(3733), 1,
      sym__hex_literal,
    ACTIONS(3735), 1,
      anon_sym__,
    ACTIONS(3737), 1,
      sym_hole,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(3746), 1,
      anon_sym_AT,
    ACTIONS(3748), 1,
      sym__conid,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(973), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [48761] = 20,
    ACTIONS(3725), 1,
      sym__varid,
    ACTIONS(3727), 1,
      sym_string,
    ACTIONS(3729), 1,
      sym_triple_quote_string,
    ACTIONS(3731), 1,
      sym__integer_literal,
    ACTIONS(3733), 1,
      sym__hex_literal,
    ACTIONS(3735), 1,
      anon_sym__,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(3746), 1,
      anon_sym_AT,
    ACTIONS(3752), 1,
      sym_hole,
    ACTIONS(3754), 1,
      sym__conid,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(968), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [48844] = 20,
    ACTIONS(3725), 1,
      sym__varid,
    ACTIONS(3727), 1,
      sym_string,
    ACTIONS(3729), 1,
      sym_triple_quote_string,
    ACTIONS(3731), 1,
      sym__integer_literal,
    ACTIONS(3733), 1,
      sym__hex_literal,
    ACTIONS(3735), 1,
      anon_sym__,
    ACTIONS(3737), 1,
      sym_hole,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(3746), 1,
      anon_sym_AT,
    ACTIONS(3757), 1,
      sym__conid,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    STATE(973), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [48927] = 24,
    ACTIONS(3635), 1,
      sym__varid,
    ACTIONS(3639), 1,
      sym_string,
    ACTIONS(3641), 1,
      sym__integer_literal,
    ACTIONS(3643), 1,
      sym__hex_literal,
    ACTIONS(3645), 1,
      anon_sym__,
    ACTIONS(3647), 1,
      anon_sym_LPAREN,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      anon_sym_LBRACK,
    ACTIONS(3760), 1,
      sym__conid,
    STATE(3303), 1,
      sym_constructor,
    STATE(3358), 1,
      sym_variable,
    STATE(3441), 1,
      sym__qcon,
    STATE(3497), 1,
      sym_qualified_constructor,
    STATE(3562), 1,
      sym_pat_fields,
    STATE(3563), 1,
      sym_literal,
    STATE(3596), 1,
      sym_wildcard,
    STATE(7579), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3181), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3637), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3697), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3186), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(965), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [49018] = 24,
    ACTIONS(3186), 1,
      sym_comma,
    ACTIONS(3565), 1,
      sym__varid,
    ACTIONS(3569), 1,
      sym_string,
    ACTIONS(3571), 1,
      sym__integer_literal,
    ACTIONS(3573), 1,
      sym__hex_literal,
    ACTIONS(3575), 1,
      anon_sym__,
    ACTIONS(3577), 1,
      anon_sym_LPAREN,
    ACTIONS(3582), 1,
      anon_sym_LBRACE,
    ACTIONS(3584), 1,
      anon_sym_LBRACK,
    ACTIONS(3763), 1,
      sym__conid,
    STATE(3313), 1,
      sym_variable,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(3630), 1,
      sym_wildcard,
    STATE(3634), 1,
      sym_literal,
    STATE(3635), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3567), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3511), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3181), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
    STATE(962), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [49109] = 23,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(3588), 1,
      sym_string,
    ACTIONS(3590), 1,
      sym__integer_literal,
    ACTIONS(3592), 1,
      sym__hex_literal,
    ACTIONS(3594), 1,
      anon_sym__,
    ACTIONS(3596), 1,
      anon_sym_LPAREN,
    ACTIONS(3601), 1,
      anon_sym_LBRACE,
    ACTIONS(3603), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 1,
      sym__conid,
    STATE(3280), 1,
      sym_constructor,
    STATE(3290), 1,
      sym_variable,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(3689), 1,
      sym_wildcard,
    STATE(3695), 1,
      sym_pat_fields,
    STATE(3699), 1,
      sym_literal,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3586), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3686), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3181), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(963), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [49198] = 26,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(8594), 1,
      sym_alt,
    STATE(10078), 1,
      sym__modid,
    STATE(5523), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [49293] = 20,
    ACTIONS(3769), 1,
      sym__varid,
    ACTIONS(3771), 1,
      sym_string,
    ACTIONS(3773), 1,
      sym_triple_quote_string,
    ACTIONS(3775), 1,
      sym__integer_literal,
    ACTIONS(3777), 1,
      sym__hex_literal,
    ACTIONS(3779), 1,
      anon_sym__,
    ACTIONS(3781), 1,
      sym_hole,
    ACTIONS(3783), 1,
      anon_sym_LPAREN,
    ACTIONS(3785), 1,
      sym__conid,
    ACTIONS(3788), 1,
      anon_sym_LBRACE,
    ACTIONS(3790), 1,
      anon_sym_AT,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1020), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [49375] = 20,
    ACTIONS(3792), 1,
      sym__varid,
    ACTIONS(3795), 1,
      sym_string,
    ACTIONS(3798), 1,
      sym_triple_quote_string,
    ACTIONS(3801), 1,
      sym__integer_literal,
    ACTIONS(3804), 1,
      sym__hex_literal,
    ACTIONS(3807), 1,
      anon_sym__,
    ACTIONS(3810), 1,
      sym_hole,
    ACTIONS(3813), 1,
      anon_sym_LPAREN,
    ACTIONS(3816), 1,
      sym__conid,
    ACTIONS(3819), 1,
      anon_sym_LBRACE,
    ACTIONS(3822), 1,
      anon_sym_AT,
    STATE(3107), 1,
      sym_constructor,
    STATE(3261), 1,
      sym_integer,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3317), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(990), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [49457] = 24,
    ACTIONS(3825), 1,
      sym__varid,
    ACTIONS(3829), 1,
      sym_string,
    ACTIONS(3831), 1,
      sym__integer_literal,
    ACTIONS(3833), 1,
      sym__hex_literal,
    ACTIONS(3835), 1,
      anon_sym__,
    ACTIONS(3837), 1,
      anon_sym_LPAREN,
    ACTIONS(3839), 1,
      sym__conid,
    ACTIONS(3842), 1,
      anon_sym_LBRACE,
    ACTIONS(3844), 1,
      anon_sym_LBRACK,
    STATE(3501), 1,
      sym_constructor,
    STATE(3627), 1,
      sym_variable,
    STATE(3908), 1,
      sym__qcon,
    STATE(3982), 1,
      sym_qualified_constructor,
    STATE(4026), 1,
      sym_wildcard,
    STATE(4027), 1,
      sym_literal,
    STATE(4050), 1,
      sym_pat_fields,
    STATE(7718), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3156), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3167), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3827), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3796), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(987), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [49547] = 24,
    ACTIONS(3825), 1,
      sym__varid,
    ACTIONS(3829), 1,
      sym_string,
    ACTIONS(3831), 1,
      sym__integer_literal,
    ACTIONS(3833), 1,
      sym__hex_literal,
    ACTIONS(3835), 1,
      anon_sym__,
    ACTIONS(3837), 1,
      anon_sym_LPAREN,
    ACTIONS(3842), 1,
      anon_sym_LBRACE,
    ACTIONS(3844), 1,
      anon_sym_LBRACK,
    ACTIONS(3846), 1,
      sym__conid,
    STATE(3501), 1,
      sym_constructor,
    STATE(3627), 1,
      sym_variable,
    STATE(3908), 1,
      sym__qcon,
    STATE(3982), 1,
      sym_qualified_constructor,
    STATE(4026), 1,
      sym_wildcard,
    STATE(4027), 1,
      sym_literal,
    STATE(4050), 1,
      sym_pat_fields,
    STATE(7718), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3181), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3186), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3827), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3796), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(981), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [49637] = 20,
    ACTIONS(3849), 1,
      sym__varid,
    ACTIONS(3851), 1,
      sym_string,
    ACTIONS(3853), 1,
      sym_triple_quote_string,
    ACTIONS(3855), 1,
      sym__integer_literal,
    ACTIONS(3857), 1,
      sym__hex_literal,
    ACTIONS(3859), 1,
      anon_sym__,
    ACTIONS(3861), 1,
      sym_hole,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    ACTIONS(3865), 1,
      sym__conid,
    ACTIONS(3868), 1,
      anon_sym_LBRACE,
    ACTIONS(3870), 1,
      anon_sym_AT,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3500), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(985), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [49719] = 20,
    ACTIONS(3849), 1,
      sym__varid,
    ACTIONS(3851), 1,
      sym_string,
    ACTIONS(3853), 1,
      sym_triple_quote_string,
    ACTIONS(3855), 1,
      sym__integer_literal,
    ACTIONS(3857), 1,
      sym__hex_literal,
    ACTIONS(3859), 1,
      anon_sym__,
    ACTIONS(3861), 1,
      sym_hole,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    ACTIONS(3868), 1,
      anon_sym_LBRACE,
    ACTIONS(3870), 1,
      anon_sym_AT,
    ACTIONS(3872), 1,
      sym__conid,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(985), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [49801] = 20,
    ACTIONS(3849), 1,
      sym__varid,
    ACTIONS(3851), 1,
      sym_string,
    ACTIONS(3853), 1,
      sym_triple_quote_string,
    ACTIONS(3855), 1,
      sym__integer_literal,
    ACTIONS(3857), 1,
      sym__hex_literal,
    ACTIONS(3859), 1,
      anon_sym__,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    ACTIONS(3868), 1,
      anon_sym_LBRACE,
    ACTIONS(3870), 1,
      anon_sym_AT,
    ACTIONS(3876), 1,
      sym_hole,
    ACTIONS(3878), 1,
      sym__conid,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3317), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(993), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [49883] = 25,
    ACTIONS(3881), 1,
      sym__varid,
    ACTIONS(3885), 1,
      sym_string,
    ACTIONS(3887), 1,
      sym__integer_literal,
    ACTIONS(3889), 1,
      sym__hex_literal,
    ACTIONS(3891), 1,
      anon_sym__,
    ACTIONS(3893), 1,
      anon_sym_DASH,
    ACTIONS(3895), 1,
      anon_sym_LPAREN,
    ACTIONS(3897), 1,
      sym__conid,
    ACTIONS(3899), 1,
      anon_sym_LBRACE,
    ACTIONS(3901), 1,
      anon_sym_LBRACK,
    STATE(1027), 1,
      sym__pat_constructor,
    STATE(3490), 1,
      sym_constructor,
    STATE(3969), 1,
      sym__qcon,
    STATE(3978), 1,
      sym_qualified_constructor,
    STATE(6729), 1,
      sym_variable,
    STATE(6733), 1,
      sym_pat_fields,
    STATE(6749), 1,
      sym_literal,
    STATE(6750), 1,
      sym_wildcard,
    STATE(7639), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(8082), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3883), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6822), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4614), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [49975] = 24,
    ACTIONS(3903), 1,
      sym__varid,
    ACTIONS(3909), 1,
      sym_string,
    ACTIONS(3912), 1,
      sym__integer_literal,
    ACTIONS(3915), 1,
      sym__hex_literal,
    ACTIONS(3918), 1,
      anon_sym__,
    ACTIONS(3921), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      sym__conid,
    ACTIONS(3927), 1,
      anon_sym_LBRACE,
    ACTIONS(3930), 1,
      anon_sym_LBRACK,
    STATE(3501), 1,
      sym_constructor,
    STATE(3627), 1,
      sym_variable,
    STATE(3908), 1,
      sym__qcon,
    STATE(3982), 1,
      sym_qualified_constructor,
    STATE(4026), 1,
      sym_wildcard,
    STATE(4027), 1,
      sym_literal,
    STATE(4050), 1,
      sym_pat_fields,
    STATE(7718), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3097), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3111), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3906), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3796), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(987), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [50065] = 20,
    ACTIONS(3933), 1,
      sym__varid,
    ACTIONS(3936), 1,
      sym_string,
    ACTIONS(3939), 1,
      sym_triple_quote_string,
    ACTIONS(3942), 1,
      sym__integer_literal,
    ACTIONS(3945), 1,
      sym__hex_literal,
    ACTIONS(3948), 1,
      anon_sym__,
    ACTIONS(3951), 1,
      sym_hole,
    ACTIONS(3954), 1,
      anon_sym_LPAREN,
    ACTIONS(3957), 1,
      sym__conid,
    ACTIONS(3960), 1,
      anon_sym_LBRACE,
    ACTIONS(3963), 1,
      anon_sym_AT,
    STATE(3107), 1,
      sym_constructor,
    STATE(3261), 1,
      sym_integer,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3463), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(980), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [50147] = 20,
    ACTIONS(3966), 1,
      sym__varid,
    ACTIONS(3969), 1,
      sym_string,
    ACTIONS(3972), 1,
      sym_triple_quote_string,
    ACTIONS(3975), 1,
      sym__integer_literal,
    ACTIONS(3978), 1,
      sym__hex_literal,
    ACTIONS(3981), 1,
      anon_sym__,
    ACTIONS(3984), 1,
      sym_hole,
    ACTIONS(3987), 1,
      anon_sym_LPAREN,
    ACTIONS(3990), 1,
      sym__conid,
    ACTIONS(3993), 1,
      anon_sym_LBRACE,
    ACTIONS(3996), 1,
      anon_sym_AT,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3463), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1031), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [50229] = 20,
    ACTIONS(3999), 1,
      sym__varid,
    ACTIONS(4002), 1,
      sym_string,
    ACTIONS(4005), 1,
      sym_triple_quote_string,
    ACTIONS(4008), 1,
      sym__integer_literal,
    ACTIONS(4011), 1,
      sym__hex_literal,
    ACTIONS(4014), 1,
      anon_sym__,
    ACTIONS(4017), 1,
      sym_hole,
    ACTIONS(4020), 1,
      anon_sym_LPAREN,
    ACTIONS(4023), 1,
      sym__conid,
    ACTIONS(4026), 1,
      anon_sym_LBRACE,
    ACTIONS(4029), 1,
      anon_sym_AT,
    STATE(3107), 1,
      sym_constructor,
    STATE(3261), 1,
      sym_integer,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3349), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(990), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [50311] = 25,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(7620), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [50403] = 20,
    ACTIONS(3849), 1,
      sym__varid,
    ACTIONS(3851), 1,
      sym_string,
    ACTIONS(3853), 1,
      sym_triple_quote_string,
    ACTIONS(3855), 1,
      sym__integer_literal,
    ACTIONS(3857), 1,
      sym__hex_literal,
    ACTIONS(3859), 1,
      anon_sym__,
    ACTIONS(3861), 1,
      sym_hole,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    ACTIONS(3868), 1,
      anon_sym_LBRACE,
    ACTIONS(3870), 1,
      anon_sym_AT,
    ACTIONS(4032), 1,
      sym__conid,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(985), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [50485] = 20,
    ACTIONS(4035), 1,
      sym__varid,
    ACTIONS(4038), 1,
      sym_string,
    ACTIONS(4041), 1,
      sym_triple_quote_string,
    ACTIONS(4044), 1,
      sym__integer_literal,
    ACTIONS(4047), 1,
      sym__hex_literal,
    ACTIONS(4050), 1,
      anon_sym__,
    ACTIONS(4053), 1,
      sym_hole,
    ACTIONS(4056), 1,
      anon_sym_LPAREN,
    ACTIONS(4059), 1,
      sym__conid,
    ACTIONS(4062), 1,
      anon_sym_LBRACE,
    ACTIONS(4065), 1,
      anon_sym_AT,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3349), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(993), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [50567] = 25,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(17), 1,
      anon_sym_DASH,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      sym__varid,
    ACTIONS(4070), 1,
      anon_sym_LPAREN,
    STATE(977), 1,
      sym__pat_constructor,
    STATE(3280), 1,
      sym_constructor,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(6305), 1,
      sym_variable,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(7686), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4359), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [50659] = 25,
    ACTIONS(4072), 1,
      sym__varid,
    ACTIONS(4076), 1,
      sym_string,
    ACTIONS(4078), 1,
      sym__integer_literal,
    ACTIONS(4080), 1,
      sym__hex_literal,
    ACTIONS(4082), 1,
      anon_sym__,
    ACTIONS(4084), 1,
      anon_sym_DASH,
    ACTIONS(4086), 1,
      anon_sym_LPAREN,
    ACTIONS(4088), 1,
      sym__conid,
    ACTIONS(4090), 1,
      anon_sym_LBRACE,
    ACTIONS(4092), 1,
      anon_sym_LBRACK,
    STATE(1115), 1,
      sym__pat_constructor,
    STATE(3971), 1,
      sym_constructor,
    STATE(4144), 1,
      sym__qcon,
    STATE(4210), 1,
      sym_qualified_constructor,
    STATE(6829), 1,
      sym_variable,
    STATE(7097), 1,
      sym_pat_fields,
    STATE(7320), 1,
      sym_wildcard,
    STATE(7322), 1,
      sym_literal,
    STATE(7964), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6854), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4074), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7077), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4735), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [50751] = 25,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2918), 1,
      anon_sym_DASH,
    ACTIONS(2920), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    STATE(976), 1,
      sym__pat_constructor,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(6331), 1,
      sym_variable,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(7941), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4371), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [50843] = 20,
    ACTIONS(4094), 1,
      sym__varid,
    ACTIONS(4097), 1,
      sym_string,
    ACTIONS(4100), 1,
      sym_triple_quote_string,
    ACTIONS(4103), 1,
      sym__integer_literal,
    ACTIONS(4106), 1,
      sym__hex_literal,
    ACTIONS(4109), 1,
      anon_sym__,
    ACTIONS(4112), 1,
      sym_hole,
    ACTIONS(4115), 1,
      anon_sym_LPAREN,
    ACTIONS(4118), 1,
      sym__conid,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    ACTIONS(4124), 1,
      anon_sym_AT,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3349), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(997), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [50925] = 25,
    ACTIONS(3881), 1,
      sym__varid,
    ACTIONS(3885), 1,
      sym_string,
    ACTIONS(3887), 1,
      sym__integer_literal,
    ACTIONS(3889), 1,
      sym__hex_literal,
    ACTIONS(3891), 1,
      anon_sym__,
    ACTIONS(3893), 1,
      anon_sym_DASH,
    ACTIONS(3895), 1,
      anon_sym_LPAREN,
    ACTIONS(3897), 1,
      sym__conid,
    ACTIONS(3899), 1,
      anon_sym_LBRACE,
    ACTIONS(3901), 1,
      anon_sym_LBRACK,
    STATE(1027), 1,
      sym__pat_constructor,
    STATE(3490), 1,
      sym_constructor,
    STATE(3969), 1,
      sym__qcon,
    STATE(3978), 1,
      sym_qualified_constructor,
    STATE(6729), 1,
      sym_variable,
    STATE(6733), 1,
      sym_pat_fields,
    STATE(6749), 1,
      sym_literal,
    STATE(6750), 1,
      sym_wildcard,
    STATE(7639), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(8318), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3883), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6822), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4614), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [51017] = 25,
    ACTIONS(4127), 1,
      sym__varid,
    ACTIONS(4131), 1,
      sym_string,
    ACTIONS(4133), 1,
      sym__integer_literal,
    ACTIONS(4135), 1,
      sym__hex_literal,
    ACTIONS(4137), 1,
      anon_sym__,
    ACTIONS(4139), 1,
      anon_sym_DASH,
    ACTIONS(4141), 1,
      anon_sym_LPAREN,
    ACTIONS(4143), 1,
      sym__conid,
    ACTIONS(4145), 1,
      anon_sym_LBRACE,
    ACTIONS(4147), 1,
      anon_sym_LBRACK,
    STATE(975), 1,
      sym__pat_constructor,
    STATE(3303), 1,
      sym_constructor,
    STATE(3441), 1,
      sym__qcon,
    STATE(3497), 1,
      sym_qualified_constructor,
    STATE(6222), 1,
      sym_variable,
    STATE(6410), 1,
      sym_literal,
    STATE(6636), 1,
      sym_wildcard,
    STATE(6710), 1,
      sym_pat_fields,
    STATE(7579), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(7769), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4129), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6595), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4342), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [51109] = 25,
    ACTIONS(4149), 1,
      sym__varid,
    ACTIONS(4153), 1,
      sym_string,
    ACTIONS(4155), 1,
      sym__integer_literal,
    ACTIONS(4157), 1,
      sym__hex_literal,
    ACTIONS(4159), 1,
      anon_sym__,
    ACTIONS(4161), 1,
      anon_sym_DASH,
    ACTIONS(4163), 1,
      anon_sym_LPAREN,
    ACTIONS(4165), 1,
      sym__conid,
    ACTIONS(4167), 1,
      anon_sym_LBRACE,
    ACTIONS(4169), 1,
      anon_sym_LBRACK,
    STATE(959), 1,
      sym__pat_constructor,
    STATE(3343), 1,
      sym_constructor,
    STATE(3462), 1,
      sym__qcon,
    STATE(3536), 1,
      sym_qualified_constructor,
    STATE(6397), 1,
      sym_variable,
    STATE(6428), 1,
      sym_wildcard,
    STATE(6432), 1,
      sym_literal,
    STATE(6639), 1,
      sym_pat_fields,
    STATE(7792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(7574), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4151), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6725), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4444), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [51201] = 24,
    ACTIONS(4171), 1,
      sym__varid,
    ACTIONS(4177), 1,
      sym_string,
    ACTIONS(4180), 1,
      sym__integer_literal,
    ACTIONS(4183), 1,
      sym__hex_literal,
    ACTIONS(4186), 1,
      anon_sym__,
    ACTIONS(4189), 1,
      anon_sym_LPAREN,
    ACTIONS(4192), 1,
      sym__conid,
    ACTIONS(4195), 1,
      anon_sym_LBRACE,
    ACTIONS(4198), 1,
      anon_sym_LBRACK,
    STATE(3490), 1,
      sym_constructor,
    STATE(3713), 1,
      sym_variable,
    STATE(3730), 1,
      sym_literal,
    STATE(3731), 1,
      sym_pat_fields,
    STATE(3760), 1,
      sym_wildcard,
    STATE(3969), 1,
      sym__qcon,
    STATE(3978), 1,
      sym_qualified_constructor,
    STATE(7639), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3097), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3111), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(4174), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4031), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1001), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [51291] = 23,
    ACTIONS(4201), 1,
      sym__varid,
    ACTIONS(4207), 1,
      sym_string,
    ACTIONS(4210), 1,
      sym__integer_literal,
    ACTIONS(4213), 1,
      sym__hex_literal,
    ACTIONS(4216), 1,
      anon_sym__,
    ACTIONS(4219), 1,
      anon_sym_LPAREN,
    ACTIONS(4222), 1,
      sym__conid,
    ACTIONS(4225), 1,
      anon_sym_LBRACE,
    ACTIONS(4228), 1,
      anon_sym_LBRACK,
    STATE(3500), 1,
      sym_variable,
    STATE(3504), 1,
      sym_constructor,
    STATE(3868), 1,
      sym_wildcard,
    STATE(3869), 1,
      sym_literal,
    STATE(3870), 1,
      sym_pat_fields,
    STATE(4052), 1,
      sym_qualified_constructor,
    STATE(4053), 1,
      sym__qcon,
    STATE(7774), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4204), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3867), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3097), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
    STATE(1002), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [51379] = 25,
    ACTIONS(4127), 1,
      sym__varid,
    ACTIONS(4131), 1,
      sym_string,
    ACTIONS(4133), 1,
      sym__integer_literal,
    ACTIONS(4135), 1,
      sym__hex_literal,
    ACTIONS(4137), 1,
      anon_sym__,
    ACTIONS(4139), 1,
      anon_sym_DASH,
    ACTIONS(4141), 1,
      anon_sym_LPAREN,
    ACTIONS(4143), 1,
      sym__conid,
    ACTIONS(4145), 1,
      anon_sym_LBRACE,
    ACTIONS(4147), 1,
      anon_sym_LBRACK,
    STATE(975), 1,
      sym__pat_constructor,
    STATE(3303), 1,
      sym_constructor,
    STATE(3441), 1,
      sym__qcon,
    STATE(3497), 1,
      sym_qualified_constructor,
    STATE(6222), 1,
      sym_variable,
    STATE(6410), 1,
      sym_literal,
    STATE(6636), 1,
      sym_wildcard,
    STATE(6710), 1,
      sym_pat_fields,
    STATE(7579), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(7753), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4129), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6595), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4342), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [51471] = 25,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2950), 1,
      anon_sym_DASH,
    ACTIONS(2952), 1,
      anon_sym_LPAREN,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    STATE(1145), 1,
      sym__pat_constructor,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(7686), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4785), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [51563] = 25,
    ACTIONS(2864), 1,
      sym__varid,
    ACTIONS(2868), 1,
      sym_string,
    ACTIONS(2870), 1,
      sym__integer_literal,
    ACTIONS(2872), 1,
      sym__hex_literal,
    ACTIONS(2874), 1,
      anon_sym__,
    ACTIONS(2876), 1,
      anon_sym_DASH,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    ACTIONS(4231), 1,
      anon_sym_LPAREN,
    ACTIONS(4233), 1,
      sym__conid,
    STATE(1007), 1,
      sym__pat_constructor,
    STATE(3504), 1,
      sym_constructor,
    STATE(4052), 1,
      sym_qualified_constructor,
    STATE(4053), 1,
      sym__qcon,
    STATE(6502), 1,
      sym_variable,
    STATE(6848), 1,
      sym_wildcard,
    STATE(6858), 1,
      sym_literal,
    STATE(6861), 1,
      sym_pat_fields,
    STATE(7774), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6854), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2866), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6846), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4526), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [51655] = 23,
    ACTIONS(4235), 1,
      sym__varid,
    ACTIONS(4239), 1,
      sym_string,
    ACTIONS(4241), 1,
      sym__integer_literal,
    ACTIONS(4243), 1,
      sym__hex_literal,
    ACTIONS(4245), 1,
      anon_sym__,
    ACTIONS(4247), 1,
      anon_sym_LPAREN,
    ACTIONS(4249), 1,
      sym__conid,
    ACTIONS(4252), 1,
      anon_sym_LBRACE,
    ACTIONS(4254), 1,
      anon_sym_LBRACK,
    STATE(3500), 1,
      sym_variable,
    STATE(3504), 1,
      sym_constructor,
    STATE(3868), 1,
      sym_wildcard,
    STATE(3869), 1,
      sym_literal,
    STATE(3870), 1,
      sym_pat_fields,
    STATE(4052), 1,
      sym_qualified_constructor,
    STATE(4053), 1,
      sym__qcon,
    STATE(7774), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4237), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3867), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3156), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
    STATE(1002), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [51743] = 23,
    ACTIONS(4235), 1,
      sym__varid,
    ACTIONS(4239), 1,
      sym_string,
    ACTIONS(4241), 1,
      sym__integer_literal,
    ACTIONS(4243), 1,
      sym__hex_literal,
    ACTIONS(4245), 1,
      anon_sym__,
    ACTIONS(4247), 1,
      anon_sym_LPAREN,
    ACTIONS(4252), 1,
      anon_sym_LBRACE,
    ACTIONS(4254), 1,
      anon_sym_LBRACK,
    ACTIONS(4256), 1,
      sym__conid,
    STATE(3500), 1,
      sym_variable,
    STATE(3504), 1,
      sym_constructor,
    STATE(3868), 1,
      sym_wildcard,
    STATE(3869), 1,
      sym_literal,
    STATE(3870), 1,
      sym_pat_fields,
    STATE(4052), 1,
      sym_qualified_constructor,
    STATE(4053), 1,
      sym__qcon,
    STATE(7774), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4237), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3867), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3181), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
    STATE(1006), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [51831] = 24,
    ACTIONS(3186), 1,
      anon_sym_RPAREN,
    ACTIONS(4259), 1,
      sym__varid,
    ACTIONS(4263), 1,
      sym_string,
    ACTIONS(4265), 1,
      sym__integer_literal,
    ACTIONS(4267), 1,
      sym__hex_literal,
    ACTIONS(4269), 1,
      anon_sym__,
    ACTIONS(4271), 1,
      anon_sym_LPAREN,
    ACTIONS(4273), 1,
      sym__conid,
    ACTIONS(4276), 1,
      anon_sym_LBRACE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_constructor,
    STATE(3678), 1,
      sym_variable,
    STATE(3792), 1,
      sym_pat_fields,
    STATE(3793), 1,
      sym_literal,
    STATE(3794), 1,
      sym_wildcard,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(7642), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4261), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3795), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3181), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    STATE(1010), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [51921] = 25,
    ACTIONS(4280), 1,
      sym__varid,
    ACTIONS(4284), 1,
      sym_string,
    ACTIONS(4286), 1,
      sym__integer_literal,
    ACTIONS(4288), 1,
      sym__hex_literal,
    ACTIONS(4290), 1,
      anon_sym__,
    ACTIONS(4292), 1,
      anon_sym_DASH,
    ACTIONS(4294), 1,
      anon_sym_LPAREN,
    ACTIONS(4296), 1,
      sym__conid,
    ACTIONS(4298), 1,
      anon_sym_LBRACE,
    ACTIONS(4300), 1,
      anon_sym_LBRACK,
    STATE(982), 1,
      sym__pat_constructor,
    STATE(3501), 1,
      sym_constructor,
    STATE(3908), 1,
      sym__qcon,
    STATE(3982), 1,
      sym_qualified_constructor,
    STATE(6627), 1,
      sym_variable,
    STATE(6791), 1,
      sym_wildcard,
    STATE(6798), 1,
      sym_literal,
    STATE(6909), 1,
      sym_pat_fields,
    STATE(7718), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(8351), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4282), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6802), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4520), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [52013] = 24,
    ACTIONS(3167), 1,
      anon_sym_RPAREN,
    ACTIONS(4259), 1,
      sym__varid,
    ACTIONS(4263), 1,
      sym_string,
    ACTIONS(4265), 1,
      sym__integer_literal,
    ACTIONS(4267), 1,
      sym__hex_literal,
    ACTIONS(4269), 1,
      anon_sym__,
    ACTIONS(4271), 1,
      anon_sym_LPAREN,
    ACTIONS(4276), 1,
      anon_sym_LBRACE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    ACTIONS(4302), 1,
      sym__conid,
    STATE(3457), 1,
      sym_constructor,
    STATE(3678), 1,
      sym_variable,
    STATE(3792), 1,
      sym_pat_fields,
    STATE(3793), 1,
      sym_literal,
    STATE(3794), 1,
      sym_wildcard,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(7642), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4261), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3795), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3156), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    STATE(1016), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [52103] = 25,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2076), 1,
      anon_sym_LPAREN,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    ACTIONS(4305), 1,
      anon_sym_DASH,
    STATE(1008), 1,
      sym__pat_constructor,
    STATE(3457), 1,
      sym_constructor,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(7642), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6854), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4632), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [52195] = 20,
    ACTIONS(4307), 1,
      sym__varid,
    ACTIONS(4310), 1,
      sym_string,
    ACTIONS(4313), 1,
      sym_triple_quote_string,
    ACTIONS(4316), 1,
      sym__integer_literal,
    ACTIONS(4319), 1,
      sym__hex_literal,
    ACTIONS(4322), 1,
      anon_sym__,
    ACTIONS(4325), 1,
      sym_hole,
    ACTIONS(4328), 1,
      anon_sym_LPAREN,
    ACTIONS(4331), 1,
      sym__conid,
    ACTIONS(4334), 1,
      anon_sym_LBRACE,
    ACTIONS(4337), 1,
      anon_sym_AT,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1012), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [52277] = 20,
    ACTIONS(4340), 1,
      sym__varid,
    ACTIONS(4343), 1,
      sym_string,
    ACTIONS(4346), 1,
      sym_triple_quote_string,
    ACTIONS(4349), 1,
      sym__integer_literal,
    ACTIONS(4352), 1,
      sym__hex_literal,
    ACTIONS(4355), 1,
      anon_sym__,
    ACTIONS(4358), 1,
      sym_hole,
    ACTIONS(4361), 1,
      anon_sym_LPAREN,
    ACTIONS(4364), 1,
      sym__conid,
    ACTIONS(4367), 1,
      anon_sym_LBRACE,
    ACTIONS(4370), 1,
      anon_sym_AT,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3349), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1013), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [52359] = 20,
    ACTIONS(4373), 1,
      sym__varid,
    ACTIONS(4376), 1,
      sym_string,
    ACTIONS(4379), 1,
      sym_triple_quote_string,
    ACTIONS(4382), 1,
      sym__integer_literal,
    ACTIONS(4385), 1,
      sym__hex_literal,
    ACTIONS(4388), 1,
      anon_sym__,
    ACTIONS(4391), 1,
      sym_hole,
    ACTIONS(4394), 1,
      anon_sym_LPAREN,
    ACTIONS(4397), 1,
      sym__conid,
    ACTIONS(4400), 1,
      anon_sym_LBRACE,
    ACTIONS(4403), 1,
      anon_sym_AT,
    STATE(3107), 1,
      sym_constructor,
    STATE(3261), 1,
      sym_integer,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3500), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(980), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [52441] = 25,
    ACTIONS(4149), 1,
      sym__varid,
    ACTIONS(4153), 1,
      sym_string,
    ACTIONS(4155), 1,
      sym__integer_literal,
    ACTIONS(4157), 1,
      sym__hex_literal,
    ACTIONS(4159), 1,
      anon_sym__,
    ACTIONS(4161), 1,
      anon_sym_DASH,
    ACTIONS(4163), 1,
      anon_sym_LPAREN,
    ACTIONS(4165), 1,
      sym__conid,
    ACTIONS(4167), 1,
      anon_sym_LBRACE,
    ACTIONS(4169), 1,
      anon_sym_LBRACK,
    STATE(959), 1,
      sym__pat_constructor,
    STATE(3343), 1,
      sym_constructor,
    STATE(3462), 1,
      sym__qcon,
    STATE(3536), 1,
      sym_qualified_constructor,
    STATE(6397), 1,
      sym_variable,
    STATE(6428), 1,
      sym_wildcard,
    STATE(6432), 1,
      sym_literal,
    STATE(6639), 1,
      sym_pat_fields,
    STATE(7792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(7580), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4151), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6725), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4444), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [52533] = 24,
    ACTIONS(3111), 1,
      anon_sym_RPAREN,
    ACTIONS(4406), 1,
      sym__varid,
    ACTIONS(4412), 1,
      sym_string,
    ACTIONS(4415), 1,
      sym__integer_literal,
    ACTIONS(4418), 1,
      sym__hex_literal,
    ACTIONS(4421), 1,
      anon_sym__,
    ACTIONS(4424), 1,
      anon_sym_LPAREN,
    ACTIONS(4427), 1,
      sym__conid,
    ACTIONS(4430), 1,
      anon_sym_LBRACE,
    ACTIONS(4433), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_constructor,
    STATE(3678), 1,
      sym_variable,
    STATE(3792), 1,
      sym_pat_fields,
    STATE(3793), 1,
      sym_literal,
    STATE(3794), 1,
      sym_wildcard,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(7642), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4409), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3795), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3097), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    STATE(1016), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [52623] = 25,
    ACTIONS(4436), 1,
      sym__varid,
    ACTIONS(4440), 1,
      sym_string,
    ACTIONS(4442), 1,
      sym__integer_literal,
    ACTIONS(4444), 1,
      sym__hex_literal,
    ACTIONS(4446), 1,
      anon_sym__,
    ACTIONS(4448), 1,
      anon_sym_DASH,
    ACTIONS(4450), 1,
      anon_sym_LPAREN,
    ACTIONS(4452), 1,
      sym__conid,
    ACTIONS(4454), 1,
      anon_sym_LBRACE,
    ACTIONS(4456), 1,
      anon_sym_LBRACK,
    STATE(951), 1,
      sym__pat_constructor,
    STATE(3283), 1,
      sym_constructor,
    STATE(3541), 1,
      sym__qcon,
    STATE(3650), 1,
      sym_qualified_constructor,
    STATE(6224), 1,
      sym_variable,
    STATE(6567), 1,
      sym_pat_fields,
    STATE(6574), 1,
      sym_wildcard,
    STATE(6577), 1,
      sym_literal,
    STATE(7904), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(6854), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4438), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6701), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4443), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [52715] = 25,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2820), 1,
      anon_sym_DASH,
    ACTIONS(2822), 1,
      anon_sym_LPAREN,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    STATE(915), 1,
      sym__pat_constructor,
    STATE(3182), 1,
      sym_constructor,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(6159), 1,
      sym_variable,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(7108), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4329), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [52807] = 25,
    ACTIONS(4280), 1,
      sym__varid,
    ACTIONS(4284), 1,
      sym_string,
    ACTIONS(4286), 1,
      sym__integer_literal,
    ACTIONS(4288), 1,
      sym__hex_literal,
    ACTIONS(4290), 1,
      anon_sym__,
    ACTIONS(4292), 1,
      anon_sym_DASH,
    ACTIONS(4294), 1,
      anon_sym_LPAREN,
    ACTIONS(4296), 1,
      sym__conid,
    ACTIONS(4298), 1,
      anon_sym_LBRACE,
    ACTIONS(4300), 1,
      anon_sym_LBRACK,
    STATE(982), 1,
      sym__pat_constructor,
    STATE(3501), 1,
      sym_constructor,
    STATE(3908), 1,
      sym__qcon,
    STATE(3982), 1,
      sym_qualified_constructor,
    STATE(6627), 1,
      sym_variable,
    STATE(6791), 1,
      sym_wildcard,
    STATE(6798), 1,
      sym_literal,
    STATE(6909), 1,
      sym_pat_fields,
    STATE(7718), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(8511), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4282), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6802), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4520), 10,
      sym_pat_name,
      sym_pat_as,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      sym_pat_negation,
      sym_pat_apply,
      sym__lpat,
  [52899] = 20,
    ACTIONS(3769), 1,
      sym__varid,
    ACTIONS(3771), 1,
      sym_string,
    ACTIONS(3773), 1,
      sym_triple_quote_string,
    ACTIONS(3775), 1,
      sym__integer_literal,
    ACTIONS(3777), 1,
      sym__hex_literal,
    ACTIONS(3779), 1,
      anon_sym__,
    ACTIONS(3783), 1,
      anon_sym_LPAREN,
    ACTIONS(3788), 1,
      anon_sym_LBRACE,
    ACTIONS(3790), 1,
      anon_sym_AT,
    ACTIONS(4458), 1,
      sym_hole,
    ACTIONS(4460), 1,
      sym__conid,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1012), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [52981] = 20,
    ACTIONS(3769), 1,
      sym__varid,
    ACTIONS(3771), 1,
      sym_string,
    ACTIONS(3773), 1,
      sym_triple_quote_string,
    ACTIONS(3775), 1,
      sym__integer_literal,
    ACTIONS(3777), 1,
      sym__hex_literal,
    ACTIONS(3779), 1,
      anon_sym__,
    ACTIONS(3781), 1,
      sym_hole,
    ACTIONS(3783), 1,
      anon_sym_LPAREN,
    ACTIONS(3788), 1,
      anon_sym_LBRACE,
    ACTIONS(3790), 1,
      anon_sym_AT,
    ACTIONS(4463), 1,
      sym__conid,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1020), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53063] = 20,
    ACTIONS(3769), 1,
      sym__varid,
    ACTIONS(3771), 1,
      sym_string,
    ACTIONS(3773), 1,
      sym_triple_quote_string,
    ACTIONS(3775), 1,
      sym__integer_literal,
    ACTIONS(3777), 1,
      sym__hex_literal,
    ACTIONS(3779), 1,
      anon_sym__,
    ACTIONS(3781), 1,
      sym_hole,
    ACTIONS(3783), 1,
      anon_sym_LPAREN,
    ACTIONS(3788), 1,
      anon_sym_LBRACE,
    ACTIONS(3790), 1,
      anon_sym_AT,
    ACTIONS(4467), 1,
      sym__conid,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1020), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53145] = 20,
    ACTIONS(4470), 1,
      sym__varid,
    ACTIONS(4472), 1,
      sym_string,
    ACTIONS(4474), 1,
      sym_triple_quote_string,
    ACTIONS(4476), 1,
      sym__integer_literal,
    ACTIONS(4478), 1,
      sym__hex_literal,
    ACTIONS(4480), 1,
      anon_sym__,
    ACTIONS(4482), 1,
      sym_hole,
    ACTIONS(4484), 1,
      anon_sym_LPAREN,
    ACTIONS(4486), 1,
      sym__conid,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4491), 1,
      anon_sym_AT,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1024), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53227] = 20,
    ACTIONS(4470), 1,
      sym__varid,
    ACTIONS(4472), 1,
      sym_string,
    ACTIONS(4474), 1,
      sym_triple_quote_string,
    ACTIONS(4476), 1,
      sym__integer_literal,
    ACTIONS(4478), 1,
      sym__hex_literal,
    ACTIONS(4480), 1,
      anon_sym__,
    ACTIONS(4484), 1,
      anon_sym_LPAREN,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4491), 1,
      anon_sym_AT,
    ACTIONS(4493), 1,
      sym_hole,
    ACTIONS(4495), 1,
      sym__conid,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3317), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1013), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53309] = 20,
    ACTIONS(4470), 1,
      sym__varid,
    ACTIONS(4472), 1,
      sym_string,
    ACTIONS(4474), 1,
      sym_triple_quote_string,
    ACTIONS(4476), 1,
      sym__integer_literal,
    ACTIONS(4478), 1,
      sym__hex_literal,
    ACTIONS(4480), 1,
      anon_sym__,
    ACTIONS(4482), 1,
      sym_hole,
    ACTIONS(4484), 1,
      anon_sym_LPAREN,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4491), 1,
      anon_sym_AT,
    ACTIONS(4498), 1,
      sym__conid,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1024), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53391] = 20,
    ACTIONS(4470), 1,
      sym__varid,
    ACTIONS(4472), 1,
      sym_string,
    ACTIONS(4474), 1,
      sym_triple_quote_string,
    ACTIONS(4476), 1,
      sym__integer_literal,
    ACTIONS(4478), 1,
      sym__hex_literal,
    ACTIONS(4480), 1,
      anon_sym__,
    ACTIONS(4482), 1,
      sym_hole,
    ACTIONS(4484), 1,
      anon_sym_LPAREN,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4491), 1,
      anon_sym_AT,
    ACTIONS(4502), 1,
      sym__conid,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3500), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1024), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53473] = 24,
    ACTIONS(4505), 1,
      sym__varid,
    ACTIONS(4509), 1,
      sym_string,
    ACTIONS(4511), 1,
      sym__integer_literal,
    ACTIONS(4513), 1,
      sym__hex_literal,
    ACTIONS(4515), 1,
      anon_sym__,
    ACTIONS(4517), 1,
      anon_sym_LPAREN,
    ACTIONS(4519), 1,
      sym__conid,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_LBRACK,
    STATE(3490), 1,
      sym_constructor,
    STATE(3713), 1,
      sym_variable,
    STATE(3730), 1,
      sym_literal,
    STATE(3731), 1,
      sym_pat_fields,
    STATE(3760), 1,
      sym_wildcard,
    STATE(3969), 1,
      sym__qcon,
    STATE(3978), 1,
      sym_qualified_constructor,
    STATE(7639), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3181), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3186), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(4507), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4031), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1028), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [53563] = 24,
    ACTIONS(4505), 1,
      sym__varid,
    ACTIONS(4509), 1,
      sym_string,
    ACTIONS(4511), 1,
      sym__integer_literal,
    ACTIONS(4513), 1,
      sym__hex_literal,
    ACTIONS(4515), 1,
      anon_sym__,
    ACTIONS(4517), 1,
      anon_sym_LPAREN,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_LBRACK,
    ACTIONS(4526), 1,
      sym__conid,
    STATE(3490), 1,
      sym_constructor,
    STATE(3713), 1,
      sym_variable,
    STATE(3730), 1,
      sym_literal,
    STATE(3731), 1,
      sym_pat_fields,
    STATE(3760), 1,
      sym_wildcard,
    STATE(3969), 1,
      sym__qcon,
    STATE(3978), 1,
      sym_qualified_constructor,
    STATE(7639), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3156), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3167), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(4507), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4031), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1001), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [53653] = 20,
    ACTIONS(4529), 1,
      sym__varid,
    ACTIONS(4533), 1,
      sym_string,
    ACTIONS(4537), 1,
      sym_triple_quote_string,
    ACTIONS(4541), 1,
      sym__integer_literal,
    ACTIONS(4545), 1,
      sym__hex_literal,
    ACTIONS(4549), 1,
      anon_sym__,
    ACTIONS(4553), 1,
      sym_hole,
    ACTIONS(4557), 1,
      anon_sym_LPAREN,
    ACTIONS(4561), 1,
      sym__conid,
    ACTIONS(4565), 1,
      anon_sym_LBRACE,
    ACTIONS(4569), 1,
      anon_sym_AT,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3288), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1031), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53735] = 20,
    ACTIONS(4573), 1,
      sym__varid,
    ACTIONS(4576), 1,
      sym_string,
    ACTIONS(4579), 1,
      sym_triple_quote_string,
    ACTIONS(4582), 1,
      sym__integer_literal,
    ACTIONS(4585), 1,
      sym__hex_literal,
    ACTIONS(4588), 1,
      anon_sym__,
    ACTIONS(4591), 1,
      sym_hole,
    ACTIONS(4594), 1,
      anon_sym_LPAREN,
    ACTIONS(4597), 1,
      sym__conid,
    ACTIONS(4600), 1,
      anon_sym_LBRACE,
    ACTIONS(4603), 1,
      anon_sym_AT,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3500), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1031), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53817] = 20,
    ACTIONS(4606), 1,
      sym__varid,
    ACTIONS(4609), 1,
      sym_string,
    ACTIONS(4612), 1,
      sym_triple_quote_string,
    ACTIONS(4615), 1,
      sym__integer_literal,
    ACTIONS(4618), 1,
      sym__hex_literal,
    ACTIONS(4621), 1,
      anon_sym__,
    ACTIONS(4624), 1,
      sym_hole,
    ACTIONS(4627), 1,
      anon_sym_LPAREN,
    ACTIONS(4630), 1,
      sym__conid,
    ACTIONS(4633), 1,
      anon_sym_LBRACE,
    ACTIONS(4636), 1,
      anon_sym_AT,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3317), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(997), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53899] = 20,
    ACTIONS(4639), 1,
      sym__varid,
    ACTIONS(4643), 1,
      sym_string,
    ACTIONS(4647), 1,
      sym_triple_quote_string,
    ACTIONS(4651), 1,
      sym__integer_literal,
    ACTIONS(4655), 1,
      sym__hex_literal,
    ACTIONS(4659), 1,
      anon_sym__,
    ACTIONS(4663), 1,
      sym_hole,
    ACTIONS(4667), 1,
      anon_sym_LPAREN,
    ACTIONS(4671), 1,
      sym__conid,
    ACTIONS(4675), 1,
      anon_sym_LBRACE,
    ACTIONS(4679), 1,
      anon_sym_AT,
    STATE(3107), 1,
      sym_constructor,
    STATE(3261), 1,
      sym_integer,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3288), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(980), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [53981] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6012), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54076] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4693), 1,
      sym__varid,
    ACTIONS(4695), 1,
      sym_string,
    ACTIONS(4697), 1,
      sym_triple_quote_string,
    ACTIONS(4699), 1,
      sym__integer_literal,
    ACTIONS(4701), 1,
      sym__hex_literal,
    ACTIONS(4703), 1,
      anon_sym__,
    ACTIONS(4705), 1,
      sym_hole,
    ACTIONS(4707), 1,
      anon_sym_LPAREN,
    ACTIONS(4709), 1,
      sym__conid,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(4713), 1,
      anon_sym_AT,
    STATE(1328), 1,
      sym_forall,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4513), 2,
      sym_type_apply,
      sym__btype,
    STATE(5743), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1277), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54167] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4715), 1,
      sym__varid,
    ACTIONS(4717), 1,
      sym_string,
    ACTIONS(4719), 1,
      sym_triple_quote_string,
    ACTIONS(4721), 1,
      sym__integer_literal,
    ACTIONS(4723), 1,
      sym__hex_literal,
    ACTIONS(4725), 1,
      anon_sym__,
    ACTIONS(4727), 1,
      sym_hole,
    ACTIONS(4729), 1,
      anon_sym_LPAREN,
    ACTIONS(4731), 1,
      sym__conid,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_AT,
    STATE(1045), 1,
      sym_forall,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5049), 2,
      sym_type_apply,
      sym__btype,
    STATE(5505), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1411), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54258] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9904), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54353] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4737), 1,
      sym__varid,
    ACTIONS(4739), 1,
      sym_string,
    ACTIONS(4741), 1,
      sym_triple_quote_string,
    ACTIONS(4743), 1,
      sym__integer_literal,
    ACTIONS(4745), 1,
      sym__hex_literal,
    ACTIONS(4747), 1,
      anon_sym__,
    ACTIONS(4749), 1,
      sym_hole,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      sym__conid,
    ACTIONS(4755), 1,
      anon_sym_LBRACE,
    ACTIONS(4757), 1,
      anon_sym_AT,
    STATE(1368), 1,
      sym_forall,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4761), 1,
      sym__btype,
    STATE(5924), 1,
      sym_type_apply,
    STATE(6216), 1,
      sym_type_infix,
    STATE(6218), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1399), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54448] = 20,
    ACTIONS(3305), 1,
      sym_comma,
    ACTIONS(4759), 1,
      sym__varid,
    ACTIONS(4761), 1,
      sym_string,
    ACTIONS(4763), 1,
      sym_triple_quote_string,
    ACTIONS(4765), 1,
      sym__integer_literal,
    ACTIONS(4767), 1,
      sym__hex_literal,
    ACTIONS(4769), 1,
      anon_sym__,
    ACTIONS(4771), 1,
      sym_hole,
    ACTIONS(4773), 1,
      anon_sym_LPAREN,
    ACTIONS(4775), 1,
      sym__conid,
    ACTIONS(4778), 1,
      anon_sym_LBRACE,
    ACTIONS(4780), 1,
      anon_sym_AT,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(1141), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [54529] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9536), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54624] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9267), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54719] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4737), 1,
      sym__varid,
    ACTIONS(4739), 1,
      sym_string,
    ACTIONS(4741), 1,
      sym_triple_quote_string,
    ACTIONS(4743), 1,
      sym__integer_literal,
    ACTIONS(4745), 1,
      sym__hex_literal,
    ACTIONS(4747), 1,
      anon_sym__,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      sym__conid,
    ACTIONS(4755), 1,
      anon_sym_LBRACE,
    ACTIONS(4757), 1,
      anon_sym_AT,
    ACTIONS(4782), 1,
      sym_hole,
    STATE(1037), 1,
      sym_forall,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4762), 2,
      sym_type_apply,
      sym__btype,
    STATE(6211), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1372), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54810] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4737), 1,
      sym__varid,
    ACTIONS(4739), 1,
      sym_string,
    ACTIONS(4741), 1,
      sym_triple_quote_string,
    ACTIONS(4743), 1,
      sym__integer_literal,
    ACTIONS(4745), 1,
      sym__hex_literal,
    ACTIONS(4747), 1,
      anon_sym__,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      sym__conid,
    ACTIONS(4755), 1,
      anon_sym_LBRACE,
    ACTIONS(4757), 1,
      anon_sym_AT,
    ACTIONS(4782), 1,
      sym_hole,
    STATE(1368), 1,
      sym_forall,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4750), 2,
      sym_type_infix,
      sym__type,
    STATE(4762), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1372), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54901] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9846), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [54996] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4470), 1,
      sym__varid,
    ACTIONS(4472), 1,
      sym_string,
    ACTIONS(4474), 1,
      sym_triple_quote_string,
    ACTIONS(4476), 1,
      sym__integer_literal,
    ACTIONS(4478), 1,
      sym__hex_literal,
    ACTIONS(4480), 1,
      anon_sym__,
    ACTIONS(4484), 1,
      anon_sym_LPAREN,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4784), 1,
      sym_hole,
    ACTIONS(4786), 1,
      sym__conid,
    ACTIONS(4788), 1,
      anon_sym_AT,
    STATE(1215), 1,
      sym_forall,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4320), 2,
      sym_type_apply,
      sym__btype,
    STATE(5505), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1026), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [55087] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4715), 1,
      sym__varid,
    ACTIONS(4717), 1,
      sym_string,
    ACTIONS(4719), 1,
      sym_triple_quote_string,
    ACTIONS(4721), 1,
      sym__integer_literal,
    ACTIONS(4723), 1,
      sym__hex_literal,
    ACTIONS(4725), 1,
      anon_sym__,
    ACTIONS(4729), 1,
      anon_sym_LPAREN,
    ACTIONS(4731), 1,
      sym__conid,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_AT,
    ACTIONS(4790), 1,
      sym_hole,
    STATE(1335), 1,
      sym_forall,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(5057), 1,
      sym__btype,
    STATE(5499), 1,
      sym__type,
    STATE(5500), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6800), 1,
      sym_type_apply,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1415), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [55182] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3769), 1,
      sym__varid,
    ACTIONS(3771), 1,
      sym_string,
    ACTIONS(3773), 1,
      sym_triple_quote_string,
    ACTIONS(3775), 1,
      sym__integer_literal,
    ACTIONS(3777), 1,
      sym__hex_literal,
    ACTIONS(3779), 1,
      anon_sym__,
    ACTIONS(3783), 1,
      anon_sym_LPAREN,
    ACTIONS(3788), 1,
      anon_sym_LBRACE,
    ACTIONS(4792), 1,
      sym_hole,
    ACTIONS(4794), 1,
      sym__conid,
    ACTIONS(4796), 1,
      anon_sym_AT,
    STATE(1317), 1,
      sym_forall,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4308), 2,
      sym_type_apply,
      sym__btype,
    STATE(5542), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1022), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [55273] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4798), 1,
      sym__varid,
    ACTIONS(4800), 1,
      sym_string,
    ACTIONS(4802), 1,
      sym_triple_quote_string,
    ACTIONS(4804), 1,
      sym__integer_literal,
    ACTIONS(4806), 1,
      sym__hex_literal,
    ACTIONS(4808), 1,
      anon_sym__,
    ACTIONS(4810), 1,
      sym_hole,
    ACTIONS(4812), 1,
      anon_sym_LPAREN,
    ACTIONS(4814), 1,
      sym__conid,
    ACTIONS(4816), 1,
      anon_sym_LBRACE,
    ACTIONS(4818), 1,
      anon_sym_AT,
    STATE(1342), 1,
      sym_forall,
    STATE(3840), 1,
      sym_constructor,
    STATE(4311), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7967), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5044), 2,
      sym_type_apply,
      sym__btype,
    STATE(7631), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4313), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1428), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [55364] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4820), 1,
      sym__varid,
    ACTIONS(4822), 1,
      sym_string,
    ACTIONS(4824), 1,
      sym_triple_quote_string,
    ACTIONS(4826), 1,
      sym__integer_literal,
    ACTIONS(4828), 1,
      sym__hex_literal,
    ACTIONS(4830), 1,
      anon_sym__,
    ACTIONS(4832), 1,
      sym_hole,
    ACTIONS(4834), 1,
      anon_sym_LPAREN,
    ACTIONS(4836), 1,
      sym__conid,
    ACTIONS(4838), 1,
      anon_sym_LBRACE,
    ACTIONS(4840), 1,
      anon_sym_AT,
    STATE(1279), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4750), 2,
      sym_type_infix,
      sym__type,
    STATE(6125), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1628), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [55455] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2753), 1,
      sym__varid,
    ACTIONS(2755), 1,
      sym_string,
    ACTIONS(2757), 1,
      sym_triple_quote_string,
    ACTIONS(2759), 1,
      sym__integer_literal,
    ACTIONS(2761), 1,
      sym__hex_literal,
    ACTIONS(2763), 1,
      anon_sym__,
    ACTIONS(2765), 1,
      sym_hole,
    ACTIONS(2767), 1,
      anon_sym_LPAREN,
    ACTIONS(2769), 1,
      sym__conid,
    ACTIONS(2771), 1,
      anon_sym_LBRACE,
    ACTIONS(2773), 1,
      anon_sym_AT,
    STATE(1309), 1,
      sym_forall,
    STATE(3382), 1,
      sym_constructor,
    STATE(3586), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2999), 2,
      sym_type_apply,
      sym__btype,
    STATE(3325), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1321), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [55546] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4470), 1,
      sym__varid,
    ACTIONS(4472), 1,
      sym_string,
    ACTIONS(4474), 1,
      sym_triple_quote_string,
    ACTIONS(4476), 1,
      sym__integer_literal,
    ACTIONS(4478), 1,
      sym__hex_literal,
    ACTIONS(4480), 1,
      anon_sym__,
    ACTIONS(4484), 1,
      anon_sym_LPAREN,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4784), 1,
      sym_hole,
    ACTIONS(4786), 1,
      sym__conid,
    ACTIONS(4788), 1,
      anon_sym_AT,
    STATE(1339), 1,
      sym_forall,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4320), 2,
      sym_type_apply,
      sym__btype,
    STATE(5613), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1026), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [55637] = 20,
    ACTIONS(4842), 1,
      sym__varid,
    ACTIONS(4845), 1,
      sym_string,
    ACTIONS(4848), 1,
      sym_triple_quote_string,
    ACTIONS(4851), 1,
      sym__integer_literal,
    ACTIONS(4854), 1,
      sym__hex_literal,
    ACTIONS(4857), 1,
      anon_sym__,
    ACTIONS(4860), 1,
      sym_hole,
    ACTIONS(4863), 1,
      anon_sym_LPAREN,
    ACTIONS(4866), 1,
      sym__conid,
    ACTIONS(4869), 1,
      anon_sym_LBRACE,
    ACTIONS(4872), 1,
      anon_sym_AT,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3335), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1051), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [55718] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9859), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [55813] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9446), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [55908] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3849), 1,
      sym__varid,
    ACTIONS(3851), 1,
      sym_string,
    ACTIONS(3853), 1,
      sym_triple_quote_string,
    ACTIONS(3855), 1,
      sym__integer_literal,
    ACTIONS(3857), 1,
      sym__hex_literal,
    ACTIONS(3859), 1,
      anon_sym__,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    ACTIONS(3868), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      sym_hole,
    ACTIONS(4877), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_AT,
    STATE(1301), 1,
      sym_forall,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(4211), 1,
      sym__btype,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(5566), 1,
      sym__type,
    STATE(5567), 1,
      sym_type_infix,
    STATE(5608), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(984), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56003] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3849), 1,
      sym__varid,
    ACTIONS(3851), 1,
      sym_string,
    ACTIONS(3853), 1,
      sym_triple_quote_string,
    ACTIONS(3855), 1,
      sym__integer_literal,
    ACTIONS(3857), 1,
      sym__hex_literal,
    ACTIONS(3859), 1,
      anon_sym__,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    ACTIONS(3868), 1,
      anon_sym_LBRACE,
    ACTIONS(4877), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_AT,
    ACTIONS(4881), 1,
      sym_hole,
    STATE(1054), 1,
      sym_forall,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4149), 2,
      sym_type_apply,
      sym__btype,
    STATE(5571), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(983), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56094] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2598), 1,
      sym__varid,
    ACTIONS(2600), 1,
      sym_string,
    ACTIONS(2602), 1,
      sym_triple_quote_string,
    ACTIONS(2604), 1,
      sym__integer_literal,
    ACTIONS(2606), 1,
      sym__hex_literal,
    ACTIONS(2608), 1,
      anon_sym__,
    ACTIONS(2610), 1,
      sym_hole,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym__conid,
    ACTIONS(2618), 1,
      anon_sym_LBRACE,
    ACTIONS(2620), 1,
      anon_sym_AT,
    STATE(1364), 1,
      sym_forall,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2986), 2,
      sym_type_apply,
      sym__btype,
    STATE(4046), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1360), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56185] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3769), 1,
      sym__varid,
    ACTIONS(3771), 1,
      sym_string,
    ACTIONS(3773), 1,
      sym_triple_quote_string,
    ACTIONS(3775), 1,
      sym__integer_literal,
    ACTIONS(3777), 1,
      sym__hex_literal,
    ACTIONS(3779), 1,
      anon_sym__,
    ACTIONS(3783), 1,
      anon_sym_LPAREN,
    ACTIONS(3788), 1,
      anon_sym_LBRACE,
    ACTIONS(4792), 1,
      sym_hole,
    ACTIONS(4794), 1,
      sym__conid,
    ACTIONS(4796), 1,
      anon_sym_AT,
    STATE(1223), 1,
      sym_forall,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4308), 2,
      sym_type_apply,
      sym__btype,
    STATE(5471), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1022), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56276] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2446), 1,
      sym__varid,
    ACTIONS(2448), 1,
      sym_string,
    ACTIONS(2450), 1,
      sym_triple_quote_string,
    ACTIONS(2452), 1,
      sym__integer_literal,
    ACTIONS(2454), 1,
      sym__hex_literal,
    ACTIONS(2456), 1,
      anon_sym__,
    ACTIONS(2458), 1,
      sym_hole,
    ACTIONS(2460), 1,
      anon_sym_LPAREN,
    ACTIONS(2462), 1,
      sym__conid,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_AT,
    STATE(1332), 1,
      sym_forall,
    STATE(3107), 1,
      sym_constructor,
    STATE(3261), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2731), 2,
      sym_type_apply,
      sym__btype,
    STATE(3415), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1014), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56367] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9832), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56462] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10025), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56557] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4883), 1,
      sym__varid,
    ACTIONS(4885), 1,
      sym_string,
    ACTIONS(4887), 1,
      sym_triple_quote_string,
    ACTIONS(4889), 1,
      sym__integer_literal,
    ACTIONS(4891), 1,
      sym__hex_literal,
    ACTIONS(4893), 1,
      anon_sym__,
    ACTIONS(4895), 1,
      sym_hole,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      sym__conid,
    ACTIONS(4901), 1,
      anon_sym_LBRACE,
    ACTIONS(4903), 1,
      anon_sym_AT,
    STATE(1291), 1,
      sym_forall,
    STATE(4236), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4381), 1,
      sym_integer,
    STATE(5131), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7060), 1,
      sym_type_apply,
    STATE(7416), 1,
      sym_type_infix,
    STATE(7417), 1,
      sym__type,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1486), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56652] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4905), 1,
      sym__varid,
    ACTIONS(4907), 1,
      sym_string,
    ACTIONS(4909), 1,
      sym_triple_quote_string,
    ACTIONS(4911), 1,
      sym__integer_literal,
    ACTIONS(4913), 1,
      sym__hex_literal,
    ACTIONS(4915), 1,
      anon_sym__,
    ACTIONS(4917), 1,
      sym_hole,
    ACTIONS(4919), 1,
      anon_sym_LPAREN,
    ACTIONS(4921), 1,
      sym__conid,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(4925), 1,
      anon_sym_AT,
    STATE(1278), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4348), 1,
      sym_constructor,
    STATE(4550), 1,
      sym_integer,
    STATE(5645), 1,
      sym__btype,
    STATE(5864), 1,
      sym__type,
    STATE(5866), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6856), 1,
      sym_type_apply,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1605), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56747] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9800), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56842] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3725), 1,
      sym__varid,
    ACTIONS(3727), 1,
      sym_string,
    ACTIONS(3729), 1,
      sym_triple_quote_string,
    ACTIONS(3731), 1,
      sym__integer_literal,
    ACTIONS(3733), 1,
      sym__hex_literal,
    ACTIONS(3735), 1,
      anon_sym__,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(4927), 1,
      sym_hole,
    ACTIONS(4929), 1,
      sym__conid,
    ACTIONS(4931), 1,
      anon_sym_AT,
    STATE(1299), 1,
      sym_forall,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(3765), 1,
      sym__btype,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(5258), 1,
      sym_type_infix,
    STATE(5259), 1,
      sym__type,
    STATE(5292), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(972), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [56937] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4883), 1,
      sym__varid,
    ACTIONS(4885), 1,
      sym_string,
    ACTIONS(4887), 1,
      sym_triple_quote_string,
    ACTIONS(4889), 1,
      sym__integer_literal,
    ACTIONS(4891), 1,
      sym__hex_literal,
    ACTIONS(4893), 1,
      anon_sym__,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      sym__conid,
    ACTIONS(4901), 1,
      anon_sym_LBRACE,
    ACTIONS(4903), 1,
      anon_sym_AT,
    ACTIONS(4933), 1,
      sym_hole,
    STATE(1061), 1,
      sym_forall,
    STATE(4236), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4381), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5208), 2,
      sym_type_apply,
      sym__btype,
    STATE(7362), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1489), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57028] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4905), 1,
      sym__varid,
    ACTIONS(4907), 1,
      sym_string,
    ACTIONS(4909), 1,
      sym_triple_quote_string,
    ACTIONS(4911), 1,
      sym__integer_literal,
    ACTIONS(4913), 1,
      sym__hex_literal,
    ACTIONS(4915), 1,
      anon_sym__,
    ACTIONS(4919), 1,
      anon_sym_LPAREN,
    ACTIONS(4921), 1,
      sym__conid,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(4925), 1,
      anon_sym_AT,
    ACTIONS(4935), 1,
      sym_hole,
    STATE(1278), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4348), 1,
      sym_constructor,
    STATE(4550), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5643), 2,
      sym_type_apply,
      sym__btype,
    STATE(6429), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1602), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57119] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4883), 1,
      sym__varid,
    ACTIONS(4885), 1,
      sym_string,
    ACTIONS(4887), 1,
      sym_triple_quote_string,
    ACTIONS(4889), 1,
      sym__integer_literal,
    ACTIONS(4891), 1,
      sym__hex_literal,
    ACTIONS(4893), 1,
      anon_sym__,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      sym__conid,
    ACTIONS(4901), 1,
      anon_sym_LBRACE,
    ACTIONS(4903), 1,
      anon_sym_AT,
    ACTIONS(4933), 1,
      sym_hole,
    STATE(1291), 1,
      sym_forall,
    STATE(4236), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4381), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5208), 2,
      sym_type_apply,
      sym__btype,
    STATE(7103), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1489), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57210] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9636), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57305] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4937), 1,
      sym__varid,
    ACTIONS(4939), 1,
      sym_string,
    ACTIONS(4941), 1,
      sym_triple_quote_string,
    ACTIONS(4943), 1,
      sym__integer_literal,
    ACTIONS(4945), 1,
      sym__hex_literal,
    ACTIONS(4947), 1,
      anon_sym__,
    ACTIONS(4949), 1,
      sym_hole,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
    ACTIONS(4953), 1,
      sym__conid,
    ACTIONS(4955), 1,
      anon_sym_LBRACE,
    ACTIONS(4957), 1,
      anon_sym_AT,
    STATE(1073), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4593), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5876), 2,
      sym_type_apply,
      sym__btype,
    STATE(5951), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1687), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57396] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4959), 1,
      sym__varid,
    ACTIONS(4961), 1,
      sym_string,
    ACTIONS(4963), 1,
      sym_triple_quote_string,
    ACTIONS(4965), 1,
      sym__integer_literal,
    ACTIONS(4967), 1,
      sym__hex_literal,
    ACTIONS(4969), 1,
      anon_sym__,
    ACTIONS(4971), 1,
      sym_hole,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    ACTIONS(4975), 1,
      sym__conid,
    ACTIONS(4977), 1,
      anon_sym_LBRACE,
    ACTIONS(4979), 1,
      anon_sym_AT,
    STATE(1290), 1,
      sym_forall,
    STATE(3780), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4447), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3807), 2,
      sym_type_infix,
      sym__type,
    STATE(5383), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1471), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57487] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9743), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57582] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9365), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57677] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4937), 1,
      sym__varid,
    ACTIONS(4939), 1,
      sym_string,
    ACTIONS(4941), 1,
      sym_triple_quote_string,
    ACTIONS(4943), 1,
      sym__integer_literal,
    ACTIONS(4945), 1,
      sym__hex_literal,
    ACTIONS(4947), 1,
      anon_sym__,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
    ACTIONS(4953), 1,
      sym__conid,
    ACTIONS(4955), 1,
      anon_sym_LBRACE,
    ACTIONS(4957), 1,
      anon_sym_AT,
    ACTIONS(4981), 1,
      sym_hole,
    STATE(1351), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4593), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(5845), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6012), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1691), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57772] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4983), 1,
      sym__varid,
    ACTIONS(4985), 1,
      sym_string,
    ACTIONS(4987), 1,
      sym_triple_quote_string,
    ACTIONS(4989), 1,
      sym__integer_literal,
    ACTIONS(4991), 1,
      sym__hex_literal,
    ACTIONS(4993), 1,
      anon_sym__,
    ACTIONS(4995), 1,
      sym_hole,
    ACTIONS(4997), 1,
      anon_sym_LPAREN,
    ACTIONS(4999), 1,
      sym__conid,
    ACTIONS(5001), 1,
      anon_sym_LBRACE,
    ACTIONS(5003), 1,
      anon_sym_AT,
    STATE(1306), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4637), 1,
      sym_constructor,
    STATE(4816), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(5997), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6012), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1673), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57867] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4983), 1,
      sym__varid,
    ACTIONS(4985), 1,
      sym_string,
    ACTIONS(4987), 1,
      sym_triple_quote_string,
    ACTIONS(4989), 1,
      sym__integer_literal,
    ACTIONS(4991), 1,
      sym__hex_literal,
    ACTIONS(4993), 1,
      anon_sym__,
    ACTIONS(4997), 1,
      anon_sym_LPAREN,
    ACTIONS(4999), 1,
      sym__conid,
    ACTIONS(5001), 1,
      anon_sym_LBRACE,
    ACTIONS(5003), 1,
      anon_sym_AT,
    ACTIONS(5005), 1,
      sym_hole,
    STATE(1074), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4637), 1,
      sym_constructor,
    STATE(4816), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5951), 2,
      sym_type_infix,
      sym__type,
    STATE(5989), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1671), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [57958] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2468), 1,
      sym__varid,
    ACTIONS(2472), 1,
      sym_string,
    ACTIONS(2474), 1,
      sym_triple_quote_string,
    ACTIONS(2476), 1,
      sym__integer_literal,
    ACTIONS(2478), 1,
      sym__hex_literal,
    ACTIONS(2482), 1,
      anon_sym__,
    ACTIONS(2484), 1,
      sym_hole,
    ACTIONS(2486), 1,
      anon_sym_LPAREN,
    ACTIONS(2488), 1,
      sym__conid,
    ACTIONS(2490), 1,
      anon_sym_LBRACE,
    ACTIONS(2492), 1,
      anon_sym_AT,
    STATE(1341), 1,
      sym_forall,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2741), 2,
      sym_type_apply,
      sym__btype,
    STATE(3325), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1030), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58049] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9703), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58144] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9696), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58239] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9645), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58334] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3725), 1,
      sym__varid,
    ACTIONS(3727), 1,
      sym_string,
    ACTIONS(3729), 1,
      sym_triple_quote_string,
    ACTIONS(3731), 1,
      sym__integer_literal,
    ACTIONS(3733), 1,
      sym__hex_literal,
    ACTIONS(3735), 1,
      anon_sym__,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(4929), 1,
      sym__conid,
    ACTIONS(4931), 1,
      anon_sym_AT,
    ACTIONS(5007), 1,
      sym_hole,
    STATE(1299), 1,
      sym_forall,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3749), 2,
      sym_type_apply,
      sym__btype,
    STATE(5068), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(971), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58425] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9598), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58520] = 20,
    ACTIONS(5009), 1,
      sym__varid,
    ACTIONS(5011), 1,
      sym_string,
    ACTIONS(5013), 1,
      sym_triple_quote_string,
    ACTIONS(5015), 1,
      sym__integer_literal,
    ACTIONS(5017), 1,
      sym__hex_literal,
    ACTIONS(5019), 1,
      anon_sym__,
    ACTIONS(5021), 1,
      sym_hole,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    ACTIONS(5025), 1,
      sym__conid,
    ACTIONS(5028), 1,
      anon_sym_LBRACE,
    ACTIONS(5030), 1,
      anon_sym_AT,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3500), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1118), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [58601] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9543), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58696] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5032), 1,
      sym__varid,
    ACTIONS(5034), 1,
      sym_string,
    ACTIONS(5036), 1,
      sym_triple_quote_string,
    ACTIONS(5038), 1,
      sym__integer_literal,
    ACTIONS(5040), 1,
      sym__hex_literal,
    ACTIONS(5042), 1,
      anon_sym__,
    ACTIONS(5044), 1,
      sym_hole,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    ACTIONS(5048), 1,
      sym__conid,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5052), 1,
      anon_sym_AT,
    STATE(1275), 1,
      sym_forall,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4973), 1,
      sym__btype,
    STATE(5864), 1,
      sym__type,
    STATE(5866), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6911), 1,
      sym_type_apply,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1447), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58791] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9497), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58886] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5054), 1,
      sym__varid,
    ACTIONS(5056), 1,
      sym_string,
    ACTIONS(5058), 1,
      sym_triple_quote_string,
    ACTIONS(5060), 1,
      sym__integer_literal,
    ACTIONS(5062), 1,
      sym__hex_literal,
    ACTIONS(5064), 1,
      anon_sym__,
    ACTIONS(5066), 1,
      sym_hole,
    ACTIONS(5068), 1,
      anon_sym_LPAREN,
    ACTIONS(5070), 1,
      sym__conid,
    ACTIONS(5072), 1,
      anon_sym_LBRACE,
    ACTIONS(5074), 1,
      anon_sym_AT,
    STATE(1295), 1,
      sym_forall,
    STATE(4259), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4428), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5380), 2,
      sym_type_apply,
      sym__btype,
    STATE(6069), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1494), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [58977] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5078), 1,
      sym_string,
    ACTIONS(5080), 1,
      sym_triple_quote_string,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5084), 1,
      sym__hex_literal,
    ACTIONS(5086), 1,
      anon_sym__,
    ACTIONS(5088), 1,
      sym_hole,
    ACTIONS(5090), 1,
      anon_sym_LPAREN,
    ACTIONS(5092), 1,
      sym__conid,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      anon_sym_AT,
    STATE(1356), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4656), 1,
      sym_constructor,
    STATE(4770), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4750), 2,
      sym_type_infix,
      sym__type,
    STATE(6031), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1652), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59068] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5098), 1,
      sym__varid,
    ACTIONS(5100), 1,
      sym_string,
    ACTIONS(5102), 1,
      sym_triple_quote_string,
    ACTIONS(5104), 1,
      sym__integer_literal,
    ACTIONS(5106), 1,
      sym__hex_literal,
    ACTIONS(5108), 1,
      anon_sym__,
    ACTIONS(5110), 1,
      sym_hole,
    ACTIONS(5112), 1,
      anon_sym_LPAREN,
    ACTIONS(5114), 1,
      sym__conid,
    ACTIONS(5116), 1,
      anon_sym_LBRACE,
    ACTIONS(5118), 1,
      anon_sym_AT,
    STATE(1097), 1,
      sym_forall,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4804), 2,
      sym_type_apply,
      sym__btype,
    STATE(7439), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1374), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59159] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5032), 1,
      sym__varid,
    ACTIONS(5034), 1,
      sym_string,
    ACTIONS(5036), 1,
      sym_triple_quote_string,
    ACTIONS(5038), 1,
      sym__integer_literal,
    ACTIONS(5040), 1,
      sym__hex_literal,
    ACTIONS(5042), 1,
      anon_sym__,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    ACTIONS(5048), 1,
      sym__conid,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5052), 1,
      anon_sym_AT,
    ACTIONS(5120), 1,
      sym_hole,
    STATE(1084), 1,
      sym_forall,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4959), 2,
      sym_type_apply,
      sym__btype,
    STATE(5883), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1438), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59250] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4715), 1,
      sym__varid,
    ACTIONS(4717), 1,
      sym_string,
    ACTIONS(4719), 1,
      sym_triple_quote_string,
    ACTIONS(4721), 1,
      sym__integer_literal,
    ACTIONS(4723), 1,
      sym__hex_literal,
    ACTIONS(4725), 1,
      anon_sym__,
    ACTIONS(4727), 1,
      sym_hole,
    ACTIONS(4729), 1,
      anon_sym_LPAREN,
    ACTIONS(4731), 1,
      sym__conid,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_AT,
    STATE(1335), 1,
      sym_forall,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3325), 2,
      sym_type_infix,
      sym__type,
    STATE(5049), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1411), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59341] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10017), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59436] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5122), 1,
      sym__varid,
    ACTIONS(5124), 1,
      sym_string,
    ACTIONS(5126), 1,
      sym_triple_quote_string,
    ACTIONS(5128), 1,
      sym__integer_literal,
    ACTIONS(5130), 1,
      sym__hex_literal,
    ACTIONS(5132), 1,
      anon_sym__,
    ACTIONS(5134), 1,
      sym_hole,
    ACTIONS(5136), 1,
      anon_sym_LPAREN,
    ACTIONS(5138), 1,
      sym__conid,
    ACTIONS(5140), 1,
      anon_sym_LBRACE,
    ACTIONS(5142), 1,
      anon_sym_AT,
    STATE(1315), 1,
      sym_forall,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(4341), 1,
      sym__btype,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(5918), 1,
      sym_type_apply,
    STATE(6160), 1,
      sym__type,
    STATE(6162), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1200), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59531] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3725), 1,
      sym__varid,
    ACTIONS(3727), 1,
      sym_string,
    ACTIONS(3729), 1,
      sym_triple_quote_string,
    ACTIONS(3731), 1,
      sym__integer_literal,
    ACTIONS(3733), 1,
      sym__hex_literal,
    ACTIONS(3735), 1,
      anon_sym__,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(4929), 1,
      sym__conid,
    ACTIONS(4931), 1,
      anon_sym_AT,
    ACTIONS(5007), 1,
      sym_hole,
    STATE(1064), 1,
      sym_forall,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3749), 2,
      sym_type_apply,
      sym__btype,
    STATE(5249), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(971), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59622] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9182), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59717] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3116), 1,
      sym__varid,
    ACTIONS(3118), 1,
      sym_string,
    ACTIONS(3120), 1,
      sym_triple_quote_string,
    ACTIONS(3122), 1,
      sym__integer_literal,
    ACTIONS(3124), 1,
      sym__hex_literal,
    ACTIONS(3126), 1,
      anon_sym__,
    ACTIONS(3128), 1,
      sym_hole,
    ACTIONS(3130), 1,
      anon_sym_LPAREN,
    ACTIONS(3132), 1,
      sym__conid,
    ACTIONS(3134), 1,
      anon_sym_LBRACE,
    ACTIONS(3136), 1,
      anon_sym_AT,
    STATE(1308), 1,
      sym_forall,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3031), 2,
      sym_type_apply,
      sym__btype,
    STATE(3047), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1429), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59808] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5122), 1,
      sym__varid,
    ACTIONS(5124), 1,
      sym_string,
    ACTIONS(5126), 1,
      sym_triple_quote_string,
    ACTIONS(5128), 1,
      sym__integer_literal,
    ACTIONS(5130), 1,
      sym__hex_literal,
    ACTIONS(5132), 1,
      anon_sym__,
    ACTIONS(5136), 1,
      anon_sym_LPAREN,
    ACTIONS(5138), 1,
      sym__conid,
    ACTIONS(5140), 1,
      anon_sym_LBRACE,
    ACTIONS(5142), 1,
      anon_sym_AT,
    ACTIONS(5144), 1,
      sym_hole,
    STATE(1092), 1,
      sym_forall,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4347), 2,
      sym_type_apply,
      sym__btype,
    STATE(6163), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1117), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59899] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5098), 1,
      sym__varid,
    ACTIONS(5100), 1,
      sym_string,
    ACTIONS(5102), 1,
      sym_triple_quote_string,
    ACTIONS(5104), 1,
      sym__integer_literal,
    ACTIONS(5106), 1,
      sym__hex_literal,
    ACTIONS(5108), 1,
      anon_sym__,
    ACTIONS(5112), 1,
      anon_sym_LPAREN,
    ACTIONS(5114), 1,
      sym__conid,
    ACTIONS(5116), 1,
      anon_sym_LBRACE,
    ACTIONS(5118), 1,
      anon_sym_AT,
    ACTIONS(5146), 1,
      sym_hole,
    STATE(1353), 1,
      sym_forall,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4769), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6728), 1,
      sym_type_apply,
    STATE(7419), 1,
      sym__type,
    STATE(7420), 1,
      sym_type_infix,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1408), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [59994] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5122), 1,
      sym__varid,
    ACTIONS(5124), 1,
      sym_string,
    ACTIONS(5126), 1,
      sym_triple_quote_string,
    ACTIONS(5128), 1,
      sym__integer_literal,
    ACTIONS(5130), 1,
      sym__hex_literal,
    ACTIONS(5132), 1,
      anon_sym__,
    ACTIONS(5136), 1,
      anon_sym_LPAREN,
    ACTIONS(5138), 1,
      sym__conid,
    ACTIONS(5140), 1,
      anon_sym_LBRACE,
    ACTIONS(5142), 1,
      anon_sym_AT,
    ACTIONS(5144), 1,
      sym_hole,
    STATE(1315), 1,
      sym_forall,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4347), 2,
      sym_type_apply,
      sym__btype,
    STATE(6069), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1117), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60085] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9043), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60180] = 25,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3047), 2,
      sym_type_infix,
      sym__type,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60271] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5160), 1,
      sym_hole,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5164), 1,
      sym__conid,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(5168), 1,
      anon_sym_AT,
    STATE(1193), 1,
      sym_forall,
    STATE(4315), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4405), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5285), 2,
      sym_type_apply,
      sym__btype,
    STATE(8251), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1490), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60362] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9455), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60457] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9848), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60552] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9420), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60647] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9107), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60742] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10061), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60837] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3042), 1,
      sym__varid,
    ACTIONS(3044), 1,
      sym_string,
    ACTIONS(3046), 1,
      sym_triple_quote_string,
    ACTIONS(3048), 1,
      sym__integer_literal,
    ACTIONS(3050), 1,
      sym__hex_literal,
    ACTIONS(3052), 1,
      anon_sym__,
    ACTIONS(3054), 1,
      sym_hole,
    ACTIONS(3056), 1,
      anon_sym_LPAREN,
    ACTIONS(3058), 1,
      sym__conid,
    ACTIONS(3060), 1,
      anon_sym_LBRACE,
    ACTIONS(3062), 1,
      anon_sym_AT,
    STATE(1330), 1,
      sym_forall,
    STATE(3809), 1,
      sym_constructor,
    STATE(4288), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3045), 2,
      sym_type_apply,
      sym__btype,
    STATE(3807), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1420), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [60928] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9374), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [61023] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5170), 1,
      sym__varid,
    ACTIONS(5172), 1,
      sym_string,
    ACTIONS(5174), 1,
      sym_triple_quote_string,
    ACTIONS(5176), 1,
      sym__integer_literal,
    ACTIONS(5178), 1,
      sym__hex_literal,
    ACTIONS(5180), 1,
      anon_sym__,
    ACTIONS(5182), 1,
      sym_hole,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    ACTIONS(5186), 1,
      sym__conid,
    ACTIONS(5188), 1,
      anon_sym_LBRACE,
    ACTIONS(5190), 1,
      anon_sym_AT,
    STATE(1338), 1,
      sym_forall,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4750), 2,
      sym_type_infix,
      sym__type,
    STATE(4829), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1384), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [61114] = 23,
    ACTIONS(5192), 1,
      sym__varid,
    ACTIONS(5196), 1,
      sym_string,
    ACTIONS(5198), 1,
      sym__integer_literal,
    ACTIONS(5200), 1,
      sym__hex_literal,
    ACTIONS(5202), 1,
      anon_sym__,
    ACTIONS(5204), 1,
      anon_sym_LPAREN,
    ACTIONS(5206), 1,
      sym__conid,
    ACTIONS(5209), 1,
      anon_sym_LBRACE,
    ACTIONS(5211), 1,
      anon_sym_LBRACK,
    STATE(3971), 1,
      sym_constructor,
    STATE(4005), 1,
      sym_variable,
    STATE(4117), 1,
      sym_pat_fields,
    STATE(4143), 1,
      sym_literal,
    STATE(4144), 1,
      sym__qcon,
    STATE(4145), 1,
      sym_wildcard,
    STATE(4210), 1,
      sym_qualified_constructor,
    STATE(7964), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5194), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4208), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3156), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
    STATE(1243), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [61201] = 20,
    ACTIONS(5009), 1,
      sym__varid,
    ACTIONS(5011), 1,
      sym_string,
    ACTIONS(5013), 1,
      sym_triple_quote_string,
    ACTIONS(5015), 1,
      sym__integer_literal,
    ACTIONS(5017), 1,
      sym__hex_literal,
    ACTIONS(5019), 1,
      anon_sym__,
    ACTIONS(5021), 1,
      sym_hole,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    ACTIONS(5028), 1,
      anon_sym_LBRACE,
    ACTIONS(5030), 1,
      anon_sym_AT,
    ACTIONS(5213), 1,
      sym__conid,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1118), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [61282] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9350), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [61377] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3275), 1,
      sym__varid,
    ACTIONS(3280), 1,
      sym_string,
    ACTIONS(3282), 1,
      sym_triple_quote_string,
    ACTIONS(3284), 1,
      sym__integer_literal,
    ACTIONS(3286), 1,
      sym__hex_literal,
    ACTIONS(3291), 1,
      anon_sym__,
    ACTIONS(3295), 1,
      anon_sym_LPAREN,
    ACTIONS(3301), 1,
      anon_sym_LBRACE,
    ACTIONS(5217), 1,
      sym_hole,
    ACTIONS(5219), 1,
      sym__conid,
    ACTIONS(5221), 1,
      anon_sym_AT,
    STATE(1294), 1,
      sym_forall,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3800), 2,
      sym_type_apply,
      sym__btype,
    STATE(5142), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(967), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [61468] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5170), 1,
      sym__varid,
    ACTIONS(5172), 1,
      sym_string,
    ACTIONS(5174), 1,
      sym_triple_quote_string,
    ACTIONS(5176), 1,
      sym__integer_literal,
    ACTIONS(5178), 1,
      sym__hex_literal,
    ACTIONS(5180), 1,
      anon_sym__,
    ACTIONS(5182), 1,
      sym_hole,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    ACTIONS(5186), 1,
      sym__conid,
    ACTIONS(5188), 1,
      anon_sym_LBRACE,
    ACTIONS(5190), 1,
      anon_sym_AT,
    STATE(1120), 1,
      sym_forall,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4829), 2,
      sym_type_apply,
      sym__btype,
    STATE(6211), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1384), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [61559] = 23,
    ACTIONS(5192), 1,
      sym__varid,
    ACTIONS(5196), 1,
      sym_string,
    ACTIONS(5198), 1,
      sym__integer_literal,
    ACTIONS(5200), 1,
      sym__hex_literal,
    ACTIONS(5202), 1,
      anon_sym__,
    ACTIONS(5204), 1,
      anon_sym_LPAREN,
    ACTIONS(5209), 1,
      anon_sym_LBRACE,
    ACTIONS(5211), 1,
      anon_sym_LBRACK,
    ACTIONS(5223), 1,
      sym__conid,
    STATE(3971), 1,
      sym_constructor,
    STATE(4005), 1,
      sym_variable,
    STATE(4117), 1,
      sym_pat_fields,
    STATE(4143), 1,
      sym_literal,
    STATE(4144), 1,
      sym__qcon,
    STATE(4145), 1,
      sym_wildcard,
    STATE(4210), 1,
      sym_qualified_constructor,
    STATE(7964), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5194), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4208), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3181), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
    STATE(1110), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [61646] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9303), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [61741] = 20,
    ACTIONS(5122), 1,
      sym__varid,
    ACTIONS(5124), 1,
      sym_string,
    ACTIONS(5126), 1,
      sym_triple_quote_string,
    ACTIONS(5128), 1,
      sym__integer_literal,
    ACTIONS(5130), 1,
      sym__hex_literal,
    ACTIONS(5132), 1,
      anon_sym__,
    ACTIONS(5136), 1,
      anon_sym_LPAREN,
    ACTIONS(5140), 1,
      anon_sym_LBRACE,
    ACTIONS(5226), 1,
      sym_hole,
    ACTIONS(5228), 1,
      sym__conid,
    ACTIONS(5231), 1,
      anon_sym_AT,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3498), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1258), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [61822] = 20,
    ACTIONS(5009), 1,
      sym__varid,
    ACTIONS(5011), 1,
      sym_string,
    ACTIONS(5013), 1,
      sym_triple_quote_string,
    ACTIONS(5015), 1,
      sym__integer_literal,
    ACTIONS(5017), 1,
      sym__hex_literal,
    ACTIONS(5019), 1,
      anon_sym__,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    ACTIONS(5028), 1,
      anon_sym_LBRACE,
    ACTIONS(5030), 1,
      anon_sym_AT,
    ACTIONS(5233), 1,
      sym_hole,
    ACTIONS(5235), 1,
      sym__conid,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3317), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1171), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [61903] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9218), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [61998] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5170), 1,
      sym__varid,
    ACTIONS(5172), 1,
      sym_string,
    ACTIONS(5174), 1,
      sym_triple_quote_string,
    ACTIONS(5176), 1,
      sym__integer_literal,
    ACTIONS(5178), 1,
      sym__hex_literal,
    ACTIONS(5180), 1,
      anon_sym__,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    ACTIONS(5186), 1,
      sym__conid,
    ACTIONS(5188), 1,
      anon_sym_LBRACE,
    ACTIONS(5190), 1,
      anon_sym_AT,
    ACTIONS(5238), 1,
      sym_hole,
    STATE(1338), 1,
      sym_forall,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4741), 1,
      sym__btype,
    STATE(5924), 1,
      sym_type_apply,
    STATE(6216), 1,
      sym_type_infix,
    STATE(6218), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1388), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62093] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3275), 1,
      sym__varid,
    ACTIONS(3280), 1,
      sym_string,
    ACTIONS(3282), 1,
      sym_triple_quote_string,
    ACTIONS(3284), 1,
      sym__integer_literal,
    ACTIONS(3286), 1,
      sym__hex_literal,
    ACTIONS(3291), 1,
      anon_sym__,
    ACTIONS(3295), 1,
      anon_sym_LPAREN,
    ACTIONS(3301), 1,
      anon_sym_LBRACE,
    ACTIONS(5217), 1,
      sym_hole,
    ACTIONS(5219), 1,
      sym__conid,
    ACTIONS(5221), 1,
      anon_sym_AT,
    STATE(1125), 1,
      sym_forall,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3800), 2,
      sym_type_apply,
      sym__btype,
    STATE(5283), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(967), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62184] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5240), 1,
      sym__varid,
    ACTIONS(5242), 1,
      sym_string,
    ACTIONS(5244), 1,
      sym_triple_quote_string,
    ACTIONS(5246), 1,
      sym__integer_literal,
    ACTIONS(5248), 1,
      sym__hex_literal,
    ACTIONS(5250), 1,
      anon_sym__,
    ACTIONS(5252), 1,
      sym_hole,
    ACTIONS(5254), 1,
      anon_sym_LPAREN,
    ACTIONS(5256), 1,
      sym__conid,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      anon_sym_AT,
    STATE(1288), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4583), 1,
      sym_constructor,
    STATE(4912), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6012), 1,
      sym__type,
    STATE(6028), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1665), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62279] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9117), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62374] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5009), 1,
      sym__varid,
    ACTIONS(5011), 1,
      sym_string,
    ACTIONS(5013), 1,
      sym_triple_quote_string,
    ACTIONS(5015), 1,
      sym__integer_literal,
    ACTIONS(5017), 1,
      sym__hex_literal,
    ACTIONS(5019), 1,
      anon_sym__,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    ACTIONS(5028), 1,
      anon_sym_LBRACE,
    ACTIONS(5262), 1,
      sym_hole,
    ACTIONS(5264), 1,
      sym__conid,
    ACTIONS(5266), 1,
      anon_sym_AT,
    STATE(1329), 1,
      sym_forall,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4373), 1,
      sym__btype,
    STATE(5923), 1,
      sym_type_apply,
    STATE(6197), 1,
      sym_type_infix,
    STATE(6212), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1111), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62469] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3275), 1,
      sym__varid,
    ACTIONS(3280), 1,
      sym_string,
    ACTIONS(3282), 1,
      sym_triple_quote_string,
    ACTIONS(3284), 1,
      sym__integer_literal,
    ACTIONS(3286), 1,
      sym__hex_literal,
    ACTIONS(3291), 1,
      anon_sym__,
    ACTIONS(3295), 1,
      anon_sym_LPAREN,
    ACTIONS(3301), 1,
      anon_sym_LBRACE,
    ACTIONS(5219), 1,
      sym__conid,
    ACTIONS(5221), 1,
      anon_sym_AT,
    ACTIONS(5268), 1,
      sym_hole,
    STATE(1294), 1,
      sym_forall,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(3861), 1,
      sym__btype,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(5284), 1,
      sym_type_apply,
    STATE(5291), 1,
      sym_type_infix,
    STATE(5296), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(947), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62564] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5160), 1,
      sym_hole,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5164), 1,
      sym__conid,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(5168), 1,
      anon_sym_AT,
    STATE(1363), 1,
      sym_forall,
    STATE(4315), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4405), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5285), 2,
      sym_type_apply,
      sym__btype,
    STATE(8423), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1490), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62655] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9901), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62750] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5240), 1,
      sym__varid,
    ACTIONS(5242), 1,
      sym_string,
    ACTIONS(5244), 1,
      sym_triple_quote_string,
    ACTIONS(5246), 1,
      sym__integer_literal,
    ACTIONS(5248), 1,
      sym__hex_literal,
    ACTIONS(5250), 1,
      anon_sym__,
    ACTIONS(5254), 1,
      anon_sym_LPAREN,
    ACTIONS(5256), 1,
      sym__conid,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      anon_sym_AT,
    ACTIONS(5270), 1,
      sym_hole,
    STATE(1122), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4583), 1,
      sym_constructor,
    STATE(4912), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5951), 2,
      sym_type_infix,
      sym__type,
    STATE(6030), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1662), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62841] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5009), 1,
      sym__varid,
    ACTIONS(5011), 1,
      sym_string,
    ACTIONS(5013), 1,
      sym_triple_quote_string,
    ACTIONS(5015), 1,
      sym__integer_literal,
    ACTIONS(5017), 1,
      sym__hex_literal,
    ACTIONS(5019), 1,
      anon_sym__,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    ACTIONS(5028), 1,
      anon_sym_LBRACE,
    ACTIONS(5264), 1,
      sym__conid,
    ACTIONS(5266), 1,
      anon_sym_AT,
    ACTIONS(5272), 1,
      sym_hole,
    STATE(1124), 1,
      sym_forall,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4434), 2,
      sym_type_apply,
      sym__btype,
    STATE(6168), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1082), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [62932] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5009), 1,
      sym__varid,
    ACTIONS(5011), 1,
      sym_string,
    ACTIONS(5013), 1,
      sym_triple_quote_string,
    ACTIONS(5015), 1,
      sym__integer_literal,
    ACTIONS(5017), 1,
      sym__hex_literal,
    ACTIONS(5019), 1,
      anon_sym__,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    ACTIONS(5028), 1,
      anon_sym_LBRACE,
    ACTIONS(5264), 1,
      sym__conid,
    ACTIONS(5266), 1,
      anon_sym_AT,
    ACTIONS(5272), 1,
      sym_hole,
    STATE(1329), 1,
      sym_forall,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4434), 2,
      sym_type_apply,
      sym__btype,
    STATE(5803), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1082), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63023] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5286), 1,
      sym_hole,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5290), 1,
      sym__conid,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(5294), 1,
      anon_sym_AT,
    STATE(1314), 1,
      sym_forall,
    STATE(4291), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4473), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5247), 2,
      sym_type_apply,
      sym__btype,
    STATE(5803), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1450), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63114] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9033), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63209] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9027), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63304] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3849), 1,
      sym__varid,
    ACTIONS(3851), 1,
      sym_string,
    ACTIONS(3853), 1,
      sym_triple_quote_string,
    ACTIONS(3855), 1,
      sym__integer_literal,
    ACTIONS(3857), 1,
      sym__hex_literal,
    ACTIONS(3859), 1,
      anon_sym__,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    ACTIONS(3868), 1,
      anon_sym_LBRACE,
    ACTIONS(4877), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_AT,
    ACTIONS(4881), 1,
      sym_hole,
    STATE(1301), 1,
      sym_forall,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4149), 2,
      sym_type_apply,
      sym__btype,
    STATE(5506), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(983), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63395] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5160), 1,
      sym_hole,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5164), 1,
      sym__conid,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(5168), 1,
      anon_sym_AT,
    STATE(1363), 1,
      sym_forall,
    STATE(4315), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4405), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5285), 2,
      sym_type_apply,
      sym__btype,
    STATE(8308), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1490), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63486] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8945), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63581] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5296), 1,
      sym__varid,
    ACTIONS(5298), 1,
      sym_string,
    ACTIONS(5300), 1,
      sym_triple_quote_string,
    ACTIONS(5302), 1,
      sym__integer_literal,
    ACTIONS(5304), 1,
      sym__hex_literal,
    ACTIONS(5306), 1,
      anon_sym__,
    ACTIONS(5308), 1,
      sym_hole,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      sym__conid,
    ACTIONS(5314), 1,
      anon_sym_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_AT,
    STATE(1186), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4350), 1,
      sym_constructor,
    STATE(4552), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5603), 2,
      sym_type_apply,
      sym__btype,
    STATE(8659), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1540), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63672] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9949), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63767] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5078), 1,
      sym_string,
    ACTIONS(5080), 1,
      sym_triple_quote_string,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5084), 1,
      sym__hex_literal,
    ACTIONS(5086), 1,
      anon_sym__,
    ACTIONS(5088), 1,
      sym_hole,
    ACTIONS(5090), 1,
      anon_sym_LPAREN,
    ACTIONS(5092), 1,
      sym__conid,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      anon_sym_AT,
    STATE(1167), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4656), 1,
      sym_constructor,
    STATE(4770), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5951), 2,
      sym_type_infix,
      sym__type,
    STATE(6031), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1652), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63858] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9975), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [63953] = 20,
    ACTIONS(3335), 1,
      sym_comma,
    ACTIONS(5318), 1,
      sym__varid,
    ACTIONS(5321), 1,
      sym_string,
    ACTIONS(5324), 1,
      sym_triple_quote_string,
    ACTIONS(5327), 1,
      sym__integer_literal,
    ACTIONS(5330), 1,
      sym__hex_literal,
    ACTIONS(5333), 1,
      anon_sym__,
    ACTIONS(5336), 1,
      sym_hole,
    ACTIONS(5339), 1,
      anon_sym_LPAREN,
    ACTIONS(5342), 1,
      sym__conid,
    ACTIONS(5345), 1,
      anon_sym_LBRACE,
    ACTIONS(5348), 1,
      anon_sym_AT,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(1141), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [64034] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2628), 1,
      sym__varid,
    ACTIONS(2630), 1,
      sym_string,
    ACTIONS(2632), 1,
      sym_triple_quote_string,
    ACTIONS(2634), 1,
      sym__integer_literal,
    ACTIONS(2636), 1,
      sym__hex_literal,
    ACTIONS(2638), 1,
      anon_sym__,
    ACTIONS(2640), 1,
      sym_hole,
    ACTIONS(2642), 1,
      anon_sym_LPAREN,
    ACTIONS(2644), 1,
      sym__conid,
    ACTIONS(2646), 1,
      anon_sym_LBRACE,
    ACTIONS(2648), 1,
      anon_sym_AT,
    STATE(1352), 1,
      sym_forall,
    STATE(3352), 1,
      sym_constructor,
    STATE(3475), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(2997), 2,
      sym_type_apply,
      sym__btype,
    STATE(3415), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1322), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [64125] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5351), 1,
      sym__varid,
    ACTIONS(5353), 1,
      sym_string,
    ACTIONS(5355), 1,
      sym_triple_quote_string,
    ACTIONS(5357), 1,
      sym__integer_literal,
    ACTIONS(5359), 1,
      sym__hex_literal,
    ACTIONS(5361), 1,
      anon_sym__,
    ACTIONS(5363), 1,
      sym_hole,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5367), 1,
      sym__conid,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(5371), 1,
      anon_sym_AT,
    STATE(1273), 1,
      sym_forall,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4658), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6266), 1,
      sym_type_apply,
    STATE(6287), 1,
      sym__type,
    STATE(6307), 1,
      sym_type_infix,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1347), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [64220] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9744), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [64315] = 23,
    ACTIONS(5373), 1,
      sym__varid,
    ACTIONS(5377), 1,
      sym_string,
    ACTIONS(5379), 1,
      sym__integer_literal,
    ACTIONS(5381), 1,
      sym__hex_literal,
    ACTIONS(5383), 1,
      anon_sym__,
    ACTIONS(5385), 1,
      anon_sym_LPAREN,
    ACTIONS(5387), 1,
      sym__conid,
    ACTIONS(5390), 1,
      anon_sym_LBRACE,
    ACTIONS(5392), 1,
      anon_sym_LBRACK,
    STATE(3846), 1,
      sym_variable,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(4250), 1,
      sym_wildcard,
    STATE(4251), 1,
      sym_literal,
    STATE(4252), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5375), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4178), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3181), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(1147), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [64402] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5394), 1,
      sym__varid,
    ACTIONS(5396), 1,
      sym_string,
    ACTIONS(5398), 1,
      sym_triple_quote_string,
    ACTIONS(5400), 1,
      sym__integer_literal,
    ACTIONS(5402), 1,
      sym__hex_literal,
    ACTIONS(5404), 1,
      anon_sym__,
    ACTIONS(5406), 1,
      sym_hole,
    ACTIONS(5408), 1,
      anon_sym_LPAREN,
    ACTIONS(5410), 1,
      sym__conid,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    ACTIONS(5414), 1,
      anon_sym_AT,
    STATE(1333), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(5504), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6012), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(7647), 1,
      sym_type_apply,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1530), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [64497] = 23,
    ACTIONS(5373), 1,
      sym__varid,
    ACTIONS(5377), 1,
      sym_string,
    ACTIONS(5379), 1,
      sym__integer_literal,
    ACTIONS(5381), 1,
      sym__hex_literal,
    ACTIONS(5383), 1,
      anon_sym__,
    ACTIONS(5385), 1,
      anon_sym_LPAREN,
    ACTIONS(5390), 1,
      anon_sym_LBRACE,
    ACTIONS(5392), 1,
      anon_sym_LBRACK,
    ACTIONS(5416), 1,
      sym__conid,
    STATE(3846), 1,
      sym_variable,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(4250), 1,
      sym_wildcard,
    STATE(4251), 1,
      sym_literal,
    STATE(4252), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5375), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4178), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3156), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(1250), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [64584] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5394), 1,
      sym__varid,
    ACTIONS(5396), 1,
      sym_string,
    ACTIONS(5398), 1,
      sym_triple_quote_string,
    ACTIONS(5400), 1,
      sym__integer_literal,
    ACTIONS(5402), 1,
      sym__hex_literal,
    ACTIONS(5404), 1,
      anon_sym__,
    ACTIONS(5408), 1,
      anon_sym_LPAREN,
    ACTIONS(5410), 1,
      sym__conid,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    ACTIONS(5414), 1,
      anon_sym_AT,
    ACTIONS(5419), 1,
      sym_hole,
    STATE(1146), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5565), 2,
      sym_type_apply,
      sym__btype,
    STATE(5951), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1541), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [64675] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8842), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [64770] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4820), 1,
      sym__varid,
    ACTIONS(4822), 1,
      sym_string,
    ACTIONS(4824), 1,
      sym_triple_quote_string,
    ACTIONS(4826), 1,
      sym__integer_literal,
    ACTIONS(4828), 1,
      sym__hex_literal,
    ACTIONS(4830), 1,
      anon_sym__,
    ACTIONS(4834), 1,
      anon_sym_LPAREN,
    ACTIONS(4836), 1,
      sym__conid,
    ACTIONS(4838), 1,
      anon_sym_LBRACE,
    ACTIONS(4840), 1,
      anon_sym_AT,
    ACTIONS(5421), 1,
      sym_hole,
    STATE(1279), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6012), 1,
      sym__type,
    STATE(6114), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1641), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [64865] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8754), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [64960] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5423), 1,
      sym__varid,
    ACTIONS(5425), 1,
      sym_string,
    ACTIONS(5427), 1,
      sym_triple_quote_string,
    ACTIONS(5429), 1,
      sym__integer_literal,
    ACTIONS(5431), 1,
      sym__hex_literal,
    ACTIONS(5433), 1,
      anon_sym__,
    ACTIONS(5435), 1,
      sym_hole,
    ACTIONS(5437), 1,
      anon_sym_LPAREN,
    ACTIONS(5439), 1,
      sym__conid,
    ACTIONS(5441), 1,
      anon_sym_LBRACE,
    ACTIONS(5443), 1,
      anon_sym_AT,
    STATE(1283), 1,
      sym_forall,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4901), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6468), 1,
      sym_type_apply,
    STATE(7154), 1,
      sym_type_infix,
    STATE(7155), 1,
      sym__type,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1370), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65055] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8958), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65150] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5445), 1,
      sym__varid,
    ACTIONS(5447), 1,
      sym_string,
    ACTIONS(5449), 1,
      sym_triple_quote_string,
    ACTIONS(5451), 1,
      sym__integer_literal,
    ACTIONS(5453), 1,
      sym__hex_literal,
    ACTIONS(5455), 1,
      anon_sym__,
    ACTIONS(5457), 1,
      sym_hole,
    ACTIONS(5459), 1,
      anon_sym_LPAREN,
    ACTIONS(5461), 1,
      sym__conid,
    ACTIONS(5463), 1,
      anon_sym_LBRACE,
    ACTIONS(5465), 1,
      anon_sym_AT,
    STATE(1344), 1,
      sym_forall,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4878), 2,
      sym_type_apply,
      sym__btype,
    STATE(6414), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1406), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65241] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5423), 1,
      sym__varid,
    ACTIONS(5425), 1,
      sym_string,
    ACTIONS(5427), 1,
      sym_triple_quote_string,
    ACTIONS(5429), 1,
      sym__integer_literal,
    ACTIONS(5431), 1,
      sym__hex_literal,
    ACTIONS(5433), 1,
      anon_sym__,
    ACTIONS(5437), 1,
      anon_sym_LPAREN,
    ACTIONS(5439), 1,
      sym__conid,
    ACTIONS(5441), 1,
      anon_sym_LBRACE,
    ACTIONS(5443), 1,
      anon_sym_AT,
    ACTIONS(5467), 1,
      sym_hole,
    STATE(1152), 1,
      sym_forall,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4773), 2,
      sym_type_apply,
      sym__btype,
    STATE(7142), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1386), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65332] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5469), 1,
      sym__varid,
    ACTIONS(5471), 1,
      sym_string,
    ACTIONS(5473), 1,
      sym_triple_quote_string,
    ACTIONS(5475), 1,
      sym__integer_literal,
    ACTIONS(5477), 1,
      sym__hex_literal,
    ACTIONS(5479), 1,
      anon_sym__,
    ACTIONS(5481), 1,
      sym_hole,
    ACTIONS(5483), 1,
      anon_sym_LPAREN,
    ACTIONS(5485), 1,
      sym__conid,
    ACTIONS(5487), 1,
      anon_sym_LBRACE,
    ACTIONS(5489), 1,
      anon_sym_AT,
    STATE(1305), 1,
      sym_forall,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3415), 2,
      sym_type_infix,
      sym__type,
    STATE(4930), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1445), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65423] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5423), 1,
      sym__varid,
    ACTIONS(5425), 1,
      sym_string,
    ACTIONS(5427), 1,
      sym_triple_quote_string,
    ACTIONS(5429), 1,
      sym__integer_literal,
    ACTIONS(5431), 1,
      sym__hex_literal,
    ACTIONS(5433), 1,
      anon_sym__,
    ACTIONS(5437), 1,
      anon_sym_LPAREN,
    ACTIONS(5439), 1,
      sym__conid,
    ACTIONS(5441), 1,
      anon_sym_LBRACE,
    ACTIONS(5443), 1,
      anon_sym_AT,
    ACTIONS(5467), 1,
      sym_hole,
    STATE(1283), 1,
      sym_forall,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4773), 2,
      sym_type_apply,
      sym__btype,
    STATE(7537), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1386), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65514] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5032), 1,
      sym__varid,
    ACTIONS(5034), 1,
      sym_string,
    ACTIONS(5036), 1,
      sym_triple_quote_string,
    ACTIONS(5038), 1,
      sym__integer_literal,
    ACTIONS(5040), 1,
      sym__hex_literal,
    ACTIONS(5042), 1,
      anon_sym__,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    ACTIONS(5048), 1,
      sym__conid,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5052), 1,
      anon_sym_AT,
    ACTIONS(5120), 1,
      sym_hole,
    STATE(1275), 1,
      sym_forall,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4959), 2,
      sym_type_apply,
      sym__btype,
    STATE(6429), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1438), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65605] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5286), 1,
      sym_hole,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5290), 1,
      sym__conid,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(5294), 1,
      anon_sym_AT,
    STATE(1314), 1,
      sym_forall,
    STATE(4291), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4473), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5247), 2,
      sym_type_apply,
      sym__btype,
    STATE(8349), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1450), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65696] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8882), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65791] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5491), 1,
      sym__varid,
    ACTIONS(5493), 1,
      sym_string,
    ACTIONS(5495), 1,
      sym_triple_quote_string,
    ACTIONS(5497), 1,
      sym__integer_literal,
    ACTIONS(5499), 1,
      sym__hex_literal,
    ACTIONS(5501), 1,
      anon_sym__,
    ACTIONS(5503), 1,
      sym_hole,
    ACTIONS(5505), 1,
      anon_sym_LPAREN,
    ACTIONS(5507), 1,
      sym__conid,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(5511), 1,
      anon_sym_AT,
    STATE(1302), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4750), 2,
      sym_type_infix,
      sym__type,
    STATE(6143), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1613), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65882] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5394), 1,
      sym__varid,
    ACTIONS(5396), 1,
      sym_string,
    ACTIONS(5398), 1,
      sym_triple_quote_string,
    ACTIONS(5400), 1,
      sym__integer_literal,
    ACTIONS(5402), 1,
      sym__hex_literal,
    ACTIONS(5404), 1,
      anon_sym__,
    ACTIONS(5408), 1,
      anon_sym_LPAREN,
    ACTIONS(5410), 1,
      sym__conid,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    ACTIONS(5414), 1,
      anon_sym_AT,
    ACTIONS(5419), 1,
      sym_hole,
    STATE(1333), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3047), 2,
      sym_type_infix,
      sym__type,
    STATE(5565), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1541), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [65973] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5445), 1,
      sym__varid,
    ACTIONS(5447), 1,
      sym_string,
    ACTIONS(5449), 1,
      sym_triple_quote_string,
    ACTIONS(5451), 1,
      sym__integer_literal,
    ACTIONS(5453), 1,
      sym__hex_literal,
    ACTIONS(5455), 1,
      anon_sym__,
    ACTIONS(5457), 1,
      sym_hole,
    ACTIONS(5459), 1,
      anon_sym_LPAREN,
    ACTIONS(5461), 1,
      sym__conid,
    ACTIONS(5463), 1,
      anon_sym_LBRACE,
    ACTIONS(5465), 1,
      anon_sym_AT,
    STATE(1170), 1,
      sym_forall,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4878), 2,
      sym_type_apply,
      sym__btype,
    STATE(6628), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1406), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66064] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5286), 1,
      sym_hole,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5290), 1,
      sym__conid,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(5294), 1,
      anon_sym_AT,
    STATE(1174), 1,
      sym_forall,
    STATE(4291), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4473), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5247), 2,
      sym_type_apply,
      sym__btype,
    STATE(6168), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1450), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66155] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4905), 1,
      sym__varid,
    ACTIONS(4907), 1,
      sym_string,
    ACTIONS(4909), 1,
      sym_triple_quote_string,
    ACTIONS(4911), 1,
      sym__integer_literal,
    ACTIONS(4913), 1,
      sym__hex_literal,
    ACTIONS(4915), 1,
      anon_sym__,
    ACTIONS(4919), 1,
      anon_sym_LPAREN,
    ACTIONS(4921), 1,
      sym__conid,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(4925), 1,
      anon_sym_AT,
    ACTIONS(4935), 1,
      sym_hole,
    STATE(1062), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4348), 1,
      sym_constructor,
    STATE(4550), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5643), 2,
      sym_type_apply,
      sym__btype,
    STATE(5883), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1602), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66246] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5491), 1,
      sym__varid,
    ACTIONS(5493), 1,
      sym_string,
    ACTIONS(5495), 1,
      sym_triple_quote_string,
    ACTIONS(5497), 1,
      sym__integer_literal,
    ACTIONS(5499), 1,
      sym__hex_literal,
    ACTIONS(5501), 1,
      anon_sym__,
    ACTIONS(5505), 1,
      anon_sym_LPAREN,
    ACTIONS(5507), 1,
      sym__conid,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(5511), 1,
      anon_sym_AT,
    ACTIONS(5513), 1,
      sym_hole,
    STATE(1302), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6012), 1,
      sym__type,
    STATE(6167), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1620), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66341] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5078), 1,
      sym_string,
    ACTIONS(5080), 1,
      sym_triple_quote_string,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5084), 1,
      sym__hex_literal,
    ACTIONS(5086), 1,
      anon_sym__,
    ACTIONS(5090), 1,
      anon_sym_LPAREN,
    ACTIONS(5092), 1,
      sym__conid,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      anon_sym_AT,
    ACTIONS(5515), 1,
      sym_hole,
    STATE(1356), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4656), 1,
      sym_constructor,
    STATE(4770), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6012), 1,
      sym__type,
    STATE(6023), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1660), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66436] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5491), 1,
      sym__varid,
    ACTIONS(5493), 1,
      sym_string,
    ACTIONS(5495), 1,
      sym_triple_quote_string,
    ACTIONS(5497), 1,
      sym__integer_literal,
    ACTIONS(5499), 1,
      sym__hex_literal,
    ACTIONS(5501), 1,
      anon_sym__,
    ACTIONS(5503), 1,
      sym_hole,
    ACTIONS(5505), 1,
      anon_sym_LPAREN,
    ACTIONS(5507), 1,
      sym__conid,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(5511), 1,
      anon_sym_AT,
    STATE(1166), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5951), 2,
      sym_type_infix,
      sym__type,
    STATE(6143), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1613), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66527] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8770), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66622] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5445), 1,
      sym__varid,
    ACTIONS(5447), 1,
      sym_string,
    ACTIONS(5449), 1,
      sym_triple_quote_string,
    ACTIONS(5451), 1,
      sym__integer_literal,
    ACTIONS(5453), 1,
      sym__hex_literal,
    ACTIONS(5455), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_LPAREN,
    ACTIONS(5461), 1,
      sym__conid,
    ACTIONS(5463), 1,
      anon_sym_LBRACE,
    ACTIONS(5465), 1,
      anon_sym_AT,
    ACTIONS(5517), 1,
      sym_hole,
    STATE(1344), 1,
      sym_forall,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4724), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6458), 1,
      sym_type_apply,
    STATE(6643), 1,
      sym_type_infix,
    STATE(6645), 1,
      sym__type,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1405), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66717] = 20,
    ACTIONS(5519), 1,
      sym__varid,
    ACTIONS(5522), 1,
      sym_string,
    ACTIONS(5525), 1,
      sym_triple_quote_string,
    ACTIONS(5528), 1,
      sym__integer_literal,
    ACTIONS(5531), 1,
      sym__hex_literal,
    ACTIONS(5534), 1,
      anon_sym__,
    ACTIONS(5537), 1,
      sym_hole,
    ACTIONS(5540), 1,
      anon_sym_LPAREN,
    ACTIONS(5543), 1,
      sym__conid,
    ACTIONS(5546), 1,
      anon_sym_LBRACE,
    ACTIONS(5549), 1,
      anon_sym_AT,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3349), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1171), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [66798] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8785), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66893] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4959), 1,
      sym__varid,
    ACTIONS(4961), 1,
      sym_string,
    ACTIONS(4963), 1,
      sym_triple_quote_string,
    ACTIONS(4965), 1,
      sym__integer_literal,
    ACTIONS(4967), 1,
      sym__hex_literal,
    ACTIONS(4969), 1,
      anon_sym__,
    ACTIONS(4971), 1,
      sym_hole,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    ACTIONS(4975), 1,
      sym__conid,
    ACTIONS(4977), 1,
      anon_sym_LBRACE,
    ACTIONS(4979), 1,
      anon_sym_AT,
    STATE(1189), 1,
      sym_forall,
    STATE(3780), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4447), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5383), 2,
      sym_type_apply,
      sym__btype,
    STATE(5883), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1471), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [66984] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5290), 1,
      sym__conid,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(5294), 1,
      anon_sym_AT,
    ACTIONS(5552), 1,
      sym_hole,
    STATE(1314), 1,
      sym_forall,
    STATE(4291), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4473), 1,
      sym_integer,
    STATE(5328), 1,
      sym__btype,
    STATE(6197), 1,
      sym_type_infix,
    STATE(6212), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7223), 1,
      sym_type_apply,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1482), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67079] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5296), 1,
      sym__varid,
    ACTIONS(5298), 1,
      sym_string,
    ACTIONS(5300), 1,
      sym_triple_quote_string,
    ACTIONS(5302), 1,
      sym__integer_literal,
    ACTIONS(5304), 1,
      sym__hex_literal,
    ACTIONS(5306), 1,
      anon_sym__,
    ACTIONS(5308), 1,
      sym_hole,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      sym__conid,
    ACTIONS(5314), 1,
      anon_sym_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_AT,
    STATE(1331), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4350), 1,
      sym_constructor,
    STATE(4552), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5603), 2,
      sym_type_apply,
      sym__btype,
    STATE(8633), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1540), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67170] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5351), 1,
      sym__varid,
    ACTIONS(5353), 1,
      sym_string,
    ACTIONS(5355), 1,
      sym_triple_quote_string,
    ACTIONS(5357), 1,
      sym__integer_literal,
    ACTIONS(5359), 1,
      sym__hex_literal,
    ACTIONS(5361), 1,
      anon_sym__,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5367), 1,
      sym__conid,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(5371), 1,
      anon_sym_AT,
    ACTIONS(5554), 1,
      sym_hole,
    STATE(1143), 1,
      sym_forall,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4698), 2,
      sym_type_apply,
      sym__btype,
    STATE(6319), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1346), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67261] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8799), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67356] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4759), 1,
      sym__varid,
    ACTIONS(4761), 1,
      sym_string,
    ACTIONS(4763), 1,
      sym_triple_quote_string,
    ACTIONS(4765), 1,
      sym__integer_literal,
    ACTIONS(4767), 1,
      sym__hex_literal,
    ACTIONS(4769), 1,
      anon_sym__,
    ACTIONS(4773), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_LBRACE,
    ACTIONS(5556), 1,
      sym_hole,
    ACTIONS(5558), 1,
      sym__conid,
    ACTIONS(5560), 1,
      anon_sym_AT,
    STATE(1276), 1,
      sym_forall,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4440), 2,
      sym_type_apply,
      sym__btype,
    STATE(5856), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1227), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67447] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4759), 1,
      sym__varid,
    ACTIONS(4761), 1,
      sym_string,
    ACTIONS(4763), 1,
      sym_triple_quote_string,
    ACTIONS(4765), 1,
      sym__integer_literal,
    ACTIONS(4767), 1,
      sym__hex_literal,
    ACTIONS(4769), 1,
      anon_sym__,
    ACTIONS(4773), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_LBRACE,
    ACTIONS(5556), 1,
      sym_hole,
    ACTIONS(5558), 1,
      sym__conid,
    ACTIONS(5560), 1,
      anon_sym_AT,
    STATE(1192), 1,
      sym_forall,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4440), 2,
      sym_type_apply,
      sym__btype,
    STATE(6065), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1227), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67538] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8817), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67633] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8836), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67728] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5562), 1,
      sym__varid,
    ACTIONS(5564), 1,
      sym_string,
    ACTIONS(5566), 1,
      sym_triple_quote_string,
    ACTIONS(5568), 1,
      sym__integer_literal,
    ACTIONS(5570), 1,
      sym__hex_literal,
    ACTIONS(5572), 1,
      anon_sym__,
    ACTIONS(5574), 1,
      sym_hole,
    ACTIONS(5576), 1,
      anon_sym_LPAREN,
    ACTIONS(5578), 1,
      sym__conid,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_AT,
    STATE(1272), 1,
      sym_forall,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4450), 2,
      sym_type_apply,
      sym__btype,
    STATE(5743), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1252), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67819] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5562), 1,
      sym__varid,
    ACTIONS(5564), 1,
      sym_string,
    ACTIONS(5566), 1,
      sym_triple_quote_string,
    ACTIONS(5568), 1,
      sym__integer_literal,
    ACTIONS(5570), 1,
      sym__hex_literal,
    ACTIONS(5572), 1,
      anon_sym__,
    ACTIONS(5574), 1,
      sym_hole,
    ACTIONS(5576), 1,
      anon_sym_LPAREN,
    ACTIONS(5578), 1,
      sym__conid,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_AT,
    STATE(1199), 1,
      sym_forall,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4450), 2,
      sym_type_apply,
      sym__btype,
    STATE(5560), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1252), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [67910] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8855), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68005] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8874), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68100] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5296), 1,
      sym__varid,
    ACTIONS(5298), 1,
      sym_string,
    ACTIONS(5300), 1,
      sym_triple_quote_string,
    ACTIONS(5302), 1,
      sym__integer_literal,
    ACTIONS(5304), 1,
      sym__hex_literal,
    ACTIONS(5306), 1,
      anon_sym__,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      sym__conid,
    ACTIONS(5314), 1,
      anon_sym_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_AT,
    ACTIONS(5584), 1,
      sym_hole,
    STATE(1331), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4350), 1,
      sym_constructor,
    STATE(4552), 1,
      sym_integer,
    STATE(5651), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7562), 1,
      sym_type_apply,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(8683), 1,
      sym_type_infix,
    STATE(8685), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1504), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68195] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8893), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68290] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9593), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68385] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4959), 1,
      sym__varid,
    ACTIONS(4961), 1,
      sym_string,
    ACTIONS(4963), 1,
      sym_triple_quote_string,
    ACTIONS(4965), 1,
      sym__integer_literal,
    ACTIONS(4967), 1,
      sym__hex_literal,
    ACTIONS(4969), 1,
      anon_sym__,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    ACTIONS(4975), 1,
      sym__conid,
    ACTIONS(4977), 1,
      anon_sym_LBRACE,
    ACTIONS(4979), 1,
      anon_sym_AT,
    ACTIONS(5586), 1,
      sym_hole,
    STATE(1290), 1,
      sym_forall,
    STATE(3780), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4447), 1,
      sym_integer,
    STATE(5158), 1,
      sym__btype,
    STATE(5864), 1,
      sym__type,
    STATE(5866), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6856), 1,
      sym_type_apply,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1454), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68480] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8912), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68575] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5588), 1,
      sym__varid,
    ACTIONS(5590), 1,
      sym_string,
    ACTIONS(5592), 1,
      sym_triple_quote_string,
    ACTIONS(5594), 1,
      sym__integer_literal,
    ACTIONS(5596), 1,
      sym__hex_literal,
    ACTIONS(5598), 1,
      anon_sym__,
    ACTIONS(5600), 1,
      sym_hole,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5604), 1,
      sym__conid,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    ACTIONS(5608), 1,
      anon_sym_AT,
    STATE(1369), 1,
      sym_forall,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4823), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6430), 1,
      sym_type_apply,
    STATE(7079), 1,
      sym_type_infix,
    STATE(7138), 1,
      sym__type,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1380), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68670] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4759), 1,
      sym__varid,
    ACTIONS(4761), 1,
      sym_string,
    ACTIONS(4763), 1,
      sym_triple_quote_string,
    ACTIONS(4765), 1,
      sym__integer_literal,
    ACTIONS(4767), 1,
      sym__hex_literal,
    ACTIONS(4769), 1,
      anon_sym__,
    ACTIONS(4773), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_LBRACE,
    ACTIONS(5558), 1,
      sym__conid,
    ACTIONS(5560), 1,
      anon_sym_AT,
    ACTIONS(5610), 1,
      sym_hole,
    STATE(1276), 1,
      sym_forall,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4349), 1,
      sym__btype,
    STATE(5991), 1,
      sym_type_apply,
    STATE(6043), 1,
      sym__type,
    STATE(6044), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1225), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68765] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5164), 1,
      sym__conid,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(5168), 1,
      anon_sym_AT,
    ACTIONS(5612), 1,
      sym_hole,
    STATE(1363), 1,
      sym_forall,
    STATE(4315), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4405), 1,
      sym_integer,
    STATE(5166), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7140), 1,
      sym_type_apply,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(8353), 1,
      sym_type_infix,
    STATE(8355), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1456), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [68860] = 20,
    ACTIONS(5562), 1,
      sym__varid,
    ACTIONS(5564), 1,
      sym_string,
    ACTIONS(5566), 1,
      sym_triple_quote_string,
    ACTIONS(5568), 1,
      sym__integer_literal,
    ACTIONS(5570), 1,
      sym__hex_literal,
    ACTIONS(5572), 1,
      anon_sym__,
    ACTIONS(5576), 1,
      anon_sym_LPAREN,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5614), 1,
      sym_hole,
    ACTIONS(5616), 1,
      sym__conid,
    ACTIONS(5619), 1,
      anon_sym_AT,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1228), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [68941] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5588), 1,
      sym__varid,
    ACTIONS(5590), 1,
      sym_string,
    ACTIONS(5592), 1,
      sym_triple_quote_string,
    ACTIONS(5594), 1,
      sym__integer_literal,
    ACTIONS(5596), 1,
      sym__hex_literal,
    ACTIONS(5598), 1,
      anon_sym__,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5604), 1,
      sym__conid,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    ACTIONS(5608), 1,
      anon_sym_AT,
    ACTIONS(5621), 1,
      sym_hole,
    STATE(1191), 1,
      sym_forall,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4742), 2,
      sym_type_apply,
      sym__btype,
    STATE(7128), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1375), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [69032] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8931), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [69127] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5286), 1,
      sym_hole,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5290), 1,
      sym__conid,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(5294), 1,
      anon_sym_AT,
    STATE(1314), 1,
      sym_forall,
    STATE(4291), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4473), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5247), 2,
      sym_type_apply,
      sym__btype,
    STATE(8215), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1450), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [69218] = 20,
    ACTIONS(3461), 1,
      sym_comma,
    ACTIONS(4759), 1,
      sym__varid,
    ACTIONS(4761), 1,
      sym_string,
    ACTIONS(4763), 1,
      sym_triple_quote_string,
    ACTIONS(4765), 1,
      sym__integer_literal,
    ACTIONS(4767), 1,
      sym__hex_literal,
    ACTIONS(4769), 1,
      anon_sym__,
    ACTIONS(4773), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_LBRACE,
    ACTIONS(4780), 1,
      anon_sym_AT,
    ACTIONS(5623), 1,
      sym_hole,
    ACTIONS(5625), 1,
      sym__conid,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(1038), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [69299] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5562), 1,
      sym__varid,
    ACTIONS(5564), 1,
      sym_string,
    ACTIONS(5566), 1,
      sym_triple_quote_string,
    ACTIONS(5568), 1,
      sym__integer_literal,
    ACTIONS(5570), 1,
      sym__hex_literal,
    ACTIONS(5572), 1,
      anon_sym__,
    ACTIONS(5576), 1,
      anon_sym_LPAREN,
    ACTIONS(5578), 1,
      sym__conid,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_AT,
    ACTIONS(5628), 1,
      sym_hole,
    STATE(1272), 1,
      sym_forall,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4442), 1,
      sym__btype,
    STATE(5573), 1,
      sym_type_infix,
    STATE(5574), 1,
      sym__type,
    STATE(5737), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1230), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [69394] = 20,
    ACTIONS(5122), 1,
      sym__varid,
    ACTIONS(5124), 1,
      sym_string,
    ACTIONS(5126), 1,
      sym_triple_quote_string,
    ACTIONS(5128), 1,
      sym__integer_literal,
    ACTIONS(5130), 1,
      sym__hex_literal,
    ACTIONS(5132), 1,
      anon_sym__,
    ACTIONS(5136), 1,
      anon_sym_LPAREN,
    ACTIONS(5140), 1,
      anon_sym_LBRACE,
    ACTIONS(5226), 1,
      sym_hole,
    ACTIONS(5231), 1,
      anon_sym_AT,
    ACTIONS(5630), 1,
      sym__conid,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3277), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1258), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [69475] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5351), 1,
      sym__varid,
    ACTIONS(5353), 1,
      sym_string,
    ACTIONS(5355), 1,
      sym_triple_quote_string,
    ACTIONS(5357), 1,
      sym__integer_literal,
    ACTIONS(5359), 1,
      sym__hex_literal,
    ACTIONS(5361), 1,
      anon_sym__,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5367), 1,
      sym__conid,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(5371), 1,
      anon_sym_AT,
    ACTIONS(5554), 1,
      sym_hole,
    STATE(1273), 1,
      sym_forall,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4698), 2,
      sym_type_apply,
      sym__btype,
    STATE(6408), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1346), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [69566] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5588), 1,
      sym__varid,
    ACTIONS(5590), 1,
      sym_string,
    ACTIONS(5592), 1,
      sym_triple_quote_string,
    ACTIONS(5594), 1,
      sym__integer_literal,
    ACTIONS(5596), 1,
      sym__hex_literal,
    ACTIONS(5598), 1,
      anon_sym__,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5604), 1,
      sym__conid,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    ACTIONS(5608), 1,
      anon_sym_AT,
    ACTIONS(5621), 1,
      sym_hole,
    STATE(1369), 1,
      sym_forall,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4742), 2,
      sym_type_apply,
      sym__btype,
    STATE(7441), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1375), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [69657] = 20,
    ACTIONS(5009), 1,
      sym__varid,
    ACTIONS(5011), 1,
      sym_string,
    ACTIONS(5013), 1,
      sym_triple_quote_string,
    ACTIONS(5015), 1,
      sym__integer_literal,
    ACTIONS(5017), 1,
      sym__hex_literal,
    ACTIONS(5019), 1,
      anon_sym__,
    ACTIONS(5021), 1,
      sym_hole,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    ACTIONS(5028), 1,
      anon_sym_LBRACE,
    ACTIONS(5030), 1,
      anon_sym_AT,
    ACTIONS(5634), 1,
      sym__conid,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1118), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [69738] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5160), 1,
      sym_hole,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5164), 1,
      sym__conid,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(5168), 1,
      anon_sym_AT,
    STATE(1363), 1,
      sym_forall,
    STATE(4315), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4405), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5285), 2,
      sym_type_apply,
      sym__btype,
    STATE(8256), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1490), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [69829] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10086), 1,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [69924] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4798), 1,
      sym__varid,
    ACTIONS(4800), 1,
      sym_string,
    ACTIONS(4802), 1,
      sym_triple_quote_string,
    ACTIONS(4804), 1,
      sym__integer_literal,
    ACTIONS(4806), 1,
      sym__hex_literal,
    ACTIONS(4808), 1,
      anon_sym__,
    ACTIONS(4810), 1,
      sym_hole,
    ACTIONS(4812), 1,
      anon_sym_LPAREN,
    ACTIONS(4814), 1,
      sym__conid,
    ACTIONS(4816), 1,
      anon_sym_LBRACE,
    ACTIONS(4818), 1,
      anon_sym_AT,
    STATE(1342), 1,
      sym_forall,
    STATE(3840), 1,
      sym_constructor,
    STATE(4311), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7967), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5044), 2,
      sym_type_apply,
      sym__btype,
    STATE(7782), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4313), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1428), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70015] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8950), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70110] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8805), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70205] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8969), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70300] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4937), 1,
      sym__varid,
    ACTIONS(4939), 1,
      sym_string,
    ACTIONS(4941), 1,
      sym_triple_quote_string,
    ACTIONS(4943), 1,
      sym__integer_literal,
    ACTIONS(4945), 1,
      sym__hex_literal,
    ACTIONS(4947), 1,
      anon_sym__,
    ACTIONS(4949), 1,
      sym_hole,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
    ACTIONS(4953), 1,
      sym__conid,
    ACTIONS(4955), 1,
      anon_sym_LBRACE,
    ACTIONS(4957), 1,
      anon_sym_AT,
    STATE(1351), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4593), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4750), 2,
      sym_type_infix,
      sym__type,
    STATE(5876), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1687), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70391] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5098), 1,
      sym__varid,
    ACTIONS(5100), 1,
      sym_string,
    ACTIONS(5102), 1,
      sym_triple_quote_string,
    ACTIONS(5104), 1,
      sym__integer_literal,
    ACTIONS(5106), 1,
      sym__hex_literal,
    ACTIONS(5108), 1,
      anon_sym__,
    ACTIONS(5110), 1,
      sym_hole,
    ACTIONS(5112), 1,
      anon_sym_LPAREN,
    ACTIONS(5114), 1,
      sym__conid,
    ACTIONS(5116), 1,
      anon_sym_LBRACE,
    ACTIONS(5118), 1,
      anon_sym_AT,
    STATE(1353), 1,
      sym_forall,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4804), 2,
      sym_type_apply,
      sym__btype,
    STATE(7076), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1374), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70482] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2570), 1,
      sym__varid,
    ACTIONS(2572), 1,
      sym_string,
    ACTIONS(2574), 1,
      sym_triple_quote_string,
    ACTIONS(2576), 1,
      sym__integer_literal,
    ACTIONS(2578), 1,
      sym__hex_literal,
    ACTIONS(2580), 1,
      anon_sym__,
    ACTIONS(2582), 1,
      sym_hole,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      sym__conid,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
    ACTIONS(2592), 1,
      anon_sym_AT,
    STATE(1320), 1,
      sym_forall,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3004), 2,
      sym_type_apply,
      sym__btype,
    STATE(3752), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1318), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70573] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8988), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70668] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2088), 1,
      sym_string,
    ACTIONS(2090), 1,
      sym_triple_quote_string,
    ACTIONS(2092), 1,
      sym__integer_literal,
    ACTIONS(2094), 1,
      sym__hex_literal,
    ACTIONS(2098), 1,
      anon_sym__,
    ACTIONS(2100), 1,
      sym_hole,
    ACTIONS(2104), 1,
      sym__conid,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3034), 1,
      sym__varid,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3038), 1,
      anon_sym_AT,
    STATE(1282), 1,
      sym_forall,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3040), 2,
      sym_type_apply,
      sym__btype,
    STATE(3047), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1412), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70759] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4470), 1,
      sym__varid,
    ACTIONS(4472), 1,
      sym_string,
    ACTIONS(4474), 1,
      sym_triple_quote_string,
    ACTIONS(4476), 1,
      sym__integer_literal,
    ACTIONS(4478), 1,
      sym__hex_literal,
    ACTIONS(4480), 1,
      anon_sym__,
    ACTIONS(4484), 1,
      anon_sym_LPAREN,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4786), 1,
      sym__conid,
    ACTIONS(4788), 1,
      anon_sym_AT,
    ACTIONS(5637), 1,
      sym_hole,
    STATE(1339), 1,
      sym_forall,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(4272), 1,
      sym__btype,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(5499), 1,
      sym__type,
    STATE(5500), 1,
      sym_type_infix,
    STATE(5648), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1025), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70854] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9969), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [70949] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4983), 1,
      sym__varid,
    ACTIONS(4985), 1,
      sym_string,
    ACTIONS(4987), 1,
      sym_triple_quote_string,
    ACTIONS(4989), 1,
      sym__integer_literal,
    ACTIONS(4991), 1,
      sym__hex_literal,
    ACTIONS(4993), 1,
      anon_sym__,
    ACTIONS(4997), 1,
      anon_sym_LPAREN,
    ACTIONS(4999), 1,
      sym__conid,
    ACTIONS(5001), 1,
      anon_sym_LBRACE,
    ACTIONS(5003), 1,
      anon_sym_AT,
    ACTIONS(5005), 1,
      sym_hole,
    STATE(1306), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4637), 1,
      sym_constructor,
    STATE(4816), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4750), 2,
      sym_type_infix,
      sym__type,
    STATE(5989), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1671), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [71040] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5469), 1,
      sym__varid,
    ACTIONS(5471), 1,
      sym_string,
    ACTIONS(5473), 1,
      sym_triple_quote_string,
    ACTIONS(5475), 1,
      sym__integer_literal,
    ACTIONS(5477), 1,
      sym__hex_literal,
    ACTIONS(5479), 1,
      anon_sym__,
    ACTIONS(5483), 1,
      anon_sym_LPAREN,
    ACTIONS(5485), 1,
      sym__conid,
    ACTIONS(5487), 1,
      anon_sym_LBRACE,
    ACTIONS(5489), 1,
      anon_sym_AT,
    ACTIONS(5639), 1,
      sym_hole,
    STATE(1305), 1,
      sym_forall,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4966), 1,
      sym__btype,
    STATE(5566), 1,
      sym__type,
    STATE(5567), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6889), 1,
      sym_type_apply,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1433), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [71135] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4820), 1,
      sym__varid,
    ACTIONS(4822), 1,
      sym_string,
    ACTIONS(4824), 1,
      sym_triple_quote_string,
    ACTIONS(4826), 1,
      sym__integer_literal,
    ACTIONS(4828), 1,
      sym__hex_literal,
    ACTIONS(4830), 1,
      anon_sym__,
    ACTIONS(4832), 1,
      sym_hole,
    ACTIONS(4834), 1,
      anon_sym_LPAREN,
    ACTIONS(4836), 1,
      sym__conid,
    ACTIONS(4838), 1,
      anon_sym_LBRACE,
    ACTIONS(4840), 1,
      anon_sym_AT,
    STATE(1150), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5951), 2,
      sym_type_infix,
      sym__type,
    STATE(6125), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1628), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [71226] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9007), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [71321] = 25,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1033), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(5951), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [71412] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9025), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [71507] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3769), 1,
      sym__varid,
    ACTIONS(3771), 1,
      sym_string,
    ACTIONS(3773), 1,
      sym_triple_quote_string,
    ACTIONS(3775), 1,
      sym__integer_literal,
    ACTIONS(3777), 1,
      sym__hex_literal,
    ACTIONS(3779), 1,
      anon_sym__,
    ACTIONS(3783), 1,
      anon_sym_LPAREN,
    ACTIONS(3788), 1,
      anon_sym_LBRACE,
    ACTIONS(4794), 1,
      sym__conid,
    ACTIONS(4796), 1,
      anon_sym_AT,
    ACTIONS(5641), 1,
      sym_hole,
    STATE(1317), 1,
      sym_forall,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(4290), 1,
      sym__btype,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(5447), 1,
      sym__type,
    STATE(5449), 1,
      sym_type_infix,
    STATE(5601), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1021), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [71602] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10077), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [71697] = 20,
    ACTIONS(3277), 1,
      sym_comma,
    ACTIONS(4759), 1,
      sym__varid,
    ACTIONS(4761), 1,
      sym_string,
    ACTIONS(4763), 1,
      sym_triple_quote_string,
    ACTIONS(4765), 1,
      sym__integer_literal,
    ACTIONS(4767), 1,
      sym__hex_literal,
    ACTIONS(4769), 1,
      anon_sym__,
    ACTIONS(4773), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_LBRACE,
    ACTIONS(4780), 1,
      anon_sym_AT,
    ACTIONS(5623), 1,
      sym_hole,
    ACTIONS(5643), 1,
      sym__conid,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(1038), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [71778] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9061), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [71873] = 20,
    ACTIONS(3498), 1,
      sym_comma,
    ACTIONS(4759), 1,
      sym__varid,
    ACTIONS(4761), 1,
      sym_string,
    ACTIONS(4763), 1,
      sym_triple_quote_string,
    ACTIONS(4765), 1,
      sym__integer_literal,
    ACTIONS(4767), 1,
      sym__hex_literal,
    ACTIONS(4769), 1,
      anon_sym__,
    ACTIONS(4773), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_LBRACE,
    ACTIONS(4780), 1,
      anon_sym_AT,
    ACTIONS(5623), 1,
      sym_hole,
    ACTIONS(5647), 1,
      sym__conid,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(1038), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [71954] = 20,
    ACTIONS(5562), 1,
      sym__varid,
    ACTIONS(5564), 1,
      sym_string,
    ACTIONS(5566), 1,
      sym_triple_quote_string,
    ACTIONS(5568), 1,
      sym__integer_literal,
    ACTIONS(5570), 1,
      sym__hex_literal,
    ACTIONS(5572), 1,
      anon_sym__,
    ACTIONS(5576), 1,
      anon_sym_LPAREN,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5619), 1,
      anon_sym_AT,
    ACTIONS(5650), 1,
      sym_hole,
    ACTIONS(5652), 1,
      sym__conid,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3317), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1251), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [72035] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9802), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [72130] = 20,
    ACTIONS(5562), 1,
      sym__varid,
    ACTIONS(5564), 1,
      sym_string,
    ACTIONS(5566), 1,
      sym_triple_quote_string,
    ACTIONS(5568), 1,
      sym__integer_literal,
    ACTIONS(5570), 1,
      sym__hex_literal,
    ACTIONS(5572), 1,
      anon_sym__,
    ACTIONS(5576), 1,
      anon_sym_LPAREN,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5614), 1,
      sym_hole,
    ACTIONS(5619), 1,
      anon_sym_AT,
    ACTIONS(5655), 1,
      sym__conid,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1228), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [72211] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5659), 1,
      sym__varid,
    ACTIONS(5661), 1,
      sym_string,
    ACTIONS(5663), 1,
      sym_triple_quote_string,
    ACTIONS(5665), 1,
      sym__integer_literal,
    ACTIONS(5667), 1,
      sym__hex_literal,
    ACTIONS(5669), 1,
      anon_sym__,
    ACTIONS(5671), 1,
      sym_hole,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5675), 1,
      sym__conid,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    ACTIONS(5679), 1,
      anon_sym_AT,
    STATE(1345), 1,
      sym_forall,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4733), 2,
      sym_type_apply,
      sym__btype,
    STATE(4750), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1383), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [72302] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9438), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [72397] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5659), 1,
      sym__varid,
    ACTIONS(5661), 1,
      sym_string,
    ACTIONS(5663), 1,
      sym_triple_quote_string,
    ACTIONS(5665), 1,
      sym__integer_literal,
    ACTIONS(5667), 1,
      sym__hex_literal,
    ACTIONS(5669), 1,
      anon_sym__,
    ACTIONS(5671), 1,
      sym_hole,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5675), 1,
      sym__conid,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    ACTIONS(5679), 1,
      anon_sym_AT,
    STATE(1237), 1,
      sym_forall,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4733), 2,
      sym_type_apply,
      sym__btype,
    STATE(6211), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1383), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [72488] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3307), 1,
      sym__varid,
    ACTIONS(3309), 1,
      sym_string,
    ACTIONS(3311), 1,
      sym_triple_quote_string,
    ACTIONS(3313), 1,
      sym__integer_literal,
    ACTIONS(3315), 1,
      sym__hex_literal,
    ACTIONS(3319), 1,
      anon_sym__,
    ACTIONS(3323), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(5681), 1,
      sym_hole,
    ACTIONS(5683), 1,
      sym__conid,
    ACTIONS(5685), 1,
      anon_sym_AT,
    STATE(1334), 1,
      sym_forall,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(4068), 1,
      sym__btype,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(5117), 1,
      sym__type,
    STATE(5120), 1,
      sym_type_infix,
    STATE(5362), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(960), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [72583] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(8844), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [72678] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3307), 1,
      sym__varid,
    ACTIONS(3309), 1,
      sym_string,
    ACTIONS(3311), 1,
      sym_triple_quote_string,
    ACTIONS(3313), 1,
      sym__integer_literal,
    ACTIONS(3315), 1,
      sym__hex_literal,
    ACTIONS(3319), 1,
      anon_sym__,
    ACTIONS(3323), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(5683), 1,
      sym__conid,
    ACTIONS(5685), 1,
      anon_sym_AT,
    ACTIONS(5687), 1,
      sym_hole,
    STATE(1234), 1,
      sym_forall,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3843), 2,
      sym_type_apply,
      sym__btype,
    STATE(5124), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(957), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [72769] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5659), 1,
      sym__varid,
    ACTIONS(5661), 1,
      sym_string,
    ACTIONS(5663), 1,
      sym_triple_quote_string,
    ACTIONS(5665), 1,
      sym__integer_literal,
    ACTIONS(5667), 1,
      sym__hex_literal,
    ACTIONS(5669), 1,
      anon_sym__,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5675), 1,
      sym__conid,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    ACTIONS(5679), 1,
      anon_sym_AT,
    ACTIONS(5689), 1,
      sym_hole,
    STATE(1345), 1,
      sym_forall,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4729), 1,
      sym__btype,
    STATE(5924), 1,
      sym_type_apply,
    STATE(6216), 1,
      sym_type_infix,
    STATE(6218), 1,
      sym__type,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1400), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [72864] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3307), 1,
      sym__varid,
    ACTIONS(3309), 1,
      sym_string,
    ACTIONS(3311), 1,
      sym_triple_quote_string,
    ACTIONS(3313), 1,
      sym__integer_literal,
    ACTIONS(3315), 1,
      sym__hex_literal,
    ACTIONS(3319), 1,
      anon_sym__,
    ACTIONS(3323), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(5683), 1,
      sym__conid,
    ACTIONS(5685), 1,
      anon_sym_AT,
    ACTIONS(5687), 1,
      sym_hole,
    STATE(1334), 1,
      sym_forall,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(3843), 2,
      sym_type_apply,
      sym__btype,
    STATE(5376), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(957), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [72955] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9079), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73050] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9243), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73145] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9097), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73240] = 26,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1880), 1,
      sym_hole,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(4703), 1,
      sym_type_variable,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5572), 2,
      sym_type_apply,
      sym__btype,
    STATE(8670), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 4,
      sym_qualified_type,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1521), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73333] = 23,
    ACTIONS(5691), 1,
      sym__varid,
    ACTIONS(5697), 1,
      sym_string,
    ACTIONS(5700), 1,
      sym__integer_literal,
    ACTIONS(5703), 1,
      sym__hex_literal,
    ACTIONS(5706), 1,
      anon_sym__,
    ACTIONS(5709), 1,
      anon_sym_LPAREN,
    ACTIONS(5712), 1,
      sym__conid,
    ACTIONS(5715), 1,
      anon_sym_LBRACE,
    ACTIONS(5718), 1,
      anon_sym_LBRACK,
    STATE(3971), 1,
      sym_constructor,
    STATE(4005), 1,
      sym_variable,
    STATE(4117), 1,
      sym_pat_fields,
    STATE(4143), 1,
      sym_literal,
    STATE(4144), 1,
      sym__qcon,
    STATE(4145), 1,
      sym_wildcard,
    STATE(4210), 1,
      sym_qualified_constructor,
    STATE(7964), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5694), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4208), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3097), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
    STATE(1243), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [73420] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10033), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73515] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5054), 1,
      sym__varid,
    ACTIONS(5056), 1,
      sym_string,
    ACTIONS(5058), 1,
      sym_triple_quote_string,
    ACTIONS(5060), 1,
      sym__integer_literal,
    ACTIONS(5062), 1,
      sym__hex_literal,
    ACTIONS(5064), 1,
      anon_sym__,
    ACTIONS(5068), 1,
      anon_sym_LPAREN,
    ACTIONS(5070), 1,
      sym__conid,
    ACTIONS(5072), 1,
      anon_sym_LBRACE,
    ACTIONS(5074), 1,
      anon_sym_AT,
    ACTIONS(5721), 1,
      sym_hole,
    STATE(1295), 1,
      sym_forall,
    STATE(4259), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4428), 1,
      sym_integer,
    STATE(5243), 1,
      sym__btype,
    STATE(6160), 1,
      sym__type,
    STATE(6162), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7334), 1,
      sym_type_apply,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1476), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73610] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9115), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73705] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9992), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73800] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9133), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73895] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9241), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [73990] = 23,
    ACTIONS(5723), 1,
      sym__varid,
    ACTIONS(5729), 1,
      sym_string,
    ACTIONS(5732), 1,
      sym__integer_literal,
    ACTIONS(5735), 1,
      sym__hex_literal,
    ACTIONS(5738), 1,
      anon_sym__,
    ACTIONS(5741), 1,
      anon_sym_LPAREN,
    ACTIONS(5744), 1,
      sym__conid,
    ACTIONS(5747), 1,
      anon_sym_LBRACE,
    ACTIONS(5750), 1,
      anon_sym_LBRACK,
    STATE(3846), 1,
      sym_variable,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(4250), 1,
      sym_wildcard,
    STATE(4251), 1,
      sym_literal,
    STATE(4252), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5726), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4178), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    ACTIONS(3097), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(1250), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [74077] = 20,
    ACTIONS(5753), 1,
      sym__varid,
    ACTIONS(5756), 1,
      sym_string,
    ACTIONS(5759), 1,
      sym_triple_quote_string,
    ACTIONS(5762), 1,
      sym__integer_literal,
    ACTIONS(5765), 1,
      sym__hex_literal,
    ACTIONS(5768), 1,
      anon_sym__,
    ACTIONS(5771), 1,
      sym_hole,
    ACTIONS(5774), 1,
      anon_sym_LPAREN,
    ACTIONS(5777), 1,
      sym__conid,
    ACTIONS(5780), 1,
      anon_sym_LBRACE,
    ACTIONS(5783), 1,
      anon_sym_AT,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3349), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1251), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [74158] = 20,
    ACTIONS(5562), 1,
      sym__varid,
    ACTIONS(5564), 1,
      sym_string,
    ACTIONS(5566), 1,
      sym_triple_quote_string,
    ACTIONS(5568), 1,
      sym__integer_literal,
    ACTIONS(5570), 1,
      sym__hex_literal,
    ACTIONS(5572), 1,
      anon_sym__,
    ACTIONS(5576), 1,
      anon_sym_LPAREN,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5614), 1,
      sym_hole,
    ACTIONS(5619), 1,
      anon_sym_AT,
    ACTIONS(5786), 1,
      sym__conid,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(3500), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1228), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [74239] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9151), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [74334] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9918), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [74429] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9169), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [74524] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5240), 1,
      sym__varid,
    ACTIONS(5242), 1,
      sym_string,
    ACTIONS(5244), 1,
      sym_triple_quote_string,
    ACTIONS(5246), 1,
      sym__integer_literal,
    ACTIONS(5248), 1,
      sym__hex_literal,
    ACTIONS(5250), 1,
      anon_sym__,
    ACTIONS(5254), 1,
      anon_sym_LPAREN,
    ACTIONS(5256), 1,
      sym__conid,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      anon_sym_AT,
    ACTIONS(5270), 1,
      sym_hole,
    STATE(1288), 1,
      sym_forall,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4583), 1,
      sym_constructor,
    STATE(4912), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4750), 2,
      sym_type_infix,
      sym__type,
    STATE(6030), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1662), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [74615] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5789), 1,
      sym__varid,
    ACTIONS(5791), 1,
      sym_string,
    ACTIONS(5793), 1,
      sym_triple_quote_string,
    ACTIONS(5795), 1,
      sym__integer_literal,
    ACTIONS(5797), 1,
      sym__hex_literal,
    ACTIONS(5799), 1,
      anon_sym__,
    ACTIONS(5801), 1,
      sym_hole,
    ACTIONS(5803), 1,
      anon_sym_LPAREN,
    ACTIONS(5805), 1,
      sym__conid,
    ACTIONS(5807), 1,
      anon_sym_LBRACE,
    ACTIONS(5809), 1,
      anon_sym_AT,
    STATE(1293), 1,
      sym_forall,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(5025), 1,
      sym__btype,
    STATE(5447), 1,
      sym__type,
    STATE(5449), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6926), 1,
      sym_type_apply,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1436), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [74710] = 20,
    ACTIONS(5122), 1,
      sym__varid,
    ACTIONS(5124), 1,
      sym_string,
    ACTIONS(5126), 1,
      sym_triple_quote_string,
    ACTIONS(5128), 1,
      sym__integer_literal,
    ACTIONS(5130), 1,
      sym__hex_literal,
    ACTIONS(5132), 1,
      anon_sym__,
    ACTIONS(5136), 1,
      anon_sym_LPAREN,
    ACTIONS(5140), 1,
      anon_sym_LBRACE,
    ACTIONS(5231), 1,
      anon_sym_AT,
    ACTIONS(5811), 1,
      sym_hole,
    ACTIONS(5813), 1,
      sym__conid,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3305), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1051), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [74791] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5789), 1,
      sym__varid,
    ACTIONS(5791), 1,
      sym_string,
    ACTIONS(5793), 1,
      sym_triple_quote_string,
    ACTIONS(5795), 1,
      sym__integer_literal,
    ACTIONS(5797), 1,
      sym__hex_literal,
    ACTIONS(5799), 1,
      anon_sym__,
    ACTIONS(5803), 1,
      anon_sym_LPAREN,
    ACTIONS(5805), 1,
      sym__conid,
    ACTIONS(5807), 1,
      anon_sym_LBRACE,
    ACTIONS(5809), 1,
      anon_sym_AT,
    ACTIONS(5816), 1,
      sym_hole,
    STATE(1257), 1,
      sym_forall,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4953), 2,
      sym_type_apply,
      sym__btype,
    STATE(5471), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1444), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [74882] = 20,
    ACTIONS(5122), 1,
      sym__varid,
    ACTIONS(5124), 1,
      sym_string,
    ACTIONS(5126), 1,
      sym_triple_quote_string,
    ACTIONS(5128), 1,
      sym__integer_literal,
    ACTIONS(5130), 1,
      sym__hex_literal,
    ACTIONS(5132), 1,
      anon_sym__,
    ACTIONS(5136), 1,
      anon_sym_LPAREN,
    ACTIONS(5140), 1,
      anon_sym_LBRACE,
    ACTIONS(5226), 1,
      sym_hole,
    ACTIONS(5231), 1,
      anon_sym_AT,
    ACTIONS(5818), 1,
      sym__conid,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3461), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_in,
    STATE(1258), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [74963] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5789), 1,
      sym__varid,
    ACTIONS(5791), 1,
      sym_string,
    ACTIONS(5793), 1,
      sym_triple_quote_string,
    ACTIONS(5795), 1,
      sym__integer_literal,
    ACTIONS(5797), 1,
      sym__hex_literal,
    ACTIONS(5799), 1,
      anon_sym__,
    ACTIONS(5803), 1,
      anon_sym_LPAREN,
    ACTIONS(5805), 1,
      sym__conid,
    ACTIONS(5807), 1,
      anon_sym_LBRACE,
    ACTIONS(5809), 1,
      anon_sym_AT,
    ACTIONS(5816), 1,
      sym_hole,
    STATE(1293), 1,
      sym_forall,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4953), 2,
      sym_type_apply,
      sym__btype,
    STATE(5542), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1444), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75054] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9259), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75149] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9295), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75244] = 27,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4693), 1,
      sym__varid,
    ACTIONS(4695), 1,
      sym_string,
    ACTIONS(4697), 1,
      sym_triple_quote_string,
    ACTIONS(4699), 1,
      sym__integer_literal,
    ACTIONS(4701), 1,
      sym__hex_literal,
    ACTIONS(4703), 1,
      anon_sym__,
    ACTIONS(4707), 1,
      anon_sym_LPAREN,
    ACTIONS(4709), 1,
      sym__conid,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(4713), 1,
      anon_sym_AT,
    ACTIONS(5821), 1,
      sym_hole,
    STATE(1328), 1,
      sym_forall,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4647), 1,
      sym__btype,
    STATE(5573), 1,
      sym_type_infix,
    STATE(5574), 1,
      sym__type,
    STATE(5737), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1285), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75339] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5054), 1,
      sym__varid,
    ACTIONS(5056), 1,
      sym_string,
    ACTIONS(5058), 1,
      sym_triple_quote_string,
    ACTIONS(5060), 1,
      sym__integer_literal,
    ACTIONS(5062), 1,
      sym__hex_literal,
    ACTIONS(5064), 1,
      anon_sym__,
    ACTIONS(5066), 1,
      sym_hole,
    ACTIONS(5068), 1,
      anon_sym_LPAREN,
    ACTIONS(5070), 1,
      sym__conid,
    ACTIONS(5072), 1,
      anon_sym_LBRACE,
    ACTIONS(5074), 1,
      anon_sym_AT,
    STATE(1245), 1,
      sym_forall,
    STATE(4259), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4428), 1,
      sym_integer,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(5380), 2,
      sym_type_apply,
      sym__btype,
    STATE(6163), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1494), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75430] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9277), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75525] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9187), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75620] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4693), 1,
      sym__varid,
    ACTIONS(4695), 1,
      sym_string,
    ACTIONS(4697), 1,
      sym_triple_quote_string,
    ACTIONS(4699), 1,
      sym__integer_literal,
    ACTIONS(4701), 1,
      sym__hex_literal,
    ACTIONS(4703), 1,
      anon_sym__,
    ACTIONS(4705), 1,
      sym_hole,
    ACTIONS(4707), 1,
      anon_sym_LPAREN,
    ACTIONS(4709), 1,
      sym__conid,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(4713), 1,
      anon_sym_AT,
    STATE(1264), 1,
      sym_forall,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4513), 2,
      sym_type_apply,
      sym__btype,
    STATE(5560), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1277), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75711] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9205), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75806] = 25,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5469), 1,
      sym__varid,
    ACTIONS(5471), 1,
      sym_string,
    ACTIONS(5473), 1,
      sym_triple_quote_string,
    ACTIONS(5475), 1,
      sym__integer_literal,
    ACTIONS(5477), 1,
      sym__hex_literal,
    ACTIONS(5479), 1,
      anon_sym__,
    ACTIONS(5481), 1,
      sym_hole,
    ACTIONS(5483), 1,
      anon_sym_LPAREN,
    ACTIONS(5485), 1,
      sym__conid,
    ACTIONS(5487), 1,
      anon_sym_LBRACE,
    ACTIONS(5489), 1,
      anon_sym_AT,
    STATE(1218), 1,
      sym_forall,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(4930), 2,
      sym_type_apply,
      sym__btype,
    STATE(5571), 2,
      sym_type_infix,
      sym__type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1445), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75897] = 27,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(1336), 1,
      sym_forall,
    STATE(4337), 1,
      sym_constructor,
    STATE(4344), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6005), 1,
      sym__btype,
    STATE(6006), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(9223), 1,
      sym__type,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [75992] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5562), 1,
      sym__varid,
    ACTIONS(5564), 1,
      sym_string,
    ACTIONS(5566), 1,
      sym_triple_quote_string,
    ACTIONS(5568), 1,
      sym__integer_literal,
    ACTIONS(5570), 1,
      sym__hex_literal,
    ACTIONS(5572), 1,
      anon_sym__,
    ACTIONS(5576), 1,
      anon_sym_LPAREN,
    ACTIONS(5578), 1,
      sym__conid,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_AT,
    ACTIONS(5628), 1,
      sym_hole,
    STATE(2208), 1,
      sym_forall,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4458), 1,
      sym__btype,
    STATE(5737), 1,
      sym_type_apply,
    STATE(5738), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1230), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [76084] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5351), 1,
      sym__varid,
    ACTIONS(5353), 1,
      sym_string,
    ACTIONS(5355), 1,
      sym_triple_quote_string,
    ACTIONS(5357), 1,
      sym__integer_literal,
    ACTIONS(5359), 1,
      sym__hex_literal,
    ACTIONS(5361), 1,
      anon_sym__,
    ACTIONS(5363), 1,
      sym_hole,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5367), 1,
      sym__conid,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(5371), 1,
      anon_sym_AT,
    STATE(2160), 1,
      sym_forall,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4618), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6266), 1,
      sym_type_apply,
    STATE(6406), 1,
      sym_type_infix,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1347), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [76176] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(435), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(5833), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [76264] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5032), 1,
      sym__varid,
    ACTIONS(5034), 1,
      sym_string,
    ACTIONS(5036), 1,
      sym_triple_quote_string,
    ACTIONS(5038), 1,
      sym__integer_literal,
    ACTIONS(5040), 1,
      sym__hex_literal,
    ACTIONS(5042), 1,
      anon_sym__,
    ACTIONS(5044), 1,
      sym_hole,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    ACTIONS(5048), 1,
      sym__conid,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5052), 1,
      anon_sym_AT,
    STATE(2122), 1,
      sym_forall,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5033), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6553), 1,
      sym_type_infix,
    STATE(6911), 1,
      sym_type_apply,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1447), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [76356] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4759), 1,
      sym__varid,
    ACTIONS(4761), 1,
      sym_string,
    ACTIONS(4763), 1,
      sym_triple_quote_string,
    ACTIONS(4765), 1,
      sym__integer_literal,
    ACTIONS(4767), 1,
      sym__hex_literal,
    ACTIONS(4769), 1,
      anon_sym__,
    ACTIONS(4773), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_LBRACE,
    ACTIONS(5558), 1,
      sym__conid,
    ACTIONS(5560), 1,
      anon_sym_AT,
    ACTIONS(5610), 1,
      sym_hole,
    STATE(2144), 1,
      sym_forall,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4438), 1,
      sym__btype,
    STATE(5847), 1,
      sym_type_infix,
    STATE(5991), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1225), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [76448] = 20,
    ACTIONS(3498), 1,
      sym_comma,
    ACTIONS(4693), 1,
      sym__varid,
    ACTIONS(4695), 1,
      sym_string,
    ACTIONS(4697), 1,
      sym_triple_quote_string,
    ACTIONS(4699), 1,
      sym__integer_literal,
    ACTIONS(4701), 1,
      sym__hex_literal,
    ACTIONS(4703), 1,
      anon_sym__,
    ACTIONS(4707), 1,
      anon_sym_LPAREN,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(5845), 1,
      sym_hole,
    ACTIONS(5847), 1,
      sym__conid,
    ACTIONS(5850), 1,
      anon_sym_AT,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_of,
    STATE(1286), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [76528] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4905), 1,
      sym__varid,
    ACTIONS(4907), 1,
      sym_string,
    ACTIONS(4909), 1,
      sym_triple_quote_string,
    ACTIONS(4911), 1,
      sym__integer_literal,
    ACTIONS(4913), 1,
      sym__hex_literal,
    ACTIONS(4915), 1,
      anon_sym__,
    ACTIONS(4917), 1,
      sym_hole,
    ACTIONS(4919), 1,
      anon_sym_LPAREN,
    ACTIONS(4921), 1,
      sym__conid,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(4925), 1,
      anon_sym_AT,
    STATE(2013), 1,
      sym_forall,
    STATE(4348), 1,
      sym_constructor,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4550), 1,
      sym_integer,
    STATE(5642), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6553), 1,
      sym_type_infix,
    STATE(6856), 1,
      sym_type_apply,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1605), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [76620] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4820), 1,
      sym__varid,
    ACTIONS(4822), 1,
      sym_string,
    ACTIONS(4824), 1,
      sym_triple_quote_string,
    ACTIONS(4826), 1,
      sym__integer_literal,
    ACTIONS(4828), 1,
      sym__hex_literal,
    ACTIONS(4830), 1,
      anon_sym__,
    ACTIONS(4834), 1,
      anon_sym_LPAREN,
    ACTIONS(4836), 1,
      sym__conid,
    ACTIONS(4838), 1,
      anon_sym_LBRACE,
    ACTIONS(4840), 1,
      anon_sym_AT,
    ACTIONS(5421), 1,
      sym_hole,
    STATE(2070), 1,
      sym_forall,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(4768), 1,
      sym_type_infix,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6128), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1641), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [76712] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(451), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(5852), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [76800] = 20,
    ACTIONS(3335), 1,
      sym_comma,
    ACTIONS(5854), 1,
      sym__varid,
    ACTIONS(5857), 1,
      sym_string,
    ACTIONS(5860), 1,
      sym_triple_quote_string,
    ACTIONS(5863), 1,
      sym__integer_literal,
    ACTIONS(5866), 1,
      sym__hex_literal,
    ACTIONS(5869), 1,
      anon_sym__,
    ACTIONS(5872), 1,
      sym_hole,
    ACTIONS(5875), 1,
      anon_sym_LPAREN,
    ACTIONS(5878), 1,
      sym__conid,
    ACTIONS(5881), 1,
      anon_sym_LBRACE,
    ACTIONS(5884), 1,
      anon_sym_AT,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_of,
    STATE(1281), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [76880] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2088), 1,
      sym_string,
    ACTIONS(2090), 1,
      sym_triple_quote_string,
    ACTIONS(2092), 1,
      sym__integer_literal,
    ACTIONS(2094), 1,
      sym__hex_literal,
    ACTIONS(2098), 1,
      anon_sym__,
    ACTIONS(2104), 1,
      sym__conid,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3034), 1,
      sym__varid,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3038), 1,
      anon_sym_AT,
    ACTIONS(5887), 1,
      sym_hole,
    STATE(2049), 1,
      sym_forall,
    STATE(3029), 1,
      sym__btype,
    STATE(3058), 1,
      sym_type_infix,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(4217), 1,
      sym_type_apply,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1432), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [76972] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5423), 1,
      sym__varid,
    ACTIONS(5425), 1,
      sym_string,
    ACTIONS(5427), 1,
      sym_triple_quote_string,
    ACTIONS(5429), 1,
      sym__integer_literal,
    ACTIONS(5431), 1,
      sym__hex_literal,
    ACTIONS(5433), 1,
      anon_sym__,
    ACTIONS(5435), 1,
      sym_hole,
    ACTIONS(5437), 1,
      anon_sym_LPAREN,
    ACTIONS(5439), 1,
      sym__conid,
    ACTIONS(5441), 1,
      anon_sym_LBRACE,
    ACTIONS(5443), 1,
      anon_sym_AT,
    STATE(2181), 1,
      sym_forall,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4822), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6468), 1,
      sym_type_apply,
    STATE(7414), 1,
      sym_type_infix,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1370), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [77064] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(452), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(5889), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [77152] = 20,
    ACTIONS(3277), 1,
      sym_comma,
    ACTIONS(4693), 1,
      sym__varid,
    ACTIONS(4695), 1,
      sym_string,
    ACTIONS(4697), 1,
      sym_triple_quote_string,
    ACTIONS(4699), 1,
      sym__integer_literal,
    ACTIONS(4701), 1,
      sym__hex_literal,
    ACTIONS(4703), 1,
      anon_sym__,
    ACTIONS(4707), 1,
      anon_sym_LPAREN,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(5845), 1,
      sym_hole,
    ACTIONS(5850), 1,
      anon_sym_AT,
    ACTIONS(5891), 1,
      sym__conid,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_of,
    STATE(1286), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [77232] = 20,
    ACTIONS(3305), 1,
      sym_comma,
    ACTIONS(4693), 1,
      sym__varid,
    ACTIONS(4695), 1,
      sym_string,
    ACTIONS(4697), 1,
      sym_triple_quote_string,
    ACTIONS(4699), 1,
      sym__integer_literal,
    ACTIONS(4701), 1,
      sym__hex_literal,
    ACTIONS(4703), 1,
      anon_sym__,
    ACTIONS(4707), 1,
      anon_sym_LPAREN,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(5850), 1,
      anon_sym_AT,
    ACTIONS(5895), 1,
      sym_hole,
    ACTIONS(5897), 1,
      sym__conid,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_of,
    STATE(1281), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [77312] = 20,
    ACTIONS(3461), 1,
      sym_comma,
    ACTIONS(4693), 1,
      sym__varid,
    ACTIONS(4695), 1,
      sym_string,
    ACTIONS(4697), 1,
      sym_triple_quote_string,
    ACTIONS(4699), 1,
      sym__integer_literal,
    ACTIONS(4701), 1,
      sym__hex_literal,
    ACTIONS(4703), 1,
      anon_sym__,
    ACTIONS(4707), 1,
      anon_sym_LPAREN,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(5845), 1,
      sym_hole,
    ACTIONS(5850), 1,
      anon_sym_AT,
    ACTIONS(5900), 1,
      sym__conid,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_of,
    STATE(1286), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [77392] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5240), 1,
      sym__varid,
    ACTIONS(5242), 1,
      sym_string,
    ACTIONS(5244), 1,
      sym_triple_quote_string,
    ACTIONS(5246), 1,
      sym__integer_literal,
    ACTIONS(5248), 1,
      sym__hex_literal,
    ACTIONS(5250), 1,
      anon_sym__,
    ACTIONS(5252), 1,
      sym_hole,
    ACTIONS(5254), 1,
      anon_sym_LPAREN,
    ACTIONS(5256), 1,
      sym__conid,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      anon_sym_AT,
    STATE(2114), 1,
      sym_forall,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4583), 1,
      sym_constructor,
    STATE(4768), 1,
      sym_type_infix,
    STATE(4912), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6032), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1665), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [77484] = 20,
    ACTIONS(3335), 1,
      sym_comma,
    ACTIONS(5903), 1,
      sym__varid,
    ACTIONS(5906), 1,
      sym_string,
    ACTIONS(5909), 1,
      sym_triple_quote_string,
    ACTIONS(5912), 1,
      sym__integer_literal,
    ACTIONS(5915), 1,
      sym__hex_literal,
    ACTIONS(5918), 1,
      anon_sym__,
    ACTIONS(5921), 1,
      sym_hole,
    ACTIONS(5924), 1,
      anon_sym_LPAREN,
    ACTIONS(5927), 1,
      sym__conid,
    ACTIONS(5930), 1,
      anon_sym_LBRACE,
    ACTIONS(5933), 1,
      anon_sym_AT,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(1289), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [77564] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4959), 1,
      sym__varid,
    ACTIONS(4961), 1,
      sym_string,
    ACTIONS(4963), 1,
      sym_triple_quote_string,
    ACTIONS(4965), 1,
      sym__integer_literal,
    ACTIONS(4967), 1,
      sym__hex_literal,
    ACTIONS(4969), 1,
      anon_sym__,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    ACTIONS(4975), 1,
      sym__conid,
    ACTIONS(4977), 1,
      anon_sym_LBRACE,
    ACTIONS(4979), 1,
      anon_sym_AT,
    ACTIONS(5586), 1,
      sym_hole,
    STATE(2029), 1,
      sym_forall,
    STATE(3780), 1,
      sym_constructor,
    STATE(4040), 1,
      sym_type_infix,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4447), 1,
      sym_integer,
    STATE(5206), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6856), 1,
      sym_type_apply,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1454), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [77656] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4883), 1,
      sym__varid,
    ACTIONS(4885), 1,
      sym_string,
    ACTIONS(4887), 1,
      sym_triple_quote_string,
    ACTIONS(4889), 1,
      sym__integer_literal,
    ACTIONS(4891), 1,
      sym__hex_literal,
    ACTIONS(4893), 1,
      anon_sym__,
    ACTIONS(4895), 1,
      sym_hole,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      sym__conid,
    ACTIONS(4901), 1,
      anon_sym_LBRACE,
    ACTIONS(4903), 1,
      anon_sym_AT,
    STATE(2166), 1,
      sym_forall,
    STATE(4236), 1,
      sym_constructor,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4381), 1,
      sym_integer,
    STATE(5222), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7060), 1,
      sym_type_apply,
    STATE(7132), 1,
      sym_type_infix,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1486), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [77748] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(545), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(5936), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [77836] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5789), 1,
      sym__varid,
    ACTIONS(5791), 1,
      sym_string,
    ACTIONS(5793), 1,
      sym_triple_quote_string,
    ACTIONS(5795), 1,
      sym__integer_literal,
    ACTIONS(5797), 1,
      sym__hex_literal,
    ACTIONS(5799), 1,
      anon_sym__,
    ACTIONS(5801), 1,
      sym_hole,
    ACTIONS(5803), 1,
      anon_sym_LPAREN,
    ACTIONS(5805), 1,
      sym__conid,
    ACTIONS(5807), 1,
      anon_sym_LBRACE,
    ACTIONS(5809), 1,
      anon_sym_AT,
    STATE(2198), 1,
      sym_forall,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4976), 1,
      sym__btype,
    STATE(5548), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6926), 1,
      sym_type_apply,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1436), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [77928] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3275), 1,
      sym__varid,
    ACTIONS(3280), 1,
      sym_string,
    ACTIONS(3282), 1,
      sym_triple_quote_string,
    ACTIONS(3284), 1,
      sym__integer_literal,
    ACTIONS(3286), 1,
      sym__hex_literal,
    ACTIONS(3291), 1,
      anon_sym__,
    ACTIONS(3295), 1,
      anon_sym_LPAREN,
    ACTIONS(3301), 1,
      anon_sym_LBRACE,
    ACTIONS(5219), 1,
      sym__conid,
    ACTIONS(5221), 1,
      anon_sym_AT,
    ACTIONS(5268), 1,
      sym_hole,
    STATE(2147), 1,
      sym_forall,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(3804), 1,
      sym__btype,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5180), 1,
      sym_type_infix,
    STATE(5284), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(947), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [78020] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5054), 1,
      sym__varid,
    ACTIONS(5056), 1,
      sym_string,
    ACTIONS(5058), 1,
      sym_triple_quote_string,
    ACTIONS(5060), 1,
      sym__integer_literal,
    ACTIONS(5062), 1,
      sym__hex_literal,
    ACTIONS(5064), 1,
      anon_sym__,
    ACTIONS(5068), 1,
      anon_sym_LPAREN,
    ACTIONS(5070), 1,
      sym__conid,
    ACTIONS(5072), 1,
      anon_sym_LBRACE,
    ACTIONS(5074), 1,
      anon_sym_AT,
    ACTIONS(5721), 1,
      sym_hole,
    STATE(1955), 1,
      sym_forall,
    STATE(4259), 1,
      sym_constructor,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4428), 1,
      sym_integer,
    STATE(5377), 1,
      sym__btype,
    STATE(6075), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7334), 1,
      sym_type_apply,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1476), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [78112] = 20,
    ACTIONS(5938), 1,
      sym__varid,
    ACTIONS(5942), 1,
      sym_string,
    ACTIONS(5946), 1,
      sym_triple_quote_string,
    ACTIONS(5950), 1,
      sym__integer_literal,
    ACTIONS(5954), 1,
      sym__hex_literal,
    ACTIONS(5958), 1,
      anon_sym__,
    ACTIONS(5962), 1,
      sym_hole,
    ACTIONS(5966), 1,
      anon_sym_LPAREN,
    ACTIONS(5970), 1,
      sym__conid,
    ACTIONS(5974), 1,
      anon_sym_LBRACE,
    ACTIONS(5978), 1,
      anon_sym_AT,
    STATE(3352), 1,
      sym_constructor,
    STATE(3475), 1,
      sym_integer,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1312), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [78192] = 20,
    ACTIONS(5982), 1,
      sym__varid,
    ACTIONS(5985), 1,
      sym_string,
    ACTIONS(5988), 1,
      sym_triple_quote_string,
    ACTIONS(5991), 1,
      sym__integer_literal,
    ACTIONS(5994), 1,
      sym__hex_literal,
    ACTIONS(5997), 1,
      anon_sym__,
    ACTIONS(6000), 1,
      sym_hole,
    ACTIONS(6003), 1,
      anon_sym_LPAREN,
    ACTIONS(6006), 1,
      sym__conid,
    ACTIONS(6009), 1,
      anon_sym_LBRACE,
    ACTIONS(6012), 1,
      anon_sym_AT,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3349), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1297), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [78272] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(445), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6015), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [78360] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3725), 1,
      sym__varid,
    ACTIONS(3727), 1,
      sym_string,
    ACTIONS(3729), 1,
      sym_triple_quote_string,
    ACTIONS(3731), 1,
      sym__integer_literal,
    ACTIONS(3733), 1,
      sym__hex_literal,
    ACTIONS(3735), 1,
      anon_sym__,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(4927), 1,
      sym_hole,
    ACTIONS(4929), 1,
      sym__conid,
    ACTIONS(4931), 1,
      anon_sym_AT,
    STATE(2148), 1,
      sym_forall,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(3745), 1,
      sym__btype,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5101), 1,
      sym_type_infix,
    STATE(5292), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(972), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [78452] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(541), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6017), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [78540] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3849), 1,
      sym__varid,
    ACTIONS(3851), 1,
      sym_string,
    ACTIONS(3853), 1,
      sym_triple_quote_string,
    ACTIONS(3855), 1,
      sym__integer_literal,
    ACTIONS(3857), 1,
      sym__hex_literal,
    ACTIONS(3859), 1,
      anon_sym__,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    ACTIONS(3868), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      sym_hole,
    ACTIONS(4877), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_AT,
    STATE(2140), 1,
      sym_forall,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(4215), 1,
      sym__btype,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5537), 1,
      sym_type_infix,
    STATE(5608), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(984), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [78632] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5491), 1,
      sym__varid,
    ACTIONS(5493), 1,
      sym_string,
    ACTIONS(5495), 1,
      sym_triple_quote_string,
    ACTIONS(5497), 1,
      sym__integer_literal,
    ACTIONS(5499), 1,
      sym__hex_literal,
    ACTIONS(5501), 1,
      anon_sym__,
    ACTIONS(5505), 1,
      anon_sym_LPAREN,
    ACTIONS(5507), 1,
      sym__conid,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(5511), 1,
      anon_sym_AT,
    ACTIONS(5513), 1,
      sym_hole,
    STATE(1994), 1,
      sym_forall,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(4768), 1,
      sym_type_infix,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6140), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1620), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [78724] = 20,
    ACTIONS(6019), 1,
      sym__varid,
    ACTIONS(6022), 1,
      sym_string,
    ACTIONS(6025), 1,
      sym_triple_quote_string,
    ACTIONS(6028), 1,
      sym__integer_literal,
    ACTIONS(6031), 1,
      sym__hex_literal,
    ACTIONS(6034), 1,
      anon_sym__,
    ACTIONS(6037), 1,
      sym_hole,
    ACTIONS(6040), 1,
      anon_sym_LPAREN,
    ACTIONS(6043), 1,
      sym__conid,
    ACTIONS(6046), 1,
      anon_sym_LBRACE,
    ACTIONS(6049), 1,
      anon_sym_AT,
    STATE(3382), 1,
      sym_constructor,
    STATE(3586), 1,
      sym_integer,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1343), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [78804] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(430), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6052), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [78892] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5469), 1,
      sym__varid,
    ACTIONS(5471), 1,
      sym_string,
    ACTIONS(5473), 1,
      sym_triple_quote_string,
    ACTIONS(5475), 1,
      sym__integer_literal,
    ACTIONS(5477), 1,
      sym__hex_literal,
    ACTIONS(5479), 1,
      anon_sym__,
    ACTIONS(5483), 1,
      anon_sym_LPAREN,
    ACTIONS(5485), 1,
      sym__conid,
    ACTIONS(5487), 1,
      anon_sym_LBRACE,
    ACTIONS(5489), 1,
      anon_sym_AT,
    ACTIONS(5639), 1,
      sym_hole,
    STATE(2200), 1,
      sym_forall,
    STATE(3333), 1,
      sym_type_infix,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5054), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6889), 1,
      sym_type_apply,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1433), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [78984] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4983), 1,
      sym__varid,
    ACTIONS(4985), 1,
      sym_string,
    ACTIONS(4987), 1,
      sym_triple_quote_string,
    ACTIONS(4989), 1,
      sym__integer_literal,
    ACTIONS(4991), 1,
      sym__hex_literal,
    ACTIONS(4993), 1,
      anon_sym__,
    ACTIONS(4995), 1,
      sym_hole,
    ACTIONS(4997), 1,
      anon_sym_LPAREN,
    ACTIONS(4999), 1,
      sym__conid,
    ACTIONS(5001), 1,
      anon_sym_LBRACE,
    ACTIONS(5003), 1,
      anon_sym_AT,
    STATE(1960), 1,
      sym_forall,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4637), 1,
      sym_constructor,
    STATE(4768), 1,
      sym_type_infix,
    STATE(4816), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(5988), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1673), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [79076] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(492), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6054), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [79164] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3116), 1,
      sym__varid,
    ACTIONS(3118), 1,
      sym_string,
    ACTIONS(3120), 1,
      sym_triple_quote_string,
    ACTIONS(3122), 1,
      sym__integer_literal,
    ACTIONS(3124), 1,
      sym__hex_literal,
    ACTIONS(3126), 1,
      anon_sym__,
    ACTIONS(3130), 1,
      anon_sym_LPAREN,
    ACTIONS(3132), 1,
      sym__conid,
    ACTIONS(3134), 1,
      anon_sym_LBRACE,
    ACTIONS(3136), 1,
      anon_sym_AT,
    ACTIONS(6056), 1,
      sym_hole,
    STATE(2167), 1,
      sym_forall,
    STATE(3043), 1,
      sym__btype,
    STATE(3058), 1,
      sym_type_infix,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(4274), 1,
      sym_type_apply,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1443), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [79256] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2753), 1,
      sym__varid,
    ACTIONS(2755), 1,
      sym_string,
    ACTIONS(2757), 1,
      sym_triple_quote_string,
    ACTIONS(2759), 1,
      sym__integer_literal,
    ACTIONS(2761), 1,
      sym__hex_literal,
    ACTIONS(2763), 1,
      anon_sym__,
    ACTIONS(2767), 1,
      anon_sym_LPAREN,
    ACTIONS(2769), 1,
      sym__conid,
    ACTIONS(2771), 1,
      anon_sym_LBRACE,
    ACTIONS(2773), 1,
      anon_sym_AT,
    ACTIONS(6058), 1,
      sym_hole,
    STATE(2103), 1,
      sym_forall,
    STATE(2989), 1,
      sym__btype,
    STATE(3276), 1,
      sym_type_infix,
    STATE(3382), 1,
      sym_constructor,
    STATE(3472), 1,
      sym_type_apply,
    STATE(3586), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1310), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [79348] = 20,
    ACTIONS(6060), 1,
      sym__varid,
    ACTIONS(6064), 1,
      sym_string,
    ACTIONS(6068), 1,
      sym_triple_quote_string,
    ACTIONS(6072), 1,
      sym__integer_literal,
    ACTIONS(6076), 1,
      sym__hex_literal,
    ACTIONS(6080), 1,
      anon_sym__,
    ACTIONS(6084), 1,
      sym_hole,
    ACTIONS(6088), 1,
      anon_sym_LPAREN,
    ACTIONS(6092), 1,
      sym__conid,
    ACTIONS(6096), 1,
      anon_sym_LBRACE,
    ACTIONS(6100), 1,
      anon_sym_AT,
    STATE(3382), 1,
      sym_constructor,
    STATE(3586), 1,
      sym_integer,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1303), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [79428] = 20,
    ACTIONS(6104), 1,
      sym__varid,
    ACTIONS(6108), 1,
      sym_string,
    ACTIONS(6112), 1,
      sym_triple_quote_string,
    ACTIONS(6116), 1,
      sym__integer_literal,
    ACTIONS(6120), 1,
      sym__hex_literal,
    ACTIONS(6124), 1,
      anon_sym__,
    ACTIONS(6128), 1,
      sym_hole,
    ACTIONS(6132), 1,
      anon_sym_LPAREN,
    ACTIONS(6136), 1,
      sym__conid,
    ACTIONS(6140), 1,
      anon_sym_LBRACE,
    ACTIONS(6144), 1,
      anon_sym_AT,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3288), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1326), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [79508] = 20,
    ACTIONS(6148), 1,
      sym__varid,
    ACTIONS(6151), 1,
      sym_string,
    ACTIONS(6154), 1,
      sym_triple_quote_string,
    ACTIONS(6157), 1,
      sym__integer_literal,
    ACTIONS(6160), 1,
      sym__hex_literal,
    ACTIONS(6163), 1,
      anon_sym__,
    ACTIONS(6166), 1,
      sym_hole,
    ACTIONS(6169), 1,
      anon_sym_LPAREN,
    ACTIONS(6172), 1,
      sym__conid,
    ACTIONS(6175), 1,
      anon_sym_LBRACE,
    ACTIONS(6178), 1,
      anon_sym_AT,
    STATE(3352), 1,
      sym_constructor,
    STATE(3475), 1,
      sym_integer,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1357), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [79588] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(542), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6181), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [79676] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5290), 1,
      sym__conid,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(5294), 1,
      anon_sym_AT,
    ACTIONS(5552), 1,
      sym_hole,
    STATE(2011), 1,
      sym_forall,
    STATE(4291), 1,
      sym_constructor,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4473), 1,
      sym_integer,
    STATE(5288), 1,
      sym__btype,
    STATE(6057), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7223), 1,
      sym_type_apply,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1482), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [79768] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5122), 1,
      sym__varid,
    ACTIONS(5124), 1,
      sym_string,
    ACTIONS(5126), 1,
      sym_triple_quote_string,
    ACTIONS(5128), 1,
      sym__integer_literal,
    ACTIONS(5130), 1,
      sym__hex_literal,
    ACTIONS(5132), 1,
      anon_sym__,
    ACTIONS(5134), 1,
      sym_hole,
    ACTIONS(5136), 1,
      anon_sym_LPAREN,
    ACTIONS(5138), 1,
      sym__conid,
    ACTIONS(5140), 1,
      anon_sym_LBRACE,
    ACTIONS(5142), 1,
      anon_sym_AT,
    STATE(2168), 1,
      sym_forall,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(4338), 1,
      sym__btype,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5918), 1,
      sym_type_apply,
    STATE(6075), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1200), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [79860] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(446), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6183), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [79948] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3769), 1,
      sym__varid,
    ACTIONS(3771), 1,
      sym_string,
    ACTIONS(3773), 1,
      sym_triple_quote_string,
    ACTIONS(3775), 1,
      sym__integer_literal,
    ACTIONS(3777), 1,
      sym__hex_literal,
    ACTIONS(3779), 1,
      anon_sym__,
    ACTIONS(3783), 1,
      anon_sym_LPAREN,
    ACTIONS(3788), 1,
      anon_sym_LBRACE,
    ACTIONS(4794), 1,
      sym__conid,
    ACTIONS(4796), 1,
      anon_sym_AT,
    ACTIONS(5641), 1,
      sym_hole,
    STATE(2149), 1,
      sym_forall,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(4307), 1,
      sym__btype,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5548), 1,
      sym_type_infix,
    STATE(5601), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1021), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [80040] = 20,
    ACTIONS(6185), 1,
      sym__varid,
    ACTIONS(6188), 1,
      sym_string,
    ACTIONS(6191), 1,
      sym_triple_quote_string,
    ACTIONS(6194), 1,
      sym__integer_literal,
    ACTIONS(6197), 1,
      sym__hex_literal,
    ACTIONS(6200), 1,
      anon_sym__,
    ACTIONS(6203), 1,
      sym_hole,
    ACTIONS(6206), 1,
      anon_sym_LPAREN,
    ACTIONS(6209), 1,
      sym__conid,
    ACTIONS(6212), 1,
      anon_sym_LBRACE,
    ACTIONS(6215), 1,
      anon_sym_AT,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3500), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1326), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [80120] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(441), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6218), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [80208] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2570), 1,
      sym__varid,
    ACTIONS(2572), 1,
      sym_string,
    ACTIONS(2574), 1,
      sym_triple_quote_string,
    ACTIONS(2576), 1,
      sym__integer_literal,
    ACTIONS(2578), 1,
      sym__hex_literal,
    ACTIONS(2580), 1,
      anon_sym__,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      sym__conid,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
    ACTIONS(2592), 1,
      anon_sym_AT,
    ACTIONS(6220), 1,
      sym_hole,
    STATE(2020), 1,
      sym_forall,
    STATE(3001), 1,
      sym__btype,
    STATE(3282), 1,
      sym_constructor,
    STATE(3470), 1,
      sym_type_apply,
    STATE(3669), 1,
      sym_integer,
    STATE(3767), 1,
      sym_type_infix,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1311), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [80300] = 20,
    ACTIONS(6222), 1,
      sym__varid,
    ACTIONS(6225), 1,
      sym_string,
    ACTIONS(6228), 1,
      sym_triple_quote_string,
    ACTIONS(6231), 1,
      sym__integer_literal,
    ACTIONS(6234), 1,
      sym__hex_literal,
    ACTIONS(6237), 1,
      anon_sym__,
    ACTIONS(6240), 1,
      sym_hole,
    ACTIONS(6243), 1,
      anon_sym_LPAREN,
    ACTIONS(6246), 1,
      sym__conid,
    ACTIONS(6249), 1,
      anon_sym_LBRACE,
    ACTIONS(6252), 1,
      anon_sym_AT,
    STATE(3382), 1,
      sym_constructor,
    STATE(3586), 1,
      sym_integer,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1303), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [80380] = 20,
    ACTIONS(6255), 1,
      sym__varid,
    ACTIONS(6258), 1,
      sym_string,
    ACTIONS(6261), 1,
      sym_triple_quote_string,
    ACTIONS(6264), 1,
      sym__integer_literal,
    ACTIONS(6267), 1,
      sym__hex_literal,
    ACTIONS(6270), 1,
      anon_sym__,
    ACTIONS(6273), 1,
      sym_hole,
    ACTIONS(6276), 1,
      anon_sym_LPAREN,
    ACTIONS(6279), 1,
      sym__conid,
    ACTIONS(6282), 1,
      anon_sym_LBRACE,
    ACTIONS(6285), 1,
      anon_sym_AT,
    STATE(3352), 1,
      sym_constructor,
    STATE(3475), 1,
      sym_integer,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1312), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [80460] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(528), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6288), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [80548] = 20,
    ACTIONS(6290), 1,
      sym__varid,
    ACTIONS(6293), 1,
      sym_string,
    ACTIONS(6296), 1,
      sym_triple_quote_string,
    ACTIONS(6299), 1,
      sym__integer_literal,
    ACTIONS(6302), 1,
      sym__hex_literal,
    ACTIONS(6305), 1,
      anon_sym__,
    ACTIONS(6308), 1,
      sym_hole,
    ACTIONS(6311), 1,
      anon_sym_LPAREN,
    ACTIONS(6314), 1,
      sym__conid,
    ACTIONS(6317), 1,
      anon_sym_LBRACE,
    ACTIONS(6320), 1,
      anon_sym_AT,
    STATE(3382), 1,
      sym_constructor,
    STATE(3586), 1,
      sym_integer,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1303), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [80628] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(478), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6323), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [80716] = 20,
    ACTIONS(6325), 1,
      sym__varid,
    ACTIONS(6328), 1,
      sym_string,
    ACTIONS(6331), 1,
      sym_triple_quote_string,
    ACTIONS(6334), 1,
      sym__integer_literal,
    ACTIONS(6337), 1,
      sym__hex_literal,
    ACTIONS(6340), 1,
      anon_sym__,
    ACTIONS(6343), 1,
      sym_hole,
    ACTIONS(6346), 1,
      anon_sym_LPAREN,
    ACTIONS(6349), 1,
      sym__conid,
    ACTIONS(6352), 1,
      anon_sym_LBRACE,
    ACTIONS(6355), 1,
      anon_sym_AT,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3317), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1366), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [80796] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(529), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6358), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [80884] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4693), 1,
      sym__varid,
    ACTIONS(4695), 1,
      sym_string,
    ACTIONS(4697), 1,
      sym_triple_quote_string,
    ACTIONS(4699), 1,
      sym__integer_literal,
    ACTIONS(4701), 1,
      sym__hex_literal,
    ACTIONS(4703), 1,
      anon_sym__,
    ACTIONS(4707), 1,
      anon_sym_LPAREN,
    ACTIONS(4709), 1,
      sym__conid,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(4713), 1,
      anon_sym_AT,
    ACTIONS(5821), 1,
      sym_hole,
    STATE(2207), 1,
      sym_forall,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4516), 1,
      sym__btype,
    STATE(5737), 1,
      sym_type_apply,
    STATE(5738), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1285), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [80976] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5009), 1,
      sym__varid,
    ACTIONS(5011), 1,
      sym_string,
    ACTIONS(5013), 1,
      sym_triple_quote_string,
    ACTIONS(5015), 1,
      sym__integer_literal,
    ACTIONS(5017), 1,
      sym__hex_literal,
    ACTIONS(5019), 1,
      anon_sym__,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    ACTIONS(5028), 1,
      anon_sym_LBRACE,
    ACTIONS(5262), 1,
      sym_hole,
    ACTIONS(5264), 1,
      sym__conid,
    ACTIONS(5266), 1,
      anon_sym_AT,
    STATE(2176), 1,
      sym_forall,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4479), 1,
      sym__btype,
    STATE(5923), 1,
      sym_type_apply,
    STATE(6057), 1,
      sym_type_infix,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1111), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81068] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3042), 1,
      sym__varid,
    ACTIONS(3044), 1,
      sym_string,
    ACTIONS(3046), 1,
      sym_triple_quote_string,
    ACTIONS(3048), 1,
      sym__integer_literal,
    ACTIONS(3050), 1,
      sym__hex_literal,
    ACTIONS(3052), 1,
      anon_sym__,
    ACTIONS(3056), 1,
      anon_sym_LPAREN,
    ACTIONS(3058), 1,
      sym__conid,
    ACTIONS(3060), 1,
      anon_sym_LBRACE,
    ACTIONS(3062), 1,
      anon_sym_AT,
    ACTIONS(6360), 1,
      sym_hole,
    STATE(2041), 1,
      sym_forall,
    STATE(3025), 1,
      sym__btype,
    STATE(3809), 1,
      sym_constructor,
    STATE(4040), 1,
      sym_type_infix,
    STATE(4288), 1,
      sym_integer,
    STATE(4309), 1,
      sym_type_apply,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1437), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81160] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5296), 1,
      sym__varid,
    ACTIONS(5298), 1,
      sym_string,
    ACTIONS(5300), 1,
      sym_triple_quote_string,
    ACTIONS(5302), 1,
      sym__integer_literal,
    ACTIONS(5304), 1,
      sym__hex_literal,
    ACTIONS(5306), 1,
      anon_sym__,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      sym__conid,
    ACTIONS(5314), 1,
      anon_sym_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_AT,
    ACTIONS(5584), 1,
      sym_hole,
    STATE(2128), 1,
      sym_forall,
    STATE(4350), 1,
      sym_constructor,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4552), 1,
      sym_integer,
    STATE(5555), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7562), 1,
      sym_type_apply,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(8619), 1,
      sym_type_infix,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1504), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81252] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2446), 1,
      sym__varid,
    ACTIONS(2448), 1,
      sym_string,
    ACTIONS(2450), 1,
      sym_triple_quote_string,
    ACTIONS(2452), 1,
      sym__integer_literal,
    ACTIONS(2454), 1,
      sym__hex_literal,
    ACTIONS(2456), 1,
      anon_sym__,
    ACTIONS(2460), 1,
      anon_sym_LPAREN,
    ACTIONS(2462), 1,
      sym__conid,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_AT,
    ACTIONS(6362), 1,
      sym_hole,
    STATE(2178), 1,
      sym_forall,
    STATE(2767), 1,
      sym__btype,
    STATE(3107), 1,
      sym_constructor,
    STATE(3222), 1,
      sym_type_apply,
    STATE(3261), 1,
      sym_integer,
    STATE(3333), 1,
      sym_type_infix,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1032), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81344] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5394), 1,
      sym__varid,
    ACTIONS(5396), 1,
      sym_string,
    ACTIONS(5398), 1,
      sym_triple_quote_string,
    ACTIONS(5400), 1,
      sym__integer_literal,
    ACTIONS(5402), 1,
      sym__hex_literal,
    ACTIONS(5404), 1,
      anon_sym__,
    ACTIONS(5406), 1,
      sym_hole,
    ACTIONS(5408), 1,
      anon_sym_LPAREN,
    ACTIONS(5410), 1,
      sym__conid,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    ACTIONS(5414), 1,
      anon_sym_AT,
    STATE(2077), 1,
      sym_forall,
    STATE(3058), 1,
      sym_type_infix,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(5554), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(7647), 1,
      sym_type_apply,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1530), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81436] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(3307), 1,
      sym__varid,
    ACTIONS(3309), 1,
      sym_string,
    ACTIONS(3311), 1,
      sym_triple_quote_string,
    ACTIONS(3313), 1,
      sym__integer_literal,
    ACTIONS(3315), 1,
      sym__hex_literal,
    ACTIONS(3319), 1,
      anon_sym__,
    ACTIONS(3323), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(5681), 1,
      sym_hole,
    ACTIONS(5683), 1,
      sym__conid,
    ACTIONS(5685), 1,
      anon_sym_AT,
    STATE(2187), 1,
      sym_forall,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(3857), 1,
      sym__btype,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5331), 1,
      sym_type_infix,
    STATE(5362), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(960), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81528] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4715), 1,
      sym__varid,
    ACTIONS(4717), 1,
      sym_string,
    ACTIONS(4719), 1,
      sym_triple_quote_string,
    ACTIONS(4721), 1,
      sym__integer_literal,
    ACTIONS(4723), 1,
      sym__hex_literal,
    ACTIONS(4725), 1,
      anon_sym__,
    ACTIONS(4729), 1,
      anon_sym_LPAREN,
    ACTIONS(4731), 1,
      sym__conid,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_AT,
    ACTIONS(4790), 1,
      sym_hole,
    STATE(2162), 1,
      sym_forall,
    STATE(3276), 1,
      sym_type_infix,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5006), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6800), 1,
      sym_type_apply,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1415), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81620] = 26,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4689), 1,
      sym_hole,
    ACTIONS(4691), 1,
      anon_sym_AT,
    STATE(2108), 1,
      sym_forall,
    STATE(3058), 1,
      sym_type_infix,
    STATE(4337), 1,
      sym_constructor,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4683), 1,
      sym_integer,
    STATE(5549), 1,
      sym__btype,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1500), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81712] = 20,
    ACTIONS(3461), 1,
      sym_comma,
    ACTIONS(5351), 1,
      sym__varid,
    ACTIONS(5353), 1,
      sym_string,
    ACTIONS(5355), 1,
      sym_triple_quote_string,
    ACTIONS(5357), 1,
      sym__integer_literal,
    ACTIONS(5359), 1,
      sym__hex_literal,
    ACTIONS(5361), 1,
      anon_sym__,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(6364), 1,
      sym_hole,
    ACTIONS(6366), 1,
      sym__conid,
    ACTIONS(6369), 1,
      anon_sym_AT,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(1349), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [81792] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5170), 1,
      sym__varid,
    ACTIONS(5172), 1,
      sym_string,
    ACTIONS(5174), 1,
      sym_triple_quote_string,
    ACTIONS(5176), 1,
      sym__integer_literal,
    ACTIONS(5178), 1,
      sym__hex_literal,
    ACTIONS(5180), 1,
      anon_sym__,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    ACTIONS(5186), 1,
      sym__conid,
    ACTIONS(5188), 1,
      anon_sym_LBRACE,
    ACTIONS(5190), 1,
      anon_sym_AT,
    ACTIONS(5238), 1,
      sym_hole,
    STATE(2130), 1,
      sym_forall,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4768), 1,
      sym_type_infix,
    STATE(4771), 1,
      sym__btype,
    STATE(5924), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1388), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81884] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4470), 1,
      sym__varid,
    ACTIONS(4472), 1,
      sym_string,
    ACTIONS(4474), 1,
      sym_triple_quote_string,
    ACTIONS(4476), 1,
      sym__integer_literal,
    ACTIONS(4478), 1,
      sym__hex_literal,
    ACTIONS(4480), 1,
      anon_sym__,
    ACTIONS(4484), 1,
      anon_sym_LPAREN,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4786), 1,
      sym__conid,
    ACTIONS(4788), 1,
      anon_sym_AT,
    ACTIONS(5637), 1,
      sym_hole,
    STATE(2154), 1,
      sym_forall,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(4316), 1,
      sym__btype,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(5640), 1,
      sym_type_infix,
    STATE(5648), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1025), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [81976] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(519), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6371), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [82064] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2468), 1,
      sym__varid,
    ACTIONS(2472), 1,
      sym_string,
    ACTIONS(2474), 1,
      sym_triple_quote_string,
    ACTIONS(2476), 1,
      sym__integer_literal,
    ACTIONS(2478), 1,
      sym__hex_literal,
    ACTIONS(2482), 1,
      anon_sym__,
    ACTIONS(2486), 1,
      anon_sym_LPAREN,
    ACTIONS(2488), 1,
      sym__conid,
    ACTIONS(2490), 1,
      anon_sym_LBRACE,
    ACTIONS(2492), 1,
      anon_sym_AT,
    ACTIONS(6373), 1,
      sym_hole,
    STATE(2131), 1,
      sym_forall,
    STATE(2898), 1,
      sym__btype,
    STATE(3122), 1,
      sym_constructor,
    STATE(3226), 1,
      sym_integer,
    STATE(3236), 1,
      sym_type_apply,
    STATE(3276), 1,
      sym_type_infix,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1029), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [82156] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4798), 1,
      sym__varid,
    ACTIONS(4800), 1,
      sym_string,
    ACTIONS(4802), 1,
      sym_triple_quote_string,
    ACTIONS(4804), 1,
      sym__integer_literal,
    ACTIONS(4806), 1,
      sym__hex_literal,
    ACTIONS(4808), 1,
      anon_sym__,
    ACTIONS(4812), 1,
      anon_sym_LPAREN,
    ACTIONS(4814), 1,
      sym__conid,
    ACTIONS(4816), 1,
      anon_sym_LBRACE,
    ACTIONS(4818), 1,
      anon_sym_AT,
    ACTIONS(6375), 1,
      sym_hole,
    STATE(2219), 1,
      sym_forall,
    STATE(3840), 1,
      sym_constructor,
    STATE(4311), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4927), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6748), 1,
      sym_type_apply,
    STATE(7760), 1,
      sym_type_infix,
    STATE(7967), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4313), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1427), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [82248] = 20,
    ACTIONS(6377), 1,
      sym__varid,
    ACTIONS(6380), 1,
      sym_string,
    ACTIONS(6383), 1,
      sym_triple_quote_string,
    ACTIONS(6386), 1,
      sym__integer_literal,
    ACTIONS(6389), 1,
      sym__hex_literal,
    ACTIONS(6392), 1,
      anon_sym__,
    ACTIONS(6395), 1,
      sym_hole,
    ACTIONS(6398), 1,
      anon_sym_LPAREN,
    ACTIONS(6401), 1,
      sym__conid,
    ACTIONS(6404), 1,
      anon_sym_LBRACE,
    ACTIONS(6407), 1,
      anon_sym_AT,
    STATE(3382), 1,
      sym_constructor,
    STATE(3586), 1,
      sym_integer,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1343), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [82328] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5445), 1,
      sym__varid,
    ACTIONS(5447), 1,
      sym_string,
    ACTIONS(5449), 1,
      sym_triple_quote_string,
    ACTIONS(5451), 1,
      sym__integer_literal,
    ACTIONS(5453), 1,
      sym__hex_literal,
    ACTIONS(5455), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_LPAREN,
    ACTIONS(5461), 1,
      sym__conid,
    ACTIONS(5463), 1,
      anon_sym_LBRACE,
    ACTIONS(5465), 1,
      anon_sym_AT,
    ACTIONS(5517), 1,
      sym_hole,
    STATE(2146), 1,
      sym_forall,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4910), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6415), 1,
      sym_type_infix,
    STATE(6458), 1,
      sym_type_apply,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1405), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [82420] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5659), 1,
      sym__varid,
    ACTIONS(5661), 1,
      sym_string,
    ACTIONS(5663), 1,
      sym_triple_quote_string,
    ACTIONS(5665), 1,
      sym__integer_literal,
    ACTIONS(5667), 1,
      sym__hex_literal,
    ACTIONS(5669), 1,
      anon_sym__,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5675), 1,
      sym__conid,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    ACTIONS(5679), 1,
      anon_sym_AT,
    ACTIONS(5689), 1,
      sym_hole,
    STATE(2213), 1,
      sym_forall,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4744), 1,
      sym__btype,
    STATE(4768), 1,
      sym_type_infix,
    STATE(5924), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1400), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [82512] = 20,
    ACTIONS(3498), 1,
      sym_comma,
    ACTIONS(5351), 1,
      sym__varid,
    ACTIONS(5353), 1,
      sym_string,
    ACTIONS(5355), 1,
      sym_triple_quote_string,
    ACTIONS(5357), 1,
      sym__integer_literal,
    ACTIONS(5359), 1,
      sym__hex_literal,
    ACTIONS(5361), 1,
      anon_sym__,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(6364), 1,
      sym_hole,
    ACTIONS(6369), 1,
      anon_sym_AT,
    ACTIONS(6410), 1,
      sym__conid,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(1349), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [82592] = 20,
    ACTIONS(3277), 1,
      sym_comma,
    ACTIONS(5351), 1,
      sym__varid,
    ACTIONS(5353), 1,
      sym_string,
    ACTIONS(5355), 1,
      sym_triple_quote_string,
    ACTIONS(5357), 1,
      sym__integer_literal,
    ACTIONS(5359), 1,
      sym__hex_literal,
    ACTIONS(5361), 1,
      anon_sym__,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(6364), 1,
      sym_hole,
    ACTIONS(6369), 1,
      anon_sym_AT,
    ACTIONS(6413), 1,
      sym__conid,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(1349), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [82672] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(470), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6417), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [82760] = 20,
    ACTIONS(3305), 1,
      sym_comma,
    ACTIONS(5351), 1,
      sym__varid,
    ACTIONS(5353), 1,
      sym_string,
    ACTIONS(5355), 1,
      sym_triple_quote_string,
    ACTIONS(5357), 1,
      sym__integer_literal,
    ACTIONS(5359), 1,
      sym__hex_literal,
    ACTIONS(5361), 1,
      anon_sym__,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(6369), 1,
      anon_sym_AT,
    ACTIONS(6419), 1,
      sym_hole,
    ACTIONS(6421), 1,
      sym__conid,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(1289), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [82840] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(521), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6424), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [82928] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4937), 1,
      sym__varid,
    ACTIONS(4939), 1,
      sym_string,
    ACTIONS(4941), 1,
      sym_triple_quote_string,
    ACTIONS(4943), 1,
      sym__integer_literal,
    ACTIONS(4945), 1,
      sym__hex_literal,
    ACTIONS(4947), 1,
      anon_sym__,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
    ACTIONS(4953), 1,
      sym__conid,
    ACTIONS(4955), 1,
      anon_sym_LBRACE,
    ACTIONS(4957), 1,
      anon_sym_AT,
    ACTIONS(4981), 1,
      sym_hole,
    STATE(2125), 1,
      sym_forall,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4593), 1,
      sym_constructor,
    STATE(4768), 1,
      sym_type_infix,
    STATE(4885), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(5868), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1691), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [83020] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2628), 1,
      sym__varid,
    ACTIONS(2630), 1,
      sym_string,
    ACTIONS(2632), 1,
      sym_triple_quote_string,
    ACTIONS(2634), 1,
      sym__integer_literal,
    ACTIONS(2636), 1,
      sym__hex_literal,
    ACTIONS(2638), 1,
      anon_sym__,
    ACTIONS(2642), 1,
      anon_sym_LPAREN,
    ACTIONS(2644), 1,
      sym__conid,
    ACTIONS(2646), 1,
      anon_sym_LBRACE,
    ACTIONS(2648), 1,
      anon_sym_AT,
    ACTIONS(6426), 1,
      sym_hole,
    STATE(2171), 1,
      sym_forall,
    STATE(2995), 1,
      sym__btype,
    STATE(3333), 1,
      sym_type_infix,
    STATE(3352), 1,
      sym_constructor,
    STATE(3444), 1,
      sym_type_apply,
    STATE(3475), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1296), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [83112] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5098), 1,
      sym__varid,
    ACTIONS(5100), 1,
      sym_string,
    ACTIONS(5102), 1,
      sym_triple_quote_string,
    ACTIONS(5104), 1,
      sym__integer_literal,
    ACTIONS(5106), 1,
      sym__hex_literal,
    ACTIONS(5108), 1,
      anon_sym__,
    ACTIONS(5112), 1,
      anon_sym_LPAREN,
    ACTIONS(5114), 1,
      sym__conid,
    ACTIONS(5116), 1,
      anon_sym_LBRACE,
    ACTIONS(5118), 1,
      anon_sym_AT,
    ACTIONS(5146), 1,
      sym_hole,
    STATE(2175), 1,
      sym_forall,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4891), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6728), 1,
      sym_type_apply,
    STATE(6984), 1,
      sym_type_infix,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1408), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [83204] = 20,
    ACTIONS(6428), 1,
      sym__varid,
    ACTIONS(6431), 1,
      sym_string,
    ACTIONS(6434), 1,
      sym_triple_quote_string,
    ACTIONS(6437), 1,
      sym__integer_literal,
    ACTIONS(6440), 1,
      sym__hex_literal,
    ACTIONS(6443), 1,
      anon_sym__,
    ACTIONS(6446), 1,
      sym_hole,
    ACTIONS(6449), 1,
      anon_sym_LPAREN,
    ACTIONS(6452), 1,
      sym__conid,
    ACTIONS(6455), 1,
      anon_sym_LBRACE,
    ACTIONS(6458), 1,
      anon_sym_AT,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3463), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1326), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [83284] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(512), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6461), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [83372] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5078), 1,
      sym_string,
    ACTIONS(5080), 1,
      sym_triple_quote_string,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5084), 1,
      sym__hex_literal,
    ACTIONS(5086), 1,
      anon_sym__,
    ACTIONS(5090), 1,
      anon_sym_LPAREN,
    ACTIONS(5092), 1,
      sym__conid,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      anon_sym_AT,
    ACTIONS(5515), 1,
      sym_hole,
    STATE(2027), 1,
      sym_forall,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4656), 1,
      sym_constructor,
    STATE(4768), 1,
      sym_type_infix,
    STATE(4770), 1,
      sym_integer,
    STATE(5568), 1,
      sym_type_apply,
    STATE(6034), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1660), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [83464] = 20,
    ACTIONS(6463), 1,
      sym__varid,
    ACTIONS(6466), 1,
      sym_string,
    ACTIONS(6469), 1,
      sym_triple_quote_string,
    ACTIONS(6472), 1,
      sym__integer_literal,
    ACTIONS(6475), 1,
      sym__hex_literal,
    ACTIONS(6478), 1,
      anon_sym__,
    ACTIONS(6481), 1,
      sym_hole,
    ACTIONS(6484), 1,
      anon_sym_LPAREN,
    ACTIONS(6487), 1,
      sym__conid,
    ACTIONS(6490), 1,
      anon_sym_LBRACE,
    ACTIONS(6493), 1,
      anon_sym_AT,
    STATE(3352), 1,
      sym_constructor,
    STATE(3475), 1,
      sym_integer,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1357), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [83544] = 20,
    ACTIONS(6496), 1,
      sym__varid,
    ACTIONS(6499), 1,
      sym_string,
    ACTIONS(6502), 1,
      sym_triple_quote_string,
    ACTIONS(6505), 1,
      sym__integer_literal,
    ACTIONS(6508), 1,
      sym__hex_literal,
    ACTIONS(6511), 1,
      anon_sym__,
    ACTIONS(6514), 1,
      sym_hole,
    ACTIONS(6517), 1,
      anon_sym_LPAREN,
    ACTIONS(6520), 1,
      sym__conid,
    ACTIONS(6523), 1,
      anon_sym_LBRACE,
    ACTIONS(6526), 1,
      anon_sym_AT,
    STATE(3352), 1,
      sym_constructor,
    STATE(3475), 1,
      sym_integer,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1312), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [83624] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(501), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6529), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [83712] = 20,
    ACTIONS(6531), 1,
      sym__varid,
    ACTIONS(6534), 1,
      sym_string,
    ACTIONS(6537), 1,
      sym_triple_quote_string,
    ACTIONS(6540), 1,
      sym__integer_literal,
    ACTIONS(6543), 1,
      sym__hex_literal,
    ACTIONS(6546), 1,
      anon_sym__,
    ACTIONS(6549), 1,
      sym_hole,
    ACTIONS(6552), 1,
      anon_sym_LPAREN,
    ACTIONS(6555), 1,
      sym__conid,
    ACTIONS(6558), 1,
      anon_sym_LBRACE,
    ACTIONS(6561), 1,
      anon_sym_AT,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3500), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1365), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [83792] = 24,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(510), 1,
      sym__arrow,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6564), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [83880] = 20,
    ACTIONS(6566), 1,
      sym__varid,
    ACTIONS(6570), 1,
      sym_string,
    ACTIONS(6574), 1,
      sym_triple_quote_string,
    ACTIONS(6578), 1,
      sym__integer_literal,
    ACTIONS(6582), 1,
      sym__hex_literal,
    ACTIONS(6586), 1,
      anon_sym__,
    ACTIONS(6590), 1,
      sym_hole,
    ACTIONS(6594), 1,
      anon_sym_LPAREN,
    ACTIONS(6598), 1,
      sym__conid,
    ACTIONS(6602), 1,
      anon_sym_LBRACE,
    ACTIONS(6606), 1,
      anon_sym_AT,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3288), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1365), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [83960] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5164), 1,
      sym__conid,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(5168), 1,
      anon_sym_AT,
    ACTIONS(5612), 1,
      sym_hole,
    STATE(2169), 1,
      sym_forall,
    STATE(4315), 1,
      sym_constructor,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4405), 1,
      sym_integer,
    STATE(5228), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7140), 1,
      sym_type_apply,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(8208), 1,
      sym_type_infix,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1456), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [84052] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(2598), 1,
      sym__varid,
    ACTIONS(2600), 1,
      sym_string,
    ACTIONS(2602), 1,
      sym_triple_quote_string,
    ACTIONS(2604), 1,
      sym__integer_literal,
    ACTIONS(2606), 1,
      sym__hex_literal,
    ACTIONS(2608), 1,
      anon_sym__,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym__conid,
    ACTIONS(2618), 1,
      anon_sym_LBRACE,
    ACTIONS(2620), 1,
      anon_sym_AT,
    ACTIONS(6610), 1,
      sym_hole,
    STATE(2040), 1,
      sym_forall,
    STATE(3013), 1,
      sym__btype,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(3465), 1,
      sym_type_apply,
    STATE(4037), 1,
      sym_type_infix,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1362), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [84144] = 20,
    ACTIONS(6612), 1,
      sym__varid,
    ACTIONS(6615), 1,
      sym_string,
    ACTIONS(6618), 1,
      sym_triple_quote_string,
    ACTIONS(6621), 1,
      sym__integer_literal,
    ACTIONS(6624), 1,
      sym__hex_literal,
    ACTIONS(6627), 1,
      anon_sym__,
    ACTIONS(6630), 1,
      sym_hole,
    ACTIONS(6633), 1,
      anon_sym_LPAREN,
    ACTIONS(6636), 1,
      sym__conid,
    ACTIONS(6639), 1,
      anon_sym_LBRACE,
    ACTIONS(6642), 1,
      anon_sym_AT,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3317), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1297), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [84224] = 20,
    ACTIONS(6645), 1,
      sym__varid,
    ACTIONS(6648), 1,
      sym_string,
    ACTIONS(6651), 1,
      sym_triple_quote_string,
    ACTIONS(6654), 1,
      sym__integer_literal,
    ACTIONS(6657), 1,
      sym__hex_literal,
    ACTIONS(6660), 1,
      anon_sym__,
    ACTIONS(6663), 1,
      sym_hole,
    ACTIONS(6666), 1,
      anon_sym_LPAREN,
    ACTIONS(6669), 1,
      sym__conid,
    ACTIONS(6672), 1,
      anon_sym_LBRACE,
    ACTIONS(6675), 1,
      anon_sym_AT,
    STATE(3282), 1,
      sym_constructor,
    STATE(3669), 1,
      sym_integer,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3349), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1366), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [84304] = 20,
    ACTIONS(6678), 1,
      sym__varid,
    ACTIONS(6681), 1,
      sym_string,
    ACTIONS(6684), 1,
      sym_triple_quote_string,
    ACTIONS(6687), 1,
      sym__integer_literal,
    ACTIONS(6690), 1,
      sym__hex_literal,
    ACTIONS(6693), 1,
      anon_sym__,
    ACTIONS(6696), 1,
      sym_hole,
    ACTIONS(6699), 1,
      anon_sym_LPAREN,
    ACTIONS(6702), 1,
      sym__conid,
    ACTIONS(6705), 1,
      anon_sym_LBRACE,
    ACTIONS(6708), 1,
      anon_sym_AT,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3463), 4,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1365), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [84384] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(4737), 1,
      sym__varid,
    ACTIONS(4739), 1,
      sym_string,
    ACTIONS(4741), 1,
      sym_triple_quote_string,
    ACTIONS(4743), 1,
      sym__integer_literal,
    ACTIONS(4745), 1,
      sym__hex_literal,
    ACTIONS(4747), 1,
      anon_sym__,
    ACTIONS(4749), 1,
      sym_hole,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      sym__conid,
    ACTIONS(4755), 1,
      anon_sym_LBRACE,
    ACTIONS(4757), 1,
      anon_sym_AT,
    STATE(2164), 1,
      sym_forall,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4765), 1,
      sym__btype,
    STATE(4768), 1,
      sym_type_infix,
    STATE(5924), 1,
      sym_type_apply,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1399), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [84476] = 26,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    ACTIONS(5588), 1,
      sym__varid,
    ACTIONS(5590), 1,
      sym_string,
    ACTIONS(5592), 1,
      sym_triple_quote_string,
    ACTIONS(5594), 1,
      sym__integer_literal,
    ACTIONS(5596), 1,
      sym__hex_literal,
    ACTIONS(5598), 1,
      anon_sym__,
    ACTIONS(5600), 1,
      sym_hole,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5604), 1,
      sym__conid,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    ACTIONS(5608), 1,
      anon_sym_AT,
    STATE(2184), 1,
      sym_forall,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(4376), 1,
      aux_sym_forall_repeat1,
    STATE(4731), 1,
      sym__btype,
    STATE(6231), 1,
      sym__forall_kw,
    STATE(6430), 1,
      sym_type_apply,
    STATE(7485), 1,
      sym_type_infix,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1380), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [84568] = 20,
    ACTIONS(5423), 1,
      sym__varid,
    ACTIONS(5425), 1,
      sym_string,
    ACTIONS(5427), 1,
      sym_triple_quote_string,
    ACTIONS(5429), 1,
      sym__integer_literal,
    ACTIONS(5431), 1,
      sym__hex_literal,
    ACTIONS(5433), 1,
      anon_sym__,
    ACTIONS(5437), 1,
      anon_sym_LPAREN,
    ACTIONS(5441), 1,
      anon_sym_LBRACE,
    ACTIONS(6711), 1,
      sym_hole,
    ACTIONS(6713), 1,
      sym__conid,
    ACTIONS(6717), 1,
      anon_sym_AT,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3288), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1377), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [84647] = 19,
    ACTIONS(6719), 1,
      sym__varid,
    ACTIONS(6722), 1,
      sym_string,
    ACTIONS(6725), 1,
      sym_triple_quote_string,
    ACTIONS(6728), 1,
      sym__integer_literal,
    ACTIONS(6731), 1,
      sym__hex_literal,
    ACTIONS(6734), 1,
      anon_sym__,
    ACTIONS(6737), 1,
      sym_hole,
    ACTIONS(6740), 1,
      anon_sym_LPAREN,
    ACTIONS(6743), 1,
      sym__conid,
    ACTIONS(6746), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_AT,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_then,
    STATE(1371), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [84724] = 19,
    ACTIONS(4737), 1,
      sym__varid,
    ACTIONS(4739), 1,
      sym_string,
    ACTIONS(4741), 1,
      sym_triple_quote_string,
    ACTIONS(4743), 1,
      sym__integer_literal,
    ACTIONS(4745), 1,
      sym__hex_literal,
    ACTIONS(4747), 1,
      anon_sym__,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4755), 1,
      anon_sym_LBRACE,
    ACTIONS(6752), 1,
      sym_hole,
    ACTIONS(6754), 1,
      sym__conid,
    ACTIONS(6757), 1,
      anon_sym_AT,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_else,
    STATE(1394), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [84801] = 20,
    ACTIONS(6759), 1,
      sym__varid,
    ACTIONS(6762), 1,
      sym_string,
    ACTIONS(6765), 1,
      sym_triple_quote_string,
    ACTIONS(6768), 1,
      sym__integer_literal,
    ACTIONS(6771), 1,
      sym__hex_literal,
    ACTIONS(6774), 1,
      anon_sym__,
    ACTIONS(6777), 1,
      sym_hole,
    ACTIONS(6780), 1,
      anon_sym_LPAREN,
    ACTIONS(6783), 1,
      sym__conid,
    ACTIONS(6786), 1,
      anon_sym_LBRACE,
    ACTIONS(6789), 1,
      anon_sym_AT,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1373), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [84880] = 20,
    ACTIONS(5098), 1,
      sym__varid,
    ACTIONS(5100), 1,
      sym_string,
    ACTIONS(5102), 1,
      sym_triple_quote_string,
    ACTIONS(5104), 1,
      sym__integer_literal,
    ACTIONS(5106), 1,
      sym__hex_literal,
    ACTIONS(5108), 1,
      anon_sym__,
    ACTIONS(5112), 1,
      anon_sym_LPAREN,
    ACTIONS(5116), 1,
      anon_sym_LBRACE,
    ACTIONS(6792), 1,
      sym_hole,
    ACTIONS(6794), 1,
      sym__conid,
    ACTIONS(6797), 1,
      anon_sym_AT,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1396), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [84959] = 20,
    ACTIONS(5588), 1,
      sym__varid,
    ACTIONS(5590), 1,
      sym_string,
    ACTIONS(5592), 1,
      sym_triple_quote_string,
    ACTIONS(5594), 1,
      sym__integer_literal,
    ACTIONS(5596), 1,
      sym__hex_literal,
    ACTIONS(5598), 1,
      anon_sym__,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    ACTIONS(6799), 1,
      sym_hole,
    ACTIONS(6801), 1,
      sym__conid,
    ACTIONS(6804), 1,
      anon_sym_AT,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1381), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85038] = 23,
    ACTIONS(6806), 1,
      sym__varid,
    ACTIONS(6812), 1,
      sym_string,
    ACTIONS(6815), 1,
      sym__integer_literal,
    ACTIONS(6818), 1,
      sym__hex_literal,
    ACTIONS(6821), 1,
      anon_sym__,
    ACTIONS(6824), 1,
      anon_sym_LPAREN,
    ACTIONS(6827), 1,
      sym__conid,
    ACTIONS(6830), 1,
      anon_sym_LBRACE,
    ACTIONS(6833), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3111), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(6809), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1376), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [85123] = 20,
    ACTIONS(5423), 1,
      sym__varid,
    ACTIONS(5425), 1,
      sym_string,
    ACTIONS(5427), 1,
      sym_triple_quote_string,
    ACTIONS(5429), 1,
      sym__integer_literal,
    ACTIONS(5431), 1,
      sym__hex_literal,
    ACTIONS(5433), 1,
      anon_sym__,
    ACTIONS(5437), 1,
      anon_sym_LPAREN,
    ACTIONS(5441), 1,
      anon_sym_LBRACE,
    ACTIONS(6717), 1,
      anon_sym_AT,
    ACTIONS(6836), 1,
      sym_hole,
    ACTIONS(6838), 1,
      sym__conid,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3317), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1402), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85202] = 20,
    ACTIONS(5098), 1,
      sym__varid,
    ACTIONS(5100), 1,
      sym_string,
    ACTIONS(5102), 1,
      sym_triple_quote_string,
    ACTIONS(5104), 1,
      sym__integer_literal,
    ACTIONS(5106), 1,
      sym__hex_literal,
    ACTIONS(5108), 1,
      anon_sym__,
    ACTIONS(5112), 1,
      anon_sym_LPAREN,
    ACTIONS(5116), 1,
      anon_sym_LBRACE,
    ACTIONS(6792), 1,
      sym_hole,
    ACTIONS(6797), 1,
      anon_sym_AT,
    ACTIONS(6841), 1,
      sym__conid,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1396), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85281] = 20,
    ACTIONS(5423), 1,
      sym__varid,
    ACTIONS(5425), 1,
      sym_string,
    ACTIONS(5427), 1,
      sym_triple_quote_string,
    ACTIONS(5429), 1,
      sym__integer_literal,
    ACTIONS(5431), 1,
      sym__hex_literal,
    ACTIONS(5433), 1,
      anon_sym__,
    ACTIONS(5437), 1,
      anon_sym_LPAREN,
    ACTIONS(5441), 1,
      anon_sym_LBRACE,
    ACTIONS(6711), 1,
      sym_hole,
    ACTIONS(6717), 1,
      anon_sym_AT,
    ACTIONS(6844), 1,
      sym__conid,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3463), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1377), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85360] = 20,
    ACTIONS(5588), 1,
      sym__varid,
    ACTIONS(5590), 1,
      sym_string,
    ACTIONS(5592), 1,
      sym_triple_quote_string,
    ACTIONS(5594), 1,
      sym__integer_literal,
    ACTIONS(5596), 1,
      sym__hex_literal,
    ACTIONS(5598), 1,
      anon_sym__,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    ACTIONS(6799), 1,
      sym_hole,
    ACTIONS(6804), 1,
      anon_sym_AT,
    ACTIONS(6847), 1,
      sym__conid,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1381), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85439] = 20,
    ACTIONS(5588), 1,
      sym__varid,
    ACTIONS(5590), 1,
      sym_string,
    ACTIONS(5592), 1,
      sym_triple_quote_string,
    ACTIONS(5594), 1,
      sym__integer_literal,
    ACTIONS(5596), 1,
      sym__hex_literal,
    ACTIONS(5598), 1,
      anon_sym__,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    ACTIONS(6804), 1,
      anon_sym_AT,
    ACTIONS(6851), 1,
      sym_hole,
    ACTIONS(6853), 1,
      sym__conid,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1385), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85518] = 20,
    ACTIONS(3335), 1,
      anon_sym_RPAREN,
    ACTIONS(6856), 1,
      sym__varid,
    ACTIONS(6859), 1,
      sym_string,
    ACTIONS(6862), 1,
      sym_triple_quote_string,
    ACTIONS(6865), 1,
      sym__integer_literal,
    ACTIONS(6868), 1,
      sym__hex_literal,
    ACTIONS(6871), 1,
      anon_sym__,
    ACTIONS(6874), 1,
      sym_hole,
    ACTIONS(6877), 1,
      anon_sym_LPAREN,
    ACTIONS(6880), 1,
      sym__conid,
    ACTIONS(6883), 1,
      anon_sym_LBRACE,
    ACTIONS(6886), 1,
      anon_sym_AT,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1382), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85597] = 19,
    ACTIONS(5659), 1,
      sym__varid,
    ACTIONS(5661), 1,
      sym_string,
    ACTIONS(5663), 1,
      sym_triple_quote_string,
    ACTIONS(5665), 1,
      sym__integer_literal,
    ACTIONS(5667), 1,
      sym__hex_literal,
    ACTIONS(5669), 1,
      anon_sym__,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    ACTIONS(6889), 1,
      sym_hole,
    ACTIONS(6891), 1,
      sym__conid,
    ACTIONS(6894), 1,
      anon_sym_AT,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3500), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_then,
    STATE(1398), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85674] = 20,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
    ACTIONS(5170), 1,
      sym__varid,
    ACTIONS(5172), 1,
      sym_string,
    ACTIONS(5174), 1,
      sym_triple_quote_string,
    ACTIONS(5176), 1,
      sym__integer_literal,
    ACTIONS(5178), 1,
      sym__hex_literal,
    ACTIONS(5180), 1,
      anon_sym__,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    ACTIONS(5188), 1,
      anon_sym_LBRACE,
    ACTIONS(6896), 1,
      sym_hole,
    ACTIONS(6898), 1,
      sym__conid,
    ACTIONS(6901), 1,
      anon_sym_AT,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1390), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85753] = 20,
    ACTIONS(6903), 1,
      sym__varid,
    ACTIONS(6906), 1,
      sym_string,
    ACTIONS(6909), 1,
      sym_triple_quote_string,
    ACTIONS(6912), 1,
      sym__integer_literal,
    ACTIONS(6915), 1,
      sym__hex_literal,
    ACTIONS(6918), 1,
      anon_sym__,
    ACTIONS(6921), 1,
      sym_hole,
    ACTIONS(6924), 1,
      anon_sym_LPAREN,
    ACTIONS(6927), 1,
      sym__conid,
    ACTIONS(6930), 1,
      anon_sym_LBRACE,
    ACTIONS(6933), 1,
      anon_sym_AT,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1385), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85832] = 20,
    ACTIONS(5423), 1,
      sym__varid,
    ACTIONS(5425), 1,
      sym_string,
    ACTIONS(5427), 1,
      sym_triple_quote_string,
    ACTIONS(5429), 1,
      sym__integer_literal,
    ACTIONS(5431), 1,
      sym__hex_literal,
    ACTIONS(5433), 1,
      anon_sym__,
    ACTIONS(5437), 1,
      anon_sym_LPAREN,
    ACTIONS(5441), 1,
      anon_sym_LBRACE,
    ACTIONS(6711), 1,
      sym_hole,
    ACTIONS(6717), 1,
      anon_sym_AT,
    ACTIONS(6936), 1,
      sym__conid,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3500), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1377), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [85911] = 24,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(6943), 1,
      sym_string,
    ACTIONS(6945), 1,
      sym__integer_literal,
    ACTIONS(6947), 1,
      sym__hex_literal,
    ACTIONS(6949), 1,
      anon_sym__,
    ACTIONS(6951), 1,
      anon_sym_LPAREN,
    ACTIONS(6953), 1,
      sym__conid,
    ACTIONS(6957), 1,
      anon_sym_LBRACE,
    ACTIONS(6959), 1,
      anon_sym_LBRACK,
    STATE(1401), 1,
      aux_sym__fun_patterns,
    STATE(4441), 1,
      sym_constructor,
    STATE(4475), 1,
      sym_variable,
    STATE(4522), 1,
      sym_pat_fields,
    STATE(4534), 1,
      sym_literal,
    STATE(4535), 1,
      sym__qcon,
    STATE(4537), 1,
      sym_qualified_constructor,
    STATE(4538), 1,
      sym_wildcard,
    STATE(7688), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6955), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(6941), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4541), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4580), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [85998] = 20,
    ACTIONS(3277), 1,
      anon_sym_RPAREN,
    ACTIONS(5170), 1,
      sym__varid,
    ACTIONS(5172), 1,
      sym_string,
    ACTIONS(5174), 1,
      sym_triple_quote_string,
    ACTIONS(5176), 1,
      sym__integer_literal,
    ACTIONS(5178), 1,
      sym__hex_literal,
    ACTIONS(5180), 1,
      anon_sym__,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    ACTIONS(5188), 1,
      anon_sym_LBRACE,
    ACTIONS(6896), 1,
      sym_hole,
    ACTIONS(6901), 1,
      anon_sym_AT,
    ACTIONS(6961), 1,
      sym__conid,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1390), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86077] = 20,
    ACTIONS(5588), 1,
      sym__varid,
    ACTIONS(5590), 1,
      sym_string,
    ACTIONS(5592), 1,
      sym_triple_quote_string,
    ACTIONS(5594), 1,
      sym__integer_literal,
    ACTIONS(5596), 1,
      sym__hex_literal,
    ACTIONS(5598), 1,
      anon_sym__,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    ACTIONS(6799), 1,
      sym_hole,
    ACTIONS(6804), 1,
      anon_sym_AT,
    ACTIONS(6965), 1,
      sym__conid,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1381), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86156] = 20,
    ACTIONS(3305), 1,
      anon_sym_RPAREN,
    ACTIONS(5170), 1,
      sym__varid,
    ACTIONS(5172), 1,
      sym_string,
    ACTIONS(5174), 1,
      sym_triple_quote_string,
    ACTIONS(5176), 1,
      sym__integer_literal,
    ACTIONS(5178), 1,
      sym__hex_literal,
    ACTIONS(5180), 1,
      anon_sym__,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    ACTIONS(5188), 1,
      anon_sym_LBRACE,
    ACTIONS(6901), 1,
      anon_sym_AT,
    ACTIONS(6968), 1,
      sym_hole,
    ACTIONS(6970), 1,
      sym__conid,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1382), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86235] = 24,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(6943), 1,
      sym_string,
    ACTIONS(6945), 1,
      sym__integer_literal,
    ACTIONS(6947), 1,
      sym__hex_literal,
    ACTIONS(6949), 1,
      anon_sym__,
    ACTIONS(6951), 1,
      anon_sym_LPAREN,
    ACTIONS(6953), 1,
      sym__conid,
    ACTIONS(6957), 1,
      anon_sym_LBRACE,
    ACTIONS(6959), 1,
      anon_sym_LBRACK,
    STATE(1387), 1,
      aux_sym__fun_patterns,
    STATE(4441), 1,
      sym_constructor,
    STATE(4475), 1,
      sym_variable,
    STATE(4522), 1,
      sym_pat_fields,
    STATE(4534), 1,
      sym_literal,
    STATE(4535), 1,
      sym__qcon,
    STATE(4537), 1,
      sym_qualified_constructor,
    STATE(4538), 1,
      sym_wildcard,
    STATE(7688), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(6973), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(6941), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4541), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4580), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [86322] = 19,
    ACTIONS(4737), 1,
      sym__varid,
    ACTIONS(4739), 1,
      sym_string,
    ACTIONS(4741), 1,
      sym_triple_quote_string,
    ACTIONS(4743), 1,
      sym__integer_literal,
    ACTIONS(4745), 1,
      sym__hex_literal,
    ACTIONS(4747), 1,
      anon_sym__,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4755), 1,
      anon_sym_LBRACE,
    ACTIONS(6752), 1,
      sym_hole,
    ACTIONS(6757), 1,
      anon_sym_AT,
    ACTIONS(6975), 1,
      sym__conid,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_else,
    STATE(1394), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86399] = 20,
    ACTIONS(3335), 1,
      sym_comma,
    ACTIONS(6978), 1,
      sym__varid,
    ACTIONS(6981), 1,
      sym_string,
    ACTIONS(6984), 1,
      sym_triple_quote_string,
    ACTIONS(6987), 1,
      sym__integer_literal,
    ACTIONS(6990), 1,
      sym__hex_literal,
    ACTIONS(6993), 1,
      anon_sym__,
    ACTIONS(6996), 1,
      sym_hole,
    ACTIONS(6999), 1,
      anon_sym_LPAREN,
    ACTIONS(7002), 1,
      sym__conid,
    ACTIONS(7005), 1,
      anon_sym_LBRACE,
    ACTIONS(7008), 1,
      anon_sym_AT,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1393), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86478] = 19,
    ACTIONS(4737), 1,
      sym__varid,
    ACTIONS(4739), 1,
      sym_string,
    ACTIONS(4741), 1,
      sym_triple_quote_string,
    ACTIONS(4743), 1,
      sym__integer_literal,
    ACTIONS(4745), 1,
      sym__hex_literal,
    ACTIONS(4747), 1,
      anon_sym__,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4755), 1,
      anon_sym_LBRACE,
    ACTIONS(6757), 1,
      anon_sym_AT,
    ACTIONS(7011), 1,
      sym_hole,
    ACTIONS(7013), 1,
      sym__conid,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_else,
    STATE(1395), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86555] = 19,
    ACTIONS(7016), 1,
      sym__varid,
    ACTIONS(7019), 1,
      sym_string,
    ACTIONS(7022), 1,
      sym_triple_quote_string,
    ACTIONS(7025), 1,
      sym__integer_literal,
    ACTIONS(7028), 1,
      sym__hex_literal,
    ACTIONS(7031), 1,
      anon_sym__,
    ACTIONS(7034), 1,
      sym_hole,
    ACTIONS(7037), 1,
      anon_sym_LPAREN,
    ACTIONS(7040), 1,
      sym__conid,
    ACTIONS(7043), 1,
      anon_sym_LBRACE,
    ACTIONS(7046), 1,
      anon_sym_AT,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3349), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_else,
    STATE(1395), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86632] = 20,
    ACTIONS(5098), 1,
      sym__varid,
    ACTIONS(5100), 1,
      sym_string,
    ACTIONS(5102), 1,
      sym_triple_quote_string,
    ACTIONS(5104), 1,
      sym__integer_literal,
    ACTIONS(5106), 1,
      sym__hex_literal,
    ACTIONS(5108), 1,
      anon_sym__,
    ACTIONS(5112), 1,
      anon_sym_LPAREN,
    ACTIONS(5116), 1,
      anon_sym_LBRACE,
    ACTIONS(6797), 1,
      anon_sym_AT,
    ACTIONS(7049), 1,
      sym_hole,
    ACTIONS(7051), 1,
      sym__conid,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1373), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86711] = 20,
    ACTIONS(3461), 1,
      anon_sym_RPAREN,
    ACTIONS(5170), 1,
      sym__varid,
    ACTIONS(5172), 1,
      sym_string,
    ACTIONS(5174), 1,
      sym_triple_quote_string,
    ACTIONS(5176), 1,
      sym__integer_literal,
    ACTIONS(5178), 1,
      sym__hex_literal,
    ACTIONS(5180), 1,
      anon_sym__,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    ACTIONS(5188), 1,
      anon_sym_LBRACE,
    ACTIONS(6896), 1,
      sym_hole,
    ACTIONS(6901), 1,
      anon_sym_AT,
    ACTIONS(7054), 1,
      sym__conid,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1390), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86790] = 19,
    ACTIONS(5659), 1,
      sym__varid,
    ACTIONS(5661), 1,
      sym_string,
    ACTIONS(5663), 1,
      sym_triple_quote_string,
    ACTIONS(5665), 1,
      sym__integer_literal,
    ACTIONS(5667), 1,
      sym__hex_literal,
    ACTIONS(5669), 1,
      anon_sym__,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    ACTIONS(6894), 1,
      anon_sym_AT,
    ACTIONS(7057), 1,
      sym_hole,
    ACTIONS(7059), 1,
      sym__conid,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3317), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_then,
    STATE(1371), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86867] = 19,
    ACTIONS(4737), 1,
      sym__varid,
    ACTIONS(4739), 1,
      sym_string,
    ACTIONS(4741), 1,
      sym_triple_quote_string,
    ACTIONS(4743), 1,
      sym__integer_literal,
    ACTIONS(4745), 1,
      sym__hex_literal,
    ACTIONS(4747), 1,
      anon_sym__,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4755), 1,
      anon_sym_LBRACE,
    ACTIONS(6752), 1,
      sym_hole,
    ACTIONS(6757), 1,
      anon_sym_AT,
    ACTIONS(7062), 1,
      sym__conid,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_else,
    STATE(1394), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [86944] = 19,
    ACTIONS(5659), 1,
      sym__varid,
    ACTIONS(5661), 1,
      sym_string,
    ACTIONS(5663), 1,
      sym_triple_quote_string,
    ACTIONS(5665), 1,
      sym__integer_literal,
    ACTIONS(5667), 1,
      sym__hex_literal,
    ACTIONS(5669), 1,
      anon_sym__,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    ACTIONS(6889), 1,
      sym_hole,
    ACTIONS(6894), 1,
      anon_sym_AT,
    ACTIONS(7066), 1,
      sym__conid,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_then,
    STATE(1398), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87021] = 24,
    ACTIONS(7070), 1,
      sym__varid,
    ACTIONS(7076), 1,
      sym_string,
    ACTIONS(7079), 1,
      sym__integer_literal,
    ACTIONS(7082), 1,
      sym__hex_literal,
    ACTIONS(7085), 1,
      anon_sym__,
    ACTIONS(7088), 1,
      anon_sym_LPAREN,
    ACTIONS(7091), 1,
      sym__conid,
    ACTIONS(7096), 1,
      anon_sym_LBRACE,
    ACTIONS(7099), 1,
      anon_sym_LBRACK,
    STATE(1401), 1,
      aux_sym__fun_patterns,
    STATE(4441), 1,
      sym_constructor,
    STATE(4475), 1,
      sym_variable,
    STATE(4522), 1,
      sym_pat_fields,
    STATE(4534), 1,
      sym_literal,
    STATE(4535), 1,
      sym__qcon,
    STATE(4537), 1,
      sym_qualified_constructor,
    STATE(4538), 1,
      sym_wildcard,
    STATE(7688), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(7094), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7073), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4541), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4580), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [87108] = 20,
    ACTIONS(7102), 1,
      sym__varid,
    ACTIONS(7105), 1,
      sym_string,
    ACTIONS(7108), 1,
      sym_triple_quote_string,
    ACTIONS(7111), 1,
      sym__integer_literal,
    ACTIONS(7114), 1,
      sym__hex_literal,
    ACTIONS(7117), 1,
      anon_sym__,
    ACTIONS(7120), 1,
      sym_hole,
    ACTIONS(7123), 1,
      anon_sym_LPAREN,
    ACTIONS(7126), 1,
      sym__conid,
    ACTIONS(7129), 1,
      anon_sym_LBRACE,
    ACTIONS(7132), 1,
      anon_sym_AT,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(3349), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1402), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87187] = 20,
    ACTIONS(3461), 1,
      sym_comma,
    ACTIONS(5445), 1,
      sym__varid,
    ACTIONS(5447), 1,
      sym_string,
    ACTIONS(5449), 1,
      sym_triple_quote_string,
    ACTIONS(5451), 1,
      sym__integer_literal,
    ACTIONS(5453), 1,
      sym__hex_literal,
    ACTIONS(5455), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_LPAREN,
    ACTIONS(5463), 1,
      anon_sym_LBRACE,
    ACTIONS(7135), 1,
      sym_hole,
    ACTIONS(7137), 1,
      sym__conid,
    ACTIONS(7140), 1,
      anon_sym_AT,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1404), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87266] = 20,
    ACTIONS(3305), 1,
      sym_comma,
    ACTIONS(5445), 1,
      sym__varid,
    ACTIONS(5447), 1,
      sym_string,
    ACTIONS(5449), 1,
      sym_triple_quote_string,
    ACTIONS(5451), 1,
      sym__integer_literal,
    ACTIONS(5453), 1,
      sym__hex_literal,
    ACTIONS(5455), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_LPAREN,
    ACTIONS(5463), 1,
      anon_sym_LBRACE,
    ACTIONS(7140), 1,
      anon_sym_AT,
    ACTIONS(7142), 1,
      sym_hole,
    ACTIONS(7144), 1,
      sym__conid,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1393), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87345] = 20,
    ACTIONS(3277), 1,
      sym_comma,
    ACTIONS(5445), 1,
      sym__varid,
    ACTIONS(5447), 1,
      sym_string,
    ACTIONS(5449), 1,
      sym_triple_quote_string,
    ACTIONS(5451), 1,
      sym__integer_literal,
    ACTIONS(5453), 1,
      sym__hex_literal,
    ACTIONS(5455), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_LPAREN,
    ACTIONS(5463), 1,
      anon_sym_LBRACE,
    ACTIONS(7135), 1,
      sym_hole,
    ACTIONS(7140), 1,
      anon_sym_AT,
    ACTIONS(7147), 1,
      sym__conid,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1404), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87424] = 20,
    ACTIONS(3498), 1,
      sym_comma,
    ACTIONS(5445), 1,
      sym__varid,
    ACTIONS(5447), 1,
      sym_string,
    ACTIONS(5449), 1,
      sym_triple_quote_string,
    ACTIONS(5451), 1,
      sym__integer_literal,
    ACTIONS(5453), 1,
      sym__hex_literal,
    ACTIONS(5455), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_LPAREN,
    ACTIONS(5463), 1,
      anon_sym_LBRACE,
    ACTIONS(7135), 1,
      sym_hole,
    ACTIONS(7140), 1,
      anon_sym_AT,
    ACTIONS(7151), 1,
      sym__conid,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1404), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87503] = 19,
    ACTIONS(5659), 1,
      sym__varid,
    ACTIONS(5661), 1,
      sym_string,
    ACTIONS(5663), 1,
      sym_triple_quote_string,
    ACTIONS(5665), 1,
      sym__integer_literal,
    ACTIONS(5667), 1,
      sym__hex_literal,
    ACTIONS(5669), 1,
      anon_sym__,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    ACTIONS(6889), 1,
      sym_hole,
    ACTIONS(6894), 1,
      anon_sym_AT,
    ACTIONS(7154), 1,
      sym__conid,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_then,
    STATE(1398), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87580] = 20,
    ACTIONS(5098), 1,
      sym__varid,
    ACTIONS(5100), 1,
      sym_string,
    ACTIONS(5102), 1,
      sym_triple_quote_string,
    ACTIONS(5104), 1,
      sym__integer_literal,
    ACTIONS(5106), 1,
      sym__hex_literal,
    ACTIONS(5108), 1,
      anon_sym__,
    ACTIONS(5112), 1,
      anon_sym_LPAREN,
    ACTIONS(5116), 1,
      anon_sym_LBRACE,
    ACTIONS(6792), 1,
      sym_hole,
    ACTIONS(6797), 1,
      anon_sym_AT,
    ACTIONS(7157), 1,
      sym__conid,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1396), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87659] = 19,
    ACTIONS(7161), 1,
      sym__varid,
    ACTIONS(7164), 1,
      sym_string,
    ACTIONS(7167), 1,
      sym_triple_quote_string,
    ACTIONS(7170), 1,
      sym__integer_literal,
    ACTIONS(7173), 1,
      sym__hex_literal,
    ACTIONS(7176), 1,
      anon_sym__,
    ACTIONS(7179), 1,
      sym_hole,
    ACTIONS(7182), 1,
      anon_sym_LPAREN,
    ACTIONS(7185), 1,
      sym__conid,
    ACTIONS(7188), 1,
      anon_sym_LBRACE,
    ACTIONS(7191), 1,
      anon_sym_AT,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1418), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87735] = 20,
    ACTIONS(7194), 1,
      sym__varid,
    ACTIONS(7197), 1,
      sym_string,
    ACTIONS(7200), 1,
      sym_triple_quote_string,
    ACTIONS(7203), 1,
      sym__integer_literal,
    ACTIONS(7206), 1,
      sym__hex_literal,
    ACTIONS(7209), 1,
      anon_sym__,
    ACTIONS(7212), 1,
      sym_hole,
    ACTIONS(7215), 1,
      anon_sym_LPAREN,
    ACTIONS(7218), 1,
      sym__conid,
    ACTIONS(7221), 1,
      anon_sym_LBRACE,
    ACTIONS(7224), 1,
      anon_sym_AT,
    STATE(3809), 1,
      sym_constructor,
    STATE(4288), 1,
      sym_integer,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3335), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1410), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87813] = 20,
    ACTIONS(3500), 1,
      sym__operator,
    ACTIONS(4715), 1,
      sym__varid,
    ACTIONS(4717), 1,
      sym_string,
    ACTIONS(4719), 1,
      sym_triple_quote_string,
    ACTIONS(4721), 1,
      sym__integer_literal,
    ACTIONS(4723), 1,
      sym__hex_literal,
    ACTIONS(4725), 1,
      anon_sym__,
    ACTIONS(4729), 1,
      anon_sym_LPAREN,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(7227), 1,
      sym_hole,
    ACTIONS(7229), 1,
      sym__conid,
    ACTIONS(7232), 1,
      anon_sym_AT,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1416), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87891] = 19,
    ACTIONS(7234), 1,
      sym__varid,
    ACTIONS(7237), 1,
      sym_string,
    ACTIONS(7240), 1,
      sym_triple_quote_string,
    ACTIONS(7243), 1,
      sym__integer_literal,
    ACTIONS(7246), 1,
      sym__hex_literal,
    ACTIONS(7249), 1,
      anon_sym__,
    ACTIONS(7252), 1,
      sym_hole,
    ACTIONS(7255), 1,
      anon_sym_LPAREN,
    ACTIONS(7258), 1,
      sym__conid,
    ACTIONS(7261), 1,
      anon_sym_LBRACE,
    ACTIONS(7264), 1,
      anon_sym_AT,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 5,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1435), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [87967] = 20,
    ACTIONS(3463), 1,
      sym__operator,
    ACTIONS(5469), 1,
      sym__varid,
    ACTIONS(5471), 1,
      sym_string,
    ACTIONS(5473), 1,
      sym_triple_quote_string,
    ACTIONS(5475), 1,
      sym__integer_literal,
    ACTIONS(5477), 1,
      sym__hex_literal,
    ACTIONS(5479), 1,
      anon_sym__,
    ACTIONS(5483), 1,
      anon_sym_LPAREN,
    ACTIONS(5487), 1,
      anon_sym_LBRACE,
    ACTIONS(7267), 1,
      sym_hole,
    ACTIONS(7269), 1,
      sym__conid,
    ACTIONS(7272), 1,
      anon_sym_AT,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1425), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88045] = 20,
    ACTIONS(4798), 1,
      sym__varid,
    ACTIONS(4800), 1,
      sym_string,
    ACTIONS(4802), 1,
      sym_triple_quote_string,
    ACTIONS(4804), 1,
      sym__integer_literal,
    ACTIONS(4806), 1,
      sym__hex_literal,
    ACTIONS(4808), 1,
      anon_sym__,
    ACTIONS(4812), 1,
      anon_sym_LPAREN,
    ACTIONS(4816), 1,
      anon_sym_LBRACE,
    ACTIONS(7274), 1,
      sym_hole,
    ACTIONS(7276), 1,
      sym__conid,
    ACTIONS(7279), 1,
      anon_sym_AT,
    STATE(3840), 1,
      sym_constructor,
    STATE(4311), 1,
      sym_integer,
    STATE(7967), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4313), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1424), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88123] = 20,
    ACTIONS(3288), 1,
      sym__operator,
    ACTIONS(4715), 1,
      sym__varid,
    ACTIONS(4717), 1,
      sym_string,
    ACTIONS(4719), 1,
      sym_triple_quote_string,
    ACTIONS(4721), 1,
      sym__integer_literal,
    ACTIONS(4723), 1,
      sym__hex_literal,
    ACTIONS(4725), 1,
      anon_sym__,
    ACTIONS(4729), 1,
      anon_sym_LPAREN,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(7227), 1,
      sym_hole,
    ACTIONS(7232), 1,
      anon_sym_AT,
    ACTIONS(7281), 1,
      sym__conid,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1416), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88201] = 20,
    ACTIONS(3317), 1,
      sym__operator,
    ACTIONS(4715), 1,
      sym__varid,
    ACTIONS(4717), 1,
      sym_string,
    ACTIONS(4719), 1,
      sym_triple_quote_string,
    ACTIONS(4721), 1,
      sym__integer_literal,
    ACTIONS(4723), 1,
      sym__hex_literal,
    ACTIONS(4725), 1,
      anon_sym__,
    ACTIONS(4729), 1,
      anon_sym_LPAREN,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(7232), 1,
      anon_sym_AT,
    ACTIONS(7285), 1,
      sym_hole,
    ACTIONS(7287), 1,
      sym__conid,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1440), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88279] = 20,
    ACTIONS(5789), 1,
      sym__varid,
    ACTIONS(5791), 1,
      sym_string,
    ACTIONS(5793), 1,
      sym_triple_quote_string,
    ACTIONS(5795), 1,
      sym__integer_literal,
    ACTIONS(5797), 1,
      sym__hex_literal,
    ACTIONS(5799), 1,
      anon_sym__,
    ACTIONS(5803), 1,
      anon_sym_LPAREN,
    ACTIONS(5807), 1,
      anon_sym_LBRACE,
    ACTIONS(7290), 1,
      sym_hole,
    ACTIONS(7292), 1,
      sym__conid,
    ACTIONS(7295), 1,
      anon_sym_AT,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1430), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88357] = 19,
    ACTIONS(7297), 1,
      sym__varid,
    ACTIONS(7300), 1,
      sym_string,
    ACTIONS(7303), 1,
      sym_triple_quote_string,
    ACTIONS(7306), 1,
      sym__integer_literal,
    ACTIONS(7309), 1,
      sym__hex_literal,
    ACTIONS(7312), 1,
      anon_sym__,
    ACTIONS(7315), 1,
      sym_hole,
    ACTIONS(7318), 1,
      anon_sym_LPAREN,
    ACTIONS(7321), 1,
      sym__conid,
    ACTIONS(7324), 1,
      anon_sym_LBRACE,
    ACTIONS(7327), 1,
      anon_sym_AT,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1442), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88433] = 19,
    ACTIONS(7330), 1,
      sym__varid,
    ACTIONS(7333), 1,
      sym_string,
    ACTIONS(7336), 1,
      sym_triple_quote_string,
    ACTIONS(7339), 1,
      sym__integer_literal,
    ACTIONS(7342), 1,
      sym__hex_literal,
    ACTIONS(7345), 1,
      anon_sym__,
    ACTIONS(7348), 1,
      sym_hole,
    ACTIONS(7351), 1,
      anon_sym_LPAREN,
    ACTIONS(7354), 1,
      sym__conid,
    ACTIONS(7357), 1,
      anon_sym_LBRACE,
    ACTIONS(7360), 1,
      anon_sym_AT,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 5,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1435), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88509] = 20,
    ACTIONS(7363), 1,
      sym__varid,
    ACTIONS(7366), 1,
      sym_string,
    ACTIONS(7369), 1,
      sym_triple_quote_string,
    ACTIONS(7372), 1,
      sym__integer_literal,
    ACTIONS(7375), 1,
      sym__hex_literal,
    ACTIONS(7378), 1,
      anon_sym__,
    ACTIONS(7381), 1,
      sym_hole,
    ACTIONS(7384), 1,
      anon_sym_LPAREN,
    ACTIONS(7387), 1,
      sym__conid,
    ACTIONS(7390), 1,
      anon_sym_LBRACE,
    ACTIONS(7393), 1,
      anon_sym_AT,
    STATE(3809), 1,
      sym_constructor,
    STATE(4288), 1,
      sym_integer,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3498), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1439), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88587] = 20,
    ACTIONS(3461), 1,
      sym_comma,
    ACTIONS(5032), 1,
      sym__varid,
    ACTIONS(5034), 1,
      sym_string,
    ACTIONS(5036), 1,
      sym_triple_quote_string,
    ACTIONS(5038), 1,
      sym__integer_literal,
    ACTIONS(5040), 1,
      sym__hex_literal,
    ACTIONS(5042), 1,
      anon_sym__,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(7396), 1,
      sym_hole,
    ACTIONS(7398), 1,
      sym__conid,
    ACTIONS(7401), 1,
      anon_sym_AT,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1448), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88665] = 20,
    ACTIONS(3335), 1,
      sym_comma,
    ACTIONS(7403), 1,
      sym__varid,
    ACTIONS(7406), 1,
      sym_string,
    ACTIONS(7409), 1,
      sym_triple_quote_string,
    ACTIONS(7412), 1,
      sym__integer_literal,
    ACTIONS(7415), 1,
      sym__hex_literal,
    ACTIONS(7418), 1,
      anon_sym__,
    ACTIONS(7421), 1,
      sym_hole,
    ACTIONS(7424), 1,
      anon_sym_LPAREN,
    ACTIONS(7427), 1,
      sym__conid,
    ACTIONS(7430), 1,
      anon_sym_LBRACE,
    ACTIONS(7433), 1,
      anon_sym_AT,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1422), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88743] = 20,
    ACTIONS(7436), 1,
      sym__varid,
    ACTIONS(7439), 1,
      sym_string,
    ACTIONS(7442), 1,
      sym_triple_quote_string,
    ACTIONS(7445), 1,
      sym__integer_literal,
    ACTIONS(7448), 1,
      sym__hex_literal,
    ACTIONS(7451), 1,
      anon_sym__,
    ACTIONS(7454), 1,
      sym_hole,
    ACTIONS(7457), 1,
      anon_sym_LPAREN,
    ACTIONS(7460), 1,
      sym__conid,
    ACTIONS(7463), 1,
      anon_sym_LBRACE,
    ACTIONS(7466), 1,
      anon_sym_AT,
    STATE(3840), 1,
      sym_constructor,
    STATE(4311), 1,
      sym_integer,
    STATE(7967), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4313), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1423), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88821] = 20,
    ACTIONS(4798), 1,
      sym__varid,
    ACTIONS(4800), 1,
      sym_string,
    ACTIONS(4802), 1,
      sym_triple_quote_string,
    ACTIONS(4804), 1,
      sym__integer_literal,
    ACTIONS(4806), 1,
      sym__hex_literal,
    ACTIONS(4808), 1,
      anon_sym__,
    ACTIONS(4812), 1,
      anon_sym_LPAREN,
    ACTIONS(4816), 1,
      anon_sym_LBRACE,
    ACTIONS(7279), 1,
      anon_sym_AT,
    ACTIONS(7469), 1,
      sym_hole,
    ACTIONS(7471), 1,
      sym__conid,
    STATE(3840), 1,
      sym_constructor,
    STATE(4311), 1,
      sym_integer,
    STATE(7967), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4313), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1423), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88899] = 20,
    ACTIONS(3317), 1,
      sym__operator,
    ACTIONS(5469), 1,
      sym__varid,
    ACTIONS(5471), 1,
      sym_string,
    ACTIONS(5473), 1,
      sym_triple_quote_string,
    ACTIONS(5475), 1,
      sym__integer_literal,
    ACTIONS(5477), 1,
      sym__hex_literal,
    ACTIONS(5479), 1,
      anon_sym__,
    ACTIONS(5483), 1,
      anon_sym_LPAREN,
    ACTIONS(5487), 1,
      anon_sym_LBRACE,
    ACTIONS(7272), 1,
      anon_sym_AT,
    ACTIONS(7474), 1,
      sym_hole,
    ACTIONS(7476), 1,
      sym__conid,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1426), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [88977] = 20,
    ACTIONS(3349), 1,
      sym__operator,
    ACTIONS(7479), 1,
      sym__varid,
    ACTIONS(7482), 1,
      sym_string,
    ACTIONS(7485), 1,
      sym_triple_quote_string,
    ACTIONS(7488), 1,
      sym__integer_literal,
    ACTIONS(7491), 1,
      sym__hex_literal,
    ACTIONS(7494), 1,
      anon_sym__,
    ACTIONS(7497), 1,
      sym_hole,
    ACTIONS(7500), 1,
      anon_sym_LPAREN,
    ACTIONS(7503), 1,
      sym__conid,
    ACTIONS(7506), 1,
      anon_sym_LBRACE,
    ACTIONS(7509), 1,
      anon_sym_AT,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1426), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89055] = 20,
    ACTIONS(4798), 1,
      sym__varid,
    ACTIONS(4800), 1,
      sym_string,
    ACTIONS(4802), 1,
      sym_triple_quote_string,
    ACTIONS(4804), 1,
      sym__integer_literal,
    ACTIONS(4806), 1,
      sym__hex_literal,
    ACTIONS(4808), 1,
      anon_sym__,
    ACTIONS(4812), 1,
      anon_sym_LPAREN,
    ACTIONS(4816), 1,
      anon_sym_LBRACE,
    ACTIONS(7274), 1,
      sym_hole,
    ACTIONS(7279), 1,
      anon_sym_AT,
    ACTIONS(7512), 1,
      sym__conid,
    STATE(3840), 1,
      sym_constructor,
    STATE(4311), 1,
      sym_integer,
    STATE(7967), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4313), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1424), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89133] = 20,
    ACTIONS(4798), 1,
      sym__varid,
    ACTIONS(4800), 1,
      sym_string,
    ACTIONS(4802), 1,
      sym_triple_quote_string,
    ACTIONS(4804), 1,
      sym__integer_literal,
    ACTIONS(4806), 1,
      sym__hex_literal,
    ACTIONS(4808), 1,
      anon_sym__,
    ACTIONS(4812), 1,
      anon_sym_LPAREN,
    ACTIONS(4816), 1,
      anon_sym_LBRACE,
    ACTIONS(7274), 1,
      sym_hole,
    ACTIONS(7279), 1,
      anon_sym_AT,
    ACTIONS(7516), 1,
      sym__conid,
    STATE(3840), 1,
      sym_constructor,
    STATE(4311), 1,
      sym_integer,
    STATE(7967), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(4313), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1424), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89211] = 19,
    ACTIONS(7519), 1,
      sym__varid,
    ACTIONS(7522), 1,
      sym_string,
    ACTIONS(7525), 1,
      sym_triple_quote_string,
    ACTIONS(7528), 1,
      sym__integer_literal,
    ACTIONS(7531), 1,
      sym__hex_literal,
    ACTIONS(7534), 1,
      anon_sym__,
    ACTIONS(7537), 1,
      sym_hole,
    ACTIONS(7540), 1,
      anon_sym_LPAREN,
    ACTIONS(7543), 1,
      sym__conid,
    ACTIONS(7546), 1,
      anon_sym_LBRACE,
    ACTIONS(7549), 1,
      anon_sym_AT,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1418), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89287] = 20,
    ACTIONS(5789), 1,
      sym__varid,
    ACTIONS(5791), 1,
      sym_string,
    ACTIONS(5793), 1,
      sym_triple_quote_string,
    ACTIONS(5795), 1,
      sym__integer_literal,
    ACTIONS(5797), 1,
      sym__hex_literal,
    ACTIONS(5799), 1,
      anon_sym__,
    ACTIONS(5803), 1,
      anon_sym_LPAREN,
    ACTIONS(5807), 1,
      anon_sym_LBRACE,
    ACTIONS(7295), 1,
      anon_sym_AT,
    ACTIONS(7552), 1,
      sym_hole,
    ACTIONS(7554), 1,
      sym__conid,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1431), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89365] = 20,
    ACTIONS(7557), 1,
      sym__varid,
    ACTIONS(7560), 1,
      sym_string,
    ACTIONS(7563), 1,
      sym_triple_quote_string,
    ACTIONS(7566), 1,
      sym__integer_literal,
    ACTIONS(7569), 1,
      sym__hex_literal,
    ACTIONS(7572), 1,
      anon_sym__,
    ACTIONS(7575), 1,
      sym_hole,
    ACTIONS(7578), 1,
      anon_sym_LPAREN,
    ACTIONS(7581), 1,
      sym__conid,
    ACTIONS(7584), 1,
      anon_sym_LBRACE,
    ACTIONS(7587), 1,
      anon_sym_AT,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1431), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89443] = 19,
    ACTIONS(7590), 1,
      sym__varid,
    ACTIONS(7594), 1,
      sym_string,
    ACTIONS(7598), 1,
      sym_triple_quote_string,
    ACTIONS(7602), 1,
      sym__integer_literal,
    ACTIONS(7606), 1,
      sym__hex_literal,
    ACTIONS(7610), 1,
      anon_sym__,
    ACTIONS(7614), 1,
      sym_hole,
    ACTIONS(7618), 1,
      anon_sym_LPAREN,
    ACTIONS(7622), 1,
      sym__conid,
    ACTIONS(7626), 1,
      anon_sym_LBRACE,
    ACTIONS(7630), 1,
      anon_sym_AT,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 5,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1435), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89519] = 20,
    ACTIONS(3288), 1,
      sym__operator,
    ACTIONS(5469), 1,
      sym__varid,
    ACTIONS(5471), 1,
      sym_string,
    ACTIONS(5473), 1,
      sym_triple_quote_string,
    ACTIONS(5475), 1,
      sym__integer_literal,
    ACTIONS(5477), 1,
      sym__hex_literal,
    ACTIONS(5479), 1,
      anon_sym__,
    ACTIONS(5483), 1,
      anon_sym_LPAREN,
    ACTIONS(5487), 1,
      anon_sym_LBRACE,
    ACTIONS(7267), 1,
      sym_hole,
    ACTIONS(7272), 1,
      anon_sym_AT,
    ACTIONS(7634), 1,
      sym__conid,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1425), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89597] = 19,
    ACTIONS(7638), 1,
      sym__varid,
    ACTIONS(7641), 1,
      sym_string,
    ACTIONS(7644), 1,
      sym_triple_quote_string,
    ACTIONS(7647), 1,
      sym__integer_literal,
    ACTIONS(7650), 1,
      sym__hex_literal,
    ACTIONS(7653), 1,
      anon_sym__,
    ACTIONS(7656), 1,
      sym_hole,
    ACTIONS(7659), 1,
      anon_sym_LPAREN,
    ACTIONS(7662), 1,
      sym__conid,
    ACTIONS(7665), 1,
      anon_sym_LBRACE,
    ACTIONS(7668), 1,
      anon_sym_AT,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 5,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1434), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89673] = 19,
    ACTIONS(7671), 1,
      sym__varid,
    ACTIONS(7674), 1,
      sym_string,
    ACTIONS(7677), 1,
      sym_triple_quote_string,
    ACTIONS(7680), 1,
      sym__integer_literal,
    ACTIONS(7683), 1,
      sym__hex_literal,
    ACTIONS(7686), 1,
      anon_sym__,
    ACTIONS(7689), 1,
      sym_hole,
    ACTIONS(7692), 1,
      anon_sym_LPAREN,
    ACTIONS(7695), 1,
      sym__conid,
    ACTIONS(7698), 1,
      anon_sym_LBRACE,
    ACTIONS(7701), 1,
      anon_sym_AT,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 5,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1434), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89749] = 20,
    ACTIONS(5789), 1,
      sym__varid,
    ACTIONS(5791), 1,
      sym_string,
    ACTIONS(5793), 1,
      sym_triple_quote_string,
    ACTIONS(5795), 1,
      sym__integer_literal,
    ACTIONS(5797), 1,
      sym__hex_literal,
    ACTIONS(5799), 1,
      anon_sym__,
    ACTIONS(5803), 1,
      anon_sym_LPAREN,
    ACTIONS(5807), 1,
      anon_sym_LBRACE,
    ACTIONS(7290), 1,
      sym_hole,
    ACTIONS(7295), 1,
      anon_sym_AT,
    ACTIONS(7704), 1,
      sym__conid,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1430), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89827] = 20,
    ACTIONS(7708), 1,
      sym__varid,
    ACTIONS(7712), 1,
      sym_string,
    ACTIONS(7716), 1,
      sym_triple_quote_string,
    ACTIONS(7720), 1,
      sym__integer_literal,
    ACTIONS(7724), 1,
      sym__hex_literal,
    ACTIONS(7728), 1,
      anon_sym__,
    ACTIONS(7732), 1,
      sym_hole,
    ACTIONS(7736), 1,
      anon_sym_LPAREN,
    ACTIONS(7740), 1,
      sym__conid,
    ACTIONS(7744), 1,
      anon_sym_LBRACE,
    ACTIONS(7748), 1,
      anon_sym_AT,
    STATE(3809), 1,
      sym_constructor,
    STATE(4288), 1,
      sym_integer,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3277), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1439), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89905] = 20,
    ACTIONS(3498), 1,
      sym_comma,
    ACTIONS(5032), 1,
      sym__varid,
    ACTIONS(5034), 1,
      sym_string,
    ACTIONS(5036), 1,
      sym_triple_quote_string,
    ACTIONS(5038), 1,
      sym__integer_literal,
    ACTIONS(5040), 1,
      sym__hex_literal,
    ACTIONS(5042), 1,
      anon_sym__,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(7396), 1,
      sym_hole,
    ACTIONS(7401), 1,
      anon_sym_AT,
    ACTIONS(7752), 1,
      sym__conid,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1448), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [89983] = 20,
    ACTIONS(7755), 1,
      sym__varid,
    ACTIONS(7758), 1,
      sym_string,
    ACTIONS(7761), 1,
      sym_triple_quote_string,
    ACTIONS(7764), 1,
      sym__integer_literal,
    ACTIONS(7767), 1,
      sym__hex_literal,
    ACTIONS(7770), 1,
      anon_sym__,
    ACTIONS(7773), 1,
      sym_hole,
    ACTIONS(7776), 1,
      anon_sym_LPAREN,
    ACTIONS(7779), 1,
      sym__conid,
    ACTIONS(7782), 1,
      anon_sym_LBRACE,
    ACTIONS(7785), 1,
      anon_sym_AT,
    STATE(3809), 1,
      sym_constructor,
    STATE(4288), 1,
      sym_integer,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3305), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1410), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90061] = 20,
    ACTIONS(3349), 1,
      sym__operator,
    ACTIONS(7788), 1,
      sym__varid,
    ACTIONS(7791), 1,
      sym_string,
    ACTIONS(7794), 1,
      sym_triple_quote_string,
    ACTIONS(7797), 1,
      sym__integer_literal,
    ACTIONS(7800), 1,
      sym__hex_literal,
    ACTIONS(7803), 1,
      anon_sym__,
    ACTIONS(7806), 1,
      sym_hole,
    ACTIONS(7809), 1,
      anon_sym_LPAREN,
    ACTIONS(7812), 1,
      sym__conid,
    ACTIONS(7815), 1,
      anon_sym_LBRACE,
    ACTIONS(7818), 1,
      anon_sym_AT,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1440), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90139] = 20,
    ACTIONS(3463), 1,
      sym__operator,
    ACTIONS(4715), 1,
      sym__varid,
    ACTIONS(4717), 1,
      sym_string,
    ACTIONS(4719), 1,
      sym_triple_quote_string,
    ACTIONS(4721), 1,
      sym__integer_literal,
    ACTIONS(4723), 1,
      sym__hex_literal,
    ACTIONS(4725), 1,
      anon_sym__,
    ACTIONS(4729), 1,
      anon_sym_LPAREN,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(7227), 1,
      sym_hole,
    ACTIONS(7232), 1,
      anon_sym_AT,
    ACTIONS(7821), 1,
      sym__conid,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1416), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90217] = 19,
    ACTIONS(7824), 1,
      sym__varid,
    ACTIONS(7827), 1,
      sym_string,
    ACTIONS(7830), 1,
      sym_triple_quote_string,
    ACTIONS(7833), 1,
      sym__integer_literal,
    ACTIONS(7836), 1,
      sym__hex_literal,
    ACTIONS(7839), 1,
      anon_sym__,
    ACTIONS(7842), 1,
      sym_hole,
    ACTIONS(7845), 1,
      anon_sym_LPAREN,
    ACTIONS(7848), 1,
      sym__conid,
    ACTIONS(7851), 1,
      anon_sym_LBRACE,
    ACTIONS(7854), 1,
      anon_sym_AT,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1442), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90293] = 19,
    ACTIONS(7857), 1,
      sym__varid,
    ACTIONS(7861), 1,
      sym_string,
    ACTIONS(7865), 1,
      sym_triple_quote_string,
    ACTIONS(7869), 1,
      sym__integer_literal,
    ACTIONS(7873), 1,
      sym__hex_literal,
    ACTIONS(7877), 1,
      anon_sym__,
    ACTIONS(7881), 1,
      sym_hole,
    ACTIONS(7885), 1,
      anon_sym_LPAREN,
    ACTIONS(7889), 1,
      sym__conid,
    ACTIONS(7893), 1,
      anon_sym_LBRACE,
    ACTIONS(7897), 1,
      anon_sym_AT,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 5,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1418), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90369] = 20,
    ACTIONS(5789), 1,
      sym__varid,
    ACTIONS(5791), 1,
      sym_string,
    ACTIONS(5793), 1,
      sym_triple_quote_string,
    ACTIONS(5795), 1,
      sym__integer_literal,
    ACTIONS(5797), 1,
      sym__hex_literal,
    ACTIONS(5799), 1,
      anon_sym__,
    ACTIONS(5803), 1,
      anon_sym_LPAREN,
    ACTIONS(5807), 1,
      anon_sym_LBRACE,
    ACTIONS(7290), 1,
      sym_hole,
    ACTIONS(7295), 1,
      anon_sym_AT,
    ACTIONS(7901), 1,
      sym__conid,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1430), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90447] = 20,
    ACTIONS(3500), 1,
      sym__operator,
    ACTIONS(5469), 1,
      sym__varid,
    ACTIONS(5471), 1,
      sym_string,
    ACTIONS(5473), 1,
      sym_triple_quote_string,
    ACTIONS(5475), 1,
      sym__integer_literal,
    ACTIONS(5477), 1,
      sym__hex_literal,
    ACTIONS(5479), 1,
      anon_sym__,
    ACTIONS(5483), 1,
      anon_sym_LPAREN,
    ACTIONS(5487), 1,
      anon_sym_LBRACE,
    ACTIONS(7267), 1,
      sym_hole,
    ACTIONS(7272), 1,
      anon_sym_AT,
    ACTIONS(7904), 1,
      sym__conid,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1425), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90525] = 20,
    ACTIONS(7907), 1,
      sym__varid,
    ACTIONS(7910), 1,
      sym_string,
    ACTIONS(7913), 1,
      sym_triple_quote_string,
    ACTIONS(7916), 1,
      sym__integer_literal,
    ACTIONS(7919), 1,
      sym__hex_literal,
    ACTIONS(7922), 1,
      anon_sym__,
    ACTIONS(7925), 1,
      sym_hole,
    ACTIONS(7928), 1,
      anon_sym_LPAREN,
    ACTIONS(7931), 1,
      sym__conid,
    ACTIONS(7934), 1,
      anon_sym_LBRACE,
    ACTIONS(7937), 1,
      anon_sym_AT,
    STATE(3809), 1,
      sym_constructor,
    STATE(4288), 1,
      sym_integer,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3461), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 3,
      sym__operator,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1439), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90603] = 20,
    ACTIONS(3277), 1,
      sym_comma,
    ACTIONS(5032), 1,
      sym__varid,
    ACTIONS(5034), 1,
      sym_string,
    ACTIONS(5036), 1,
      sym_triple_quote_string,
    ACTIONS(5038), 1,
      sym__integer_literal,
    ACTIONS(5040), 1,
      sym__hex_literal,
    ACTIONS(5042), 1,
      anon_sym__,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(7396), 1,
      sym_hole,
    ACTIONS(7401), 1,
      anon_sym_AT,
    ACTIONS(7940), 1,
      sym__conid,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1448), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90681] = 20,
    ACTIONS(3305), 1,
      sym_comma,
    ACTIONS(5032), 1,
      sym__varid,
    ACTIONS(5034), 1,
      sym_string,
    ACTIONS(5036), 1,
      sym_triple_quote_string,
    ACTIONS(5038), 1,
      sym__integer_literal,
    ACTIONS(5040), 1,
      sym__hex_literal,
    ACTIONS(5042), 1,
      anon_sym__,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(7401), 1,
      anon_sym_AT,
    ACTIONS(7944), 1,
      sym_hole,
    ACTIONS(7946), 1,
      sym__conid,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1422), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90759] = 20,
    ACTIONS(5054), 1,
      sym__varid,
    ACTIONS(5056), 1,
      sym_string,
    ACTIONS(5058), 1,
      sym_triple_quote_string,
    ACTIONS(5060), 1,
      sym__integer_literal,
    ACTIONS(5062), 1,
      sym__hex_literal,
    ACTIONS(5064), 1,
      anon_sym__,
    ACTIONS(5068), 1,
      anon_sym_LPAREN,
    ACTIONS(5072), 1,
      anon_sym_LBRACE,
    ACTIONS(7949), 1,
      sym_hole,
    ACTIONS(7951), 1,
      sym__conid,
    ACTIONS(7954), 1,
      anon_sym_AT,
    STATE(4259), 1,
      sym_constructor,
    STATE(4428), 1,
      sym_integer,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3461), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1472), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90836] = 20,
    ACTIONS(3500), 1,
      sym__operator,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(7956), 1,
      sym_hole,
    ACTIONS(7958), 1,
      sym__conid,
    ACTIONS(7961), 1,
      anon_sym_AT,
    STATE(4291), 1,
      sym_constructor,
    STATE(4473), 1,
      sym_integer,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1496), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90913] = 20,
    ACTIONS(3461), 1,
      anon_sym_RPAREN,
    ACTIONS(4883), 1,
      sym__varid,
    ACTIONS(4885), 1,
      sym_string,
    ACTIONS(4887), 1,
      sym_triple_quote_string,
    ACTIONS(4889), 1,
      sym__integer_literal,
    ACTIONS(4891), 1,
      sym__hex_literal,
    ACTIONS(4893), 1,
      anon_sym__,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4901), 1,
      anon_sym_LBRACE,
    ACTIONS(7963), 1,
      sym_hole,
    ACTIONS(7965), 1,
      sym__conid,
    ACTIONS(7968), 1,
      anon_sym_AT,
    STATE(4236), 1,
      sym_constructor,
    STATE(4381), 1,
      sym_integer,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1463), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [90990] = 20,
    ACTIONS(3317), 1,
      sym__operator,
    ACTIONS(4959), 1,
      sym__varid,
    ACTIONS(4961), 1,
      sym_string,
    ACTIONS(4963), 1,
      sym_triple_quote_string,
    ACTIONS(4965), 1,
      sym__integer_literal,
    ACTIONS(4967), 1,
      sym__hex_literal,
    ACTIONS(4969), 1,
      anon_sym__,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    ACTIONS(4977), 1,
      anon_sym_LBRACE,
    ACTIONS(7970), 1,
      sym_hole,
    ACTIONS(7972), 1,
      sym__conid,
    ACTIONS(7975), 1,
      anon_sym_AT,
    STATE(3780), 1,
      sym_constructor,
    STATE(4447), 1,
      sym_integer,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1465), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [91067] = 20,
    ACTIONS(3317), 1,
      sym__operator,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(7977), 1,
      sym_hole,
    ACTIONS(7979), 1,
      sym__conid,
    ACTIONS(7982), 1,
      anon_sym_AT,
    STATE(4315), 1,
      sym_constructor,
    STATE(4405), 1,
      sym_integer,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1457), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [91144] = 20,
    ACTIONS(3288), 1,
      sym__operator,
    ACTIONS(4959), 1,
      sym__varid,
    ACTIONS(4961), 1,
      sym_string,
    ACTIONS(4963), 1,
      sym_triple_quote_string,
    ACTIONS(4965), 1,
      sym__integer_literal,
    ACTIONS(4967), 1,
      sym__hex_literal,
    ACTIONS(4969), 1,
      anon_sym__,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    ACTIONS(4977), 1,
      anon_sym_LBRACE,
    ACTIONS(7975), 1,
      anon_sym_AT,
    ACTIONS(7984), 1,
      sym_hole,
    ACTIONS(7986), 1,
      sym__conid,
    STATE(3780), 1,
      sym_constructor,
    STATE(4447), 1,
      sym_integer,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1452), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [91221] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1327), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [91302] = 20,
    ACTIONS(3288), 1,
      sym__operator,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_AT,
    ACTIONS(7990), 1,
      sym_hole,
    ACTIONS(7992), 1,
      sym__conid,
    STATE(4315), 1,
      sym_constructor,
    STATE(4405), 1,
      sym_integer,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1453), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [91379] = 20,
    ACTIONS(3349), 1,
      sym__operator,
    ACTIONS(7996), 1,
      sym__varid,
    ACTIONS(7999), 1,
      sym_string,
    ACTIONS(8002), 1,
      sym_triple_quote_string,
    ACTIONS(8005), 1,
      sym__integer_literal,
    ACTIONS(8008), 1,
      sym__hex_literal,
    ACTIONS(8011), 1,
      anon_sym__,
    ACTIONS(8014), 1,
      sym_hole,
    ACTIONS(8017), 1,
      anon_sym_LPAREN,
    ACTIONS(8020), 1,
      sym__conid,
    ACTIONS(8023), 1,
      anon_sym_LBRACE,
    ACTIONS(8026), 1,
      anon_sym_AT,
    STATE(4315), 1,
      sym_constructor,
    STATE(4405), 1,
      sym_integer,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1457), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [91456] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1298), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [91537] = 20,
    ACTIONS(3335), 1,
      anon_sym_RPAREN,
    ACTIONS(8029), 1,
      sym__varid,
    ACTIONS(8032), 1,
      sym_string,
    ACTIONS(8035), 1,
      sym_triple_quote_string,
    ACTIONS(8038), 1,
      sym__integer_literal,
    ACTIONS(8041), 1,
      sym__hex_literal,
    ACTIONS(8044), 1,
      anon_sym__,
    ACTIONS(8047), 1,
      sym_hole,
    ACTIONS(8050), 1,
      anon_sym_LPAREN,
    ACTIONS(8053), 1,
      sym__conid,
    ACTIONS(8056), 1,
      anon_sym_LBRACE,
    ACTIONS(8059), 1,
      anon_sym_AT,
    STATE(4236), 1,
      sym_constructor,
    STATE(4381), 1,
      sym_integer,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1459), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [91614] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1307), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [91695] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1284), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [91776] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1361), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [91857] = 20,
    ACTIONS(3305), 1,
      anon_sym_RPAREN,
    ACTIONS(4883), 1,
      sym__varid,
    ACTIONS(4885), 1,
      sym_string,
    ACTIONS(4887), 1,
      sym_triple_quote_string,
    ACTIONS(4889), 1,
      sym__integer_literal,
    ACTIONS(4891), 1,
      sym__hex_literal,
    ACTIONS(4893), 1,
      anon_sym__,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4901), 1,
      anon_sym_LBRACE,
    ACTIONS(7968), 1,
      anon_sym_AT,
    ACTIONS(8062), 1,
      sym_hole,
    ACTIONS(8064), 1,
      sym__conid,
    STATE(4236), 1,
      sym_constructor,
    STATE(4381), 1,
      sym_integer,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1459), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [91934] = 23,
    ACTIONS(1696), 1,
      anon_sym_RPAREN,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    ACTIONS(8067), 1,
      anon_sym_LPAREN,
    ACTIONS(8069), 1,
      sym__conid,
    STATE(6499), 1,
      sym_constructor,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(6837), 1,
      sym__qcon,
    STATE(6838), 1,
      sym_qualified_constructor,
    STATE(7615), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6831), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [92017] = 20,
    ACTIONS(3349), 1,
      sym__operator,
    ACTIONS(8071), 1,
      sym__varid,
    ACTIONS(8074), 1,
      sym_string,
    ACTIONS(8077), 1,
      sym_triple_quote_string,
    ACTIONS(8080), 1,
      sym__integer_literal,
    ACTIONS(8083), 1,
      sym__hex_literal,
    ACTIONS(8086), 1,
      anon_sym__,
    ACTIONS(8089), 1,
      sym_hole,
    ACTIONS(8092), 1,
      anon_sym_LPAREN,
    ACTIONS(8095), 1,
      sym__conid,
    ACTIONS(8098), 1,
      anon_sym_LBRACE,
    ACTIONS(8101), 1,
      anon_sym_AT,
    STATE(3780), 1,
      sym_constructor,
    STATE(4447), 1,
      sym_integer,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1465), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [92094] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1280), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [92175] = 9,
    ACTIONS(8113), 1,
      sym__immediate_dot,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8118), 1,
      anon_sym_AT2,
    STATE(1780), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8108), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8110), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8106), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 12,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [92230] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1348), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [92311] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1323), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [92392] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1350), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [92473] = 20,
    ACTIONS(3500), 1,
      sym__operator,
    ACTIONS(4959), 1,
      sym__varid,
    ACTIONS(4961), 1,
      sym_string,
    ACTIONS(4963), 1,
      sym_triple_quote_string,
    ACTIONS(4965), 1,
      sym__integer_literal,
    ACTIONS(4967), 1,
      sym__hex_literal,
    ACTIONS(4969), 1,
      anon_sym__,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    ACTIONS(4977), 1,
      anon_sym_LBRACE,
    ACTIONS(7975), 1,
      anon_sym_AT,
    ACTIONS(7984), 1,
      sym_hole,
    ACTIONS(8120), 1,
      sym__conid,
    STATE(3780), 1,
      sym_constructor,
    STATE(4447), 1,
      sym_integer,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1452), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [92550] = 20,
    ACTIONS(5054), 1,
      sym__varid,
    ACTIONS(5056), 1,
      sym_string,
    ACTIONS(5058), 1,
      sym_triple_quote_string,
    ACTIONS(5060), 1,
      sym__integer_literal,
    ACTIONS(5062), 1,
      sym__hex_literal,
    ACTIONS(5064), 1,
      anon_sym__,
    ACTIONS(5068), 1,
      anon_sym_LPAREN,
    ACTIONS(5072), 1,
      anon_sym_LBRACE,
    ACTIONS(7954), 1,
      anon_sym_AT,
    ACTIONS(8123), 1,
      sym_hole,
    ACTIONS(8125), 1,
      sym__conid,
    STATE(4259), 1,
      sym_constructor,
    STATE(4428), 1,
      sym_integer,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3305), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1491), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [92627] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1319), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [92708] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1340), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [92789] = 20,
    ACTIONS(3463), 1,
      sym__operator,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_AT,
    ACTIONS(7990), 1,
      sym_hole,
    ACTIONS(8128), 1,
      sym__conid,
    STATE(4315), 1,
      sym_constructor,
    STATE(4405), 1,
      sym_integer,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1453), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [92866] = 20,
    ACTIONS(5054), 1,
      sym__varid,
    ACTIONS(5056), 1,
      sym_string,
    ACTIONS(5058), 1,
      sym_triple_quote_string,
    ACTIONS(5060), 1,
      sym__integer_literal,
    ACTIONS(5062), 1,
      sym__hex_literal,
    ACTIONS(5064), 1,
      anon_sym__,
    ACTIONS(5068), 1,
      anon_sym_LPAREN,
    ACTIONS(5072), 1,
      anon_sym_LBRACE,
    ACTIONS(7949), 1,
      sym_hole,
    ACTIONS(7954), 1,
      anon_sym_AT,
    ACTIONS(8131), 1,
      sym__conid,
    STATE(4259), 1,
      sym_constructor,
    STATE(4428), 1,
      sym_integer,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3277), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1472), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [92943] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1325), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [93024] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1355), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [93105] = 9,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8118), 1,
      anon_sym_AT2,
    ACTIONS(8135), 1,
      sym__immediate_dot,
    STATE(1761), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8108), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8110), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8106), 9,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 13,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [93160] = 20,
    ACTIONS(3463), 1,
      sym__operator,
    ACTIONS(4959), 1,
      sym__varid,
    ACTIONS(4961), 1,
      sym_string,
    ACTIONS(4963), 1,
      sym_triple_quote_string,
    ACTIONS(4965), 1,
      sym__integer_literal,
    ACTIONS(4967), 1,
      sym__hex_literal,
    ACTIONS(4969), 1,
      anon_sym__,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    ACTIONS(4977), 1,
      anon_sym_LBRACE,
    ACTIONS(7975), 1,
      anon_sym_AT,
    ACTIONS(7984), 1,
      sym_hole,
    ACTIONS(8137), 1,
      sym__conid,
    STATE(3780), 1,
      sym_constructor,
    STATE(4447), 1,
      sym_integer,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1452), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [93237] = 20,
    ACTIONS(3463), 1,
      sym__operator,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(7956), 1,
      sym_hole,
    ACTIONS(7961), 1,
      anon_sym_AT,
    ACTIONS(8140), 1,
      sym__conid,
    STATE(4291), 1,
      sym_constructor,
    STATE(4473), 1,
      sym_integer,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1496), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [93314] = 20,
    ACTIONS(3288), 1,
      sym__operator,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(7956), 1,
      sym_hole,
    ACTIONS(7961), 1,
      anon_sym_AT,
    ACTIONS(8143), 1,
      sym__conid,
    STATE(4291), 1,
      sym_constructor,
    STATE(4473), 1,
      sym_integer,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1496), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [93391] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1313), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [93472] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1316), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [93553] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1292), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [93634] = 20,
    ACTIONS(3277), 1,
      anon_sym_RPAREN,
    ACTIONS(4883), 1,
      sym__varid,
    ACTIONS(4885), 1,
      sym_string,
    ACTIONS(4887), 1,
      sym_triple_quote_string,
    ACTIONS(4889), 1,
      sym__integer_literal,
    ACTIONS(4891), 1,
      sym__hex_literal,
    ACTIONS(4893), 1,
      anon_sym__,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4901), 1,
      anon_sym_LBRACE,
    ACTIONS(7963), 1,
      sym_hole,
    ACTIONS(7968), 1,
      anon_sym_AT,
    ACTIONS(8147), 1,
      sym__conid,
    STATE(4236), 1,
      sym_constructor,
    STATE(4381), 1,
      sym_integer,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1463), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [93711] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1359), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [93792] = 20,
    ACTIONS(3349), 1,
      sym__operator,
    ACTIONS(8151), 1,
      sym__varid,
    ACTIONS(8154), 1,
      sym_string,
    ACTIONS(8157), 1,
      sym_triple_quote_string,
    ACTIONS(8160), 1,
      sym__integer_literal,
    ACTIONS(8163), 1,
      sym__hex_literal,
    ACTIONS(8166), 1,
      anon_sym__,
    ACTIONS(8169), 1,
      sym_hole,
    ACTIONS(8172), 1,
      anon_sym_LPAREN,
    ACTIONS(8175), 1,
      sym__conid,
    ACTIONS(8178), 1,
      anon_sym_LBRACE,
    ACTIONS(8181), 1,
      anon_sym_AT,
    STATE(4291), 1,
      sym_constructor,
    STATE(4473), 1,
      sym_integer,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1488), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [93869] = 20,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
    ACTIONS(4883), 1,
      sym__varid,
    ACTIONS(4885), 1,
      sym_string,
    ACTIONS(4887), 1,
      sym_triple_quote_string,
    ACTIONS(4889), 1,
      sym__integer_literal,
    ACTIONS(4891), 1,
      sym__hex_literal,
    ACTIONS(4893), 1,
      anon_sym__,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4901), 1,
      anon_sym_LBRACE,
    ACTIONS(7963), 1,
      sym_hole,
    ACTIONS(7968), 1,
      anon_sym_AT,
    ACTIONS(8184), 1,
      sym__conid,
    STATE(4236), 1,
      sym_constructor,
    STATE(4381), 1,
      sym_integer,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1463), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [93946] = 20,
    ACTIONS(3500), 1,
      sym__operator,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_AT,
    ACTIONS(7990), 1,
      sym_hole,
    ACTIONS(8187), 1,
      sym__conid,
    STATE(4315), 1,
      sym_constructor,
    STATE(4405), 1,
      sym_integer,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3498), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1453), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [94023] = 20,
    ACTIONS(8190), 1,
      sym__varid,
    ACTIONS(8193), 1,
      sym_string,
    ACTIONS(8196), 1,
      sym_triple_quote_string,
    ACTIONS(8199), 1,
      sym__integer_literal,
    ACTIONS(8202), 1,
      sym__hex_literal,
    ACTIONS(8205), 1,
      anon_sym__,
    ACTIONS(8208), 1,
      sym_hole,
    ACTIONS(8211), 1,
      anon_sym_LPAREN,
    ACTIONS(8214), 1,
      sym__conid,
    ACTIONS(8217), 1,
      anon_sym_LBRACE,
    ACTIONS(8220), 1,
      anon_sym_AT,
    STATE(4259), 1,
      sym_constructor,
    STATE(4428), 1,
      sym_integer,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3335), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1491), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [94100] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 21,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
      anon_sym_hiding,
      anon_sym_as,
  [94143] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1274), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [94224] = 20,
    ACTIONS(5054), 1,
      sym__varid,
    ACTIONS(5056), 1,
      sym_string,
    ACTIONS(5058), 1,
      sym_triple_quote_string,
    ACTIONS(5060), 1,
      sym__integer_literal,
    ACTIONS(5062), 1,
      sym__hex_literal,
    ACTIONS(5064), 1,
      anon_sym__,
    ACTIONS(5068), 1,
      anon_sym_LPAREN,
    ACTIONS(5072), 1,
      anon_sym_LBRACE,
    ACTIONS(7949), 1,
      sym_hole,
    ACTIONS(7954), 1,
      anon_sym_AT,
    ACTIONS(8227), 1,
      sym__conid,
    STATE(4259), 1,
      sym_constructor,
    STATE(4428), 1,
      sym_integer,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3498), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1472), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [94301] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1304), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [94382] = 20,
    ACTIONS(3317), 1,
      sym__operator,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(7961), 1,
      anon_sym_AT,
    ACTIONS(8230), 1,
      sym_hole,
    ACTIONS(8232), 1,
      sym__conid,
    STATE(4291), 1,
      sym_constructor,
    STATE(4473), 1,
      sym_integer,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3305), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1488), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [94459] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(1300), 9,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
      aux_sym_exp_lambda_repeat1,
  [94540] = 22,
    ACTIONS(3635), 1,
      sym__varid,
    ACTIONS(3639), 1,
      sym_string,
    ACTIONS(3641), 1,
      sym__integer_literal,
    ACTIONS(3643), 1,
      sym__hex_literal,
    ACTIONS(3645), 1,
      anon_sym__,
    ACTIONS(3647), 1,
      anon_sym_LPAREN,
    ACTIONS(3652), 1,
      anon_sym_LBRACE,
    ACTIONS(3654), 1,
      anon_sym_LBRACK,
    ACTIONS(4143), 1,
      sym__conid,
    STATE(3303), 1,
      sym_constructor,
    STATE(3358), 1,
      sym_variable,
    STATE(3441), 1,
      sym__qcon,
    STATE(3497), 1,
      sym_qualified_constructor,
    STATE(3562), 1,
      sym_pat_fields,
    STATE(3563), 1,
      sym_literal,
    STATE(3596), 1,
      sym_wildcard,
    STATE(7579), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3637), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3697), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(3542), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [94620] = 22,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    ACTIONS(8067), 1,
      anon_sym_LPAREN,
    ACTIONS(8069), 1,
      sym__conid,
    STATE(6499), 1,
      sym_constructor,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(6837), 1,
      sym__qcon,
    STATE(6838), 1,
      sym_qualified_constructor,
    STATE(7615), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6831), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [94700] = 20,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(3288), 1,
      sym__operator,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(8235), 1,
      sym_hole,
    ACTIONS(8237), 1,
      sym__conid,
    ACTIONS(8241), 1,
      anon_sym_AT,
    STATE(4337), 1,
      sym_constructor,
    STATE(4683), 1,
      sym_integer,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3277), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1503), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [94776] = 19,
    ACTIONS(5296), 1,
      sym__varid,
    ACTIONS(5298), 1,
      sym_string,
    ACTIONS(5300), 1,
      sym_triple_quote_string,
    ACTIONS(5302), 1,
      sym__integer_literal,
    ACTIONS(5304), 1,
      sym__hex_literal,
    ACTIONS(5306), 1,
      anon_sym__,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_LBRACE,
    ACTIONS(8243), 1,
      sym_hole,
    ACTIONS(8245), 1,
      sym__conid,
    ACTIONS(8248), 1,
      anon_sym_AT,
    STATE(4350), 1,
      sym_constructor,
    STATE(4552), 1,
      sym_integer,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1527), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [94850] = 5,
    ACTIONS(8254), 1,
      sym__immediate_dot,
    STATE(1520), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [94896] = 20,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(3317), 1,
      sym__operator,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(8241), 1,
      anon_sym_AT,
    ACTIONS(8256), 1,
      sym_hole,
    ACTIONS(8258), 1,
      sym__conid,
    STATE(4337), 1,
      sym_constructor,
    STATE(4683), 1,
      sym_integer,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3305), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1585), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [94972] = 19,
    ACTIONS(5296), 1,
      sym__varid,
    ACTIONS(5298), 1,
      sym_string,
    ACTIONS(5300), 1,
      sym_triple_quote_string,
    ACTIONS(5302), 1,
      sym__integer_literal,
    ACTIONS(5304), 1,
      sym__hex_literal,
    ACTIONS(5306), 1,
      anon_sym__,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_LBRACE,
    ACTIONS(8248), 1,
      anon_sym_AT,
    ACTIONS(8261), 1,
      sym_hole,
    ACTIONS(8263), 1,
      sym__conid,
    STATE(4350), 1,
      sym_constructor,
    STATE(4552), 1,
      sym_integer,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1501), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [95046] = 22,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(3146), 1,
      sym__varid,
    ACTIONS(3150), 1,
      sym_string,
    ACTIONS(3152), 1,
      sym__integer_literal,
    ACTIONS(3154), 1,
      sym__hex_literal,
    ACTIONS(3158), 1,
      anon_sym__,
    ACTIONS(3160), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      anon_sym_LBRACE,
    ACTIONS(3169), 1,
      anon_sym_LBRACK,
    STATE(3182), 1,
      sym_constructor,
    STATE(3195), 1,
      sym_variable,
    STATE(3370), 1,
      sym_pat_fields,
    STATE(3380), 1,
      sym_literal,
    STATE(3386), 1,
      sym_wildcard,
    STATE(3401), 1,
      sym_qualified_constructor,
    STATE(3402), 1,
      sym__qcon,
    STATE(8004), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3148), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3389), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(3297), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [95126] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8281), 1,
      sym_hole,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8269), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1522), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [95200] = 22,
    ACTIONS(4149), 1,
      sym__varid,
    ACTIONS(4153), 1,
      sym_string,
    ACTIONS(4155), 1,
      sym__integer_literal,
    ACTIONS(4157), 1,
      sym__hex_literal,
    ACTIONS(4159), 1,
      anon_sym__,
    ACTIONS(4167), 1,
      anon_sym_LBRACE,
    ACTIONS(4169), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_LPAREN,
    ACTIONS(8293), 1,
      sym__conid,
    STATE(6397), 1,
      sym_variable,
    STATE(6400), 1,
      sym_constructor,
    STATE(6424), 1,
      sym_qualified_constructor,
    STATE(6428), 1,
      sym_wildcard,
    STATE(6432), 1,
      sym_literal,
    STATE(6639), 1,
      sym_pat_fields,
    STATE(6648), 1,
      sym__qcon,
    STATE(8014), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4151), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6725), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6679), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [95280] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8309), 1,
      sym_hole,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8295), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1579), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [95354] = 5,
    ACTIONS(8254), 1,
      sym__immediate_dot,
    STATE(1520), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [95400] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(8325), 1,
      sym_hole,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8323), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1519), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [95474] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8329), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8327), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1592), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [95548] = 20,
    ACTIONS(3461), 1,
      sym_comma,
    ACTIONS(4905), 1,
      sym__varid,
    ACTIONS(4907), 1,
      sym_string,
    ACTIONS(4909), 1,
      sym_triple_quote_string,
    ACTIONS(4911), 1,
      sym__integer_literal,
    ACTIONS(4913), 1,
      sym__hex_literal,
    ACTIONS(4915), 1,
      anon_sym__,
    ACTIONS(4919), 1,
      anon_sym_LPAREN,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(8331), 1,
      sym_hole,
    ACTIONS(8333), 1,
      sym__conid,
    ACTIONS(8336), 1,
      anon_sym_AT,
    STATE(4348), 1,
      sym_constructor,
    STATE(4550), 1,
      sym_integer,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1554), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [95624] = 22,
    ACTIONS(2954), 1,
      sym__conid,
    ACTIONS(5373), 1,
      sym__varid,
    ACTIONS(5377), 1,
      sym_string,
    ACTIONS(5379), 1,
      sym__integer_literal,
    ACTIONS(5381), 1,
      sym__hex_literal,
    ACTIONS(5383), 1,
      anon_sym__,
    ACTIONS(5385), 1,
      anon_sym_LPAREN,
    ACTIONS(5390), 1,
      anon_sym_LBRACE,
    ACTIONS(5392), 1,
      anon_sym_LBRACK,
    STATE(3846), 1,
      sym_variable,
    STATE(3891), 1,
      sym_constructor,
    STATE(4105), 1,
      sym__qcon,
    STATE(4229), 1,
      sym_qualified_constructor,
    STATE(4250), 1,
      sym_wildcard,
    STATE(4251), 1,
      sym_literal,
    STATE(4252), 1,
      sym_pat_fields,
    STATE(7538), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5375), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4178), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4266), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [95704] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 21,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
      anon_sym_AT2,
  [95746] = 22,
    ACTIONS(3507), 1,
      sym__varid,
    ACTIONS(3511), 1,
      sym_string,
    ACTIONS(3513), 1,
      sym__integer_literal,
    ACTIONS(3515), 1,
      sym__hex_literal,
    ACTIONS(3517), 1,
      anon_sym__,
    ACTIONS(3519), 1,
      anon_sym_LPAREN,
    ACTIONS(3524), 1,
      anon_sym_LBRACE,
    ACTIONS(3526), 1,
      anon_sym_LBRACK,
    ACTIONS(4165), 1,
      sym__conid,
    STATE(3343), 1,
      sym_constructor,
    STATE(3375), 1,
      sym_variable,
    STATE(3462), 1,
      sym__qcon,
    STATE(3536), 1,
      sym_qualified_constructor,
    STATE(3710), 1,
      sym_literal,
    STATE(3711), 1,
      sym_pat_fields,
    STATE(3717), 1,
      sym_wildcard,
    STATE(7792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3509), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3709), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(3661), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [95826] = 22,
    ACTIONS(4127), 1,
      sym__varid,
    ACTIONS(4131), 1,
      sym_string,
    ACTIONS(4133), 1,
      sym__integer_literal,
    ACTIONS(4135), 1,
      sym__hex_literal,
    ACTIONS(4137), 1,
      anon_sym__,
    ACTIONS(4145), 1,
      anon_sym_LBRACE,
    ACTIONS(4147), 1,
      anon_sym_LBRACK,
    ACTIONS(8342), 1,
      anon_sym_LPAREN,
    ACTIONS(8344), 1,
      sym__conid,
    STATE(6222), 1,
      sym_variable,
    STATE(6405), 1,
      sym_constructor,
    STATE(6410), 1,
      sym_literal,
    STATE(6417), 1,
      sym__qcon,
    STATE(6636), 1,
      sym_wildcard,
    STATE(6680), 1,
      sym_qualified_constructor,
    STATE(6710), 1,
      sym_pat_fields,
    STATE(7754), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4129), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6595), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6479), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [95906] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8348), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8346), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1569), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [95980] = 22,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(8350), 1,
      anon_sym_LPAREN,
    ACTIONS(8352), 1,
      sym__conid,
    STATE(6313), 1,
      sym_constructor,
    STATE(6331), 1,
      sym_variable,
    STATE(6451), 1,
      sym__qcon,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6537), 1,
      sym_qualified_constructor,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7624), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6709), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [96060] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8281), 1,
      sym_hole,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8346), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1522), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [96134] = 5,
    ACTIONS(8358), 1,
      sym__immediate_dot,
    STATE(1520), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [96180] = 20,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(3500), 1,
      sym__operator,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(8235), 1,
      sym_hole,
    ACTIONS(8241), 1,
      anon_sym_AT,
    ACTIONS(8361), 1,
      sym__conid,
    STATE(4337), 1,
      sym_constructor,
    STATE(4683), 1,
      sym_integer,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3498), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1503), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [96256] = 19,
    ACTIONS(8364), 1,
      sym__varid,
    ACTIONS(8367), 1,
      sym_string,
    ACTIONS(8370), 1,
      sym_triple_quote_string,
    ACTIONS(8373), 1,
      sym__integer_literal,
    ACTIONS(8376), 1,
      sym__hex_literal,
    ACTIONS(8379), 1,
      anon_sym__,
    ACTIONS(8382), 1,
      sym_hole,
    ACTIONS(8385), 1,
      anon_sym_LPAREN,
    ACTIONS(8388), 1,
      sym__conid,
    ACTIONS(8391), 1,
      anon_sym_LBRACE,
    ACTIONS(8394), 1,
      anon_sym_AT,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1522), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [96330] = 22,
    ACTIONS(3881), 1,
      sym__varid,
    ACTIONS(3885), 1,
      sym_string,
    ACTIONS(3887), 1,
      sym__integer_literal,
    ACTIONS(3889), 1,
      sym__hex_literal,
    ACTIONS(3891), 1,
      anon_sym__,
    ACTIONS(3899), 1,
      anon_sym_LBRACE,
    ACTIONS(3901), 1,
      anon_sym_LBRACK,
    ACTIONS(8397), 1,
      anon_sym_LPAREN,
    ACTIONS(8399), 1,
      sym__conid,
    STATE(6434), 1,
      sym_constructor,
    STATE(6729), 1,
      sym_variable,
    STATE(6733), 1,
      sym_pat_fields,
    STATE(6749), 1,
      sym_literal,
    STATE(6750), 1,
      sym_wildcard,
    STATE(6914), 1,
      sym_qualified_constructor,
    STATE(6924), 1,
      sym__qcon,
    STATE(7689), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3883), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6822), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6743), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [96410] = 19,
    ACTIONS(5394), 1,
      sym__varid,
    ACTIONS(5396), 1,
      sym_string,
    ACTIONS(5398), 1,
      sym_triple_quote_string,
    ACTIONS(5400), 1,
      sym__integer_literal,
    ACTIONS(5402), 1,
      sym__hex_literal,
    ACTIONS(5404), 1,
      anon_sym__,
    ACTIONS(5408), 1,
      anon_sym_LPAREN,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    ACTIONS(8401), 1,
      sym_hole,
    ACTIONS(8403), 1,
      sym__conid,
    ACTIONS(8406), 1,
      anon_sym_AT,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 3,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1525), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [96484] = 19,
    ACTIONS(5394), 1,
      sym__varid,
    ACTIONS(5396), 1,
      sym_string,
    ACTIONS(5398), 1,
      sym_triple_quote_string,
    ACTIONS(5400), 1,
      sym__integer_literal,
    ACTIONS(5402), 1,
      sym__hex_literal,
    ACTIONS(5404), 1,
      anon_sym__,
    ACTIONS(5408), 1,
      anon_sym_LPAREN,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    ACTIONS(8406), 1,
      anon_sym_AT,
    ACTIONS(8408), 1,
      sym_hole,
    ACTIONS(8410), 1,
      sym__conid,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3317), 3,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1555), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [96558] = 6,
    ACTIONS(8417), 1,
      sym__immediate_dot,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    STATE(1542), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [96606] = 19,
    ACTIONS(8422), 1,
      sym__varid,
    ACTIONS(8425), 1,
      sym_string,
    ACTIONS(8428), 1,
      sym_triple_quote_string,
    ACTIONS(8431), 1,
      sym__integer_literal,
    ACTIONS(8434), 1,
      sym__hex_literal,
    ACTIONS(8437), 1,
      anon_sym__,
    ACTIONS(8440), 1,
      sym_hole,
    ACTIONS(8443), 1,
      anon_sym_LPAREN,
    ACTIONS(8446), 1,
      sym__conid,
    ACTIONS(8449), 1,
      anon_sym_LBRACE,
    ACTIONS(8452), 1,
      anon_sym_AT,
    STATE(4350), 1,
      sym_constructor,
    STATE(4552), 1,
      sym_integer,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1527), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [96680] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8417), 1,
      sym__immediate_dot,
    STATE(1546), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [96728] = 22,
    ACTIONS(2922), 1,
      sym__conid,
    ACTIONS(3565), 1,
      sym__varid,
    ACTIONS(3569), 1,
      sym_string,
    ACTIONS(3571), 1,
      sym__integer_literal,
    ACTIONS(3573), 1,
      sym__hex_literal,
    ACTIONS(3575), 1,
      anon_sym__,
    ACTIONS(3577), 1,
      anon_sym_LPAREN,
    ACTIONS(3582), 1,
      anon_sym_LBRACE,
    ACTIONS(3584), 1,
      anon_sym_LBRACK,
    STATE(3313), 1,
      sym_variable,
    STATE(3431), 1,
      sym_constructor,
    STATE(3438), 1,
      sym_qualified_constructor,
    STATE(3620), 1,
      sym__qcon,
    STATE(3630), 1,
      sym_wildcard,
    STATE(3634), 1,
      sym_literal,
    STATE(3635), 1,
      sym_pat_fields,
    STATE(7748), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3567), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3511), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(3652), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [96808] = 19,
    ACTIONS(5394), 1,
      sym__varid,
    ACTIONS(5396), 1,
      sym_string,
    ACTIONS(5398), 1,
      sym_triple_quote_string,
    ACTIONS(5400), 1,
      sym__integer_literal,
    ACTIONS(5402), 1,
      sym__hex_literal,
    ACTIONS(5404), 1,
      anon_sym__,
    ACTIONS(5408), 1,
      anon_sym_LPAREN,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    ACTIONS(8401), 1,
      sym_hole,
    ACTIONS(8406), 1,
      anon_sym_AT,
    ACTIONS(8455), 1,
      sym__conid,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 3,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1525), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [96882] = 20,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(3463), 1,
      sym__operator,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(8235), 1,
      sym_hole,
    ACTIONS(8241), 1,
      anon_sym_AT,
    ACTIONS(8459), 1,
      sym__conid,
    STATE(4337), 1,
      sym_constructor,
    STATE(4683), 1,
      sym_integer,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3461), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1503), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [96958] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8254), 1,
      sym__immediate_dot,
    STATE(1502), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [97006] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(8464), 1,
      sym_hole,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8462), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1506), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [97080] = 22,
    ACTIONS(5), 1,
      sym__varid,
    ACTIONS(21), 1,
      sym__conid,
    ACTIONS(3588), 1,
      sym_string,
    ACTIONS(3590), 1,
      sym__integer_literal,
    ACTIONS(3592), 1,
      sym__hex_literal,
    ACTIONS(3594), 1,
      anon_sym__,
    ACTIONS(3596), 1,
      anon_sym_LPAREN,
    ACTIONS(3601), 1,
      anon_sym_LBRACE,
    ACTIONS(3603), 1,
      anon_sym_LBRACK,
    STATE(3280), 1,
      sym_constructor,
    STATE(3290), 1,
      sym_variable,
    STATE(3572), 1,
      sym__qcon,
    STATE(3612), 1,
      sym_qualified_constructor,
    STATE(3689), 1,
      sym_wildcard,
    STATE(3695), 1,
      sym_pat_fields,
    STATE(3699), 1,
      sym_literal,
    STATE(7874), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3586), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3686), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(3679), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [97160] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8281), 1,
      sym_hole,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8466), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1522), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [97234] = 22,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(8468), 1,
      anon_sym_LPAREN,
    ACTIONS(8470), 1,
      sym__conid,
    STATE(6828), 1,
      sym_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(6962), 1,
      sym_qualified_constructor,
    STATE(7102), 1,
      sym__qcon,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7559), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7431), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [97314] = 22,
    ACTIONS(3402), 1,
      sym__varid,
    ACTIONS(3406), 1,
      sym_string,
    ACTIONS(3408), 1,
      sym__integer_literal,
    ACTIONS(3410), 1,
      sym__hex_literal,
    ACTIONS(3412), 1,
      anon_sym__,
    ACTIONS(3414), 1,
      anon_sym_LPAREN,
    ACTIONS(3419), 1,
      anon_sym_LBRACE,
    ACTIONS(3421), 1,
      anon_sym_LBRACK,
    ACTIONS(4452), 1,
      sym__conid,
    STATE(3283), 1,
      sym_constructor,
    STATE(3340), 1,
      sym_variable,
    STATE(3540), 1,
      sym_literal,
    STATE(3541), 1,
      sym__qcon,
    STATE(3543), 1,
      sym_wildcard,
    STATE(3602), 1,
      sym_pat_fields,
    STATE(3650), 1,
      sym_qualified_constructor,
    STATE(7904), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3404), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3653), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(3712), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [97394] = 6,
    ACTIONS(8254), 1,
      sym__immediate_dot,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    STATE(1571), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [97442] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8281), 1,
      sym_hole,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8472), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1522), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [97516] = 19,
    ACTIONS(5296), 1,
      sym__varid,
    ACTIONS(5298), 1,
      sym_string,
    ACTIONS(5300), 1,
      sym_triple_quote_string,
    ACTIONS(5302), 1,
      sym__integer_literal,
    ACTIONS(5304), 1,
      sym__hex_literal,
    ACTIONS(5306), 1,
      anon_sym__,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_LBRACE,
    ACTIONS(8248), 1,
      anon_sym_AT,
    ACTIONS(8261), 1,
      sym_hole,
    ACTIONS(8474), 1,
      sym__conid,
    STATE(4350), 1,
      sym_constructor,
    STATE(4552), 1,
      sym_integer,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1501), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [97590] = 19,
    ACTIONS(5394), 1,
      sym__varid,
    ACTIONS(5396), 1,
      sym_string,
    ACTIONS(5398), 1,
      sym_triple_quote_string,
    ACTIONS(5400), 1,
      sym__integer_literal,
    ACTIONS(5402), 1,
      sym__hex_literal,
    ACTIONS(5404), 1,
      anon_sym__,
    ACTIONS(5408), 1,
      anon_sym_LPAREN,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    ACTIONS(8401), 1,
      sym_hole,
    ACTIONS(8406), 1,
      anon_sym_AT,
    ACTIONS(8477), 1,
      sym__conid,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3500), 3,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1525), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [97664] = 5,
    ACTIONS(8417), 1,
      sym__immediate_dot,
    STATE(1556), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [97710] = 22,
    ACTIONS(3825), 1,
      sym__varid,
    ACTIONS(3829), 1,
      sym_string,
    ACTIONS(3831), 1,
      sym__integer_literal,
    ACTIONS(3833), 1,
      sym__hex_literal,
    ACTIONS(3835), 1,
      anon_sym__,
    ACTIONS(3837), 1,
      anon_sym_LPAREN,
    ACTIONS(3842), 1,
      anon_sym_LBRACE,
    ACTIONS(3844), 1,
      anon_sym_LBRACK,
    ACTIONS(4296), 1,
      sym__conid,
    STATE(3501), 1,
      sym_constructor,
    STATE(3627), 1,
      sym_variable,
    STATE(3908), 1,
      sym__qcon,
    STATE(3982), 1,
      sym_qualified_constructor,
    STATE(4026), 1,
      sym_wildcard,
    STATE(4027), 1,
      sym_literal,
    STATE(4050), 1,
      sym_pat_fields,
    STATE(7718), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3827), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3796), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4056), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [97790] = 22,
    ACTIONS(4088), 1,
      sym__conid,
    ACTIONS(5192), 1,
      sym__varid,
    ACTIONS(5196), 1,
      sym_string,
    ACTIONS(5198), 1,
      sym__integer_literal,
    ACTIONS(5200), 1,
      sym__hex_literal,
    ACTIONS(5202), 1,
      anon_sym__,
    ACTIONS(5204), 1,
      anon_sym_LPAREN,
    ACTIONS(5209), 1,
      anon_sym_LBRACE,
    ACTIONS(5211), 1,
      anon_sym_LBRACK,
    STATE(3971), 1,
      sym_constructor,
    STATE(4005), 1,
      sym_variable,
    STATE(4117), 1,
      sym_pat_fields,
    STATE(4143), 1,
      sym_literal,
    STATE(4144), 1,
      sym__qcon,
    STATE(4145), 1,
      sym_wildcard,
    STATE(4210), 1,
      sym_qualified_constructor,
    STATE(7964), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5194), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4208), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4113), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [97870] = 5,
    ACTIONS(8417), 1,
      sym__immediate_dot,
    STATE(1556), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [97916] = 5,
    ACTIONS(8417), 1,
      sym__immediate_dot,
    STATE(1556), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [97962] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(8482), 1,
      sym_hole,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8480), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1559), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [98036] = 22,
    ACTIONS(2938), 1,
      sym__varid,
    ACTIONS(2942), 1,
      sym_string,
    ACTIONS(2944), 1,
      sym__integer_literal,
    ACTIONS(2946), 1,
      sym__hex_literal,
    ACTIONS(2948), 1,
      anon_sym__,
    ACTIONS(2956), 1,
      anon_sym_LBRACE,
    ACTIONS(2958), 1,
      anon_sym_LBRACK,
    ACTIONS(8468), 1,
      anon_sym_LPAREN,
    ACTIONS(8470), 1,
      sym__conid,
    STATE(6828), 1,
      sym_constructor,
    STATE(6863), 1,
      sym_variable,
    STATE(6962), 1,
      sym_qualified_constructor,
    STATE(7102), 1,
      sym__qcon,
    STATE(7442), 1,
      sym_wildcard,
    STATE(7443), 1,
      sym_literal,
    STATE(7446), 1,
      sym_pat_fields,
    STATE(7559), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2940), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7015), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7156), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [98116] = 22,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      sym__varid,
    ACTIONS(8484), 1,
      anon_sym_LPAREN,
    ACTIONS(8486), 1,
      sym__conid,
    STATE(6280), 1,
      sym_constructor,
    STATE(6305), 1,
      sym_variable,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6707), 1,
      sym__qcon,
    STATE(6711), 1,
      sym_qualified_constructor,
    STATE(7772), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6586), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [98196] = 22,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(5827), 1,
      sym_string,
    ACTIONS(5829), 1,
      sym__integer_literal,
    ACTIONS(5831), 1,
      sym__hex_literal,
    ACTIONS(5835), 1,
      anon_sym__,
    ACTIONS(5837), 1,
      anon_sym_LPAREN,
    ACTIONS(5839), 1,
      sym__conid,
    ACTIONS(5841), 1,
      anon_sym_LBRACE,
    ACTIONS(5843), 1,
      anon_sym_LBRACK,
    STATE(4340), 1,
      sym_variable,
    STATE(4436), 1,
      sym_constructor,
    STATE(4508), 1,
      sym_literal,
    STATE(4509), 1,
      sym__qcon,
    STATE(4511), 1,
      sym_wildcard,
    STATE(4626), 1,
      sym_pat_fields,
    STATE(4638), 1,
      sym_qualified_constructor,
    STATE(7895), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(5825), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4630), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4650), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [98276] = 20,
    ACTIONS(3335), 1,
      sym_comma,
    ACTIONS(8488), 1,
      sym__varid,
    ACTIONS(8491), 1,
      sym_string,
    ACTIONS(8494), 1,
      sym_triple_quote_string,
    ACTIONS(8497), 1,
      sym__integer_literal,
    ACTIONS(8500), 1,
      sym__hex_literal,
    ACTIONS(8503), 1,
      anon_sym__,
    ACTIONS(8506), 1,
      sym_hole,
    ACTIONS(8509), 1,
      anon_sym_LPAREN,
    ACTIONS(8512), 1,
      sym__conid,
    ACTIONS(8515), 1,
      anon_sym_LBRACE,
    ACTIONS(8518), 1,
      anon_sym_AT,
    STATE(4348), 1,
      sym_constructor,
    STATE(4550), 1,
      sym_integer,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1551), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [98352] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8523), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8521), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1590), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [98426] = 22,
    ACTIONS(4280), 1,
      sym__varid,
    ACTIONS(4284), 1,
      sym_string,
    ACTIONS(4286), 1,
      sym__integer_literal,
    ACTIONS(4288), 1,
      sym__hex_literal,
    ACTIONS(4290), 1,
      anon_sym__,
    ACTIONS(4298), 1,
      anon_sym_LBRACE,
    ACTIONS(4300), 1,
      anon_sym_LBRACK,
    ACTIONS(8525), 1,
      anon_sym_LPAREN,
    ACTIONS(8527), 1,
      sym__conid,
    STATE(6452), 1,
      sym_constructor,
    STATE(6627), 1,
      sym_variable,
    STATE(6764), 1,
      sym__qcon,
    STATE(6791), 1,
      sym_wildcard,
    STATE(6798), 1,
      sym_literal,
    STATE(6894), 1,
      sym_qualified_constructor,
    STATE(6909), 1,
      sym_pat_fields,
    STATE(8022), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4282), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6802), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6898), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [98506] = 20,
    ACTIONS(3305), 1,
      sym_comma,
    ACTIONS(4905), 1,
      sym__varid,
    ACTIONS(4907), 1,
      sym_string,
    ACTIONS(4909), 1,
      sym_triple_quote_string,
    ACTIONS(4911), 1,
      sym__integer_literal,
    ACTIONS(4913), 1,
      sym__hex_literal,
    ACTIONS(4915), 1,
      anon_sym__,
    ACTIONS(4919), 1,
      anon_sym_LPAREN,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(8336), 1,
      anon_sym_AT,
    ACTIONS(8529), 1,
      sym_hole,
    ACTIONS(8531), 1,
      sym__conid,
    STATE(4348), 1,
      sym_constructor,
    STATE(4550), 1,
      sym_integer,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1551), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [98582] = 19,
    ACTIONS(8534), 1,
      sym__varid,
    ACTIONS(8537), 1,
      sym_string,
    ACTIONS(8540), 1,
      sym_triple_quote_string,
    ACTIONS(8543), 1,
      sym__integer_literal,
    ACTIONS(8546), 1,
      sym__hex_literal,
    ACTIONS(8549), 1,
      anon_sym__,
    ACTIONS(8552), 1,
      sym_hole,
    ACTIONS(8555), 1,
      anon_sym_LPAREN,
    ACTIONS(8558), 1,
      sym__conid,
    ACTIONS(8561), 1,
      anon_sym_LBRACE,
    ACTIONS(8564), 1,
      anon_sym_AT,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3349), 3,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1555), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [98656] = 5,
    ACTIONS(8567), 1,
      sym__immediate_dot,
    STATE(1556), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [98702] = 22,
    ACTIONS(4436), 1,
      sym__varid,
    ACTIONS(4440), 1,
      sym_string,
    ACTIONS(4442), 1,
      sym__integer_literal,
    ACTIONS(4444), 1,
      sym__hex_literal,
    ACTIONS(4446), 1,
      anon_sym__,
    ACTIONS(4454), 1,
      anon_sym_LBRACE,
    ACTIONS(4456), 1,
      anon_sym_LBRACK,
    ACTIONS(8570), 1,
      anon_sym_LPAREN,
    ACTIONS(8572), 1,
      sym__conid,
    STATE(6224), 1,
      sym_variable,
    STATE(6270), 1,
      sym_constructor,
    STATE(6567), 1,
      sym_pat_fields,
    STATE(6574), 1,
      sym_wildcard,
    STATE(6576), 1,
      sym__qcon,
    STATE(6577), 1,
      sym_literal,
    STATE(6706), 1,
      sym_qualified_constructor,
    STATE(7697), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4438), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6701), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6554), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [98782] = 22,
    ACTIONS(4149), 1,
      sym__varid,
    ACTIONS(4153), 1,
      sym_string,
    ACTIONS(4155), 1,
      sym__integer_literal,
    ACTIONS(4157), 1,
      sym__hex_literal,
    ACTIONS(4159), 1,
      anon_sym__,
    ACTIONS(4167), 1,
      anon_sym_LBRACE,
    ACTIONS(4169), 1,
      anon_sym_LBRACK,
    ACTIONS(8291), 1,
      anon_sym_LPAREN,
    ACTIONS(8293), 1,
      sym__conid,
    STATE(6397), 1,
      sym_variable,
    STATE(6400), 1,
      sym_constructor,
    STATE(6424), 1,
      sym_qualified_constructor,
    STATE(6428), 1,
      sym_wildcard,
    STATE(6432), 1,
      sym_literal,
    STATE(6639), 1,
      sym_pat_fields,
    STATE(6648), 1,
      sym__qcon,
    STATE(8014), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4151), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6725), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6557), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [98862] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8281), 1,
      sym_hole,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8574), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1522), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [98936] = 22,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(4259), 1,
      sym__varid,
    ACTIONS(4263), 1,
      sym_string,
    ACTIONS(4265), 1,
      sym__integer_literal,
    ACTIONS(4267), 1,
      sym__hex_literal,
    ACTIONS(4269), 1,
      anon_sym__,
    ACTIONS(4271), 1,
      anon_sym_LPAREN,
    ACTIONS(4276), 1,
      anon_sym_LBRACE,
    ACTIONS(4278), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_constructor,
    STATE(3678), 1,
      sym_variable,
    STATE(3792), 1,
      sym_pat_fields,
    STATE(3793), 1,
      sym_literal,
    STATE(3794), 1,
      sym_wildcard,
    STATE(3931), 1,
      sym_qualified_constructor,
    STATE(3932), 1,
      sym__qcon,
    STATE(7642), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4261), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3795), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(3776), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [99016] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(8578), 1,
      sym_hole,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8576), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1567), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [99090] = 22,
    ACTIONS(2864), 1,
      sym__varid,
    ACTIONS(2868), 1,
      sym_string,
    ACTIONS(2870), 1,
      sym__integer_literal,
    ACTIONS(2872), 1,
      sym__hex_literal,
    ACTIONS(2874), 1,
      anon_sym__,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    ACTIONS(8580), 1,
      anon_sym_LPAREN,
    ACTIONS(8582), 1,
      sym__conid,
    STATE(6502), 1,
      sym_variable,
    STATE(6620), 1,
      sym_constructor,
    STATE(6742), 1,
      sym__qcon,
    STATE(6745), 1,
      sym_qualified_constructor,
    STATE(6848), 1,
      sym_wildcard,
    STATE(6858), 1,
      sym_literal,
    STATE(6861), 1,
      sym_pat_fields,
    STATE(7617), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2866), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6846), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6884), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [99170] = 22,
    ACTIONS(4072), 1,
      sym__varid,
    ACTIONS(4076), 1,
      sym_string,
    ACTIONS(4078), 1,
      sym__integer_literal,
    ACTIONS(4080), 1,
      sym__hex_literal,
    ACTIONS(4082), 1,
      anon_sym__,
    ACTIONS(4090), 1,
      anon_sym_LBRACE,
    ACTIONS(4092), 1,
      anon_sym_LBRACK,
    ACTIONS(8584), 1,
      anon_sym_LPAREN,
    ACTIONS(8586), 1,
      sym__conid,
    STATE(6829), 1,
      sym_variable,
    STATE(6887), 1,
      sym_constructor,
    STATE(7074), 1,
      sym_qualified_constructor,
    STATE(7097), 1,
      sym_pat_fields,
    STATE(7320), 1,
      sym_wildcard,
    STATE(7321), 1,
      sym__qcon,
    STATE(7322), 1,
      sym_literal,
    STATE(7976), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4074), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7077), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7507), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [99250] = 22,
    ACTIONS(4233), 1,
      sym__conid,
    ACTIONS(4235), 1,
      sym__varid,
    ACTIONS(4239), 1,
      sym_string,
    ACTIONS(4241), 1,
      sym__integer_literal,
    ACTIONS(4243), 1,
      sym__hex_literal,
    ACTIONS(4245), 1,
      anon_sym__,
    ACTIONS(4247), 1,
      anon_sym_LPAREN,
    ACTIONS(4252), 1,
      anon_sym_LBRACE,
    ACTIONS(4254), 1,
      anon_sym_LBRACK,
    STATE(3500), 1,
      sym_variable,
    STATE(3504), 1,
      sym_constructor,
    STATE(3868), 1,
      sym_wildcard,
    STATE(3869), 1,
      sym_literal,
    STATE(3870), 1,
      sym_pat_fields,
    STATE(4052), 1,
      sym_qualified_constructor,
    STATE(4053), 1,
      sym__qcon,
    STATE(7774), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4237), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(3867), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(3882), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [99330] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8281), 1,
      sym_hole,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8295), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1522), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [99404] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8281), 1,
      sym_hole,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8480), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1522), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [99478] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8281), 1,
      sym_hole,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8588), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1522), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [99552] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(8590), 1,
      sym_hole,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8295), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1535), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [99626] = 19,
    ACTIONS(8592), 1,
      sym__varid,
    ACTIONS(8595), 1,
      sym_string,
    ACTIONS(8598), 1,
      sym_triple_quote_string,
    ACTIONS(8601), 1,
      sym__integer_literal,
    ACTIONS(8604), 1,
      sym__hex_literal,
    ACTIONS(8607), 1,
      anon_sym__,
    ACTIONS(8610), 1,
      sym_hole,
    ACTIONS(8613), 1,
      anon_sym_LPAREN,
    ACTIONS(8616), 1,
      sym__conid,
    ACTIONS(8619), 1,
      anon_sym_LBRACE,
    ACTIONS(8622), 1,
      anon_sym_AT,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3335), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1569), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [99700] = 22,
    ACTIONS(2906), 1,
      sym__varid,
    ACTIONS(2910), 1,
      sym_string,
    ACTIONS(2912), 1,
      sym__integer_literal,
    ACTIONS(2914), 1,
      sym__hex_literal,
    ACTIONS(2916), 1,
      anon_sym__,
    ACTIONS(2924), 1,
      anon_sym_LBRACE,
    ACTIONS(2926), 1,
      anon_sym_LBRACK,
    ACTIONS(8350), 1,
      anon_sym_LPAREN,
    ACTIONS(8352), 1,
      sym__conid,
    STATE(6313), 1,
      sym_constructor,
    STATE(6331), 1,
      sym_variable,
    STATE(6451), 1,
      sym__qcon,
    STATE(6471), 1,
      sym_wildcard,
    STATE(6472), 1,
      sym_literal,
    STATE(6537), 1,
      sym_qualified_constructor,
    STATE(6580), 1,
      sym_pat_fields,
    STATE(7624), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2908), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6579), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6619), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [99780] = 5,
    ACTIONS(8254), 1,
      sym__immediate_dot,
    STATE(1520), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [99826] = 22,
    ACTIONS(4127), 1,
      sym__varid,
    ACTIONS(4131), 1,
      sym_string,
    ACTIONS(4133), 1,
      sym__integer_literal,
    ACTIONS(4135), 1,
      sym__hex_literal,
    ACTIONS(4137), 1,
      anon_sym__,
    ACTIONS(4145), 1,
      anon_sym_LBRACE,
    ACTIONS(4147), 1,
      anon_sym_LBRACK,
    ACTIONS(8342), 1,
      anon_sym_LPAREN,
    ACTIONS(8344), 1,
      sym__conid,
    STATE(6222), 1,
      sym_variable,
    STATE(6405), 1,
      sym_constructor,
    STATE(6410), 1,
      sym_literal,
    STATE(6417), 1,
      sym__qcon,
    STATE(6636), 1,
      sym_wildcard,
    STATE(6680), 1,
      sym_qualified_constructor,
    STATE(6710), 1,
      sym_pat_fields,
    STATE(7754), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4129), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6595), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6640), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [99906] = 22,
    ACTIONS(4280), 1,
      sym__varid,
    ACTIONS(4284), 1,
      sym_string,
    ACTIONS(4286), 1,
      sym__integer_literal,
    ACTIONS(4288), 1,
      sym__hex_literal,
    ACTIONS(4290), 1,
      anon_sym__,
    ACTIONS(4298), 1,
      anon_sym_LBRACE,
    ACTIONS(4300), 1,
      anon_sym_LBRACK,
    ACTIONS(8525), 1,
      anon_sym_LPAREN,
    ACTIONS(8527), 1,
      sym__conid,
    STATE(6452), 1,
      sym_constructor,
    STATE(6627), 1,
      sym_variable,
    STATE(6764), 1,
      sym__qcon,
    STATE(6791), 1,
      sym_wildcard,
    STATE(6798), 1,
      sym_literal,
    STATE(6894), 1,
      sym_qualified_constructor,
    STATE(6909), 1,
      sym_pat_fields,
    STATE(8022), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4282), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6802), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6862), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [99986] = 22,
    ACTIONS(3897), 1,
      sym__conid,
    ACTIONS(4505), 1,
      sym__varid,
    ACTIONS(4509), 1,
      sym_string,
    ACTIONS(4511), 1,
      sym__integer_literal,
    ACTIONS(4513), 1,
      sym__hex_literal,
    ACTIONS(4515), 1,
      anon_sym__,
    ACTIONS(4517), 1,
      anon_sym_LPAREN,
    ACTIONS(4522), 1,
      anon_sym_LBRACE,
    ACTIONS(4524), 1,
      anon_sym_LBRACK,
    STATE(3490), 1,
      sym_constructor,
    STATE(3713), 1,
      sym_variable,
    STATE(3730), 1,
      sym_literal,
    STATE(3731), 1,
      sym_pat_fields,
    STATE(3760), 1,
      sym_wildcard,
    STATE(3969), 1,
      sym__qcon,
    STATE(3978), 1,
      sym_qualified_constructor,
    STATE(7639), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4507), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4031), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(3748), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [100066] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(8625), 1,
      sym_hole,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8521), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1539), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [100140] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8627), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8462), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1594), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [100214] = 22,
    ACTIONS(4436), 1,
      sym__varid,
    ACTIONS(4440), 1,
      sym_string,
    ACTIONS(4442), 1,
      sym__integer_literal,
    ACTIONS(4444), 1,
      sym__hex_literal,
    ACTIONS(4446), 1,
      anon_sym__,
    ACTIONS(4454), 1,
      anon_sym_LBRACE,
    ACTIONS(4456), 1,
      anon_sym_LBRACK,
    ACTIONS(8570), 1,
      anon_sym_LPAREN,
    ACTIONS(8572), 1,
      sym__conid,
    STATE(6224), 1,
      sym_variable,
    STATE(6270), 1,
      sym_constructor,
    STATE(6567), 1,
      sym_pat_fields,
    STATE(6574), 1,
      sym_wildcard,
    STATE(6576), 1,
      sym__qcon,
    STATE(6577), 1,
      sym_literal,
    STATE(6706), 1,
      sym_qualified_constructor,
    STATE(7697), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4438), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6701), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6626), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [100294] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8629), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8480), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1584), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [100368] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8348), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8466), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1569), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [100442] = 22,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(8631), 1,
      anon_sym_LPAREN,
    ACTIONS(8633), 1,
      sym__conid,
    STATE(6159), 1,
      sym_variable,
    STATE(6161), 1,
      sym_constructor,
    STATE(6232), 1,
      sym_qualified_constructor,
    STATE(6233), 1,
      sym__qcon,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(7547), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6350), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [100522] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(8635), 1,
      sym_hole,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8574), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1565), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [100596] = 22,
    ACTIONS(2864), 1,
      sym__varid,
    ACTIONS(2868), 1,
      sym_string,
    ACTIONS(2870), 1,
      sym__integer_literal,
    ACTIONS(2872), 1,
      sym__hex_literal,
    ACTIONS(2874), 1,
      anon_sym__,
    ACTIONS(2882), 1,
      anon_sym_LBRACE,
    ACTIONS(2884), 1,
      anon_sym_LBRACK,
    ACTIONS(8580), 1,
      anon_sym_LPAREN,
    ACTIONS(8582), 1,
      sym__conid,
    STATE(6502), 1,
      sym_variable,
    STATE(6620), 1,
      sym_constructor,
    STATE(6742), 1,
      sym__qcon,
    STATE(6745), 1,
      sym_qualified_constructor,
    STATE(6848), 1,
      sym_wildcard,
    STATE(6858), 1,
      sym_literal,
    STATE(6861), 1,
      sym_pat_fields,
    STATE(7617), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2866), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6846), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6921), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [100676] = 19,
    ACTIONS(5296), 1,
      sym__varid,
    ACTIONS(5298), 1,
      sym_string,
    ACTIONS(5300), 1,
      sym_triple_quote_string,
    ACTIONS(5302), 1,
      sym__integer_literal,
    ACTIONS(5304), 1,
      sym__hex_literal,
    ACTIONS(5306), 1,
      anon_sym__,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_LBRACE,
    ACTIONS(8248), 1,
      anon_sym_AT,
    ACTIONS(8261), 1,
      sym_hole,
    ACTIONS(8637), 1,
      sym__conid,
    STATE(4350), 1,
      sym_constructor,
    STATE(4552), 1,
      sym_integer,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1501), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [100750] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8348), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8574), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1569), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [100824] = 20,
    ACTIONS(3349), 1,
      sym__operator,
    ACTIONS(8640), 1,
      sym__varid,
    ACTIONS(8643), 1,
      sym_string,
    ACTIONS(8646), 1,
      sym_triple_quote_string,
    ACTIONS(8649), 1,
      sym__integer_literal,
    ACTIONS(8652), 1,
      sym__hex_literal,
    ACTIONS(8655), 1,
      anon_sym__,
    ACTIONS(8658), 1,
      sym_hole,
    ACTIONS(8661), 1,
      anon_sym_LPAREN,
    ACTIONS(8664), 1,
      sym__conid,
    ACTIONS(8667), 1,
      anon_sym_LBRACE,
    ACTIONS(8670), 1,
      anon_sym_AT,
    STATE(4337), 1,
      sym_constructor,
    STATE(4683), 1,
      sym_integer,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3335), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1585), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [100900] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8673), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8576), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1601), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [100974] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8675), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8574), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1600), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [101048] = 5,
    ACTIONS(8677), 1,
      sym__immediate_dot,
    STATE(1588), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [101094] = 22,
    ACTIONS(3881), 1,
      sym__varid,
    ACTIONS(3885), 1,
      sym_string,
    ACTIONS(3887), 1,
      sym__integer_literal,
    ACTIONS(3889), 1,
      sym__hex_literal,
    ACTIONS(3891), 1,
      anon_sym__,
    ACTIONS(3899), 1,
      anon_sym_LBRACE,
    ACTIONS(3901), 1,
      anon_sym_LBRACK,
    ACTIONS(8397), 1,
      anon_sym_LPAREN,
    ACTIONS(8399), 1,
      sym__conid,
    STATE(6434), 1,
      sym_constructor,
    STATE(6729), 1,
      sym_variable,
    STATE(6733), 1,
      sym_pat_fields,
    STATE(6749), 1,
      sym_literal,
    STATE(6750), 1,
      sym_wildcard,
    STATE(6914), 1,
      sym_qualified_constructor,
    STATE(6924), 1,
      sym__qcon,
    STATE(7689), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3883), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6822), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6906), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [101174] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8348), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8472), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1569), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [101248] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8680), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8323), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1517), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [101322] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8348), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8480), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1569), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [101396] = 22,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(6943), 1,
      sym_string,
    ACTIONS(6945), 1,
      sym__integer_literal,
    ACTIONS(6947), 1,
      sym__hex_literal,
    ACTIONS(6949), 1,
      anon_sym__,
    ACTIONS(6951), 1,
      anon_sym_LPAREN,
    ACTIONS(6953), 1,
      sym__conid,
    ACTIONS(6957), 1,
      anon_sym_LBRACE,
    ACTIONS(6959), 1,
      anon_sym_LBRACK,
    STATE(4441), 1,
      sym_constructor,
    STATE(4475), 1,
      sym_variable,
    STATE(4522), 1,
      sym_pat_fields,
    STATE(4534), 1,
      sym_literal,
    STATE(4535), 1,
      sym__qcon,
    STATE(4537), 1,
      sym_qualified_constructor,
    STATE(4538), 1,
      sym_wildcard,
    STATE(7688), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(6941), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(4541), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(4681), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [101476] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8348), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8269), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1569), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [101550] = 5,
    ACTIONS(8682), 1,
      sym__immediate_dot,
    STATE(1588), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [101596] = 5,
    ACTIONS(8682), 1,
      sym__immediate_dot,
    STATE(1588), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [101642] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 22,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
      anon_sym_AT2,
  [101684] = 5,
    ACTIONS(8682), 1,
      sym__immediate_dot,
    STATE(1588), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [101730] = 22,
    ACTIONS(2808), 1,
      sym__varid,
    ACTIONS(2812), 1,
      sym_string,
    ACTIONS(2814), 1,
      sym__integer_literal,
    ACTIONS(2816), 1,
      sym__hex_literal,
    ACTIONS(2818), 1,
      anon_sym__,
    ACTIONS(2826), 1,
      anon_sym_LBRACE,
    ACTIONS(2828), 1,
      anon_sym_LBRACK,
    ACTIONS(8631), 1,
      anon_sym_LPAREN,
    ACTIONS(8633), 1,
      sym__conid,
    STATE(6159), 1,
      sym_variable,
    STATE(6161), 1,
      sym_constructor,
    STATE(6232), 1,
      sym_qualified_constructor,
    STATE(6233), 1,
      sym__qcon,
    STATE(6241), 1,
      sym_pat_fields,
    STATE(6245), 1,
      sym_literal,
    STATE(6247), 1,
      sym_wildcard,
    STATE(7547), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2810), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6249), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6236), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [101810] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8348), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8295), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1569), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [101884] = 19,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8299), 1,
      sym_string,
    ACTIONS(8301), 1,
      sym_triple_quote_string,
    ACTIONS(8303), 1,
      sym__integer_literal,
    ACTIONS(8305), 1,
      sym__hex_literal,
    ACTIONS(8307), 1,
      anon_sym__,
    ACTIONS(8311), 1,
      anon_sym_LPAREN,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8315), 1,
      anon_sym_LBRACE,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(8348), 1,
      sym_hole,
    STATE(4336), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8588), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1569), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [101958] = 20,
    ACTIONS(3498), 1,
      sym_comma,
    ACTIONS(4905), 1,
      sym__varid,
    ACTIONS(4907), 1,
      sym_string,
    ACTIONS(4909), 1,
      sym_triple_quote_string,
    ACTIONS(4911), 1,
      sym__integer_literal,
    ACTIONS(4913), 1,
      sym__hex_literal,
    ACTIONS(4915), 1,
      anon_sym__,
    ACTIONS(4919), 1,
      anon_sym_LPAREN,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(8331), 1,
      sym_hole,
    ACTIONS(8336), 1,
      anon_sym_AT,
    ACTIONS(8684), 1,
      sym__conid,
    STATE(4348), 1,
      sym_constructor,
    STATE(4550), 1,
      sym_integer,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1554), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [102034] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8682), 1,
      sym__immediate_dot,
    STATE(1595), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [102082] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8682), 1,
      sym__immediate_dot,
    STATE(1598), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [102130] = 20,
    ACTIONS(3277), 1,
      sym_comma,
    ACTIONS(4905), 1,
      sym__varid,
    ACTIONS(4907), 1,
      sym_string,
    ACTIONS(4909), 1,
      sym_triple_quote_string,
    ACTIONS(4911), 1,
      sym__integer_literal,
    ACTIONS(4913), 1,
      sym__hex_literal,
    ACTIONS(4915), 1,
      anon_sym__,
    ACTIONS(4919), 1,
      anon_sym_LPAREN,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(8331), 1,
      sym_hole,
    ACTIONS(8336), 1,
      anon_sym_AT,
    ACTIONS(8687), 1,
      sym__conid,
    STATE(4348), 1,
      sym_constructor,
    STATE(4550), 1,
      sym_integer,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1554), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [102206] = 19,
    ACTIONS(8267), 1,
      sym__varid,
    ACTIONS(8271), 1,
      sym_string,
    ACTIONS(8273), 1,
      sym_triple_quote_string,
    ACTIONS(8275), 1,
      sym__integer_literal,
    ACTIONS(8277), 1,
      sym__hex_literal,
    ACTIONS(8279), 1,
      anon_sym__,
    ACTIONS(8283), 1,
      anon_sym_LPAREN,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8287), 1,
      anon_sym_LBRACE,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(8691), 1,
      sym_hole,
    STATE(4360), 1,
      sym_constructor,
    STATE(4610), 1,
      sym_integer,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8327), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1566), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [102280] = 22,
    ACTIONS(4072), 1,
      sym__varid,
    ACTIONS(4076), 1,
      sym_string,
    ACTIONS(4078), 1,
      sym__integer_literal,
    ACTIONS(4080), 1,
      sym__hex_literal,
    ACTIONS(4082), 1,
      anon_sym__,
    ACTIONS(4090), 1,
      anon_sym_LBRACE,
    ACTIONS(4092), 1,
      anon_sym_LBRACK,
    ACTIONS(8584), 1,
      anon_sym_LPAREN,
    ACTIONS(8586), 1,
      sym__conid,
    STATE(6829), 1,
      sym_variable,
    STATE(6887), 1,
      sym_constructor,
    STATE(7074), 1,
      sym_qualified_constructor,
    STATE(7097), 1,
      sym_pat_fields,
    STATE(7320), 1,
      sym_wildcard,
    STATE(7321), 1,
      sym__qcon,
    STATE(7322), 1,
      sym_literal,
    STATE(7976), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(4074), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(7077), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(7063), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [102360] = 22,
    ACTIONS(9), 1,
      sym_string,
    ACTIONS(11), 1,
      sym__integer_literal,
    ACTIONS(13), 1,
      sym__hex_literal,
    ACTIONS(15), 1,
      anon_sym__,
    ACTIONS(23), 1,
      anon_sym_LBRACE,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      sym__varid,
    ACTIONS(8484), 1,
      anon_sym_LPAREN,
    ACTIONS(8486), 1,
      sym__conid,
    STATE(6280), 1,
      sym_constructor,
    STATE(6305), 1,
      sym_variable,
    STATE(6509), 1,
      sym_wildcard,
    STATE(6515), 1,
      sym_literal,
    STATE(6646), 1,
      sym_pat_fields,
    STATE(6707), 1,
      sym__qcon,
    STATE(6711), 1,
      sym_qualified_constructor,
    STATE(7772), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(7), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6504), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6659), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [102440] = 22,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2066), 1,
      sym_string,
    ACTIONS(2068), 1,
      sym__integer_literal,
    ACTIONS(2070), 1,
      sym__hex_literal,
    ACTIONS(2072), 1,
      anon_sym__,
    ACTIONS(2080), 1,
      anon_sym_LBRACE,
    ACTIONS(2082), 1,
      anon_sym_LBRACK,
    ACTIONS(8067), 1,
      anon_sym_LPAREN,
    ACTIONS(8069), 1,
      sym__conid,
    STATE(6499), 1,
      sym_constructor,
    STATE(6587), 1,
      sym_variable,
    STATE(6771), 1,
      sym_literal,
    STATE(6789), 1,
      sym_pat_fields,
    STATE(6799), 1,
      sym_wildcard,
    STATE(6837), 1,
      sym__qcon,
    STATE(6838), 1,
      sym_qualified_constructor,
    STATE(7615), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2064), 3,
      sym_number,
      sym_char,
      sym_triple_quote_string,
    STATE(6788), 3,
      sym_integer,
      sym__numeric,
      sym__literal,
    STATE(6857), 8,
      sym_pat_name,
      sym_pat_as,
      sym__pat_constructor,
      sym_pat_record,
      sym_pat_wildcard,
      sym_pat_parens,
      sym_pat_array,
      sym__apat,
  [102520] = 19,
    ACTIONS(8693), 1,
      sym__varid,
    ACTIONS(8696), 1,
      sym_string,
    ACTIONS(8699), 1,
      sym_triple_quote_string,
    ACTIONS(8702), 1,
      sym__integer_literal,
    ACTIONS(8705), 1,
      sym__hex_literal,
    ACTIONS(8708), 1,
      anon_sym__,
    ACTIONS(8711), 1,
      sym_hole,
    ACTIONS(8714), 1,
      anon_sym_LPAREN,
    ACTIONS(8717), 1,
      sym__conid,
    ACTIONS(8720), 1,
      anon_sym_LBRACE,
    ACTIONS(8723), 1,
      anon_sym_AT,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_class,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1610), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [102593] = 19,
    ACTIONS(8726), 1,
      sym__varid,
    ACTIONS(8729), 1,
      sym_string,
    ACTIONS(8732), 1,
      sym_triple_quote_string,
    ACTIONS(8735), 1,
      sym__integer_literal,
    ACTIONS(8738), 1,
      sym__hex_literal,
    ACTIONS(8741), 1,
      anon_sym__,
    ACTIONS(8744), 1,
      sym_hole,
    ACTIONS(8747), 1,
      anon_sym_LPAREN,
    ACTIONS(8750), 1,
      sym__conid,
    ACTIONS(8753), 1,
      anon_sym_LBRACE,
    ACTIONS(8756), 1,
      anon_sym_AT,
    STATE(4656), 1,
      sym_constructor,
    STATE(4770), 1,
      sym_integer,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1611), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [102666] = 5,
    ACTIONS(8759), 1,
      sym__immediate_dot,
    STATE(1612), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [102711] = 19,
    ACTIONS(5491), 1,
      sym__varid,
    ACTIONS(5493), 1,
      sym_string,
    ACTIONS(5495), 1,
      sym_triple_quote_string,
    ACTIONS(5497), 1,
      sym__integer_literal,
    ACTIONS(5499), 1,
      sym__hex_literal,
    ACTIONS(5501), 1,
      anon_sym__,
    ACTIONS(5505), 1,
      anon_sym_LPAREN,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(8762), 1,
      sym_hole,
    ACTIONS(8764), 1,
      sym__conid,
    ACTIONS(8767), 1,
      anon_sym_AT,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_class,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1623), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [102784] = 5,
    ACTIONS(8769), 1,
      sym__immediate_dot,
    STATE(1612), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [102829] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [102870] = 5,
    ACTIONS(8769), 1,
      sym__immediate_dot,
    STATE(1612), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [102915] = 4,
    ACTIONS(8779), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [102958] = 5,
    ACTIONS(8769), 1,
      sym__immediate_dot,
    STATE(1612), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103003] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103044] = 19,
    ACTIONS(5491), 1,
      sym__varid,
    ACTIONS(5493), 1,
      sym_string,
    ACTIONS(5495), 1,
      sym_triple_quote_string,
    ACTIONS(5497), 1,
      sym__integer_literal,
    ACTIONS(5499), 1,
      sym__hex_literal,
    ACTIONS(5501), 1,
      anon_sym__,
    ACTIONS(5505), 1,
      anon_sym_LPAREN,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(8762), 1,
      sym_hole,
    ACTIONS(8767), 1,
      anon_sym_AT,
    ACTIONS(8785), 1,
      sym__conid,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_class,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1623), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [103117] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103158] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103199] = 19,
    ACTIONS(5491), 1,
      sym__varid,
    ACTIONS(5493), 1,
      sym_string,
    ACTIONS(5495), 1,
      sym_triple_quote_string,
    ACTIONS(5497), 1,
      sym__integer_literal,
    ACTIONS(5499), 1,
      sym__hex_literal,
    ACTIONS(5501), 1,
      anon_sym__,
    ACTIONS(5505), 1,
      anon_sym_LPAREN,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(8767), 1,
      anon_sym_AT,
    ACTIONS(8797), 1,
      sym_hole,
    ACTIONS(8799), 1,
      sym__conid,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_class,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1610), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [103272] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103313] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8769), 1,
      sym__immediate_dot,
    STATE(1614), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103360] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8769), 1,
      sym__immediate_dot,
    STATE(1618), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103407] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103448] = 19,
    ACTIONS(4820), 1,
      sym__varid,
    ACTIONS(4822), 1,
      sym_string,
    ACTIONS(4824), 1,
      sym_triple_quote_string,
    ACTIONS(4826), 1,
      sym__integer_literal,
    ACTIONS(4828), 1,
      sym__hex_literal,
    ACTIONS(4830), 1,
      anon_sym__,
    ACTIONS(4834), 1,
      anon_sym_LPAREN,
    ACTIONS(4838), 1,
      anon_sym_LBRACE,
    ACTIONS(8806), 1,
      sym_hole,
    ACTIONS(8808), 1,
      sym__conid,
    ACTIONS(8811), 1,
      anon_sym_AT,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1643), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [103521] = 19,
    ACTIONS(8813), 1,
      sym__varid,
    ACTIONS(8816), 1,
      sym_string,
    ACTIONS(8819), 1,
      sym_triple_quote_string,
    ACTIONS(8822), 1,
      sym__integer_literal,
    ACTIONS(8825), 1,
      sym__hex_literal,
    ACTIONS(8828), 1,
      anon_sym__,
    ACTIONS(8831), 1,
      sym_hole,
    ACTIONS(8834), 1,
      anon_sym_LPAREN,
    ACTIONS(8837), 1,
      sym__conid,
    ACTIONS(8840), 1,
      anon_sym_LBRACE,
    ACTIONS(8843), 1,
      anon_sym_AT,
    STATE(4583), 1,
      sym_constructor,
    STATE(4912), 1,
      sym_integer,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1629), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [103594] = 19,
    ACTIONS(5240), 1,
      sym__varid,
    ACTIONS(5242), 1,
      sym_string,
    ACTIONS(5244), 1,
      sym_triple_quote_string,
    ACTIONS(5246), 1,
      sym__integer_literal,
    ACTIONS(5248), 1,
      sym__hex_literal,
    ACTIONS(5250), 1,
      anon_sym__,
    ACTIONS(5254), 1,
      anon_sym_LPAREN,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(8846), 1,
      sym_hole,
    ACTIONS(8848), 1,
      sym__conid,
    ACTIONS(8851), 1,
      anon_sym_AT,
    STATE(4583), 1,
      sym_constructor,
    STATE(4912), 1,
      sym_integer,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1667), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [103667] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103710] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103751] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103794] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103835] = 19,
    ACTIONS(4820), 1,
      sym__varid,
    ACTIONS(4822), 1,
      sym_string,
    ACTIONS(4824), 1,
      sym_triple_quote_string,
    ACTIONS(4826), 1,
      sym__integer_literal,
    ACTIONS(4828), 1,
      sym__hex_literal,
    ACTIONS(4830), 1,
      anon_sym__,
    ACTIONS(4834), 1,
      anon_sym_LPAREN,
    ACTIONS(4838), 1,
      anon_sym_LBRACE,
    ACTIONS(8806), 1,
      sym_hole,
    ACTIONS(8811), 1,
      anon_sym_AT,
    ACTIONS(8863), 1,
      sym__conid,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1643), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [103908] = 4,
    ACTIONS(8866), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103951] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [103992] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104033] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104074] = 9,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    ACTIONS(8877), 1,
      anon_sym_AT2,
    STATE(1722), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8874), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8110), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8106), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 12,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104127] = 19,
    ACTIONS(4820), 1,
      sym__varid,
    ACTIONS(4822), 1,
      sym_string,
    ACTIONS(4824), 1,
      sym_triple_quote_string,
    ACTIONS(4826), 1,
      sym__integer_literal,
    ACTIONS(4828), 1,
      sym__hex_literal,
    ACTIONS(4830), 1,
      anon_sym__,
    ACTIONS(4834), 1,
      anon_sym_LPAREN,
    ACTIONS(4838), 1,
      anon_sym_LBRACE,
    ACTIONS(8806), 1,
      sym_hole,
    ACTIONS(8811), 1,
      anon_sym_AT,
    ACTIONS(8879), 1,
      sym__conid,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1643), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [104200] = 4,
    ACTIONS(8887), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104243] = 19,
    ACTIONS(4820), 1,
      sym__varid,
    ACTIONS(4822), 1,
      sym_string,
    ACTIONS(4824), 1,
      sym_triple_quote_string,
    ACTIONS(4826), 1,
      sym__integer_literal,
    ACTIONS(4828), 1,
      sym__hex_literal,
    ACTIONS(4830), 1,
      anon_sym__,
    ACTIONS(4834), 1,
      anon_sym_LPAREN,
    ACTIONS(4838), 1,
      anon_sym_LBRACE,
    ACTIONS(8811), 1,
      anon_sym_AT,
    ACTIONS(8889), 1,
      sym_hole,
    ACTIONS(8891), 1,
      sym__conid,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1703), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [104316] = 4,
    ACTIONS(8894), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104359] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104400] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104443] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104486] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104529] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104570] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104611] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104652] = 19,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5078), 1,
      sym_string,
    ACTIONS(5080), 1,
      sym_triple_quote_string,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5084), 1,
      sym__hex_literal,
    ACTIONS(5086), 1,
      anon_sym__,
    ACTIONS(5090), 1,
      anon_sym_LPAREN,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(8904), 1,
      sym_hole,
    ACTIONS(8906), 1,
      sym__conid,
    ACTIONS(8909), 1,
      anon_sym_AT,
    STATE(4656), 1,
      sym_constructor,
    STATE(4770), 1,
      sym_integer,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1661), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [104725] = 4,
    ACTIONS(8915), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104768] = 4,
    ACTIONS(8917), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104811] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104854] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104895] = 4,
    ACTIONS(8927), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104938] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [104979] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105022] = 19,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5078), 1,
      sym_string,
    ACTIONS(5080), 1,
      sym_triple_quote_string,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5084), 1,
      sym__hex_literal,
    ACTIONS(5086), 1,
      anon_sym__,
    ACTIONS(5090), 1,
      anon_sym_LPAREN,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(8904), 1,
      sym_hole,
    ACTIONS(8909), 1,
      anon_sym_AT,
    ACTIONS(8933), 1,
      sym__conid,
    STATE(4656), 1,
      sym_constructor,
    STATE(4770), 1,
      sym_integer,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1661), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [105095] = 19,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5078), 1,
      sym_string,
    ACTIONS(5080), 1,
      sym_triple_quote_string,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5084), 1,
      sym__hex_literal,
    ACTIONS(5086), 1,
      anon_sym__,
    ACTIONS(5090), 1,
      anon_sym_LPAREN,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(8909), 1,
      anon_sym_AT,
    ACTIONS(8937), 1,
      sym_hole,
    ACTIONS(8939), 1,
      sym__conid,
    STATE(4656), 1,
      sym_constructor,
    STATE(4770), 1,
      sym_integer,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1611), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [105168] = 19,
    ACTIONS(5240), 1,
      sym__varid,
    ACTIONS(5242), 1,
      sym_string,
    ACTIONS(5244), 1,
      sym_triple_quote_string,
    ACTIONS(5246), 1,
      sym__integer_literal,
    ACTIONS(5248), 1,
      sym__hex_literal,
    ACTIONS(5250), 1,
      anon_sym__,
    ACTIONS(5254), 1,
      anon_sym_LPAREN,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(8846), 1,
      sym_hole,
    ACTIONS(8851), 1,
      anon_sym_AT,
    ACTIONS(8942), 1,
      sym__conid,
    STATE(4583), 1,
      sym_constructor,
    STATE(4912), 1,
      sym_integer,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1667), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [105241] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105282] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105325] = 19,
    ACTIONS(5240), 1,
      sym__varid,
    ACTIONS(5242), 1,
      sym_string,
    ACTIONS(5244), 1,
      sym_triple_quote_string,
    ACTIONS(5246), 1,
      sym__integer_literal,
    ACTIONS(5248), 1,
      sym__hex_literal,
    ACTIONS(5250), 1,
      anon_sym__,
    ACTIONS(5254), 1,
      anon_sym_LPAREN,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(8846), 1,
      sym_hole,
    ACTIONS(8851), 1,
      anon_sym_AT,
    ACTIONS(8953), 1,
      sym__conid,
    STATE(4583), 1,
      sym_constructor,
    STATE(4912), 1,
      sym_integer,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1667), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [105398] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105439] = 19,
    ACTIONS(5240), 1,
      sym__varid,
    ACTIONS(5242), 1,
      sym_string,
    ACTIONS(5244), 1,
      sym_triple_quote_string,
    ACTIONS(5246), 1,
      sym__integer_literal,
    ACTIONS(5248), 1,
      sym__hex_literal,
    ACTIONS(5250), 1,
      anon_sym__,
    ACTIONS(5254), 1,
      anon_sym_LPAREN,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(8851), 1,
      anon_sym_AT,
    ACTIONS(8957), 1,
      sym_hole,
    ACTIONS(8959), 1,
      sym__conid,
    STATE(4583), 1,
      sym_constructor,
    STATE(4912), 1,
      sym_integer,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1629), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [105512] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105555] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 12,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105596] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105639] = 19,
    ACTIONS(4983), 1,
      sym__varid,
    ACTIONS(4985), 1,
      sym_string,
    ACTIONS(4987), 1,
      sym_triple_quote_string,
    ACTIONS(4989), 1,
      sym__integer_literal,
    ACTIONS(4991), 1,
      sym__hex_literal,
    ACTIONS(4993), 1,
      anon_sym__,
    ACTIONS(4997), 1,
      anon_sym_LPAREN,
    ACTIONS(5001), 1,
      anon_sym_LBRACE,
    ACTIONS(8962), 1,
      sym_hole,
    ACTIONS(8964), 1,
      sym__conid,
    ACTIONS(8967), 1,
      anon_sym_AT,
    STATE(4637), 1,
      sym_constructor,
    STATE(4816), 1,
      sym_integer,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1674), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [105712] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105753] = 19,
    ACTIONS(4983), 1,
      sym__varid,
    ACTIONS(4985), 1,
      sym_string,
    ACTIONS(4987), 1,
      sym_triple_quote_string,
    ACTIONS(4989), 1,
      sym__integer_literal,
    ACTIONS(4991), 1,
      sym__hex_literal,
    ACTIONS(4993), 1,
      anon_sym__,
    ACTIONS(4997), 1,
      anon_sym_LPAREN,
    ACTIONS(5001), 1,
      anon_sym_LBRACE,
    ACTIONS(8962), 1,
      sym_hole,
    ACTIONS(8967), 1,
      anon_sym_AT,
    ACTIONS(8969), 1,
      sym__conid,
    STATE(4637), 1,
      sym_constructor,
    STATE(4816), 1,
      sym_integer,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1674), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [105826] = 19,
    ACTIONS(4983), 1,
      sym__varid,
    ACTIONS(4985), 1,
      sym_string,
    ACTIONS(4987), 1,
      sym_triple_quote_string,
    ACTIONS(4989), 1,
      sym__integer_literal,
    ACTIONS(4991), 1,
      sym__hex_literal,
    ACTIONS(4993), 1,
      anon_sym__,
    ACTIONS(4997), 1,
      anon_sym_LPAREN,
    ACTIONS(5001), 1,
      anon_sym_LBRACE,
    ACTIONS(8967), 1,
      anon_sym_AT,
    ACTIONS(8973), 1,
      sym_hole,
    ACTIONS(8975), 1,
      sym__conid,
    STATE(4637), 1,
      sym_constructor,
    STATE(4816), 1,
      sym_integer,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1695), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [105899] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105940] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [105981] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106022] = 19,
    ACTIONS(5491), 1,
      sym__varid,
    ACTIONS(5493), 1,
      sym_string,
    ACTIONS(5495), 1,
      sym_triple_quote_string,
    ACTIONS(5497), 1,
      sym__integer_literal,
    ACTIONS(5499), 1,
      sym__hex_literal,
    ACTIONS(5501), 1,
      anon_sym__,
    ACTIONS(5505), 1,
      anon_sym_LPAREN,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(8762), 1,
      sym_hole,
    ACTIONS(8767), 1,
      anon_sym_AT,
    ACTIONS(8978), 1,
      sym__conid,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_class,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1623), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [106095] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106136] = 5,
    ACTIONS(8981), 1,
      sym__immediate_dot,
    STATE(1680), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106181] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106224] = 5,
    ACTIONS(8984), 1,
      sym__immediate_dot,
    STATE(1680), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106269] = 5,
    ACTIONS(8984), 1,
      sym__immediate_dot,
    STATE(1680), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106314] = 5,
    ACTIONS(8984), 1,
      sym__immediate_dot,
    STATE(1680), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106359] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106402] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8984), 1,
      sym__immediate_dot,
    STATE(1682), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106449] = 19,
    ACTIONS(4937), 1,
      sym__varid,
    ACTIONS(4939), 1,
      sym_string,
    ACTIONS(4941), 1,
      sym_triple_quote_string,
    ACTIONS(4943), 1,
      sym__integer_literal,
    ACTIONS(4945), 1,
      sym__hex_literal,
    ACTIONS(4947), 1,
      anon_sym__,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
    ACTIONS(4955), 1,
      anon_sym_LBRACE,
    ACTIONS(8986), 1,
      sym_hole,
    ACTIONS(8988), 1,
      sym__conid,
    ACTIONS(8991), 1,
      anon_sym_AT,
    STATE(4593), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_integer,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3500), 2,
      sym__operator,
      anon_sym_newtype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1692), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [106522] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8984), 1,
      sym__immediate_dot,
    STATE(1684), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106569] = 9,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8993), 1,
      sym__immediate_dot,
    ACTIONS(8995), 1,
      anon_sym_AT2,
    STATE(2417), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8108), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8110), 3,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8106), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 14,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106622] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106665] = 19,
    ACTIONS(4937), 1,
      sym__varid,
    ACTIONS(4939), 1,
      sym_string,
    ACTIONS(4941), 1,
      sym_triple_quote_string,
    ACTIONS(4943), 1,
      sym__integer_literal,
    ACTIONS(4945), 1,
      sym__hex_literal,
    ACTIONS(4947), 1,
      anon_sym__,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
    ACTIONS(4955), 1,
      anon_sym_LBRACE,
    ACTIONS(8986), 1,
      sym_hole,
    ACTIONS(8991), 1,
      anon_sym_AT,
    ACTIONS(8997), 1,
      sym__conid,
    STATE(4593), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_integer,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_newtype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1692), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [106738] = 19,
    ACTIONS(4937), 1,
      sym__varid,
    ACTIONS(4939), 1,
      sym_string,
    ACTIONS(4941), 1,
      sym_triple_quote_string,
    ACTIONS(4943), 1,
      sym__integer_literal,
    ACTIONS(4945), 1,
      sym__hex_literal,
    ACTIONS(4947), 1,
      anon_sym__,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
    ACTIONS(4955), 1,
      anon_sym_LBRACE,
    ACTIONS(8991), 1,
      anon_sym_AT,
    ACTIONS(9001), 1,
      sym_hole,
    ACTIONS(9003), 1,
      sym__conid,
    STATE(4593), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_integer,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3317), 2,
      sym__operator,
      anon_sym_newtype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1707), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [106811] = 5,
    ACTIONS(9006), 1,
      sym__immediate_dot,
    STATE(1693), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [106856] = 19,
    ACTIONS(4983), 1,
      sym__varid,
    ACTIONS(4985), 1,
      sym_string,
    ACTIONS(4987), 1,
      sym_triple_quote_string,
    ACTIONS(4989), 1,
      sym__integer_literal,
    ACTIONS(4991), 1,
      sym__hex_literal,
    ACTIONS(4993), 1,
      anon_sym__,
    ACTIONS(4997), 1,
      anon_sym_LPAREN,
    ACTIONS(5001), 1,
      anon_sym_LBRACE,
    ACTIONS(8962), 1,
      sym_hole,
    ACTIONS(8967), 1,
      anon_sym_AT,
    ACTIONS(9009), 1,
      sym__conid,
    STATE(4637), 1,
      sym_constructor,
    STATE(4816), 1,
      sym_integer,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1674), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [106929] = 19,
    ACTIONS(9012), 1,
      sym__varid,
    ACTIONS(9015), 1,
      sym_string,
    ACTIONS(9018), 1,
      sym_triple_quote_string,
    ACTIONS(9021), 1,
      sym__integer_literal,
    ACTIONS(9024), 1,
      sym__hex_literal,
    ACTIONS(9027), 1,
      anon_sym__,
    ACTIONS(9030), 1,
      sym_hole,
    ACTIONS(9033), 1,
      anon_sym_LPAREN,
    ACTIONS(9036), 1,
      sym__conid,
    ACTIONS(9039), 1,
      anon_sym_LBRACE,
    ACTIONS(9042), 1,
      anon_sym_AT,
    STATE(4637), 1,
      sym_constructor,
    STATE(4816), 1,
      sym_integer,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1695), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [107002] = 5,
    ACTIONS(9045), 1,
      sym__immediate_dot,
    STATE(1693), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107047] = 5,
    ACTIONS(9045), 1,
      sym__immediate_dot,
    STATE(1693), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107092] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 11,
      sym__layout_semicolon,
      sym__dot,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107133] = 5,
    ACTIONS(9045), 1,
      sym__immediate_dot,
    STATE(1693), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107178] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(9045), 1,
      sym__immediate_dot,
    STATE(1696), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107225] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107268] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(9045), 1,
      sym__immediate_dot,
    STATE(1699), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107315] = 19,
    ACTIONS(9047), 1,
      sym__varid,
    ACTIONS(9050), 1,
      sym_string,
    ACTIONS(9053), 1,
      sym_triple_quote_string,
    ACTIONS(9056), 1,
      sym__integer_literal,
    ACTIONS(9059), 1,
      sym__hex_literal,
    ACTIONS(9062), 1,
      anon_sym__,
    ACTIONS(9065), 1,
      sym_hole,
    ACTIONS(9068), 1,
      anon_sym_LPAREN,
    ACTIONS(9071), 1,
      sym__conid,
    ACTIONS(9074), 1,
      anon_sym_LBRACE,
    ACTIONS(9077), 1,
      anon_sym_AT,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1703), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [107388] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107431] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107472] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107515] = 19,
    ACTIONS(9080), 1,
      sym__varid,
    ACTIONS(9083), 1,
      sym_string,
    ACTIONS(9086), 1,
      sym_triple_quote_string,
    ACTIONS(9089), 1,
      sym__integer_literal,
    ACTIONS(9092), 1,
      sym__hex_literal,
    ACTIONS(9095), 1,
      anon_sym__,
    ACTIONS(9098), 1,
      sym_hole,
    ACTIONS(9101), 1,
      anon_sym_LPAREN,
    ACTIONS(9104), 1,
      sym__conid,
    ACTIONS(9107), 1,
      anon_sym_LBRACE,
    ACTIONS(9110), 1,
      anon_sym_AT,
    STATE(4593), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_integer,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3349), 2,
      sym__operator,
      anon_sym_newtype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1707), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [107588] = 4,
    ACTIONS(8894), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107631] = 4,
    ACTIONS(9113), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107674] = 4,
    ACTIONS(9115), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107717] = 4,
    ACTIONS(9117), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107760] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107801] = 4,
    ACTIONS(9119), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107844] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107885] = 19,
    ACTIONS(4937), 1,
      sym__varid,
    ACTIONS(4939), 1,
      sym_string,
    ACTIONS(4941), 1,
      sym_triple_quote_string,
    ACTIONS(4943), 1,
      sym__integer_literal,
    ACTIONS(4945), 1,
      sym__hex_literal,
    ACTIONS(4947), 1,
      anon_sym__,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
    ACTIONS(4955), 1,
      anon_sym_LBRACE,
    ACTIONS(8986), 1,
      sym_hole,
    ACTIONS(8991), 1,
      anon_sym_AT,
    ACTIONS(9121), 1,
      sym__conid,
    STATE(4593), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_integer,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_newtype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1692), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [107958] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 13,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [107999] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108040] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108081] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108122] = 19,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5078), 1,
      sym_string,
    ACTIONS(5080), 1,
      sym_triple_quote_string,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5084), 1,
      sym__hex_literal,
    ACTIONS(5086), 1,
      anon_sym__,
    ACTIONS(5090), 1,
      anon_sym_LPAREN,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(8904), 1,
      sym_hole,
    ACTIONS(8909), 1,
      anon_sym_AT,
    ACTIONS(9124), 1,
      sym__conid,
    STATE(4656), 1,
      sym_constructor,
    STATE(4770), 1,
      sym_integer,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1661), 9,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
      aux_sym_type_apply_repeat1,
  [108195] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108237] = 5,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    STATE(1800), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108281] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108321] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108361] = 4,
    ACTIONS(9135), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108403] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108443] = 9,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8995), 1,
      anon_sym_AT2,
    ACTIONS(9142), 1,
      sym__immediate_dot,
    STATE(2538), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8108), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8110), 3,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8106), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 13,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108495] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108537] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108577] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108617] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108657] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108697] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108737] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108777] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108817] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108857] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108899] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108941] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [108981] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109021] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109061] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109101] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109143] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109183] = 5,
    ACTIONS(9188), 1,
      sym__immediate_dot,
    STATE(1745), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109227] = 6,
    ACTIONS(9197), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_hole,
    ACTIONS(9194), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 8,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
    ACTIONS(9191), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [109273] = 5,
    ACTIONS(9199), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9201), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8415), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8413), 12,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109317] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109357] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109397] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109439] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109479] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109519] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109559] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109599] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109639] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109679] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109719] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109759] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109799] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109839] = 5,
    ACTIONS(8135), 1,
      sym__immediate_dot,
    STATE(1745), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109883] = 5,
    ACTIONS(8135), 1,
      sym__immediate_dot,
    STATE(1745), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109927] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [109967] = 5,
    ACTIONS(8135), 1,
      sym__immediate_dot,
    STATE(1745), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110011] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110051] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110091] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110133] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110173] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110213] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8135), 1,
      sym__immediate_dot,
    STATE(1908), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 9,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110259] = 6,
    ACTIONS(8135), 1,
      sym__immediate_dot,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    STATE(1764), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 9,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110305] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110345] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110385] = 5,
    ACTIONS(9260), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9262), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9222), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 12,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110429] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110469] = 5,
    ACTIONS(9265), 1,
      sym__immediate_dot,
    STATE(1776), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110513] = 5,
    ACTIONS(8113), 1,
      sym__immediate_dot,
    STATE(1776), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110557] = 4,
    ACTIONS(9268), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110599] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110639] = 5,
    ACTIONS(8113), 1,
      sym__immediate_dot,
    STATE(1776), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110683] = 5,
    ACTIONS(8113), 1,
      sym__immediate_dot,
    STATE(1776), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110727] = 5,
    ACTIONS(8113), 1,
      sym__immediate_dot,
    STATE(1776), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110771] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110811] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110851] = 6,
    ACTIONS(8113), 1,
      sym__immediate_dot,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    STATE(1777), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110897] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110937] = 6,
    ACTIONS(8113), 1,
      sym__immediate_dot,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    STATE(1782), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [110983] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111023] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111063] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111105] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111145] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111185] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111225] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111265] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111307] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111349] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111389] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111429] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111469] = 5,
    ACTIONS(9287), 1,
      sym__immediate_dot,
    STATE(1800), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8356), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111513] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111553] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111593] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111633] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111673] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111713] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111753] = 4,
    ACTIONS(9306), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111795] = 5,
    ACTIONS(9308), 1,
      sym__immediate_dot,
    STATE(1808), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111839] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111879] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
      anon_sym_AT2,
  [111919] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [111959] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112001] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112041] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112081] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112121] = 4,
    ACTIONS(9311), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112163] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112205] = 5,
    ACTIONS(9313), 1,
      sym__immediate_dot,
    STATE(1808), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112249] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112289] = 4,
    ACTIONS(9315), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112331] = 4,
    ACTIONS(9317), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112373] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112415] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112455] = 5,
    ACTIONS(9313), 1,
      sym__immediate_dot,
    STATE(1808), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112499] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112539] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112579] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112619] = 4,
    ACTIONS(9323), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112661] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112701] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112741] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112781] = 5,
    ACTIONS(9313), 1,
      sym__immediate_dot,
    STATE(1808), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112825] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112865] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112905] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(9313), 1,
      sym__immediate_dot,
    STATE(1818), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112951] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [112991] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(9313), 1,
      sym__immediate_dot,
    STATE(1832), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113037] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113077] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113117] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113157] = 5,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    STATE(1800), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113201] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113241] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113281] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113321] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113361] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113401] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113441] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113481] = 5,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    STATE(1800), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113525] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113565] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113605] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113645] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113685] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113725] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 12,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113765] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113805] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113845] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113885] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113925] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [113965] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114005] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 13,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114045] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114085] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114125] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 21,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
      anon_sym_AT2,
  [114165] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114205] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114245] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114285] = 4,
    ACTIONS(9329), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114327] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114367] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114407] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114447] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    STATE(1932), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114493] = 4,
    ACTIONS(9332), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114535] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114575] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114615] = 6,
    ACTIONS(9197), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_hole,
    ACTIONS(9194), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 9,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
    ACTIONS(9191), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [114661] = 5,
    ACTIONS(9199), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9201), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8415), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8413), 13,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114705] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114745] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    STATE(1849), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114791] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114831] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114871] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114911] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114951] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [114991] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115031] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115071] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115111] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115151] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115191] = 4,
    ACTIONS(9335), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115233] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115273] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115313] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115353] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115393] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115433] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115473] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115513] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115553] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115593] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115633] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115673] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115713] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115753] = 5,
    ACTIONS(9260), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9262), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9222), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 13,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115797] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115837] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115877] = 5,
    ACTIONS(8135), 1,
      sym__immediate_dot,
    STATE(1745), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115921] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [115961] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116001] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116041] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116081] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116121] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116161] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116201] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116241] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116281] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116321] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116361] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116401] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116441] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116481] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116521] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116561] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116601] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116641] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116681] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116721] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116763] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116803] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116843] = 5,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    STATE(1800), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116887] = 4,
    ACTIONS(9338), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116929] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [116969] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117009] = 4,
    ACTIONS(9340), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117051] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117091] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117131] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117171] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117213] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117253] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117293] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117333] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117373] = 4,
    ACTIONS(9342), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117415] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117455] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117495] = 4,
    ACTIONS(9344), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117537] = 4,
    ACTIONS(9346), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117579] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117618] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117657] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117696] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117735] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117774] = 19,
    ACTIONS(5054), 1,
      sym__varid,
    ACTIONS(5056), 1,
      sym_string,
    ACTIONS(5058), 1,
      sym_triple_quote_string,
    ACTIONS(5060), 1,
      sym__integer_literal,
    ACTIONS(5062), 1,
      sym__hex_literal,
    ACTIONS(5064), 1,
      anon_sym__,
    ACTIONS(5068), 1,
      anon_sym_LPAREN,
    ACTIONS(5070), 1,
      sym__conid,
    ACTIONS(5072), 1,
      anon_sym_LBRACE,
    ACTIONS(5074), 1,
      anon_sym_AT,
    ACTIONS(9348), 1,
      sym_hole,
    STATE(4259), 1,
      sym_constructor,
    STATE(4428), 1,
      sym_integer,
    STATE(7345), 1,
      sym_type_apply,
    STATE(7568), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4400), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1449), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [117845] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117884] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117923] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8861), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [117964] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118003] = 19,
    ACTIONS(4983), 1,
      sym__varid,
    ACTIONS(4985), 1,
      sym_string,
    ACTIONS(4987), 1,
      sym_triple_quote_string,
    ACTIONS(4989), 1,
      sym__integer_literal,
    ACTIONS(4991), 1,
      sym__hex_literal,
    ACTIONS(4993), 1,
      anon_sym__,
    ACTIONS(4997), 1,
      anon_sym_LPAREN,
    ACTIONS(4999), 1,
      sym__conid,
    ACTIONS(5001), 1,
      anon_sym_LBRACE,
    ACTIONS(5003), 1,
      anon_sym_AT,
    ACTIONS(9350), 1,
      sym_hole,
    STATE(4637), 1,
      sym_constructor,
    STATE(4816), 1,
      sym_integer,
    STATE(5547), 1,
      sym_type_apply,
    STATE(7907), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1694), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [118074] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118115] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118154] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118193] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118232] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118273] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118314] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(9352), 1,
      sym__immediate_dot,
    STATE(1980), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118359] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(9352), 1,
      sym__immediate_dot,
    STATE(1982), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118404] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118443] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118484] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118525] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118564] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118603] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118642] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118681] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118720] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118759] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118798] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118837] = 5,
    ACTIONS(9352), 1,
      sym__immediate_dot,
    STATE(1995), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118880] = 5,
    ACTIONS(9352), 1,
      sym__immediate_dot,
    STATE(1995), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118923] = 5,
    ACTIONS(9352), 1,
      sym__immediate_dot,
    STATE(1995), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [118966] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119005] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119044] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119083] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119122] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 12,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8931), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119161] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119200] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119239] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119278] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119317] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119356] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119395] = 19,
    ACTIONS(5491), 1,
      sym__varid,
    ACTIONS(5493), 1,
      sym_string,
    ACTIONS(5495), 1,
      sym_triple_quote_string,
    ACTIONS(5497), 1,
      sym__integer_literal,
    ACTIONS(5499), 1,
      sym__hex_literal,
    ACTIONS(5501), 1,
      anon_sym__,
    ACTIONS(5505), 1,
      anon_sym_LPAREN,
    ACTIONS(5507), 1,
      sym__conid,
    ACTIONS(5509), 1,
      anon_sym_LBRACE,
    ACTIONS(5511), 1,
      anon_sym_AT,
    ACTIONS(9354), 1,
      sym_hole,
    STATE(4682), 1,
      sym_constructor,
    STATE(4748), 1,
      sym_integer,
    STATE(5547), 1,
      sym_type_apply,
    STATE(8009), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4820), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1678), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [119466] = 5,
    ACTIONS(9356), 1,
      sym__immediate_dot,
    STATE(1995), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119509] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 12,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8947), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119548] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119587] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119626] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119665] = 4,
    ACTIONS(9359), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8925), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119706] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119745] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119784] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119823] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119862] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119901] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119940] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [119979] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120018] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 11,
      sym__layout_semicolon,
      sym__dot,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120057] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 12,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8921), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120096] = 19,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5276), 1,
      sym_string,
    ACTIONS(5278), 1,
      sym_triple_quote_string,
    ACTIONS(5280), 1,
      sym__integer_literal,
    ACTIONS(5282), 1,
      sym__hex_literal,
    ACTIONS(5284), 1,
      anon_sym__,
    ACTIONS(5288), 1,
      anon_sym_LPAREN,
    ACTIONS(5290), 1,
      sym__conid,
    ACTIONS(5292), 1,
      anon_sym_LBRACE,
    ACTIONS(5294), 1,
      anon_sym_AT,
    ACTIONS(9361), 1,
      sym_hole,
    STATE(4291), 1,
      sym_constructor,
    STATE(4473), 1,
      sym_integer,
    STATE(7268), 1,
      sym_type_apply,
    STATE(7573), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4470), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1481), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [120167] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120206] = 19,
    ACTIONS(4905), 1,
      sym__varid,
    ACTIONS(4907), 1,
      sym_string,
    ACTIONS(4909), 1,
      sym_triple_quote_string,
    ACTIONS(4911), 1,
      sym__integer_literal,
    ACTIONS(4913), 1,
      sym__hex_literal,
    ACTIONS(4915), 1,
      anon_sym__,
    ACTIONS(4919), 1,
      anon_sym_LPAREN,
    ACTIONS(4921), 1,
      sym__conid,
    ACTIONS(4923), 1,
      anon_sym_LBRACE,
    ACTIONS(4925), 1,
      anon_sym_AT,
    ACTIONS(9363), 1,
      sym_hole,
    STATE(4348), 1,
      sym_constructor,
    STATE(4550), 1,
      sym_integer,
    STATE(6796), 1,
      sym_type_apply,
    STATE(7712), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4546), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1512), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [120277] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120316] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120355] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120394] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120433] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120472] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120511] = 19,
    ACTIONS(2570), 1,
      sym__varid,
    ACTIONS(2572), 1,
      sym_string,
    ACTIONS(2574), 1,
      sym_triple_quote_string,
    ACTIONS(2576), 1,
      sym__integer_literal,
    ACTIONS(2578), 1,
      sym__hex_literal,
    ACTIONS(2580), 1,
      anon_sym__,
    ACTIONS(2584), 1,
      anon_sym_LPAREN,
    ACTIONS(2586), 1,
      sym__conid,
    ACTIONS(2590), 1,
      anon_sym_LBRACE,
    ACTIONS(2592), 1,
      anon_sym_AT,
    ACTIONS(9365), 1,
      sym_hole,
    STATE(3282), 1,
      sym_constructor,
    STATE(3454), 1,
      sym_type_apply,
    STATE(3669), 1,
      sym_integer,
    STATE(7572), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3663), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1354), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [120582] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120621] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120660] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120699] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120738] = 4,
    ACTIONS(9367), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120779] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120818] = 19,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5078), 1,
      sym_string,
    ACTIONS(5080), 1,
      sym_triple_quote_string,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5084), 1,
      sym__hex_literal,
    ACTIONS(5086), 1,
      anon_sym__,
    ACTIONS(5090), 1,
      anon_sym_LPAREN,
    ACTIONS(5092), 1,
      sym__conid,
    ACTIONS(5094), 1,
      anon_sym_LBRACE,
    ACTIONS(5096), 1,
      anon_sym_AT,
    ACTIONS(9369), 1,
      sym_hole,
    STATE(4656), 1,
      sym_constructor,
    STATE(4770), 1,
      sym_integer,
    STATE(5547), 1,
      sym_type_apply,
    STATE(7730), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4786), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1720), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [120889] = 4,
    ACTIONS(9371), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [120930] = 19,
    ACTIONS(4959), 1,
      sym__varid,
    ACTIONS(4961), 1,
      sym_string,
    ACTIONS(4963), 1,
      sym_triple_quote_string,
    ACTIONS(4965), 1,
      sym__integer_literal,
    ACTIONS(4967), 1,
      sym__hex_literal,
    ACTIONS(4969), 1,
      anon_sym__,
    ACTIONS(4973), 1,
      anon_sym_LPAREN,
    ACTIONS(4975), 1,
      sym__conid,
    ACTIONS(4977), 1,
      anon_sym_LBRACE,
    ACTIONS(4979), 1,
      anon_sym_AT,
    ACTIONS(9373), 1,
      sym_hole,
    STATE(3780), 1,
      sym_constructor,
    STATE(4447), 1,
      sym_integer,
    STATE(6796), 1,
      sym_type_apply,
    STATE(7973), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1480), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [121001] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121040] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121079] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121120] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121159] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121198] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121237] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121315] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121354] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 12,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8902), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121393] = 19,
    ACTIONS(2598), 1,
      sym__varid,
    ACTIONS(2600), 1,
      sym_string,
    ACTIONS(2602), 1,
      sym_triple_quote_string,
    ACTIONS(2604), 1,
      sym__integer_literal,
    ACTIONS(2606), 1,
      sym__hex_literal,
    ACTIONS(2608), 1,
      anon_sym__,
    ACTIONS(2612), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym__conid,
    ACTIONS(2618), 1,
      anon_sym_LBRACE,
    ACTIONS(2620), 1,
      anon_sym_AT,
    ACTIONS(9375), 1,
      sym_hole,
    STATE(3347), 1,
      sym_constructor,
    STATE(3436), 1,
      sym_integer,
    STATE(3675), 1,
      sym_type_apply,
    STATE(7776), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3537), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1367), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [121464] = 19,
    ACTIONS(3042), 1,
      sym__varid,
    ACTIONS(3044), 1,
      sym_string,
    ACTIONS(3046), 1,
      sym_triple_quote_string,
    ACTIONS(3048), 1,
      sym__integer_literal,
    ACTIONS(3050), 1,
      sym__hex_literal,
    ACTIONS(3052), 1,
      anon_sym__,
    ACTIONS(3056), 1,
      anon_sym_LPAREN,
    ACTIONS(3058), 1,
      sym__conid,
    ACTIONS(3060), 1,
      anon_sym_LBRACE,
    ACTIONS(3062), 1,
      anon_sym_AT,
    ACTIONS(9377), 1,
      sym_hole,
    STATE(3809), 1,
      sym_constructor,
    STATE(4132), 1,
      sym_type_apply,
    STATE(4288), 1,
      sym_integer,
    STATE(8029), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4231), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1446), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [121535] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121574] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121613] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121652] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121693] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121732] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121771] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121810] = 19,
    ACTIONS(2088), 1,
      sym_string,
    ACTIONS(2090), 1,
      sym_triple_quote_string,
    ACTIONS(2092), 1,
      sym__integer_literal,
    ACTIONS(2094), 1,
      sym__hex_literal,
    ACTIONS(2098), 1,
      anon_sym__,
    ACTIONS(2104), 1,
      sym__conid,
    ACTIONS(2108), 1,
      anon_sym_LBRACE,
    ACTIONS(3034), 1,
      sym__varid,
    ACTIONS(3036), 1,
      anon_sym_LPAREN,
    ACTIONS(3038), 1,
      anon_sym_AT,
    ACTIONS(9379), 1,
      sym_hole,
    STATE(3985), 1,
      sym_constructor,
    STATE(4176), 1,
      sym_integer,
    STATE(4244), 1,
      sym_type_apply,
    STATE(7683), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4180), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1419), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [121881] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121920] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121959] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [121998] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122037] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122076] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122115] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122154] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122193] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122232] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122271] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122310] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122349] = 4,
    ACTIONS(9381), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8885), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122390] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122429] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122468] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8949), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122509] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122548] = 4,
    ACTIONS(9383), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122589] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122628] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122667] = 19,
    ACTIONS(4820), 1,
      sym__varid,
    ACTIONS(4822), 1,
      sym_string,
    ACTIONS(4824), 1,
      sym_triple_quote_string,
    ACTIONS(4826), 1,
      sym__integer_literal,
    ACTIONS(4828), 1,
      sym__hex_literal,
    ACTIONS(4830), 1,
      anon_sym__,
    ACTIONS(4834), 1,
      anon_sym_LPAREN,
    ACTIONS(4836), 1,
      sym__conid,
    ACTIONS(4838), 1,
      anon_sym_LBRACE,
    ACTIONS(4840), 1,
      anon_sym_AT,
    ACTIONS(9385), 1,
      sym_hole,
    STATE(4488), 1,
      sym_constructor,
    STATE(4732), 1,
      sym_integer,
    STATE(5547), 1,
      sym_type_apply,
    STATE(7905), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4905), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1635), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [122738] = 4,
    ACTIONS(9387), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122779] = 4,
    ACTIONS(9389), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122820] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122859] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122898] = 4,
    ACTIONS(9391), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122939] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [122978] = 19,
    ACTIONS(5394), 1,
      sym__varid,
    ACTIONS(5396), 1,
      sym_string,
    ACTIONS(5398), 1,
      sym_triple_quote_string,
    ACTIONS(5400), 1,
      sym__integer_literal,
    ACTIONS(5402), 1,
      sym__hex_literal,
    ACTIONS(5404), 1,
      anon_sym__,
    ACTIONS(5408), 1,
      anon_sym_LPAREN,
    ACTIONS(5410), 1,
      sym__conid,
    ACTIONS(5412), 1,
      anon_sym_LBRACE,
    ACTIONS(5414), 1,
      anon_sym_AT,
    ACTIONS(9393), 1,
      sym_hole,
    STATE(4378), 1,
      sym_constructor,
    STATE(4685), 1,
      sym_integer,
    STATE(7610), 1,
      aux_sym__qualifying_module,
    STATE(7618), 1,
      sym_type_apply,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4654), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1524), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [123049] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123088] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      sym__immediate_dot,
    STATE(2105), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123133] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123172] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123211] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123250] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123289] = 4,
    ACTIONS(9397), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123330] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123369] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123408] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123447] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123486] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123525] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123564] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123603] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123642] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123681] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8771), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123720] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123759] = 4,
    ACTIONS(9399), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8775), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123800] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123839] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123878] = 5,
    ACTIONS(9395), 1,
      sym__immediate_dot,
    STATE(2152), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123921] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      sym__immediate_dot,
    STATE(2099), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [123966] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124007] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124046] = 19,
    ACTIONS(2753), 1,
      sym__varid,
    ACTIONS(2755), 1,
      sym_string,
    ACTIONS(2757), 1,
      sym_triple_quote_string,
    ACTIONS(2759), 1,
      sym__integer_literal,
    ACTIONS(2761), 1,
      sym__hex_literal,
    ACTIONS(2763), 1,
      anon_sym__,
    ACTIONS(2767), 1,
      anon_sym_LPAREN,
    ACTIONS(2769), 1,
      sym__conid,
    ACTIONS(2771), 1,
      anon_sym_LBRACE,
    ACTIONS(2773), 1,
      anon_sym_AT,
    ACTIONS(9401), 1,
      sym_hole,
    STATE(3382), 1,
      sym_constructor,
    STATE(3582), 1,
      sym_type_apply,
    STATE(3586), 1,
      sym_integer,
    STATE(7794), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3588), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1324), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [124117] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124158] = 5,
    ACTIONS(9395), 1,
      sym__immediate_dot,
    STATE(2152), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124201] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124240] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124281] = 19,
    ACTIONS(1874), 1,
      sym__integer_literal,
    ACTIONS(1876), 1,
      sym__hex_literal,
    ACTIONS(1878), 1,
      anon_sym__,
    ACTIONS(1884), 1,
      anon_sym_LPAREN,
    ACTIONS(1888), 1,
      sym__conid,
    ACTIONS(1892), 1,
      anon_sym_LBRACE,
    ACTIONS(4683), 1,
      sym__varid,
    ACTIONS(4685), 1,
      sym_string,
    ACTIONS(4687), 1,
      sym_triple_quote_string,
    ACTIONS(4691), 1,
      anon_sym_AT,
    ACTIONS(9403), 1,
      sym_hole,
    STATE(4337), 1,
      sym_constructor,
    STATE(4683), 1,
      sym_integer,
    STATE(5547), 1,
      sym_type_apply,
    STATE(7796), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4686), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1531), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [124352] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124391] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124430] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124469] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124508] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124549] = 19,
    ACTIONS(5240), 1,
      sym__varid,
    ACTIONS(5242), 1,
      sym_string,
    ACTIONS(5244), 1,
      sym_triple_quote_string,
    ACTIONS(5246), 1,
      sym__integer_literal,
    ACTIONS(5248), 1,
      sym__hex_literal,
    ACTIONS(5250), 1,
      anon_sym__,
    ACTIONS(5254), 1,
      anon_sym_LPAREN,
    ACTIONS(5256), 1,
      sym__conid,
    ACTIONS(5258), 1,
      anon_sym_LBRACE,
    ACTIONS(5260), 1,
      anon_sym_AT,
    ACTIONS(9405), 1,
      sym_hole,
    STATE(4583), 1,
      sym_constructor,
    STATE(4912), 1,
      sym_integer,
    STATE(5547), 1,
      sym_type_apply,
    STATE(7661), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4915), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1630), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [124620] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 12,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8223), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124659] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124698] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8789), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124737] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124778] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124819] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124860] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [124899] = 19,
    ACTIONS(5032), 1,
      sym__varid,
    ACTIONS(5034), 1,
      sym_string,
    ACTIONS(5036), 1,
      sym_triple_quote_string,
    ACTIONS(5038), 1,
      sym__integer_literal,
    ACTIONS(5040), 1,
      sym__hex_literal,
    ACTIONS(5042), 1,
      anon_sym__,
    ACTIONS(5046), 1,
      anon_sym_LPAREN,
    ACTIONS(5048), 1,
      sym__conid,
    ACTIONS(5050), 1,
      anon_sym_LBRACE,
    ACTIONS(5052), 1,
      anon_sym_AT,
    ACTIONS(9407), 1,
      sym_hole,
    STATE(3980), 1,
      sym_constructor,
    STATE(4197), 1,
      sym_integer,
    STATE(6774), 1,
      sym_type_apply,
    STATE(7716), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4195), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1421), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [124970] = 4,
    ACTIONS(9409), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125011] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125050] = 19,
    ACTIONS(4937), 1,
      sym__varid,
    ACTIONS(4939), 1,
      sym_string,
    ACTIONS(4941), 1,
      sym_triple_quote_string,
    ACTIONS(4943), 1,
      sym__integer_literal,
    ACTIONS(4945), 1,
      sym__hex_literal,
    ACTIONS(4947), 1,
      anon_sym__,
    ACTIONS(4951), 1,
      anon_sym_LPAREN,
    ACTIONS(4953), 1,
      sym__conid,
    ACTIONS(4955), 1,
      anon_sym_LBRACE,
    ACTIONS(4957), 1,
      anon_sym_AT,
    ACTIONS(9412), 1,
      sym_hole,
    STATE(4593), 1,
      sym_constructor,
    STATE(4885), 1,
      sym_integer,
    STATE(5547), 1,
      sym_type_apply,
    STATE(7890), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4730), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1715), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [125121] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125160] = 4,
    ACTIONS(9414), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125201] = 19,
    ACTIONS(5296), 1,
      sym__varid,
    ACTIONS(5298), 1,
      sym_string,
    ACTIONS(5300), 1,
      sym_triple_quote_string,
    ACTIONS(5302), 1,
      sym__integer_literal,
    ACTIONS(5304), 1,
      sym__hex_literal,
    ACTIONS(5306), 1,
      anon_sym__,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5312), 1,
      sym__conid,
    ACTIONS(5314), 1,
      anon_sym_LBRACE,
    ACTIONS(5316), 1,
      anon_sym_AT,
    ACTIONS(9417), 1,
      sym_hole,
    STATE(4350), 1,
      sym_constructor,
    STATE(4552), 1,
      sym_integer,
    STATE(7649), 1,
      sym_type_apply,
    STATE(7726), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4696), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1583), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [125272] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125311] = 19,
    ACTIONS(5170), 1,
      sym__varid,
    ACTIONS(5172), 1,
      sym_string,
    ACTIONS(5174), 1,
      sym_triple_quote_string,
    ACTIONS(5176), 1,
      sym__integer_literal,
    ACTIONS(5178), 1,
      sym__hex_literal,
    ACTIONS(5180), 1,
      anon_sym__,
    ACTIONS(5184), 1,
      anon_sym_LPAREN,
    ACTIONS(5186), 1,
      sym__conid,
    ACTIONS(5188), 1,
      anon_sym_LBRACE,
    ACTIONS(5190), 1,
      anon_sym_AT,
    ACTIONS(9419), 1,
      sym_hole,
    STATE(3614), 1,
      sym_constructor,
    STATE(4008), 1,
      sym_integer,
    STATE(5914), 1,
      sym_type_apply,
    STATE(7847), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4010), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1397), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [125382] = 19,
    ACTIONS(2468), 1,
      sym__varid,
    ACTIONS(2472), 1,
      sym_string,
    ACTIONS(2474), 1,
      sym_triple_quote_string,
    ACTIONS(2476), 1,
      sym__integer_literal,
    ACTIONS(2478), 1,
      sym__hex_literal,
    ACTIONS(2482), 1,
      anon_sym__,
    ACTIONS(2486), 1,
      anon_sym_LPAREN,
    ACTIONS(2488), 1,
      sym__conid,
    ACTIONS(2490), 1,
      anon_sym_LBRACE,
    ACTIONS(2492), 1,
      anon_sym_AT,
    ACTIONS(9421), 1,
      sym_hole,
    STATE(3122), 1,
      sym_constructor,
    STATE(3165), 1,
      sym_type_apply,
    STATE(3226), 1,
      sym_integer,
    STATE(7546), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3219), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(989), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [125453] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8781), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125492] = 4,
    ACTIONS(9423), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125533] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125574] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8896), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125615] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125654] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125693] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8793), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125732] = 5,
    ACTIONS(9395), 1,
      sym__immediate_dot,
    STATE(2152), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125775] = 19,
    ACTIONS(3849), 1,
      sym__varid,
    ACTIONS(3851), 1,
      sym_string,
    ACTIONS(3853), 1,
      sym_triple_quote_string,
    ACTIONS(3855), 1,
      sym__integer_literal,
    ACTIONS(3857), 1,
      sym__hex_literal,
    ACTIONS(3859), 1,
      anon_sym__,
    ACTIONS(3863), 1,
      anon_sym_LPAREN,
    ACTIONS(3868), 1,
      anon_sym_LBRACE,
    ACTIONS(4877), 1,
      sym__conid,
    ACTIONS(4879), 1,
      anon_sym_AT,
    ACTIONS(9426), 1,
      sym_hole,
    STATE(3099), 1,
      sym_constructor,
    STATE(3245), 1,
      sym_integer,
    STATE(5669), 1,
      sym_type_apply,
    STATE(7652), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3248), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(992), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [125846] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125885] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125924] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [125963] = 19,
    ACTIONS(4759), 1,
      sym__varid,
    ACTIONS(4761), 1,
      sym_string,
    ACTIONS(4763), 1,
      sym_triple_quote_string,
    ACTIONS(4765), 1,
      sym__integer_literal,
    ACTIONS(4767), 1,
      sym__hex_literal,
    ACTIONS(4769), 1,
      anon_sym__,
    ACTIONS(4773), 1,
      anon_sym_LPAREN,
    ACTIONS(4778), 1,
      anon_sym_LBRACE,
    ACTIONS(5558), 1,
      sym__conid,
    ACTIONS(5560), 1,
      anon_sym_AT,
    ACTIONS(9428), 1,
      sym_hole,
    STATE(3229), 1,
      sym_constructor,
    STATE(3324), 1,
      sym_integer,
    STATE(5905), 1,
      sym_type_apply,
    STATE(7966), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3315), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1198), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [126034] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126073] = 19,
    ACTIONS(5445), 1,
      sym__varid,
    ACTIONS(5447), 1,
      sym_string,
    ACTIONS(5449), 1,
      sym_triple_quote_string,
    ACTIONS(5451), 1,
      sym__integer_literal,
    ACTIONS(5453), 1,
      sym__hex_literal,
    ACTIONS(5455), 1,
      anon_sym__,
    ACTIONS(5459), 1,
      anon_sym_LPAREN,
    ACTIONS(5461), 1,
      sym__conid,
    ACTIONS(5463), 1,
      anon_sym_LBRACE,
    ACTIONS(5465), 1,
      anon_sym_AT,
    ACTIONS(9430), 1,
      sym_hole,
    STATE(3449), 1,
      sym_constructor,
    STATE(3922), 1,
      sym_integer,
    STATE(6450), 1,
      sym_type_apply,
    STATE(7968), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3917), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1403), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [126144] = 19,
    ACTIONS(3275), 1,
      sym__varid,
    ACTIONS(3280), 1,
      sym_string,
    ACTIONS(3282), 1,
      sym_triple_quote_string,
    ACTIONS(3284), 1,
      sym__integer_literal,
    ACTIONS(3286), 1,
      sym__hex_literal,
    ACTIONS(3291), 1,
      anon_sym__,
    ACTIONS(3295), 1,
      anon_sym_LPAREN,
    ACTIONS(3301), 1,
      anon_sym_LBRACE,
    ACTIONS(5219), 1,
      sym__conid,
    ACTIONS(5221), 1,
      anon_sym_AT,
    ACTIONS(9432), 1,
      sym_hole,
    STATE(3042), 1,
      sym_constructor,
    STATE(3110), 1,
      sym_integer,
    STATE(5281), 1,
      sym_type_apply,
    STATE(7975), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3089), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(955), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [126215] = 19,
    ACTIONS(3725), 1,
      sym__varid,
    ACTIONS(3727), 1,
      sym_string,
    ACTIONS(3729), 1,
      sym_triple_quote_string,
    ACTIONS(3731), 1,
      sym__integer_literal,
    ACTIONS(3733), 1,
      sym__hex_literal,
    ACTIONS(3735), 1,
      anon_sym__,
    ACTIONS(3739), 1,
      anon_sym_LPAREN,
    ACTIONS(3744), 1,
      anon_sym_LBRACE,
    ACTIONS(4929), 1,
      sym__conid,
    ACTIONS(4931), 1,
      anon_sym_AT,
    ACTIONS(9434), 1,
      sym_hole,
    STATE(3030), 1,
      sym_constructor,
    STATE(3141), 1,
      sym_integer,
    STATE(5287), 1,
      sym_type_apply,
    STATE(7984), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3132), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(974), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [126286] = 19,
    ACTIONS(3769), 1,
      sym__varid,
    ACTIONS(3771), 1,
      sym_string,
    ACTIONS(3773), 1,
      sym_triple_quote_string,
    ACTIONS(3775), 1,
      sym__integer_literal,
    ACTIONS(3777), 1,
      sym__hex_literal,
    ACTIONS(3779), 1,
      anon_sym__,
    ACTIONS(3783), 1,
      anon_sym_LPAREN,
    ACTIONS(3788), 1,
      anon_sym_LBRACE,
    ACTIONS(4794), 1,
      sym__conid,
    ACTIONS(4796), 1,
      anon_sym_AT,
    ACTIONS(9436), 1,
      sym_hole,
    STATE(3100), 1,
      sym_constructor,
    STATE(3231), 1,
      sym_integer,
    STATE(5596), 1,
      sym_type_apply,
    STATE(7987), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3256), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(979), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [126357] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126396] = 4,
    ACTIONS(9438), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126437] = 5,
    ACTIONS(9441), 1,
      sym__immediate_dot,
    STATE(2152), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126480] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126519] = 19,
    ACTIONS(4470), 1,
      sym__varid,
    ACTIONS(4472), 1,
      sym_string,
    ACTIONS(4474), 1,
      sym_triple_quote_string,
    ACTIONS(4476), 1,
      sym__integer_literal,
    ACTIONS(4478), 1,
      sym__hex_literal,
    ACTIONS(4480), 1,
      anon_sym__,
    ACTIONS(4484), 1,
      anon_sym_LPAREN,
    ACTIONS(4489), 1,
      anon_sym_LBRACE,
    ACTIONS(4786), 1,
      sym__conid,
    ACTIONS(4788), 1,
      anon_sym_AT,
    ACTIONS(9444), 1,
      sym_hole,
    STATE(3066), 1,
      sym_constructor,
    STATE(3191), 1,
      sym_integer,
    STATE(5644), 1,
      sym_type_apply,
    STATE(7995), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3197), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1023), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [126590] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126629] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126668] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
      anon_sym_AT2,
  [126707] = 4,
    ACTIONS(9446), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126748] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126787] = 19,
    ACTIONS(5351), 1,
      sym__varid,
    ACTIONS(5353), 1,
      sym_string,
    ACTIONS(5355), 1,
      sym_triple_quote_string,
    ACTIONS(5357), 1,
      sym__integer_literal,
    ACTIONS(5359), 1,
      sym__hex_literal,
    ACTIONS(5361), 1,
      anon_sym__,
    ACTIONS(5365), 1,
      anon_sym_LPAREN,
    ACTIONS(5367), 1,
      sym__conid,
    ACTIONS(5369), 1,
      anon_sym_LBRACE,
    ACTIONS(5371), 1,
      anon_sym_AT,
    ACTIONS(9448), 1,
      sym_hole,
    STATE(3293), 1,
      sym_constructor,
    STATE(3665), 1,
      sym_integer,
    STATE(6260), 1,
      sym_type_apply,
    STATE(8002), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3646), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1337), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [126858] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [126897] = 19,
    ACTIONS(4715), 1,
      sym__varid,
    ACTIONS(4717), 1,
      sym_string,
    ACTIONS(4719), 1,
      sym_triple_quote_string,
    ACTIONS(4721), 1,
      sym__integer_literal,
    ACTIONS(4723), 1,
      sym__hex_literal,
    ACTIONS(4725), 1,
      anon_sym__,
    ACTIONS(4729), 1,
      anon_sym_LPAREN,
    ACTIONS(4731), 1,
      sym__conid,
    ACTIONS(4733), 1,
      anon_sym_LBRACE,
    ACTIONS(4735), 1,
      anon_sym_AT,
    ACTIONS(9450), 1,
      sym_hole,
    STATE(3998), 1,
      sym_constructor,
    STATE(4172), 1,
      sym_integer,
    STATE(6859), 1,
      sym_type_apply,
    STATE(7738), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4170), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1441), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [126968] = 4,
    ACTIONS(9452), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [127009] = 19,
    ACTIONS(4737), 1,
      sym__varid,
    ACTIONS(4739), 1,
      sym_string,
    ACTIONS(4741), 1,
      sym_triple_quote_string,
    ACTIONS(4743), 1,
      sym__integer_literal,
    ACTIONS(4745), 1,
      sym__hex_literal,
    ACTIONS(4747), 1,
      anon_sym__,
    ACTIONS(4751), 1,
      anon_sym_LPAREN,
    ACTIONS(4753), 1,
      sym__conid,
    ACTIONS(4755), 1,
      anon_sym_LBRACE,
    ACTIONS(4757), 1,
      anon_sym_AT,
    ACTIONS(9454), 1,
      sym_hole,
    STATE(3621), 1,
      sym_constructor,
    STATE(3828), 1,
      sym_integer,
    STATE(5914), 1,
      sym_type_apply,
    STATE(8026), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3790), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1392), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [127080] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [127121] = 19,
    ACTIONS(4883), 1,
      sym__varid,
    ACTIONS(4885), 1,
      sym_string,
    ACTIONS(4887), 1,
      sym_triple_quote_string,
    ACTIONS(4889), 1,
      sym__integer_literal,
    ACTIONS(4891), 1,
      sym__hex_literal,
    ACTIONS(4893), 1,
      anon_sym__,
    ACTIONS(4897), 1,
      anon_sym_LPAREN,
    ACTIONS(4899), 1,
      sym__conid,
    ACTIONS(4901), 1,
      anon_sym_LBRACE,
    ACTIONS(4903), 1,
      anon_sym_AT,
    ACTIONS(9456), 1,
      sym_hole,
    STATE(4236), 1,
      sym_constructor,
    STATE(4381), 1,
      sym_integer,
    STATE(7078), 1,
      sym_type_apply,
    STATE(8032), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4382), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1451), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [127192] = 19,
    ACTIONS(3116), 1,
      sym__varid,
    ACTIONS(3118), 1,
      sym_string,
    ACTIONS(3120), 1,
      sym_triple_quote_string,
    ACTIONS(3122), 1,
      sym__integer_literal,
    ACTIONS(3124), 1,
      sym__hex_literal,
    ACTIONS(3126), 1,
      anon_sym__,
    ACTIONS(3130), 1,
      anon_sym_LPAREN,
    ACTIONS(3132), 1,
      sym__conid,
    ACTIONS(3134), 1,
      anon_sym_LBRACE,
    ACTIONS(3136), 1,
      anon_sym_AT,
    ACTIONS(9458), 1,
      sym_hole,
    STATE(4007), 1,
      sym_constructor,
    STATE(4137), 1,
      sym_integer,
    STATE(4248), 1,
      sym_type_apply,
    STATE(7797), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4135), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1409), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [127263] = 19,
    ACTIONS(5122), 1,
      sym__varid,
    ACTIONS(5124), 1,
      sym_string,
    ACTIONS(5126), 1,
      sym_triple_quote_string,
    ACTIONS(5128), 1,
      sym__integer_literal,
    ACTIONS(5130), 1,
      sym__hex_literal,
    ACTIONS(5132), 1,
      anon_sym__,
    ACTIONS(5136), 1,
      anon_sym_LPAREN,
    ACTIONS(5138), 1,
      sym__conid,
    ACTIONS(5140), 1,
      anon_sym_LBRACE,
    ACTIONS(5142), 1,
      anon_sym_AT,
    ACTIONS(9460), 1,
      sym_hole,
    STATE(3166), 1,
      sym_constructor,
    STATE(3413), 1,
      sym_integer,
    STATE(5919), 1,
      sym_type_apply,
    STATE(7965), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3396), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1260), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [127334] = 19,
    ACTIONS(5148), 1,
      sym__varid,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5162), 1,
      anon_sym_LPAREN,
    ACTIONS(5164), 1,
      sym__conid,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(5168), 1,
      anon_sym_AT,
    ACTIONS(9462), 1,
      sym_hole,
    STATE(4315), 1,
      sym_constructor,
    STATE(4405), 1,
      sym_integer,
    STATE(7307), 1,
      sym_type_apply,
    STATE(7630), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4352), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1475), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [127405] = 4,
    ACTIONS(9464), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 11,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [127446] = 19,
    ACTIONS(2628), 1,
      sym__varid,
    ACTIONS(2630), 1,
      sym_string,
    ACTIONS(2632), 1,
      sym_triple_quote_string,
    ACTIONS(2634), 1,
      sym__integer_literal,
    ACTIONS(2636), 1,
      sym__hex_literal,
    ACTIONS(2638), 1,
      anon_sym__,
    ACTIONS(2642), 1,
      anon_sym_LPAREN,
    ACTIONS(2644), 1,
      sym__conid,
    ACTIONS(2646), 1,
      anon_sym_LBRACE,
    ACTIONS(2648), 1,
      anon_sym_AT,
    ACTIONS(9467), 1,
      sym_hole,
    STATE(3352), 1,
      sym_constructor,
    STATE(3450), 1,
      sym_type_apply,
    STATE(3475), 1,
      sym_integer,
    STATE(7569), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3459), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1358), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [127517] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [127556] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [127595] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [127634] = 19,
    ACTIONS(5098), 1,
      sym__varid,
    ACTIONS(5100), 1,
      sym_string,
    ACTIONS(5102), 1,
      sym_triple_quote_string,
    ACTIONS(5104), 1,
      sym__integer_literal,
    ACTIONS(5106), 1,
      sym__hex_literal,
    ACTIONS(5108), 1,
      anon_sym__,
    ACTIONS(5112), 1,
      anon_sym_LPAREN,
    ACTIONS(5114), 1,
      sym__conid,
    ACTIONS(5116), 1,
      anon_sym_LBRACE,
    ACTIONS(5118), 1,
      anon_sym_AT,
    ACTIONS(9469), 1,
      sym_hole,
    STATE(3715), 1,
      sym_constructor,
    STATE(3744), 1,
      sym_integer,
    STATE(6666), 1,
      sym_type_apply,
    STATE(7592), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3757), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1378), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [127705] = 19,
    ACTIONS(5009), 1,
      sym__varid,
    ACTIONS(5011), 1,
      sym_string,
    ACTIONS(5013), 1,
      sym_triple_quote_string,
    ACTIONS(5015), 1,
      sym__integer_literal,
    ACTIONS(5017), 1,
      sym__hex_literal,
    ACTIONS(5019), 1,
      anon_sym__,
    ACTIONS(5023), 1,
      anon_sym_LPAREN,
    ACTIONS(5028), 1,
      anon_sym_LBRACE,
    ACTIONS(5264), 1,
      sym__conid,
    ACTIONS(5266), 1,
      anon_sym_AT,
    ACTIONS(9471), 1,
      sym_hole,
    STATE(3154), 1,
      sym_constructor,
    STATE(3407), 1,
      sym_integer,
    STATE(5916), 1,
      sym_type_apply,
    STATE(8034), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3410), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1203), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [127776] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8338), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [127815] = 19,
    ACTIONS(2446), 1,
      sym__varid,
    ACTIONS(2448), 1,
      sym_string,
    ACTIONS(2450), 1,
      sym_triple_quote_string,
    ACTIONS(2452), 1,
      sym__integer_literal,
    ACTIONS(2454), 1,
      sym__hex_literal,
    ACTIONS(2456), 1,
      anon_sym__,
    ACTIONS(2460), 1,
      anon_sym_LPAREN,
    ACTIONS(2462), 1,
      sym__conid,
    ACTIONS(2464), 1,
      anon_sym_LBRACE,
    ACTIONS(2466), 1,
      anon_sym_AT,
    ACTIONS(9473), 1,
      sym_hole,
    STATE(3107), 1,
      sym_constructor,
    STATE(3171), 1,
      sym_type_apply,
    STATE(3261), 1,
      sym_integer,
    STATE(7604), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3255), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(988), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [127886] = 4,
    ACTIONS(9475), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [127927] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [127966] = 19,
    ACTIONS(5423), 1,
      sym__varid,
    ACTIONS(5425), 1,
      sym_string,
    ACTIONS(5427), 1,
      sym_triple_quote_string,
    ACTIONS(5429), 1,
      sym__integer_literal,
    ACTIONS(5431), 1,
      sym__hex_literal,
    ACTIONS(5433), 1,
      anon_sym__,
    ACTIONS(5437), 1,
      anon_sym_LPAREN,
    ACTIONS(5439), 1,
      sym__conid,
    ACTIONS(5441), 1,
      anon_sym_LBRACE,
    ACTIONS(5443), 1,
      anon_sym_AT,
    ACTIONS(9477), 1,
      sym_hole,
    STATE(3476), 1,
      sym_constructor,
    STATE(3970), 1,
      sym_integer,
    STATE(6474), 1,
      sym_type_apply,
    STATE(8010), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3962), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1379), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [128037] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128076] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128115] = 19,
    ACTIONS(5588), 1,
      sym__varid,
    ACTIONS(5590), 1,
      sym_string,
    ACTIONS(5592), 1,
      sym_triple_quote_string,
    ACTIONS(5594), 1,
      sym__integer_literal,
    ACTIONS(5596), 1,
      sym__hex_literal,
    ACTIONS(5598), 1,
      anon_sym__,
    ACTIONS(5602), 1,
      anon_sym_LPAREN,
    ACTIONS(5604), 1,
      sym__conid,
    ACTIONS(5606), 1,
      anon_sym_LBRACE,
    ACTIONS(5608), 1,
      anon_sym_AT,
    ACTIONS(9479), 1,
      sym_hole,
    STATE(3517), 1,
      sym_constructor,
    STATE(4003), 1,
      sym_integer,
    STATE(6435), 1,
      sym_type_apply,
    STATE(7996), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4001), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1389), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [128186] = 4,
    ACTIONS(9481), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128227] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128266] = 19,
    ACTIONS(3307), 1,
      sym__varid,
    ACTIONS(3309), 1,
      sym_string,
    ACTIONS(3311), 1,
      sym_triple_quote_string,
    ACTIONS(3313), 1,
      sym__integer_literal,
    ACTIONS(3315), 1,
      sym__hex_literal,
    ACTIONS(3319), 1,
      anon_sym__,
    ACTIONS(3323), 1,
      anon_sym_LPAREN,
    ACTIONS(3328), 1,
      anon_sym_LBRACE,
    ACTIONS(5683), 1,
      sym__conid,
    ACTIONS(5685), 1,
      anon_sym_AT,
    ACTIONS(9483), 1,
      sym_hole,
    STATE(3036), 1,
      sym_constructor,
    STATE(3142), 1,
      sym_integer,
    STATE(5369), 1,
      sym_type_apply,
    STATE(7963), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3079), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(969), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [128337] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8802), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128376] = 9,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8874), 1,
      anon_sym_RPAREN,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(9487), 1,
      anon_sym_AT2,
    STATE(2384), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8110), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8106), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 12,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128427] = 4,
    ACTIONS(8894), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128468] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128507] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128546] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128585] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128624] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128663] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128702] = 4,
    ACTIONS(9489), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128743] = 19,
    ACTIONS(5789), 1,
      sym__varid,
    ACTIONS(5791), 1,
      sym_string,
    ACTIONS(5793), 1,
      sym_triple_quote_string,
    ACTIONS(5795), 1,
      sym__integer_literal,
    ACTIONS(5797), 1,
      sym__hex_literal,
    ACTIONS(5799), 1,
      anon_sym__,
    ACTIONS(5803), 1,
      anon_sym_LPAREN,
    ACTIONS(5805), 1,
      sym__conid,
    ACTIONS(5807), 1,
      anon_sym_LBRACE,
    ACTIONS(5809), 1,
      anon_sym_AT,
    ACTIONS(9491), 1,
      sym_hole,
    STATE(4063), 1,
      sym_constructor,
    STATE(4098), 1,
      sym_integer,
    STATE(6927), 1,
      sym_type_apply,
    STATE(7949), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4096), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1417), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [128814] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128855] = 19,
    ACTIONS(5469), 1,
      sym__varid,
    ACTIONS(5471), 1,
      sym_string,
    ACTIONS(5473), 1,
      sym_triple_quote_string,
    ACTIONS(5475), 1,
      sym__integer_literal,
    ACTIONS(5477), 1,
      sym__hex_literal,
    ACTIONS(5479), 1,
      anon_sym__,
    ACTIONS(5483), 1,
      anon_sym_LPAREN,
    ACTIONS(5485), 1,
      sym__conid,
    ACTIONS(5487), 1,
      anon_sym_LBRACE,
    ACTIONS(5489), 1,
      anon_sym_AT,
    ACTIONS(9493), 1,
      sym_hole,
    STATE(3811), 1,
      sym_constructor,
    STATE(4280), 1,
      sym_integer,
    STATE(6738), 1,
      sym_type_apply,
    STATE(8007), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4282), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1413), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [128926] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [128965] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129004] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129043] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129084] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 20,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129123] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129162] = 19,
    ACTIONS(4693), 1,
      sym__varid,
    ACTIONS(4695), 1,
      sym_string,
    ACTIONS(4697), 1,
      sym_triple_quote_string,
    ACTIONS(4699), 1,
      sym__integer_literal,
    ACTIONS(4701), 1,
      sym__hex_literal,
    ACTIONS(4703), 1,
      anon_sym__,
    ACTIONS(4707), 1,
      anon_sym_LPAREN,
    ACTIONS(4709), 1,
      sym__conid,
    ACTIONS(4711), 1,
      anon_sym_LBRACE,
    ACTIONS(4713), 1,
      anon_sym_AT,
    ACTIONS(9495), 1,
      sym_hole,
    STATE(3275), 1,
      sym_constructor,
    STATE(3714), 1,
      sym_integer,
    STATE(5742), 1,
      sym_type_apply,
    STATE(7884), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3723), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1287), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [129233] = 19,
    ACTIONS(5562), 1,
      sym__varid,
    ACTIONS(5564), 1,
      sym_string,
    ACTIONS(5566), 1,
      sym_triple_quote_string,
    ACTIONS(5568), 1,
      sym__integer_literal,
    ACTIONS(5570), 1,
      sym__hex_literal,
    ACTIONS(5572), 1,
      anon_sym__,
    ACTIONS(5576), 1,
      anon_sym_LPAREN,
    ACTIONS(5578), 1,
      sym__conid,
    ACTIONS(5580), 1,
      anon_sym_LBRACE,
    ACTIONS(5582), 1,
      anon_sym_AT,
    ACTIONS(9497), 1,
      sym_hole,
    STATE(3151), 1,
      sym_constructor,
    STATE(3421), 1,
      sym_integer,
    STATE(5742), 1,
      sym_type_apply,
    STATE(7849), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3429), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1194), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [129304] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129343] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129382] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129421] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129460] = 19,
    ACTIONS(5659), 1,
      sym__varid,
    ACTIONS(5661), 1,
      sym_string,
    ACTIONS(5663), 1,
      sym_triple_quote_string,
    ACTIONS(5665), 1,
      sym__integer_literal,
    ACTIONS(5667), 1,
      sym__hex_literal,
    ACTIONS(5669), 1,
      anon_sym__,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5675), 1,
      sym__conid,
    ACTIONS(5677), 1,
      anon_sym_LBRACE,
    ACTIONS(5679), 1,
      anon_sym_AT,
    ACTIONS(9499), 1,
      sym_hole,
    STATE(3648), 1,
      sym_constructor,
    STATE(4032), 1,
      sym_integer,
    STATE(5914), 1,
      sym_type_apply,
    STATE(7861), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4034), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1407), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [129531] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129570] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129609] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129648] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129687] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129726] = 19,
    ACTIONS(4798), 1,
      sym__varid,
    ACTIONS(4800), 1,
      sym_string,
    ACTIONS(4802), 1,
      sym_triple_quote_string,
    ACTIONS(4804), 1,
      sym__integer_literal,
    ACTIONS(4806), 1,
      sym__hex_literal,
    ACTIONS(4808), 1,
      anon_sym__,
    ACTIONS(4812), 1,
      anon_sym_LPAREN,
    ACTIONS(4814), 1,
      sym__conid,
    ACTIONS(4816), 1,
      anon_sym_LBRACE,
    ACTIONS(4818), 1,
      anon_sym_AT,
    ACTIONS(9501), 1,
      sym_hole,
    STATE(3840), 1,
      sym_constructor,
    STATE(4311), 1,
      sym_integer,
    STATE(6816), 1,
      sym_type_apply,
    STATE(7967), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4313), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1414), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [129797] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129836] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129875] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [129914] = 18,
    ACTIONS(995), 1,
      sym__integer_literal,
    ACTIONS(997), 1,
      sym__hex_literal,
    ACTIONS(1255), 1,
      sym__conid,
    ACTIONS(9503), 1,
      sym__varid,
    ACTIONS(9505), 1,
      sym_string,
    ACTIONS(9507), 1,
      sym_triple_quote_string,
    ACTIONS(9509), 1,
      anon_sym__,
    ACTIONS(9511), 1,
      sym_hole,
    ACTIONS(9513), 1,
      anon_sym_LPAREN,
    ACTIONS(9515), 1,
      anon_sym_LBRACE,
    ACTIONS(9517), 1,
      anon_sym_AT,
    STATE(2199), 1,
      sym_constructor,
    STATE(2279), 1,
      sym_integer,
    STATE(7656), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2271), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2512), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [129982] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130020] = 18,
    ACTIONS(897), 1,
      sym__integer_literal,
    ACTIONS(899), 1,
      sym__hex_literal,
    ACTIONS(905), 1,
      sym__conid,
    ACTIONS(9519), 1,
      sym__varid,
    ACTIONS(9521), 1,
      sym_string,
    ACTIONS(9523), 1,
      sym_triple_quote_string,
    ACTIONS(9525), 1,
      anon_sym__,
    ACTIONS(9527), 1,
      sym_hole,
    ACTIONS(9529), 1,
      anon_sym_LPAREN,
    ACTIONS(9531), 1,
      anon_sym_LBRACE,
    ACTIONS(9533), 1,
      anon_sym_AT,
    STATE(2119), 1,
      sym_constructor,
    STATE(2346), 1,
      sym_integer,
    STATE(7677), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2418), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2419), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [130088] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130126] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130164] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130202] = 18,
    ACTIONS(2224), 1,
      sym__integer_literal,
    ACTIONS(2226), 1,
      sym__hex_literal,
    ACTIONS(2232), 1,
      sym__conid,
    ACTIONS(9535), 1,
      sym__varid,
    ACTIONS(9537), 1,
      sym_string,
    ACTIONS(9539), 1,
      sym_triple_quote_string,
    ACTIONS(9541), 1,
      anon_sym__,
    ACTIONS(9543), 1,
      sym_hole,
    ACTIONS(9545), 1,
      anon_sym_LPAREN,
    ACTIONS(9547), 1,
      anon_sym_LBRACE,
    ACTIONS(9549), 1,
      anon_sym_AT,
    STATE(4931), 1,
      sym_constructor,
    STATE(5245), 1,
      sym_integer,
    STATE(7991), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5242), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(5116), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [130270] = 4,
    ACTIONS(9551), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130310] = 5,
    ACTIONS(9553), 1,
      sym__immediate_dot,
    STATE(2231), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130352] = 18,
    ACTIONS(1536), 1,
      sym__integer_literal,
    ACTIONS(1538), 1,
      sym__hex_literal,
    ACTIONS(1649), 1,
      sym__conid,
    ACTIONS(9556), 1,
      sym__varid,
    ACTIONS(9558), 1,
      sym_string,
    ACTIONS(9560), 1,
      sym_triple_quote_string,
    ACTIONS(9562), 1,
      anon_sym__,
    ACTIONS(9564), 1,
      sym_hole,
    ACTIONS(9566), 1,
      anon_sym_LPAREN,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(9570), 1,
      anon_sym_AT,
    STATE(2670), 1,
      sym_constructor,
    STATE(2779), 1,
      sym_integer,
    STATE(7997), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2758), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2822), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [130420] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
      anon_sym_AT2,
  [130458] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130496] = 4,
    ACTIONS(9572), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130536] = 4,
    ACTIONS(9574), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130576] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130614] = 18,
    ACTIONS(2136), 1,
      sym__integer_literal,
    ACTIONS(2138), 1,
      sym__hex_literal,
    ACTIONS(2142), 1,
      sym__conid,
    ACTIONS(9576), 1,
      sym__varid,
    ACTIONS(9578), 1,
      sym_string,
    ACTIONS(9580), 1,
      sym_triple_quote_string,
    ACTIONS(9582), 1,
      anon_sym__,
    ACTIONS(9584), 1,
      sym_hole,
    ACTIONS(9586), 1,
      anon_sym_LPAREN,
    ACTIONS(9588), 1,
      anon_sym_LBRACE,
    ACTIONS(9590), 1,
      anon_sym_AT,
    STATE(5562), 1,
      sym_constructor,
    STATE(6000), 1,
      sym_integer,
    STATE(7616), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(6174), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(6046), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [130682] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130720] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130758] = 5,
    ACTIONS(9592), 1,
      sym__immediate_dot,
    STATE(2231), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130800] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130838] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130876] = 5,
    ACTIONS(9592), 1,
      sym__immediate_dot,
    STATE(2231), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130918] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [130956] = 18,
    ACTIONS(1331), 1,
      sym__integer_literal,
    ACTIONS(1333), 1,
      sym__hex_literal,
    ACTIONS(1343), 1,
      sym__conid,
    ACTIONS(9594), 1,
      sym__varid,
    ACTIONS(9596), 1,
      sym_string,
    ACTIONS(9598), 1,
      sym_triple_quote_string,
    ACTIONS(9600), 1,
      anon_sym__,
    ACTIONS(9602), 1,
      sym_hole,
    ACTIONS(9604), 1,
      anon_sym_LPAREN,
    ACTIONS(9606), 1,
      anon_sym_LBRACE,
    ACTIONS(9608), 1,
      anon_sym_AT,
    STATE(2502), 1,
      sym_constructor,
    STATE(2557), 1,
      sym_integer,
    STATE(7575), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2527), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2620), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [131024] = 5,
    ACTIONS(9592), 1,
      sym__immediate_dot,
    STATE(2231), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131066] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131104] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131144] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(9610), 1,
      sym__immediate_dot,
    STATE(2263), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131188] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(9610), 1,
      sym__immediate_dot,
    STATE(2267), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131232] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131270] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9156), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131308] = 18,
    ACTIONS(658), 1,
      sym__integer_literal,
    ACTIONS(660), 1,
      sym__hex_literal,
    ACTIONS(1432), 1,
      sym__conid,
    ACTIONS(9612), 1,
      sym__varid,
    ACTIONS(9614), 1,
      sym_string,
    ACTIONS(9616), 1,
      sym_triple_quote_string,
    ACTIONS(9618), 1,
      anon_sym__,
    ACTIONS(9620), 1,
      sym_hole,
    ACTIONS(9622), 1,
      anon_sym_LPAREN,
    ACTIONS(9624), 1,
      anon_sym_LBRACE,
    ACTIONS(9626), 1,
      anon_sym_AT,
    STATE(1646), 1,
      sym_constructor,
    STATE(1894), 1,
      sym_integer,
    STATE(7954), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1903), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1934), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [131376] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131414] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(9592), 1,
      sym__immediate_dot,
    STATE(2241), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131458] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(9592), 1,
      sym__immediate_dot,
    STATE(2247), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131502] = 4,
    ACTIONS(9628), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131542] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131582] = 18,
    ACTIONS(2354), 1,
      sym__integer_literal,
    ACTIONS(2356), 1,
      sym__hex_literal,
    ACTIONS(2362), 1,
      sym__conid,
    ACTIONS(9630), 1,
      sym__varid,
    ACTIONS(9632), 1,
      sym_string,
    ACTIONS(9634), 1,
      sym_triple_quote_string,
    ACTIONS(9636), 1,
      anon_sym__,
    ACTIONS(9638), 1,
      sym_hole,
    ACTIONS(9640), 1,
      anon_sym_LPAREN,
    ACTIONS(9642), 1,
      anon_sym_LBRACE,
    ACTIONS(9644), 1,
      anon_sym_AT,
    STATE(4989), 1,
      sym_constructor,
    STATE(5089), 1,
      sym_integer,
    STATE(8005), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5091), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(5081), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [131650] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131688] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9279), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131726] = 5,
    ACTIONS(9610), 1,
      sym__immediate_dot,
    STATE(2297), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131768] = 5,
    ACTIONS(9610), 1,
      sym__immediate_dot,
    STATE(2297), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131810] = 6,
    ACTIONS(8106), 2,
      sym_comma,
      sym_hole,
    ACTIONS(9197), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9191), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9194), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 10,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131854] = 5,
    ACTIONS(9199), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9201), 3,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8415), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8413), 14,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131896] = 5,
    ACTIONS(9610), 1,
      sym__immediate_dot,
    STATE(2297), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131938] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [131976] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132014] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132052] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132090] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132128] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132166] = 18,
    ACTIONS(2380), 1,
      sym__integer_literal,
    ACTIONS(2382), 1,
      sym__hex_literal,
    ACTIONS(2386), 1,
      sym__conid,
    ACTIONS(9646), 1,
      sym__varid,
    ACTIONS(9648), 1,
      sym_string,
    ACTIONS(9650), 1,
      sym_triple_quote_string,
    ACTIONS(9652), 1,
      anon_sym__,
    ACTIONS(9654), 1,
      sym_hole,
    ACTIONS(9656), 1,
      anon_sym_LPAREN,
    ACTIONS(9658), 1,
      anon_sym_LBRACE,
    ACTIONS(9660), 1,
      anon_sym_AT,
    STATE(6267), 1,
      sym_constructor,
    STATE(6532), 1,
      sym_integer,
    STATE(8008), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(6538), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(6484), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [132234] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132272] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132310] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132348] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132386] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132424] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9224), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132462] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132500] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132538] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132576] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132614] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132652] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132690] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132728] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132766] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132804] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132842] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132880] = 5,
    ACTIONS(9260), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9262), 3,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9222), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 14,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132922] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132960] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [132998] = 5,
    ACTIONS(8993), 1,
      sym__immediate_dot,
    STATE(2416), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133040] = 18,
    ACTIONS(937), 1,
      sym__integer_literal,
    ACTIONS(939), 1,
      sym__hex_literal,
    ACTIONS(1375), 1,
      sym__conid,
    ACTIONS(9662), 1,
      sym__varid,
    ACTIONS(9664), 1,
      sym_string,
    ACTIONS(9666), 1,
      sym_triple_quote_string,
    ACTIONS(9668), 1,
      anon_sym__,
    ACTIONS(9670), 1,
      sym_hole,
    ACTIONS(9672), 1,
      anon_sym_LPAREN,
    ACTIONS(9674), 1,
      anon_sym_LBRACE,
    ACTIONS(9676), 1,
      anon_sym_AT,
    STATE(2101), 1,
      sym_constructor,
    STATE(2511), 1,
      sym_integer,
    STATE(7978), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2451), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2234), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [133108] = 5,
    ACTIONS(9678), 1,
      sym__immediate_dot,
    STATE(2297), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133150] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133188] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133226] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133264] = 18,
    ACTIONS(863), 1,
      sym__integer_literal,
    ACTIONS(865), 1,
      sym__hex_literal,
    ACTIONS(873), 1,
      sym__conid,
    ACTIONS(9681), 1,
      sym__varid,
    ACTIONS(9683), 1,
      sym_string,
    ACTIONS(9685), 1,
      sym_triple_quote_string,
    ACTIONS(9687), 1,
      anon_sym__,
    ACTIONS(9689), 1,
      sym_hole,
    ACTIONS(9691), 1,
      anon_sym_LPAREN,
    ACTIONS(9693), 1,
      anon_sym_LBRACE,
    ACTIONS(9695), 1,
      anon_sym_AT,
    STATE(2493), 1,
      sym_constructor,
    STATE(2627), 1,
      sym_integer,
    STATE(7892), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2640), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2535), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [133332] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133370] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133408] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133446] = 4,
    ACTIONS(9697), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133486] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133524] = 18,
    ACTIONS(2302), 1,
      sym__integer_literal,
    ACTIONS(2304), 1,
      sym__hex_literal,
    ACTIONS(2310), 1,
      sym__conid,
    ACTIONS(9699), 1,
      sym__varid,
    ACTIONS(9701), 1,
      sym_string,
    ACTIONS(9703), 1,
      sym_triple_quote_string,
    ACTIONS(9705), 1,
      anon_sym__,
    ACTIONS(9707), 1,
      sym_hole,
    ACTIONS(9709), 1,
      anon_sym_LPAREN,
    ACTIONS(9711), 1,
      anon_sym_LBRACE,
    ACTIONS(9713), 1,
      anon_sym_AT,
    STATE(5227), 1,
      sym_constructor,
    STATE(5687), 1,
      sym_integer,
    STATE(7951), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5691), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(5539), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [133592] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133630] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133668] = 18,
    ACTIONS(2154), 1,
      sym__integer_literal,
    ACTIONS(2156), 1,
      sym__hex_literal,
    ACTIONS(2162), 1,
      sym__conid,
    ACTIONS(9715), 1,
      sym__varid,
    ACTIONS(9717), 1,
      sym_string,
    ACTIONS(9719), 1,
      sym_triple_quote_string,
    ACTIONS(9721), 1,
      anon_sym__,
    ACTIONS(9723), 1,
      sym_hole,
    ACTIONS(9725), 1,
      anon_sym_LPAREN,
    ACTIONS(9727), 1,
      anon_sym_LBRACE,
    ACTIONS(9729), 1,
      anon_sym_AT,
    STATE(4982), 1,
      sym_constructor,
    STATE(5264), 1,
      sym_integer,
    STATE(7609), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5321), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(5301), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [133736] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9228), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133774] = 18,
    ACTIONS(2398), 1,
      sym__integer_literal,
    ACTIONS(2400), 1,
      sym__hex_literal,
    ACTIONS(2406), 1,
      sym__conid,
    ACTIONS(9731), 1,
      sym__varid,
    ACTIONS(9733), 1,
      sym_string,
    ACTIONS(9735), 1,
      sym_triple_quote_string,
    ACTIONS(9737), 1,
      anon_sym__,
    ACTIONS(9739), 1,
      sym_hole,
    ACTIONS(9741), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      anon_sym_LBRACE,
    ACTIONS(9745), 1,
      anon_sym_AT,
    STATE(5765), 1,
      sym_constructor,
    STATE(5841), 1,
      sym_integer,
    STATE(7971), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5837), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(6122), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [133842] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133880] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133918] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9160), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133956] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [133994] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134032] = 18,
    ACTIONS(1768), 1,
      sym__integer_literal,
    ACTIONS(1770), 1,
      sym__hex_literal,
    ACTIONS(1776), 1,
      sym__conid,
    ACTIONS(9747), 1,
      sym__varid,
    ACTIONS(9749), 1,
      sym_string,
    ACTIONS(9751), 1,
      sym_triple_quote_string,
    ACTIONS(9753), 1,
      anon_sym__,
    ACTIONS(9755), 1,
      sym_hole,
    ACTIONS(9757), 1,
      anon_sym_LPAREN,
    ACTIONS(9759), 1,
      anon_sym_LBRACE,
    ACTIONS(9761), 1,
      anon_sym_AT,
    STATE(5295), 1,
      sym_constructor,
    STATE(5730), 1,
      sym_integer,
    STATE(7767), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5728), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(5424), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [134100] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134138] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134176] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9292), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134214] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134252] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134290] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134328] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134366] = 18,
    ACTIONS(2328), 1,
      sym__integer_literal,
    ACTIONS(2330), 1,
      sym__hex_literal,
    ACTIONS(2336), 1,
      sym__conid,
    ACTIONS(9763), 1,
      sym__varid,
    ACTIONS(9765), 1,
      sym_string,
    ACTIONS(9767), 1,
      sym_triple_quote_string,
    ACTIONS(9769), 1,
      anon_sym__,
    ACTIONS(9771), 1,
      sym_hole,
    ACTIONS(9773), 1,
      anon_sym_LPAREN,
    ACTIONS(9775), 1,
      anon_sym_LBRACE,
    ACTIONS(9777), 1,
      anon_sym_AT,
    STATE(5304), 1,
      sym_constructor,
    STATE(5404), 1,
      sym_integer,
    STATE(7928), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5402), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(5772), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [134434] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134472] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134510] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134548] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134586] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9240), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134624] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9210), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134662] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9327), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134700] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134738] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134776] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134814] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134852] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134890] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9133), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134928] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [134966] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135004] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135042] = 4,
    ACTIONS(9779), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135082] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135120] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135158] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135196] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135234] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135272] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135310] = 4,
    ACTIONS(9781), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135350] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135388] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135426] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135464] = 5,
    ACTIONS(9783), 1,
      sym__immediate_dot,
    STATE(2354), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135506] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9170), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135544] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9214), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135582] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9218), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135620] = 4,
    ACTIONS(9786), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135660] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9184), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135698] = 5,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    STATE(2354), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135740] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135778] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135816] = 4,
    ACTIONS(9788), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135856] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135894] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135932] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [135970] = 4,
    ACTIONS(9790), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136010] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136048] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136086] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136124] = 18,
    ACTIONS(2276), 1,
      sym__integer_literal,
    ACTIONS(2278), 1,
      sym__hex_literal,
    ACTIONS(2282), 1,
      sym__conid,
    ACTIONS(9792), 1,
      sym__varid,
    ACTIONS(9794), 1,
      sym_string,
    ACTIONS(9796), 1,
      sym_triple_quote_string,
    ACTIONS(9798), 1,
      anon_sym__,
    ACTIONS(9800), 1,
      sym_hole,
    ACTIONS(9802), 1,
      anon_sym_LPAREN,
    ACTIONS(9804), 1,
      anon_sym_LBRACE,
    ACTIONS(9806), 1,
      anon_sym_AT,
    STATE(5581), 1,
      sym_constructor,
    STATE(6047), 1,
      sym_integer,
    STATE(7601), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5993), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(5902), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [136192] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136230] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136270] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9273), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136308] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9277), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136346] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136386] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9244), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136424] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136464] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136502] = 18,
    ACTIONS(1299), 1,
      sym__integer_literal,
    ACTIONS(1301), 1,
      sym__hex_literal,
    ACTIONS(1307), 1,
      sym__conid,
    ACTIONS(9808), 1,
      sym__varid,
    ACTIONS(9810), 1,
      sym_string,
    ACTIONS(9812), 1,
      sym_triple_quote_string,
    ACTIONS(9814), 1,
      anon_sym__,
    ACTIONS(9816), 1,
      sym_hole,
    ACTIONS(9818), 1,
      anon_sym_LPAREN,
    ACTIONS(9820), 1,
      anon_sym_LBRACE,
    ACTIONS(9822), 1,
      anon_sym_AT,
    STATE(2586), 1,
      sym_constructor,
    STATE(2835), 1,
      sym_integer,
    STATE(7828), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2845), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2842), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [136570] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136608] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136646] = 18,
    ACTIONS(2180), 1,
      sym__integer_literal,
    ACTIONS(2182), 1,
      sym__hex_literal,
    ACTIONS(2186), 1,
      sym__conid,
    ACTIONS(9824), 1,
      sym__varid,
    ACTIONS(9826), 1,
      sym_string,
    ACTIONS(9828), 1,
      sym_triple_quote_string,
    ACTIONS(9830), 1,
      anon_sym__,
    ACTIONS(9832), 1,
      sym_hole,
    ACTIONS(9834), 1,
      anon_sym_LPAREN,
    ACTIONS(9836), 1,
      anon_sym_LBRACE,
    ACTIONS(9838), 1,
      anon_sym_AT,
    STATE(6489), 1,
      sym_constructor,
    STATE(6867), 1,
      sym_integer,
    STATE(7634), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(6870), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(6794), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [136714] = 5,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    STATE(2354), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136756] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9232), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136794] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136834] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136872] = 18,
    ACTIONS(1686), 1,
      sym__integer_literal,
    ACTIONS(1688), 1,
      sym__hex_literal,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(9840), 1,
      sym__varid,
    ACTIONS(9842), 1,
      sym_string,
    ACTIONS(9844), 1,
      sym_triple_quote_string,
    ACTIONS(9846), 1,
      anon_sym__,
    ACTIONS(9848), 1,
      sym_hole,
    ACTIONS(9850), 1,
      anon_sym_LPAREN,
    ACTIONS(9852), 1,
      anon_sym_LBRACE,
    ACTIONS(9854), 1,
      anon_sym_AT,
    STATE(5781), 1,
      sym_constructor,
    STATE(5801), 1,
      sym_integer,
    STATE(7810), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5804), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(5963), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [136940] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [136980] = 18,
    ACTIONS(621), 1,
      sym__integer_literal,
    ACTIONS(623), 1,
      sym__hex_literal,
    ACTIONS(1401), 1,
      sym__conid,
    ACTIONS(9856), 1,
      sym__varid,
    ACTIONS(9858), 1,
      sym_string,
    ACTIONS(9860), 1,
      sym_triple_quote_string,
    ACTIONS(9862), 1,
      anon_sym__,
    ACTIONS(9864), 1,
      sym_hole,
    ACTIONS(9866), 1,
      anon_sym_LPAREN,
    ACTIONS(9868), 1,
      anon_sym_LBRACE,
    ACTIONS(9870), 1,
      anon_sym_AT,
    STATE(1690), 1,
      sym_constructor,
    STATE(1805), 1,
      sym_integer,
    STATE(7770), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1811), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1760), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [137048] = 5,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    STATE(2354), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137090] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137128] = 18,
    ACTIONS(1623), 1,
      sym__integer_literal,
    ACTIONS(1625), 1,
      sym__hex_literal,
    ACTIONS(1631), 1,
      sym__conid,
    ACTIONS(9872), 1,
      sym__varid,
    ACTIONS(9874), 1,
      sym_string,
    ACTIONS(9876), 1,
      sym_triple_quote_string,
    ACTIONS(9878), 1,
      anon_sym__,
    ACTIONS(9880), 1,
      sym_hole,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACE,
    ACTIONS(9886), 1,
      anon_sym_AT,
    STATE(2790), 1,
      sym_constructor,
    STATE(2957), 1,
      sym_integer,
    STATE(7739), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2955), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2952), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [137196] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137234] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137274] = 5,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9888), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9262), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9222), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 12,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137316] = 5,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    STATE(2354), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137358] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9176), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137396] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9296), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137434] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137472] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137510] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137548] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137588] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9302), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137626] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9298), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137664] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137702] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137740] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137778] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137816] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9164), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137854] = 18,
    ACTIONS(2250), 1,
      sym__integer_literal,
    ACTIONS(2252), 1,
      sym__hex_literal,
    ACTIONS(2258), 1,
      sym__conid,
    ACTIONS(9891), 1,
      sym__varid,
    ACTIONS(9893), 1,
      sym_string,
    ACTIONS(9895), 1,
      sym_triple_quote_string,
    ACTIONS(9897), 1,
      anon_sym__,
    ACTIONS(9899), 1,
      sym_hole,
    ACTIONS(9901), 1,
      anon_sym_LPAREN,
    ACTIONS(9903), 1,
      anon_sym_LBRACE,
    ACTIONS(9905), 1,
      anon_sym_AT,
    STATE(6818), 1,
      sym_constructor,
    STATE(7013), 1,
      sym_integer,
    STATE(7625), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(6978), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(7274), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [137922] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [137960] = 18,
    ACTIONS(1263), 1,
      sym__integer_literal,
    ACTIONS(1265), 1,
      sym__hex_literal,
    ACTIONS(1273), 1,
      sym__conid,
    ACTIONS(9907), 1,
      sym__varid,
    ACTIONS(9909), 1,
      sym_string,
    ACTIONS(9911), 1,
      sym_triple_quote_string,
    ACTIONS(9913), 1,
      anon_sym__,
    ACTIONS(9915), 1,
      sym_hole,
    ACTIONS(9917), 1,
      anon_sym_LPAREN,
    ACTIONS(9919), 1,
      anon_sym_LBRACE,
    ACTIONS(9921), 1,
      anon_sym_AT,
    STATE(2601), 1,
      sym_constructor,
    STATE(2802), 1,
      sym_integer,
    STATE(7556), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2815), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2880), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [138028] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138066] = 18,
    ACTIONS(696), 1,
      sym__integer_literal,
    ACTIONS(698), 1,
      sym__hex_literal,
    ACTIONS(1422), 1,
      sym__conid,
    ACTIONS(9923), 1,
      sym__varid,
    ACTIONS(9925), 1,
      sym_string,
    ACTIONS(9927), 1,
      sym_triple_quote_string,
    ACTIONS(9929), 1,
      anon_sym__,
    ACTIONS(9931), 1,
      sym_hole,
    ACTIONS(9933), 1,
      anon_sym_LPAREN,
    ACTIONS(9935), 1,
      anon_sym_LBRACE,
    ACTIONS(9937), 1,
      anon_sym_AT,
    STATE(1685), 1,
      sym_constructor,
    STATE(1825), 1,
      sym_integer,
    STATE(8018), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1804), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(1931), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [138134] = 5,
    ACTIONS(9939), 1,
      sym__immediate_dot,
    STATE(2416), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138176] = 5,
    ACTIONS(8993), 1,
      sym__immediate_dot,
    STATE(2416), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138218] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138256] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138294] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138332] = 18,
    ACTIONS(471), 1,
      sym__integer_literal,
    ACTIONS(473), 1,
      sym__hex_literal,
    ACTIONS(483), 1,
      sym__conid,
    ACTIONS(9942), 1,
      sym__varid,
    ACTIONS(9944), 1,
      sym_string,
    ACTIONS(9946), 1,
      sym_triple_quote_string,
    ACTIONS(9948), 1,
      anon_sym__,
    ACTIONS(9950), 1,
      sym_hole,
    ACTIONS(9952), 1,
      anon_sym_LPAREN,
    ACTIONS(9954), 1,
      anon_sym_LBRACE,
    ACTIONS(9956), 1,
      anon_sym_AT,
    STATE(2135), 1,
      sym_constructor,
    STATE(2405), 1,
      sym_integer,
    STATE(7764), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2399), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2331), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [138400] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9220), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138438] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138478] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138516] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138554] = 18,
    ACTIONS(2424), 1,
      sym__integer_literal,
    ACTIONS(2426), 1,
      sym__hex_literal,
    ACTIONS(2432), 1,
      sym__conid,
    ACTIONS(9958), 1,
      sym__varid,
    ACTIONS(9960), 1,
      sym_string,
    ACTIONS(9962), 1,
      sym_triple_quote_string,
    ACTIONS(9964), 1,
      anon_sym__,
    ACTIONS(9966), 1,
      sym_hole,
    ACTIONS(9968), 1,
      anon_sym_LPAREN,
    ACTIONS(9970), 1,
      anon_sym_LBRACE,
    ACTIONS(9972), 1,
      anon_sym_AT,
    STATE(6048), 1,
      sym_constructor,
    STATE(6288), 1,
      sym_integer,
    STATE(7674), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(6302), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(6359), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [138622] = 5,
    ACTIONS(8993), 1,
      sym__immediate_dot,
    STATE(2416), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138664] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9127), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138702] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9172), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138740] = 18,
    ACTIONS(5150), 1,
      sym_string,
    ACTIONS(5152), 1,
      sym_triple_quote_string,
    ACTIONS(5154), 1,
      sym__integer_literal,
    ACTIONS(5156), 1,
      sym__hex_literal,
    ACTIONS(5158), 1,
      anon_sym__,
    ACTIONS(5166), 1,
      anon_sym_LBRACE,
    ACTIONS(8297), 1,
      sym__varid,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(9974), 1,
      sym_hole,
    ACTIONS(9976), 1,
      anon_sym_LPAREN,
    STATE(4315), 1,
      sym_constructor,
    STATE(4405), 1,
      sym_integer,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(8410), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [138808] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138846] = 5,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9978), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9201), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8415), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8413), 12,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [138888] = 18,
    ACTIONS(782), 1,
      sym__integer_literal,
    ACTIONS(784), 1,
      sym__hex_literal,
    ACTIONS(1385), 1,
      sym__conid,
    ACTIONS(9981), 1,
      sym__varid,
    ACTIONS(9983), 1,
      sym_string,
    ACTIONS(9985), 1,
      sym_triple_quote_string,
    ACTIONS(9987), 1,
      anon_sym__,
    ACTIONS(9989), 1,
      sym_hole,
    ACTIONS(9991), 1,
      anon_sym_LPAREN,
    ACTIONS(9993), 1,
      anon_sym_LBRACE,
    ACTIONS(9995), 1,
      anon_sym_AT,
    STATE(1812), 1,
      sym_constructor,
    STATE(2004), 1,
      sym_integer,
    STATE(7673), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2002), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2183), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [138956] = 5,
    ACTIONS(8106), 1,
      sym_hole,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 8,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
    ACTIONS(9191), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9194), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [138998] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9152), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139036] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
      anon_sym_as,
  [139074] = 18,
    ACTIONS(2198), 1,
      sym__integer_literal,
    ACTIONS(2200), 1,
      sym__hex_literal,
    ACTIONS(2206), 1,
      sym__conid,
    ACTIONS(9997), 1,
      sym__varid,
    ACTIONS(9999), 1,
      sym_string,
    ACTIONS(10001), 1,
      sym_triple_quote_string,
    ACTIONS(10003), 1,
      anon_sym__,
    ACTIONS(10005), 1,
      sym_hole,
    ACTIONS(10007), 1,
      anon_sym_LPAREN,
    ACTIONS(10009), 1,
      anon_sym_LBRACE,
    ACTIONS(10011), 1,
      anon_sym_AT,
    STATE(5061), 1,
      sym_constructor,
    STATE(5470), 1,
      sym_integer,
    STATE(7720), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5467), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(5740), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [139142] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9148), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139180] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139218] = 18,
    ACTIONS(1481), 1,
      sym__integer_literal,
    ACTIONS(1483), 1,
      sym__hex_literal,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(10013), 1,
      sym__varid,
    ACTIONS(10015), 1,
      sym_string,
    ACTIONS(10017), 1,
      sym_triple_quote_string,
    ACTIONS(10019), 1,
      anon_sym__,
    ACTIONS(10021), 1,
      sym_hole,
    ACTIONS(10023), 1,
      anon_sym_LPAREN,
    ACTIONS(10025), 1,
      anon_sym_LBRACE,
    ACTIONS(10027), 1,
      anon_sym_AT,
    STATE(2947), 1,
      sym_constructor,
    STATE(3006), 1,
      sym_integer,
    STATE(7636), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2975), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(3005), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [139286] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9144), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139324] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139362] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139400] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139438] = 4,
    ACTIONS(10029), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139478] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139516] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    STATE(2360), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139560] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139598] = 5,
    ACTIONS(8993), 1,
      sym__immediate_dot,
    STATE(2416), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139640] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139678] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139716] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139754] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    STATE(2397), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139798] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139836] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(8993), 1,
      sym__immediate_dot,
    STATE(2295), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139880] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139918] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139956] = 4,
    ACTIONS(10032), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [139996] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140034] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140072] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(8993), 1,
      sym__immediate_dot,
    STATE(2449), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140116] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140154] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140192] = 18,
    ACTIONS(746), 1,
      sym__integer_literal,
    ACTIONS(748), 1,
      sym__hex_literal,
    ACTIONS(1367), 1,
      sym__conid,
    ACTIONS(10035), 1,
      sym__varid,
    ACTIONS(10037), 1,
      sym_string,
    ACTIONS(10039), 1,
      sym_triple_quote_string,
    ACTIONS(10041), 1,
      anon_sym__,
    ACTIONS(10043), 1,
      sym_hole,
    ACTIONS(10045), 1,
      anon_sym_LPAREN,
    ACTIONS(10047), 1,
      anon_sym_LBRACE,
    ACTIONS(10049), 1,
      anon_sym_AT,
    STATE(1737), 1,
      sym_constructor,
    STATE(2059), 1,
      sym_integer,
    STATE(7653), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2044), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2214), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [140260] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140298] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140336] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140374] = 4,
    ACTIONS(10051), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140414] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140452] = 4,
    ACTIONS(10054), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140492] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140530] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140568] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140606] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140644] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140682] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140720] = 4,
    ACTIONS(10057), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140760] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140798] = 18,
    ACTIONS(818), 1,
      sym__integer_literal,
    ACTIONS(820), 1,
      sym__hex_literal,
    ACTIONS(1456), 1,
      sym__conid,
    ACTIONS(10060), 1,
      sym__varid,
    ACTIONS(10062), 1,
      sym_string,
    ACTIONS(10064), 1,
      sym_triple_quote_string,
    ACTIONS(10066), 1,
      anon_sym__,
    ACTIONS(10068), 1,
      sym_hole,
    ACTIONS(10070), 1,
      anon_sym_LPAREN,
    ACTIONS(10072), 1,
      anon_sym_LBRACE,
    ACTIONS(10074), 1,
      anon_sym_AT,
    STATE(1728), 1,
      sym_constructor,
    STATE(2043), 1,
      sym_integer,
    STATE(7664), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2035), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2014), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [140866] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140904] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140942] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [140980] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141018] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141056] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141094] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141132] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141170] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141208] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141246] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141284] = 4,
    ACTIONS(8894), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 17,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141324] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141362] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141402] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9283), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141440] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141478] = 18,
    ACTIONS(59), 1,
      sym__integer_literal,
    ACTIONS(61), 1,
      sym__hex_literal,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(10076), 1,
      sym__varid,
    ACTIONS(10078), 1,
      sym_string,
    ACTIONS(10080), 1,
      sym_triple_quote_string,
    ACTIONS(10082), 1,
      anon_sym__,
    ACTIONS(10084), 1,
      sym_hole,
    ACTIONS(10086), 1,
      anon_sym_LPAREN,
    ACTIONS(10088), 1,
      anon_sym_LBRACE,
    ACTIONS(10090), 1,
      anon_sym_AT,
    STATE(2563), 1,
      sym_constructor,
    STATE(2881), 1,
      sym_integer,
    STATE(7699), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2884), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(2764), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [141546] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141584] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141622] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141660] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141698] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141736] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141776] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9256), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141814] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9248), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141852] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141892] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [141930] = 18,
    ACTIONS(237), 1,
      sym__integer_literal,
    ACTIONS(239), 1,
      sym__hex_literal,
    ACTIONS(247), 1,
      sym__conid,
    ACTIONS(9519), 1,
      sym__varid,
    ACTIONS(9521), 1,
      sym_string,
    ACTIONS(9523), 1,
      sym_triple_quote_string,
    ACTIONS(9525), 1,
      anon_sym__,
    ACTIONS(9529), 1,
      anon_sym_LPAREN,
    ACTIONS(9531), 1,
      anon_sym_LBRACE,
    ACTIONS(9533), 1,
      anon_sym_AT,
    ACTIONS(10092), 1,
      sym_hole,
    STATE(2119), 1,
      sym_constructor,
    STATE(2346), 1,
      sym_integer,
    STATE(7784), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(2418), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
    STATE(8193), 8,
      sym_type_literal,
      sym_row_type,
      sym_record_type_literal,
      sym_type_name,
      sym_type_wildcard,
      sym_captured_type_operator,
      sym_type_parens,
      sym__atype,
  [141998] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9236), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142036] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142074] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142112] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142150] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 10,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142188] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142226] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142264] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9138), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142302] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 9,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_in,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142342] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 11,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(9204), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142380] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142418] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142455] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142492] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142529] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142566] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142603] = 4,
    ACTIONS(10094), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142642] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142679] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142716] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142753] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142790] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142829] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142866] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142903] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142940] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [142977] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143016] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143053] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143090] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143127] = 5,
    ACTIONS(9142), 1,
      sym__immediate_dot,
    STATE(2559), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143168] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143205] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143242] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143279] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143316] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143353] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143392] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143429] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143468] = 4,
    ACTIONS(10096), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143507] = 5,
    ACTIONS(9142), 1,
      sym__immediate_dot,
    STATE(2559), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143548] = 4,
    ACTIONS(10098), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143587] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143624] = 5,
    ACTIONS(9142), 1,
      sym__immediate_dot,
    STATE(2559), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143665] = 5,
    ACTIONS(9260), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9262), 3,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9222), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 13,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143706] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143743] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143782] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143819] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 9,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143856] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143893] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143930] = 5,
    ACTIONS(10100), 1,
      sym__immediate_dot,
    STATE(2559), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [143971] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144008] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 10,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144045] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144082] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144121] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144158] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144195] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 9,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144232] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144269] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144306] = 4,
    ACTIONS(10103), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144345] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 9,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144382] = 4,
    ACTIONS(10105), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144421] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144458] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144495] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144532] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144569] = 5,
    ACTIONS(9142), 1,
      sym__immediate_dot,
    STATE(2559), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144610] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144647] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144684] = 4,
    ACTIONS(10107), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144723] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144762] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 9,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144799] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144836] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144873] = 4,
    ACTIONS(10109), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144912] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144949] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [144988] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145025] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145062] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145099] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145136] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145175] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145212] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145251] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145288] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145325] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145362] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145399] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145436] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145473] = 4,
    ACTIONS(10111), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145512] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145551] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145590] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145627] = 4,
    ACTIONS(10113), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145666] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145703] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145740] = 4,
    ACTIONS(10115), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145779] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145816] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145853] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145890] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145927] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [145964] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146001] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146038] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146077] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146114] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 10,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146151] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146188] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146225] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146262] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146299] = 4,
    ACTIONS(10117), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146338] = 4,
    ACTIONS(10119), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146377] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146416] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146453] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146490] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146527] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146564] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146601] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146638] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146675] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146712] = 4,
    ACTIONS(10121), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146751] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146788] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146825] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146862] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146899] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146936] = 4,
    ACTIONS(10123), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [146975] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147012] = 4,
    ACTIONS(10125), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147051] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 17,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147088] = 4,
    ACTIONS(10127), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147127] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147164] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147201] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    STATE(2384), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147244] = 5,
    ACTIONS(9199), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9201), 3,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8415), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8413), 13,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147285] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147322] = 6,
    ACTIONS(8106), 2,
      sym_comma,
      sym_hole,
    ACTIONS(9197), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9191), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9194), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 9,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147365] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147402] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(9142), 1,
      sym__immediate_dot,
    STATE(2548), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147445] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147482] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147519] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147556] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(9142), 1,
      sym__immediate_dot,
    STATE(2576), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147599] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147636] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147673] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 10,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147710] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147747] = 4,
    ACTIONS(10129), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147786] = 4,
    ACTIONS(10131), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147825] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147862] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 9,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147899] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 9,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147936] = 4,
    ACTIONS(10133), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [147975] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 10,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148012] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 9,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148049] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148086] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148123] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148162] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148199] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148236] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148273] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148310] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148347] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148384] = 4,
    ACTIONS(10135), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148423] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148460] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148499] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148538] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 9,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148575] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148612] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148649] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148686] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148723] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148762] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148799] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 19,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148836] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148873] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148910] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148947] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [148984] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149021] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149058] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149095] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149132] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149169] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149206] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149243] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149280] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149317] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_of,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149354] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149390] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149426] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149462] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149498] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149534] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149570] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149606] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149642] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149678] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149714] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149750] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149786] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 17,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149822] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149858] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149894] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149930] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [149966] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150002] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150038] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150074] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150110] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150146] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150182] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150218] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150254] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150290] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150326] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150362] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10143), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1058), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10139), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [150410] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150446] = 5,
    ACTIONS(9888), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9262), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9222), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 12,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150486] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150522] = 5,
    ACTIONS(10146), 1,
      sym__immediate_dot,
    STATE(2754), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8321), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150562] = 5,
    ACTIONS(10146), 1,
      sym__immediate_dot,
    STATE(2754), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150602] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150638] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150674] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150710] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150746] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10143), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1076), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10139), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [150794] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150830] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150866] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150902] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150938] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [150974] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151010] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151046] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151082] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151118] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151154] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151190] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151226] = 5,
    ACTIONS(10148), 1,
      sym__immediate_dot,
    STATE(2754), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8356), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151266] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151302] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151338] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151374] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151410] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151446] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151482] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151518] = 5,
    ACTIONS(10146), 1,
      sym__immediate_dot,
    STATE(2754), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8252), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151558] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151594] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151630] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151666] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151702] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10155), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1058), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10153), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [151750] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151786] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151822] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151858] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151894] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151930] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [151966] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152002] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152038] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152074] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152110] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152146] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152182] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 10,
      sym__layout_end,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152218] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152254] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152290] = 6,
    ACTIONS(8115), 1,
      anon_sym_LBRACE,
    ACTIONS(10146), 1,
      sym__immediate_dot,
    STATE(2736), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(8104), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152332] = 6,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(10146), 1,
      sym__immediate_dot,
    STATE(2762), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152374] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152410] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152446] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152482] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152518] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152554] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152592] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152628] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152664] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152700] = 4,
    ACTIONS(10158), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152738] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152774] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152810] = 4,
    ACTIONS(10160), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152848] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152884] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152920] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152956] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [152994] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153030] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153066] = 4,
    ACTIONS(10162), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153104] = 5,
    ACTIONS(9978), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9201), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8415), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8413), 12,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153144] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153180] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153216] = 5,
    ACTIONS(8106), 1,
      sym_hole,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 8,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
    ACTIONS(9194), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9191), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [153256] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153294] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153330] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 17,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153366] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153404] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153440] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153476] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153512] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153548] = 4,
    ACTIONS(10164), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153586] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153622] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153658] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153694] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153730] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153766] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153802] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153840] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153876] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 17,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153912] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153948] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [153984] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154020] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154056] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154092] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154128] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154164] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154200] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154236] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154272] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154308] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154344] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154380] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154416] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154454] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154490] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154526] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154562] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154598] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154634] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154670] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154706] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154742] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154778] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154814] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154850] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154886] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154922] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154958] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [154994] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155030] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155066] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155102] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155138] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155176] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155212] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155248] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155284] = 4,
    ACTIONS(10166), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155322] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155358] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155394] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155430] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 17,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155466] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155502] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 17,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155538] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155574] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155610] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155648] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155684] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155720] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155756] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_then,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155792] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155828] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155864] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155900] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155936] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [155972] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156008] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156044] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156080] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156116] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 17,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156152] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156188] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156224] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156260] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156296] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156332] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156368] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156404] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156440] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156476] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10155), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1076), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10153), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [156524] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156560] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156596] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156632] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 18,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156668] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 17,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156704] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156739] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156774] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156809] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156844] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156879] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 10,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8902), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156914] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156949] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [156984] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157019] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157054] = 4,
    ACTIONS(10168), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157091] = 4,
    ACTIONS(10170), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8913), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157128] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157163] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 10,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8921), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157198] = 4,
    ACTIONS(10172), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8925), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157235] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157270] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 10,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8931), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157305] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 10,
      sym__layout_end,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8947), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157340] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157375] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157410] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157445] = 7,
    ACTIONS(8857), 1,
      sym__dot,
    STATE(1168), 1,
      sym__colon2,
    STATE(9988), 1,
      sym__type_annotation,
    ACTIONS(10178), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10174), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10176), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [157488] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157523] = 4,
    ACTIONS(10180), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8885), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157560] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157595] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8771), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157630] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157665] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157700] = 7,
    ACTIONS(8857), 1,
      sym__dot,
    STATE(1168), 1,
      sym__colon2,
    STATE(9988), 1,
      sym__type_annotation,
    ACTIONS(10178), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10174), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10176), 14,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [157743] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8949), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157780] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157815] = 4,
    ACTIONS(10182), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8775), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157852] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157887] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157922] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157957] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [157992] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8789), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158027] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158062] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8793), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158097] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158132] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8802), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158167] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158202] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158237] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8896), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158274] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158309] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158344] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158379] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158414] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158449] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158484] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158519] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158554] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158589] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158624] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158659] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158694] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158731] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158768] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158803] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158838] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8781), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158873] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158908] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 9,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158943] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8870), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__immediate_dot,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [158978] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 16,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159015] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9302), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159049] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9256), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159083] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8104), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159117] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159151] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9321), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159185] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9232), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159219] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9296), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159253] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9292), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159287] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9244), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159321] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9210), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159355] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159389] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9327), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159423] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9180), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159457] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9283), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159491] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9220), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159525] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9252), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159559] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9133), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159593] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10143), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1056), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10139), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [159639] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159673] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9127), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159707] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10155), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1049), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(10151), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [159753] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9172), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159787] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159821] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9164), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159855] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9204), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159889] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9228), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [159923] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10155), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1142), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(10151), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [159969] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9170), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160003] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10143), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1142), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(10137), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [160049] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160083] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10143), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1049), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(10137), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [160129] = 4,
    ACTIONS(8419), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(8413), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160165] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10155), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1212), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10153), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [160211] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9214), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160245] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9248), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160279] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10143), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1212), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10139), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [160325] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9240), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160359] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9298), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160393] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9236), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160427] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9273), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160461] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9218), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160495] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9176), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160529] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9277), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160563] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9156), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160597] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10155), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1056), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10153), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [160643] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9184), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160677] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9152), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160711] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9148), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160745] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9138), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160779] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9160), 15,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_BSLASH,
      anon_sym_do,
      anon_sym_ado,
  [160813] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8225), 17,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [160846] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8225), 17,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [160879] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [160913] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10184), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_do,
      anon_sym_ado,
    ACTIONS(10186), 12,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
  [160945] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10188), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_do,
      anon_sym_ado,
    ACTIONS(10190), 12,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
  [160977] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10198), 1,
      anon_sym_PIPE,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1155), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(7000), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10194), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(617), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [161031] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10155), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1107), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(10153), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [161075] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [161109] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10198), 1,
      anon_sym_PIPE,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1088), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(7520), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10202), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(642), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [161163] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10198), 1,
      anon_sym_PIPE,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1195), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(7038), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10204), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(621), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [161217] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10155), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1214), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10153), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [161261] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [161295] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10143), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1095), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10139), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [161339] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [161371] = 7,
    ACTIONS(8857), 1,
      sym__dot,
    STATE(1164), 1,
      sym__colon2,
    STATE(8428), 1,
      sym__type_annotation,
    ACTIONS(10206), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [161411] = 7,
    ACTIONS(8857), 1,
      sym__dot,
    STATE(1101), 1,
      sym__colon2,
    STATE(8247), 1,
      sym__type_annotation,
    ACTIONS(10208), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [161451] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10198), 1,
      anon_sym_PIPE,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1093), 1,
      sym__colon2,
    STATE(5084), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10210), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(621), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [161505] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [161539] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [161571] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10198), 1,
      anon_sym_PIPE,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1121), 1,
      sym__colon2,
    STATE(5196), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10212), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(617), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [161625] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10214), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_if,
      anon_sym_case,
      anon_sym_let,
      anon_sym_do,
      anon_sym_ado,
    ACTIONS(1696), 12,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_BSLASH,
  [161657] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10143), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1214), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10139), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [161701] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10198), 1,
      anon_sym_PIPE,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1236), 1,
      sym__colon2,
    STATE(5177), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10216), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(642), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [161755] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [161789] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10155), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1095), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10153), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [161833] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [161865] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10143), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1107), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(10139), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [161909] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [161943] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10220), 15,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [161974] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8951), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [162007] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1055), 1,
      sym__colon2,
    STATE(5589), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10222), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(609), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [162058] = 6,
    STATE(1101), 1,
      sym__colon2,
    STATE(8422), 1,
      sym__type_annotation,
    ACTIONS(10208), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [162095] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1044), 1,
      sym__colon2,
    STATE(5558), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10224), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(643), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [162146] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1057), 1,
      sym__colon2,
    STATE(5553), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10226), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(618), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [162197] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162228] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162259] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162290] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162323] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162356] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10151), 15,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [162387] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162418] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10174), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10176), 14,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [162451] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162482] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162513] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [162544] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162575] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162606] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162639] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162670] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162701] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162732] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162763] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162794] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162825] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162856] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [162887] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162918] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162949] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [162980] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [163011] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [163042] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [163073] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [163104] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [163135] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [163166] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [163197] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1270), 1,
      sym__colon2,
    STATE(5589), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10228), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(609), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [163248] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1259), 1,
      sym__colon2,
    STATE(5553), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10230), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(618), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [163299] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [163330] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [163361] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [163392] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [163423] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [163454] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [163487] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8225), 12,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [163518] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
      anon_sym_hiding,
      anon_sym_as,
    ACTIONS(8225), 13,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [163549] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [163580] = 7,
    ACTIONS(10237), 1,
      anon_sym_LPAREN,
    ACTIONS(10240), 1,
      anon_sym_PIPE,
    ACTIONS(10232), 2,
      sym__varid,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 4,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LBRACE,
    ACTIONS(10235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(9296), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__operator,
      sym__conid,
      anon_sym_forall,
      anon_sym_u2200,
  [163619] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [163652] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10174), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10176), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [163685] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [163718] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [163751] = 7,
    ACTIONS(10237), 1,
      anon_sym_LPAREN,
    ACTIONS(10240), 1,
      anon_sym_PIPE,
    ACTIONS(10232), 2,
      sym__varid,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 4,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LBRACE,
    ACTIONS(10235), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(9296), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__operator,
      sym__conid,
      anon_sym_forall,
      anon_sym_u2200,
  [163790] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [163821] = 9,
    ACTIONS(10252), 1,
      anon_sym_AT2,
    STATE(1265), 1,
      sym__colon2,
    STATE(8086), 1,
      sym__type_annotation,
    ACTIONS(8108), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10246), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10249), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10242), 4,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
    ACTIONS(10244), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [163864] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [163895] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [163926] = 9,
    ACTIONS(10252), 1,
      anon_sym_AT2,
    STATE(1101), 1,
      sym__colon2,
    STATE(8162), 1,
      sym__type_annotation,
    ACTIONS(8108), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10254), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10249), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10242), 4,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
    ACTIONS(10244), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [163969] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [164002] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164033] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8951), 14,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [164066] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [164097] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164128] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164159] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164190] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164221] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164252] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164283] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1035), 1,
      sym__colon2,
    STATE(5558), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10257), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(643), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [164334] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [164365] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164396] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164427] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164458] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [164491] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [164522] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [164553] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [164584] = 9,
    ACTIONS(10252), 1,
      anon_sym_AT2,
    STATE(1164), 1,
      sym__colon2,
    STATE(8573), 1,
      sym__type_annotation,
    ACTIONS(8108), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10259), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10249), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10242), 4,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
    ACTIONS(10244), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [164627] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164658] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164689] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [164720] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164751] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [164782] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164813] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164844] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164875] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164908] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [164939] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [164970] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165001] = 6,
    STATE(1164), 1,
      sym__colon2,
    STATE(8216), 1,
      sym__type_annotation,
    ACTIONS(10206), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [165038] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165069] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165100] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165131] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165161] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165191] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1265), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(8124), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10264), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10262), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(626), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [165241] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8225), 14,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [165271] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165301] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165331] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165361] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165391] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165423] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1129), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(6217), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10266), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(641), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [165473] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1096), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(6156), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10268), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(632), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [165523] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165555] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165585] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165615] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165645] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165675] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165705] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165735] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165765] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8859), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [165797] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10174), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10176), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [165829] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10270), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10272), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [165859] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3463), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165889] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [165921] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [165951] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [165981] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166011] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166041] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3463), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166071] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166101] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [166131] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1164), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(6217), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10206), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(641), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [166181] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166211] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166241] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166271] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [166301] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166331] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166361] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [166391] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [166423] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166453] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 8,
      sym__layout_semicolon,
      sym__dot,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [166483] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 8,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [166513] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166543] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166573] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166603] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [166635] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166665] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166695] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166725] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166755] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166785] = 4,
    ACTIONS(10276), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10274), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [166817] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166847] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166877] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166907] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166937] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [166967] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8949), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [166999] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 7,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167029] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167061] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167091] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167121] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167151] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1164), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(8504), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10206), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10262), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(625), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [167201] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [167231] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167261] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167291] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167321] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167351] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167381] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167411] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10270), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10272), 14,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [167441] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167471] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167501] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [167531] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [167561] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10174), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10176), 13,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [167593] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8225), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [167623] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3288), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [167653] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [167683] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [167713] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1265), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(6156), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10264), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(632), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [167763] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [167793] = 8,
    STATE(1164), 1,
      sym__colon2,
    STATE(8371), 1,
      sym__type_annotation,
    ACTIONS(10282), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(10285), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10287), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10278), 4,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
    ACTIONS(10280), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [167833] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [167863] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [167895] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1183), 1,
      sym__colon2,
    STATE(5538), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10290), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(603), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [167945] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [167975] = 8,
    STATE(1101), 1,
      sym__colon2,
    STATE(8295), 1,
      sym__type_annotation,
    ACTIONS(10285), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10292), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10287), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10278), 4,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
    ACTIONS(10280), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [168015] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8951), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [168047] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [168077] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168107] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3288), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [168137] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168167] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168197] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1173), 1,
      sym__colon2,
    STATE(6027), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10295), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10192), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(603), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [168247] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168277] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [168309] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [168339] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168369] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168399] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [168429] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168459] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [168489] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [168519] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [168549] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [168579] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168609] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [168639] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8951), 13,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [168671] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168701] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [168731] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168761] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT2,
    ACTIONS(8340), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [168791] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168821] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168851] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      sym_comma,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1163), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(6506), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10198), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(10297), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(619), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [168903] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [168933] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [168963] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      sym_comma,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1179), 1,
      sym__colon2,
    STATE(5897), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10198), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(10299), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(619), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [169015] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169045] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169075] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169105] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [169135] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169165] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [169195] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169225] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169255] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169285] = 8,
    STATE(1265), 1,
      sym__colon2,
    STATE(8178), 1,
      sym__type_annotation,
    ACTIONS(10285), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10301), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10287), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10278), 4,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
    ACTIONS(10280), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [169325] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169355] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [169386] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10151), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [169415] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [169444] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [169473] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      sym_comma,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10198), 1,
      anon_sym_EQ,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1089), 1,
      sym__colon2,
    STATE(6027), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10304), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(633), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [169524] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [169555] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(570), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [169606] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [169637] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [169668] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(563), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [169719] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169748] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [169777] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(569), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [169828] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [169859] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [169890] = 4,
    ACTIONS(10321), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8108), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [169921] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [169950] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [169979] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [170010] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1165), 1,
      sym__colon2,
    STATE(6027), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10192), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(10323), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(608), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [170059] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9146), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [170088] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [170119] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10327), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [170148] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10331), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [170177] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [170206] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8859), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [170237] = 14,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      sym_comma,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10198), 1,
      anon_sym_EQ,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1176), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(6223), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10333), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(633), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [170288] = 7,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(10174), 1,
      anon_sym_forall,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(10176), 3,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2200,
    ACTIONS(10335), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10338), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [170325] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [170356] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [170385] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT2,
    ACTIONS(8340), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [170414] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 8,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [170443] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(582), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [170494] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [170523] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [170552] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [170581] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8225), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [170610] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [170639] = 4,
    ACTIONS(10341), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8108), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [170670] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(559), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [170721] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [170750] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(577), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [170801] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [170832] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(571), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [170883] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [170912] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(562), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [170963] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [170992] = 7,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(10174), 1,
      anon_sym_forall,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(10176), 3,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2200,
    ACTIONS(10335), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10338), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [171029] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [171060] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171089] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10220), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [171118] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(580), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [171169] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171198] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1268), 1,
      sym__colon2,
    STATE(5538), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10192), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(10343), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(608), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [171247] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(584), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [171298] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171327] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [171358] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [171387] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10151), 13,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [171416] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(587), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [171467] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10347), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [171496] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171525] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171554] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171583] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10351), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [171612] = 4,
    ACTIONS(10353), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8108), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [171643] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171672] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT2,
  [171701] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [171732] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT2,
  [171761] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [171790] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171819] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [171850] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [171879] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171908] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171937] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [171966] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [171997] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT2,
    ACTIONS(8340), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [172026] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172055] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172084] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8225), 12,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [172113] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172142] = 4,
    ACTIONS(10355), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10274), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [172173] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172202] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172231] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8225), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [172260] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172289] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10357), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [172318] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8951), 12,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [172349] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10359), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [172378] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172407] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172436] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172465] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 8,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [172494] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10363), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [172523] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 7,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172552] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172581] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172610] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [172639] = 4,
    ACTIONS(10365), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10274), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [172670] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8951), 12,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [172701] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [172732] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [172761] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10369), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [172790] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10371), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [172819] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__dot,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [172848] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [172879] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [172908] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [172937] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [172966] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10314), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [172995] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [173024] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10375), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [173053] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9226), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [173082] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10377), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [173111] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 13,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [173140] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_as,
  [173169] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [173198] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [173227] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [173256] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [173285] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 7,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [173314] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10381), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [173343] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [173372] = 14,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10308), 1,
      sym__operator,
    ACTIONS(10311), 1,
      anon_sym_DASH,
    ACTIONS(10314), 1,
      anon_sym_RPAREN,
    ACTIONS(10316), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10306), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(589), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [173423] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [173452] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10383), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [173481] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8859), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [173512] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [173541] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [173570] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [173601] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [173630] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [173659] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9281), 10,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
  [173688] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [173717] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10270), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10272), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [173746] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [173775] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_in,
  [173804] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10270), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10272), 13,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [173833] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10220), 13,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [173862] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [173891] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [173920] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [173949] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [173978] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174007] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174036] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174065] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174094] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174123] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174152] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174181] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174210] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174239] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174268] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174297] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [174328] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174357] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [174388] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174417] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174446] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [174474] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8340), 13,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AT2,
  [174502] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [174530] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [174558] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [174586] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10383), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [174614] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(644), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [174662] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10349), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [174690] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3288), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [174718] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [174748] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(638), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [174796] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174824] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT2,
    ACTIONS(8340), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [174852] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174882] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3463), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [174910] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(601), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [174958] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [174986] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [175014] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3463), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [175042] = 11,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10387), 1,
      sym__tyconsym,
    STATE(5056), 1,
      aux_sym__qualifying_module,
    STATE(10103), 1,
      sym_constructor,
    STATE(10142), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9763), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
    STATE(9764), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [175086] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [175114] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [175144] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [175172] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [175200] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(630), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [175248] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT2,
  [175276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10383), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [175304] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [175332] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [175362] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3288), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [175390] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [175418] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [175446] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [175474] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [175502] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3288), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [175530] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [175558] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3288), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [175586] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [175616] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [175644] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [175672] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [175702] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(631), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [175750] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [175778] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [175806] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10345), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [175834] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [175862] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(607), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [175910] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(611), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [175958] = 6,
    ACTIONS(10270), 1,
      anon_sym_forall,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(10272), 3,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2200,
    ACTIONS(10389), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10392), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [175992] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_then,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1139), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10395), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(652), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176040] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(622), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176088] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(604), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176136] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(653), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176184] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(620), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176232] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [176262] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8859), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [176292] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10329), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [176320] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [176348] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [176376] = 6,
    ACTIONS(10270), 1,
      anon_sym_forall,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(10272), 3,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u2200,
    ACTIONS(10389), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10392), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [176410] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(635), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176458] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [176486] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9281), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [176514] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [176542] = 4,
    ACTIONS(10397), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8108), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [176572] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [176602] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8859), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [176632] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [176660] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [176690] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(649), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176738] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(651), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176786] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [176814] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(637), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176862] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [176890] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [176918] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [176946] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(600), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [176994] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [177022] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(598), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [177070] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [177098] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [177126] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [177156] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(623), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [177204] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(615), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [177252] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9146), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [177280] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(605), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [177328] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(613), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [177376] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9260), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [177404] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(614), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [177452] = 6,
    STATE(1164), 1,
      sym__colon2,
    STATE(8573), 1,
      sym__type_annotation,
    ACTIONS(10399), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10242), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10244), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [177486] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8894), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [177514] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(629), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [177562] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10369), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [177590] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [177618] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10379), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [177646] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10375), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [177674] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10377), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [177702] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(646), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [177750] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [177780] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [177808] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [177836] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [177864] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [177892] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [177920] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9199), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [177948] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9197), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [177976] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10327), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178004] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10306), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [178032] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178060] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [178088] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178116] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [178144] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [178172] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [178200] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10331), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178228] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(650), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [178276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [178304] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10347), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178332] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10351), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178360] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178388] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178416] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10357), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178444] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10359), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178472] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8225), 11,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178500] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178528] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178556] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10363), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178584] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10371), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178612] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9281), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178640] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178668] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178696] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178724] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 7,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [178752] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178780] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178808] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178836] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9197), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [178864] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT2,
    ACTIONS(8340), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [178892] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178920] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178948] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [178976] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179004] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179032] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179060] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179088] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8894), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [179116] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3463), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179144] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(648), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [179192] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [179220] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [179248] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [179276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [179304] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179332] = 6,
    STATE(1164), 1,
      sym__colon2,
    STATE(8371), 1,
      sym__type_annotation,
    ACTIONS(10399), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10278), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10280), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [179366] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179394] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179422] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [179450] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179478] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [179506] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179534] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10314), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [179562] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179590] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179618] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179646] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [179674] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [179702] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10361), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [179730] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179758] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179786] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [179816] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179844] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179872] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179900] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [179928] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [179956] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [179984] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [180012] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10379), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [180040] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [180070] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [180100] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 7,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [180128] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [180156] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10367), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [180184] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
      anon_sym_as,
  [180214] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9197), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [180242] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [180272] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [180300] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 8,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [180328] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10381), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [180356] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [180384] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [180412] = 4,
    ACTIONS(10401), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10274), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [180442] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(610), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [180490] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [180518] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10306), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [180546] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(606), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [180594] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(634), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [180642] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [180670] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9199), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [180698] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10361), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [180726] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(597), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [180774] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8894), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [180802] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9260), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [180830] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [180858] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(602), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [180906] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10349), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [180934] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10345), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [180962] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [180990] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10329), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [181018] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10369), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [181046] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [181074] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [181102] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [181132] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10373), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [181160] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [181188] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [181216] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10325), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [181244] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [181272] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [181300] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10375), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [181328] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [181356] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10285), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [181384] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10373), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [181412] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10377), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [181440] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 8,
      sym_comma,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10367), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
  [181468] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10327), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [181496] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10285), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [181524] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [181552] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [181580] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [181608] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [181636] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [181664] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [181692] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [181720] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10379), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [181748] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [181776] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10331), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [181804] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_else,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1041), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10403), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(599), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [181852] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [181880] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3463), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [181908] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [181938] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_then,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1233), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10405), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(652), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [181986] = 4,
    ACTIONS(10407), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8108), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [182016] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10325), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [182044] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [182072] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10347), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182100] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [182128] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9146), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182156] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [182184] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10381), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182212] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [182240] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1114), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10409), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(640), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [182288] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [182316] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10306), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [182344] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1065), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(7232), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10411), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(640), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [182392] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [182420] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [182448] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [182476] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [182504] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10361), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [182532] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [182560] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9226), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182588] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [182618] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9199), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [182646] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8225), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182674] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [182702] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10367), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [182730] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10357), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182758] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10351), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182786] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10373), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [182814] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10285), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [182842] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10359), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182870] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(616), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [182918] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9226), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182946] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10371), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [182974] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10363), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183002] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10325), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [183030] = 4,
    ACTIONS(10413), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10274), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183060] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [183088] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [183118] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT2,
  [183146] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10314), 11,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183174] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_RPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1221), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(612), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [183222] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9260), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [183250] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [183278] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [183306] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10329), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [183334] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_of,
  [183362] = 13,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10192), 1,
      anon_sym_else,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1128), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10415), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(599), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [183410] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10345), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [183438] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10349), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [183466] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [183496] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [183523] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9146), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183550] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10371), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183577] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10363), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183604] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [183631] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10359), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183658] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10357), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183685] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [183712] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [183739] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10351), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183766] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10347), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183793] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [183820] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10331), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [183847] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8225), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [183874] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [183901] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [183928] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [183955] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1080), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [183994] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [184021] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [184048] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10327), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [184075] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1080), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(10139), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [184114] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [184141] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [184168] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10220), 11,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [184195] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10377), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [184222] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10375), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [184249] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [184276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10369), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [184303] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [184330] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [184357] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9907), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [184390] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10314), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [184417] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9858), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [184450] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [184477] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [184504] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [184531] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1080), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [184570] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9648), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [184603] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10151), 11,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [184630] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [184657] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [184684] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [184711] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10367), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [184738] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [184765] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10373), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [184792] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10285), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [184819] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [184846] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10325), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [184873] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [184900] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [184927] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [184954] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8898), 9,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [184983] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [185010] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [185037] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [185064] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10329), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185091] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [185118] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10345), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185145] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10349), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185172] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9260), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185199] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8894), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185226] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [185253] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9772), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [185286] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10361), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185313] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9199), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185340] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10306), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185367] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185394] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9226), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [185421] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8340), 12,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_AT2,
  [185448] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10379), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [185475] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [185502] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1113), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(10139), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [185541] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [185568] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 8,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [185595] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9542), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [185628] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1113), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [185667] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1114), 1,
      sym__colon2,
    STATE(6086), 1,
      sym__type_annotation,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10409), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(639), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [185712] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 7,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [185739] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10220), 11,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u2200,
      anon_sym_RBRACK,
  [185766] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9454), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [185799] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [185828] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [185855] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [185884] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [185911] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9369), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [185944] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [185971] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9908), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186004] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9272), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186037] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [186064] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [186091] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [186118] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 8,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [186145] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [186172] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9189), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186205] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [186232] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [186259] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9038), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186292] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8961), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186325] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9979), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186358] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [186385] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8885), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186418] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8808), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186451] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8744), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186484] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9212), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186517] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [186544] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9603), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186577] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9584), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186610] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [186637] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9734), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186670] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9845), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186703] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8768), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186736] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(8898), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [186765] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9967), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186798] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [186825] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1238), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(10139), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [186864] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(10023), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186897] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9656), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [186930] = 4,
    ACTIONS(10443), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8108), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [186959] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9146), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [186986] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(10059), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187019] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [187046] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(10136), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187079] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(10089), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187112] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(10038), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187145] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9997), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187178] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9954), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187211] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9906), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187244] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9867), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187277] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1238), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [187316] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 8,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [187343] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9835), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187376] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [187403] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1113), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [187442] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9805), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187475] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9746), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187508] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9708), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187541] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9377), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187574] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10379), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187601] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187628] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10306), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187655] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9199), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187682] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10361), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187709] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10381), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [187736] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9614), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187769] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8894), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187796] = 5,
    STATE(4224), 1,
      sym__colon2,
    ACTIONS(10445), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [187827] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9260), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187854] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10349), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187881] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10345), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187908] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9439), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [187941] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10329), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [187968] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9457), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188001] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9424), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188034] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10325), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [188061] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9076), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188094] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9353), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188127] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9317), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188160] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9231), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188193] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10285), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [188220] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10373), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [188247] = 5,
    STATE(4222), 1,
      sym__colon2,
    ACTIONS(10447), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [188278] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10367), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [188305] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [188334] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188361] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [188390] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188417] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [188444] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9141), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188477] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188504] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188531] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188558] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9042), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188591] = 16,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2436), 1,
      sym_variable,
    STATE(2686), 1,
      sym_constructor,
    STATE(5604), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(9854), 1,
      sym__modid,
    STATE(10005), 1,
      sym_constructor_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3023), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
  [188644] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9548), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188677] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188704] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8850), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188737] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188764] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT2,
  [188791] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188818] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10383), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [188845] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188872] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8751), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [188905] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188932] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [188959] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [188986] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8783), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189019] = 5,
    STATE(4249), 1,
      sym__colon2,
    ACTIONS(10453), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [189050] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8797), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189083] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [189110] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8814), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189143] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8833), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189176] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8852), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189209] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [189236] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [189263] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [189292] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8871), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189325] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8890), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189358] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8909), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189391] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8928), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189424] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8947), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189457] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8966), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189490] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(8985), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189523] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [189550] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9197), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [189577] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9004), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189610] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9022), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189643] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [189670] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9040), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189703] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9058), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189736] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9305), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189769] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9094), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [189802] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [189829] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [189856] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 8,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [189883] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [189910] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [189937] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [189964] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [189991] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9112), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190024] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(10085), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190057] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9130), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190090] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9148), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190123] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9166), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190156] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9184), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190189] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9202), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190222] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190249] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190303] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190330] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190357] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190384] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9220), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190417] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9238), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190450] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190477] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9256), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190510] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9274), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190543] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8861), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [190572] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9292), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190605] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9302), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190638] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190665] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10383), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [190692] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190719] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [190748] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9308), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190781] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9311), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190814] = 6,
    STATE(1221), 1,
      sym__colon2,
    STATE(9314), 1,
      sym__type_annotation,
    ACTIONS(10385), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [190847] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
      anon_sym_in,
  [190874] = 5,
    STATE(4221), 1,
      sym__colon2,
    ACTIONS(10455), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [190905] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    STATE(1065), 1,
      sym__colon2,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(7232), 1,
      sym__type_annotation,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10411), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(639), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [190950] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [190977] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9281), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [191004] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191033] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191060] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(8853), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [191087] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9281), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [191114] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [191143] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [191172] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(8951), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191201] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191228] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191255] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191282] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191309] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191336] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191363] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191390] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191417] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191444] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191471] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191498] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191527] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8225), 10,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191554] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
    ACTIONS(8225), 9,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_AT,
  [191581] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191608] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191635] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [191662] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191691] = 4,
    ACTIONS(10457), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8108), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [191720] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(8225), 9,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [191747] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [191776] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191803] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191830] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191857] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191884] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191911] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [191938] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191965] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [191992] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [192019] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [192046] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [192073] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [192100] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [192127] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [192154] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [192181] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8951), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [192210] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8225), 11,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [192237] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192264] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10314), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [192291] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10371), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [192318] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10359), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [192345] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10357), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [192372] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8338), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [192399] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(9226), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [192426] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192453] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192480] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192507] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192534] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192561] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10151), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [192588] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192615] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192642] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10151), 11,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_u2200,
      anon_sym_RBRACK,
  [192669] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192696] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192723] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192750] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192777] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192804] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10220), 11,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [192831] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [192858] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [192885] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10381), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [192912] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10363), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [192939] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10351), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [192966] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [192993] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9197), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [193020] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10347), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [193047] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10331), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [193074] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10327), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [193101] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10377), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [193128] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_else,
  [193155] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10375), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [193182] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(10369), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [193209] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 12,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
      anon_sym_then,
  [193236] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [193263] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(8898), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [193292] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [193319] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(8951), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [193348] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 10,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
  [193375] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [193402] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1238), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [193441] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [193470] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [193497] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [193523] = 11,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10461), 1,
      sym_comma,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10459), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(628), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [193565] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10379), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [193591] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [193617] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(566), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [193661] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10379), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [193687] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(559), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [193731] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [193757] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(556), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [193801] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(569), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [193845] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(565), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [193889] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(572), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [193933] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(563), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [193977] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [194003] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194029] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194055] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194081] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194107] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194133] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194159] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194185] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194211] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(9186), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [194237] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194263] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194289] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [194315] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(9304), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [194341] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(9300), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [194367] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(570), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [194411] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(576), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [194455] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(592), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [194499] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(590), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [194543] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(583), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [194587] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8225), 10,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [194613] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9197), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [194639] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [194665] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(567), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [194709] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [194735] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10367), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [194761] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [194787] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10373), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [194813] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10285), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [194839] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10325), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [194865] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10329), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [194891] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10345), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [194917] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10349), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [194943] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10361), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [194969] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [194995] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195021] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195047] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195073] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195099] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195125] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195151] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195177] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9285), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [195203] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195229] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [195255] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195281] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(549), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [195325] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195351] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(3463), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195377] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195403] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [195429] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195455] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195481] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195507] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [195533] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(587), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [195577] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [195603] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9260), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [195629] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8894), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [195655] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9199), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [195681] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9197), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [195707] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10306), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [195733] = 9,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10465), 1,
      sym__varid,
    ACTIONS(10469), 1,
      anon_sym_LPAREN,
    STATE(1075), 1,
      sym__colon2,
    STATE(9972), 1,
      sym__type_annotation,
    ACTIONS(10467), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10463), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(5045), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [195771] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(553), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [195815] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(582), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [195859] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1134), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [195897] = 14,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10471), 1,
      sym__varid,
    ACTIONS(10473), 1,
      anon_sym_LPAREN,
    STATE(939), 1,
      sym_class_name,
    STATE(1511), 1,
      sym_type_name,
    STATE(3322), 1,
      sym_constructor,
    STATE(3484), 1,
      sym_qualified_type,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(7778), 1,
      sym_constraint,
    STATE(8246), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4510), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [195945] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(577), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [195989] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(551), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [196033] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(579), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [196077] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(586), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [196121] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(548), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [196165] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [196191] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [196217] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196243] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196269] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196295] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196321] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196347] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9162), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [196373] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196399] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196425] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196451] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196477] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196503] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196529] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196555] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196581] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196607] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(571), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [196651] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(562), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [196695] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9206), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [196721] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [196747] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [196773] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [196799] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9206), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196825] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [196851] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [196877] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(560), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [196921] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9146), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [196947] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [196973] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [196999] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197025] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197051] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197077] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197103] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197129] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197155] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197181] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197207] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197233] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197259] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197285] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [197311] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(580), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [197355] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(585), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [197399] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(584), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [197443] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [197469] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(557), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [197513] = 14,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10473), 1,
      anon_sym_LPAREN,
    ACTIONS(10475), 1,
      sym__varid,
    STATE(939), 1,
      sym_class_name,
    STATE(1578), 1,
      sym_type_name,
    STATE(3322), 1,
      sym_constructor,
    STATE(3484), 1,
      sym_qualified_type,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(7778), 1,
      sym_constraint,
    STATE(8350), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4510), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [197561] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [197587] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(589), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [197631] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(555), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [197675] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(550), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [197719] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9224), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [197745] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [197771] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [197797] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1134), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [197835] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [197861] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [197887] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8951), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [197915] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1134), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [197953] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [197979] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3288), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198005] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198031] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9285), 9,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [198057] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [198085] = 14,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10465), 1,
      sym__varid,
    ACTIONS(10473), 1,
      anon_sym_LPAREN,
    STATE(939), 1,
      sym_class_name,
    STATE(1586), 1,
      sym_type_name,
    STATE(3322), 1,
      sym_constructor,
    STATE(3484), 1,
      sym_qualified_type,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(7778), 1,
      sym_constraint,
    STATE(8419), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4510), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [198133] = 14,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10477), 1,
      sym__varid,
    ACTIONS(10479), 1,
      anon_sym_LPAREN,
    STATE(939), 1,
      sym_class_name,
    STATE(1575), 1,
      sym_type_name,
    STATE(3302), 1,
      sym_constructor,
    STATE(3495), 1,
      sym_qualified_type,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(7778), 1,
      sym_constraint,
    STATE(8596), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4616), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [198181] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198207] = 14,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10477), 1,
      sym__varid,
    ACTIONS(10479), 1,
      anon_sym_LPAREN,
    STATE(939), 1,
      sym_class_name,
    STATE(1561), 1,
      sym_type_name,
    STATE(3302), 1,
      sym_constructor,
    STATE(3495), 1,
      sym_qualified_type,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(7778), 1,
      sym_constraint,
    STATE(8601), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4616), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [198255] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198281] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [198307] = 14,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10479), 1,
      anon_sym_LPAREN,
    ACTIONS(10481), 1,
      sym__varid,
    STATE(939), 1,
      sym_class_name,
    STATE(1547), 1,
      sym_type_name,
    STATE(3302), 1,
      sym_constructor,
    STATE(3495), 1,
      sym_qualified_type,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(7778), 1,
      sym_constraint,
    STATE(8603), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4616), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [198355] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9279), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [198381] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8855), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [198407] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9206), 9,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [198433] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198459] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9162), 9,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [198485] = 12,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(574), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [198529] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198555] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198581] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [198609] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9162), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [198635] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198661] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198687] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198713] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198739] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198765] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8951), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [198793] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3463), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198819] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198845] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198871] = 14,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10479), 1,
      anon_sym_LPAREN,
    ACTIONS(10483), 1,
      sym__varid,
    STATE(939), 1,
      sym_class_name,
    STATE(1606), 1,
      sym_type_name,
    STATE(3302), 1,
      sym_constructor,
    STATE(3495), 1,
      sym_qualified_type,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(7778), 1,
      sym_constraint,
    STATE(8606), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4616), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [198919] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3463), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [198945] = 14,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10465), 1,
      sym__varid,
    ACTIONS(10473), 1,
      anon_sym_LPAREN,
    STATE(939), 1,
      sym_class_name,
    STATE(1552), 1,
      sym_type_name,
    STATE(3322), 1,
      sym_constructor,
    STATE(3484), 1,
      sym_qualified_type,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(7778), 1,
      sym_constraint,
    STATE(8486), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4510), 4,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [198993] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10306), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199019] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9199), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199045] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10361), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199071] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(8894), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199097] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9260), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199123] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10349), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199149] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199175] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199201] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10329), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199227] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [199255] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199281] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199307] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199333] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199359] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199385] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199411] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10325), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199437] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10285), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199463] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10373), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199489] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10367), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199515] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [199541] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(10345), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [199567] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1050), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [199605] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199631] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(3288), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199657] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199683] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199709] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 7,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [199735] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(9146), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [199761] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [199789] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [199815] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [199841] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [199867] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9294), 9,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [199893] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
    ACTIONS(8225), 8,
      sym__layout_semicolon,
      sym__dot,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [199919] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [199945] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [199971] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [199997] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [200023] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9285), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200049] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1046), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [200087] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8898), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200115] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200141] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200167] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200193] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200219] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200245] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200271] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200297] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200323] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200349] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200375] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [200401] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8225), 9,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [200427] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 10,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [200453] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 7,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
  [200479] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 11,
      sym_string,
      sym__integer_literal,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [200505] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1046), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [200543] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1046), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [200581] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 7,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(3288), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_forall,
      anon_sym_u2200,
  [200607] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8951), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200635] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9300), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [200661] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9304), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [200687] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [200713] = 9,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10477), 1,
      sym__varid,
    ACTIONS(10485), 1,
      anon_sym_LPAREN,
    STATE(1075), 1,
      sym__colon2,
    STATE(9972), 1,
      sym__type_annotation,
    ACTIONS(10467), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10463), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(5022), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [200751] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8898), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [200779] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1050), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [200817] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10174), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10176), 9,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [200845] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(8951), 9,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [200873] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [200899] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1050), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [200937] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [200963] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
    ACTIONS(9186), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [200989] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [201015] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [201041] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [201067] = 11,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10489), 1,
      sym_comma,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10487), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(628), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [201109] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [201135] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [201161] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10491), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10493), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(1018), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [201201] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [201227] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [201253] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT,
  [201279] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [201304] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9325), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [201329] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [201354] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [201381] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8898), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [201408] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1098), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [201445] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [201470] = 4,
    ACTIONS(10495), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10274), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [201497] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1098), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [201534] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10493), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(1003), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [201571] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [201596] = 5,
    STATE(4364), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10497), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10499), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [201625] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8225), 10,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [201650] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [201675] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10137), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1098), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [201712] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [201739] = 9,
    ACTIONS(10429), 1,
      sym_comma,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1178), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [201776] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [201803] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [201828] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9294), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [201853] = 11,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10487), 1,
      anon_sym_EQ,
    ACTIONS(10489), 1,
      sym_comma,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(627), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [201894] = 10,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10503), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(8514), 5,
      sym__cdecl,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
  [201933] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [201960] = 10,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10505), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(8514), 5,
      sym__cdecl,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
  [201999] = 4,
    ACTIONS(10507), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [202026] = 4,
    ACTIONS(10513), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10511), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(10509), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [202053] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10491), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(994), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [202090] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8898), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [202117] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [202142] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [202167] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [202192] = 7,
    ACTIONS(10520), 1,
      anon_sym_forall,
    ACTIONS(10523), 1,
      anon_sym_u2200,
    STATE(4364), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10516), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10518), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [202225] = 10,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10526), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(7563), 5,
      sym__cdecl,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
  [202264] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10270), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10272), 9,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [202289] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [202314] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9146), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [202339] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [202364] = 10,
    ACTIONS(8104), 1,
      anon_sym_BQUOTE,
    ACTIONS(8118), 1,
      anon_sym_AT2,
    ACTIONS(8874), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10528), 1,
      sym__immediate_dot,
    STATE(4995), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8108), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(8110), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [202403] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10493), 1,
      sym_comma,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10491), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(991), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [202442] = 10,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10530), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(7859), 5,
      sym__cdecl,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
  [202481] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(1130), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [202518] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9162), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_AT,
  [202543] = 10,
    ACTIONS(8104), 1,
      anon_sym_BQUOTE,
    ACTIONS(8118), 1,
      anon_sym_AT2,
    ACTIONS(8874), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10532), 1,
      sym__immediate_dot,
    STATE(4932), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8108), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(8110), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [202582] = 7,
    ACTIONS(1896), 1,
      anon_sym_forall,
    ACTIONS(2112), 1,
      anon_sym_u2200,
    STATE(4364), 1,
      aux_sym_forall_repeat1,
    STATE(6231), 1,
      sym__forall_kw,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10497), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10499), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [202615] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9206), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_AT,
  [202640] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [202667] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8951), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [202694] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9285), 10,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_AT,
  [202719] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [202744] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [202769] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [202794] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9162), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_AT,
  [202819] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9319), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [202844] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [202869] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [202894] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [202919] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [202944] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9290), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [202969] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [202994] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [203019] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [203044] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [203069] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [203094] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9208), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203119] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9325), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203144] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(8225), 8,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [203169] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203194] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203219] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9131), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203244] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [203269] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [203294] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [203319] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9300), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203344] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9304), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203369] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9285), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_AT,
  [203394] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8225), 10,
      sym__dot,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [203419] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203444] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203469] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203494] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203519] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203544] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203569] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8859), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [203596] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203621] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203646] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9146), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203671] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203696] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203721] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9168), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203746] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203771] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203796] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [203821] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [203846] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203871] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203896] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 7,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_in,
  [203921] = 11,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10459), 1,
      anon_sym_EQ,
    ACTIONS(10461), 1,
      sym_comma,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(627), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [203962] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9212), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [203987] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9216), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204012] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9186), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204037] = 10,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10534), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(8514), 5,
      sym__cdecl,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
  [204076] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10137), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(1130), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [204113] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9271), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204138] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8853), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [204165] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9275), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204190] = 9,
    ACTIONS(10151), 1,
      sym_comma,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1178), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [204227] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9146), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [204252] = 9,
    ACTIONS(10137), 1,
      sym_comma,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1178), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [204289] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8853), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [204316] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(1182), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [204353] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10491), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    STATE(1017), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [204390] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10493), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(1015), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [204427] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 6,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_AT,
      anon_sym_BQUOTE,
  [204452] = 10,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10536), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(8514), 5,
      sym__cdecl,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
  [204491] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9300), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [204516] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9304), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [204541] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9206), 10,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_AT,
  [204566] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10137), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(1182), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [204603] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9319), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204628] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9275), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [204653] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9271), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [204678] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9290), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204703] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9208), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204728] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9325), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204753] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9131), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204778] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(1182), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [204815] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9168), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204840] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9212), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204865] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9186), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [204890] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9216), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [204915] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9216), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204940] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9186), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [204965] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [204992] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 7,
      sym__dot,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [205017] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9271), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [205042] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9275), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [205067] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9212), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [205092] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9294), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [205117] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9304), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [205142] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8859), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [205169] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9300), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [205194] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9168), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [205219] = 4,
    ACTIONS(10538), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10274), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [205246] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9208), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [205271] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9131), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [205296] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [205323] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(1130), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [205360] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9290), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [205385] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9319), 8,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [205410] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10357), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [205434] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [205458] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10540), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [205496] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [205520] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [205544] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [205568] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [205594] = 5,
    ACTIONS(10542), 1,
      sym__immediate_dot,
    STATE(4489), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8356), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [205622] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9277), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [205646] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [205672] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [205696] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9281), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [205720] = 5,
    ACTIONS(10545), 1,
      sym__immediate_dot,
    STATE(4489), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [205748] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10547), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [205786] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10549), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [205824] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [205848] = 5,
    ACTIONS(10545), 1,
      sym__immediate_dot,
    STATE(4489), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [205876] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [205900] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9273), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [205924] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [205948] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [205972] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [205996] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10357), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [206020] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10359), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [206044] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [206068] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10551), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [206106] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10371), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [206130] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10383), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [206154] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [206178] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10314), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [206202] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9285), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [206226] = 9,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10137), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1034), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [206262] = 6,
    ACTIONS(8417), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1545), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [206292] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10557), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [206330] = 9,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10151), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1034), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [206366] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [206390] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10359), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [206414] = 8,
    ACTIONS(2126), 1,
      anon_sym_PIPE,
    ACTIONS(10561), 1,
      sym__varid,
    ACTIONS(10563), 1,
      anon_sym_LPAREN,
    ACTIONS(10565), 1,
      anon_sym_AT,
    STATE(7596), 1,
      sym_fundeps,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10559), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4860), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [206448] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10493), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(1019), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [206484] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10567), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [206522] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10363), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [206546] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [206570] = 5,
    ACTIONS(10569), 1,
      sym__immediate_dot,
    STATE(4539), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [206598] = 5,
    ACTIONS(10569), 1,
      sym__immediate_dot,
    STATE(4539), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [206626] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10491), 3,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_EQ,
    STATE(1005), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [206662] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [206686] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10545), 1,
      sym__immediate_dot,
    STATE(4494), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8104), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [206716] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [206740] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [206764] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [206788] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10571), 1,
      sym__immediate_dot,
    STATE(4586), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8104), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [206818] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10571), 1,
      sym__immediate_dot,
    STATE(4575), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8413), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [206848] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10371), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [206872] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10383), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [206896] = 9,
    ACTIONS(6939), 1,
      sym__varid,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(111), 3,
      anon_sym_infixl,
      anon_sym_infixr,
      anon_sym_infix,
    STATE(8514), 5,
      sym__cdecl,
      sym_function,
      sym_operator_declaration,
      sym_signature,
      sym__gendecl,
  [206932] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8853), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [206956] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10314), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [206980] = 5,
    ACTIONS(10573), 1,
      sym__immediate_dot,
    STATE(4539), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8356), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [207008] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [207032] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9226), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [207056] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [207080] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10569), 1,
      sym__immediate_dot,
    STATE(4525), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8104), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [207110] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [207134] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10569), 1,
      sym__immediate_dot,
    STATE(4524), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8413), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [207164] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [207188] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [207212] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10545), 1,
      sym__immediate_dot,
    STATE(4498), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8413), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [207242] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [207268] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [207292] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [207316] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [207340] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [207366] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [207390] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10576), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [207428] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10578), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [207466] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [207490] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10381), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [207514] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9327), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [207538] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [207562] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [207586] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [207610] = 8,
    ACTIONS(2106), 1,
      anon_sym_PIPE,
    ACTIONS(10580), 1,
      sym__varid,
    ACTIONS(10584), 1,
      anon_sym_LPAREN,
    ACTIONS(10586), 1,
      anon_sym_AT,
    STATE(7913), 1,
      sym_fundeps,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10582), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4850), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [207644] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9146), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [207668] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10381), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [207692] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [207716] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [207740] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9304), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [207764] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [207788] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10588), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [207826] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9206), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [207850] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [207874] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10590), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [207912] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9146), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [207936] = 5,
    ACTIONS(10571), 1,
      sym__immediate_dot,
    STATE(4629), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [207964] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [207988] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208012] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208036] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [208060] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10592), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10594), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [208084] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [208108] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10596), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [208146] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [208172] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9146), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208196] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10598), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [208234] = 5,
    ACTIONS(10571), 1,
      sym__immediate_dot,
    STATE(4629), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [208262] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208286] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208310] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9290), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208334] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9208), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208358] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9325), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208382] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9131), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208406] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [208432] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10600), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [208470] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9162), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [208494] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9168), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208518] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9212), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208542] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9146), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [208566] = 6,
    ACTIONS(8254), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1509), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [208596] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9216), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208620] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9321), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [208644] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9186), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208668] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9319), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208692] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9271), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208716] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9292), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [208740] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9275), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208764] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10602), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [208802] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [208826] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9304), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208850] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9300), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [208874] = 8,
    ACTIONS(2106), 1,
      anon_sym_PIPE,
    ACTIONS(10580), 1,
      sym__varid,
    ACTIONS(10584), 1,
      anon_sym_LPAREN,
    ACTIONS(10586), 1,
      anon_sym_AT,
    STATE(7834), 1,
      sym_fundeps,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10604), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4563), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [208908] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10606), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [208946] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10608), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [208984] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10493), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(986), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [209020] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [209046] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9294), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
  [209070] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10610), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [209108] = 9,
    ACTIONS(10151), 1,
      sym_comma,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1201), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [209144] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [209168] = 8,
    ACTIONS(2126), 1,
      anon_sym_PIPE,
    ACTIONS(10561), 1,
      sym__varid,
    ACTIONS(10563), 1,
      anon_sym_LPAREN,
    ACTIONS(10565), 1,
      anon_sym_AT,
    STATE(7560), 1,
      sym_fundeps,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10604), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4700), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [209202] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [209226] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [209250] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10612), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [209288] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [209312] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9210), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [209336] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10363), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [209360] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10614), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [209398] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10616), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [209436] = 5,
    ACTIONS(10618), 1,
      sym__immediate_dot,
    STATE(4629), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8356), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [209464] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9226), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [209488] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10351), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [209512] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10493), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10491), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1011), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [209550] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10621), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [209588] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10347), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [209612] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10331), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [209636] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [209662] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [209688] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(8853), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [209712] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10623), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [209750] = 6,
    ACTIONS(8682), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1596), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10555), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [209780] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8949), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [209806] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10375), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [209830] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10625), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [209868] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [209892] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9133), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [209916] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [209940] = 9,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10429), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1034), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [209976] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8338), 9,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_AT2,
  [210000] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10627), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [210038] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10327), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [210062] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [210086] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10377), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [210110] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10629), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [210148] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210172] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10631), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [210210] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [210236] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10633), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [210274] = 9,
    ACTIONS(10429), 1,
      sym_comma,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1201), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [210310] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210334] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210358] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210382] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210406] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210430] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10375), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [210454] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [210478] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10369), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [210502] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210526] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210550] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210574] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210598] = 8,
    ACTIONS(2106), 1,
      anon_sym_PIPE,
    ACTIONS(10580), 1,
      sym__varid,
    ACTIONS(10584), 1,
      anon_sym_LPAREN,
    ACTIONS(10586), 1,
      anon_sym_AT,
    STATE(7763), 1,
      sym_fundeps,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10559), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(4850), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [210632] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(9281), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [210656] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__dot,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8223), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [210680] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10635), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [210718] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10351), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [210742] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210766] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210790] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10347), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [210814] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [210838] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210862] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10327), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [210886] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(8896), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [210912] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9300), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [210936] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210960] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 9,
      sym_string,
      sym__integer_literal,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [210984] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9296), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [211008] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10369), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [211032] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 6,
      sym_comma,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_of,
  [211056] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [211080] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [211104] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9214), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [211128] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10377), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [211152] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9218), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [211176] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10637), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [211214] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
    ACTIONS(9186), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [211238] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [211262] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [211286] = 9,
    ACTIONS(10137), 1,
      sym_comma,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1201), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [211322] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
    ACTIONS(9170), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [211346] = 8,
    ACTIONS(2126), 1,
      anon_sym_PIPE,
    ACTIONS(10561), 1,
      sym__varid,
    ACTIONS(10563), 1,
      anon_sym_LPAREN,
    ACTIONS(10565), 1,
      anon_sym_AT,
    STATE(7654), 1,
      sym_fundeps,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10582), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(4860), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [211380] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [211404] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10639), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10641), 8,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [211428] = 4,
    ACTIONS(10643), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10511), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(10509), 7,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
  [211454] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10645), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [211492] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10647), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [211530] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 5,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
    ACTIONS(10331), 9,
      sym_number,
      sym_char,
      sym_triple_quote_string,
      sym__hex_literal,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_LBRACK,
  [211554] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 9,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_AT2,
  [211578] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10649), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [211616] = 10,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10200), 1,
      anon_sym_BQUOTE,
    ACTIONS(10651), 1,
      anon_sym_RPAREN,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(636), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [211654] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 9,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT,
  [211678] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(10379), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [211701] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [211724] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [211747] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [211770] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [211793] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8781), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [211816] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10657), 1,
      anon_sym_RPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    STATE(7594), 1,
      sym_constructor,
    STATE(8650), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [211855] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [211878] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8789), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [211901] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8793), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [211924] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8802), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [211947] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [211970] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10665), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10667), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [211993] = 9,
    ACTIONS(10429), 1,
      sym_comma,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1154), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [212028] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8338), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [212051] = 5,
    ACTIONS(10669), 1,
      sym__immediate_dot,
    STATE(4783), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [212078] = 10,
    ACTIONS(8106), 1,
      sym_comma,
    ACTIONS(8874), 1,
      sym__conid,
    ACTIONS(8995), 1,
      anon_sym_AT2,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10671), 1,
      sym__immediate_dot,
    STATE(5689), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8108), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(8110), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
  [212115] = 5,
    ACTIONS(10669), 1,
      sym__immediate_dot,
    STATE(4783), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [212142] = 9,
    ACTIONS(10429), 1,
      anon_sym_then,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1231), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [212177] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [212200] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10153), 1,
      anon_sym_PIPE,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1202), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [212235] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [212258] = 9,
    ACTIONS(10137), 1,
      anon_sym_then,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1231), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [212293] = 5,
    ACTIONS(10545), 1,
      sym__immediate_dot,
    STATE(4489), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8321), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [212320] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10491), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(995), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [212355] = 6,
    ACTIONS(9045), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1697), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [212384] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [212407] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [212430] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(10379), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [212453] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [212476] = 9,
    ACTIONS(10429), 1,
      anon_sym_RPAREN,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1109), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [212511] = 9,
    ACTIONS(10139), 1,
      anon_sym_PIPE,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1202), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [212546] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [212569] = 9,
    ACTIONS(10151), 1,
      anon_sym_then,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1231), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [212604] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [212627] = 9,
    ACTIONS(10463), 1,
      anon_sym_EQ,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10677), 1,
      anon_sym_LPAREN,
    ACTIONS(10679), 1,
      anon_sym_AT,
    STATE(1219), 1,
      sym__colon2,
    STATE(9995), 1,
      sym__type_annotation,
    ACTIONS(10675), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5062), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [212662] = 8,
    ACTIONS(8104), 1,
      anon_sym_BQUOTE,
    ACTIONS(8877), 1,
      anon_sym_AT2,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10681), 1,
      sym__immediate_dot,
    STATE(4841), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8110), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(8874), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [212695] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [212718] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10669), 1,
      sym__immediate_dot,
    STATE(4728), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [212747] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10220), 8,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_type,
      anon_sym_then,
      anon_sym_else,
      anon_sym_class,
      anon_sym_data,
      anon_sym_newtype,
  [212770] = 10,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10465), 1,
      sym__varid,
    ACTIONS(10469), 1,
      anon_sym_LPAREN,
    STATE(1508), 1,
      sym_type_name,
    STATE(4336), 1,
      sym_constructor,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [212807] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [212830] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10669), 1,
      sym__immediate_dot,
    STATE(4726), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [212859] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [212882] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [212905] = 6,
    ACTIONS(8769), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1616), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [212934] = 5,
    ACTIONS(10569), 1,
      sym__immediate_dot,
    STATE(4539), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8321), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [212961] = 5,
    ACTIONS(10683), 1,
      sym__immediate_dot,
    STATE(4758), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8356), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8354), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [212988] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [213011] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(10379), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [213034] = 9,
    ACTIONS(10429), 1,
      anon_sym_else,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1042), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10432), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [213069] = 9,
    ACTIONS(10137), 1,
      anon_sym_else,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1042), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [213104] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [213127] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [213150] = 9,
    ACTIONS(10151), 1,
      anon_sym_else,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1042), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [213185] = 5,
    ACTIONS(10686), 1,
      sym__immediate_dot,
    STATE(4766), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8356), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8354), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [213212] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [213235] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10151), 8,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_type,
      anon_sym_then,
      anon_sym_else,
      anon_sym_class,
      anon_sym_data,
      anon_sym_newtype,
  [213258] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10432), 1,
      anon_sym_PIPE,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1211), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [213293] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [213316] = 9,
    ACTIONS(10151), 1,
      anon_sym_RPAREN,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1109), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [213351] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8771), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [213374] = 9,
    ACTIONS(10139), 1,
      anon_sym_PIPE,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1157), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [213409] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [213432] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    ACTIONS(10689), 1,
      anon_sym_RPAREN,
    STATE(7594), 1,
      sym_constructor,
    STATE(8333), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [213471] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8802), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [213494] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [213517] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [213540] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [213563] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [213586] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8793), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [213609] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    ACTIONS(10691), 1,
      anon_sym_RPAREN,
    STATE(7594), 1,
      sym_constructor,
    STATE(8076), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [213648] = 5,
    ACTIONS(10693), 1,
      sym__immediate_dot,
    STATE(4783), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8356), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8354), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [213675] = 4,
    ACTIONS(8894), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [213700] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10491), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1004), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [213735] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [213758] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [213781] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [213804] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [213827] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [213850] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [213873] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [213896] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [213919] = 5,
    ACTIONS(10696), 1,
      sym__immediate_dot,
    STATE(4758), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [213946] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [213969] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [213992] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [214015] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [214038] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [214061] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [214084] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [214107] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [214130] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [214153] = 9,
    ACTIONS(10139), 1,
      anon_sym_PIPE,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1211), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [214188] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [214211] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8789), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [214234] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    ACTIONS(10698), 1,
      anon_sym_RPAREN,
    STATE(7594), 1,
      sym_constructor,
    STATE(8100), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [214273] = 5,
    ACTIONS(10696), 1,
      sym__immediate_dot,
    STATE(4758), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [214300] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [214323] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [214346] = 10,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10477), 1,
      sym__varid,
    ACTIONS(10485), 1,
      anon_sym_LPAREN,
    STATE(1581), 1,
      sym_type_name,
    STATE(4360), 1,
      sym_constructor,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [214383] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [214406] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [214429] = 9,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10700), 1,
      anon_sym_BQUOTE,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(645), 6,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
      sym_exp_ticked,
  [214464] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [214487] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [214510] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [214533] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [214556] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [214579] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [214602] = 5,
    ACTIONS(10702), 1,
      sym__immediate_dot,
    STATE(4766), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [214629] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10153), 1,
      anon_sym_PIPE,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1157), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [214664] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10432), 1,
      anon_sym_PIPE,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1202), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [214699] = 10,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10465), 1,
      sym__varid,
    ACTIONS(10469), 1,
      anon_sym_LPAREN,
    STATE(1587), 1,
      sym_type_name,
    STATE(4336), 1,
      sym_constructor,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [214736] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8789), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [214759] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [214782] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [214805] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [214828] = 9,
    ACTIONS(10137), 1,
      anon_sym_RPAREN,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1109), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [214863] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [214886] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    ACTIONS(10704), 1,
      anon_sym_RPAREN,
    STATE(7594), 1,
      sym_constructor,
    STATE(8650), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [214925] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8781), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [214948] = 5,
    ACTIONS(10706), 1,
      sym__immediate_dot,
    STATE(4833), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8356), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8354), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [214975] = 4,
    ACTIONS(8894), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [215000] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [215023] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8793), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [215046] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [215069] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [215092] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [215115] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [215138] = 5,
    ACTIONS(10681), 1,
      sym__immediate_dot,
    STATE(4833), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8250), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [215165] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [215188] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [215211] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [215234] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [215257] = 10,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10465), 1,
      sym__varid,
    ACTIONS(10469), 1,
      anon_sym_LPAREN,
    STATE(1576), 1,
      sym_type_name,
    STATE(4336), 1,
      sym_constructor,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [215294] = 10,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10477), 1,
      sym__varid,
    ACTIONS(10485), 1,
      anon_sym_LPAREN,
    STATE(1510), 1,
      sym_type_name,
    STATE(4360), 1,
      sym_constructor,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [215331] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [215354] = 10,
    ACTIONS(8313), 1,
      sym__conid,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10465), 1,
      sym__varid,
    ACTIONS(10469), 1,
      anon_sym_LPAREN,
    STATE(1591), 1,
      sym_type_name,
    STATE(4336), 1,
      sym_constructor,
    STATE(7544), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4510), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [215391] = 6,
    ACTIONS(10709), 1,
      sym__varid,
    ACTIONS(10714), 1,
      anon_sym_LPAREN,
    ACTIONS(10717), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10712), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(4850), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [215420] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [215443] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10696), 1,
      sym__immediate_dot,
    STATE(4794), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [215472] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    ACTIONS(10720), 1,
      anon_sym_RPAREN,
    STATE(7594), 1,
      sym_constructor,
    STATE(8650), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [215511] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8802), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [215534] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    ACTIONS(10722), 1,
      anon_sym_RPAREN,
    STATE(7594), 1,
      sym_constructor,
    STATE(8400), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [215573] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [215596] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [215619] = 10,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(4979), 1,
      anon_sym_AT,
    ACTIONS(10724), 1,
      sym__varid,
    ACTIONS(10726), 1,
      anon_sym_LPAREN,
    STATE(3780), 1,
      sym_constructor,
    STATE(7623), 1,
      aux_sym__qualifying_module,
    STATE(8667), 1,
      sym_type_name,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4283), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [215656] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [215679] = 6,
    ACTIONS(10728), 1,
      sym__varid,
    ACTIONS(10731), 1,
      anon_sym_LPAREN,
    ACTIONS(10734), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10712), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(4860), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [215708] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [215731] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10696), 1,
      sym__immediate_dot,
    STATE(4808), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [215760] = 9,
    ACTIONS(10463), 1,
      anon_sym_EQ,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10677), 1,
      anon_sym_LPAREN,
    ACTIONS(10679), 1,
      anon_sym_AT,
    STATE(1069), 1,
      sym__colon2,
    STATE(9970), 1,
      sym__type_annotation,
    ACTIONS(10737), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5062), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [215795] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10739), 6,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__conid,
      anon_sym_forall,
    ACTIONS(10741), 7,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_u2200,
  [215818] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [215841] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [215864] = 5,
    ACTIONS(10702), 1,
      sym__immediate_dot,
    STATE(4766), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8250), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [215891] = 6,
    ACTIONS(8984), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1683), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [215920] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8771), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [215943] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    ACTIONS(10743), 1,
      anon_sym_RPAREN,
    STATE(7594), 1,
      sym_constructor,
    STATE(8650), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [215982] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    ACTIONS(10745), 1,
      anon_sym_RPAREN,
    STATE(7594), 1,
      sym_constructor,
    STATE(8650), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [216021] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [216044] = 13,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10747), 1,
      anon_sym_LPAREN,
    ACTIONS(10749), 1,
      anon_sym_type,
    ACTIONS(10751), 1,
      anon_sym_class,
    ACTIONS(10753), 1,
      anon_sym_module,
    STATE(6844), 1,
      aux_sym__qualifying_module,
    STATE(7491), 1,
      sym_constructor,
    STATE(7577), 1,
      sym_qualified_type,
    STATE(8339), 1,
      sym_export,
    STATE(10018), 1,
      sym__modid,
    STATE(8679), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [216087] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [216110] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8771), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [216133] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8781), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [216156] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [216179] = 9,
    ACTIONS(10137), 1,
      sym_comma,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1154), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10139), 4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [216214] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9160), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [216237] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [216260] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [216283] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [216306] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10702), 1,
      sym__immediate_dot,
    STATE(4867), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [216335] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [216358] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [216381] = 5,
    ACTIONS(10681), 1,
      sym__immediate_dot,
    STATE(4833), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8250), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [216408] = 13,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10747), 1,
      anon_sym_LPAREN,
    ACTIONS(10749), 1,
      anon_sym_type,
    ACTIONS(10751), 1,
      anon_sym_class,
    ACTIONS(10753), 1,
      anon_sym_module,
    STATE(6844), 1,
      aux_sym__qualifying_module,
    STATE(7491), 1,
      sym_constructor,
    STATE(7577), 1,
      sym_qualified_type,
    STATE(8646), 1,
      sym_export,
    STATE(10018), 1,
      sym__modid,
    STATE(8679), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [216451] = 10,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10477), 1,
      sym__varid,
    ACTIONS(10485), 1,
      anon_sym_LPAREN,
    STATE(1568), 1,
      sym_type_name,
    STATE(4360), 1,
      sym_constructor,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [216488] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [216511] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [216534] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10153), 1,
      anon_sym_PIPE,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1211), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [216569] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [216592] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [216615] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9144), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [216638] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [216661] = 5,
    ACTIONS(10571), 1,
      sym__immediate_dot,
    STATE(4629), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8321), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [216688] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9321), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [216711] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9292), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [216734] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9210), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [216757] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [216780] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10432), 1,
      anon_sym_PIPE,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1157), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [216815] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9283), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_then,
  [216838] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_data,
  [216861] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9327), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [216884] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_type,
  [216907] = 11,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    ACTIONS(10755), 1,
      anon_sym_RPAREN,
    STATE(7594), 1,
      sym_constructor,
    STATE(8650), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [216946] = 10,
    ACTIONS(8285), 1,
      sym__conid,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10477), 1,
      sym__varid,
    ACTIONS(10485), 1,
      anon_sym_LPAREN,
    STATE(1533), 1,
      sym_type_name,
    STATE(4360), 1,
      sym_constructor,
    STATE(7541), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4616), 5,
      sym_qualified_type,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
  [216983] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10681), 1,
      sym__immediate_dot,
    STATE(4886), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8415), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [217012] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9133), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217035] = 9,
    ACTIONS(10151), 1,
      sym_comma,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1154), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10153), 4,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [217070] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9204), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_class,
  [217093] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9298), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217116] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9302), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217139] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10702), 1,
      sym__immediate_dot,
    STATE(4821), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [217168] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9296), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217191] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9170), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217214] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8870), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [217237] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217260] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217283] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9277), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [217306] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9273), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_newtype,
  [217329] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9184), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217352] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9218), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217375] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_triple_quote_string,
      sym__hex_literal,
      sym_hole,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(9214), 8,
      sym_string,
      sym__integer_literal,
      anon_sym__,
      sym__varid,
      sym__operator,
      sym__conid,
      anon_sym_AT,
      anon_sym_else,
  [217398] = 4,
    ACTIONS(10757), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8925), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [217422] = 5,
    ACTIONS(10532), 1,
      sym__immediate_dot,
    STATE(4935), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [217448] = 9,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10153), 1,
      anon_sym_PIPE,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(1206), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [217482] = 13,
    ACTIONS(10759), 1,
      sym__varid,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(10763), 1,
      sym__conid,
    STATE(825), 1,
      sym_class_name,
    STATE(3220), 1,
      sym_constructor,
    STATE(3414), 1,
      sym_qualified_type,
    STATE(5636), 1,
      sym__instance_name,
    STATE(7746), 1,
      sym_instance_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7948), 1,
      aux_sym__qualifying_module,
    STATE(8144), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [217524] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10681), 1,
      sym__immediate_dot,
    STATE(5000), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [217552] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1156), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [217584] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8896), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [217608] = 5,
    ACTIONS(10532), 1,
      sym__immediate_dot,
    STATE(4935), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [217634] = 6,
    ACTIONS(10767), 1,
      sym__varid,
    ACTIONS(10770), 1,
      anon_sym_LPAREN,
    ACTIONS(10773), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10712), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_DOT,
    STATE(4933), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [217662] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(8225), 6,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [217684] = 5,
    ACTIONS(10776), 1,
      sym__immediate_dot,
    STATE(4935), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8356), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [217710] = 10,
    ACTIONS(10653), 1,
      sym__varid,
    ACTIONS(10655), 1,
      anon_sym_LPAREN,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(10661), 1,
      anon_sym_type,
    ACTIONS(10663), 1,
      anon_sym_class,
    STATE(7594), 1,
      sym_constructor,
    STATE(8650), 1,
      sym_import_item,
    STATE(8681), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8680), 4,
      sym_class_import,
      sym_type_operator_import,
      sym_type_import,
      sym_var_import,
  [217746] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8855), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [217770] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(8225), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [217792] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8861), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [217816] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8771), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8773), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [217838] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8781), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8783), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [217860] = 6,
    ACTIONS(10779), 1,
      sym__varid,
    ACTIONS(10782), 1,
      anon_sym_LPAREN,
    ACTIONS(10785), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10712), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(4942), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [217888] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8340), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [217910] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
    ACTIONS(8225), 6,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [217932] = 6,
    ACTIONS(8113), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1781), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [217960] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10532), 1,
      sym__immediate_dot,
    STATE(5002), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [217988] = 5,
    ACTIONS(10788), 1,
      sym__immediate_dot,
    STATE(4947), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8356), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218014] = 11,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(10791), 1,
      sym__conid,
    STATE(902), 1,
      sym_class_name,
    STATE(4317), 1,
      sym_constructor,
    STATE(4366), 1,
      sym_qualified_type,
    STATE(7756), 1,
      aux_sym__qualifying_module,
    STATE(8204), 1,
      sym_constraint,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7857), 3,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
  [218052] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8921), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218074] = 6,
    ACTIONS(10793), 1,
      sym__varid,
    ACTIONS(10796), 1,
      anon_sym_LPAREN,
    ACTIONS(10799), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10712), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(4950), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [218102] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8789), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8791), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [218124] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8949), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218148] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1261), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [218180] = 4,
    ACTIONS(10802), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8913), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218204] = 5,
    ACTIONS(10702), 1,
      sym__immediate_dot,
    STATE(4766), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218230] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218252] = 5,
    ACTIONS(10528), 1,
      sym__immediate_dot,
    STATE(4981), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218278] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10532), 1,
      sym__immediate_dot,
    STATE(4926), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218306] = 9,
    ACTIONS(10137), 1,
      sym_comma,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10139), 3,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(1158), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [218340] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8949), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218364] = 5,
    ACTIONS(10804), 1,
      sym__immediate_dot,
    STATE(4947), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218390] = 4,
    ACTIONS(10806), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8885), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218414] = 5,
    ACTIONS(10681), 1,
      sym__immediate_dot,
    STATE(4833), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(8321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218440] = 5,
    ACTIONS(10804), 1,
      sym__immediate_dot,
    STATE(4947), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218466] = 11,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(10791), 1,
      sym__conid,
    STATE(902), 1,
      sym_class_name,
    STATE(4317), 1,
      sym_constructor,
    STATE(4366), 1,
      sym_qualified_type,
    STATE(7756), 1,
      aux_sym__qualifying_module,
    STATE(8204), 1,
      sym_constraint,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7950), 3,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
  [218504] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1156), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [218536] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8802), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8804), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [218558] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8781), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8783), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [218580] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8793), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8795), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [218602] = 4,
    ACTIONS(10808), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8775), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218626] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8789), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8791), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [218648] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8921), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218670] = 9,
    ACTIONS(10429), 1,
      sym_comma,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10432), 3,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(1158), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [218704] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8861), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218728] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8947), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218750] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1261), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [218782] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8902), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218804] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8223), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218826] = 4,
    ACTIONS(10810), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8913), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218850] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218874] = 5,
    ACTIONS(10812), 1,
      sym__immediate_dot,
    STATE(4981), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8356), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [218900] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8896), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218924] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8902), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [218946] = 10,
    ACTIONS(8106), 1,
      sym_comma,
    ACTIONS(8874), 1,
      sym__conid,
    ACTIONS(8995), 1,
      anon_sym_AT2,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10815), 1,
      sym__immediate_dot,
    STATE(6017), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8104), 2,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(8108), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(8110), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [218982] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10804), 1,
      sym__immediate_dot,
    STATE(4964), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219010] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8947), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219032] = 13,
    ACTIONS(10759), 1,
      sym__varid,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(10817), 1,
      sym__conid,
    STATE(827), 1,
      sym_class_name,
    STATE(3163), 1,
      sym_constructor,
    STATE(3411), 1,
      sym_qualified_type,
    STATE(5684), 1,
      sym__instance_name,
    STATE(7597), 1,
      sym_instance_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7862), 1,
      aux_sym__qualifying_module,
    STATE(8604), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [219074] = 6,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1841), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219102] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8896), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219126] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219150] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8861), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219174] = 4,
    ACTIONS(10819), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8885), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219198] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8931), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219220] = 5,
    ACTIONS(10696), 1,
      sym__immediate_dot,
    STATE(4758), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219246] = 5,
    ACTIONS(10528), 1,
      sym__immediate_dot,
    STATE(4981), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219272] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 9,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_AT2,
  [219294] = 5,
    ACTIONS(10528), 1,
      sym__immediate_dot,
    STATE(4981), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219320] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8413), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219344] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8771), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8773), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [219366] = 5,
    ACTIONS(10681), 1,
      sym__immediate_dot,
    STATE(4833), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 5,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219392] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8793), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8795), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [219414] = 5,
    ACTIONS(10532), 1,
      sym__immediate_dot,
    STATE(4935), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219440] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8781), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8783), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [219462] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8802), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8804), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [219484] = 5,
    ACTIONS(10821), 1,
      sym__immediate_dot,
    STATE(5005), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8356), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219510] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1090), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [219542] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8781), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8783), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [219564] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8802), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8804), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [219586] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 5,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8338), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_AT2,
  [219608] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219630] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8793), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8795), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [219652] = 4,
    ACTIONS(10824), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219676] = 5,
    ACTIONS(10826), 1,
      sym__immediate_dot,
    STATE(5005), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219702] = 4,
    ACTIONS(10828), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219726] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8802), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8804), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [219748] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8413), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219772] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10381), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [219794] = 5,
    ACTIONS(10826), 1,
      sym__immediate_dot,
    STATE(5005), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [219820] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8793), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8795), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [219842] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8789), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8791), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [219864] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8413), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [219888] = 6,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10477), 1,
      sym__varid,
    ACTIONS(10485), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10830), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(4942), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [219916] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8771), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8773), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [219938] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8789), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8791), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [219960] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1261), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [219992] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8861), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [220016] = 6,
    ACTIONS(9313), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1824), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10553), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220044] = 13,
    ACTIONS(10759), 1,
      sym__varid,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(10763), 1,
      sym__conid,
    STATE(825), 1,
      sym_class_name,
    STATE(3220), 1,
      sym_constructor,
    STATE(3414), 1,
      sym_qualified_type,
    STATE(5661), 1,
      sym__instance_name,
    STATE(7778), 1,
      sym_constraint,
    STATE(7823), 1,
      sym_instance_head,
    STATE(7948), 1,
      aux_sym__qualifying_module,
    STATE(8144), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [220086] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10381), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [220108] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8340), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [220130] = 6,
    ACTIONS(8135), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1762), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220158] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8340), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [220180] = 9,
    ACTIONS(10151), 1,
      sym_comma,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 3,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    STATE(1158), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [220214] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8949), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [220238] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8861), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220262] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10528), 1,
      sym__immediate_dot,
    STATE(4957), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220290] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220314] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8340), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [220336] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220358] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10381), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [220380] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10528), 1,
      sym__immediate_dot,
    STATE(4997), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220408] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220430] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8931), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [220452] = 9,
    ACTIONS(10139), 1,
      anon_sym_PIPE,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10137), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(1206), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [220486] = 6,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10465), 1,
      sym__varid,
    ACTIONS(10469), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10830), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
    STATE(4950), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [220514] = 5,
    ACTIONS(10669), 1,
      sym__immediate_dot,
    STATE(4783), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220540] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 5,
      sym__layout_semicolon,
      sym__dot,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8223), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220562] = 4,
    ACTIONS(10832), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8925), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [220586] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1090), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10137), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [220618] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10826), 1,
      sym__immediate_dot,
    STATE(5018), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8415), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220646] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10381), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
  [220668] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8771), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8773), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
  [220690] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10826), 1,
      sym__immediate_dot,
    STATE(5013), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8106), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [220718] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1156), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [220750] = 13,
    ACTIONS(10759), 1,
      sym__varid,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(10817), 1,
      sym__conid,
    STATE(827), 1,
      sym_class_name,
    STATE(3163), 1,
      sym_constructor,
    STATE(3411), 1,
      sym_qualified_type,
    STATE(5681), 1,
      sym__instance_name,
    STATE(7655), 1,
      sym_instance_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7862), 1,
      aux_sym__qualifying_module,
    STATE(8604), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [220792] = 11,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10834), 1,
      sym__operator,
    STATE(4702), 1,
      sym_type_operator,
    STATE(6433), 1,
      aux_sym__qualifying_module,
    STATE(10005), 1,
      sym_constructor_operator,
    STATE(10103), 1,
      sym_constructor,
    STATE(10142), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3023), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
  [220830] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1090), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [220862] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [220886] = 4,
    ACTIONS(10836), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8775), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [220910] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9283), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [220931] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8898), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [220954] = 6,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10677), 1,
      anon_sym_LPAREN,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10830), 3,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
    STATE(4933), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [220981] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8781), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221002] = 4,
    ACTIONS(10838), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(8925), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221025] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10842), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221046] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8104), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221067] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10804), 1,
      sym__immediate_dot,
    STATE(4961), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 3,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221094] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10218), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221115] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8931), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8929), 6,
      sym__layout_end,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [221136] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221157] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10681), 1,
      sym__immediate_dot,
    STATE(4841), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 3,
      sym_comma,
      sym__conid,
      anon_sym_of,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221184] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8947), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8945), 6,
      sym__layout_end,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [221205] = 4,
    ACTIONS(10844), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221228] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9156), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221249] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8900), 6,
      sym__layout_end,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [221270] = 4,
    ACTIONS(10846), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221293] = 6,
    ACTIONS(9395), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2139), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 3,
      sym_comma,
      sym__conid,
      anon_sym_of,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221320] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10850), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221341] = 4,
    ACTIONS(8894), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221364] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10854), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221385] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9240), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221406] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8104), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221427] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9220), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221448] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10858), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221469] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8921), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8919), 6,
      sym__layout_end,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [221490] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9327), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221511] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10681), 1,
      sym__immediate_dot,
    STATE(4963), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10314), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [221538] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9144), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221559] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9298), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221580] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9302), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221601] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9296), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221622] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9148), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221643] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9277), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221664] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9273), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221685] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9184), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221706] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9218), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221727] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9214), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221748] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8781), 8,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221769] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9170), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221790] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9133), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221811] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10153), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221832] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9210), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221853] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9292), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221874] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8338), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221895] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9138), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [221916] = 4,
    ACTIONS(10860), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8775), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8777), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [221939] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [221962] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8225), 6,
      sym__dot,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [221983] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8861), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222006] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9321), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222027] = 6,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10677), 1,
      anon_sym_LPAREN,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10463), 3,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
    STATE(5062), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [222054] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9236), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222075] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8861), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222098] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9248), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222119] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222142] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9240), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222163] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10864), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222184] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10868), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222205] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10872), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222226] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10432), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222247] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10876), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222268] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9256), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222289] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8415), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [222312] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10880), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222333] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9228), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222354] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9152), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222375] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10884), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222396] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9220), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222417] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9220), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222438] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8793), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222459] = 9,
    ACTIONS(10429), 1,
      anon_sym_RPAREN,
    ACTIONS(10435), 1,
      sym__operator,
    ACTIONS(10439), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10432), 2,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1067), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [222492] = 4,
    ACTIONS(10886), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(8885), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222515] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222536] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9127), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222557] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10890), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222578] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9164), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222599] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10894), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222620] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8771), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222641] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10898), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222662] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9172), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222683] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10379), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222704] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10218), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222725] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8789), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222746] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8951), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [222769] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8900), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [222790] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8771), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222811] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9176), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222832] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8802), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222853] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9156), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222874] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10902), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [222895] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(10379), 8,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222916] = 5,
    ACTIONS(10804), 1,
      sym__immediate_dot,
    STATE(4947), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222941] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8789), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222962] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8793), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [222983] = 6,
    ACTIONS(9220), 1,
      anon_sym_BQUOTE,
    ACTIONS(9888), 1,
      sym__conid,
    ACTIONS(9260), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(9262), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [223010] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9232), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223031] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9144), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [223052] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(1070), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [223083] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8802), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [223104] = 6,
    ACTIONS(8413), 1,
      anon_sym_BQUOTE,
    ACTIONS(9978), 1,
      sym__conid,
    ACTIONS(9199), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(9201), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [223131] = 6,
    ACTIONS(8104), 1,
      anon_sym_BQUOTE,
    ACTIONS(9194), 1,
      sym__conid,
    ACTIONS(9197), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(9191), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [223158] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9283), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223179] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9321), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223200] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9292), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223221] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9210), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223242] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(1204), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [223273] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9244), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223294] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [223317] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9180), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223338] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9180), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223359] = 6,
    ACTIONS(9352), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1981), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10553), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [223386] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8861), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [223409] = 5,
    ACTIONS(10528), 1,
      sym__immediate_dot,
    STATE(4981), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [223434] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10842), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223455] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [223476] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9204), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223497] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10858), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223518] = 6,
    ACTIONS(9220), 1,
      anon_sym_BQUOTE,
    ACTIONS(9888), 1,
      sym__conid,
    ACTIONS(9260), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(9262), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [223545] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223566] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10153), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223587] = 6,
    ACTIONS(8413), 1,
      anon_sym_BQUOTE,
    ACTIONS(9978), 1,
      sym__conid,
    ACTIONS(9199), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(9201), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [223614] = 6,
    ACTIONS(8104), 1,
      anon_sym_BQUOTE,
    ACTIONS(9194), 1,
      sym__conid,
    ACTIONS(9197), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(9191), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [223641] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10850), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223662] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9152), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223683] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9327), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223704] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8947), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8945), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [223725] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9133), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223746] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8931), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8929), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [223767] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9170), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223788] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9214), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223809] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9218), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223830] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8225), 6,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [223851] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8951), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [223874] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10850), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223895] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10854), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223916] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10858), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [223937] = 4,
    ACTIONS(10904), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8925), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [223960] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8921), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8919), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [223981] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 8,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [224002] = 4,
    ACTIONS(10906), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [224025] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9160), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224046] = 4,
    ACTIONS(10908), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [224069] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8781), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [224090] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10902), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224111] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9184), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224132] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(1070), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [224163] = 4,
    ACTIONS(10910), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8885), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [224186] = 9,
    ACTIONS(10137), 1,
      anon_sym_RPAREN,
    ACTIONS(10423), 1,
      sym__operator,
    ACTIONS(10426), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10139), 2,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1067), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [224219] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10868), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224240] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10872), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224261] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10876), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224282] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9273), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224303] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9277), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224324] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9224), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224345] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224366] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224387] = 8,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6147), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9626), 5,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_qualified_operator,
      sym__q_op,
  [224418] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9279), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224439] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9148), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224460] = 4,
    ACTIONS(10912), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8775), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8777), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [224483] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10902), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224504] = 9,
    ACTIONS(10151), 1,
      anon_sym_RPAREN,
    ACTIONS(10417), 1,
      sym__operator,
    ACTIONS(10420), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10153), 2,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1067), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [224537] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10884), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224558] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9160), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224579] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10555), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224600] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10890), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224621] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8898), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [224644] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(1204), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [224675] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10894), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224696] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10914), 1,
      sym__immediate_dot,
    STATE(5248), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8415), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [224723] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10898), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224744] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9138), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224765] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10914), 1,
      sym__immediate_dot,
    STATE(5250), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8106), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [224792] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10868), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224813] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10381), 6,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [224834] = 4,
    ACTIONS(10916), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8775), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224857] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10842), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224878] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9144), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [224899] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9204), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224920] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9236), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224941] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10854), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224962] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9296), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [224983] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1086), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [225014] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9302), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225035] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9298), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225056] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10876), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225077] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10137), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(1131), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [225108] = 5,
    ACTIONS(10914), 1,
      sym__immediate_dot,
    STATE(5256), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [225133] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10880), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225154] = 5,
    ACTIONS(10914), 1,
      sym__immediate_dot,
    STATE(5256), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [225179] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9279), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225200] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8855), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225221] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9224), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225242] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8771), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225263] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(10379), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225284] = 5,
    ACTIONS(10919), 1,
      sym__immediate_dot,
    STATE(5256), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8356), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [225309] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10884), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225330] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10432), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225351] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10864), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225372] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8789), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225393] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8793), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225414] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225435] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8802), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225456] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9298), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225477] = 5,
    ACTIONS(10532), 1,
      sym__immediate_dot,
    STATE(4935), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8319), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225502] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8900), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [225523] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [225546] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8921), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8919), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [225567] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225588] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9144), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225609] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8931), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8929), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [225630] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8947), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8945), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [225651] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9248), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225672] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10890), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225693] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10894), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225714] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [225737] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9256), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225758] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(10379), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [225779] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10898), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225800] = 4,
    ACTIONS(10922), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8885), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225823] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225844] = 6,
    ACTIONS(8289), 1,
      anon_sym_AT,
    ACTIONS(10477), 1,
      sym__varid,
    ACTIONS(10485), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10463), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(5022), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [225871] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10880), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225892] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225913] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10137), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(1204), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [225944] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8225), 6,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [225965] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [225986] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(1131), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [226017] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8781), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [226038] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9144), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226059] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10432), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226080] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226101] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_in,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [226122] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9279), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [226143] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8898), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [226166] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10864), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226187] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [226208] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9224), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [226229] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10872), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226250] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9321), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226271] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9240), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226292] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9292), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226313] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9210), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226334] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8898), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [226357] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9327), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226378] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9133), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226399] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9170), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226420] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9156), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226441] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9214), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226462] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9218), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226483] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9152), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226504] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9148), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226525] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9138), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226546] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9184), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226567] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9224), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226588] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9273), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226609] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9236), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226630] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9248), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226651] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9277), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226672] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9228), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226693] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9296), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226714] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9224), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226735] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9302), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226756] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226777] = 4,
    ACTIONS(10925), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8885), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [226800] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9279), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226821] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9256), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226842] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(1131), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [226873] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9180), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226894] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226915] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10153), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226936] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9283), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226957] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9228), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [226978] = 4,
    ACTIONS(10927), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8925), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227001] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8104), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227022] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9180), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227043] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9127), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227064] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9244), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227085] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9204), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227106] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9127), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227127] = 4,
    ACTIONS(10930), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227150] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8771), 8,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227171] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8789), 8,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227192] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8793), 8,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227213] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 5,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227234] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8802), 8,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227255] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8225), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [227276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9164), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227297] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9172), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227318] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9232), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227339] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9176), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227360] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8951), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [227383] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9279), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227404] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9232), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227425] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 8,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227446] = 5,
    ACTIONS(10826), 1,
      sym__immediate_dot,
    STATE(5005), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8319), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8321), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227471] = 4,
    ACTIONS(10933), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227494] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9244), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227515] = 8,
    ACTIONS(8104), 1,
      anon_sym_BQUOTE,
    ACTIONS(9487), 1,
      anon_sym_AT2,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10804), 1,
      sym__immediate_dot,
    STATE(4961), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8874), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8110), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [227546] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9180), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227567] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8415), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [227590] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227611] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9180), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227632] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9176), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227653] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8951), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [227676] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9172), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227697] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227718] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9160), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227739] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227760] = 4,
    ACTIONS(10936), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8775), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8777), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [227783] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9164), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227804] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8338), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227825] = 6,
    ACTIONS(8317), 1,
      anon_sym_AT,
    ACTIONS(10465), 1,
      sym__varid,
    ACTIONS(10469), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10463), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(5045), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [227852] = 4,
    ACTIONS(10938), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227875] = 4,
    ACTIONS(10940), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227898] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10218), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_BQUOTE,
  [227919] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1086), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [227950] = 4,
    ACTIONS(10942), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8925), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227973] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [227996] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10137), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1086), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [228027] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(8861), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228050] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 8,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
      anon_sym_AT2,
  [228071] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10137), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    STATE(1070), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [228102] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9327), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228122] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9127), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9129), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [228142] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10894), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228162] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228184] = 4,
    ACTIONS(10944), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8925), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228206] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228228] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 5,
      sym__layout_end,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8931), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228248] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228268] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9292), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228288] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9210), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228308] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9327), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228328] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9133), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228348] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9170), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228368] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9214), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228388] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228408] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9186), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [228428] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9273), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228448] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9277), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228468] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9296), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228488] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9304), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [228508] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9300), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [228528] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10898), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228548] = 11,
    ACTIONS(1776), 1,
      sym__conid,
    ACTIONS(2288), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5003), 1,
      sym_variable,
    STATE(5381), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [228584] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10898), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228604] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 5,
      sym__layout_end,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8947), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228624] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 5,
      sym__layout_end,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8921), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228644] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9162), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [228664] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10890), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228684] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228704] = 4,
    ACTIONS(10946), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228726] = 4,
    ACTIONS(10948), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228748] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9206), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [228768] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 5,
      sym__layout_end,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228788] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10842), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228808] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9285), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [228828] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10884), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228848] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8861), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228870] = 4,
    ACTIONS(10950), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8885), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228892] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228914] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10850), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228934] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9240), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9242), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [228954] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10854), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228974] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10876), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [228994] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10872), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229014] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8861), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229036] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10868), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229056] = 11,
    ACTIONS(247), 1,
      sym__conid,
    ACTIONS(891), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1647), 1,
      sym_constructor,
    STATE(2155), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [229092] = 4,
    ACTIONS(10952), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8775), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229114] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9156), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9158), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [229134] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9152), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9154), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [229154] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9222), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [229174] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229196] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10854), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229216] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10850), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229236] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9148), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9150), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [229256] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9138), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9140), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [229276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9281), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [229296] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229316] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9226), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [229336] = 11,
    ACTIONS(73), 1,
      sym__conid,
    ACTIONS(601), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2436), 1,
      sym_variable,
    STATE(2686), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [229372] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9236), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9238), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [229392] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10868), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229412] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10872), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229432] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10864), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229452] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9285), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [229472] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229492] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229512] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9292), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229532] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9210), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229552] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9133), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229572] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8106), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [229592] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9170), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229612] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9214), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229632] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10876), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229652] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229674] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10842), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229694] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229716] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229738] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229758] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9186), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [229778] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9273), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229798] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9277), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229818] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10804), 1,
      sym__immediate_dot,
    STATE(5564), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8106), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229844] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9296), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229864] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9206), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [229884] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9304), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [229904] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9300), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [229924] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10880), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [229944] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9248), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9250), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [229964] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9256), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9258), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [229984] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9228), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9230), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230004] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9127), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9129), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230024] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10894), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230044] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9164), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9166), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230064] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [230084] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10890), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230104] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10884), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230124] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9172), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9174), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230144] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9176), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9178), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230164] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9232), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9234), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230184] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9162), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [230204] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230224] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9244), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9246), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230244] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9182), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230264] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9182), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230284] = 11,
    ACTIONS(153), 1,
      sym__conid,
    ACTIONS(989), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1659), 1,
      sym_constructor,
    STATE(2192), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [230320] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230340] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10894), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230360] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9254), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [230380] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10898), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230400] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10381), 5,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
      anon_sym_then,
      anon_sym_else,
  [230420] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(10956), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8530), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [230452] = 9,
    ACTIONS(10960), 1,
      anon_sym_PIPE,
    ACTIONS(10962), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(7090), 1,
      aux_sym_alt_repeat1,
    STATE(7953), 1,
      sym__alt_variants,
    STATE(8579), 1,
      sym_guards,
    ACTIONS(10958), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(6299), 2,
      sym_gdpat,
      aux_sym__alt_variants_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [230484] = 11,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(2114), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5063), 1,
      sym_variable,
    STATE(5770), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [230520] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230540] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10864), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230560] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230580] = 5,
    ACTIONS(10671), 1,
      sym__immediate_dot,
    STATE(5686), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230604] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8949), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230626] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10890), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230646] = 8,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10432), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1162), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [230676] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10880), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230696] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10220), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [230716] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9281), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [230736] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230756] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9226), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [230776] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8225), 5,
      sym__dot,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
  [230796] = 11,
    ACTIONS(1475), 1,
      sym__varid,
    ACTIONS(1491), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2961), 1,
      sym_constructor,
    STATE(2964), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [230832] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(10964), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8530), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [230864] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8949), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [230886] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9254), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [230906] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [230926] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [230946] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9244), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9246), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [230966] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9156), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9158), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [230986] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9232), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9234), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231006] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9176), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9178), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231026] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9172), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9174), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231046] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9164), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9166), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231066] = 9,
    ACTIONS(10960), 1,
      anon_sym_PIPE,
    ACTIONS(10962), 1,
      sym_comma,
    STATE(499), 1,
      sym__arrow,
    STATE(5496), 1,
      aux_sym_alt_repeat1,
    STATE(7910), 1,
      sym__alt_variants,
    STATE(8579), 1,
      sym_guards,
    ACTIONS(10958), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(6299), 2,
      sym_gdpat,
      aux_sym__alt_variants_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [231098] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9127), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9129), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231118] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9228), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9230), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231138] = 11,
    ACTIONS(690), 1,
      sym__varid,
    ACTIONS(1422), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1633), 1,
      sym_constructor,
    STATE(1645), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [231174] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9256), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9258), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231194] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9248), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9250), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231214] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9236), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9238), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231234] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [231254] = 11,
    ACTIONS(2192), 1,
      sym__varid,
    ACTIONS(2206), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5007), 1,
      sym_variable,
    STATE(5113), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [231290] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9138), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9140), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231310] = 6,
    ACTIONS(9313), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1824), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10553), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [231336] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9148), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9150), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231356] = 11,
    ACTIONS(2148), 1,
      sym__varid,
    ACTIONS(2162), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(4716), 1,
      sym_variable,
    STATE(4991), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [231392] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9152), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9154), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231412] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [231432] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10858), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [231452] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9240), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9242), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [231472] = 11,
    ACTIONS(613), 1,
      sym__varid,
    ACTIONS(1401), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1704), 1,
      sym_constructor,
    STATE(1705), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [231508] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(10966), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8530), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [231540] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10220), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [231560] = 11,
    ACTIONS(2296), 1,
      sym__varid,
    ACTIONS(2310), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(4968), 1,
      sym_variable,
    STATE(5172), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [231596] = 11,
    ACTIONS(1257), 1,
      sym__varid,
    ACTIONS(1273), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2615), 1,
      sym_constructor,
    STATE(2688), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [231632] = 7,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1841), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10968), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [231660] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(10970), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8530), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [231692] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 10,
      sym__operator,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_type,
      anon_sym_then,
      anon_sym_else,
      anon_sym_class,
      anon_sym_data,
      anon_sym_newtype,
  [231710] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [231730] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10151), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1100), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [231760] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9146), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [231780] = 11,
    ACTIONS(1325), 1,
      sym__varid,
    ACTIONS(1343), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2389), 1,
      sym_constructor,
    STATE(2518), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [231816] = 11,
    ACTIONS(1617), 1,
      sym__varid,
    ACTIONS(1631), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2642), 1,
      sym_variable,
    STATE(2801), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [231852] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10858), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [231872] = 8,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10153), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1162), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [231902] = 8,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10153), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1175), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [231932] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(10970), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7762), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [231964] = 11,
    ACTIONS(1724), 1,
      sym__conid,
    ACTIONS(2270), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5035), 1,
      sym_constructor,
    STATE(5203), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [232000] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10858), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232020] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10884), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232040] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10880), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232060] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9222), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [232080] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8896), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232102] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232124] = 5,
    ACTIONS(10804), 1,
      sym__immediate_dot,
    STATE(4947), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232148] = 8,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10139), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1162), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [232178] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10864), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232198] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232218] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 10,
      sym__operator,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_type,
      anon_sym_then,
      anon_sym_else,
      anon_sym_class,
      anon_sym_data,
      anon_sym_newtype,
  [232236] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8781), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [232256] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [232276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10880), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232296] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10137), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1100), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [232326] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232346] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10864), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232366] = 11,
    ACTIONS(891), 1,
      sym__varid,
    ACTIONS(905), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2120), 1,
      sym_constructor,
    STATE(2155), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [232402] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10898), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232422] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10894), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232442] = 11,
    ACTIONS(857), 1,
      sym__varid,
    ACTIONS(873), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2261), 1,
      sym_variable,
    STATE(2376), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [232478] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10890), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232498] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232518] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8896), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232540] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(10972), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7629), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [232572] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10876), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232592] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10872), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232612] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10868), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232632] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232652] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10854), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232672] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10850), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232692] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10858), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232712] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(10974), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7583), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [232744] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10842), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232764] = 6,
    ACTIONS(8113), 1,
      sym__immediate_dot,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1781), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [232790] = 11,
    ACTIONS(1750), 1,
      sym__conid,
    ACTIONS(2130), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(4939), 1,
      sym_constructor,
    STATE(5289), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [232826] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(10379), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [232846] = 11,
    ACTIONS(2392), 1,
      sym__varid,
    ACTIONS(2406), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5098), 1,
      sym_variable,
    STATE(5460), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [232882] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [232902] = 11,
    ACTIONS(1293), 1,
      sym__varid,
    ACTIONS(1307), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2589), 1,
      sym_variable,
    STATE(2593), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [232938] = 11,
    ACTIONS(2374), 1,
      sym__varid,
    ACTIONS(2386), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5814), 1,
      sym_variable,
    STATE(6355), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [232974] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9146), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [232994] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9162), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [233014] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233034] = 6,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10528), 1,
      sym__immediate_dot,
    STATE(5173), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [233060] = 8,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10139), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1175), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [233090] = 7,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10981), 1,
      sym__consym,
    STATE(5604), 1,
      aux_sym__qualifying_module,
    STATE(9854), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10976), 5,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      anon_sym_do,
      anon_sym_ado,
  [233118] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8415), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8413), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233140] = 4,
    ACTIONS(10983), 1,
      sym__layout_end,
    ACTIONS(8923), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8925), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233162] = 11,
    ACTIONS(931), 1,
      sym__varid,
    ACTIONS(1375), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1954), 1,
      sym_variable,
    STATE(1971), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233198] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233218] = 4,
    ACTIONS(10985), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233240] = 11,
    ACTIONS(989), 1,
      sym__varid,
    ACTIONS(1255), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2104), 1,
      sym_constructor,
    STATE(2192), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233276] = 4,
    ACTIONS(10987), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233298] = 11,
    ACTIONS(1530), 1,
      sym__varid,
    ACTIONS(1649), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2532), 1,
      sym_variable,
    STATE(2544), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233334] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10220), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [233354] = 11,
    ACTIONS(1802), 1,
      sym__conid,
    ACTIONS(2374), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5387), 1,
      sym_constructor,
    STATE(5814), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233390] = 6,
    ACTIONS(8872), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1841), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 3,
      sym_comma,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(10306), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [233416] = 11,
    ACTIONS(483), 1,
      sym__conid,
    ACTIONS(919), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1958), 1,
      sym_constructor,
    STATE(2132), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233452] = 4,
    ACTIONS(10989), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8775), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233474] = 4,
    ACTIONS(10991), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8885), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233496] = 11,
    ACTIONS(581), 1,
      sym__conid,
    ACTIONS(1617), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(2423), 1,
      sym_constructor,
    STATE(2642), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233532] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10842), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233552] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233572] = 6,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10532), 1,
      sym__immediate_dot,
    STATE(5265), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [233598] = 4,
    ACTIONS(10993), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233620] = 6,
    ACTIONS(9592), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10553), 2,
      sym__conid,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233646] = 4,
    ACTIONS(10995), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233668] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8921), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233688] = 4,
    ACTIONS(10997), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8925), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233710] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8931), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233730] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8947), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233750] = 11,
    ACTIONS(2348), 1,
      sym__varid,
    ACTIONS(2362), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(4832), 1,
      sym_variable,
    STATE(4974), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233786] = 11,
    ACTIONS(2244), 1,
      sym__varid,
    ACTIONS(2258), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(6685), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(6937), 1,
      sym_constructor,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233822] = 6,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10553), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233848] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9146), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [233868] = 11,
    ACTIONS(545), 1,
      sym__conid,
    ACTIONS(1530), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1965), 1,
      sym_constructor,
    STATE(2532), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233904] = 4,
    ACTIONS(10999), 1,
      sym__layout_end,
    ACTIONS(8883), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8885), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [233926] = 11,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(11001), 1,
      sym__conid,
    STATE(825), 1,
      sym_class_name,
    STATE(3220), 1,
      sym_constructor,
    STATE(3414), 1,
      sym_qualified_type,
    STATE(7646), 1,
      sym_instance_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7948), 1,
      aux_sym__qualifying_module,
    STATE(8144), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233962] = 11,
    ACTIONS(1828), 1,
      sym__conid,
    ACTIONS(2174), 1,
      sym__varid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(6137), 1,
      sym_constructor,
    STATE(6389), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [233998] = 11,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(11003), 1,
      sym__conid,
    STATE(806), 1,
      sym_class_name,
    STATE(3060), 1,
      sym_constructor,
    STATE(3215), 1,
      sym_qualified_type,
    STATE(7388), 1,
      sym_class_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7853), 1,
      aux_sym__qualifying_module,
    STATE(8126), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [234034] = 4,
    ACTIONS(11005), 1,
      sym__layout_end,
    ACTIONS(8777), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8775), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234056] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234076] = 11,
    ACTIONS(2218), 1,
      sym__varid,
    ACTIONS(2232), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(4876), 1,
      sym_variable,
    STATE(5026), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [234112] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10151), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1066), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [234142] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10137), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1066), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [234172] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234192] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10429), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1066), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [234222] = 6,
    ACTIONS(8135), 1,
      sym__immediate_dot,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1762), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [234248] = 6,
    ACTIONS(9610), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10553), 2,
      sym__conid,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234274] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234294] = 11,
    ACTIONS(2174), 1,
      sym__varid,
    ACTIONS(2186), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(6389), 1,
      sym_variable,
    STATE(6418), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [234330] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(8415), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234352] = 8,
    ACTIONS(10141), 1,
      sym__operator,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10432), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1175), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [234382] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10850), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234402] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(11007), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8530), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [234434] = 4,
    ACTIONS(8894), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 5,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [234456] = 11,
    ACTIONS(2130), 1,
      sym__varid,
    ACTIONS(2142), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5289), 1,
      sym_variable,
    STATE(5420), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [234492] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9206), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [234512] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(11009), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8530), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [234544] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8951), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8949), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234566] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10854), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234586] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(11011), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8530), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [234618] = 11,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(11001), 1,
      sym__conid,
    STATE(825), 1,
      sym_class_name,
    STATE(3220), 1,
      sym_constructor,
    STATE(3414), 1,
      sym_qualified_type,
    STATE(7746), 1,
      sym_instance_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7948), 1,
      aux_sym__qualifying_module,
    STATE(8144), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [234654] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(11013), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8530), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [234686] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(11013), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7815), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [234718] = 11,
    ACTIONS(740), 1,
      sym__varid,
    ACTIONS(1367), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1750), 1,
      sym_constructor,
    STATE(1925), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [234754] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [234774] = 11,
    ACTIONS(2270), 1,
      sym__varid,
    ACTIONS(2282), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5203), 1,
      sym_variable,
    STATE(5428), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [234810] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234830] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(11015), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7830), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [234862] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234882] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9226), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [234902] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [234922] = 9,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    ACTIONS(11017), 1,
      sym__layout_end,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7854), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [234954] = 11,
    ACTIONS(652), 1,
      sym__varid,
    ACTIONS(1432), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1619), 1,
      sym_variable,
    STATE(1668), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [234990] = 11,
    ACTIONS(812), 1,
      sym__varid,
    ACTIONS(1456), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1738), 1,
      sym_constructor,
    STATE(1867), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [235026] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9281), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [235046] = 11,
    ACTIONS(776), 1,
      sym__varid,
    ACTIONS(1385), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(1817), 1,
      sym_constructor,
    STATE(1845), 1,
      sym_variable,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [235082] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [235102] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9285), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [235122] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10868), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235142] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10872), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235162] = 11,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(11019), 1,
      sym__conid,
    STATE(827), 1,
      sym_class_name,
    STATE(3163), 1,
      sym_constructor,
    STATE(3411), 1,
      sym_qualified_type,
    STATE(7734), 1,
      sym_instance_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7862), 1,
      aux_sym__qualifying_module,
    STATE(8604), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [235198] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9222), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [235218] = 11,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(11021), 1,
      sym__conid,
    STATE(784), 1,
      sym_class_name,
    STATE(3098), 1,
      sym_constructor,
    STATE(3164), 1,
      sym_qualified_type,
    STATE(7347), 1,
      sym_class_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7911), 1,
      aux_sym__qualifying_module,
    STATE(8582), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [235254] = 11,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(11019), 1,
      sym__conid,
    STATE(827), 1,
      sym_class_name,
    STATE(3163), 1,
      sym_constructor,
    STATE(3411), 1,
      sym_qualified_type,
    STATE(7655), 1,
      sym_instance_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7862), 1,
      aux_sym__qualifying_module,
    STATE(8604), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [235290] = 11,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(11003), 1,
      sym__conid,
    STATE(806), 1,
      sym_class_name,
    STATE(2932), 1,
      sym_constructor,
    STATE(3215), 1,
      sym_qualified_type,
    STATE(6938), 1,
      sym_class_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7853), 1,
      aux_sym__qualifying_module,
    STATE(8126), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [235326] = 5,
    ACTIONS(11023), 1,
      sym__immediate_dot,
    STATE(5686), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8356), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235350] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9300), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [235370] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10884), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235390] = 5,
    ACTIONS(10671), 1,
      sym__immediate_dot,
    STATE(5686), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235414] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9304), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [235434] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9296), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235454] = 5,
    ACTIONS(10671), 1,
      sym__immediate_dot,
    STATE(5686), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235478] = 11,
    ACTIONS(10761), 1,
      anon_sym_LPAREN,
    ACTIONS(11021), 1,
      sym__conid,
    STATE(784), 1,
      sym_class_name,
    STATE(2925), 1,
      sym_constructor,
    STATE(3164), 1,
      sym_qualified_type,
    STATE(7400), 1,
      sym_class_head,
    STATE(7778), 1,
      sym_constraint,
    STATE(7911), 1,
      aux_sym__qualifying_module,
    STATE(8582), 1,
      sym_constraints,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [235514] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9277), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235534] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9273), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235554] = 11,
    ACTIONS(2418), 1,
      sym__varid,
    ACTIONS(2432), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(5569), 1,
      sym_variable,
    STATE(6103), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [235590] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10671), 1,
      sym__immediate_dot,
    STATE(5501), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8106), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235616] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10671), 1,
      sym__immediate_dot,
    STATE(5692), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8415), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235642] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym__dot,
      sym_comma,
      sym__conid,
    ACTIONS(8223), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235662] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9186), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [235682] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235702] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9214), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235722] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_AT2,
  [235742] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9170), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235762] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8947), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235782] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8931), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235802] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8921), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235822] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8902), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235842] = 5,
    ACTIONS(10914), 1,
      sym__immediate_dot,
    STATE(5256), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8319), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8321), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [235866] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8802), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [235886] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8793), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [235906] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235926] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9292), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235946] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9210), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235966] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9327), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [235986] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9133), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236006] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8789), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [236026] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9133), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236046] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9327), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236066] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym__dot,
      sym_comma,
      sym__conid,
    ACTIONS(8223), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236086] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9170), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236106] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9214), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236126] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236146] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9186), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [236166] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9210), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236186] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9273), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236206] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9277), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236226] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(9296), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236246] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9304), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [236266] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9300), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [236286] = 11,
    ACTIONS(2322), 1,
      sym__varid,
    ACTIONS(2336), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_do,
    ACTIONS(10451), 1,
      anon_sym_ado,
    STATE(4941), 1,
      sym_variable,
    STATE(5109), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(9822), 1,
      sym__ado_kw,
    STATE(9823), 1,
      sym__do_kw,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [236322] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8771), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [236342] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9292), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236362] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236382] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8106), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [236402] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10876), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236422] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236442] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236462] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8225), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym__conid,
  [236482] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9240), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9242), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236502] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9222), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [236522] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236542] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(10220), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [236562] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9156), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9158), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236582] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9152), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9154), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236602] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9148), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9150), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236622] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9138), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9140), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236642] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [236662] = 4,
    ACTIONS(11026), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8775), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236684] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9236), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9238), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236704] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9248), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9250), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236724] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9256), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9258), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236744] = 4,
    ACTIONS(11029), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8885), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236766] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9228), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9230), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236786] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9127), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9129), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236806] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9164), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9166), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236826] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9172), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9174), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236846] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9176), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9178), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236866] = 4,
    ACTIONS(11032), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236888] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9232), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9234), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236908] = 4,
    ACTIONS(11035), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236930] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9244), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9246), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [236950] = 4,
    ACTIONS(11038), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8925), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236972] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8951), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [236994] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8898), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237016] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [237036] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9206), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [237056] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9254), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [237076] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237098] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8861), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237120] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [237140] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9240), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9242), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237160] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9156), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9158), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237180] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9152), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9154), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237200] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9148), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9150), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237220] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9138), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9140), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237240] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9285), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [237260] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9236), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9238), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237280] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9248), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9250), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237300] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9256), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9258), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237320] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8898), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8896), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237342] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8225), 5,
      sym__layout_semicolon,
      sym__dot,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237362] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9146), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237382] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9228), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9230), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237402] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9162), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [237422] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9281), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [237442] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237462] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9226), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [237482] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9254), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237502] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9182), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237522] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9244), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9246), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237542] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9232), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9234), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237562] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9176), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9178), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237582] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9172), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9174), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237602] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9164), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(9166), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [237622] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11047), 1,
      anon_sym_RBRACE,
    STATE(7368), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8767), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [237655] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237674] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237693] = 3,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237712] = 3,
    ACTIONS(9186), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237731] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9298), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237750] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9302), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237769] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237788] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9296), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237807] = 3,
    ACTIONS(9319), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237826] = 3,
    ACTIONS(9290), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237845] = 3,
    ACTIONS(9208), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237864] = 3,
    ACTIONS(9325), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237883] = 3,
    ACTIONS(9131), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237902] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237921] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11049), 1,
      anon_sym_RBRACE,
    STATE(6946), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9183), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [237954] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9220), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237973] = 3,
    ACTIONS(9168), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [237992] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8781), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238011] = 3,
    ACTIONS(9226), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238030] = 3,
    ACTIONS(9212), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238049] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9279), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238068] = 3,
    ACTIONS(9216), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238087] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238106] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238125] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9210), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238144] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9224), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238163] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11051), 1,
      anon_sym_RBRACE,
    STATE(6964), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9219), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [238196] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238215] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9236), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238234] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9148), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238253] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9248), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238272] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9256), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238291] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9138), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238310] = 4,
    ACTIONS(11053), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8883), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8885), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238331] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9228), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238350] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11056), 1,
      anon_sym_RBRACE,
    STATE(6949), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9204), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [238383] = 4,
    ACTIONS(11058), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8777), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8775), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238404] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9244), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238423] = 3,
    ACTIONS(9271), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238442] = 3,
    ACTIONS(9275), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238461] = 3,
    ACTIONS(9294), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238480] = 3,
    ACTIONS(9304), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238499] = 3,
    ACTIONS(9285), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238518] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11061), 1,
      anon_sym_RBRACE,
    STATE(6959), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9165), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [238551] = 3,
    ACTIONS(9300), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238570] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9277), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238589] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9273), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238608] = 3,
    ACTIONS(9206), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238627] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10429), 1,
      anon_sym_newtype,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1210), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [238656] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11063), 1,
      anon_sym_RBRACE,
    STATE(6974), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9237), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [238689] = 3,
    ACTIONS(10151), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238708] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9220), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238727] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9184), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238746] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238765] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9214), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238784] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9170), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238803] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9232), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238822] = 3,
    ACTIONS(9162), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238841] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_AT,
  [238858] = 3,
    ACTIONS(10220), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238877] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9133), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238896] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9327), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238915] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9292), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238934] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11065), 1,
      anon_sym_RBRACE,
    STATE(7533), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9460), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [238967] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9156), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [238986] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239005] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9127), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239024] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10864), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(10862), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [239043] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9164), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239062] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10432), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(10429), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [239081] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9172), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239100] = 8,
    ACTIONS(10151), 1,
      anon_sym_newtype,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1210), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [239129] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9176), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239148] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9172), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239167] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9279), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239186] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239205] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9164), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239224] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9127), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239243] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9228), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239262] = 8,
    ACTIONS(10137), 1,
      anon_sym_newtype,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1210), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [239291] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239310] = 4,
    ACTIONS(11067), 1,
      sym__layout_end,
    ACTIONS(8923), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8925), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [239331] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9224), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239350] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9176), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239369] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239388] = 3,
    ACTIONS(9146), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239407] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10880), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(10878), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [239426] = 4,
    ACTIONS(11069), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [239447] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9302), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239466] = 4,
    ACTIONS(11071), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [239487] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11073), 1,
      anon_sym_RBRACE,
    STATE(7524), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9428), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [239520] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9277), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239539] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11075), 1,
      anon_sym_RBRACE,
    STATE(7504), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9506), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [239572] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11077), 1,
      anon_sym_RBRACE,
    STATE(7512), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9790), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [239605] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9256), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239624] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11079), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(11081), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239643] = 4,
    ACTIONS(11083), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239664] = 4,
    ACTIONS(11086), 1,
      sym__layout_end,
    ACTIONS(8883), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8885), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [239685] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9232), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239704] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9248), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239723] = 3,
    ACTIONS(10856), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10858), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239742] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11088), 1,
      anon_sym_RBRACE,
    STATE(7480), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9572), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [239775] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9279), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239794] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9273), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239813] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8855), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239832] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9240), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239851] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11090), 1,
      anon_sym_RBRACE,
    STATE(6995), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9147), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [239884] = 4,
    ACTIONS(11092), 1,
      sym__layout_end,
    ACTIONS(8777), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8775), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [239905] = 3,
    ACTIONS(3461), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239924] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9184), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239943] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11094), 1,
      anon_sym_RBRACE,
    STATE(7515), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9378), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [239976] = 3,
    ACTIONS(9146), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [239995] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym__dot,
      sym_comma,
      sym__conid,
    ACTIONS(8223), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [240014] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11096), 1,
      anon_sym_RBRACE,
    STATE(7002), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9255), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240047] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240066] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11098), 1,
      anon_sym_RBRACE,
    STATE(7484), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9552), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240099] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9214), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240118] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240137] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8338), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_AT2,
  [240156] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240175] = 4,
    ACTIONS(11100), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8911), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8913), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240196] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240215] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(3463), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240234] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240253] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9283), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240272] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11103), 1,
      anon_sym_RBRACE,
    STATE(7519), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9400), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240305] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240324] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(3288), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240343] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11105), 1,
      anon_sym_RBRACE,
    STATE(7012), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9125), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240376] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9244), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240395] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9236), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240414] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240433] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(8415), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [240454] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9204), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240473] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11107), 1,
      anon_sym_RBRACE,
    STATE(7500), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9354), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240506] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8921), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240525] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11109), 1,
      anon_sym_RBRACE,
    STATE(7092), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(10046), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240558] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9138), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240577] = 5,
    ACTIONS(10671), 1,
      sym__immediate_dot,
    STATE(5686), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8319), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8321), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240600] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11111), 1,
      anon_sym_RBRACE,
    STATE(7020), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9273), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240633] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11113), 1,
      anon_sym_RBRACE,
    STATE(7010), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9129), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240666] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240685] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11115), 1,
      anon_sym_RBRACE,
    STATE(7062), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(10054), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240718] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8802), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240737] = 4,
    ACTIONS(11117), 1,
      sym__layout_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8923), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8925), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240758] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240777] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11120), 1,
      anon_sym_RBRACE,
    STATE(7479), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9865), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [240810] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9148), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240829] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8931), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240848] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9152), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240867] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8947), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [240886] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8931), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [240905] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8921), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [240924] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8902), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [240943] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 9,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_type,
      anon_sym_then,
      anon_sym_else,
      anon_sym_class,
      anon_sym_data,
      anon_sym_newtype,
  [240960] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8793), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [240979] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10815), 1,
      sym__immediate_dot,
    STATE(6013), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8415), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [241004] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11122), 1,
      anon_sym_RBRACE,
    STATE(7022), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9111), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241037] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9156), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241056] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11124), 1,
      anon_sym_RBRACE,
    STATE(7042), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9291), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241089] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10804), 1,
      sym__immediate_dot,
    STATE(5152), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10314), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [241114] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11126), 1,
      anon_sym_RBRACE,
    STATE(7030), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9093), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241147] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8789), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241166] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10815), 1,
      sym__immediate_dot,
    STATE(6090), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8106), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [241191] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9224), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241210] = 7,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(11128), 1,
      sym__tyconsym,
    STATE(9784), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9785), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
  [241237] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9240), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241256] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11130), 1,
      anon_sym_RBRACE,
    STATE(7135), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(10107), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241289] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8951), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [241310] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9170), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241329] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241348] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10842), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241367] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9133), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241386] = 6,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10677), 1,
      anon_sym_LPAREN,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(11132), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(4933), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [241411] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11134), 1,
      anon_sym_RBRACE,
    STATE(7037), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9287), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241444] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241463] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9327), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241482] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym__dot,
      sym_comma,
      sym__conid,
    ACTIONS(8223), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [241501] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9210), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241520] = 3,
    ACTIONS(9226), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241539] = 3,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241558] = 8,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(11136), 1,
      sym__conid,
    STATE(4379), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3023), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
  [241587] = 3,
    ACTIONS(9281), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241606] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11138), 1,
      anon_sym_RBRACE,
    STATE(7467), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9616), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241639] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(8947), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241658] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9292), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241677] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9319), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9321), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241696] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8771), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241715] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11140), 1,
      anon_sym_RBRACE,
    STATE(7475), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9319), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241748] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9160), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241767] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11142), 1,
      anon_sym_RBRACE,
    STATE(7068), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9075), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241800] = 8,
    ACTIONS(10151), 1,
      anon_sym_data,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1217), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [241829] = 8,
    ACTIONS(10137), 1,
      anon_sym_data,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1217), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [241858] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11144), 1,
      anon_sym_RBRACE,
    STATE(7137), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(10004), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241891] = 3,
    ACTIONS(3277), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241910] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11146), 1,
      anon_sym_RBRACE,
    STATE(7089), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9051), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [241943] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9296), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241962] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [241981] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9144), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242000] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11148), 1,
      anon_sym_RBRACE,
    STATE(7130), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9905), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242033] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10429), 1,
      anon_sym_data,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1217), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [242062] = 3,
    ACTIONS(9254), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9252), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242081] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11150), 1,
      anon_sym_RBRACE,
    STATE(7462), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9233), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242114] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9298), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242133] = 3,
    ACTIONS(9281), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242152] = 3,
    ACTIONS(9182), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242171] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9304), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9302), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242190] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9275), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9277), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242209] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10429), 1,
      anon_sym_RPAREN,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1100), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [242238] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 9,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_type,
      anon_sym_then,
      anon_sym_else,
      anon_sym_class,
      anon_sym_data,
      anon_sym_newtype,
  [242255] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11152), 1,
      anon_sym_RBRACE,
    STATE(7085), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9057), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242288] = 3,
    ACTIONS(9182), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242307] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11154), 1,
      anon_sym_RBRACE,
    STATE(7095), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9039), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242340] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9271), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9273), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242359] = 3,
    ACTIONS(10381), 2,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
  [242378] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 9,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_type,
      anon_sym_then,
      anon_sym_else,
      anon_sym_class,
      anon_sym_data,
      anon_sym_newtype,
  [242395] = 5,
    ACTIONS(10815), 1,
      sym__immediate_dot,
    STATE(6060), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [242418] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10850), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242437] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11156), 1,
      anon_sym_RBRACE,
    STATE(7450), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9146), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242470] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9186), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9184), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242489] = 5,
    ACTIONS(10815), 1,
      sym__immediate_dot,
    STATE(6060), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [242512] = 3,
    ACTIONS(9246), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9244), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242531] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11158), 1,
      anon_sym_RBRACE,
    STATE(7107), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9021), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242564] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11160), 1,
      anon_sym_RBRACE,
    STATE(7426), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9658), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242597] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9216), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242616] = 3,
    ACTIONS(9234), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9232), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242635] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10429), 1,
      anon_sym_then,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1087), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [242664] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11162), 1,
      anon_sym_RBRACE,
    STATE(7403), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9723), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242697] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10854), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242716] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11164), 1,
      anon_sym_RBRACE,
    STATE(7451), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9153), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242749] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10858), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(10856), 5,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [242768] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10429), 1,
      anon_sym_else,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1256), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [242797] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9144), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [242816] = 8,
    ACTIONS(10137), 1,
      anon_sym_else,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1256), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [242845] = 8,
    ACTIONS(10137), 1,
      anon_sym_then,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1087), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [242874] = 8,
    ACTIONS(10151), 1,
      anon_sym_else,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1256), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [242903] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11166), 1,
      anon_sym_RBRACE,
    STATE(7177), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9960), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242936] = 8,
    ACTIONS(10151), 1,
      anon_sym_then,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1087), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [242965] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11168), 1,
      anon_sym_RBRACE,
    STATE(7436), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9045), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [242998] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9204), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243017] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11170), 1,
      anon_sym_RBRACE,
    STATE(7410), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8964), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [243050] = 3,
    ACTIONS(9178), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9176), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243069] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10872), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243088] = 6,
    ACTIONS(8106), 1,
      sym_comma,
    ACTIONS(9194), 1,
      sym__conid,
    ACTIONS(9191), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(9197), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
  [243113] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11172), 1,
      anon_sym_RBRACE,
    STATE(7411), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9713), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [243146] = 6,
    ACTIONS(8415), 1,
      sym_comma,
    ACTIONS(9978), 1,
      sym__conid,
    ACTIONS(9199), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(9201), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
  [243171] = 3,
    ACTIONS(10862), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10864), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243190] = 3,
    ACTIONS(10429), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10432), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243209] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11174), 1,
      anon_sym_RBRACE,
    STATE(7124), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9384), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [243242] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9242), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9240), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243261] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9300), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9298), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243280] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8898), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [243301] = 4,
    ACTIONS(8104), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9191), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(9194), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [243322] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9222), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9220), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243341] = 3,
    ACTIONS(9154), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9152), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243360] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11176), 1,
      anon_sym_RBRACE,
    STATE(7191), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9956), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [243393] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9212), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9214), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243412] = 4,
    ACTIONS(8413), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9201), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(9978), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [243433] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10842), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243452] = 6,
    ACTIONS(9352), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(1981), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10553), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [243477] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243496] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9168), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9170), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243515] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10850), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243534] = 5,
    ACTIONS(11178), 1,
      sym__immediate_dot,
    STATE(6060), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8356), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [243557] = 4,
    ACTIONS(9220), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9262), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(9888), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [243578] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11181), 1,
      anon_sym_RBRACE,
    STATE(7358), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9668), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [243611] = 6,
    ACTIONS(9222), 1,
      sym_comma,
    ACTIONS(9888), 1,
      sym__conid,
    ACTIONS(9260), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(9262), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
  [243636] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9158), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9156), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243655] = 3,
    ACTIONS(10878), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10880), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243674] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10854), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243693] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9283), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243712] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9131), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9133), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243731] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10218), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243750] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9325), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9327), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243769] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8106), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(8104), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243788] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9208), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9210), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243807] = 8,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(11183), 1,
      anon_sym_type,
    STATE(6826), 1,
      aux_sym__qualifying_module,
    STATE(8614), 1,
      sym_constructor,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9334), 3,
      sym_variable,
      sym_qualified_variable,
      sym_qualified_type,
  [243836] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9160), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243855] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10153), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243874] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11185), 1,
      anon_sym_RBRACE,
    STATE(7145), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9003), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [243907] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11187), 1,
      anon_sym_RBRACE,
    STATE(7166), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8977), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [243940] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9204), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [243959] = 8,
    ACTIONS(10501), 1,
      anon_sym_LPAREN,
    ACTIONS(10954), 1,
      sym__varid,
    STATE(1391), 1,
      sym__fun_name,
    STATE(3525), 1,
      sym_variable,
    STATE(6866), 1,
      sym__funlhs,
    STATE(8732), 1,
      sym__funvar,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8530), 3,
      sym__idecl,
      sym_function,
      sym_signature,
  [243988] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11189), 1,
      anon_sym_RBRACE,
    STATE(7161), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8984), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244021] = 3,
    ACTIONS(9174), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9172), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244040] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(8225), 5,
      sym__dot,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [244059] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10868), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244078] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_AT,
  [244095] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10900), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10902), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244114] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10858), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244133] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11191), 1,
      anon_sym_RBRACE,
    STATE(7171), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8965), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244166] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11193), 1,
      anon_sym_RBRACE,
    STATE(7375), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9748), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244199] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11195), 1,
      anon_sym_RBRACE,
    STATE(7225), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9919), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244232] = 5,
    ACTIONS(10815), 1,
      sym__immediate_dot,
    STATE(6060), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [244255] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9150), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9148), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244274] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11197), 1,
      anon_sym_RBRACE,
    STATE(7183), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8946), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244307] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(9160), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244326] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [244347] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11199), 1,
      anon_sym_RBRACE,
    STATE(7396), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8863), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244380] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9140), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9138), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244399] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10876), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244418] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11079), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(11081), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244437] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9283), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244456] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9238), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9236), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244475] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9250), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9248), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244494] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9258), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9256), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244513] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [244534] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9152), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244553] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11201), 1,
      anon_sym_RBRACE,
    STATE(7366), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9920), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244586] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [244607] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10884), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244626] = 3,
    ACTIONS(9166), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9164), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244645] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244664] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11203), 1,
      anon_sym_RBRACE,
    STATE(7384), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8750), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244697] = 8,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(11205), 1,
      anon_sym_type,
    STATE(6826), 1,
      aux_sym__qualifying_module,
    STATE(8622), 1,
      sym_constructor,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9389), 3,
      sym_variable,
      sym_qualified_variable,
      sym_qualified_type,
  [244726] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10868), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244745] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244764] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10429), 1,
      anon_sym_type,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1048), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [244793] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10872), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244812] = 3,
    ACTIONS(8106), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244831] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11207), 1,
      anon_sym_RBRACE,
    STATE(7250), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9895), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244864] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9230), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9228), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244883] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10876), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244902] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11209), 1,
      anon_sym_RBRACE,
    STATE(7210), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9468), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [244935] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9290), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9292), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244954] = 3,
    ACTIONS(9242), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9240), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244973] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10890), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [244992] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10898), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245011] = 8,
    ACTIONS(10137), 1,
      anon_sym_type,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1048), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [245040] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11211), 1,
      anon_sym_RBRACE,
    STATE(7289), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9868), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245073] = 3,
    ACTIONS(9222), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245092] = 8,
    ACTIONS(10151), 1,
      anon_sym_type,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1048), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [245121] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10872), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245140] = 3,
    ACTIONS(9158), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9156), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245159] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11213), 1,
      anon_sym_RBRACE,
    STATE(7221), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8927), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245192] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10894), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245211] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9129), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9127), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245230] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11215), 1,
      anon_sym_RBRACE,
    STATE(7243), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8901), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245263] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11217), 1,
      anon_sym_RBRACE,
    STATE(7383), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8753), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245296] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9166), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9164), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245315] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [245336] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11219), 1,
      anon_sym_RBRACE,
    STATE(6973), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(10133), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245369] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9174), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9172), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245388] = 8,
    ACTIONS(10151), 1,
      anon_sym_class,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1161), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [245417] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11221), 1,
      anon_sym_RBRACE,
    STATE(7034), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(10101), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245450] = 8,
    ACTIONS(2062), 1,
      sym__varid,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(11223), 1,
      anon_sym_type,
    STATE(6826), 1,
      aux_sym__qualifying_module,
    STATE(8699), 1,
      sym_constructor,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9963), 3,
      sym_variable,
      sym_qualified_variable,
      sym_qualified_type,
  [245479] = 8,
    ACTIONS(10137), 1,
      anon_sym_class,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1161), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [245508] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9178), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9176), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245527] = 3,
    ACTIONS(10840), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10842), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245546] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11225), 1,
      anon_sym_RBRACE,
    STATE(7238), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8908), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245579] = 8,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(3023), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
  [245608] = 3,
    ACTIONS(9250), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9248), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245627] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10898), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245646] = 3,
    ACTIONS(10848), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10850), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245665] = 3,
    ACTIONS(10852), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10854), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245684] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11227), 1,
      anon_sym_RBRACE,
    STATE(6944), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9201), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245717] = 3,
    ACTIONS(9150), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9148), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245736] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11229), 1,
      anon_sym_RBRACE,
    STATE(7248), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8889), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245769] = 3,
    ACTIONS(9140), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9138), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245788] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10858), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245807] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11231), 1,
      anon_sym_RBRACE,
    STATE(7260), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8870), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245840] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11233), 1,
      anon_sym_RBRACE,
    STATE(7281), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9994), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [245873] = 4,
    ACTIONS(8877), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10274), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [245894] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10864), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245913] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8855), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [245934] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245953] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10880), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [245972] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11235), 1,
      anon_sym_RBRACE,
    STATE(7351), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8782), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [246005] = 3,
    ACTIONS(9238), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9236), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246024] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9234), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9232), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246043] = 8,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10429), 1,
      anon_sym_class,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(6885), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(1161), 3,
      sym_qualified_type_operator,
      sym_type_operator,
      sym__type_qoperator,
  [246072] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10880), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246091] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10840), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10842), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246110] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8861), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [246131] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9246), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9244), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246150] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 9,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DOT,
  [246167] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10884), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246186] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9294), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9296), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246205] = 3,
    ACTIONS(10900), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10902), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246224] = 3,
    ACTIONS(9129), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9127), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246243] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11237), 1,
      anon_sym_RBRACE,
    STATE(7292), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8851), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [246276] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10896), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10898), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246295] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10894), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246314] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11239), 1,
      anon_sym_RBRACE,
    STATE(7314), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8823), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [246347] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11241), 1,
      anon_sym_RBRACE,
    STATE(7458), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9877), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [246380] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246399] = 3,
    ACTIONS(10866), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10868), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246418] = 3,
    ACTIONS(10870), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10872), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246437] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10892), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10894), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246456] = 3,
    ACTIONS(10874), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10876), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246475] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9154), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9152), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246494] = 3,
    ACTIONS(10882), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10884), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246513] = 3,
    ACTIONS(10553), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246532] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11243), 1,
      anon_sym_RBRACE,
    STATE(7296), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9557), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [246565] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11245), 1,
      anon_sym_RBRACE,
    STATE(7312), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9836), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [246598] = 3,
    ACTIONS(10888), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10890), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246617] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10890), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246636] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246655] = 3,
    ACTIONS(9258), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9256), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246674] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9182), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9180), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246693] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246712] = 3,
    ACTIONS(10892), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10894), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246731] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10882), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10884), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246750] = 3,
    ACTIONS(9230), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9228), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246769] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10874), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10876), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246788] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11247), 1,
      anon_sym_RBRACE,
    STATE(7300), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8832), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [246821] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(9144), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246840] = 3,
    ACTIONS(10896), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10898), 7,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246859] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10553), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10555), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246878] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10888), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10890), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246897] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11249), 1,
      anon_sym_RBRACE,
    STATE(7333), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9828), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [246930] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11251), 1,
      anon_sym_RBRACE,
    STATE(7318), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8813), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [246963] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9254), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(9252), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [246982] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10866), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10868), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247001] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10880), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247020] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10864), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247039] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11253), 1,
      anon_sym_RBRACE,
    STATE(7352), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(9806), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [247072] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(10379), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247091] = 10,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11255), 1,
      anon_sym_RBRACE,
    STATE(7330), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    STATE(8796), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [247124] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10432), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247143] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
    ACTIONS(10858), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247162] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 4,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_then,
      anon_sym_else,
    ACTIONS(10864), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247181] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10848), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10850), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247200] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10852), 4,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
    ACTIONS(10854), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247219] = 5,
    ACTIONS(10815), 1,
      sym__immediate_dot,
    STATE(6060), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8319), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8321), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [247241] = 4,
    ACTIONS(11257), 1,
      anon_sym_AT2,
    ACTIONS(8108), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [247261] = 3,
    ACTIONS(10856), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10858), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [247279] = 4,
    ACTIONS(8118), 1,
      anon_sym_AT2,
    ACTIONS(10274), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [247299] = 3,
    ACTIONS(10870), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10872), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [247317] = 7,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(11259), 1,
      sym__varid,
    STATE(6826), 1,
      aux_sym__qualifying_module,
    STATE(8677), 1,
      sym_constructor,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9853), 3,
      sym_variable,
      sym_qualified_variable,
      sym_qualified_type,
  [247343] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10359), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [247361] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11267), 1,
      anon_sym_RBRACE,
    STATE(8169), 1,
      sym_pat_field,
    STATE(8307), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [247391] = 3,
    ACTIONS(9226), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [247409] = 5,
    STATE(6292), 1,
      aux_sym_type_role_declaration_repeat1,
    STATE(6776), 1,
      sym__role,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11269), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(11271), 3,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [247431] = 5,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10677), 1,
      anon_sym_LPAREN,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(5970), 5,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
      sym__tyvar_annotated,
      aux_sym__quantifiers_repeat1,
  [247453] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
    ACTIONS(8855), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [247471] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10383), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [247489] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(9281), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [247507] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(11273), 1,
      sym__immediate_dot,
    STATE(6244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8415), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247531] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11275), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(11277), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [247549] = 6,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(11273), 1,
      sym__immediate_dot,
    STATE(6246), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8106), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247573] = 6,
    ACTIONS(8993), 1,
      sym__immediate_dot,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2427), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [247597] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11279), 1,
      anon_sym_RBRACE,
    STATE(8043), 1,
      sym_pat_field,
    STATE(8291), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [247627] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11285), 1,
      sym_where,
    STATE(10019), 1,
      sym_guards,
    STATE(6279), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11281), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [247651] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10363), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [247669] = 3,
    ACTIONS(10900), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10902), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [247687] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_AT2,
    ACTIONS(8340), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [247705] = 5,
    ACTIONS(11273), 1,
      sym__immediate_dot,
    STATE(6248), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247727] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10371), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [247745] = 5,
    ACTIONS(11273), 1,
      sym__immediate_dot,
    STATE(6248), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8250), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8252), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247767] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10314), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [247785] = 5,
    ACTIONS(11287), 1,
      sym__immediate_dot,
    STATE(6248), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8354), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8356), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [247807] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(9226), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [247825] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11290), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    STATE(8361), 1,
      sym_record_field,
    STATE(8572), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [247855] = 6,
    ACTIONS(9142), 1,
      sym__immediate_dot,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2551), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [247879] = 7,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(11259), 1,
      sym__varid,
    STATE(6826), 1,
      aux_sym__qualifying_module,
    STATE(8623), 1,
      sym_constructor,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9399), 3,
      sym_variable,
      sym_qualified_variable,
      sym_qualified_type,
  [247905] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_as,
    ACTIONS(8338), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_AT2,
  [247923] = 3,
    ACTIONS(8223), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [247941] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT,
  [247957] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11292), 1,
      anon_sym_RBRACE,
    STATE(8105), 1,
      sym_record_field,
    STATE(8169), 1,
      sym_pat_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [247987] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT,
  [248003] = 3,
    ACTIONS(9281), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248021] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT,
  [248037] = 3,
    ACTIONS(3461), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248055] = 3,
    ACTIONS(9146), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248073] = 3,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248091] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8771), 5,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248109] = 3,
    ACTIONS(9281), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248127] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11294), 1,
      anon_sym_RBRACE,
    STATE(8147), 1,
      sym_pat_field,
    STATE(8336), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [248157] = 3,
    ACTIONS(3277), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248175] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8898), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [248195] = 6,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10671), 1,
      sym__immediate_dot,
    STATE(5935), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [248219] = 6,
    ACTIONS(9222), 1,
      sym_comma,
    ACTIONS(9888), 1,
      sym__conid,
    ACTIONS(9220), 2,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(9260), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(9262), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [248243] = 4,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [248263] = 3,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248281] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [248301] = 4,
    ACTIONS(11298), 1,
      sym__varid,
    STATE(6315), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11296), 5,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [248321] = 6,
    ACTIONS(8415), 1,
      sym_comma,
    ACTIONS(9978), 1,
      sym__conid,
    ACTIONS(8413), 2,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(9199), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(9201), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [248345] = 6,
    ACTIONS(8106), 1,
      sym_comma,
    ACTIONS(9194), 1,
      sym__conid,
    ACTIONS(8104), 2,
      anon_sym_EQ,
      anon_sym_BQUOTE,
    ACTIONS(9191), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(9197), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [248369] = 7,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(11259), 1,
      sym__varid,
    STATE(6826), 1,
      aux_sym__qualifying_module,
    STATE(8615), 1,
      sym_constructor,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9352), 3,
      sym_variable,
      sym_qualified_variable,
      sym_qualified_type,
  [248395] = 3,
    ACTIONS(9212), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248413] = 3,
    ACTIONS(9226), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248431] = 5,
    ACTIONS(11302), 1,
      anon_sym_PIPE,
    STATE(10019), 1,
      sym_guards,
    STATE(6279), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11300), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [248453] = 4,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [248473] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8789), 5,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248491] = 3,
    ACTIONS(10840), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10842), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248509] = 4,
    ACTIONS(11305), 1,
      sym__layout_end,
    ACTIONS(8923), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8925), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [248529] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8793), 5,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248547] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11307), 1,
      anon_sym_RBRACE,
    STATE(8169), 1,
      sym_pat_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    STATE(8472), 1,
      sym_record_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [248577] = 3,
    ACTIONS(8340), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 6,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AT2,
  [248595] = 3,
    ACTIONS(10862), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10864), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248613] = 3,
    ACTIONS(9300), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248631] = 3,
    ACTIONS(9304), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248649] = 3,
    ACTIONS(8106), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248667] = 3,
    ACTIONS(10848), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10850), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248685] = 5,
    STATE(6292), 1,
      aux_sym_type_role_declaration_repeat1,
    STATE(6776), 1,
      sym__role,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11309), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(11311), 3,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [248707] = 5,
    STATE(6388), 1,
      aux_sym_type_role_declaration_repeat1,
    STATE(6853), 1,
      sym__role,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11269), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(11314), 3,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [248729] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8802), 5,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248747] = 3,
    ACTIONS(10852), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10854), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248765] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(10379), 5,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
  [248783] = 6,
    ACTIONS(9485), 1,
      sym__immediate_dot,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10553), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [248807] = 3,
    ACTIONS(10866), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10868), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248825] = 5,
    ACTIONS(10960), 1,
      anon_sym_PIPE,
    STATE(8579), 1,
      sym_guards,
    STATE(6317), 2,
      sym_gdpat,
      aux_sym__alt_variants_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11316), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [248847] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11318), 1,
      anon_sym_RBRACE,
    STATE(8169), 1,
      sym_pat_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    STATE(8433), 1,
      sym_record_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [248877] = 4,
    ACTIONS(11320), 1,
      sym__varid,
    STATE(6301), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11323), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
  [248897] = 3,
    ACTIONS(9294), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248915] = 3,
    ACTIONS(10874), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10876), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248933] = 4,
    ACTIONS(11325), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [248953] = 4,
    ACTIONS(10252), 1,
      anon_sym_AT2,
    ACTIONS(10274), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [248973] = 3,
    ACTIONS(10882), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10884), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [248991] = 3,
    ACTIONS(10429), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10432), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249009] = 3,
    ACTIONS(10553), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249027] = 3,
    ACTIONS(10888), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10890), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249045] = 3,
    ACTIONS(9275), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249063] = 3,
    ACTIONS(9222), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249081] = 3,
    ACTIONS(10892), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10894), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249099] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [249119] = 5,
    ACTIONS(11302), 1,
      anon_sym_PIPE,
    STATE(9332), 1,
      sym_guards,
    STATE(6314), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11300), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [249141] = 4,
    ACTIONS(11327), 1,
      sym__varid,
    STATE(6315), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11323), 5,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [249161] = 3,
    ACTIONS(8225), 2,
      sym__dot,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [249179] = 5,
    ACTIONS(11332), 1,
      anon_sym_PIPE,
    STATE(8579), 1,
      sym_guards,
    STATE(6317), 2,
      sym_gdpat,
      aux_sym__alt_variants_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11330), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [249201] = 3,
    ACTIONS(8340), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [249219] = 3,
    ACTIONS(10878), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10880), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249237] = 3,
    ACTIONS(9186), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249255] = 4,
    ACTIONS(11335), 1,
      sym__layout_end,
    ACTIONS(8883), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8885), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [249275] = 3,
    ACTIONS(9216), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249293] = 3,
    ACTIONS(9168), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249311] = 3,
    ACTIONS(9271), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249329] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10357), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [249347] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10369), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [249365] = 3,
    ACTIONS(9131), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249383] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10375), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [249401] = 3,
    ACTIONS(9325), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249419] = 3,
    ACTIONS(9208), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249437] = 4,
    ACTIONS(11337), 1,
      anon_sym_AT2,
    ACTIONS(10274), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [249457] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10377), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [249475] = 3,
    ACTIONS(9290), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249493] = 3,
    ACTIONS(9319), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249511] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT,
  [249527] = 4,
    ACTIONS(11339), 1,
      sym__varid,
    STATE(6301), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11296), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
  [249547] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10381), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [249565] = 6,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(10815), 1,
      sym__immediate_dot,
    STATE(6221), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [249589] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT,
  [249605] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11341), 1,
      anon_sym_RBRACE,
    STATE(8205), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    STATE(8572), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [249635] = 4,
    ACTIONS(11343), 1,
      sym__layout_end,
    ACTIONS(8777), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8775), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [249655] = 7,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11345), 1,
      anon_sym_LPAREN,
    ACTIONS(11347), 1,
      anon_sym_RPAREN,
    ACTIONS(11349), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8477), 3,
      sym_variable,
      sym_constructor,
      sym__name,
  [249681] = 3,
    ACTIONS(8340), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 7,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_AT2,
  [249699] = 3,
    ACTIONS(10896), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10898), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249717] = 5,
    ACTIONS(11302), 1,
      anon_sym_PIPE,
    STATE(9388), 1,
      sym_guards,
    STATE(6345), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11300), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [249739] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11351), 1,
      anon_sym_RBRACE,
    STATE(8083), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    STATE(8572), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [249769] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [249789] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_PIPE,
      anon_sym_AT,
  [249805] = 3,
    ACTIONS(9206), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [249823] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10327), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [249841] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10331), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [249859] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10347), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [249877] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10351), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [249895] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11353), 1,
      anon_sym_RBRACE,
    STATE(8043), 1,
      sym_pat_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    STATE(8517), 1,
      sym_record_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [249925] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [249945] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [249965] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11355), 1,
      sym_where,
    STATE(9388), 1,
      sym_guards,
    STATE(6345), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11281), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [249989] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(8415), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [250009] = 3,
    ACTIONS(9242), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9240), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250027] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(10379), 5,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250045] = 7,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11357), 1,
      anon_sym_LPAREN,
    ACTIONS(11359), 1,
      anon_sym_RPAREN,
    ACTIONS(11361), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8460), 3,
      sym_variable,
      sym_constructor,
      sym__import_name,
  [250071] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym__dot,
      sym_comma,
      sym__conid,
    ACTIONS(8223), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [250089] = 4,
    ACTIONS(11363), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [250109] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 5,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250127] = 3,
    ACTIONS(9158), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9156), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250145] = 3,
    ACTIONS(9154), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9152), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250163] = 3,
    ACTIONS(9150), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9148), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250181] = 3,
    ACTIONS(9140), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9138), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250199] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8951), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [250219] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 5,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250237] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(9146), 4,
      sym_comma,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [250255] = 3,
    ACTIONS(9238), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9236), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250273] = 3,
    ACTIONS(9250), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9248), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250291] = 3,
    ACTIONS(9258), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9256), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250309] = 3,
    ACTIONS(9230), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9228), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250327] = 3,
    ACTIONS(9162), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250345] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11365), 1,
      anon_sym_RBRACE,
    STATE(8147), 1,
      sym_pat_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    STATE(8556), 1,
      sym_record_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [250375] = 3,
    ACTIONS(9129), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9127), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250393] = 3,
    ACTIONS(9166), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9164), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250411] = 3,
    ACTIONS(9174), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9172), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250429] = 3,
    ACTIONS(9178), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9176), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250447] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11367), 1,
      sym_where,
    STATE(9332), 1,
      sym_guards,
    STATE(6314), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11281), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [250471] = 3,
    ACTIONS(9234), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9232), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250489] = 3,
    ACTIONS(9246), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9244), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250507] = 3,
    ACTIONS(8223), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [250525] = 3,
    ACTIONS(9182), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250543] = 3,
    ACTIONS(9182), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250561] = 5,
    STATE(6388), 1,
      aux_sym_type_role_declaration_repeat1,
    STATE(6853), 1,
      sym__role,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11309), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(11369), 3,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [250583] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 3,
      sym_comma,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8781), 5,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250601] = 3,
    ACTIONS(9254), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9252), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250619] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_AT2,
    ACTIONS(8340), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [250637] = 3,
    ACTIONS(9146), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250655] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8947), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [250673] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8931), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [250691] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8921), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [250709] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8902), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [250727] = 4,
    ACTIONS(11372), 1,
      anon_sym_AT2,
    ACTIONS(8108), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [250747] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym__dot,
      sym_comma,
      sym__conid,
    ACTIONS(8223), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [250765] = 3,
    ACTIONS(8225), 2,
      sym__dot,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [250783] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8855), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [250803] = 9,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11374), 1,
      anon_sym_RBRACE,
    STATE(8190), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(8360), 1,
      sym__field_name,
    STATE(8572), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [250833] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [250853] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8861), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [250873] = 3,
    ACTIONS(9285), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250891] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8855), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [250911] = 3,
    ACTIONS(10151), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250929] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8861), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [250949] = 3,
    ACTIONS(10220), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [250967] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11380), 1,
      anon_sym_RBRACE,
    STATE(8307), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [250994] = 3,
    ACTIONS(9199), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [251011] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11384), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8430), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251038] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11386), 1,
      anon_sym_RBRACE,
    STATE(8096), 1,
      sym__record_field_update,
    STATE(8120), 1,
      sym_variable,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251065] = 3,
    ACTIONS(9162), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [251082] = 3,
    ACTIONS(10220), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [251099] = 3,
    ACTIONS(10151), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [251116] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [251135] = 3,
    ACTIONS(9197), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [251152] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [251171] = 3,
    ACTIONS(10381), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [251188] = 3,
    ACTIONS(9279), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [251205] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11388), 1,
      anon_sym_RBRACE,
    STATE(8240), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251232] = 3,
    ACTIONS(9279), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [251249] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11390), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8378), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251276] = 3,
    ACTIONS(8855), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [251293] = 3,
    ACTIONS(10381), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [251310] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11392), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8528), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251337] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11394), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8434), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251364] = 3,
    ACTIONS(10306), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [251381] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 3,
      sym_comma,
      sym__conid,
      anon_sym_of,
    ACTIONS(10218), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [251398] = 3,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [251415] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8861), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [251434] = 3,
    ACTIONS(9199), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [251451] = 7,
    ACTIONS(10981), 1,
      sym__consym,
    ACTIONS(11396), 1,
      sym__conid,
    STATE(6433), 1,
      aux_sym__qualifying_module,
    STATE(10103), 1,
      sym_constructor,
    STATE(10142), 1,
      sym__modid,
    ACTIONS(10976), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251476] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8855), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [251495] = 3,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [251512] = 3,
    ACTIONS(9206), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [251529] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11399), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8424), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251556] = 3,
    ACTIONS(9281), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [251573] = 3,
    ACTIONS(10379), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [251590] = 3,
    ACTIONS(8894), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [251607] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11401), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8364), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251634] = 3,
    ACTIONS(9260), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [251651] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11403), 1,
      anon_sym_RBRACE,
    STATE(8291), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251678] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11405), 1,
      anon_sym_RBRACE,
    STATE(8041), 1,
      sym__record_field_update,
    STATE(8120), 1,
      sym_variable,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251705] = 3,
    ACTIONS(9146), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [251722] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11407), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8542), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251749] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11409), 1,
      anon_sym_RBRACE,
    STATE(8356), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251776] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8861), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8859), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [251795] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11411), 1,
      anon_sym_RBRACE,
    STATE(8352), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251822] = 3,
    ACTIONS(3461), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [251839] = 3,
    ACTIONS(10383), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [251856] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8855), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [251875] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11413), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8433), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251902] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11415), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8473), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251929] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11417), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8500), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251956] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8857), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_as,
  [251971] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11419), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8432), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [251998] = 3,
    ACTIONS(3277), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252015] = 3,
    ACTIONS(8223), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      sym__conid,
  [252032] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_AT2,
    ACTIONS(8340), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [252049] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11421), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8169), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252076] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11423), 1,
      anon_sym_RBRACE,
    STATE(8083), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252103] = 3,
    ACTIONS(9146), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252120] = 3,
    ACTIONS(9285), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252137] = 4,
    ACTIONS(8104), 1,
      anon_sym_BQUOTE,
    ACTIONS(9194), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9191), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [252156] = 4,
    ACTIONS(8413), 1,
      anon_sym_BQUOTE,
    ACTIONS(9978), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9201), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [252175] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11425), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8381), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252202] = 3,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [252219] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11427), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8323), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252246] = 3,
    ACTIONS(9146), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [252263] = 3,
    ACTIONS(10314), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [252280] = 3,
    ACTIONS(10371), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [252297] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11429), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_as,
  [252314] = 3,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
      anon_sym_in,
  [252331] = 4,
    ACTIONS(9220), 1,
      anon_sym_BQUOTE,
    ACTIONS(9888), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9262), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [252350] = 3,
    ACTIONS(10359), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [252367] = 3,
    ACTIONS(10357), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [252384] = 3,
    ACTIONS(9144), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [252401] = 3,
    ACTIONS(10325), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [252418] = 3,
    ACTIONS(9226), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252435] = 3,
    ACTIONS(9144), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [252452] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11433), 1,
      anon_sym_RBRACE,
    STATE(8043), 1,
      sym_pat_field,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252479] = 3,
    ACTIONS(10381), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [252496] = 3,
    ACTIONS(9242), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9240), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252513] = 3,
    ACTIONS(10981), 1,
      sym__consym,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10976), 6,
      sym__varid,
      sym__operator,
      anon_sym_DASH,
      sym__conid,
      anon_sym_do,
      anon_sym_ado,
  [252530] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11435), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_as,
  [252547] = 3,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252564] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11437), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8534), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252591] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8898), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [252610] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11439), 1,
      anon_sym_RBRACE,
    STATE(8206), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252637] = 6,
    ACTIONS(11443), 1,
      anon_sym_LPAREN,
    ACTIONS(11445), 1,
      anon_sym_hiding,
    ACTIONS(11447), 1,
      anon_sym_as,
    STATE(7637), 1,
      sym_import_list,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11441), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [252660] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11449), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8108), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252687] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11451), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8152), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252714] = 3,
    ACTIONS(9281), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252731] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11453), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8493), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252758] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11455), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8519), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252785] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11457), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8453), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252812] = 3,
    ACTIONS(9212), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252829] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8853), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [252848] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11459), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8391), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252875] = 3,
    ACTIONS(8225), 2,
      sym__dot,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [252892] = 4,
    ACTIONS(10274), 1,
      sym__conid,
    ACTIONS(11461), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [252911] = 3,
    ACTIONS(9158), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9156), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252928] = 3,
    ACTIONS(9226), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [252945] = 8,
    ACTIONS(11463), 1,
      sym__conid,
    STATE(902), 1,
      sym_class_name,
    STATE(4317), 1,
      sym_constructor,
    STATE(4366), 1,
      sym_qualified_type,
    STATE(7756), 1,
      aux_sym__qualifying_module,
    STATE(8671), 1,
      sym_constraint,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [252972] = 3,
    ACTIONS(10856), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10858), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [252989] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11465), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8445), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253016] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11467), 1,
      anon_sym_RBRACE,
    STATE(8302), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253043] = 3,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [253060] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9285), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DOT,
  [253075] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11469), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8560), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253102] = 3,
    ACTIONS(10369), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [253119] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9206), 7,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DOT,
  [253134] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8868), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8870), 4,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253151] = 3,
    ACTIONS(10371), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [253168] = 3,
    ACTIONS(9154), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9152), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253185] = 3,
    ACTIONS(10367), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [253202] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(8415), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [253221] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11471), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8403), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253248] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11473), 1,
      anon_sym_RBRACE,
    STATE(8337), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253275] = 3,
    ACTIONS(10375), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [253292] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11475), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8311), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253319] = 3,
    ACTIONS(10377), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [253336] = 3,
    ACTIONS(10351), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [253353] = 3,
    ACTIONS(9150), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9148), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253370] = 3,
    ACTIONS(10369), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [253387] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11477), 1,
      anon_sym_RBRACE,
    STATE(8336), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253414] = 3,
    ACTIONS(10375), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [253431] = 3,
    ACTIONS(8340), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_AT2,
  [253448] = 3,
    ACTIONS(9281), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [253465] = 3,
    ACTIONS(9140), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9138), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253482] = 3,
    ACTIONS(9300), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253499] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11479), 1,
      anon_sym_RBRACE,
    STATE(8079), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253526] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11481), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8361), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253553] = 3,
    ACTIONS(9304), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253570] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11483), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8610), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253597] = 3,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [253614] = 3,
    ACTIONS(9294), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253631] = 5,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9511), 4,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_constructor_operator,
  [253652] = 3,
    ACTIONS(10373), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [253669] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11485), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8474), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253696] = 3,
    ACTIONS(10377), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [253713] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11487), 1,
      anon_sym_RBRACE,
    STATE(8205), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253740] = 3,
    ACTIONS(10285), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [253757] = 3,
    ACTIONS(9275), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253774] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8947), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [253791] = 3,
    ACTIONS(9146), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [253808] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11489), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8263), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253835] = 3,
    ACTIONS(9271), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253852] = 3,
    ACTIONS(9186), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253869] = 5,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9499), 4,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
      sym_constructor_operator,
  [253890] = 3,
    ACTIONS(9216), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [253907] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym_comma,
      sym__conid,
      anon_sym_of,
    ACTIONS(10153), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [253924] = 3,
    ACTIONS(10327), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [253941] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11491), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8265), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [253968] = 3,
    ACTIONS(10329), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [253985] = 3,
    ACTIONS(11275), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11277), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [254002] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254021] = 3,
    ACTIONS(10345), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [254038] = 3,
    ACTIONS(10351), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254055] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11493), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8153), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254082] = 3,
    ACTIONS(10331), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254099] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8931), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [254116] = 3,
    ACTIONS(10347), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254133] = 3,
    ACTIONS(9168), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254150] = 3,
    ACTIONS(9131), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254167] = 3,
    ACTIONS(10363), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254184] = 3,
    ACTIONS(10349), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [254201] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(10379), 4,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254218] = 3,
    ACTIONS(9325), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254235] = 4,
    ACTIONS(11495), 1,
      sym__layout_end,
    ACTIONS(8923), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8925), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [254254] = 3,
    ACTIONS(9208), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254271] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11497), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8388), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254298] = 3,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254315] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8921), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [254332] = 3,
    ACTIONS(10383), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254349] = 3,
    ACTIONS(10371), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254366] = 3,
    ACTIONS(9290), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254383] = 3,
    ACTIONS(9226), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [254400] = 3,
    ACTIONS(10363), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [254417] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11499), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8258), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254444] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11501), 1,
      anon_sym_RBRACE,
    STATE(8040), 1,
      sym__record_field_update,
    STATE(8120), 1,
      sym_variable,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254471] = 3,
    ACTIONS(10359), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254488] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11503), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8498), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254515] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11505), 1,
      anon_sym_RBRACE,
    STATE(8078), 1,
      sym__record_field_update,
    STATE(8120), 1,
      sym_variable,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254542] = 3,
    ACTIONS(10327), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [254559] = 4,
    ACTIONS(9487), 1,
      anon_sym_AT2,
    ACTIONS(10274), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254578] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11507), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8482), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254605] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11509), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8394), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254632] = 3,
    ACTIONS(9319), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254649] = 3,
    ACTIONS(10357), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [254666] = 3,
    ACTIONS(10351), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [254683] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11511), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8567), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254710] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11513), 1,
      anon_sym_RBRACE,
    STATE(8233), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254737] = 3,
    ACTIONS(9224), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [254754] = 3,
    ACTIONS(9238), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9236), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254771] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11515), 1,
      anon_sym_RBRACE,
    STATE(8139), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254798] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8338), 4,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254815] = 3,
    ACTIONS(9260), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [254832] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11517), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8344), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254859] = 4,
    ACTIONS(11519), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [254878] = 3,
    ACTIONS(10882), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10884), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [254895] = 3,
    ACTIONS(10347), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [254912] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11429), 6,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_as,
  [254929] = 3,
    ACTIONS(10331), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [254946] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11521), 1,
      anon_sym_RBRACE,
    STATE(8105), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [254973] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11523), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8243), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255000] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11525), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8543), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255027] = 3,
    ACTIONS(9250), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9248), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255044] = 3,
    ACTIONS(9258), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9256), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255061] = 3,
    ACTIONS(8894), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [255078] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11527), 1,
      anon_sym_RBRACE,
    STATE(8241), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255105] = 4,
    ACTIONS(11529), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [255124] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11531), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8203), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255151] = 3,
    ACTIONS(8223), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 5,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [255168] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11533), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8200), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255195] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11535), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8118), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255222] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11537), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8539), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255249] = 3,
    ACTIONS(11277), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11275), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [255266] = 4,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [255285] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 3,
      sym__layout_end,
      sym_comma,
      sym__conid,
    ACTIONS(8902), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [255302] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11539), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8509), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255329] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11541), 1,
      anon_sym_RBRACE,
    STATE(8135), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255356] = 3,
    ACTIONS(10331), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [255373] = 3,
    ACTIONS(10379), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [255390] = 3,
    ACTIONS(11277), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11275), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [255407] = 4,
    ACTIONS(11543), 1,
      anon_sym_AT2,
    ACTIONS(8108), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [255426] = 3,
    ACTIONS(10878), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10880), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255443] = 3,
    ACTIONS(10347), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [255460] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11545), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8457), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255487] = 3,
    ACTIONS(9230), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9228), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255504] = 3,
    ACTIONS(10377), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [255521] = 3,
    ACTIONS(10375), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [255538] = 3,
    ACTIONS(10369), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [255555] = 5,
    STATE(1173), 1,
      sym__colon2,
    STATE(8109), 1,
      sym__type_annotation,
    ACTIONS(11547), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11549), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [255576] = 3,
    ACTIONS(10306), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [255593] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11551), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8310), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255620] = 3,
    ACTIONS(9129), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9127), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255637] = 3,
    ACTIONS(10361), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [255654] = 3,
    ACTIONS(11275), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11277), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [255671] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11553), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8132), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255698] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11555), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8185), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255725] = 3,
    ACTIONS(10429), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10432), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255742] = 3,
    ACTIONS(9166), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9164), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255759] = 3,
    ACTIONS(10862), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10864), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255776] = 3,
    ACTIONS(10363), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [255793] = 3,
    ACTIONS(10349), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [255810] = 3,
    ACTIONS(9197), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [255827] = 4,
    ACTIONS(11557), 1,
      sym__layout_end,
    ACTIONS(8883), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8885), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [255846] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11559), 1,
      anon_sym_RBRACE,
    STATE(8036), 1,
      sym_pat_field,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255873] = 3,
    ACTIONS(10345), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [255890] = 3,
    ACTIONS(10896), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10898), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255907] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11561), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8608), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [255934] = 3,
    ACTIONS(10892), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10894), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255951] = 3,
    ACTIONS(10888), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10890), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255968] = 3,
    ACTIONS(9174), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9172), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [255985] = 3,
    ACTIONS(10553), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256002] = 3,
    ACTIONS(9178), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9176), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256019] = 3,
    ACTIONS(11277), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11275), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [256036] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11563), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8147), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256063] = 3,
    ACTIONS(10874), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10876), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256080] = 5,
    ACTIONS(11273), 1,
      sym__immediate_dot,
    STATE(6248), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(8319), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8321), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256101] = 3,
    ACTIONS(10870), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10872), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256118] = 3,
    ACTIONS(10866), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10868), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256135] = 3,
    ACTIONS(10900), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10902), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256152] = 3,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [256169] = 3,
    ACTIONS(9234), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9232), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256186] = 3,
    ACTIONS(10852), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10854), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256203] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11565), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8524), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256230] = 3,
    ACTIONS(10848), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10850), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256247] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8804), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8802), 4,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256264] = 3,
    ACTIONS(10359), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [256281] = 3,
    ACTIONS(10329), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [256298] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11567), 1,
      anon_sym_RBRACE,
    STATE(8052), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256325] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11569), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8556), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256352] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11571), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8572), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256379] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8795), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8793), 4,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256396] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8791), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8789), 4,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256413] = 3,
    ACTIONS(10325), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [256430] = 3,
    ACTIONS(8855), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [256447] = 3,
    ACTIONS(10357), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [256464] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11573), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8214), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256491] = 3,
    ACTIONS(10840), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10842), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256508] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8773), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8771), 4,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256525] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8783), 3,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACE,
    ACTIONS(8781), 4,
      sym__immediate_dot,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256542] = 8,
    ACTIONS(11463), 1,
      sym__conid,
    STATE(902), 1,
      sym_class_name,
    STATE(4317), 1,
      sym_constructor,
    STATE(4366), 1,
      sym_qualified_type,
    STATE(7756), 1,
      aux_sym__qualifying_module,
    STATE(8204), 1,
      sym_constraint,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256569] = 3,
    ACTIONS(9281), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [256586] = 3,
    ACTIONS(9246), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9244), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256603] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11575), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8517), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256630] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11577), 1,
      anon_sym_RBRACE,
    STATE(8190), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256657] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11579), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8254), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256684] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11581), 1,
      anon_sym_RBRACE,
    STATE(8166), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256711] = 6,
    ACTIONS(10978), 1,
      sym__conid,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(10018), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10976), 3,
      sym__varid,
      anon_sym_do,
      anon_sym_ado,
  [256734] = 3,
    ACTIONS(9222), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [256751] = 3,
    ACTIONS(10285), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [256768] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8857), 7,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_as,
  [256783] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11583), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8280), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256810] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11585), 1,
      anon_sym_RBRACE,
    STATE(8113), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256837] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym__dot,
      sym_comma,
      sym__conid,
    ACTIONS(8223), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [256854] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11587), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8305), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256881] = 3,
    ACTIONS(9226), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [256898] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11435), 6,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_as,
  [256915] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11589), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8562), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256942] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11591), 1,
      anon_sym_RBRACE,
    STATE(8292), 1,
      sym_record_field,
    STATE(8359), 1,
      sym_variable,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [256969] = 3,
    ACTIONS(10373), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [256986] = 3,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [257003] = 3,
    ACTIONS(10383), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [257020] = 3,
    ACTIONS(8106), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257037] = 3,
    ACTIONS(10327), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
  [257054] = 3,
    ACTIONS(10361), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__conid,
  [257071] = 3,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 6,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [257088] = 3,
    ACTIONS(9254), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9252), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257105] = 6,
    ACTIONS(11593), 1,
      anon_sym_LPAREN,
    ACTIONS(11595), 1,
      anon_sym_hiding,
    ACTIONS(11597), 1,
      anon_sym_as,
    STATE(7727), 1,
      sym_import_list,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11441), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [257128] = 8,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    ACTIONS(11599), 1,
      anon_sym_RBRACE,
    STATE(8120), 1,
      sym_variable,
    STATE(8228), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [257155] = 3,
    ACTIONS(10367), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [257172] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11601), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8577), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [257199] = 4,
    ACTIONS(11603), 1,
      sym__layout_end,
    ACTIONS(8777), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8775), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [257218] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11605), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8267), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [257245] = 3,
    ACTIONS(9182), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257262] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11607), 1,
      anon_sym_RBRACE,
    STATE(8359), 1,
      sym_variable,
    STATE(8472), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [257289] = 3,
    ACTIONS(9182), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 5,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257306] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_AT2,
    ACTIONS(8340), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [257323] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8951), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [257342] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym__dot,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(8223), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [257359] = 3,
    ACTIONS(9224), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [257376] = 8,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    ACTIONS(11609), 1,
      anon_sym_RBRACE,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8225), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [257403] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [257422] = 3,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [257439] = 4,
    ACTIONS(11611), 1,
      anon_sym_AT2,
    ACTIONS(8108), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10274), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257458] = 3,
    ACTIONS(9154), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9152), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [257474] = 3,
    ACTIONS(9281), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [257490] = 3,
    ACTIONS(8894), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257506] = 3,
    ACTIONS(10361), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257522] = 3,
    ACTIONS(9260), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257538] = 3,
    ACTIONS(8340), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 5,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [257554] = 3,
    ACTIONS(9150), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9148), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [257570] = 3,
    ACTIONS(10349), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257586] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
  [257600] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(8225), 3,
      sym__dot,
      anon_sym_RPAREN,
      sym__conid,
  [257616] = 3,
    ACTIONS(10345), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257632] = 3,
    ACTIONS(10329), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257648] = 3,
    ACTIONS(10383), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [257664] = 3,
    ACTIONS(10325), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257680] = 3,
    ACTIONS(9158), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9156), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [257696] = 3,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [257712] = 3,
    ACTIONS(9140), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9138), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [257728] = 3,
    ACTIONS(10285), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257744] = 3,
    ACTIONS(3288), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 4,
      sym_comma,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_RBRACE,
  [257760] = 3,
    ACTIONS(9199), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257776] = 3,
    ACTIONS(10306), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257792] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8945), 3,
      sym__layout_end,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(8947), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257808] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8929), 3,
      sym__layout_end,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(8931), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257824] = 3,
    ACTIONS(10553), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [257840] = 3,
    ACTIONS(10888), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10890), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [257856] = 4,
    ACTIONS(11615), 1,
      sym_comma,
    STATE(6823), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11613), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [257874] = 4,
    ACTIONS(11617), 1,
      sym__layout_end,
    ACTIONS(8923), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8925), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257892] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8919), 3,
      sym__layout_end,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(8921), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257908] = 3,
    ACTIONS(10373), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [257924] = 4,
    ACTIONS(11619), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257942] = 4,
    ACTIONS(11621), 1,
      sym__layout_end,
    ACTIONS(8911), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8913), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257960] = 3,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8900), 3,
      sym__layout_end,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(8902), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [257976] = 3,
    ACTIONS(9238), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9236), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [257992] = 3,
    ACTIONS(10882), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10884), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258008] = 3,
    ACTIONS(9197), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [258024] = 4,
    ACTIONS(11623), 1,
      sym__layout_end,
    ACTIONS(8883), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8885), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [258042] = 4,
    ACTIONS(11625), 1,
      sym__layout_end,
    ACTIONS(8777), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8775), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [258060] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__varid,
  [258074] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11627), 1,
      anon_sym_EQ,
    STATE(8570), 1,
      sym__funrhs,
    STATE(9332), 1,
      sym_guards,
    STATE(6382), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258096] = 4,
    ACTIONS(11615), 1,
      sym_comma,
    STATE(6755), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11629), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [258114] = 5,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11345), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8625), 3,
      sym_variable,
      sym_constructor,
      sym__name,
  [258134] = 3,
    ACTIONS(10371), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [258150] = 7,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    STATE(8120), 1,
      sym_variable,
    STATE(8611), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258174] = 7,
    ACTIONS(93), 1,
      sym__consym,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(3464), 1,
      sym_constructor,
    STATE(6433), 1,
      aux_sym__qualifying_module,
    STATE(10005), 1,
      sym_constructor_operator,
    STATE(10142), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258198] = 3,
    ACTIONS(3461), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258214] = 3,
    ACTIONS(9258), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9256), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258230] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11631), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [258244] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11633), 1,
      anon_sym_EQ,
    STATE(8181), 1,
      sym__funrhs,
    STATE(10019), 1,
      sym_guards,
    STATE(6240), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258266] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11635), 1,
      anon_sym_EQ,
    STATE(8131), 1,
      sym__funrhs,
    STATE(9388), 1,
      sym_guards,
    STATE(6357), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258288] = 3,
    ACTIONS(9146), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258304] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11633), 1,
      anon_sym_EQ,
    STATE(8184), 1,
      sym__funrhs,
    STATE(10019), 1,
      sym_guards,
    STATE(6240), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258326] = 5,
    STATE(1137), 1,
      sym__colon2,
    STATE(8719), 1,
      sym__type_annotation,
    ACTIONS(11549), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(11637), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258346] = 3,
    ACTIONS(10892), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10894), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258362] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11635), 1,
      anon_sym_EQ,
    STATE(8134), 1,
      sym__funrhs,
    STATE(9388), 1,
      sym_guards,
    STATE(6357), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258384] = 3,
    ACTIONS(10379), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [258400] = 3,
    ACTIONS(9230), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9228), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258416] = 5,
    STATE(1148), 1,
      sym__colon2,
    STATE(8557), 1,
      sym__type_annotation,
    ACTIONS(11549), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(11639), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258436] = 3,
    ACTIONS(9129), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9127), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258452] = 3,
    ACTIONS(9226), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [258468] = 3,
    ACTIONS(10363), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [258484] = 3,
    ACTIONS(9285), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258500] = 3,
    ACTIONS(10306), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10314), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [258516] = 6,
    ACTIONS(11396), 1,
      sym__conid,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(10976), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258538] = 5,
    ACTIONS(10673), 1,
      sym__varid,
    STATE(8097), 1,
      sym__arrow,
    ACTIONS(11641), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(7527), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258558] = 3,
    ACTIONS(9242), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9240), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258574] = 5,
    ACTIONS(10659), 1,
      sym__conid,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11357), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(8628), 3,
      sym_variable,
      sym_constructor,
      sym__import_name,
  [258594] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 6,
      sym_comma,
      sym__operator,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [258608] = 7,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11263), 1,
      sym_string,
    ACTIONS(11265), 1,
      sym_triple_quote_string,
    STATE(8104), 1,
      sym_variable,
    STATE(8107), 1,
      sym__field_name,
    STATE(8688), 1,
      sym_pat_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258632] = 3,
    ACTIONS(9199), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10371), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [258648] = 3,
    ACTIONS(10314), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [258664] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
  [258678] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(8415), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8413), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [258696] = 3,
    ACTIONS(9224), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [258712] = 3,
    ACTIONS(9166), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9164), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258728] = 3,
    ACTIONS(9174), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9172), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258744] = 3,
    ACTIONS(9178), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9176), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258760] = 3,
    ACTIONS(10852), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10854), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258776] = 7,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    ACTIONS(11382), 1,
      sym__varid,
    STATE(8120), 1,
      sym_variable,
    STATE(8631), 1,
      sym__record_field_update,
    STATE(8654), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258800] = 3,
    ACTIONS(10874), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10876), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258816] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9162), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      sym__varid,
  [258830] = 3,
    ACTIONS(10870), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10872), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258846] = 3,
    ACTIONS(9234), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9232), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258862] = 3,
    ACTIONS(8894), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10359), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [258878] = 3,
    ACTIONS(10866), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10868), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258894] = 3,
    ACTIONS(9260), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10357), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [258910] = 3,
    ACTIONS(9250), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9248), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [258926] = 3,
    ACTIONS(3463), 2,
      sym__operator,
      anon_sym_PIPE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 4,
      sym_comma,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_RBRACE,
  [258942] = 7,
    ACTIONS(11003), 1,
      sym__conid,
    STATE(3060), 1,
      sym_constructor,
    STATE(3215), 1,
      sym_qualified_type,
    STATE(4620), 1,
      sym_class_name,
    STATE(7853), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [258966] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8898), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8896), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [258984] = 3,
    ACTIONS(10381), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259000] = 7,
    ACTIONS(11001), 1,
      sym__conid,
    STATE(840), 1,
      sym_class_name,
    STATE(3220), 1,
      sym_constructor,
    STATE(3414), 1,
      sym_qualified_type,
    STATE(7948), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [259024] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11643), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [259038] = 3,
    ACTIONS(9224), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9226), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [259054] = 4,
    ACTIONS(11647), 1,
      sym_comma,
    STATE(6823), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11645), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [259072] = 3,
    ACTIONS(10375), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259088] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8951), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8949), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [259106] = 7,
    ACTIONS(2078), 1,
      sym__conid,
    ACTIONS(11259), 1,
      sym__varid,
    STATE(2436), 1,
      sym_variable,
    STATE(3619), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [259130] = 3,
    ACTIONS(9246), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9244), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259146] = 4,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [259164] = 4,
    ACTIONS(8995), 1,
      anon_sym_AT2,
    ACTIONS(10274), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [259182] = 3,
    ACTIONS(10377), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259198] = 3,
    ACTIONS(11277), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11275), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259214] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [259232] = 3,
    ACTIONS(9182), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259248] = 3,
    ACTIONS(10369), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259264] = 3,
    ACTIONS(9281), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259280] = 3,
    ACTIONS(9162), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259296] = 3,
    ACTIONS(10383), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259312] = 3,
    ACTIONS(8853), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259328] = 3,
    ACTIONS(9254), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9252), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259344] = 3,
    ACTIONS(10367), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [259360] = 3,
    ACTIONS(10381), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259376] = 3,
    ACTIONS(10840), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10842), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259392] = 3,
    ACTIONS(10357), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259408] = 7,
    ACTIONS(2824), 1,
      sym__conid,
    ACTIONS(11261), 1,
      sym__varid,
    STATE(2642), 1,
      sym_variable,
    STATE(4318), 1,
      sym_constructor,
    STATE(6693), 1,
      aux_sym__qualifying_module,
    STATE(10018), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [259432] = 7,
    ACTIONS(11019), 1,
      sym__conid,
    STATE(850), 1,
      sym_class_name,
    STATE(3163), 1,
      sym_constructor,
    STATE(3411), 1,
      sym_qualified_type,
    STATE(7862), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [259456] = 3,
    ACTIONS(9226), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259472] = 4,
    ACTIONS(11650), 1,
      sym_comma,
    STATE(6847), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11645), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [259490] = 3,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259506] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11643), 6,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [259520] = 3,
    ACTIONS(9206), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259536] = 3,
    ACTIONS(8225), 2,
      sym__dot,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [259552] = 7,
    ACTIONS(11021), 1,
      sym__conid,
    STATE(3098), 1,
      sym_constructor,
    STATE(3164), 1,
      sym_qualified_type,
    STATE(4611), 1,
      sym_class_name,
    STATE(7911), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [259576] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11631), 6,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [259590] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11653), 6,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
  [259604] = 3,
    ACTIONS(9146), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259620] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 6,
      sym_comma,
      sym__operator,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_of,
  [259634] = 3,
    ACTIONS(10327), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [259650] = 3,
    ACTIONS(10371), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259666] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
  [259680] = 3,
    ACTIONS(9216), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259696] = 3,
    ACTIONS(10363), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259712] = 3,
    ACTIONS(11275), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11277), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [259728] = 4,
    ACTIONS(10274), 1,
      sym__conid,
    ACTIONS(11655), 1,
      anon_sym_AT2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8108), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [259746] = 3,
    ACTIONS(10359), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259762] = 3,
    ACTIONS(10357), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259778] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11627), 1,
      anon_sym_EQ,
    STATE(8515), 1,
      sym__funrhs,
    STATE(9332), 1,
      sym_guards,
    STATE(6382), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [259800] = 3,
    ACTIONS(9300), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259816] = 6,
    ACTIONS(11283), 1,
      anon_sym_PIPE,
    ACTIONS(11627), 1,
      anon_sym_EQ,
    STATE(8552), 1,
      sym__funrhs,
    STATE(9332), 1,
      sym_guards,
    STATE(6382), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [259838] = 3,
    ACTIONS(9304), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259854] = 3,
    ACTIONS(9294), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259870] = 3,
    ACTIONS(10351), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259886] = 3,
    ACTIONS(10347), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259902] = 3,
    ACTIONS(8106), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259918] = 3,
    ACTIONS(10331), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [259934] = 3,
    ACTIONS(9144), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [259950] = 3,
    ACTIONS(9275), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259966] = 3,
    ACTIONS(10900), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10902), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259982] = 3,
    ACTIONS(9271), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [259998] = 3,
    ACTIONS(8340), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8338), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_AT2,
  [260014] = 4,
    ACTIONS(11657), 1,
      sym_comma,
    STATE(6913), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11629), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [260032] = 7,
    ACTIONS(11261), 1,
      sym__varid,
    ACTIONS(11376), 1,
      sym_string,
    ACTIONS(11378), 1,
      sym_triple_quote_string,
    STATE(8359), 1,
      sym_variable,
    STATE(8643), 1,
      sym_record_field,
    STATE(9821), 1,
      sym__field_name,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [260056] = 5,
    ACTIONS(10673), 1,
      sym__varid,
    STATE(8389), 1,
      sym__arrow,
    ACTIONS(11659), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(7527), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [260076] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [260094] = 3,
    ACTIONS(10327), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [260110] = 7,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10765), 1,
      sym__operator,
    STATE(4702), 1,
      sym_type_operator,
    STATE(7494), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [260134] = 3,
    ACTIONS(10359), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [260150] = 4,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [260168] = 3,
    ACTIONS(9182), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260184] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
  [260198] = 3,
    ACTIONS(10331), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [260214] = 3,
    ACTIONS(10367), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10369), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260230] = 3,
    ACTIONS(10347), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [260246] = 3,
    ACTIONS(10373), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10375), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260262] = 3,
    ACTIONS(8855), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260278] = 3,
    ACTIONS(10285), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10377), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260294] = 3,
    ACTIONS(9146), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [260310] = 3,
    ACTIONS(10351), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      sym__operator,
      anon_sym_DASH,
  [260326] = 3,
    ACTIONS(10325), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10327), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260342] = 3,
    ACTIONS(9279), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260358] = 3,
    ACTIONS(10329), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10331), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260374] = 3,
    ACTIONS(10345), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10347), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260390] = 7,
    ACTIONS(11661), 1,
      sym__conid,
    STATE(4317), 1,
      sym_constructor,
    STATE(4366), 1,
      sym_qualified_type,
    STATE(7623), 1,
      aux_sym__qualifying_module,
    STATE(8657), 1,
      sym_class_name,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [260414] = 3,
    ACTIONS(10349), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10351), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260430] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8853), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [260448] = 3,
    ACTIONS(9222), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260464] = 3,
    ACTIONS(11275), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11277), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [260480] = 3,
    ACTIONS(10377), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [260496] = 3,
    ACTIONS(9186), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260512] = 3,
    ACTIONS(10361), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10363), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260528] = 3,
    ACTIONS(10375), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [260544] = 3,
    ACTIONS(3277), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260560] = 3,
    ACTIONS(8225), 2,
      sym__dot,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8223), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [260576] = 4,
    ACTIONS(11657), 1,
      sym_comma,
    STATE(6847), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11613), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [260594] = 3,
    ACTIONS(8855), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8853), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [260610] = 3,
    ACTIONS(10848), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10850), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260626] = 7,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(11041), 1,
      sym_string,
    ACTIONS(11043), 1,
      sym_triple_quote_string,
    STATE(7633), 1,
      sym_row_field,
    STATE(8322), 1,
      sym__field_name_ty,
    STATE(8682), 1,
      sym_type_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [260650] = 3,
    ACTIONS(9212), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260666] = 3,
    ACTIONS(10369), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [260682] = 3,
    ACTIONS(9279), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [260698] = 7,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(11663), 1,
      sym__immediate_dot,
    ACTIONS(11665), 1,
      anon_sym_of,
    ACTIONS(11667), 1,
      sym_comma,
    STATE(2139), 1,
      aux_sym_record_accessor_repeat1,
    STATE(8465), 1,
      aux_sym__exp_case_slots_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [260722] = 3,
    ACTIONS(11277), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11275), 5,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
  [260738] = 3,
    ACTIONS(10379), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10381), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260754] = 3,
    ACTIONS(9168), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260770] = 3,
    ACTIONS(9197), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10383), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__conid,
  [260786] = 3,
    ACTIONS(9281), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260802] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
      anon_sym_in,
  [260816] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 6,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
      anon_sym_in,
  [260830] = 3,
    ACTIONS(9131), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260846] = 3,
    ACTIONS(9325), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260862] = 3,
    ACTIONS(9144), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9146), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__conid,
  [260878] = 3,
    ACTIONS(9208), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260894] = 3,
    ACTIONS(8853), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260910] = 3,
    ACTIONS(10896), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10898), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260926] = 3,
    ACTIONS(9226), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260942] = 3,
    ACTIONS(9290), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260958] = 3,
    ACTIONS(9319), 2,
      sym_comma,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_EQ,
      anon_sym_BQUOTE,
  [260974] = 4,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(8859), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8861), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [260992] = 4,
    ACTIONS(11671), 1,
      sym_where,
    STATE(8213), 1,
      sym_class_body,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11669), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [261009] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11673), 1,
      anon_sym_RBRACE,
    ACTIONS(11675), 1,
      sym_comma,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9896), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261030] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11677), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10143), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261051] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11679), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9191), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261072] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11681), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9240), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261093] = 4,
    ACTIONS(11683), 1,
      sym_string,
    ACTIONS(11685), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2112), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261110] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11687), 1,
      anon_sym_RBRACE,
    STATE(6954), 1,
      aux_sym_row_type_repeat1,
    STATE(9206), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261131] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11689), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9190), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261152] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11691), 1,
      anon_sym_RBRACE,
    STATE(6941), 1,
      aux_sym_row_type_repeat1,
    STATE(9188), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261173] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11693), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9168), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261194] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11695), 1,
      anon_sym_RPAREN,
    STATE(6945), 1,
      aux_sym_row_type_repeat1,
    STATE(9185), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261215] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11697), 1,
      anon_sym_RBRACE,
    STATE(6950), 1,
      aux_sym_row_type_repeat1,
    STATE(9179), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261236] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11699), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9164), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261257] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11701), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9208), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261278] = 5,
    ACTIONS(11705), 1,
      anon_sym_in,
    STATE(5280), 1,
      sym__ado_in,
    STATE(6968), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11703), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261297] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11707), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9173), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261318] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11709), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9209), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261339] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11711), 1,
      anon_sym_RPAREN,
    STATE(6947), 1,
      aux_sym_row_type_repeat1,
    STATE(9186), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261360] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11713), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9172), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261381] = 3,
    ACTIONS(9146), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [261396] = 5,
    ACTIONS(11717), 1,
      anon_sym_in,
    STATE(2458), 1,
      sym__ado_in,
    STATE(6969), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11715), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261415] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11719), 1,
      anon_sym_RBRACE,
    STATE(6953), 1,
      aux_sym_row_type_repeat1,
    STATE(9170), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261436] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11721), 1,
      anon_sym_RPAREN,
    STATE(6956), 1,
      aux_sym_row_type_repeat1,
    STATE(9167), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261457] = 3,
    ACTIONS(9281), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [261472] = 3,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [261487] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11723), 1,
      anon_sym_RPAREN,
    STATE(6965), 1,
      aux_sym_row_type_repeat1,
    STATE(9221), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261508] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11725), 1,
      anon_sym_RBRACE,
    STATE(6967), 1,
      aux_sym_row_type_repeat1,
    STATE(9224), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261529] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11727), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9226), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261550] = 3,
    ACTIONS(9162), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9160), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261565] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11729), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9227), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261586] = 5,
    ACTIONS(11705), 1,
      anon_sym_in,
    STATE(5341), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11731), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261605] = 5,
    ACTIONS(11717), 1,
      anon_sym_in,
    STATE(2470), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11733), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261624] = 3,
    ACTIONS(9206), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9204), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261639] = 4,
    ACTIONS(11735), 1,
      sym_string,
    ACTIONS(11737), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(4854), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261656] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11739), 1,
      anon_sym_RPAREN,
    STATE(6986), 1,
      aux_sym_row_type_repeat1,
    STATE(9239), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261677] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11741), 1,
      anon_sym_RBRACE,
    STATE(7192), 1,
      aux_sym_row_type_repeat1,
    STATE(9430), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261698] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11743), 1,
      anon_sym_RBRACE,
    STATE(6988), 1,
      aux_sym_row_type_repeat1,
    STATE(9242), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261719] = 3,
    ACTIONS(9285), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9283), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261734] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11745), 1,
      anon_sym_RPAREN,
    STATE(6940), 1,
      aux_sym_row_type_repeat1,
    STATE(10137), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261755] = 3,
    ACTIONS(9131), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9133), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261770] = 3,
    ACTIONS(9294), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9296), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261785] = 3,
    ACTIONS(9146), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [261800] = 3,
    ACTIONS(9319), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9321), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261815] = 3,
    ACTIONS(9146), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261830] = 3,
    ACTIONS(9208), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9210), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261845] = 5,
    ACTIONS(11749), 1,
      anon_sym_in,
    STATE(5076), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11747), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261864] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [261877] = 3,
    ACTIONS(9325), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9327), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261892] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11751), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9244), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261913] = 3,
    ACTIONS(9168), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9170), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261928] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11753), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9245), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261949] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11755), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [261962] = 3,
    ACTIONS(9212), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9214), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [261977] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11757), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9155), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [261998] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11759), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9154), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262019] = 3,
    ACTIONS(9216), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9218), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [262034] = 3,
    ACTIONS(9186), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9184), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [262049] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11761), 1,
      anon_sym_RBRACE,
    STATE(6991), 1,
      aux_sym_row_type_repeat1,
    STATE(9152), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262070] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11763), 1,
      anon_sym_RPAREN,
    STATE(6992), 1,
      aux_sym_row_type_repeat1,
    STATE(9149), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262091] = 5,
    ACTIONS(11749), 1,
      anon_sym_in,
    STATE(5132), 1,
      sym__ado_in,
    STATE(6983), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11765), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262110] = 3,
    ACTIONS(9271), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9273), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [262125] = 3,
    ACTIONS(9275), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9277), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [262140] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [262153] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11767), 1,
      anon_sym_RPAREN,
    STATE(7003), 1,
      aux_sym_row_type_repeat1,
    STATE(9257), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262174] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11769), 1,
      anon_sym_RBRACE,
    STATE(7005), 1,
      aux_sym_row_type_repeat1,
    STATE(9260), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262195] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11771), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9262), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262216] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11773), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9246), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262237] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11775), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9263), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262258] = 3,
    ACTIONS(9304), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9302), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [262273] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11777), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9137), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262294] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11779), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9136), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262315] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11781), 1,
      anon_sym_RPAREN,
    STATE(7024), 1,
      aux_sym_row_type_repeat1,
    STATE(9110), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262336] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11783), 1,
      anon_sym_RBRACE,
    STATE(7007), 1,
      aux_sym_row_type_repeat1,
    STATE(9134), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262357] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11785), 1,
      anon_sym_RPAREN,
    STATE(7008), 1,
      aux_sym_row_type_repeat1,
    STATE(9131), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262378] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11787), 1,
      anon_sym_RBRACE,
    STATE(7027), 1,
      aux_sym_row_type_repeat1,
    STATE(9105), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262399] = 3,
    ACTIONS(9300), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9298), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [262414] = 4,
    ACTIONS(11789), 1,
      sym_string,
    ACTIONS(11791), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2089), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262431] = 3,
    ACTIONS(9226), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [262446] = 5,
    ACTIONS(11795), 1,
      anon_sym_in,
    STATE(1710), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11793), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262465] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11797), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9119), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262486] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11799), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9118), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262507] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11801), 1,
      anon_sym_RPAREN,
    STATE(7021), 1,
      aux_sym_row_type_repeat1,
    STATE(9275), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262528] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11803), 1,
      anon_sym_RBRACE,
    STATE(7025), 1,
      aux_sym_row_type_repeat1,
    STATE(9278), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262549] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11805), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9280), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262570] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11807), 1,
      anon_sym_RBRACE,
    STATE(7017), 1,
      aux_sym_row_type_repeat1,
    STATE(9116), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262591] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11809), 1,
      anon_sym_RPAREN,
    STATE(7018), 1,
      aux_sym_row_type_repeat1,
    STATE(9113), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262612] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11811), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9089), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262633] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11813), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9281), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262654] = 3,
    ACTIONS(9281), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [262669] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11815), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9087), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262690] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11817), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9101), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262711] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11819), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9100), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262732] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11821), 1,
      anon_sym_RBRACE,
    STATE(7028), 1,
      aux_sym_row_type_repeat1,
    STATE(9098), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262753] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11823), 1,
      anon_sym_RPAREN,
    STATE(7048), 1,
      aux_sym_row_type_repeat1,
    STATE(10088), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262774] = 3,
    ACTIONS(10351), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [262789] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11825), 1,
      anon_sym_RPAREN,
    STATE(7029), 1,
      aux_sym_row_type_repeat1,
    STATE(9095), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262810] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11827), 1,
      anon_sym_RBRACE,
    STATE(7050), 1,
      aux_sym_row_type_repeat1,
    STATE(10079), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262831] = 5,
    ACTIONS(11831), 1,
      anon_sym_in,
    STATE(2075), 1,
      sym__ado_in,
    STATE(7046), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11829), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262850] = 4,
    ACTIONS(11833), 1,
      sym_string,
    ACTIONS(11835), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(4967), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262867] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11837), 1,
      anon_sym_RBRACE,
    STATE(7004), 1,
      aux_sym_row_type_repeat1,
    STATE(9264), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262888] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [262901] = 4,
    ACTIONS(11839), 1,
      sym_string,
    ACTIONS(11841), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2613), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262918] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11843), 1,
      anon_sym_RPAREN,
    STATE(7045), 1,
      aux_sym_row_type_repeat1,
    STATE(9293), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262939] = 3,
    ACTIONS(8853), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [262954] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11845), 1,
      anon_sym_RBRACE,
    STATE(7047), 1,
      aux_sym_row_type_repeat1,
    STATE(9296), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [262975] = 4,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    STATE(7121), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11847), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [262992] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11849), 1,
      anon_sym_RPAREN,
    STATE(6942), 1,
      aux_sym_row_type_repeat1,
    STATE(9269), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263013] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11851), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9298), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263034] = 5,
    ACTIONS(11831), 1,
      anon_sym_in,
    STATE(2071), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11853), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263053] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11855), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9299), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263074] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11857), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10070), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263095] = 5,
    ACTIONS(11795), 1,
      anon_sym_in,
    STATE(1713), 1,
      sym__ado_in,
    STATE(7016), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11859), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263114] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11861), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10067), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263135] = 5,
    ACTIONS(11865), 1,
      anon_sym_in,
    STATE(2660), 1,
      sym__ado_in,
    STATE(7058), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11863), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263154] = 3,
    ACTIONS(10369), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263169] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11867), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10087), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263190] = 3,
    ACTIONS(10375), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263205] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11869), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10072), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263226] = 3,
    ACTIONS(10377), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263241] = 3,
    ACTIONS(9226), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [263256] = 5,
    ACTIONS(11865), 1,
      anon_sym_in,
    STATE(2622), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11871), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263275] = 3,
    ACTIONS(9290), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9292), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [263290] = 3,
    ACTIONS(3277), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [263305] = 4,
    ACTIONS(11873), 1,
      sym_string,
    ACTIONS(11875), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(1624), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263322] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11877), 1,
      anon_sym_RBRACE,
    STATE(7053), 1,
      aux_sym_row_type_repeat1,
    STATE(10062), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263343] = 3,
    ACTIONS(10327), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263358] = 4,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    STATE(7121), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2622), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [263375] = 3,
    ACTIONS(10331), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263390] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11879), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9083), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263411] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11881), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9082), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263432] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11883), 1,
      anon_sym_RBRACE,
    STATE(7066), 1,
      aux_sym_row_type_repeat1,
    STATE(9080), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263453] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11885), 1,
      anon_sym_RPAREN,
    STATE(7067), 1,
      aux_sym_row_type_repeat1,
    STATE(9077), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263474] = 3,
    ACTIONS(9281), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9279), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263489] = 3,
    ACTIONS(10347), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263504] = 6,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(11887), 1,
      anon_sym_LPAREN,
    ACTIONS(11889), 1,
      anon_sym_data,
    STATE(7932), 1,
      sym__fun_name,
    STATE(8697), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263525] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11891), 1,
      anon_sym_RPAREN,
    STATE(7055), 1,
      aux_sym_row_type_repeat1,
    STATE(10060), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263546] = 3,
    ACTIONS(8853), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8855), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263561] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11893), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9065), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263582] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [263595] = 3,
    ACTIONS(9226), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9224), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263610] = 3,
    ACTIONS(3461), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [263625] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [263638] = 3,
    ACTIONS(10381), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [263653] = 5,
    ACTIONS(11897), 1,
      anon_sym_in,
    STATE(5413), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11895), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263672] = 6,
    ACTIONS(11899), 1,
      sym__conid,
    STATE(6456), 1,
      sym_constructor,
    STATE(6486), 1,
      sym__modid,
    STATE(6491), 1,
      sym_qualified_module,
    STATE(7681), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263693] = 6,
    ACTIONS(11901), 1,
      sym__conid,
    STATE(6696), 1,
      sym_constructor,
    STATE(6702), 1,
      sym__modid,
    STATE(6713), 1,
      sym_qualified_module,
    STATE(7839), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263714] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11903), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9064), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263735] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11905), 1,
      anon_sym_RBRACE,
    STATE(7075), 1,
      aux_sym_row_type_repeat1,
    STATE(9062), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263756] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11907), 1,
      anon_sym_RPAREN,
    STATE(7101), 1,
      aux_sym_row_type_repeat1,
    STATE(9035), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263777] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11909), 1,
      anon_sym_RPAREN,
    STATE(7084), 1,
      aux_sym_row_type_repeat1,
    STATE(9059), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263798] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11911), 1,
      anon_sym_RPAREN,
    STATE(7114), 1,
      aux_sym_row_type_repeat1,
    STATE(10037), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263819] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11913), 1,
      anon_sym_RBRACE,
    STATE(7104), 1,
      aux_sym_row_type_repeat1,
    STATE(9032), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263840] = 4,
    ACTIONS(11917), 1,
      sym_comma,
    STATE(7090), 1,
      aux_sym_alt_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11915), 3,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [263857] = 4,
    ACTIONS(11920), 1,
      sym_string,
    ACTIONS(11922), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2944), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263874] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11924), 1,
      anon_sym_RBRACE,
    STATE(7117), 1,
      aux_sym_row_type_repeat1,
    STATE(10030), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263895] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11926), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9047), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263916] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11928), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9046), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263937] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11930), 1,
      anon_sym_RBRACE,
    STATE(7093), 1,
      aux_sym_row_type_repeat1,
    STATE(9044), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263958] = 6,
    ACTIONS(11932), 1,
      sym__conid,
    STATE(7947), 1,
      aux_sym__qualifying_module,
    STATE(8136), 1,
      sym_qualified_module,
    STATE(8283), 1,
      sym_constructor,
    STATE(8369), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [263979] = 3,
    ACTIONS(10363), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [263994] = 5,
    ACTIONS(11897), 1,
      anon_sym_in,
    STATE(5421), 1,
      sym__ado_in,
    STATE(7081), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11934), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264013] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11936), 1,
      anon_sym_RPAREN,
    STATE(7094), 1,
      aux_sym_row_type_repeat1,
    STATE(9041), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264034] = 4,
    ACTIONS(11938), 1,
      sym_string,
    ACTIONS(11940), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(4776), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264051] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11942), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9017), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264072] = 3,
    ACTIONS(10383), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [264087] = 3,
    ACTIONS(10220), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10218), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [264102] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11944), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9015), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264123] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11946), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9029), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264144] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11948), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9028), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264165] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11950), 1,
      anon_sym_RBRACE,
    STATE(7105), 1,
      aux_sym_row_type_repeat1,
    STATE(9026), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264186] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11653), 5,
      sym_comma,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [264199] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11952), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9345), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264220] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11954), 1,
      anon_sym_RPAREN,
    STATE(7106), 1,
      aux_sym_row_type_repeat1,
    STATE(9023), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264241] = 4,
    STATE(6230), 1,
      aux_sym_type_role_declaration_repeat1,
    STATE(6776), 1,
      sym__role,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11271), 3,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [264258] = 5,
    ACTIONS(11958), 1,
      anon_sym_in,
    STATE(2927), 1,
      sym__ado_in,
    STATE(7123), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11956), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264277] = 5,
    ACTIONS(11962), 1,
      anon_sym_in,
    STATE(5375), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11960), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264296] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11964), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10028), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264317] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11966), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9348), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264338] = 5,
    ACTIONS(11962), 1,
      anon_sym_in,
    STATE(5325), 1,
      sym__ado_in,
    STATE(7113), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11968), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264357] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11970), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10027), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264378] = 5,
    ACTIONS(11974), 1,
      anon_sym_in,
    STATE(4992), 1,
      sym__ado_in,
    STATE(7125), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11972), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264397] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11976), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10036), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264418] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11978), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10029), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264439] = 4,
    ACTIONS(11980), 1,
      anon_sym_PIPE,
    STATE(7121), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2624), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [264456] = 4,
    ACTIONS(11983), 1,
      sym_string,
    ACTIONS(11985), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(5148), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264473] = 5,
    ACTIONS(11958), 1,
      anon_sym_in,
    STATE(2915), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11987), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264492] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11989), 1,
      anon_sym_RBRACE,
    STATE(7109), 1,
      aux_sym_row_type_repeat1,
    STATE(9361), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264513] = 5,
    ACTIONS(11974), 1,
      anon_sym_in,
    STATE(4979), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(11991), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264532] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(11993), 1,
      anon_sym_RPAREN,
    STATE(7115), 1,
      aux_sym_row_type_repeat1,
    STATE(9367), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264553] = 4,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    STATE(7121), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11995), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [264570] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [264583] = 4,
    ACTIONS(11997), 1,
      sym_string,
    ACTIONS(11999), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(5004), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264600] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12001), 1,
      anon_sym_RBRACE,
    STATE(7119), 1,
      aux_sym_row_type_repeat1,
    STATE(10026), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264621] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12003), 1,
      anon_sym_RPAREN,
    STATE(7120), 1,
      aux_sym_row_type_repeat1,
    STATE(10024), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264642] = 3,
    ACTIONS(10151), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10153), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [264657] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11645), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
  [264670] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12005), 1,
      anon_sym_RPAREN,
    STATE(7157), 1,
      aux_sym_row_type_repeat1,
    STATE(10083), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264691] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12007), 1,
      anon_sym_RBRACE,
    STATE(7167), 1,
      aux_sym_row_type_repeat1,
    STATE(10068), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264712] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12009), 1,
      anon_sym_RPAREN,
    STATE(7141), 1,
      aux_sym_row_type_repeat1,
    STATE(9993), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264733] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12011), 1,
      anon_sym_RBRACE,
    STATE(7147), 1,
      aux_sym_row_type_repeat1,
    STATE(9991), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264754] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [264767] = 4,
    ACTIONS(12013), 1,
      sym_string,
    ACTIONS(12015), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(5940), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264784] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
  [264797] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12017), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9984), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264818] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [264831] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12019), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9011), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264852] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12021), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9010), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264873] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12023), 1,
      anon_sym_RBRACE,
    STATE(7143), 1,
      aux_sym_row_type_repeat1,
    STATE(9008), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264894] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12025), 1,
      anon_sym_RPAREN,
    STATE(7144), 1,
      aux_sym_row_type_repeat1,
    STATE(9005), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264915] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12027), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9983), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264936] = 5,
    ACTIONS(12031), 1,
      anon_sym_in,
    STATE(6321), 1,
      sym__ado_in,
    STATE(7160), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12029), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264955] = 4,
    ACTIONS(12033), 1,
      sym_string,
    ACTIONS(12035), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(1799), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264972] = 5,
    ACTIONS(12039), 1,
      anon_sym_in,
    STATE(1874), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12037), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [264991] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12041), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8992), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265012] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12043), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8991), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265033] = 5,
    ACTIONS(12039), 1,
      anon_sym_in,
    STATE(1654), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12045), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265052] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [265065] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [265078] = 3,
    ACTIONS(11277), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11275), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [265093] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12047), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10045), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265114] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12049), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [265127] = 5,
    ACTIONS(12039), 1,
      anon_sym_in,
    STATE(1778), 1,
      sym__ado_in,
    STATE(7150), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12051), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265146] = 5,
    ACTIONS(12031), 1,
      anon_sym_in,
    STATE(6363), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12053), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265165] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12055), 1,
      anon_sym_RBRACE,
    STATE(7151), 1,
      aux_sym_row_type_repeat1,
    STATE(8989), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265186] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12057), 1,
      anon_sym_RPAREN,
    STATE(7152), 1,
      aux_sym_row_type_repeat1,
    STATE(8986), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265207] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12059), 1,
      anon_sym_RPAREN,
    STATE(7178), 1,
      aux_sym_row_type_repeat1,
    STATE(8959), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265228] = 5,
    ACTIONS(12039), 1,
      anon_sym_in,
    STATE(1642), 1,
      sym__ado_in,
    STATE(7153), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12061), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265247] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12063), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9982), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265268] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12065), 1,
      anon_sym_RBRACE,
    STATE(7181), 1,
      aux_sym_row_type_repeat1,
    STATE(8956), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265289] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12067), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10044), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265310] = 4,
    ACTIONS(12069), 1,
      sym_string,
    ACTIONS(12071), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(4721), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265327] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12073), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8973), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265348] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12075), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8972), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265369] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12077), 1,
      anon_sym_RBRACE,
    STATE(7169), 1,
      aux_sym_row_type_repeat1,
    STATE(8970), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265390] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12079), 1,
      anon_sym_RPAREN,
    STATE(7170), 1,
      aux_sym_row_type_repeat1,
    STATE(8967), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265411] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12081), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9981), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265432] = 4,
    ACTIONS(2616), 1,
      anon_sym_PIPE,
    STATE(7121), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2596), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [265449] = 3,
    ACTIONS(10896), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10898), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [265464] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12083), 1,
      anon_sym_RPAREN,
    STATE(7194), 1,
      aux_sym_row_type_repeat1,
    STATE(9953), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265485] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12085), 1,
      anon_sym_RBRACE,
    STATE(7196), 1,
      aux_sym_row_type_repeat1,
    STATE(9947), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265506] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12087), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8940), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265527] = 4,
    ACTIONS(12089), 1,
      sym_string,
    ACTIONS(12091), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(1718), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265544] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12093), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8954), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265565] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12095), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8939), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265586] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12097), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8953), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265607] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12099), 1,
      anon_sym_RBRACE,
    STATE(7180), 1,
      aux_sym_row_type_repeat1,
    STATE(8951), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265628] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12101), 1,
      anon_sym_RPAREN,
    STATE(7182), 1,
      aux_sym_row_type_repeat1,
    STATE(8948), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265649] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12103), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9419), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265670] = 3,
    ACTIONS(10892), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10894), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [265685] = 4,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    STATE(7353), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11847), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [265702] = 4,
    ACTIONS(12105), 1,
      sym_string,
    ACTIONS(12107), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2205), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265719] = 5,
    ACTIONS(11705), 1,
      anon_sym_in,
    STATE(4962), 1,
      sym__ado_in,
    STATE(7200), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12109), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265738] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12111), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9426), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265759] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12113), 1,
      anon_sym_RBRACE,
    STATE(7165), 1,
      aux_sym_row_type_repeat1,
    STATE(9971), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265780] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12115), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(10138), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265801] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12117), 1,
      anon_sym_RPAREN,
    STATE(7173), 1,
      aux_sym_row_type_repeat1,
    STATE(9968), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265822] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12119), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9945), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265843] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12121), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8935), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265864] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12123), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9944), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265885] = 3,
    ACTIONS(9182), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [265900] = 3,
    ACTIONS(10888), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10890), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [265915] = 3,
    ACTIONS(10553), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10555), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [265930] = 5,
    ACTIONS(11705), 1,
      anon_sym_in,
    STATE(5014), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12125), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265949] = 5,
    ACTIONS(12129), 1,
      anon_sym_in,
    STATE(2179), 1,
      sym__ado_in,
    STATE(7204), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12127), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265968] = 5,
    ACTIONS(12133), 1,
      anon_sym_in,
    STATE(1816), 1,
      sym__ado_in,
    STATE(7207), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12131), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [265987] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12135), 1,
      sym__immediate_dot,
    STATE(1841), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(12137), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266006] = 5,
    ACTIONS(12129), 1,
      anon_sym_in,
    STATE(2163), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12139), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266025] = 4,
    ACTIONS(12141), 1,
      sym_string,
    ACTIONS(12143), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(1627), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266042] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12049), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [266055] = 5,
    ACTIONS(12133), 1,
      anon_sym_in,
    STATE(1821), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12145), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266074] = 3,
    ACTIONS(10882), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10884), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266089] = 3,
    ACTIONS(10381), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10379), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [266104] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12147), 1,
      anon_sym_RBRACE,
    STATE(7185), 1,
      aux_sym_row_type_repeat1,
    STATE(9444), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266125] = 5,
    ACTIONS(12151), 1,
      anon_sym_in,
    STATE(5761), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12149), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266144] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12153), 1,
      anon_sym_RPAREN,
    STATE(6951), 1,
      aux_sym_row_type_repeat1,
    STATE(9203), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266165] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12155), 1,
      anon_sym_RPAREN,
    STATE(7190), 1,
      aux_sym_row_type_repeat1,
    STATE(9449), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266186] = 3,
    ACTIONS(9254), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9252), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266201] = 5,
    ACTIONS(12151), 1,
      anon_sym_in,
    STATE(5753), 1,
      sym__ado_in,
    STATE(7211), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12157), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266220] = 3,
    ACTIONS(10874), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10876), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266235] = 3,
    ACTIONS(9182), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9180), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266250] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12159), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9929), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266271] = 3,
    ACTIONS(10866), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10868), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266286] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12161), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8934), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266307] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12163), 1,
      anon_sym_RBRACE,
    STATE(7195), 1,
      aux_sym_row_type_repeat1,
    STATE(8932), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266328] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12165), 1,
      anon_sym_RPAREN,
    STATE(7220), 1,
      aux_sym_row_type_repeat1,
    STATE(8929), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266349] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
  [266362] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12167), 1,
      anon_sym_RPAREN,
    STATE(7236), 1,
      aux_sym_row_type_repeat1,
    STATE(9888), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266383] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12169), 1,
      anon_sym_RBRACE,
    STATE(6939), 1,
      aux_sym_row_type_repeat1,
    STATE(9902), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266404] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12171), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9928), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266425] = 4,
    ACTIONS(12173), 1,
      sym_string,
    ACTIONS(12175), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(5346), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266442] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12177), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8916), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266463] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12179), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8915), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266484] = 3,
    ACTIONS(9246), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9244), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266499] = 5,
    ACTIONS(12183), 1,
      anon_sym_in,
    STATE(2794), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12181), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266518] = 3,
    ACTIONS(10856), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10858), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266533] = 3,
    ACTIONS(9234), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9232), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266548] = 3,
    ACTIONS(9178), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9176), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266563] = 3,
    ACTIONS(9174), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9172), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266578] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12185), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9897), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266599] = 5,
    ACTIONS(12189), 1,
      anon_sym_in,
    STATE(6759), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12187), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266618] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12191), 1,
      anon_sym_RBRACE,
    STATE(7228), 1,
      aux_sym_row_type_repeat1,
    STATE(8913), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266639] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12193), 1,
      anon_sym_RPAREN,
    STATE(7229), 1,
      aux_sym_row_type_repeat1,
    STATE(8910), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266660] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12195), 1,
      anon_sym_RPAREN,
    STATE(7255), 1,
      aux_sym_row_type_repeat1,
    STATE(8883), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266681] = 5,
    ACTIONS(12151), 1,
      anon_sym_in,
    STATE(5200), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12197), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266700] = 4,
    ACTIONS(12199), 1,
      sym_string,
    ACTIONS(12201), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(5015), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266717] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12203), 1,
      anon_sym_RBRACE,
    STATE(7258), 1,
      aux_sym_row_type_repeat1,
    STATE(8880), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266738] = 5,
    ACTIONS(12207), 1,
      anon_sym_in,
    STATE(5635), 1,
      sym__ado_in,
    STATE(7252), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12205), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266757] = 4,
    ACTIONS(12209), 1,
      sym_string,
    ACTIONS(12211), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2530), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266774] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12213), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8897), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266795] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12215), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8896), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266816] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12217), 1,
      anon_sym_RBRACE,
    STATE(7246), 1,
      aux_sym_row_type_repeat1,
    STATE(8894), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266837] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12219), 1,
      anon_sym_RPAREN,
    STATE(7247), 1,
      aux_sym_row_type_repeat1,
    STATE(8891), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266858] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12221), 1,
      anon_sym_RBRACE,
    STATE(7218), 1,
      aux_sym_row_type_repeat1,
    STATE(9921), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266879] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12223), 1,
      anon_sym_RPAREN,
    STATE(7226), 1,
      aux_sym_row_type_repeat1,
    STATE(9909), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266900] = 5,
    ACTIONS(12207), 1,
      anon_sym_in,
    STATE(5609), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12225), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266919] = 3,
    ACTIONS(9129), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9127), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266934] = 5,
    ACTIONS(12151), 1,
      anon_sym_in,
    STATE(5207), 1,
      sym__ado_in,
    STATE(7241), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12227), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266953] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12229), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8866), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [266974] = 3,
    ACTIONS(9230), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9228), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [266989] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12231), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8878), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267010] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12233), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8861), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267031] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12235), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8877), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267052] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12237), 1,
      anon_sym_RBRACE,
    STATE(7257), 1,
      aux_sym_row_type_repeat1,
    STATE(8875), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267073] = 3,
    ACTIONS(9258), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9256), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267088] = 3,
    ACTIONS(10852), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10854), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267103] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12239), 1,
      anon_sym_RPAREN,
    STATE(7259), 1,
      aux_sym_row_type_repeat1,
    STATE(8872), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267124] = 3,
    ACTIONS(9250), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9248), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267139] = 5,
    ACTIONS(12243), 1,
      anon_sym_in,
    STATE(2584), 1,
      sym__ado_in,
    STATE(7275), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12241), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267158] = 5,
    ACTIONS(12247), 1,
      anon_sym_in,
    STATE(2258), 1,
      sym__ado_in,
    STATE(7348), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12245), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267177] = 3,
    ACTIONS(9238), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9236), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267192] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
  [267205] = 3,
    ACTIONS(9140), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9138), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267220] = 3,
    ACTIONS(9150), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9148), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267235] = 3,
    ACTIONS(10848), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10850), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267250] = 3,
    ACTIONS(9154), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9152), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267265] = 3,
    ACTIONS(9158), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9156), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267280] = 3,
    ACTIONS(9242), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9240), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267295] = 5,
    ACTIONS(12243), 1,
      anon_sym_in,
    STATE(2571), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12249), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267314] = 6,
    ACTIONS(5823), 1,
      sym__varid,
    ACTIONS(11887), 1,
      anon_sym_LPAREN,
    ACTIONS(12251), 1,
      anon_sym_data,
    STATE(7711), 1,
      sym__fun_name,
    STATE(8697), 1,
      sym_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267335] = 3,
    ACTIONS(10840), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10842), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267350] = 4,
    STATE(6293), 1,
      aux_sym_type_role_declaration_repeat1,
    STATE(6853), 1,
      sym__role,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11314), 3,
      anon_sym_nominal,
      anon_sym_representational,
      anon_sym_phantom,
  [267367] = 3,
    ACTIONS(9166), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9164), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [267382] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7658), 3,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
  [267399] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12253), 1,
      anon_sym_RBRACE,
    STATE(7308), 1,
      aux_sym_row_type_repeat1,
    STATE(9966), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267420] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12255), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9513), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267441] = 5,
    ACTIONS(12259), 1,
      anon_sym_in,
    STATE(5884), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12257), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267460] = 4,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    STATE(7353), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2622), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [267477] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12261), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9520), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267498] = 4,
    ACTIONS(12263), 1,
      sym_string,
    ACTIONS(12265), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(6294), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267515] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12135), 1,
      sym__immediate_dot,
    STATE(1841), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(10968), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267534] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12267), 1,
      anon_sym_RPAREN,
    STATE(7295), 1,
      aux_sym_row_type_repeat1,
    STATE(9861), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267555] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12269), 1,
      anon_sym_RBRACE,
    STATE(7301), 1,
      aux_sym_row_type_repeat1,
    STATE(9857), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267576] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12271), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8859), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267597] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12273), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8858), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267618] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12275), 1,
      anon_sym_RBRACE,
    STATE(7290), 1,
      aux_sym_row_type_repeat1,
    STATE(8856), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267639] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12277), 1,
      anon_sym_RPAREN,
    STATE(7291), 1,
      aux_sym_row_type_repeat1,
    STATE(8853), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267660] = 4,
    ACTIONS(12279), 1,
      sym_string,
    ACTIONS(12281), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(5008), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267677] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12283), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9855), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267698] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12285), 1,
      anon_sym_RBRACE,
    STATE(7282), 1,
      aux_sym_row_type_repeat1,
    STATE(9532), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267719] = 5,
    ACTIONS(12259), 1,
      anon_sym_in,
    STATE(5894), 1,
      sym__ado_in,
    STATE(7283), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12287), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267738] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12289), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8840), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267759] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12291), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8839), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267780] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12293), 1,
      anon_sym_RBRACE,
    STATE(7298), 1,
      aux_sym_row_type_repeat1,
    STATE(8837), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267801] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12295), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9852), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267822] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12297), 1,
      anon_sym_RPAREN,
    STATE(7285), 1,
      aux_sym_row_type_repeat1,
    STATE(9538), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267843] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12299), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9860), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267864] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(11663), 1,
      sym__immediate_dot,
    STATE(2139), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(12301), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267883] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12303), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9856), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267904] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12305), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9952), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267925] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
  [267938] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12307), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9948), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267959] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12309), 1,
      anon_sym_RPAREN,
    STATE(7299), 1,
      aux_sym_row_type_repeat1,
    STATE(8834), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [267980] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12311), 1,
      anon_sym_RPAREN,
    STATE(7325), 1,
      aux_sym_row_type_repeat1,
    STATE(9834), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268001] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12313), 1,
      anon_sym_RPAREN,
    STATE(7326), 1,
      aux_sym_row_type_repeat1,
    STATE(8807), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268022] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12315), 1,
      anon_sym_RBRACE,
    STATE(7335), 1,
      aux_sym_row_type_repeat1,
    STATE(9830), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268043] = 4,
    ACTIONS(12317), 1,
      sym_string,
    ACTIONS(12319), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(5710), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268060] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12321), 1,
      anon_sym_RBRACE,
    STATE(7329), 1,
      aux_sym_row_type_repeat1,
    STATE(8801), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268081] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12323), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8821), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268102] = 4,
    ACTIONS(12325), 1,
      sym_string,
    ACTIONS(12327), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2324), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268119] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12329), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8820), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268140] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12331), 1,
      anon_sym_RBRACE,
    STATE(7315), 1,
      aux_sym_row_type_repeat1,
    STATE(8818), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268161] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12333), 1,
      anon_sym_RPAREN,
    STATE(7317), 1,
      aux_sym_row_type_repeat1,
    STATE(8815), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268182] = 3,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [268197] = 3,
    ACTIONS(10383), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9197), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [268212] = 3,
    ACTIONS(10371), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [268227] = 3,
    ACTIONS(10359), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [268242] = 3,
    ACTIONS(10357), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [268257] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12335), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9827), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268278] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12337), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8792), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268299] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12339), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8803), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268320] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12341), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8802), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268341] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12343), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8790), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268362] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12345), 1,
      anon_sym_RBRACE,
    STATE(7327), 1,
      aux_sym_row_type_repeat1,
    STATE(8800), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268383] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12347), 1,
      anon_sym_RPAREN,
    STATE(7328), 1,
      aux_sym_row_type_repeat1,
    STATE(8798), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268404] = 3,
    ACTIONS(10900), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10902), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [268419] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12349), 1,
      anon_sym_RBRACE,
    STATE(7303), 1,
      aux_sym_row_type_repeat1,
    STATE(9850), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268440] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3277), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
      anon_sym_in,
  [268453] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12351), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9825), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268474] = 5,
    ACTIONS(12355), 1,
      anon_sym_in,
    STATE(2350), 1,
      sym__ado_in,
    STATE(7346), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12353), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268493] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7840), 3,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
  [268510] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12357), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8788), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268531] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12359), 1,
      anon_sym_RPAREN,
    STATE(7305), 1,
      aux_sym_row_type_repeat1,
    STATE(9898), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268552] = 4,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9849), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
  [268569] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12361), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8787), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268590] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7857), 3,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
  [268607] = 5,
    ACTIONS(12365), 1,
      anon_sym_in,
    STATE(6649), 1,
      sym__ado_in,
    STATE(7349), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12363), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268626] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7866), 3,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
  [268643] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3461), 5,
      sym__layout_semicolon,
      anon_sym_SEMI,
      sym__operator,
      sym__conid,
      anon_sym_in,
  [268656] = 5,
    ACTIONS(12355), 1,
      anon_sym_in,
    STATE(2363), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12367), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268675] = 4,
    ACTIONS(12371), 1,
      sym_where,
    STATE(8268), 1,
      sym_class_body,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12369), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [268692] = 5,
    ACTIONS(12247), 1,
      anon_sym_in,
    STATE(2230), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12373), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268711] = 5,
    ACTIONS(12365), 1,
      anon_sym_in,
    STATE(6601), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12375), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268730] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12377), 1,
      anon_sym_RPAREN,
    STATE(7354), 1,
      aux_sym_row_type_repeat1,
    STATE(9801), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268751] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12379), 1,
      anon_sym_RBRACE,
    STATE(7338), 1,
      aux_sym_row_type_repeat1,
    STATE(8786), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268772] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12381), 1,
      anon_sym_RBRACE,
    STATE(7355), 1,
      aux_sym_row_type_repeat1,
    STATE(9799), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268793] = 4,
    ACTIONS(12383), 1,
      anon_sym_PIPE,
    STATE(7353), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2624), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [268810] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12386), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9783), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268831] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12388), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9782), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268852] = 4,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    STATE(7353), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11995), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [268869] = 5,
    ACTIONS(12392), 1,
      anon_sym_in,
    STATE(1936), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12390), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268888] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12394), 1,
      anon_sym_RBRACE,
    STATE(7371), 1,
      aux_sym_row_type_repeat1,
    STATE(9526), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268909] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7916), 3,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
  [268926] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12396), 1,
      anon_sym_RPAREN,
    STATE(7389), 1,
      aux_sym_row_type_repeat1,
    STATE(9903), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268947] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12398), 1,
      anon_sym_RPAREN,
    STATE(7341), 1,
      aux_sym_row_type_repeat1,
    STATE(8784), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [268968] = 3,
    ACTIONS(10878), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10880), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [268983] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    ACTIONS(10679), 1,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(7950), 3,
      sym_type_variable,
      sym__visible_type_variable,
      sym__tyvar_no_annotation,
  [269000] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12400), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8774), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269021] = 5,
    ACTIONS(12392), 1,
      anon_sym_in,
    STATE(1948), 1,
      sym__ado_in,
    STATE(7357), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12402), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269040] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12404), 1,
      anon_sym_RBRACE,
    STATE(7390), 1,
      aux_sym_row_type_repeat1,
    STATE(9900), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269061] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12406), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8773), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269082] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12408), 1,
      anon_sym_RBRACE,
    STATE(7364), 1,
      aux_sym_row_type_repeat1,
    STATE(8771), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269103] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12410), 1,
      anon_sym_RPAREN,
    STATE(7367), 1,
      aux_sym_row_type_repeat1,
    STATE(8769), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269124] = 4,
    ACTIONS(12412), 1,
      sym_string,
    ACTIONS(12414), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2673), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269141] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12416), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9604), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269162] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12418), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9774), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269183] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12420), 1,
      anon_sym_RPAREN,
    STATE(7379), 1,
      aux_sym_row_type_repeat1,
    STATE(9745), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269204] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12422), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9606), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269225] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12424), 1,
      anon_sym_RBRACE,
    STATE(7387), 1,
      aux_sym_row_type_repeat1,
    STATE(9742), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269246] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12426), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9724), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269267] = 3,
    ACTIONS(8106), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8104), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [269282] = 5,
    ACTIONS(11549), 1,
      anon_sym_RPAREN,
    STATE(1221), 1,
      sym__colon2,
    STATE(8557), 1,
      sym__type_annotation,
    ACTIONS(12428), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269301] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12430), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9736), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269322] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12432), 1,
      anon_sym_RPAREN,
    STATE(7395), 1,
      aux_sym_row_type_repeat1,
    STATE(8831), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269343] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12434), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8758), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269364] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12436), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8757), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269385] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12438), 1,
      anon_sym_RBRACE,
    STATE(7398), 1,
      aux_sym_row_type_repeat1,
    STATE(8812), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269406] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12440), 1,
      anon_sym_RBRACE,
    STATE(7381), 1,
      aux_sym_row_type_repeat1,
    STATE(8755), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269427] = 4,
    ACTIONS(12442), 1,
      sym_string,
    ACTIONS(12444), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(5263), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269444] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12446), 1,
      anon_sym_RPAREN,
    STATE(7382), 1,
      aux_sym_row_type_repeat1,
    STATE(8752), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269465] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12448), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9735), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269486] = 4,
    ACTIONS(11671), 1,
      sym_where,
    STATE(8375), 1,
      sym_class_body,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12369), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [269503] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12450), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9892), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269524] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12452), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9891), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269545] = 4,
    ACTIONS(12454), 1,
      sym_string,
    ACTIONS(12456), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2368), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269562] = 4,
    ACTIONS(12458), 1,
      sym_string,
    ACTIONS(12460), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(1943), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269579] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12462), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8742), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269600] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12464), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9441), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269621] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12466), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8914), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269642] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12468), 1,
      anon_sym_RBRACE,
    STATE(7393), 1,
      aux_sym_row_type_repeat1,
    STATE(8835), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269663] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12470), 1,
      anon_sym_RPAREN,
    STATE(7394), 1,
      aux_sym_row_type_repeat1,
    STATE(8847), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269684] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12472), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8937), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269705] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12474), 1,
      anon_sym_RPAREN,
    STATE(7495), 1,
      aux_sym_row_type_repeat1,
    STATE(9768), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269726] = 4,
    ACTIONS(12371), 1,
      sym_where,
    STATE(8466), 1,
      sym_class_body,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11669), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [269743] = 3,
    ACTIONS(10870), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10872), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [269758] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12476), 1,
      anon_sym_RPAREN,
    STATE(7306), 1,
      aux_sym_row_type_repeat1,
    STATE(9977), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269779] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12478), 1,
      anon_sym_RBRACE,
    STATE(7372), 1,
      aux_sym_row_type_repeat1,
    STATE(9752), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269800] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12480), 1,
      anon_sym_RPAREN,
    STATE(7412), 1,
      aux_sym_row_type_repeat1,
    STATE(9706), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269821] = 5,
    ACTIONS(12484), 1,
      anon_sym_in,
    STATE(5830), 1,
      sym__ado_in,
    STATE(7415), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12482), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269840] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12486), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8923), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269861] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12488), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(8926), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269882] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12490), 1,
      anon_sym_RPAREN,
    STATE(7374), 1,
      aux_sym_row_type_repeat1,
    STATE(9644), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269903] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12492), 1,
      anon_sym_RPAREN,
    STATE(7376), 1,
      aux_sym_row_type_repeat1,
    STATE(9738), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269924] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12494), 1,
      anon_sym_RBRACE,
    STATE(7406), 1,
      aux_sym_row_type_repeat1,
    STATE(8942), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269945] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12496), 1,
      anon_sym_RBRACE,
    STATE(7421), 1,
      aux_sym_row_type_repeat1,
    STATE(9698), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269966] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12498), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9695), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [269987] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11645), 5,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [270000] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [270013] = 5,
    ACTIONS(12484), 1,
      anon_sym_in,
    STATE(5917), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12500), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270032] = 3,
    ACTIONS(10429), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10432), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [270047] = 3,
    ACTIONS(10862), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10864), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [270062] = 3,
    ACTIONS(10369), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10367), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270077] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [270090] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [270103] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12502), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9694), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270124] = 4,
    ACTIONS(12506), 1,
      sym_comma,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12504), 3,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [270141] = 5,
    ACTIONS(12511), 1,
      anon_sym_in,
    STATE(2604), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12509), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270160] = 3,
    ACTIONS(10375), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10373), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270175] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12513), 1,
      anon_sym_RPAREN,
    STATE(7427), 1,
      aux_sym_row_type_repeat1,
    STATE(9654), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270196] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12515), 1,
      anon_sym_RBRACE,
    STATE(7430), 1,
      aux_sym_row_type_repeat1,
    STATE(9642), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270217] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12517), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9641), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270238] = 3,
    ACTIONS(10377), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10285), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270253] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12519), 1,
      anon_sym_RPAREN,
    STATE(7407), 1,
      aux_sym_row_type_repeat1,
    STATE(8949), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270274] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12521), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9640), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270295] = 3,
    ACTIONS(10327), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10325), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270310] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12523), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9006), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270331] = 3,
    ACTIONS(10331), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10329), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270346] = 3,
    ACTIONS(10347), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10345), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270361] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12525), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9014), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270382] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12527), 1,
      anon_sym_RBRACE,
    STATE(7432), 1,
      aux_sym_row_type_repeat1,
    STATE(9024), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270403] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12529), 1,
      anon_sym_RPAREN,
    STATE(7435), 1,
      aux_sym_row_type_repeat1,
    STATE(8994), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270424] = 3,
    ACTIONS(9222), 2,
      anon_sym_RPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9220), 3,
      sym__operator,
      anon_sym_DASH,
      anon_sym_BQUOTE,
  [270439] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [270452] = 5,
    ACTIONS(12133), 1,
      anon_sym_in,
    STATE(2127), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12531), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270471] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [270484] = 3,
    ACTIONS(10314), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10306), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270499] = 3,
    ACTIONS(10371), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9199), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270514] = 3,
    ACTIONS(10351), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10349), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270529] = 3,
    ACTIONS(10359), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8894), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270544] = 3,
    ACTIONS(10363), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10361), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270559] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12533), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9096), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270580] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12535), 1,
      anon_sym_RPAREN,
    STATE(7463), 1,
      aux_sym_row_type_repeat1,
    STATE(9225), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270601] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12537), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9099), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270622] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12539), 1,
      anon_sym_RBRACE,
    STATE(7447), 1,
      aux_sym_row_type_repeat1,
    STATE(9104), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270643] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12541), 1,
      anon_sym_RBRACE,
    STATE(7466), 1,
      aux_sym_row_type_repeat1,
    STATE(9254), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270664] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12543), 1,
      anon_sym_RPAREN,
    STATE(7449), 1,
      aux_sym_row_type_repeat1,
    STATE(9140), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270685] = 4,
    ACTIONS(12545), 1,
      sym_string,
    ACTIONS(12547), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(5159), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270702] = 3,
    ACTIONS(10357), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9260), 4,
      sym__operator,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_EQ,
  [270717] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12549), 1,
      anon_sym_RPAREN,
    STATE(7529), 1,
      aux_sym_row_type_repeat1,
    STATE(9804), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270738] = 5,
    ACTIONS(12133), 1,
      anon_sym_in,
    STATE(2151), 1,
      sym__ado_in,
    STATE(7440), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12551), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270757] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12553), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9194), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270778] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12555), 1,
      anon_sym_RBRACE,
    STATE(7526), 1,
      aux_sym_row_type_repeat1,
    STATE(9794), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270799] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12557), 1,
      anon_sym_RPAREN,
    STATE(7468), 1,
      aux_sym_row_type_repeat1,
    STATE(9612), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270820] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12559), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9630), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270841] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12561), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9195), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270862] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12563), 1,
      anon_sym_RBRACE,
    STATE(7457), 1,
      aux_sym_row_type_repeat1,
    STATE(9215), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270883] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12565), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9284), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270904] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12567), 1,
      anon_sym_RPAREN,
    STATE(7461), 1,
      aux_sym_row_type_repeat1,
    STATE(9230), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270925] = 5,
    ACTIONS(12571), 1,
      anon_sym_in,
    STATE(2547), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12569), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270944] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12573), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9309), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270965] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12575), 1,
      anon_sym_RBRACE,
    STATE(7470), 1,
      aux_sym_row_type_repeat1,
    STATE(9597), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [270986] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12577), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9591), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271007] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12579), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9628), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271028] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12581), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9589), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271049] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12583), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9276), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271070] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12585), 1,
      anon_sym_RPAREN,
    STATE(7496), 1,
      aux_sym_row_type_repeat1,
    STATE(9765), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271091] = 5,
    ACTIONS(12589), 1,
      anon_sym_in,
    STATE(5618), 1,
      sym__ado_in,
    STATE(7483), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12587), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271110] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12591), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9279), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271131] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12593), 1,
      anon_sym_RBRACE,
    STATE(7471), 1,
      aux_sym_row_type_repeat1,
    STATE(9300), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271152] = 5,
    ACTIONS(12183), 1,
      anon_sym_in,
    STATE(2817), 1,
      sym__ado_in,
    STATE(7231), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12595), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271171] = 4,
    ACTIONS(12597), 1,
      sym_string,
    ACTIONS(12599), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(1838), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271188] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12601), 1,
      anon_sym_RPAREN,
    STATE(7474), 1,
      aux_sym_row_type_repeat1,
    STATE(9315), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271209] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12603), 1,
      anon_sym_RBRACE,
    STATE(7502), 1,
      aux_sym_row_type_repeat1,
    STATE(9844), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271230] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12605), 1,
      anon_sym_RBRACE,
    STATE(7460), 1,
      aux_sym_row_type_repeat1,
    STATE(9732), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271251] = 5,
    ACTIONS(12571), 1,
      anon_sym_in,
    STATE(2643), 1,
      sym__ado_in,
    STATE(7465), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12607), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271270] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12609), 1,
      anon_sym_RPAREN,
    STATE(7487), 1,
      aux_sym_row_type_repeat1,
    STATE(9547), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271291] = 5,
    ACTIONS(12589), 1,
      anon_sym_in,
    STATE(5625), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12611), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271310] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12613), 1,
      anon_sym_RBRACE,
    STATE(7488), 1,
      aux_sym_row_type_repeat1,
    STATE(9537), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271331] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [271344] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12615), 1,
      anon_sym_RPAREN,
    STATE(7469), 1,
      aux_sym_row_type_repeat1,
    STATE(9587), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271365] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12617), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9529), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271386] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12619), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9527), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271407] = 4,
    ACTIONS(12621), 1,
      sym_string,
    ACTIONS(12623), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2188), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271424] = 6,
    ACTIONS(11661), 1,
      sym__conid,
    STATE(7755), 1,
      aux_sym__qualifying_module,
    STATE(8080), 1,
      sym__modid,
    STATE(8467), 1,
      sym_constructor,
    STATE(8665), 1,
      sym_qualified_module,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271445] = 5,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(12625), 1,
      anon_sym_LPAREN,
    STATE(8664), 1,
      sym_export_names,
    ACTIONS(12627), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271464] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12629), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9704), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271485] = 4,
    ACTIONS(2588), 1,
      anon_sym_PIPE,
    STATE(7353), 1,
      aux_sym_decl_data_repeat2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(2596), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [271502] = 6,
    ACTIONS(10981), 1,
      sym__operator,
    ACTIONS(11396), 1,
      sym__conid,
    STATE(7494), 1,
      aux_sym__qualifying_module,
    STATE(9889), 1,
      sym__modid,
    STATE(10103), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271523] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12631), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9712), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271544] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12633), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9826), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271565] = 4,
    ACTIONS(12635), 1,
      sym_string,
    ACTIONS(12637), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2888), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271582] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12639), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9340), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271603] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12641), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9344), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271624] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12643), 1,
      anon_sym_RBRACE,
    STATE(7498), 1,
      aux_sym_row_type_repeat1,
    STATE(9349), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271645] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12645), 1,
      anon_sym_RPAREN,
    STATE(7505), 1,
      aux_sym_row_type_repeat1,
    STATE(9500), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271666] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12647), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9824), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271687] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12649), 1,
      anon_sym_RPAREN,
    STATE(7499), 1,
      aux_sym_row_type_repeat1,
    STATE(9351), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271708] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12651), 1,
      anon_sym_RBRACE,
    STATE(7508), 1,
      aux_sym_row_type_repeat1,
    STATE(9495), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271729] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12653), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9494), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271750] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12655), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9371), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271771] = 3,
    ACTIONS(11277), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11275), 4,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
      anon_sym_DASH,
  [271786] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12657), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9493), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271807] = 5,
    ACTIONS(12661), 1,
      anon_sym_in,
    STATE(2062), 1,
      sym__ado_in,
    STATE(7518), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12659), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271826] = 4,
    ACTIONS(12663), 1,
      sym_string,
    ACTIONS(12665), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(2603), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271843] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12049), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [271856] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12667), 1,
      anon_sym_RBRACE,
    STATE(7492), 1,
      aux_sym_row_type_repeat1,
    STATE(9756), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271877] = 4,
    ACTIONS(67), 1,
      sym__operator,
    ACTIONS(1882), 1,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    STATE(9664), 3,
      sym_operator,
      sym__minus,
      sym__operator_or_minus,
  [271894] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12669), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9372), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271915] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12671), 1,
      anon_sym_RBRACE,
    STATE(7506), 1,
      aux_sym_row_type_repeat1,
    STATE(9373), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271936] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12673), 1,
      anon_sym_RPAREN,
    STATE(7528), 1,
      aux_sym_row_type_repeat1,
    STATE(9436), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271957] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12675), 1,
      anon_sym_RPAREN,
    STATE(7514), 1,
      aux_sym_row_type_repeat1,
    STATE(9249), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271978] = 5,
    ACTIONS(12661), 1,
      anon_sym_in,
    STATE(2025), 1,
      sym__ado_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12677), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [271997] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12679), 1,
      anon_sym_RBRACE,
    STATE(7531), 1,
      aux_sym_row_type_repeat1,
    STATE(9442), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272018] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10856), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [272031] = 4,
    ACTIONS(12681), 1,
      sym_string,
    ACTIONS(12683), 2,
      sym_triple_quote_string,
      sym__immediate_varid,
    STATE(6671), 2,
      sym__immediate_variable,
      sym__record_access_field,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272048] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12685), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9411), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272069] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12687), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9412), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272090] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12689), 1,
      anon_sym_RBRACE,
    STATE(7522), 1,
      aux_sym_row_type_repeat1,
    STATE(9418), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272111] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12691), 1,
      anon_sym_RPAREN,
    STATE(7523), 1,
      aux_sym_row_type_repeat1,
    STATE(9421), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272132] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12693), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9669), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272153] = 4,
    ACTIONS(12695), 1,
      sym__varid,
    ACTIONS(11323), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    STATE(7527), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272170] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12698), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9467), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272191] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12700), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9678), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272212] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12702), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9443), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272233] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12704), 1,
      anon_sym_RBRACE,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9478), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272254] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12706), 1,
      anon_sym_RPAREN,
    STATE(7422), 1,
      aux_sym_row_type_repeat1,
    STATE(9448), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272275] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12708), 1,
      anon_sym_RBRACE,
    STATE(7530), 1,
      aux_sym_row_type_repeat1,
    STATE(9450), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272296] = 5,
    ACTIONS(12511), 1,
      anon_sym_in,
    STATE(2600), 1,
      sym__ado_in,
    STATE(7423), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12710), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272315] = 6,
    ACTIONS(11045), 1,
      anon_sym_PIPE,
    ACTIONS(11675), 1,
      sym_comma,
    ACTIONS(12712), 1,
      anon_sym_RPAREN,
    STATE(7532), 1,
      aux_sym_row_type_repeat1,
    STATE(9456), 1,
      sym__row_variable,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272336] = 5,
    ACTIONS(12189), 1,
      anon_sym_in,
    STATE(6765), 1,
      sym__ado_in,
    STATE(7237), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12714), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272355] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [272368] = 5,
    ACTIONS(12716), 1,
      sym__conid,
    STATE(3893), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272386] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    STATE(7413), 1,
      sym_fundep,
    STATE(6882), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272402] = 4,
    ACTIONS(12720), 1,
      sym__layout_end,
    STATE(7548), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12718), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272418] = 5,
    ACTIONS(12722), 1,
      sym__conid,
    STATE(3364), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272436] = 3,
    ACTIONS(12726), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12724), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [272450] = 3,
    ACTIONS(10976), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(10981), 2,
      sym__consym,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272464] = 5,
    ACTIONS(11901), 1,
      sym__conid,
    STATE(3376), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272482] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(12730), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272500] = 5,
    ACTIONS(12732), 1,
      sym__conid,
    STATE(3092), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272518] = 5,
    ACTIONS(12734), 1,
      sym__conid,
    STATE(6170), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272536] = 4,
    ACTIONS(367), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12736), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272552] = 4,
    ACTIONS(1157), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12738), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272568] = 4,
    ACTIONS(3226), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(12740), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272584] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12742), 4,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
  [272596] = 4,
    ACTIONS(12746), 1,
      sym__layout_end,
    STATE(7549), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12744), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272612] = 4,
    ACTIONS(1094), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12748), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272628] = 4,
    ACTIONS(12752), 1,
      sym__layout_end,
    STATE(7557), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12750), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272644] = 4,
    ACTIONS(12756), 1,
      sym__layout_end,
    STATE(7550), 1,
      aux_sym_alts_repeat1,
    ACTIONS(12754), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272660] = 5,
    ACTIONS(12758), 1,
      sym__conid,
    STATE(2580), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272678] = 4,
    ACTIONS(1112), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12760), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272694] = 4,
    ACTIONS(379), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12762), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272710] = 5,
    ACTIONS(12764), 1,
      sym__conid,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(6832), 1,
      sym_constructor,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272728] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10582), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [272740] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(12766), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272758] = 3,
    ACTIONS(3277), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_EQ,
  [272772] = 4,
    ACTIONS(12770), 1,
      sym__layout_end,
    STATE(7660), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(12768), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272788] = 4,
    ACTIONS(12774), 1,
      sym__layout_end,
    STATE(7558), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12772), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272804] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(12778), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272822] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12780), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_as,
  [272834] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12782), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [272848] = 5,
    ACTIONS(12784), 1,
      sym__conid,
    STATE(4220), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272866] = 5,
    ACTIONS(12786), 1,
      sym__conid,
    STATE(3289), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272884] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12788), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [272898] = 5,
    ACTIONS(11901), 1,
      sym__conid,
    STATE(6696), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(7666), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272916] = 5,
    ACTIONS(12790), 1,
      sym__conid,
    STATE(3406), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272934] = 5,
    ACTIONS(12792), 1,
      sym__conid,
    STATE(4243), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272952] = 3,
    ACTIONS(12796), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12794), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [272966] = 5,
    ACTIONS(12798), 1,
      sym__conid,
    STATE(2403), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [272984] = 4,
    STATE(1101), 1,
      sym__colon2,
    STATE(8418), 1,
      sym__type_annotation,
    ACTIONS(12800), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273000] = 4,
    ACTIONS(12625), 1,
      anon_sym_LPAREN,
    STATE(8657), 1,
      sym_export_names,
    ACTIONS(12802), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273016] = 4,
    ACTIONS(12806), 1,
      sym__layout_end,
    STATE(7669), 1,
      aux_sym_purescript_repeat1,
    ACTIONS(12804), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273032] = 5,
    ACTIONS(12808), 1,
      sym__conid,
    STATE(3300), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273050] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11653), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [273062] = 5,
    ACTIONS(11901), 1,
      sym__conid,
    STATE(6696), 1,
      sym_constructor,
    STATE(7570), 1,
      sym__modid,
    STATE(7571), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273080] = 4,
    ACTIONS(1136), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12810), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273096] = 4,
    ACTIONS(10972), 1,
      sym__layout_end,
    STATE(7721), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(12812), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273112] = 4,
    ACTIONS(12816), 1,
      anon_sym_in,
    STATE(7737), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(12814), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273128] = 4,
    ACTIONS(12820), 1,
      sym__layout_end,
    STATE(7582), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12818), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273144] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12822), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [273156] = 4,
    ACTIONS(12826), 1,
      sym__layout_end,
    STATE(7600), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12824), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273172] = 4,
    ACTIONS(335), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12828), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273188] = 4,
    ACTIONS(12832), 1,
      sym__layout_end,
    STATE(7743), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12830), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273204] = 5,
    ACTIONS(11901), 1,
      sym__conid,
    STATE(6696), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(7567), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273222] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12834), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [273236] = 5,
    ACTIONS(12836), 1,
      sym__conid,
    STATE(3534), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273254] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(12838), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273272] = 4,
    ACTIONS(12840), 1,
      anon_sym_LPAREN,
    STATE(8666), 1,
      sym_import_con_names,
    ACTIONS(12842), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273288] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12844), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_as,
  [273300] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10604), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [273312] = 3,
    ACTIONS(12848), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12846), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [273326] = 4,
    ACTIONS(12852), 1,
      sym__layout_end,
    STATE(7588), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12850), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273342] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(12854), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273360] = 4,
    ACTIONS(349), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12856), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273376] = 5,
    ACTIONS(12858), 1,
      sym__conid,
    STATE(5513), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273394] = 3,
    ACTIONS(12862), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12860), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [273408] = 4,
    ACTIONS(12866), 1,
      sym__layout_end,
    STATE(7607), 1,
      aux_sym_alts_repeat1,
    ACTIONS(12864), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273424] = 5,
    ACTIONS(12868), 1,
      sym__conid,
    STATE(3097), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273442] = 4,
    ACTIONS(12872), 1,
      sym__layout_end,
    STATE(7553), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12870), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273458] = 4,
    ACTIONS(12876), 1,
      sym__layout_end,
    STATE(7614), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12874), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273474] = 4,
    ACTIONS(3076), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(12878), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273490] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10559), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [273502] = 5,
    ACTIONS(12880), 1,
      sym__conid,
    STATE(5034), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273520] = 5,
    ACTIONS(12882), 1,
      sym__conid,
    STATE(4355), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273538] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(12884), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273556] = 3,
    ACTIONS(12888), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12886), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [273570] = 4,
    ACTIONS(12892), 1,
      sym__layout_end,
    STATE(7648), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12890), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273586] = 4,
    ACTIONS(445), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12894), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273602] = 5,
    ACTIONS(12896), 1,
      sym__conid,
    STATE(6558), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273620] = 5,
    ACTIONS(12898), 1,
      sym__conid,
    STATE(5502), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273638] = 5,
    ACTIONS(12900), 1,
      sym__conid,
    STATE(6727), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273656] = 3,
    ACTIONS(3461), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 3,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
  [273670] = 4,
    ACTIONS(12904), 1,
      sym__layout_end,
    STATE(7622), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12902), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273686] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11653), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [273698] = 4,
    ACTIONS(1149), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12906), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273714] = 4,
    ACTIONS(1193), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12908), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273730] = 5,
    ACTIONS(11661), 1,
      sym__conid,
    STATE(4318), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273748] = 5,
    ACTIONS(12910), 1,
      sym__conid,
    STATE(6347), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273766] = 5,
    ACTIONS(12912), 1,
      sym__conid,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(6825), 1,
      sym_constructor,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273784] = 4,
    ACTIONS(3179), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(12914), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273800] = 4,
    ACTIONS(12918), 1,
      sym__layout_end,
    STATE(7621), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12916), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273816] = 4,
    ACTIONS(12922), 1,
      sym__layout_end,
    STATE(7747), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(12920), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273832] = 4,
    ACTIONS(10970), 1,
      sym__layout_end,
    STATE(7761), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(12924), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273848] = 5,
    ACTIONS(12926), 1,
      sym__conid,
    STATE(4310), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273866] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12928), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [273878] = 4,
    ACTIONS(12932), 1,
      sym__layout_end,
    STATE(7626), 1,
      aux_sym_alts_repeat1,
    ACTIONS(12930), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273894] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12504), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [273906] = 5,
    ACTIONS(12934), 1,
      sym__conid,
    STATE(6723), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273924] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(12938), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273942] = 5,
    ACTIONS(12940), 1,
      sym__conid,
    STATE(2933), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [273960] = 3,
    ACTIONS(12944), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12942), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [273974] = 3,
    ACTIONS(12948), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12946), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [273988] = 5,
    ACTIONS(12950), 1,
      sym__conid,
    STATE(3491), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274006] = 4,
    ACTIONS(1243), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12952), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274022] = 4,
    ACTIONS(337), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12954), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274038] = 5,
    ACTIONS(10196), 1,
      sym__conid,
    STATE(3464), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274056] = 4,
    ACTIONS(12958), 1,
      sym__layout_end,
    STATE(7640), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(12956), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274072] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12960), 4,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
  [274084] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(12962), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274102] = 3,
    ACTIONS(12966), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12964), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [274116] = 3,
    ACTIONS(3277), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3288), 3,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      sym__operator,
  [274130] = 4,
    ACTIONS(459), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12968), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274146] = 3,
    ACTIONS(3461), 1,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(3463), 3,
      sym__operator,
      anon_sym_PIPE,
      anon_sym_EQ,
  [274160] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(12970), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274178] = 4,
    ACTIONS(12974), 1,
      sym__layout_end,
    STATE(7641), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(12972), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274194] = 5,
    ACTIONS(12976), 1,
      sym__conid,
    STATE(3135), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274212] = 5,
    ACTIONS(12978), 1,
      sym__conid,
    STATE(1795), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274230] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12980), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [274242] = 3,
    ACTIONS(12982), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12946), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [274256] = 5,
    ACTIONS(12984), 1,
      sym__conid,
    STATE(2113), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274274] = 3,
    ACTIONS(12986), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12964), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [274288] = 4,
    STATE(1221), 1,
      sym__colon2,
    STATE(9812), 1,
      sym__type_annotation,
    ACTIONS(12428), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274304] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(12988), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274322] = 4,
    ACTIONS(10534), 1,
      sym__layout_end,
    STATE(7812), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(12990), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274338] = 5,
    ACTIONS(12992), 1,
      sym__conid,
    STATE(4491), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274356] = 4,
    ACTIONS(12840), 1,
      anon_sym_LPAREN,
    STATE(8640), 1,
      sym_import_con_names,
    ACTIONS(12994), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274372] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(12996), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274390] = 5,
    ACTIONS(12998), 1,
      sym__conid,
    STATE(1721), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274408] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13000), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_as,
  [274420] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13002), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [274434] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13004), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274452] = 5,
    ACTIONS(13006), 1,
      sym__conid,
    ACTIONS(13008), 1,
      anon_sym_role,
    STATE(4746), 1,
      sym_constructor,
    STATE(9325), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274470] = 4,
    ACTIONS(127), 1,
      sym__layout_end,
    STATE(7723), 1,
      aux_sym_purescript_repeat1,
    ACTIONS(13010), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274486] = 4,
    ACTIONS(12625), 1,
      anon_sym_LPAREN,
    STATE(8635), 1,
      sym_export_names,
    ACTIONS(13012), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274502] = 4,
    ACTIONS(13016), 1,
      sym__layout_end,
    STATE(7679), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13014), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274518] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13018), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274536] = 5,
    ACTIONS(13020), 1,
      sym__conid,
    STATE(1796), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274554] = 5,
    ACTIONS(13022), 1,
      sym__conid,
    STATE(5965), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274572] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8340), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [274584] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13024), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274602] = 5,
    ACTIONS(13026), 1,
      sym__conid,
    STATE(2118), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274620] = 3,
    ACTIONS(13030), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13028), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [274634] = 4,
    ACTIONS(441), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13032), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274650] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13034), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274668] = 5,
    ACTIONS(11899), 1,
      sym__conid,
    STATE(6456), 1,
      sym_constructor,
    STATE(6473), 1,
      sym__modid,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274686] = 4,
    ACTIONS(13038), 1,
      sym__layout_end,
    STATE(7701), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13036), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274702] = 5,
    ACTIONS(13040), 1,
      sym__conid,
    STATE(3619), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274720] = 4,
    ACTIONS(13044), 1,
      sym__layout_end,
    STATE(7687), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13042), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274736] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10489), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [274748] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11653), 4,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
  [274760] = 4,
    ACTIONS(1153), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13046), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274776] = 5,
    ACTIONS(13048), 1,
      sym__conid,
    STATE(4472), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274794] = 5,
    ACTIONS(13050), 1,
      sym__conid,
    STATE(6431), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274812] = 3,
    ACTIONS(13052), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13028), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [274826] = 4,
    ACTIONS(1035), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13054), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274842] = 4,
    ACTIONS(2934), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13056), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274858] = 4,
    ACTIONS(13060), 1,
      sym__layout_end,
    STATE(7691), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13058), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274874] = 4,
    ACTIONS(13064), 1,
      sym__layout_end,
    STATE(7692), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13062), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274890] = 4,
    ACTIONS(13068), 1,
      sym__layout_end,
    STATE(7795), 1,
      aux_sym_purescript_repeat1,
    ACTIONS(13066), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274906] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13070), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274924] = 5,
    ACTIONS(13072), 1,
      sym__conid,
    STATE(6272), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274942] = 4,
    ACTIONS(1138), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13074), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274958] = 5,
    ACTIONS(13076), 1,
      sym__conid,
    STATE(2624), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274976] = 4,
    ACTIONS(1840), 1,
      sym__layout_end,
    STATE(7974), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(13078), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [274992] = 4,
    ACTIONS(447), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13080), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275008] = 4,
    ACTIONS(13084), 1,
      sym__layout_end,
    STATE(7698), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13082), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275024] = 4,
    ACTIONS(291), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13086), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275040] = 4,
    ACTIONS(13090), 1,
      sym__layout_end,
    STATE(7713), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13088), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275056] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13092), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275074] = 4,
    ACTIONS(13094), 1,
      ts_builtin_sym_end,
    STATE(7706), 1,
      aux_sym_purescript_repeat1,
    ACTIONS(13096), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275090] = 4,
    ACTIONS(13101), 1,
      sym__layout_end,
    STATE(7700), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(13099), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275106] = 4,
    ACTIONS(13105), 1,
      sym__layout_end,
    STATE(7715), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13103), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275122] = 4,
    ACTIONS(13109), 1,
      sym__layout_end,
    STATE(7703), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13107), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275138] = 4,
    ACTIONS(389), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13111), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275154] = 4,
    STATE(1101), 1,
      sym__colon2,
    STATE(8348), 1,
      sym__type_annotation,
    ACTIONS(12800), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275170] = 5,
    ACTIONS(13113), 1,
      sym__conid,
    STATE(4478), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275188] = 4,
    ACTIONS(3190), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13115), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275204] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13117), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275222] = 4,
    ACTIONS(1225), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13119), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275238] = 5,
    ACTIONS(13121), 1,
      sym__conid,
    STATE(4004), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275256] = 4,
    ACTIONS(13125), 1,
      sym__layout_end,
    STATE(7710), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13123), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275272] = 5,
    ACTIONS(13127), 1,
      sym__conid,
    STATE(3502), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275290] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13129), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275308] = 5,
    ACTIONS(13131), 1,
      sym__conid,
    STATE(5193), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275326] = 4,
    ACTIONS(10970), 1,
      sym__layout_end,
    STATE(7800), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(12924), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275342] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13133), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275360] = 4,
    ACTIONS(13094), 1,
      sym__layout_end,
    STATE(7723), 1,
      aux_sym_purescript_repeat1,
    ACTIONS(13135), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275376] = 3,
    ACTIONS(13138), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12946), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [275390] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13140), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275408] = 5,
    ACTIONS(13142), 1,
      sym__conid,
    STATE(4465), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275426] = 3,
    ACTIONS(13144), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12942), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [275440] = 5,
    ACTIONS(11901), 1,
      sym__conid,
    STATE(6696), 1,
      sym_constructor,
    STATE(7590), 1,
      aux_sym__qualifying_module,
    STATE(7591), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275458] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13146), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275476] = 5,
    ACTIONS(13148), 1,
      sym__conid,
    STATE(4553), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275494] = 3,
    ACTIONS(13150), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12886), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [275508] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13152), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275526] = 3,
    ACTIONS(13154), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12964), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [275540] = 3,
    ACTIONS(13156), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12964), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [275554] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13158), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275572] = 4,
    ACTIONS(13162), 1,
      sym__layout_end,
    STATE(7744), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13160), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275588] = 4,
    ACTIONS(13166), 1,
      anon_sym_in,
    STATE(7813), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(13164), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275604] = 5,
    ACTIONS(13168), 1,
      sym__conid,
    STATE(4023), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275622] = 5,
    ACTIONS(13170), 1,
      sym__conid,
    STATE(2824), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275640] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10559), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [275652] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13172), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275670] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13174), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275688] = 4,
    ACTIONS(419), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13176), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275704] = 4,
    ACTIONS(423), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13178), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275720] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    STATE(6880), 1,
      sym_fundep,
    STATE(6882), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275736] = 3,
    ACTIONS(13180), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12946), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [275750] = 4,
    ACTIONS(1854), 1,
      sym__layout_end,
    STATE(7974), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(13182), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275766] = 5,
    ACTIONS(13184), 1,
      sym__conid,
    STATE(3433), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275784] = 4,
    ACTIONS(13188), 1,
      sym__layout_end,
    STATE(7752), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13186), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275800] = 4,
    ACTIONS(1231), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13190), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275816] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13192), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275834] = 4,
    ACTIONS(915), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13194), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275850] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11653), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [275862] = 5,
    ACTIONS(13196), 1,
      sym__conid,
    STATE(6407), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275880] = 5,
    ACTIONS(11661), 1,
      sym__conid,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(8142), 1,
      sym__modid,
    STATE(8467), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275898] = 5,
    ACTIONS(11463), 1,
      sym__conid,
    STATE(4318), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275916] = 4,
    ACTIONS(133), 1,
      ts_builtin_sym_end,
    STATE(7706), 1,
      aux_sym_purescript_repeat1,
    ACTIONS(13198), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275932] = 4,
    ACTIONS(13202), 1,
      anon_sym_EQ,
    STATE(1000), 1,
      sym__larrow,
    ACTIONS(13200), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275948] = 4,
    ACTIONS(13206), 1,
      sym__layout_end,
    STATE(7750), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13204), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275964] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [275976] = 4,
    ACTIONS(10966), 1,
      sym__layout_end,
    STATE(7800), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13208), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [275992] = 4,
    ACTIONS(10966), 1,
      sym__layout_end,
    STATE(7850), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13208), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276008] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10604), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [276020] = 5,
    ACTIONS(13210), 1,
      sym__conid,
    STATE(2065), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276038] = 4,
    ACTIONS(369), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13212), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276054] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12844), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_as,
  [276066] = 5,
    ACTIONS(13214), 1,
      sym__conid,
    STATE(5365), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276084] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12834), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [276098] = 3,
    ACTIONS(13216), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12794), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [276112] = 5,
    ACTIONS(13218), 1,
      sym__conid,
    STATE(1664), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276130] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13220), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276148] = 5,
    ACTIONS(13222), 1,
      sym__conid,
    STATE(6402), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276166] = 4,
    ACTIONS(13226), 1,
      sym__layout_end,
    STATE(7765), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13224), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276182] = 5,
    ACTIONS(13228), 1,
      sym__conid,
    STATE(3605), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276200] = 4,
    ACTIONS(13232), 1,
      sym__layout_end,
    STATE(7786), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13230), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276216] = 5,
    ACTIONS(13234), 1,
      sym__conid,
    STATE(3377), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276234] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13236), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276252] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13238), 4,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
  [276264] = 4,
    ACTIONS(13243), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13240), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276280] = 4,
    ACTIONS(415), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13245), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276296] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13247), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276314] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [276326] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13249), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_as,
  [276338] = 5,
    ACTIONS(11899), 1,
      sym__conid,
    STATE(2118), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276356] = 4,
    ACTIONS(13253), 1,
      sym__layout_end,
    STATE(7780), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13251), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276372] = 4,
    ACTIONS(267), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13255), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276388] = 4,
    ACTIONS(13259), 1,
      sym__layout_end,
    STATE(7789), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13257), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276404] = 4,
    ACTIONS(13263), 1,
      sym__layout_end,
    STATE(7791), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13261), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276420] = 4,
    ACTIONS(3198), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13265), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276436] = 4,
    ACTIONS(1155), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13267), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276452] = 4,
    ACTIONS(1102), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13269), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276468] = 5,
    ACTIONS(13271), 1,
      sym__conid,
    STATE(3403), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276486] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13273), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276504] = 5,
    ACTIONS(13275), 1,
      sym__conid,
    STATE(3331), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276522] = 4,
    ACTIONS(129), 1,
      sym__layout_end,
    STATE(7723), 1,
      aux_sym_purescript_repeat1,
    ACTIONS(13277), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276538] = 5,
    ACTIONS(11136), 1,
      sym__conid,
    STATE(4379), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276556] = 5,
    ACTIONS(13279), 1,
      sym__conid,
    STATE(4069), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276574] = 4,
    ACTIONS(3066), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13281), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276590] = 5,
    ACTIONS(13283), 1,
      anon_sym_SEMI,
    ACTIONS(13285), 1,
      sym__layout_semicolon,
    ACTIONS(13287), 1,
      sym__layout_end,
    STATE(7926), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276608] = 4,
    ACTIONS(13292), 1,
      sym__layout_end,
    STATE(7800), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13289), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276624] = 4,
    ACTIONS(13296), 1,
      sym__layout_end,
    STATE(7809), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13294), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276640] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13298), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276658] = 4,
    ACTIONS(11009), 1,
      sym__layout_end,
    STATE(7800), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13300), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276674] = 4,
    ACTIONS(13304), 1,
      sym_comma,
    STATE(7864), 1,
      aux_sym_guards_repeat1,
    ACTIONS(13302), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276690] = 4,
    ACTIONS(13308), 1,
      sym__layout_end,
    STATE(7790), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13306), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276706] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13310), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276724] = 5,
    ACTIONS(13312), 1,
      anon_sym_SEMI,
    ACTIONS(13314), 1,
      sym__layout_semicolon,
    ACTIONS(13316), 1,
      sym__layout_end,
    STATE(7872), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276742] = 4,
    ACTIONS(13320), 1,
      sym__layout_end,
    STATE(7798), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13318), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276758] = 4,
    ACTIONS(405), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13322), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276774] = 5,
    ACTIONS(13324), 1,
      sym__conid,
    STATE(5658), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276792] = 5,
    ACTIONS(13326), 1,
      anon_sym_SEMI,
    ACTIONS(13328), 1,
      sym__layout_semicolon,
    ACTIONS(13330), 1,
      sym__layout_end,
    STATE(7799), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276810] = 4,
    ACTIONS(13335), 1,
      sym__layout_end,
    STATE(7812), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(13332), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276826] = 4,
    ACTIONS(13340), 1,
      anon_sym_in,
    STATE(7813), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(13337), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276842] = 4,
    ACTIONS(13344), 1,
      sym__layout_end,
    STATE(7817), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13342), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276858] = 4,
    ACTIONS(11011), 1,
      sym__layout_end,
    STATE(7803), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13346), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276874] = 4,
    ACTIONS(11011), 1,
      sym__layout_end,
    STATE(7800), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13346), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276890] = 4,
    ACTIONS(972), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13348), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276906] = 4,
    ACTIONS(1866), 1,
      sym__layout_end,
    STATE(7974), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(13350), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276922] = 4,
    ACTIONS(1092), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13352), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276938] = 4,
    ACTIONS(347), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13354), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276954] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13356), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276972] = 4,
    ACTIONS(11013), 1,
      sym__layout_end,
    STATE(7800), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13358), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [276988] = 3,
    ACTIONS(13360), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12846), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [277002] = 4,
    ACTIONS(3080), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13362), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277018] = 4,
    ACTIONS(10505), 1,
      sym__layout_end,
    STATE(7812), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(13364), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277034] = 3,
    ACTIONS(13366), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12724), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [277048] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13368), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277066] = 5,
    ACTIONS(13370), 1,
      sym__conid,
    STATE(2534), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277084] = 3,
    ACTIONS(13372), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12860), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [277098] = 4,
    ACTIONS(11013), 1,
      sym__layout_end,
    STATE(7816), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13358), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277114] = 4,
    ACTIONS(385), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13374), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277130] = 4,
    ACTIONS(13378), 1,
      sym__layout_end,
    STATE(7818), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(13376), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277146] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13380), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277164] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10582), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [277176] = 4,
    ACTIONS(13384), 1,
      sym__layout_end,
    STATE(7819), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13382), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277192] = 4,
    ACTIONS(13388), 1,
      sym__layout_end,
    STATE(7824), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13386), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277208] = 4,
    ACTIONS(13392), 1,
      sym__layout_end,
    STATE(7831), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13390), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277224] = 4,
    ACTIONS(13396), 1,
      sym__layout_end,
    STATE(7820), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13394), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277240] = 5,
    ACTIONS(11901), 1,
      sym__conid,
    STATE(6604), 1,
      sym__modid,
    STATE(6696), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277258] = 4,
    STATE(1221), 1,
      sym__colon2,
    STATE(8952), 1,
      sym__type_annotation,
    ACTIONS(12428), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277274] = 4,
    ACTIONS(345), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13398), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277290] = 4,
    ACTIONS(1106), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13400), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277306] = 4,
    ACTIONS(13404), 1,
      sym__layout_end,
    STATE(7922), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13402), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277322] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12780), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_as,
  [277334] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13406), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277352] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13408), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277370] = 5,
    ACTIONS(13410), 1,
      sym__conid,
    STATE(3473), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277388] = 4,
    ACTIONS(13414), 1,
      sym__layout_end,
    STATE(7841), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13412), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277404] = 5,
    ACTIONS(13416), 1,
      sym__conid,
    STATE(3201), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277422] = 4,
    ACTIONS(10964), 1,
      sym__layout_end,
    STATE(7800), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13418), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277438] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12782), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [277452] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13420), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277470] = 5,
    ACTIONS(11003), 1,
      sym__conid,
    STATE(3109), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277488] = 4,
    ACTIONS(11015), 1,
      sym__layout_end,
    STATE(7822), 1,
      aux_sym_class_instance_repeat1,
    ACTIONS(13422), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277504] = 5,
    ACTIONS(11899), 1,
      sym__conid,
    STATE(6456), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(7915), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277522] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12788), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [277536] = 4,
    STATE(1221), 1,
      sym__colon2,
    STATE(9548), 1,
      sym__type_annotation,
    ACTIONS(12428), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277552] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13424), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277570] = 4,
    ACTIONS(13428), 1,
      sym__layout_end,
    STATE(7825), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(13426), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277586] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13430), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_as,
  [277598] = 5,
    ACTIONS(13432), 1,
      sym__conid,
    STATE(3727), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277616] = 5,
    ACTIONS(11019), 1,
      sym__conid,
    STATE(3233), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277634] = 4,
    ACTIONS(13436), 1,
      sym__layout_end,
    STATE(7876), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13434), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277650] = 4,
    ACTIONS(13438), 1,
      sym_comma,
    STATE(7864), 1,
      aux_sym_guards_repeat1,
    ACTIONS(12822), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277666] = 4,
    ACTIONS(13443), 1,
      sym__layout_end,
    STATE(7873), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13441), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277682] = 4,
    STATE(1221), 1,
      sym__colon2,
    STATE(9454), 1,
      sym__type_annotation,
    ACTIONS(12428), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277698] = 4,
    ACTIONS(351), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13445), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277714] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13447), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277732] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13449), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277750] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13451), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277768] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    STATE(7133), 1,
      sym_fundep,
    STATE(6793), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277784] = 5,
    ACTIONS(13453), 1,
      anon_sym_SEMI,
    ACTIONS(13455), 1,
      sym__layout_semicolon,
    ACTIONS(13457), 1,
      sym__layout_end,
    STATE(7926), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277802] = 4,
    ACTIONS(377), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13459), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277818] = 5,
    ACTIONS(13461), 1,
      sym__conid,
    STATE(3323), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277836] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13463), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277854] = 4,
    ACTIONS(303), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13465), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277870] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13467), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277888] = 4,
    ACTIONS(13471), 1,
      sym__layout_end,
    STATE(7881), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13469), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277904] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13473), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277922] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13475), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277940] = 4,
    ACTIONS(1029), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13477), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277956] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13479), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277974] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13481), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [277992] = 5,
    ACTIONS(13483), 1,
      sym__conid,
    STATE(3317), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278010] = 4,
    STATE(1164), 1,
      sym__colon2,
    STATE(8217), 1,
      sym__type_annotation,
    ACTIONS(10399), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278026] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13485), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278044] = 4,
    ACTIONS(13489), 1,
      sym__layout_end,
    STATE(7893), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13487), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278060] = 4,
    ACTIONS(13493), 1,
      sym__layout_end,
    STATE(7867), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13491), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278076] = 4,
    ACTIONS(13497), 1,
      sym__layout_end,
    STATE(7894), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13495), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278092] = 5,
    ACTIONS(13499), 1,
      sym__conid,
    STATE(4549), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278110] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13501), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278128] = 5,
    ACTIONS(13503), 1,
      sym__conid,
    STATE(2259), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278146] = 4,
    ACTIONS(3196), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13505), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278162] = 4,
    ACTIONS(966), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13507), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278178] = 5,
    ACTIONS(13509), 1,
      sym__conid,
    STATE(4415), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278196] = 4,
    ACTIONS(13513), 1,
      sym__layout_end,
    STATE(7906), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13511), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278212] = 5,
    ACTIONS(11899), 1,
      sym__conid,
    STATE(6456), 1,
      sym_constructor,
    STATE(7855), 1,
      aux_sym__qualifying_module,
    STATE(7856), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278230] = 5,
    ACTIONS(11899), 1,
      sym__conid,
    STATE(6456), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(7851), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278248] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13515), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278266] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13517), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278284] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13519), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278302] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13521), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278320] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13523), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278338] = 5,
    ACTIONS(13525), 1,
      sym__conid,
    STATE(3288), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278356] = 5,
    ACTIONS(13527), 1,
      sym__conid,
    STATE(4641), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278374] = 4,
    ACTIONS(3064), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13529), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278390] = 5,
    ACTIONS(13531), 1,
      sym__conid,
    STATE(4615), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278408] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13533), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278426] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13535), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278444] = 3,
    ACTIONS(13539), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13537), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [278458] = 5,
    ACTIONS(11021), 1,
      sym__conid,
    STATE(3048), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278476] = 4,
    ACTIONS(3234), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13541), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278492] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12980), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [278504] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13000), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_as,
  [278516] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13002), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [278530] = 4,
    STATE(1221), 1,
      sym__colon2,
    STATE(9114), 1,
      sym__type_annotation,
    ACTIONS(12428), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278546] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13543), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278564] = 4,
    ACTIONS(13304), 1,
      sym_comma,
    STATE(7804), 1,
      aux_sym_guards_repeat1,
    ACTIONS(13545), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278580] = 3,
    ACTIONS(13547), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13028), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [278594] = 4,
    ACTIONS(13551), 1,
      sym__layout_end,
    STATE(7842), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13549), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278610] = 4,
    ACTIONS(13555), 1,
      sym__layout_end,
    STATE(7912), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13553), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278626] = 4,
    ACTIONS(1017), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13557), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278642] = 4,
    ACTIONS(319), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13559), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278658] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13561), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278676] = 4,
    ACTIONS(439), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13563), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278692] = 4,
    ACTIONS(13568), 1,
      sym__layout_end,
    STATE(7926), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(13565), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278708] = 4,
    ACTIONS(13572), 1,
      sym__layout_end,
    STATE(7923), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13570), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278724] = 5,
    ACTIONS(13574), 1,
      sym__conid,
    STATE(5144), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278742] = 4,
    ACTIONS(13578), 1,
      sym__layout_end,
    STATE(7937), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13576), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278758] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    ACTIONS(13580), 1,
      anon_sym_else,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278776] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13582), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278794] = 4,
    STATE(1164), 1,
      sym__colon2,
    STATE(8319), 1,
      sym__type_annotation,
    ACTIONS(10399), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278810] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13584), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278828] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13586), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278846] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13588), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278864] = 5,
    ACTIONS(11899), 1,
      sym__conid,
    STATE(6456), 1,
      sym_constructor,
    STATE(7768), 1,
      sym__modid,
    STATE(7898), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278882] = 4,
    ACTIONS(339), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13590), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278898] = 4,
    ACTIONS(10673), 1,
      sym__varid,
    STATE(6769), 1,
      sym_fundep,
    STATE(6793), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278914] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    ACTIONS(13592), 1,
      anon_sym_then,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278932] = 4,
    ACTIONS(13597), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13594), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278948] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13599), 4,
      sym_comma,
      anon_sym_u2192,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [278960] = 4,
    ACTIONS(13603), 1,
      sym__layout_end,
    STATE(7945), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13601), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278976] = 4,
    ACTIONS(13607), 1,
      sym__layout_end,
    STATE(7925), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13605), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [278992] = 4,
    ACTIONS(13609), 1,
      ts_builtin_sym_end,
    STATE(7757), 1,
      aux_sym_purescript_repeat1,
    ACTIONS(13611), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279008] = 4,
    ACTIONS(1079), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13613), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279024] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13615), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [279036] = 5,
    ACTIONS(11932), 1,
      sym__conid,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(8283), 1,
      sym_constructor,
    STATE(8449), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279054] = 5,
    ACTIONS(11001), 1,
      sym__conid,
    STATE(3253), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279072] = 5,
    ACTIONS(13617), 1,
      sym__conid,
    STATE(3986), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279090] = 4,
    STATE(1221), 1,
      sym__colon2,
    STATE(9979), 1,
      sym__type_annotation,
    ACTIONS(12428), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279106] = 5,
    ACTIONS(13619), 1,
      sym__conid,
    STATE(5352), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279124] = 4,
    ACTIONS(13623), 1,
      sym__layout_end,
    STATE(7959), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13621), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279140] = 3,
    ACTIONS(13627), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13625), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [279154] = 5,
    ACTIONS(13629), 1,
      sym__conid,
    STATE(1701), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279172] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13631), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279190] = 5,
    ACTIONS(13006), 1,
      sym__conid,
    ACTIONS(13633), 1,
      anon_sym_role,
    STATE(4746), 1,
      sym_constructor,
    STATE(10056), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279208] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10976), 4,
      sym__varid,
      sym__conid,
      anon_sym_do,
      anon_sym_ado,
  [279220] = 4,
    ACTIONS(13637), 1,
      anon_sym_EQ,
    STATE(999), 1,
      sym__larrow,
    ACTIONS(13635), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279236] = 4,
    ACTIONS(431), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13639), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279252] = 4,
    ACTIONS(13643), 1,
      sym__layout_end,
    STATE(7961), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13641), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279268] = 4,
    ACTIONS(3140), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13645), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279284] = 4,
    ACTIONS(1075), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13647), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279300] = 5,
    ACTIONS(13649), 1,
      sym__conid,
    STATE(3021), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279318] = 5,
    ACTIONS(13651), 1,
      sym__conid,
    STATE(3965), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279336] = 5,
    ACTIONS(13653), 1,
      sym__conid,
    STATE(3189), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279354] = 5,
    ACTIONS(13655), 1,
      sym__conid,
    STATE(3203), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279372] = 5,
    ACTIONS(13657), 1,
      sym__conid,
    STATE(4065), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279390] = 5,
    ACTIONS(13659), 1,
      sym__conid,
    STATE(3698), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279408] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13249), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_as,
  [279420] = 4,
    ACTIONS(1211), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13661), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279436] = 5,
    ACTIONS(13663), 1,
      sym__conid,
    STATE(5764), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279454] = 4,
    ACTIONS(13667), 1,
      sym__layout_end,
    STATE(7970), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13665), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279470] = 5,
    ACTIONS(13669), 1,
      sym__conid,
    STATE(4214), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279488] = 4,
    ACTIONS(13340), 1,
      sym__layout_end,
    STATE(7974), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(13671), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279504] = 5,
    ACTIONS(13674), 1,
      sym__conid,
    STATE(3046), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279522] = 5,
    ACTIONS(13676), 1,
      sym__conid,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(6883), 1,
      sym_constructor,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279540] = 4,
    ACTIONS(279), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13678), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279556] = 5,
    ACTIONS(13680), 1,
      sym__conid,
    STATE(2045), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279574] = 4,
    ACTIONS(13243), 1,
      anon_sym_in,
    STATE(7979), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13682), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279590] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13685), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279608] = 4,
    ACTIONS(987), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13687), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279624] = 4,
    ACTIONS(2932), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13689), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279640] = 4,
    ACTIONS(13693), 1,
      sym__layout_end,
    STATE(7977), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13691), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279656] = 5,
    ACTIONS(13695), 1,
      sym__conid,
    STATE(3026), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279674] = 4,
    ACTIONS(13699), 1,
      sym__layout_end,
    STATE(7993), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13697), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279690] = 4,
    ACTIONS(13703), 1,
      sym__layout_end,
    STATE(7981), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13701), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279706] = 5,
    ACTIONS(13705), 1,
      sym__conid,
    STATE(3056), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279724] = 4,
    ACTIONS(13709), 1,
      sym__layout_end,
    STATE(7982), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13707), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279740] = 4,
    ACTIONS(359), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13711), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279756] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13713), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279774] = 5,
    ACTIONS(13715), 1,
      sym__conid,
    STATE(4952), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279792] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13717), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279810] = 4,
    ACTIONS(305), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13719), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279826] = 4,
    ACTIONS(13723), 1,
      sym__layout_end,
    STATE(7989), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13721), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279842] = 5,
    ACTIONS(13725), 1,
      sym__conid,
    STATE(3057), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279860] = 5,
    ACTIONS(13727), 1,
      sym__conid,
    STATE(3445), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279878] = 5,
    ACTIONS(13729), 1,
      sym__conid,
    STATE(2529), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279896] = 4,
    ACTIONS(13733), 1,
      sym__layout_end,
    STATE(8001), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13731), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279912] = 4,
    ACTIONS(13738), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13735), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279928] = 4,
    ACTIONS(13742), 1,
      sym__layout_end,
    STATE(7962), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13740), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279944] = 4,
    ACTIONS(1108), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13744), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279960] = 5,
    ACTIONS(13746), 1,
      sym__conid,
    STATE(3296), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279978] = 4,
    ACTIONS(13750), 1,
      sym__layout_end,
    STATE(8012), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13748), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [279994] = 5,
    ACTIONS(11661), 1,
      sym__conid,
    STATE(3162), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280012] = 5,
    ACTIONS(13752), 1,
      sym__conid,
    STATE(4960), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280030] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_as,
  [280042] = 5,
    ACTIONS(13754), 1,
      sym__conid,
    STATE(3923), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280060] = 5,
    ACTIONS(13756), 1,
      sym__conid,
    STATE(6369), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280078] = 5,
    ACTIONS(13758), 1,
      sym__conid,
    STATE(4636), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280096] = 5,
    ACTIONS(13760), 1,
      sym__conid,
    STATE(3676), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280114] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13762), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280132] = 4,
    ACTIONS(353), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13764), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280148] = 4,
    ACTIONS(13768), 1,
      sym__layout_end,
    STATE(8016), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13766), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280164] = 5,
    ACTIONS(13770), 1,
      sym__conid,
    STATE(6403), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280182] = 4,
    ACTIONS(13774), 1,
      sym__layout_end,
    STATE(8019), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13772), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280198] = 4,
    ACTIONS(3230), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13776), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280214] = 4,
    ACTIONS(1096), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13778), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280230] = 5,
    ACTIONS(13780), 1,
      sym__conid,
    STATE(1681), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280248] = 4,
    ACTIONS(1221), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13782), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280264] = 4,
    ACTIONS(3175), 1,
      sym__layout_end,
    STATE(7940), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13784), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280280] = 4,
    ACTIONS(1159), 1,
      sym__layout_end,
    STATE(7999), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13786), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280296] = 5,
    ACTIONS(13788), 1,
      sym__conid,
    STATE(6448), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280314] = 4,
    ACTIONS(13792), 1,
      sym__layout_end,
    STATE(8021), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13790), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280330] = 4,
    ACTIONS(13796), 1,
      sym__layout_end,
    STATE(8017), 1,
      aux_sym__ado_in_repeat1,
    ACTIONS(13794), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280346] = 4,
    ACTIONS(13800), 1,
      sym__layout_end,
    STATE(8020), 1,
      aux_sym_alts_repeat1,
    ACTIONS(13798), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280362] = 5,
    ACTIONS(13802), 1,
      sym__conid,
    STATE(3615), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280380] = 4,
    ACTIONS(273), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13804), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280396] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13806), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280414] = 5,
    ACTIONS(13808), 1,
      sym__conid,
    STATE(3984), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280432] = 4,
    ACTIONS(275), 1,
      sym__layout_end,
    STATE(7779), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13810), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280448] = 5,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    ACTIONS(13812), 1,
      anon_sym_RPAREN,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280466] = 5,
    ACTIONS(13814), 1,
      sym__conid,
    STATE(4279), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280484] = 4,
    ACTIONS(13818), 1,
      sym__layout_end,
    STATE(8030), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13816), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280500] = 5,
    ACTIONS(13820), 1,
      sym__conid,
    STATE(3241), 1,
      sym_constructor,
    STATE(6792), 1,
      aux_sym__qualifying_module,
    STATE(10078), 1,
      sym__modid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280518] = 4,
    ACTIONS(13824), 1,
      sym__layout_end,
    STATE(8027), 1,
      aux_sym_exp_do_repeat1,
    ACTIONS(13822), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280534] = 4,
    ACTIONS(13826), 1,
      anon_sym_RBRACE,
    ACTIONS(13828), 1,
      sym_comma,
    STATE(8324), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280549] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12728), 1,
      sym__immediate_dot,
    STATE(2391), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280564] = 4,
    ACTIONS(13830), 1,
      anon_sym_RBRACE,
    ACTIONS(13832), 1,
      sym_comma,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280579] = 4,
    ACTIONS(13834), 1,
      anon_sym_RBRACK,
    ACTIONS(13836), 1,
      sym_comma,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280594] = 4,
    ACTIONS(13838), 1,
      anon_sym_RBRACE,
    ACTIONS(13840), 1,
      sym_comma,
    STATE(8047), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280609] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(13842), 1,
      anon_sym_RBRACE,
    STATE(8085), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280624] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym_comma,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [280635] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(13844), 1,
      anon_sym_RBRACE,
    STATE(8061), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280650] = 4,
    ACTIONS(13846), 1,
      anon_sym_RBRACK,
    ACTIONS(13848), 1,
      sym_comma,
    STATE(8062), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280665] = 4,
    ACTIONS(13850), 1,
      sym__conid,
    STATE(5282), 1,
      sym_constructor,
    STATE(8376), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280680] = 4,
    ACTIONS(13852), 1,
      sym__conid,
    STATE(4146), 1,
      sym_constructor,
    STATE(7829), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280695] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(13854), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280710] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13856), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280721] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13858), 1,
      anon_sym_RBRACK,
    STATE(8039), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280736] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13856), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280747] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13860), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280758] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(13862), 1,
      anon_sym_RBRACE,
    STATE(8038), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280773] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(4863), 1,
      sym_constructor,
    STATE(10040), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280788] = 4,
    ACTIONS(13864), 1,
      sym__integer_literal,
    ACTIONS(13866), 1,
      sym__hex_literal,
    STATE(6142), 1,
      sym_integer,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280803] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13868), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280814] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13870), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280825] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(13872), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280840] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13870), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280851] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13874), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280862] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13876), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280873] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(13878), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280888] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(13880), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280903] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13882), 1,
      anon_sym_RBRACK,
    STATE(8089), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280918] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(2507), 1,
      sym_constructor,
    STATE(8320), 1,
      sym_newtype_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280933] = 3,
    STATE(588), 1,
      sym__larrow,
    ACTIONS(13884), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280946] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13886), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280957] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(13888), 1,
      sym__immediate_dot,
    STATE(4896), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280972] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(13890), 1,
      sym__immediate_dot,
    STATE(2551), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [280987] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13892), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [280998] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(13894), 1,
      sym__immediate_dot,
    STATE(1683), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281013] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13896), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [281024] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13898), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281035] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(13900), 1,
      sym__immediate_dot,
    STATE(4757), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281050] = 4,
    ACTIONS(13850), 1,
      sym__conid,
    STATE(4314), 1,
      sym_constructor,
    STATE(7602), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281065] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10186), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281076] = 4,
    ACTIONS(10698), 1,
      anon_sym_RPAREN,
    ACTIONS(13902), 1,
      sym_comma,
    STATE(8099), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281091] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8225), 3,
      sym__dot,
      sym_where,
      anon_sym_LPAREN,
  [281102] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(13904), 1,
      anon_sym_RBRACE,
    STATE(8387), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281117] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(13906), 1,
      anon_sym_RBRACE,
    STATE(8121), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281132] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(11435), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281145] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13908), 1,
      anon_sym_RBRACK,
    STATE(8123), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281160] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11653), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281171] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(13910), 1,
      anon_sym_RBRACE,
    STATE(8094), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281186] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13912), 1,
      anon_sym_RBRACK,
    STATE(8095), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281201] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(13914), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281216] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13916), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [281227] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13918), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281238] = 4,
    ACTIONS(13864), 1,
      sym__integer_literal,
    ACTIONS(13866), 1,
      sym__hex_literal,
    STATE(6111), 1,
      sym_integer,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281253] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13920), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281268] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(2507), 1,
      sym_constructor,
    STATE(8179), 1,
      sym_newtype_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281283] = 4,
    ACTIONS(13864), 1,
      sym__integer_literal,
    ACTIONS(13866), 1,
      sym__hex_literal,
    STATE(6073), 1,
      sym_integer,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281298] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13896), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [281309] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(13922), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281324] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(13924), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281339] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13926), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281354] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(13928), 1,
      anon_sym_RBRACE,
    STATE(8103), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281369] = 3,
    ACTIONS(11339), 1,
      sym__varid,
    STATE(6336), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281382] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13930), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281397] = 4,
    ACTIONS(10745), 1,
      anon_sym_RPAREN,
    ACTIONS(13932), 1,
      sym_comma,
    STATE(8462), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281412] = 4,
    ACTIONS(10745), 1,
      anon_sym_RPAREN,
    ACTIONS(13932), 1,
      sym_comma,
    STATE(8137), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281427] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13934), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281438] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(13936), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281453] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(13938), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281468] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13940), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [281479] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(13942), 1,
      anon_sym_RBRACE,
    STATE(8192), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281494] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13944), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [281505] = 3,
    ACTIONS(13948), 1,
      anon_sym_COLON,
    ACTIONS(13946), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281518] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(13950), 1,
      anon_sym_RBRACE,
    STATE(8189), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281533] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13952), 3,
      sym_comma,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [281544] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13954), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [281555] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13956), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281566] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13958), 1,
      anon_sym_RBRACK,
    STATE(8098), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281581] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(13960), 1,
      anon_sym_RBRACE,
    STATE(8102), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281596] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13962), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281607] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13964), 1,
      anon_sym_RBRACK,
    STATE(8198), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281622] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13966), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281633] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13968), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281644] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(13970), 1,
      anon_sym_RBRACE,
    STATE(8093), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281659] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(13972), 1,
      anon_sym_RBRACK,
    STATE(8195), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281674] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13940), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_EQ,
  [281685] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(13974), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281700] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13976), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [281711] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(13978), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281726] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13980), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [281737] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13982), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [281748] = 3,
    STATE(6817), 1,
      sym__lcarrow,
    ACTIONS(13984), 2,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281761] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(13986), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281776] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(13988), 1,
      sym__immediate_dot,
    STATE(5173), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281791] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(13990), 1,
      sym__immediate_dot,
    STATE(2427), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281806] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(13992), 1,
      anon_sym_RBRACK,
    STATE(8057), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281821] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13994), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [281832] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(13996), 1,
      anon_sym_RBRACE,
    STATE(8145), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281847] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10186), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [281858] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13998), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [281869] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14000), 1,
      anon_sym_RBRACE,
    STATE(8127), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281884] = 4,
    ACTIONS(14002), 1,
      anon_sym_LPAREN,
    ACTIONS(14004), 1,
      sym_where,
    STATE(9973), 1,
      sym_exports,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281899] = 4,
    ACTIONS(10755), 1,
      anon_sym_RPAREN,
    ACTIONS(14006), 1,
      sym_comma,
    STATE(8462), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281914] = 3,
    STATE(8704), 1,
      sym__colon2,
    ACTIONS(14008), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281927] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14010), 1,
      anon_sym_RBRACE,
    STATE(8150), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281942] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14012), 1,
      anon_sym_RBRACK,
    STATE(8151), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281957] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14014), 1,
      sym__immediate_dot,
    STATE(6221), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281972] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(11429), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [281985] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14016), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282000] = 3,
    STATE(6820), 1,
      sym__rcarrow,
    ACTIONS(14018), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282013] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14020), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282028] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14022), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282043] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14024), 1,
      anon_sym_RBRACE,
    STATE(8257), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282058] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14026), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [282069] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14028), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282084] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14030), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282099] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14032), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282114] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14034), 1,
      anon_sym_RBRACE,
    STATE(8159), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282129] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14036), 1,
      anon_sym_RBRACE,
    STATE(8143), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282144] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14038), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282159] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14040), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [282170] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14040), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [282181] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14042), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [282192] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14044), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282207] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14046), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282222] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14048), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [282233] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14050), 1,
      anon_sym_RBRACK,
    STATE(8175), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282248] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13916), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [282259] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13896), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [282270] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(5111), 1,
      sym_constructor,
    STATE(9943), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282285] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14052), 1,
      anon_sym_RBRACK,
    STATE(8154), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282300] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14054), 1,
      anon_sym_RBRACE,
    STATE(8158), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282315] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14056), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [282326] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14058), 1,
      anon_sym_RBRACK,
    STATE(8146), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282341] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14060), 1,
      anon_sym_RBRACE,
    STATE(8149), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282356] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14062), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282371] = 3,
    ACTIONS(10981), 1,
      sym__conid,
    ACTIONS(10976), 2,
      sym__operator,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282384] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(5111), 1,
      sym_constructor,
    STATE(9911), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282399] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(5111), 1,
      sym_constructor,
    STATE(9910), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282414] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14064), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282429] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14066), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282444] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14068), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [282455] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14070), 1,
      sym__immediate_dot,
    STATE(5265), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282470] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14072), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [282481] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14074), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [282492] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14076), 1,
      sym__immediate_dot,
    STATE(1824), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282507] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13998), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [282518] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14078), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282533] = 4,
    ACTIONS(13852), 1,
      sym__conid,
    STATE(5373), 1,
      sym_constructor,
    STATE(8316), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282548] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13994), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [282559] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14080), 1,
      anon_sym_RBRACE,
    STATE(8174), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282574] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14082), 1,
      sym__immediate_dot,
    STATE(4955), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282589] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14084), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282604] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14086), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282619] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14088), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282634] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14090), 1,
      anon_sym_RBRACE,
    STATE(8201), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282649] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14092), 1,
      anon_sym_RBRACK,
    STATE(8202), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282664] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14094), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282679] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14096), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [282690] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14098), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [282701] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14100), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282716] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14102), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282731] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14104), 1,
      anon_sym_RBRACK,
    STATE(8182), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282746] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14106), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282761] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14108), 1,
      anon_sym_RBRACK,
    STATE(8188), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282776] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14110), 1,
      anon_sym_RBRACE,
    STATE(8187), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282791] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14112), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282806] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14114), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282821] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14116), 1,
      anon_sym_RBRACE,
    STATE(8210), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282836] = 4,
    ACTIONS(14118), 1,
      anon_sym_RPAREN,
    ACTIONS(14120), 1,
      sym_comma,
    STATE(8366), 1,
      aux_sym_constraints_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282851] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14122), 1,
      anon_sym_RBRACE,
    STATE(8236), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282866] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14124), 1,
      anon_sym_RBRACE,
    STATE(8196), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282881] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14126), 1,
      anon_sym_RBRACK,
    STATE(8237), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282896] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10151), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [282907] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14128), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282922] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14130), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282937] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14132), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [282948] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14134), 1,
      sym__immediate_dot,
    STATE(6662), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282963] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12369), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [282974] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14136), 1,
      anon_sym_RBRACE,
    STATE(8209), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [282989] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14138), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [283000] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14140), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [283011] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14142), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [283022] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14144), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [283033] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14146), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [283044] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14148), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283059] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14150), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283074] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12724), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [283085] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14152), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283100] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14154), 1,
      anon_sym_RBRACK,
    STATE(8220), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283115] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14156), 1,
      anon_sym_RBRACE,
    STATE(8223), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283130] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(2430), 1,
      sym_constructor,
    STATE(8341), 1,
      sym_newtype_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283145] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14158), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283160] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14160), 1,
      anon_sym_RBRACE,
    STATE(8227), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283175] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14162), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [283186] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14164), 1,
      anon_sym_RBRACK,
    STATE(8221), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283201] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14166), 1,
      sym__immediate_dot,
    STATE(5935), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283216] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14168), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283231] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14170), 1,
      anon_sym_RBRACE,
    STATE(8170), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283246] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14172), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283261] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14174), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283276] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14176), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283291] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14178), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283306] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14180), 1,
      anon_sym_RBRACK,
    STATE(8234), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283321] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(5111), 1,
      sym_constructor,
    STATE(7576), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283336] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14182), 1,
      anon_sym_RBRACE,
    STATE(8235), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283351] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14184), 1,
      anon_sym_RBRACE,
    STATE(8252), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283366] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14186), 1,
      anon_sym_RBRACK,
    STATE(8253), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283381] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14188), 1,
      anon_sym_RBRACE,
    STATE(8249), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283396] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14190), 1,
      sym__immediate_dot,
    STATE(1762), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283411] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14192), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [283422] = 3,
    STATE(4824), 1,
      sym__rcarrow,
    ACTIONS(14194), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283435] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14196), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [283446] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14198), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [283457] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14200), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283472] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14202), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283487] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10878), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [283498] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14204), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283513] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14206), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283528] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14208), 1,
      anon_sym_RBRACE,
    STATE(8261), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283543] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14210), 1,
      sym__immediate_dot,
    STATE(1596), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283558] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10220), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [283569] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14212), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283584] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14214), 1,
      anon_sym_RBRACE,
    STATE(8297), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283599] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14146), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [283610] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14144), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [283621] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14216), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283636] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14218), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283651] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14220), 1,
      anon_sym_RBRACE,
    STATE(8271), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283666] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14222), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283681] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14224), 1,
      anon_sym_RBRACE,
    STATE(8313), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283696] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14226), 1,
      anon_sym_RBRACK,
    STATE(8262), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283711] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14228), 1,
      anon_sym_RBRACE,
    STATE(8264), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283726] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14230), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [283737] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14162), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [283748] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14232), 1,
      anon_sym_RBRACK,
    STATE(8274), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283763] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14234), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283778] = 4,
    ACTIONS(13545), 1,
      anon_sym_EQ,
    ACTIONS(14236), 1,
      sym_comma,
    STATE(8367), 1,
      aux_sym_guards_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283793] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14098), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [283804] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14238), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283819] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13934), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [283830] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14240), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283845] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14048), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [283856] = 3,
    STATE(575), 1,
      sym__larrow,
    ACTIONS(14242), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283869] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12135), 1,
      sym__immediate_dot,
    STATE(1841), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283884] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14244), 1,
      anon_sym_RBRACE,
    STATE(8276), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283899] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14246), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283914] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14248), 1,
      sym__immediate_dot,
    STATE(5356), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283929] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8857), 3,
      sym__dot,
      sym_where,
      anon_sym_LPAREN,
  [283940] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14250), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283955] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14252), 1,
      sym__immediate_dot,
    STATE(1697), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283970] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14254), 1,
      anon_sym_RBRACK,
    STATE(8343), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [283985] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(5111), 1,
      sym_constructor,
    STATE(9347), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284000] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(5111), 1,
      sym_constructor,
    STATE(9346), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284015] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(5111), 1,
      sym_constructor,
    STATE(9339), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284030] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(4863), 1,
      sym_constructor,
    STATE(9327), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284045] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14256), 1,
      anon_sym_RBRACE,
    STATE(8301), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284060] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14258), 1,
      anon_sym_RBRACE,
    STATE(8303), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284075] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14260), 1,
      anon_sym_RBRACK,
    STATE(8304), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284090] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14262), 1,
      anon_sym_RBRACK,
    STATE(8306), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284105] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14072), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [284116] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14042), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [284127] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14264), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284142] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14266), 1,
      anon_sym_RBRACK,
    STATE(8250), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284157] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14268), 1,
      anon_sym_RBRACK,
    STATE(8281), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284172] = 4,
    ACTIONS(14270), 1,
      anon_sym_RBRACE,
    ACTIONS(14272), 1,
      sym_comma,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284187] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14275), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284202] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14277), 1,
      anon_sym_RBRACE,
    STATE(8284), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284217] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14279), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284232] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14281), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284247] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14283), 1,
      anon_sym_RBRACE,
    STATE(8312), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284262] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14285), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284277] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14287), 1,
      anon_sym_RBRACE,
    STATE(8393), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284292] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14289), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [284303] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14291), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284318] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14293), 1,
      anon_sym_RBRACE,
    STATE(8309), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284333] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14295), 1,
      anon_sym_RBRACE,
    STATE(8315), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284348] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14297), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284363] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14299), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284378] = 4,
    ACTIONS(14301), 1,
      anon_sym_RBRACK,
    ACTIONS(14303), 1,
      sym_comma,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284393] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14306), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284408] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14308), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [284419] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14310), 1,
      sym__immediate_dot,
    STATE(5046), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284434] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14312), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [284445] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14314), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [284456] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14316), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [284467] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14318), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284482] = 3,
    STATE(1047), 1,
      sym__colon2,
    ACTIONS(14320), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284495] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14322), 1,
      anon_sym_RBRACE,
    STATE(8328), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284510] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14324), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284525] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14326), 1,
      anon_sym_RBRACK,
    STATE(8329), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284540] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14328), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284555] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14330), 1,
      anon_sym_RBRACK,
    STATE(8321), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284570] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14332), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284585] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14334), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284600] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14336), 1,
      sym__immediate_dot,
    STATE(1509), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284615] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13976), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [284626] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14338), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284641] = 4,
    ACTIONS(10722), 1,
      anon_sym_RPAREN,
    ACTIONS(14340), 1,
      sym_comma,
    STATE(8397), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284656] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14342), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284671] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14344), 1,
      anon_sym_RBRACK,
    STATE(8326), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284686] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14346), 1,
      anon_sym_RBRACE,
    STATE(8357), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284701] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14348), 1,
      anon_sym_RBRACE,
    STATE(8332), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284716] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14350), 1,
      anon_sym_RBRACK,
    STATE(8358), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284731] = 4,
    ACTIONS(14352), 1,
      anon_sym_RPAREN,
    ACTIONS(14354), 1,
      sym_comma,
    STATE(8407), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284746] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14356), 1,
      sym__immediate_dot,
    STATE(1781), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284761] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14316), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [284772] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14358), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284787] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14360), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284802] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14362), 1,
      anon_sym_RBRACE,
    STATE(8334), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284817] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14364), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284832] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14366), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284847] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14368), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284862] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14314), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [284873] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14289), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [284884] = 3,
    STATE(4751), 1,
      sym__rcarrow,
    ACTIONS(14370), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284897] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14312), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [284908] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14372), 1,
      anon_sym_RBRACE,
    STATE(8406), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284923] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10429), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [284934] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14374), 1,
      anon_sym_RBRACK,
    STATE(8345), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284949] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10862), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [284960] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14376), 1,
      anon_sym_RBRACE,
    STATE(8346), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284975] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14378), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [284990] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14380), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285005] = 3,
    ACTIONS(13940), 1,
      anon_sym_COLON,
    ACTIONS(14382), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285018] = 3,
    ACTIONS(14384), 1,
      anon_sym_COLON,
    ACTIONS(13946), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285031] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14386), 1,
      anon_sym_RBRACE,
    STATE(8425), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285046] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14388), 1,
      anon_sym_RBRACK,
    STATE(8427), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285061] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12936), 1,
      sym__immediate_dot,
    STATE(2244), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285076] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14390), 1,
      anon_sym_RBRACE,
    STATE(8368), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285091] = 4,
    ACTIONS(11665), 1,
      anon_sym_of,
    ACTIONS(11667), 1,
      sym_comma,
    STATE(8431), 1,
      aux_sym__exp_case_slots_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285106] = 4,
    ACTIONS(14120), 1,
      sym_comma,
    ACTIONS(14392), 1,
      anon_sym_RPAREN,
    STATE(8382), 1,
      aux_sym_constraints_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285121] = 4,
    ACTIONS(13302), 1,
      anon_sym_EQ,
    ACTIONS(14236), 1,
      sym_comma,
    STATE(8435), 1,
      aux_sym_guards_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285136] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14394), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285151] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(11435), 2,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285164] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14162), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285175] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14072), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [285186] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14396), 1,
      anon_sym_RBRACK,
    STATE(8342), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285201] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(2430), 1,
      sym_constructor,
    STATE(8443), 1,
      sym_newtype_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285216] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14398), 1,
      sym__immediate_dot,
    STATE(1545), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285231] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14230), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285242] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14308), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [285253] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14400), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285268] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14402), 1,
      anon_sym_RBRACE,
    STATE(8385), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285283] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14404), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285298] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14406), 1,
      anon_sym_RBRACK,
    STATE(8386), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285313] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14408), 1,
      anon_sym_RBRACE,
    STATE(8347), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285328] = 4,
    ACTIONS(14410), 1,
      anon_sym_RPAREN,
    ACTIONS(14412), 1,
      sym_comma,
    STATE(8382), 1,
      aux_sym_constraints_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285343] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14415), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285358] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14417), 1,
      anon_sym_RBRACK,
    STATE(8377), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285373] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14419), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285388] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14421), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285403] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14423), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285418] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14425), 1,
      anon_sym_RBRACE,
    STATE(8379), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285433] = 3,
    ACTIONS(11298), 1,
      sym__varid,
    STATE(6273), 2,
      sym_type_variable,
      aux_sym_fundep_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285446] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14192), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285457] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14427), 1,
      anon_sym_RBRACE,
    STATE(8383), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285472] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14429), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285487] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14431), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285502] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14433), 1,
      anon_sym_RBRACE,
    STATE(8409), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285517] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13918), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [285528] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13876), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [285539] = 4,
    ACTIONS(10657), 1,
      anon_sym_RPAREN,
    ACTIONS(14435), 1,
      sym_comma,
    STATE(8462), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285554] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(9144), 3,
      sym__varid,
      sym__conid,
      anon_sym_type,
  [285565] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14437), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285580] = 4,
    ACTIONS(10657), 1,
      anon_sym_RPAREN,
    ACTIONS(14435), 1,
      sym_comma,
    STATE(8464), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285595] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14439), 1,
      anon_sym_RBRACK,
    STATE(8412), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285610] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14441), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [285621] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14443), 1,
      anon_sym_RBRACE,
    STATE(8399), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285636] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14445), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285651] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14447), 1,
      anon_sym_RBRACK,
    STATE(8392), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285666] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14449), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285681] = 4,
    ACTIONS(14354), 1,
      sym_comma,
    ACTIONS(14451), 1,
      anon_sym_RPAREN,
    STATE(8480), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285696] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14453), 1,
      sym__immediate_dot,
    STATE(1981), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285711] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14455), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285726] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14096), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285737] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12724), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285748] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14457), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285763] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14459), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [285774] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14461), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285789] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14146), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285800] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14144), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285811] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14463), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285826] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14142), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285837] = 3,
    STATE(4846), 1,
      sym__rcarrow,
    ACTIONS(14465), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285850] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14467), 1,
      anon_sym_RBRACK,
    STATE(8414), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285865] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14469), 1,
      anon_sym_RBRACK,
    STATE(8404), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285880] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14140), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285891] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14138), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [285902] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14471), 1,
      anon_sym_RBRACE,
    STATE(8417), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285917] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14473), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285932] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14198), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [285943] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14475), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285958] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14196), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [285969] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14477), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285984] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14479), 1,
      anon_sym_RBRACE,
    STATE(8429), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [285999] = 4,
    ACTIONS(11667), 1,
      sym_comma,
    ACTIONS(14481), 1,
      anon_sym_of,
    STATE(8499), 1,
      aux_sym__exp_case_slots_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286014] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14483), 1,
      anon_sym_RBRACE,
    STATE(8439), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286029] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14485), 1,
      anon_sym_RBRACE,
    STATE(8522), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286044] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14487), 1,
      anon_sym_RBRACE,
    STATE(8501), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286059] = 4,
    ACTIONS(12822), 1,
      anon_sym_EQ,
    ACTIONS(14489), 1,
      sym_comma,
    STATE(8435), 1,
      aux_sym_guards_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286074] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14492), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286089] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14132), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [286100] = 3,
    STATE(468), 1,
      sym__larrow,
    ACTIONS(14494), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286113] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14496), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286128] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14098), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286139] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14498), 1,
      sym__immediate_dot,
    STATE(4994), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286154] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13934), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286165] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14074), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286176] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14500), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286191] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14502), 1,
      anon_sym_RBRACE,
    STATE(8450), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286206] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14068), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286217] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14504), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286232] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14506), 1,
      anon_sym_RBRACK,
    STATE(8452), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286247] = 3,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(11429), 2,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286260] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14508), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286275] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14510), 1,
      anon_sym_RBRACK,
    STATE(8444), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286290] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14512), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286305] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14514), 1,
      anon_sym_RBRACE,
    STATE(8447), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286320] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14516), 1,
      sym__immediate_dot,
    STATE(5152), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286335] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14056), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286346] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14518), 1,
      anon_sym_RBRACK,
    STATE(8523), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286361] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14520), 1,
      anon_sym_RBRACE,
    STATE(8468), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286376] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14522), 1,
      anon_sym_RBRACK,
    STATE(8471), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286391] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14524), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286406] = 4,
    ACTIONS(14526), 1,
      anon_sym_RPAREN,
    ACTIONS(14528), 1,
      sym_comma,
    STATE(8521), 1,
      aux_sym_import_con_names_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286421] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14530), 1,
      anon_sym_RBRACK,
    STATE(8436), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286436] = 4,
    ACTIONS(14532), 1,
      anon_sym_RPAREN,
    ACTIONS(14534), 1,
      sym_comma,
    STATE(8462), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286451] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(10186), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [286462] = 4,
    ACTIONS(10704), 1,
      anon_sym_RPAREN,
    ACTIONS(14537), 1,
      sym_comma,
    STATE(8462), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286477] = 4,
    ACTIONS(11667), 1,
      sym_comma,
    ACTIONS(14481), 1,
      anon_sym_of,
    STATE(8499), 1,
      aux_sym__exp_case_slots_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286492] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(12369), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [286503] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(8857), 3,
      sym__dot,
      sym_comma,
      anon_sym_RPAREN,
  [286514] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14539), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286529] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14541), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286544] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13856), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286555] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14543), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286570] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14545), 1,
      anon_sym_RBRACE,
    STATE(8459), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286585] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14547), 1,
      anon_sym_RBRACE,
    STATE(8469), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286600] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14549), 1,
      anon_sym_RBRACE,
    STATE(8481), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286615] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14551), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286630] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13856), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286641] = 4,
    ACTIONS(14553), 1,
      anon_sym_RPAREN,
    ACTIONS(14555), 1,
      sym_comma,
    STATE(8529), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286656] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14557), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286671] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14559), 1,
      sym__immediate_dot,
    STATE(4734), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286686] = 4,
    ACTIONS(14561), 1,
      anon_sym_RPAREN,
    ACTIONS(14563), 1,
      sym_comma,
    STATE(8480), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286701] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14566), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286716] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14568), 1,
      anon_sym_RBRACE,
    STATE(8487), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286731] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14048), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286742] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14042), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286753] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14570), 1,
      anon_sym_RBRACK,
    STATE(8496), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286768] = 3,
    STATE(4849), 1,
      sym__rcarrow,
    ACTIONS(14572), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286781] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14574), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286796] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14576), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286811] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14578), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286826] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13860), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [286837] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14580), 1,
      anon_sym_RBRACK,
    STATE(8475), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286852] = 4,
    ACTIONS(14582), 1,
      anon_sym_RBRACE,
    ACTIONS(14584), 1,
      sym_comma,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286867] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14587), 1,
      anon_sym_RBRACE,
    STATE(8478), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286882] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14589), 1,
      anon_sym_RBRACK,
    STATE(8488), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286897] = 4,
    ACTIONS(14591), 1,
      anon_sym_RBRACK,
    ACTIONS(14593), 1,
      sym_comma,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286912] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14596), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286927] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(12776), 1,
      sym__immediate_dot,
    STATE(2264), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286942] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14598), 1,
      anon_sym_RBRACE,
    STATE(8489), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286957] = 4,
    ACTIONS(14600), 1,
      anon_sym_of,
    ACTIONS(14602), 1,
      sym_comma,
    STATE(8499), 1,
      aux_sym__exp_case_slots_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286972] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14605), 1,
      anon_sym_RBRACE,
    STATE(8506), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [286987] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14607), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287002] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13982), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287013] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14609), 1,
      anon_sym_RBRACK,
    STATE(8507), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287028] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13980), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287039] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13976), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [287050] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14611), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287065] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14613), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287080] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13968), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [287091] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14615), 1,
      anon_sym_RBRACE,
    STATE(8520), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287106] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14617), 1,
      sym__immediate_dot,
    STATE(5709), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287121] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(11653), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [287132] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13966), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [287143] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14619), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287158] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14621), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287169] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13998), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287180] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14623), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287195] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14625), 1,
      anon_sym_RBRACE,
    STATE(8599), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287210] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14627), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287225] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14629), 1,
      anon_sym_RBRACE,
    STATE(8516), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287240] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14631), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287255] = 4,
    ACTIONS(14528), 1,
      sym_comma,
    ACTIONS(14633), 1,
      anon_sym_RPAREN,
    STATE(8561), 1,
      aux_sym_import_con_names_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287270] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14635), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287285] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14637), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287300] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14639), 1,
      anon_sym_RBRACE,
    STATE(8531), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287315] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14641), 1,
      anon_sym_RBRACK,
    STATE(8513), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287330] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14643), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287345] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14645), 1,
      anon_sym_RBRACK,
    STATE(8533), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287360] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14647), 1,
      anon_sym_RBRACE,
    STATE(8518), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287375] = 4,
    ACTIONS(14555), 1,
      sym_comma,
    ACTIONS(14649), 1,
      anon_sym_RPAREN,
    STATE(8568), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287390] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14651), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287401] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14653), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287416] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13962), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [287427] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14655), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287442] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14657), 1,
      anon_sym_RBRACE,
    STATE(8581), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287457] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14659), 1,
      sym__immediate_dot,
    STATE(4963), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287472] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14661), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287487] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13956), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
  [287498] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14663), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287513] = 4,
    ACTIONS(14665), 1,
      anon_sym_RBRACE,
    ACTIONS(14667), 1,
      sym_comma,
    STATE(8583), 1,
      aux_sym__record_field_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287528] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14669), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287539] = 4,
    ACTIONS(14671), 1,
      anon_sym_RBRACE,
    ACTIONS(14673), 1,
      sym_comma,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287554] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14676), 1,
      anon_sym_RBRACE,
    STATE(8536), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287569] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14678), 1,
      anon_sym_RBRACE,
    STATE(8551), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287584] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13944), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287595] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14680), 1,
      anon_sym_RBRACK,
    STATE(8553), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287610] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14682), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287625] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13954), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287636] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13918), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [287647] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14684), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287662] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13898), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [287673] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14686), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287688] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13994), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287699] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14688), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287714] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13892), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [287725] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14690), 1,
      anon_sym_RBRACK,
    STATE(8526), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287740] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14692), 1,
      anon_sym_RBRACE,
    STATE(8538), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287755] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13952), 3,
      anon_sym_u2190,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
  [287766] = 4,
    ACTIONS(14694), 1,
      anon_sym_RBRACE,
    ACTIONS(14696), 1,
      sym_comma,
    STATE(8558), 1,
      aux_sym__record_field_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287781] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14699), 1,
      sym__immediate_dot,
    STATE(2735), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287796] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14701), 1,
      anon_sym_RBRACE,
    STATE(8600), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287811] = 4,
    ACTIONS(14703), 1,
      anon_sym_RPAREN,
    ACTIONS(14705), 1,
      sym_comma,
    STATE(8561), 1,
      aux_sym_import_con_names_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287826] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14708), 1,
      anon_sym_RBRACE,
    STATE(8569), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287841] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14710), 1,
      anon_sym_RBRACK,
    STATE(8546), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287856] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14712), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287871] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14714), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287886] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14716), 1,
      anon_sym_RBRACK,
    STATE(8564), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287901] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14718), 1,
      anon_sym_RBRACE,
    STATE(8549), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287916] = 4,
    ACTIONS(14720), 1,
      anon_sym_RPAREN,
    ACTIONS(14722), 1,
      sym_comma,
    STATE(8568), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287931] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14725), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287946] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14727), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287957] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13886), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [287968] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14729), 1,
      anon_sym_RBRACE,
    STATE(8576), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [287983] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13916), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [287994] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14040), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [288005] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14731), 1,
      anon_sym_RBRACK,
    STATE(8580), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288020] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14733), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288035] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14735), 1,
      anon_sym_RBRACE,
    STATE(8565), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288050] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14040), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [288061] = 3,
    STATE(526), 1,
      sym__arrow,
    ACTIONS(14737), 2,
      anon_sym_u2192,
      anon_sym_DASH_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288074] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14739), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288089] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14741), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288104] = 3,
    STATE(6852), 1,
      sym__lcarrow,
    ACTIONS(14743), 2,
      anon_sym_u21d0,
      anon_sym_LT_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288117] = 4,
    ACTIONS(14667), 1,
      sym_comma,
    ACTIONS(14745), 1,
      anon_sym_RBRACE,
    STATE(8558), 1,
      aux_sym__record_field_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288132] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13874), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [288143] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(11663), 1,
      sym__immediate_dot,
    STATE(2139), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288158] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13876), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [288169] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13870), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [288180] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14747), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [288191] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13870), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [288202] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14747), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [288213] = 4,
    ACTIONS(10319), 1,
      anon_sym_LBRACE,
    ACTIONS(14749), 1,
      sym__immediate_dot,
    STATE(1616), 1,
      aux_sym_record_accessor_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288228] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(13868), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [288239] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14751), 1,
      anon_sym_RBRACK,
    STATE(8602), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288254] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14753), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [288265] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14755), 1,
      anon_sym_RBRACK,
    STATE(8314), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288280] = 3,
    STATE(4847), 1,
      sym__rcarrow,
    ACTIONS(14757), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288293] = 2,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
    ACTIONS(14026), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [288304] = 3,
    STATE(444), 1,
      sym__larrow,
    ACTIONS(14759), 2,
      anon_sym_u2190,
      anon_sym_LT_DASH,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288317] = 4,
    ACTIONS(13832), 1,
      sym_comma,
    ACTIONS(14761), 1,
      anon_sym_RBRACE,
    STATE(8492), 1,
      aux_sym_record_literal_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288332] = 4,
    ACTIONS(13828), 1,
      sym_comma,
    ACTIONS(14763), 1,
      anon_sym_RBRACE,
    STATE(8300), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288347] = 3,
    STATE(4907), 1,
      sym__rcarrow,
    ACTIONS(14765), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288360] = 4,
    ACTIONS(13836), 1,
      sym_comma,
    ACTIONS(14767), 1,
      anon_sym_RBRACK,
    STATE(8495), 1,
      aux_sym_exp_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288375] = 3,
    STATE(4888), 1,
      sym__rcarrow,
    ACTIONS(14769), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288388] = 3,
    STATE(6845), 1,
      sym__rcarrow,
    ACTIONS(14771), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288401] = 4,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(5111), 1,
      sym_constructor,
    STATE(7885), 1,
      sym__simpletype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288416] = 3,
    STATE(4811), 1,
      sym__rcarrow,
    ACTIONS(14773), 2,
      anon_sym_u21d2,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288429] = 4,
    ACTIONS(13848), 1,
      sym_comma,
    ACTIONS(14775), 1,
      anon_sym_RBRACK,
    STATE(8595), 1,
      aux_sym_pat_array_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288444] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14777), 1,
      anon_sym_RBRACE,
    STATE(8609), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288459] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14779), 1,
      anon_sym_RBRACE,
    STATE(8541), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288474] = 4,
    ACTIONS(13840), 1,
      sym_comma,
    ACTIONS(14781), 1,
      anon_sym_RBRACE,
    STATE(8232), 1,
      aux_sym_record_update_repeat1,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288489] = 2,
    ACTIONS(14783), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288499] = 3,
    ACTIONS(14785), 1,
      sym__layout_start,
    STATE(8413), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288511] = 3,
    ACTIONS(14787), 1,
      sym__layout_start,
    STATE(5429), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288523] = 3,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(14789), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288535] = 3,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(14791), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288547] = 2,
    ACTIONS(14793), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288557] = 2,
    ACTIONS(10981), 2,
      sym__operator,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288567] = 3,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(7111), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288579] = 2,
    ACTIONS(10151), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288589] = 2,
    ACTIONS(14795), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288599] = 3,
    ACTIONS(14797), 1,
      anon_sym_newtype,
    ACTIONS(14799), 1,
      anon_sym_instance,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288611] = 3,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(14801), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288623] = 3,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(14803), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288635] = 2,
    ACTIONS(14805), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288645] = 2,
    ACTIONS(14720), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288655] = 2,
    ACTIONS(14807), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288665] = 2,
    ACTIONS(14809), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288675] = 2,
    ACTIONS(14703), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288685] = 2,
    ACTIONS(14811), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288695] = 3,
    ACTIONS(14813), 1,
      sym__layout_start,
    STATE(6298), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288707] = 2,
    ACTIONS(14671), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288717] = 2,
    ACTIONS(12137), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288727] = 2,
    ACTIONS(10220), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288737] = 2,
    ACTIONS(14815), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288747] = 2,
    ACTIONS(14817), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288757] = 3,
    ACTIONS(14819), 1,
      sym__layout_start,
    STATE(7219), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288769] = 3,
    ACTIONS(14821), 1,
      sym__layout_start,
    STATE(5445), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288781] = 2,
    ACTIONS(14823), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288791] = 2,
    ACTIONS(14825), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288801] = 2,
    ACTIONS(14827), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288811] = 2,
    ACTIONS(12301), 2,
      sym_comma,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288821] = 2,
    ACTIONS(14591), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288831] = 2,
    ACTIONS(14582), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288841] = 2,
    ACTIONS(14829), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288851] = 2,
    ACTIONS(14831), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288861] = 2,
    ACTIONS(14561), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288871] = 2,
    ACTIONS(14833), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288881] = 3,
    ACTIONS(14835), 1,
      sym__layout_start,
    STATE(6210), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288893] = 2,
    ACTIONS(13012), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288903] = 2,
    ACTIONS(14532), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288913] = 2,
    ACTIONS(14837), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288923] = 2,
    ACTIONS(14839), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288933] = 3,
    ACTIONS(14785), 1,
      sym__layout_start,
    STATE(8502), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288945] = 3,
    ACTIONS(14841), 1,
      anon_sym_LBRACE,
    ACTIONS(14843), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288957] = 3,
    ACTIONS(14845), 1,
      sym__layout_start,
    STATE(5118), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288969] = 3,
    ACTIONS(14847), 1,
      sym__layout_start,
    STATE(6813), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288981] = 2,
    ACTIONS(14849), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [288991] = 3,
    ACTIONS(14851), 1,
      sym__layout_start,
    STATE(6083), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289003] = 2,
    ACTIONS(10878), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289013] = 2,
    ACTIONS(10280), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289023] = 3,
    ACTIONS(14853), 1,
      sym__operator,
    STATE(8484), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289035] = 3,
    ACTIONS(14853), 1,
      sym__operator,
    STATE(8483), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289047] = 3,
    ACTIONS(14855), 1,
      sym__conid,
    STATE(849), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289059] = 2,
    ACTIONS(14857), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289069] = 2,
    ACTIONS(14859), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289079] = 2,
    ACTIONS(14861), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289089] = 2,
    ACTIONS(14863), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289099] = 3,
    ACTIONS(14865), 1,
      sym__layout_start,
    STATE(5209), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289111] = 3,
    ACTIONS(14867), 1,
      sym__operator,
    STATE(9655), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289123] = 2,
    ACTIONS(10643), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289133] = 2,
    ACTIONS(14410), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289143] = 3,
    ACTIONS(14855), 1,
      sym__conid,
    STATE(831), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289155] = 3,
    ACTIONS(14869), 1,
      sym__layout_start,
    STATE(8440), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289167] = 3,
    ACTIONS(14871), 1,
      sym__layout_start,
    STATE(5234), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289179] = 3,
    ACTIONS(14853), 1,
      sym__operator,
    STATE(8416), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289191] = 3,
    ACTIONS(14853), 1,
      sym__operator,
    STATE(8415), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289203] = 3,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(14873), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289215] = 3,
    ACTIONS(14875), 1,
      ts_builtin_sym_end,
    ACTIONS(14877), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289227] = 2,
    ACTIONS(12802), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289237] = 2,
    ACTIONS(14879), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289247] = 2,
    ACTIONS(14881), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289257] = 2,
    ACTIONS(14883), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289267] = 2,
    ACTIONS(10429), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289277] = 3,
    ACTIONS(14885), 1,
      sym__layout_start,
    STATE(6664), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289289] = 2,
    ACTIONS(10862), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289299] = 2,
    ACTIONS(14301), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289309] = 3,
    ACTIONS(14887), 1,
      sym__layout_start,
    STATE(5585), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289321] = 2,
    ACTIONS(14270), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289331] = 2,
    ACTIONS(14889), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289341] = 3,
    ACTIONS(14869), 1,
      sym__layout_start,
    STATE(8370), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289353] = 3,
    ACTIONS(14785), 1,
      sym__layout_start,
    STATE(8402), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289365] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9356), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289377] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9402), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289389] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9762), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289401] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9423), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289413] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(8741), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289425] = 2,
    ACTIONS(10244), 2,
      anon_sym_u2237,
      anon_sym_COLON_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289435] = 3,
    ACTIONS(14893), 1,
      sym__layout_start,
    STATE(6112), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289447] = 3,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(14895), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289459] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9459), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289471] = 3,
    ACTIONS(14897), 1,
      sym__layout_start,
    STATE(6183), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289483] = 3,
    ACTIONS(14899), 1,
      sym__operator,
    STATE(8296), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289495] = 3,
    ACTIONS(14899), 1,
      sym__operator,
    STATE(8277), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289507] = 2,
    ACTIONS(14901), 2,
      anon_sym_LPAREN,
      sym__conid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289517] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9476), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289529] = 3,
    ACTIONS(14855), 1,
      sym__conid,
    STATE(832), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289541] = 3,
    ACTIONS(14903), 1,
      ts_builtin_sym_end,
    ACTIONS(14905), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289553] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9492), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289565] = 3,
    ACTIONS(14907), 1,
      sym__layout_start,
    STATE(8273), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289577] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9508), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289589] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9524), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289601] = 3,
    ACTIONS(14899), 1,
      sym__operator,
    STATE(8260), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289613] = 3,
    ACTIONS(14899), 1,
      sym__operator,
    STATE(8259), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289625] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9540), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289637] = 3,
    ACTIONS(14907), 1,
      sym__layout_start,
    STATE(8229), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289649] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9556), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289661] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9571), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289673] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9586), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289685] = 2,
    ACTIONS(13952), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289695] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9601), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289707] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9615), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289719] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9629), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289731] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9643), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289743] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9657), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289755] = 3,
    ACTIONS(14907), 1,
      sym__layout_start,
    STATE(8125), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289767] = 3,
    ACTIONS(14891), 1,
      sym__layout_start,
    STATE(9671), 1,
      sym__let_decls,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289779] = 3,
    ACTIONS(14909), 1,
      sym__layout_start,
    STATE(5679), 1,
      sym_alts,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289791] = 3,
    ACTIONS(14911), 1,
      sym__operator,
    STATE(8157), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289803] = 3,
    ACTIONS(14911), 1,
      sym__operator,
    STATE(8160), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289815] = 3,
    ACTIONS(13006), 1,
      sym__conid,
    STATE(7278), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289827] = 3,
    ACTIONS(14913), 1,
      sym__conid,
    STATE(839), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289839] = 2,
    ACTIONS(14915), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289849] = 3,
    ACTIONS(14913), 1,
      sym__conid,
    STATE(837), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289861] = 3,
    ACTIONS(14785), 1,
      sym__layout_start,
    STATE(8194), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289873] = 3,
    ACTIONS(14911), 1,
      sym__operator,
    STATE(8218), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289885] = 3,
    ACTIONS(14911), 1,
      sym__operator,
    STATE(8219), 1,
      sym_operator,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289897] = 3,
    ACTIONS(14785), 1,
      sym__layout_start,
    STATE(8269), 1,
      sym_declarations,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289909] = 3,
    ACTIONS(14913), 1,
      sym__conid,
    STATE(838), 1,
      sym_constructor,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289921] = 3,
    ACTIONS(14917), 1,
      anon_sym_newtype,
    ACTIONS(14919), 1,
      anon_sym_instance,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289933] = 2,
    ACTIONS(14921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289942] = 2,
    ACTIONS(14923), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289951] = 2,
    ACTIONS(14925), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289960] = 2,
    ACTIONS(14927), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289969] = 2,
    ACTIONS(14929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289978] = 2,
    ACTIONS(14931), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289987] = 2,
    ACTIONS(14933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [289996] = 2,
    ACTIONS(14935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290005] = 2,
    ACTIONS(12446), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290014] = 2,
    ACTIONS(14937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290023] = 2,
    ACTIONS(12440), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290032] = 2,
    ACTIONS(14939), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290041] = 2,
    ACTIONS(12436), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290050] = 2,
    ACTIONS(12438), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290059] = 2,
    ACTIONS(14941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290068] = 2,
    ACTIONS(12434), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290077] = 2,
    ACTIONS(14943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290086] = 2,
    ACTIONS(14945), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290095] = 2,
    ACTIONS(14947), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290104] = 2,
    ACTIONS(14949), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290113] = 2,
    ACTIONS(12432), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290122] = 2,
    ACTIONS(14951), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290131] = 2,
    ACTIONS(14953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290140] = 2,
    ACTIONS(14955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290149] = 2,
    ACTIONS(12410), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290158] = 2,
    ACTIONS(14957), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290167] = 2,
    ACTIONS(14959), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290176] = 2,
    ACTIONS(12408), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290185] = 2,
    ACTIONS(14961), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290194] = 2,
    ACTIONS(12406), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290203] = 2,
    ACTIONS(14963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290212] = 2,
    ACTIONS(12400), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290221] = 2,
    ACTIONS(14965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290230] = 2,
    ACTIONS(14967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290239] = 2,
    ACTIONS(14969), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290248] = 2,
    ACTIONS(14971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290257] = 2,
    ACTIONS(14973), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290266] = 2,
    ACTIONS(14975), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290275] = 2,
    ACTIONS(14977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290284] = 2,
    ACTIONS(12398), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290293] = 2,
    ACTIONS(14979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290302] = 2,
    ACTIONS(14981), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290311] = 2,
    ACTIONS(12379), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290320] = 2,
    ACTIONS(14983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290329] = 2,
    ACTIONS(12361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290338] = 2,
    ACTIONS(14985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290347] = 2,
    ACTIONS(12357), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290356] = 2,
    ACTIONS(14987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290365] = 2,
    ACTIONS(14989), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290374] = 2,
    ACTIONS(14991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290383] = 2,
    ACTIONS(14993), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290392] = 2,
    ACTIONS(14995), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290401] = 2,
    ACTIONS(14997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290410] = 2,
    ACTIONS(14999), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290419] = 2,
    ACTIONS(12347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290428] = 2,
    ACTIONS(15001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290437] = 2,
    ACTIONS(12345), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290446] = 2,
    ACTIONS(15003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290455] = 2,
    ACTIONS(12341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290464] = 2,
    ACTIONS(15005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290473] = 2,
    ACTIONS(12339), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290482] = 2,
    ACTIONS(12343), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290491] = 2,
    ACTIONS(15007), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290500] = 2,
    ACTIONS(15009), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290509] = 2,
    ACTIONS(15011), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290518] = 2,
    ACTIONS(15013), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290527] = 2,
    ACTIONS(15015), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290536] = 2,
    ACTIONS(12337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290545] = 2,
    ACTIONS(15017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290554] = 2,
    ACTIONS(15019), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290563] = 2,
    ACTIONS(12333), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290572] = 2,
    ACTIONS(15021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290581] = 2,
    ACTIONS(12472), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290590] = 2,
    ACTIONS(12331), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290599] = 2,
    ACTIONS(15023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290608] = 2,
    ACTIONS(12329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290617] = 2,
    ACTIONS(15025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290626] = 2,
    ACTIONS(15027), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290635] = 2,
    ACTIONS(12323), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290644] = 2,
    ACTIONS(15029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290653] = 2,
    ACTIONS(15031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290662] = 2,
    ACTIONS(15033), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290671] = 2,
    ACTIONS(15035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290680] = 2,
    ACTIONS(12321), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290689] = 2,
    ACTIONS(15037), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290698] = 2,
    ACTIONS(15039), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290707] = 2,
    ACTIONS(12313), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290716] = 2,
    ACTIONS(15041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290725] = 2,
    ACTIONS(15043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290734] = 2,
    ACTIONS(12309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290743] = 2,
    ACTIONS(15045), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290752] = 2,
    ACTIONS(12466), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290761] = 2,
    ACTIONS(12293), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290770] = 2,
    ACTIONS(15047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290779] = 2,
    ACTIONS(12291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290788] = 2,
    ACTIONS(12462), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290797] = 2,
    ACTIONS(15049), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290806] = 2,
    ACTIONS(12289), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290815] = 2,
    ACTIONS(15051), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290824] = 2,
    ACTIONS(15053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290833] = 2,
    ACTIONS(15055), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290842] = 2,
    ACTIONS(15057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290851] = 2,
    ACTIONS(15059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290860] = 2,
    ACTIONS(15061), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290869] = 2,
    ACTIONS(15063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290878] = 2,
    ACTIONS(15065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290887] = 2,
    ACTIONS(15067), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290896] = 2,
    ACTIONS(12464), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290905] = 2,
    ACTIONS(12277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290914] = 2,
    ACTIONS(15069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290923] = 2,
    ACTIONS(15071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290932] = 2,
    ACTIONS(12275), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290941] = 2,
    ACTIONS(15073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290950] = 2,
    ACTIONS(12273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290959] = 2,
    ACTIONS(15075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290968] = 2,
    ACTIONS(15077), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290977] = 2,
    ACTIONS(12271), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290986] = 2,
    ACTIONS(15079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [290995] = 2,
    ACTIONS(15081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291004] = 2,
    ACTIONS(15083), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291013] = 2,
    ACTIONS(15085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291022] = 2,
    ACTIONS(15087), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291031] = 2,
    ACTIONS(15089), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291040] = 2,
    ACTIONS(12468), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291049] = 2,
    ACTIONS(15091), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291058] = 2,
    ACTIONS(15093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291067] = 2,
    ACTIONS(15095), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291076] = 2,
    ACTIONS(12239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291085] = 2,
    ACTIONS(15097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291094] = 2,
    ACTIONS(15099), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291103] = 2,
    ACTIONS(12237), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291112] = 2,
    ACTIONS(15101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291121] = 2,
    ACTIONS(12235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291130] = 2,
    ACTIONS(15103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291139] = 2,
    ACTIONS(15105), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291148] = 2,
    ACTIONS(12231), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291157] = 2,
    ACTIONS(12470), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291166] = 2,
    ACTIONS(15107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291175] = 2,
    ACTIONS(15109), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291184] = 2,
    ACTIONS(15111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291193] = 2,
    ACTIONS(12233), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291202] = 2,
    ACTIONS(15113), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291211] = 2,
    ACTIONS(15115), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291220] = 2,
    ACTIONS(12229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291229] = 2,
    ACTIONS(15117), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291238] = 2,
    ACTIONS(15119), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291247] = 2,
    ACTIONS(12219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291256] = 2,
    ACTIONS(15121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291265] = 2,
    ACTIONS(15123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291274] = 2,
    ACTIONS(12217), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291283] = 2,
    ACTIONS(15125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291292] = 2,
    ACTIONS(12215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291301] = 2,
    ACTIONS(15127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291310] = 2,
    ACTIONS(15129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291319] = 2,
    ACTIONS(12213), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291328] = 2,
    ACTIONS(15131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291337] = 2,
    ACTIONS(15133), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291346] = 2,
    ACTIONS(15135), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291355] = 2,
    ACTIONS(15137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291364] = 2,
    ACTIONS(15139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291373] = 2,
    ACTIONS(15141), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291382] = 2,
    ACTIONS(12203), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291391] = 2,
    ACTIONS(15143), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291400] = 2,
    ACTIONS(15145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291409] = 2,
    ACTIONS(12195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291418] = 2,
    ACTIONS(12193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291427] = 2,
    ACTIONS(15147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291436] = 2,
    ACTIONS(15149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291445] = 2,
    ACTIONS(12191), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291454] = 2,
    ACTIONS(15151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291463] = 2,
    ACTIONS(12179), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291472] = 2,
    ACTIONS(15153), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291481] = 2,
    ACTIONS(15155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291490] = 2,
    ACTIONS(12177), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291499] = 2,
    ACTIONS(15157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291508] = 2,
    ACTIONS(15159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291517] = 2,
    ACTIONS(15161), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291526] = 2,
    ACTIONS(15163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291535] = 2,
    ACTIONS(15165), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291544] = 2,
    ACTIONS(15167), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291553] = 2,
    ACTIONS(15169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291562] = 2,
    ACTIONS(15171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291571] = 2,
    ACTIONS(15173), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291580] = 2,
    ACTIONS(15175), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291589] = 2,
    ACTIONS(12165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291598] = 2,
    ACTIONS(15177), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291607] = 2,
    ACTIONS(15179), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291616] = 2,
    ACTIONS(12163), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291625] = 2,
    ACTIONS(15181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291634] = 2,
    ACTIONS(12161), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291643] = 2,
    ACTIONS(15183), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291652] = 2,
    ACTIONS(15185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291661] = 2,
    ACTIONS(12121), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291670] = 2,
    ACTIONS(15187), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291679] = 2,
    ACTIONS(15189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291688] = 2,
    ACTIONS(15191), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291697] = 2,
    ACTIONS(15193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291706] = 2,
    ACTIONS(15195), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291715] = 2,
    ACTIONS(15197), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291724] = 2,
    ACTIONS(15199), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291733] = 2,
    ACTIONS(15201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291742] = 2,
    ACTIONS(15203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291751] = 2,
    ACTIONS(12486), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291760] = 2,
    ACTIONS(12101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291769] = 2,
    ACTIONS(15205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291778] = 2,
    ACTIONS(15207), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291787] = 2,
    ACTIONS(12099), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291796] = 2,
    ACTIONS(15209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291805] = 2,
    ACTIONS(12097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291814] = 2,
    ACTIONS(12488), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291823] = 2,
    ACTIONS(15211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291832] = 2,
    ACTIONS(12093), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291841] = 2,
    ACTIONS(15213), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291850] = 2,
    ACTIONS(15215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291859] = 2,
    ACTIONS(15217), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291868] = 2,
    ACTIONS(15219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291877] = 2,
    ACTIONS(12095), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291886] = 2,
    ACTIONS(15221), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291895] = 2,
    ACTIONS(15223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291904] = 2,
    ACTIONS(12087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291913] = 2,
    ACTIONS(15225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291922] = 2,
    ACTIONS(15227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291931] = 2,
    ACTIONS(12079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291940] = 2,
    ACTIONS(15229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291949] = 2,
    ACTIONS(12494), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291958] = 2,
    ACTIONS(12077), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291967] = 2,
    ACTIONS(15231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291976] = 2,
    ACTIONS(12075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291985] = 2,
    ACTIONS(15233), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [291994] = 2,
    ACTIONS(15235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292003] = 2,
    ACTIONS(12073), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292012] = 2,
    ACTIONS(15237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292021] = 2,
    ACTIONS(15239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292030] = 2,
    ACTIONS(15241), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292039] = 2,
    ACTIONS(15243), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292048] = 2,
    ACTIONS(15245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292057] = 2,
    ACTIONS(15247), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292066] = 2,
    ACTIONS(12065), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292075] = 2,
    ACTIONS(15249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292084] = 2,
    ACTIONS(15251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292093] = 2,
    ACTIONS(12059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292102] = 2,
    ACTIONS(12057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292111] = 2,
    ACTIONS(15253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292120] = 2,
    ACTIONS(15255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292129] = 2,
    ACTIONS(12055), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292138] = 2,
    ACTIONS(15257), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292147] = 2,
    ACTIONS(12043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292156] = 2,
    ACTIONS(15259), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292165] = 2,
    ACTIONS(15261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292174] = 2,
    ACTIONS(12041), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292183] = 2,
    ACTIONS(12519), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292192] = 2,
    ACTIONS(15263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292201] = 2,
    ACTIONS(15265), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292210] = 2,
    ACTIONS(15267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292219] = 2,
    ACTIONS(12525), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292228] = 2,
    ACTIONS(15269), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292237] = 2,
    ACTIONS(15271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292246] = 2,
    ACTIONS(15273), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292255] = 2,
    ACTIONS(15275), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292264] = 2,
    ACTIONS(15277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292273] = 2,
    ACTIONS(12025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292282] = 2,
    ACTIONS(15279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292291] = 2,
    ACTIONS(15281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292300] = 2,
    ACTIONS(12023), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292309] = 2,
    ACTIONS(15283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292318] = 2,
    ACTIONS(12021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292327] = 2,
    ACTIONS(15285), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292336] = 2,
    ACTIONS(15287), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292345] = 2,
    ACTIONS(12019), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292354] = 2,
    ACTIONS(15289), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292363] = 2,
    ACTIONS(15291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292372] = 2,
    ACTIONS(15293), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292381] = 2,
    ACTIONS(15295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292390] = 2,
    ACTIONS(15297), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292399] = 2,
    ACTIONS(15299), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292408] = 2,
    ACTIONS(15301), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292417] = 2,
    ACTIONS(15303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292426] = 2,
    ACTIONS(15305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292435] = 2,
    ACTIONS(11954), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292444] = 2,
    ACTIONS(15307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292453] = 2,
    ACTIONS(15309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292462] = 2,
    ACTIONS(11950), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292471] = 2,
    ACTIONS(15311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292480] = 2,
    ACTIONS(11948), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292489] = 2,
    ACTIONS(12523), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292498] = 2,
    ACTIONS(15313), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292507] = 2,
    ACTIONS(11946), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292516] = 2,
    ACTIONS(15315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292525] = 2,
    ACTIONS(15317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292534] = 2,
    ACTIONS(15319), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292543] = 2,
    ACTIONS(15321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292552] = 2,
    ACTIONS(15323), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292561] = 2,
    ACTIONS(11944), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292570] = 2,
    ACTIONS(15325), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292579] = 2,
    ACTIONS(15327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292588] = 2,
    ACTIONS(11942), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292597] = 2,
    ACTIONS(11936), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292606] = 2,
    ACTIONS(15329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292615] = 2,
    ACTIONS(15331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292624] = 2,
    ACTIONS(11930), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292633] = 2,
    ACTIONS(15333), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292642] = 2,
    ACTIONS(11928), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292651] = 2,
    ACTIONS(15335), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292660] = 2,
    ACTIONS(15337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292669] = 2,
    ACTIONS(11926), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292678] = 2,
    ACTIONS(12527), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292687] = 2,
    ACTIONS(15339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292696] = 2,
    ACTIONS(15341), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292705] = 2,
    ACTIONS(15343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292714] = 2,
    ACTIONS(15345), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292723] = 2,
    ACTIONS(15347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292732] = 2,
    ACTIONS(11913), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292741] = 2,
    ACTIONS(15349), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292750] = 2,
    ACTIONS(15351), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292759] = 2,
    ACTIONS(11909), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292768] = 2,
    ACTIONS(15353), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292777] = 2,
    ACTIONS(11907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292786] = 2,
    ACTIONS(11905), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292795] = 2,
    ACTIONS(15355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292804] = 2,
    ACTIONS(11903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292813] = 2,
    ACTIONS(15357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292822] = 2,
    ACTIONS(15359), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292831] = 2,
    ACTIONS(11893), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292840] = 2,
    ACTIONS(15361), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292849] = 2,
    ACTIONS(15363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292858] = 2,
    ACTIONS(15365), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292867] = 2,
    ACTIONS(15367), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292876] = 2,
    ACTIONS(15369), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292885] = 2,
    ACTIONS(15371), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292894] = 2,
    ACTIONS(12529), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292903] = 2,
    ACTIONS(15373), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292912] = 2,
    ACTIONS(15375), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292921] = 2,
    ACTIONS(11885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292930] = 2,
    ACTIONS(15377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292939] = 2,
    ACTIONS(15379), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292948] = 2,
    ACTIONS(11883), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292957] = 2,
    ACTIONS(15381), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292966] = 2,
    ACTIONS(11881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292975] = 2,
    ACTIONS(15383), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292984] = 2,
    ACTIONS(15385), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [292993] = 2,
    ACTIONS(11879), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293002] = 2,
    ACTIONS(15387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293011] = 2,
    ACTIONS(15389), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293020] = 2,
    ACTIONS(15391), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293029] = 2,
    ACTIONS(15393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293038] = 2,
    ACTIONS(15395), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293047] = 2,
    ACTIONS(15397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293056] = 2,
    ACTIONS(15399), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293065] = 2,
    ACTIONS(15401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293074] = 2,
    ACTIONS(15403), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293083] = 2,
    ACTIONS(11825), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293092] = 2,
    ACTIONS(15405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293101] = 2,
    ACTIONS(15407), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293110] = 2,
    ACTIONS(11821), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293119] = 2,
    ACTIONS(15409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293128] = 2,
    ACTIONS(11819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293137] = 2,
    ACTIONS(15411), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293146] = 2,
    ACTIONS(15413), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293155] = 2,
    ACTIONS(11817), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293164] = 2,
    ACTIONS(15415), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293173] = 2,
    ACTIONS(15417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293182] = 2,
    ACTIONS(15419), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293191] = 2,
    ACTIONS(12535), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293200] = 2,
    ACTIONS(15421), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293209] = 2,
    ACTIONS(12533), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293218] = 2,
    ACTIONS(11815), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293227] = 2,
    ACTIONS(15423), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293236] = 2,
    ACTIONS(15425), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293245] = 2,
    ACTIONS(11809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293254] = 2,
    ACTIONS(15427), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293263] = 2,
    ACTIONS(11811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293272] = 2,
    ACTIONS(11807), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293281] = 2,
    ACTIONS(15429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293290] = 2,
    ACTIONS(11799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293299] = 2,
    ACTIONS(15431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293308] = 2,
    ACTIONS(15433), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293317] = 2,
    ACTIONS(11797), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293326] = 2,
    ACTIONS(15435), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293335] = 2,
    ACTIONS(15437), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293344] = 2,
    ACTIONS(15439), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293353] = 2,
    ACTIONS(15441), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293362] = 2,
    ACTIONS(15443), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293371] = 2,
    ACTIONS(15445), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293380] = 2,
    ACTIONS(15447), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293389] = 2,
    ACTIONS(15449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293398] = 2,
    ACTIONS(11787), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293407] = 2,
    ACTIONS(11785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293416] = 2,
    ACTIONS(15451), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293425] = 2,
    ACTIONS(15453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293434] = 2,
    ACTIONS(11783), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293443] = 2,
    ACTIONS(15455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293452] = 2,
    ACTIONS(11779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293461] = 2,
    ACTIONS(11781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293470] = 2,
    ACTIONS(15457), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293479] = 2,
    ACTIONS(11777), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293488] = 2,
    ACTIONS(15459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293497] = 2,
    ACTIONS(15461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293506] = 2,
    ACTIONS(15463), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293515] = 2,
    ACTIONS(15465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293524] = 2,
    ACTIONS(15467), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293533] = 2,
    ACTIONS(12537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293542] = 2,
    ACTIONS(15469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293551] = 2,
    ACTIONS(15471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293560] = 2,
    ACTIONS(15473), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293569] = 2,
    ACTIONS(11763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293578] = 2,
    ACTIONS(15475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293587] = 2,
    ACTIONS(12539), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293596] = 2,
    ACTIONS(11761), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293605] = 2,
    ACTIONS(15477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293614] = 2,
    ACTIONS(11759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293623] = 2,
    ACTIONS(15479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293632] = 2,
    ACTIONS(15481), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293641] = 2,
    ACTIONS(11757), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293650] = 2,
    ACTIONS(12541), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293659] = 2,
    ACTIONS(15483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293668] = 2,
    ACTIONS(15485), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293677] = 2,
    ACTIONS(15487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293686] = 2,
    ACTIONS(15489), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293695] = 2,
    ACTIONS(15491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293704] = 2,
    ACTIONS(15493), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293713] = 2,
    ACTIONS(15495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293722] = 2,
    ACTIONS(12543), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293731] = 2,
    ACTIONS(11721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293740] = 2,
    ACTIONS(15497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293749] = 2,
    ACTIONS(15499), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293758] = 2,
    ACTIONS(11719), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293767] = 2,
    ACTIONS(15501), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293776] = 2,
    ACTIONS(11713), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293785] = 2,
    ACTIONS(15503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293794] = 2,
    ACTIONS(15505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293803] = 2,
    ACTIONS(11707), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293812] = 2,
    ACTIONS(15507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293821] = 2,
    ACTIONS(15509), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293830] = 2,
    ACTIONS(15511), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293839] = 2,
    ACTIONS(15513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293848] = 2,
    ACTIONS(15515), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293857] = 2,
    ACTIONS(15517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293866] = 2,
    ACTIONS(15519), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293875] = 2,
    ACTIONS(15521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293884] = 2,
    ACTIONS(11699), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293893] = 2,
    ACTIONS(11695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293902] = 2,
    ACTIONS(15523), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293911] = 2,
    ACTIONS(15525), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293920] = 2,
    ACTIONS(11691), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293929] = 2,
    ACTIONS(15527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293938] = 2,
    ACTIONS(11689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293947] = 2,
    ACTIONS(11693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293956] = 2,
    ACTIONS(15529), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293965] = 2,
    ACTIONS(11679), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293974] = 2,
    ACTIONS(15531), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293983] = 2,
    ACTIONS(15533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [293992] = 2,
    ACTIONS(15535), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294001] = 2,
    ACTIONS(15537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294010] = 2,
    ACTIONS(15539), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294019] = 2,
    ACTIONS(15541), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294028] = 2,
    ACTIONS(15543), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294037] = 2,
    ACTIONS(15545), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294046] = 2,
    ACTIONS(15547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294055] = 2,
    ACTIONS(12153), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294064] = 2,
    ACTIONS(15549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294073] = 2,
    ACTIONS(15551), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294082] = 2,
    ACTIONS(11687), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294091] = 2,
    ACTIONS(15553), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294100] = 2,
    ACTIONS(11701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294109] = 2,
    ACTIONS(11697), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294118] = 2,
    ACTIONS(15555), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294127] = 2,
    ACTIONS(11709), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294136] = 2,
    ACTIONS(15557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294145] = 2,
    ACTIONS(15559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294154] = 2,
    ACTIONS(15561), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294163] = 2,
    ACTIONS(11711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294172] = 2,
    ACTIONS(15563), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294181] = 2,
    ACTIONS(15565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294190] = 2,
    ACTIONS(15567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294199] = 2,
    ACTIONS(15569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294208] = 2,
    ACTIONS(12553), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294217] = 2,
    ACTIONS(11723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294226] = 2,
    ACTIONS(15571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294235] = 2,
    ACTIONS(15573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294244] = 2,
    ACTIONS(11725), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294253] = 2,
    ACTIONS(15575), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294262] = 2,
    ACTIONS(11727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294271] = 2,
    ACTIONS(15577), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294280] = 2,
    ACTIONS(15579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294289] = 2,
    ACTIONS(11729), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294298] = 2,
    ACTIONS(12565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294307] = 2,
    ACTIONS(15581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294316] = 2,
    ACTIONS(15583), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294325] = 2,
    ACTIONS(15585), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294334] = 2,
    ACTIONS(15587), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294343] = 2,
    ACTIONS(12561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294352] = 2,
    ACTIONS(15589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294361] = 2,
    ACTIONS(15591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294370] = 2,
    ACTIONS(12563), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294379] = 2,
    ACTIONS(11739), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294388] = 2,
    ACTIONS(15593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294397] = 2,
    ACTIONS(15595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294406] = 2,
    ACTIONS(11743), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294415] = 2,
    ACTIONS(15597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294424] = 2,
    ACTIONS(11751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294433] = 2,
    ACTIONS(15599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294442] = 2,
    ACTIONS(15601), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294451] = 2,
    ACTIONS(11753), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294460] = 2,
    ACTIONS(15603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294469] = 2,
    ACTIONS(15605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294478] = 2,
    ACTIONS(15607), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294487] = 2,
    ACTIONS(15609), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294496] = 2,
    ACTIONS(15611), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294505] = 2,
    ACTIONS(15613), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294514] = 2,
    ACTIONS(12669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294523] = 2,
    ACTIONS(15615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294532] = 2,
    ACTIONS(12567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294541] = 2,
    ACTIONS(11767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294550] = 2,
    ACTIONS(15617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294559] = 2,
    ACTIONS(12573), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294568] = 2,
    ACTIONS(11769), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294577] = 2,
    ACTIONS(15619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294586] = 2,
    ACTIONS(11771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294595] = 2,
    ACTIONS(15621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294604] = 2,
    ACTIONS(15623), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294613] = 2,
    ACTIONS(11775), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294622] = 2,
    ACTIONS(15625), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294631] = 2,
    ACTIONS(15627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294640] = 2,
    ACTIONS(15629), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294649] = 2,
    ACTIONS(11773), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294658] = 2,
    ACTIONS(15631), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294667] = 2,
    ACTIONS(15633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294676] = 2,
    ACTIONS(15635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294685] = 2,
    ACTIONS(15637), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294694] = 2,
    ACTIONS(11681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294703] = 2,
    ACTIONS(11801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294712] = 2,
    ACTIONS(15639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294721] = 2,
    ACTIONS(15641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294730] = 2,
    ACTIONS(11803), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294739] = 2,
    ACTIONS(15643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294748] = 2,
    ACTIONS(11805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294757] = 2,
    ACTIONS(15645), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294766] = 2,
    ACTIONS(15647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294775] = 2,
    ACTIONS(11813), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294784] = 2,
    ACTIONS(15649), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294793] = 2,
    ACTIONS(15651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294802] = 2,
    ACTIONS(15653), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294811] = 2,
    ACTIONS(15655), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294820] = 2,
    ACTIONS(15657), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294829] = 2,
    ACTIONS(15659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294838] = 2,
    ACTIONS(15661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294847] = 2,
    ACTIONS(15663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294856] = 2,
    ACTIONS(11837), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294865] = 2,
    ACTIONS(11843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294874] = 2,
    ACTIONS(15665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294883] = 2,
    ACTIONS(15667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294892] = 2,
    ACTIONS(11845), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294901] = 2,
    ACTIONS(15669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294910] = 2,
    ACTIONS(11851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294919] = 2,
    ACTIONS(11849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294928] = 2,
    ACTIONS(15671), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294937] = 2,
    ACTIONS(11855), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294946] = 2,
    ACTIONS(15673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294955] = 2,
    ACTIONS(15675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294964] = 2,
    ACTIONS(15677), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294973] = 2,
    ACTIONS(12583), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294982] = 2,
    ACTIONS(15679), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [294991] = 2,
    ACTIONS(15681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295000] = 2,
    ACTIONS(15683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295009] = 2,
    ACTIONS(15685), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295018] = 2,
    ACTIONS(15687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295027] = 2,
    ACTIONS(15689), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295036] = 2,
    ACTIONS(15691), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295045] = 2,
    ACTIONS(15693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295054] = 2,
    ACTIONS(15695), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295063] = 2,
    ACTIONS(15697), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295072] = 2,
    ACTIONS(15699), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295081] = 2,
    ACTIONS(15701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295090] = 2,
    ACTIONS(15703), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295099] = 2,
    ACTIONS(15705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295108] = 2,
    ACTIONS(12591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295117] = 2,
    ACTIONS(15707), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295126] = 2,
    ACTIONS(15709), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295135] = 2,
    ACTIONS(15711), 1,
      anon_sym_instance,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295144] = 2,
    ACTIONS(12593), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295153] = 2,
    ACTIONS(15713), 1,
      anon_sym_class,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295162] = 2,
    ACTIONS(15715), 1,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295171] = 2,
    ACTIONS(15717), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295180] = 2,
    ACTIONS(15719), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295189] = 2,
    ACTIONS(12601), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295198] = 2,
    ACTIONS(15721), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295207] = 2,
    ACTIONS(15723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295216] = 2,
    ACTIONS(15725), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295225] = 2,
    ACTIONS(15727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295234] = 2,
    ACTIONS(15729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295243] = 2,
    ACTIONS(15731), 1,
      anon_sym_instance,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295252] = 2,
    ACTIONS(15733), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295261] = 2,
    ACTIONS(15735), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295270] = 2,
    ACTIONS(15737), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295279] = 2,
    ACTIONS(15739), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295288] = 2,
    ACTIONS(15741), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295297] = 2,
    ACTIONS(15743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295306] = 2,
    ACTIONS(15745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295315] = 2,
    ACTIONS(15747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295324] = 2,
    ACTIONS(15749), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295333] = 2,
    ACTIONS(15751), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295342] = 2,
    ACTIONS(15753), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295351] = 2,
    ACTIONS(15755), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295360] = 2,
    ACTIONS(15757), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295369] = 2,
    ACTIONS(15759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295378] = 2,
    ACTIONS(15761), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295387] = 2,
    ACTIONS(15763), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295396] = 2,
    ACTIONS(15765), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295405] = 2,
    ACTIONS(15767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295414] = 2,
    ACTIONS(12639), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295423] = 2,
    ACTIONS(15769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295432] = 2,
    ACTIONS(12641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295441] = 2,
    ACTIONS(15771), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295450] = 2,
    ACTIONS(15773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295459] = 2,
    ACTIONS(12643), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295468] = 2,
    ACTIONS(15775), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295477] = 2,
    ACTIONS(15777), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295486] = 2,
    ACTIONS(15779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295495] = 2,
    ACTIONS(15781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295504] = 2,
    ACTIONS(15783), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295513] = 2,
    ACTIONS(12649), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295522] = 2,
    ACTIONS(11952), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295531] = 2,
    ACTIONS(15785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295540] = 2,
    ACTIONS(15787), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295549] = 2,
    ACTIONS(15789), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295558] = 2,
    ACTIONS(15791), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295567] = 2,
    ACTIONS(13580), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295576] = 2,
    ACTIONS(11966), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295585] = 2,
    ACTIONS(15793), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295594] = 2,
    ACTIONS(15795), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295603] = 2,
    ACTIONS(15797), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295612] = 2,
    ACTIONS(15799), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295621] = 2,
    ACTIONS(15801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295630] = 2,
    ACTIONS(12655), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295639] = 2,
    ACTIONS(15803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295648] = 2,
    ACTIONS(15805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295657] = 2,
    ACTIONS(15807), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295666] = 2,
    ACTIONS(15809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295675] = 2,
    ACTIONS(12671), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295684] = 2,
    ACTIONS(15811), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295693] = 2,
    ACTIONS(15813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295702] = 2,
    ACTIONS(12673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295711] = 2,
    ACTIONS(15815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295720] = 2,
    ACTIONS(15817), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295729] = 2,
    ACTIONS(11989), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295738] = 2,
    ACTIONS(15819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295747] = 2,
    ACTIONS(11993), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295756] = 2,
    ACTIONS(15821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295765] = 2,
    ACTIONS(15823), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295774] = 2,
    ACTIONS(15825), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295783] = 2,
    ACTIONS(12675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295792] = 2,
    ACTIONS(15827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295801] = 2,
    ACTIONS(15829), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295810] = 2,
    ACTIONS(15831), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295819] = 2,
    ACTIONS(15833), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295828] = 2,
    ACTIONS(15835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295837] = 2,
    ACTIONS(15837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295846] = 2,
    ACTIONS(15839), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295855] = 2,
    ACTIONS(15841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295864] = 2,
    ACTIONS(15843), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295873] = 2,
    ACTIONS(12679), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295882] = 2,
    ACTIONS(15845), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295891] = 2,
    ACTIONS(15847), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295900] = 2,
    ACTIONS(15849), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295909] = 2,
    ACTIONS(15851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295918] = 2,
    ACTIONS(15853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295927] = 2,
    ACTIONS(15855), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295936] = 2,
    ACTIONS(15857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295945] = 2,
    ACTIONS(13519), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295954] = 2,
    ACTIONS(15859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295963] = 2,
    ACTIONS(15861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295972] = 2,
    ACTIONS(15863), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295981] = 2,
    ACTIONS(15865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295990] = 2,
    ACTIONS(15867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [295999] = 2,
    ACTIONS(15869), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296008] = 2,
    ACTIONS(15871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296017] = 2,
    ACTIONS(15873), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296026] = 2,
    ACTIONS(15875), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296035] = 2,
    ACTIONS(12685), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296044] = 2,
    ACTIONS(15877), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296053] = 2,
    ACTIONS(15879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296062] = 2,
    ACTIONS(12687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296071] = 2,
    ACTIONS(15881), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296080] = 2,
    ACTIONS(15883), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296089] = 2,
    ACTIONS(15885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296098] = 2,
    ACTIONS(15887), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296107] = 2,
    ACTIONS(15889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296116] = 2,
    ACTIONS(15891), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296125] = 2,
    ACTIONS(12689), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296134] = 2,
    ACTIONS(13424), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296143] = 2,
    ACTIONS(12115), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296152] = 2,
    ACTIONS(12691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296161] = 2,
    ACTIONS(15893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296170] = 2,
    ACTIONS(15895), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296179] = 2,
    ACTIONS(15897), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296188] = 2,
    ACTIONS(15899), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296197] = 2,
    ACTIONS(12698), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296206] = 2,
    ACTIONS(15901), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296215] = 2,
    ACTIONS(15903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296224] = 2,
    ACTIONS(15905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296233] = 2,
    ACTIONS(15907), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296242] = 2,
    ACTIONS(15909), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296251] = 2,
    ACTIONS(12704), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296260] = 2,
    ACTIONS(15911), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296269] = 2,
    ACTIONS(12103), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296278] = 2,
    ACTIONS(15913), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296287] = 2,
    ACTIONS(15915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296296] = 2,
    ACTIONS(13408), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296305] = 2,
    ACTIONS(15917), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296314] = 2,
    ACTIONS(12111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296323] = 2,
    ACTIONS(12702), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296332] = 2,
    ACTIONS(15919), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296341] = 2,
    ACTIONS(15921), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296350] = 2,
    ACTIONS(15923), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296359] = 2,
    ACTIONS(15925), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296368] = 2,
    ACTIONS(15927), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296377] = 2,
    ACTIONS(12706), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296386] = 2,
    ACTIONS(15929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296395] = 2,
    ACTIONS(15931), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296404] = 2,
    ACTIONS(15933), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296413] = 2,
    ACTIONS(12708), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296422] = 2,
    ACTIONS(15935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296431] = 2,
    ACTIONS(15937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296440] = 2,
    ACTIONS(15939), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296449] = 2,
    ACTIONS(15941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296458] = 2,
    ACTIONS(13368), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296467] = 2,
    ACTIONS(12712), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296476] = 2,
    ACTIONS(15943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296485] = 2,
    ACTIONS(12147), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296494] = 2,
    ACTIONS(15945), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296503] = 2,
    ACTIONS(15947), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296512] = 2,
    ACTIONS(15949), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296521] = 2,
    ACTIONS(15951), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296530] = 2,
    ACTIONS(15953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296539] = 2,
    ACTIONS(12155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296548] = 2,
    ACTIONS(15955), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296557] = 2,
    ACTIONS(15957), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296566] = 2,
    ACTIONS(15959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296575] = 2,
    ACTIONS(15961), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296584] = 2,
    ACTIONS(15963), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296593] = 2,
    ACTIONS(15965), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296602] = 2,
    ACTIONS(15967), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296611] = 2,
    ACTIONS(13298), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296620] = 2,
    ACTIONS(15969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296629] = 2,
    ACTIONS(15971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296638] = 2,
    ACTIONS(15973), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296647] = 2,
    ACTIONS(15975), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296656] = 2,
    ACTIONS(15977), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296665] = 2,
    ACTIONS(15979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296674] = 2,
    ACTIONS(15981), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296683] = 2,
    ACTIONS(15983), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296692] = 2,
    ACTIONS(15985), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296701] = 2,
    ACTIONS(15987), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296710] = 2,
    ACTIONS(15989), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296719] = 2,
    ACTIONS(15991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296728] = 2,
    ACTIONS(12657), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296737] = 2,
    ACTIONS(15993), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296746] = 2,
    ACTIONS(15995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296755] = 2,
    ACTIONS(13273), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296764] = 2,
    ACTIONS(15997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296773] = 2,
    ACTIONS(12653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296782] = 2,
    ACTIONS(15999), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296791] = 2,
    ACTIONS(16001), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296800] = 2,
    ACTIONS(16003), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296809] = 2,
    ACTIONS(16005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296818] = 2,
    ACTIONS(16007), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296827] = 2,
    ACTIONS(12651), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296836] = 2,
    ACTIONS(16009), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296845] = 2,
    ACTIONS(16011), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296854] = 2,
    ACTIONS(16013), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296863] = 2,
    ACTIONS(16015), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296872] = 2,
    ACTIONS(16017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296881] = 2,
    ACTIONS(16019), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296890] = 2,
    ACTIONS(16021), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296899] = 2,
    ACTIONS(13236), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296908] = 2,
    ACTIONS(12645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296917] = 2,
    ACTIONS(16023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296926] = 2,
    ACTIONS(16025), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296935] = 2,
    ACTIONS(16027), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296944] = 2,
    ACTIONS(16029), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296953] = 2,
    ACTIONS(16031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296962] = 2,
    ACTIONS(16033), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296971] = 2,
    ACTIONS(16035), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296980] = 2,
    ACTIONS(16037), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296989] = 2,
    ACTIONS(16039), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [296998] = 2,
    ACTIONS(16041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297007] = 2,
    ACTIONS(12416), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297016] = 2,
    ACTIONS(16043), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297025] = 2,
    ACTIONS(16045), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297034] = 2,
    ACTIONS(16047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297043] = 2,
    ACTIONS(13192), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297052] = 2,
    ACTIONS(16049), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297061] = 2,
    ACTIONS(12255), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297070] = 2,
    ACTIONS(16051), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297079] = 2,
    ACTIONS(16053), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297088] = 2,
    ACTIONS(16055), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297097] = 2,
    ACTIONS(16057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297106] = 2,
    ACTIONS(12619), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297115] = 2,
    ACTIONS(12261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297124] = 2,
    ACTIONS(16059), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297133] = 2,
    ACTIONS(16061), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297142] = 2,
    ACTIONS(16063), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297151] = 2,
    ACTIONS(16065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297160] = 2,
    ACTIONS(16067), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297169] = 2,
    ACTIONS(16069), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297178] = 2,
    ACTIONS(12615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297187] = 2,
    ACTIONS(13174), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297196] = 2,
    ACTIONS(12617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297205] = 2,
    ACTIONS(16071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297214] = 2,
    ACTIONS(16073), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297223] = 2,
    ACTIONS(16075), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297232] = 2,
    ACTIONS(16077), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297241] = 2,
    ACTIONS(12613), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297250] = 2,
    ACTIONS(16079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297259] = 2,
    ACTIONS(16081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297268] = 2,
    ACTIONS(16083), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297277] = 2,
    ACTIONS(16085), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297286] = 2,
    ACTIONS(12285), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297295] = 2,
    ACTIONS(16087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297304] = 2,
    ACTIONS(12297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297313] = 2,
    ACTIONS(16089), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297322] = 2,
    ACTIONS(16091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297331] = 2,
    ACTIONS(13158), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297340] = 2,
    ACTIONS(16093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297349] = 2,
    ACTIONS(16095), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297358] = 2,
    ACTIONS(16097), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297367] = 2,
    ACTIONS(16099), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297376] = 2,
    ACTIONS(16101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297385] = 2,
    ACTIONS(12609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297394] = 2,
    ACTIONS(13152), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297403] = 2,
    ACTIONS(16103), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297412] = 2,
    ACTIONS(16105), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297421] = 2,
    ACTIONS(12605), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297430] = 2,
    ACTIONS(16107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297439] = 2,
    ACTIONS(16109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297448] = 2,
    ACTIONS(16111), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297457] = 2,
    ACTIONS(16113), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297466] = 2,
    ACTIONS(13146), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297475] = 2,
    ACTIONS(16115), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297484] = 2,
    ACTIONS(16117), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297493] = 2,
    ACTIONS(16119), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297502] = 2,
    ACTIONS(16121), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297511] = 2,
    ACTIONS(16123), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297520] = 2,
    ACTIONS(16125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297529] = 2,
    ACTIONS(16127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297538] = 2,
    ACTIONS(16129), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297547] = 2,
    ACTIONS(16131), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297556] = 2,
    ACTIONS(12579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297565] = 2,
    ACTIONS(16133), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297574] = 2,
    ACTIONS(16135), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297583] = 2,
    ACTIONS(16137), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297592] = 2,
    ACTIONS(16139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297601] = 2,
    ACTIONS(13133), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297610] = 2,
    ACTIONS(16141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297619] = 2,
    ACTIONS(16143), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297628] = 2,
    ACTIONS(16145), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297637] = 2,
    ACTIONS(16147), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297646] = 2,
    ACTIONS(12581), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297655] = 2,
    ACTIONS(16149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297664] = 2,
    ACTIONS(16151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297673] = 2,
    ACTIONS(16153), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297682] = 2,
    ACTIONS(16155), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297691] = 2,
    ACTIONS(16157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297700] = 2,
    ACTIONS(16159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297709] = 2,
    ACTIONS(16161), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297718] = 2,
    ACTIONS(16163), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297727] = 2,
    ACTIONS(16165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297736] = 2,
    ACTIONS(13034), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297745] = 2,
    ACTIONS(16167), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297754] = 2,
    ACTIONS(16169), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297763] = 2,
    ACTIONS(16171), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297772] = 2,
    ACTIONS(16173), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297781] = 2,
    ACTIONS(12577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297790] = 2,
    ACTIONS(16175), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297799] = 2,
    ACTIONS(16177), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297808] = 2,
    ACTIONS(16179), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297817] = 2,
    ACTIONS(12575), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297826] = 2,
    ACTIONS(14553), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297835] = 2,
    ACTIONS(16181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297844] = 2,
    ACTIONS(16183), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297853] = 2,
    ACTIONS(12557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297862] = 2,
    ACTIONS(13018), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297871] = 2,
    ACTIONS(16185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297880] = 2,
    ACTIONS(16187), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297889] = 2,
    ACTIONS(16189), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297898] = 2,
    ACTIONS(16191), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297907] = 2,
    ACTIONS(16193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297916] = 2,
    ACTIONS(16195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297925] = 2,
    ACTIONS(16198), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297934] = 2,
    ACTIONS(16200), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297943] = 2,
    ACTIONS(16202), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297952] = 2,
    ACTIONS(16204), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297961] = 2,
    ACTIONS(16206), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297970] = 2,
    ACTIONS(16208), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297979] = 2,
    ACTIONS(16210), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297988] = 2,
    ACTIONS(13004), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [297997] = 2,
    ACTIONS(16212), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298006] = 2,
    ACTIONS(16214), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298015] = 2,
    ACTIONS(16216), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298024] = 2,
    ACTIONS(16218), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298033] = 2,
    ACTIONS(16220), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298042] = 2,
    ACTIONS(16222), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298051] = 2,
    ACTIONS(12521), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298060] = 2,
    ACTIONS(16224), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298069] = 2,
    ACTIONS(12422), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298078] = 2,
    ACTIONS(16226), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298087] = 2,
    ACTIONS(14526), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298096] = 2,
    ACTIONS(16228), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298105] = 2,
    ACTIONS(16230), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298114] = 2,
    ACTIONS(12996), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298123] = 2,
    ACTIONS(16232), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298132] = 2,
    ACTIONS(16234), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298141] = 2,
    ACTIONS(16236), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298150] = 2,
    ACTIONS(16238), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298159] = 2,
    ACTIONS(12517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298168] = 2,
    ACTIONS(16240), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298177] = 2,
    ACTIONS(16242), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298186] = 2,
    ACTIONS(16244), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298195] = 2,
    ACTIONS(12515), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298204] = 2,
    ACTIONS(16246), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298213] = 2,
    ACTIONS(16248), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298222] = 2,
    ACTIONS(16250), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298231] = 2,
    ACTIONS(16252), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298240] = 2,
    ACTIONS(12988), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298249] = 2,
    ACTIONS(16254), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298258] = 2,
    ACTIONS(16256), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298267] = 2,
    ACTIONS(16258), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298276] = 2,
    ACTIONS(16260), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298285] = 2,
    ACTIONS(12394), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298294] = 2,
    ACTIONS(16262), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298303] = 2,
    ACTIONS(16264), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298312] = 2,
    ACTIONS(16266), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298321] = 2,
    ACTIONS(12490), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298330] = 2,
    ACTIONS(16268), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298339] = 2,
    ACTIONS(16270), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298348] = 2,
    ACTIONS(16272), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298357] = 2,
    ACTIONS(12513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298366] = 2,
    ACTIONS(12938), 1,
      anon_sym_else,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298375] = 2,
    ACTIONS(16274), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298384] = 2,
    ACTIONS(16276), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298393] = 2,
    ACTIONS(16278), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298402] = 2,
    ACTIONS(16280), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298411] = 2,
    ACTIONS(16282), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298420] = 2,
    ACTIONS(16284), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298429] = 2,
    ACTIONS(16286), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298438] = 2,
    ACTIONS(16288), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298447] = 2,
    ACTIONS(16290), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298456] = 2,
    ACTIONS(16292), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298465] = 2,
    ACTIONS(16294), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298474] = 2,
    ACTIONS(16296), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298483] = 2,
    ACTIONS(16298), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298492] = 2,
    ACTIONS(16300), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298501] = 2,
    ACTIONS(16302), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298510] = 2,
    ACTIONS(16304), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298519] = 2,
    ACTIONS(16306), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298528] = 2,
    ACTIONS(16308), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298537] = 2,
    ACTIONS(16310), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298546] = 2,
    ACTIONS(16312), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298555] = 2,
    ACTIONS(12502), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298564] = 2,
    ACTIONS(16314), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298573] = 2,
    ACTIONS(16316), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298582] = 2,
    ACTIONS(16318), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298591] = 2,
    ACTIONS(16320), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298600] = 2,
    ACTIONS(16322), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298609] = 2,
    ACTIONS(16324), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298618] = 2,
    ACTIONS(16326), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298627] = 2,
    ACTIONS(12498), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298636] = 2,
    ACTIONS(16328), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298645] = 2,
    ACTIONS(16330), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298654] = 2,
    ACTIONS(16332), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298663] = 2,
    ACTIONS(16334), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298672] = 2,
    ACTIONS(16336), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298681] = 2,
    ACTIONS(16338), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298690] = 2,
    ACTIONS(12496), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298699] = 2,
    ACTIONS(12492), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298708] = 2,
    ACTIONS(16340), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298717] = 2,
    ACTIONS(12480), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298726] = 2,
    ACTIONS(16342), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298735] = 2,
    ACTIONS(16344), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298744] = 2,
    ACTIONS(16346), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298753] = 2,
    ACTIONS(16348), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298762] = 2,
    ACTIONS(16350), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298771] = 2,
    ACTIONS(16352), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298780] = 2,
    ACTIONS(12478), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298789] = 2,
    ACTIONS(16354), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298798] = 2,
    ACTIONS(16356), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298807] = 2,
    ACTIONS(16358), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298816] = 2,
    ACTIONS(16360), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298825] = 2,
    ACTIONS(16362), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298834] = 2,
    ACTIONS(16364), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298843] = 2,
    ACTIONS(16366), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298852] = 2,
    ACTIONS(16368), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298861] = 2,
    ACTIONS(12559), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298870] = 2,
    ACTIONS(16370), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298879] = 2,
    ACTIONS(16372), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298888] = 2,
    ACTIONS(16374), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298897] = 2,
    ACTIONS(16376), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298906] = 2,
    ACTIONS(16378), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298915] = 2,
    ACTIONS(12426), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298924] = 2,
    ACTIONS(16380), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298933] = 2,
    ACTIONS(16382), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298942] = 2,
    ACTIONS(16384), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298951] = 2,
    ACTIONS(12448), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298960] = 2,
    ACTIONS(16386), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298969] = 2,
    ACTIONS(16388), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298978] = 2,
    ACTIONS(12430), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298987] = 2,
    ACTIONS(16390), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [298996] = 2,
    ACTIONS(16392), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299005] = 2,
    ACTIONS(12424), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299014] = 2,
    ACTIONS(16394), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299023] = 2,
    ACTIONS(16396), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299032] = 2,
    ACTIONS(16398), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299041] = 2,
    ACTIONS(12418), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299050] = 2,
    ACTIONS(16400), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299059] = 2,
    ACTIONS(16402), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299068] = 2,
    ACTIONS(12420), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299077] = 2,
    ACTIONS(12629), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299086] = 2,
    ACTIONS(16404), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299095] = 2,
    ACTIONS(16406), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299104] = 2,
    ACTIONS(16408), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299113] = 2,
    ACTIONS(16410), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299122] = 2,
    ACTIONS(16412), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299131] = 2,
    ACTIONS(16414), 1,
      anon_sym_in,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299140] = 2,
    ACTIONS(16416), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299149] = 2,
    ACTIONS(16418), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299158] = 2,
    ACTIONS(12633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299167] = 2,
    ACTIONS(16420), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299176] = 2,
    ACTIONS(16422), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299185] = 2,
    ACTIONS(12631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299194] = 2,
    ACTIONS(16424), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299203] = 2,
    ACTIONS(16426), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299212] = 2,
    ACTIONS(16428), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299221] = 2,
    ACTIONS(16430), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299230] = 2,
    ACTIONS(16432), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299239] = 2,
    ACTIONS(16434), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299248] = 2,
    ACTIONS(16436), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299257] = 2,
    ACTIONS(16438), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299266] = 2,
    ACTIONS(16440), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299275] = 2,
    ACTIONS(16442), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299284] = 2,
    ACTIONS(16444), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299293] = 2,
    ACTIONS(16446), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299302] = 2,
    ACTIONS(16448), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299311] = 2,
    ACTIONS(16450), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299320] = 2,
    ACTIONS(16452), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299329] = 2,
    ACTIONS(16454), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299338] = 2,
    ACTIONS(16456), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299347] = 2,
    ACTIONS(16458), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299356] = 2,
    ACTIONS(16460), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299365] = 2,
    ACTIONS(16462), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299374] = 2,
    ACTIONS(16464), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299383] = 2,
    ACTIONS(12667), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299392] = 2,
    ACTIONS(16466), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299401] = 2,
    ACTIONS(16468), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299410] = 2,
    ACTIONS(12474), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299419] = 2,
    ACTIONS(12693), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299428] = 2,
    ACTIONS(16470), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299437] = 2,
    ACTIONS(16472), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299446] = 2,
    ACTIONS(16474), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299455] = 2,
    ACTIONS(16476), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299464] = 2,
    ACTIONS(12388), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299473] = 2,
    ACTIONS(16478), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299482] = 2,
    ACTIONS(12386), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299491] = 2,
    ACTIONS(16480), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299500] = 2,
    ACTIONS(16482), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299509] = 2,
    ACTIONS(12700), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299518] = 2,
    ACTIONS(16484), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299527] = 2,
    ACTIONS(12381), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299536] = 2,
    ACTIONS(16486), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299545] = 2,
    ACTIONS(16488), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299554] = 2,
    ACTIONS(12377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299563] = 2,
    ACTIONS(16490), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299572] = 2,
    ACTIONS(16492), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299581] = 2,
    ACTIONS(16494), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299590] = 2,
    ACTIONS(16496), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299599] = 2,
    ACTIONS(16498), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299608] = 2,
    ACTIONS(16500), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299617] = 2,
    ACTIONS(16502), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299626] = 2,
    ACTIONS(16504), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299635] = 2,
    ACTIONS(16506), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299644] = 2,
    ACTIONS(12359), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299653] = 2,
    ACTIONS(16508), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299662] = 2,
    ACTIONS(16510), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299671] = 2,
    ACTIONS(16512), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299680] = 2,
    ACTIONS(16514), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299689] = 2,
    ACTIONS(16516), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299698] = 2,
    ACTIONS(16518), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299707] = 2,
    ACTIONS(16520), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299716] = 2,
    ACTIONS(16522), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299725] = 2,
    ACTIONS(12349), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299734] = 2,
    ACTIONS(16524), 1,
      anon_sym_of,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299743] = 2,
    ACTIONS(12351), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299752] = 2,
    ACTIONS(12778), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299761] = 2,
    ACTIONS(16526), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299770] = 2,
    ACTIONS(16528), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299779] = 2,
    ACTIONS(12335), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299788] = 2,
    ACTIONS(16530), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299797] = 2,
    ACTIONS(12315), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299806] = 2,
    ACTIONS(16532), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299815] = 2,
    ACTIONS(16534), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299824] = 2,
    ACTIONS(16536), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299833] = 2,
    ACTIONS(16539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299842] = 2,
    ACTIONS(16541), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299851] = 2,
    ACTIONS(12311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299860] = 2,
    ACTIONS(16543), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299869] = 2,
    ACTIONS(12647), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299878] = 2,
    ACTIONS(16545), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299887] = 2,
    ACTIONS(16547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299896] = 2,
    ACTIONS(16549), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299905] = 2,
    ACTIONS(16551), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299914] = 2,
    ACTIONS(16553), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299923] = 2,
    ACTIONS(12299), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299932] = 2,
    ACTIONS(16555), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299941] = 2,
    ACTIONS(16557), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299950] = 2,
    ACTIONS(16559), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299959] = 2,
    ACTIONS(16561), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299968] = 2,
    ACTIONS(16563), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299977] = 2,
    ACTIONS(16565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299986] = 2,
    ACTIONS(12295), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [299995] = 2,
    ACTIONS(16567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300004] = 2,
    ACTIONS(16569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300013] = 2,
    ACTIONS(16571), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300022] = 2,
    ACTIONS(12283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300031] = 2,
    ACTIONS(16573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300040] = 2,
    ACTIONS(16575), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300049] = 2,
    ACTIONS(16577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300058] = 2,
    ACTIONS(12603), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300067] = 2,
    ACTIONS(16579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300076] = 2,
    ACTIONS(16581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300085] = 2,
    ACTIONS(12269), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300094] = 2,
    ACTIONS(12585), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300103] = 2,
    ACTIONS(16583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300112] = 2,
    ACTIONS(16585), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300121] = 2,
    ACTIONS(16587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300130] = 2,
    ACTIONS(12267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300139] = 2,
    ACTIONS(16589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300148] = 2,
    ACTIONS(16591), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300157] = 2,
    ACTIONS(16593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300166] = 2,
    ACTIONS(12555), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300175] = 2,
    ACTIONS(16595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300184] = 2,
    ACTIONS(16597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300193] = 2,
    ACTIONS(16599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300202] = 2,
    ACTIONS(16601), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300211] = 2,
    ACTIONS(16603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300220] = 2,
    ACTIONS(16605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300229] = 2,
    ACTIONS(12549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300238] = 2,
    ACTIONS(16607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300247] = 2,
    ACTIONS(16609), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300256] = 2,
    ACTIONS(16611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300265] = 2,
    ACTIONS(12185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300274] = 2,
    ACTIONS(16613), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300283] = 2,
    ACTIONS(16615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300292] = 2,
    ACTIONS(16617), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300301] = 2,
    ACTIONS(16619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300310] = 2,
    ACTIONS(12223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300319] = 2,
    ACTIONS(16621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300328] = 2,
    ACTIONS(12221), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300337] = 2,
    ACTIONS(16623), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300346] = 2,
    ACTIONS(16625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300355] = 2,
    ACTIONS(12303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300364] = 2,
    ACTIONS(16627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300373] = 2,
    ACTIONS(12452), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300382] = 2,
    ACTIONS(16629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300391] = 2,
    ACTIONS(11673), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300400] = 2,
    ACTIONS(12450), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300409] = 2,
    ACTIONS(16631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300418] = 2,
    ACTIONS(12001), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300427] = 2,
    ACTIONS(16633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300436] = 2,
    ACTIONS(16635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300445] = 2,
    ACTIONS(16637), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300454] = 2,
    ACTIONS(12171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300463] = 2,
    ACTIONS(16639), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300472] = 2,
    ACTIONS(16641), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300481] = 2,
    ACTIONS(16643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300490] = 2,
    ACTIONS(16645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300499] = 2,
    ACTIONS(16647), 1,
      anon_sym_import,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300508] = 2,
    ACTIONS(16649), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300517] = 2,
    ACTIONS(16651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300526] = 2,
    ACTIONS(16654), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300535] = 2,
    ACTIONS(16656), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300544] = 2,
    ACTIONS(12169), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300553] = 2,
    ACTIONS(12404), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300562] = 2,
    ACTIONS(12159), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300571] = 2,
    ACTIONS(16658), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300580] = 2,
    ACTIONS(12396), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300589] = 2,
    ACTIONS(16660), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300598] = 2,
    ACTIONS(12167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300607] = 2,
    ACTIONS(16662), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300616] = 2,
    ACTIONS(16664), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300625] = 2,
    ACTIONS(16666), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300634] = 2,
    ACTIONS(16668), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300643] = 2,
    ACTIONS(16670), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300652] = 2,
    ACTIONS(16672), 1,
      sym__layout_start,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300661] = 2,
    ACTIONS(16674), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300670] = 2,
    ACTIONS(16676), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300679] = 2,
    ACTIONS(16678), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300688] = 2,
    ACTIONS(16680), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300697] = 2,
    ACTIONS(16682), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300706] = 2,
    ACTIONS(16684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300715] = 2,
    ACTIONS(16686), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300724] = 2,
    ACTIONS(16688), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300733] = 2,
    ACTIONS(16690), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300742] = 2,
    ACTIONS(16692), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300751] = 2,
    ACTIONS(16694), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300760] = 2,
    ACTIONS(16696), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300769] = 2,
    ACTIONS(16698), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300778] = 2,
    ACTIONS(16700), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300787] = 2,
    ACTIONS(16702), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300796] = 2,
    ACTIONS(12123), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300805] = 2,
    ACTIONS(16704), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300814] = 2,
    ACTIONS(16706), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300823] = 2,
    ACTIONS(12117), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300832] = 2,
    ACTIONS(16708), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300841] = 2,
    ACTIONS(16710), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300850] = 2,
    ACTIONS(12119), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300859] = 2,
    ACTIONS(16712), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300868] = 2,
    ACTIONS(16714), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300877] = 2,
    ACTIONS(12113), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300886] = 2,
    ACTIONS(16716), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300895] = 2,
    ACTIONS(16718), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300904] = 2,
    ACTIONS(16720), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300913] = 2,
    ACTIONS(12085), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300922] = 2,
    ACTIONS(16722), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300931] = 2,
    ACTIONS(16724), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300940] = 2,
    ACTIONS(16726), 1,
      anon_sym_as,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300949] = 2,
    ACTIONS(12083), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300958] = 2,
    ACTIONS(16728), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300967] = 2,
    ACTIONS(12307), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300976] = 2,
    ACTIONS(16730), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300985] = 2,
    ACTIONS(12081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [300994] = 2,
    ACTIONS(16732), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301003] = 2,
    ACTIONS(16734), 1,
      anon_sym_newtype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301012] = 2,
    ACTIONS(12063), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301021] = 2,
    ACTIONS(16736), 1,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301030] = 2,
    ACTIONS(16739), 1,
      sym_where,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301039] = 2,
    ACTIONS(16741), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301048] = 2,
    ACTIONS(16743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301057] = 2,
    ACTIONS(16745), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301066] = 2,
    ACTIONS(12305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301075] = 2,
    ACTIONS(16747), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301084] = 2,
    ACTIONS(16749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301093] = 2,
    ACTIONS(16751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301102] = 2,
    ACTIONS(16753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301111] = 2,
    ACTIONS(16755), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301120] = 2,
    ACTIONS(16757), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301129] = 2,
    ACTIONS(16759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301138] = 2,
    ACTIONS(16761), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301147] = 2,
    ACTIONS(16763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301156] = 2,
    ACTIONS(16765), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301165] = 2,
    ACTIONS(16768), 1,
      anon_sym_class,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301174] = 2,
    ACTIONS(16770), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301183] = 2,
    ACTIONS(16772), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301192] = 2,
    ACTIONS(12027), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301201] = 2,
    ACTIONS(16774), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301210] = 2,
    ACTIONS(12017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301219] = 2,
    ACTIONS(12253), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301228] = 2,
    ACTIONS(16776), 1,
      anon_sym_type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301237] = 2,
    ACTIONS(16778), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301246] = 2,
    ACTIONS(16780), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301255] = 2,
    ACTIONS(16782), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301264] = 2,
    ACTIONS(12476), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301273] = 2,
    ACTIONS(16784), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301282] = 2,
    ACTIONS(16786), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301291] = 2,
    ACTIONS(16788), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301300] = 2,
    ACTIONS(16790), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301309] = 2,
    ACTIONS(12011), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301318] = 2,
    ACTIONS(16792), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301327] = 2,
    ACTIONS(16794), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301336] = 2,
    ACTIONS(16796), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301345] = 2,
    ACTIONS(16798), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301354] = 2,
    ACTIONS(12009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301363] = 2,
    ACTIONS(16800), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301372] = 2,
    ACTIONS(16802), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301381] = 2,
    ACTIONS(12003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301390] = 2,
    ACTIONS(16804), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301399] = 2,
    ACTIONS(16806), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301408] = 2,
    ACTIONS(16808), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301417] = 2,
    ACTIONS(13609), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301426] = 2,
    ACTIONS(16810), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301435] = 2,
    ACTIONS(16812), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301444] = 2,
    ACTIONS(16814), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301453] = 2,
    ACTIONS(16816), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301462] = 2,
    ACTIONS(16818), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301471] = 2,
    ACTIONS(16820), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301480] = 2,
    ACTIONS(16822), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301489] = 2,
    ACTIONS(11978), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301498] = 2,
    ACTIONS(16824), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301507] = 2,
    ACTIONS(11976), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301516] = 2,
    ACTIONS(16826), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301525] = 2,
    ACTIONS(16828), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301534] = 2,
    ACTIONS(16830), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301543] = 2,
    ACTIONS(11970), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301552] = 2,
    ACTIONS(16832), 1,
      anon_sym_instance,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301561] = 2,
    ACTIONS(16834), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301570] = 2,
    ACTIONS(16836), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301579] = 2,
    ACTIONS(16838), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301588] = 2,
    ACTIONS(12005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301597] = 2,
    ACTIONS(16840), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301606] = 2,
    ACTIONS(11964), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301615] = 2,
    ACTIONS(16842), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301624] = 2,
    ACTIONS(16844), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301633] = 2,
    ACTIONS(16846), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301642] = 2,
    ACTIONS(16848), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301651] = 2,
    ACTIONS(16850), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301660] = 2,
    ACTIONS(16852), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301669] = 2,
    ACTIONS(16854), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301678] = 2,
    ACTIONS(16856), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301687] = 2,
    ACTIONS(11924), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301696] = 2,
    ACTIONS(16858), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301705] = 2,
    ACTIONS(11911), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301714] = 2,
    ACTIONS(16860), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301723] = 2,
    ACTIONS(16862), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301732] = 2,
    ACTIONS(11891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301741] = 2,
    ACTIONS(16864), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301750] = 2,
    ACTIONS(16866), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301759] = 2,
    ACTIONS(11877), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301768] = 2,
    ACTIONS(16868), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301777] = 2,
    ACTIONS(16870), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301786] = 2,
    ACTIONS(16872), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301795] = 2,
    ACTIONS(16874), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301804] = 2,
    ACTIONS(16876), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301813] = 2,
    ACTIONS(11869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301822] = 2,
    ACTIONS(16878), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301831] = 2,
    ACTIONS(11867), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301840] = 2,
    ACTIONS(16880), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301849] = 2,
    ACTIONS(16882), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301858] = 2,
    ACTIONS(16884), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301867] = 2,
    ACTIONS(16886), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301876] = 2,
    ACTIONS(16888), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301885] = 2,
    ACTIONS(12067), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301894] = 2,
    ACTIONS(16890), 1,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301903] = 2,
    ACTIONS(16892), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301912] = 2,
    ACTIONS(16894), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301921] = 2,
    ACTIONS(16896), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301930] = 2,
    ACTIONS(16898), 1,
      anon_sym_class,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301939] = 2,
    ACTIONS(16900), 1,
      anon_sym_newtype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301948] = 2,
    ACTIONS(16902), 1,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301957] = 2,
    ACTIONS(16904), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301966] = 2,
    ACTIONS(16906), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301975] = 2,
    ACTIONS(11431), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301984] = 2,
    ACTIONS(11861), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [301993] = 2,
    ACTIONS(16908), 1,
      anon_sym_type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302002] = 2,
    ACTIONS(16910), 1,
      anon_sym_data,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302011] = 2,
    ACTIONS(16912), 1,
      anon_sym_newtype,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302020] = 2,
    ACTIONS(12047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302029] = 2,
    ACTIONS(13463), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302038] = 2,
    ACTIONS(16914), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302047] = 2,
    ACTIONS(16916), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302056] = 2,
    ACTIONS(16918), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302065] = 2,
    ACTIONS(11857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302074] = 2,
    ACTIONS(16920), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302083] = 2,
    ACTIONS(13467), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302092] = 2,
    ACTIONS(16922), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302101] = 2,
    ACTIONS(13473), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302110] = 2,
    ACTIONS(16924), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302119] = 2,
    ACTIONS(13475), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302128] = 2,
    ACTIONS(16926), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302137] = 2,
    ACTIONS(13479), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302146] = 2,
    ACTIONS(16928), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302155] = 2,
    ACTIONS(13481), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302164] = 2,
    ACTIONS(16930), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302173] = 2,
    ACTIONS(13485), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302182] = 2,
    ACTIONS(11827), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302191] = 2,
    ACTIONS(13501), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302200] = 2,
    ACTIONS(8857), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302209] = 2,
    ACTIONS(13515), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302218] = 2,
    ACTIONS(16933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302227] = 2,
    ACTIONS(13517), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302236] = 2,
    ACTIONS(12007), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302245] = 2,
    ACTIONS(13521), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302254] = 2,
    ACTIONS(16935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302263] = 2,
    ACTIONS(13523), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302272] = 2,
    ACTIONS(11823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302281] = 2,
    ACTIONS(13420), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302290] = 2,
    ACTIONS(16937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302299] = 2,
    ACTIONS(13533), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302308] = 2,
    ACTIONS(16939), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302317] = 2,
    ACTIONS(13535), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302326] = 2,
    ACTIONS(16941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302335] = 2,
    ACTIONS(13543), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302344] = 2,
    ACTIONS(16943), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302353] = 2,
    ACTIONS(13584), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302362] = 2,
    ACTIONS(16945), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302371] = 2,
    ACTIONS(13588), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302380] = 2,
    ACTIONS(16947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302389] = 2,
    ACTIONS(13592), 1,
      anon_sym_then,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302398] = 2,
    ACTIONS(16949), 1,
      anon_sym_type,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302407] = 2,
    ACTIONS(11745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302416] = 2,
    ACTIONS(16951), 1,
      sym__immediate_varid,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302425] = 2,
    ACTIONS(16953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302434] = 2,
    ACTIONS(16955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302443] = 2,
    ACTIONS(16957), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302452] = 2,
    ACTIONS(16959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302461] = 2,
    ACTIONS(16961), 1,
      anon_sym_import,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302470] = 2,
    ACTIONS(11741), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302479] = 2,
    ACTIONS(16963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302488] = 2,
    ACTIONS(16965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302497] = 2,
    ACTIONS(16967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302506] = 2,
    ACTIONS(11677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302515] = 2,
    ACTIONS(16969), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302524] = 2,
    ACTIONS(16971), 1,
      anon_sym_instance,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302533] = 2,
    ACTIONS(16973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302542] = 2,
    ACTIONS(16975), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302551] = 2,
    ACTIONS(16977), 1,
      sym__dot,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
  [302560] = 2,
    ACTIONS(16979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_comment,
      sym_cpp,
      aux_sym__token1,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(548)] = 0,
  [SMALL_STATE(549)] = 137,
  [SMALL_STATE(550)] = 274,
  [SMALL_STATE(551)] = 411,
  [SMALL_STATE(552)] = 548,
  [SMALL_STATE(553)] = 683,
  [SMALL_STATE(554)] = 820,
  [SMALL_STATE(555)] = 955,
  [SMALL_STATE(556)] = 1092,
  [SMALL_STATE(557)] = 1229,
  [SMALL_STATE(558)] = 1366,
  [SMALL_STATE(559)] = 1501,
  [SMALL_STATE(560)] = 1638,
  [SMALL_STATE(561)] = 1775,
  [SMALL_STATE(562)] = 1912,
  [SMALL_STATE(563)] = 2049,
  [SMALL_STATE(564)] = 2186,
  [SMALL_STATE(565)] = 2323,
  [SMALL_STATE(566)] = 2460,
  [SMALL_STATE(567)] = 2597,
  [SMALL_STATE(568)] = 2734,
  [SMALL_STATE(569)] = 2871,
  [SMALL_STATE(570)] = 3008,
  [SMALL_STATE(571)] = 3145,
  [SMALL_STATE(572)] = 3282,
  [SMALL_STATE(573)] = 3419,
  [SMALL_STATE(574)] = 3554,
  [SMALL_STATE(575)] = 3691,
  [SMALL_STATE(576)] = 3828,
  [SMALL_STATE(577)] = 3965,
  [SMALL_STATE(578)] = 4102,
  [SMALL_STATE(579)] = 4239,
  [SMALL_STATE(580)] = 4376,
  [SMALL_STATE(581)] = 4513,
  [SMALL_STATE(582)] = 4650,
  [SMALL_STATE(583)] = 4787,
  [SMALL_STATE(584)] = 4924,
  [SMALL_STATE(585)] = 5061,
  [SMALL_STATE(586)] = 5198,
  [SMALL_STATE(587)] = 5335,
  [SMALL_STATE(588)] = 5472,
  [SMALL_STATE(589)] = 5609,
  [SMALL_STATE(590)] = 5746,
  [SMALL_STATE(591)] = 5883,
  [SMALL_STATE(592)] = 6020,
  [SMALL_STATE(593)] = 6157,
  [SMALL_STATE(594)] = 6293,
  [SMALL_STATE(595)] = 6429,
  [SMALL_STATE(596)] = 6563,
  [SMALL_STATE(597)] = 6697,
  [SMALL_STATE(598)] = 6832,
  [SMALL_STATE(599)] = 6967,
  [SMALL_STATE(600)] = 7102,
  [SMALL_STATE(601)] = 7237,
  [SMALL_STATE(602)] = 7372,
  [SMALL_STATE(603)] = 7507,
  [SMALL_STATE(604)] = 7642,
  [SMALL_STATE(605)] = 7777,
  [SMALL_STATE(606)] = 7912,
  [SMALL_STATE(607)] = 8047,
  [SMALL_STATE(608)] = 8182,
  [SMALL_STATE(609)] = 8317,
  [SMALL_STATE(610)] = 8452,
  [SMALL_STATE(611)] = 8587,
  [SMALL_STATE(612)] = 8722,
  [SMALL_STATE(613)] = 8857,
  [SMALL_STATE(614)] = 8992,
  [SMALL_STATE(615)] = 9127,
  [SMALL_STATE(616)] = 9262,
  [SMALL_STATE(617)] = 9397,
  [SMALL_STATE(618)] = 9532,
  [SMALL_STATE(619)] = 9667,
  [SMALL_STATE(620)] = 9802,
  [SMALL_STATE(621)] = 9937,
  [SMALL_STATE(622)] = 10072,
  [SMALL_STATE(623)] = 10207,
  [SMALL_STATE(624)] = 10342,
  [SMALL_STATE(625)] = 10477,
  [SMALL_STATE(626)] = 10612,
  [SMALL_STATE(627)] = 10747,
  [SMALL_STATE(628)] = 10882,
  [SMALL_STATE(629)] = 11017,
  [SMALL_STATE(630)] = 11152,
  [SMALL_STATE(631)] = 11287,
  [SMALL_STATE(632)] = 11422,
  [SMALL_STATE(633)] = 11557,
  [SMALL_STATE(634)] = 11692,
  [SMALL_STATE(635)] = 11827,
  [SMALL_STATE(636)] = 11962,
  [SMALL_STATE(637)] = 12097,
  [SMALL_STATE(638)] = 12232,
  [SMALL_STATE(639)] = 12367,
  [SMALL_STATE(640)] = 12502,
  [SMALL_STATE(641)] = 12637,
  [SMALL_STATE(642)] = 12772,
  [SMALL_STATE(643)] = 12907,
  [SMALL_STATE(644)] = 13042,
  [SMALL_STATE(645)] = 13177,
  [SMALL_STATE(646)] = 13312,
  [SMALL_STATE(647)] = 13447,
  [SMALL_STATE(648)] = 13582,
  [SMALL_STATE(649)] = 13717,
  [SMALL_STATE(650)] = 13852,
  [SMALL_STATE(651)] = 13987,
  [SMALL_STATE(652)] = 14122,
  [SMALL_STATE(653)] = 14257,
  [SMALL_STATE(654)] = 14392,
  [SMALL_STATE(655)] = 14524,
  [SMALL_STATE(656)] = 14656,
  [SMALL_STATE(657)] = 14784,
  [SMALL_STATE(658)] = 14909,
  [SMALL_STATE(659)] = 15034,
  [SMALL_STATE(660)] = 15159,
  [SMALL_STATE(661)] = 15284,
  [SMALL_STATE(662)] = 15409,
  [SMALL_STATE(663)] = 15533,
  [SMALL_STATE(664)] = 15657,
  [SMALL_STATE(665)] = 15781,
  [SMALL_STATE(666)] = 15905,
  [SMALL_STATE(667)] = 16029,
  [SMALL_STATE(668)] = 16153,
  [SMALL_STATE(669)] = 16277,
  [SMALL_STATE(670)] = 16401,
  [SMALL_STATE(671)] = 16525,
  [SMALL_STATE(672)] = 16649,
  [SMALL_STATE(673)] = 16773,
  [SMALL_STATE(674)] = 16897,
  [SMALL_STATE(675)] = 17018,
  [SMALL_STATE(676)] = 17139,
  [SMALL_STATE(677)] = 17260,
  [SMALL_STATE(678)] = 17381,
  [SMALL_STATE(679)] = 17502,
  [SMALL_STATE(680)] = 17623,
  [SMALL_STATE(681)] = 17744,
  [SMALL_STATE(682)] = 17865,
  [SMALL_STATE(683)] = 17986,
  [SMALL_STATE(684)] = 18107,
  [SMALL_STATE(685)] = 18228,
  [SMALL_STATE(686)] = 18349,
  [SMALL_STATE(687)] = 18470,
  [SMALL_STATE(688)] = 18591,
  [SMALL_STATE(689)] = 18712,
  [SMALL_STATE(690)] = 18833,
  [SMALL_STATE(691)] = 18954,
  [SMALL_STATE(692)] = 19075,
  [SMALL_STATE(693)] = 19196,
  [SMALL_STATE(694)] = 19317,
  [SMALL_STATE(695)] = 19438,
  [SMALL_STATE(696)] = 19559,
  [SMALL_STATE(697)] = 19680,
  [SMALL_STATE(698)] = 19801,
  [SMALL_STATE(699)] = 19922,
  [SMALL_STATE(700)] = 20043,
  [SMALL_STATE(701)] = 20164,
  [SMALL_STATE(702)] = 20285,
  [SMALL_STATE(703)] = 20406,
  [SMALL_STATE(704)] = 20527,
  [SMALL_STATE(705)] = 20648,
  [SMALL_STATE(706)] = 20769,
  [SMALL_STATE(707)] = 20890,
  [SMALL_STATE(708)] = 21011,
  [SMALL_STATE(709)] = 21132,
  [SMALL_STATE(710)] = 21253,
  [SMALL_STATE(711)] = 21374,
  [SMALL_STATE(712)] = 21495,
  [SMALL_STATE(713)] = 21616,
  [SMALL_STATE(714)] = 21737,
  [SMALL_STATE(715)] = 21858,
  [SMALL_STATE(716)] = 21979,
  [SMALL_STATE(717)] = 22100,
  [SMALL_STATE(718)] = 22221,
  [SMALL_STATE(719)] = 22342,
  [SMALL_STATE(720)] = 22463,
  [SMALL_STATE(721)] = 22584,
  [SMALL_STATE(722)] = 22705,
  [SMALL_STATE(723)] = 22826,
  [SMALL_STATE(724)] = 22947,
  [SMALL_STATE(725)] = 23068,
  [SMALL_STATE(726)] = 23189,
  [SMALL_STATE(727)] = 23310,
  [SMALL_STATE(728)] = 23431,
  [SMALL_STATE(729)] = 23552,
  [SMALL_STATE(730)] = 23673,
  [SMALL_STATE(731)] = 23794,
  [SMALL_STATE(732)] = 23915,
  [SMALL_STATE(733)] = 24036,
  [SMALL_STATE(734)] = 24157,
  [SMALL_STATE(735)] = 24278,
  [SMALL_STATE(736)] = 24399,
  [SMALL_STATE(737)] = 24520,
  [SMALL_STATE(738)] = 24641,
  [SMALL_STATE(739)] = 24762,
  [SMALL_STATE(740)] = 24883,
  [SMALL_STATE(741)] = 25004,
  [SMALL_STATE(742)] = 25125,
  [SMALL_STATE(743)] = 25246,
  [SMALL_STATE(744)] = 25367,
  [SMALL_STATE(745)] = 25488,
  [SMALL_STATE(746)] = 25609,
  [SMALL_STATE(747)] = 25730,
  [SMALL_STATE(748)] = 25851,
  [SMALL_STATE(749)] = 25972,
  [SMALL_STATE(750)] = 26093,
  [SMALL_STATE(751)] = 26214,
  [SMALL_STATE(752)] = 26335,
  [SMALL_STATE(753)] = 26456,
  [SMALL_STATE(754)] = 26577,
  [SMALL_STATE(755)] = 26698,
  [SMALL_STATE(756)] = 26819,
  [SMALL_STATE(757)] = 26940,
  [SMALL_STATE(758)] = 27061,
  [SMALL_STATE(759)] = 27182,
  [SMALL_STATE(760)] = 27303,
  [SMALL_STATE(761)] = 27424,
  [SMALL_STATE(762)] = 27545,
  [SMALL_STATE(763)] = 27656,
  [SMALL_STATE(764)] = 27767,
  [SMALL_STATE(765)] = 27878,
  [SMALL_STATE(766)] = 27989,
  [SMALL_STATE(767)] = 28100,
  [SMALL_STATE(768)] = 28211,
  [SMALL_STATE(769)] = 28322,
  [SMALL_STATE(770)] = 28433,
  [SMALL_STATE(771)] = 28544,
  [SMALL_STATE(772)] = 28655,
  [SMALL_STATE(773)] = 28766,
  [SMALL_STATE(774)] = 28877,
  [SMALL_STATE(775)] = 28988,
  [SMALL_STATE(776)] = 29099,
  [SMALL_STATE(777)] = 29210,
  [SMALL_STATE(778)] = 29321,
  [SMALL_STATE(779)] = 29432,
  [SMALL_STATE(780)] = 29543,
  [SMALL_STATE(781)] = 29654,
  [SMALL_STATE(782)] = 29765,
  [SMALL_STATE(783)] = 29876,
  [SMALL_STATE(784)] = 29987,
  [SMALL_STATE(785)] = 30100,
  [SMALL_STATE(786)] = 30211,
  [SMALL_STATE(787)] = 30322,
  [SMALL_STATE(788)] = 30433,
  [SMALL_STATE(789)] = 30544,
  [SMALL_STATE(790)] = 30655,
  [SMALL_STATE(791)] = 30766,
  [SMALL_STATE(792)] = 30877,
  [SMALL_STATE(793)] = 30988,
  [SMALL_STATE(794)] = 31099,
  [SMALL_STATE(795)] = 31210,
  [SMALL_STATE(796)] = 31323,
  [SMALL_STATE(797)] = 31434,
  [SMALL_STATE(798)] = 31545,
  [SMALL_STATE(799)] = 31656,
  [SMALL_STATE(800)] = 31767,
  [SMALL_STATE(801)] = 31878,
  [SMALL_STATE(802)] = 31989,
  [SMALL_STATE(803)] = 32100,
  [SMALL_STATE(804)] = 32211,
  [SMALL_STATE(805)] = 32322,
  [SMALL_STATE(806)] = 32435,
  [SMALL_STATE(807)] = 32548,
  [SMALL_STATE(808)] = 32659,
  [SMALL_STATE(809)] = 32767,
  [SMALL_STATE(810)] = 32875,
  [SMALL_STATE(811)] = 32983,
  [SMALL_STATE(812)] = 33091,
  [SMALL_STATE(813)] = 33199,
  [SMALL_STATE(814)] = 33307,
  [SMALL_STATE(815)] = 33415,
  [SMALL_STATE(816)] = 33523,
  [SMALL_STATE(817)] = 33631,
  [SMALL_STATE(818)] = 33739,
  [SMALL_STATE(819)] = 33847,
  [SMALL_STATE(820)] = 33955,
  [SMALL_STATE(821)] = 34063,
  [SMALL_STATE(822)] = 34171,
  [SMALL_STATE(823)] = 34279,
  [SMALL_STATE(824)] = 34387,
  [SMALL_STATE(825)] = 34495,
  [SMALL_STATE(826)] = 34597,
  [SMALL_STATE(827)] = 34699,
  [SMALL_STATE(828)] = 34801,
  [SMALL_STATE(829)] = 34903,
  [SMALL_STATE(830)] = 35003,
  [SMALL_STATE(831)] = 35103,
  [SMALL_STATE(832)] = 35206,
  [SMALL_STATE(833)] = 35309,
  [SMALL_STATE(834)] = 35412,
  [SMALL_STATE(835)] = 35515,
  [SMALL_STATE(836)] = 35618,
  [SMALL_STATE(837)] = 35721,
  [SMALL_STATE(838)] = 35824,
  [SMALL_STATE(839)] = 35927,
  [SMALL_STATE(840)] = 36025,
  [SMALL_STATE(841)] = 36123,
  [SMALL_STATE(842)] = 36221,
  [SMALL_STATE(843)] = 36319,
  [SMALL_STATE(844)] = 36417,
  [SMALL_STATE(845)] = 36515,
  [SMALL_STATE(846)] = 36613,
  [SMALL_STATE(847)] = 36711,
  [SMALL_STATE(848)] = 36809,
  [SMALL_STATE(849)] = 36907,
  [SMALL_STATE(850)] = 37005,
  [SMALL_STATE(851)] = 37103,
  [SMALL_STATE(852)] = 37202,
  [SMALL_STATE(853)] = 37301,
  [SMALL_STATE(854)] = 37400,
  [SMALL_STATE(855)] = 37499,
  [SMALL_STATE(856)] = 37598,
  [SMALL_STATE(857)] = 37697,
  [SMALL_STATE(858)] = 37796,
  [SMALL_STATE(859)] = 37895,
  [SMALL_STATE(860)] = 37994,
  [SMALL_STATE(861)] = 38093,
  [SMALL_STATE(862)] = 38192,
  [SMALL_STATE(863)] = 38291,
  [SMALL_STATE(864)] = 38390,
  [SMALL_STATE(865)] = 38489,
  [SMALL_STATE(866)] = 38588,
  [SMALL_STATE(867)] = 38687,
  [SMALL_STATE(868)] = 38786,
  [SMALL_STATE(869)] = 38887,
  [SMALL_STATE(870)] = 38986,
  [SMALL_STATE(871)] = 39085,
  [SMALL_STATE(872)] = 39184,
  [SMALL_STATE(873)] = 39283,
  [SMALL_STATE(874)] = 39382,
  [SMALL_STATE(875)] = 39481,
  [SMALL_STATE(876)] = 39580,
  [SMALL_STATE(877)] = 39679,
  [SMALL_STATE(878)] = 39778,
  [SMALL_STATE(879)] = 39879,
  [SMALL_STATE(880)] = 39977,
  [SMALL_STATE(881)] = 40075,
  [SMALL_STATE(882)] = 40173,
  [SMALL_STATE(883)] = 40271,
  [SMALL_STATE(884)] = 40369,
  [SMALL_STATE(885)] = 40467,
  [SMALL_STATE(886)] = 40563,
  [SMALL_STATE(887)] = 40661,
  [SMALL_STATE(888)] = 40759,
  [SMALL_STATE(889)] = 40855,
  [SMALL_STATE(890)] = 40953,
  [SMALL_STATE(891)] = 41049,
  [SMALL_STATE(892)] = 41147,
  [SMALL_STATE(893)] = 41243,
  [SMALL_STATE(894)] = 41341,
  [SMALL_STATE(895)] = 41439,
  [SMALL_STATE(896)] = 41537,
  [SMALL_STATE(897)] = 41635,
  [SMALL_STATE(898)] = 41733,
  [SMALL_STATE(899)] = 41831,
  [SMALL_STATE(900)] = 41929,
  [SMALL_STATE(901)] = 42027,
  [SMALL_STATE(902)] = 42125,
  [SMALL_STATE(903)] = 42221,
  [SMALL_STATE(904)] = 42313,
  [SMALL_STATE(905)] = 42409,
  [SMALL_STATE(906)] = 42507,
  [SMALL_STATE(907)] = 42605,
  [SMALL_STATE(908)] = 42703,
  [SMALL_STATE(909)] = 42801,
  [SMALL_STATE(910)] = 42893,
  [SMALL_STATE(911)] = 42991,
  [SMALL_STATE(912)] = 43089,
  [SMALL_STATE(913)] = 43187,
  [SMALL_STATE(914)] = 43285,
  [SMALL_STATE(915)] = 43383,
  [SMALL_STATE(916)] = 43475,
  [SMALL_STATE(917)] = 43571,
  [SMALL_STATE(918)] = 43669,
  [SMALL_STATE(919)] = 43767,
  [SMALL_STATE(920)] = 43865,
  [SMALL_STATE(921)] = 43963,
  [SMALL_STATE(922)] = 44061,
  [SMALL_STATE(923)] = 44159,
  [SMALL_STATE(924)] = 44257,
  [SMALL_STATE(925)] = 44355,
  [SMALL_STATE(926)] = 44453,
  [SMALL_STATE(927)] = 44551,
  [SMALL_STATE(928)] = 44649,
  [SMALL_STATE(929)] = 44747,
  [SMALL_STATE(930)] = 44845,
  [SMALL_STATE(931)] = 44943,
  [SMALL_STATE(932)] = 45041,
  [SMALL_STATE(933)] = 45139,
  [SMALL_STATE(934)] = 45237,
  [SMALL_STATE(935)] = 45335,
  [SMALL_STATE(936)] = 45433,
  [SMALL_STATE(937)] = 45531,
  [SMALL_STATE(938)] = 45629,
  [SMALL_STATE(939)] = 45727,
  [SMALL_STATE(940)] = 45823,
  [SMALL_STATE(941)] = 45921,
  [SMALL_STATE(942)] = 46019,
  [SMALL_STATE(943)] = 46115,
  [SMALL_STATE(944)] = 46213,
  [SMALL_STATE(945)] = 46309,
  [SMALL_STATE(946)] = 46407,
  [SMALL_STATE(947)] = 46505,
  [SMALL_STATE(948)] = 46588,
  [SMALL_STATE(949)] = 46671,
  [SMALL_STATE(950)] = 46754,
  [SMALL_STATE(951)] = 46837,
  [SMALL_STATE(952)] = 46926,
  [SMALL_STATE(953)] = 47009,
  [SMALL_STATE(954)] = 47098,
  [SMALL_STATE(955)] = 47189,
  [SMALL_STATE(956)] = 47272,
  [SMALL_STATE(957)] = 47363,
  [SMALL_STATE(958)] = 47446,
  [SMALL_STATE(959)] = 47537,
  [SMALL_STATE(960)] = 47628,
  [SMALL_STATE(961)] = 47711,
  [SMALL_STATE(962)] = 47802,
  [SMALL_STATE(963)] = 47893,
  [SMALL_STATE(964)] = 47982,
  [SMALL_STATE(965)] = 48071,
  [SMALL_STATE(966)] = 48162,
  [SMALL_STATE(967)] = 48251,
  [SMALL_STATE(968)] = 48334,
  [SMALL_STATE(969)] = 48417,
  [SMALL_STATE(970)] = 48500,
  [SMALL_STATE(971)] = 48595,
  [SMALL_STATE(972)] = 48678,
  [SMALL_STATE(973)] = 48761,
  [SMALL_STATE(974)] = 48844,
  [SMALL_STATE(975)] = 48927,
  [SMALL_STATE(976)] = 49018,
  [SMALL_STATE(977)] = 49109,
  [SMALL_STATE(978)] = 49198,
  [SMALL_STATE(979)] = 49293,
  [SMALL_STATE(980)] = 49375,
  [SMALL_STATE(981)] = 49457,
  [SMALL_STATE(982)] = 49547,
  [SMALL_STATE(983)] = 49637,
  [SMALL_STATE(984)] = 49719,
  [SMALL_STATE(985)] = 49801,
  [SMALL_STATE(986)] = 49883,
  [SMALL_STATE(987)] = 49975,
  [SMALL_STATE(988)] = 50065,
  [SMALL_STATE(989)] = 50147,
  [SMALL_STATE(990)] = 50229,
  [SMALL_STATE(991)] = 50311,
  [SMALL_STATE(992)] = 50403,
  [SMALL_STATE(993)] = 50485,
  [SMALL_STATE(994)] = 50567,
  [SMALL_STATE(995)] = 50659,
  [SMALL_STATE(996)] = 50751,
  [SMALL_STATE(997)] = 50843,
  [SMALL_STATE(998)] = 50925,
  [SMALL_STATE(999)] = 51017,
  [SMALL_STATE(1000)] = 51109,
  [SMALL_STATE(1001)] = 51201,
  [SMALL_STATE(1002)] = 51291,
  [SMALL_STATE(1003)] = 51379,
  [SMALL_STATE(1004)] = 51471,
  [SMALL_STATE(1005)] = 51563,
  [SMALL_STATE(1006)] = 51655,
  [SMALL_STATE(1007)] = 51743,
  [SMALL_STATE(1008)] = 51831,
  [SMALL_STATE(1009)] = 51921,
  [SMALL_STATE(1010)] = 52013,
  [SMALL_STATE(1011)] = 52103,
  [SMALL_STATE(1012)] = 52195,
  [SMALL_STATE(1013)] = 52277,
  [SMALL_STATE(1014)] = 52359,
  [SMALL_STATE(1015)] = 52441,
  [SMALL_STATE(1016)] = 52533,
  [SMALL_STATE(1017)] = 52623,
  [SMALL_STATE(1018)] = 52715,
  [SMALL_STATE(1019)] = 52807,
  [SMALL_STATE(1020)] = 52899,
  [SMALL_STATE(1021)] = 52981,
  [SMALL_STATE(1022)] = 53063,
  [SMALL_STATE(1023)] = 53145,
  [SMALL_STATE(1024)] = 53227,
  [SMALL_STATE(1025)] = 53309,
  [SMALL_STATE(1026)] = 53391,
  [SMALL_STATE(1027)] = 53473,
  [SMALL_STATE(1028)] = 53563,
  [SMALL_STATE(1029)] = 53653,
  [SMALL_STATE(1030)] = 53735,
  [SMALL_STATE(1031)] = 53817,
  [SMALL_STATE(1032)] = 53899,
  [SMALL_STATE(1033)] = 53981,
  [SMALL_STATE(1034)] = 54076,
  [SMALL_STATE(1035)] = 54167,
  [SMALL_STATE(1036)] = 54258,
  [SMALL_STATE(1037)] = 54353,
  [SMALL_STATE(1038)] = 54448,
  [SMALL_STATE(1039)] = 54529,
  [SMALL_STATE(1040)] = 54624,
  [SMALL_STATE(1041)] = 54719,
  [SMALL_STATE(1042)] = 54810,
  [SMALL_STATE(1043)] = 54901,
  [SMALL_STATE(1044)] = 54996,
  [SMALL_STATE(1045)] = 55087,
  [SMALL_STATE(1046)] = 55182,
  [SMALL_STATE(1047)] = 55273,
  [SMALL_STATE(1048)] = 55364,
  [SMALL_STATE(1049)] = 55455,
  [SMALL_STATE(1050)] = 55546,
  [SMALL_STATE(1051)] = 55637,
  [SMALL_STATE(1052)] = 55718,
  [SMALL_STATE(1053)] = 55813,
  [SMALL_STATE(1054)] = 55908,
  [SMALL_STATE(1055)] = 56003,
  [SMALL_STATE(1056)] = 56094,
  [SMALL_STATE(1057)] = 56185,
  [SMALL_STATE(1058)] = 56276,
  [SMALL_STATE(1059)] = 56367,
  [SMALL_STATE(1060)] = 56462,
  [SMALL_STATE(1061)] = 56557,
  [SMALL_STATE(1062)] = 56652,
  [SMALL_STATE(1063)] = 56747,
  [SMALL_STATE(1064)] = 56842,
  [SMALL_STATE(1065)] = 56937,
  [SMALL_STATE(1066)] = 57028,
  [SMALL_STATE(1067)] = 57119,
  [SMALL_STATE(1068)] = 57210,
  [SMALL_STATE(1069)] = 57305,
  [SMALL_STATE(1070)] = 57396,
  [SMALL_STATE(1071)] = 57487,
  [SMALL_STATE(1072)] = 57582,
  [SMALL_STATE(1073)] = 57677,
  [SMALL_STATE(1074)] = 57772,
  [SMALL_STATE(1075)] = 57867,
  [SMALL_STATE(1076)] = 57958,
  [SMALL_STATE(1077)] = 58049,
  [SMALL_STATE(1078)] = 58144,
  [SMALL_STATE(1079)] = 58239,
  [SMALL_STATE(1080)] = 58334,
  [SMALL_STATE(1081)] = 58425,
  [SMALL_STATE(1082)] = 58520,
  [SMALL_STATE(1083)] = 58601,
  [SMALL_STATE(1084)] = 58696,
  [SMALL_STATE(1085)] = 58791,
  [SMALL_STATE(1086)] = 58886,
  [SMALL_STATE(1087)] = 58977,
  [SMALL_STATE(1088)] = 59068,
  [SMALL_STATE(1089)] = 59159,
  [SMALL_STATE(1090)] = 59250,
  [SMALL_STATE(1091)] = 59341,
  [SMALL_STATE(1092)] = 59436,
  [SMALL_STATE(1093)] = 59531,
  [SMALL_STATE(1094)] = 59622,
  [SMALL_STATE(1095)] = 59717,
  [SMALL_STATE(1096)] = 59808,
  [SMALL_STATE(1097)] = 59899,
  [SMALL_STATE(1098)] = 59994,
  [SMALL_STATE(1099)] = 60085,
  [SMALL_STATE(1100)] = 60180,
  [SMALL_STATE(1101)] = 60271,
  [SMALL_STATE(1102)] = 60362,
  [SMALL_STATE(1103)] = 60457,
  [SMALL_STATE(1104)] = 60552,
  [SMALL_STATE(1105)] = 60647,
  [SMALL_STATE(1106)] = 60742,
  [SMALL_STATE(1107)] = 60837,
  [SMALL_STATE(1108)] = 60928,
  [SMALL_STATE(1109)] = 61023,
  [SMALL_STATE(1110)] = 61114,
  [SMALL_STATE(1111)] = 61201,
  [SMALL_STATE(1112)] = 61282,
  [SMALL_STATE(1113)] = 61377,
  [SMALL_STATE(1114)] = 61468,
  [SMALL_STATE(1115)] = 61559,
  [SMALL_STATE(1116)] = 61646,
  [SMALL_STATE(1117)] = 61741,
  [SMALL_STATE(1118)] = 61822,
  [SMALL_STATE(1119)] = 61903,
  [SMALL_STATE(1120)] = 61998,
  [SMALL_STATE(1121)] = 62093,
  [SMALL_STATE(1122)] = 62184,
  [SMALL_STATE(1123)] = 62279,
  [SMALL_STATE(1124)] = 62374,
  [SMALL_STATE(1125)] = 62469,
  [SMALL_STATE(1126)] = 62564,
  [SMALL_STATE(1127)] = 62655,
  [SMALL_STATE(1128)] = 62750,
  [SMALL_STATE(1129)] = 62841,
  [SMALL_STATE(1130)] = 62932,
  [SMALL_STATE(1131)] = 63023,
  [SMALL_STATE(1132)] = 63114,
  [SMALL_STATE(1133)] = 63209,
  [SMALL_STATE(1134)] = 63304,
  [SMALL_STATE(1135)] = 63395,
  [SMALL_STATE(1136)] = 63486,
  [SMALL_STATE(1137)] = 63581,
  [SMALL_STATE(1138)] = 63672,
  [SMALL_STATE(1139)] = 63767,
  [SMALL_STATE(1140)] = 63858,
  [SMALL_STATE(1141)] = 63953,
  [SMALL_STATE(1142)] = 64034,
  [SMALL_STATE(1143)] = 64125,
  [SMALL_STATE(1144)] = 64220,
  [SMALL_STATE(1145)] = 64315,
  [SMALL_STATE(1146)] = 64402,
  [SMALL_STATE(1147)] = 64497,
  [SMALL_STATE(1148)] = 64584,
  [SMALL_STATE(1149)] = 64675,
  [SMALL_STATE(1150)] = 64770,
  [SMALL_STATE(1151)] = 64865,
  [SMALL_STATE(1152)] = 64960,
  [SMALL_STATE(1153)] = 65055,
  [SMALL_STATE(1154)] = 65150,
  [SMALL_STATE(1155)] = 65241,
  [SMALL_STATE(1156)] = 65332,
  [SMALL_STATE(1157)] = 65423,
  [SMALL_STATE(1158)] = 65514,
  [SMALL_STATE(1159)] = 65605,
  [SMALL_STATE(1160)] = 65696,
  [SMALL_STATE(1161)] = 65791,
  [SMALL_STATE(1162)] = 65882,
  [SMALL_STATE(1163)] = 65973,
  [SMALL_STATE(1164)] = 66064,
  [SMALL_STATE(1165)] = 66155,
  [SMALL_STATE(1166)] = 66246,
  [SMALL_STATE(1167)] = 66341,
  [SMALL_STATE(1168)] = 66436,
  [SMALL_STATE(1169)] = 66527,
  [SMALL_STATE(1170)] = 66622,
  [SMALL_STATE(1171)] = 66717,
  [SMALL_STATE(1172)] = 66798,
  [SMALL_STATE(1173)] = 66893,
  [SMALL_STATE(1174)] = 66984,
  [SMALL_STATE(1175)] = 67079,
  [SMALL_STATE(1176)] = 67170,
  [SMALL_STATE(1177)] = 67261,
  [SMALL_STATE(1178)] = 67356,
  [SMALL_STATE(1179)] = 67447,
  [SMALL_STATE(1180)] = 67538,
  [SMALL_STATE(1181)] = 67633,
  [SMALL_STATE(1182)] = 67728,
  [SMALL_STATE(1183)] = 67819,
  [SMALL_STATE(1184)] = 67910,
  [SMALL_STATE(1185)] = 68005,
  [SMALL_STATE(1186)] = 68100,
  [SMALL_STATE(1187)] = 68195,
  [SMALL_STATE(1188)] = 68290,
  [SMALL_STATE(1189)] = 68385,
  [SMALL_STATE(1190)] = 68480,
  [SMALL_STATE(1191)] = 68575,
  [SMALL_STATE(1192)] = 68670,
  [SMALL_STATE(1193)] = 68765,
  [SMALL_STATE(1194)] = 68860,
  [SMALL_STATE(1195)] = 68941,
  [SMALL_STATE(1196)] = 69032,
  [SMALL_STATE(1197)] = 69127,
  [SMALL_STATE(1198)] = 69218,
  [SMALL_STATE(1199)] = 69299,
  [SMALL_STATE(1200)] = 69394,
  [SMALL_STATE(1201)] = 69475,
  [SMALL_STATE(1202)] = 69566,
  [SMALL_STATE(1203)] = 69657,
  [SMALL_STATE(1204)] = 69738,
  [SMALL_STATE(1205)] = 69829,
  [SMALL_STATE(1206)] = 69924,
  [SMALL_STATE(1207)] = 70015,
  [SMALL_STATE(1208)] = 70110,
  [SMALL_STATE(1209)] = 70205,
  [SMALL_STATE(1210)] = 70300,
  [SMALL_STATE(1211)] = 70391,
  [SMALL_STATE(1212)] = 70482,
  [SMALL_STATE(1213)] = 70573,
  [SMALL_STATE(1214)] = 70668,
  [SMALL_STATE(1215)] = 70759,
  [SMALL_STATE(1216)] = 70854,
  [SMALL_STATE(1217)] = 70949,
  [SMALL_STATE(1218)] = 71040,
  [SMALL_STATE(1219)] = 71135,
  [SMALL_STATE(1220)] = 71226,
  [SMALL_STATE(1221)] = 71321,
  [SMALL_STATE(1222)] = 71412,
  [SMALL_STATE(1223)] = 71507,
  [SMALL_STATE(1224)] = 71602,
  [SMALL_STATE(1225)] = 71697,
  [SMALL_STATE(1226)] = 71778,
  [SMALL_STATE(1227)] = 71873,
  [SMALL_STATE(1228)] = 71954,
  [SMALL_STATE(1229)] = 72035,
  [SMALL_STATE(1230)] = 72130,
  [SMALL_STATE(1231)] = 72211,
  [SMALL_STATE(1232)] = 72302,
  [SMALL_STATE(1233)] = 72397,
  [SMALL_STATE(1234)] = 72488,
  [SMALL_STATE(1235)] = 72583,
  [SMALL_STATE(1236)] = 72678,
  [SMALL_STATE(1237)] = 72769,
  [SMALL_STATE(1238)] = 72864,
  [SMALL_STATE(1239)] = 72955,
  [SMALL_STATE(1240)] = 73050,
  [SMALL_STATE(1241)] = 73145,
  [SMALL_STATE(1242)] = 73240,
  [SMALL_STATE(1243)] = 73333,
  [SMALL_STATE(1244)] = 73420,
  [SMALL_STATE(1245)] = 73515,
  [SMALL_STATE(1246)] = 73610,
  [SMALL_STATE(1247)] = 73705,
  [SMALL_STATE(1248)] = 73800,
  [SMALL_STATE(1249)] = 73895,
  [SMALL_STATE(1250)] = 73990,
  [SMALL_STATE(1251)] = 74077,
  [SMALL_STATE(1252)] = 74158,
  [SMALL_STATE(1253)] = 74239,
  [SMALL_STATE(1254)] = 74334,
  [SMALL_STATE(1255)] = 74429,
  [SMALL_STATE(1256)] = 74524,
  [SMALL_STATE(1257)] = 74615,
  [SMALL_STATE(1258)] = 74710,
  [SMALL_STATE(1259)] = 74791,
  [SMALL_STATE(1260)] = 74882,
  [SMALL_STATE(1261)] = 74963,
  [SMALL_STATE(1262)] = 75054,
  [SMALL_STATE(1263)] = 75149,
  [SMALL_STATE(1264)] = 75244,
  [SMALL_STATE(1265)] = 75339,
  [SMALL_STATE(1266)] = 75430,
  [SMALL_STATE(1267)] = 75525,
  [SMALL_STATE(1268)] = 75620,
  [SMALL_STATE(1269)] = 75711,
  [SMALL_STATE(1270)] = 75806,
  [SMALL_STATE(1271)] = 75897,
  [SMALL_STATE(1272)] = 75992,
  [SMALL_STATE(1273)] = 76084,
  [SMALL_STATE(1274)] = 76176,
  [SMALL_STATE(1275)] = 76264,
  [SMALL_STATE(1276)] = 76356,
  [SMALL_STATE(1277)] = 76448,
  [SMALL_STATE(1278)] = 76528,
  [SMALL_STATE(1279)] = 76620,
  [SMALL_STATE(1280)] = 76712,
  [SMALL_STATE(1281)] = 76800,
  [SMALL_STATE(1282)] = 76880,
  [SMALL_STATE(1283)] = 76972,
  [SMALL_STATE(1284)] = 77064,
  [SMALL_STATE(1285)] = 77152,
  [SMALL_STATE(1286)] = 77232,
  [SMALL_STATE(1287)] = 77312,
  [SMALL_STATE(1288)] = 77392,
  [SMALL_STATE(1289)] = 77484,
  [SMALL_STATE(1290)] = 77564,
  [SMALL_STATE(1291)] = 77656,
  [SMALL_STATE(1292)] = 77748,
  [SMALL_STATE(1293)] = 77836,
  [SMALL_STATE(1294)] = 77928,
  [SMALL_STATE(1295)] = 78020,
  [SMALL_STATE(1296)] = 78112,
  [SMALL_STATE(1297)] = 78192,
  [SMALL_STATE(1298)] = 78272,
  [SMALL_STATE(1299)] = 78360,
  [SMALL_STATE(1300)] = 78452,
  [SMALL_STATE(1301)] = 78540,
  [SMALL_STATE(1302)] = 78632,
  [SMALL_STATE(1303)] = 78724,
  [SMALL_STATE(1304)] = 78804,
  [SMALL_STATE(1305)] = 78892,
  [SMALL_STATE(1306)] = 78984,
  [SMALL_STATE(1307)] = 79076,
  [SMALL_STATE(1308)] = 79164,
  [SMALL_STATE(1309)] = 79256,
  [SMALL_STATE(1310)] = 79348,
  [SMALL_STATE(1311)] = 79428,
  [SMALL_STATE(1312)] = 79508,
  [SMALL_STATE(1313)] = 79588,
  [SMALL_STATE(1314)] = 79676,
  [SMALL_STATE(1315)] = 79768,
  [SMALL_STATE(1316)] = 79860,
  [SMALL_STATE(1317)] = 79948,
  [SMALL_STATE(1318)] = 80040,
  [SMALL_STATE(1319)] = 80120,
  [SMALL_STATE(1320)] = 80208,
  [SMALL_STATE(1321)] = 80300,
  [SMALL_STATE(1322)] = 80380,
  [SMALL_STATE(1323)] = 80460,
  [SMALL_STATE(1324)] = 80548,
  [SMALL_STATE(1325)] = 80628,
  [SMALL_STATE(1326)] = 80716,
  [SMALL_STATE(1327)] = 80796,
  [SMALL_STATE(1328)] = 80884,
  [SMALL_STATE(1329)] = 80976,
  [SMALL_STATE(1330)] = 81068,
  [SMALL_STATE(1331)] = 81160,
  [SMALL_STATE(1332)] = 81252,
  [SMALL_STATE(1333)] = 81344,
  [SMALL_STATE(1334)] = 81436,
  [SMALL_STATE(1335)] = 81528,
  [SMALL_STATE(1336)] = 81620,
  [SMALL_STATE(1337)] = 81712,
  [SMALL_STATE(1338)] = 81792,
  [SMALL_STATE(1339)] = 81884,
  [SMALL_STATE(1340)] = 81976,
  [SMALL_STATE(1341)] = 82064,
  [SMALL_STATE(1342)] = 82156,
  [SMALL_STATE(1343)] = 82248,
  [SMALL_STATE(1344)] = 82328,
  [SMALL_STATE(1345)] = 82420,
  [SMALL_STATE(1346)] = 82512,
  [SMALL_STATE(1347)] = 82592,
  [SMALL_STATE(1348)] = 82672,
  [SMALL_STATE(1349)] = 82760,
  [SMALL_STATE(1350)] = 82840,
  [SMALL_STATE(1351)] = 82928,
  [SMALL_STATE(1352)] = 83020,
  [SMALL_STATE(1353)] = 83112,
  [SMALL_STATE(1354)] = 83204,
  [SMALL_STATE(1355)] = 83284,
  [SMALL_STATE(1356)] = 83372,
  [SMALL_STATE(1357)] = 83464,
  [SMALL_STATE(1358)] = 83544,
  [SMALL_STATE(1359)] = 83624,
  [SMALL_STATE(1360)] = 83712,
  [SMALL_STATE(1361)] = 83792,
  [SMALL_STATE(1362)] = 83880,
  [SMALL_STATE(1363)] = 83960,
  [SMALL_STATE(1364)] = 84052,
  [SMALL_STATE(1365)] = 84144,
  [SMALL_STATE(1366)] = 84224,
  [SMALL_STATE(1367)] = 84304,
  [SMALL_STATE(1368)] = 84384,
  [SMALL_STATE(1369)] = 84476,
  [SMALL_STATE(1370)] = 84568,
  [SMALL_STATE(1371)] = 84647,
  [SMALL_STATE(1372)] = 84724,
  [SMALL_STATE(1373)] = 84801,
  [SMALL_STATE(1374)] = 84880,
  [SMALL_STATE(1375)] = 84959,
  [SMALL_STATE(1376)] = 85038,
  [SMALL_STATE(1377)] = 85123,
  [SMALL_STATE(1378)] = 85202,
  [SMALL_STATE(1379)] = 85281,
  [SMALL_STATE(1380)] = 85360,
  [SMALL_STATE(1381)] = 85439,
  [SMALL_STATE(1382)] = 85518,
  [SMALL_STATE(1383)] = 85597,
  [SMALL_STATE(1384)] = 85674,
  [SMALL_STATE(1385)] = 85753,
  [SMALL_STATE(1386)] = 85832,
  [SMALL_STATE(1387)] = 85911,
  [SMALL_STATE(1388)] = 85998,
  [SMALL_STATE(1389)] = 86077,
  [SMALL_STATE(1390)] = 86156,
  [SMALL_STATE(1391)] = 86235,
  [SMALL_STATE(1392)] = 86322,
  [SMALL_STATE(1393)] = 86399,
  [SMALL_STATE(1394)] = 86478,
  [SMALL_STATE(1395)] = 86555,
  [SMALL_STATE(1396)] = 86632,
  [SMALL_STATE(1397)] = 86711,
  [SMALL_STATE(1398)] = 86790,
  [SMALL_STATE(1399)] = 86867,
  [SMALL_STATE(1400)] = 86944,
  [SMALL_STATE(1401)] = 87021,
  [SMALL_STATE(1402)] = 87108,
  [SMALL_STATE(1403)] = 87187,
  [SMALL_STATE(1404)] = 87266,
  [SMALL_STATE(1405)] = 87345,
  [SMALL_STATE(1406)] = 87424,
  [SMALL_STATE(1407)] = 87503,
  [SMALL_STATE(1408)] = 87580,
  [SMALL_STATE(1409)] = 87659,
  [SMALL_STATE(1410)] = 87735,
  [SMALL_STATE(1411)] = 87813,
  [SMALL_STATE(1412)] = 87891,
  [SMALL_STATE(1413)] = 87967,
  [SMALL_STATE(1414)] = 88045,
  [SMALL_STATE(1415)] = 88123,
  [SMALL_STATE(1416)] = 88201,
  [SMALL_STATE(1417)] = 88279,
  [SMALL_STATE(1418)] = 88357,
  [SMALL_STATE(1419)] = 88433,
  [SMALL_STATE(1420)] = 88509,
  [SMALL_STATE(1421)] = 88587,
  [SMALL_STATE(1422)] = 88665,
  [SMALL_STATE(1423)] = 88743,
  [SMALL_STATE(1424)] = 88821,
  [SMALL_STATE(1425)] = 88899,
  [SMALL_STATE(1426)] = 88977,
  [SMALL_STATE(1427)] = 89055,
  [SMALL_STATE(1428)] = 89133,
  [SMALL_STATE(1429)] = 89211,
  [SMALL_STATE(1430)] = 89287,
  [SMALL_STATE(1431)] = 89365,
  [SMALL_STATE(1432)] = 89443,
  [SMALL_STATE(1433)] = 89519,
  [SMALL_STATE(1434)] = 89597,
  [SMALL_STATE(1435)] = 89673,
  [SMALL_STATE(1436)] = 89749,
  [SMALL_STATE(1437)] = 89827,
  [SMALL_STATE(1438)] = 89905,
  [SMALL_STATE(1439)] = 89983,
  [SMALL_STATE(1440)] = 90061,
  [SMALL_STATE(1441)] = 90139,
  [SMALL_STATE(1442)] = 90217,
  [SMALL_STATE(1443)] = 90293,
  [SMALL_STATE(1444)] = 90369,
  [SMALL_STATE(1445)] = 90447,
  [SMALL_STATE(1446)] = 90525,
  [SMALL_STATE(1447)] = 90603,
  [SMALL_STATE(1448)] = 90681,
  [SMALL_STATE(1449)] = 90759,
  [SMALL_STATE(1450)] = 90836,
  [SMALL_STATE(1451)] = 90913,
  [SMALL_STATE(1452)] = 90990,
  [SMALL_STATE(1453)] = 91067,
  [SMALL_STATE(1454)] = 91144,
  [SMALL_STATE(1455)] = 91221,
  [SMALL_STATE(1456)] = 91302,
  [SMALL_STATE(1457)] = 91379,
  [SMALL_STATE(1458)] = 91456,
  [SMALL_STATE(1459)] = 91537,
  [SMALL_STATE(1460)] = 91614,
  [SMALL_STATE(1461)] = 91695,
  [SMALL_STATE(1462)] = 91776,
  [SMALL_STATE(1463)] = 91857,
  [SMALL_STATE(1464)] = 91934,
  [SMALL_STATE(1465)] = 92017,
  [SMALL_STATE(1466)] = 92094,
  [SMALL_STATE(1467)] = 92175,
  [SMALL_STATE(1468)] = 92230,
  [SMALL_STATE(1469)] = 92311,
  [SMALL_STATE(1470)] = 92392,
  [SMALL_STATE(1471)] = 92473,
  [SMALL_STATE(1472)] = 92550,
  [SMALL_STATE(1473)] = 92627,
  [SMALL_STATE(1474)] = 92708,
  [SMALL_STATE(1475)] = 92789,
  [SMALL_STATE(1476)] = 92866,
  [SMALL_STATE(1477)] = 92943,
  [SMALL_STATE(1478)] = 93024,
  [SMALL_STATE(1479)] = 93105,
  [SMALL_STATE(1480)] = 93160,
  [SMALL_STATE(1481)] = 93237,
  [SMALL_STATE(1482)] = 93314,
  [SMALL_STATE(1483)] = 93391,
  [SMALL_STATE(1484)] = 93472,
  [SMALL_STATE(1485)] = 93553,
  [SMALL_STATE(1486)] = 93634,
  [SMALL_STATE(1487)] = 93711,
  [SMALL_STATE(1488)] = 93792,
  [SMALL_STATE(1489)] = 93869,
  [SMALL_STATE(1490)] = 93946,
  [SMALL_STATE(1491)] = 94023,
  [SMALL_STATE(1492)] = 94100,
  [SMALL_STATE(1493)] = 94143,
  [SMALL_STATE(1494)] = 94224,
  [SMALL_STATE(1495)] = 94301,
  [SMALL_STATE(1496)] = 94382,
  [SMALL_STATE(1497)] = 94459,
  [SMALL_STATE(1498)] = 94540,
  [SMALL_STATE(1499)] = 94620,
  [SMALL_STATE(1500)] = 94700,
  [SMALL_STATE(1501)] = 94776,
  [SMALL_STATE(1502)] = 94850,
  [SMALL_STATE(1503)] = 94896,
  [SMALL_STATE(1504)] = 94972,
  [SMALL_STATE(1505)] = 95046,
  [SMALL_STATE(1506)] = 95126,
  [SMALL_STATE(1507)] = 95200,
  [SMALL_STATE(1508)] = 95280,
  [SMALL_STATE(1509)] = 95354,
  [SMALL_STATE(1510)] = 95400,
  [SMALL_STATE(1511)] = 95474,
  [SMALL_STATE(1512)] = 95548,
  [SMALL_STATE(1513)] = 95624,
  [SMALL_STATE(1514)] = 95704,
  [SMALL_STATE(1515)] = 95746,
  [SMALL_STATE(1516)] = 95826,
  [SMALL_STATE(1517)] = 95906,
  [SMALL_STATE(1518)] = 95980,
  [SMALL_STATE(1519)] = 96060,
  [SMALL_STATE(1520)] = 96134,
  [SMALL_STATE(1521)] = 96180,
  [SMALL_STATE(1522)] = 96256,
  [SMALL_STATE(1523)] = 96330,
  [SMALL_STATE(1524)] = 96410,
  [SMALL_STATE(1525)] = 96484,
  [SMALL_STATE(1526)] = 96558,
  [SMALL_STATE(1527)] = 96606,
  [SMALL_STATE(1528)] = 96680,
  [SMALL_STATE(1529)] = 96728,
  [SMALL_STATE(1530)] = 96808,
  [SMALL_STATE(1531)] = 96882,
  [SMALL_STATE(1532)] = 96958,
  [SMALL_STATE(1533)] = 97006,
  [SMALL_STATE(1534)] = 97080,
  [SMALL_STATE(1535)] = 97160,
  [SMALL_STATE(1536)] = 97234,
  [SMALL_STATE(1537)] = 97314,
  [SMALL_STATE(1538)] = 97394,
  [SMALL_STATE(1539)] = 97442,
  [SMALL_STATE(1540)] = 97516,
  [SMALL_STATE(1541)] = 97590,
  [SMALL_STATE(1542)] = 97664,
  [SMALL_STATE(1543)] = 97710,
  [SMALL_STATE(1544)] = 97790,
  [SMALL_STATE(1545)] = 97870,
  [SMALL_STATE(1546)] = 97916,
  [SMALL_STATE(1547)] = 97962,
  [SMALL_STATE(1548)] = 98036,
  [SMALL_STATE(1549)] = 98116,
  [SMALL_STATE(1550)] = 98196,
  [SMALL_STATE(1551)] = 98276,
  [SMALL_STATE(1552)] = 98352,
  [SMALL_STATE(1553)] = 98426,
  [SMALL_STATE(1554)] = 98506,
  [SMALL_STATE(1555)] = 98582,
  [SMALL_STATE(1556)] = 98656,
  [SMALL_STATE(1557)] = 98702,
  [SMALL_STATE(1558)] = 98782,
  [SMALL_STATE(1559)] = 98862,
  [SMALL_STATE(1560)] = 98936,
  [SMALL_STATE(1561)] = 99016,
  [SMALL_STATE(1562)] = 99090,
  [SMALL_STATE(1563)] = 99170,
  [SMALL_STATE(1564)] = 99250,
  [SMALL_STATE(1565)] = 99330,
  [SMALL_STATE(1566)] = 99404,
  [SMALL_STATE(1567)] = 99478,
  [SMALL_STATE(1568)] = 99552,
  [SMALL_STATE(1569)] = 99626,
  [SMALL_STATE(1570)] = 99700,
  [SMALL_STATE(1571)] = 99780,
  [SMALL_STATE(1572)] = 99826,
  [SMALL_STATE(1573)] = 99906,
  [SMALL_STATE(1574)] = 99986,
  [SMALL_STATE(1575)] = 100066,
  [SMALL_STATE(1576)] = 100140,
  [SMALL_STATE(1577)] = 100214,
  [SMALL_STATE(1578)] = 100294,
  [SMALL_STATE(1579)] = 100368,
  [SMALL_STATE(1580)] = 100442,
  [SMALL_STATE(1581)] = 100522,
  [SMALL_STATE(1582)] = 100596,
  [SMALL_STATE(1583)] = 100676,
  [SMALL_STATE(1584)] = 100750,
  [SMALL_STATE(1585)] = 100824,
  [SMALL_STATE(1586)] = 100900,
  [SMALL_STATE(1587)] = 100974,
  [SMALL_STATE(1588)] = 101048,
  [SMALL_STATE(1589)] = 101094,
  [SMALL_STATE(1590)] = 101174,
  [SMALL_STATE(1591)] = 101248,
  [SMALL_STATE(1592)] = 101322,
  [SMALL_STATE(1593)] = 101396,
  [SMALL_STATE(1594)] = 101476,
  [SMALL_STATE(1595)] = 101550,
  [SMALL_STATE(1596)] = 101596,
  [SMALL_STATE(1597)] = 101642,
  [SMALL_STATE(1598)] = 101684,
  [SMALL_STATE(1599)] = 101730,
  [SMALL_STATE(1600)] = 101810,
  [SMALL_STATE(1601)] = 101884,
  [SMALL_STATE(1602)] = 101958,
  [SMALL_STATE(1603)] = 102034,
  [SMALL_STATE(1604)] = 102082,
  [SMALL_STATE(1605)] = 102130,
  [SMALL_STATE(1606)] = 102206,
  [SMALL_STATE(1607)] = 102280,
  [SMALL_STATE(1608)] = 102360,
  [SMALL_STATE(1609)] = 102440,
  [SMALL_STATE(1610)] = 102520,
  [SMALL_STATE(1611)] = 102593,
  [SMALL_STATE(1612)] = 102666,
  [SMALL_STATE(1613)] = 102711,
  [SMALL_STATE(1614)] = 102784,
  [SMALL_STATE(1615)] = 102829,
  [SMALL_STATE(1616)] = 102870,
  [SMALL_STATE(1617)] = 102915,
  [SMALL_STATE(1618)] = 102958,
  [SMALL_STATE(1619)] = 103003,
  [SMALL_STATE(1620)] = 103044,
  [SMALL_STATE(1621)] = 103117,
  [SMALL_STATE(1622)] = 103158,
  [SMALL_STATE(1623)] = 103199,
  [SMALL_STATE(1624)] = 103272,
  [SMALL_STATE(1625)] = 103313,
  [SMALL_STATE(1626)] = 103360,
  [SMALL_STATE(1627)] = 103407,
  [SMALL_STATE(1628)] = 103448,
  [SMALL_STATE(1629)] = 103521,
  [SMALL_STATE(1630)] = 103594,
  [SMALL_STATE(1631)] = 103667,
  [SMALL_STATE(1632)] = 103710,
  [SMALL_STATE(1633)] = 103751,
  [SMALL_STATE(1634)] = 103794,
  [SMALL_STATE(1635)] = 103835,
  [SMALL_STATE(1636)] = 103908,
  [SMALL_STATE(1637)] = 103951,
  [SMALL_STATE(1638)] = 103992,
  [SMALL_STATE(1639)] = 104033,
  [SMALL_STATE(1640)] = 104074,
  [SMALL_STATE(1641)] = 104127,
  [SMALL_STATE(1642)] = 104200,
  [SMALL_STATE(1643)] = 104243,
  [SMALL_STATE(1644)] = 104316,
  [SMALL_STATE(1645)] = 104359,
  [SMALL_STATE(1646)] = 104400,
  [SMALL_STATE(1647)] = 104443,
  [SMALL_STATE(1648)] = 104486,
  [SMALL_STATE(1649)] = 104529,
  [SMALL_STATE(1650)] = 104570,
  [SMALL_STATE(1651)] = 104611,
  [SMALL_STATE(1652)] = 104652,
  [SMALL_STATE(1653)] = 104725,
  [SMALL_STATE(1654)] = 104768,
  [SMALL_STATE(1655)] = 104811,
  [SMALL_STATE(1656)] = 104854,
  [SMALL_STATE(1657)] = 104895,
  [SMALL_STATE(1658)] = 104938,
  [SMALL_STATE(1659)] = 104979,
  [SMALL_STATE(1660)] = 105022,
  [SMALL_STATE(1661)] = 105095,
  [SMALL_STATE(1662)] = 105168,
  [SMALL_STATE(1663)] = 105241,
  [SMALL_STATE(1664)] = 105282,
  [SMALL_STATE(1665)] = 105325,
  [SMALL_STATE(1666)] = 105398,
  [SMALL_STATE(1667)] = 105439,
  [SMALL_STATE(1668)] = 105512,
  [SMALL_STATE(1669)] = 105555,
  [SMALL_STATE(1670)] = 105596,
  [SMALL_STATE(1671)] = 105639,
  [SMALL_STATE(1672)] = 105712,
  [SMALL_STATE(1673)] = 105753,
  [SMALL_STATE(1674)] = 105826,
  [SMALL_STATE(1675)] = 105899,
  [SMALL_STATE(1676)] = 105940,
  [SMALL_STATE(1677)] = 105981,
  [SMALL_STATE(1678)] = 106022,
  [SMALL_STATE(1679)] = 106095,
  [SMALL_STATE(1680)] = 106136,
  [SMALL_STATE(1681)] = 106181,
  [SMALL_STATE(1682)] = 106224,
  [SMALL_STATE(1683)] = 106269,
  [SMALL_STATE(1684)] = 106314,
  [SMALL_STATE(1685)] = 106359,
  [SMALL_STATE(1686)] = 106402,
  [SMALL_STATE(1687)] = 106449,
  [SMALL_STATE(1688)] = 106522,
  [SMALL_STATE(1689)] = 106569,
  [SMALL_STATE(1690)] = 106622,
  [SMALL_STATE(1691)] = 106665,
  [SMALL_STATE(1692)] = 106738,
  [SMALL_STATE(1693)] = 106811,
  [SMALL_STATE(1694)] = 106856,
  [SMALL_STATE(1695)] = 106929,
  [SMALL_STATE(1696)] = 107002,
  [SMALL_STATE(1697)] = 107047,
  [SMALL_STATE(1698)] = 107092,
  [SMALL_STATE(1699)] = 107133,
  [SMALL_STATE(1700)] = 107178,
  [SMALL_STATE(1701)] = 107225,
  [SMALL_STATE(1702)] = 107268,
  [SMALL_STATE(1703)] = 107315,
  [SMALL_STATE(1704)] = 107388,
  [SMALL_STATE(1705)] = 107431,
  [SMALL_STATE(1706)] = 107472,
  [SMALL_STATE(1707)] = 107515,
  [SMALL_STATE(1708)] = 107588,
  [SMALL_STATE(1709)] = 107631,
  [SMALL_STATE(1710)] = 107674,
  [SMALL_STATE(1711)] = 107717,
  [SMALL_STATE(1712)] = 107760,
  [SMALL_STATE(1713)] = 107801,
  [SMALL_STATE(1714)] = 107844,
  [SMALL_STATE(1715)] = 107885,
  [SMALL_STATE(1716)] = 107958,
  [SMALL_STATE(1717)] = 107999,
  [SMALL_STATE(1718)] = 108040,
  [SMALL_STATE(1719)] = 108081,
  [SMALL_STATE(1720)] = 108122,
  [SMALL_STATE(1721)] = 108195,
  [SMALL_STATE(1722)] = 108237,
  [SMALL_STATE(1723)] = 108281,
  [SMALL_STATE(1724)] = 108321,
  [SMALL_STATE(1725)] = 108361,
  [SMALL_STATE(1726)] = 108403,
  [SMALL_STATE(1727)] = 108443,
  [SMALL_STATE(1728)] = 108495,
  [SMALL_STATE(1729)] = 108537,
  [SMALL_STATE(1730)] = 108577,
  [SMALL_STATE(1731)] = 108617,
  [SMALL_STATE(1732)] = 108657,
  [SMALL_STATE(1733)] = 108697,
  [SMALL_STATE(1734)] = 108737,
  [SMALL_STATE(1735)] = 108777,
  [SMALL_STATE(1736)] = 108817,
  [SMALL_STATE(1737)] = 108857,
  [SMALL_STATE(1738)] = 108899,
  [SMALL_STATE(1739)] = 108941,
  [SMALL_STATE(1740)] = 108981,
  [SMALL_STATE(1741)] = 109021,
  [SMALL_STATE(1742)] = 109061,
  [SMALL_STATE(1743)] = 109101,
  [SMALL_STATE(1744)] = 109143,
  [SMALL_STATE(1745)] = 109183,
  [SMALL_STATE(1746)] = 109227,
  [SMALL_STATE(1747)] = 109273,
  [SMALL_STATE(1748)] = 109317,
  [SMALL_STATE(1749)] = 109357,
  [SMALL_STATE(1750)] = 109397,
  [SMALL_STATE(1751)] = 109439,
  [SMALL_STATE(1752)] = 109479,
  [SMALL_STATE(1753)] = 109519,
  [SMALL_STATE(1754)] = 109559,
  [SMALL_STATE(1755)] = 109599,
  [SMALL_STATE(1756)] = 109639,
  [SMALL_STATE(1757)] = 109679,
  [SMALL_STATE(1758)] = 109719,
  [SMALL_STATE(1759)] = 109759,
  [SMALL_STATE(1760)] = 109799,
  [SMALL_STATE(1761)] = 109839,
  [SMALL_STATE(1762)] = 109883,
  [SMALL_STATE(1763)] = 109927,
  [SMALL_STATE(1764)] = 109967,
  [SMALL_STATE(1765)] = 110011,
  [SMALL_STATE(1766)] = 110051,
  [SMALL_STATE(1767)] = 110091,
  [SMALL_STATE(1768)] = 110133,
  [SMALL_STATE(1769)] = 110173,
  [SMALL_STATE(1770)] = 110213,
  [SMALL_STATE(1771)] = 110259,
  [SMALL_STATE(1772)] = 110305,
  [SMALL_STATE(1773)] = 110345,
  [SMALL_STATE(1774)] = 110385,
  [SMALL_STATE(1775)] = 110429,
  [SMALL_STATE(1776)] = 110469,
  [SMALL_STATE(1777)] = 110513,
  [SMALL_STATE(1778)] = 110557,
  [SMALL_STATE(1779)] = 110599,
  [SMALL_STATE(1780)] = 110639,
  [SMALL_STATE(1781)] = 110683,
  [SMALL_STATE(1782)] = 110727,
  [SMALL_STATE(1783)] = 110771,
  [SMALL_STATE(1784)] = 110811,
  [SMALL_STATE(1785)] = 110851,
  [SMALL_STATE(1786)] = 110897,
  [SMALL_STATE(1787)] = 110937,
  [SMALL_STATE(1788)] = 110983,
  [SMALL_STATE(1789)] = 111023,
  [SMALL_STATE(1790)] = 111063,
  [SMALL_STATE(1791)] = 111105,
  [SMALL_STATE(1792)] = 111145,
  [SMALL_STATE(1793)] = 111185,
  [SMALL_STATE(1794)] = 111225,
  [SMALL_STATE(1795)] = 111265,
  [SMALL_STATE(1796)] = 111307,
  [SMALL_STATE(1797)] = 111349,
  [SMALL_STATE(1798)] = 111389,
  [SMALL_STATE(1799)] = 111429,
  [SMALL_STATE(1800)] = 111469,
  [SMALL_STATE(1801)] = 111513,
  [SMALL_STATE(1802)] = 111553,
  [SMALL_STATE(1803)] = 111593,
  [SMALL_STATE(1804)] = 111633,
  [SMALL_STATE(1805)] = 111673,
  [SMALL_STATE(1806)] = 111713,
  [SMALL_STATE(1807)] = 111753,
  [SMALL_STATE(1808)] = 111795,
  [SMALL_STATE(1809)] = 111839,
  [SMALL_STATE(1810)] = 111879,
  [SMALL_STATE(1811)] = 111919,
  [SMALL_STATE(1812)] = 111959,
  [SMALL_STATE(1813)] = 112001,
  [SMALL_STATE(1814)] = 112041,
  [SMALL_STATE(1815)] = 112081,
  [SMALL_STATE(1816)] = 112121,
  [SMALL_STATE(1817)] = 112163,
  [SMALL_STATE(1818)] = 112205,
  [SMALL_STATE(1819)] = 112249,
  [SMALL_STATE(1820)] = 112289,
  [SMALL_STATE(1821)] = 112331,
  [SMALL_STATE(1822)] = 112373,
  [SMALL_STATE(1823)] = 112415,
  [SMALL_STATE(1824)] = 112455,
  [SMALL_STATE(1825)] = 112499,
  [SMALL_STATE(1826)] = 112539,
  [SMALL_STATE(1827)] = 112579,
  [SMALL_STATE(1828)] = 112619,
  [SMALL_STATE(1829)] = 112661,
  [SMALL_STATE(1830)] = 112701,
  [SMALL_STATE(1831)] = 112741,
  [SMALL_STATE(1832)] = 112781,
  [SMALL_STATE(1833)] = 112825,
  [SMALL_STATE(1834)] = 112865,
  [SMALL_STATE(1835)] = 112905,
  [SMALL_STATE(1836)] = 112951,
  [SMALL_STATE(1837)] = 112991,
  [SMALL_STATE(1838)] = 113037,
  [SMALL_STATE(1839)] = 113077,
  [SMALL_STATE(1840)] = 113117,
  [SMALL_STATE(1841)] = 113157,
  [SMALL_STATE(1842)] = 113201,
  [SMALL_STATE(1843)] = 113241,
  [SMALL_STATE(1844)] = 113281,
  [SMALL_STATE(1845)] = 113321,
  [SMALL_STATE(1846)] = 113361,
  [SMALL_STATE(1847)] = 113401,
  [SMALL_STATE(1848)] = 113441,
  [SMALL_STATE(1849)] = 113481,
  [SMALL_STATE(1850)] = 113525,
  [SMALL_STATE(1851)] = 113565,
  [SMALL_STATE(1852)] = 113605,
  [SMALL_STATE(1853)] = 113645,
  [SMALL_STATE(1854)] = 113685,
  [SMALL_STATE(1855)] = 113725,
  [SMALL_STATE(1856)] = 113765,
  [SMALL_STATE(1857)] = 113805,
  [SMALL_STATE(1858)] = 113845,
  [SMALL_STATE(1859)] = 113885,
  [SMALL_STATE(1860)] = 113925,
  [SMALL_STATE(1861)] = 113965,
  [SMALL_STATE(1862)] = 114005,
  [SMALL_STATE(1863)] = 114045,
  [SMALL_STATE(1864)] = 114085,
  [SMALL_STATE(1865)] = 114125,
  [SMALL_STATE(1866)] = 114165,
  [SMALL_STATE(1867)] = 114205,
  [SMALL_STATE(1868)] = 114245,
  [SMALL_STATE(1869)] = 114285,
  [SMALL_STATE(1870)] = 114327,
  [SMALL_STATE(1871)] = 114367,
  [SMALL_STATE(1872)] = 114407,
  [SMALL_STATE(1873)] = 114447,
  [SMALL_STATE(1874)] = 114493,
  [SMALL_STATE(1875)] = 114535,
  [SMALL_STATE(1876)] = 114575,
  [SMALL_STATE(1877)] = 114615,
  [SMALL_STATE(1878)] = 114661,
  [SMALL_STATE(1879)] = 114705,
  [SMALL_STATE(1880)] = 114745,
  [SMALL_STATE(1881)] = 114791,
  [SMALL_STATE(1882)] = 114831,
  [SMALL_STATE(1883)] = 114871,
  [SMALL_STATE(1884)] = 114911,
  [SMALL_STATE(1885)] = 114951,
  [SMALL_STATE(1886)] = 114991,
  [SMALL_STATE(1887)] = 115031,
  [SMALL_STATE(1888)] = 115071,
  [SMALL_STATE(1889)] = 115111,
  [SMALL_STATE(1890)] = 115151,
  [SMALL_STATE(1891)] = 115191,
  [SMALL_STATE(1892)] = 115233,
  [SMALL_STATE(1893)] = 115273,
  [SMALL_STATE(1894)] = 115313,
  [SMALL_STATE(1895)] = 115353,
  [SMALL_STATE(1896)] = 115393,
  [SMALL_STATE(1897)] = 115433,
  [SMALL_STATE(1898)] = 115473,
  [SMALL_STATE(1899)] = 115513,
  [SMALL_STATE(1900)] = 115553,
  [SMALL_STATE(1901)] = 115593,
  [SMALL_STATE(1902)] = 115633,
  [SMALL_STATE(1903)] = 115673,
  [SMALL_STATE(1904)] = 115713,
  [SMALL_STATE(1905)] = 115753,
  [SMALL_STATE(1906)] = 115797,
  [SMALL_STATE(1907)] = 115837,
  [SMALL_STATE(1908)] = 115877,
  [SMALL_STATE(1909)] = 115921,
  [SMALL_STATE(1910)] = 115961,
  [SMALL_STATE(1911)] = 116001,
  [SMALL_STATE(1912)] = 116041,
  [SMALL_STATE(1913)] = 116081,
  [SMALL_STATE(1914)] = 116121,
  [SMALL_STATE(1915)] = 116161,
  [SMALL_STATE(1916)] = 116201,
  [SMALL_STATE(1917)] = 116241,
  [SMALL_STATE(1918)] = 116281,
  [SMALL_STATE(1919)] = 116321,
  [SMALL_STATE(1920)] = 116361,
  [SMALL_STATE(1921)] = 116401,
  [SMALL_STATE(1922)] = 116441,
  [SMALL_STATE(1923)] = 116481,
  [SMALL_STATE(1924)] = 116521,
  [SMALL_STATE(1925)] = 116561,
  [SMALL_STATE(1926)] = 116601,
  [SMALL_STATE(1927)] = 116641,
  [SMALL_STATE(1928)] = 116681,
  [SMALL_STATE(1929)] = 116721,
  [SMALL_STATE(1930)] = 116763,
  [SMALL_STATE(1931)] = 116803,
  [SMALL_STATE(1932)] = 116843,
  [SMALL_STATE(1933)] = 116887,
  [SMALL_STATE(1934)] = 116929,
  [SMALL_STATE(1935)] = 116969,
  [SMALL_STATE(1936)] = 117009,
  [SMALL_STATE(1937)] = 117051,
  [SMALL_STATE(1938)] = 117091,
  [SMALL_STATE(1939)] = 117131,
  [SMALL_STATE(1940)] = 117171,
  [SMALL_STATE(1941)] = 117213,
  [SMALL_STATE(1942)] = 117253,
  [SMALL_STATE(1943)] = 117293,
  [SMALL_STATE(1944)] = 117333,
  [SMALL_STATE(1945)] = 117373,
  [SMALL_STATE(1946)] = 117415,
  [SMALL_STATE(1947)] = 117455,
  [SMALL_STATE(1948)] = 117495,
  [SMALL_STATE(1949)] = 117537,
  [SMALL_STATE(1950)] = 117579,
  [SMALL_STATE(1951)] = 117618,
  [SMALL_STATE(1952)] = 117657,
  [SMALL_STATE(1953)] = 117696,
  [SMALL_STATE(1954)] = 117735,
  [SMALL_STATE(1955)] = 117774,
  [SMALL_STATE(1956)] = 117845,
  [SMALL_STATE(1957)] = 117884,
  [SMALL_STATE(1958)] = 117923,
  [SMALL_STATE(1959)] = 117964,
  [SMALL_STATE(1960)] = 118003,
  [SMALL_STATE(1961)] = 118074,
  [SMALL_STATE(1962)] = 118115,
  [SMALL_STATE(1963)] = 118154,
  [SMALL_STATE(1964)] = 118193,
  [SMALL_STATE(1965)] = 118232,
  [SMALL_STATE(1966)] = 118273,
  [SMALL_STATE(1967)] = 118314,
  [SMALL_STATE(1968)] = 118359,
  [SMALL_STATE(1969)] = 118404,
  [SMALL_STATE(1970)] = 118443,
  [SMALL_STATE(1971)] = 118484,
  [SMALL_STATE(1972)] = 118525,
  [SMALL_STATE(1973)] = 118564,
  [SMALL_STATE(1974)] = 118603,
  [SMALL_STATE(1975)] = 118642,
  [SMALL_STATE(1976)] = 118681,
  [SMALL_STATE(1977)] = 118720,
  [SMALL_STATE(1978)] = 118759,
  [SMALL_STATE(1979)] = 118798,
  [SMALL_STATE(1980)] = 118837,
  [SMALL_STATE(1981)] = 118880,
  [SMALL_STATE(1982)] = 118923,
  [SMALL_STATE(1983)] = 118966,
  [SMALL_STATE(1984)] = 119005,
  [SMALL_STATE(1985)] = 119044,
  [SMALL_STATE(1986)] = 119083,
  [SMALL_STATE(1987)] = 119122,
  [SMALL_STATE(1988)] = 119161,
  [SMALL_STATE(1989)] = 119200,
  [SMALL_STATE(1990)] = 119239,
  [SMALL_STATE(1991)] = 119278,
  [SMALL_STATE(1992)] = 119317,
  [SMALL_STATE(1993)] = 119356,
  [SMALL_STATE(1994)] = 119395,
  [SMALL_STATE(1995)] = 119466,
  [SMALL_STATE(1996)] = 119509,
  [SMALL_STATE(1997)] = 119548,
  [SMALL_STATE(1998)] = 119587,
  [SMALL_STATE(1999)] = 119626,
  [SMALL_STATE(2000)] = 119665,
  [SMALL_STATE(2001)] = 119706,
  [SMALL_STATE(2002)] = 119745,
  [SMALL_STATE(2003)] = 119784,
  [SMALL_STATE(2004)] = 119823,
  [SMALL_STATE(2005)] = 119862,
  [SMALL_STATE(2006)] = 119901,
  [SMALL_STATE(2007)] = 119940,
  [SMALL_STATE(2008)] = 119979,
  [SMALL_STATE(2009)] = 120018,
  [SMALL_STATE(2010)] = 120057,
  [SMALL_STATE(2011)] = 120096,
  [SMALL_STATE(2012)] = 120167,
  [SMALL_STATE(2013)] = 120206,
  [SMALL_STATE(2014)] = 120277,
  [SMALL_STATE(2015)] = 120316,
  [SMALL_STATE(2016)] = 120355,
  [SMALL_STATE(2017)] = 120394,
  [SMALL_STATE(2018)] = 120433,
  [SMALL_STATE(2019)] = 120472,
  [SMALL_STATE(2020)] = 120511,
  [SMALL_STATE(2021)] = 120582,
  [SMALL_STATE(2022)] = 120621,
  [SMALL_STATE(2023)] = 120660,
  [SMALL_STATE(2024)] = 120699,
  [SMALL_STATE(2025)] = 120738,
  [SMALL_STATE(2026)] = 120779,
  [SMALL_STATE(2027)] = 120818,
  [SMALL_STATE(2028)] = 120889,
  [SMALL_STATE(2029)] = 120930,
  [SMALL_STATE(2030)] = 121001,
  [SMALL_STATE(2031)] = 121040,
  [SMALL_STATE(2032)] = 121079,
  [SMALL_STATE(2033)] = 121120,
  [SMALL_STATE(2034)] = 121159,
  [SMALL_STATE(2035)] = 121198,
  [SMALL_STATE(2036)] = 121237,
  [SMALL_STATE(2037)] = 121276,
  [SMALL_STATE(2038)] = 121315,
  [SMALL_STATE(2039)] = 121354,
  [SMALL_STATE(2040)] = 121393,
  [SMALL_STATE(2041)] = 121464,
  [SMALL_STATE(2042)] = 121535,
  [SMALL_STATE(2043)] = 121574,
  [SMALL_STATE(2044)] = 121613,
  [SMALL_STATE(2045)] = 121652,
  [SMALL_STATE(2046)] = 121693,
  [SMALL_STATE(2047)] = 121732,
  [SMALL_STATE(2048)] = 121771,
  [SMALL_STATE(2049)] = 121810,
  [SMALL_STATE(2050)] = 121881,
  [SMALL_STATE(2051)] = 121920,
  [SMALL_STATE(2052)] = 121959,
  [SMALL_STATE(2053)] = 121998,
  [SMALL_STATE(2054)] = 122037,
  [SMALL_STATE(2055)] = 122076,
  [SMALL_STATE(2056)] = 122115,
  [SMALL_STATE(2057)] = 122154,
  [SMALL_STATE(2058)] = 122193,
  [SMALL_STATE(2059)] = 122232,
  [SMALL_STATE(2060)] = 122271,
  [SMALL_STATE(2061)] = 122310,
  [SMALL_STATE(2062)] = 122349,
  [SMALL_STATE(2063)] = 122390,
  [SMALL_STATE(2064)] = 122429,
  [SMALL_STATE(2065)] = 122468,
  [SMALL_STATE(2066)] = 122509,
  [SMALL_STATE(2067)] = 122548,
  [SMALL_STATE(2068)] = 122589,
  [SMALL_STATE(2069)] = 122628,
  [SMALL_STATE(2070)] = 122667,
  [SMALL_STATE(2071)] = 122738,
  [SMALL_STATE(2072)] = 122779,
  [SMALL_STATE(2073)] = 122820,
  [SMALL_STATE(2074)] = 122859,
  [SMALL_STATE(2075)] = 122898,
  [SMALL_STATE(2076)] = 122939,
  [SMALL_STATE(2077)] = 122978,
  [SMALL_STATE(2078)] = 123049,
  [SMALL_STATE(2079)] = 123088,
  [SMALL_STATE(2080)] = 123133,
  [SMALL_STATE(2081)] = 123172,
  [SMALL_STATE(2082)] = 123211,
  [SMALL_STATE(2083)] = 123250,
  [SMALL_STATE(2084)] = 123289,
  [SMALL_STATE(2085)] = 123330,
  [SMALL_STATE(2086)] = 123369,
  [SMALL_STATE(2087)] = 123408,
  [SMALL_STATE(2088)] = 123447,
  [SMALL_STATE(2089)] = 123486,
  [SMALL_STATE(2090)] = 123525,
  [SMALL_STATE(2091)] = 123564,
  [SMALL_STATE(2092)] = 123603,
  [SMALL_STATE(2093)] = 123642,
  [SMALL_STATE(2094)] = 123681,
  [SMALL_STATE(2095)] = 123720,
  [SMALL_STATE(2096)] = 123759,
  [SMALL_STATE(2097)] = 123800,
  [SMALL_STATE(2098)] = 123839,
  [SMALL_STATE(2099)] = 123878,
  [SMALL_STATE(2100)] = 123921,
  [SMALL_STATE(2101)] = 123966,
  [SMALL_STATE(2102)] = 124007,
  [SMALL_STATE(2103)] = 124046,
  [SMALL_STATE(2104)] = 124117,
  [SMALL_STATE(2105)] = 124158,
  [SMALL_STATE(2106)] = 124201,
  [SMALL_STATE(2107)] = 124240,
  [SMALL_STATE(2108)] = 124281,
  [SMALL_STATE(2109)] = 124352,
  [SMALL_STATE(2110)] = 124391,
  [SMALL_STATE(2111)] = 124430,
  [SMALL_STATE(2112)] = 124469,
  [SMALL_STATE(2113)] = 124508,
  [SMALL_STATE(2114)] = 124549,
  [SMALL_STATE(2115)] = 124620,
  [SMALL_STATE(2116)] = 124659,
  [SMALL_STATE(2117)] = 124698,
  [SMALL_STATE(2118)] = 124737,
  [SMALL_STATE(2119)] = 124778,
  [SMALL_STATE(2120)] = 124819,
  [SMALL_STATE(2121)] = 124860,
  [SMALL_STATE(2122)] = 124899,
  [SMALL_STATE(2123)] = 124970,
  [SMALL_STATE(2124)] = 125011,
  [SMALL_STATE(2125)] = 125050,
  [SMALL_STATE(2126)] = 125121,
  [SMALL_STATE(2127)] = 125160,
  [SMALL_STATE(2128)] = 125201,
  [SMALL_STATE(2129)] = 125272,
  [SMALL_STATE(2130)] = 125311,
  [SMALL_STATE(2131)] = 125382,
  [SMALL_STATE(2132)] = 125453,
  [SMALL_STATE(2133)] = 125492,
  [SMALL_STATE(2134)] = 125533,
  [SMALL_STATE(2135)] = 125574,
  [SMALL_STATE(2136)] = 125615,
  [SMALL_STATE(2137)] = 125654,
  [SMALL_STATE(2138)] = 125693,
  [SMALL_STATE(2139)] = 125732,
  [SMALL_STATE(2140)] = 125775,
  [SMALL_STATE(2141)] = 125846,
  [SMALL_STATE(2142)] = 125885,
  [SMALL_STATE(2143)] = 125924,
  [SMALL_STATE(2144)] = 125963,
  [SMALL_STATE(2145)] = 126034,
  [SMALL_STATE(2146)] = 126073,
  [SMALL_STATE(2147)] = 126144,
  [SMALL_STATE(2148)] = 126215,
  [SMALL_STATE(2149)] = 126286,
  [SMALL_STATE(2150)] = 126357,
  [SMALL_STATE(2151)] = 126396,
  [SMALL_STATE(2152)] = 126437,
  [SMALL_STATE(2153)] = 126480,
  [SMALL_STATE(2154)] = 126519,
  [SMALL_STATE(2155)] = 126590,
  [SMALL_STATE(2156)] = 126629,
  [SMALL_STATE(2157)] = 126668,
  [SMALL_STATE(2158)] = 126707,
  [SMALL_STATE(2159)] = 126748,
  [SMALL_STATE(2160)] = 126787,
  [SMALL_STATE(2161)] = 126858,
  [SMALL_STATE(2162)] = 126897,
  [SMALL_STATE(2163)] = 126968,
  [SMALL_STATE(2164)] = 127009,
  [SMALL_STATE(2165)] = 127080,
  [SMALL_STATE(2166)] = 127121,
  [SMALL_STATE(2167)] = 127192,
  [SMALL_STATE(2168)] = 127263,
  [SMALL_STATE(2169)] = 127334,
  [SMALL_STATE(2170)] = 127405,
  [SMALL_STATE(2171)] = 127446,
  [SMALL_STATE(2172)] = 127517,
  [SMALL_STATE(2173)] = 127556,
  [SMALL_STATE(2174)] = 127595,
  [SMALL_STATE(2175)] = 127634,
  [SMALL_STATE(2176)] = 127705,
  [SMALL_STATE(2177)] = 127776,
  [SMALL_STATE(2178)] = 127815,
  [SMALL_STATE(2179)] = 127886,
  [SMALL_STATE(2180)] = 127927,
  [SMALL_STATE(2181)] = 127966,
  [SMALL_STATE(2182)] = 128037,
  [SMALL_STATE(2183)] = 128076,
  [SMALL_STATE(2184)] = 128115,
  [SMALL_STATE(2185)] = 128186,
  [SMALL_STATE(2186)] = 128227,
  [SMALL_STATE(2187)] = 128266,
  [SMALL_STATE(2188)] = 128337,
  [SMALL_STATE(2189)] = 128376,
  [SMALL_STATE(2190)] = 128427,
  [SMALL_STATE(2191)] = 128468,
  [SMALL_STATE(2192)] = 128507,
  [SMALL_STATE(2193)] = 128546,
  [SMALL_STATE(2194)] = 128585,
  [SMALL_STATE(2195)] = 128624,
  [SMALL_STATE(2196)] = 128663,
  [SMALL_STATE(2197)] = 128702,
  [SMALL_STATE(2198)] = 128743,
  [SMALL_STATE(2199)] = 128814,
  [SMALL_STATE(2200)] = 128855,
  [SMALL_STATE(2201)] = 128926,
  [SMALL_STATE(2202)] = 128965,
  [SMALL_STATE(2203)] = 129004,
  [SMALL_STATE(2204)] = 129043,
  [SMALL_STATE(2205)] = 129084,
  [SMALL_STATE(2206)] = 129123,
  [SMALL_STATE(2207)] = 129162,
  [SMALL_STATE(2208)] = 129233,
  [SMALL_STATE(2209)] = 129304,
  [SMALL_STATE(2210)] = 129343,
  [SMALL_STATE(2211)] = 129382,
  [SMALL_STATE(2212)] = 129421,
  [SMALL_STATE(2213)] = 129460,
  [SMALL_STATE(2214)] = 129531,
  [SMALL_STATE(2215)] = 129570,
  [SMALL_STATE(2216)] = 129609,
  [SMALL_STATE(2217)] = 129648,
  [SMALL_STATE(2218)] = 129687,
  [SMALL_STATE(2219)] = 129726,
  [SMALL_STATE(2220)] = 129797,
  [SMALL_STATE(2221)] = 129836,
  [SMALL_STATE(2222)] = 129875,
  [SMALL_STATE(2223)] = 129914,
  [SMALL_STATE(2224)] = 129982,
  [SMALL_STATE(2225)] = 130020,
  [SMALL_STATE(2226)] = 130088,
  [SMALL_STATE(2227)] = 130126,
  [SMALL_STATE(2228)] = 130164,
  [SMALL_STATE(2229)] = 130202,
  [SMALL_STATE(2230)] = 130270,
  [SMALL_STATE(2231)] = 130310,
  [SMALL_STATE(2232)] = 130352,
  [SMALL_STATE(2233)] = 130420,
  [SMALL_STATE(2234)] = 130458,
  [SMALL_STATE(2235)] = 130496,
  [SMALL_STATE(2236)] = 130536,
  [SMALL_STATE(2237)] = 130576,
  [SMALL_STATE(2238)] = 130614,
  [SMALL_STATE(2239)] = 130682,
  [SMALL_STATE(2240)] = 130720,
  [SMALL_STATE(2241)] = 130758,
  [SMALL_STATE(2242)] = 130800,
  [SMALL_STATE(2243)] = 130838,
  [SMALL_STATE(2244)] = 130876,
  [SMALL_STATE(2245)] = 130918,
  [SMALL_STATE(2246)] = 130956,
  [SMALL_STATE(2247)] = 131024,
  [SMALL_STATE(2248)] = 131066,
  [SMALL_STATE(2249)] = 131104,
  [SMALL_STATE(2250)] = 131144,
  [SMALL_STATE(2251)] = 131188,
  [SMALL_STATE(2252)] = 131232,
  [SMALL_STATE(2253)] = 131270,
  [SMALL_STATE(2254)] = 131308,
  [SMALL_STATE(2255)] = 131376,
  [SMALL_STATE(2256)] = 131414,
  [SMALL_STATE(2257)] = 131458,
  [SMALL_STATE(2258)] = 131502,
  [SMALL_STATE(2259)] = 131542,
  [SMALL_STATE(2260)] = 131582,
  [SMALL_STATE(2261)] = 131650,
  [SMALL_STATE(2262)] = 131688,
  [SMALL_STATE(2263)] = 131726,
  [SMALL_STATE(2264)] = 131768,
  [SMALL_STATE(2265)] = 131810,
  [SMALL_STATE(2266)] = 131854,
  [SMALL_STATE(2267)] = 131896,
  [SMALL_STATE(2268)] = 131938,
  [SMALL_STATE(2269)] = 131976,
  [SMALL_STATE(2270)] = 132014,
  [SMALL_STATE(2271)] = 132052,
  [SMALL_STATE(2272)] = 132090,
  [SMALL_STATE(2273)] = 132128,
  [SMALL_STATE(2274)] = 132166,
  [SMALL_STATE(2275)] = 132234,
  [SMALL_STATE(2276)] = 132272,
  [SMALL_STATE(2277)] = 132310,
  [SMALL_STATE(2278)] = 132348,
  [SMALL_STATE(2279)] = 132386,
  [SMALL_STATE(2280)] = 132424,
  [SMALL_STATE(2281)] = 132462,
  [SMALL_STATE(2282)] = 132500,
  [SMALL_STATE(2283)] = 132538,
  [SMALL_STATE(2284)] = 132576,
  [SMALL_STATE(2285)] = 132614,
  [SMALL_STATE(2286)] = 132652,
  [SMALL_STATE(2287)] = 132690,
  [SMALL_STATE(2288)] = 132728,
  [SMALL_STATE(2289)] = 132766,
  [SMALL_STATE(2290)] = 132804,
  [SMALL_STATE(2291)] = 132842,
  [SMALL_STATE(2292)] = 132880,
  [SMALL_STATE(2293)] = 132922,
  [SMALL_STATE(2294)] = 132960,
  [SMALL_STATE(2295)] = 132998,
  [SMALL_STATE(2296)] = 133040,
  [SMALL_STATE(2297)] = 133108,
  [SMALL_STATE(2298)] = 133150,
  [SMALL_STATE(2299)] = 133188,
  [SMALL_STATE(2300)] = 133226,
  [SMALL_STATE(2301)] = 133264,
  [SMALL_STATE(2302)] = 133332,
  [SMALL_STATE(2303)] = 133370,
  [SMALL_STATE(2304)] = 133408,
  [SMALL_STATE(2305)] = 133446,
  [SMALL_STATE(2306)] = 133486,
  [SMALL_STATE(2307)] = 133524,
  [SMALL_STATE(2308)] = 133592,
  [SMALL_STATE(2309)] = 133630,
  [SMALL_STATE(2310)] = 133668,
  [SMALL_STATE(2311)] = 133736,
  [SMALL_STATE(2312)] = 133774,
  [SMALL_STATE(2313)] = 133842,
  [SMALL_STATE(2314)] = 133880,
  [SMALL_STATE(2315)] = 133918,
  [SMALL_STATE(2316)] = 133956,
  [SMALL_STATE(2317)] = 133994,
  [SMALL_STATE(2318)] = 134032,
  [SMALL_STATE(2319)] = 134100,
  [SMALL_STATE(2320)] = 134138,
  [SMALL_STATE(2321)] = 134176,
  [SMALL_STATE(2322)] = 134214,
  [SMALL_STATE(2323)] = 134252,
  [SMALL_STATE(2324)] = 134290,
  [SMALL_STATE(2325)] = 134328,
  [SMALL_STATE(2326)] = 134366,
  [SMALL_STATE(2327)] = 134434,
  [SMALL_STATE(2328)] = 134472,
  [SMALL_STATE(2329)] = 134510,
  [SMALL_STATE(2330)] = 134548,
  [SMALL_STATE(2331)] = 134586,
  [SMALL_STATE(2332)] = 134624,
  [SMALL_STATE(2333)] = 134662,
  [SMALL_STATE(2334)] = 134700,
  [SMALL_STATE(2335)] = 134738,
  [SMALL_STATE(2336)] = 134776,
  [SMALL_STATE(2337)] = 134814,
  [SMALL_STATE(2338)] = 134852,
  [SMALL_STATE(2339)] = 134890,
  [SMALL_STATE(2340)] = 134928,
  [SMALL_STATE(2341)] = 134966,
  [SMALL_STATE(2342)] = 135004,
  [SMALL_STATE(2343)] = 135042,
  [SMALL_STATE(2344)] = 135082,
  [SMALL_STATE(2345)] = 135120,
  [SMALL_STATE(2346)] = 135158,
  [SMALL_STATE(2347)] = 135196,
  [SMALL_STATE(2348)] = 135234,
  [SMALL_STATE(2349)] = 135272,
  [SMALL_STATE(2350)] = 135310,
  [SMALL_STATE(2351)] = 135350,
  [SMALL_STATE(2352)] = 135388,
  [SMALL_STATE(2353)] = 135426,
  [SMALL_STATE(2354)] = 135464,
  [SMALL_STATE(2355)] = 135506,
  [SMALL_STATE(2356)] = 135544,
  [SMALL_STATE(2357)] = 135582,
  [SMALL_STATE(2358)] = 135620,
  [SMALL_STATE(2359)] = 135660,
  [SMALL_STATE(2360)] = 135698,
  [SMALL_STATE(2361)] = 135740,
  [SMALL_STATE(2362)] = 135778,
  [SMALL_STATE(2363)] = 135816,
  [SMALL_STATE(2364)] = 135856,
  [SMALL_STATE(2365)] = 135894,
  [SMALL_STATE(2366)] = 135932,
  [SMALL_STATE(2367)] = 135970,
  [SMALL_STATE(2368)] = 136010,
  [SMALL_STATE(2369)] = 136048,
  [SMALL_STATE(2370)] = 136086,
  [SMALL_STATE(2371)] = 136124,
  [SMALL_STATE(2372)] = 136192,
  [SMALL_STATE(2373)] = 136230,
  [SMALL_STATE(2374)] = 136270,
  [SMALL_STATE(2375)] = 136308,
  [SMALL_STATE(2376)] = 136346,
  [SMALL_STATE(2377)] = 136386,
  [SMALL_STATE(2378)] = 136424,
  [SMALL_STATE(2379)] = 136464,
  [SMALL_STATE(2380)] = 136502,
  [SMALL_STATE(2381)] = 136570,
  [SMALL_STATE(2382)] = 136608,
  [SMALL_STATE(2383)] = 136646,
  [SMALL_STATE(2384)] = 136714,
  [SMALL_STATE(2385)] = 136756,
  [SMALL_STATE(2386)] = 136794,
  [SMALL_STATE(2387)] = 136834,
  [SMALL_STATE(2388)] = 136872,
  [SMALL_STATE(2389)] = 136940,
  [SMALL_STATE(2390)] = 136980,
  [SMALL_STATE(2391)] = 137048,
  [SMALL_STATE(2392)] = 137090,
  [SMALL_STATE(2393)] = 137128,
  [SMALL_STATE(2394)] = 137196,
  [SMALL_STATE(2395)] = 137234,
  [SMALL_STATE(2396)] = 137274,
  [SMALL_STATE(2397)] = 137316,
  [SMALL_STATE(2398)] = 137358,
  [SMALL_STATE(2399)] = 137396,
  [SMALL_STATE(2400)] = 137434,
  [SMALL_STATE(2401)] = 137472,
  [SMALL_STATE(2402)] = 137510,
  [SMALL_STATE(2403)] = 137548,
  [SMALL_STATE(2404)] = 137588,
  [SMALL_STATE(2405)] = 137626,
  [SMALL_STATE(2406)] = 137664,
  [SMALL_STATE(2407)] = 137702,
  [SMALL_STATE(2408)] = 137740,
  [SMALL_STATE(2409)] = 137778,
  [SMALL_STATE(2410)] = 137816,
  [SMALL_STATE(2411)] = 137854,
  [SMALL_STATE(2412)] = 137922,
  [SMALL_STATE(2413)] = 137960,
  [SMALL_STATE(2414)] = 138028,
  [SMALL_STATE(2415)] = 138066,
  [SMALL_STATE(2416)] = 138134,
  [SMALL_STATE(2417)] = 138176,
  [SMALL_STATE(2418)] = 138218,
  [SMALL_STATE(2419)] = 138256,
  [SMALL_STATE(2420)] = 138294,
  [SMALL_STATE(2421)] = 138332,
  [SMALL_STATE(2422)] = 138400,
  [SMALL_STATE(2423)] = 138438,
  [SMALL_STATE(2424)] = 138478,
  [SMALL_STATE(2425)] = 138516,
  [SMALL_STATE(2426)] = 138554,
  [SMALL_STATE(2427)] = 138622,
  [SMALL_STATE(2428)] = 138664,
  [SMALL_STATE(2429)] = 138702,
  [SMALL_STATE(2430)] = 138740,
  [SMALL_STATE(2431)] = 138808,
  [SMALL_STATE(2432)] = 138846,
  [SMALL_STATE(2433)] = 138888,
  [SMALL_STATE(2434)] = 138956,
  [SMALL_STATE(2435)] = 138998,
  [SMALL_STATE(2436)] = 139036,
  [SMALL_STATE(2437)] = 139074,
  [SMALL_STATE(2438)] = 139142,
  [SMALL_STATE(2439)] = 139180,
  [SMALL_STATE(2440)] = 139218,
  [SMALL_STATE(2441)] = 139286,
  [SMALL_STATE(2442)] = 139324,
  [SMALL_STATE(2443)] = 139362,
  [SMALL_STATE(2444)] = 139400,
  [SMALL_STATE(2445)] = 139438,
  [SMALL_STATE(2446)] = 139478,
  [SMALL_STATE(2447)] = 139516,
  [SMALL_STATE(2448)] = 139560,
  [SMALL_STATE(2449)] = 139598,
  [SMALL_STATE(2450)] = 139640,
  [SMALL_STATE(2451)] = 139678,
  [SMALL_STATE(2452)] = 139716,
  [SMALL_STATE(2453)] = 139754,
  [SMALL_STATE(2454)] = 139798,
  [SMALL_STATE(2455)] = 139836,
  [SMALL_STATE(2456)] = 139880,
  [SMALL_STATE(2457)] = 139918,
  [SMALL_STATE(2458)] = 139956,
  [SMALL_STATE(2459)] = 139996,
  [SMALL_STATE(2460)] = 140034,
  [SMALL_STATE(2461)] = 140072,
  [SMALL_STATE(2462)] = 140116,
  [SMALL_STATE(2463)] = 140154,
  [SMALL_STATE(2464)] = 140192,
  [SMALL_STATE(2465)] = 140260,
  [SMALL_STATE(2466)] = 140298,
  [SMALL_STATE(2467)] = 140336,
  [SMALL_STATE(2468)] = 140374,
  [SMALL_STATE(2469)] = 140414,
  [SMALL_STATE(2470)] = 140452,
  [SMALL_STATE(2471)] = 140492,
  [SMALL_STATE(2472)] = 140530,
  [SMALL_STATE(2473)] = 140568,
  [SMALL_STATE(2474)] = 140606,
  [SMALL_STATE(2475)] = 140644,
  [SMALL_STATE(2476)] = 140682,
  [SMALL_STATE(2477)] = 140720,
  [SMALL_STATE(2478)] = 140760,
  [SMALL_STATE(2479)] = 140798,
  [SMALL_STATE(2480)] = 140866,
  [SMALL_STATE(2481)] = 140904,
  [SMALL_STATE(2482)] = 140942,
  [SMALL_STATE(2483)] = 140980,
  [SMALL_STATE(2484)] = 141018,
  [SMALL_STATE(2485)] = 141056,
  [SMALL_STATE(2486)] = 141094,
  [SMALL_STATE(2487)] = 141132,
  [SMALL_STATE(2488)] = 141170,
  [SMALL_STATE(2489)] = 141208,
  [SMALL_STATE(2490)] = 141246,
  [SMALL_STATE(2491)] = 141284,
  [SMALL_STATE(2492)] = 141324,
  [SMALL_STATE(2493)] = 141362,
  [SMALL_STATE(2494)] = 141402,
  [SMALL_STATE(2495)] = 141440,
  [SMALL_STATE(2496)] = 141478,
  [SMALL_STATE(2497)] = 141546,
  [SMALL_STATE(2498)] = 141584,
  [SMALL_STATE(2499)] = 141622,
  [SMALL_STATE(2500)] = 141660,
  [SMALL_STATE(2501)] = 141698,
  [SMALL_STATE(2502)] = 141736,
  [SMALL_STATE(2503)] = 141776,
  [SMALL_STATE(2504)] = 141814,
  [SMALL_STATE(2505)] = 141852,
  [SMALL_STATE(2506)] = 141892,
  [SMALL_STATE(2507)] = 141930,
  [SMALL_STATE(2508)] = 141998,
  [SMALL_STATE(2509)] = 142036,
  [SMALL_STATE(2510)] = 142074,
  [SMALL_STATE(2511)] = 142112,
  [SMALL_STATE(2512)] = 142150,
  [SMALL_STATE(2513)] = 142188,
  [SMALL_STATE(2514)] = 142226,
  [SMALL_STATE(2515)] = 142264,
  [SMALL_STATE(2516)] = 142302,
  [SMALL_STATE(2517)] = 142342,
  [SMALL_STATE(2518)] = 142380,
  [SMALL_STATE(2519)] = 142418,
  [SMALL_STATE(2520)] = 142455,
  [SMALL_STATE(2521)] = 142492,
  [SMALL_STATE(2522)] = 142529,
  [SMALL_STATE(2523)] = 142566,
  [SMALL_STATE(2524)] = 142603,
  [SMALL_STATE(2525)] = 142642,
  [SMALL_STATE(2526)] = 142679,
  [SMALL_STATE(2527)] = 142716,
  [SMALL_STATE(2528)] = 142753,
  [SMALL_STATE(2529)] = 142790,
  [SMALL_STATE(2530)] = 142829,
  [SMALL_STATE(2531)] = 142866,
  [SMALL_STATE(2532)] = 142903,
  [SMALL_STATE(2533)] = 142940,
  [SMALL_STATE(2534)] = 142977,
  [SMALL_STATE(2535)] = 143016,
  [SMALL_STATE(2536)] = 143053,
  [SMALL_STATE(2537)] = 143090,
  [SMALL_STATE(2538)] = 143127,
  [SMALL_STATE(2539)] = 143168,
  [SMALL_STATE(2540)] = 143205,
  [SMALL_STATE(2541)] = 143242,
  [SMALL_STATE(2542)] = 143279,
  [SMALL_STATE(2543)] = 143316,
  [SMALL_STATE(2544)] = 143353,
  [SMALL_STATE(2545)] = 143392,
  [SMALL_STATE(2546)] = 143429,
  [SMALL_STATE(2547)] = 143468,
  [SMALL_STATE(2548)] = 143507,
  [SMALL_STATE(2549)] = 143548,
  [SMALL_STATE(2550)] = 143587,
  [SMALL_STATE(2551)] = 143624,
  [SMALL_STATE(2552)] = 143665,
  [SMALL_STATE(2553)] = 143706,
  [SMALL_STATE(2554)] = 143743,
  [SMALL_STATE(2555)] = 143782,
  [SMALL_STATE(2556)] = 143819,
  [SMALL_STATE(2557)] = 143856,
  [SMALL_STATE(2558)] = 143893,
  [SMALL_STATE(2559)] = 143930,
  [SMALL_STATE(2560)] = 143971,
  [SMALL_STATE(2561)] = 144008,
  [SMALL_STATE(2562)] = 144045,
  [SMALL_STATE(2563)] = 144082,
  [SMALL_STATE(2564)] = 144121,
  [SMALL_STATE(2565)] = 144158,
  [SMALL_STATE(2566)] = 144195,
  [SMALL_STATE(2567)] = 144232,
  [SMALL_STATE(2568)] = 144269,
  [SMALL_STATE(2569)] = 144306,
  [SMALL_STATE(2570)] = 144345,
  [SMALL_STATE(2571)] = 144382,
  [SMALL_STATE(2572)] = 144421,
  [SMALL_STATE(2573)] = 144458,
  [SMALL_STATE(2574)] = 144495,
  [SMALL_STATE(2575)] = 144532,
  [SMALL_STATE(2576)] = 144569,
  [SMALL_STATE(2577)] = 144610,
  [SMALL_STATE(2578)] = 144647,
  [SMALL_STATE(2579)] = 144684,
  [SMALL_STATE(2580)] = 144723,
  [SMALL_STATE(2581)] = 144762,
  [SMALL_STATE(2582)] = 144799,
  [SMALL_STATE(2583)] = 144836,
  [SMALL_STATE(2584)] = 144873,
  [SMALL_STATE(2585)] = 144912,
  [SMALL_STATE(2586)] = 144949,
  [SMALL_STATE(2587)] = 144988,
  [SMALL_STATE(2588)] = 145025,
  [SMALL_STATE(2589)] = 145062,
  [SMALL_STATE(2590)] = 145099,
  [SMALL_STATE(2591)] = 145136,
  [SMALL_STATE(2592)] = 145175,
  [SMALL_STATE(2593)] = 145212,
  [SMALL_STATE(2594)] = 145251,
  [SMALL_STATE(2595)] = 145288,
  [SMALL_STATE(2596)] = 145325,
  [SMALL_STATE(2597)] = 145362,
  [SMALL_STATE(2598)] = 145399,
  [SMALL_STATE(2599)] = 145436,
  [SMALL_STATE(2600)] = 145473,
  [SMALL_STATE(2601)] = 145512,
  [SMALL_STATE(2602)] = 145551,
  [SMALL_STATE(2603)] = 145590,
  [SMALL_STATE(2604)] = 145627,
  [SMALL_STATE(2605)] = 145666,
  [SMALL_STATE(2606)] = 145703,
  [SMALL_STATE(2607)] = 145740,
  [SMALL_STATE(2608)] = 145779,
  [SMALL_STATE(2609)] = 145816,
  [SMALL_STATE(2610)] = 145853,
  [SMALL_STATE(2611)] = 145890,
  [SMALL_STATE(2612)] = 145927,
  [SMALL_STATE(2613)] = 145964,
  [SMALL_STATE(2614)] = 146001,
  [SMALL_STATE(2615)] = 146038,
  [SMALL_STATE(2616)] = 146077,
  [SMALL_STATE(2617)] = 146114,
  [SMALL_STATE(2618)] = 146151,
  [SMALL_STATE(2619)] = 146188,
  [SMALL_STATE(2620)] = 146225,
  [SMALL_STATE(2621)] = 146262,
  [SMALL_STATE(2622)] = 146299,
  [SMALL_STATE(2623)] = 146338,
  [SMALL_STATE(2624)] = 146377,
  [SMALL_STATE(2625)] = 146416,
  [SMALL_STATE(2626)] = 146453,
  [SMALL_STATE(2627)] = 146490,
  [SMALL_STATE(2628)] = 146527,
  [SMALL_STATE(2629)] = 146564,
  [SMALL_STATE(2630)] = 146601,
  [SMALL_STATE(2631)] = 146638,
  [SMALL_STATE(2632)] = 146675,
  [SMALL_STATE(2633)] = 146712,
  [SMALL_STATE(2634)] = 146751,
  [SMALL_STATE(2635)] = 146788,
  [SMALL_STATE(2636)] = 146825,
  [SMALL_STATE(2637)] = 146862,
  [SMALL_STATE(2638)] = 146899,
  [SMALL_STATE(2639)] = 146936,
  [SMALL_STATE(2640)] = 146975,
  [SMALL_STATE(2641)] = 147012,
  [SMALL_STATE(2642)] = 147051,
  [SMALL_STATE(2643)] = 147088,
  [SMALL_STATE(2644)] = 147127,
  [SMALL_STATE(2645)] = 147164,
  [SMALL_STATE(2646)] = 147201,
  [SMALL_STATE(2647)] = 147244,
  [SMALL_STATE(2648)] = 147285,
  [SMALL_STATE(2649)] = 147322,
  [SMALL_STATE(2650)] = 147365,
  [SMALL_STATE(2651)] = 147402,
  [SMALL_STATE(2652)] = 147445,
  [SMALL_STATE(2653)] = 147482,
  [SMALL_STATE(2654)] = 147519,
  [SMALL_STATE(2655)] = 147556,
  [SMALL_STATE(2656)] = 147599,
  [SMALL_STATE(2657)] = 147636,
  [SMALL_STATE(2658)] = 147673,
  [SMALL_STATE(2659)] = 147710,
  [SMALL_STATE(2660)] = 147747,
  [SMALL_STATE(2661)] = 147786,
  [SMALL_STATE(2662)] = 147825,
  [SMALL_STATE(2663)] = 147862,
  [SMALL_STATE(2664)] = 147899,
  [SMALL_STATE(2665)] = 147936,
  [SMALL_STATE(2666)] = 147975,
  [SMALL_STATE(2667)] = 148012,
  [SMALL_STATE(2668)] = 148049,
  [SMALL_STATE(2669)] = 148086,
  [SMALL_STATE(2670)] = 148123,
  [SMALL_STATE(2671)] = 148162,
  [SMALL_STATE(2672)] = 148199,
  [SMALL_STATE(2673)] = 148236,
  [SMALL_STATE(2674)] = 148273,
  [SMALL_STATE(2675)] = 148310,
  [SMALL_STATE(2676)] = 148347,
  [SMALL_STATE(2677)] = 148384,
  [SMALL_STATE(2678)] = 148423,
  [SMALL_STATE(2679)] = 148460,
  [SMALL_STATE(2680)] = 148499,
  [SMALL_STATE(2681)] = 148538,
  [SMALL_STATE(2682)] = 148575,
  [SMALL_STATE(2683)] = 148612,
  [SMALL_STATE(2684)] = 148649,
  [SMALL_STATE(2685)] = 148686,
  [SMALL_STATE(2686)] = 148723,
  [SMALL_STATE(2687)] = 148762,
  [SMALL_STATE(2688)] = 148799,
  [SMALL_STATE(2689)] = 148836,
  [SMALL_STATE(2690)] = 148873,
  [SMALL_STATE(2691)] = 148910,
  [SMALL_STATE(2692)] = 148947,
  [SMALL_STATE(2693)] = 148984,
  [SMALL_STATE(2694)] = 149021,
  [SMALL_STATE(2695)] = 149058,
  [SMALL_STATE(2696)] = 149095,
  [SMALL_STATE(2697)] = 149132,
  [SMALL_STATE(2698)] = 149169,
  [SMALL_STATE(2699)] = 149206,
  [SMALL_STATE(2700)] = 149243,
  [SMALL_STATE(2701)] = 149280,
  [SMALL_STATE(2702)] = 149317,
  [SMALL_STATE(2703)] = 149354,
  [SMALL_STATE(2704)] = 149390,
  [SMALL_STATE(2705)] = 149426,
  [SMALL_STATE(2706)] = 149462,
  [SMALL_STATE(2707)] = 149498,
  [SMALL_STATE(2708)] = 149534,
  [SMALL_STATE(2709)] = 149570,
  [SMALL_STATE(2710)] = 149606,
  [SMALL_STATE(2711)] = 149642,
  [SMALL_STATE(2712)] = 149678,
  [SMALL_STATE(2713)] = 149714,
  [SMALL_STATE(2714)] = 149750,
  [SMALL_STATE(2715)] = 149786,
  [SMALL_STATE(2716)] = 149822,
  [SMALL_STATE(2717)] = 149858,
  [SMALL_STATE(2718)] = 149894,
  [SMALL_STATE(2719)] = 149930,
  [SMALL_STATE(2720)] = 149966,
  [SMALL_STATE(2721)] = 150002,
  [SMALL_STATE(2722)] = 150038,
  [SMALL_STATE(2723)] = 150074,
  [SMALL_STATE(2724)] = 150110,
  [SMALL_STATE(2725)] = 150146,
  [SMALL_STATE(2726)] = 150182,
  [SMALL_STATE(2727)] = 150218,
  [SMALL_STATE(2728)] = 150254,
  [SMALL_STATE(2729)] = 150290,
  [SMALL_STATE(2730)] = 150326,
  [SMALL_STATE(2731)] = 150362,
  [SMALL_STATE(2732)] = 150410,
  [SMALL_STATE(2733)] = 150446,
  [SMALL_STATE(2734)] = 150486,
  [SMALL_STATE(2735)] = 150522,
  [SMALL_STATE(2736)] = 150562,
  [SMALL_STATE(2737)] = 150602,
  [SMALL_STATE(2738)] = 150638,
  [SMALL_STATE(2739)] = 150674,
  [SMALL_STATE(2740)] = 150710,
  [SMALL_STATE(2741)] = 150746,
  [SMALL_STATE(2742)] = 150794,
  [SMALL_STATE(2743)] = 150830,
  [SMALL_STATE(2744)] = 150866,
  [SMALL_STATE(2745)] = 150902,
  [SMALL_STATE(2746)] = 150938,
  [SMALL_STATE(2747)] = 150974,
  [SMALL_STATE(2748)] = 151010,
  [SMALL_STATE(2749)] = 151046,
  [SMALL_STATE(2750)] = 151082,
  [SMALL_STATE(2751)] = 151118,
  [SMALL_STATE(2752)] = 151154,
  [SMALL_STATE(2753)] = 151190,
  [SMALL_STATE(2754)] = 151226,
  [SMALL_STATE(2755)] = 151266,
  [SMALL_STATE(2756)] = 151302,
  [SMALL_STATE(2757)] = 151338,
  [SMALL_STATE(2758)] = 151374,
  [SMALL_STATE(2759)] = 151410,
  [SMALL_STATE(2760)] = 151446,
  [SMALL_STATE(2761)] = 151482,
  [SMALL_STATE(2762)] = 151518,
  [SMALL_STATE(2763)] = 151558,
  [SMALL_STATE(2764)] = 151594,
  [SMALL_STATE(2765)] = 151630,
  [SMALL_STATE(2766)] = 151666,
  [SMALL_STATE(2767)] = 151702,
  [SMALL_STATE(2768)] = 151750,
  [SMALL_STATE(2769)] = 151786,
  [SMALL_STATE(2770)] = 151822,
  [SMALL_STATE(2771)] = 151858,
  [SMALL_STATE(2772)] = 151894,
  [SMALL_STATE(2773)] = 151930,
  [SMALL_STATE(2774)] = 151966,
  [SMALL_STATE(2775)] = 152002,
  [SMALL_STATE(2776)] = 152038,
  [SMALL_STATE(2777)] = 152074,
  [SMALL_STATE(2778)] = 152110,
  [SMALL_STATE(2779)] = 152146,
  [SMALL_STATE(2780)] = 152182,
  [SMALL_STATE(2781)] = 152218,
  [SMALL_STATE(2782)] = 152254,
  [SMALL_STATE(2783)] = 152290,
  [SMALL_STATE(2784)] = 152332,
  [SMALL_STATE(2785)] = 152374,
  [SMALL_STATE(2786)] = 152410,
  [SMALL_STATE(2787)] = 152446,
  [SMALL_STATE(2788)] = 152482,
  [SMALL_STATE(2789)] = 152518,
  [SMALL_STATE(2790)] = 152554,
  [SMALL_STATE(2791)] = 152592,
  [SMALL_STATE(2792)] = 152628,
  [SMALL_STATE(2793)] = 152664,
  [SMALL_STATE(2794)] = 152700,
  [SMALL_STATE(2795)] = 152738,
  [SMALL_STATE(2796)] = 152774,
  [SMALL_STATE(2797)] = 152810,
  [SMALL_STATE(2798)] = 152848,
  [SMALL_STATE(2799)] = 152884,
  [SMALL_STATE(2800)] = 152920,
  [SMALL_STATE(2801)] = 152956,
  [SMALL_STATE(2802)] = 152994,
  [SMALL_STATE(2803)] = 153030,
  [SMALL_STATE(2804)] = 153066,
  [SMALL_STATE(2805)] = 153104,
  [SMALL_STATE(2806)] = 153144,
  [SMALL_STATE(2807)] = 153180,
  [SMALL_STATE(2808)] = 153216,
  [SMALL_STATE(2809)] = 153256,
  [SMALL_STATE(2810)] = 153294,
  [SMALL_STATE(2811)] = 153330,
  [SMALL_STATE(2812)] = 153366,
  [SMALL_STATE(2813)] = 153404,
  [SMALL_STATE(2814)] = 153440,
  [SMALL_STATE(2815)] = 153476,
  [SMALL_STATE(2816)] = 153512,
  [SMALL_STATE(2817)] = 153548,
  [SMALL_STATE(2818)] = 153586,
  [SMALL_STATE(2819)] = 153622,
  [SMALL_STATE(2820)] = 153658,
  [SMALL_STATE(2821)] = 153694,
  [SMALL_STATE(2822)] = 153730,
  [SMALL_STATE(2823)] = 153766,
  [SMALL_STATE(2824)] = 153802,
  [SMALL_STATE(2825)] = 153840,
  [SMALL_STATE(2826)] = 153876,
  [SMALL_STATE(2827)] = 153912,
  [SMALL_STATE(2828)] = 153948,
  [SMALL_STATE(2829)] = 153984,
  [SMALL_STATE(2830)] = 154020,
  [SMALL_STATE(2831)] = 154056,
  [SMALL_STATE(2832)] = 154092,
  [SMALL_STATE(2833)] = 154128,
  [SMALL_STATE(2834)] = 154164,
  [SMALL_STATE(2835)] = 154200,
  [SMALL_STATE(2836)] = 154236,
  [SMALL_STATE(2837)] = 154272,
  [SMALL_STATE(2838)] = 154308,
  [SMALL_STATE(2839)] = 154344,
  [SMALL_STATE(2840)] = 154380,
  [SMALL_STATE(2841)] = 154416,
  [SMALL_STATE(2842)] = 154454,
  [SMALL_STATE(2843)] = 154490,
  [SMALL_STATE(2844)] = 154526,
  [SMALL_STATE(2845)] = 154562,
  [SMALL_STATE(2846)] = 154598,
  [SMALL_STATE(2847)] = 154634,
  [SMALL_STATE(2848)] = 154670,
  [SMALL_STATE(2849)] = 154706,
  [SMALL_STATE(2850)] = 154742,
  [SMALL_STATE(2851)] = 154778,
  [SMALL_STATE(2852)] = 154814,
  [SMALL_STATE(2853)] = 154850,
  [SMALL_STATE(2854)] = 154886,
  [SMALL_STATE(2855)] = 154922,
  [SMALL_STATE(2856)] = 154958,
  [SMALL_STATE(2857)] = 154994,
  [SMALL_STATE(2858)] = 155030,
  [SMALL_STATE(2859)] = 155066,
  [SMALL_STATE(2860)] = 155102,
  [SMALL_STATE(2861)] = 155138,
  [SMALL_STATE(2862)] = 155176,
  [SMALL_STATE(2863)] = 155212,
  [SMALL_STATE(2864)] = 155248,
  [SMALL_STATE(2865)] = 155284,
  [SMALL_STATE(2866)] = 155322,
  [SMALL_STATE(2867)] = 155358,
  [SMALL_STATE(2868)] = 155394,
  [SMALL_STATE(2869)] = 155430,
  [SMALL_STATE(2870)] = 155466,
  [SMALL_STATE(2871)] = 155502,
  [SMALL_STATE(2872)] = 155538,
  [SMALL_STATE(2873)] = 155574,
  [SMALL_STATE(2874)] = 155610,
  [SMALL_STATE(2875)] = 155648,
  [SMALL_STATE(2876)] = 155684,
  [SMALL_STATE(2877)] = 155720,
  [SMALL_STATE(2878)] = 155756,
  [SMALL_STATE(2879)] = 155792,
  [SMALL_STATE(2880)] = 155828,
  [SMALL_STATE(2881)] = 155864,
  [SMALL_STATE(2882)] = 155900,
  [SMALL_STATE(2883)] = 155936,
  [SMALL_STATE(2884)] = 155972,
  [SMALL_STATE(2885)] = 156008,
  [SMALL_STATE(2886)] = 156044,
  [SMALL_STATE(2887)] = 156080,
  [SMALL_STATE(2888)] = 156116,
  [SMALL_STATE(2889)] = 156152,
  [SMALL_STATE(2890)] = 156188,
  [SMALL_STATE(2891)] = 156224,
  [SMALL_STATE(2892)] = 156260,
  [SMALL_STATE(2893)] = 156296,
  [SMALL_STATE(2894)] = 156332,
  [SMALL_STATE(2895)] = 156368,
  [SMALL_STATE(2896)] = 156404,
  [SMALL_STATE(2897)] = 156440,
  [SMALL_STATE(2898)] = 156476,
  [SMALL_STATE(2899)] = 156524,
  [SMALL_STATE(2900)] = 156560,
  [SMALL_STATE(2901)] = 156596,
  [SMALL_STATE(2902)] = 156632,
  [SMALL_STATE(2903)] = 156668,
  [SMALL_STATE(2904)] = 156704,
  [SMALL_STATE(2905)] = 156739,
  [SMALL_STATE(2906)] = 156774,
  [SMALL_STATE(2907)] = 156809,
  [SMALL_STATE(2908)] = 156844,
  [SMALL_STATE(2909)] = 156879,
  [SMALL_STATE(2910)] = 156914,
  [SMALL_STATE(2911)] = 156949,
  [SMALL_STATE(2912)] = 156984,
  [SMALL_STATE(2913)] = 157019,
  [SMALL_STATE(2914)] = 157054,
  [SMALL_STATE(2915)] = 157091,
  [SMALL_STATE(2916)] = 157128,
  [SMALL_STATE(2917)] = 157163,
  [SMALL_STATE(2918)] = 157198,
  [SMALL_STATE(2919)] = 157235,
  [SMALL_STATE(2920)] = 157270,
  [SMALL_STATE(2921)] = 157305,
  [SMALL_STATE(2922)] = 157340,
  [SMALL_STATE(2923)] = 157375,
  [SMALL_STATE(2924)] = 157410,
  [SMALL_STATE(2925)] = 157445,
  [SMALL_STATE(2926)] = 157488,
  [SMALL_STATE(2927)] = 157523,
  [SMALL_STATE(2928)] = 157560,
  [SMALL_STATE(2929)] = 157595,
  [SMALL_STATE(2930)] = 157630,
  [SMALL_STATE(2931)] = 157665,
  [SMALL_STATE(2932)] = 157700,
  [SMALL_STATE(2933)] = 157743,
  [SMALL_STATE(2934)] = 157780,
  [SMALL_STATE(2935)] = 157815,
  [SMALL_STATE(2936)] = 157852,
  [SMALL_STATE(2937)] = 157887,
  [SMALL_STATE(2938)] = 157922,
  [SMALL_STATE(2939)] = 157957,
  [SMALL_STATE(2940)] = 157992,
  [SMALL_STATE(2941)] = 158027,
  [SMALL_STATE(2942)] = 158062,
  [SMALL_STATE(2943)] = 158097,
  [SMALL_STATE(2944)] = 158132,
  [SMALL_STATE(2945)] = 158167,
  [SMALL_STATE(2946)] = 158202,
  [SMALL_STATE(2947)] = 158237,
  [SMALL_STATE(2948)] = 158274,
  [SMALL_STATE(2949)] = 158309,
  [SMALL_STATE(2950)] = 158344,
  [SMALL_STATE(2951)] = 158379,
  [SMALL_STATE(2952)] = 158414,
  [SMALL_STATE(2953)] = 158449,
  [SMALL_STATE(2954)] = 158484,
  [SMALL_STATE(2955)] = 158519,
  [SMALL_STATE(2956)] = 158554,
  [SMALL_STATE(2957)] = 158589,
  [SMALL_STATE(2958)] = 158624,
  [SMALL_STATE(2959)] = 158659,
  [SMALL_STATE(2960)] = 158694,
  [SMALL_STATE(2961)] = 158731,
  [SMALL_STATE(2962)] = 158768,
  [SMALL_STATE(2963)] = 158803,
  [SMALL_STATE(2964)] = 158838,
  [SMALL_STATE(2965)] = 158873,
  [SMALL_STATE(2966)] = 158908,
  [SMALL_STATE(2967)] = 158943,
  [SMALL_STATE(2968)] = 158978,
  [SMALL_STATE(2969)] = 159015,
  [SMALL_STATE(2970)] = 159049,
  [SMALL_STATE(2971)] = 159083,
  [SMALL_STATE(2972)] = 159117,
  [SMALL_STATE(2973)] = 159151,
  [SMALL_STATE(2974)] = 159185,
  [SMALL_STATE(2975)] = 159219,
  [SMALL_STATE(2976)] = 159253,
  [SMALL_STATE(2977)] = 159287,
  [SMALL_STATE(2978)] = 159321,
  [SMALL_STATE(2979)] = 159355,
  [SMALL_STATE(2980)] = 159389,
  [SMALL_STATE(2981)] = 159423,
  [SMALL_STATE(2982)] = 159457,
  [SMALL_STATE(2983)] = 159491,
  [SMALL_STATE(2984)] = 159525,
  [SMALL_STATE(2985)] = 159559,
  [SMALL_STATE(2986)] = 159593,
  [SMALL_STATE(2987)] = 159639,
  [SMALL_STATE(2988)] = 159673,
  [SMALL_STATE(2989)] = 159707,
  [SMALL_STATE(2990)] = 159753,
  [SMALL_STATE(2991)] = 159787,
  [SMALL_STATE(2992)] = 159821,
  [SMALL_STATE(2993)] = 159855,
  [SMALL_STATE(2994)] = 159889,
  [SMALL_STATE(2995)] = 159923,
  [SMALL_STATE(2996)] = 159969,
  [SMALL_STATE(2997)] = 160003,
  [SMALL_STATE(2998)] = 160049,
  [SMALL_STATE(2999)] = 160083,
  [SMALL_STATE(3000)] = 160129,
  [SMALL_STATE(3001)] = 160165,
  [SMALL_STATE(3002)] = 160211,
  [SMALL_STATE(3003)] = 160245,
  [SMALL_STATE(3004)] = 160279,
  [SMALL_STATE(3005)] = 160325,
  [SMALL_STATE(3006)] = 160359,
  [SMALL_STATE(3007)] = 160393,
  [SMALL_STATE(3008)] = 160427,
  [SMALL_STATE(3009)] = 160461,
  [SMALL_STATE(3010)] = 160495,
  [SMALL_STATE(3011)] = 160529,
  [SMALL_STATE(3012)] = 160563,
  [SMALL_STATE(3013)] = 160597,
  [SMALL_STATE(3014)] = 160643,
  [SMALL_STATE(3015)] = 160677,
  [SMALL_STATE(3016)] = 160711,
  [SMALL_STATE(3017)] = 160745,
  [SMALL_STATE(3018)] = 160779,
  [SMALL_STATE(3019)] = 160813,
  [SMALL_STATE(3020)] = 160846,
  [SMALL_STATE(3021)] = 160879,
  [SMALL_STATE(3022)] = 160913,
  [SMALL_STATE(3023)] = 160945,
  [SMALL_STATE(3024)] = 160977,
  [SMALL_STATE(3025)] = 161031,
  [SMALL_STATE(3026)] = 161075,
  [SMALL_STATE(3027)] = 161109,
  [SMALL_STATE(3028)] = 161163,
  [SMALL_STATE(3029)] = 161217,
  [SMALL_STATE(3030)] = 161261,
  [SMALL_STATE(3031)] = 161295,
  [SMALL_STATE(3032)] = 161339,
  [SMALL_STATE(3033)] = 161371,
  [SMALL_STATE(3034)] = 161411,
  [SMALL_STATE(3035)] = 161451,
  [SMALL_STATE(3036)] = 161505,
  [SMALL_STATE(3037)] = 161539,
  [SMALL_STATE(3038)] = 161571,
  [SMALL_STATE(3039)] = 161625,
  [SMALL_STATE(3040)] = 161657,
  [SMALL_STATE(3041)] = 161701,
  [SMALL_STATE(3042)] = 161755,
  [SMALL_STATE(3043)] = 161789,
  [SMALL_STATE(3044)] = 161833,
  [SMALL_STATE(3045)] = 161865,
  [SMALL_STATE(3046)] = 161909,
  [SMALL_STATE(3047)] = 161943,
  [SMALL_STATE(3048)] = 161974,
  [SMALL_STATE(3049)] = 162007,
  [SMALL_STATE(3050)] = 162058,
  [SMALL_STATE(3051)] = 162095,
  [SMALL_STATE(3052)] = 162146,
  [SMALL_STATE(3053)] = 162197,
  [SMALL_STATE(3054)] = 162228,
  [SMALL_STATE(3055)] = 162259,
  [SMALL_STATE(3056)] = 162290,
  [SMALL_STATE(3057)] = 162323,
  [SMALL_STATE(3058)] = 162356,
  [SMALL_STATE(3059)] = 162387,
  [SMALL_STATE(3060)] = 162418,
  [SMALL_STATE(3061)] = 162451,
  [SMALL_STATE(3062)] = 162482,
  [SMALL_STATE(3063)] = 162513,
  [SMALL_STATE(3064)] = 162544,
  [SMALL_STATE(3065)] = 162575,
  [SMALL_STATE(3066)] = 162606,
  [SMALL_STATE(3067)] = 162639,
  [SMALL_STATE(3068)] = 162670,
  [SMALL_STATE(3069)] = 162701,
  [SMALL_STATE(3070)] = 162732,
  [SMALL_STATE(3071)] = 162763,
  [SMALL_STATE(3072)] = 162794,
  [SMALL_STATE(3073)] = 162825,
  [SMALL_STATE(3074)] = 162856,
  [SMALL_STATE(3075)] = 162887,
  [SMALL_STATE(3076)] = 162918,
  [SMALL_STATE(3077)] = 162949,
  [SMALL_STATE(3078)] = 162980,
  [SMALL_STATE(3079)] = 163011,
  [SMALL_STATE(3080)] = 163042,
  [SMALL_STATE(3081)] = 163073,
  [SMALL_STATE(3082)] = 163104,
  [SMALL_STATE(3083)] = 163135,
  [SMALL_STATE(3084)] = 163166,
  [SMALL_STATE(3085)] = 163197,
  [SMALL_STATE(3086)] = 163248,
  [SMALL_STATE(3087)] = 163299,
  [SMALL_STATE(3088)] = 163330,
  [SMALL_STATE(3089)] = 163361,
  [SMALL_STATE(3090)] = 163392,
  [SMALL_STATE(3091)] = 163423,
  [SMALL_STATE(3092)] = 163454,
  [SMALL_STATE(3093)] = 163487,
  [SMALL_STATE(3094)] = 163518,
  [SMALL_STATE(3095)] = 163549,
  [SMALL_STATE(3096)] = 163580,
  [SMALL_STATE(3097)] = 163619,
  [SMALL_STATE(3098)] = 163652,
  [SMALL_STATE(3099)] = 163685,
  [SMALL_STATE(3100)] = 163718,
  [SMALL_STATE(3101)] = 163751,
  [SMALL_STATE(3102)] = 163790,
  [SMALL_STATE(3103)] = 163821,
  [SMALL_STATE(3104)] = 163864,
  [SMALL_STATE(3105)] = 163895,
  [SMALL_STATE(3106)] = 163926,
  [SMALL_STATE(3107)] = 163969,
  [SMALL_STATE(3108)] = 164002,
  [SMALL_STATE(3109)] = 164033,
  [SMALL_STATE(3110)] = 164066,
  [SMALL_STATE(3111)] = 164097,
  [SMALL_STATE(3112)] = 164128,
  [SMALL_STATE(3113)] = 164159,
  [SMALL_STATE(3114)] = 164190,
  [SMALL_STATE(3115)] = 164221,
  [SMALL_STATE(3116)] = 164252,
  [SMALL_STATE(3117)] = 164283,
  [SMALL_STATE(3118)] = 164334,
  [SMALL_STATE(3119)] = 164365,
  [SMALL_STATE(3120)] = 164396,
  [SMALL_STATE(3121)] = 164427,
  [SMALL_STATE(3122)] = 164458,
  [SMALL_STATE(3123)] = 164491,
  [SMALL_STATE(3124)] = 164522,
  [SMALL_STATE(3125)] = 164553,
  [SMALL_STATE(3126)] = 164584,
  [SMALL_STATE(3127)] = 164627,
  [SMALL_STATE(3128)] = 164658,
  [SMALL_STATE(3129)] = 164689,
  [SMALL_STATE(3130)] = 164720,
  [SMALL_STATE(3131)] = 164751,
  [SMALL_STATE(3132)] = 164782,
  [SMALL_STATE(3133)] = 164813,
  [SMALL_STATE(3134)] = 164844,
  [SMALL_STATE(3135)] = 164875,
  [SMALL_STATE(3136)] = 164908,
  [SMALL_STATE(3137)] = 164939,
  [SMALL_STATE(3138)] = 164970,
  [SMALL_STATE(3139)] = 165001,
  [SMALL_STATE(3140)] = 165038,
  [SMALL_STATE(3141)] = 165069,
  [SMALL_STATE(3142)] = 165100,
  [SMALL_STATE(3143)] = 165131,
  [SMALL_STATE(3144)] = 165161,
  [SMALL_STATE(3145)] = 165191,
  [SMALL_STATE(3146)] = 165241,
  [SMALL_STATE(3147)] = 165271,
  [SMALL_STATE(3148)] = 165301,
  [SMALL_STATE(3149)] = 165331,
  [SMALL_STATE(3150)] = 165361,
  [SMALL_STATE(3151)] = 165391,
  [SMALL_STATE(3152)] = 165423,
  [SMALL_STATE(3153)] = 165473,
  [SMALL_STATE(3154)] = 165523,
  [SMALL_STATE(3155)] = 165555,
  [SMALL_STATE(3156)] = 165585,
  [SMALL_STATE(3157)] = 165615,
  [SMALL_STATE(3158)] = 165645,
  [SMALL_STATE(3159)] = 165675,
  [SMALL_STATE(3160)] = 165705,
  [SMALL_STATE(3161)] = 165735,
  [SMALL_STATE(3162)] = 165765,
  [SMALL_STATE(3163)] = 165797,
  [SMALL_STATE(3164)] = 165829,
  [SMALL_STATE(3165)] = 165859,
  [SMALL_STATE(3166)] = 165889,
  [SMALL_STATE(3167)] = 165921,
  [SMALL_STATE(3168)] = 165951,
  [SMALL_STATE(3169)] = 165981,
  [SMALL_STATE(3170)] = 166011,
  [SMALL_STATE(3171)] = 166041,
  [SMALL_STATE(3172)] = 166071,
  [SMALL_STATE(3173)] = 166101,
  [SMALL_STATE(3174)] = 166131,
  [SMALL_STATE(3175)] = 166181,
  [SMALL_STATE(3176)] = 166211,
  [SMALL_STATE(3177)] = 166241,
  [SMALL_STATE(3178)] = 166271,
  [SMALL_STATE(3179)] = 166301,
  [SMALL_STATE(3180)] = 166331,
  [SMALL_STATE(3181)] = 166361,
  [SMALL_STATE(3182)] = 166391,
  [SMALL_STATE(3183)] = 166423,
  [SMALL_STATE(3184)] = 166453,
  [SMALL_STATE(3185)] = 166483,
  [SMALL_STATE(3186)] = 166513,
  [SMALL_STATE(3187)] = 166543,
  [SMALL_STATE(3188)] = 166573,
  [SMALL_STATE(3189)] = 166603,
  [SMALL_STATE(3190)] = 166635,
  [SMALL_STATE(3191)] = 166665,
  [SMALL_STATE(3192)] = 166695,
  [SMALL_STATE(3193)] = 166725,
  [SMALL_STATE(3194)] = 166755,
  [SMALL_STATE(3195)] = 166785,
  [SMALL_STATE(3196)] = 166817,
  [SMALL_STATE(3197)] = 166847,
  [SMALL_STATE(3198)] = 166877,
  [SMALL_STATE(3199)] = 166907,
  [SMALL_STATE(3200)] = 166937,
  [SMALL_STATE(3201)] = 166967,
  [SMALL_STATE(3202)] = 166999,
  [SMALL_STATE(3203)] = 167029,
  [SMALL_STATE(3204)] = 167061,
  [SMALL_STATE(3205)] = 167091,
  [SMALL_STATE(3206)] = 167121,
  [SMALL_STATE(3207)] = 167151,
  [SMALL_STATE(3208)] = 167201,
  [SMALL_STATE(3209)] = 167231,
  [SMALL_STATE(3210)] = 167261,
  [SMALL_STATE(3211)] = 167291,
  [SMALL_STATE(3212)] = 167321,
  [SMALL_STATE(3213)] = 167351,
  [SMALL_STATE(3214)] = 167381,
  [SMALL_STATE(3215)] = 167411,
  [SMALL_STATE(3216)] = 167441,
  [SMALL_STATE(3217)] = 167471,
  [SMALL_STATE(3218)] = 167501,
  [SMALL_STATE(3219)] = 167531,
  [SMALL_STATE(3220)] = 167561,
  [SMALL_STATE(3221)] = 167593,
  [SMALL_STATE(3222)] = 167623,
  [SMALL_STATE(3223)] = 167653,
  [SMALL_STATE(3224)] = 167683,
  [SMALL_STATE(3225)] = 167713,
  [SMALL_STATE(3226)] = 167763,
  [SMALL_STATE(3227)] = 167793,
  [SMALL_STATE(3228)] = 167833,
  [SMALL_STATE(3229)] = 167863,
  [SMALL_STATE(3230)] = 167895,
  [SMALL_STATE(3231)] = 167945,
  [SMALL_STATE(3232)] = 167975,
  [SMALL_STATE(3233)] = 168015,
  [SMALL_STATE(3234)] = 168047,
  [SMALL_STATE(3235)] = 168077,
  [SMALL_STATE(3236)] = 168107,
  [SMALL_STATE(3237)] = 168137,
  [SMALL_STATE(3238)] = 168167,
  [SMALL_STATE(3239)] = 168197,
  [SMALL_STATE(3240)] = 168247,
  [SMALL_STATE(3241)] = 168277,
  [SMALL_STATE(3242)] = 168309,
  [SMALL_STATE(3243)] = 168339,
  [SMALL_STATE(3244)] = 168369,
  [SMALL_STATE(3245)] = 168399,
  [SMALL_STATE(3246)] = 168429,
  [SMALL_STATE(3247)] = 168459,
  [SMALL_STATE(3248)] = 168489,
  [SMALL_STATE(3249)] = 168519,
  [SMALL_STATE(3250)] = 168549,
  [SMALL_STATE(3251)] = 168579,
  [SMALL_STATE(3252)] = 168609,
  [SMALL_STATE(3253)] = 168639,
  [SMALL_STATE(3254)] = 168671,
  [SMALL_STATE(3255)] = 168701,
  [SMALL_STATE(3256)] = 168731,
  [SMALL_STATE(3257)] = 168761,
  [SMALL_STATE(3258)] = 168791,
  [SMALL_STATE(3259)] = 168821,
  [SMALL_STATE(3260)] = 168851,
  [SMALL_STATE(3261)] = 168903,
  [SMALL_STATE(3262)] = 168933,
  [SMALL_STATE(3263)] = 168963,
  [SMALL_STATE(3264)] = 169015,
  [SMALL_STATE(3265)] = 169045,
  [SMALL_STATE(3266)] = 169075,
  [SMALL_STATE(3267)] = 169105,
  [SMALL_STATE(3268)] = 169135,
  [SMALL_STATE(3269)] = 169165,
  [SMALL_STATE(3270)] = 169195,
  [SMALL_STATE(3271)] = 169225,
  [SMALL_STATE(3272)] = 169255,
  [SMALL_STATE(3273)] = 169285,
  [SMALL_STATE(3274)] = 169325,
  [SMALL_STATE(3275)] = 169355,
  [SMALL_STATE(3276)] = 169386,
  [SMALL_STATE(3277)] = 169415,
  [SMALL_STATE(3278)] = 169444,
  [SMALL_STATE(3279)] = 169473,
  [SMALL_STATE(3280)] = 169524,
  [SMALL_STATE(3281)] = 169555,
  [SMALL_STATE(3282)] = 169606,
  [SMALL_STATE(3283)] = 169637,
  [SMALL_STATE(3284)] = 169668,
  [SMALL_STATE(3285)] = 169719,
  [SMALL_STATE(3286)] = 169748,
  [SMALL_STATE(3287)] = 169777,
  [SMALL_STATE(3288)] = 169828,
  [SMALL_STATE(3289)] = 169859,
  [SMALL_STATE(3290)] = 169890,
  [SMALL_STATE(3291)] = 169921,
  [SMALL_STATE(3292)] = 169950,
  [SMALL_STATE(3293)] = 169979,
  [SMALL_STATE(3294)] = 170010,
  [SMALL_STATE(3295)] = 170059,
  [SMALL_STATE(3296)] = 170088,
  [SMALL_STATE(3297)] = 170119,
  [SMALL_STATE(3298)] = 170148,
  [SMALL_STATE(3299)] = 170177,
  [SMALL_STATE(3300)] = 170206,
  [SMALL_STATE(3301)] = 170237,
  [SMALL_STATE(3302)] = 170288,
  [SMALL_STATE(3303)] = 170325,
  [SMALL_STATE(3304)] = 170356,
  [SMALL_STATE(3305)] = 170385,
  [SMALL_STATE(3306)] = 170414,
  [SMALL_STATE(3307)] = 170443,
  [SMALL_STATE(3308)] = 170494,
  [SMALL_STATE(3309)] = 170523,
  [SMALL_STATE(3310)] = 170552,
  [SMALL_STATE(3311)] = 170581,
  [SMALL_STATE(3312)] = 170610,
  [SMALL_STATE(3313)] = 170639,
  [SMALL_STATE(3314)] = 170670,
  [SMALL_STATE(3315)] = 170721,
  [SMALL_STATE(3316)] = 170750,
  [SMALL_STATE(3317)] = 170801,
  [SMALL_STATE(3318)] = 170832,
  [SMALL_STATE(3319)] = 170883,
  [SMALL_STATE(3320)] = 170912,
  [SMALL_STATE(3321)] = 170963,
  [SMALL_STATE(3322)] = 170992,
  [SMALL_STATE(3323)] = 171029,
  [SMALL_STATE(3324)] = 171060,
  [SMALL_STATE(3325)] = 171089,
  [SMALL_STATE(3326)] = 171118,
  [SMALL_STATE(3327)] = 171169,
  [SMALL_STATE(3328)] = 171198,
  [SMALL_STATE(3329)] = 171247,
  [SMALL_STATE(3330)] = 171298,
  [SMALL_STATE(3331)] = 171327,
  [SMALL_STATE(3332)] = 171358,
  [SMALL_STATE(3333)] = 171387,
  [SMALL_STATE(3334)] = 171416,
  [SMALL_STATE(3335)] = 171467,
  [SMALL_STATE(3336)] = 171496,
  [SMALL_STATE(3337)] = 171525,
  [SMALL_STATE(3338)] = 171554,
  [SMALL_STATE(3339)] = 171583,
  [SMALL_STATE(3340)] = 171612,
  [SMALL_STATE(3341)] = 171643,
  [SMALL_STATE(3342)] = 171672,
  [SMALL_STATE(3343)] = 171701,
  [SMALL_STATE(3344)] = 171732,
  [SMALL_STATE(3345)] = 171761,
  [SMALL_STATE(3346)] = 171790,
  [SMALL_STATE(3347)] = 171819,
  [SMALL_STATE(3348)] = 171850,
  [SMALL_STATE(3349)] = 171879,
  [SMALL_STATE(3350)] = 171908,
  [SMALL_STATE(3351)] = 171937,
  [SMALL_STATE(3352)] = 171966,
  [SMALL_STATE(3353)] = 171997,
  [SMALL_STATE(3354)] = 172026,
  [SMALL_STATE(3355)] = 172055,
  [SMALL_STATE(3356)] = 172084,
  [SMALL_STATE(3357)] = 172113,
  [SMALL_STATE(3358)] = 172142,
  [SMALL_STATE(3359)] = 172173,
  [SMALL_STATE(3360)] = 172202,
  [SMALL_STATE(3361)] = 172231,
  [SMALL_STATE(3362)] = 172260,
  [SMALL_STATE(3363)] = 172289,
  [SMALL_STATE(3364)] = 172318,
  [SMALL_STATE(3365)] = 172349,
  [SMALL_STATE(3366)] = 172378,
  [SMALL_STATE(3367)] = 172407,
  [SMALL_STATE(3368)] = 172436,
  [SMALL_STATE(3369)] = 172465,
  [SMALL_STATE(3370)] = 172494,
  [SMALL_STATE(3371)] = 172523,
  [SMALL_STATE(3372)] = 172552,
  [SMALL_STATE(3373)] = 172581,
  [SMALL_STATE(3374)] = 172610,
  [SMALL_STATE(3375)] = 172639,
  [SMALL_STATE(3376)] = 172670,
  [SMALL_STATE(3377)] = 172701,
  [SMALL_STATE(3378)] = 172732,
  [SMALL_STATE(3379)] = 172761,
  [SMALL_STATE(3380)] = 172790,
  [SMALL_STATE(3381)] = 172819,
  [SMALL_STATE(3382)] = 172848,
  [SMALL_STATE(3383)] = 172879,
  [SMALL_STATE(3384)] = 172908,
  [SMALL_STATE(3385)] = 172937,
  [SMALL_STATE(3386)] = 172966,
  [SMALL_STATE(3387)] = 172995,
  [SMALL_STATE(3388)] = 173024,
  [SMALL_STATE(3389)] = 173053,
  [SMALL_STATE(3390)] = 173082,
  [SMALL_STATE(3391)] = 173111,
  [SMALL_STATE(3392)] = 173140,
  [SMALL_STATE(3393)] = 173169,
  [SMALL_STATE(3394)] = 173198,
  [SMALL_STATE(3395)] = 173227,
  [SMALL_STATE(3396)] = 173256,
  [SMALL_STATE(3397)] = 173285,
  [SMALL_STATE(3398)] = 173314,
  [SMALL_STATE(3399)] = 173343,
  [SMALL_STATE(3400)] = 173372,
  [SMALL_STATE(3401)] = 173423,
  [SMALL_STATE(3402)] = 173452,
  [SMALL_STATE(3403)] = 173481,
  [SMALL_STATE(3404)] = 173512,
  [SMALL_STATE(3405)] = 173541,
  [SMALL_STATE(3406)] = 173570,
  [SMALL_STATE(3407)] = 173601,
  [SMALL_STATE(3408)] = 173630,
  [SMALL_STATE(3409)] = 173659,
  [SMALL_STATE(3410)] = 173688,
  [SMALL_STATE(3411)] = 173717,
  [SMALL_STATE(3412)] = 173746,
  [SMALL_STATE(3413)] = 173775,
  [SMALL_STATE(3414)] = 173804,
  [SMALL_STATE(3415)] = 173833,
  [SMALL_STATE(3416)] = 173862,
  [SMALL_STATE(3417)] = 173891,
  [SMALL_STATE(3418)] = 173920,
  [SMALL_STATE(3419)] = 173949,
  [SMALL_STATE(3420)] = 173978,
  [SMALL_STATE(3421)] = 174007,
  [SMALL_STATE(3422)] = 174036,
  [SMALL_STATE(3423)] = 174065,
  [SMALL_STATE(3424)] = 174094,
  [SMALL_STATE(3425)] = 174123,
  [SMALL_STATE(3426)] = 174152,
  [SMALL_STATE(3427)] = 174181,
  [SMALL_STATE(3428)] = 174210,
  [SMALL_STATE(3429)] = 174239,
  [SMALL_STATE(3430)] = 174268,
  [SMALL_STATE(3431)] = 174297,
  [SMALL_STATE(3432)] = 174328,
  [SMALL_STATE(3433)] = 174357,
  [SMALL_STATE(3434)] = 174388,
  [SMALL_STATE(3435)] = 174417,
  [SMALL_STATE(3436)] = 174446,
  [SMALL_STATE(3437)] = 174474,
  [SMALL_STATE(3438)] = 174502,
  [SMALL_STATE(3439)] = 174530,
  [SMALL_STATE(3440)] = 174558,
  [SMALL_STATE(3441)] = 174586,
  [SMALL_STATE(3442)] = 174614,
  [SMALL_STATE(3443)] = 174662,
  [SMALL_STATE(3444)] = 174690,
  [SMALL_STATE(3445)] = 174718,
  [SMALL_STATE(3446)] = 174748,
  [SMALL_STATE(3447)] = 174796,
  [SMALL_STATE(3448)] = 174824,
  [SMALL_STATE(3449)] = 174852,
  [SMALL_STATE(3450)] = 174882,
  [SMALL_STATE(3451)] = 174910,
  [SMALL_STATE(3452)] = 174958,
  [SMALL_STATE(3453)] = 174986,
  [SMALL_STATE(3454)] = 175014,
  [SMALL_STATE(3455)] = 175042,
  [SMALL_STATE(3456)] = 175086,
  [SMALL_STATE(3457)] = 175114,
  [SMALL_STATE(3458)] = 175144,
  [SMALL_STATE(3459)] = 175172,
  [SMALL_STATE(3460)] = 175200,
  [SMALL_STATE(3461)] = 175248,
  [SMALL_STATE(3462)] = 175276,
  [SMALL_STATE(3463)] = 175304,
  [SMALL_STATE(3464)] = 175332,
  [SMALL_STATE(3465)] = 175362,
  [SMALL_STATE(3466)] = 175390,
  [SMALL_STATE(3467)] = 175418,
  [SMALL_STATE(3468)] = 175446,
  [SMALL_STATE(3469)] = 175474,
  [SMALL_STATE(3470)] = 175502,
  [SMALL_STATE(3471)] = 175530,
  [SMALL_STATE(3472)] = 175558,
  [SMALL_STATE(3473)] = 175586,
  [SMALL_STATE(3474)] = 175616,
  [SMALL_STATE(3475)] = 175644,
  [SMALL_STATE(3476)] = 175672,
  [SMALL_STATE(3477)] = 175702,
  [SMALL_STATE(3478)] = 175750,
  [SMALL_STATE(3479)] = 175778,
  [SMALL_STATE(3480)] = 175806,
  [SMALL_STATE(3481)] = 175834,
  [SMALL_STATE(3482)] = 175862,
  [SMALL_STATE(3483)] = 175910,
  [SMALL_STATE(3484)] = 175958,
  [SMALL_STATE(3485)] = 175992,
  [SMALL_STATE(3486)] = 176040,
  [SMALL_STATE(3487)] = 176088,
  [SMALL_STATE(3488)] = 176136,
  [SMALL_STATE(3489)] = 176184,
  [SMALL_STATE(3490)] = 176232,
  [SMALL_STATE(3491)] = 176262,
  [SMALL_STATE(3492)] = 176292,
  [SMALL_STATE(3493)] = 176320,
  [SMALL_STATE(3494)] = 176348,
  [SMALL_STATE(3495)] = 176376,
  [SMALL_STATE(3496)] = 176410,
  [SMALL_STATE(3497)] = 176458,
  [SMALL_STATE(3498)] = 176486,
  [SMALL_STATE(3499)] = 176514,
  [SMALL_STATE(3500)] = 176542,
  [SMALL_STATE(3501)] = 176572,
  [SMALL_STATE(3502)] = 176602,
  [SMALL_STATE(3503)] = 176632,
  [SMALL_STATE(3504)] = 176660,
  [SMALL_STATE(3505)] = 176690,
  [SMALL_STATE(3506)] = 176738,
  [SMALL_STATE(3507)] = 176786,
  [SMALL_STATE(3508)] = 176814,
  [SMALL_STATE(3509)] = 176862,
  [SMALL_STATE(3510)] = 176890,
  [SMALL_STATE(3511)] = 176918,
  [SMALL_STATE(3512)] = 176946,
  [SMALL_STATE(3513)] = 176994,
  [SMALL_STATE(3514)] = 177022,
  [SMALL_STATE(3515)] = 177070,
  [SMALL_STATE(3516)] = 177098,
  [SMALL_STATE(3517)] = 177126,
  [SMALL_STATE(3518)] = 177156,
  [SMALL_STATE(3519)] = 177204,
  [SMALL_STATE(3520)] = 177252,
  [SMALL_STATE(3521)] = 177280,
  [SMALL_STATE(3522)] = 177328,
  [SMALL_STATE(3523)] = 177376,
  [SMALL_STATE(3524)] = 177404,
  [SMALL_STATE(3525)] = 177452,
  [SMALL_STATE(3526)] = 177486,
  [SMALL_STATE(3527)] = 177514,
  [SMALL_STATE(3528)] = 177562,
  [SMALL_STATE(3529)] = 177590,
  [SMALL_STATE(3530)] = 177618,
  [SMALL_STATE(3531)] = 177646,
  [SMALL_STATE(3532)] = 177674,
  [SMALL_STATE(3533)] = 177702,
  [SMALL_STATE(3534)] = 177750,
  [SMALL_STATE(3535)] = 177780,
  [SMALL_STATE(3536)] = 177808,
  [SMALL_STATE(3537)] = 177836,
  [SMALL_STATE(3538)] = 177864,
  [SMALL_STATE(3539)] = 177892,
  [SMALL_STATE(3540)] = 177920,
  [SMALL_STATE(3541)] = 177948,
  [SMALL_STATE(3542)] = 177976,
  [SMALL_STATE(3543)] = 178004,
  [SMALL_STATE(3544)] = 178032,
  [SMALL_STATE(3545)] = 178060,
  [SMALL_STATE(3546)] = 178088,
  [SMALL_STATE(3547)] = 178116,
  [SMALL_STATE(3548)] = 178144,
  [SMALL_STATE(3549)] = 178172,
  [SMALL_STATE(3550)] = 178200,
  [SMALL_STATE(3551)] = 178228,
  [SMALL_STATE(3552)] = 178276,
  [SMALL_STATE(3553)] = 178304,
  [SMALL_STATE(3554)] = 178332,
  [SMALL_STATE(3555)] = 178360,
  [SMALL_STATE(3556)] = 178388,
  [SMALL_STATE(3557)] = 178416,
  [SMALL_STATE(3558)] = 178444,
  [SMALL_STATE(3559)] = 178472,
  [SMALL_STATE(3560)] = 178500,
  [SMALL_STATE(3561)] = 178528,
  [SMALL_STATE(3562)] = 178556,
  [SMALL_STATE(3563)] = 178584,
  [SMALL_STATE(3564)] = 178612,
  [SMALL_STATE(3565)] = 178640,
  [SMALL_STATE(3566)] = 178668,
  [SMALL_STATE(3567)] = 178696,
  [SMALL_STATE(3568)] = 178724,
  [SMALL_STATE(3569)] = 178752,
  [SMALL_STATE(3570)] = 178780,
  [SMALL_STATE(3571)] = 178808,
  [SMALL_STATE(3572)] = 178836,
  [SMALL_STATE(3573)] = 178864,
  [SMALL_STATE(3574)] = 178892,
  [SMALL_STATE(3575)] = 178920,
  [SMALL_STATE(3576)] = 178948,
  [SMALL_STATE(3577)] = 178976,
  [SMALL_STATE(3578)] = 179004,
  [SMALL_STATE(3579)] = 179032,
  [SMALL_STATE(3580)] = 179060,
  [SMALL_STATE(3581)] = 179088,
  [SMALL_STATE(3582)] = 179116,
  [SMALL_STATE(3583)] = 179144,
  [SMALL_STATE(3584)] = 179192,
  [SMALL_STATE(3585)] = 179220,
  [SMALL_STATE(3586)] = 179248,
  [SMALL_STATE(3587)] = 179276,
  [SMALL_STATE(3588)] = 179304,
  [SMALL_STATE(3589)] = 179332,
  [SMALL_STATE(3590)] = 179366,
  [SMALL_STATE(3591)] = 179394,
  [SMALL_STATE(3592)] = 179422,
  [SMALL_STATE(3593)] = 179450,
  [SMALL_STATE(3594)] = 179478,
  [SMALL_STATE(3595)] = 179506,
  [SMALL_STATE(3596)] = 179534,
  [SMALL_STATE(3597)] = 179562,
  [SMALL_STATE(3598)] = 179590,
  [SMALL_STATE(3599)] = 179618,
  [SMALL_STATE(3600)] = 179646,
  [SMALL_STATE(3601)] = 179674,
  [SMALL_STATE(3602)] = 179702,
  [SMALL_STATE(3603)] = 179730,
  [SMALL_STATE(3604)] = 179758,
  [SMALL_STATE(3605)] = 179786,
  [SMALL_STATE(3606)] = 179816,
  [SMALL_STATE(3607)] = 179844,
  [SMALL_STATE(3608)] = 179872,
  [SMALL_STATE(3609)] = 179900,
  [SMALL_STATE(3610)] = 179928,
  [SMALL_STATE(3611)] = 179956,
  [SMALL_STATE(3612)] = 179984,
  [SMALL_STATE(3613)] = 180012,
  [SMALL_STATE(3614)] = 180040,
  [SMALL_STATE(3615)] = 180070,
  [SMALL_STATE(3616)] = 180100,
  [SMALL_STATE(3617)] = 180128,
  [SMALL_STATE(3618)] = 180156,
  [SMALL_STATE(3619)] = 180184,
  [SMALL_STATE(3620)] = 180214,
  [SMALL_STATE(3621)] = 180242,
  [SMALL_STATE(3622)] = 180272,
  [SMALL_STATE(3623)] = 180300,
  [SMALL_STATE(3624)] = 180328,
  [SMALL_STATE(3625)] = 180356,
  [SMALL_STATE(3626)] = 180384,
  [SMALL_STATE(3627)] = 180412,
  [SMALL_STATE(3628)] = 180442,
  [SMALL_STATE(3629)] = 180490,
  [SMALL_STATE(3630)] = 180518,
  [SMALL_STATE(3631)] = 180546,
  [SMALL_STATE(3632)] = 180594,
  [SMALL_STATE(3633)] = 180642,
  [SMALL_STATE(3634)] = 180670,
  [SMALL_STATE(3635)] = 180698,
  [SMALL_STATE(3636)] = 180726,
  [SMALL_STATE(3637)] = 180774,
  [SMALL_STATE(3638)] = 180802,
  [SMALL_STATE(3639)] = 180830,
  [SMALL_STATE(3640)] = 180858,
  [SMALL_STATE(3641)] = 180906,
  [SMALL_STATE(3642)] = 180934,
  [SMALL_STATE(3643)] = 180962,
  [SMALL_STATE(3644)] = 180990,
  [SMALL_STATE(3645)] = 181018,
  [SMALL_STATE(3646)] = 181046,
  [SMALL_STATE(3647)] = 181074,
  [SMALL_STATE(3648)] = 181102,
  [SMALL_STATE(3649)] = 181132,
  [SMALL_STATE(3650)] = 181160,
  [SMALL_STATE(3651)] = 181188,
  [SMALL_STATE(3652)] = 181216,
  [SMALL_STATE(3653)] = 181244,
  [SMALL_STATE(3654)] = 181272,
  [SMALL_STATE(3655)] = 181300,
  [SMALL_STATE(3656)] = 181328,
  [SMALL_STATE(3657)] = 181356,
  [SMALL_STATE(3658)] = 181384,
  [SMALL_STATE(3659)] = 181412,
  [SMALL_STATE(3660)] = 181440,
  [SMALL_STATE(3661)] = 181468,
  [SMALL_STATE(3662)] = 181496,
  [SMALL_STATE(3663)] = 181524,
  [SMALL_STATE(3664)] = 181552,
  [SMALL_STATE(3665)] = 181580,
  [SMALL_STATE(3666)] = 181608,
  [SMALL_STATE(3667)] = 181636,
  [SMALL_STATE(3668)] = 181664,
  [SMALL_STATE(3669)] = 181692,
  [SMALL_STATE(3670)] = 181720,
  [SMALL_STATE(3671)] = 181748,
  [SMALL_STATE(3672)] = 181776,
  [SMALL_STATE(3673)] = 181804,
  [SMALL_STATE(3674)] = 181852,
  [SMALL_STATE(3675)] = 181880,
  [SMALL_STATE(3676)] = 181908,
  [SMALL_STATE(3677)] = 181938,
  [SMALL_STATE(3678)] = 181986,
  [SMALL_STATE(3679)] = 182016,
  [SMALL_STATE(3680)] = 182044,
  [SMALL_STATE(3681)] = 182072,
  [SMALL_STATE(3682)] = 182100,
  [SMALL_STATE(3683)] = 182128,
  [SMALL_STATE(3684)] = 182156,
  [SMALL_STATE(3685)] = 182184,
  [SMALL_STATE(3686)] = 182212,
  [SMALL_STATE(3687)] = 182240,
  [SMALL_STATE(3688)] = 182288,
  [SMALL_STATE(3689)] = 182316,
  [SMALL_STATE(3690)] = 182344,
  [SMALL_STATE(3691)] = 182392,
  [SMALL_STATE(3692)] = 182420,
  [SMALL_STATE(3693)] = 182448,
  [SMALL_STATE(3694)] = 182476,
  [SMALL_STATE(3695)] = 182504,
  [SMALL_STATE(3696)] = 182532,
  [SMALL_STATE(3697)] = 182560,
  [SMALL_STATE(3698)] = 182588,
  [SMALL_STATE(3699)] = 182618,
  [SMALL_STATE(3700)] = 182646,
  [SMALL_STATE(3701)] = 182674,
  [SMALL_STATE(3702)] = 182702,
  [SMALL_STATE(3703)] = 182730,
  [SMALL_STATE(3704)] = 182758,
  [SMALL_STATE(3705)] = 182786,
  [SMALL_STATE(3706)] = 182814,
  [SMALL_STATE(3707)] = 182842,
  [SMALL_STATE(3708)] = 182870,
  [SMALL_STATE(3709)] = 182918,
  [SMALL_STATE(3710)] = 182946,
  [SMALL_STATE(3711)] = 182974,
  [SMALL_STATE(3712)] = 183002,
  [SMALL_STATE(3713)] = 183030,
  [SMALL_STATE(3714)] = 183060,
  [SMALL_STATE(3715)] = 183088,
  [SMALL_STATE(3716)] = 183118,
  [SMALL_STATE(3717)] = 183146,
  [SMALL_STATE(3718)] = 183174,
  [SMALL_STATE(3719)] = 183222,
  [SMALL_STATE(3720)] = 183250,
  [SMALL_STATE(3721)] = 183278,
  [SMALL_STATE(3722)] = 183306,
  [SMALL_STATE(3723)] = 183334,
  [SMALL_STATE(3724)] = 183362,
  [SMALL_STATE(3725)] = 183410,
  [SMALL_STATE(3726)] = 183438,
  [SMALL_STATE(3727)] = 183466,
  [SMALL_STATE(3728)] = 183496,
  [SMALL_STATE(3729)] = 183523,
  [SMALL_STATE(3730)] = 183550,
  [SMALL_STATE(3731)] = 183577,
  [SMALL_STATE(3732)] = 183604,
  [SMALL_STATE(3733)] = 183631,
  [SMALL_STATE(3734)] = 183658,
  [SMALL_STATE(3735)] = 183685,
  [SMALL_STATE(3736)] = 183712,
  [SMALL_STATE(3737)] = 183739,
  [SMALL_STATE(3738)] = 183766,
  [SMALL_STATE(3739)] = 183793,
  [SMALL_STATE(3740)] = 183820,
  [SMALL_STATE(3741)] = 183847,
  [SMALL_STATE(3742)] = 183874,
  [SMALL_STATE(3743)] = 183901,
  [SMALL_STATE(3744)] = 183928,
  [SMALL_STATE(3745)] = 183955,
  [SMALL_STATE(3746)] = 183994,
  [SMALL_STATE(3747)] = 184021,
  [SMALL_STATE(3748)] = 184048,
  [SMALL_STATE(3749)] = 184075,
  [SMALL_STATE(3750)] = 184114,
  [SMALL_STATE(3751)] = 184141,
  [SMALL_STATE(3752)] = 184168,
  [SMALL_STATE(3753)] = 184195,
  [SMALL_STATE(3754)] = 184222,
  [SMALL_STATE(3755)] = 184249,
  [SMALL_STATE(3756)] = 184276,
  [SMALL_STATE(3757)] = 184303,
  [SMALL_STATE(3758)] = 184330,
  [SMALL_STATE(3759)] = 184357,
  [SMALL_STATE(3760)] = 184390,
  [SMALL_STATE(3761)] = 184417,
  [SMALL_STATE(3762)] = 184450,
  [SMALL_STATE(3763)] = 184477,
  [SMALL_STATE(3764)] = 184504,
  [SMALL_STATE(3765)] = 184531,
  [SMALL_STATE(3766)] = 184570,
  [SMALL_STATE(3767)] = 184603,
  [SMALL_STATE(3768)] = 184630,
  [SMALL_STATE(3769)] = 184657,
  [SMALL_STATE(3770)] = 184684,
  [SMALL_STATE(3771)] = 184711,
  [SMALL_STATE(3772)] = 184738,
  [SMALL_STATE(3773)] = 184765,
  [SMALL_STATE(3774)] = 184792,
  [SMALL_STATE(3775)] = 184819,
  [SMALL_STATE(3776)] = 184846,
  [SMALL_STATE(3777)] = 184873,
  [SMALL_STATE(3778)] = 184900,
  [SMALL_STATE(3779)] = 184927,
  [SMALL_STATE(3780)] = 184954,
  [SMALL_STATE(3781)] = 184983,
  [SMALL_STATE(3782)] = 185010,
  [SMALL_STATE(3783)] = 185037,
  [SMALL_STATE(3784)] = 185064,
  [SMALL_STATE(3785)] = 185091,
  [SMALL_STATE(3786)] = 185118,
  [SMALL_STATE(3787)] = 185145,
  [SMALL_STATE(3788)] = 185172,
  [SMALL_STATE(3789)] = 185199,
  [SMALL_STATE(3790)] = 185226,
  [SMALL_STATE(3791)] = 185253,
  [SMALL_STATE(3792)] = 185286,
  [SMALL_STATE(3793)] = 185313,
  [SMALL_STATE(3794)] = 185340,
  [SMALL_STATE(3795)] = 185367,
  [SMALL_STATE(3796)] = 185394,
  [SMALL_STATE(3797)] = 185421,
  [SMALL_STATE(3798)] = 185448,
  [SMALL_STATE(3799)] = 185475,
  [SMALL_STATE(3800)] = 185502,
  [SMALL_STATE(3801)] = 185541,
  [SMALL_STATE(3802)] = 185568,
  [SMALL_STATE(3803)] = 185595,
  [SMALL_STATE(3804)] = 185628,
  [SMALL_STATE(3805)] = 185667,
  [SMALL_STATE(3806)] = 185712,
  [SMALL_STATE(3807)] = 185739,
  [SMALL_STATE(3808)] = 185766,
  [SMALL_STATE(3809)] = 185799,
  [SMALL_STATE(3810)] = 185828,
  [SMALL_STATE(3811)] = 185855,
  [SMALL_STATE(3812)] = 185884,
  [SMALL_STATE(3813)] = 185911,
  [SMALL_STATE(3814)] = 185944,
  [SMALL_STATE(3815)] = 185971,
  [SMALL_STATE(3816)] = 186004,
  [SMALL_STATE(3817)] = 186037,
  [SMALL_STATE(3818)] = 186064,
  [SMALL_STATE(3819)] = 186091,
  [SMALL_STATE(3820)] = 186118,
  [SMALL_STATE(3821)] = 186145,
  [SMALL_STATE(3822)] = 186172,
  [SMALL_STATE(3823)] = 186205,
  [SMALL_STATE(3824)] = 186232,
  [SMALL_STATE(3825)] = 186259,
  [SMALL_STATE(3826)] = 186292,
  [SMALL_STATE(3827)] = 186325,
  [SMALL_STATE(3828)] = 186358,
  [SMALL_STATE(3829)] = 186385,
  [SMALL_STATE(3830)] = 186418,
  [SMALL_STATE(3831)] = 186451,
  [SMALL_STATE(3832)] = 186484,
  [SMALL_STATE(3833)] = 186517,
  [SMALL_STATE(3834)] = 186544,
  [SMALL_STATE(3835)] = 186577,
  [SMALL_STATE(3836)] = 186610,
  [SMALL_STATE(3837)] = 186637,
  [SMALL_STATE(3838)] = 186670,
  [SMALL_STATE(3839)] = 186703,
  [SMALL_STATE(3840)] = 186736,
  [SMALL_STATE(3841)] = 186765,
  [SMALL_STATE(3842)] = 186798,
  [SMALL_STATE(3843)] = 186825,
  [SMALL_STATE(3844)] = 186864,
  [SMALL_STATE(3845)] = 186897,
  [SMALL_STATE(3846)] = 186930,
  [SMALL_STATE(3847)] = 186959,
  [SMALL_STATE(3848)] = 186986,
  [SMALL_STATE(3849)] = 187019,
  [SMALL_STATE(3850)] = 187046,
  [SMALL_STATE(3851)] = 187079,
  [SMALL_STATE(3852)] = 187112,
  [SMALL_STATE(3853)] = 187145,
  [SMALL_STATE(3854)] = 187178,
  [SMALL_STATE(3855)] = 187211,
  [SMALL_STATE(3856)] = 187244,
  [SMALL_STATE(3857)] = 187277,
  [SMALL_STATE(3858)] = 187316,
  [SMALL_STATE(3859)] = 187343,
  [SMALL_STATE(3860)] = 187376,
  [SMALL_STATE(3861)] = 187403,
  [SMALL_STATE(3862)] = 187442,
  [SMALL_STATE(3863)] = 187475,
  [SMALL_STATE(3864)] = 187508,
  [SMALL_STATE(3865)] = 187541,
  [SMALL_STATE(3866)] = 187574,
  [SMALL_STATE(3867)] = 187601,
  [SMALL_STATE(3868)] = 187628,
  [SMALL_STATE(3869)] = 187655,
  [SMALL_STATE(3870)] = 187682,
  [SMALL_STATE(3871)] = 187709,
  [SMALL_STATE(3872)] = 187736,
  [SMALL_STATE(3873)] = 187769,
  [SMALL_STATE(3874)] = 187796,
  [SMALL_STATE(3875)] = 187827,
  [SMALL_STATE(3876)] = 187854,
  [SMALL_STATE(3877)] = 187881,
  [SMALL_STATE(3878)] = 187908,
  [SMALL_STATE(3879)] = 187941,
  [SMALL_STATE(3880)] = 187968,
  [SMALL_STATE(3881)] = 188001,
  [SMALL_STATE(3882)] = 188034,
  [SMALL_STATE(3883)] = 188061,
  [SMALL_STATE(3884)] = 188094,
  [SMALL_STATE(3885)] = 188127,
  [SMALL_STATE(3886)] = 188160,
  [SMALL_STATE(3887)] = 188193,
  [SMALL_STATE(3888)] = 188220,
  [SMALL_STATE(3889)] = 188247,
  [SMALL_STATE(3890)] = 188278,
  [SMALL_STATE(3891)] = 188305,
  [SMALL_STATE(3892)] = 188334,
  [SMALL_STATE(3893)] = 188361,
  [SMALL_STATE(3894)] = 188390,
  [SMALL_STATE(3895)] = 188417,
  [SMALL_STATE(3896)] = 188444,
  [SMALL_STATE(3897)] = 188477,
  [SMALL_STATE(3898)] = 188504,
  [SMALL_STATE(3899)] = 188531,
  [SMALL_STATE(3900)] = 188558,
  [SMALL_STATE(3901)] = 188591,
  [SMALL_STATE(3902)] = 188644,
  [SMALL_STATE(3903)] = 188677,
  [SMALL_STATE(3904)] = 188704,
  [SMALL_STATE(3905)] = 188737,
  [SMALL_STATE(3906)] = 188764,
  [SMALL_STATE(3907)] = 188791,
  [SMALL_STATE(3908)] = 188818,
  [SMALL_STATE(3909)] = 188845,
  [SMALL_STATE(3910)] = 188872,
  [SMALL_STATE(3911)] = 188905,
  [SMALL_STATE(3912)] = 188932,
  [SMALL_STATE(3913)] = 188959,
  [SMALL_STATE(3914)] = 188986,
  [SMALL_STATE(3915)] = 189019,
  [SMALL_STATE(3916)] = 189050,
  [SMALL_STATE(3917)] = 189083,
  [SMALL_STATE(3918)] = 189110,
  [SMALL_STATE(3919)] = 189143,
  [SMALL_STATE(3920)] = 189176,
  [SMALL_STATE(3921)] = 189209,
  [SMALL_STATE(3922)] = 189236,
  [SMALL_STATE(3923)] = 189263,
  [SMALL_STATE(3924)] = 189292,
  [SMALL_STATE(3925)] = 189325,
  [SMALL_STATE(3926)] = 189358,
  [SMALL_STATE(3927)] = 189391,
  [SMALL_STATE(3928)] = 189424,
  [SMALL_STATE(3929)] = 189457,
  [SMALL_STATE(3930)] = 189490,
  [SMALL_STATE(3931)] = 189523,
  [SMALL_STATE(3932)] = 189550,
  [SMALL_STATE(3933)] = 189577,
  [SMALL_STATE(3934)] = 189610,
  [SMALL_STATE(3935)] = 189643,
  [SMALL_STATE(3936)] = 189670,
  [SMALL_STATE(3937)] = 189703,
  [SMALL_STATE(3938)] = 189736,
  [SMALL_STATE(3939)] = 189769,
  [SMALL_STATE(3940)] = 189802,
  [SMALL_STATE(3941)] = 189829,
  [SMALL_STATE(3942)] = 189856,
  [SMALL_STATE(3943)] = 189883,
  [SMALL_STATE(3944)] = 189910,
  [SMALL_STATE(3945)] = 189937,
  [SMALL_STATE(3946)] = 189964,
  [SMALL_STATE(3947)] = 189991,
  [SMALL_STATE(3948)] = 190024,
  [SMALL_STATE(3949)] = 190057,
  [SMALL_STATE(3950)] = 190090,
  [SMALL_STATE(3951)] = 190123,
  [SMALL_STATE(3952)] = 190156,
  [SMALL_STATE(3953)] = 190189,
  [SMALL_STATE(3954)] = 190222,
  [SMALL_STATE(3955)] = 190249,
  [SMALL_STATE(3956)] = 190276,
  [SMALL_STATE(3957)] = 190303,
  [SMALL_STATE(3958)] = 190330,
  [SMALL_STATE(3959)] = 190357,
  [SMALL_STATE(3960)] = 190384,
  [SMALL_STATE(3961)] = 190417,
  [SMALL_STATE(3962)] = 190450,
  [SMALL_STATE(3963)] = 190477,
  [SMALL_STATE(3964)] = 190510,
  [SMALL_STATE(3965)] = 190543,
  [SMALL_STATE(3966)] = 190572,
  [SMALL_STATE(3967)] = 190605,
  [SMALL_STATE(3968)] = 190638,
  [SMALL_STATE(3969)] = 190665,
  [SMALL_STATE(3970)] = 190692,
  [SMALL_STATE(3971)] = 190719,
  [SMALL_STATE(3972)] = 190748,
  [SMALL_STATE(3973)] = 190781,
  [SMALL_STATE(3974)] = 190814,
  [SMALL_STATE(3975)] = 190847,
  [SMALL_STATE(3976)] = 190874,
  [SMALL_STATE(3977)] = 190905,
  [SMALL_STATE(3978)] = 190950,
  [SMALL_STATE(3979)] = 190977,
  [SMALL_STATE(3980)] = 191004,
  [SMALL_STATE(3981)] = 191033,
  [SMALL_STATE(3982)] = 191060,
  [SMALL_STATE(3983)] = 191087,
  [SMALL_STATE(3984)] = 191114,
  [SMALL_STATE(3985)] = 191143,
  [SMALL_STATE(3986)] = 191172,
  [SMALL_STATE(3987)] = 191201,
  [SMALL_STATE(3988)] = 191228,
  [SMALL_STATE(3989)] = 191255,
  [SMALL_STATE(3990)] = 191282,
  [SMALL_STATE(3991)] = 191309,
  [SMALL_STATE(3992)] = 191336,
  [SMALL_STATE(3993)] = 191363,
  [SMALL_STATE(3994)] = 191390,
  [SMALL_STATE(3995)] = 191417,
  [SMALL_STATE(3996)] = 191444,
  [SMALL_STATE(3997)] = 191471,
  [SMALL_STATE(3998)] = 191498,
  [SMALL_STATE(3999)] = 191527,
  [SMALL_STATE(4000)] = 191554,
  [SMALL_STATE(4001)] = 191581,
  [SMALL_STATE(4002)] = 191608,
  [SMALL_STATE(4003)] = 191635,
  [SMALL_STATE(4004)] = 191662,
  [SMALL_STATE(4005)] = 191691,
  [SMALL_STATE(4006)] = 191720,
  [SMALL_STATE(4007)] = 191747,
  [SMALL_STATE(4008)] = 191776,
  [SMALL_STATE(4009)] = 191803,
  [SMALL_STATE(4010)] = 191830,
  [SMALL_STATE(4011)] = 191857,
  [SMALL_STATE(4012)] = 191884,
  [SMALL_STATE(4013)] = 191911,
  [SMALL_STATE(4014)] = 191938,
  [SMALL_STATE(4015)] = 191965,
  [SMALL_STATE(4016)] = 191992,
  [SMALL_STATE(4017)] = 192019,
  [SMALL_STATE(4018)] = 192046,
  [SMALL_STATE(4019)] = 192073,
  [SMALL_STATE(4020)] = 192100,
  [SMALL_STATE(4021)] = 192127,
  [SMALL_STATE(4022)] = 192154,
  [SMALL_STATE(4023)] = 192181,
  [SMALL_STATE(4024)] = 192210,
  [SMALL_STATE(4025)] = 192237,
  [SMALL_STATE(4026)] = 192264,
  [SMALL_STATE(4027)] = 192291,
  [SMALL_STATE(4028)] = 192318,
  [SMALL_STATE(4029)] = 192345,
  [SMALL_STATE(4030)] = 192372,
  [SMALL_STATE(4031)] = 192399,
  [SMALL_STATE(4032)] = 192426,
  [SMALL_STATE(4033)] = 192453,
  [SMALL_STATE(4034)] = 192480,
  [SMALL_STATE(4035)] = 192507,
  [SMALL_STATE(4036)] = 192534,
  [SMALL_STATE(4037)] = 192561,
  [SMALL_STATE(4038)] = 192588,
  [SMALL_STATE(4039)] = 192615,
  [SMALL_STATE(4040)] = 192642,
  [SMALL_STATE(4041)] = 192669,
  [SMALL_STATE(4042)] = 192696,
  [SMALL_STATE(4043)] = 192723,
  [SMALL_STATE(4044)] = 192750,
  [SMALL_STATE(4045)] = 192777,
  [SMALL_STATE(4046)] = 192804,
  [SMALL_STATE(4047)] = 192831,
  [SMALL_STATE(4048)] = 192858,
  [SMALL_STATE(4049)] = 192885,
  [SMALL_STATE(4050)] = 192912,
  [SMALL_STATE(4051)] = 192939,
  [SMALL_STATE(4052)] = 192966,
  [SMALL_STATE(4053)] = 192993,
  [SMALL_STATE(4054)] = 193020,
  [SMALL_STATE(4055)] = 193047,
  [SMALL_STATE(4056)] = 193074,
  [SMALL_STATE(4057)] = 193101,
  [SMALL_STATE(4058)] = 193128,
  [SMALL_STATE(4059)] = 193155,
  [SMALL_STATE(4060)] = 193182,
  [SMALL_STATE(4061)] = 193209,
  [SMALL_STATE(4062)] = 193236,
  [SMALL_STATE(4063)] = 193263,
  [SMALL_STATE(4064)] = 193292,
  [SMALL_STATE(4065)] = 193319,
  [SMALL_STATE(4066)] = 193348,
  [SMALL_STATE(4067)] = 193375,
  [SMALL_STATE(4068)] = 193402,
  [SMALL_STATE(4069)] = 193441,
  [SMALL_STATE(4070)] = 193470,
  [SMALL_STATE(4071)] = 193497,
  [SMALL_STATE(4072)] = 193523,
  [SMALL_STATE(4073)] = 193565,
  [SMALL_STATE(4074)] = 193591,
  [SMALL_STATE(4075)] = 193617,
  [SMALL_STATE(4076)] = 193661,
  [SMALL_STATE(4077)] = 193687,
  [SMALL_STATE(4078)] = 193731,
  [SMALL_STATE(4079)] = 193757,
  [SMALL_STATE(4080)] = 193801,
  [SMALL_STATE(4081)] = 193845,
  [SMALL_STATE(4082)] = 193889,
  [SMALL_STATE(4083)] = 193933,
  [SMALL_STATE(4084)] = 193977,
  [SMALL_STATE(4085)] = 194003,
  [SMALL_STATE(4086)] = 194029,
  [SMALL_STATE(4087)] = 194055,
  [SMALL_STATE(4088)] = 194081,
  [SMALL_STATE(4089)] = 194107,
  [SMALL_STATE(4090)] = 194133,
  [SMALL_STATE(4091)] = 194159,
  [SMALL_STATE(4092)] = 194185,
  [SMALL_STATE(4093)] = 194211,
  [SMALL_STATE(4094)] = 194237,
  [SMALL_STATE(4095)] = 194263,
  [SMALL_STATE(4096)] = 194289,
  [SMALL_STATE(4097)] = 194315,
  [SMALL_STATE(4098)] = 194341,
  [SMALL_STATE(4099)] = 194367,
  [SMALL_STATE(4100)] = 194411,
  [SMALL_STATE(4101)] = 194455,
  [SMALL_STATE(4102)] = 194499,
  [SMALL_STATE(4103)] = 194543,
  [SMALL_STATE(4104)] = 194587,
  [SMALL_STATE(4105)] = 194613,
  [SMALL_STATE(4106)] = 194639,
  [SMALL_STATE(4107)] = 194665,
  [SMALL_STATE(4108)] = 194709,
  [SMALL_STATE(4109)] = 194735,
  [SMALL_STATE(4110)] = 194761,
  [SMALL_STATE(4111)] = 194787,
  [SMALL_STATE(4112)] = 194813,
  [SMALL_STATE(4113)] = 194839,
  [SMALL_STATE(4114)] = 194865,
  [SMALL_STATE(4115)] = 194891,
  [SMALL_STATE(4116)] = 194917,
  [SMALL_STATE(4117)] = 194943,
  [SMALL_STATE(4118)] = 194969,
  [SMALL_STATE(4119)] = 194995,
  [SMALL_STATE(4120)] = 195021,
  [SMALL_STATE(4121)] = 195047,
  [SMALL_STATE(4122)] = 195073,
  [SMALL_STATE(4123)] = 195099,
  [SMALL_STATE(4124)] = 195125,
  [SMALL_STATE(4125)] = 195151,
  [SMALL_STATE(4126)] = 195177,
  [SMALL_STATE(4127)] = 195203,
  [SMALL_STATE(4128)] = 195229,
  [SMALL_STATE(4129)] = 195255,
  [SMALL_STATE(4130)] = 195281,
  [SMALL_STATE(4131)] = 195325,
  [SMALL_STATE(4132)] = 195351,
  [SMALL_STATE(4133)] = 195377,
  [SMALL_STATE(4134)] = 195403,
  [SMALL_STATE(4135)] = 195429,
  [SMALL_STATE(4136)] = 195455,
  [SMALL_STATE(4137)] = 195481,
  [SMALL_STATE(4138)] = 195507,
  [SMALL_STATE(4139)] = 195533,
  [SMALL_STATE(4140)] = 195577,
  [SMALL_STATE(4141)] = 195603,
  [SMALL_STATE(4142)] = 195629,
  [SMALL_STATE(4143)] = 195655,
  [SMALL_STATE(4144)] = 195681,
  [SMALL_STATE(4145)] = 195707,
  [SMALL_STATE(4146)] = 195733,
  [SMALL_STATE(4147)] = 195771,
  [SMALL_STATE(4148)] = 195815,
  [SMALL_STATE(4149)] = 195859,
  [SMALL_STATE(4150)] = 195897,
  [SMALL_STATE(4151)] = 195945,
  [SMALL_STATE(4152)] = 195989,
  [SMALL_STATE(4153)] = 196033,
  [SMALL_STATE(4154)] = 196077,
  [SMALL_STATE(4155)] = 196121,
  [SMALL_STATE(4156)] = 196165,
  [SMALL_STATE(4157)] = 196191,
  [SMALL_STATE(4158)] = 196217,
  [SMALL_STATE(4159)] = 196243,
  [SMALL_STATE(4160)] = 196269,
  [SMALL_STATE(4161)] = 196295,
  [SMALL_STATE(4162)] = 196321,
  [SMALL_STATE(4163)] = 196347,
  [SMALL_STATE(4164)] = 196373,
  [SMALL_STATE(4165)] = 196399,
  [SMALL_STATE(4166)] = 196425,
  [SMALL_STATE(4167)] = 196451,
  [SMALL_STATE(4168)] = 196477,
  [SMALL_STATE(4169)] = 196503,
  [SMALL_STATE(4170)] = 196529,
  [SMALL_STATE(4171)] = 196555,
  [SMALL_STATE(4172)] = 196581,
  [SMALL_STATE(4173)] = 196607,
  [SMALL_STATE(4174)] = 196651,
  [SMALL_STATE(4175)] = 196695,
  [SMALL_STATE(4176)] = 196721,
  [SMALL_STATE(4177)] = 196747,
  [SMALL_STATE(4178)] = 196773,
  [SMALL_STATE(4179)] = 196799,
  [SMALL_STATE(4180)] = 196825,
  [SMALL_STATE(4181)] = 196851,
  [SMALL_STATE(4182)] = 196877,
  [SMALL_STATE(4183)] = 196921,
  [SMALL_STATE(4184)] = 196947,
  [SMALL_STATE(4185)] = 196973,
  [SMALL_STATE(4186)] = 196999,
  [SMALL_STATE(4187)] = 197025,
  [SMALL_STATE(4188)] = 197051,
  [SMALL_STATE(4189)] = 197077,
  [SMALL_STATE(4190)] = 197103,
  [SMALL_STATE(4191)] = 197129,
  [SMALL_STATE(4192)] = 197155,
  [SMALL_STATE(4193)] = 197181,
  [SMALL_STATE(4194)] = 197207,
  [SMALL_STATE(4195)] = 197233,
  [SMALL_STATE(4196)] = 197259,
  [SMALL_STATE(4197)] = 197285,
  [SMALL_STATE(4198)] = 197311,
  [SMALL_STATE(4199)] = 197355,
  [SMALL_STATE(4200)] = 197399,
  [SMALL_STATE(4201)] = 197443,
  [SMALL_STATE(4202)] = 197469,
  [SMALL_STATE(4203)] = 197513,
  [SMALL_STATE(4204)] = 197561,
  [SMALL_STATE(4205)] = 197587,
  [SMALL_STATE(4206)] = 197631,
  [SMALL_STATE(4207)] = 197675,
  [SMALL_STATE(4208)] = 197719,
  [SMALL_STATE(4209)] = 197745,
  [SMALL_STATE(4210)] = 197771,
  [SMALL_STATE(4211)] = 197797,
  [SMALL_STATE(4212)] = 197835,
  [SMALL_STATE(4213)] = 197861,
  [SMALL_STATE(4214)] = 197887,
  [SMALL_STATE(4215)] = 197915,
  [SMALL_STATE(4216)] = 197953,
  [SMALL_STATE(4217)] = 197979,
  [SMALL_STATE(4218)] = 198005,
  [SMALL_STATE(4219)] = 198031,
  [SMALL_STATE(4220)] = 198057,
  [SMALL_STATE(4221)] = 198085,
  [SMALL_STATE(4222)] = 198133,
  [SMALL_STATE(4223)] = 198181,
  [SMALL_STATE(4224)] = 198207,
  [SMALL_STATE(4225)] = 198255,
  [SMALL_STATE(4226)] = 198281,
  [SMALL_STATE(4227)] = 198307,
  [SMALL_STATE(4228)] = 198355,
  [SMALL_STATE(4229)] = 198381,
  [SMALL_STATE(4230)] = 198407,
  [SMALL_STATE(4231)] = 198433,
  [SMALL_STATE(4232)] = 198459,
  [SMALL_STATE(4233)] = 198485,
  [SMALL_STATE(4234)] = 198529,
  [SMALL_STATE(4235)] = 198555,
  [SMALL_STATE(4236)] = 198581,
  [SMALL_STATE(4237)] = 198609,
  [SMALL_STATE(4238)] = 198635,
  [SMALL_STATE(4239)] = 198661,
  [SMALL_STATE(4240)] = 198687,
  [SMALL_STATE(4241)] = 198713,
  [SMALL_STATE(4242)] = 198739,
  [SMALL_STATE(4243)] = 198765,
  [SMALL_STATE(4244)] = 198793,
  [SMALL_STATE(4245)] = 198819,
  [SMALL_STATE(4246)] = 198845,
  [SMALL_STATE(4247)] = 198871,
  [SMALL_STATE(4248)] = 198919,
  [SMALL_STATE(4249)] = 198945,
  [SMALL_STATE(4250)] = 198993,
  [SMALL_STATE(4251)] = 199019,
  [SMALL_STATE(4252)] = 199045,
  [SMALL_STATE(4253)] = 199071,
  [SMALL_STATE(4254)] = 199097,
  [SMALL_STATE(4255)] = 199123,
  [SMALL_STATE(4256)] = 199149,
  [SMALL_STATE(4257)] = 199175,
  [SMALL_STATE(4258)] = 199201,
  [SMALL_STATE(4259)] = 199227,
  [SMALL_STATE(4260)] = 199255,
  [SMALL_STATE(4261)] = 199281,
  [SMALL_STATE(4262)] = 199307,
  [SMALL_STATE(4263)] = 199333,
  [SMALL_STATE(4264)] = 199359,
  [SMALL_STATE(4265)] = 199385,
  [SMALL_STATE(4266)] = 199411,
  [SMALL_STATE(4267)] = 199437,
  [SMALL_STATE(4268)] = 199463,
  [SMALL_STATE(4269)] = 199489,
  [SMALL_STATE(4270)] = 199515,
  [SMALL_STATE(4271)] = 199541,
  [SMALL_STATE(4272)] = 199567,
  [SMALL_STATE(4273)] = 199605,
  [SMALL_STATE(4274)] = 199631,
  [SMALL_STATE(4275)] = 199657,
  [SMALL_STATE(4276)] = 199683,
  [SMALL_STATE(4277)] = 199709,
  [SMALL_STATE(4278)] = 199735,
  [SMALL_STATE(4279)] = 199761,
  [SMALL_STATE(4280)] = 199789,
  [SMALL_STATE(4281)] = 199815,
  [SMALL_STATE(4282)] = 199841,
  [SMALL_STATE(4283)] = 199867,
  [SMALL_STATE(4284)] = 199893,
  [SMALL_STATE(4285)] = 199919,
  [SMALL_STATE(4286)] = 199945,
  [SMALL_STATE(4287)] = 199971,
  [SMALL_STATE(4288)] = 199997,
  [SMALL_STATE(4289)] = 200023,
  [SMALL_STATE(4290)] = 200049,
  [SMALL_STATE(4291)] = 200087,
  [SMALL_STATE(4292)] = 200115,
  [SMALL_STATE(4293)] = 200141,
  [SMALL_STATE(4294)] = 200167,
  [SMALL_STATE(4295)] = 200193,
  [SMALL_STATE(4296)] = 200219,
  [SMALL_STATE(4297)] = 200245,
  [SMALL_STATE(4298)] = 200271,
  [SMALL_STATE(4299)] = 200297,
  [SMALL_STATE(4300)] = 200323,
  [SMALL_STATE(4301)] = 200349,
  [SMALL_STATE(4302)] = 200375,
  [SMALL_STATE(4303)] = 200401,
  [SMALL_STATE(4304)] = 200427,
  [SMALL_STATE(4305)] = 200453,
  [SMALL_STATE(4306)] = 200479,
  [SMALL_STATE(4307)] = 200505,
  [SMALL_STATE(4308)] = 200543,
  [SMALL_STATE(4309)] = 200581,
  [SMALL_STATE(4310)] = 200607,
  [SMALL_STATE(4311)] = 200635,
  [SMALL_STATE(4312)] = 200661,
  [SMALL_STATE(4313)] = 200687,
  [SMALL_STATE(4314)] = 200713,
  [SMALL_STATE(4315)] = 200751,
  [SMALL_STATE(4316)] = 200779,
  [SMALL_STATE(4317)] = 200817,
  [SMALL_STATE(4318)] = 200845,
  [SMALL_STATE(4319)] = 200873,
  [SMALL_STATE(4320)] = 200899,
  [SMALL_STATE(4321)] = 200937,
  [SMALL_STATE(4322)] = 200963,
  [SMALL_STATE(4323)] = 200989,
  [SMALL_STATE(4324)] = 201015,
  [SMALL_STATE(4325)] = 201041,
  [SMALL_STATE(4326)] = 201067,
  [SMALL_STATE(4327)] = 201109,
  [SMALL_STATE(4328)] = 201135,
  [SMALL_STATE(4329)] = 201161,
  [SMALL_STATE(4330)] = 201201,
  [SMALL_STATE(4331)] = 201227,
  [SMALL_STATE(4332)] = 201253,
  [SMALL_STATE(4333)] = 201279,
  [SMALL_STATE(4334)] = 201304,
  [SMALL_STATE(4335)] = 201329,
  [SMALL_STATE(4336)] = 201354,
  [SMALL_STATE(4337)] = 201381,
  [SMALL_STATE(4338)] = 201408,
  [SMALL_STATE(4339)] = 201445,
  [SMALL_STATE(4340)] = 201470,
  [SMALL_STATE(4341)] = 201497,
  [SMALL_STATE(4342)] = 201534,
  [SMALL_STATE(4343)] = 201571,
  [SMALL_STATE(4344)] = 201596,
  [SMALL_STATE(4345)] = 201625,
  [SMALL_STATE(4346)] = 201650,
  [SMALL_STATE(4347)] = 201675,
  [SMALL_STATE(4348)] = 201712,
  [SMALL_STATE(4349)] = 201739,
  [SMALL_STATE(4350)] = 201776,
  [SMALL_STATE(4351)] = 201803,
  [SMALL_STATE(4352)] = 201828,
  [SMALL_STATE(4353)] = 201853,
  [SMALL_STATE(4354)] = 201894,
  [SMALL_STATE(4355)] = 201933,
  [SMALL_STATE(4356)] = 201960,
  [SMALL_STATE(4357)] = 201999,
  [SMALL_STATE(4358)] = 202026,
  [SMALL_STATE(4359)] = 202053,
  [SMALL_STATE(4360)] = 202090,
  [SMALL_STATE(4361)] = 202117,
  [SMALL_STATE(4362)] = 202142,
  [SMALL_STATE(4363)] = 202167,
  [SMALL_STATE(4364)] = 202192,
  [SMALL_STATE(4365)] = 202225,
  [SMALL_STATE(4366)] = 202264,
  [SMALL_STATE(4367)] = 202289,
  [SMALL_STATE(4368)] = 202314,
  [SMALL_STATE(4369)] = 202339,
  [SMALL_STATE(4370)] = 202364,
  [SMALL_STATE(4371)] = 202403,
  [SMALL_STATE(4372)] = 202442,
  [SMALL_STATE(4373)] = 202481,
  [SMALL_STATE(4374)] = 202518,
  [SMALL_STATE(4375)] = 202543,
  [SMALL_STATE(4376)] = 202582,
  [SMALL_STATE(4377)] = 202615,
  [SMALL_STATE(4378)] = 202640,
  [SMALL_STATE(4379)] = 202667,
  [SMALL_STATE(4380)] = 202694,
  [SMALL_STATE(4381)] = 202719,
  [SMALL_STATE(4382)] = 202744,
  [SMALL_STATE(4383)] = 202769,
  [SMALL_STATE(4384)] = 202794,
  [SMALL_STATE(4385)] = 202819,
  [SMALL_STATE(4386)] = 202844,
  [SMALL_STATE(4387)] = 202869,
  [SMALL_STATE(4388)] = 202894,
  [SMALL_STATE(4389)] = 202919,
  [SMALL_STATE(4390)] = 202944,
  [SMALL_STATE(4391)] = 202969,
  [SMALL_STATE(4392)] = 202994,
  [SMALL_STATE(4393)] = 203019,
  [SMALL_STATE(4394)] = 203044,
  [SMALL_STATE(4395)] = 203069,
  [SMALL_STATE(4396)] = 203094,
  [SMALL_STATE(4397)] = 203119,
  [SMALL_STATE(4398)] = 203144,
  [SMALL_STATE(4399)] = 203169,
  [SMALL_STATE(4400)] = 203194,
  [SMALL_STATE(4401)] = 203219,
  [SMALL_STATE(4402)] = 203244,
  [SMALL_STATE(4403)] = 203269,
  [SMALL_STATE(4404)] = 203294,
  [SMALL_STATE(4405)] = 203319,
  [SMALL_STATE(4406)] = 203344,
  [SMALL_STATE(4407)] = 203369,
  [SMALL_STATE(4408)] = 203394,
  [SMALL_STATE(4409)] = 203419,
  [SMALL_STATE(4410)] = 203444,
  [SMALL_STATE(4411)] = 203469,
  [SMALL_STATE(4412)] = 203494,
  [SMALL_STATE(4413)] = 203519,
  [SMALL_STATE(4414)] = 203544,
  [SMALL_STATE(4415)] = 203569,
  [SMALL_STATE(4416)] = 203596,
  [SMALL_STATE(4417)] = 203621,
  [SMALL_STATE(4418)] = 203646,
  [SMALL_STATE(4419)] = 203671,
  [SMALL_STATE(4420)] = 203696,
  [SMALL_STATE(4421)] = 203721,
  [SMALL_STATE(4422)] = 203746,
  [SMALL_STATE(4423)] = 203771,
  [SMALL_STATE(4424)] = 203796,
  [SMALL_STATE(4425)] = 203821,
  [SMALL_STATE(4426)] = 203846,
  [SMALL_STATE(4427)] = 203871,
  [SMALL_STATE(4428)] = 203896,
  [SMALL_STATE(4429)] = 203921,
  [SMALL_STATE(4430)] = 203962,
  [SMALL_STATE(4431)] = 203987,
  [SMALL_STATE(4432)] = 204012,
  [SMALL_STATE(4433)] = 204037,
  [SMALL_STATE(4434)] = 204076,
  [SMALL_STATE(4435)] = 204113,
  [SMALL_STATE(4436)] = 204138,
  [SMALL_STATE(4437)] = 204165,
  [SMALL_STATE(4438)] = 204190,
  [SMALL_STATE(4439)] = 204227,
  [SMALL_STATE(4440)] = 204252,
  [SMALL_STATE(4441)] = 204289,
  [SMALL_STATE(4442)] = 204316,
  [SMALL_STATE(4443)] = 204353,
  [SMALL_STATE(4444)] = 204390,
  [SMALL_STATE(4445)] = 204427,
  [SMALL_STATE(4446)] = 204452,
  [SMALL_STATE(4447)] = 204491,
  [SMALL_STATE(4448)] = 204516,
  [SMALL_STATE(4449)] = 204541,
  [SMALL_STATE(4450)] = 204566,
  [SMALL_STATE(4451)] = 204603,
  [SMALL_STATE(4452)] = 204628,
  [SMALL_STATE(4453)] = 204653,
  [SMALL_STATE(4454)] = 204678,
  [SMALL_STATE(4455)] = 204703,
  [SMALL_STATE(4456)] = 204728,
  [SMALL_STATE(4457)] = 204753,
  [SMALL_STATE(4458)] = 204778,
  [SMALL_STATE(4459)] = 204815,
  [SMALL_STATE(4460)] = 204840,
  [SMALL_STATE(4461)] = 204865,
  [SMALL_STATE(4462)] = 204890,
  [SMALL_STATE(4463)] = 204915,
  [SMALL_STATE(4464)] = 204940,
  [SMALL_STATE(4465)] = 204965,
  [SMALL_STATE(4466)] = 204992,
  [SMALL_STATE(4467)] = 205017,
  [SMALL_STATE(4468)] = 205042,
  [SMALL_STATE(4469)] = 205067,
  [SMALL_STATE(4470)] = 205092,
  [SMALL_STATE(4471)] = 205117,
  [SMALL_STATE(4472)] = 205142,
  [SMALL_STATE(4473)] = 205169,
  [SMALL_STATE(4474)] = 205194,
  [SMALL_STATE(4475)] = 205219,
  [SMALL_STATE(4476)] = 205246,
  [SMALL_STATE(4477)] = 205271,
  [SMALL_STATE(4478)] = 205296,
  [SMALL_STATE(4479)] = 205323,
  [SMALL_STATE(4480)] = 205360,
  [SMALL_STATE(4481)] = 205385,
  [SMALL_STATE(4482)] = 205410,
  [SMALL_STATE(4483)] = 205434,
  [SMALL_STATE(4484)] = 205458,
  [SMALL_STATE(4485)] = 205496,
  [SMALL_STATE(4486)] = 205520,
  [SMALL_STATE(4487)] = 205544,
  [SMALL_STATE(4488)] = 205568,
  [SMALL_STATE(4489)] = 205594,
  [SMALL_STATE(4490)] = 205622,
  [SMALL_STATE(4491)] = 205646,
  [SMALL_STATE(4492)] = 205672,
  [SMALL_STATE(4493)] = 205696,
  [SMALL_STATE(4494)] = 205720,
  [SMALL_STATE(4495)] = 205748,
  [SMALL_STATE(4496)] = 205786,
  [SMALL_STATE(4497)] = 205824,
  [SMALL_STATE(4498)] = 205848,
  [SMALL_STATE(4499)] = 205876,
  [SMALL_STATE(4500)] = 205900,
  [SMALL_STATE(4501)] = 205924,
  [SMALL_STATE(4502)] = 205948,
  [SMALL_STATE(4503)] = 205972,
  [SMALL_STATE(4504)] = 205996,
  [SMALL_STATE(4505)] = 206020,
  [SMALL_STATE(4506)] = 206044,
  [SMALL_STATE(4507)] = 206068,
  [SMALL_STATE(4508)] = 206106,
  [SMALL_STATE(4509)] = 206130,
  [SMALL_STATE(4510)] = 206154,
  [SMALL_STATE(4511)] = 206178,
  [SMALL_STATE(4512)] = 206202,
  [SMALL_STATE(4513)] = 206226,
  [SMALL_STATE(4514)] = 206262,
  [SMALL_STATE(4515)] = 206292,
  [SMALL_STATE(4516)] = 206330,
  [SMALL_STATE(4517)] = 206366,
  [SMALL_STATE(4518)] = 206390,
  [SMALL_STATE(4519)] = 206414,
  [SMALL_STATE(4520)] = 206448,
  [SMALL_STATE(4521)] = 206484,
  [SMALL_STATE(4522)] = 206522,
  [SMALL_STATE(4523)] = 206546,
  [SMALL_STATE(4524)] = 206570,
  [SMALL_STATE(4525)] = 206598,
  [SMALL_STATE(4526)] = 206626,
  [SMALL_STATE(4527)] = 206662,
  [SMALL_STATE(4528)] = 206686,
  [SMALL_STATE(4529)] = 206716,
  [SMALL_STATE(4530)] = 206740,
  [SMALL_STATE(4531)] = 206764,
  [SMALL_STATE(4532)] = 206788,
  [SMALL_STATE(4533)] = 206818,
  [SMALL_STATE(4534)] = 206848,
  [SMALL_STATE(4535)] = 206872,
  [SMALL_STATE(4536)] = 206896,
  [SMALL_STATE(4537)] = 206932,
  [SMALL_STATE(4538)] = 206956,
  [SMALL_STATE(4539)] = 206980,
  [SMALL_STATE(4540)] = 207008,
  [SMALL_STATE(4541)] = 207032,
  [SMALL_STATE(4542)] = 207056,
  [SMALL_STATE(4543)] = 207080,
  [SMALL_STATE(4544)] = 207110,
  [SMALL_STATE(4545)] = 207134,
  [SMALL_STATE(4546)] = 207164,
  [SMALL_STATE(4547)] = 207188,
  [SMALL_STATE(4548)] = 207212,
  [SMALL_STATE(4549)] = 207242,
  [SMALL_STATE(4550)] = 207268,
  [SMALL_STATE(4551)] = 207292,
  [SMALL_STATE(4552)] = 207316,
  [SMALL_STATE(4553)] = 207340,
  [SMALL_STATE(4554)] = 207366,
  [SMALL_STATE(4555)] = 207390,
  [SMALL_STATE(4556)] = 207428,
  [SMALL_STATE(4557)] = 207466,
  [SMALL_STATE(4558)] = 207490,
  [SMALL_STATE(4559)] = 207514,
  [SMALL_STATE(4560)] = 207538,
  [SMALL_STATE(4561)] = 207562,
  [SMALL_STATE(4562)] = 207586,
  [SMALL_STATE(4563)] = 207610,
  [SMALL_STATE(4564)] = 207644,
  [SMALL_STATE(4565)] = 207668,
  [SMALL_STATE(4566)] = 207692,
  [SMALL_STATE(4567)] = 207716,
  [SMALL_STATE(4568)] = 207740,
  [SMALL_STATE(4569)] = 207764,
  [SMALL_STATE(4570)] = 207788,
  [SMALL_STATE(4571)] = 207826,
  [SMALL_STATE(4572)] = 207850,
  [SMALL_STATE(4573)] = 207874,
  [SMALL_STATE(4574)] = 207912,
  [SMALL_STATE(4575)] = 207936,
  [SMALL_STATE(4576)] = 207964,
  [SMALL_STATE(4577)] = 207988,
  [SMALL_STATE(4578)] = 208012,
  [SMALL_STATE(4579)] = 208036,
  [SMALL_STATE(4580)] = 208060,
  [SMALL_STATE(4581)] = 208084,
  [SMALL_STATE(4582)] = 208108,
  [SMALL_STATE(4583)] = 208146,
  [SMALL_STATE(4584)] = 208172,
  [SMALL_STATE(4585)] = 208196,
  [SMALL_STATE(4586)] = 208234,
  [SMALL_STATE(4587)] = 208262,
  [SMALL_STATE(4588)] = 208286,
  [SMALL_STATE(4589)] = 208310,
  [SMALL_STATE(4590)] = 208334,
  [SMALL_STATE(4591)] = 208358,
  [SMALL_STATE(4592)] = 208382,
  [SMALL_STATE(4593)] = 208406,
  [SMALL_STATE(4594)] = 208432,
  [SMALL_STATE(4595)] = 208470,
  [SMALL_STATE(4596)] = 208494,
  [SMALL_STATE(4597)] = 208518,
  [SMALL_STATE(4598)] = 208542,
  [SMALL_STATE(4599)] = 208566,
  [SMALL_STATE(4600)] = 208596,
  [SMALL_STATE(4601)] = 208620,
  [SMALL_STATE(4602)] = 208644,
  [SMALL_STATE(4603)] = 208668,
  [SMALL_STATE(4604)] = 208692,
  [SMALL_STATE(4605)] = 208716,
  [SMALL_STATE(4606)] = 208740,
  [SMALL_STATE(4607)] = 208764,
  [SMALL_STATE(4608)] = 208802,
  [SMALL_STATE(4609)] = 208826,
  [SMALL_STATE(4610)] = 208850,
  [SMALL_STATE(4611)] = 208874,
  [SMALL_STATE(4612)] = 208908,
  [SMALL_STATE(4613)] = 208946,
  [SMALL_STATE(4614)] = 208984,
  [SMALL_STATE(4615)] = 209020,
  [SMALL_STATE(4616)] = 209046,
  [SMALL_STATE(4617)] = 209070,
  [SMALL_STATE(4618)] = 209108,
  [SMALL_STATE(4619)] = 209144,
  [SMALL_STATE(4620)] = 209168,
  [SMALL_STATE(4621)] = 209202,
  [SMALL_STATE(4622)] = 209226,
  [SMALL_STATE(4623)] = 209250,
  [SMALL_STATE(4624)] = 209288,
  [SMALL_STATE(4625)] = 209312,
  [SMALL_STATE(4626)] = 209336,
  [SMALL_STATE(4627)] = 209360,
  [SMALL_STATE(4628)] = 209398,
  [SMALL_STATE(4629)] = 209436,
  [SMALL_STATE(4630)] = 209464,
  [SMALL_STATE(4631)] = 209488,
  [SMALL_STATE(4632)] = 209512,
  [SMALL_STATE(4633)] = 209550,
  [SMALL_STATE(4634)] = 209588,
  [SMALL_STATE(4635)] = 209612,
  [SMALL_STATE(4636)] = 209636,
  [SMALL_STATE(4637)] = 209662,
  [SMALL_STATE(4638)] = 209688,
  [SMALL_STATE(4639)] = 209712,
  [SMALL_STATE(4640)] = 209750,
  [SMALL_STATE(4641)] = 209780,
  [SMALL_STATE(4642)] = 209806,
  [SMALL_STATE(4643)] = 209830,
  [SMALL_STATE(4644)] = 209868,
  [SMALL_STATE(4645)] = 209892,
  [SMALL_STATE(4646)] = 209916,
  [SMALL_STATE(4647)] = 209940,
  [SMALL_STATE(4648)] = 209976,
  [SMALL_STATE(4649)] = 210000,
  [SMALL_STATE(4650)] = 210038,
  [SMALL_STATE(4651)] = 210062,
  [SMALL_STATE(4652)] = 210086,
  [SMALL_STATE(4653)] = 210110,
  [SMALL_STATE(4654)] = 210148,
  [SMALL_STATE(4655)] = 210172,
  [SMALL_STATE(4656)] = 210210,
  [SMALL_STATE(4657)] = 210236,
  [SMALL_STATE(4658)] = 210274,
  [SMALL_STATE(4659)] = 210310,
  [SMALL_STATE(4660)] = 210334,
  [SMALL_STATE(4661)] = 210358,
  [SMALL_STATE(4662)] = 210382,
  [SMALL_STATE(4663)] = 210406,
  [SMALL_STATE(4664)] = 210430,
  [SMALL_STATE(4665)] = 210454,
  [SMALL_STATE(4666)] = 210478,
  [SMALL_STATE(4667)] = 210502,
  [SMALL_STATE(4668)] = 210526,
  [SMALL_STATE(4669)] = 210550,
  [SMALL_STATE(4670)] = 210574,
  [SMALL_STATE(4671)] = 210598,
  [SMALL_STATE(4672)] = 210632,
  [SMALL_STATE(4673)] = 210656,
  [SMALL_STATE(4674)] = 210680,
  [SMALL_STATE(4675)] = 210718,
  [SMALL_STATE(4676)] = 210742,
  [SMALL_STATE(4677)] = 210766,
  [SMALL_STATE(4678)] = 210790,
  [SMALL_STATE(4679)] = 210814,
  [SMALL_STATE(4680)] = 210838,
  [SMALL_STATE(4681)] = 210862,
  [SMALL_STATE(4682)] = 210886,
  [SMALL_STATE(4683)] = 210912,
  [SMALL_STATE(4684)] = 210936,
  [SMALL_STATE(4685)] = 210960,
  [SMALL_STATE(4686)] = 210984,
  [SMALL_STATE(4687)] = 211008,
  [SMALL_STATE(4688)] = 211032,
  [SMALL_STATE(4689)] = 211056,
  [SMALL_STATE(4690)] = 211080,
  [SMALL_STATE(4691)] = 211104,
  [SMALL_STATE(4692)] = 211128,
  [SMALL_STATE(4693)] = 211152,
  [SMALL_STATE(4694)] = 211176,
  [SMALL_STATE(4695)] = 211214,
  [SMALL_STATE(4696)] = 211238,
  [SMALL_STATE(4697)] = 211262,
  [SMALL_STATE(4698)] = 211286,
  [SMALL_STATE(4699)] = 211322,
  [SMALL_STATE(4700)] = 211346,
  [SMALL_STATE(4701)] = 211380,
  [SMALL_STATE(4702)] = 211404,
  [SMALL_STATE(4703)] = 211428,
  [SMALL_STATE(4704)] = 211454,
  [SMALL_STATE(4705)] = 211492,
  [SMALL_STATE(4706)] = 211530,
  [SMALL_STATE(4707)] = 211554,
  [SMALL_STATE(4708)] = 211578,
  [SMALL_STATE(4709)] = 211616,
  [SMALL_STATE(4710)] = 211654,
  [SMALL_STATE(4711)] = 211678,
  [SMALL_STATE(4712)] = 211701,
  [SMALL_STATE(4713)] = 211724,
  [SMALL_STATE(4714)] = 211747,
  [SMALL_STATE(4715)] = 211770,
  [SMALL_STATE(4716)] = 211793,
  [SMALL_STATE(4717)] = 211816,
  [SMALL_STATE(4718)] = 211855,
  [SMALL_STATE(4719)] = 211878,
  [SMALL_STATE(4720)] = 211901,
  [SMALL_STATE(4721)] = 211924,
  [SMALL_STATE(4722)] = 211947,
  [SMALL_STATE(4723)] = 211970,
  [SMALL_STATE(4724)] = 211993,
  [SMALL_STATE(4725)] = 212028,
  [SMALL_STATE(4726)] = 212051,
  [SMALL_STATE(4727)] = 212078,
  [SMALL_STATE(4728)] = 212115,
  [SMALL_STATE(4729)] = 212142,
  [SMALL_STATE(4730)] = 212177,
  [SMALL_STATE(4731)] = 212200,
  [SMALL_STATE(4732)] = 212235,
  [SMALL_STATE(4733)] = 212258,
  [SMALL_STATE(4734)] = 212293,
  [SMALL_STATE(4735)] = 212320,
  [SMALL_STATE(4736)] = 212355,
  [SMALL_STATE(4737)] = 212384,
  [SMALL_STATE(4738)] = 212407,
  [SMALL_STATE(4739)] = 212430,
  [SMALL_STATE(4740)] = 212453,
  [SMALL_STATE(4741)] = 212476,
  [SMALL_STATE(4742)] = 212511,
  [SMALL_STATE(4743)] = 212546,
  [SMALL_STATE(4744)] = 212569,
  [SMALL_STATE(4745)] = 212604,
  [SMALL_STATE(4746)] = 212627,
  [SMALL_STATE(4747)] = 212662,
  [SMALL_STATE(4748)] = 212695,
  [SMALL_STATE(4749)] = 212718,
  [SMALL_STATE(4750)] = 212747,
  [SMALL_STATE(4751)] = 212770,
  [SMALL_STATE(4752)] = 212807,
  [SMALL_STATE(4753)] = 212830,
  [SMALL_STATE(4754)] = 212859,
  [SMALL_STATE(4755)] = 212882,
  [SMALL_STATE(4756)] = 212905,
  [SMALL_STATE(4757)] = 212934,
  [SMALL_STATE(4758)] = 212961,
  [SMALL_STATE(4759)] = 212988,
  [SMALL_STATE(4760)] = 213011,
  [SMALL_STATE(4761)] = 213034,
  [SMALL_STATE(4762)] = 213069,
  [SMALL_STATE(4763)] = 213104,
  [SMALL_STATE(4764)] = 213127,
  [SMALL_STATE(4765)] = 213150,
  [SMALL_STATE(4766)] = 213185,
  [SMALL_STATE(4767)] = 213212,
  [SMALL_STATE(4768)] = 213235,
  [SMALL_STATE(4769)] = 213258,
  [SMALL_STATE(4770)] = 213293,
  [SMALL_STATE(4771)] = 213316,
  [SMALL_STATE(4772)] = 213351,
  [SMALL_STATE(4773)] = 213374,
  [SMALL_STATE(4774)] = 213409,
  [SMALL_STATE(4775)] = 213432,
  [SMALL_STATE(4776)] = 213471,
  [SMALL_STATE(4777)] = 213494,
  [SMALL_STATE(4778)] = 213517,
  [SMALL_STATE(4779)] = 213540,
  [SMALL_STATE(4780)] = 213563,
  [SMALL_STATE(4781)] = 213586,
  [SMALL_STATE(4782)] = 213609,
  [SMALL_STATE(4783)] = 213648,
  [SMALL_STATE(4784)] = 213675,
  [SMALL_STATE(4785)] = 213700,
  [SMALL_STATE(4786)] = 213735,
  [SMALL_STATE(4787)] = 213758,
  [SMALL_STATE(4788)] = 213781,
  [SMALL_STATE(4789)] = 213804,
  [SMALL_STATE(4790)] = 213827,
  [SMALL_STATE(4791)] = 213850,
  [SMALL_STATE(4792)] = 213873,
  [SMALL_STATE(4793)] = 213896,
  [SMALL_STATE(4794)] = 213919,
  [SMALL_STATE(4795)] = 213946,
  [SMALL_STATE(4796)] = 213969,
  [SMALL_STATE(4797)] = 213992,
  [SMALL_STATE(4798)] = 214015,
  [SMALL_STATE(4799)] = 214038,
  [SMALL_STATE(4800)] = 214061,
  [SMALL_STATE(4801)] = 214084,
  [SMALL_STATE(4802)] = 214107,
  [SMALL_STATE(4803)] = 214130,
  [SMALL_STATE(4804)] = 214153,
  [SMALL_STATE(4805)] = 214188,
  [SMALL_STATE(4806)] = 214211,
  [SMALL_STATE(4807)] = 214234,
  [SMALL_STATE(4808)] = 214273,
  [SMALL_STATE(4809)] = 214300,
  [SMALL_STATE(4810)] = 214323,
  [SMALL_STATE(4811)] = 214346,
  [SMALL_STATE(4812)] = 214383,
  [SMALL_STATE(4813)] = 214406,
  [SMALL_STATE(4814)] = 214429,
  [SMALL_STATE(4815)] = 214464,
  [SMALL_STATE(4816)] = 214487,
  [SMALL_STATE(4817)] = 214510,
  [SMALL_STATE(4818)] = 214533,
  [SMALL_STATE(4819)] = 214556,
  [SMALL_STATE(4820)] = 214579,
  [SMALL_STATE(4821)] = 214602,
  [SMALL_STATE(4822)] = 214629,
  [SMALL_STATE(4823)] = 214664,
  [SMALL_STATE(4824)] = 214699,
  [SMALL_STATE(4825)] = 214736,
  [SMALL_STATE(4826)] = 214759,
  [SMALL_STATE(4827)] = 214782,
  [SMALL_STATE(4828)] = 214805,
  [SMALL_STATE(4829)] = 214828,
  [SMALL_STATE(4830)] = 214863,
  [SMALL_STATE(4831)] = 214886,
  [SMALL_STATE(4832)] = 214925,
  [SMALL_STATE(4833)] = 214948,
  [SMALL_STATE(4834)] = 214975,
  [SMALL_STATE(4835)] = 215000,
  [SMALL_STATE(4836)] = 215023,
  [SMALL_STATE(4837)] = 215046,
  [SMALL_STATE(4838)] = 215069,
  [SMALL_STATE(4839)] = 215092,
  [SMALL_STATE(4840)] = 215115,
  [SMALL_STATE(4841)] = 215138,
  [SMALL_STATE(4842)] = 215165,
  [SMALL_STATE(4843)] = 215188,
  [SMALL_STATE(4844)] = 215211,
  [SMALL_STATE(4845)] = 215234,
  [SMALL_STATE(4846)] = 215257,
  [SMALL_STATE(4847)] = 215294,
  [SMALL_STATE(4848)] = 215331,
  [SMALL_STATE(4849)] = 215354,
  [SMALL_STATE(4850)] = 215391,
  [SMALL_STATE(4851)] = 215420,
  [SMALL_STATE(4852)] = 215443,
  [SMALL_STATE(4853)] = 215472,
  [SMALL_STATE(4854)] = 215511,
  [SMALL_STATE(4855)] = 215534,
  [SMALL_STATE(4856)] = 215573,
  [SMALL_STATE(4857)] = 215596,
  [SMALL_STATE(4858)] = 215619,
  [SMALL_STATE(4859)] = 215656,
  [SMALL_STATE(4860)] = 215679,
  [SMALL_STATE(4861)] = 215708,
  [SMALL_STATE(4862)] = 215731,
  [SMALL_STATE(4863)] = 215760,
  [SMALL_STATE(4864)] = 215795,
  [SMALL_STATE(4865)] = 215818,
  [SMALL_STATE(4866)] = 215841,
  [SMALL_STATE(4867)] = 215864,
  [SMALL_STATE(4868)] = 215891,
  [SMALL_STATE(4869)] = 215920,
  [SMALL_STATE(4870)] = 215943,
  [SMALL_STATE(4871)] = 215982,
  [SMALL_STATE(4872)] = 216021,
  [SMALL_STATE(4873)] = 216044,
  [SMALL_STATE(4874)] = 216087,
  [SMALL_STATE(4875)] = 216110,
  [SMALL_STATE(4876)] = 216133,
  [SMALL_STATE(4877)] = 216156,
  [SMALL_STATE(4878)] = 216179,
  [SMALL_STATE(4879)] = 216214,
  [SMALL_STATE(4880)] = 216237,
  [SMALL_STATE(4881)] = 216260,
  [SMALL_STATE(4882)] = 216283,
  [SMALL_STATE(4883)] = 216306,
  [SMALL_STATE(4884)] = 216335,
  [SMALL_STATE(4885)] = 216358,
  [SMALL_STATE(4886)] = 216381,
  [SMALL_STATE(4887)] = 216408,
  [SMALL_STATE(4888)] = 216451,
  [SMALL_STATE(4889)] = 216488,
  [SMALL_STATE(4890)] = 216511,
  [SMALL_STATE(4891)] = 216534,
  [SMALL_STATE(4892)] = 216569,
  [SMALL_STATE(4893)] = 216592,
  [SMALL_STATE(4894)] = 216615,
  [SMALL_STATE(4895)] = 216638,
  [SMALL_STATE(4896)] = 216661,
  [SMALL_STATE(4897)] = 216688,
  [SMALL_STATE(4898)] = 216711,
  [SMALL_STATE(4899)] = 216734,
  [SMALL_STATE(4900)] = 216757,
  [SMALL_STATE(4901)] = 216780,
  [SMALL_STATE(4902)] = 216815,
  [SMALL_STATE(4903)] = 216838,
  [SMALL_STATE(4904)] = 216861,
  [SMALL_STATE(4905)] = 216884,
  [SMALL_STATE(4906)] = 216907,
  [SMALL_STATE(4907)] = 216946,
  [SMALL_STATE(4908)] = 216983,
  [SMALL_STATE(4909)] = 217012,
  [SMALL_STATE(4910)] = 217035,
  [SMALL_STATE(4911)] = 217070,
  [SMALL_STATE(4912)] = 217093,
  [SMALL_STATE(4913)] = 217116,
  [SMALL_STATE(4914)] = 217139,
  [SMALL_STATE(4915)] = 217168,
  [SMALL_STATE(4916)] = 217191,
  [SMALL_STATE(4917)] = 217214,
  [SMALL_STATE(4918)] = 217237,
  [SMALL_STATE(4919)] = 217260,
  [SMALL_STATE(4920)] = 217283,
  [SMALL_STATE(4921)] = 217306,
  [SMALL_STATE(4922)] = 217329,
  [SMALL_STATE(4923)] = 217352,
  [SMALL_STATE(4924)] = 217375,
  [SMALL_STATE(4925)] = 217398,
  [SMALL_STATE(4926)] = 217422,
  [SMALL_STATE(4927)] = 217448,
  [SMALL_STATE(4928)] = 217482,
  [SMALL_STATE(4929)] = 217524,
  [SMALL_STATE(4930)] = 217552,
  [SMALL_STATE(4931)] = 217584,
  [SMALL_STATE(4932)] = 217608,
  [SMALL_STATE(4933)] = 217634,
  [SMALL_STATE(4934)] = 217662,
  [SMALL_STATE(4935)] = 217684,
  [SMALL_STATE(4936)] = 217710,
  [SMALL_STATE(4937)] = 217746,
  [SMALL_STATE(4938)] = 217770,
  [SMALL_STATE(4939)] = 217792,
  [SMALL_STATE(4940)] = 217816,
  [SMALL_STATE(4941)] = 217838,
  [SMALL_STATE(4942)] = 217860,
  [SMALL_STATE(4943)] = 217888,
  [SMALL_STATE(4944)] = 217910,
  [SMALL_STATE(4945)] = 217932,
  [SMALL_STATE(4946)] = 217960,
  [SMALL_STATE(4947)] = 217988,
  [SMALL_STATE(4948)] = 218014,
  [SMALL_STATE(4949)] = 218052,
  [SMALL_STATE(4950)] = 218074,
  [SMALL_STATE(4951)] = 218102,
  [SMALL_STATE(4952)] = 218124,
  [SMALL_STATE(4953)] = 218148,
  [SMALL_STATE(4954)] = 218180,
  [SMALL_STATE(4955)] = 218204,
  [SMALL_STATE(4956)] = 218230,
  [SMALL_STATE(4957)] = 218252,
  [SMALL_STATE(4958)] = 218278,
  [SMALL_STATE(4959)] = 218306,
  [SMALL_STATE(4960)] = 218340,
  [SMALL_STATE(4961)] = 218364,
  [SMALL_STATE(4962)] = 218390,
  [SMALL_STATE(4963)] = 218414,
  [SMALL_STATE(4964)] = 218440,
  [SMALL_STATE(4965)] = 218466,
  [SMALL_STATE(4966)] = 218504,
  [SMALL_STATE(4967)] = 218536,
  [SMALL_STATE(4968)] = 218558,
  [SMALL_STATE(4969)] = 218580,
  [SMALL_STATE(4970)] = 218602,
  [SMALL_STATE(4971)] = 218626,
  [SMALL_STATE(4972)] = 218648,
  [SMALL_STATE(4973)] = 218670,
  [SMALL_STATE(4974)] = 218704,
  [SMALL_STATE(4975)] = 218728,
  [SMALL_STATE(4976)] = 218750,
  [SMALL_STATE(4977)] = 218782,
  [SMALL_STATE(4978)] = 218804,
  [SMALL_STATE(4979)] = 218826,
  [SMALL_STATE(4980)] = 218850,
  [SMALL_STATE(4981)] = 218874,
  [SMALL_STATE(4982)] = 218900,
  [SMALL_STATE(4983)] = 218924,
  [SMALL_STATE(4984)] = 218946,
  [SMALL_STATE(4985)] = 218982,
  [SMALL_STATE(4986)] = 219010,
  [SMALL_STATE(4987)] = 219032,
  [SMALL_STATE(4988)] = 219074,
  [SMALL_STATE(4989)] = 219102,
  [SMALL_STATE(4990)] = 219126,
  [SMALL_STATE(4991)] = 219150,
  [SMALL_STATE(4992)] = 219174,
  [SMALL_STATE(4993)] = 219198,
  [SMALL_STATE(4994)] = 219220,
  [SMALL_STATE(4995)] = 219246,
  [SMALL_STATE(4996)] = 219272,
  [SMALL_STATE(4997)] = 219294,
  [SMALL_STATE(4998)] = 219320,
  [SMALL_STATE(4999)] = 219344,
  [SMALL_STATE(5000)] = 219366,
  [SMALL_STATE(5001)] = 219392,
  [SMALL_STATE(5002)] = 219414,
  [SMALL_STATE(5003)] = 219440,
  [SMALL_STATE(5004)] = 219462,
  [SMALL_STATE(5005)] = 219484,
  [SMALL_STATE(5006)] = 219510,
  [SMALL_STATE(5007)] = 219542,
  [SMALL_STATE(5008)] = 219564,
  [SMALL_STATE(5009)] = 219586,
  [SMALL_STATE(5010)] = 219608,
  [SMALL_STATE(5011)] = 219630,
  [SMALL_STATE(5012)] = 219652,
  [SMALL_STATE(5013)] = 219676,
  [SMALL_STATE(5014)] = 219702,
  [SMALL_STATE(5015)] = 219726,
  [SMALL_STATE(5016)] = 219748,
  [SMALL_STATE(5017)] = 219772,
  [SMALL_STATE(5018)] = 219794,
  [SMALL_STATE(5019)] = 219820,
  [SMALL_STATE(5020)] = 219842,
  [SMALL_STATE(5021)] = 219864,
  [SMALL_STATE(5022)] = 219888,
  [SMALL_STATE(5023)] = 219916,
  [SMALL_STATE(5024)] = 219938,
  [SMALL_STATE(5025)] = 219960,
  [SMALL_STATE(5026)] = 219992,
  [SMALL_STATE(5027)] = 220016,
  [SMALL_STATE(5028)] = 220044,
  [SMALL_STATE(5029)] = 220086,
  [SMALL_STATE(5030)] = 220108,
  [SMALL_STATE(5031)] = 220130,
  [SMALL_STATE(5032)] = 220158,
  [SMALL_STATE(5033)] = 220180,
  [SMALL_STATE(5034)] = 220214,
  [SMALL_STATE(5035)] = 220238,
  [SMALL_STATE(5036)] = 220262,
  [SMALL_STATE(5037)] = 220290,
  [SMALL_STATE(5038)] = 220314,
  [SMALL_STATE(5039)] = 220336,
  [SMALL_STATE(5040)] = 220358,
  [SMALL_STATE(5041)] = 220380,
  [SMALL_STATE(5042)] = 220408,
  [SMALL_STATE(5043)] = 220430,
  [SMALL_STATE(5044)] = 220452,
  [SMALL_STATE(5045)] = 220486,
  [SMALL_STATE(5046)] = 220514,
  [SMALL_STATE(5047)] = 220540,
  [SMALL_STATE(5048)] = 220562,
  [SMALL_STATE(5049)] = 220586,
  [SMALL_STATE(5050)] = 220618,
  [SMALL_STATE(5051)] = 220646,
  [SMALL_STATE(5052)] = 220668,
  [SMALL_STATE(5053)] = 220690,
  [SMALL_STATE(5054)] = 220718,
  [SMALL_STATE(5055)] = 220750,
  [SMALL_STATE(5056)] = 220792,
  [SMALL_STATE(5057)] = 220830,
  [SMALL_STATE(5058)] = 220862,
  [SMALL_STATE(5059)] = 220886,
  [SMALL_STATE(5060)] = 220910,
  [SMALL_STATE(5061)] = 220931,
  [SMALL_STATE(5062)] = 220954,
  [SMALL_STATE(5063)] = 220981,
  [SMALL_STATE(5064)] = 221002,
  [SMALL_STATE(5065)] = 221025,
  [SMALL_STATE(5066)] = 221046,
  [SMALL_STATE(5067)] = 221067,
  [SMALL_STATE(5068)] = 221094,
  [SMALL_STATE(5069)] = 221115,
  [SMALL_STATE(5070)] = 221136,
  [SMALL_STATE(5071)] = 221157,
  [SMALL_STATE(5072)] = 221184,
  [SMALL_STATE(5073)] = 221205,
  [SMALL_STATE(5074)] = 221228,
  [SMALL_STATE(5075)] = 221249,
  [SMALL_STATE(5076)] = 221270,
  [SMALL_STATE(5077)] = 221293,
  [SMALL_STATE(5078)] = 221320,
  [SMALL_STATE(5079)] = 221341,
  [SMALL_STATE(5080)] = 221364,
  [SMALL_STATE(5081)] = 221385,
  [SMALL_STATE(5082)] = 221406,
  [SMALL_STATE(5083)] = 221427,
  [SMALL_STATE(5084)] = 221448,
  [SMALL_STATE(5085)] = 221469,
  [SMALL_STATE(5086)] = 221490,
  [SMALL_STATE(5087)] = 221511,
  [SMALL_STATE(5088)] = 221538,
  [SMALL_STATE(5089)] = 221559,
  [SMALL_STATE(5090)] = 221580,
  [SMALL_STATE(5091)] = 221601,
  [SMALL_STATE(5092)] = 221622,
  [SMALL_STATE(5093)] = 221643,
  [SMALL_STATE(5094)] = 221664,
  [SMALL_STATE(5095)] = 221685,
  [SMALL_STATE(5096)] = 221706,
  [SMALL_STATE(5097)] = 221727,
  [SMALL_STATE(5098)] = 221748,
  [SMALL_STATE(5099)] = 221769,
  [SMALL_STATE(5100)] = 221790,
  [SMALL_STATE(5101)] = 221811,
  [SMALL_STATE(5102)] = 221832,
  [SMALL_STATE(5103)] = 221853,
  [SMALL_STATE(5104)] = 221874,
  [SMALL_STATE(5105)] = 221895,
  [SMALL_STATE(5106)] = 221916,
  [SMALL_STATE(5107)] = 221939,
  [SMALL_STATE(5108)] = 221962,
  [SMALL_STATE(5109)] = 221983,
  [SMALL_STATE(5110)] = 222006,
  [SMALL_STATE(5111)] = 222027,
  [SMALL_STATE(5112)] = 222054,
  [SMALL_STATE(5113)] = 222075,
  [SMALL_STATE(5114)] = 222098,
  [SMALL_STATE(5115)] = 222119,
  [SMALL_STATE(5116)] = 222142,
  [SMALL_STATE(5117)] = 222163,
  [SMALL_STATE(5118)] = 222184,
  [SMALL_STATE(5119)] = 222205,
  [SMALL_STATE(5120)] = 222226,
  [SMALL_STATE(5121)] = 222247,
  [SMALL_STATE(5122)] = 222268,
  [SMALL_STATE(5123)] = 222289,
  [SMALL_STATE(5124)] = 222312,
  [SMALL_STATE(5125)] = 222333,
  [SMALL_STATE(5126)] = 222354,
  [SMALL_STATE(5127)] = 222375,
  [SMALL_STATE(5128)] = 222396,
  [SMALL_STATE(5129)] = 222417,
  [SMALL_STATE(5130)] = 222438,
  [SMALL_STATE(5131)] = 222459,
  [SMALL_STATE(5132)] = 222492,
  [SMALL_STATE(5133)] = 222515,
  [SMALL_STATE(5134)] = 222536,
  [SMALL_STATE(5135)] = 222557,
  [SMALL_STATE(5136)] = 222578,
  [SMALL_STATE(5137)] = 222599,
  [SMALL_STATE(5138)] = 222620,
  [SMALL_STATE(5139)] = 222641,
  [SMALL_STATE(5140)] = 222662,
  [SMALL_STATE(5141)] = 222683,
  [SMALL_STATE(5142)] = 222704,
  [SMALL_STATE(5143)] = 222725,
  [SMALL_STATE(5144)] = 222746,
  [SMALL_STATE(5145)] = 222769,
  [SMALL_STATE(5146)] = 222790,
  [SMALL_STATE(5147)] = 222811,
  [SMALL_STATE(5148)] = 222832,
  [SMALL_STATE(5149)] = 222853,
  [SMALL_STATE(5150)] = 222874,
  [SMALL_STATE(5151)] = 222895,
  [SMALL_STATE(5152)] = 222916,
  [SMALL_STATE(5153)] = 222941,
  [SMALL_STATE(5154)] = 222962,
  [SMALL_STATE(5155)] = 222983,
  [SMALL_STATE(5156)] = 223010,
  [SMALL_STATE(5157)] = 223031,
  [SMALL_STATE(5158)] = 223052,
  [SMALL_STATE(5159)] = 223083,
  [SMALL_STATE(5160)] = 223104,
  [SMALL_STATE(5161)] = 223131,
  [SMALL_STATE(5162)] = 223158,
  [SMALL_STATE(5163)] = 223179,
  [SMALL_STATE(5164)] = 223200,
  [SMALL_STATE(5165)] = 223221,
  [SMALL_STATE(5166)] = 223242,
  [SMALL_STATE(5167)] = 223273,
  [SMALL_STATE(5168)] = 223294,
  [SMALL_STATE(5169)] = 223317,
  [SMALL_STATE(5170)] = 223338,
  [SMALL_STATE(5171)] = 223359,
  [SMALL_STATE(5172)] = 223386,
  [SMALL_STATE(5173)] = 223409,
  [SMALL_STATE(5174)] = 223434,
  [SMALL_STATE(5175)] = 223455,
  [SMALL_STATE(5176)] = 223476,
  [SMALL_STATE(5177)] = 223497,
  [SMALL_STATE(5178)] = 223518,
  [SMALL_STATE(5179)] = 223545,
  [SMALL_STATE(5180)] = 223566,
  [SMALL_STATE(5181)] = 223587,
  [SMALL_STATE(5182)] = 223614,
  [SMALL_STATE(5183)] = 223641,
  [SMALL_STATE(5184)] = 223662,
  [SMALL_STATE(5185)] = 223683,
  [SMALL_STATE(5186)] = 223704,
  [SMALL_STATE(5187)] = 223725,
  [SMALL_STATE(5188)] = 223746,
  [SMALL_STATE(5189)] = 223767,
  [SMALL_STATE(5190)] = 223788,
  [SMALL_STATE(5191)] = 223809,
  [SMALL_STATE(5192)] = 223830,
  [SMALL_STATE(5193)] = 223851,
  [SMALL_STATE(5194)] = 223874,
  [SMALL_STATE(5195)] = 223895,
  [SMALL_STATE(5196)] = 223916,
  [SMALL_STATE(5197)] = 223937,
  [SMALL_STATE(5198)] = 223960,
  [SMALL_STATE(5199)] = 223981,
  [SMALL_STATE(5200)] = 224002,
  [SMALL_STATE(5201)] = 224025,
  [SMALL_STATE(5202)] = 224046,
  [SMALL_STATE(5203)] = 224069,
  [SMALL_STATE(5204)] = 224090,
  [SMALL_STATE(5205)] = 224111,
  [SMALL_STATE(5206)] = 224132,
  [SMALL_STATE(5207)] = 224163,
  [SMALL_STATE(5208)] = 224186,
  [SMALL_STATE(5209)] = 224219,
  [SMALL_STATE(5210)] = 224240,
  [SMALL_STATE(5211)] = 224261,
  [SMALL_STATE(5212)] = 224282,
  [SMALL_STATE(5213)] = 224303,
  [SMALL_STATE(5214)] = 224324,
  [SMALL_STATE(5215)] = 224345,
  [SMALL_STATE(5216)] = 224366,
  [SMALL_STATE(5217)] = 224387,
  [SMALL_STATE(5218)] = 224418,
  [SMALL_STATE(5219)] = 224439,
  [SMALL_STATE(5220)] = 224460,
  [SMALL_STATE(5221)] = 224483,
  [SMALL_STATE(5222)] = 224504,
  [SMALL_STATE(5223)] = 224537,
  [SMALL_STATE(5224)] = 224558,
  [SMALL_STATE(5225)] = 224579,
  [SMALL_STATE(5226)] = 224600,
  [SMALL_STATE(5227)] = 224621,
  [SMALL_STATE(5228)] = 224644,
  [SMALL_STATE(5229)] = 224675,
  [SMALL_STATE(5230)] = 224696,
  [SMALL_STATE(5231)] = 224723,
  [SMALL_STATE(5232)] = 224744,
  [SMALL_STATE(5233)] = 224765,
  [SMALL_STATE(5234)] = 224792,
  [SMALL_STATE(5235)] = 224813,
  [SMALL_STATE(5236)] = 224834,
  [SMALL_STATE(5237)] = 224857,
  [SMALL_STATE(5238)] = 224878,
  [SMALL_STATE(5239)] = 224899,
  [SMALL_STATE(5240)] = 224920,
  [SMALL_STATE(5241)] = 224941,
  [SMALL_STATE(5242)] = 224962,
  [SMALL_STATE(5243)] = 224983,
  [SMALL_STATE(5244)] = 225014,
  [SMALL_STATE(5245)] = 225035,
  [SMALL_STATE(5246)] = 225056,
  [SMALL_STATE(5247)] = 225077,
  [SMALL_STATE(5248)] = 225108,
  [SMALL_STATE(5249)] = 225133,
  [SMALL_STATE(5250)] = 225154,
  [SMALL_STATE(5251)] = 225179,
  [SMALL_STATE(5252)] = 225200,
  [SMALL_STATE(5253)] = 225221,
  [SMALL_STATE(5254)] = 225242,
  [SMALL_STATE(5255)] = 225263,
  [SMALL_STATE(5256)] = 225284,
  [SMALL_STATE(5257)] = 225309,
  [SMALL_STATE(5258)] = 225330,
  [SMALL_STATE(5259)] = 225351,
  [SMALL_STATE(5260)] = 225372,
  [SMALL_STATE(5261)] = 225393,
  [SMALL_STATE(5262)] = 225414,
  [SMALL_STATE(5263)] = 225435,
  [SMALL_STATE(5264)] = 225456,
  [SMALL_STATE(5265)] = 225477,
  [SMALL_STATE(5266)] = 225502,
  [SMALL_STATE(5267)] = 225523,
  [SMALL_STATE(5268)] = 225546,
  [SMALL_STATE(5269)] = 225567,
  [SMALL_STATE(5270)] = 225588,
  [SMALL_STATE(5271)] = 225609,
  [SMALL_STATE(5272)] = 225630,
  [SMALL_STATE(5273)] = 225651,
  [SMALL_STATE(5274)] = 225672,
  [SMALL_STATE(5275)] = 225693,
  [SMALL_STATE(5276)] = 225714,
  [SMALL_STATE(5277)] = 225737,
  [SMALL_STATE(5278)] = 225758,
  [SMALL_STATE(5279)] = 225779,
  [SMALL_STATE(5280)] = 225800,
  [SMALL_STATE(5281)] = 225823,
  [SMALL_STATE(5282)] = 225844,
  [SMALL_STATE(5283)] = 225871,
  [SMALL_STATE(5284)] = 225892,
  [SMALL_STATE(5285)] = 225913,
  [SMALL_STATE(5286)] = 225944,
  [SMALL_STATE(5287)] = 225965,
  [SMALL_STATE(5288)] = 225986,
  [SMALL_STATE(5289)] = 226017,
  [SMALL_STATE(5290)] = 226038,
  [SMALL_STATE(5291)] = 226059,
  [SMALL_STATE(5292)] = 226080,
  [SMALL_STATE(5293)] = 226101,
  [SMALL_STATE(5294)] = 226122,
  [SMALL_STATE(5295)] = 226143,
  [SMALL_STATE(5296)] = 226166,
  [SMALL_STATE(5297)] = 226187,
  [SMALL_STATE(5298)] = 226208,
  [SMALL_STATE(5299)] = 226229,
  [SMALL_STATE(5300)] = 226250,
  [SMALL_STATE(5301)] = 226271,
  [SMALL_STATE(5302)] = 226292,
  [SMALL_STATE(5303)] = 226313,
  [SMALL_STATE(5304)] = 226334,
  [SMALL_STATE(5305)] = 226357,
  [SMALL_STATE(5306)] = 226378,
  [SMALL_STATE(5307)] = 226399,
  [SMALL_STATE(5308)] = 226420,
  [SMALL_STATE(5309)] = 226441,
  [SMALL_STATE(5310)] = 226462,
  [SMALL_STATE(5311)] = 226483,
  [SMALL_STATE(5312)] = 226504,
  [SMALL_STATE(5313)] = 226525,
  [SMALL_STATE(5314)] = 226546,
  [SMALL_STATE(5315)] = 226567,
  [SMALL_STATE(5316)] = 226588,
  [SMALL_STATE(5317)] = 226609,
  [SMALL_STATE(5318)] = 226630,
  [SMALL_STATE(5319)] = 226651,
  [SMALL_STATE(5320)] = 226672,
  [SMALL_STATE(5321)] = 226693,
  [SMALL_STATE(5322)] = 226714,
  [SMALL_STATE(5323)] = 226735,
  [SMALL_STATE(5324)] = 226756,
  [SMALL_STATE(5325)] = 226777,
  [SMALL_STATE(5326)] = 226800,
  [SMALL_STATE(5327)] = 226821,
  [SMALL_STATE(5328)] = 226842,
  [SMALL_STATE(5329)] = 226873,
  [SMALL_STATE(5330)] = 226894,
  [SMALL_STATE(5331)] = 226915,
  [SMALL_STATE(5332)] = 226936,
  [SMALL_STATE(5333)] = 226957,
  [SMALL_STATE(5334)] = 226978,
  [SMALL_STATE(5335)] = 227001,
  [SMALL_STATE(5336)] = 227022,
  [SMALL_STATE(5337)] = 227043,
  [SMALL_STATE(5338)] = 227064,
  [SMALL_STATE(5339)] = 227085,
  [SMALL_STATE(5340)] = 227106,
  [SMALL_STATE(5341)] = 227127,
  [SMALL_STATE(5342)] = 227150,
  [SMALL_STATE(5343)] = 227171,
  [SMALL_STATE(5344)] = 227192,
  [SMALL_STATE(5345)] = 227213,
  [SMALL_STATE(5346)] = 227234,
  [SMALL_STATE(5347)] = 227255,
  [SMALL_STATE(5348)] = 227276,
  [SMALL_STATE(5349)] = 227297,
  [SMALL_STATE(5350)] = 227318,
  [SMALL_STATE(5351)] = 227339,
  [SMALL_STATE(5352)] = 227360,
  [SMALL_STATE(5353)] = 227383,
  [SMALL_STATE(5354)] = 227404,
  [SMALL_STATE(5355)] = 227425,
  [SMALL_STATE(5356)] = 227446,
  [SMALL_STATE(5357)] = 227471,
  [SMALL_STATE(5358)] = 227494,
  [SMALL_STATE(5359)] = 227515,
  [SMALL_STATE(5360)] = 227546,
  [SMALL_STATE(5361)] = 227567,
  [SMALL_STATE(5362)] = 227590,
  [SMALL_STATE(5363)] = 227611,
  [SMALL_STATE(5364)] = 227632,
  [SMALL_STATE(5365)] = 227653,
  [SMALL_STATE(5366)] = 227676,
  [SMALL_STATE(5367)] = 227697,
  [SMALL_STATE(5368)] = 227718,
  [SMALL_STATE(5369)] = 227739,
  [SMALL_STATE(5370)] = 227760,
  [SMALL_STATE(5371)] = 227783,
  [SMALL_STATE(5372)] = 227804,
  [SMALL_STATE(5373)] = 227825,
  [SMALL_STATE(5374)] = 227852,
  [SMALL_STATE(5375)] = 227875,
  [SMALL_STATE(5376)] = 227898,
  [SMALL_STATE(5377)] = 227919,
  [SMALL_STATE(5378)] = 227950,
  [SMALL_STATE(5379)] = 227973,
  [SMALL_STATE(5380)] = 227996,
  [SMALL_STATE(5381)] = 228027,
  [SMALL_STATE(5382)] = 228050,
  [SMALL_STATE(5383)] = 228071,
  [SMALL_STATE(5384)] = 228102,
  [SMALL_STATE(5385)] = 228122,
  [SMALL_STATE(5386)] = 228142,
  [SMALL_STATE(5387)] = 228162,
  [SMALL_STATE(5388)] = 228184,
  [SMALL_STATE(5389)] = 228206,
  [SMALL_STATE(5390)] = 228228,
  [SMALL_STATE(5391)] = 228248,
  [SMALL_STATE(5392)] = 228268,
  [SMALL_STATE(5393)] = 228288,
  [SMALL_STATE(5394)] = 228308,
  [SMALL_STATE(5395)] = 228328,
  [SMALL_STATE(5396)] = 228348,
  [SMALL_STATE(5397)] = 228368,
  [SMALL_STATE(5398)] = 228388,
  [SMALL_STATE(5399)] = 228408,
  [SMALL_STATE(5400)] = 228428,
  [SMALL_STATE(5401)] = 228448,
  [SMALL_STATE(5402)] = 228468,
  [SMALL_STATE(5403)] = 228488,
  [SMALL_STATE(5404)] = 228508,
  [SMALL_STATE(5405)] = 228528,
  [SMALL_STATE(5406)] = 228548,
  [SMALL_STATE(5407)] = 228584,
  [SMALL_STATE(5408)] = 228604,
  [SMALL_STATE(5409)] = 228624,
  [SMALL_STATE(5410)] = 228644,
  [SMALL_STATE(5411)] = 228664,
  [SMALL_STATE(5412)] = 228684,
  [SMALL_STATE(5413)] = 228704,
  [SMALL_STATE(5414)] = 228726,
  [SMALL_STATE(5415)] = 228748,
  [SMALL_STATE(5416)] = 228768,
  [SMALL_STATE(5417)] = 228788,
  [SMALL_STATE(5418)] = 228808,
  [SMALL_STATE(5419)] = 228828,
  [SMALL_STATE(5420)] = 228848,
  [SMALL_STATE(5421)] = 228870,
  [SMALL_STATE(5422)] = 228892,
  [SMALL_STATE(5423)] = 228914,
  [SMALL_STATE(5424)] = 228934,
  [SMALL_STATE(5425)] = 228954,
  [SMALL_STATE(5426)] = 228974,
  [SMALL_STATE(5427)] = 228994,
  [SMALL_STATE(5428)] = 229014,
  [SMALL_STATE(5429)] = 229036,
  [SMALL_STATE(5430)] = 229056,
  [SMALL_STATE(5431)] = 229092,
  [SMALL_STATE(5432)] = 229114,
  [SMALL_STATE(5433)] = 229134,
  [SMALL_STATE(5434)] = 229154,
  [SMALL_STATE(5435)] = 229174,
  [SMALL_STATE(5436)] = 229196,
  [SMALL_STATE(5437)] = 229216,
  [SMALL_STATE(5438)] = 229236,
  [SMALL_STATE(5439)] = 229256,
  [SMALL_STATE(5440)] = 229276,
  [SMALL_STATE(5441)] = 229296,
  [SMALL_STATE(5442)] = 229316,
  [SMALL_STATE(5443)] = 229336,
  [SMALL_STATE(5444)] = 229372,
  [SMALL_STATE(5445)] = 229392,
  [SMALL_STATE(5446)] = 229412,
  [SMALL_STATE(5447)] = 229432,
  [SMALL_STATE(5448)] = 229452,
  [SMALL_STATE(5449)] = 229472,
  [SMALL_STATE(5450)] = 229492,
  [SMALL_STATE(5451)] = 229512,
  [SMALL_STATE(5452)] = 229532,
  [SMALL_STATE(5453)] = 229552,
  [SMALL_STATE(5454)] = 229572,
  [SMALL_STATE(5455)] = 229592,
  [SMALL_STATE(5456)] = 229612,
  [SMALL_STATE(5457)] = 229632,
  [SMALL_STATE(5458)] = 229652,
  [SMALL_STATE(5459)] = 229674,
  [SMALL_STATE(5460)] = 229694,
  [SMALL_STATE(5461)] = 229716,
  [SMALL_STATE(5462)] = 229738,
  [SMALL_STATE(5463)] = 229758,
  [SMALL_STATE(5464)] = 229778,
  [SMALL_STATE(5465)] = 229798,
  [SMALL_STATE(5466)] = 229818,
  [SMALL_STATE(5467)] = 229844,
  [SMALL_STATE(5468)] = 229864,
  [SMALL_STATE(5469)] = 229884,
  [SMALL_STATE(5470)] = 229904,
  [SMALL_STATE(5471)] = 229924,
  [SMALL_STATE(5472)] = 229944,
  [SMALL_STATE(5473)] = 229964,
  [SMALL_STATE(5474)] = 229984,
  [SMALL_STATE(5475)] = 230004,
  [SMALL_STATE(5476)] = 230024,
  [SMALL_STATE(5477)] = 230044,
  [SMALL_STATE(5478)] = 230064,
  [SMALL_STATE(5479)] = 230084,
  [SMALL_STATE(5480)] = 230104,
  [SMALL_STATE(5481)] = 230124,
  [SMALL_STATE(5482)] = 230144,
  [SMALL_STATE(5483)] = 230164,
  [SMALL_STATE(5484)] = 230184,
  [SMALL_STATE(5485)] = 230204,
  [SMALL_STATE(5486)] = 230224,
  [SMALL_STATE(5487)] = 230244,
  [SMALL_STATE(5488)] = 230264,
  [SMALL_STATE(5489)] = 230284,
  [SMALL_STATE(5490)] = 230320,
  [SMALL_STATE(5491)] = 230340,
  [SMALL_STATE(5492)] = 230360,
  [SMALL_STATE(5493)] = 230380,
  [SMALL_STATE(5494)] = 230400,
  [SMALL_STATE(5495)] = 230420,
  [SMALL_STATE(5496)] = 230452,
  [SMALL_STATE(5497)] = 230484,
  [SMALL_STATE(5498)] = 230520,
  [SMALL_STATE(5499)] = 230540,
  [SMALL_STATE(5500)] = 230560,
  [SMALL_STATE(5501)] = 230580,
  [SMALL_STATE(5502)] = 230604,
  [SMALL_STATE(5503)] = 230626,
  [SMALL_STATE(5504)] = 230646,
  [SMALL_STATE(5505)] = 230676,
  [SMALL_STATE(5506)] = 230696,
  [SMALL_STATE(5507)] = 230716,
  [SMALL_STATE(5508)] = 230736,
  [SMALL_STATE(5509)] = 230756,
  [SMALL_STATE(5510)] = 230776,
  [SMALL_STATE(5511)] = 230796,
  [SMALL_STATE(5512)] = 230832,
  [SMALL_STATE(5513)] = 230864,
  [SMALL_STATE(5514)] = 230886,
  [SMALL_STATE(5515)] = 230906,
  [SMALL_STATE(5516)] = 230926,
  [SMALL_STATE(5517)] = 230946,
  [SMALL_STATE(5518)] = 230966,
  [SMALL_STATE(5519)] = 230986,
  [SMALL_STATE(5520)] = 231006,
  [SMALL_STATE(5521)] = 231026,
  [SMALL_STATE(5522)] = 231046,
  [SMALL_STATE(5523)] = 231066,
  [SMALL_STATE(5524)] = 231098,
  [SMALL_STATE(5525)] = 231118,
  [SMALL_STATE(5526)] = 231138,
  [SMALL_STATE(5527)] = 231174,
  [SMALL_STATE(5528)] = 231194,
  [SMALL_STATE(5529)] = 231214,
  [SMALL_STATE(5530)] = 231234,
  [SMALL_STATE(5531)] = 231254,
  [SMALL_STATE(5532)] = 231290,
  [SMALL_STATE(5533)] = 231310,
  [SMALL_STATE(5534)] = 231336,
  [SMALL_STATE(5535)] = 231356,
  [SMALL_STATE(5536)] = 231392,
  [SMALL_STATE(5537)] = 231412,
  [SMALL_STATE(5538)] = 231432,
  [SMALL_STATE(5539)] = 231452,
  [SMALL_STATE(5540)] = 231472,
  [SMALL_STATE(5541)] = 231508,
  [SMALL_STATE(5542)] = 231540,
  [SMALL_STATE(5543)] = 231560,
  [SMALL_STATE(5544)] = 231596,
  [SMALL_STATE(5545)] = 231632,
  [SMALL_STATE(5546)] = 231660,
  [SMALL_STATE(5547)] = 231692,
  [SMALL_STATE(5548)] = 231710,
  [SMALL_STATE(5549)] = 231730,
  [SMALL_STATE(5550)] = 231760,
  [SMALL_STATE(5551)] = 231780,
  [SMALL_STATE(5552)] = 231816,
  [SMALL_STATE(5553)] = 231852,
  [SMALL_STATE(5554)] = 231872,
  [SMALL_STATE(5555)] = 231902,
  [SMALL_STATE(5556)] = 231932,
  [SMALL_STATE(5557)] = 231964,
  [SMALL_STATE(5558)] = 232000,
  [SMALL_STATE(5559)] = 232020,
  [SMALL_STATE(5560)] = 232040,
  [SMALL_STATE(5561)] = 232060,
  [SMALL_STATE(5562)] = 232080,
  [SMALL_STATE(5563)] = 232102,
  [SMALL_STATE(5564)] = 232124,
  [SMALL_STATE(5565)] = 232148,
  [SMALL_STATE(5566)] = 232178,
  [SMALL_STATE(5567)] = 232198,
  [SMALL_STATE(5568)] = 232218,
  [SMALL_STATE(5569)] = 232236,
  [SMALL_STATE(5570)] = 232256,
  [SMALL_STATE(5571)] = 232276,
  [SMALL_STATE(5572)] = 232296,
  [SMALL_STATE(5573)] = 232326,
  [SMALL_STATE(5574)] = 232346,
  [SMALL_STATE(5575)] = 232366,
  [SMALL_STATE(5576)] = 232402,
  [SMALL_STATE(5577)] = 232422,
  [SMALL_STATE(5578)] = 232442,
  [SMALL_STATE(5579)] = 232478,
  [SMALL_STATE(5580)] = 232498,
  [SMALL_STATE(5581)] = 232518,
  [SMALL_STATE(5582)] = 232540,
  [SMALL_STATE(5583)] = 232572,
  [SMALL_STATE(5584)] = 232592,
  [SMALL_STATE(5585)] = 232612,
  [SMALL_STATE(5586)] = 232632,
  [SMALL_STATE(5587)] = 232652,
  [SMALL_STATE(5588)] = 232672,
  [SMALL_STATE(5589)] = 232692,
  [SMALL_STATE(5590)] = 232712,
  [SMALL_STATE(5591)] = 232744,
  [SMALL_STATE(5592)] = 232764,
  [SMALL_STATE(5593)] = 232790,
  [SMALL_STATE(5594)] = 232826,
  [SMALL_STATE(5595)] = 232846,
  [SMALL_STATE(5596)] = 232882,
  [SMALL_STATE(5597)] = 232902,
  [SMALL_STATE(5598)] = 232938,
  [SMALL_STATE(5599)] = 232974,
  [SMALL_STATE(5600)] = 232994,
  [SMALL_STATE(5601)] = 233014,
  [SMALL_STATE(5602)] = 233034,
  [SMALL_STATE(5603)] = 233060,
  [SMALL_STATE(5604)] = 233090,
  [SMALL_STATE(5605)] = 233118,
  [SMALL_STATE(5606)] = 233140,
  [SMALL_STATE(5607)] = 233162,
  [SMALL_STATE(5608)] = 233198,
  [SMALL_STATE(5609)] = 233218,
  [SMALL_STATE(5610)] = 233240,
  [SMALL_STATE(5611)] = 233276,
  [SMALL_STATE(5612)] = 233298,
  [SMALL_STATE(5613)] = 233334,
  [SMALL_STATE(5614)] = 233354,
  [SMALL_STATE(5615)] = 233390,
  [SMALL_STATE(5616)] = 233416,
  [SMALL_STATE(5617)] = 233452,
  [SMALL_STATE(5618)] = 233474,
  [SMALL_STATE(5619)] = 233496,
  [SMALL_STATE(5620)] = 233532,
  [SMALL_STATE(5621)] = 233552,
  [SMALL_STATE(5622)] = 233572,
  [SMALL_STATE(5623)] = 233598,
  [SMALL_STATE(5624)] = 233620,
  [SMALL_STATE(5625)] = 233646,
  [SMALL_STATE(5626)] = 233668,
  [SMALL_STATE(5627)] = 233688,
  [SMALL_STATE(5628)] = 233710,
  [SMALL_STATE(5629)] = 233730,
  [SMALL_STATE(5630)] = 233750,
  [SMALL_STATE(5631)] = 233786,
  [SMALL_STATE(5632)] = 233822,
  [SMALL_STATE(5633)] = 233848,
  [SMALL_STATE(5634)] = 233868,
  [SMALL_STATE(5635)] = 233904,
  [SMALL_STATE(5636)] = 233926,
  [SMALL_STATE(5637)] = 233962,
  [SMALL_STATE(5638)] = 233998,
  [SMALL_STATE(5639)] = 234034,
  [SMALL_STATE(5640)] = 234056,
  [SMALL_STATE(5641)] = 234076,
  [SMALL_STATE(5642)] = 234112,
  [SMALL_STATE(5643)] = 234142,
  [SMALL_STATE(5644)] = 234172,
  [SMALL_STATE(5645)] = 234192,
  [SMALL_STATE(5646)] = 234222,
  [SMALL_STATE(5647)] = 234248,
  [SMALL_STATE(5648)] = 234274,
  [SMALL_STATE(5649)] = 234294,
  [SMALL_STATE(5650)] = 234330,
  [SMALL_STATE(5651)] = 234352,
  [SMALL_STATE(5652)] = 234382,
  [SMALL_STATE(5653)] = 234402,
  [SMALL_STATE(5654)] = 234434,
  [SMALL_STATE(5655)] = 234456,
  [SMALL_STATE(5656)] = 234492,
  [SMALL_STATE(5657)] = 234512,
  [SMALL_STATE(5658)] = 234544,
  [SMALL_STATE(5659)] = 234566,
  [SMALL_STATE(5660)] = 234586,
  [SMALL_STATE(5661)] = 234618,
  [SMALL_STATE(5662)] = 234654,
  [SMALL_STATE(5663)] = 234686,
  [SMALL_STATE(5664)] = 234718,
  [SMALL_STATE(5665)] = 234754,
  [SMALL_STATE(5666)] = 234774,
  [SMALL_STATE(5667)] = 234810,
  [SMALL_STATE(5668)] = 234830,
  [SMALL_STATE(5669)] = 234862,
  [SMALL_STATE(5670)] = 234882,
  [SMALL_STATE(5671)] = 234902,
  [SMALL_STATE(5672)] = 234922,
  [SMALL_STATE(5673)] = 234954,
  [SMALL_STATE(5674)] = 234990,
  [SMALL_STATE(5675)] = 235026,
  [SMALL_STATE(5676)] = 235046,
  [SMALL_STATE(5677)] = 235082,
  [SMALL_STATE(5678)] = 235102,
  [SMALL_STATE(5679)] = 235122,
  [SMALL_STATE(5680)] = 235142,
  [SMALL_STATE(5681)] = 235162,
  [SMALL_STATE(5682)] = 235198,
  [SMALL_STATE(5683)] = 235218,
  [SMALL_STATE(5684)] = 235254,
  [SMALL_STATE(5685)] = 235290,
  [SMALL_STATE(5686)] = 235326,
  [SMALL_STATE(5687)] = 235350,
  [SMALL_STATE(5688)] = 235370,
  [SMALL_STATE(5689)] = 235390,
  [SMALL_STATE(5690)] = 235414,
  [SMALL_STATE(5691)] = 235434,
  [SMALL_STATE(5692)] = 235454,
  [SMALL_STATE(5693)] = 235478,
  [SMALL_STATE(5694)] = 235514,
  [SMALL_STATE(5695)] = 235534,
  [SMALL_STATE(5696)] = 235554,
  [SMALL_STATE(5697)] = 235590,
  [SMALL_STATE(5698)] = 235616,
  [SMALL_STATE(5699)] = 235642,
  [SMALL_STATE(5700)] = 235662,
  [SMALL_STATE(5701)] = 235682,
  [SMALL_STATE(5702)] = 235702,
  [SMALL_STATE(5703)] = 235722,
  [SMALL_STATE(5704)] = 235742,
  [SMALL_STATE(5705)] = 235762,
  [SMALL_STATE(5706)] = 235782,
  [SMALL_STATE(5707)] = 235802,
  [SMALL_STATE(5708)] = 235822,
  [SMALL_STATE(5709)] = 235842,
  [SMALL_STATE(5710)] = 235866,
  [SMALL_STATE(5711)] = 235886,
  [SMALL_STATE(5712)] = 235906,
  [SMALL_STATE(5713)] = 235926,
  [SMALL_STATE(5714)] = 235946,
  [SMALL_STATE(5715)] = 235966,
  [SMALL_STATE(5716)] = 235986,
  [SMALL_STATE(5717)] = 236006,
  [SMALL_STATE(5718)] = 236026,
  [SMALL_STATE(5719)] = 236046,
  [SMALL_STATE(5720)] = 236066,
  [SMALL_STATE(5721)] = 236086,
  [SMALL_STATE(5722)] = 236106,
  [SMALL_STATE(5723)] = 236126,
  [SMALL_STATE(5724)] = 236146,
  [SMALL_STATE(5725)] = 236166,
  [SMALL_STATE(5726)] = 236186,
  [SMALL_STATE(5727)] = 236206,
  [SMALL_STATE(5728)] = 236226,
  [SMALL_STATE(5729)] = 236246,
  [SMALL_STATE(5730)] = 236266,
  [SMALL_STATE(5731)] = 236286,
  [SMALL_STATE(5732)] = 236322,
  [SMALL_STATE(5733)] = 236342,
  [SMALL_STATE(5734)] = 236362,
  [SMALL_STATE(5735)] = 236382,
  [SMALL_STATE(5736)] = 236402,
  [SMALL_STATE(5737)] = 236422,
  [SMALL_STATE(5738)] = 236442,
  [SMALL_STATE(5739)] = 236462,
  [SMALL_STATE(5740)] = 236482,
  [SMALL_STATE(5741)] = 236502,
  [SMALL_STATE(5742)] = 236522,
  [SMALL_STATE(5743)] = 236542,
  [SMALL_STATE(5744)] = 236562,
  [SMALL_STATE(5745)] = 236582,
  [SMALL_STATE(5746)] = 236602,
  [SMALL_STATE(5747)] = 236622,
  [SMALL_STATE(5748)] = 236642,
  [SMALL_STATE(5749)] = 236662,
  [SMALL_STATE(5750)] = 236684,
  [SMALL_STATE(5751)] = 236704,
  [SMALL_STATE(5752)] = 236724,
  [SMALL_STATE(5753)] = 236744,
  [SMALL_STATE(5754)] = 236766,
  [SMALL_STATE(5755)] = 236786,
  [SMALL_STATE(5756)] = 236806,
  [SMALL_STATE(5757)] = 236826,
  [SMALL_STATE(5758)] = 236846,
  [SMALL_STATE(5759)] = 236866,
  [SMALL_STATE(5760)] = 236888,
  [SMALL_STATE(5761)] = 236908,
  [SMALL_STATE(5762)] = 236930,
  [SMALL_STATE(5763)] = 236950,
  [SMALL_STATE(5764)] = 236972,
  [SMALL_STATE(5765)] = 236994,
  [SMALL_STATE(5766)] = 237016,
  [SMALL_STATE(5767)] = 237036,
  [SMALL_STATE(5768)] = 237056,
  [SMALL_STATE(5769)] = 237076,
  [SMALL_STATE(5770)] = 237098,
  [SMALL_STATE(5771)] = 237120,
  [SMALL_STATE(5772)] = 237140,
  [SMALL_STATE(5773)] = 237160,
  [SMALL_STATE(5774)] = 237180,
  [SMALL_STATE(5775)] = 237200,
  [SMALL_STATE(5776)] = 237220,
  [SMALL_STATE(5777)] = 237240,
  [SMALL_STATE(5778)] = 237260,
  [SMALL_STATE(5779)] = 237280,
  [SMALL_STATE(5780)] = 237300,
  [SMALL_STATE(5781)] = 237320,
  [SMALL_STATE(5782)] = 237342,
  [SMALL_STATE(5783)] = 237362,
  [SMALL_STATE(5784)] = 237382,
  [SMALL_STATE(5785)] = 237402,
  [SMALL_STATE(5786)] = 237422,
  [SMALL_STATE(5787)] = 237442,
  [SMALL_STATE(5788)] = 237462,
  [SMALL_STATE(5789)] = 237482,
  [SMALL_STATE(5790)] = 237502,
  [SMALL_STATE(5791)] = 237522,
  [SMALL_STATE(5792)] = 237542,
  [SMALL_STATE(5793)] = 237562,
  [SMALL_STATE(5794)] = 237582,
  [SMALL_STATE(5795)] = 237602,
  [SMALL_STATE(5796)] = 237622,
  [SMALL_STATE(5797)] = 237655,
  [SMALL_STATE(5798)] = 237674,
  [SMALL_STATE(5799)] = 237693,
  [SMALL_STATE(5800)] = 237712,
  [SMALL_STATE(5801)] = 237731,
  [SMALL_STATE(5802)] = 237750,
  [SMALL_STATE(5803)] = 237769,
  [SMALL_STATE(5804)] = 237788,
  [SMALL_STATE(5805)] = 237807,
  [SMALL_STATE(5806)] = 237826,
  [SMALL_STATE(5807)] = 237845,
  [SMALL_STATE(5808)] = 237864,
  [SMALL_STATE(5809)] = 237883,
  [SMALL_STATE(5810)] = 237902,
  [SMALL_STATE(5811)] = 237921,
  [SMALL_STATE(5812)] = 237954,
  [SMALL_STATE(5813)] = 237973,
  [SMALL_STATE(5814)] = 237992,
  [SMALL_STATE(5815)] = 238011,
  [SMALL_STATE(5816)] = 238030,
  [SMALL_STATE(5817)] = 238049,
  [SMALL_STATE(5818)] = 238068,
  [SMALL_STATE(5819)] = 238087,
  [SMALL_STATE(5820)] = 238106,
  [SMALL_STATE(5821)] = 238125,
  [SMALL_STATE(5822)] = 238144,
  [SMALL_STATE(5823)] = 238163,
  [SMALL_STATE(5824)] = 238196,
  [SMALL_STATE(5825)] = 238215,
  [SMALL_STATE(5826)] = 238234,
  [SMALL_STATE(5827)] = 238253,
  [SMALL_STATE(5828)] = 238272,
  [SMALL_STATE(5829)] = 238291,
  [SMALL_STATE(5830)] = 238310,
  [SMALL_STATE(5831)] = 238331,
  [SMALL_STATE(5832)] = 238350,
  [SMALL_STATE(5833)] = 238383,
  [SMALL_STATE(5834)] = 238404,
  [SMALL_STATE(5835)] = 238423,
  [SMALL_STATE(5836)] = 238442,
  [SMALL_STATE(5837)] = 238461,
  [SMALL_STATE(5838)] = 238480,
  [SMALL_STATE(5839)] = 238499,
  [SMALL_STATE(5840)] = 238518,
  [SMALL_STATE(5841)] = 238551,
  [SMALL_STATE(5842)] = 238570,
  [SMALL_STATE(5843)] = 238589,
  [SMALL_STATE(5844)] = 238608,
  [SMALL_STATE(5845)] = 238627,
  [SMALL_STATE(5846)] = 238656,
  [SMALL_STATE(5847)] = 238689,
  [SMALL_STATE(5848)] = 238708,
  [SMALL_STATE(5849)] = 238727,
  [SMALL_STATE(5850)] = 238746,
  [SMALL_STATE(5851)] = 238765,
  [SMALL_STATE(5852)] = 238784,
  [SMALL_STATE(5853)] = 238803,
  [SMALL_STATE(5854)] = 238822,
  [SMALL_STATE(5855)] = 238841,
  [SMALL_STATE(5856)] = 238858,
  [SMALL_STATE(5857)] = 238877,
  [SMALL_STATE(5858)] = 238896,
  [SMALL_STATE(5859)] = 238915,
  [SMALL_STATE(5860)] = 238934,
  [SMALL_STATE(5861)] = 238967,
  [SMALL_STATE(5862)] = 238986,
  [SMALL_STATE(5863)] = 239005,
  [SMALL_STATE(5864)] = 239024,
  [SMALL_STATE(5865)] = 239043,
  [SMALL_STATE(5866)] = 239062,
  [SMALL_STATE(5867)] = 239081,
  [SMALL_STATE(5868)] = 239100,
  [SMALL_STATE(5869)] = 239129,
  [SMALL_STATE(5870)] = 239148,
  [SMALL_STATE(5871)] = 239167,
  [SMALL_STATE(5872)] = 239186,
  [SMALL_STATE(5873)] = 239205,
  [SMALL_STATE(5874)] = 239224,
  [SMALL_STATE(5875)] = 239243,
  [SMALL_STATE(5876)] = 239262,
  [SMALL_STATE(5877)] = 239291,
  [SMALL_STATE(5878)] = 239310,
  [SMALL_STATE(5879)] = 239331,
  [SMALL_STATE(5880)] = 239350,
  [SMALL_STATE(5881)] = 239369,
  [SMALL_STATE(5882)] = 239388,
  [SMALL_STATE(5883)] = 239407,
  [SMALL_STATE(5884)] = 239426,
  [SMALL_STATE(5885)] = 239447,
  [SMALL_STATE(5886)] = 239466,
  [SMALL_STATE(5887)] = 239487,
  [SMALL_STATE(5888)] = 239520,
  [SMALL_STATE(5889)] = 239539,
  [SMALL_STATE(5890)] = 239572,
  [SMALL_STATE(5891)] = 239605,
  [SMALL_STATE(5892)] = 239624,
  [SMALL_STATE(5893)] = 239643,
  [SMALL_STATE(5894)] = 239664,
  [SMALL_STATE(5895)] = 239685,
  [SMALL_STATE(5896)] = 239704,
  [SMALL_STATE(5897)] = 239723,
  [SMALL_STATE(5898)] = 239742,
  [SMALL_STATE(5899)] = 239775,
  [SMALL_STATE(5900)] = 239794,
  [SMALL_STATE(5901)] = 239813,
  [SMALL_STATE(5902)] = 239832,
  [SMALL_STATE(5903)] = 239851,
  [SMALL_STATE(5904)] = 239884,
  [SMALL_STATE(5905)] = 239905,
  [SMALL_STATE(5906)] = 239924,
  [SMALL_STATE(5907)] = 239943,
  [SMALL_STATE(5908)] = 239976,
  [SMALL_STATE(5909)] = 239995,
  [SMALL_STATE(5910)] = 240014,
  [SMALL_STATE(5911)] = 240047,
  [SMALL_STATE(5912)] = 240066,
  [SMALL_STATE(5913)] = 240099,
  [SMALL_STATE(5914)] = 240118,
  [SMALL_STATE(5915)] = 240137,
  [SMALL_STATE(5916)] = 240156,
  [SMALL_STATE(5917)] = 240175,
  [SMALL_STATE(5918)] = 240196,
  [SMALL_STATE(5919)] = 240215,
  [SMALL_STATE(5920)] = 240234,
  [SMALL_STATE(5921)] = 240253,
  [SMALL_STATE(5922)] = 240272,
  [SMALL_STATE(5923)] = 240305,
  [SMALL_STATE(5924)] = 240324,
  [SMALL_STATE(5925)] = 240343,
  [SMALL_STATE(5926)] = 240376,
  [SMALL_STATE(5927)] = 240395,
  [SMALL_STATE(5928)] = 240414,
  [SMALL_STATE(5929)] = 240433,
  [SMALL_STATE(5930)] = 240454,
  [SMALL_STATE(5931)] = 240473,
  [SMALL_STATE(5932)] = 240506,
  [SMALL_STATE(5933)] = 240525,
  [SMALL_STATE(5934)] = 240558,
  [SMALL_STATE(5935)] = 240577,
  [SMALL_STATE(5936)] = 240600,
  [SMALL_STATE(5937)] = 240633,
  [SMALL_STATE(5938)] = 240666,
  [SMALL_STATE(5939)] = 240685,
  [SMALL_STATE(5940)] = 240718,
  [SMALL_STATE(5941)] = 240737,
  [SMALL_STATE(5942)] = 240758,
  [SMALL_STATE(5943)] = 240777,
  [SMALL_STATE(5944)] = 240810,
  [SMALL_STATE(5945)] = 240829,
  [SMALL_STATE(5946)] = 240848,
  [SMALL_STATE(5947)] = 240867,
  [SMALL_STATE(5948)] = 240886,
  [SMALL_STATE(5949)] = 240905,
  [SMALL_STATE(5950)] = 240924,
  [SMALL_STATE(5951)] = 240943,
  [SMALL_STATE(5952)] = 240960,
  [SMALL_STATE(5953)] = 240979,
  [SMALL_STATE(5954)] = 241004,
  [SMALL_STATE(5955)] = 241037,
  [SMALL_STATE(5956)] = 241056,
  [SMALL_STATE(5957)] = 241089,
  [SMALL_STATE(5958)] = 241114,
  [SMALL_STATE(5959)] = 241147,
  [SMALL_STATE(5960)] = 241166,
  [SMALL_STATE(5961)] = 241191,
  [SMALL_STATE(5962)] = 241210,
  [SMALL_STATE(5963)] = 241237,
  [SMALL_STATE(5964)] = 241256,
  [SMALL_STATE(5965)] = 241289,
  [SMALL_STATE(5966)] = 241310,
  [SMALL_STATE(5967)] = 241329,
  [SMALL_STATE(5968)] = 241348,
  [SMALL_STATE(5969)] = 241367,
  [SMALL_STATE(5970)] = 241386,
  [SMALL_STATE(5971)] = 241411,
  [SMALL_STATE(5972)] = 241444,
  [SMALL_STATE(5973)] = 241463,
  [SMALL_STATE(5974)] = 241482,
  [SMALL_STATE(5975)] = 241501,
  [SMALL_STATE(5976)] = 241520,
  [SMALL_STATE(5977)] = 241539,
  [SMALL_STATE(5978)] = 241558,
  [SMALL_STATE(5979)] = 241587,
  [SMALL_STATE(5980)] = 241606,
  [SMALL_STATE(5981)] = 241639,
  [SMALL_STATE(5982)] = 241658,
  [SMALL_STATE(5983)] = 241677,
  [SMALL_STATE(5984)] = 241696,
  [SMALL_STATE(5985)] = 241715,
  [SMALL_STATE(5986)] = 241748,
  [SMALL_STATE(5987)] = 241767,
  [SMALL_STATE(5988)] = 241800,
  [SMALL_STATE(5989)] = 241829,
  [SMALL_STATE(5990)] = 241858,
  [SMALL_STATE(5991)] = 241891,
  [SMALL_STATE(5992)] = 241910,
  [SMALL_STATE(5993)] = 241943,
  [SMALL_STATE(5994)] = 241962,
  [SMALL_STATE(5995)] = 241981,
  [SMALL_STATE(5996)] = 242000,
  [SMALL_STATE(5997)] = 242033,
  [SMALL_STATE(5998)] = 242062,
  [SMALL_STATE(5999)] = 242081,
  [SMALL_STATE(6000)] = 242114,
  [SMALL_STATE(6001)] = 242133,
  [SMALL_STATE(6002)] = 242152,
  [SMALL_STATE(6003)] = 242171,
  [SMALL_STATE(6004)] = 242190,
  [SMALL_STATE(6005)] = 242209,
  [SMALL_STATE(6006)] = 242238,
  [SMALL_STATE(6007)] = 242255,
  [SMALL_STATE(6008)] = 242288,
  [SMALL_STATE(6009)] = 242307,
  [SMALL_STATE(6010)] = 242340,
  [SMALL_STATE(6011)] = 242359,
  [SMALL_STATE(6012)] = 242378,
  [SMALL_STATE(6013)] = 242395,
  [SMALL_STATE(6014)] = 242418,
  [SMALL_STATE(6015)] = 242437,
  [SMALL_STATE(6016)] = 242470,
  [SMALL_STATE(6017)] = 242489,
  [SMALL_STATE(6018)] = 242512,
  [SMALL_STATE(6019)] = 242531,
  [SMALL_STATE(6020)] = 242564,
  [SMALL_STATE(6021)] = 242597,
  [SMALL_STATE(6022)] = 242616,
  [SMALL_STATE(6023)] = 242635,
  [SMALL_STATE(6024)] = 242664,
  [SMALL_STATE(6025)] = 242697,
  [SMALL_STATE(6026)] = 242716,
  [SMALL_STATE(6027)] = 242749,
  [SMALL_STATE(6028)] = 242768,
  [SMALL_STATE(6029)] = 242797,
  [SMALL_STATE(6030)] = 242816,
  [SMALL_STATE(6031)] = 242845,
  [SMALL_STATE(6032)] = 242874,
  [SMALL_STATE(6033)] = 242903,
  [SMALL_STATE(6034)] = 242936,
  [SMALL_STATE(6035)] = 242965,
  [SMALL_STATE(6036)] = 242998,
  [SMALL_STATE(6037)] = 243017,
  [SMALL_STATE(6038)] = 243050,
  [SMALL_STATE(6039)] = 243069,
  [SMALL_STATE(6040)] = 243088,
  [SMALL_STATE(6041)] = 243113,
  [SMALL_STATE(6042)] = 243146,
  [SMALL_STATE(6043)] = 243171,
  [SMALL_STATE(6044)] = 243190,
  [SMALL_STATE(6045)] = 243209,
  [SMALL_STATE(6046)] = 243242,
  [SMALL_STATE(6047)] = 243261,
  [SMALL_STATE(6048)] = 243280,
  [SMALL_STATE(6049)] = 243301,
  [SMALL_STATE(6050)] = 243322,
  [SMALL_STATE(6051)] = 243341,
  [SMALL_STATE(6052)] = 243360,
  [SMALL_STATE(6053)] = 243393,
  [SMALL_STATE(6054)] = 243412,
  [SMALL_STATE(6055)] = 243433,
  [SMALL_STATE(6056)] = 243452,
  [SMALL_STATE(6057)] = 243477,
  [SMALL_STATE(6058)] = 243496,
  [SMALL_STATE(6059)] = 243515,
  [SMALL_STATE(6060)] = 243534,
  [SMALL_STATE(6061)] = 243557,
  [SMALL_STATE(6062)] = 243578,
  [SMALL_STATE(6063)] = 243611,
  [SMALL_STATE(6064)] = 243636,
  [SMALL_STATE(6065)] = 243655,
  [SMALL_STATE(6066)] = 243674,
  [SMALL_STATE(6067)] = 243693,
  [SMALL_STATE(6068)] = 243712,
  [SMALL_STATE(6069)] = 243731,
  [SMALL_STATE(6070)] = 243750,
  [SMALL_STATE(6071)] = 243769,
  [SMALL_STATE(6072)] = 243788,
  [SMALL_STATE(6073)] = 243807,
  [SMALL_STATE(6074)] = 243836,
  [SMALL_STATE(6075)] = 243855,
  [SMALL_STATE(6076)] = 243874,
  [SMALL_STATE(6077)] = 243907,
  [SMALL_STATE(6078)] = 243940,
  [SMALL_STATE(6079)] = 243959,
  [SMALL_STATE(6080)] = 243988,
  [SMALL_STATE(6081)] = 244021,
  [SMALL_STATE(6082)] = 244040,
  [SMALL_STATE(6083)] = 244059,
  [SMALL_STATE(6084)] = 244078,
  [SMALL_STATE(6085)] = 244095,
  [SMALL_STATE(6086)] = 244114,
  [SMALL_STATE(6087)] = 244133,
  [SMALL_STATE(6088)] = 244166,
  [SMALL_STATE(6089)] = 244199,
  [SMALL_STATE(6090)] = 244232,
  [SMALL_STATE(6091)] = 244255,
  [SMALL_STATE(6092)] = 244274,
  [SMALL_STATE(6093)] = 244307,
  [SMALL_STATE(6094)] = 244326,
  [SMALL_STATE(6095)] = 244347,
  [SMALL_STATE(6096)] = 244380,
  [SMALL_STATE(6097)] = 244399,
  [SMALL_STATE(6098)] = 244418,
  [SMALL_STATE(6099)] = 244437,
  [SMALL_STATE(6100)] = 244456,
  [SMALL_STATE(6101)] = 244475,
  [SMALL_STATE(6102)] = 244494,
  [SMALL_STATE(6103)] = 244513,
  [SMALL_STATE(6104)] = 244534,
  [SMALL_STATE(6105)] = 244553,
  [SMALL_STATE(6106)] = 244586,
  [SMALL_STATE(6107)] = 244607,
  [SMALL_STATE(6108)] = 244626,
  [SMALL_STATE(6109)] = 244645,
  [SMALL_STATE(6110)] = 244664,
  [SMALL_STATE(6111)] = 244697,
  [SMALL_STATE(6112)] = 244726,
  [SMALL_STATE(6113)] = 244745,
  [SMALL_STATE(6114)] = 244764,
  [SMALL_STATE(6115)] = 244793,
  [SMALL_STATE(6116)] = 244812,
  [SMALL_STATE(6117)] = 244831,
  [SMALL_STATE(6118)] = 244864,
  [SMALL_STATE(6119)] = 244883,
  [SMALL_STATE(6120)] = 244902,
  [SMALL_STATE(6121)] = 244935,
  [SMALL_STATE(6122)] = 244954,
  [SMALL_STATE(6123)] = 244973,
  [SMALL_STATE(6124)] = 244992,
  [SMALL_STATE(6125)] = 245011,
  [SMALL_STATE(6126)] = 245040,
  [SMALL_STATE(6127)] = 245073,
  [SMALL_STATE(6128)] = 245092,
  [SMALL_STATE(6129)] = 245121,
  [SMALL_STATE(6130)] = 245140,
  [SMALL_STATE(6131)] = 245159,
  [SMALL_STATE(6132)] = 245192,
  [SMALL_STATE(6133)] = 245211,
  [SMALL_STATE(6134)] = 245230,
  [SMALL_STATE(6135)] = 245263,
  [SMALL_STATE(6136)] = 245296,
  [SMALL_STATE(6137)] = 245315,
  [SMALL_STATE(6138)] = 245336,
  [SMALL_STATE(6139)] = 245369,
  [SMALL_STATE(6140)] = 245388,
  [SMALL_STATE(6141)] = 245417,
  [SMALL_STATE(6142)] = 245450,
  [SMALL_STATE(6143)] = 245479,
  [SMALL_STATE(6144)] = 245508,
  [SMALL_STATE(6145)] = 245527,
  [SMALL_STATE(6146)] = 245546,
  [SMALL_STATE(6147)] = 245579,
  [SMALL_STATE(6148)] = 245608,
  [SMALL_STATE(6149)] = 245627,
  [SMALL_STATE(6150)] = 245646,
  [SMALL_STATE(6151)] = 245665,
  [SMALL_STATE(6152)] = 245684,
  [SMALL_STATE(6153)] = 245717,
  [SMALL_STATE(6154)] = 245736,
  [SMALL_STATE(6155)] = 245769,
  [SMALL_STATE(6156)] = 245788,
  [SMALL_STATE(6157)] = 245807,
  [SMALL_STATE(6158)] = 245840,
  [SMALL_STATE(6159)] = 245873,
  [SMALL_STATE(6160)] = 245894,
  [SMALL_STATE(6161)] = 245913,
  [SMALL_STATE(6162)] = 245934,
  [SMALL_STATE(6163)] = 245953,
  [SMALL_STATE(6164)] = 245972,
  [SMALL_STATE(6165)] = 246005,
  [SMALL_STATE(6166)] = 246024,
  [SMALL_STATE(6167)] = 246043,
  [SMALL_STATE(6168)] = 246072,
  [SMALL_STATE(6169)] = 246091,
  [SMALL_STATE(6170)] = 246110,
  [SMALL_STATE(6171)] = 246131,
  [SMALL_STATE(6172)] = 246150,
  [SMALL_STATE(6173)] = 246167,
  [SMALL_STATE(6174)] = 246186,
  [SMALL_STATE(6175)] = 246205,
  [SMALL_STATE(6176)] = 246224,
  [SMALL_STATE(6177)] = 246243,
  [SMALL_STATE(6178)] = 246276,
  [SMALL_STATE(6179)] = 246295,
  [SMALL_STATE(6180)] = 246314,
  [SMALL_STATE(6181)] = 246347,
  [SMALL_STATE(6182)] = 246380,
  [SMALL_STATE(6183)] = 246399,
  [SMALL_STATE(6184)] = 246418,
  [SMALL_STATE(6185)] = 246437,
  [SMALL_STATE(6186)] = 246456,
  [SMALL_STATE(6187)] = 246475,
  [SMALL_STATE(6188)] = 246494,
  [SMALL_STATE(6189)] = 246513,
  [SMALL_STATE(6190)] = 246532,
  [SMALL_STATE(6191)] = 246565,
  [SMALL_STATE(6192)] = 246598,
  [SMALL_STATE(6193)] = 246617,
  [SMALL_STATE(6194)] = 246636,
  [SMALL_STATE(6195)] = 246655,
  [SMALL_STATE(6196)] = 246674,
  [SMALL_STATE(6197)] = 246693,
  [SMALL_STATE(6198)] = 246712,
  [SMALL_STATE(6199)] = 246731,
  [SMALL_STATE(6200)] = 246750,
  [SMALL_STATE(6201)] = 246769,
  [SMALL_STATE(6202)] = 246788,
  [SMALL_STATE(6203)] = 246821,
  [SMALL_STATE(6204)] = 246840,
  [SMALL_STATE(6205)] = 246859,
  [SMALL_STATE(6206)] = 246878,
  [SMALL_STATE(6207)] = 246897,
  [SMALL_STATE(6208)] = 246930,
  [SMALL_STATE(6209)] = 246963,
  [SMALL_STATE(6210)] = 246982,
  [SMALL_STATE(6211)] = 247001,
  [SMALL_STATE(6212)] = 247020,
  [SMALL_STATE(6213)] = 247039,
  [SMALL_STATE(6214)] = 247072,
  [SMALL_STATE(6215)] = 247091,
  [SMALL_STATE(6216)] = 247124,
  [SMALL_STATE(6217)] = 247143,
  [SMALL_STATE(6218)] = 247162,
  [SMALL_STATE(6219)] = 247181,
  [SMALL_STATE(6220)] = 247200,
  [SMALL_STATE(6221)] = 247219,
  [SMALL_STATE(6222)] = 247241,
  [SMALL_STATE(6223)] = 247261,
  [SMALL_STATE(6224)] = 247279,
  [SMALL_STATE(6225)] = 247299,
  [SMALL_STATE(6226)] = 247317,
  [SMALL_STATE(6227)] = 247343,
  [SMALL_STATE(6228)] = 247361,
  [SMALL_STATE(6229)] = 247391,
  [SMALL_STATE(6230)] = 247409,
  [SMALL_STATE(6231)] = 247431,
  [SMALL_STATE(6232)] = 247453,
  [SMALL_STATE(6233)] = 247471,
  [SMALL_STATE(6234)] = 247489,
  [SMALL_STATE(6235)] = 247507,
  [SMALL_STATE(6236)] = 247531,
  [SMALL_STATE(6237)] = 247549,
  [SMALL_STATE(6238)] = 247573,
  [SMALL_STATE(6239)] = 247597,
  [SMALL_STATE(6240)] = 247627,
  [SMALL_STATE(6241)] = 247651,
  [SMALL_STATE(6242)] = 247669,
  [SMALL_STATE(6243)] = 247687,
  [SMALL_STATE(6244)] = 247705,
  [SMALL_STATE(6245)] = 247727,
  [SMALL_STATE(6246)] = 247745,
  [SMALL_STATE(6247)] = 247767,
  [SMALL_STATE(6248)] = 247785,
  [SMALL_STATE(6249)] = 247807,
  [SMALL_STATE(6250)] = 247825,
  [SMALL_STATE(6251)] = 247855,
  [SMALL_STATE(6252)] = 247879,
  [SMALL_STATE(6253)] = 247905,
  [SMALL_STATE(6254)] = 247923,
  [SMALL_STATE(6255)] = 247941,
  [SMALL_STATE(6256)] = 247957,
  [SMALL_STATE(6257)] = 247987,
  [SMALL_STATE(6258)] = 248003,
  [SMALL_STATE(6259)] = 248021,
  [SMALL_STATE(6260)] = 248037,
  [SMALL_STATE(6261)] = 248055,
  [SMALL_STATE(6262)] = 248073,
  [SMALL_STATE(6263)] = 248091,
  [SMALL_STATE(6264)] = 248109,
  [SMALL_STATE(6265)] = 248127,
  [SMALL_STATE(6266)] = 248157,
  [SMALL_STATE(6267)] = 248175,
  [SMALL_STATE(6268)] = 248195,
  [SMALL_STATE(6269)] = 248219,
  [SMALL_STATE(6270)] = 248243,
  [SMALL_STATE(6271)] = 248263,
  [SMALL_STATE(6272)] = 248281,
  [SMALL_STATE(6273)] = 248301,
  [SMALL_STATE(6274)] = 248321,
  [SMALL_STATE(6275)] = 248345,
  [SMALL_STATE(6276)] = 248369,
  [SMALL_STATE(6277)] = 248395,
  [SMALL_STATE(6278)] = 248413,
  [SMALL_STATE(6279)] = 248431,
  [SMALL_STATE(6280)] = 248453,
  [SMALL_STATE(6281)] = 248473,
  [SMALL_STATE(6282)] = 248491,
  [SMALL_STATE(6283)] = 248509,
  [SMALL_STATE(6284)] = 248529,
  [SMALL_STATE(6285)] = 248547,
  [SMALL_STATE(6286)] = 248577,
  [SMALL_STATE(6287)] = 248595,
  [SMALL_STATE(6288)] = 248613,
  [SMALL_STATE(6289)] = 248631,
  [SMALL_STATE(6290)] = 248649,
  [SMALL_STATE(6291)] = 248667,
  [SMALL_STATE(6292)] = 248685,
  [SMALL_STATE(6293)] = 248707,
  [SMALL_STATE(6294)] = 248729,
  [SMALL_STATE(6295)] = 248747,
  [SMALL_STATE(6296)] = 248765,
  [SMALL_STATE(6297)] = 248783,
  [SMALL_STATE(6298)] = 248807,
  [SMALL_STATE(6299)] = 248825,
  [SMALL_STATE(6300)] = 248847,
  [SMALL_STATE(6301)] = 248877,
  [SMALL_STATE(6302)] = 248897,
  [SMALL_STATE(6303)] = 248915,
  [SMALL_STATE(6304)] = 248933,
  [SMALL_STATE(6305)] = 248953,
  [SMALL_STATE(6306)] = 248973,
  [SMALL_STATE(6307)] = 248991,
  [SMALL_STATE(6308)] = 249009,
  [SMALL_STATE(6309)] = 249027,
  [SMALL_STATE(6310)] = 249045,
  [SMALL_STATE(6311)] = 249063,
  [SMALL_STATE(6312)] = 249081,
  [SMALL_STATE(6313)] = 249099,
  [SMALL_STATE(6314)] = 249119,
  [SMALL_STATE(6315)] = 249141,
  [SMALL_STATE(6316)] = 249161,
  [SMALL_STATE(6317)] = 249179,
  [SMALL_STATE(6318)] = 249201,
  [SMALL_STATE(6319)] = 249219,
  [SMALL_STATE(6320)] = 249237,
  [SMALL_STATE(6321)] = 249255,
  [SMALL_STATE(6322)] = 249275,
  [SMALL_STATE(6323)] = 249293,
  [SMALL_STATE(6324)] = 249311,
  [SMALL_STATE(6325)] = 249329,
  [SMALL_STATE(6326)] = 249347,
  [SMALL_STATE(6327)] = 249365,
  [SMALL_STATE(6328)] = 249383,
  [SMALL_STATE(6329)] = 249401,
  [SMALL_STATE(6330)] = 249419,
  [SMALL_STATE(6331)] = 249437,
  [SMALL_STATE(6332)] = 249457,
  [SMALL_STATE(6333)] = 249475,
  [SMALL_STATE(6334)] = 249493,
  [SMALL_STATE(6335)] = 249511,
  [SMALL_STATE(6336)] = 249527,
  [SMALL_STATE(6337)] = 249547,
  [SMALL_STATE(6338)] = 249565,
  [SMALL_STATE(6339)] = 249589,
  [SMALL_STATE(6340)] = 249605,
  [SMALL_STATE(6341)] = 249635,
  [SMALL_STATE(6342)] = 249655,
  [SMALL_STATE(6343)] = 249681,
  [SMALL_STATE(6344)] = 249699,
  [SMALL_STATE(6345)] = 249717,
  [SMALL_STATE(6346)] = 249739,
  [SMALL_STATE(6347)] = 249769,
  [SMALL_STATE(6348)] = 249789,
  [SMALL_STATE(6349)] = 249805,
  [SMALL_STATE(6350)] = 249823,
  [SMALL_STATE(6351)] = 249841,
  [SMALL_STATE(6352)] = 249859,
  [SMALL_STATE(6353)] = 249877,
  [SMALL_STATE(6354)] = 249895,
  [SMALL_STATE(6355)] = 249925,
  [SMALL_STATE(6356)] = 249945,
  [SMALL_STATE(6357)] = 249965,
  [SMALL_STATE(6358)] = 249989,
  [SMALL_STATE(6359)] = 250009,
  [SMALL_STATE(6360)] = 250027,
  [SMALL_STATE(6361)] = 250045,
  [SMALL_STATE(6362)] = 250071,
  [SMALL_STATE(6363)] = 250089,
  [SMALL_STATE(6364)] = 250109,
  [SMALL_STATE(6365)] = 250127,
  [SMALL_STATE(6366)] = 250145,
  [SMALL_STATE(6367)] = 250163,
  [SMALL_STATE(6368)] = 250181,
  [SMALL_STATE(6369)] = 250199,
  [SMALL_STATE(6370)] = 250219,
  [SMALL_STATE(6371)] = 250237,
  [SMALL_STATE(6372)] = 250255,
  [SMALL_STATE(6373)] = 250273,
  [SMALL_STATE(6374)] = 250291,
  [SMALL_STATE(6375)] = 250309,
  [SMALL_STATE(6376)] = 250327,
  [SMALL_STATE(6377)] = 250345,
  [SMALL_STATE(6378)] = 250375,
  [SMALL_STATE(6379)] = 250393,
  [SMALL_STATE(6380)] = 250411,
  [SMALL_STATE(6381)] = 250429,
  [SMALL_STATE(6382)] = 250447,
  [SMALL_STATE(6383)] = 250471,
  [SMALL_STATE(6384)] = 250489,
  [SMALL_STATE(6385)] = 250507,
  [SMALL_STATE(6386)] = 250525,
  [SMALL_STATE(6387)] = 250543,
  [SMALL_STATE(6388)] = 250561,
  [SMALL_STATE(6389)] = 250583,
  [SMALL_STATE(6390)] = 250601,
  [SMALL_STATE(6391)] = 250619,
  [SMALL_STATE(6392)] = 250637,
  [SMALL_STATE(6393)] = 250655,
  [SMALL_STATE(6394)] = 250673,
  [SMALL_STATE(6395)] = 250691,
  [SMALL_STATE(6396)] = 250709,
  [SMALL_STATE(6397)] = 250727,
  [SMALL_STATE(6398)] = 250747,
  [SMALL_STATE(6399)] = 250765,
  [SMALL_STATE(6400)] = 250783,
  [SMALL_STATE(6401)] = 250803,
  [SMALL_STATE(6402)] = 250833,
  [SMALL_STATE(6403)] = 250853,
  [SMALL_STATE(6404)] = 250873,
  [SMALL_STATE(6405)] = 250891,
  [SMALL_STATE(6406)] = 250911,
  [SMALL_STATE(6407)] = 250929,
  [SMALL_STATE(6408)] = 250949,
  [SMALL_STATE(6409)] = 250967,
  [SMALL_STATE(6410)] = 250994,
  [SMALL_STATE(6411)] = 251011,
  [SMALL_STATE(6412)] = 251038,
  [SMALL_STATE(6413)] = 251065,
  [SMALL_STATE(6414)] = 251082,
  [SMALL_STATE(6415)] = 251099,
  [SMALL_STATE(6416)] = 251116,
  [SMALL_STATE(6417)] = 251135,
  [SMALL_STATE(6418)] = 251152,
  [SMALL_STATE(6419)] = 251171,
  [SMALL_STATE(6420)] = 251188,
  [SMALL_STATE(6421)] = 251205,
  [SMALL_STATE(6422)] = 251232,
  [SMALL_STATE(6423)] = 251249,
  [SMALL_STATE(6424)] = 251276,
  [SMALL_STATE(6425)] = 251293,
  [SMALL_STATE(6426)] = 251310,
  [SMALL_STATE(6427)] = 251337,
  [SMALL_STATE(6428)] = 251364,
  [SMALL_STATE(6429)] = 251381,
  [SMALL_STATE(6430)] = 251398,
  [SMALL_STATE(6431)] = 251415,
  [SMALL_STATE(6432)] = 251434,
  [SMALL_STATE(6433)] = 251451,
  [SMALL_STATE(6434)] = 251476,
  [SMALL_STATE(6435)] = 251495,
  [SMALL_STATE(6436)] = 251512,
  [SMALL_STATE(6437)] = 251529,
  [SMALL_STATE(6438)] = 251556,
  [SMALL_STATE(6439)] = 251573,
  [SMALL_STATE(6440)] = 251590,
  [SMALL_STATE(6441)] = 251607,
  [SMALL_STATE(6442)] = 251634,
  [SMALL_STATE(6443)] = 251651,
  [SMALL_STATE(6444)] = 251678,
  [SMALL_STATE(6445)] = 251705,
  [SMALL_STATE(6446)] = 251722,
  [SMALL_STATE(6447)] = 251749,
  [SMALL_STATE(6448)] = 251776,
  [SMALL_STATE(6449)] = 251795,
  [SMALL_STATE(6450)] = 251822,
  [SMALL_STATE(6451)] = 251839,
  [SMALL_STATE(6452)] = 251856,
  [SMALL_STATE(6453)] = 251875,
  [SMALL_STATE(6454)] = 251902,
  [SMALL_STATE(6455)] = 251929,
  [SMALL_STATE(6456)] = 251956,
  [SMALL_STATE(6457)] = 251971,
  [SMALL_STATE(6458)] = 251998,
  [SMALL_STATE(6459)] = 252015,
  [SMALL_STATE(6460)] = 252032,
  [SMALL_STATE(6461)] = 252049,
  [SMALL_STATE(6462)] = 252076,
  [SMALL_STATE(6463)] = 252103,
  [SMALL_STATE(6464)] = 252120,
  [SMALL_STATE(6465)] = 252137,
  [SMALL_STATE(6466)] = 252156,
  [SMALL_STATE(6467)] = 252175,
  [SMALL_STATE(6468)] = 252202,
  [SMALL_STATE(6469)] = 252219,
  [SMALL_STATE(6470)] = 252246,
  [SMALL_STATE(6471)] = 252263,
  [SMALL_STATE(6472)] = 252280,
  [SMALL_STATE(6473)] = 252297,
  [SMALL_STATE(6474)] = 252314,
  [SMALL_STATE(6475)] = 252331,
  [SMALL_STATE(6476)] = 252350,
  [SMALL_STATE(6477)] = 252367,
  [SMALL_STATE(6478)] = 252384,
  [SMALL_STATE(6479)] = 252401,
  [SMALL_STATE(6480)] = 252418,
  [SMALL_STATE(6481)] = 252435,
  [SMALL_STATE(6482)] = 252452,
  [SMALL_STATE(6483)] = 252479,
  [SMALL_STATE(6484)] = 252496,
  [SMALL_STATE(6485)] = 252513,
  [SMALL_STATE(6486)] = 252530,
  [SMALL_STATE(6487)] = 252547,
  [SMALL_STATE(6488)] = 252564,
  [SMALL_STATE(6489)] = 252591,
  [SMALL_STATE(6490)] = 252610,
  [SMALL_STATE(6491)] = 252637,
  [SMALL_STATE(6492)] = 252660,
  [SMALL_STATE(6493)] = 252687,
  [SMALL_STATE(6494)] = 252714,
  [SMALL_STATE(6495)] = 252731,
  [SMALL_STATE(6496)] = 252758,
  [SMALL_STATE(6497)] = 252785,
  [SMALL_STATE(6498)] = 252812,
  [SMALL_STATE(6499)] = 252829,
  [SMALL_STATE(6500)] = 252848,
  [SMALL_STATE(6501)] = 252875,
  [SMALL_STATE(6502)] = 252892,
  [SMALL_STATE(6503)] = 252911,
  [SMALL_STATE(6504)] = 252928,
  [SMALL_STATE(6505)] = 252945,
  [SMALL_STATE(6506)] = 252972,
  [SMALL_STATE(6507)] = 252989,
  [SMALL_STATE(6508)] = 253016,
  [SMALL_STATE(6509)] = 253043,
  [SMALL_STATE(6510)] = 253060,
  [SMALL_STATE(6511)] = 253075,
  [SMALL_STATE(6512)] = 253102,
  [SMALL_STATE(6513)] = 253119,
  [SMALL_STATE(6514)] = 253134,
  [SMALL_STATE(6515)] = 253151,
  [SMALL_STATE(6516)] = 253168,
  [SMALL_STATE(6517)] = 253185,
  [SMALL_STATE(6518)] = 253202,
  [SMALL_STATE(6519)] = 253221,
  [SMALL_STATE(6520)] = 253248,
  [SMALL_STATE(6521)] = 253275,
  [SMALL_STATE(6522)] = 253292,
  [SMALL_STATE(6523)] = 253319,
  [SMALL_STATE(6524)] = 253336,
  [SMALL_STATE(6525)] = 253353,
  [SMALL_STATE(6526)] = 253370,
  [SMALL_STATE(6527)] = 253387,
  [SMALL_STATE(6528)] = 253414,
  [SMALL_STATE(6529)] = 253431,
  [SMALL_STATE(6530)] = 253448,
  [SMALL_STATE(6531)] = 253465,
  [SMALL_STATE(6532)] = 253482,
  [SMALL_STATE(6533)] = 253499,
  [SMALL_STATE(6534)] = 253526,
  [SMALL_STATE(6535)] = 253553,
  [SMALL_STATE(6536)] = 253570,
  [SMALL_STATE(6537)] = 253597,
  [SMALL_STATE(6538)] = 253614,
  [SMALL_STATE(6539)] = 253631,
  [SMALL_STATE(6540)] = 253652,
  [SMALL_STATE(6541)] = 253669,
  [SMALL_STATE(6542)] = 253696,
  [SMALL_STATE(6543)] = 253713,
  [SMALL_STATE(6544)] = 253740,
  [SMALL_STATE(6545)] = 253757,
  [SMALL_STATE(6546)] = 253774,
  [SMALL_STATE(6547)] = 253791,
  [SMALL_STATE(6548)] = 253808,
  [SMALL_STATE(6549)] = 253835,
  [SMALL_STATE(6550)] = 253852,
  [SMALL_STATE(6551)] = 253869,
  [SMALL_STATE(6552)] = 253890,
  [SMALL_STATE(6553)] = 253907,
  [SMALL_STATE(6554)] = 253924,
  [SMALL_STATE(6555)] = 253941,
  [SMALL_STATE(6556)] = 253968,
  [SMALL_STATE(6557)] = 253985,
  [SMALL_STATE(6558)] = 254002,
  [SMALL_STATE(6559)] = 254021,
  [SMALL_STATE(6560)] = 254038,
  [SMALL_STATE(6561)] = 254055,
  [SMALL_STATE(6562)] = 254082,
  [SMALL_STATE(6563)] = 254099,
  [SMALL_STATE(6564)] = 254116,
  [SMALL_STATE(6565)] = 254133,
  [SMALL_STATE(6566)] = 254150,
  [SMALL_STATE(6567)] = 254167,
  [SMALL_STATE(6568)] = 254184,
  [SMALL_STATE(6569)] = 254201,
  [SMALL_STATE(6570)] = 254218,
  [SMALL_STATE(6571)] = 254235,
  [SMALL_STATE(6572)] = 254254,
  [SMALL_STATE(6573)] = 254271,
  [SMALL_STATE(6574)] = 254298,
  [SMALL_STATE(6575)] = 254315,
  [SMALL_STATE(6576)] = 254332,
  [SMALL_STATE(6577)] = 254349,
  [SMALL_STATE(6578)] = 254366,
  [SMALL_STATE(6579)] = 254383,
  [SMALL_STATE(6580)] = 254400,
  [SMALL_STATE(6581)] = 254417,
  [SMALL_STATE(6582)] = 254444,
  [SMALL_STATE(6583)] = 254471,
  [SMALL_STATE(6584)] = 254488,
  [SMALL_STATE(6585)] = 254515,
  [SMALL_STATE(6586)] = 254542,
  [SMALL_STATE(6587)] = 254559,
  [SMALL_STATE(6588)] = 254578,
  [SMALL_STATE(6589)] = 254605,
  [SMALL_STATE(6590)] = 254632,
  [SMALL_STATE(6591)] = 254649,
  [SMALL_STATE(6592)] = 254666,
  [SMALL_STATE(6593)] = 254683,
  [SMALL_STATE(6594)] = 254710,
  [SMALL_STATE(6595)] = 254737,
  [SMALL_STATE(6596)] = 254754,
  [SMALL_STATE(6597)] = 254771,
  [SMALL_STATE(6598)] = 254798,
  [SMALL_STATE(6599)] = 254815,
  [SMALL_STATE(6600)] = 254832,
  [SMALL_STATE(6601)] = 254859,
  [SMALL_STATE(6602)] = 254878,
  [SMALL_STATE(6603)] = 254895,
  [SMALL_STATE(6604)] = 254912,
  [SMALL_STATE(6605)] = 254929,
  [SMALL_STATE(6606)] = 254946,
  [SMALL_STATE(6607)] = 254973,
  [SMALL_STATE(6608)] = 255000,
  [SMALL_STATE(6609)] = 255027,
  [SMALL_STATE(6610)] = 255044,
  [SMALL_STATE(6611)] = 255061,
  [SMALL_STATE(6612)] = 255078,
  [SMALL_STATE(6613)] = 255105,
  [SMALL_STATE(6614)] = 255124,
  [SMALL_STATE(6615)] = 255151,
  [SMALL_STATE(6616)] = 255168,
  [SMALL_STATE(6617)] = 255195,
  [SMALL_STATE(6618)] = 255222,
  [SMALL_STATE(6619)] = 255249,
  [SMALL_STATE(6620)] = 255266,
  [SMALL_STATE(6621)] = 255285,
  [SMALL_STATE(6622)] = 255302,
  [SMALL_STATE(6623)] = 255329,
  [SMALL_STATE(6624)] = 255356,
  [SMALL_STATE(6625)] = 255373,
  [SMALL_STATE(6626)] = 255390,
  [SMALL_STATE(6627)] = 255407,
  [SMALL_STATE(6628)] = 255426,
  [SMALL_STATE(6629)] = 255443,
  [SMALL_STATE(6630)] = 255460,
  [SMALL_STATE(6631)] = 255487,
  [SMALL_STATE(6632)] = 255504,
  [SMALL_STATE(6633)] = 255521,
  [SMALL_STATE(6634)] = 255538,
  [SMALL_STATE(6635)] = 255555,
  [SMALL_STATE(6636)] = 255576,
  [SMALL_STATE(6637)] = 255593,
  [SMALL_STATE(6638)] = 255620,
  [SMALL_STATE(6639)] = 255637,
  [SMALL_STATE(6640)] = 255654,
  [SMALL_STATE(6641)] = 255671,
  [SMALL_STATE(6642)] = 255698,
  [SMALL_STATE(6643)] = 255725,
  [SMALL_STATE(6644)] = 255742,
  [SMALL_STATE(6645)] = 255759,
  [SMALL_STATE(6646)] = 255776,
  [SMALL_STATE(6647)] = 255793,
  [SMALL_STATE(6648)] = 255810,
  [SMALL_STATE(6649)] = 255827,
  [SMALL_STATE(6650)] = 255846,
  [SMALL_STATE(6651)] = 255873,
  [SMALL_STATE(6652)] = 255890,
  [SMALL_STATE(6653)] = 255907,
  [SMALL_STATE(6654)] = 255934,
  [SMALL_STATE(6655)] = 255951,
  [SMALL_STATE(6656)] = 255968,
  [SMALL_STATE(6657)] = 255985,
  [SMALL_STATE(6658)] = 256002,
  [SMALL_STATE(6659)] = 256019,
  [SMALL_STATE(6660)] = 256036,
  [SMALL_STATE(6661)] = 256063,
  [SMALL_STATE(6662)] = 256080,
  [SMALL_STATE(6663)] = 256101,
  [SMALL_STATE(6664)] = 256118,
  [SMALL_STATE(6665)] = 256135,
  [SMALL_STATE(6666)] = 256152,
  [SMALL_STATE(6667)] = 256169,
  [SMALL_STATE(6668)] = 256186,
  [SMALL_STATE(6669)] = 256203,
  [SMALL_STATE(6670)] = 256230,
  [SMALL_STATE(6671)] = 256247,
  [SMALL_STATE(6672)] = 256264,
  [SMALL_STATE(6673)] = 256281,
  [SMALL_STATE(6674)] = 256298,
  [SMALL_STATE(6675)] = 256325,
  [SMALL_STATE(6676)] = 256352,
  [SMALL_STATE(6677)] = 256379,
  [SMALL_STATE(6678)] = 256396,
  [SMALL_STATE(6679)] = 256413,
  [SMALL_STATE(6680)] = 256430,
  [SMALL_STATE(6681)] = 256447,
  [SMALL_STATE(6682)] = 256464,
  [SMALL_STATE(6683)] = 256491,
  [SMALL_STATE(6684)] = 256508,
  [SMALL_STATE(6685)] = 256525,
  [SMALL_STATE(6686)] = 256542,
  [SMALL_STATE(6687)] = 256569,
  [SMALL_STATE(6688)] = 256586,
  [SMALL_STATE(6689)] = 256603,
  [SMALL_STATE(6690)] = 256630,
  [SMALL_STATE(6691)] = 256657,
  [SMALL_STATE(6692)] = 256684,
  [SMALL_STATE(6693)] = 256711,
  [SMALL_STATE(6694)] = 256734,
  [SMALL_STATE(6695)] = 256751,
  [SMALL_STATE(6696)] = 256768,
  [SMALL_STATE(6697)] = 256783,
  [SMALL_STATE(6698)] = 256810,
  [SMALL_STATE(6699)] = 256837,
  [SMALL_STATE(6700)] = 256854,
  [SMALL_STATE(6701)] = 256881,
  [SMALL_STATE(6702)] = 256898,
  [SMALL_STATE(6703)] = 256915,
  [SMALL_STATE(6704)] = 256942,
  [SMALL_STATE(6705)] = 256969,
  [SMALL_STATE(6706)] = 256986,
  [SMALL_STATE(6707)] = 257003,
  [SMALL_STATE(6708)] = 257020,
  [SMALL_STATE(6709)] = 257037,
  [SMALL_STATE(6710)] = 257054,
  [SMALL_STATE(6711)] = 257071,
  [SMALL_STATE(6712)] = 257088,
  [SMALL_STATE(6713)] = 257105,
  [SMALL_STATE(6714)] = 257128,
  [SMALL_STATE(6715)] = 257155,
  [SMALL_STATE(6716)] = 257172,
  [SMALL_STATE(6717)] = 257199,
  [SMALL_STATE(6718)] = 257218,
  [SMALL_STATE(6719)] = 257245,
  [SMALL_STATE(6720)] = 257262,
  [SMALL_STATE(6721)] = 257289,
  [SMALL_STATE(6722)] = 257306,
  [SMALL_STATE(6723)] = 257323,
  [SMALL_STATE(6724)] = 257342,
  [SMALL_STATE(6725)] = 257359,
  [SMALL_STATE(6726)] = 257376,
  [SMALL_STATE(6727)] = 257403,
  [SMALL_STATE(6728)] = 257422,
  [SMALL_STATE(6729)] = 257439,
  [SMALL_STATE(6730)] = 257458,
  [SMALL_STATE(6731)] = 257474,
  [SMALL_STATE(6732)] = 257490,
  [SMALL_STATE(6733)] = 257506,
  [SMALL_STATE(6734)] = 257522,
  [SMALL_STATE(6735)] = 257538,
  [SMALL_STATE(6736)] = 257554,
  [SMALL_STATE(6737)] = 257570,
  [SMALL_STATE(6738)] = 257586,
  [SMALL_STATE(6739)] = 257600,
  [SMALL_STATE(6740)] = 257616,
  [SMALL_STATE(6741)] = 257632,
  [SMALL_STATE(6742)] = 257648,
  [SMALL_STATE(6743)] = 257664,
  [SMALL_STATE(6744)] = 257680,
  [SMALL_STATE(6745)] = 257696,
  [SMALL_STATE(6746)] = 257712,
  [SMALL_STATE(6747)] = 257728,
  [SMALL_STATE(6748)] = 257744,
  [SMALL_STATE(6749)] = 257760,
  [SMALL_STATE(6750)] = 257776,
  [SMALL_STATE(6751)] = 257792,
  [SMALL_STATE(6752)] = 257808,
  [SMALL_STATE(6753)] = 257824,
  [SMALL_STATE(6754)] = 257840,
  [SMALL_STATE(6755)] = 257856,
  [SMALL_STATE(6756)] = 257874,
  [SMALL_STATE(6757)] = 257892,
  [SMALL_STATE(6758)] = 257908,
  [SMALL_STATE(6759)] = 257924,
  [SMALL_STATE(6760)] = 257942,
  [SMALL_STATE(6761)] = 257960,
  [SMALL_STATE(6762)] = 257976,
  [SMALL_STATE(6763)] = 257992,
  [SMALL_STATE(6764)] = 258008,
  [SMALL_STATE(6765)] = 258024,
  [SMALL_STATE(6766)] = 258042,
  [SMALL_STATE(6767)] = 258060,
  [SMALL_STATE(6768)] = 258074,
  [SMALL_STATE(6769)] = 258096,
  [SMALL_STATE(6770)] = 258114,
  [SMALL_STATE(6771)] = 258134,
  [SMALL_STATE(6772)] = 258150,
  [SMALL_STATE(6773)] = 258174,
  [SMALL_STATE(6774)] = 258198,
  [SMALL_STATE(6775)] = 258214,
  [SMALL_STATE(6776)] = 258230,
  [SMALL_STATE(6777)] = 258244,
  [SMALL_STATE(6778)] = 258266,
  [SMALL_STATE(6779)] = 258288,
  [SMALL_STATE(6780)] = 258304,
  [SMALL_STATE(6781)] = 258326,
  [SMALL_STATE(6782)] = 258346,
  [SMALL_STATE(6783)] = 258362,
  [SMALL_STATE(6784)] = 258384,
  [SMALL_STATE(6785)] = 258400,
  [SMALL_STATE(6786)] = 258416,
  [SMALL_STATE(6787)] = 258436,
  [SMALL_STATE(6788)] = 258452,
  [SMALL_STATE(6789)] = 258468,
  [SMALL_STATE(6790)] = 258484,
  [SMALL_STATE(6791)] = 258500,
  [SMALL_STATE(6792)] = 258516,
  [SMALL_STATE(6793)] = 258538,
  [SMALL_STATE(6794)] = 258558,
  [SMALL_STATE(6795)] = 258574,
  [SMALL_STATE(6796)] = 258594,
  [SMALL_STATE(6797)] = 258608,
  [SMALL_STATE(6798)] = 258632,
  [SMALL_STATE(6799)] = 258648,
  [SMALL_STATE(6800)] = 258664,
  [SMALL_STATE(6801)] = 258678,
  [SMALL_STATE(6802)] = 258696,
  [SMALL_STATE(6803)] = 258712,
  [SMALL_STATE(6804)] = 258728,
  [SMALL_STATE(6805)] = 258744,
  [SMALL_STATE(6806)] = 258760,
  [SMALL_STATE(6807)] = 258776,
  [SMALL_STATE(6808)] = 258800,
  [SMALL_STATE(6809)] = 258816,
  [SMALL_STATE(6810)] = 258830,
  [SMALL_STATE(6811)] = 258846,
  [SMALL_STATE(6812)] = 258862,
  [SMALL_STATE(6813)] = 258878,
  [SMALL_STATE(6814)] = 258894,
  [SMALL_STATE(6815)] = 258910,
  [SMALL_STATE(6816)] = 258926,
  [SMALL_STATE(6817)] = 258942,
  [SMALL_STATE(6818)] = 258966,
  [SMALL_STATE(6819)] = 258984,
  [SMALL_STATE(6820)] = 259000,
  [SMALL_STATE(6821)] = 259024,
  [SMALL_STATE(6822)] = 259038,
  [SMALL_STATE(6823)] = 259054,
  [SMALL_STATE(6824)] = 259072,
  [SMALL_STATE(6825)] = 259088,
  [SMALL_STATE(6826)] = 259106,
  [SMALL_STATE(6827)] = 259130,
  [SMALL_STATE(6828)] = 259146,
  [SMALL_STATE(6829)] = 259164,
  [SMALL_STATE(6830)] = 259182,
  [SMALL_STATE(6831)] = 259198,
  [SMALL_STATE(6832)] = 259214,
  [SMALL_STATE(6833)] = 259232,
  [SMALL_STATE(6834)] = 259248,
  [SMALL_STATE(6835)] = 259264,
  [SMALL_STATE(6836)] = 259280,
  [SMALL_STATE(6837)] = 259296,
  [SMALL_STATE(6838)] = 259312,
  [SMALL_STATE(6839)] = 259328,
  [SMALL_STATE(6840)] = 259344,
  [SMALL_STATE(6841)] = 259360,
  [SMALL_STATE(6842)] = 259376,
  [SMALL_STATE(6843)] = 259392,
  [SMALL_STATE(6844)] = 259408,
  [SMALL_STATE(6845)] = 259432,
  [SMALL_STATE(6846)] = 259456,
  [SMALL_STATE(6847)] = 259472,
  [SMALL_STATE(6848)] = 259490,
  [SMALL_STATE(6849)] = 259506,
  [SMALL_STATE(6850)] = 259520,
  [SMALL_STATE(6851)] = 259536,
  [SMALL_STATE(6852)] = 259552,
  [SMALL_STATE(6853)] = 259576,
  [SMALL_STATE(6854)] = 259590,
  [SMALL_STATE(6855)] = 259604,
  [SMALL_STATE(6856)] = 259620,
  [SMALL_STATE(6857)] = 259634,
  [SMALL_STATE(6858)] = 259650,
  [SMALL_STATE(6859)] = 259666,
  [SMALL_STATE(6860)] = 259680,
  [SMALL_STATE(6861)] = 259696,
  [SMALL_STATE(6862)] = 259712,
  [SMALL_STATE(6863)] = 259728,
  [SMALL_STATE(6864)] = 259746,
  [SMALL_STATE(6865)] = 259762,
  [SMALL_STATE(6866)] = 259778,
  [SMALL_STATE(6867)] = 259800,
  [SMALL_STATE(6868)] = 259816,
  [SMALL_STATE(6869)] = 259838,
  [SMALL_STATE(6870)] = 259854,
  [SMALL_STATE(6871)] = 259870,
  [SMALL_STATE(6872)] = 259886,
  [SMALL_STATE(6873)] = 259902,
  [SMALL_STATE(6874)] = 259918,
  [SMALL_STATE(6875)] = 259934,
  [SMALL_STATE(6876)] = 259950,
  [SMALL_STATE(6877)] = 259966,
  [SMALL_STATE(6878)] = 259982,
  [SMALL_STATE(6879)] = 259998,
  [SMALL_STATE(6880)] = 260014,
  [SMALL_STATE(6881)] = 260032,
  [SMALL_STATE(6882)] = 260056,
  [SMALL_STATE(6883)] = 260076,
  [SMALL_STATE(6884)] = 260094,
  [SMALL_STATE(6885)] = 260110,
  [SMALL_STATE(6886)] = 260134,
  [SMALL_STATE(6887)] = 260150,
  [SMALL_STATE(6888)] = 260168,
  [SMALL_STATE(6889)] = 260184,
  [SMALL_STATE(6890)] = 260198,
  [SMALL_STATE(6891)] = 260214,
  [SMALL_STATE(6892)] = 260230,
  [SMALL_STATE(6893)] = 260246,
  [SMALL_STATE(6894)] = 260262,
  [SMALL_STATE(6895)] = 260278,
  [SMALL_STATE(6896)] = 260294,
  [SMALL_STATE(6897)] = 260310,
  [SMALL_STATE(6898)] = 260326,
  [SMALL_STATE(6899)] = 260342,
  [SMALL_STATE(6900)] = 260358,
  [SMALL_STATE(6901)] = 260374,
  [SMALL_STATE(6902)] = 260390,
  [SMALL_STATE(6903)] = 260414,
  [SMALL_STATE(6904)] = 260430,
  [SMALL_STATE(6905)] = 260448,
  [SMALL_STATE(6906)] = 260464,
  [SMALL_STATE(6907)] = 260480,
  [SMALL_STATE(6908)] = 260496,
  [SMALL_STATE(6909)] = 260512,
  [SMALL_STATE(6910)] = 260528,
  [SMALL_STATE(6911)] = 260544,
  [SMALL_STATE(6912)] = 260560,
  [SMALL_STATE(6913)] = 260576,
  [SMALL_STATE(6914)] = 260594,
  [SMALL_STATE(6915)] = 260610,
  [SMALL_STATE(6916)] = 260626,
  [SMALL_STATE(6917)] = 260650,
  [SMALL_STATE(6918)] = 260666,
  [SMALL_STATE(6919)] = 260682,
  [SMALL_STATE(6920)] = 260698,
  [SMALL_STATE(6921)] = 260722,
  [SMALL_STATE(6922)] = 260738,
  [SMALL_STATE(6923)] = 260754,
  [SMALL_STATE(6924)] = 260770,
  [SMALL_STATE(6925)] = 260786,
  [SMALL_STATE(6926)] = 260802,
  [SMALL_STATE(6927)] = 260816,
  [SMALL_STATE(6928)] = 260830,
  [SMALL_STATE(6929)] = 260846,
  [SMALL_STATE(6930)] = 260862,
  [SMALL_STATE(6931)] = 260878,
  [SMALL_STATE(6932)] = 260894,
  [SMALL_STATE(6933)] = 260910,
  [SMALL_STATE(6934)] = 260926,
  [SMALL_STATE(6935)] = 260942,
  [SMALL_STATE(6936)] = 260958,
  [SMALL_STATE(6937)] = 260974,
  [SMALL_STATE(6938)] = 260992,
  [SMALL_STATE(6939)] = 261009,
  [SMALL_STATE(6940)] = 261030,
  [SMALL_STATE(6941)] = 261051,
  [SMALL_STATE(6942)] = 261072,
  [SMALL_STATE(6943)] = 261093,
  [SMALL_STATE(6944)] = 261110,
  [SMALL_STATE(6945)] = 261131,
  [SMALL_STATE(6946)] = 261152,
  [SMALL_STATE(6947)] = 261173,
  [SMALL_STATE(6948)] = 261194,
  [SMALL_STATE(6949)] = 261215,
  [SMALL_STATE(6950)] = 261236,
  [SMALL_STATE(6951)] = 261257,
  [SMALL_STATE(6952)] = 261278,
  [SMALL_STATE(6953)] = 261297,
  [SMALL_STATE(6954)] = 261318,
  [SMALL_STATE(6955)] = 261339,
  [SMALL_STATE(6956)] = 261360,
  [SMALL_STATE(6957)] = 261381,
  [SMALL_STATE(6958)] = 261396,
  [SMALL_STATE(6959)] = 261415,
  [SMALL_STATE(6960)] = 261436,
  [SMALL_STATE(6961)] = 261457,
  [SMALL_STATE(6962)] = 261472,
  [SMALL_STATE(6963)] = 261487,
  [SMALL_STATE(6964)] = 261508,
  [SMALL_STATE(6965)] = 261529,
  [SMALL_STATE(6966)] = 261550,
  [SMALL_STATE(6967)] = 261565,
  [SMALL_STATE(6968)] = 261586,
  [SMALL_STATE(6969)] = 261605,
  [SMALL_STATE(6970)] = 261624,
  [SMALL_STATE(6971)] = 261639,
  [SMALL_STATE(6972)] = 261656,
  [SMALL_STATE(6973)] = 261677,
  [SMALL_STATE(6974)] = 261698,
  [SMALL_STATE(6975)] = 261719,
  [SMALL_STATE(6976)] = 261734,
  [SMALL_STATE(6977)] = 261755,
  [SMALL_STATE(6978)] = 261770,
  [SMALL_STATE(6979)] = 261785,
  [SMALL_STATE(6980)] = 261800,
  [SMALL_STATE(6981)] = 261815,
  [SMALL_STATE(6982)] = 261830,
  [SMALL_STATE(6983)] = 261845,
  [SMALL_STATE(6984)] = 261864,
  [SMALL_STATE(6985)] = 261877,
  [SMALL_STATE(6986)] = 261892,
  [SMALL_STATE(6987)] = 261913,
  [SMALL_STATE(6988)] = 261928,
  [SMALL_STATE(6989)] = 261949,
  [SMALL_STATE(6990)] = 261962,
  [SMALL_STATE(6991)] = 261977,
  [SMALL_STATE(6992)] = 261998,
  [SMALL_STATE(6993)] = 262019,
  [SMALL_STATE(6994)] = 262034,
  [SMALL_STATE(6995)] = 262049,
  [SMALL_STATE(6996)] = 262070,
  [SMALL_STATE(6997)] = 262091,
  [SMALL_STATE(6998)] = 262110,
  [SMALL_STATE(6999)] = 262125,
  [SMALL_STATE(7000)] = 262140,
  [SMALL_STATE(7001)] = 262153,
  [SMALL_STATE(7002)] = 262174,
  [SMALL_STATE(7003)] = 262195,
  [SMALL_STATE(7004)] = 262216,
  [SMALL_STATE(7005)] = 262237,
  [SMALL_STATE(7006)] = 262258,
  [SMALL_STATE(7007)] = 262273,
  [SMALL_STATE(7008)] = 262294,
  [SMALL_STATE(7009)] = 262315,
  [SMALL_STATE(7010)] = 262336,
  [SMALL_STATE(7011)] = 262357,
  [SMALL_STATE(7012)] = 262378,
  [SMALL_STATE(7013)] = 262399,
  [SMALL_STATE(7014)] = 262414,
  [SMALL_STATE(7015)] = 262431,
  [SMALL_STATE(7016)] = 262446,
  [SMALL_STATE(7017)] = 262465,
  [SMALL_STATE(7018)] = 262486,
  [SMALL_STATE(7019)] = 262507,
  [SMALL_STATE(7020)] = 262528,
  [SMALL_STATE(7021)] = 262549,
  [SMALL_STATE(7022)] = 262570,
  [SMALL_STATE(7023)] = 262591,
  [SMALL_STATE(7024)] = 262612,
  [SMALL_STATE(7025)] = 262633,
  [SMALL_STATE(7026)] = 262654,
  [SMALL_STATE(7027)] = 262669,
  [SMALL_STATE(7028)] = 262690,
  [SMALL_STATE(7029)] = 262711,
  [SMALL_STATE(7030)] = 262732,
  [SMALL_STATE(7031)] = 262753,
  [SMALL_STATE(7032)] = 262774,
  [SMALL_STATE(7033)] = 262789,
  [SMALL_STATE(7034)] = 262810,
  [SMALL_STATE(7035)] = 262831,
  [SMALL_STATE(7036)] = 262850,
  [SMALL_STATE(7037)] = 262867,
  [SMALL_STATE(7038)] = 262888,
  [SMALL_STATE(7039)] = 262901,
  [SMALL_STATE(7040)] = 262918,
  [SMALL_STATE(7041)] = 262939,
  [SMALL_STATE(7042)] = 262954,
  [SMALL_STATE(7043)] = 262975,
  [SMALL_STATE(7044)] = 262992,
  [SMALL_STATE(7045)] = 263013,
  [SMALL_STATE(7046)] = 263034,
  [SMALL_STATE(7047)] = 263053,
  [SMALL_STATE(7048)] = 263074,
  [SMALL_STATE(7049)] = 263095,
  [SMALL_STATE(7050)] = 263114,
  [SMALL_STATE(7051)] = 263135,
  [SMALL_STATE(7052)] = 263154,
  [SMALL_STATE(7053)] = 263169,
  [SMALL_STATE(7054)] = 263190,
  [SMALL_STATE(7055)] = 263205,
  [SMALL_STATE(7056)] = 263226,
  [SMALL_STATE(7057)] = 263241,
  [SMALL_STATE(7058)] = 263256,
  [SMALL_STATE(7059)] = 263275,
  [SMALL_STATE(7060)] = 263290,
  [SMALL_STATE(7061)] = 263305,
  [SMALL_STATE(7062)] = 263322,
  [SMALL_STATE(7063)] = 263343,
  [SMALL_STATE(7064)] = 263358,
  [SMALL_STATE(7065)] = 263375,
  [SMALL_STATE(7066)] = 263390,
  [SMALL_STATE(7067)] = 263411,
  [SMALL_STATE(7068)] = 263432,
  [SMALL_STATE(7069)] = 263453,
  [SMALL_STATE(7070)] = 263474,
  [SMALL_STATE(7071)] = 263489,
  [SMALL_STATE(7072)] = 263504,
  [SMALL_STATE(7073)] = 263525,
  [SMALL_STATE(7074)] = 263546,
  [SMALL_STATE(7075)] = 263561,
  [SMALL_STATE(7076)] = 263582,
  [SMALL_STATE(7077)] = 263595,
  [SMALL_STATE(7078)] = 263610,
  [SMALL_STATE(7079)] = 263625,
  [SMALL_STATE(7080)] = 263638,
  [SMALL_STATE(7081)] = 263653,
  [SMALL_STATE(7082)] = 263672,
  [SMALL_STATE(7083)] = 263693,
  [SMALL_STATE(7084)] = 263714,
  [SMALL_STATE(7085)] = 263735,
  [SMALL_STATE(7086)] = 263756,
  [SMALL_STATE(7087)] = 263777,
  [SMALL_STATE(7088)] = 263798,
  [SMALL_STATE(7089)] = 263819,
  [SMALL_STATE(7090)] = 263840,
  [SMALL_STATE(7091)] = 263857,
  [SMALL_STATE(7092)] = 263874,
  [SMALL_STATE(7093)] = 263895,
  [SMALL_STATE(7094)] = 263916,
  [SMALL_STATE(7095)] = 263937,
  [SMALL_STATE(7096)] = 263958,
  [SMALL_STATE(7097)] = 263979,
  [SMALL_STATE(7098)] = 263994,
  [SMALL_STATE(7099)] = 264013,
  [SMALL_STATE(7100)] = 264034,
  [SMALL_STATE(7101)] = 264051,
  [SMALL_STATE(7102)] = 264072,
  [SMALL_STATE(7103)] = 264087,
  [SMALL_STATE(7104)] = 264102,
  [SMALL_STATE(7105)] = 264123,
  [SMALL_STATE(7106)] = 264144,
  [SMALL_STATE(7107)] = 264165,
  [SMALL_STATE(7108)] = 264186,
  [SMALL_STATE(7109)] = 264199,
  [SMALL_STATE(7110)] = 264220,
  [SMALL_STATE(7111)] = 264241,
  [SMALL_STATE(7112)] = 264258,
  [SMALL_STATE(7113)] = 264277,
  [SMALL_STATE(7114)] = 264296,
  [SMALL_STATE(7115)] = 264317,
  [SMALL_STATE(7116)] = 264338,
  [SMALL_STATE(7117)] = 264357,
  [SMALL_STATE(7118)] = 264378,
  [SMALL_STATE(7119)] = 264397,
  [SMALL_STATE(7120)] = 264418,
  [SMALL_STATE(7121)] = 264439,
  [SMALL_STATE(7122)] = 264456,
  [SMALL_STATE(7123)] = 264473,
  [SMALL_STATE(7124)] = 264492,
  [SMALL_STATE(7125)] = 264513,
  [SMALL_STATE(7126)] = 264532,
  [SMALL_STATE(7127)] = 264553,
  [SMALL_STATE(7128)] = 264570,
  [SMALL_STATE(7129)] = 264583,
  [SMALL_STATE(7130)] = 264600,
  [SMALL_STATE(7131)] = 264621,
  [SMALL_STATE(7132)] = 264642,
  [SMALL_STATE(7133)] = 264657,
  [SMALL_STATE(7134)] = 264670,
  [SMALL_STATE(7135)] = 264691,
  [SMALL_STATE(7136)] = 264712,
  [SMALL_STATE(7137)] = 264733,
  [SMALL_STATE(7138)] = 264754,
  [SMALL_STATE(7139)] = 264767,
  [SMALL_STATE(7140)] = 264784,
  [SMALL_STATE(7141)] = 264797,
  [SMALL_STATE(7142)] = 264818,
  [SMALL_STATE(7143)] = 264831,
  [SMALL_STATE(7144)] = 264852,
  [SMALL_STATE(7145)] = 264873,
  [SMALL_STATE(7146)] = 264894,
  [SMALL_STATE(7147)] = 264915,
  [SMALL_STATE(7148)] = 264936,
  [SMALL_STATE(7149)] = 264955,
  [SMALL_STATE(7150)] = 264972,
  [SMALL_STATE(7151)] = 264991,
  [SMALL_STATE(7152)] = 265012,
  [SMALL_STATE(7153)] = 265033,
  [SMALL_STATE(7154)] = 265052,
  [SMALL_STATE(7155)] = 265065,
  [SMALL_STATE(7156)] = 265078,
  [SMALL_STATE(7157)] = 265093,
  [SMALL_STATE(7158)] = 265114,
  [SMALL_STATE(7159)] = 265127,
  [SMALL_STATE(7160)] = 265146,
  [SMALL_STATE(7161)] = 265165,
  [SMALL_STATE(7162)] = 265186,
  [SMALL_STATE(7163)] = 265207,
  [SMALL_STATE(7164)] = 265228,
  [SMALL_STATE(7165)] = 265247,
  [SMALL_STATE(7166)] = 265268,
  [SMALL_STATE(7167)] = 265289,
  [SMALL_STATE(7168)] = 265310,
  [SMALL_STATE(7169)] = 265327,
  [SMALL_STATE(7170)] = 265348,
  [SMALL_STATE(7171)] = 265369,
  [SMALL_STATE(7172)] = 265390,
  [SMALL_STATE(7173)] = 265411,
  [SMALL_STATE(7174)] = 265432,
  [SMALL_STATE(7175)] = 265449,
  [SMALL_STATE(7176)] = 265464,
  [SMALL_STATE(7177)] = 265485,
  [SMALL_STATE(7178)] = 265506,
  [SMALL_STATE(7179)] = 265527,
  [SMALL_STATE(7180)] = 265544,
  [SMALL_STATE(7181)] = 265565,
  [SMALL_STATE(7182)] = 265586,
  [SMALL_STATE(7183)] = 265607,
  [SMALL_STATE(7184)] = 265628,
  [SMALL_STATE(7185)] = 265649,
  [SMALL_STATE(7186)] = 265670,
  [SMALL_STATE(7187)] = 265685,
  [SMALL_STATE(7188)] = 265702,
  [SMALL_STATE(7189)] = 265719,
  [SMALL_STATE(7190)] = 265738,
  [SMALL_STATE(7191)] = 265759,
  [SMALL_STATE(7192)] = 265780,
  [SMALL_STATE(7193)] = 265801,
  [SMALL_STATE(7194)] = 265822,
  [SMALL_STATE(7195)] = 265843,
  [SMALL_STATE(7196)] = 265864,
  [SMALL_STATE(7197)] = 265885,
  [SMALL_STATE(7198)] = 265900,
  [SMALL_STATE(7199)] = 265915,
  [SMALL_STATE(7200)] = 265930,
  [SMALL_STATE(7201)] = 265949,
  [SMALL_STATE(7202)] = 265968,
  [SMALL_STATE(7203)] = 265987,
  [SMALL_STATE(7204)] = 266006,
  [SMALL_STATE(7205)] = 266025,
  [SMALL_STATE(7206)] = 266042,
  [SMALL_STATE(7207)] = 266055,
  [SMALL_STATE(7208)] = 266074,
  [SMALL_STATE(7209)] = 266089,
  [SMALL_STATE(7210)] = 266104,
  [SMALL_STATE(7211)] = 266125,
  [SMALL_STATE(7212)] = 266144,
  [SMALL_STATE(7213)] = 266165,
  [SMALL_STATE(7214)] = 266186,
  [SMALL_STATE(7215)] = 266201,
  [SMALL_STATE(7216)] = 266220,
  [SMALL_STATE(7217)] = 266235,
  [SMALL_STATE(7218)] = 266250,
  [SMALL_STATE(7219)] = 266271,
  [SMALL_STATE(7220)] = 266286,
  [SMALL_STATE(7221)] = 266307,
  [SMALL_STATE(7222)] = 266328,
  [SMALL_STATE(7223)] = 266349,
  [SMALL_STATE(7224)] = 266362,
  [SMALL_STATE(7225)] = 266383,
  [SMALL_STATE(7226)] = 266404,
  [SMALL_STATE(7227)] = 266425,
  [SMALL_STATE(7228)] = 266442,
  [SMALL_STATE(7229)] = 266463,
  [SMALL_STATE(7230)] = 266484,
  [SMALL_STATE(7231)] = 266499,
  [SMALL_STATE(7232)] = 266518,
  [SMALL_STATE(7233)] = 266533,
  [SMALL_STATE(7234)] = 266548,
  [SMALL_STATE(7235)] = 266563,
  [SMALL_STATE(7236)] = 266578,
  [SMALL_STATE(7237)] = 266599,
  [SMALL_STATE(7238)] = 266618,
  [SMALL_STATE(7239)] = 266639,
  [SMALL_STATE(7240)] = 266660,
  [SMALL_STATE(7241)] = 266681,
  [SMALL_STATE(7242)] = 266700,
  [SMALL_STATE(7243)] = 266717,
  [SMALL_STATE(7244)] = 266738,
  [SMALL_STATE(7245)] = 266757,
  [SMALL_STATE(7246)] = 266774,
  [SMALL_STATE(7247)] = 266795,
  [SMALL_STATE(7248)] = 266816,
  [SMALL_STATE(7249)] = 266837,
  [SMALL_STATE(7250)] = 266858,
  [SMALL_STATE(7251)] = 266879,
  [SMALL_STATE(7252)] = 266900,
  [SMALL_STATE(7253)] = 266919,
  [SMALL_STATE(7254)] = 266934,
  [SMALL_STATE(7255)] = 266953,
  [SMALL_STATE(7256)] = 266974,
  [SMALL_STATE(7257)] = 266989,
  [SMALL_STATE(7258)] = 267010,
  [SMALL_STATE(7259)] = 267031,
  [SMALL_STATE(7260)] = 267052,
  [SMALL_STATE(7261)] = 267073,
  [SMALL_STATE(7262)] = 267088,
  [SMALL_STATE(7263)] = 267103,
  [SMALL_STATE(7264)] = 267124,
  [SMALL_STATE(7265)] = 267139,
  [SMALL_STATE(7266)] = 267158,
  [SMALL_STATE(7267)] = 267177,
  [SMALL_STATE(7268)] = 267192,
  [SMALL_STATE(7269)] = 267205,
  [SMALL_STATE(7270)] = 267220,
  [SMALL_STATE(7271)] = 267235,
  [SMALL_STATE(7272)] = 267250,
  [SMALL_STATE(7273)] = 267265,
  [SMALL_STATE(7274)] = 267280,
  [SMALL_STATE(7275)] = 267295,
  [SMALL_STATE(7276)] = 267314,
  [SMALL_STATE(7277)] = 267335,
  [SMALL_STATE(7278)] = 267350,
  [SMALL_STATE(7279)] = 267367,
  [SMALL_STATE(7280)] = 267382,
  [SMALL_STATE(7281)] = 267399,
  [SMALL_STATE(7282)] = 267420,
  [SMALL_STATE(7283)] = 267441,
  [SMALL_STATE(7284)] = 267460,
  [SMALL_STATE(7285)] = 267477,
  [SMALL_STATE(7286)] = 267498,
  [SMALL_STATE(7287)] = 267515,
  [SMALL_STATE(7288)] = 267534,
  [SMALL_STATE(7289)] = 267555,
  [SMALL_STATE(7290)] = 267576,
  [SMALL_STATE(7291)] = 267597,
  [SMALL_STATE(7292)] = 267618,
  [SMALL_STATE(7293)] = 267639,
  [SMALL_STATE(7294)] = 267660,
  [SMALL_STATE(7295)] = 267677,
  [SMALL_STATE(7296)] = 267698,
  [SMALL_STATE(7297)] = 267719,
  [SMALL_STATE(7298)] = 267738,
  [SMALL_STATE(7299)] = 267759,
  [SMALL_STATE(7300)] = 267780,
  [SMALL_STATE(7301)] = 267801,
  [SMALL_STATE(7302)] = 267822,
  [SMALL_STATE(7303)] = 267843,
  [SMALL_STATE(7304)] = 267864,
  [SMALL_STATE(7305)] = 267883,
  [SMALL_STATE(7306)] = 267904,
  [SMALL_STATE(7307)] = 267925,
  [SMALL_STATE(7308)] = 267938,
  [SMALL_STATE(7309)] = 267959,
  [SMALL_STATE(7310)] = 267980,
  [SMALL_STATE(7311)] = 268001,
  [SMALL_STATE(7312)] = 268022,
  [SMALL_STATE(7313)] = 268043,
  [SMALL_STATE(7314)] = 268060,
  [SMALL_STATE(7315)] = 268081,
  [SMALL_STATE(7316)] = 268102,
  [SMALL_STATE(7317)] = 268119,
  [SMALL_STATE(7318)] = 268140,
  [SMALL_STATE(7319)] = 268161,
  [SMALL_STATE(7320)] = 268182,
  [SMALL_STATE(7321)] = 268197,
  [SMALL_STATE(7322)] = 268212,
  [SMALL_STATE(7323)] = 268227,
  [SMALL_STATE(7324)] = 268242,
  [SMALL_STATE(7325)] = 268257,
  [SMALL_STATE(7326)] = 268278,
  [SMALL_STATE(7327)] = 268299,
  [SMALL_STATE(7328)] = 268320,
  [SMALL_STATE(7329)] = 268341,
  [SMALL_STATE(7330)] = 268362,
  [SMALL_STATE(7331)] = 268383,
  [SMALL_STATE(7332)] = 268404,
  [SMALL_STATE(7333)] = 268419,
  [SMALL_STATE(7334)] = 268440,
  [SMALL_STATE(7335)] = 268453,
  [SMALL_STATE(7336)] = 268474,
  [SMALL_STATE(7337)] = 268493,
  [SMALL_STATE(7338)] = 268510,
  [SMALL_STATE(7339)] = 268531,
  [SMALL_STATE(7340)] = 268552,
  [SMALL_STATE(7341)] = 268569,
  [SMALL_STATE(7342)] = 268590,
  [SMALL_STATE(7343)] = 268607,
  [SMALL_STATE(7344)] = 268626,
  [SMALL_STATE(7345)] = 268643,
  [SMALL_STATE(7346)] = 268656,
  [SMALL_STATE(7347)] = 268675,
  [SMALL_STATE(7348)] = 268692,
  [SMALL_STATE(7349)] = 268711,
  [SMALL_STATE(7350)] = 268730,
  [SMALL_STATE(7351)] = 268751,
  [SMALL_STATE(7352)] = 268772,
  [SMALL_STATE(7353)] = 268793,
  [SMALL_STATE(7354)] = 268810,
  [SMALL_STATE(7355)] = 268831,
  [SMALL_STATE(7356)] = 268852,
  [SMALL_STATE(7357)] = 268869,
  [SMALL_STATE(7358)] = 268888,
  [SMALL_STATE(7359)] = 268909,
  [SMALL_STATE(7360)] = 268926,
  [SMALL_STATE(7361)] = 268947,
  [SMALL_STATE(7362)] = 268968,
  [SMALL_STATE(7363)] = 268983,
  [SMALL_STATE(7364)] = 269000,
  [SMALL_STATE(7365)] = 269021,
  [SMALL_STATE(7366)] = 269040,
  [SMALL_STATE(7367)] = 269061,
  [SMALL_STATE(7368)] = 269082,
  [SMALL_STATE(7369)] = 269103,
  [SMALL_STATE(7370)] = 269124,
  [SMALL_STATE(7371)] = 269141,
  [SMALL_STATE(7372)] = 269162,
  [SMALL_STATE(7373)] = 269183,
  [SMALL_STATE(7374)] = 269204,
  [SMALL_STATE(7375)] = 269225,
  [SMALL_STATE(7376)] = 269246,
  [SMALL_STATE(7377)] = 269267,
  [SMALL_STATE(7378)] = 269282,
  [SMALL_STATE(7379)] = 269301,
  [SMALL_STATE(7380)] = 269322,
  [SMALL_STATE(7381)] = 269343,
  [SMALL_STATE(7382)] = 269364,
  [SMALL_STATE(7383)] = 269385,
  [SMALL_STATE(7384)] = 269406,
  [SMALL_STATE(7385)] = 269427,
  [SMALL_STATE(7386)] = 269444,
  [SMALL_STATE(7387)] = 269465,
  [SMALL_STATE(7388)] = 269486,
  [SMALL_STATE(7389)] = 269503,
  [SMALL_STATE(7390)] = 269524,
  [SMALL_STATE(7391)] = 269545,
  [SMALL_STATE(7392)] = 269562,
  [SMALL_STATE(7393)] = 269579,
  [SMALL_STATE(7394)] = 269600,
  [SMALL_STATE(7395)] = 269621,
  [SMALL_STATE(7396)] = 269642,
  [SMALL_STATE(7397)] = 269663,
  [SMALL_STATE(7398)] = 269684,
  [SMALL_STATE(7399)] = 269705,
  [SMALL_STATE(7400)] = 269726,
  [SMALL_STATE(7401)] = 269743,
  [SMALL_STATE(7402)] = 269758,
  [SMALL_STATE(7403)] = 269779,
  [SMALL_STATE(7404)] = 269800,
  [SMALL_STATE(7405)] = 269821,
  [SMALL_STATE(7406)] = 269840,
  [SMALL_STATE(7407)] = 269861,
  [SMALL_STATE(7408)] = 269882,
  [SMALL_STATE(7409)] = 269903,
  [SMALL_STATE(7410)] = 269924,
  [SMALL_STATE(7411)] = 269945,
  [SMALL_STATE(7412)] = 269966,
  [SMALL_STATE(7413)] = 269987,
  [SMALL_STATE(7414)] = 270000,
  [SMALL_STATE(7415)] = 270013,
  [SMALL_STATE(7416)] = 270032,
  [SMALL_STATE(7417)] = 270047,
  [SMALL_STATE(7418)] = 270062,
  [SMALL_STATE(7419)] = 270077,
  [SMALL_STATE(7420)] = 270090,
  [SMALL_STATE(7421)] = 270103,
  [SMALL_STATE(7422)] = 270124,
  [SMALL_STATE(7423)] = 270141,
  [SMALL_STATE(7424)] = 270160,
  [SMALL_STATE(7425)] = 270175,
  [SMALL_STATE(7426)] = 270196,
  [SMALL_STATE(7427)] = 270217,
  [SMALL_STATE(7428)] = 270238,
  [SMALL_STATE(7429)] = 270253,
  [SMALL_STATE(7430)] = 270274,
  [SMALL_STATE(7431)] = 270295,
  [SMALL_STATE(7432)] = 270310,
  [SMALL_STATE(7433)] = 270331,
  [SMALL_STATE(7434)] = 270346,
  [SMALL_STATE(7435)] = 270361,
  [SMALL_STATE(7436)] = 270382,
  [SMALL_STATE(7437)] = 270403,
  [SMALL_STATE(7438)] = 270424,
  [SMALL_STATE(7439)] = 270439,
  [SMALL_STATE(7440)] = 270452,
  [SMALL_STATE(7441)] = 270471,
  [SMALL_STATE(7442)] = 270484,
  [SMALL_STATE(7443)] = 270499,
  [SMALL_STATE(7444)] = 270514,
  [SMALL_STATE(7445)] = 270529,
  [SMALL_STATE(7446)] = 270544,
  [SMALL_STATE(7447)] = 270559,
  [SMALL_STATE(7448)] = 270580,
  [SMALL_STATE(7449)] = 270601,
  [SMALL_STATE(7450)] = 270622,
  [SMALL_STATE(7451)] = 270643,
  [SMALL_STATE(7452)] = 270664,
  [SMALL_STATE(7453)] = 270685,
  [SMALL_STATE(7454)] = 270702,
  [SMALL_STATE(7455)] = 270717,
  [SMALL_STATE(7456)] = 270738,
  [SMALL_STATE(7457)] = 270757,
  [SMALL_STATE(7458)] = 270778,
  [SMALL_STATE(7459)] = 270799,
  [SMALL_STATE(7460)] = 270820,
  [SMALL_STATE(7461)] = 270841,
  [SMALL_STATE(7462)] = 270862,
  [SMALL_STATE(7463)] = 270883,
  [SMALL_STATE(7464)] = 270904,
  [SMALL_STATE(7465)] = 270925,
  [SMALL_STATE(7466)] = 270944,
  [SMALL_STATE(7467)] = 270965,
  [SMALL_STATE(7468)] = 270986,
  [SMALL_STATE(7469)] = 271007,
  [SMALL_STATE(7470)] = 271028,
  [SMALL_STATE(7471)] = 271049,
  [SMALL_STATE(7472)] = 271070,
  [SMALL_STATE(7473)] = 271091,
  [SMALL_STATE(7474)] = 271110,
  [SMALL_STATE(7475)] = 271131,
  [SMALL_STATE(7476)] = 271152,
  [SMALL_STATE(7477)] = 271171,
  [SMALL_STATE(7478)] = 271188,
  [SMALL_STATE(7479)] = 271209,
  [SMALL_STATE(7480)] = 271230,
  [SMALL_STATE(7481)] = 271251,
  [SMALL_STATE(7482)] = 271270,
  [SMALL_STATE(7483)] = 271291,
  [SMALL_STATE(7484)] = 271310,
  [SMALL_STATE(7485)] = 271331,
  [SMALL_STATE(7486)] = 271344,
  [SMALL_STATE(7487)] = 271365,
  [SMALL_STATE(7488)] = 271386,
  [SMALL_STATE(7489)] = 271407,
  [SMALL_STATE(7490)] = 271424,
  [SMALL_STATE(7491)] = 271445,
  [SMALL_STATE(7492)] = 271464,
  [SMALL_STATE(7493)] = 271485,
  [SMALL_STATE(7494)] = 271502,
  [SMALL_STATE(7495)] = 271523,
  [SMALL_STATE(7496)] = 271544,
  [SMALL_STATE(7497)] = 271565,
  [SMALL_STATE(7498)] = 271582,
  [SMALL_STATE(7499)] = 271603,
  [SMALL_STATE(7500)] = 271624,
  [SMALL_STATE(7501)] = 271645,
  [SMALL_STATE(7502)] = 271666,
  [SMALL_STATE(7503)] = 271687,
  [SMALL_STATE(7504)] = 271708,
  [SMALL_STATE(7505)] = 271729,
  [SMALL_STATE(7506)] = 271750,
  [SMALL_STATE(7507)] = 271771,
  [SMALL_STATE(7508)] = 271786,
  [SMALL_STATE(7509)] = 271807,
  [SMALL_STATE(7510)] = 271826,
  [SMALL_STATE(7511)] = 271843,
  [SMALL_STATE(7512)] = 271856,
  [SMALL_STATE(7513)] = 271877,
  [SMALL_STATE(7514)] = 271894,
  [SMALL_STATE(7515)] = 271915,
  [SMALL_STATE(7516)] = 271936,
  [SMALL_STATE(7517)] = 271957,
  [SMALL_STATE(7518)] = 271978,
  [SMALL_STATE(7519)] = 271997,
  [SMALL_STATE(7520)] = 272018,
  [SMALL_STATE(7521)] = 272031,
  [SMALL_STATE(7522)] = 272048,
  [SMALL_STATE(7523)] = 272069,
  [SMALL_STATE(7524)] = 272090,
  [SMALL_STATE(7525)] = 272111,
  [SMALL_STATE(7526)] = 272132,
  [SMALL_STATE(7527)] = 272153,
  [SMALL_STATE(7528)] = 272170,
  [SMALL_STATE(7529)] = 272191,
  [SMALL_STATE(7530)] = 272212,
  [SMALL_STATE(7531)] = 272233,
  [SMALL_STATE(7532)] = 272254,
  [SMALL_STATE(7533)] = 272275,
  [SMALL_STATE(7534)] = 272296,
  [SMALL_STATE(7535)] = 272315,
  [SMALL_STATE(7536)] = 272336,
  [SMALL_STATE(7537)] = 272355,
  [SMALL_STATE(7538)] = 272368,
  [SMALL_STATE(7539)] = 272386,
  [SMALL_STATE(7540)] = 272402,
  [SMALL_STATE(7541)] = 272418,
  [SMALL_STATE(7542)] = 272436,
  [SMALL_STATE(7543)] = 272450,
  [SMALL_STATE(7544)] = 272464,
  [SMALL_STATE(7545)] = 272482,
  [SMALL_STATE(7546)] = 272500,
  [SMALL_STATE(7547)] = 272518,
  [SMALL_STATE(7548)] = 272536,
  [SMALL_STATE(7549)] = 272552,
  [SMALL_STATE(7550)] = 272568,
  [SMALL_STATE(7551)] = 272584,
  [SMALL_STATE(7552)] = 272596,
  [SMALL_STATE(7553)] = 272612,
  [SMALL_STATE(7554)] = 272628,
  [SMALL_STATE(7555)] = 272644,
  [SMALL_STATE(7556)] = 272660,
  [SMALL_STATE(7557)] = 272678,
  [SMALL_STATE(7558)] = 272694,
  [SMALL_STATE(7559)] = 272710,
  [SMALL_STATE(7560)] = 272728,
  [SMALL_STATE(7561)] = 272740,
  [SMALL_STATE(7562)] = 272758,
  [SMALL_STATE(7563)] = 272772,
  [SMALL_STATE(7564)] = 272788,
  [SMALL_STATE(7565)] = 272804,
  [SMALL_STATE(7566)] = 272822,
  [SMALL_STATE(7567)] = 272834,
  [SMALL_STATE(7568)] = 272848,
  [SMALL_STATE(7569)] = 272866,
  [SMALL_STATE(7570)] = 272884,
  [SMALL_STATE(7571)] = 272898,
  [SMALL_STATE(7572)] = 272916,
  [SMALL_STATE(7573)] = 272934,
  [SMALL_STATE(7574)] = 272952,
  [SMALL_STATE(7575)] = 272966,
  [SMALL_STATE(7576)] = 272984,
  [SMALL_STATE(7577)] = 273000,
  [SMALL_STATE(7578)] = 273016,
  [SMALL_STATE(7579)] = 273032,
  [SMALL_STATE(7580)] = 273050,
  [SMALL_STATE(7581)] = 273062,
  [SMALL_STATE(7582)] = 273080,
  [SMALL_STATE(7583)] = 273096,
  [SMALL_STATE(7584)] = 273112,
  [SMALL_STATE(7585)] = 273128,
  [SMALL_STATE(7586)] = 273144,
  [SMALL_STATE(7587)] = 273156,
  [SMALL_STATE(7588)] = 273172,
  [SMALL_STATE(7589)] = 273188,
  [SMALL_STATE(7590)] = 273204,
  [SMALL_STATE(7591)] = 273222,
  [SMALL_STATE(7592)] = 273236,
  [SMALL_STATE(7593)] = 273254,
  [SMALL_STATE(7594)] = 273272,
  [SMALL_STATE(7595)] = 273288,
  [SMALL_STATE(7596)] = 273300,
  [SMALL_STATE(7597)] = 273312,
  [SMALL_STATE(7598)] = 273326,
  [SMALL_STATE(7599)] = 273342,
  [SMALL_STATE(7600)] = 273360,
  [SMALL_STATE(7601)] = 273376,
  [SMALL_STATE(7602)] = 273394,
  [SMALL_STATE(7603)] = 273408,
  [SMALL_STATE(7604)] = 273424,
  [SMALL_STATE(7605)] = 273442,
  [SMALL_STATE(7606)] = 273458,
  [SMALL_STATE(7607)] = 273474,
  [SMALL_STATE(7608)] = 273490,
  [SMALL_STATE(7609)] = 273502,
  [SMALL_STATE(7610)] = 273520,
  [SMALL_STATE(7611)] = 273538,
  [SMALL_STATE(7612)] = 273556,
  [SMALL_STATE(7613)] = 273570,
  [SMALL_STATE(7614)] = 273586,
  [SMALL_STATE(7615)] = 273602,
  [SMALL_STATE(7616)] = 273620,
  [SMALL_STATE(7617)] = 273638,
  [SMALL_STATE(7618)] = 273656,
  [SMALL_STATE(7619)] = 273670,
  [SMALL_STATE(7620)] = 273686,
  [SMALL_STATE(7621)] = 273698,
  [SMALL_STATE(7622)] = 273714,
  [SMALL_STATE(7623)] = 273730,
  [SMALL_STATE(7624)] = 273748,
  [SMALL_STATE(7625)] = 273766,
  [SMALL_STATE(7626)] = 273784,
  [SMALL_STATE(7627)] = 273800,
  [SMALL_STATE(7628)] = 273816,
  [SMALL_STATE(7629)] = 273832,
  [SMALL_STATE(7630)] = 273848,
  [SMALL_STATE(7631)] = 273866,
  [SMALL_STATE(7632)] = 273878,
  [SMALL_STATE(7633)] = 273894,
  [SMALL_STATE(7634)] = 273906,
  [SMALL_STATE(7635)] = 273924,
  [SMALL_STATE(7636)] = 273942,
  [SMALL_STATE(7637)] = 273960,
  [SMALL_STATE(7638)] = 273974,
  [SMALL_STATE(7639)] = 273988,
  [SMALL_STATE(7640)] = 274006,
  [SMALL_STATE(7641)] = 274022,
  [SMALL_STATE(7642)] = 274038,
  [SMALL_STATE(7643)] = 274056,
  [SMALL_STATE(7644)] = 274072,
  [SMALL_STATE(7645)] = 274084,
  [SMALL_STATE(7646)] = 274102,
  [SMALL_STATE(7647)] = 274116,
  [SMALL_STATE(7648)] = 274130,
  [SMALL_STATE(7649)] = 274146,
  [SMALL_STATE(7650)] = 274160,
  [SMALL_STATE(7651)] = 274178,
  [SMALL_STATE(7652)] = 274194,
  [SMALL_STATE(7653)] = 274212,
  [SMALL_STATE(7654)] = 274230,
  [SMALL_STATE(7655)] = 274242,
  [SMALL_STATE(7656)] = 274256,
  [SMALL_STATE(7657)] = 274274,
  [SMALL_STATE(7658)] = 274288,
  [SMALL_STATE(7659)] = 274304,
  [SMALL_STATE(7660)] = 274322,
  [SMALL_STATE(7661)] = 274338,
  [SMALL_STATE(7662)] = 274356,
  [SMALL_STATE(7663)] = 274372,
  [SMALL_STATE(7664)] = 274390,
  [SMALL_STATE(7665)] = 274408,
  [SMALL_STATE(7666)] = 274420,
  [SMALL_STATE(7667)] = 274434,
  [SMALL_STATE(7668)] = 274452,
  [SMALL_STATE(7669)] = 274470,
  [SMALL_STATE(7670)] = 274486,
  [SMALL_STATE(7671)] = 274502,
  [SMALL_STATE(7672)] = 274518,
  [SMALL_STATE(7673)] = 274536,
  [SMALL_STATE(7674)] = 274554,
  [SMALL_STATE(7675)] = 274572,
  [SMALL_STATE(7676)] = 274584,
  [SMALL_STATE(7677)] = 274602,
  [SMALL_STATE(7678)] = 274620,
  [SMALL_STATE(7679)] = 274634,
  [SMALL_STATE(7680)] = 274650,
  [SMALL_STATE(7681)] = 274668,
  [SMALL_STATE(7682)] = 274686,
  [SMALL_STATE(7683)] = 274702,
  [SMALL_STATE(7684)] = 274720,
  [SMALL_STATE(7685)] = 274736,
  [SMALL_STATE(7686)] = 274748,
  [SMALL_STATE(7687)] = 274760,
  [SMALL_STATE(7688)] = 274776,
  [SMALL_STATE(7689)] = 274794,
  [SMALL_STATE(7690)] = 274812,
  [SMALL_STATE(7691)] = 274826,
  [SMALL_STATE(7692)] = 274842,
  [SMALL_STATE(7693)] = 274858,
  [SMALL_STATE(7694)] = 274874,
  [SMALL_STATE(7695)] = 274890,
  [SMALL_STATE(7696)] = 274906,
  [SMALL_STATE(7697)] = 274924,
  [SMALL_STATE(7698)] = 274942,
  [SMALL_STATE(7699)] = 274958,
  [SMALL_STATE(7700)] = 274976,
  [SMALL_STATE(7701)] = 274992,
  [SMALL_STATE(7702)] = 275008,
  [SMALL_STATE(7703)] = 275024,
  [SMALL_STATE(7704)] = 275040,
  [SMALL_STATE(7705)] = 275056,
  [SMALL_STATE(7706)] = 275074,
  [SMALL_STATE(7707)] = 275090,
  [SMALL_STATE(7708)] = 275106,
  [SMALL_STATE(7709)] = 275122,
  [SMALL_STATE(7710)] = 275138,
  [SMALL_STATE(7711)] = 275154,
  [SMALL_STATE(7712)] = 275170,
  [SMALL_STATE(7713)] = 275188,
  [SMALL_STATE(7714)] = 275204,
  [SMALL_STATE(7715)] = 275222,
  [SMALL_STATE(7716)] = 275238,
  [SMALL_STATE(7717)] = 275256,
  [SMALL_STATE(7718)] = 275272,
  [SMALL_STATE(7719)] = 275290,
  [SMALL_STATE(7720)] = 275308,
  [SMALL_STATE(7721)] = 275326,
  [SMALL_STATE(7722)] = 275342,
  [SMALL_STATE(7723)] = 275360,
  [SMALL_STATE(7724)] = 275376,
  [SMALL_STATE(7725)] = 275390,
  [SMALL_STATE(7726)] = 275408,
  [SMALL_STATE(7727)] = 275426,
  [SMALL_STATE(7728)] = 275440,
  [SMALL_STATE(7729)] = 275458,
  [SMALL_STATE(7730)] = 275476,
  [SMALL_STATE(7731)] = 275494,
  [SMALL_STATE(7732)] = 275508,
  [SMALL_STATE(7733)] = 275526,
  [SMALL_STATE(7734)] = 275540,
  [SMALL_STATE(7735)] = 275554,
  [SMALL_STATE(7736)] = 275572,
  [SMALL_STATE(7737)] = 275588,
  [SMALL_STATE(7738)] = 275604,
  [SMALL_STATE(7739)] = 275622,
  [SMALL_STATE(7740)] = 275640,
  [SMALL_STATE(7741)] = 275652,
  [SMALL_STATE(7742)] = 275670,
  [SMALL_STATE(7743)] = 275688,
  [SMALL_STATE(7744)] = 275704,
  [SMALL_STATE(7745)] = 275720,
  [SMALL_STATE(7746)] = 275736,
  [SMALL_STATE(7747)] = 275750,
  [SMALL_STATE(7748)] = 275766,
  [SMALL_STATE(7749)] = 275784,
  [SMALL_STATE(7750)] = 275800,
  [SMALL_STATE(7751)] = 275816,
  [SMALL_STATE(7752)] = 275834,
  [SMALL_STATE(7753)] = 275850,
  [SMALL_STATE(7754)] = 275862,
  [SMALL_STATE(7755)] = 275880,
  [SMALL_STATE(7756)] = 275898,
  [SMALL_STATE(7757)] = 275916,
  [SMALL_STATE(7758)] = 275932,
  [SMALL_STATE(7759)] = 275948,
  [SMALL_STATE(7760)] = 275964,
  [SMALL_STATE(7761)] = 275976,
  [SMALL_STATE(7762)] = 275992,
  [SMALL_STATE(7763)] = 276008,
  [SMALL_STATE(7764)] = 276020,
  [SMALL_STATE(7765)] = 276038,
  [SMALL_STATE(7766)] = 276054,
  [SMALL_STATE(7767)] = 276066,
  [SMALL_STATE(7768)] = 276084,
  [SMALL_STATE(7769)] = 276098,
  [SMALL_STATE(7770)] = 276112,
  [SMALL_STATE(7771)] = 276130,
  [SMALL_STATE(7772)] = 276148,
  [SMALL_STATE(7773)] = 276166,
  [SMALL_STATE(7774)] = 276182,
  [SMALL_STATE(7775)] = 276200,
  [SMALL_STATE(7776)] = 276216,
  [SMALL_STATE(7777)] = 276234,
  [SMALL_STATE(7778)] = 276252,
  [SMALL_STATE(7779)] = 276264,
  [SMALL_STATE(7780)] = 276280,
  [SMALL_STATE(7781)] = 276296,
  [SMALL_STATE(7782)] = 276314,
  [SMALL_STATE(7783)] = 276326,
  [SMALL_STATE(7784)] = 276338,
  [SMALL_STATE(7785)] = 276356,
  [SMALL_STATE(7786)] = 276372,
  [SMALL_STATE(7787)] = 276388,
  [SMALL_STATE(7788)] = 276404,
  [SMALL_STATE(7789)] = 276420,
  [SMALL_STATE(7790)] = 276436,
  [SMALL_STATE(7791)] = 276452,
  [SMALL_STATE(7792)] = 276468,
  [SMALL_STATE(7793)] = 276486,
  [SMALL_STATE(7794)] = 276504,
  [SMALL_STATE(7795)] = 276522,
  [SMALL_STATE(7796)] = 276538,
  [SMALL_STATE(7797)] = 276556,
  [SMALL_STATE(7798)] = 276574,
  [SMALL_STATE(7799)] = 276590,
  [SMALL_STATE(7800)] = 276608,
  [SMALL_STATE(7801)] = 276624,
  [SMALL_STATE(7802)] = 276640,
  [SMALL_STATE(7803)] = 276658,
  [SMALL_STATE(7804)] = 276674,
  [SMALL_STATE(7805)] = 276690,
  [SMALL_STATE(7806)] = 276706,
  [SMALL_STATE(7807)] = 276724,
  [SMALL_STATE(7808)] = 276742,
  [SMALL_STATE(7809)] = 276758,
  [SMALL_STATE(7810)] = 276774,
  [SMALL_STATE(7811)] = 276792,
  [SMALL_STATE(7812)] = 276810,
  [SMALL_STATE(7813)] = 276826,
  [SMALL_STATE(7814)] = 276842,
  [SMALL_STATE(7815)] = 276858,
  [SMALL_STATE(7816)] = 276874,
  [SMALL_STATE(7817)] = 276890,
  [SMALL_STATE(7818)] = 276906,
  [SMALL_STATE(7819)] = 276922,
  [SMALL_STATE(7820)] = 276938,
  [SMALL_STATE(7821)] = 276954,
  [SMALL_STATE(7822)] = 276972,
  [SMALL_STATE(7823)] = 276988,
  [SMALL_STATE(7824)] = 277002,
  [SMALL_STATE(7825)] = 277018,
  [SMALL_STATE(7826)] = 277034,
  [SMALL_STATE(7827)] = 277048,
  [SMALL_STATE(7828)] = 277066,
  [SMALL_STATE(7829)] = 277084,
  [SMALL_STATE(7830)] = 277098,
  [SMALL_STATE(7831)] = 277114,
  [SMALL_STATE(7832)] = 277130,
  [SMALL_STATE(7833)] = 277146,
  [SMALL_STATE(7834)] = 277164,
  [SMALL_STATE(7835)] = 277176,
  [SMALL_STATE(7836)] = 277192,
  [SMALL_STATE(7837)] = 277208,
  [SMALL_STATE(7838)] = 277224,
  [SMALL_STATE(7839)] = 277240,
  [SMALL_STATE(7840)] = 277258,
  [SMALL_STATE(7841)] = 277274,
  [SMALL_STATE(7842)] = 277290,
  [SMALL_STATE(7843)] = 277306,
  [SMALL_STATE(7844)] = 277322,
  [SMALL_STATE(7845)] = 277334,
  [SMALL_STATE(7846)] = 277352,
  [SMALL_STATE(7847)] = 277370,
  [SMALL_STATE(7848)] = 277388,
  [SMALL_STATE(7849)] = 277404,
  [SMALL_STATE(7850)] = 277422,
  [SMALL_STATE(7851)] = 277438,
  [SMALL_STATE(7852)] = 277452,
  [SMALL_STATE(7853)] = 277470,
  [SMALL_STATE(7854)] = 277488,
  [SMALL_STATE(7855)] = 277504,
  [SMALL_STATE(7856)] = 277522,
  [SMALL_STATE(7857)] = 277536,
  [SMALL_STATE(7858)] = 277552,
  [SMALL_STATE(7859)] = 277570,
  [SMALL_STATE(7860)] = 277586,
  [SMALL_STATE(7861)] = 277598,
  [SMALL_STATE(7862)] = 277616,
  [SMALL_STATE(7863)] = 277634,
  [SMALL_STATE(7864)] = 277650,
  [SMALL_STATE(7865)] = 277666,
  [SMALL_STATE(7866)] = 277682,
  [SMALL_STATE(7867)] = 277698,
  [SMALL_STATE(7868)] = 277714,
  [SMALL_STATE(7869)] = 277732,
  [SMALL_STATE(7870)] = 277750,
  [SMALL_STATE(7871)] = 277768,
  [SMALL_STATE(7872)] = 277784,
  [SMALL_STATE(7873)] = 277802,
  [SMALL_STATE(7874)] = 277818,
  [SMALL_STATE(7875)] = 277836,
  [SMALL_STATE(7876)] = 277854,
  [SMALL_STATE(7877)] = 277870,
  [SMALL_STATE(7878)] = 277888,
  [SMALL_STATE(7879)] = 277904,
  [SMALL_STATE(7880)] = 277922,
  [SMALL_STATE(7881)] = 277940,
  [SMALL_STATE(7882)] = 277956,
  [SMALL_STATE(7883)] = 277974,
  [SMALL_STATE(7884)] = 277992,
  [SMALL_STATE(7885)] = 278010,
  [SMALL_STATE(7886)] = 278026,
  [SMALL_STATE(7887)] = 278044,
  [SMALL_STATE(7888)] = 278060,
  [SMALL_STATE(7889)] = 278076,
  [SMALL_STATE(7890)] = 278092,
  [SMALL_STATE(7891)] = 278110,
  [SMALL_STATE(7892)] = 278128,
  [SMALL_STATE(7893)] = 278146,
  [SMALL_STATE(7894)] = 278162,
  [SMALL_STATE(7895)] = 278178,
  [SMALL_STATE(7896)] = 278196,
  [SMALL_STATE(7897)] = 278212,
  [SMALL_STATE(7898)] = 278230,
  [SMALL_STATE(7899)] = 278248,
  [SMALL_STATE(7900)] = 278266,
  [SMALL_STATE(7901)] = 278284,
  [SMALL_STATE(7902)] = 278302,
  [SMALL_STATE(7903)] = 278320,
  [SMALL_STATE(7904)] = 278338,
  [SMALL_STATE(7905)] = 278356,
  [SMALL_STATE(7906)] = 278374,
  [SMALL_STATE(7907)] = 278390,
  [SMALL_STATE(7908)] = 278408,
  [SMALL_STATE(7909)] = 278426,
  [SMALL_STATE(7910)] = 278444,
  [SMALL_STATE(7911)] = 278458,
  [SMALL_STATE(7912)] = 278476,
  [SMALL_STATE(7913)] = 278492,
  [SMALL_STATE(7914)] = 278504,
  [SMALL_STATE(7915)] = 278516,
  [SMALL_STATE(7916)] = 278530,
  [SMALL_STATE(7917)] = 278546,
  [SMALL_STATE(7918)] = 278564,
  [SMALL_STATE(7919)] = 278580,
  [SMALL_STATE(7920)] = 278594,
  [SMALL_STATE(7921)] = 278610,
  [SMALL_STATE(7922)] = 278626,
  [SMALL_STATE(7923)] = 278642,
  [SMALL_STATE(7924)] = 278658,
  [SMALL_STATE(7925)] = 278676,
  [SMALL_STATE(7926)] = 278692,
  [SMALL_STATE(7927)] = 278708,
  [SMALL_STATE(7928)] = 278724,
  [SMALL_STATE(7929)] = 278742,
  [SMALL_STATE(7930)] = 278758,
  [SMALL_STATE(7931)] = 278776,
  [SMALL_STATE(7932)] = 278794,
  [SMALL_STATE(7933)] = 278810,
  [SMALL_STATE(7934)] = 278828,
  [SMALL_STATE(7935)] = 278846,
  [SMALL_STATE(7936)] = 278864,
  [SMALL_STATE(7937)] = 278882,
  [SMALL_STATE(7938)] = 278898,
  [SMALL_STATE(7939)] = 278914,
  [SMALL_STATE(7940)] = 278932,
  [SMALL_STATE(7941)] = 278948,
  [SMALL_STATE(7942)] = 278960,
  [SMALL_STATE(7943)] = 278976,
  [SMALL_STATE(7944)] = 278992,
  [SMALL_STATE(7945)] = 279008,
  [SMALL_STATE(7946)] = 279024,
  [SMALL_STATE(7947)] = 279036,
  [SMALL_STATE(7948)] = 279054,
  [SMALL_STATE(7949)] = 279072,
  [SMALL_STATE(7950)] = 279090,
  [SMALL_STATE(7951)] = 279106,
  [SMALL_STATE(7952)] = 279124,
  [SMALL_STATE(7953)] = 279140,
  [SMALL_STATE(7954)] = 279154,
  [SMALL_STATE(7955)] = 279172,
  [SMALL_STATE(7956)] = 279190,
  [SMALL_STATE(7957)] = 279208,
  [SMALL_STATE(7958)] = 279220,
  [SMALL_STATE(7959)] = 279236,
  [SMALL_STATE(7960)] = 279252,
  [SMALL_STATE(7961)] = 279268,
  [SMALL_STATE(7962)] = 279284,
  [SMALL_STATE(7963)] = 279300,
  [SMALL_STATE(7964)] = 279318,
  [SMALL_STATE(7965)] = 279336,
  [SMALL_STATE(7966)] = 279354,
  [SMALL_STATE(7967)] = 279372,
  [SMALL_STATE(7968)] = 279390,
  [SMALL_STATE(7969)] = 279408,
  [SMALL_STATE(7970)] = 279420,
  [SMALL_STATE(7971)] = 279436,
  [SMALL_STATE(7972)] = 279454,
  [SMALL_STATE(7973)] = 279470,
  [SMALL_STATE(7974)] = 279488,
  [SMALL_STATE(7975)] = 279504,
  [SMALL_STATE(7976)] = 279522,
  [SMALL_STATE(7977)] = 279540,
  [SMALL_STATE(7978)] = 279556,
  [SMALL_STATE(7979)] = 279574,
  [SMALL_STATE(7980)] = 279590,
  [SMALL_STATE(7981)] = 279608,
  [SMALL_STATE(7982)] = 279624,
  [SMALL_STATE(7983)] = 279640,
  [SMALL_STATE(7984)] = 279656,
  [SMALL_STATE(7985)] = 279674,
  [SMALL_STATE(7986)] = 279690,
  [SMALL_STATE(7987)] = 279706,
  [SMALL_STATE(7988)] = 279724,
  [SMALL_STATE(7989)] = 279740,
  [SMALL_STATE(7990)] = 279756,
  [SMALL_STATE(7991)] = 279774,
  [SMALL_STATE(7992)] = 279792,
  [SMALL_STATE(7993)] = 279810,
  [SMALL_STATE(7994)] = 279826,
  [SMALL_STATE(7995)] = 279842,
  [SMALL_STATE(7996)] = 279860,
  [SMALL_STATE(7997)] = 279878,
  [SMALL_STATE(7998)] = 279896,
  [SMALL_STATE(7999)] = 279912,
  [SMALL_STATE(8000)] = 279928,
  [SMALL_STATE(8001)] = 279944,
  [SMALL_STATE(8002)] = 279960,
  [SMALL_STATE(8003)] = 279978,
  [SMALL_STATE(8004)] = 279994,
  [SMALL_STATE(8005)] = 280012,
  [SMALL_STATE(8006)] = 280030,
  [SMALL_STATE(8007)] = 280042,
  [SMALL_STATE(8008)] = 280060,
  [SMALL_STATE(8009)] = 280078,
  [SMALL_STATE(8010)] = 280096,
  [SMALL_STATE(8011)] = 280114,
  [SMALL_STATE(8012)] = 280132,
  [SMALL_STATE(8013)] = 280148,
  [SMALL_STATE(8014)] = 280164,
  [SMALL_STATE(8015)] = 280182,
  [SMALL_STATE(8016)] = 280198,
  [SMALL_STATE(8017)] = 280214,
  [SMALL_STATE(8018)] = 280230,
  [SMALL_STATE(8019)] = 280248,
  [SMALL_STATE(8020)] = 280264,
  [SMALL_STATE(8021)] = 280280,
  [SMALL_STATE(8022)] = 280296,
  [SMALL_STATE(8023)] = 280314,
  [SMALL_STATE(8024)] = 280330,
  [SMALL_STATE(8025)] = 280346,
  [SMALL_STATE(8026)] = 280362,
  [SMALL_STATE(8027)] = 280380,
  [SMALL_STATE(8028)] = 280396,
  [SMALL_STATE(8029)] = 280414,
  [SMALL_STATE(8030)] = 280432,
  [SMALL_STATE(8031)] = 280448,
  [SMALL_STATE(8032)] = 280466,
  [SMALL_STATE(8033)] = 280484,
  [SMALL_STATE(8034)] = 280500,
  [SMALL_STATE(8035)] = 280518,
  [SMALL_STATE(8036)] = 280534,
  [SMALL_STATE(8037)] = 280549,
  [SMALL_STATE(8038)] = 280564,
  [SMALL_STATE(8039)] = 280579,
  [SMALL_STATE(8040)] = 280594,
  [SMALL_STATE(8041)] = 280609,
  [SMALL_STATE(8042)] = 280624,
  [SMALL_STATE(8043)] = 280635,
  [SMALL_STATE(8044)] = 280650,
  [SMALL_STATE(8045)] = 280665,
  [SMALL_STATE(8046)] = 280680,
  [SMALL_STATE(8047)] = 280695,
  [SMALL_STATE(8048)] = 280710,
  [SMALL_STATE(8049)] = 280721,
  [SMALL_STATE(8050)] = 280736,
  [SMALL_STATE(8051)] = 280747,
  [SMALL_STATE(8052)] = 280758,
  [SMALL_STATE(8053)] = 280773,
  [SMALL_STATE(8054)] = 280788,
  [SMALL_STATE(8055)] = 280803,
  [SMALL_STATE(8056)] = 280814,
  [SMALL_STATE(8057)] = 280825,
  [SMALL_STATE(8058)] = 280840,
  [SMALL_STATE(8059)] = 280851,
  [SMALL_STATE(8060)] = 280862,
  [SMALL_STATE(8061)] = 280873,
  [SMALL_STATE(8062)] = 280888,
  [SMALL_STATE(8063)] = 280903,
  [SMALL_STATE(8064)] = 280918,
  [SMALL_STATE(8065)] = 280933,
  [SMALL_STATE(8066)] = 280946,
  [SMALL_STATE(8067)] = 280957,
  [SMALL_STATE(8068)] = 280972,
  [SMALL_STATE(8069)] = 280987,
  [SMALL_STATE(8070)] = 280998,
  [SMALL_STATE(8071)] = 281013,
  [SMALL_STATE(8072)] = 281024,
  [SMALL_STATE(8073)] = 281035,
  [SMALL_STATE(8074)] = 281050,
  [SMALL_STATE(8075)] = 281065,
  [SMALL_STATE(8076)] = 281076,
  [SMALL_STATE(8077)] = 281091,
  [SMALL_STATE(8078)] = 281102,
  [SMALL_STATE(8079)] = 281117,
  [SMALL_STATE(8080)] = 281132,
  [SMALL_STATE(8081)] = 281145,
  [SMALL_STATE(8082)] = 281160,
  [SMALL_STATE(8083)] = 281171,
  [SMALL_STATE(8084)] = 281186,
  [SMALL_STATE(8085)] = 281201,
  [SMALL_STATE(8086)] = 281216,
  [SMALL_STATE(8087)] = 281227,
  [SMALL_STATE(8088)] = 281238,
  [SMALL_STATE(8089)] = 281253,
  [SMALL_STATE(8090)] = 281268,
  [SMALL_STATE(8091)] = 281283,
  [SMALL_STATE(8092)] = 281298,
  [SMALL_STATE(8093)] = 281309,
  [SMALL_STATE(8094)] = 281324,
  [SMALL_STATE(8095)] = 281339,
  [SMALL_STATE(8096)] = 281354,
  [SMALL_STATE(8097)] = 281369,
  [SMALL_STATE(8098)] = 281382,
  [SMALL_STATE(8099)] = 281397,
  [SMALL_STATE(8100)] = 281412,
  [SMALL_STATE(8101)] = 281427,
  [SMALL_STATE(8102)] = 281438,
  [SMALL_STATE(8103)] = 281453,
  [SMALL_STATE(8104)] = 281468,
  [SMALL_STATE(8105)] = 281479,
  [SMALL_STATE(8106)] = 281494,
  [SMALL_STATE(8107)] = 281505,
  [SMALL_STATE(8108)] = 281518,
  [SMALL_STATE(8109)] = 281533,
  [SMALL_STATE(8110)] = 281544,
  [SMALL_STATE(8111)] = 281555,
  [SMALL_STATE(8112)] = 281566,
  [SMALL_STATE(8113)] = 281581,
  [SMALL_STATE(8114)] = 281596,
  [SMALL_STATE(8115)] = 281607,
  [SMALL_STATE(8116)] = 281622,
  [SMALL_STATE(8117)] = 281633,
  [SMALL_STATE(8118)] = 281644,
  [SMALL_STATE(8119)] = 281659,
  [SMALL_STATE(8120)] = 281674,
  [SMALL_STATE(8121)] = 281685,
  [SMALL_STATE(8122)] = 281700,
  [SMALL_STATE(8123)] = 281711,
  [SMALL_STATE(8124)] = 281726,
  [SMALL_STATE(8125)] = 281737,
  [SMALL_STATE(8126)] = 281748,
  [SMALL_STATE(8127)] = 281761,
  [SMALL_STATE(8128)] = 281776,
  [SMALL_STATE(8129)] = 281791,
  [SMALL_STATE(8130)] = 281806,
  [SMALL_STATE(8131)] = 281821,
  [SMALL_STATE(8132)] = 281832,
  [SMALL_STATE(8133)] = 281847,
  [SMALL_STATE(8134)] = 281858,
  [SMALL_STATE(8135)] = 281869,
  [SMALL_STATE(8136)] = 281884,
  [SMALL_STATE(8137)] = 281899,
  [SMALL_STATE(8138)] = 281914,
  [SMALL_STATE(8139)] = 281927,
  [SMALL_STATE(8140)] = 281942,
  [SMALL_STATE(8141)] = 281957,
  [SMALL_STATE(8142)] = 281972,
  [SMALL_STATE(8143)] = 281985,
  [SMALL_STATE(8144)] = 282000,
  [SMALL_STATE(8145)] = 282013,
  [SMALL_STATE(8146)] = 282028,
  [SMALL_STATE(8147)] = 282043,
  [SMALL_STATE(8148)] = 282058,
  [SMALL_STATE(8149)] = 282069,
  [SMALL_STATE(8150)] = 282084,
  [SMALL_STATE(8151)] = 282099,
  [SMALL_STATE(8152)] = 282114,
  [SMALL_STATE(8153)] = 282129,
  [SMALL_STATE(8154)] = 282144,
  [SMALL_STATE(8155)] = 282159,
  [SMALL_STATE(8156)] = 282170,
  [SMALL_STATE(8157)] = 282181,
  [SMALL_STATE(8158)] = 282192,
  [SMALL_STATE(8159)] = 282207,
  [SMALL_STATE(8160)] = 282222,
  [SMALL_STATE(8161)] = 282233,
  [SMALL_STATE(8162)] = 282248,
  [SMALL_STATE(8163)] = 282259,
  [SMALL_STATE(8164)] = 282270,
  [SMALL_STATE(8165)] = 282285,
  [SMALL_STATE(8166)] = 282300,
  [SMALL_STATE(8167)] = 282315,
  [SMALL_STATE(8168)] = 282326,
  [SMALL_STATE(8169)] = 282341,
  [SMALL_STATE(8170)] = 282356,
  [SMALL_STATE(8171)] = 282371,
  [SMALL_STATE(8172)] = 282384,
  [SMALL_STATE(8173)] = 282399,
  [SMALL_STATE(8174)] = 282414,
  [SMALL_STATE(8175)] = 282429,
  [SMALL_STATE(8176)] = 282444,
  [SMALL_STATE(8177)] = 282455,
  [SMALL_STATE(8178)] = 282470,
  [SMALL_STATE(8179)] = 282481,
  [SMALL_STATE(8180)] = 282492,
  [SMALL_STATE(8181)] = 282507,
  [SMALL_STATE(8182)] = 282518,
  [SMALL_STATE(8183)] = 282533,
  [SMALL_STATE(8184)] = 282548,
  [SMALL_STATE(8185)] = 282559,
  [SMALL_STATE(8186)] = 282574,
  [SMALL_STATE(8187)] = 282589,
  [SMALL_STATE(8188)] = 282604,
  [SMALL_STATE(8189)] = 282619,
  [SMALL_STATE(8190)] = 282634,
  [SMALL_STATE(8191)] = 282649,
  [SMALL_STATE(8192)] = 282664,
  [SMALL_STATE(8193)] = 282679,
  [SMALL_STATE(8194)] = 282690,
  [SMALL_STATE(8195)] = 282701,
  [SMALL_STATE(8196)] = 282716,
  [SMALL_STATE(8197)] = 282731,
  [SMALL_STATE(8198)] = 282746,
  [SMALL_STATE(8199)] = 282761,
  [SMALL_STATE(8200)] = 282776,
  [SMALL_STATE(8201)] = 282791,
  [SMALL_STATE(8202)] = 282806,
  [SMALL_STATE(8203)] = 282821,
  [SMALL_STATE(8204)] = 282836,
  [SMALL_STATE(8205)] = 282851,
  [SMALL_STATE(8206)] = 282866,
  [SMALL_STATE(8207)] = 282881,
  [SMALL_STATE(8208)] = 282896,
  [SMALL_STATE(8209)] = 282907,
  [SMALL_STATE(8210)] = 282922,
  [SMALL_STATE(8211)] = 282937,
  [SMALL_STATE(8212)] = 282948,
  [SMALL_STATE(8213)] = 282963,
  [SMALL_STATE(8214)] = 282974,
  [SMALL_STATE(8215)] = 282989,
  [SMALL_STATE(8216)] = 283000,
  [SMALL_STATE(8217)] = 283011,
  [SMALL_STATE(8218)] = 283022,
  [SMALL_STATE(8219)] = 283033,
  [SMALL_STATE(8220)] = 283044,
  [SMALL_STATE(8221)] = 283059,
  [SMALL_STATE(8222)] = 283074,
  [SMALL_STATE(8223)] = 283085,
  [SMALL_STATE(8224)] = 283100,
  [SMALL_STATE(8225)] = 283115,
  [SMALL_STATE(8226)] = 283130,
  [SMALL_STATE(8227)] = 283145,
  [SMALL_STATE(8228)] = 283160,
  [SMALL_STATE(8229)] = 283175,
  [SMALL_STATE(8230)] = 283186,
  [SMALL_STATE(8231)] = 283201,
  [SMALL_STATE(8232)] = 283216,
  [SMALL_STATE(8233)] = 283231,
  [SMALL_STATE(8234)] = 283246,
  [SMALL_STATE(8235)] = 283261,
  [SMALL_STATE(8236)] = 283276,
  [SMALL_STATE(8237)] = 283291,
  [SMALL_STATE(8238)] = 283306,
  [SMALL_STATE(8239)] = 283321,
  [SMALL_STATE(8240)] = 283336,
  [SMALL_STATE(8241)] = 283351,
  [SMALL_STATE(8242)] = 283366,
  [SMALL_STATE(8243)] = 283381,
  [SMALL_STATE(8244)] = 283396,
  [SMALL_STATE(8245)] = 283411,
  [SMALL_STATE(8246)] = 283422,
  [SMALL_STATE(8247)] = 283435,
  [SMALL_STATE(8248)] = 283446,
  [SMALL_STATE(8249)] = 283457,
  [SMALL_STATE(8250)] = 283472,
  [SMALL_STATE(8251)] = 283487,
  [SMALL_STATE(8252)] = 283498,
  [SMALL_STATE(8253)] = 283513,
  [SMALL_STATE(8254)] = 283528,
  [SMALL_STATE(8255)] = 283543,
  [SMALL_STATE(8256)] = 283558,
  [SMALL_STATE(8257)] = 283569,
  [SMALL_STATE(8258)] = 283584,
  [SMALL_STATE(8259)] = 283599,
  [SMALL_STATE(8260)] = 283610,
  [SMALL_STATE(8261)] = 283621,
  [SMALL_STATE(8262)] = 283636,
  [SMALL_STATE(8263)] = 283651,
  [SMALL_STATE(8264)] = 283666,
  [SMALL_STATE(8265)] = 283681,
  [SMALL_STATE(8266)] = 283696,
  [SMALL_STATE(8267)] = 283711,
  [SMALL_STATE(8268)] = 283726,
  [SMALL_STATE(8269)] = 283737,
  [SMALL_STATE(8270)] = 283748,
  [SMALL_STATE(8271)] = 283763,
  [SMALL_STATE(8272)] = 283778,
  [SMALL_STATE(8273)] = 283793,
  [SMALL_STATE(8274)] = 283804,
  [SMALL_STATE(8275)] = 283819,
  [SMALL_STATE(8276)] = 283830,
  [SMALL_STATE(8277)] = 283845,
  [SMALL_STATE(8278)] = 283856,
  [SMALL_STATE(8279)] = 283869,
  [SMALL_STATE(8280)] = 283884,
  [SMALL_STATE(8281)] = 283899,
  [SMALL_STATE(8282)] = 283914,
  [SMALL_STATE(8283)] = 283929,
  [SMALL_STATE(8284)] = 283940,
  [SMALL_STATE(8285)] = 283955,
  [SMALL_STATE(8286)] = 283970,
  [SMALL_STATE(8287)] = 283985,
  [SMALL_STATE(8288)] = 284000,
  [SMALL_STATE(8289)] = 284015,
  [SMALL_STATE(8290)] = 284030,
  [SMALL_STATE(8291)] = 284045,
  [SMALL_STATE(8292)] = 284060,
  [SMALL_STATE(8293)] = 284075,
  [SMALL_STATE(8294)] = 284090,
  [SMALL_STATE(8295)] = 284105,
  [SMALL_STATE(8296)] = 284116,
  [SMALL_STATE(8297)] = 284127,
  [SMALL_STATE(8298)] = 284142,
  [SMALL_STATE(8299)] = 284157,
  [SMALL_STATE(8300)] = 284172,
  [SMALL_STATE(8301)] = 284187,
  [SMALL_STATE(8302)] = 284202,
  [SMALL_STATE(8303)] = 284217,
  [SMALL_STATE(8304)] = 284232,
  [SMALL_STATE(8305)] = 284247,
  [SMALL_STATE(8306)] = 284262,
  [SMALL_STATE(8307)] = 284277,
  [SMALL_STATE(8308)] = 284292,
  [SMALL_STATE(8309)] = 284303,
  [SMALL_STATE(8310)] = 284318,
  [SMALL_STATE(8311)] = 284333,
  [SMALL_STATE(8312)] = 284348,
  [SMALL_STATE(8313)] = 284363,
  [SMALL_STATE(8314)] = 284378,
  [SMALL_STATE(8315)] = 284393,
  [SMALL_STATE(8316)] = 284408,
  [SMALL_STATE(8317)] = 284419,
  [SMALL_STATE(8318)] = 284434,
  [SMALL_STATE(8319)] = 284445,
  [SMALL_STATE(8320)] = 284456,
  [SMALL_STATE(8321)] = 284467,
  [SMALL_STATE(8322)] = 284482,
  [SMALL_STATE(8323)] = 284495,
  [SMALL_STATE(8324)] = 284510,
  [SMALL_STATE(8325)] = 284525,
  [SMALL_STATE(8326)] = 284540,
  [SMALL_STATE(8327)] = 284555,
  [SMALL_STATE(8328)] = 284570,
  [SMALL_STATE(8329)] = 284585,
  [SMALL_STATE(8330)] = 284600,
  [SMALL_STATE(8331)] = 284615,
  [SMALL_STATE(8332)] = 284626,
  [SMALL_STATE(8333)] = 284641,
  [SMALL_STATE(8334)] = 284656,
  [SMALL_STATE(8335)] = 284671,
  [SMALL_STATE(8336)] = 284686,
  [SMALL_STATE(8337)] = 284701,
  [SMALL_STATE(8338)] = 284716,
  [SMALL_STATE(8339)] = 284731,
  [SMALL_STATE(8340)] = 284746,
  [SMALL_STATE(8341)] = 284761,
  [SMALL_STATE(8342)] = 284772,
  [SMALL_STATE(8343)] = 284787,
  [SMALL_STATE(8344)] = 284802,
  [SMALL_STATE(8345)] = 284817,
  [SMALL_STATE(8346)] = 284832,
  [SMALL_STATE(8347)] = 284847,
  [SMALL_STATE(8348)] = 284862,
  [SMALL_STATE(8349)] = 284873,
  [SMALL_STATE(8350)] = 284884,
  [SMALL_STATE(8351)] = 284897,
  [SMALL_STATE(8352)] = 284908,
  [SMALL_STATE(8353)] = 284923,
  [SMALL_STATE(8354)] = 284934,
  [SMALL_STATE(8355)] = 284949,
  [SMALL_STATE(8356)] = 284960,
  [SMALL_STATE(8357)] = 284975,
  [SMALL_STATE(8358)] = 284990,
  [SMALL_STATE(8359)] = 285005,
  [SMALL_STATE(8360)] = 285018,
  [SMALL_STATE(8361)] = 285031,
  [SMALL_STATE(8362)] = 285046,
  [SMALL_STATE(8363)] = 285061,
  [SMALL_STATE(8364)] = 285076,
  [SMALL_STATE(8365)] = 285091,
  [SMALL_STATE(8366)] = 285106,
  [SMALL_STATE(8367)] = 285121,
  [SMALL_STATE(8368)] = 285136,
  [SMALL_STATE(8369)] = 285151,
  [SMALL_STATE(8370)] = 285164,
  [SMALL_STATE(8371)] = 285175,
  [SMALL_STATE(8372)] = 285186,
  [SMALL_STATE(8373)] = 285201,
  [SMALL_STATE(8374)] = 285216,
  [SMALL_STATE(8375)] = 285231,
  [SMALL_STATE(8376)] = 285242,
  [SMALL_STATE(8377)] = 285253,
  [SMALL_STATE(8378)] = 285268,
  [SMALL_STATE(8379)] = 285283,
  [SMALL_STATE(8380)] = 285298,
  [SMALL_STATE(8381)] = 285313,
  [SMALL_STATE(8382)] = 285328,
  [SMALL_STATE(8383)] = 285343,
  [SMALL_STATE(8384)] = 285358,
  [SMALL_STATE(8385)] = 285373,
  [SMALL_STATE(8386)] = 285388,
  [SMALL_STATE(8387)] = 285403,
  [SMALL_STATE(8388)] = 285418,
  [SMALL_STATE(8389)] = 285433,
  [SMALL_STATE(8390)] = 285446,
  [SMALL_STATE(8391)] = 285457,
  [SMALL_STATE(8392)] = 285472,
  [SMALL_STATE(8393)] = 285487,
  [SMALL_STATE(8394)] = 285502,
  [SMALL_STATE(8395)] = 285517,
  [SMALL_STATE(8396)] = 285528,
  [SMALL_STATE(8397)] = 285539,
  [SMALL_STATE(8398)] = 285554,
  [SMALL_STATE(8399)] = 285565,
  [SMALL_STATE(8400)] = 285580,
  [SMALL_STATE(8401)] = 285595,
  [SMALL_STATE(8402)] = 285610,
  [SMALL_STATE(8403)] = 285621,
  [SMALL_STATE(8404)] = 285636,
  [SMALL_STATE(8405)] = 285651,
  [SMALL_STATE(8406)] = 285666,
  [SMALL_STATE(8407)] = 285681,
  [SMALL_STATE(8408)] = 285696,
  [SMALL_STATE(8409)] = 285711,
  [SMALL_STATE(8410)] = 285726,
  [SMALL_STATE(8411)] = 285737,
  [SMALL_STATE(8412)] = 285748,
  [SMALL_STATE(8413)] = 285763,
  [SMALL_STATE(8414)] = 285774,
  [SMALL_STATE(8415)] = 285789,
  [SMALL_STATE(8416)] = 285800,
  [SMALL_STATE(8417)] = 285811,
  [SMALL_STATE(8418)] = 285826,
  [SMALL_STATE(8419)] = 285837,
  [SMALL_STATE(8420)] = 285850,
  [SMALL_STATE(8421)] = 285865,
  [SMALL_STATE(8422)] = 285880,
  [SMALL_STATE(8423)] = 285891,
  [SMALL_STATE(8424)] = 285902,
  [SMALL_STATE(8425)] = 285917,
  [SMALL_STATE(8426)] = 285932,
  [SMALL_STATE(8427)] = 285943,
  [SMALL_STATE(8428)] = 285958,
  [SMALL_STATE(8429)] = 285969,
  [SMALL_STATE(8430)] = 285984,
  [SMALL_STATE(8431)] = 285999,
  [SMALL_STATE(8432)] = 286014,
  [SMALL_STATE(8433)] = 286029,
  [SMALL_STATE(8434)] = 286044,
  [SMALL_STATE(8435)] = 286059,
  [SMALL_STATE(8436)] = 286074,
  [SMALL_STATE(8437)] = 286089,
  [SMALL_STATE(8438)] = 286100,
  [SMALL_STATE(8439)] = 286113,
  [SMALL_STATE(8440)] = 286128,
  [SMALL_STATE(8441)] = 286139,
  [SMALL_STATE(8442)] = 286154,
  [SMALL_STATE(8443)] = 286165,
  [SMALL_STATE(8444)] = 286176,
  [SMALL_STATE(8445)] = 286191,
  [SMALL_STATE(8446)] = 286206,
  [SMALL_STATE(8447)] = 286217,
  [SMALL_STATE(8448)] = 286232,
  [SMALL_STATE(8449)] = 286247,
  [SMALL_STATE(8450)] = 286260,
  [SMALL_STATE(8451)] = 286275,
  [SMALL_STATE(8452)] = 286290,
  [SMALL_STATE(8453)] = 286305,
  [SMALL_STATE(8454)] = 286320,
  [SMALL_STATE(8455)] = 286335,
  [SMALL_STATE(8456)] = 286346,
  [SMALL_STATE(8457)] = 286361,
  [SMALL_STATE(8458)] = 286376,
  [SMALL_STATE(8459)] = 286391,
  [SMALL_STATE(8460)] = 286406,
  [SMALL_STATE(8461)] = 286421,
  [SMALL_STATE(8462)] = 286436,
  [SMALL_STATE(8463)] = 286451,
  [SMALL_STATE(8464)] = 286462,
  [SMALL_STATE(8465)] = 286477,
  [SMALL_STATE(8466)] = 286492,
  [SMALL_STATE(8467)] = 286503,
  [SMALL_STATE(8468)] = 286514,
  [SMALL_STATE(8469)] = 286529,
  [SMALL_STATE(8470)] = 286544,
  [SMALL_STATE(8471)] = 286555,
  [SMALL_STATE(8472)] = 286570,
  [SMALL_STATE(8473)] = 286585,
  [SMALL_STATE(8474)] = 286600,
  [SMALL_STATE(8475)] = 286615,
  [SMALL_STATE(8476)] = 286630,
  [SMALL_STATE(8477)] = 286641,
  [SMALL_STATE(8478)] = 286656,
  [SMALL_STATE(8479)] = 286671,
  [SMALL_STATE(8480)] = 286686,
  [SMALL_STATE(8481)] = 286701,
  [SMALL_STATE(8482)] = 286716,
  [SMALL_STATE(8483)] = 286731,
  [SMALL_STATE(8484)] = 286742,
  [SMALL_STATE(8485)] = 286753,
  [SMALL_STATE(8486)] = 286768,
  [SMALL_STATE(8487)] = 286781,
  [SMALL_STATE(8488)] = 286796,
  [SMALL_STATE(8489)] = 286811,
  [SMALL_STATE(8490)] = 286826,
  [SMALL_STATE(8491)] = 286837,
  [SMALL_STATE(8492)] = 286852,
  [SMALL_STATE(8493)] = 286867,
  [SMALL_STATE(8494)] = 286882,
  [SMALL_STATE(8495)] = 286897,
  [SMALL_STATE(8496)] = 286912,
  [SMALL_STATE(8497)] = 286927,
  [SMALL_STATE(8498)] = 286942,
  [SMALL_STATE(8499)] = 286957,
  [SMALL_STATE(8500)] = 286972,
  [SMALL_STATE(8501)] = 286987,
  [SMALL_STATE(8502)] = 287002,
  [SMALL_STATE(8503)] = 287013,
  [SMALL_STATE(8504)] = 287028,
  [SMALL_STATE(8505)] = 287039,
  [SMALL_STATE(8506)] = 287050,
  [SMALL_STATE(8507)] = 287065,
  [SMALL_STATE(8508)] = 287080,
  [SMALL_STATE(8509)] = 287091,
  [SMALL_STATE(8510)] = 287106,
  [SMALL_STATE(8511)] = 287121,
  [SMALL_STATE(8512)] = 287132,
  [SMALL_STATE(8513)] = 287143,
  [SMALL_STATE(8514)] = 287158,
  [SMALL_STATE(8515)] = 287169,
  [SMALL_STATE(8516)] = 287180,
  [SMALL_STATE(8517)] = 287195,
  [SMALL_STATE(8518)] = 287210,
  [SMALL_STATE(8519)] = 287225,
  [SMALL_STATE(8520)] = 287240,
  [SMALL_STATE(8521)] = 287255,
  [SMALL_STATE(8522)] = 287270,
  [SMALL_STATE(8523)] = 287285,
  [SMALL_STATE(8524)] = 287300,
  [SMALL_STATE(8525)] = 287315,
  [SMALL_STATE(8526)] = 287330,
  [SMALL_STATE(8527)] = 287345,
  [SMALL_STATE(8528)] = 287360,
  [SMALL_STATE(8529)] = 287375,
  [SMALL_STATE(8530)] = 287390,
  [SMALL_STATE(8531)] = 287401,
  [SMALL_STATE(8532)] = 287416,
  [SMALL_STATE(8533)] = 287427,
  [SMALL_STATE(8534)] = 287442,
  [SMALL_STATE(8535)] = 287457,
  [SMALL_STATE(8536)] = 287472,
  [SMALL_STATE(8537)] = 287487,
  [SMALL_STATE(8538)] = 287498,
  [SMALL_STATE(8539)] = 287513,
  [SMALL_STATE(8540)] = 287528,
  [SMALL_STATE(8541)] = 287539,
  [SMALL_STATE(8542)] = 287554,
  [SMALL_STATE(8543)] = 287569,
  [SMALL_STATE(8544)] = 287584,
  [SMALL_STATE(8545)] = 287595,
  [SMALL_STATE(8546)] = 287610,
  [SMALL_STATE(8547)] = 287625,
  [SMALL_STATE(8548)] = 287636,
  [SMALL_STATE(8549)] = 287647,
  [SMALL_STATE(8550)] = 287662,
  [SMALL_STATE(8551)] = 287673,
  [SMALL_STATE(8552)] = 287688,
  [SMALL_STATE(8553)] = 287699,
  [SMALL_STATE(8554)] = 287714,
  [SMALL_STATE(8555)] = 287725,
  [SMALL_STATE(8556)] = 287740,
  [SMALL_STATE(8557)] = 287755,
  [SMALL_STATE(8558)] = 287766,
  [SMALL_STATE(8559)] = 287781,
  [SMALL_STATE(8560)] = 287796,
  [SMALL_STATE(8561)] = 287811,
  [SMALL_STATE(8562)] = 287826,
  [SMALL_STATE(8563)] = 287841,
  [SMALL_STATE(8564)] = 287856,
  [SMALL_STATE(8565)] = 287871,
  [SMALL_STATE(8566)] = 287886,
  [SMALL_STATE(8567)] = 287901,
  [SMALL_STATE(8568)] = 287916,
  [SMALL_STATE(8569)] = 287931,
  [SMALL_STATE(8570)] = 287946,
  [SMALL_STATE(8571)] = 287957,
  [SMALL_STATE(8572)] = 287968,
  [SMALL_STATE(8573)] = 287983,
  [SMALL_STATE(8574)] = 287994,
  [SMALL_STATE(8575)] = 288005,
  [SMALL_STATE(8576)] = 288020,
  [SMALL_STATE(8577)] = 288035,
  [SMALL_STATE(8578)] = 288050,
  [SMALL_STATE(8579)] = 288061,
  [SMALL_STATE(8580)] = 288074,
  [SMALL_STATE(8581)] = 288089,
  [SMALL_STATE(8582)] = 288104,
  [SMALL_STATE(8583)] = 288117,
  [SMALL_STATE(8584)] = 288132,
  [SMALL_STATE(8585)] = 288143,
  [SMALL_STATE(8586)] = 288158,
  [SMALL_STATE(8587)] = 288169,
  [SMALL_STATE(8588)] = 288180,
  [SMALL_STATE(8589)] = 288191,
  [SMALL_STATE(8590)] = 288202,
  [SMALL_STATE(8591)] = 288213,
  [SMALL_STATE(8592)] = 288228,
  [SMALL_STATE(8593)] = 288239,
  [SMALL_STATE(8594)] = 288254,
  [SMALL_STATE(8595)] = 288265,
  [SMALL_STATE(8596)] = 288280,
  [SMALL_STATE(8597)] = 288293,
  [SMALL_STATE(8598)] = 288304,
  [SMALL_STATE(8599)] = 288317,
  [SMALL_STATE(8600)] = 288332,
  [SMALL_STATE(8601)] = 288347,
  [SMALL_STATE(8602)] = 288360,
  [SMALL_STATE(8603)] = 288375,
  [SMALL_STATE(8604)] = 288388,
  [SMALL_STATE(8605)] = 288401,
  [SMALL_STATE(8606)] = 288416,
  [SMALL_STATE(8607)] = 288429,
  [SMALL_STATE(8608)] = 288444,
  [SMALL_STATE(8609)] = 288459,
  [SMALL_STATE(8610)] = 288474,
  [SMALL_STATE(8611)] = 288489,
  [SMALL_STATE(8612)] = 288499,
  [SMALL_STATE(8613)] = 288511,
  [SMALL_STATE(8614)] = 288523,
  [SMALL_STATE(8615)] = 288535,
  [SMALL_STATE(8616)] = 288547,
  [SMALL_STATE(8617)] = 288557,
  [SMALL_STATE(8618)] = 288567,
  [SMALL_STATE(8619)] = 288579,
  [SMALL_STATE(8620)] = 288589,
  [SMALL_STATE(8621)] = 288599,
  [SMALL_STATE(8622)] = 288611,
  [SMALL_STATE(8623)] = 288623,
  [SMALL_STATE(8624)] = 288635,
  [SMALL_STATE(8625)] = 288645,
  [SMALL_STATE(8626)] = 288655,
  [SMALL_STATE(8627)] = 288665,
  [SMALL_STATE(8628)] = 288675,
  [SMALL_STATE(8629)] = 288685,
  [SMALL_STATE(8630)] = 288695,
  [SMALL_STATE(8631)] = 288707,
  [SMALL_STATE(8632)] = 288717,
  [SMALL_STATE(8633)] = 288727,
  [SMALL_STATE(8634)] = 288737,
  [SMALL_STATE(8635)] = 288747,
  [SMALL_STATE(8636)] = 288757,
  [SMALL_STATE(8637)] = 288769,
  [SMALL_STATE(8638)] = 288781,
  [SMALL_STATE(8639)] = 288791,
  [SMALL_STATE(8640)] = 288801,
  [SMALL_STATE(8641)] = 288811,
  [SMALL_STATE(8642)] = 288821,
  [SMALL_STATE(8643)] = 288831,
  [SMALL_STATE(8644)] = 288841,
  [SMALL_STATE(8645)] = 288851,
  [SMALL_STATE(8646)] = 288861,
  [SMALL_STATE(8647)] = 288871,
  [SMALL_STATE(8648)] = 288881,
  [SMALL_STATE(8649)] = 288893,
  [SMALL_STATE(8650)] = 288903,
  [SMALL_STATE(8651)] = 288913,
  [SMALL_STATE(8652)] = 288923,
  [SMALL_STATE(8653)] = 288933,
  [SMALL_STATE(8654)] = 288945,
  [SMALL_STATE(8655)] = 288957,
  [SMALL_STATE(8656)] = 288969,
  [SMALL_STATE(8657)] = 288981,
  [SMALL_STATE(8658)] = 288991,
  [SMALL_STATE(8659)] = 289003,
  [SMALL_STATE(8660)] = 289013,
  [SMALL_STATE(8661)] = 289023,
  [SMALL_STATE(8662)] = 289035,
  [SMALL_STATE(8663)] = 289047,
  [SMALL_STATE(8664)] = 289059,
  [SMALL_STATE(8665)] = 289069,
  [SMALL_STATE(8666)] = 289079,
  [SMALL_STATE(8667)] = 289089,
  [SMALL_STATE(8668)] = 289099,
  [SMALL_STATE(8669)] = 289111,
  [SMALL_STATE(8670)] = 289123,
  [SMALL_STATE(8671)] = 289133,
  [SMALL_STATE(8672)] = 289143,
  [SMALL_STATE(8673)] = 289155,
  [SMALL_STATE(8674)] = 289167,
  [SMALL_STATE(8675)] = 289179,
  [SMALL_STATE(8676)] = 289191,
  [SMALL_STATE(8677)] = 289203,
  [SMALL_STATE(8678)] = 289215,
  [SMALL_STATE(8679)] = 289227,
  [SMALL_STATE(8680)] = 289237,
  [SMALL_STATE(8681)] = 289247,
  [SMALL_STATE(8682)] = 289257,
  [SMALL_STATE(8683)] = 289267,
  [SMALL_STATE(8684)] = 289277,
  [SMALL_STATE(8685)] = 289289,
  [SMALL_STATE(8686)] = 289299,
  [SMALL_STATE(8687)] = 289309,
  [SMALL_STATE(8688)] = 289321,
  [SMALL_STATE(8689)] = 289331,
  [SMALL_STATE(8690)] = 289341,
  [SMALL_STATE(8691)] = 289353,
  [SMALL_STATE(8692)] = 289365,
  [SMALL_STATE(8693)] = 289377,
  [SMALL_STATE(8694)] = 289389,
  [SMALL_STATE(8695)] = 289401,
  [SMALL_STATE(8696)] = 289413,
  [SMALL_STATE(8697)] = 289425,
  [SMALL_STATE(8698)] = 289435,
  [SMALL_STATE(8699)] = 289447,
  [SMALL_STATE(8700)] = 289459,
  [SMALL_STATE(8701)] = 289471,
  [SMALL_STATE(8702)] = 289483,
  [SMALL_STATE(8703)] = 289495,
  [SMALL_STATE(8704)] = 289507,
  [SMALL_STATE(8705)] = 289517,
  [SMALL_STATE(8706)] = 289529,
  [SMALL_STATE(8707)] = 289541,
  [SMALL_STATE(8708)] = 289553,
  [SMALL_STATE(8709)] = 289565,
  [SMALL_STATE(8710)] = 289577,
  [SMALL_STATE(8711)] = 289589,
  [SMALL_STATE(8712)] = 289601,
  [SMALL_STATE(8713)] = 289613,
  [SMALL_STATE(8714)] = 289625,
  [SMALL_STATE(8715)] = 289637,
  [SMALL_STATE(8716)] = 289649,
  [SMALL_STATE(8717)] = 289661,
  [SMALL_STATE(8718)] = 289673,
  [SMALL_STATE(8719)] = 289685,
  [SMALL_STATE(8720)] = 289695,
  [SMALL_STATE(8721)] = 289707,
  [SMALL_STATE(8722)] = 289719,
  [SMALL_STATE(8723)] = 289731,
  [SMALL_STATE(8724)] = 289743,
  [SMALL_STATE(8725)] = 289755,
  [SMALL_STATE(8726)] = 289767,
  [SMALL_STATE(8727)] = 289779,
  [SMALL_STATE(8728)] = 289791,
  [SMALL_STATE(8729)] = 289803,
  [SMALL_STATE(8730)] = 289815,
  [SMALL_STATE(8731)] = 289827,
  [SMALL_STATE(8732)] = 289839,
  [SMALL_STATE(8733)] = 289849,
  [SMALL_STATE(8734)] = 289861,
  [SMALL_STATE(8735)] = 289873,
  [SMALL_STATE(8736)] = 289885,
  [SMALL_STATE(8737)] = 289897,
  [SMALL_STATE(8738)] = 289909,
  [SMALL_STATE(8739)] = 289921,
  [SMALL_STATE(8740)] = 289933,
  [SMALL_STATE(8741)] = 289942,
  [SMALL_STATE(8742)] = 289951,
  [SMALL_STATE(8743)] = 289960,
  [SMALL_STATE(8744)] = 289969,
  [SMALL_STATE(8745)] = 289978,
  [SMALL_STATE(8746)] = 289987,
  [SMALL_STATE(8747)] = 289996,
  [SMALL_STATE(8748)] = 290005,
  [SMALL_STATE(8749)] = 290014,
  [SMALL_STATE(8750)] = 290023,
  [SMALL_STATE(8751)] = 290032,
  [SMALL_STATE(8752)] = 290041,
  [SMALL_STATE(8753)] = 290050,
  [SMALL_STATE(8754)] = 290059,
  [SMALL_STATE(8755)] = 290068,
  [SMALL_STATE(8756)] = 290077,
  [SMALL_STATE(8757)] = 290086,
  [SMALL_STATE(8758)] = 290095,
  [SMALL_STATE(8759)] = 290104,
  [SMALL_STATE(8760)] = 290113,
  [SMALL_STATE(8761)] = 290122,
  [SMALL_STATE(8762)] = 290131,
  [SMALL_STATE(8763)] = 290140,
  [SMALL_STATE(8764)] = 290149,
  [SMALL_STATE(8765)] = 290158,
  [SMALL_STATE(8766)] = 290167,
  [SMALL_STATE(8767)] = 290176,
  [SMALL_STATE(8768)] = 290185,
  [SMALL_STATE(8769)] = 290194,
  [SMALL_STATE(8770)] = 290203,
  [SMALL_STATE(8771)] = 290212,
  [SMALL_STATE(8772)] = 290221,
  [SMALL_STATE(8773)] = 290230,
  [SMALL_STATE(8774)] = 290239,
  [SMALL_STATE(8775)] = 290248,
  [SMALL_STATE(8776)] = 290257,
  [SMALL_STATE(8777)] = 290266,
  [SMALL_STATE(8778)] = 290275,
  [SMALL_STATE(8779)] = 290284,
  [SMALL_STATE(8780)] = 290293,
  [SMALL_STATE(8781)] = 290302,
  [SMALL_STATE(8782)] = 290311,
  [SMALL_STATE(8783)] = 290320,
  [SMALL_STATE(8784)] = 290329,
  [SMALL_STATE(8785)] = 290338,
  [SMALL_STATE(8786)] = 290347,
  [SMALL_STATE(8787)] = 290356,
  [SMALL_STATE(8788)] = 290365,
  [SMALL_STATE(8789)] = 290374,
  [SMALL_STATE(8790)] = 290383,
  [SMALL_STATE(8791)] = 290392,
  [SMALL_STATE(8792)] = 290401,
  [SMALL_STATE(8793)] = 290410,
  [SMALL_STATE(8794)] = 290419,
  [SMALL_STATE(8795)] = 290428,
  [SMALL_STATE(8796)] = 290437,
  [SMALL_STATE(8797)] = 290446,
  [SMALL_STATE(8798)] = 290455,
  [SMALL_STATE(8799)] = 290464,
  [SMALL_STATE(8800)] = 290473,
  [SMALL_STATE(8801)] = 290482,
  [SMALL_STATE(8802)] = 290491,
  [SMALL_STATE(8803)] = 290500,
  [SMALL_STATE(8804)] = 290509,
  [SMALL_STATE(8805)] = 290518,
  [SMALL_STATE(8806)] = 290527,
  [SMALL_STATE(8807)] = 290536,
  [SMALL_STATE(8808)] = 290545,
  [SMALL_STATE(8809)] = 290554,
  [SMALL_STATE(8810)] = 290563,
  [SMALL_STATE(8811)] = 290572,
  [SMALL_STATE(8812)] = 290581,
  [SMALL_STATE(8813)] = 290590,
  [SMALL_STATE(8814)] = 290599,
  [SMALL_STATE(8815)] = 290608,
  [SMALL_STATE(8816)] = 290617,
  [SMALL_STATE(8817)] = 290626,
  [SMALL_STATE(8818)] = 290635,
  [SMALL_STATE(8819)] = 290644,
  [SMALL_STATE(8820)] = 290653,
  [SMALL_STATE(8821)] = 290662,
  [SMALL_STATE(8822)] = 290671,
  [SMALL_STATE(8823)] = 290680,
  [SMALL_STATE(8824)] = 290689,
  [SMALL_STATE(8825)] = 290698,
  [SMALL_STATE(8826)] = 290707,
  [SMALL_STATE(8827)] = 290716,
  [SMALL_STATE(8828)] = 290725,
  [SMALL_STATE(8829)] = 290734,
  [SMALL_STATE(8830)] = 290743,
  [SMALL_STATE(8831)] = 290752,
  [SMALL_STATE(8832)] = 290761,
  [SMALL_STATE(8833)] = 290770,
  [SMALL_STATE(8834)] = 290779,
  [SMALL_STATE(8835)] = 290788,
  [SMALL_STATE(8836)] = 290797,
  [SMALL_STATE(8837)] = 290806,
  [SMALL_STATE(8838)] = 290815,
  [SMALL_STATE(8839)] = 290824,
  [SMALL_STATE(8840)] = 290833,
  [SMALL_STATE(8841)] = 290842,
  [SMALL_STATE(8842)] = 290851,
  [SMALL_STATE(8843)] = 290860,
  [SMALL_STATE(8844)] = 290869,
  [SMALL_STATE(8845)] = 290878,
  [SMALL_STATE(8846)] = 290887,
  [SMALL_STATE(8847)] = 290896,
  [SMALL_STATE(8848)] = 290905,
  [SMALL_STATE(8849)] = 290914,
  [SMALL_STATE(8850)] = 290923,
  [SMALL_STATE(8851)] = 290932,
  [SMALL_STATE(8852)] = 290941,
  [SMALL_STATE(8853)] = 290950,
  [SMALL_STATE(8854)] = 290959,
  [SMALL_STATE(8855)] = 290968,
  [SMALL_STATE(8856)] = 290977,
  [SMALL_STATE(8857)] = 290986,
  [SMALL_STATE(8858)] = 290995,
  [SMALL_STATE(8859)] = 291004,
  [SMALL_STATE(8860)] = 291013,
  [SMALL_STATE(8861)] = 291022,
  [SMALL_STATE(8862)] = 291031,
  [SMALL_STATE(8863)] = 291040,
  [SMALL_STATE(8864)] = 291049,
  [SMALL_STATE(8865)] = 291058,
  [SMALL_STATE(8866)] = 291067,
  [SMALL_STATE(8867)] = 291076,
  [SMALL_STATE(8868)] = 291085,
  [SMALL_STATE(8869)] = 291094,
  [SMALL_STATE(8870)] = 291103,
  [SMALL_STATE(8871)] = 291112,
  [SMALL_STATE(8872)] = 291121,
  [SMALL_STATE(8873)] = 291130,
  [SMALL_STATE(8874)] = 291139,
  [SMALL_STATE(8875)] = 291148,
  [SMALL_STATE(8876)] = 291157,
  [SMALL_STATE(8877)] = 291166,
  [SMALL_STATE(8878)] = 291175,
  [SMALL_STATE(8879)] = 291184,
  [SMALL_STATE(8880)] = 291193,
  [SMALL_STATE(8881)] = 291202,
  [SMALL_STATE(8882)] = 291211,
  [SMALL_STATE(8883)] = 291220,
  [SMALL_STATE(8884)] = 291229,
  [SMALL_STATE(8885)] = 291238,
  [SMALL_STATE(8886)] = 291247,
  [SMALL_STATE(8887)] = 291256,
  [SMALL_STATE(8888)] = 291265,
  [SMALL_STATE(8889)] = 291274,
  [SMALL_STATE(8890)] = 291283,
  [SMALL_STATE(8891)] = 291292,
  [SMALL_STATE(8892)] = 291301,
  [SMALL_STATE(8893)] = 291310,
  [SMALL_STATE(8894)] = 291319,
  [SMALL_STATE(8895)] = 291328,
  [SMALL_STATE(8896)] = 291337,
  [SMALL_STATE(8897)] = 291346,
  [SMALL_STATE(8898)] = 291355,
  [SMALL_STATE(8899)] = 291364,
  [SMALL_STATE(8900)] = 291373,
  [SMALL_STATE(8901)] = 291382,
  [SMALL_STATE(8902)] = 291391,
  [SMALL_STATE(8903)] = 291400,
  [SMALL_STATE(8904)] = 291409,
  [SMALL_STATE(8905)] = 291418,
  [SMALL_STATE(8906)] = 291427,
  [SMALL_STATE(8907)] = 291436,
  [SMALL_STATE(8908)] = 291445,
  [SMALL_STATE(8909)] = 291454,
  [SMALL_STATE(8910)] = 291463,
  [SMALL_STATE(8911)] = 291472,
  [SMALL_STATE(8912)] = 291481,
  [SMALL_STATE(8913)] = 291490,
  [SMALL_STATE(8914)] = 291499,
  [SMALL_STATE(8915)] = 291508,
  [SMALL_STATE(8916)] = 291517,
  [SMALL_STATE(8917)] = 291526,
  [SMALL_STATE(8918)] = 291535,
  [SMALL_STATE(8919)] = 291544,
  [SMALL_STATE(8920)] = 291553,
  [SMALL_STATE(8921)] = 291562,
  [SMALL_STATE(8922)] = 291571,
  [SMALL_STATE(8923)] = 291580,
  [SMALL_STATE(8924)] = 291589,
  [SMALL_STATE(8925)] = 291598,
  [SMALL_STATE(8926)] = 291607,
  [SMALL_STATE(8927)] = 291616,
  [SMALL_STATE(8928)] = 291625,
  [SMALL_STATE(8929)] = 291634,
  [SMALL_STATE(8930)] = 291643,
  [SMALL_STATE(8931)] = 291652,
  [SMALL_STATE(8932)] = 291661,
  [SMALL_STATE(8933)] = 291670,
  [SMALL_STATE(8934)] = 291679,
  [SMALL_STATE(8935)] = 291688,
  [SMALL_STATE(8936)] = 291697,
  [SMALL_STATE(8937)] = 291706,
  [SMALL_STATE(8938)] = 291715,
  [SMALL_STATE(8939)] = 291724,
  [SMALL_STATE(8940)] = 291733,
  [SMALL_STATE(8941)] = 291742,
  [SMALL_STATE(8942)] = 291751,
  [SMALL_STATE(8943)] = 291760,
  [SMALL_STATE(8944)] = 291769,
  [SMALL_STATE(8945)] = 291778,
  [SMALL_STATE(8946)] = 291787,
  [SMALL_STATE(8947)] = 291796,
  [SMALL_STATE(8948)] = 291805,
  [SMALL_STATE(8949)] = 291814,
  [SMALL_STATE(8950)] = 291823,
  [SMALL_STATE(8951)] = 291832,
  [SMALL_STATE(8952)] = 291841,
  [SMALL_STATE(8953)] = 291850,
  [SMALL_STATE(8954)] = 291859,
  [SMALL_STATE(8955)] = 291868,
  [SMALL_STATE(8956)] = 291877,
  [SMALL_STATE(8957)] = 291886,
  [SMALL_STATE(8958)] = 291895,
  [SMALL_STATE(8959)] = 291904,
  [SMALL_STATE(8960)] = 291913,
  [SMALL_STATE(8961)] = 291922,
  [SMALL_STATE(8962)] = 291931,
  [SMALL_STATE(8963)] = 291940,
  [SMALL_STATE(8964)] = 291949,
  [SMALL_STATE(8965)] = 291958,
  [SMALL_STATE(8966)] = 291967,
  [SMALL_STATE(8967)] = 291976,
  [SMALL_STATE(8968)] = 291985,
  [SMALL_STATE(8969)] = 291994,
  [SMALL_STATE(8970)] = 292003,
  [SMALL_STATE(8971)] = 292012,
  [SMALL_STATE(8972)] = 292021,
  [SMALL_STATE(8973)] = 292030,
  [SMALL_STATE(8974)] = 292039,
  [SMALL_STATE(8975)] = 292048,
  [SMALL_STATE(8976)] = 292057,
  [SMALL_STATE(8977)] = 292066,
  [SMALL_STATE(8978)] = 292075,
  [SMALL_STATE(8979)] = 292084,
  [SMALL_STATE(8980)] = 292093,
  [SMALL_STATE(8981)] = 292102,
  [SMALL_STATE(8982)] = 292111,
  [SMALL_STATE(8983)] = 292120,
  [SMALL_STATE(8984)] = 292129,
  [SMALL_STATE(8985)] = 292138,
  [SMALL_STATE(8986)] = 292147,
  [SMALL_STATE(8987)] = 292156,
  [SMALL_STATE(8988)] = 292165,
  [SMALL_STATE(8989)] = 292174,
  [SMALL_STATE(8990)] = 292183,
  [SMALL_STATE(8991)] = 292192,
  [SMALL_STATE(8992)] = 292201,
  [SMALL_STATE(8993)] = 292210,
  [SMALL_STATE(8994)] = 292219,
  [SMALL_STATE(8995)] = 292228,
  [SMALL_STATE(8996)] = 292237,
  [SMALL_STATE(8997)] = 292246,
  [SMALL_STATE(8998)] = 292255,
  [SMALL_STATE(8999)] = 292264,
  [SMALL_STATE(9000)] = 292273,
  [SMALL_STATE(9001)] = 292282,
  [SMALL_STATE(9002)] = 292291,
  [SMALL_STATE(9003)] = 292300,
  [SMALL_STATE(9004)] = 292309,
  [SMALL_STATE(9005)] = 292318,
  [SMALL_STATE(9006)] = 292327,
  [SMALL_STATE(9007)] = 292336,
  [SMALL_STATE(9008)] = 292345,
  [SMALL_STATE(9009)] = 292354,
  [SMALL_STATE(9010)] = 292363,
  [SMALL_STATE(9011)] = 292372,
  [SMALL_STATE(9012)] = 292381,
  [SMALL_STATE(9013)] = 292390,
  [SMALL_STATE(9014)] = 292399,
  [SMALL_STATE(9015)] = 292408,
  [SMALL_STATE(9016)] = 292417,
  [SMALL_STATE(9017)] = 292426,
  [SMALL_STATE(9018)] = 292435,
  [SMALL_STATE(9019)] = 292444,
  [SMALL_STATE(9020)] = 292453,
  [SMALL_STATE(9021)] = 292462,
  [SMALL_STATE(9022)] = 292471,
  [SMALL_STATE(9023)] = 292480,
  [SMALL_STATE(9024)] = 292489,
  [SMALL_STATE(9025)] = 292498,
  [SMALL_STATE(9026)] = 292507,
  [SMALL_STATE(9027)] = 292516,
  [SMALL_STATE(9028)] = 292525,
  [SMALL_STATE(9029)] = 292534,
  [SMALL_STATE(9030)] = 292543,
  [SMALL_STATE(9031)] = 292552,
  [SMALL_STATE(9032)] = 292561,
  [SMALL_STATE(9033)] = 292570,
  [SMALL_STATE(9034)] = 292579,
  [SMALL_STATE(9035)] = 292588,
  [SMALL_STATE(9036)] = 292597,
  [SMALL_STATE(9037)] = 292606,
  [SMALL_STATE(9038)] = 292615,
  [SMALL_STATE(9039)] = 292624,
  [SMALL_STATE(9040)] = 292633,
  [SMALL_STATE(9041)] = 292642,
  [SMALL_STATE(9042)] = 292651,
  [SMALL_STATE(9043)] = 292660,
  [SMALL_STATE(9044)] = 292669,
  [SMALL_STATE(9045)] = 292678,
  [SMALL_STATE(9046)] = 292687,
  [SMALL_STATE(9047)] = 292696,
  [SMALL_STATE(9048)] = 292705,
  [SMALL_STATE(9049)] = 292714,
  [SMALL_STATE(9050)] = 292723,
  [SMALL_STATE(9051)] = 292732,
  [SMALL_STATE(9052)] = 292741,
  [SMALL_STATE(9053)] = 292750,
  [SMALL_STATE(9054)] = 292759,
  [SMALL_STATE(9055)] = 292768,
  [SMALL_STATE(9056)] = 292777,
  [SMALL_STATE(9057)] = 292786,
  [SMALL_STATE(9058)] = 292795,
  [SMALL_STATE(9059)] = 292804,
  [SMALL_STATE(9060)] = 292813,
  [SMALL_STATE(9061)] = 292822,
  [SMALL_STATE(9062)] = 292831,
  [SMALL_STATE(9063)] = 292840,
  [SMALL_STATE(9064)] = 292849,
  [SMALL_STATE(9065)] = 292858,
  [SMALL_STATE(9066)] = 292867,
  [SMALL_STATE(9067)] = 292876,
  [SMALL_STATE(9068)] = 292885,
  [SMALL_STATE(9069)] = 292894,
  [SMALL_STATE(9070)] = 292903,
  [SMALL_STATE(9071)] = 292912,
  [SMALL_STATE(9072)] = 292921,
  [SMALL_STATE(9073)] = 292930,
  [SMALL_STATE(9074)] = 292939,
  [SMALL_STATE(9075)] = 292948,
  [SMALL_STATE(9076)] = 292957,
  [SMALL_STATE(9077)] = 292966,
  [SMALL_STATE(9078)] = 292975,
  [SMALL_STATE(9079)] = 292984,
  [SMALL_STATE(9080)] = 292993,
  [SMALL_STATE(9081)] = 293002,
  [SMALL_STATE(9082)] = 293011,
  [SMALL_STATE(9083)] = 293020,
  [SMALL_STATE(9084)] = 293029,
  [SMALL_STATE(9085)] = 293038,
  [SMALL_STATE(9086)] = 293047,
  [SMALL_STATE(9087)] = 293056,
  [SMALL_STATE(9088)] = 293065,
  [SMALL_STATE(9089)] = 293074,
  [SMALL_STATE(9090)] = 293083,
  [SMALL_STATE(9091)] = 293092,
  [SMALL_STATE(9092)] = 293101,
  [SMALL_STATE(9093)] = 293110,
  [SMALL_STATE(9094)] = 293119,
  [SMALL_STATE(9095)] = 293128,
  [SMALL_STATE(9096)] = 293137,
  [SMALL_STATE(9097)] = 293146,
  [SMALL_STATE(9098)] = 293155,
  [SMALL_STATE(9099)] = 293164,
  [SMALL_STATE(9100)] = 293173,
  [SMALL_STATE(9101)] = 293182,
  [SMALL_STATE(9102)] = 293191,
  [SMALL_STATE(9103)] = 293200,
  [SMALL_STATE(9104)] = 293209,
  [SMALL_STATE(9105)] = 293218,
  [SMALL_STATE(9106)] = 293227,
  [SMALL_STATE(9107)] = 293236,
  [SMALL_STATE(9108)] = 293245,
  [SMALL_STATE(9109)] = 293254,
  [SMALL_STATE(9110)] = 293263,
  [SMALL_STATE(9111)] = 293272,
  [SMALL_STATE(9112)] = 293281,
  [SMALL_STATE(9113)] = 293290,
  [SMALL_STATE(9114)] = 293299,
  [SMALL_STATE(9115)] = 293308,
  [SMALL_STATE(9116)] = 293317,
  [SMALL_STATE(9117)] = 293326,
  [SMALL_STATE(9118)] = 293335,
  [SMALL_STATE(9119)] = 293344,
  [SMALL_STATE(9120)] = 293353,
  [SMALL_STATE(9121)] = 293362,
  [SMALL_STATE(9122)] = 293371,
  [SMALL_STATE(9123)] = 293380,
  [SMALL_STATE(9124)] = 293389,
  [SMALL_STATE(9125)] = 293398,
  [SMALL_STATE(9126)] = 293407,
  [SMALL_STATE(9127)] = 293416,
  [SMALL_STATE(9128)] = 293425,
  [SMALL_STATE(9129)] = 293434,
  [SMALL_STATE(9130)] = 293443,
  [SMALL_STATE(9131)] = 293452,
  [SMALL_STATE(9132)] = 293461,
  [SMALL_STATE(9133)] = 293470,
  [SMALL_STATE(9134)] = 293479,
  [SMALL_STATE(9135)] = 293488,
  [SMALL_STATE(9136)] = 293497,
  [SMALL_STATE(9137)] = 293506,
  [SMALL_STATE(9138)] = 293515,
  [SMALL_STATE(9139)] = 293524,
  [SMALL_STATE(9140)] = 293533,
  [SMALL_STATE(9141)] = 293542,
  [SMALL_STATE(9142)] = 293551,
  [SMALL_STATE(9143)] = 293560,
  [SMALL_STATE(9144)] = 293569,
  [SMALL_STATE(9145)] = 293578,
  [SMALL_STATE(9146)] = 293587,
  [SMALL_STATE(9147)] = 293596,
  [SMALL_STATE(9148)] = 293605,
  [SMALL_STATE(9149)] = 293614,
  [SMALL_STATE(9150)] = 293623,
  [SMALL_STATE(9151)] = 293632,
  [SMALL_STATE(9152)] = 293641,
  [SMALL_STATE(9153)] = 293650,
  [SMALL_STATE(9154)] = 293659,
  [SMALL_STATE(9155)] = 293668,
  [SMALL_STATE(9156)] = 293677,
  [SMALL_STATE(9157)] = 293686,
  [SMALL_STATE(9158)] = 293695,
  [SMALL_STATE(9159)] = 293704,
  [SMALL_STATE(9160)] = 293713,
  [SMALL_STATE(9161)] = 293722,
  [SMALL_STATE(9162)] = 293731,
  [SMALL_STATE(9163)] = 293740,
  [SMALL_STATE(9164)] = 293749,
  [SMALL_STATE(9165)] = 293758,
  [SMALL_STATE(9166)] = 293767,
  [SMALL_STATE(9167)] = 293776,
  [SMALL_STATE(9168)] = 293785,
  [SMALL_STATE(9169)] = 293794,
  [SMALL_STATE(9170)] = 293803,
  [SMALL_STATE(9171)] = 293812,
  [SMALL_STATE(9172)] = 293821,
  [SMALL_STATE(9173)] = 293830,
  [SMALL_STATE(9174)] = 293839,
  [SMALL_STATE(9175)] = 293848,
  [SMALL_STATE(9176)] = 293857,
  [SMALL_STATE(9177)] = 293866,
  [SMALL_STATE(9178)] = 293875,
  [SMALL_STATE(9179)] = 293884,
  [SMALL_STATE(9180)] = 293893,
  [SMALL_STATE(9181)] = 293902,
  [SMALL_STATE(9182)] = 293911,
  [SMALL_STATE(9183)] = 293920,
  [SMALL_STATE(9184)] = 293929,
  [SMALL_STATE(9185)] = 293938,
  [SMALL_STATE(9186)] = 293947,
  [SMALL_STATE(9187)] = 293956,
  [SMALL_STATE(9188)] = 293965,
  [SMALL_STATE(9189)] = 293974,
  [SMALL_STATE(9190)] = 293983,
  [SMALL_STATE(9191)] = 293992,
  [SMALL_STATE(9192)] = 294001,
  [SMALL_STATE(9193)] = 294010,
  [SMALL_STATE(9194)] = 294019,
  [SMALL_STATE(9195)] = 294028,
  [SMALL_STATE(9196)] = 294037,
  [SMALL_STATE(9197)] = 294046,
  [SMALL_STATE(9198)] = 294055,
  [SMALL_STATE(9199)] = 294064,
  [SMALL_STATE(9200)] = 294073,
  [SMALL_STATE(9201)] = 294082,
  [SMALL_STATE(9202)] = 294091,
  [SMALL_STATE(9203)] = 294100,
  [SMALL_STATE(9204)] = 294109,
  [SMALL_STATE(9205)] = 294118,
  [SMALL_STATE(9206)] = 294127,
  [SMALL_STATE(9207)] = 294136,
  [SMALL_STATE(9208)] = 294145,
  [SMALL_STATE(9209)] = 294154,
  [SMALL_STATE(9210)] = 294163,
  [SMALL_STATE(9211)] = 294172,
  [SMALL_STATE(9212)] = 294181,
  [SMALL_STATE(9213)] = 294190,
  [SMALL_STATE(9214)] = 294199,
  [SMALL_STATE(9215)] = 294208,
  [SMALL_STATE(9216)] = 294217,
  [SMALL_STATE(9217)] = 294226,
  [SMALL_STATE(9218)] = 294235,
  [SMALL_STATE(9219)] = 294244,
  [SMALL_STATE(9220)] = 294253,
  [SMALL_STATE(9221)] = 294262,
  [SMALL_STATE(9222)] = 294271,
  [SMALL_STATE(9223)] = 294280,
  [SMALL_STATE(9224)] = 294289,
  [SMALL_STATE(9225)] = 294298,
  [SMALL_STATE(9226)] = 294307,
  [SMALL_STATE(9227)] = 294316,
  [SMALL_STATE(9228)] = 294325,
  [SMALL_STATE(9229)] = 294334,
  [SMALL_STATE(9230)] = 294343,
  [SMALL_STATE(9231)] = 294352,
  [SMALL_STATE(9232)] = 294361,
  [SMALL_STATE(9233)] = 294370,
  [SMALL_STATE(9234)] = 294379,
  [SMALL_STATE(9235)] = 294388,
  [SMALL_STATE(9236)] = 294397,
  [SMALL_STATE(9237)] = 294406,
  [SMALL_STATE(9238)] = 294415,
  [SMALL_STATE(9239)] = 294424,
  [SMALL_STATE(9240)] = 294433,
  [SMALL_STATE(9241)] = 294442,
  [SMALL_STATE(9242)] = 294451,
  [SMALL_STATE(9243)] = 294460,
  [SMALL_STATE(9244)] = 294469,
  [SMALL_STATE(9245)] = 294478,
  [SMALL_STATE(9246)] = 294487,
  [SMALL_STATE(9247)] = 294496,
  [SMALL_STATE(9248)] = 294505,
  [SMALL_STATE(9249)] = 294514,
  [SMALL_STATE(9250)] = 294523,
  [SMALL_STATE(9251)] = 294532,
  [SMALL_STATE(9252)] = 294541,
  [SMALL_STATE(9253)] = 294550,
  [SMALL_STATE(9254)] = 294559,
  [SMALL_STATE(9255)] = 294568,
  [SMALL_STATE(9256)] = 294577,
  [SMALL_STATE(9257)] = 294586,
  [SMALL_STATE(9258)] = 294595,
  [SMALL_STATE(9259)] = 294604,
  [SMALL_STATE(9260)] = 294613,
  [SMALL_STATE(9261)] = 294622,
  [SMALL_STATE(9262)] = 294631,
  [SMALL_STATE(9263)] = 294640,
  [SMALL_STATE(9264)] = 294649,
  [SMALL_STATE(9265)] = 294658,
  [SMALL_STATE(9266)] = 294667,
  [SMALL_STATE(9267)] = 294676,
  [SMALL_STATE(9268)] = 294685,
  [SMALL_STATE(9269)] = 294694,
  [SMALL_STATE(9270)] = 294703,
  [SMALL_STATE(9271)] = 294712,
  [SMALL_STATE(9272)] = 294721,
  [SMALL_STATE(9273)] = 294730,
  [SMALL_STATE(9274)] = 294739,
  [SMALL_STATE(9275)] = 294748,
  [SMALL_STATE(9276)] = 294757,
  [SMALL_STATE(9277)] = 294766,
  [SMALL_STATE(9278)] = 294775,
  [SMALL_STATE(9279)] = 294784,
  [SMALL_STATE(9280)] = 294793,
  [SMALL_STATE(9281)] = 294802,
  [SMALL_STATE(9282)] = 294811,
  [SMALL_STATE(9283)] = 294820,
  [SMALL_STATE(9284)] = 294829,
  [SMALL_STATE(9285)] = 294838,
  [SMALL_STATE(9286)] = 294847,
  [SMALL_STATE(9287)] = 294856,
  [SMALL_STATE(9288)] = 294865,
  [SMALL_STATE(9289)] = 294874,
  [SMALL_STATE(9290)] = 294883,
  [SMALL_STATE(9291)] = 294892,
  [SMALL_STATE(9292)] = 294901,
  [SMALL_STATE(9293)] = 294910,
  [SMALL_STATE(9294)] = 294919,
  [SMALL_STATE(9295)] = 294928,
  [SMALL_STATE(9296)] = 294937,
  [SMALL_STATE(9297)] = 294946,
  [SMALL_STATE(9298)] = 294955,
  [SMALL_STATE(9299)] = 294964,
  [SMALL_STATE(9300)] = 294973,
  [SMALL_STATE(9301)] = 294982,
  [SMALL_STATE(9302)] = 294991,
  [SMALL_STATE(9303)] = 295000,
  [SMALL_STATE(9304)] = 295009,
  [SMALL_STATE(9305)] = 295018,
  [SMALL_STATE(9306)] = 295027,
  [SMALL_STATE(9307)] = 295036,
  [SMALL_STATE(9308)] = 295045,
  [SMALL_STATE(9309)] = 295054,
  [SMALL_STATE(9310)] = 295063,
  [SMALL_STATE(9311)] = 295072,
  [SMALL_STATE(9312)] = 295081,
  [SMALL_STATE(9313)] = 295090,
  [SMALL_STATE(9314)] = 295099,
  [SMALL_STATE(9315)] = 295108,
  [SMALL_STATE(9316)] = 295117,
  [SMALL_STATE(9317)] = 295126,
  [SMALL_STATE(9318)] = 295135,
  [SMALL_STATE(9319)] = 295144,
  [SMALL_STATE(9320)] = 295153,
  [SMALL_STATE(9321)] = 295162,
  [SMALL_STATE(9322)] = 295171,
  [SMALL_STATE(9323)] = 295180,
  [SMALL_STATE(9324)] = 295189,
  [SMALL_STATE(9325)] = 295198,
  [SMALL_STATE(9326)] = 295207,
  [SMALL_STATE(9327)] = 295216,
  [SMALL_STATE(9328)] = 295225,
  [SMALL_STATE(9329)] = 295234,
  [SMALL_STATE(9330)] = 295243,
  [SMALL_STATE(9331)] = 295252,
  [SMALL_STATE(9332)] = 295261,
  [SMALL_STATE(9333)] = 295270,
  [SMALL_STATE(9334)] = 295279,
  [SMALL_STATE(9335)] = 295288,
  [SMALL_STATE(9336)] = 295297,
  [SMALL_STATE(9337)] = 295306,
  [SMALL_STATE(9338)] = 295315,
  [SMALL_STATE(9339)] = 295324,
  [SMALL_STATE(9340)] = 295333,
  [SMALL_STATE(9341)] = 295342,
  [SMALL_STATE(9342)] = 295351,
  [SMALL_STATE(9343)] = 295360,
  [SMALL_STATE(9344)] = 295369,
  [SMALL_STATE(9345)] = 295378,
  [SMALL_STATE(9346)] = 295387,
  [SMALL_STATE(9347)] = 295396,
  [SMALL_STATE(9348)] = 295405,
  [SMALL_STATE(9349)] = 295414,
  [SMALL_STATE(9350)] = 295423,
  [SMALL_STATE(9351)] = 295432,
  [SMALL_STATE(9352)] = 295441,
  [SMALL_STATE(9353)] = 295450,
  [SMALL_STATE(9354)] = 295459,
  [SMALL_STATE(9355)] = 295468,
  [SMALL_STATE(9356)] = 295477,
  [SMALL_STATE(9357)] = 295486,
  [SMALL_STATE(9358)] = 295495,
  [SMALL_STATE(9359)] = 295504,
  [SMALL_STATE(9360)] = 295513,
  [SMALL_STATE(9361)] = 295522,
  [SMALL_STATE(9362)] = 295531,
  [SMALL_STATE(9363)] = 295540,
  [SMALL_STATE(9364)] = 295549,
  [SMALL_STATE(9365)] = 295558,
  [SMALL_STATE(9366)] = 295567,
  [SMALL_STATE(9367)] = 295576,
  [SMALL_STATE(9368)] = 295585,
  [SMALL_STATE(9369)] = 295594,
  [SMALL_STATE(9370)] = 295603,
  [SMALL_STATE(9371)] = 295612,
  [SMALL_STATE(9372)] = 295621,
  [SMALL_STATE(9373)] = 295630,
  [SMALL_STATE(9374)] = 295639,
  [SMALL_STATE(9375)] = 295648,
  [SMALL_STATE(9376)] = 295657,
  [SMALL_STATE(9377)] = 295666,
  [SMALL_STATE(9378)] = 295675,
  [SMALL_STATE(9379)] = 295684,
  [SMALL_STATE(9380)] = 295693,
  [SMALL_STATE(9381)] = 295702,
  [SMALL_STATE(9382)] = 295711,
  [SMALL_STATE(9383)] = 295720,
  [SMALL_STATE(9384)] = 295729,
  [SMALL_STATE(9385)] = 295738,
  [SMALL_STATE(9386)] = 295747,
  [SMALL_STATE(9387)] = 295756,
  [SMALL_STATE(9388)] = 295765,
  [SMALL_STATE(9389)] = 295774,
  [SMALL_STATE(9390)] = 295783,
  [SMALL_STATE(9391)] = 295792,
  [SMALL_STATE(9392)] = 295801,
  [SMALL_STATE(9393)] = 295810,
  [SMALL_STATE(9394)] = 295819,
  [SMALL_STATE(9395)] = 295828,
  [SMALL_STATE(9396)] = 295837,
  [SMALL_STATE(9397)] = 295846,
  [SMALL_STATE(9398)] = 295855,
  [SMALL_STATE(9399)] = 295864,
  [SMALL_STATE(9400)] = 295873,
  [SMALL_STATE(9401)] = 295882,
  [SMALL_STATE(9402)] = 295891,
  [SMALL_STATE(9403)] = 295900,
  [SMALL_STATE(9404)] = 295909,
  [SMALL_STATE(9405)] = 295918,
  [SMALL_STATE(9406)] = 295927,
  [SMALL_STATE(9407)] = 295936,
  [SMALL_STATE(9408)] = 295945,
  [SMALL_STATE(9409)] = 295954,
  [SMALL_STATE(9410)] = 295963,
  [SMALL_STATE(9411)] = 295972,
  [SMALL_STATE(9412)] = 295981,
  [SMALL_STATE(9413)] = 295990,
  [SMALL_STATE(9414)] = 295999,
  [SMALL_STATE(9415)] = 296008,
  [SMALL_STATE(9416)] = 296017,
  [SMALL_STATE(9417)] = 296026,
  [SMALL_STATE(9418)] = 296035,
  [SMALL_STATE(9419)] = 296044,
  [SMALL_STATE(9420)] = 296053,
  [SMALL_STATE(9421)] = 296062,
  [SMALL_STATE(9422)] = 296071,
  [SMALL_STATE(9423)] = 296080,
  [SMALL_STATE(9424)] = 296089,
  [SMALL_STATE(9425)] = 296098,
  [SMALL_STATE(9426)] = 296107,
  [SMALL_STATE(9427)] = 296116,
  [SMALL_STATE(9428)] = 296125,
  [SMALL_STATE(9429)] = 296134,
  [SMALL_STATE(9430)] = 296143,
  [SMALL_STATE(9431)] = 296152,
  [SMALL_STATE(9432)] = 296161,
  [SMALL_STATE(9433)] = 296170,
  [SMALL_STATE(9434)] = 296179,
  [SMALL_STATE(9435)] = 296188,
  [SMALL_STATE(9436)] = 296197,
  [SMALL_STATE(9437)] = 296206,
  [SMALL_STATE(9438)] = 296215,
  [SMALL_STATE(9439)] = 296224,
  [SMALL_STATE(9440)] = 296233,
  [SMALL_STATE(9441)] = 296242,
  [SMALL_STATE(9442)] = 296251,
  [SMALL_STATE(9443)] = 296260,
  [SMALL_STATE(9444)] = 296269,
  [SMALL_STATE(9445)] = 296278,
  [SMALL_STATE(9446)] = 296287,
  [SMALL_STATE(9447)] = 296296,
  [SMALL_STATE(9448)] = 296305,
  [SMALL_STATE(9449)] = 296314,
  [SMALL_STATE(9450)] = 296323,
  [SMALL_STATE(9451)] = 296332,
  [SMALL_STATE(9452)] = 296341,
  [SMALL_STATE(9453)] = 296350,
  [SMALL_STATE(9454)] = 296359,
  [SMALL_STATE(9455)] = 296368,
  [SMALL_STATE(9456)] = 296377,
  [SMALL_STATE(9457)] = 296386,
  [SMALL_STATE(9458)] = 296395,
  [SMALL_STATE(9459)] = 296404,
  [SMALL_STATE(9460)] = 296413,
  [SMALL_STATE(9461)] = 296422,
  [SMALL_STATE(9462)] = 296431,
  [SMALL_STATE(9463)] = 296440,
  [SMALL_STATE(9464)] = 296449,
  [SMALL_STATE(9465)] = 296458,
  [SMALL_STATE(9466)] = 296467,
  [SMALL_STATE(9467)] = 296476,
  [SMALL_STATE(9468)] = 296485,
  [SMALL_STATE(9469)] = 296494,
  [SMALL_STATE(9470)] = 296503,
  [SMALL_STATE(9471)] = 296512,
  [SMALL_STATE(9472)] = 296521,
  [SMALL_STATE(9473)] = 296530,
  [SMALL_STATE(9474)] = 296539,
  [SMALL_STATE(9475)] = 296548,
  [SMALL_STATE(9476)] = 296557,
  [SMALL_STATE(9477)] = 296566,
  [SMALL_STATE(9478)] = 296575,
  [SMALL_STATE(9479)] = 296584,
  [SMALL_STATE(9480)] = 296593,
  [SMALL_STATE(9481)] = 296602,
  [SMALL_STATE(9482)] = 296611,
  [SMALL_STATE(9483)] = 296620,
  [SMALL_STATE(9484)] = 296629,
  [SMALL_STATE(9485)] = 296638,
  [SMALL_STATE(9486)] = 296647,
  [SMALL_STATE(9487)] = 296656,
  [SMALL_STATE(9488)] = 296665,
  [SMALL_STATE(9489)] = 296674,
  [SMALL_STATE(9490)] = 296683,
  [SMALL_STATE(9491)] = 296692,
  [SMALL_STATE(9492)] = 296701,
  [SMALL_STATE(9493)] = 296710,
  [SMALL_STATE(9494)] = 296719,
  [SMALL_STATE(9495)] = 296728,
  [SMALL_STATE(9496)] = 296737,
  [SMALL_STATE(9497)] = 296746,
  [SMALL_STATE(9498)] = 296755,
  [SMALL_STATE(9499)] = 296764,
  [SMALL_STATE(9500)] = 296773,
  [SMALL_STATE(9501)] = 296782,
  [SMALL_STATE(9502)] = 296791,
  [SMALL_STATE(9503)] = 296800,
  [SMALL_STATE(9504)] = 296809,
  [SMALL_STATE(9505)] = 296818,
  [SMALL_STATE(9506)] = 296827,
  [SMALL_STATE(9507)] = 296836,
  [SMALL_STATE(9508)] = 296845,
  [SMALL_STATE(9509)] = 296854,
  [SMALL_STATE(9510)] = 296863,
  [SMALL_STATE(9511)] = 296872,
  [SMALL_STATE(9512)] = 296881,
  [SMALL_STATE(9513)] = 296890,
  [SMALL_STATE(9514)] = 296899,
  [SMALL_STATE(9515)] = 296908,
  [SMALL_STATE(9516)] = 296917,
  [SMALL_STATE(9517)] = 296926,
  [SMALL_STATE(9518)] = 296935,
  [SMALL_STATE(9519)] = 296944,
  [SMALL_STATE(9520)] = 296953,
  [SMALL_STATE(9521)] = 296962,
  [SMALL_STATE(9522)] = 296971,
  [SMALL_STATE(9523)] = 296980,
  [SMALL_STATE(9524)] = 296989,
  [SMALL_STATE(9525)] = 296998,
  [SMALL_STATE(9526)] = 297007,
  [SMALL_STATE(9527)] = 297016,
  [SMALL_STATE(9528)] = 297025,
  [SMALL_STATE(9529)] = 297034,
  [SMALL_STATE(9530)] = 297043,
  [SMALL_STATE(9531)] = 297052,
  [SMALL_STATE(9532)] = 297061,
  [SMALL_STATE(9533)] = 297070,
  [SMALL_STATE(9534)] = 297079,
  [SMALL_STATE(9535)] = 297088,
  [SMALL_STATE(9536)] = 297097,
  [SMALL_STATE(9537)] = 297106,
  [SMALL_STATE(9538)] = 297115,
  [SMALL_STATE(9539)] = 297124,
  [SMALL_STATE(9540)] = 297133,
  [SMALL_STATE(9541)] = 297142,
  [SMALL_STATE(9542)] = 297151,
  [SMALL_STATE(9543)] = 297160,
  [SMALL_STATE(9544)] = 297169,
  [SMALL_STATE(9545)] = 297178,
  [SMALL_STATE(9546)] = 297187,
  [SMALL_STATE(9547)] = 297196,
  [SMALL_STATE(9548)] = 297205,
  [SMALL_STATE(9549)] = 297214,
  [SMALL_STATE(9550)] = 297223,
  [SMALL_STATE(9551)] = 297232,
  [SMALL_STATE(9552)] = 297241,
  [SMALL_STATE(9553)] = 297250,
  [SMALL_STATE(9554)] = 297259,
  [SMALL_STATE(9555)] = 297268,
  [SMALL_STATE(9556)] = 297277,
  [SMALL_STATE(9557)] = 297286,
  [SMALL_STATE(9558)] = 297295,
  [SMALL_STATE(9559)] = 297304,
  [SMALL_STATE(9560)] = 297313,
  [SMALL_STATE(9561)] = 297322,
  [SMALL_STATE(9562)] = 297331,
  [SMALL_STATE(9563)] = 297340,
  [SMALL_STATE(9564)] = 297349,
  [SMALL_STATE(9565)] = 297358,
  [SMALL_STATE(9566)] = 297367,
  [SMALL_STATE(9567)] = 297376,
  [SMALL_STATE(9568)] = 297385,
  [SMALL_STATE(9569)] = 297394,
  [SMALL_STATE(9570)] = 297403,
  [SMALL_STATE(9571)] = 297412,
  [SMALL_STATE(9572)] = 297421,
  [SMALL_STATE(9573)] = 297430,
  [SMALL_STATE(9574)] = 297439,
  [SMALL_STATE(9575)] = 297448,
  [SMALL_STATE(9576)] = 297457,
  [SMALL_STATE(9577)] = 297466,
  [SMALL_STATE(9578)] = 297475,
  [SMALL_STATE(9579)] = 297484,
  [SMALL_STATE(9580)] = 297493,
  [SMALL_STATE(9581)] = 297502,
  [SMALL_STATE(9582)] = 297511,
  [SMALL_STATE(9583)] = 297520,
  [SMALL_STATE(9584)] = 297529,
  [SMALL_STATE(9585)] = 297538,
  [SMALL_STATE(9586)] = 297547,
  [SMALL_STATE(9587)] = 297556,
  [SMALL_STATE(9588)] = 297565,
  [SMALL_STATE(9589)] = 297574,
  [SMALL_STATE(9590)] = 297583,
  [SMALL_STATE(9591)] = 297592,
  [SMALL_STATE(9592)] = 297601,
  [SMALL_STATE(9593)] = 297610,
  [SMALL_STATE(9594)] = 297619,
  [SMALL_STATE(9595)] = 297628,
  [SMALL_STATE(9596)] = 297637,
  [SMALL_STATE(9597)] = 297646,
  [SMALL_STATE(9598)] = 297655,
  [SMALL_STATE(9599)] = 297664,
  [SMALL_STATE(9600)] = 297673,
  [SMALL_STATE(9601)] = 297682,
  [SMALL_STATE(9602)] = 297691,
  [SMALL_STATE(9603)] = 297700,
  [SMALL_STATE(9604)] = 297709,
  [SMALL_STATE(9605)] = 297718,
  [SMALL_STATE(9606)] = 297727,
  [SMALL_STATE(9607)] = 297736,
  [SMALL_STATE(9608)] = 297745,
  [SMALL_STATE(9609)] = 297754,
  [SMALL_STATE(9610)] = 297763,
  [SMALL_STATE(9611)] = 297772,
  [SMALL_STATE(9612)] = 297781,
  [SMALL_STATE(9613)] = 297790,
  [SMALL_STATE(9614)] = 297799,
  [SMALL_STATE(9615)] = 297808,
  [SMALL_STATE(9616)] = 297817,
  [SMALL_STATE(9617)] = 297826,
  [SMALL_STATE(9618)] = 297835,
  [SMALL_STATE(9619)] = 297844,
  [SMALL_STATE(9620)] = 297853,
  [SMALL_STATE(9621)] = 297862,
  [SMALL_STATE(9622)] = 297871,
  [SMALL_STATE(9623)] = 297880,
  [SMALL_STATE(9624)] = 297889,
  [SMALL_STATE(9625)] = 297898,
  [SMALL_STATE(9626)] = 297907,
  [SMALL_STATE(9627)] = 297916,
  [SMALL_STATE(9628)] = 297925,
  [SMALL_STATE(9629)] = 297934,
  [SMALL_STATE(9630)] = 297943,
  [SMALL_STATE(9631)] = 297952,
  [SMALL_STATE(9632)] = 297961,
  [SMALL_STATE(9633)] = 297970,
  [SMALL_STATE(9634)] = 297979,
  [SMALL_STATE(9635)] = 297988,
  [SMALL_STATE(9636)] = 297997,
  [SMALL_STATE(9637)] = 298006,
  [SMALL_STATE(9638)] = 298015,
  [SMALL_STATE(9639)] = 298024,
  [SMALL_STATE(9640)] = 298033,
  [SMALL_STATE(9641)] = 298042,
  [SMALL_STATE(9642)] = 298051,
  [SMALL_STATE(9643)] = 298060,
  [SMALL_STATE(9644)] = 298069,
  [SMALL_STATE(9645)] = 298078,
  [SMALL_STATE(9646)] = 298087,
  [SMALL_STATE(9647)] = 298096,
  [SMALL_STATE(9648)] = 298105,
  [SMALL_STATE(9649)] = 298114,
  [SMALL_STATE(9650)] = 298123,
  [SMALL_STATE(9651)] = 298132,
  [SMALL_STATE(9652)] = 298141,
  [SMALL_STATE(9653)] = 298150,
  [SMALL_STATE(9654)] = 298159,
  [SMALL_STATE(9655)] = 298168,
  [SMALL_STATE(9656)] = 298177,
  [SMALL_STATE(9657)] = 298186,
  [SMALL_STATE(9658)] = 298195,
  [SMALL_STATE(9659)] = 298204,
  [SMALL_STATE(9660)] = 298213,
  [SMALL_STATE(9661)] = 298222,
  [SMALL_STATE(9662)] = 298231,
  [SMALL_STATE(9663)] = 298240,
  [SMALL_STATE(9664)] = 298249,
  [SMALL_STATE(9665)] = 298258,
  [SMALL_STATE(9666)] = 298267,
  [SMALL_STATE(9667)] = 298276,
  [SMALL_STATE(9668)] = 298285,
  [SMALL_STATE(9669)] = 298294,
  [SMALL_STATE(9670)] = 298303,
  [SMALL_STATE(9671)] = 298312,
  [SMALL_STATE(9672)] = 298321,
  [SMALL_STATE(9673)] = 298330,
  [SMALL_STATE(9674)] = 298339,
  [SMALL_STATE(9675)] = 298348,
  [SMALL_STATE(9676)] = 298357,
  [SMALL_STATE(9677)] = 298366,
  [SMALL_STATE(9678)] = 298375,
  [SMALL_STATE(9679)] = 298384,
  [SMALL_STATE(9680)] = 298393,
  [SMALL_STATE(9681)] = 298402,
  [SMALL_STATE(9682)] = 298411,
  [SMALL_STATE(9683)] = 298420,
  [SMALL_STATE(9684)] = 298429,
  [SMALL_STATE(9685)] = 298438,
  [SMALL_STATE(9686)] = 298447,
  [SMALL_STATE(9687)] = 298456,
  [SMALL_STATE(9688)] = 298465,
  [SMALL_STATE(9689)] = 298474,
  [SMALL_STATE(9690)] = 298483,
  [SMALL_STATE(9691)] = 298492,
  [SMALL_STATE(9692)] = 298501,
  [SMALL_STATE(9693)] = 298510,
  [SMALL_STATE(9694)] = 298519,
  [SMALL_STATE(9695)] = 298528,
  [SMALL_STATE(9696)] = 298537,
  [SMALL_STATE(9697)] = 298546,
  [SMALL_STATE(9698)] = 298555,
  [SMALL_STATE(9699)] = 298564,
  [SMALL_STATE(9700)] = 298573,
  [SMALL_STATE(9701)] = 298582,
  [SMALL_STATE(9702)] = 298591,
  [SMALL_STATE(9703)] = 298600,
  [SMALL_STATE(9704)] = 298609,
  [SMALL_STATE(9705)] = 298618,
  [SMALL_STATE(9706)] = 298627,
  [SMALL_STATE(9707)] = 298636,
  [SMALL_STATE(9708)] = 298645,
  [SMALL_STATE(9709)] = 298654,
  [SMALL_STATE(9710)] = 298663,
  [SMALL_STATE(9711)] = 298672,
  [SMALL_STATE(9712)] = 298681,
  [SMALL_STATE(9713)] = 298690,
  [SMALL_STATE(9714)] = 298699,
  [SMALL_STATE(9715)] = 298708,
  [SMALL_STATE(9716)] = 298717,
  [SMALL_STATE(9717)] = 298726,
  [SMALL_STATE(9718)] = 298735,
  [SMALL_STATE(9719)] = 298744,
  [SMALL_STATE(9720)] = 298753,
  [SMALL_STATE(9721)] = 298762,
  [SMALL_STATE(9722)] = 298771,
  [SMALL_STATE(9723)] = 298780,
  [SMALL_STATE(9724)] = 298789,
  [SMALL_STATE(9725)] = 298798,
  [SMALL_STATE(9726)] = 298807,
  [SMALL_STATE(9727)] = 298816,
  [SMALL_STATE(9728)] = 298825,
  [SMALL_STATE(9729)] = 298834,
  [SMALL_STATE(9730)] = 298843,
  [SMALL_STATE(9731)] = 298852,
  [SMALL_STATE(9732)] = 298861,
  [SMALL_STATE(9733)] = 298870,
  [SMALL_STATE(9734)] = 298879,
  [SMALL_STATE(9735)] = 298888,
  [SMALL_STATE(9736)] = 298897,
  [SMALL_STATE(9737)] = 298906,
  [SMALL_STATE(9738)] = 298915,
  [SMALL_STATE(9739)] = 298924,
  [SMALL_STATE(9740)] = 298933,
  [SMALL_STATE(9741)] = 298942,
  [SMALL_STATE(9742)] = 298951,
  [SMALL_STATE(9743)] = 298960,
  [SMALL_STATE(9744)] = 298969,
  [SMALL_STATE(9745)] = 298978,
  [SMALL_STATE(9746)] = 298987,
  [SMALL_STATE(9747)] = 298996,
  [SMALL_STATE(9748)] = 299005,
  [SMALL_STATE(9749)] = 299014,
  [SMALL_STATE(9750)] = 299023,
  [SMALL_STATE(9751)] = 299032,
  [SMALL_STATE(9752)] = 299041,
  [SMALL_STATE(9753)] = 299050,
  [SMALL_STATE(9754)] = 299059,
  [SMALL_STATE(9755)] = 299068,
  [SMALL_STATE(9756)] = 299077,
  [SMALL_STATE(9757)] = 299086,
  [SMALL_STATE(9758)] = 299095,
  [SMALL_STATE(9759)] = 299104,
  [SMALL_STATE(9760)] = 299113,
  [SMALL_STATE(9761)] = 299122,
  [SMALL_STATE(9762)] = 299131,
  [SMALL_STATE(9763)] = 299140,
  [SMALL_STATE(9764)] = 299149,
  [SMALL_STATE(9765)] = 299158,
  [SMALL_STATE(9766)] = 299167,
  [SMALL_STATE(9767)] = 299176,
  [SMALL_STATE(9768)] = 299185,
  [SMALL_STATE(9769)] = 299194,
  [SMALL_STATE(9770)] = 299203,
  [SMALL_STATE(9771)] = 299212,
  [SMALL_STATE(9772)] = 299221,
  [SMALL_STATE(9773)] = 299230,
  [SMALL_STATE(9774)] = 299239,
  [SMALL_STATE(9775)] = 299248,
  [SMALL_STATE(9776)] = 299257,
  [SMALL_STATE(9777)] = 299266,
  [SMALL_STATE(9778)] = 299275,
  [SMALL_STATE(9779)] = 299284,
  [SMALL_STATE(9780)] = 299293,
  [SMALL_STATE(9781)] = 299302,
  [SMALL_STATE(9782)] = 299311,
  [SMALL_STATE(9783)] = 299320,
  [SMALL_STATE(9784)] = 299329,
  [SMALL_STATE(9785)] = 299338,
  [SMALL_STATE(9786)] = 299347,
  [SMALL_STATE(9787)] = 299356,
  [SMALL_STATE(9788)] = 299365,
  [SMALL_STATE(9789)] = 299374,
  [SMALL_STATE(9790)] = 299383,
  [SMALL_STATE(9791)] = 299392,
  [SMALL_STATE(9792)] = 299401,
  [SMALL_STATE(9793)] = 299410,
  [SMALL_STATE(9794)] = 299419,
  [SMALL_STATE(9795)] = 299428,
  [SMALL_STATE(9796)] = 299437,
  [SMALL_STATE(9797)] = 299446,
  [SMALL_STATE(9798)] = 299455,
  [SMALL_STATE(9799)] = 299464,
  [SMALL_STATE(9800)] = 299473,
  [SMALL_STATE(9801)] = 299482,
  [SMALL_STATE(9802)] = 299491,
  [SMALL_STATE(9803)] = 299500,
  [SMALL_STATE(9804)] = 299509,
  [SMALL_STATE(9805)] = 299518,
  [SMALL_STATE(9806)] = 299527,
  [SMALL_STATE(9807)] = 299536,
  [SMALL_STATE(9808)] = 299545,
  [SMALL_STATE(9809)] = 299554,
  [SMALL_STATE(9810)] = 299563,
  [SMALL_STATE(9811)] = 299572,
  [SMALL_STATE(9812)] = 299581,
  [SMALL_STATE(9813)] = 299590,
  [SMALL_STATE(9814)] = 299599,
  [SMALL_STATE(9815)] = 299608,
  [SMALL_STATE(9816)] = 299617,
  [SMALL_STATE(9817)] = 299626,
  [SMALL_STATE(9818)] = 299635,
  [SMALL_STATE(9819)] = 299644,
  [SMALL_STATE(9820)] = 299653,
  [SMALL_STATE(9821)] = 299662,
  [SMALL_STATE(9822)] = 299671,
  [SMALL_STATE(9823)] = 299680,
  [SMALL_STATE(9824)] = 299689,
  [SMALL_STATE(9825)] = 299698,
  [SMALL_STATE(9826)] = 299707,
  [SMALL_STATE(9827)] = 299716,
  [SMALL_STATE(9828)] = 299725,
  [SMALL_STATE(9829)] = 299734,
  [SMALL_STATE(9830)] = 299743,
  [SMALL_STATE(9831)] = 299752,
  [SMALL_STATE(9832)] = 299761,
  [SMALL_STATE(9833)] = 299770,
  [SMALL_STATE(9834)] = 299779,
  [SMALL_STATE(9835)] = 299788,
  [SMALL_STATE(9836)] = 299797,
  [SMALL_STATE(9837)] = 299806,
  [SMALL_STATE(9838)] = 299815,
  [SMALL_STATE(9839)] = 299824,
  [SMALL_STATE(9840)] = 299833,
  [SMALL_STATE(9841)] = 299842,
  [SMALL_STATE(9842)] = 299851,
  [SMALL_STATE(9843)] = 299860,
  [SMALL_STATE(9844)] = 299869,
  [SMALL_STATE(9845)] = 299878,
  [SMALL_STATE(9846)] = 299887,
  [SMALL_STATE(9847)] = 299896,
  [SMALL_STATE(9848)] = 299905,
  [SMALL_STATE(9849)] = 299914,
  [SMALL_STATE(9850)] = 299923,
  [SMALL_STATE(9851)] = 299932,
  [SMALL_STATE(9852)] = 299941,
  [SMALL_STATE(9853)] = 299950,
  [SMALL_STATE(9854)] = 299959,
  [SMALL_STATE(9855)] = 299968,
  [SMALL_STATE(9856)] = 299977,
  [SMALL_STATE(9857)] = 299986,
  [SMALL_STATE(9858)] = 299995,
  [SMALL_STATE(9859)] = 300004,
  [SMALL_STATE(9860)] = 300013,
  [SMALL_STATE(9861)] = 300022,
  [SMALL_STATE(9862)] = 300031,
  [SMALL_STATE(9863)] = 300040,
  [SMALL_STATE(9864)] = 300049,
  [SMALL_STATE(9865)] = 300058,
  [SMALL_STATE(9866)] = 300067,
  [SMALL_STATE(9867)] = 300076,
  [SMALL_STATE(9868)] = 300085,
  [SMALL_STATE(9869)] = 300094,
  [SMALL_STATE(9870)] = 300103,
  [SMALL_STATE(9871)] = 300112,
  [SMALL_STATE(9872)] = 300121,
  [SMALL_STATE(9873)] = 300130,
  [SMALL_STATE(9874)] = 300139,
  [SMALL_STATE(9875)] = 300148,
  [SMALL_STATE(9876)] = 300157,
  [SMALL_STATE(9877)] = 300166,
  [SMALL_STATE(9878)] = 300175,
  [SMALL_STATE(9879)] = 300184,
  [SMALL_STATE(9880)] = 300193,
  [SMALL_STATE(9881)] = 300202,
  [SMALL_STATE(9882)] = 300211,
  [SMALL_STATE(9883)] = 300220,
  [SMALL_STATE(9884)] = 300229,
  [SMALL_STATE(9885)] = 300238,
  [SMALL_STATE(9886)] = 300247,
  [SMALL_STATE(9887)] = 300256,
  [SMALL_STATE(9888)] = 300265,
  [SMALL_STATE(9889)] = 300274,
  [SMALL_STATE(9890)] = 300283,
  [SMALL_STATE(9891)] = 300292,
  [SMALL_STATE(9892)] = 300301,
  [SMALL_STATE(9893)] = 300310,
  [SMALL_STATE(9894)] = 300319,
  [SMALL_STATE(9895)] = 300328,
  [SMALL_STATE(9896)] = 300337,
  [SMALL_STATE(9897)] = 300346,
  [SMALL_STATE(9898)] = 300355,
  [SMALL_STATE(9899)] = 300364,
  [SMALL_STATE(9900)] = 300373,
  [SMALL_STATE(9901)] = 300382,
  [SMALL_STATE(9902)] = 300391,
  [SMALL_STATE(9903)] = 300400,
  [SMALL_STATE(9904)] = 300409,
  [SMALL_STATE(9905)] = 300418,
  [SMALL_STATE(9906)] = 300427,
  [SMALL_STATE(9907)] = 300436,
  [SMALL_STATE(9908)] = 300445,
  [SMALL_STATE(9909)] = 300454,
  [SMALL_STATE(9910)] = 300463,
  [SMALL_STATE(9911)] = 300472,
  [SMALL_STATE(9912)] = 300481,
  [SMALL_STATE(9913)] = 300490,
  [SMALL_STATE(9914)] = 300499,
  [SMALL_STATE(9915)] = 300508,
  [SMALL_STATE(9916)] = 300517,
  [SMALL_STATE(9917)] = 300526,
  [SMALL_STATE(9918)] = 300535,
  [SMALL_STATE(9919)] = 300544,
  [SMALL_STATE(9920)] = 300553,
  [SMALL_STATE(9921)] = 300562,
  [SMALL_STATE(9922)] = 300571,
  [SMALL_STATE(9923)] = 300580,
  [SMALL_STATE(9924)] = 300589,
  [SMALL_STATE(9925)] = 300598,
  [SMALL_STATE(9926)] = 300607,
  [SMALL_STATE(9927)] = 300616,
  [SMALL_STATE(9928)] = 300625,
  [SMALL_STATE(9929)] = 300634,
  [SMALL_STATE(9930)] = 300643,
  [SMALL_STATE(9931)] = 300652,
  [SMALL_STATE(9932)] = 300661,
  [SMALL_STATE(9933)] = 300670,
  [SMALL_STATE(9934)] = 300679,
  [SMALL_STATE(9935)] = 300688,
  [SMALL_STATE(9936)] = 300697,
  [SMALL_STATE(9937)] = 300706,
  [SMALL_STATE(9938)] = 300715,
  [SMALL_STATE(9939)] = 300724,
  [SMALL_STATE(9940)] = 300733,
  [SMALL_STATE(9941)] = 300742,
  [SMALL_STATE(9942)] = 300751,
  [SMALL_STATE(9943)] = 300760,
  [SMALL_STATE(9944)] = 300769,
  [SMALL_STATE(9945)] = 300778,
  [SMALL_STATE(9946)] = 300787,
  [SMALL_STATE(9947)] = 300796,
  [SMALL_STATE(9948)] = 300805,
  [SMALL_STATE(9949)] = 300814,
  [SMALL_STATE(9950)] = 300823,
  [SMALL_STATE(9951)] = 300832,
  [SMALL_STATE(9952)] = 300841,
  [SMALL_STATE(9953)] = 300850,
  [SMALL_STATE(9954)] = 300859,
  [SMALL_STATE(9955)] = 300868,
  [SMALL_STATE(9956)] = 300877,
  [SMALL_STATE(9957)] = 300886,
  [SMALL_STATE(9958)] = 300895,
  [SMALL_STATE(9959)] = 300904,
  [SMALL_STATE(9960)] = 300913,
  [SMALL_STATE(9961)] = 300922,
  [SMALL_STATE(9962)] = 300931,
  [SMALL_STATE(9963)] = 300940,
  [SMALL_STATE(9964)] = 300949,
  [SMALL_STATE(9965)] = 300958,
  [SMALL_STATE(9966)] = 300967,
  [SMALL_STATE(9967)] = 300976,
  [SMALL_STATE(9968)] = 300985,
  [SMALL_STATE(9969)] = 300994,
  [SMALL_STATE(9970)] = 301003,
  [SMALL_STATE(9971)] = 301012,
  [SMALL_STATE(9972)] = 301021,
  [SMALL_STATE(9973)] = 301030,
  [SMALL_STATE(9974)] = 301039,
  [SMALL_STATE(9975)] = 301048,
  [SMALL_STATE(9976)] = 301057,
  [SMALL_STATE(9977)] = 301066,
  [SMALL_STATE(9978)] = 301075,
  [SMALL_STATE(9979)] = 301084,
  [SMALL_STATE(9980)] = 301093,
  [SMALL_STATE(9981)] = 301102,
  [SMALL_STATE(9982)] = 301111,
  [SMALL_STATE(9983)] = 301120,
  [SMALL_STATE(9984)] = 301129,
  [SMALL_STATE(9985)] = 301138,
  [SMALL_STATE(9986)] = 301147,
  [SMALL_STATE(9987)] = 301156,
  [SMALL_STATE(9988)] = 301165,
  [SMALL_STATE(9989)] = 301174,
  [SMALL_STATE(9990)] = 301183,
  [SMALL_STATE(9991)] = 301192,
  [SMALL_STATE(9992)] = 301201,
  [SMALL_STATE(9993)] = 301210,
  [SMALL_STATE(9994)] = 301219,
  [SMALL_STATE(9995)] = 301228,
  [SMALL_STATE(9996)] = 301237,
  [SMALL_STATE(9997)] = 301246,
  [SMALL_STATE(9998)] = 301255,
  [SMALL_STATE(9999)] = 301264,
  [SMALL_STATE(10000)] = 301273,
  [SMALL_STATE(10001)] = 301282,
  [SMALL_STATE(10002)] = 301291,
  [SMALL_STATE(10003)] = 301300,
  [SMALL_STATE(10004)] = 301309,
  [SMALL_STATE(10005)] = 301318,
  [SMALL_STATE(10006)] = 301327,
  [SMALL_STATE(10007)] = 301336,
  [SMALL_STATE(10008)] = 301345,
  [SMALL_STATE(10009)] = 301354,
  [SMALL_STATE(10010)] = 301363,
  [SMALL_STATE(10011)] = 301372,
  [SMALL_STATE(10012)] = 301381,
  [SMALL_STATE(10013)] = 301390,
  [SMALL_STATE(10014)] = 301399,
  [SMALL_STATE(10015)] = 301408,
  [SMALL_STATE(10016)] = 301417,
  [SMALL_STATE(10017)] = 301426,
  [SMALL_STATE(10018)] = 301435,
  [SMALL_STATE(10019)] = 301444,
  [SMALL_STATE(10020)] = 301453,
  [SMALL_STATE(10021)] = 301462,
  [SMALL_STATE(10022)] = 301471,
  [SMALL_STATE(10023)] = 301480,
  [SMALL_STATE(10024)] = 301489,
  [SMALL_STATE(10025)] = 301498,
  [SMALL_STATE(10026)] = 301507,
  [SMALL_STATE(10027)] = 301516,
  [SMALL_STATE(10028)] = 301525,
  [SMALL_STATE(10029)] = 301534,
  [SMALL_STATE(10030)] = 301543,
  [SMALL_STATE(10031)] = 301552,
  [SMALL_STATE(10032)] = 301561,
  [SMALL_STATE(10033)] = 301570,
  [SMALL_STATE(10034)] = 301579,
  [SMALL_STATE(10035)] = 301588,
  [SMALL_STATE(10036)] = 301597,
  [SMALL_STATE(10037)] = 301606,
  [SMALL_STATE(10038)] = 301615,
  [SMALL_STATE(10039)] = 301624,
  [SMALL_STATE(10040)] = 301633,
  [SMALL_STATE(10041)] = 301642,
  [SMALL_STATE(10042)] = 301651,
  [SMALL_STATE(10043)] = 301660,
  [SMALL_STATE(10044)] = 301669,
  [SMALL_STATE(10045)] = 301678,
  [SMALL_STATE(10046)] = 301687,
  [SMALL_STATE(10047)] = 301696,
  [SMALL_STATE(10048)] = 301705,
  [SMALL_STATE(10049)] = 301714,
  [SMALL_STATE(10050)] = 301723,
  [SMALL_STATE(10051)] = 301732,
  [SMALL_STATE(10052)] = 301741,
  [SMALL_STATE(10053)] = 301750,
  [SMALL_STATE(10054)] = 301759,
  [SMALL_STATE(10055)] = 301768,
  [SMALL_STATE(10056)] = 301777,
  [SMALL_STATE(10057)] = 301786,
  [SMALL_STATE(10058)] = 301795,
  [SMALL_STATE(10059)] = 301804,
  [SMALL_STATE(10060)] = 301813,
  [SMALL_STATE(10061)] = 301822,
  [SMALL_STATE(10062)] = 301831,
  [SMALL_STATE(10063)] = 301840,
  [SMALL_STATE(10064)] = 301849,
  [SMALL_STATE(10065)] = 301858,
  [SMALL_STATE(10066)] = 301867,
  [SMALL_STATE(10067)] = 301876,
  [SMALL_STATE(10068)] = 301885,
  [SMALL_STATE(10069)] = 301894,
  [SMALL_STATE(10070)] = 301903,
  [SMALL_STATE(10071)] = 301912,
  [SMALL_STATE(10072)] = 301921,
  [SMALL_STATE(10073)] = 301930,
  [SMALL_STATE(10074)] = 301939,
  [SMALL_STATE(10075)] = 301948,
  [SMALL_STATE(10076)] = 301957,
  [SMALL_STATE(10077)] = 301966,
  [SMALL_STATE(10078)] = 301975,
  [SMALL_STATE(10079)] = 301984,
  [SMALL_STATE(10080)] = 301993,
  [SMALL_STATE(10081)] = 302002,
  [SMALL_STATE(10082)] = 302011,
  [SMALL_STATE(10083)] = 302020,
  [SMALL_STATE(10084)] = 302029,
  [SMALL_STATE(10085)] = 302038,
  [SMALL_STATE(10086)] = 302047,
  [SMALL_STATE(10087)] = 302056,
  [SMALL_STATE(10088)] = 302065,
  [SMALL_STATE(10089)] = 302074,
  [SMALL_STATE(10090)] = 302083,
  [SMALL_STATE(10091)] = 302092,
  [SMALL_STATE(10092)] = 302101,
  [SMALL_STATE(10093)] = 302110,
  [SMALL_STATE(10094)] = 302119,
  [SMALL_STATE(10095)] = 302128,
  [SMALL_STATE(10096)] = 302137,
  [SMALL_STATE(10097)] = 302146,
  [SMALL_STATE(10098)] = 302155,
  [SMALL_STATE(10099)] = 302164,
  [SMALL_STATE(10100)] = 302173,
  [SMALL_STATE(10101)] = 302182,
  [SMALL_STATE(10102)] = 302191,
  [SMALL_STATE(10103)] = 302200,
  [SMALL_STATE(10104)] = 302209,
  [SMALL_STATE(10105)] = 302218,
  [SMALL_STATE(10106)] = 302227,
  [SMALL_STATE(10107)] = 302236,
  [SMALL_STATE(10108)] = 302245,
  [SMALL_STATE(10109)] = 302254,
  [SMALL_STATE(10110)] = 302263,
  [SMALL_STATE(10111)] = 302272,
  [SMALL_STATE(10112)] = 302281,
  [SMALL_STATE(10113)] = 302290,
  [SMALL_STATE(10114)] = 302299,
  [SMALL_STATE(10115)] = 302308,
  [SMALL_STATE(10116)] = 302317,
  [SMALL_STATE(10117)] = 302326,
  [SMALL_STATE(10118)] = 302335,
  [SMALL_STATE(10119)] = 302344,
  [SMALL_STATE(10120)] = 302353,
  [SMALL_STATE(10121)] = 302362,
  [SMALL_STATE(10122)] = 302371,
  [SMALL_STATE(10123)] = 302380,
  [SMALL_STATE(10124)] = 302389,
  [SMALL_STATE(10125)] = 302398,
  [SMALL_STATE(10126)] = 302407,
  [SMALL_STATE(10127)] = 302416,
  [SMALL_STATE(10128)] = 302425,
  [SMALL_STATE(10129)] = 302434,
  [SMALL_STATE(10130)] = 302443,
  [SMALL_STATE(10131)] = 302452,
  [SMALL_STATE(10132)] = 302461,
  [SMALL_STATE(10133)] = 302470,
  [SMALL_STATE(10134)] = 302479,
  [SMALL_STATE(10135)] = 302488,
  [SMALL_STATE(10136)] = 302497,
  [SMALL_STATE(10137)] = 302506,
  [SMALL_STATE(10138)] = 302515,
  [SMALL_STATE(10139)] = 302524,
  [SMALL_STATE(10140)] = 302533,
  [SMALL_STATE(10141)] = 302542,
  [SMALL_STATE(10142)] = 302551,
  [SMALL_STATE(10143)] = 302560,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6504),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6445),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6483),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7956),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10139),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5685),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7083),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7096),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8046),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8053),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8054),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10132),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8739),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10016),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2876),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5141),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3022),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2496),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8693),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9416),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9417),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10066),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7668),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9318),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5693),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7082),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8074),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8290),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4987),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8091),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9914),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8621),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9425),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9608),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9248),
  [125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_purescript, 3),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9379),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9414),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9766),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_purescript, 2),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1730),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6011),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6228),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8725),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9757),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9565),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9566),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9747),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9702),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9363),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9590),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9406),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9480),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9687),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9647),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9528),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9697),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9512),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9767),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9675),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9445),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9496),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9633),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9463),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9427),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9544),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9560),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9575),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9605),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9707),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9661),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9737),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9717),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9619),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9727),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1736),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8653),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9550),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9551),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6805),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6171),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6531),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5793),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6688),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7230),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6384),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6381),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6018),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5926),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1810),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2280),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2441),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5235),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6265),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8695),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9434),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9435),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6063),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5494),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8724),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9760),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9761),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2539),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2676),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2288),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6250),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8694),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9931),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9930),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2553),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6569),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6443),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1666),
  [615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_apply, 1),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1756),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_apply, 1),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(1679),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8721),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9720),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9721),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1914),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(1669),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6698),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2254),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8722),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9740),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9741),
  [687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1638),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1926),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [707] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(1716),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2415),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8705),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9502),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9503),
  [729] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(1669),
  [733] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(1679),
  [737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(1716),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1952),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [754] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(1769),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6495),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2464),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8718),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9680),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9681),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [790] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(1862),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2433),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8692),
  [806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9342),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9343),
  [812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [826] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(1855),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2479),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8720),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9690),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9691),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(1769),
  [851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(1855),
  [854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(1862),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2431),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2684),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2472),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8700),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9470),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9471),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2098),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2406),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2309),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8716),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2074),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2500),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2081),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8726),
  [960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9788),
  [964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9789),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2115),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2421),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2308),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1001] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2009),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6409),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8717),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6563),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4977),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [1061] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2081),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5266),
  [1071] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2115),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4986),
  [1083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2009),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6396),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6394),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6393),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6752),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6905),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [1124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5947),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [1140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(1963),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5948),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6621),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [1199] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(1963),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6694),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7438),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5945),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2725),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2740),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2606),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6490),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8711),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9610),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9611),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5255),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2827),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2610),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6589),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8696),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9452),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9453),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2497),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2630),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6360),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1967),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6623),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [1353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8714),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [1359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9624),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9625),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5017),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6214),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1862),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [1393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8723),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [1411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2270),
  [1414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [1416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [1418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4760),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [1422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5029),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [1438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5151),
  [1440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5040),
  [1442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4739),
  [1444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4711),
  [1446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5278),
  [1448] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2270),
  [1452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5594),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [1456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1855),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [1462] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2472),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [1468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [1470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5051),
  [1472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2472),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2998),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2965),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6520),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8710),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9580),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9581),
  [1511] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2610),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [1517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [1519] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2606),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [1527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2610),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2541),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6462),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [1553] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2645),
  [1557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(2923),
  [1560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ticked, 3), SHIFT(2991),
  [1563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(2991),
  [1566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(2998),
  [1569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ticked, 3), SHIFT(2998),
  [1572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(5494),
  [1575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ticked, 3), SHIFT(2784),
  [1578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ticked, 3), SHIFT(813),
  [1581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ticked, 3), SHIFT(246),
  [1584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(2965),
  [1587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ticked, 3), SHIFT(6520),
  [1590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ticked, 3), SHIFT(2440),
  [1593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ticked, 3), SHIFT(362),
  [1596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(483),
  [1599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(312),
  [1602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(8708),
  [1605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ticked, 3), SHIFT(1485),
  [1608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(9580),
  [1611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_ticked, 3), SHIFT(9581),
  [1614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2606),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2959),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6534),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8708),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [1643] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2541),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2541),
  [1651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2645),
  [1654] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2785),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2393),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [1662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2785),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [1667] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(2965),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2440),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [1675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), SHIFT(2965),
  [1678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [1680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5703),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [1684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5822),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5995),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5995),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6296),
  [1692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__minus, 1, .production_id = 11),
  [1698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5510),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6354),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9518),
  [1708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9519),
  [1710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4707),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5298),
  [1716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5157),
  [1718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4978),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6256),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9638),
  [1734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9639),
  [1736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4648),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [1740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5253),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5238),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5047),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9652),
  [1760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9653),
  [1762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5009),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5788),
  [1766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5788),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5550),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5108),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6377),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9534),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9535),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4996),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5815),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5882),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5720),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6401),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9779),
  [1812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9780),
  [1814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5382),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6278),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6392),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6392),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5953),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5974),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6340),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9393),
  [1838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9394),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8395),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8396),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8060),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8442),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [1850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__let_decls, 3),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8088),
  [1854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8548),
  [1856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8101),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8275),
  [1862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__let_decls, 1),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__let_decls, 4),
  [1866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [1868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4339),
  [1870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4357),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4574),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4574),
  [1878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4568),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3039),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [1888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [1890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5943),
  [1894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9222),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6231),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6876),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6545),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5836),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3250),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6310),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4828),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3228),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6253),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6788),
  [2068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6855),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6855),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6819),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6482),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_head, 1),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4225),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4177),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4070),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7938),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6181),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9582),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5372),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6689),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10127),
  [2130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5104),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [2134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5879),
  [2136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6029),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5782),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4889),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5315),
  [2154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5088),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4944),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6421),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9595),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9596),
  [2174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6364),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [2178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6934),
  [2180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6779),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6779),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6699),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6543),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4943),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [2196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5509),
  [2198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5633),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5347),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6508),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9710),
  [2216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9711),
  [2218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4763),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [2222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5214),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5290),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4938),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9750),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9751),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6598),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7057),
  [2248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7057),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6981),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6739),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6593),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9666),
  [2268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9667),
  [2270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5070),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5961),
  [2276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6203),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6203),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5739),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5038),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6675),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5030),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [2300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5670),
  [2302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5599),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5192),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [2318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9486),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9487),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5032),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5442),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5442),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5783),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5286),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6692),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [2344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9730),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9731),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4725),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5322),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5270),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4934),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6597),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [2370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9770),
  [2372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9771),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6109),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [2378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6480),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6463),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [2386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6362),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6690),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5199),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5976),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5908),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5699),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [2414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9797),
  [2416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9798),
  [2418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5478),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6229),
  [2424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6261),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5909),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6447),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9700),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9701),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_head, 1),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3261),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3179),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3129),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9933),
  [2468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3148),
  [2470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_head, 2),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3223),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6088),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9479),
  [2494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2),
  [2496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3157),
  [2499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3261),
  [2502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3261),
  [2505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3179),
  [2508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3179),
  [2511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3267),
  [2514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(1014),
  [2517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(761),
  [2520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3129),
  [2523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(5964),
  [2526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(9933),
  [2529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(6231),
  [2532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(6231),
  [2535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3148),
  [2538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3226),
  [2541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3226),
  [2544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3160),
  [2547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3160),
  [2550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3223),
  [2553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(1030),
  [2556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(740),
  [2559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3125),
  [2562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(6088),
  [2565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(9479),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_data, 5, .production_id = 31),
  [2570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [2572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [2576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3577),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [2580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3668),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8663),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9364),
  [2594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_data, 4, .production_id = 16),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_data, 5, .production_id = 16),
  [2598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [2600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3436),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [2604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3692),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [2608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8731),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6164),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8881),
  [2622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_data, 6, .production_id = 31),
  [2624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat2, 2),
  [2626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_head, 3),
  [2628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [2630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [2638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6180),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9521),
  [2650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_instance_head, 4),
  [2652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3469),
  [2655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3586),
  [2658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3586),
  [2661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3688),
  [2664] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3688),
  [2667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3587),
  [2670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(1321),
  [2673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(678),
  [2676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3308),
  [2679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(6215),
  [2682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(8900),
  [2685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3499),
  [2688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3436),
  [2691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3436),
  [2694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3692),
  [2697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3692),
  [2700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3535),
  [2703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(1360),
  [2706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(715),
  [2709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3385),
  [2712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(6164),
  [2715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(8881),
  [2718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat2, 3),
  [2720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3439),
  [2723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3475),
  [2726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3475),
  [2729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3552),
  [2732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3552),
  [2735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3471),
  [2738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(1322),
  [2741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(710),
  [2744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3405),
  [2747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(6180),
  [2750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(9521),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [2755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3586),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [2759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3688),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [2763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6215),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8900),
  [2775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3509),
  [2778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3669),
  [2781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3669),
  [2784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3577),
  [2787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3577),
  [2790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3668),
  [2793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(1318),
  [2796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(734),
  [2799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3419),
  [2802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(6134),
  [2805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(9364),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5915),
  [2810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6249),
  [2812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6249),
  [2814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6371),
  [2816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6371),
  [2818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6337),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6660),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6681),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6442),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7454),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6477),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6529),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6846),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6896),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6896),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6841),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6548),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7324),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6865),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6599),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6814),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6286),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [2910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6579),
  [2912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6547),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6425),
  [2918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6511),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6185),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [2938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6735),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [2942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7015),
  [2944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6957),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6957),
  [2948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7080),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3802),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8058),
  [2962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4138),
  [2965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4176),
  [2968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4176),
  [2971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4225),
  [2974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4225),
  [2977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4177),
  [2980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(1412),
  [2983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(712),
  [2986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4070),
  [2989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(6181),
  [2992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(9143),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6107),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8056),
  [2999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4223),
  [3002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4288),
  [3005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4288),
  [3008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4157),
  [3011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4157),
  [3014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4287),
  [3017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(1420),
  [3020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(699),
  [3023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3820),
  [3026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(6190),
  [3029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(9397),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5419),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [3036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [3038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9143),
  [3040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4223),
  [3044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4288),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [3048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4157),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [3052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4287),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [3056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [3058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3820),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6190),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9397),
  [3064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [3068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6188),
  [3070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6933),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8589),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [3078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6198),
  [3082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3257),
  [3085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3389),
  [3088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3389),
  [3091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3295),
  [3094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3295),
  [3097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2),
  [3099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3398),
  [3102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(807),
  [3105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3093),
  [3108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6588),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2),
  [3113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(860),
  [3116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4078),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4137),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4302),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4136),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [3132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8838),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6204),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8532),
  [3146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3257),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [3150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3295),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_apply, 2),
  [3158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [3162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3093),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [3167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_apply, 2),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6149),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [3181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__apat, 1),
  [3183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3093),
  [3186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__apat, 1),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6306),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8470),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8476),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8050),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6178),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8048),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6199),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6344),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6763),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6654),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6124),
  [3238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4078),
  [3241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4137),
  [3244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4137),
  [3247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4302),
  [3250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4302),
  [3253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(4136),
  [3256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(1429),
  [3259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(741),
  [3262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(3946),
  [3265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(5925),
  [3268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat1, 2), SHIFT_REPEAT(8838),
  [3271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8114),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6652),
  [3275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [3277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2),
  [3280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [3284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3136),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [3288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [3293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [3295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [3297] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3032),
  [3301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9307),
  [3305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_apply, 2),
  [3307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3053),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [3311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3138),
  [3315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [3317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_apply, 2),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [3321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [3323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [3325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3044),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6092),
  [3330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9049),
  [3332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3078),
  [3335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2),
  [3337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3110),
  [3340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3110),
  [3343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3136),
  [3346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3136),
  [3349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2),
  [3351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3104),
  [3354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(949),
  [3357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(711),
  [3360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3032),
  [3363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5846),
  [3366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9307),
  [3369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3053),
  [3372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3142),
  [3375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3142),
  [3378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3138),
  [3381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3138),
  [3384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3059),
  [3387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(950),
  [3390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(690),
  [3393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3044),
  [3396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6092),
  [3399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9049),
  [3402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [3406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3653),
  [3408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3617),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [3412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [3416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3369),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [3425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3032),
  [3428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3369),
  [3431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3305),
  [3434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3709),
  [3437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3709),
  [3440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3520),
  [3443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3520),
  [3446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3624),
  [3449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(772),
  [3452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3356),
  [3455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6726),
  [3458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(867),
  [3461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__btype, 2),
  [3463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__btype, 2),
  [3465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3032),
  [3468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3353),
  [3471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3697),
  [3474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3697),
  [3477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3683),
  [3480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3683),
  [3483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3685),
  [3486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(791),
  [3489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3361),
  [3492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6616),
  [3495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(854),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__btype, 1),
  [3500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__btype, 1),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [3504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3044),
  [3507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3305),
  [3509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [3511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3709),
  [3513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [3517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3624),
  [3519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [3521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3356),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6726),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [3528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3356),
  [3531] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3044),
  [3535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3342),
  [3538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3511),
  [3541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3511),
  [3544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3453),
  [3547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3453),
  [3550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3613),
  [3553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(804),
  [3556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3381),
  [3559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6650),
  [3562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(851),
  [3565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3342),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [3569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [3571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [3575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3613),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3381),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3686),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3529),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [3594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3670),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [3598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3306),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6469),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3286),
  [3608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3686),
  [3611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3686),
  [3614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3529),
  [3617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3529),
  [3620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3670),
  [3623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(778),
  [3626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3306),
  [3629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6469),
  [3632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(873),
  [3635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [3637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [3639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3697),
  [3641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3683),
  [3643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [3645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3685),
  [3647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [3649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3361),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6616),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3344),
  [3659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3653),
  [3662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3653),
  [3665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3617),
  [3668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3617),
  [3671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3530),
  [3674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(785),
  [3677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3369),
  [3680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6617),
  [3683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(855),
  [3686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3032),
  [3689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3069),
  [3692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3141),
  [3695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3141),
  [3698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3137),
  [3701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3137),
  [3704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3140),
  [3707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(968),
  [3710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(676),
  [3713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3037),
  [3716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6152),
  [3719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9301),
  [3722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3044),
  [3725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [3727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [3731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3137),
  [3733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [3735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3037),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9301),
  [3748] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3037),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [3754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3037),
  [3757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3037),
  [3760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3361),
  [3763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3381),
  [3766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3306),
  [3769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3178),
  [3771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3231),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [3775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3181),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [3779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [3785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3131),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9283),
  [3792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3157),
  [3795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3261),
  [3798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3261),
  [3801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3179),
  [3804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3179),
  [3807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3267),
  [3810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(990),
  [3813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(761),
  [3816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3129),
  [3819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5964),
  [3822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9933),
  [3825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [3829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3796),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3847),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4049),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [3839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3559),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [3846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3559),
  [3849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3155),
  [3851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3245),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [3855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [3859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3116),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8806),
  [3872] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3116),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [3878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3116),
  [3881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6460),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6822),
  [3885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6822),
  [3887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6875),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6875),
  [3891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [3897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3700),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [3903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3448),
  [3906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3796),
  [3909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3796),
  [3912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3847),
  [3915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3847),
  [3918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4049),
  [3921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(799),
  [3924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3559),
  [3927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6581),
  [3930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(853),
  [3933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3157),
  [3936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3261),
  [3939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3261),
  [3942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3179),
  [3945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3179),
  [3948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3267),
  [3951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(980),
  [3954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(761),
  [3957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3129),
  [3960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(5964),
  [3963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(9933),
  [3966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3148),
  [3969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3226),
  [3972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3226),
  [3975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3160),
  [3978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3160),
  [3981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3223),
  [3984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(1031),
  [3987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(740),
  [3990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3125),
  [3993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(6088),
  [3996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(9479),
  [3999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3157),
  [4002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3261),
  [4005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3261),
  [4008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3179),
  [4011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3179),
  [4014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3267),
  [4017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(990),
  [4020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(761),
  [4023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3129),
  [4026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5964),
  [4029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9933),
  [4032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3116),
  [4035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3155),
  [4038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3245),
  [4041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3245),
  [4044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3194),
  [4047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3194),
  [4050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3247),
  [4053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(993),
  [4056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(730),
  [4059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3116),
  [4062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6037),
  [4065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8806),
  [4068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6318),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6879),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7077),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7077),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6979),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6979),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7209),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [4088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3858),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3148),
  [4097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3226),
  [4100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3226),
  [4103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3160),
  [4106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3160),
  [4109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3223),
  [4112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(997),
  [4115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(740),
  [4118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3125),
  [4121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6088),
  [4124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9479),
  [4127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6391),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6595),
  [4131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6595),
  [4133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6478),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [4137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6439),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [4143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6497),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6243),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6725),
  [4153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6725),
  [4155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6481),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6481),
  [4159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6625),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [4163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [4165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6584),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [4171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3573),
  [4174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4031),
  [4177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4031),
  [4180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3729),
  [4183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3729),
  [4186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3871),
  [4189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(763),
  [4192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3700),
  [4195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6718),
  [4198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(865),
  [4201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3461),
  [4204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3867),
  [4207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3867),
  [4210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3943),
  [4213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3943),
  [4216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3866),
  [4219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(779),
  [4222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3623),
  [4225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6669),
  [4228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(874),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3623),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [4241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3943),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3623),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6669),
  [4254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [4256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3623),
  [4259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [4263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3795),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3798),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3392),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [4278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6722),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6802),
  [4284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6802),
  [4286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6930),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6922),
  [4292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [4298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [4302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3392),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [4307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3178),
  [4310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3231),
  [4313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3231),
  [4316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3181),
  [4319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3181),
  [4322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3238),
  [4325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1012),
  [4328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(707),
  [4331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3131),
  [4334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5811),
  [4337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9283),
  [4340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3234),
  [4343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3191),
  [4346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3191),
  [4349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3177),
  [4352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3177),
  [4355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3192),
  [4358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1013),
  [4361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(706),
  [4364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3134),
  [4367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5840),
  [4370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9265),
  [4373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3157),
  [4376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3261),
  [4379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3261),
  [4382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3179),
  [4385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3179),
  [4388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3267),
  [4391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(980),
  [4394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(761),
  [4397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3129),
  [4400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5964),
  [4403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9933),
  [4406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3716),
  [4409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3795),
  [4412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3795),
  [4415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3742),
  [4418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3742),
  [4421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3798),
  [4424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(803),
  [4427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3392),
  [4430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6507),
  [4433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(864),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6701),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6701),
  [4442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6470),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6470),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6419),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [4452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6461),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [4460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3131),
  [4463] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3131),
  [4467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3131),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3234),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [4476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [4480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [4486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3134),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5840),
  [4491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9265),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [4495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3134),
  [4498] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3134),
  [4502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3134),
  [4505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3573),
  [4507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [4509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [4511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3729),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [4517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [4519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3700),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6718),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [4526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3700),
  [4529] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3148),
  [4533] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3226),
  [4537] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3226),
  [4541] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3160),
  [4545] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3160),
  [4549] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3223),
  [4553] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(1031),
  [4557] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(740),
  [4561] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3125),
  [4565] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(6088),
  [4569] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(9479),
  [4573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3148),
  [4576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3226),
  [4579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3226),
  [4582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3160),
  [4585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3160),
  [4588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3223),
  [4591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(1031),
  [4594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(740),
  [4597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3125),
  [4600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6088),
  [4603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9479),
  [4606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3148),
  [4609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3226),
  [4612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3226),
  [4615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3160),
  [4618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3160),
  [4621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3223),
  [4624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(997),
  [4627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(740),
  [4630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3125),
  [4633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6088),
  [4636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9479),
  [4639] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3157),
  [4643] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3261),
  [4647] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3261),
  [4651] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3179),
  [4655] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3179),
  [4659] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3267),
  [4663] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(980),
  [4667] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(761),
  [4671] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3129),
  [4675] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(5964),
  [4679] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(9933),
  [4683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4595),
  [4685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4683),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9682),
  [4693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [4695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3714),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [4699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3639),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [4703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [4709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6157),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8976),
  [4715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [4717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4172),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [4721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4301),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [4725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4171),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [4731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3814),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6110),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8843),
  [4737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3935),
  [4739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3828),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [4743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3821),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [4747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3823),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [4753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3585),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9211),
  [4759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3338),
  [4761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3324),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [4765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3373),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [4769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [4775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3202),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9316),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [4786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3134),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9265),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [4794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3131),
  [4796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9283),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4163),
  [4800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4311),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [4804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4183),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [4808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4312),
  [4810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [4816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5996),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10053),
  [4820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4759),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4732),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [4826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4892),
  [4828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [4830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4872),
  [4832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [4834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [4836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4579),
  [4838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [4840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9576),
  [4842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3291),
  [4845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3413),
  [4848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3413),
  [4851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3394),
  [4854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3394),
  [4857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3404),
  [4860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1051),
  [4863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(698),
  [4866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3184),
  [4869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5987),
  [4872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9175),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8806),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [4883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4424),
  [4885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4381),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [4889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4445),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [4893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4333),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [4899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9193),
  [4905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4506),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4550),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4560),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [4915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4547),
  [4917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4466),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5933),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9881),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [4929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3037),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9301),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [4937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4743),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4885),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [4947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4895),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [4953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4673),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5971),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8918),
  [4959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4232),
  [4961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4447),
  [4963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [4965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [4967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [4969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4448),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [4975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4303),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6062),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9481),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [4983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4826),
  [4985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4816),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [4989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4812),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [4993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4817),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [4999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4621),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6045),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8864),
  [5005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [5009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [5011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3407),
  [5013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [5015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [5019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [5025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3183),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [5030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9157),
  [5032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [5034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4197),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [5038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4304),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4196),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [5048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3806),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8791),
  [5054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4361),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4428),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [5060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4346),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [5064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4427),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4284),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9403),
  [5076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4780),
  [5078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4770),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [5082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4714),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [5086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4779),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [5092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4503),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6141),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9932),
  [5098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3849),
  [5100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3744),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4062),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [5114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3463),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9686),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [5122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [5124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [5128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [5132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3404),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [5138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9175),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [5148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4389),
  [5150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4405),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4368),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [5158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4406),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4270),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6158),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [5170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [5172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [5176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3799),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [5180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4009),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [5186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3616),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6208),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8919),
  [5192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3906),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4208),
  [5198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4305),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [5202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4073),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [5206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3858),
  [5209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [5213] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3183),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [5219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [5221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9307),
  [5223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3858),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [5228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3184),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9175),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [5235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3183),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [5240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4874),
  [5242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4912),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [5246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4894),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [5250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4913),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [5256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4523),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8745),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [5264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9157),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [5274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [5276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4473),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [5280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4418),
  [5284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4471),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [5290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4226),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6213),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9631),
  [5296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4710),
  [5298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4552),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [5302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4619),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [5306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4554),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [5312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4351),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9803),
  [5318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3338),
  [5321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3324),
  [5324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3324),
  [5327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3373),
  [5330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3373),
  [5333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3319),
  [5336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1141),
  [5339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(716),
  [5342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3202),
  [5345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5956),
  [5348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9316),
  [5351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3467),
  [5353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3665),
  [5355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [5357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3601),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [5361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3656),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [5367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3371),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9247),
  [5373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4030),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [5377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4178),
  [5379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4257),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4257),
  [5383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4076),
  [5385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [5387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__apat, 1), SHIFT(3802),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6573),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [5394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4557),
  [5396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4685),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [5400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4677),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [5404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4684),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [5410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4343),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5889),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9261),
  [5416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_apply, 2), SHIFT(3802),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [5423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3975),
  [5425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3970),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [5429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3818),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [5433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3968),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [5439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3594),
  [5441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6009),
  [5443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9139),
  [5445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [5447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3922),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [5451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3824),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [5455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [5461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9313),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [5469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4237),
  [5471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4280),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [5475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4204),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [5479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4281),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [5485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3999),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6117),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10119),
  [5491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4879),
  [5493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4748),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [5497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4851),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [5501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4752),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [5507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4540),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9306),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [5519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3330),
  [5522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3407),
  [5525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3407),
  [5528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3399),
  [5531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3399),
  [5534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3408),
  [5537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1171),
  [5540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(697),
  [5543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3183),
  [5546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6007),
  [5549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9157),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [5558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3202),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9316),
  [5562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [5568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [5572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [5578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3169),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6202),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8938),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [5590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [5594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3817),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [5598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3600),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9085),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [5616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3169),
  [5619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8938),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [5623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [5625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3202),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [5630] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3184),
  [5634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3183),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [5643] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3202),
  [5647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3202),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [5652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3169),
  [5655] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3169),
  [5659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3728),
  [5661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4032),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [5665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3810),
  [5667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [5669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4033),
  [5671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [5673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [5675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3611),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8957),
  [5681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [5683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9049),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [5691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3906),
  [5694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4208),
  [5697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4208),
  [5700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4305),
  [5703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4305),
  [5706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4073),
  [5709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(780),
  [5712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3858),
  [5715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6467),
  [5718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(875),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [5723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4030),
  [5726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4178),
  [5729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4178),
  [5732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4257),
  [5735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4257),
  [5738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4076),
  [5741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(787),
  [5744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3802),
  [5747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6573),
  [5750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(856),
  [5753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3366),
  [5756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3421),
  [5759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3421),
  [5762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3292),
  [5765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3292),
  [5768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3423),
  [5771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1251),
  [5774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(680),
  [5777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3169),
  [5780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6202),
  [5783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8938),
  [5786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3169),
  [5789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4209),
  [5791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4098),
  [5793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [5795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4278),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [5799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4097),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3819),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9013),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [5813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3184),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [5818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3184),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [5823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [5827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4630),
  [5829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4564),
  [5831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [5833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [5835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4565),
  [5837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [5839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4408),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [5847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3397),
  [5850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8976),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [5854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3507),
  [5857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3714),
  [5860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3714),
  [5863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3639),
  [5866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3639),
  [5869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3721),
  [5872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1281),
  [5875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(682),
  [5878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3397),
  [5881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6157),
  [5884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8976),
  [5887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [5889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [5891] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3397),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [5897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3397),
  [5900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3397),
  [5903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3467),
  [5906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3665),
  [5909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3665),
  [5912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3601),
  [5915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3601),
  [5918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3656),
  [5921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1289),
  [5924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(704),
  [5927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3371),
  [5930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5903),
  [5933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9247),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [5938] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3439),
  [5942] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3475),
  [5946] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3475),
  [5950] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3552),
  [5954] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3552),
  [5958] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3471),
  [5962] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(1312),
  [5966] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(710),
  [5970] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3405),
  [5974] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(6180),
  [5978] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(9521),
  [5982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3499),
  [5985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3436),
  [5988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3436),
  [5991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3692),
  [5994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3692),
  [5997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3535),
  [6000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1297),
  [6003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(715),
  [6006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3385),
  [6009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6164),
  [6012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8881),
  [6015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [6017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [6019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3469),
  [6022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3586),
  [6025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3586),
  [6028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3688),
  [6031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3688),
  [6034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3587),
  [6037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(1343),
  [6040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(678),
  [6043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3308),
  [6046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6215),
  [6049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(8900),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [6060] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3469),
  [6064] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3586),
  [6068] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3586),
  [6072] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3688),
  [6076] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3688),
  [6080] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3587),
  [6084] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(1303),
  [6088] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(678),
  [6092] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3308),
  [6096] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(6215),
  [6100] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(8900),
  [6104] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3509),
  [6108] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3669),
  [6112] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3669),
  [6116] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3577),
  [6120] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3577),
  [6124] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3668),
  [6128] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(1326),
  [6132] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(734),
  [6136] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3419),
  [6140] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(6134),
  [6144] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(9364),
  [6148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3439),
  [6151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3475),
  [6154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3475),
  [6157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3552),
  [6160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3552),
  [6163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3471),
  [6166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(1357),
  [6169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(710),
  [6172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3405),
  [6175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6180),
  [6178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9521),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [6185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3509),
  [6188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3669),
  [6191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3669),
  [6194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3577),
  [6197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3577),
  [6200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3668),
  [6203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(1326),
  [6206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(734),
  [6209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3419),
  [6212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6134),
  [6215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9364),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [6222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3469),
  [6225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3586),
  [6228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3586),
  [6231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3688),
  [6234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3688),
  [6237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3587),
  [6240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(1303),
  [6243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(678),
  [6246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3308),
  [6249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6215),
  [6252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(8900),
  [6255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3439),
  [6258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3475),
  [6261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3475),
  [6264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3552),
  [6267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3552),
  [6270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3471),
  [6273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(1312),
  [6276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(710),
  [6279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3405),
  [6282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6180),
  [6285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9521),
  [6288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [6290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3469),
  [6293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3586),
  [6296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3586),
  [6299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3688),
  [6302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3688),
  [6305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3587),
  [6308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(1303),
  [6311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(678),
  [6314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3308),
  [6317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(6215),
  [6320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(8900),
  [6323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [6325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3509),
  [6328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3669),
  [6331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3669),
  [6334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3577),
  [6337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3577),
  [6340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3668),
  [6343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(1366),
  [6346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(734),
  [6349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3419),
  [6352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6134),
  [6355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9364),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [6366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3371),
  [6369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9247),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [6375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [6377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3469),
  [6380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3586),
  [6383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3586),
  [6386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3688),
  [6389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3688),
  [6392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3587),
  [6395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1343),
  [6398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(678),
  [6401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3308),
  [6404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6215),
  [6407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8900),
  [6410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3371),
  [6413] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3371),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [6421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3371),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [6428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3509),
  [6431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3669),
  [6434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3669),
  [6437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3577),
  [6440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3577),
  [6443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3668),
  [6446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(1326),
  [6449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(734),
  [6452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3419),
  [6455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(6134),
  [6458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(9364),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [6463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3439),
  [6466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3475),
  [6469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3475),
  [6472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3552),
  [6475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3552),
  [6478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3471),
  [6481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1357),
  [6484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(710),
  [6487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3405),
  [6490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6180),
  [6493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9521),
  [6496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3439),
  [6499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3475),
  [6502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3475),
  [6505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3552),
  [6508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3552),
  [6511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3471),
  [6514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(1312),
  [6517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(710),
  [6520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3405),
  [6523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(6180),
  [6526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(9521),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [6531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3499),
  [6534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3436),
  [6537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3436),
  [6540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3692),
  [6543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3692),
  [6546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3535),
  [6549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(1365),
  [6552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(715),
  [6555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3385),
  [6558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6164),
  [6561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(8881),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [6566] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3499),
  [6570] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3436),
  [6574] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3436),
  [6578] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3692),
  [6582] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3692),
  [6586] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3535),
  [6590] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(1365),
  [6594] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(715),
  [6598] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3385),
  [6602] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(6164),
  [6606] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(8881),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [6612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3499),
  [6615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3436),
  [6618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3436),
  [6621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3692),
  [6624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3692),
  [6627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3535),
  [6630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(1297),
  [6633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(715),
  [6636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3385),
  [6639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6164),
  [6642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(8881),
  [6645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3509),
  [6648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3669),
  [6651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3669),
  [6654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3577),
  [6657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3577),
  [6660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3668),
  [6663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1366),
  [6666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(734),
  [6669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3419),
  [6672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6134),
  [6675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9364),
  [6678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3499),
  [6681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3436),
  [6684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3436),
  [6687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3692),
  [6690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(3692),
  [6693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3535),
  [6696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(1365),
  [6699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(715),
  [6702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3385),
  [6705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(6164),
  [6708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(8881),
  [6711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [6713] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3594),
  [6717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9139),
  [6719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3728),
  [6722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4032),
  [6725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4032),
  [6728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3810),
  [6731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3810),
  [6734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4033),
  [6737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1371),
  [6740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(681),
  [6743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3611),
  [6746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6177),
  [6749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8957),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [6754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3585),
  [6757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9211),
  [6759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3849),
  [6762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3744),
  [6765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3744),
  [6768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4062),
  [6771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4062),
  [6774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3743),
  [6777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1373),
  [6780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(727),
  [6783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3463),
  [6786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6191),
  [6789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9686),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [6794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3463),
  [6797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9686),
  [6799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [6801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3600),
  [6804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9085),
  [6806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3437),
  [6809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4630),
  [6812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4630),
  [6815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4564),
  [6818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4564),
  [6821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4565),
  [6824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(764),
  [6827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(4408),
  [6830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(6437),
  [6833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(863),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [6838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3594),
  [6841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3463),
  [6844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3594),
  [6847] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3600),
  [6851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [6853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3600),
  [6856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4048),
  [6859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4008),
  [6862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4008),
  [6865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3799),
  [6868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3799),
  [6871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4009),
  [6874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1382),
  [6877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(679),
  [6880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3616),
  [6883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6208),
  [6886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8919),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [6891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3611),
  [6894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8957),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [6898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3616),
  [6901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8919),
  [6903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3836),
  [6906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4003),
  [6909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4003),
  [6912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3817),
  [6915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3817),
  [6918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4002),
  [6921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1385),
  [6924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(693),
  [6927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3600),
  [6930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6080),
  [6933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9085),
  [6936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3594),
  [6939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3797),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [6943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4541),
  [6945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4598),
  [6947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [6949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4558),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [6953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4345),
  [6955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funvar, 2, .production_id = 20),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6423),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [6961] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3616),
  [6965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3600),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [6970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3616),
  [6973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funvar, 1, .production_id = 9),
  [6975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3585),
  [6978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3736),
  [6981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3922),
  [6984] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3922),
  [6987] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3824),
  [6990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3824),
  [6993] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3921),
  [6996] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1393),
  [6999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(714),
  [7002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3568),
  [7005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5936),
  [7008] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9313),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [7013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3585),
  [7016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3935),
  [7019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3828),
  [7022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3828),
  [7025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3821),
  [7028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3821),
  [7031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3823),
  [7034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1395),
  [7037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(702),
  [7040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3585),
  [7043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5954),
  [7046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9211),
  [7049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [7051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3463),
  [7054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3616),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [7059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3611),
  [7062] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3585),
  [7066] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3611),
  [7070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(3797),
  [7073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(4541),
  [7076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(4541),
  [7079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(4598),
  [7082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(4598),
  [7085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(4558),
  [7088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(786),
  [7091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(4345),
  [7094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2),
  [7096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(6423),
  [7099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(858),
  [7102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3975),
  [7105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3970),
  [7108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3970),
  [7111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3818),
  [7114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3818),
  [7117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3968),
  [7120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1402),
  [7123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(696),
  [7126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3594),
  [7129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6009),
  [7132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9139),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [7137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3568),
  [7140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9313),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [7144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3568),
  [7147] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3568),
  [7151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3568),
  [7154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3611),
  [7157] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3463),
  [7161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4078),
  [7164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4137),
  [7167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(4137),
  [7170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4302),
  [7173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(4302),
  [7176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4136),
  [7179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(1418),
  [7182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(741),
  [7185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3946),
  [7188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(5925),
  [7191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(8838),
  [7194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4223),
  [7197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4288),
  [7200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4288),
  [7203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4157),
  [7206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4157),
  [7209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4287),
  [7212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1410),
  [7215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(699),
  [7218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3820),
  [7221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6190),
  [7224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9397),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [7229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3814),
  [7232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8843),
  [7234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4138),
  [7237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4176),
  [7240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4176),
  [7243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4225),
  [7246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4225),
  [7249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4177),
  [7252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(1435),
  [7255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(712),
  [7258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4070),
  [7261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6181),
  [7264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9143),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [7269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3999),
  [7272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10119),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [7276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4006),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10053),
  [7281] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3814),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [7287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3814),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [7292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3819),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9013),
  [7297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4078),
  [7300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4137),
  [7303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4137),
  [7306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4302),
  [7309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4302),
  [7312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4136),
  [7315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(1442),
  [7318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(741),
  [7321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3946),
  [7324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5925),
  [7327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(8838),
  [7330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4138),
  [7333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4176),
  [7336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(4176),
  [7339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4225),
  [7342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(4225),
  [7345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4177),
  [7348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(1435),
  [7351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(712),
  [7354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4070),
  [7357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(6181),
  [7360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(9143),
  [7363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4223),
  [7366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4288),
  [7369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4288),
  [7372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4157),
  [7375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4157),
  [7378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4287),
  [7381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(1439),
  [7384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(699),
  [7387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3820),
  [7390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6190),
  [7393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9397),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [7398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3806),
  [7401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8791),
  [7403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4128),
  [7406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4197),
  [7409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4197),
  [7412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4304),
  [7415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4304),
  [7418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4196),
  [7421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1422),
  [7424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(732),
  [7427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3806),
  [7430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6035),
  [7433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8791),
  [7436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4163),
  [7439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4311),
  [7442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4311),
  [7445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4183),
  [7448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4183),
  [7451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4312),
  [7454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1423),
  [7457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(748),
  [7460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4006),
  [7463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5996),
  [7466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10053),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [7471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4006),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [7476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3999),
  [7479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4237),
  [7482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4280),
  [7485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4280),
  [7488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4204),
  [7491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4204),
  [7494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4281),
  [7497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1426),
  [7500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(760),
  [7503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3999),
  [7506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6117),
  [7509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10119),
  [7512] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4006),
  [7516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4006),
  [7519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4078),
  [7522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4137),
  [7525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4137),
  [7528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4302),
  [7531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4302),
  [7534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4136),
  [7537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(1418),
  [7540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(741),
  [7543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3946),
  [7546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5925),
  [7549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(8838),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [7554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3819),
  [7557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4209),
  [7560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4098),
  [7563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4098),
  [7566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4278),
  [7569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4278),
  [7572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4097),
  [7575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1431),
  [7578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(686),
  [7581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3819),
  [7584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6146),
  [7587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9013),
  [7590] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4138),
  [7594] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4176),
  [7598] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4176),
  [7602] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4225),
  [7606] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4225),
  [7610] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4177),
  [7614] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(1435),
  [7618] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(712),
  [7622] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4070),
  [7626] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(6181),
  [7630] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(9143),
  [7634] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3999),
  [7638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4138),
  [7641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4176),
  [7644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4176),
  [7647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4225),
  [7650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4225),
  [7653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4177),
  [7656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1434),
  [7659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(712),
  [7662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4070),
  [7665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6181),
  [7668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9143),
  [7671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4138),
  [7674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4176),
  [7677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4176),
  [7680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4225),
  [7683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4225),
  [7686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4177),
  [7689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(1434),
  [7692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(712),
  [7695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4070),
  [7698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6181),
  [7701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9143),
  [7704] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3819),
  [7708] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4223),
  [7712] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4288),
  [7716] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4288),
  [7720] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4157),
  [7724] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4157),
  [7728] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4287),
  [7732] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(1439),
  [7736] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(699),
  [7740] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3820),
  [7744] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(6190),
  [7748] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(9397),
  [7752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3806),
  [7755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4223),
  [7758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4288),
  [7761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4288),
  [7764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4157),
  [7767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4157),
  [7770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4287),
  [7773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(1410),
  [7776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(699),
  [7779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3820),
  [7782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6190),
  [7785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9397),
  [7788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4106),
  [7791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4172),
  [7794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4172),
  [7797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4301),
  [7800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4301),
  [7803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4171),
  [7806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1440),
  [7809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(717),
  [7812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3814),
  [7815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6110),
  [7818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8843),
  [7821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3814),
  [7824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4078),
  [7827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4137),
  [7830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4137),
  [7833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4302),
  [7836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4302),
  [7839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4136),
  [7842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1442),
  [7845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(741),
  [7848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3946),
  [7851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5925),
  [7854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8838),
  [7857] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4078),
  [7861] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4137),
  [7865] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4137),
  [7869] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4302),
  [7873] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4302),
  [7877] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4136),
  [7881] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(1418),
  [7885] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(741),
  [7889] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3946),
  [7893] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(5925),
  [7897] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(8838),
  [7901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3819),
  [7904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(3999),
  [7907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4223),
  [7910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4288),
  [7913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(4288),
  [7916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4157),
  [7919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(4157),
  [7922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4287),
  [7925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(1439),
  [7928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(699),
  [7931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(3820),
  [7934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 2), SHIFT(6190),
  [7937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(9397),
  [7940] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(3806),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [7946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(3806),
  [7949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [7951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4284),
  [7954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9403),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [7958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4226),
  [7961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9631),
  [7963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [7965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4277),
  [7968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9193),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [7972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4303),
  [7975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9481),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [7979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4270),
  [7982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9875),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [7986] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4303),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [7992] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4270),
  [7996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4389),
  [7999] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4405),
  [8002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4405),
  [8005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4368),
  [8008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4368),
  [8011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4406),
  [8014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1457),
  [8017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(747),
  [8020] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4270),
  [8023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6158),
  [8026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9875),
  [8029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4424),
  [8032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4381),
  [8035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4381),
  [8038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4445),
  [8041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4445),
  [8044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4333),
  [8047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1459),
  [8050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(700),
  [8053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4277),
  [8056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5958),
  [8059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9193),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [8064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4277),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [8069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6724),
  [8071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4232),
  [8074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4447),
  [8077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4447),
  [8080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4439),
  [8083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4439),
  [8086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4448),
  [8089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1465),
  [8092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(705),
  [8095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4303),
  [8098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6062),
  [8101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9481),
  [8104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_name, 1),
  [8106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_name, 1),
  [8108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_name, 1),
  [8110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_name, 1), REDUCE(sym_pat_name, 1),
  [8113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6943),
  [8115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__record_update_lhs, 1), REDUCE(sym_exp_name, 1),
  [8118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [8120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4303),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [8125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4284),
  [8128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4270),
  [8131] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4284),
  [8135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7014),
  [8137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4303),
  [8140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4226),
  [8143] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4226),
  [8147] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4277),
  [8151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4391),
  [8154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4473),
  [8157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4473),
  [8160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4418),
  [8163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4418),
  [8166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4471),
  [8169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1488),
  [8172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(735),
  [8175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4226),
  [8178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6213),
  [8181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9631),
  [8184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4277),
  [8187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4270),
  [8190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4361),
  [8193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4428),
  [8196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4428),
  [8199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4346),
  [8202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4346),
  [8205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4427),
  [8208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1491),
  [8211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(750),
  [8214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4284),
  [8217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6020),
  [8220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9403),
  [8223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor, 1),
  [8225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 1),
  [8227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4284),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [8232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4226),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [8237] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4398),
  [8241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9682),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [8245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4351),
  [8248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9803),
  [8250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_record_access, 2, .production_id = 38),
  [8252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_record_access, 2, .production_id = 38),
  [8254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7205),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [8258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4398),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [8263] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4351),
  [8267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4374),
  [8269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 8, .production_id = 47),
  [8271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4610),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [8275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4572),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [8279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4609),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [8285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5931),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9522),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [8293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6254),
  [8295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 6),
  [8297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [8299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4502),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [8303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4584),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [8307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4501),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [8313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3094),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5832),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10014),
  [8319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_accessor, 2, .production_id = 38),
  [8321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_accessor, 2, .production_id = 38),
  [8323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 8, .production_id = 54),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [8327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 3),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [8331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [8333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4466),
  [8336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9881),
  [8338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1),
  [8340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [8344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6385),
  [8346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 9, .production_id = 54),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [8352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6398),
  [8354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49),
  [8356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49),
  [8358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7205),
  [8361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4398),
  [8364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4374),
  [8367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4610),
  [8370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4610),
  [8373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4572),
  [8376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4572),
  [8379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4609),
  [8382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1522),
  [8385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(744),
  [8388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3311),
  [8391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5931),
  [8394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9522),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [8399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6459),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [8403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4343),
  [8406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9261),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [8410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4343),
  [8413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__aexp_projection, 1),
  [8415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__aexp_projection, 1),
  [8417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7179),
  [8419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__record_update_lhs, 1), REDUCE(sym__aexp_projection, 1),
  [8422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4710),
  [8425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4552),
  [8428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4552),
  [8431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4619),
  [8434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4619),
  [8437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4554),
  [8440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1527),
  [8443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(688),
  [8446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4351),
  [8449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6105),
  [8452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9803),
  [8455] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4343),
  [8459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4398),
  [8462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 7, .production_id = 47),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [8466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 7),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [8470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [8472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 7, .production_id = 54),
  [8474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4351),
  [8477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4343),
  [8480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 4),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [8486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6316),
  [8488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4506),
  [8491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4550),
  [8494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4550),
  [8497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4560),
  [8500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4560),
  [8503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4547),
  [8506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1551),
  [8509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(718),
  [8512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4466),
  [8515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5933),
  [8518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9881),
  [8521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 6, .production_id = 54),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [8527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6615),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [8531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4466),
  [8534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4557),
  [8537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4685),
  [8540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4685),
  [8543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4677),
  [8546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4677),
  [8549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4684),
  [8552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1555),
  [8555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(757),
  [8558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4343),
  [8561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5889),
  [8564] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9261),
  [8567] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7179),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [8572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6399),
  [8574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 5),
  [8576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 5, .production_id = 47),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [8582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6501),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [8586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6851),
  [8588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_derive, 6, .production_id = 47),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [8592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4384),
  [8595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4502),
  [8598] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4502),
  [8601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4584),
  [8604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4584),
  [8607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4501),
  [8610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1569),
  [8613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(726),
  [8616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3094),
  [8619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5832),
  [8622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10014),
  [8625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [8627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [8629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [8631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [8633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6082),
  [8635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [8637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4351),
  [8640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4595),
  [8643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4683),
  [8646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4683),
  [8649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4574),
  [8652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4574),
  [8655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4568),
  [8658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1585),
  [8661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(745),
  [8664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4398),
  [8667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5943),
  [8670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9682),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [8677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7061),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [8682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7061),
  [8684] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4466),
  [8687] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4466),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [8693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4879),
  [8696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4748),
  [8699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4748),
  [8702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4851),
  [8705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4851),
  [8708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4752),
  [8711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1610),
  [8714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(759),
  [8717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4540),
  [8720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6120),
  [8723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9306),
  [8726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4780),
  [8729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4770),
  [8732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4770),
  [8735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4714),
  [8738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4714),
  [8741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4779),
  [8744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1611),
  [8747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(728),
  [8750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4503),
  [8753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6141),
  [8756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9932),
  [8759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7392),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [8764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4540),
  [8767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9306),
  [8769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7392),
  [8771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_literal, 4),
  [8773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_literal, 4),
  [8775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_ado, 3, .production_id = 51),
  [8777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_ado, 3, .production_id = 51),
  [8779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [8781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_variable, 2),
  [8783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_variable, 2),
  [8785] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4540),
  [8789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_literal, 3),
  [8791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_literal, 3),
  [8793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_parens, 3),
  [8795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_parens, 3),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [8799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4540),
  [8802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 48),
  [8804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 48),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [8808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4579),
  [8811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9576),
  [8813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4874),
  [8816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4912),
  [8819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4912),
  [8822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4894),
  [8825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4894),
  [8828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4913),
  [8831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1629),
  [8834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(739),
  [8837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4523),
  [8840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5985),
  [8843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8745),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [8848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4523),
  [8851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8745),
  [8853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qcon, 1),
  [8855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qcon, 1),
  [8857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__modid, 1, .production_id = 3),
  [8859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_constructor, 2),
  [8861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_constructor, 2),
  [8863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4579),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [8868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_literal, 2),
  [8870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_literal, 2),
  [8872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7489),
  [8874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym_pat_name, 1),
  [8877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [8879] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4579),
  [8883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_ado, 4, .production_id = 59),
  [8885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_ado, 4, .production_id = 59),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [8891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4579),
  [8894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_fields, 2),
  [8896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 14),
  [8898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 14),
  [8900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ado_in, 3, .production_id = 60),
  [8902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ado_in, 3, .production_id = 60),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [8906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4503),
  [8909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9932),
  [8911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61),
  [8913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_ado, 5, .production_id = 61),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [8919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ado_in, 4, .production_id = 67),
  [8921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ado_in, 4, .production_id = 67),
  [8923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_ado, 6, .production_id = 68),
  [8925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_ado, 6, .production_id = 68),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [8929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ado_in, 5, .production_id = 76),
  [8931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ado_in, 5, .production_id = 76),
  [8933] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4503),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [8939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4503),
  [8942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4523),
  [8945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ado_in, 6, .production_id = 77),
  [8947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ado_in, 6, .production_id = 77),
  [8949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type, 2, .production_id = 23),
  [8951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 2, .production_id = 23),
  [8953] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4523),
  [8957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [8959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4523),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [8964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4621),
  [8967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8864),
  [8969] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4621),
  [8973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [8975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4621),
  [8978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4540),
  [8981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7477),
  [8984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7477),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [8988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(4673),
  [8991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8918),
  [8993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7039),
  [8995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [8997] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__btype, 1), REDUCE(sym__btype, 2), SHIFT(4673),
  [9001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [9003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(4673),
  [9006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7149),
  [9009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4621),
  [9012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4826),
  [9015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4816),
  [9018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4816),
  [9021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4812),
  [9024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4812),
  [9027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4817),
  [9030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1695),
  [9033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(752),
  [9036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4621),
  [9039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6045),
  [9042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8864),
  [9045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7149),
  [9047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4759),
  [9050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4732),
  [9053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4732),
  [9056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4892),
  [9059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4892),
  [9062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4872),
  [9065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1703),
  [9068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(719),
  [9071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4579),
  [9074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5890),
  [9077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9576),
  [9080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4743),
  [9083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4885),
  [9086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4885),
  [9089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4715),
  [9092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4715),
  [9095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4895),
  [9098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1707),
  [9101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(720),
  [9104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4673),
  [9107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5971),
  [9110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8918),
  [9113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [9115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [9117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [9119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [9121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4673),
  [9124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 2), SHIFT(4503),
  [9127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_section_left, 5),
  [9129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_section_left, 5),
  [9131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_type, 4, .dynamic_precedence = 1),
  [9133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_type, 4, .dynamic_precedence = 1),
  [9135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 3, .production_id = 51), SHIFT(1788),
  [9138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 3),
  [9140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 3),
  [9142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7497),
  [9144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 1),
  [9146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 1),
  [9148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_update, 3),
  [9150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update, 3),
  [9152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_array, 3),
  [9154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_array, 3),
  [9156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_name, 3),
  [9158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_name, 3),
  [9160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variable, 1),
  [9162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 1),
  [9164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_section_right, 5),
  [9166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_section_right, 5),
  [9168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_literal, 3),
  [9170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type_literal, 3),
  [9172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_update, 5),
  [9174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update, 5),
  [9176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 5),
  [9178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 5),
  [9180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_ado, 6, .production_id = 61),
  [9182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_ado, 6, .production_id = 61),
  [9184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_captured_type_operator, 3),
  [9186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_captured_type_operator, 3),
  [9188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7014),
  [9191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_name, 1), REDUCE(sym__pat_constructor, 1, .production_id = 4),
  [9194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym__pat_constructor, 1, .production_id = 4),
  [9197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_constructor, 1, .production_id = 4),
  [9199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__apat, 1, .production_id = 5),
  [9201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__aexp_projection, 1), REDUCE(sym__apat, 1, .production_id = 5),
  [9204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__visible_type_variable, 2, .production_id = 34),
  [9206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__visible_type_variable, 2, .production_id = 34),
  [9208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_literal, 4),
  [9210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type_literal, 4),
  [9212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parens, 3),
  [9214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parens, 3),
  [9216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_type, 3, .dynamic_precedence = 1),
  [9218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_type, 3, .dynamic_precedence = 1),
  [9220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_array, 2),
  [9222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_array, 2),
  [9224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1),
  [9226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1),
  [9228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_ado, 4, .production_id = 51),
  [9230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_ado, 4, .production_id = 51),
  [9232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_ado, 5, .production_id = 59),
  [9234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 59),
  [9236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_array, 4),
  [9238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_array, 4),
  [9240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_type_application, 2),
  [9242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_type_application, 2),
  [9244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 6),
  [9246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 6),
  [9248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_update, 4),
  [9250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_update, 4),
  [9252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_ado, 7, .production_id = 68),
  [9254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_ado, 7, .production_id = 68),
  [9256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 4),
  [9258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 4),
  [9260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_array, 2),
  [9262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_array, 2), REDUCE(sym_pat_array, 2),
  [9265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(6943),
  [9268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 4, .production_id = 59), SHIFT(1871),
  [9271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_literal, 2),
  [9273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type_literal, 2),
  [9275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_type, 2, .dynamic_precedence = 1),
  [9277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_type, 2, .dynamic_precedence = 1),
  [9279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qcon, 3),
  [9281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qcon, 3),
  [9283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tyvar_annotated, 4),
  [9285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyvar_annotated, 4),
  [9287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7489),
  [9290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_type, 5, .dynamic_precedence = 1),
  [9292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_row_type, 5, .dynamic_precedence = 1),
  [9294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1),
  [9296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1),
  [9298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_literal, 1),
  [9300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_literal, 1),
  [9302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_wildcard, 1),
  [9304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_wildcard, 1),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [9308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7188),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [9313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7188),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [9319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_type_literal, 5),
  [9321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_type_literal, 5),
  [9323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [9325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parens, 4),
  [9327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parens, 4),
  [9329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(1886),
  [9332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(1897),
  [9335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 6, .production_id = 68), SHIFT(1910),
  [9338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [9340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [9342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [9344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [9346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [9348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [9350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [9352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7316),
  [9354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [9356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7316),
  [9359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [9361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [9363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [9367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [9369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [9371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [9373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [9375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [9377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [9381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [9383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [9385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [9387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [9389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [9391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [9395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7391),
  [9397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [9399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [9401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [9403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [9405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [9407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [9409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 6, .production_id = 68), SHIFT(2106),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [9414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(2121),
  [9417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [9419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [9421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [9423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(2124),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [9428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [9430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [9432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [9436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [9438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 4, .production_id = 59), SHIFT(2129),
  [9441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7391),
  [9444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [9448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [9450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [9452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [9454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [9456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [9462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [9464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 3, .production_id = 51), SHIFT(2150),
  [9467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [9469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [9471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [9473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [9475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [9477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [9481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [9483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [9485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7370),
  [9487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [9489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [9491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [9493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [9495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [9497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [9499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [9501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [9503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2425),
  [9505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2279),
  [9507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [9509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2273),
  [9511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [9513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [9515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9815),
  [9519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [9521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [9523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [9525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [9527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [9531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [9533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9847),
  [9535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5201),
  [9537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5245),
  [9539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [9541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5244),
  [9543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [9545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [9547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [9549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9067),
  [9551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [9553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7245),
  [9556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2711),
  [9558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [9562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [9564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [9566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [9568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [9570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9103),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [9574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [9576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5986),
  [9578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6000),
  [9580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6000),
  [9582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6003),
  [9584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6046),
  [9586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [9588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5860),
  [9590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9177),
  [9592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7245),
  [9594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [9596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [9600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2555),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [9606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [9608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9368),
  [9610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7510),
  [9612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1734),
  [9614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1894),
  [9616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [9618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1896),
  [9620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [9622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [9626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9031),
  [9628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [9630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5368),
  [9632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5089),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [9636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5090),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [9644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9121),
  [9646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6413),
  [9648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6532),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6532),
  [9652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6535),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [9656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [9658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5937),
  [9660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9229),
  [9662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [9664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [9666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [9668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [9670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [9672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [9674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [9676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9304),
  [9678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7510),
  [9681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2568),
  [9683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [9685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [9687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [9689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [9691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [9693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6024),
  [9695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10006),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [9699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5785),
  [9701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5687),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [9705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5690),
  [9707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [9711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6207),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10043),
  [9715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [9717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5264),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [9721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5323),
  [9723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [9727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9725),
  [9731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5854),
  [9733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5841),
  [9735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [9737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [9741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [9743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9310),
  [9747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5600),
  [9749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5730),
  [9751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [9753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5729),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [9757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6138),
  [9761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9976),
  [9763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5484),
  [9765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5404),
  [9767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [9769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5403),
  [9771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [9773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [9775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [9777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8995),
  [9779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [9781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [9783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7370),
  [9786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [9788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [9790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [9792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6074),
  [9794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6047),
  [9796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [9798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5885),
  [9800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [9804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5912),
  [9806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9335),
  [9808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [9810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [9812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [9814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [9816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [9818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [9820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5898),
  [9822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9940),
  [9824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6836),
  [9826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6867),
  [9828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6867),
  [9830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6869),
  [9832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [9834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [9836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [9838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9692),
  [9840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6093),
  [9842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5801),
  [9844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [9846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5802),
  [9848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5963),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [9852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [9854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10015),
  [9856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [9858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [9860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [9862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [9864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [9866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8862),
  [9872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [9874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2957),
  [9876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [9878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2956),
  [9880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [9884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [9886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8766),
  [9888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_array, 2), REDUCE(sym_pat_array, 2),
  [9891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6966),
  [9893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7013),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [9897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7006),
  [9899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7274),
  [9901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9078),
  [9907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [9909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [9911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [9913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [9915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [9919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6041),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9437),
  [9923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1899),
  [9925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1825),
  [9927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [9929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [9931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [9933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [9937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10121),
  [9939] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7039),
  [9942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [9944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2405),
  [9946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [9948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2404),
  [9950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [9952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [9954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [9956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9886),
  [9958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6376),
  [9960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6288),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [9964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6289),
  [9966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [9968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [9970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8776),
  [9974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8410),
  [9976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [9978] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__aexp_projection, 1), REDUCE(sym__apat, 1, .production_id = 5),
  [9981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [9983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [9987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6077),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9063),
  [9997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5410),
  [9999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5470),
  [10001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5470),
  [10003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5469),
  [10005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [10007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [10009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6095),
  [10011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8824),
  [10013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [10015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [10017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [10019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2969),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [10023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6089),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9775),
  [10029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 3, .production_id = 51), SHIFT(2459),
  [10032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 4, .production_id = 59), SHIFT(2469),
  [10035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [10037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [10041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5907),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8997),
  [10051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(2476),
  [10054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(2478),
  [10057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 6, .production_id = 68), SHIFT(2481),
  [10060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [10062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2043),
  [10064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [10066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [10068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [10070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [10072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [10074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8761),
  [10076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2704),
  [10078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [10080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [10082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [10086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [10088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [10090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9814),
  [10092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [10094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [10096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [10098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [10100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7497),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [10109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [10111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [10113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [10119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [10121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [10123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [10127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [10129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [10133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [10135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [10137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [10139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [10141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4864),
  [10143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type, 1), SHIFT(3392),
  [10146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7091),
  [10148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7091),
  [10151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 2),
  [10153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 2),
  [10155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type, 2), SHIFT(3392),
  [10158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [10162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [10164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [10166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [10168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [10170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [10174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_name, 1, .production_id = 14),
  [10176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_name, 1, .production_id = 14),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [10184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1),
  [10186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1),
  [10188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_operator, 2),
  [10190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator, 2),
  [10192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp, 1),
  [10194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [10198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp, 1),
  [10200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [10202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [10204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [10206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1164),
  [10208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [10210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [10212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [10214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__minus, 1, .production_id = 11),
  [10216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [10218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_infix, 3),
  [10220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_infix, 3),
  [10222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [10224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [10226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [10228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [10230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [10232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1), REDUCE(aux_sym__quantifiers_repeat1, 1),
  [10235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 1),
  [10237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), REDUCE(aux_sym__quantifiers_repeat1, 1),
  [10240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__quantifiers_repeat1, 1),
  [10242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_name, 1, .production_id = 2),
  [10244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_name, 1, .production_id = 2),
  [10246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_name, 1), SHIFT(1265),
  [10249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_name, 1), REDUCE(sym__fun_name, 1, .production_id = 2),
  [10252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1549),
  [10254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_name, 1), SHIFT(1101),
  [10257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [10259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_name, 1), SHIFT(1164),
  [10262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_exp, 1),
  [10264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [10266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [10268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [10270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_name, 1),
  [10272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_name, 1),
  [10274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_name, 1),
  [10276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1505),
  [10278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_name, 3, .production_id = 22),
  [10280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_name, 3, .production_id = 22),
  [10282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_name, 3), SHIFT(1164),
  [10285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_name, 3),
  [10287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_name, 3), REDUCE(sym__fun_name, 3, .production_id = 22),
  [10290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [10292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_name, 3), SHIFT(1101),
  [10295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [10297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [10299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [10301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_name, 3), SHIFT(1265),
  [10304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [10306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_wildcard, 1, .production_id = 1),
  [10308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_wildcard, 1, .production_id = 1), SHIFT(3022),
  [10311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pat_wildcard, 1, .production_id = 1), SHIFT(3039),
  [10314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_wildcard, 1, .production_id = 1),
  [10316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_wildcard, 1, .production_id = 1), SHIFT(3392),
  [10319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_update_lhs, 1),
  [10321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [10323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [10325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_as, 3, .production_id = 28),
  [10327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_as, 3, .production_id = 28),
  [10329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_array, 3),
  [10331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_array, 3),
  [10333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [10335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 14), REDUCE(sym_class_name, 1, .production_id = 14),
  [10338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 14), REDUCE(sym_class_name, 1, .production_id = 14),
  [10341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1529),
  [10343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [10345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_fields, 3),
  [10347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_fields, 3),
  [10349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_parens, 3),
  [10351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_parens, 3),
  [10353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [10355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [10357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_array, 2),
  [10359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_fields, 2),
  [10361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_record, 1, .production_id = 6),
  [10363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_record, 1, .production_id = 6),
  [10365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [10367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_array, 4),
  [10369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_array, 4),
  [10371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__apat, 1, .production_id = 5),
  [10373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_fields, 4),
  [10375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_fields, 4),
  [10377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_name, 3),
  [10379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_wildcard, 1),
  [10381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard, 1),
  [10383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_constructor, 1, .production_id = 4),
  [10385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1221),
  [10387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9763),
  [10389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1), REDUCE(sym_class_name, 1),
  [10392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), REDUCE(sym_class_name, 1),
  [10395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [10397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [10399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [10401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [10403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [10405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [10407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [10409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [10411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [10413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [10415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1128),
  [10417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type, 2), SHIFT(4864),
  [10420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 2), SHIFT(3392),
  [10423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type, 1), SHIFT(4864),
  [10426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), SHIFT(3392),
  [10429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym__type, 2),
  [10432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type, 1), REDUCE(sym__type, 2),
  [10435] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type, 1), REDUCE(sym__type, 2), SHIFT(4864),
  [10439] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym__type, 2), SHIFT(3392),
  [10443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1513),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [10447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [10449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9823),
  [10451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9822),
  [10453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [10455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [10457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [10459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_guard, 3),
  [10461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_guard, 3),
  [10463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 1, .production_id = 13),
  [10465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [10467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [10471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [10473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [10477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [10479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [10481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [10483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [10485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7342),
  [10487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_guard, 1),
  [10489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard, 1),
  [10491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat, 1),
  [10493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat, 1),
  [10495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [10497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forall, 1),
  [10499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forall, 1),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8069),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8116),
  [10507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_name_ty, 1, .production_id = 12),
  [10509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tyvar_no_annotation, 1),
  [10511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyvar_no_annotation, 1),
  [10513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__field_name_ty, 1, .production_id = 12), REDUCE(sym__tyvar_no_annotation, 1),
  [10516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_forall_repeat1, 2),
  [10518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_forall_repeat1, 2),
  [10520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_forall_repeat1, 2), SHIFT_REPEAT(6231),
  [10523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_forall_repeat1, 2), SHIFT_REPEAT(6231),
  [10526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8390),
  [10528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7453),
  [10530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8245),
  [10532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7385),
  [10534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8512),
  [10536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8554),
  [10538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6787),
  [10542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7168),
  [10545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7168),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [10549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [10553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_if, 6, .production_id = 64),
  [10555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_if, 6, .production_id = 64),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [10559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_head, 2),
  [10561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6257),
  [10563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7359),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9068),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [10569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7100),
  [10571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6971),
  [10573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7100),
  [10576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [10578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6638),
  [10580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6348),
  [10582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_head, 4),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [10586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8911),
  [10588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [10590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [10592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 1),
  [10594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 1),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [10598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [10600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6176),
  [10604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_head, 3),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [10610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [10612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [10614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [10616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [10618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(6971),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [10625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [10627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [10629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [10635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [10637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [10639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_operator, 2),
  [10641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_operator, 2),
  [10643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__row_variable, 2),
  [10645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [10647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [10649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [10651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [10653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7675),
  [10655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [10657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7665),
  [10659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8042),
  [10661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9871),
  [10663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4858),
  [10665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_forall_repeat1, 3),
  [10667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_forall_repeat1, 3),
  [10669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7129),
  [10671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7139),
  [10673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6172),
  [10675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [10677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7280),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9996),
  [10681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7036),
  [10683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7242),
  [10686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7294),
  [10689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7595),
  [10691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7766),
  [10693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7129),
  [10696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7242),
  [10698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7844),
  [10700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [10702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7294),
  [10704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7783),
  [10706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7036),
  [10709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(6348),
  [10712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2),
  [10714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(7337),
  [10717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(8911),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8006),
  [10722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [10724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [10726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7344),
  [10728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(6257),
  [10731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(7359),
  [10734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(9068),
  [10737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [10739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_operator, 1),
  [10741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_operator, 1),
  [10743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7860),
  [10745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7914),
  [10747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [10749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9863),
  [10751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6902),
  [10753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7490),
  [10755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7969),
  [10757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [10759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8138),
  [10761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6686),
  [10763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3146),
  [10765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [10767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(6172),
  [10770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(7280),
  [10773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(9996),
  [10776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7385),
  [10779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(4374),
  [10782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(7342),
  [10785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(9522),
  [10788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7122),
  [10791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4104),
  [10793] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(4384),
  [10796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(7363),
  [10799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__quantifiers_repeat1, 2), SHIFT_REPEAT(10014),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [10804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7122),
  [10806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [10808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [10810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [10812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7453),
  [10815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7286),
  [10817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [10819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [10821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7227),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [10826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7227),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [10830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 2, .production_id = 13),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [10834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9627),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [10840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fexp, 1, .production_id = 29),
  [10842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fexp, 1, .production_id = 29),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5488),
  [10848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_negation, 2),
  [10850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_negation, 2),
  [10852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_apply, 2),
  [10854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_apply, 2),
  [10856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp, 2),
  [10858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp, 2),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [10862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_annotation, 3),
  [10864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_annotation, 3),
  [10866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_case, 4, .production_id = 58),
  [10868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_case, 4, .production_id = 58),
  [10870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let_in, 4),
  [10872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let_in, 4),
  [10874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_lambda, 4),
  [10876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_lambda, 4),
  [10878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_annotation, 2),
  [10880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_annotation, 2),
  [10882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 2),
  [10884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 2),
  [10886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [10888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 3),
  [10890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 3),
  [10892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 4),
  [10894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 4),
  [10896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 5),
  [10898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 5),
  [10900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_infix, 3),
  [10902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_infix, 3),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [10914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7313),
  [10916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 3, .production_id = 51), SHIFT(5320),
  [10919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7313),
  [10922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 4, .production_id = 59), SHIFT(5350),
  [10925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5792),
  [10927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 6, .production_id = 68), SHIFT(5269),
  [10930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(5329),
  [10933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(5336),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [10940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5789),
  [10944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5920),
  [10948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [10950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5875),
  [10954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [10956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8490),
  [10958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [10962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [10964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [10966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8550),
  [10968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_wildcard, 1),
  [10970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8446),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8411),
  [10976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__qualifying_module, 2),
  [10978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__qualifying_module, 2), SHIFT_REPEAT(3392),
  [10981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2),
  [10983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [10985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [10987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6008),
  [10989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [10991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6166),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6182),
  [10995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6196),
  [10997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6209),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [11001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [11005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6200),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8051),
  [11009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8059),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8072),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8117),
  [11015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8176),
  [11017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8222),
  [11019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [11023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7139),
  [11026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 3, .production_id = 51), SHIFT(5754),
  [11029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 4, .production_id = 59), SHIFT(5760),
  [11032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(5771),
  [11035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(5766),
  [11038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 6, .production_id = 68), SHIFT(5768),
  [11041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8682),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8682),
  [11045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [11053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 4, .production_id = 59), SHIFT(5895),
  [11056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [11058] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 3, .production_id = 51), SHIFT(5831),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6010),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6390),
  [11069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6387),
  [11071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6386),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [11075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [11079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___statement_exp_infix, 3),
  [11081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___statement_exp_infix, 3),
  [11083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(5938),
  [11086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [11088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [11090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [11092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6375),
  [11094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [11098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5900),
  [11100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 5, .production_id = 61), SHIFT(5942),
  [11103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [11105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [11107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [11109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [11111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [11113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [11115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [11117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_ado, 6, .production_id = 68), SHIFT(5972),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [11122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [11128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9784),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3224),
  [11132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [11136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [11138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [11140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [11142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [11146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [11148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [11150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [11152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [11154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [11156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6324),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [11160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [11166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [11170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [11172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [11174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [11176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [11178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7286),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [11183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6276),
  [11185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2752),
  [11187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [11189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [11191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [11193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [11195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [11197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [11201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [11203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [11205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6252),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [11211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [11213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [11215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [11217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6878),
  [11219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [11221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [11223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6226),
  [11225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [11229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [11231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [11233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [11235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [11241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [11243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4275),
  [11245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [11249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [11251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [11253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [11255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [11257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [11259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6253),
  [11261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7675),
  [11263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8104),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8104),
  [11267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [11269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_role_declaration, 4, .production_id = 33),
  [11271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6821),
  [11273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7521),
  [11275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_negation, 2),
  [11277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_negation, 2),
  [11279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [11281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 1),
  [11283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [11285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8690),
  [11287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_record_accessor_repeat1, 2, .production_id = 49), SHIFT_REPEAT(7521),
  [11290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [11294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [11296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundep, 3),
  [11298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [11300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fun_guards, 2),
  [11302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_guards, 2), SHIFT_REPEAT(238),
  [11305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [11307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [11309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_role_declaration_repeat1, 2, .production_id = 41),
  [11311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_role_declaration_repeat1, 2, .production_id = 41), SHIFT_REPEAT(6821),
  [11314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6849),
  [11316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alt_variants, 1),
  [11318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [11320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundep_repeat1, 2), SHIFT_REPEAT(6809),
  [11323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fundep_repeat1, 2),
  [11325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [11327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundep_repeat1, 2), SHIFT_REPEAT(6767),
  [11330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__alt_variants_repeat1, 2),
  [11332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__alt_variants_repeat1, 2), SHIFT_REPEAT(239),
  [11335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6667),
  [11337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [11341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8647),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9617),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8715),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8651),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9646),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6721),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8737),
  [11369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_role_declaration_repeat1, 2, .production_id = 41), SHIFT_REPEAT(6849),
  [11372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [11374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [11376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8120),
  [11378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8120),
  [11380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [11382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [11384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [11386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [11388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [11390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [11396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2), SHIFT_REPEAT(3392),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [11429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_module, 2),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8171),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [11435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_module, 1),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6091),
  [11439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [11441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 2, .production_id = 15),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4782),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9333),
  [11447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7936),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6672),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5438),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6611),
  [11459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [11461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [11483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [11487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6864),
  [11491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7445),
  [11493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [11495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [11497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [11499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [11501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [11503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6440),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [11507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [11509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [11511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6514),
  [11513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [11515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [11517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [11519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [11521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [11523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [11525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [11527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [11531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6525),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [11537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8632),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [11543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1553),
  [11545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [11549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typed_pat, 1),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [11555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [11557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6811),
  [11559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [11561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5944),
  [11563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6227),
  [11565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [11567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4787),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [11579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [11595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9978),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [11599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6812),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [11611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1523),
  [11613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundeps, 3),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7871),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7214),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7233),
  [11625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7256),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [11629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundeps, 2),
  [11631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_role_declaration_repeat1, 1, .production_id = 32),
  [11633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [11637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8097),
  [11643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__role, 1),
  [11645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2),
  [11647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2), SHIFT_REPEAT(7871),
  [11650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2), SHIFT_REPEAT(7539),
  [11653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_infix, 3),
  [11655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [11657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7539),
  [11659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8389),
  [11661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7391),
  [11665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_case_slots, 1, .production_id = 40),
  [11667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [11669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 2),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7731),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [11675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [11679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4818),
  [11683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [11701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [11703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [11705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9605),
  [11707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3214),
  [11709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [11713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [11715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [11717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9560),
  [11719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [11725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [11731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [11733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [11735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4854),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [11739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [11743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9544),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [11753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [11755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gdpat, 3),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [11765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [11769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [11773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6572),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [11783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6565),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6552),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [11789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [11793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [11795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9717),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [11799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [11801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [11803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [11805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [11807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [11809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [11811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [11813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [11815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [11817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [11819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [11827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9575),
  [11833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4967),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [11839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2613),
  [11841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [11843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [11845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [11847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_data, 7, .production_id = 31),
  [11849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [11853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [11857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [11859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [11861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [11863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9727),
  [11867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5821),
  [11869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [11873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [11875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [11877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [11879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [11883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [11887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [11889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8605),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9528),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [11915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alt_repeat1, 2, .production_id = 74),
  [11917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alt_repeat1, 2, .production_id = 74), SHIFT_REPEAT(996),
  [11920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2944),
  [11922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [11924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [11926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [11928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [11930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [11932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8077),
  [11934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [11936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [11938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4776),
  [11940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4776),
  [11942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [11944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [11946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [11948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5100),
  [11950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [11952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [11954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [11956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [11958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9590),
  [11960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [11962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9707),
  [11964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [11966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [11968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [11970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4567),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [11974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9737),
  [11976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [11978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [11980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat2, 2), SHIFT_REPEAT(8731),
  [11983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [11987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [11989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [11993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [11995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_data, 6, .production_id = 16),
  [11997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5004),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [12001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [12003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [12007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [12011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [12013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5940),
  [12015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5940),
  [12017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [12019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [12021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [12027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [12029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [12031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9747),
  [12033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [12035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [12037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9512),
  [12041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [12043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [12045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [12047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [12049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard_equation, 3),
  [12051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [12055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [12057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [12059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [12061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [12069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4721),
  [12071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [12077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [12081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [12083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [12085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [12087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [12089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [12091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [12093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [12095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [12097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [12099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [12101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [12103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [12105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [12107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [12109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [12111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [12113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [12115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [12117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [12125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [12127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [12129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9757),
  [12131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9363),
  [12135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [12137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_field_update, 3),
  [12139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [12141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [12143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [12145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [12147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [12149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [12151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9496),
  [12153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [12155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [12157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [12159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [12161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [12163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [12165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [12169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [12173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5346),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9702),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [12187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9675),
  [12191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [12193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [12195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [12199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5015),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [12203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [12205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9767),
  [12209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [12211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [12213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [12215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [12217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [12219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [12221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [12223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [12225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [12229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [12231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [12235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [12237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [12243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9619),
  [12245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [12247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9480),
  [12249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [12251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8239),
  [12253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [12255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [12257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [12259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9697),
  [12261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [12263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6294),
  [12265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [12267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [12269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [12271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [12273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [12275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [12277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [12279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5008),
  [12281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [12283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5306),
  [12285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [12287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [12289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [12291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [12293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [12295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5303),
  [12297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [12299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [12301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_case_slots_repeat1, 2, .production_id = 56),
  [12303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3435),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [12317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5710),
  [12319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [12321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [12325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [12327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [12329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4017),
  [12331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [12333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [12335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [12337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [12339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [12341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [12345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [12351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [12353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [12355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9633),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [12363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9406),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [12369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7612),
  [12373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [12379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [12383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_data_repeat2, 2), SHIFT_REPEAT(8663),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9687),
  [12394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [12396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [12398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [12400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [12402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [12404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [12406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [12408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [12410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [12412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2673),
  [12414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [12416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [12418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [12420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [12428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [12440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [12442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5263),
  [12444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [12446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [12448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [12450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [12452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [12454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [12456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [12458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1943),
  [12460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [12462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5452),
  [12464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5453),
  [12466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6928),
  [12468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [12470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [12472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [12474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [12476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [12478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [12480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2829),
  [12482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9647),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [12488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [12494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [12500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [12502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [12504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_row_type_repeat1, 2),
  [12506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_row_type_repeat1, 2), SHIFT_REPEAT(6916),
  [12509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [12511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9427),
  [12513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [12515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [12517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [12519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [12521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [12523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [12525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [12527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [12529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [12531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [12535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [12537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [12539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [12541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [12545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5159),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [12549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [12561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [12567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9463),
  [12573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [12577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [12589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9661),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [12593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [12595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [12597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1838),
  [12599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [12601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [12603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [12605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [12607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5911),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [12615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [12617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [12621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [12623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6342),
  [12627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 1, .production_id = 14),
  [12629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [12631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [12633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [12635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2888),
  [12637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [12639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [12647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [12649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [12651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [12653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4663),
  [12655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [12657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [12659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [12661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9445),
  [12663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [12665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [12667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [12669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [12671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [12673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [12675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [12677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [12679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [12681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6671),
  [12683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6671),
  [12685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [12687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6977),
  [12689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [12691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [12693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [12695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundep_repeat1, 2), SHIFT_REPEAT(6172),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6072),
  [12704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [12706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6068),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [12714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [12718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7261),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [12724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_instance, 5),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [12728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7370),
  [12730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7279),
  [12732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [12742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 4),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [12746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [12750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [12760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8455),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7510),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [12780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 3),
  [12782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 5, .production_id = 42),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [12788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 5, .production_id = 43),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [12794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 3, .production_id = 37),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9728),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [12802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 1),
  [12804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [12806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9541),
  [12808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [12810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [12812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [12814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [12816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 2),
  [12818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [12822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [12832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [12834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 4, .production_id = 35),
  [12836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6136),
  [12840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6361),
  [12842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_import, 1, .production_id = 14),
  [12844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 2),
  [12846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_instance, 2),
  [12848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7638),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6102),
  [12854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [12856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [12858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [12860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kind_declaration, 2, .production_id = 16),
  [12862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8738),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6123),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [12872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [12874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [12876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [12878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [12880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [12882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [12884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [12886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 1),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5828),
  [12894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [12896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6724),
  [12898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5782),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6501),
  [12902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [12904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [12906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [12912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6739),
  [12914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8505),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [12928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_row_field, 3),
  [12930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [12932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5579),
  [12934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [12936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [12938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [12940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [12942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 3, .production_id = 25),
  [12944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7897),
  [12946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_instance, 3),
  [12948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [12950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [12952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [12956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [12958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [12960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 3),
  [12962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [12964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_instance, 4),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7542),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5865),
  [12972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [12978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [12980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_head, 5),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7733),
  [12984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [12986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [12988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [12990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [12992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [12994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_import, 3),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [13000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 4),
  [13002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 6, .production_id = 52),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8618),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [13012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 3),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5909),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [13028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 2, .production_id = 30),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8673),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5949),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8734),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6575),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6206),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9490),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6399),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6193),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [13094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_purescript_repeat1, 2),
  [13096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_purescript_repeat1, 2), SHIFT_REPEAT(112),
  [13099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [13101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8331),
  [13103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [13105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [13107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [13109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [13111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [13113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [13115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [13117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [13119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [13121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [13123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [13125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [13127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [13129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [13131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [13133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [13135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_purescript_repeat1, 2), SHIFT_REPEAT(28),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7581),
  [13146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7826),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6374),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [13166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 3),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6379),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6385),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9359),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [13220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [13226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [13230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [13238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraints, 1),
  [13240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_do_repeat1, 2), SHIFT_REPEAT(222),
  [13243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_do_repeat1, 2),
  [13245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [13247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [13249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 5),
  [13251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [13253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6195),
  [13255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [13257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [13259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [13261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [13263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [13265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [13267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [13269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [13271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [13273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [13275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [13277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [13279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [13281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [13283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [13285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [13287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8055),
  [13289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_instance_repeat1, 2), SHIFT_REPEAT(6079),
  [13292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_instance_repeat1, 2),
  [13294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [13302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guards, 3),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [13312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8571),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [13320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [13322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [13324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [13326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [13328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [13330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [13332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(4536),
  [13335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [13337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat1, 2), SHIFT_REPEAT(675),
  [13340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat1, 2),
  [13342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5657),
  [13348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [13350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [13356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [13360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7724),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [13364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [13366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [13368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [13370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [13372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8706),
  [13374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [13376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [13378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [13380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [13382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [13384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [13386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [13388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6192),
  [13390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [13392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [13394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [13398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [13400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [13404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [13410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [13412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [13414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [13416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [13418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [13420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [13422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [13424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [13426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [13428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8167),
  [13430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 6),
  [13432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [13434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [13436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [13438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2), SHIFT_REPEAT(237),
  [13441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [13443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [13445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [13447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [13449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [13451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [13453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [13455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [13457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8592),
  [13459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [13461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [13463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [13465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [13467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [13469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [13471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [13473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [13475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [13477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [13479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [13481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [13483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [13485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [13487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [13489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [13491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [13493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6610),
  [13495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [13497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [13499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [13501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [13503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [13505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [13507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [13509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [13511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [13513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6754),
  [13515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [13517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [13519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [13521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [13523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [13525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [13527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [13529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [13531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [13533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [13535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [13537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 2, .production_id = 65),
  [13539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8612),
  [13541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [13543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [13545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guards, 2),
  [13547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8709),
  [13549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [13551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [13553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [13555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [13557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [13559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [13561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [13563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [13565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat1, 2, .production_id = 70), SHIFT_REPEAT(970),
  [13568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat1, 2, .production_id = 70),
  [13570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [13572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [13574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [13576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [13578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [13580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [13582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [13584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [13586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5795),
  [13588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [13590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [13592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [13594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alts_repeat1, 2), SHIFT_REPEAT(978),
  [13597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alts_repeat1, 2),
  [13599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alt_repeat1, 2, .production_id = 71),
  [13601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [13603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [13605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [13607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [13609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_purescript, 1),
  [13611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [13613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [13615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alt_variants, 2, .production_id = 72),
  [13617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [13619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [13621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [13623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [13625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 3, .production_id = 73),
  [13627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8691),
  [13629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [13631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [13633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8730),
  [13635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [13637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [13639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [13641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [13643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [13645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [13647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [13649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [13651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [13653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [13655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [13657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [13659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [13661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [13663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [13665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [13667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [13669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [13671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat1, 2), SHIFT_REPEAT(674),
  [13674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [13676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [13680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [13682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_do_repeat1, 2), SHIFT_REPEAT(223),
  [13685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [13687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [13689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [13691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [13693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [13695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [13697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [13699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [13701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [13703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [13705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [13707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [13709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [13711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [13713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [13715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [13717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [13719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [13721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [13723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [13725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [13727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [13729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [13731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [13733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6395),
  [13735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ado_in_repeat1, 2), SHIFT_REPEAT(530),
  [13738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__ado_in_repeat1, 2),
  [13740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [13744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [13748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [13750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [13752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6362),
  [13758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [13760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [13762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [13764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [13766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [13768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5503),
  [13770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [13772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [13774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [13776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [13778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [13782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [13784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [13786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [13788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [13790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [13792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [13794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [13796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [13798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [13800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [13802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [13804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [13806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [13808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [13810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [13812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [13814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [13816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [13818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [13820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [13822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [13824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [13826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [13828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6797),
  [13830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [13832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6881),
  [13834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [13836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [13838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [13840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6807),
  [13842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [13844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6892),
  [13846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6890),
  [13848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [13850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [13852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6084),
  [13854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [13856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 9, .production_id = 69),
  [13858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [13860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_instance, 10),
  [13862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [13864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8398),
  [13866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8398),
  [13868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 8, .production_id = 69),
  [13870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 8, .production_id = 63),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [13874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_instance, 9),
  [13876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarations, 5),
  [13878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6824),
  [13880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6834),
  [13882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [13884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [13886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 7, .production_id = 63),
  [13888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6971),
  [13890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7497),
  [13892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 6),
  [13894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [13896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_fun, 1, .dynamic_precedence = 1, .production_id = 8),
  [13898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_instance, 8),
  [13900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7100),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [13904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [13906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [13908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [13910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [13914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [13916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 2, .production_id = 2),
  [13918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarations, 4),
  [13920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [13922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [13924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [13926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [13928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [13932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [13934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarations, 2),
  [13936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [13938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [13940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_name, 1, .production_id = 12),
  [13942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [13944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_do_repeat1, 2, .dynamic_precedence = 1),
  [13946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 1),
  [13948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [13950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6629),
  [13952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_typed, 2, .production_id = 18),
  [13954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bind_pattern, 3),
  [13956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat1, 2, .dynamic_precedence = 1),
  [13958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [13960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [13962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 6, .production_id = 37),
  [13964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [13966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 5),
  [13968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_instance, 7),
  [13970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [13972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6624),
  [13974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [13976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarations, 3),
  [13978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [13980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_exp, 2),
  [13982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 2),
  [13984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6817),
  [13986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [13988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [13990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [13992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [13994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funpat, 2, .production_id = 19),
  [13996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [13998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 2, .production_id = 21),
  [14000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [14002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [14004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [14006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [14008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8704),
  [14010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [14012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [14014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [14016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5794),
  [14018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6820),
  [14020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [14022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6526),
  [14024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6352),
  [14026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_pattern, 2),
  [14028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [14030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [14032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [14034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [14036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [14038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [14040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_pattern, 2, .production_id = 17),
  [14042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 6, .production_id = 53),
  [14044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [14046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [14048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 6, .production_id = 44),
  [14050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6351),
  [14052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [14054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [14056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 4),
  [14058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6562),
  [14060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [14062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [14064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [14066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6326),
  [14068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_instance, 6),
  [14070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7385),
  [14072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 4, .production_id = 22),
  [14074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_newtype, 5, .production_id = 31),
  [14076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [14078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [14080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [14082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [14084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [14086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [14088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6521),
  [14090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5959),
  [14092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6516),
  [14094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [14096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype_constructor, 2),
  [14098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 4, .production_id = 30),
  [14100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [14102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [14104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [14106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [14108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [14110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [14112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5984),
  [14114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6596),
  [14116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [14118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7644),
  [14120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6505),
  [14122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [14124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [14126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6730),
  [14128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [14130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6656),
  [14132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [14134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [14136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [14138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_type, 5, .production_id = 31),
  [14140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_type, 4),
  [14142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kind_value_declaration, 5, .production_id = 46),
  [14144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 5, .production_id = 45),
  [14146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 5, .production_id = 44),
  [14148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [14150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [14152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [14154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [14156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [14158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [14160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5318),
  [14162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 3),
  [14164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [14166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7139),
  [14168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5867),
  [14170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [14172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [14174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [14176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6263),
  [14178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [14180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [14182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [14184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [14186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [14188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6815),
  [14190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7014),
  [14192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [14194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [14196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_type, 2),
  [14198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_purescript_repeat1, 2, .dynamic_precedence = 1),
  [14200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [14202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [14204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [14206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [14208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [14210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7061),
  [14212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [14214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [14216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [14218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [14220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [14222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [14224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7434),
  [14226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [14228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [14230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4),
  [14232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [14234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6910),
  [14236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [14238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [14240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [14242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [14244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [14246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [14248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [14250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [14252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7149),
  [14254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7433),
  [14256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [14258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [14260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [14262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [14264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [14266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [14268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [14270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pat_fields_repeat1, 2),
  [14272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pat_fields_repeat1, 2), SHIFT_REPEAT(6797),
  [14275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [14277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [14281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [14285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [14287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [14289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_type, 4, .production_id = 16),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [14297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6081),
  [14299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [14301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pat_array_repeat1, 2),
  [14303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pat_array_repeat1, 2), SHIFT_REPEAT(916),
  [14306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [14308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kind_declaration, 3, .production_id = 31),
  [14310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [14312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_equals, 3, .production_id = 37),
  [14314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_foreign_import, 4, .production_id = 31),
  [14316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_newtype, 4, .production_id = 16),
  [14318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [14320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [14322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [14324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [14326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [14328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [14330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [14332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [14334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [14336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [14338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [14340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [14342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6380),
  [14344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [14346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [14348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [14350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [14352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9754),
  [14354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [14356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6943),
  [14358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [14360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [14362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6373),
  [14364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6372),
  [14366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [14368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [14370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [14372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [14374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6366),
  [14376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5717),
  [14378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [14380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [14382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 1, .production_id = 39),
  [14384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [14386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [14388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [14394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [14396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [14398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [14400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [14402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [14404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4268),
  [14406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [14408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [14410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constraints_repeat1, 2),
  [14412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constraints_repeat1, 2), SHIFT_REPEAT(6505),
  [14415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [14417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [14419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [14421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4666),
  [14423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [14425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [14427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [14429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [14431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [14433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [14435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [14437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [14439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [14441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 5, .production_id = 73),
  [14443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [14445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [14447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [14449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [14451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9613),
  [14453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7316),
  [14455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [14457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [14459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 4, .production_id = 65),
  [14461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [14463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [14465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [14467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [14469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [14471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [14473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [14475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [14477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [14479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [14481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_case_slots, 2, .production_id = 50),
  [14483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [14485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [14487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [14489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2), SHIFT_REPEAT(240),
  [14492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [14494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [14496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [14498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [14500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6517),
  [14502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [14504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [14506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [14508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [14510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [14512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [14514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [14516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [14518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [14520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [14522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [14524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [14526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8638),
  [14528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [14530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [14532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2),
  [14534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2), SHIFT_REPEAT(4936),
  [14537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [14539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [14541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [14543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [14545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [14547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [14549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6770),
  [14557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [14559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7168),
  [14561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2),
  [14563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2), SHIFT_REPEAT(4887),
  [14566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [14568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [14570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [14572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [14574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [14576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [14578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6705),
  [14580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [14582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_literal_repeat1, 2),
  [14584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_literal_repeat1, 2), SHIFT_REPEAT(6881),
  [14587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6673),
  [14591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_array_repeat1, 2),
  [14593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_array_repeat1, 2), SHIFT_REPEAT(511),
  [14596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [14598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6651),
  [14600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_case_slots_repeat1, 2, .production_id = 57),
  [14602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_case_slots_repeat1, 2, .production_id = 57), SHIFT_REPEAT(515),
  [14605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [14607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5536),
  [14611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5529),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [14617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [14619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [14621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .dynamic_precedence = 1),
  [14623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [14625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [14627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [14629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [14631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [14633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8627),
  [14635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [14637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [14639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [14641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6741),
  [14643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5444),
  [14645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [14647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6740),
  [14649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8624),
  [14651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_instance_repeat1, 2, .dynamic_precedence = 1),
  [14653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6101),
  [14659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [14661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [14663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [14665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8616),
  [14667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [14669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__ado_in_repeat1, 2, .dynamic_precedence = 1),
  [14671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_update_repeat1, 2),
  [14673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_update_repeat1, 2), SHIFT_REPEAT(6807),
  [14676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7264),
  [14678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [14680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [14682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [14684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [14686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [14688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [14690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5433),
  [14692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [14694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__record_field_update_repeat1, 2),
  [14696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__record_field_update_repeat1, 2), SHIFT_REPEAT(6772),
  [14699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [14701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6603),
  [14703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_con_names_repeat1, 2),
  [14705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_con_names_repeat1, 2), SHIFT_REPEAT(6795),
  [14708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [14710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7272),
  [14712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [14714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [14716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6900),
  [14718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [14720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_names_repeat1, 2),
  [14722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_names_repeat1, 2), SHIFT_REPEAT(6770),
  [14725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [14727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_decl, 2, .production_id = 62),
  [14729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7071),
  [14731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7065),
  [14733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [14735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6901),
  [14737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [14739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7052),
  [14741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6139),
  [14743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [14745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8620),
  [14747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat1, 2, .dynamic_precedence = 1, .production_id = 62),
  [14749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7392),
  [14751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [14753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alts_repeat1, 2, .dynamic_precedence = 1),
  [14755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [14757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [14759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [14761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [14763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [14765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [14767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5927),
  [14769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [14771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [14773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [14775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6605),
  [14777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [14779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [14781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [14783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__record_field_update_repeat1, 2, .production_id = 75),
  [14785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [14787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [14789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8735),
  [14791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8728),
  [14793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_field_update, 4, .production_id = 66),
  [14795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_field_update, 5, .production_id = 66),
  [14797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9330),
  [14799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [14801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8712),
  [14803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8702),
  [14805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 4),
  [14807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 3),
  [14809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 4),
  [14811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_name, 3),
  [14813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [14815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 3),
  [14817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 4),
  [14819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [14821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [14823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 3),
  [14825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_operator_import, 4),
  [14827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_import, 4),
  [14829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 3, .production_id = 55),
  [14831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 3),
  [14833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 2),
  [14835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [14837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 2),
  [14839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_import, 3),
  [14841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6618),
  [14843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [14845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [14847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [14849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2),
  [14851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [14853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8133),
  [14855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [14857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2, .production_id = 14),
  [14859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2, .production_id = 15),
  [14861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_import, 2, .production_id = 14),
  [14863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_import, 2),
  [14865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [14867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [14869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [14871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [14873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8661),
  [14875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 4, .production_id = 36),
  [14877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [14879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 1),
  [14881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_import, 1),
  [14883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_name_ty, 1, .production_id = 12),
  [14885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [14887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [14889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 3),
  [14891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [14893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [14895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8675),
  [14897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [14899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8463),
  [14901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance_name, 2, .production_id = 27),
  [14903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 3, .production_id = 26),
  [14905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [14907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [14909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [14911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8075),
  [14913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [14915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funlhs, 1, .dynamic_precedence = 2, .production_id = 10),
  [14917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10031),
  [14919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [14921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6990),
  [14923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [14925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [14927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [14929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [14931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [14933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [14935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [14937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [14939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [14941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [14943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [14945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [14947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [14949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [14951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [14953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6908),
  [14955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [14957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [14959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [14961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6404),
  [14963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [14965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [14967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [14969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [14971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [14973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6349),
  [14975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [14977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [14979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [14981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [14983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [14985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [14987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [14989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [14991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [14993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [14995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [14997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [14999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [15001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [15003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [15005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [15007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [15009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [15011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [15013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [15015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [15017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [15019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [15021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [15023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [15025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [15027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [15029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [15031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [15033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [15035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [15037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [15039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [15041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [15043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [15045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [15047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [15049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [15051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [15053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [15055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [15057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6919),
  [15059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [15061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [15063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6929),
  [15065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [15067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [15069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [15071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [15073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [15075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6560),
  [15077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [15079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [15081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [15083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [15085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [15087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [15089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [15091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [15093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [15095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [15097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [15099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7444),
  [15101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [15103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [15105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [15107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [15109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [15111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [15113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [15115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [15117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [15119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [15121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [15123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [15125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [15127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5861),
  [15129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [15131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [15133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [15135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [15137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [15139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [15141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [15143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [15145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [15147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [15149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [15151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [15153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6339),
  [15155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [15157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [15159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [15161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [15163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6001),
  [15165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [15167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [15169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6961),
  [15171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7056),
  [15173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [15175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [15177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [15179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [15181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [15183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [15185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [15187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [15189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [15191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [15193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [15195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6936),
  [15197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [15199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [15201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [15203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [15205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [15207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [15209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [15211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [15213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6335),
  [15215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [15217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [15219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [15221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [15223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [15225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [15227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [15229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [15231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [15233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [15235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [15237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [15239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [15241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [15243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6494),
  [15245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [15247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [15249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [15251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [15253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [15255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [15257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5448),
  [15259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [15261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [15263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [15265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [15267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [15269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [15271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [15273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [15275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [15277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [15279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [15281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [15283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [15285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [15287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [15289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [15291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [15293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [15295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [15297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [15299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [15301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [15303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [15305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [15307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [15309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [15311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [15313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [15315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [15317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [15319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5110),
  [15321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [15323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [15325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [15327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [15329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [15331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [15333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [15335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [15337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [15339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [15341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [15343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [15345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [15347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [15349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [15351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [15353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [15355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [15357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [15359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [15361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [15363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [15365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [15367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [15369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [15371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6255),
  [15373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [15375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [15377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [15379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [15381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [15383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6970),
  [15385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [15387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [15389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [15391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [15393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6258),
  [15395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [15397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2894),
  [15399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [15401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [15403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [15405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [15407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3979),
  [15409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [15411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [15413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [15415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6333),
  [15417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [15419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [15421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [15423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [15425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [15427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [15429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [15431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6259),
  [15433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [15435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6329),
  [15437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [15439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [15441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [15443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [15445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [15447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [15449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [15451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6498),
  [15453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [15455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [15457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6570),
  [15459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [15461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [15463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [15465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [15467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [15469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [15471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [15473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [15475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [15477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [15479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [15481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [15483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [15485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [15487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [15489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [15491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [15493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [15495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3206),
  [15497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [15499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [15501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [15503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [15505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [15507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [15509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [15511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [15513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6320),
  [15515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [15517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [15519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6036),
  [15521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [15523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [15525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [15527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [15529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [15531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [15533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [15535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [15537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [15539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [15541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [15543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [15545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [15547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [15549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [15551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [15553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [15555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [15557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [15559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [15561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [15563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [15565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [15567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [15569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [15571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [15573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [15575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6464),
  [15577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [15579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [15581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [15583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [15585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [15587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [15589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [15591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [15593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [15595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [15597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [15599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [15601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [15603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [15605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [15607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [15609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [15611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [15613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 9, .production_id = 36),
  [15615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [15617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [15619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [15621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [15623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5808),
  [15625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [15627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [15629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [15631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [15633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [15635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [15637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [15639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [15641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [15643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [15645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [15647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [15649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [15651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [15653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [15655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [15657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [15659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [15661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5432),
  [15663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [15665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [15667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [15669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [15671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [15673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [15675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [15677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [15679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [15681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [15683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [15685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [15687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [15689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [15691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [15693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5839),
  [15695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [15697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [15699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [15701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6695),
  [15703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [15705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [15707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [15709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [15711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [15713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [15715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [15717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [15719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [15721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [15723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [15725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [15727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [15729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6903),
  [15731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [15733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [15735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [15737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [15739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8736),
  [15741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [15743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [15745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6687),
  [15747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [15749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [15751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [15753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6641),
  [15755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [15757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [15759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [15761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [15763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8733),
  [15765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [15767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [15769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [15771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [15773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [15775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8727),
  [15777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [15779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6542),
  [15781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [15783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [15785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [15787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [15789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [15791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [15793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [15795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [15797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6264),
  [15799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [15801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [15803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [15805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [15807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [15809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [15811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 7, .production_id = 26),
  [15813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [15815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [15817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [15819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [15821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [15823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [15825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8713),
  [15827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [15829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [15831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [15833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [15835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [15837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [15839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [15841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [15843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8703),
  [15845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8698),
  [15847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [15849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [15851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6895),
  [15853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7273),
  [15855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [15857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [15859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7032),
  [15861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [15863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [15865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7059),
  [15867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6677),
  [15869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 8, .production_id = 36),
  [15871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [15873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [15875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [15877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [15879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6985),
  [15881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8687),
  [15883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [15885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [15887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 8, .production_id = 26),
  [15889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [15891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [15893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [15895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6441),
  [15897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [15899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [15901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [15903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [15905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [15907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8674),
  [15909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [15911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5877),
  [15913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [15915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [15917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6121),
  [15919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [15921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [15923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [15925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [15927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6070),
  [15929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [15931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8658),
  [15933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [15935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6053),
  [15937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [15939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [15941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [15943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [15945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6541),
  [15947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [15949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [15951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [15953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [15955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8648),
  [15957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [15959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [15961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [15963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [15965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [15967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [15969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [15971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [15973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6622),
  [15975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [15977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [15979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [15981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [15983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 7, .production_id = 36),
  [15985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8636),
  [15987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [15989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [15991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [15993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [15995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [15997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [15999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [16001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [16003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [16005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7026),
  [16007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [16009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8630),
  [16011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [16013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6747),
  [16015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [16017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8629),
  [16019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [16021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [16023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [16025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [16027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [16029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [16031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [16033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [16035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [16037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [16039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [16041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [16043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5983),
  [16045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [16047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [16049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [16051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6496),
  [16053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [16055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [16057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [16059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8637),
  [16061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [16063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 6, .production_id = 26),
  [16065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [16067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [16069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [16071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [16073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6411),
  [16075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [16077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [16079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [16081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [16083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [16085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [16087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [16089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [16091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [16093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [16095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6500),
  [16097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [16099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [16101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [16103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8668),
  [16105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [16107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5906),
  [16109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [16111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [16113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [16115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [16117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6637),
  [16119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [16121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [16123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [16125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6925),
  [16127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [16129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8684),
  [16131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [16133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [16135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [16137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [16139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [16141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [16143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6714),
  [16145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [16147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [16149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [16151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [16153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8701),
  [16155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [16157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [16159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [16161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [16163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [16165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [16167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 6, .production_id = 36),
  [16169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [16171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [16173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [16175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 4),
  [16177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [16179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [16181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [16183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [16185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [16187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [16189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [16191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [16193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8635),
  [16195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_operator, 1), REDUCE(sym_type_operator, 1),
  [16198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [16200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [16202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [16204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [16206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [16208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [16210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6835),
  [16212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4334),
  [16214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [16216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [16218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [16220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [16222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [16224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [16226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [16228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [16230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [16232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [16234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [16236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [16238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [16240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8639),
  [16242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [16244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [16246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [16248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6568),
  [16250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [16252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2702),
  [16254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [16256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6446),
  [16258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [16260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [16262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [16264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [16266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [16268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [16270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [16272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [16274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [16276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [16278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [16280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [16282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [16284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [16286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [16288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [16290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [16292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [16294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [16296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6519),
  [16298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [16300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [16302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6850),
  [16304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [16306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [16308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [16310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [16312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [16314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6600),
  [16316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [16318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [16320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [16322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [16324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [16326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [16328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [16330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [16332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [16334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [16336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [16338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [16340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [16342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [16344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [16346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6682),
  [16348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [16350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [16352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [16354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [16356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [16358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [16360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [16362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [16364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [16366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [16368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [16370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [16372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [16374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [16376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [16378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [16380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [16382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [16384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [16386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [16388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [16390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [16392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [16394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [16396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [16398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [16400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [16402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 3),
  [16404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [16406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [16408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [16410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [16412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [16414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [16416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7670),
  [16418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [16420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_module, 5, .production_id = 26),
  [16422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [16424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [16426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [16428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [16430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [16432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [16434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [16436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [16438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [16440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [16442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [16444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [16446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [16448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [16450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [16452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [16454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7662),
  [16456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8652),
  [16458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [16460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6691),
  [16462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [16464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [16466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [16468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [16470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [16472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6700),
  [16474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [16476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [16478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [16480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4263),
  [16482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [16484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [16486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [16488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [16490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [16492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [16494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [16496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [16498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [16500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [16502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [16504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [16506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [16508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [16510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [16512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ado, 2),
  [16514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__do, 2),
  [16516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [16518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [16520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [16522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [16524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8656),
  [16526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [16528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6365),
  [16530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [16532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [16534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [16536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__q_op, 1), SHIFT(7056),
  [16539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [16541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [16543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [16545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [16547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [16549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [16551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [16553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8660),
  [16555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [16557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [16559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8662),
  [16561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [16563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [16565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [16567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [16569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [16571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [16573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [16575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [16577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [16579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [16581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [16583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [16585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8669),
  [16587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [16589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [16591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [16593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6899),
  [16595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [16597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [16599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [16601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [16603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [16605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [16607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [16609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [16611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [16613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [16615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [16617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [16619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [16621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [16623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [16625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [16627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [16629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [16631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [16633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [16635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3249),
  [16637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [16639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8373),
  [16641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8672),
  [16643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [16645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [16647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7072),
  [16649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [16651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__q_op, 1), SHIFT(6542),
  [16654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [16656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [16658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [16660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [16662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [16664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [16666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [16668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [16670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [16672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [16674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [16676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [16678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6422),
  [16680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [16682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [16684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [16686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [16688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [16690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [16692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [16694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [16696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [16698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [16700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [16702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [16704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [16706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [16708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [16710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [16712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4902),
  [16714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [16716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [16718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [16720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [16722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [16724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [16726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8676),
  [16728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [16730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [16732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [16734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype_type_signature, 3, .production_id = 23),
  [16736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__data_type_signature, 3, .production_id = 23), REDUCE(sym__newkind_type_signature, 3, .dynamic_precedence = 1, .production_id = 23),
  [16739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8678),
  [16741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [16743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [16745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [16747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [16749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [16751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [16753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [16755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [16757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [16759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [16761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [16763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [16765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__q_op, 1), SHIFT(6332),
  [16768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_kind_declaration, 3, .production_id = 24),
  [16770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [16772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [16774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [16776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_type_signature, 3, .production_id = 23),
  [16778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [16780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [16782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [16784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [16786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [16788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [16790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6503),
  [16792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_constructor_operator, 2),
  [16794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [16796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6523),
  [16798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [16800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [16802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [16804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [16806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [16808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [16810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [16812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7957),
  [16814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [16816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [16818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6332),
  [16820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5011),
  [16822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [16824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [16826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [16828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [16830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [16832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [16834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6353),
  [16836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [16838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [16840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [16842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5921),
  [16844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [16846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8226),
  [16848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4781),
  [16850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [16852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [16854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [16856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [16858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [16860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [16862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [16864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [16866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [16868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [16870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [16872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [16874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [16876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [16878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [16880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6524),
  [16882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [16884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3232),
  [16886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_operator, 1),
  [16888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [16890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [16892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [16894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5773),
  [16896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5859),
  [16898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [16900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8173),
  [16902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8172),
  [16904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_purescript, 1, .production_id = 7),
  [16906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [16908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8289),
  [16910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8288),
  [16912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8287),
  [16914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [16916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [16918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5862),
  [16920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [16922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [16924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [16926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [16928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [16930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__q_op, 1), SHIFT(6830),
  [16933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4884),
  [16935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [16937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3193),
  [16939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [16941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7070),
  [16943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [16945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [16947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [16949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8164),
  [16951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [16953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [16955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [16957] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [16959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [16961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [16963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [16965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [16967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [16969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5712),
  [16971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [16973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [16975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6438),
  [16977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7543),
  [16979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__layout_semicolon = 0,
  ts_external_token__layout_start = 1,
  ts_external_token__layout_end = 2,
  ts_external_token__dot = 3,
  ts_external_token__arith_dotdot = 4,
  ts_external_token_where = 5,
  ts_external_token__splice_dollar = 6,
  ts_external_token__varsym = 7,
  ts_external_token__consym = 8,
  ts_external_token__tyconsym = 9,
  ts_external_token_comment = 10,
  ts_external_token_cpp = 11,
  ts_external_token_comma = 12,
  ts_external_token_quasiquote_start = 13,
  ts_external_token_quasiquote_bar = 14,
  ts_external_token_quasiquote_body = 15,
  ts_external_token__strict = 16,
  ts_external_token__lazy = 17,
  ts_external_token__unboxed_close = 18,
  ts_external_token_PIPE = 19,
  ts_external_token_in = 20,
  ts_external_token__token1 = 21,
  ts_external_token_empty_file = 22,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__layout_semicolon] = sym__layout_semicolon,
  [ts_external_token__layout_start] = sym__layout_start,
  [ts_external_token__layout_end] = sym__layout_end,
  [ts_external_token__dot] = sym__dot,
  [ts_external_token__arith_dotdot] = sym__arith_dotdot,
  [ts_external_token_where] = sym_where,
  [ts_external_token__splice_dollar] = sym__splice_dollar,
  [ts_external_token__varsym] = sym__varsym,
  [ts_external_token__consym] = sym__consym,
  [ts_external_token__tyconsym] = sym__tyconsym,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_cpp] = sym_cpp,
  [ts_external_token_comma] = sym_comma,
  [ts_external_token_quasiquote_start] = sym_quasiquote_start,
  [ts_external_token_quasiquote_bar] = sym_quasiquote_bar,
  [ts_external_token_quasiquote_body] = sym_quasiquote_body,
  [ts_external_token__strict] = sym__strict,
  [ts_external_token__lazy] = sym__lazy,
  [ts_external_token__unboxed_close] = sym__unboxed_close,
  [ts_external_token_PIPE] = anon_sym_PIPE,
  [ts_external_token_in] = anon_sym_in,
  [ts_external_token__token1] = aux_sym__token1,
  [ts_external_token_empty_file] = sym_empty_file,
};

static const bool ts_external_scanner_states[48][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_quasiquote_bar] = true,
    [ts_external_token_quasiquote_body] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
    [ts_external_token_empty_file] = true,
  },
  [2] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
    [ts_external_token_empty_file] = true,
  },
  [3] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [4] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [5] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [6] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [7] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [8] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [9] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [10] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [11] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [12] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [13] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [14] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [15] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [16] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [17] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [18] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [19] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [20] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [21] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [22] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [23] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [24] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [25] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [26] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [27] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [28] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [29] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [30] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [31] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [32] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [33] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [34] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [35] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [36] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [37] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [38] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [39] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [40] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [41] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [42] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [43] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [44] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [45] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [46] = {
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [47] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_purescript_external_scanner_create(void);
void tree_sitter_purescript_external_scanner_destroy(void *);
bool tree_sitter_purescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_purescript_external_scanner_serialize(void *, char *);
void tree_sitter_purescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_purescript(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__varid,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_purescript_external_scanner_create,
      tree_sitter_purescript_external_scanner_destroy,
      tree_sitter_purescript_external_scanner_scan,
      tree_sitter_purescript_external_scanner_serialize,
      tree_sitter_purescript_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
